// DO NOT EDIT THIS FILE! It was generated by running `npm run tsgen`
/// <reference types="./matter" />

declare type CameraRotateCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number, angle: number)=>void;

declare type DataEachCallback = (parent: any, key: string, value: any, ...args: any[])=>void;

declare type ContentLoadedCallback = ()=>void;

declare type CreateCallback = (bob: Phaser.GameObjects.Bob, index: number)=>void;

declare type EachContainerCallback<I> = (item: any, ...args: any[])=>void;

declare type LightForEach = (light: Phaser.GameObjects.Light)=>void;

/**
 * A custom function that will be responsible for wrapping the text.
 */
declare type TextStyleWordWrapCallback = (text: string, textObject: Phaser.GameObjects.Text)=>string | string[];

declare type CenterFunction = (triangle: Phaser.Geom.Triangle)=>Phaser.Math.Vector2;

declare namespace Phaser {
    namespace Actions {
        /**
         * Takes an array of Game Objects and aligns them next to each other.
         * 
         * The alignment position is controlled by the `position` parameter, which should be one
         * of the Phaser.Display.Align constants, such as `Phaser.Display.Align.TOP_LEFT`,
         * `Phaser.Display.Align.TOP_CENTER`, etc.
         * 
         * The first item isn't moved. The second item is aligned next to the first,
         * then the third next to the second, and so on.
         * @param items The array of items to be updated by this action.
         * @param position The position to align the items with. This is an align constant, such as `Phaser.Display.Align.LEFT_CENTER`.
         * @param offsetX Optional horizontal offset from the position. Default 0.
         * @param offsetY Optional vertical offset from the position. Default 0.
         */
        function AlignTo<G extends Phaser.GameObjects.GameObject[]>(items: G, position: number, offsetX?: number, offsetY?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `angle` property,
         * and then adds the given value to each of their `angle` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `Angle(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `angle` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function Angle<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of objects and passes each of them to the given callback.
         * @param items The array of items to be updated by this action.
         * @param callback The callback to be invoked. It will be passed just one argument: the item from the array.
         * @param context The scope in which the callback will be invoked.
         */
        function Call<G extends Phaser.GameObjects.GameObject[]>(items: G, callback: Phaser.Types.Actions.CallCallback, context: any): G;

        /**
         * Takes an array of objects and returns the first element in the array that has properties which match
         * all of those specified in the `compare` object. For example, if the compare object was: `{ scaleX: 0.5, alpha: 1 }`
         * then it would return the first item which had the property `scaleX` set to 0.5 and `alpha` set to 1.
         * 
         * To use this with a Group: `GetFirst(group.getChildren(), compare, index)`
         * @param items The array of items to be searched by this action.
         * @param compare The comparison object. Each property in this object will be checked against the items of the array.
         * @param index An optional offset to start searching from within the items array. Default 0.
         */
        function GetFirst<G extends Phaser.GameObjects.GameObject[]>(items: G, compare: object, index?: number): object | Phaser.GameObjects.GameObject | null;

        /**
         * Takes an array of objects and returns the last element in the array that has properties which match
         * all of those specified in the `compare` object. For example, if the compare object was: `{ scaleX: 0.5, alpha: 1 }`
         * then it would return the last item which had the property `scaleX` set to 0.5 and `alpha` set to 1.
         * 
         * To use this with a Group: `GetLast(group.getChildren(), compare, index)`
         * @param items The array of items to be searched by this action.
         * @param compare The comparison object. Each property in this object will be checked against the items of the array.
         * @param index An optional offset to start searching from within the items array. Default 0.
         */
        function GetLast<G extends Phaser.GameObjects.GameObject[]>(items: G, compare: object, index?: number): object | Phaser.GameObjects.GameObject | null;

        /**
         * Takes an array of Game Objects, or any objects that have public `x` and `y` properties,
         * and then aligns them based on the grid configuration given to this action.
         * @param items The array of items to be updated by this action.
         * @param options The GridAlign Configuration object.
         */
        function GridAlign<G extends Phaser.GameObjects.GameObject[]>(items: G, options: Phaser.Types.Actions.GridAlignConfig): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `alpha` property,
         * and then adds the given value to each of their `alpha` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `IncAlpha(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `alpha` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function IncAlpha<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `x` property,
         * and then adds the given value to each of their `x` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `IncX(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `x` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function IncX<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have public `x` and `y` properties,
         * and then adds the given value to each of them.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `IncXY(group.getChildren(), x, y, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param x The amount to be added to the `x` property.
         * @param y The amount to be added to the `y` property. If `undefined` or `null` it uses the `x` value. Default x.
         * @param stepX This is added to the `x` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `y` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function IncXY<G extends Phaser.GameObjects.GameObject[]>(items: G, x: number, y?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `y` property,
         * and then adds the given value to each of their `y` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `IncY(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `y` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function IncY<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects and positions them on evenly spaced points around the perimeter of a Circle.
         * 
         * If you wish to pass a `Phaser.GameObjects.Circle` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param circle The Circle to position the Game Objects on.
         * @param startAngle Optional angle to start position from, in radians. Default 0.
         * @param endAngle Optional angle to stop position at, in radians. Default 6.28.
         */
        function PlaceOnCircle<G extends Phaser.GameObjects.GameObject[]>(items: G, circle: Phaser.Geom.Circle, startAngle?: number, endAngle?: number): G;

        /**
         * Takes an array of Game Objects and positions them on evenly spaced points around the perimeter of an Ellipse.
         * 
         * If you wish to pass a `Phaser.GameObjects.Ellipse` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param ellipse The Ellipse to position the Game Objects on.
         * @param startAngle Optional angle to start position from, in radians. Default 0.
         * @param endAngle Optional angle to stop position at, in radians. Default 6.28.
         */
        function PlaceOnEllipse<G extends Phaser.GameObjects.GameObject[]>(items: G, ellipse: Phaser.Geom.Ellipse, startAngle?: number, endAngle?: number): G;

        /**
         * Positions an array of Game Objects on evenly spaced points of a Line.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param line The Line to position the Game Objects on.
         */
        function PlaceOnLine<G extends Phaser.GameObjects.GameObject[]>(items: G, line: Phaser.Geom.Line): G;

        /**
         * Takes an array of Game Objects and positions them on evenly spaced points around the perimeter of a Rectangle.
         * 
         * Placement starts from the top-left of the rectangle, and proceeds in a clockwise direction.
         * If the `shift` parameter is given you can offset where placement begins.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param rect The Rectangle to position the Game Objects on.
         * @param shift An optional positional offset. Default 0.
         */
        function PlaceOnRectangle<G extends Phaser.GameObjects.GameObject[]>(items: G, rect: Phaser.Geom.Rectangle, shift?: number): G;

        /**
         * Takes an array of Game Objects and positions them on evenly spaced points around the edges of a Triangle.
         * 
         * If you wish to pass a `Phaser.GameObjects.Triangle` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param triangle The Triangle to position the Game Objects on.
         * @param stepRate An optional step rate, to increase or decrease the packing of the Game Objects on the lines. Default 1.
         */
        function PlaceOnTriangle<G extends Phaser.GameObjects.GameObject[]>(items: G, triangle: Phaser.Geom.Triangle, stepRate?: number): G;

        /**
         * Play an animation on all Game Objects in the array that have an Animation component.
         * 
         * You can pass either an animation key, or an animation configuration object for more control over the playback.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
         * @param ignoreIfPlaying If this animation is already playing then ignore this call. Default false.
         */
        function PlayAnimation<G extends Phaser.GameObjects.GameObject[]>(items: G, key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public property as defined in `key`,
         * and then adds the given value to it.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `PropertyValueInc(group.getChildren(), key, value, step)`
         * @param items The array of items to be updated by this action.
         * @param key The property to be updated.
         * @param value The amount to be added to the property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function PropertyValueInc<G extends Phaser.GameObjects.GameObject[]>(items: G, key: string, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public property as defined in `key`,
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `PropertyValueSet(group.getChildren(), key, value, step)`
         * @param items The array of items to be updated by this action.
         * @param key The property to be updated.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function PropertyValueSet<G extends Phaser.GameObjects.GameObject[]>(items: G, key: string, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects and positions them at random locations within the Circle.
         * 
         * If you wish to pass a `Phaser.GameObjects.Circle` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param circle The Circle to position the Game Objects within.
         */
        function RandomCircle<G extends Phaser.GameObjects.GameObject[]>(items: G, circle: Phaser.Geom.Circle): G;

        /**
         * Takes an array of Game Objects and positions them at random locations within the Ellipse.
         * 
         * If you wish to pass a `Phaser.GameObjects.Ellipse` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param ellipse The Ellipse to position the Game Objects within.
         */
        function RandomEllipse<G extends Phaser.GameObjects.GameObject[]>(items: G, ellipse: Phaser.Geom.Ellipse): G;

        /**
         * Takes an array of Game Objects and positions them at random locations on the Line.
         * 
         * If you wish to pass a `Phaser.GameObjects.Line` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param line The Line to position the Game Objects randomly on.
         */
        function RandomLine<G extends Phaser.GameObjects.GameObject[]>(items: G, line: Phaser.Geom.Line): G;

        /**
         * Takes an array of Game Objects and positions them at random locations within the Rectangle.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param rect The Rectangle to position the Game Objects within.
         */
        function RandomRectangle<G extends Phaser.GameObjects.GameObject[]>(items: G, rect: Phaser.Geom.Rectangle): G;

        /**
         * Takes an array of Game Objects and positions them at random locations within the Triangle.
         * 
         * If you wish to pass a `Phaser.GameObjects.Triangle` Shape to this function, you should pass its `geom` property.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param triangle The Triangle to position the Game Objects within.
         */
        function RandomTriangle<G extends Phaser.GameObjects.GameObject[]>(items: G, triangle: Phaser.Geom.Triangle): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `rotation` property,
         * and then adds the given value to each of their `rotation` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `Rotate(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `rotation` property (in radians).
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function Rotate<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Rotates each item around the given point by the given angle.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param point Any object with public `x` and `y` properties.
         * @param angle The angle to rotate by, in radians.
         */
        function RotateAround<G extends Phaser.GameObjects.GameObject[]>(items: G, point: object, angle: number): G;

        /**
         * Rotates an array of Game Objects around a point by the given angle and distance.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param point Any object with public `x` and `y` properties.
         * @param angle The angle to rotate by, in radians.
         * @param distance The distance from the point of rotation in pixels.
         */
        function RotateAroundDistance<G extends Phaser.GameObjects.GameObject[]>(items: G, point: object, angle: number, distance: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `scaleX` property,
         * and then adds the given value to each of their `scaleX` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `ScaleX(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `scaleX` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function ScaleX<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have public `scaleX` and `scaleY` properties,
         * and then adds the given value to each of them.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `ScaleXY(group.getChildren(), scaleX, scaleY, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param scaleX The amount to be added to the `scaleX` property.
         * @param scaleY The amount to be added to the `scaleY` property. If `undefined` or `null` it uses the `scaleX` value.
         * @param stepX This is added to the `scaleX` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `scaleY` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function ScaleXY<G extends Phaser.GameObjects.GameObject[]>(items: G, scaleX: number, scaleY?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have a public `scaleY` property,
         * and then adds the given value to each of their `scaleY` properties.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `ScaleY(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to be added to the `scaleY` property.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function ScaleY<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `alpha`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetAlpha(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetAlpha<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `blendMode`
         * and then sets it to the given value.
         * 
         * To use this with a Group: `SetBlendMode(group.getChildren(), value)`
         * @param items The array of items to be updated by this action.
         * @param value The Blend Mode to be set.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetBlendMode<G extends Phaser.GameObjects.GameObject[]>(items: G, value: Phaser.BlendModes | string | number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `depth`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetDepth(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetDepth<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Passes all provided Game Objects to the Input Manager to enable them for input with identical areas and callbacks.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param hitArea Either an input configuration object, or a geometric shape that defines the hit area for the Game Object. If not given it will try to create a Rectangle based on the texture frame.
         * @param callback The callback that determines if the pointer is within the Hit Area shape or not. If you provide a shape you must also provide a callback.
         */
        function SetHitArea<G extends Phaser.GameObjects.GameObject[]>(items: G, hitArea?: Phaser.Types.Input.InputConfiguration | any, callback?: Phaser.Types.Input.HitAreaCallback): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public properties `originX` and `originY`
         * and then sets them to the given values.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetOrigin(group.getChildren(), originX, originY, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param originX The amount to set the `originX` property to.
         * @param originY The amount to set the `originY` property to. If `undefined` or `null` it uses the `originX` value.
         * @param stepX This is added to the `originX` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `originY` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetOrigin<G extends Phaser.GameObjects.GameObject[]>(items: G, originX: number, originY?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `rotation`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetRotation(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetRotation<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public properties `scaleX` and `scaleY`
         * and then sets them to the given values.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScale(group.getChildren(), scaleX, scaleY, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param scaleX The amount to set the `scaleX` property to.
         * @param scaleY The amount to set the `scaleY` property to. If `undefined` or `null` it uses the `scaleX` value.
         * @param stepX This is added to the `scaleX` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `scaleY` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScale<G extends Phaser.GameObjects.GameObject[]>(items: G, scaleX: number, scaleY?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `scaleX`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScaleX(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScaleX<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `scaleY`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScaleY(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScaleY<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public properties `scrollFactorX` and `scrollFactorY`
         * and then sets them to the given values.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScrollFactor(group.getChildren(), scrollFactorX, scrollFactorY, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param scrollFactorX The amount to set the `scrollFactorX` property to.
         * @param scrollFactorY The amount to set the `scrollFactorY` property to. If `undefined` or `null` it uses the `scrollFactorX` value.
         * @param stepX This is added to the `scrollFactorX` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `scrollFactorY` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScrollFactor<G extends Phaser.GameObjects.GameObject[]>(items: G, scrollFactorX: number, scrollFactorY?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `scrollFactorX`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScrollFactorX(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScrollFactorX<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `scrollFactorY`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetScrollFactorY(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetScrollFactorY<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public method setTint() and then updates it to the given value(s). You can specify tint color per corner or provide only one color value for `topLeft` parameter, in which case whole item will be tinted with that color.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param topLeft The tint being applied to top-left corner of item. If other parameters are given no value, this tint will be applied to whole item.
         * @param topRight The tint to be applied to top-right corner of item.
         * @param bottomLeft The tint to be applied to the bottom-left corner of item.
         * @param bottomRight The tint to be applied to the bottom-right corner of item.
         */
        function SetTint<G extends Phaser.GameObjects.GameObject[]>(items: G, topLeft: number, topRight?: number, bottomLeft?: number, bottomRight?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `visible`
         * and then sets it to the given value.
         * 
         * To use this with a Group: `SetVisible(group.getChildren(), value)`
         * @param items The array of items to be updated by this action.
         * @param value The value to set the property to.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetVisible<G extends Phaser.GameObjects.GameObject[]>(items: G, value: boolean, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `x`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetX(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetX<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public properties `x` and `y`
         * and then sets them to the given values.
         * 
         * The optional `stepX` and `stepY` properties are applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetXY(group.getChildren(), x, y, stepX, stepY)`
         * @param items The array of items to be updated by this action.
         * @param x The amount to set the `x` property to.
         * @param y The amount to set the `y` property to. If `undefined` or `null` it uses the `x` value. Default x.
         * @param stepX This is added to the `x` amount, multiplied by the iteration counter. Default 0.
         * @param stepY This is added to the `y` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetXY<G extends Phaser.GameObjects.GameObject[]>(items: G, x: number, y?: number, stepX?: number, stepY?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of Game Objects, or any objects that have the public property `y`
         * and then sets it to the given value.
         * 
         * The optional `step` property is applied incrementally, multiplied by each item in the array.
         * 
         * To use this with a Group: `SetY(group.getChildren(), value, step)`
         * @param items The array of items to be updated by this action.
         * @param value The amount to set the property to.
         * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
         * @param index An optional offset to start searching from within the items array. Default 0.
         * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
         */
        function SetY<G extends Phaser.GameObjects.GameObject[]>(items: G, value: number, step?: number, index?: number, direction?: number): G;

        /**
         * Takes an array of items, such as Game Objects, or any objects with public `x` and
         * `y` properties and then iterates through them. As this function iterates, it moves
         * the position of the current element to be that of the previous entry in the array.
         * This repeats until all items have been moved.
         * 
         * The direction controls the order of iteration. A value of 0 (the default) assumes
         * that the final item in the array is the 'head' item.
         * 
         * A direction value of 1 assumes that the first item in the array is the 'head' item.
         * 
         * The position of the 'head' item is set to the x/y values given to this function.
         * Every other item in the array is then updated, in sequence, to be that of the
         * previous (or next) entry in the array.
         * 
         * The final x/y coords are returned, or set in the 'output' Vector2.
         * 
         * Think of it as being like the game Snake, where the 'head' is moved and then
         * each body piece is moved into the space of the previous piece.
         * @param items An array of Game Objects, or objects with public x and y positions. The contents of this array are updated by this Action.
         * @param x The x coordinate to place the head item at.
         * @param y The y coordinate to place the head item at.
         * @param direction The iteration direction. 0 = first to last and 1 = last to first. Default 0.
         * @param output An optional Vec2Like object to store the final position in.
         */
        function ShiftPosition<G extends Phaser.GameObjects.GameObject[], O extends Phaser.Math.Vector2>(items: G, x: number, y: number, direction?: number, output?: O): O;

        /**
         * Shuffles the array in place. The shuffled array is both modified and returned.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         */
        function Shuffle<G extends Phaser.GameObjects.GameObject[]>(items: G): G;

        /**
         * Smootherstep is a sigmoid-like interpolation and clamping function.
         * 
         * The function depends on three parameters, the input x, the "left edge" and the "right edge", with the left edge being assumed smaller than the right edge. The function receives a real number x as an argument and returns 0 if x is less than or equal to the left edge, 1 if x is greater than or equal to the right edge, and smoothly interpolates, using a Hermite polynomial, between 0 and 1 otherwise. The slope of the smoothstep function is zero at both edges. This is convenient for creating a sequence of transitions using smoothstep to interpolate each segment as an alternative to using more sophisticated or expensive interpolation techniques.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param property The property of the Game Object to interpolate.
         * @param min The minimum interpolation value.
         * @param max The maximum interpolation value.
         * @param inc Should the values be incremented? `true` or set (`false`) Default false.
         */
        function SmootherStep<G extends Phaser.GameObjects.GameObject[]>(items: G, property: string, min: number, max: number, inc?: boolean): G;

        /**
         * Smoothstep is a sigmoid-like interpolation and clamping function.
         * 
         * The function depends on three parameters, the input x, the "left edge"
         * and the "right edge", with the left edge being assumed smaller than the right edge.
         * 
         * The function receives a real number x as an argument and returns 0 if x is less than
         * or equal to the left edge, 1 if x is greater than or equal to the right edge, and smoothly
         * interpolates, using a Hermite polynomial, between 0 and 1 otherwise. The slope of the
         * smoothstep function is zero at both edges.
         * 
         * This is convenient for creating a sequence of transitions using smoothstep to interpolate
         * each segment as an alternative to using more sophisticated or expensive interpolation techniques.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param property The property of the Game Object to interpolate.
         * @param min The minimum interpolation value.
         * @param max The maximum interpolation value.
         * @param inc Should the property value be incremented (`true`) or set (`false`)? Default false.
         */
        function SmoothStep<G extends Phaser.GameObjects.GameObject[]>(items: G, property: string, min: number, max: number, inc?: boolean): G;

        /**
         * Takes an array of Game Objects and then modifies their `property` so the value equals, or is incremented, by the
         * calculated spread value.
         * 
         * The spread value is derived from the given `min` and `max` values and the total number of items in the array.
         * 
         * For example, to cause an array of Sprites to change in alpha from 0 to 1 you could call:
         * 
         * ```javascript
         * Phaser.Actions.Spread(itemsArray, 'alpha', 0, 1);
         * ```
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param property The property of the Game Object to spread.
         * @param min The minimum value.
         * @param max The maximum value.
         * @param inc Should the values be incremented? `true` or set (`false`) Default false.
         */
        function Spread<G extends Phaser.GameObjects.GameObject[]>(items: G, property: string, min: number, max: number, inc?: boolean): G;

        /**
         * Takes an array of Game Objects and toggles the visibility of each one.
         * Those previously `visible = false` will become `visible = true`, and vice versa.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         */
        function ToggleVisible<G extends Phaser.GameObjects.GameObject[]>(items: G): G;

        /**
         * Iterates through the given array and makes sure that each objects x and y
         * properties are wrapped to keep them contained within the given Rectangles
         * area.
         * @param items An array of Game Objects. The contents of this array are updated by this Action.
         * @param rect The rectangle which the objects will be wrapped to remain within.
         * @param padding An amount added to each side of the rectangle during the operation. Default 0.
         */
        function WrapInRectangle<G extends Phaser.GameObjects.GameObject[]>(items: G, rect: Phaser.Geom.Rectangle, padding?: number): G;

    }

    namespace Animations {
        /**
         * A Frame based Animation.
         * 
         * Animations in Phaser consist of a sequence of `AnimationFrame` objects, which are managed by
         * this class, along with properties that impact playback, such as the animations frame rate
         * or delay.
         * 
         * This class contains all of the properties and methods needed to handle playback of the animation
         * directly to an `AnimationState` instance, which is owned by a Sprite, or similar Game Object.
         * 
         * You don't typically create an instance of this class directly, but instead go via
         * either the `AnimationManager` or the `AnimationState` and use their `create` methods,
         * depending on if you need a global animation, or local to a specific Sprite.
         */
        class Animation {
            /**
             * 
             * @param manager A reference to the global Animation Manager
             * @param key The unique identifying string for this animation.
             * @param config The Animation configuration.
             */
            constructor(manager: Phaser.Animations.AnimationManager, key: string, config: Phaser.Types.Animations.Animation);

            /**
             * A reference to the global Animation Manager.
             */
            manager: Phaser.Animations.AnimationManager;

            /**
             * The unique identifying string for this animation.
             */
            key: string;

            /**
             * A frame based animation (as opposed to a bone based animation)
             */
            type: string;

            /**
             * Extract all the frame data into the frames array.
             */
            frames: Phaser.Animations.AnimationFrame[];

            /**
             * The frame rate of playback in frames per second (default 24 if duration is null)
             */
            frameRate: number;

            /**
             * How long the animation should play for, in milliseconds.
             * If the `frameRate` property has been set then it overrides this value,
             * otherwise the `frameRate` is derived from `duration`.
             */
            duration: number;

            /**
             * How many ms per frame, not including frame specific modifiers.
             */
            msPerFrame: number;

            /**
             * Skip frames if the time lags, or always advanced anyway?
             */
            skipMissedFrames: boolean;

            /**
             * The delay in ms before the playback will begin.
             */
            delay: number;

            /**
             * Number of times to repeat the animation. Set to -1 to repeat forever.
             */
            repeat: number;

            /**
             * The delay in ms before the a repeat play starts.
             */
            repeatDelay: number;

            /**
             * Should the animation yoyo (reverse back down to the start) before repeating?
             */
            yoyo: boolean;

            /**
             * If the animation has a delay set, before playback will begin, this
             * controls when the first frame is set on the Sprite. If this property
             * is 'false' then the frame is set only after the delay has expired.
             * This is the default behavior.
             */
            showBeforeDelay: boolean;

            /**
             * Should the GameObject's `visible` property be set to `true` when the animation starts to play?
             */
            showOnStart: boolean;

            /**
             * Should the GameObject's `visible` property be set to `false` when the animation finishes?
             */
            hideOnComplete: boolean;

            /**
             * Start playback of this animation from a random frame?
             */
            randomFrame: boolean;

            /**
             * Global pause. All Game Objects using this Animation instance are impacted by this property.
             */
            paused: boolean;

            /**
             * Gets the total number of frames in this animation.
             */
            getTotalFrames(): number;

            /**
             * Calculates the duration, frame rate and msPerFrame values.
             * @param target The target to set the values on.
             * @param totalFrames The total number of frames in the animation.
             * @param duration The duration to calculate the frame rate from. Pass `null` if you wish to set the `frameRate` instead.
             * @param frameRate The frame rate to calculate the duration from.
             */
            calculateDuration(target: Phaser.Animations.Animation, totalFrames: number, duration?: number | undefined, frameRate?: number | undefined): void;

            /**
             * Add frames to the end of the animation.
             * @param config Either a string, in which case it will use all frames from a texture with the matching key, or an array of Animation Frame configuration objects.
             */
            addFrame(config: string | Phaser.Types.Animations.AnimationFrame[]): this;

            /**
             * Add frame/s into the animation.
             * @param index The index to insert the frame at within the animation.
             * @param config Either a string, in which case it will use all frames from a texture with the matching key, or an array of Animation Frame configuration objects.
             */
            addFrameAt(index: number, config: string | Phaser.Types.Animations.AnimationFrame[]): this;

            /**
             * Check if the given frame index is valid.
             * @param index The index to be checked.
             */
            checkFrame(index: number): boolean;

            /**
             * Called internally when this Animation first starts to play.
             * Sets the accumulator and nextTick properties.
             * @param state The Animation State belonging to the Game Object invoking this call.
             */
            protected getFirstTick(state: Phaser.Animations.AnimationState): void;

            /**
             * Returns the AnimationFrame at the provided index
             * @param index The index in the AnimationFrame array
             */
            getFrameAt(index: number): Phaser.Animations.AnimationFrame;

            /**
             * Creates AnimationFrame instances based on the given frame data.
             * @param textureManager A reference to the global Texture Manager.
             * @param frames Either a string, in which case it will use all frames from a texture with the matching key, or an array of Animation Frame configuration objects.
             * @param defaultTextureKey The key to use if no key is set in the frame configuration object.
             */
            getFrames(textureManager: Phaser.Textures.TextureManager, frames: string | Phaser.Types.Animations.AnimationFrame[], defaultTextureKey?: string): Phaser.Animations.AnimationFrame[];

            /**
             * Called internally. Sets the accumulator and nextTick values of the current Animation.
             * @param state The Animation State belonging to the Game Object invoking this call.
             */
            getNextTick(state: Phaser.Animations.AnimationState): void;

            /**
             * Returns the frame closest to the given progress value between 0 and 1.
             * @param value A value between 0 and 1.
             */
            getFrameByProgress(value: number): Phaser.Animations.AnimationFrame;

            /**
             * Advance the animation frame.
             * @param state The Animation State to advance.
             */
            nextFrame(state: Phaser.Animations.AnimationState): void;

            /**
             * Returns the animation last frame.
             */
            getLastFrame(): Phaser.Animations.AnimationFrame;

            /**
             * Called internally when the Animation is playing backwards.
             * Sets the previous frame, causing a yoyo, repeat, complete or update, accordingly.
             * @param state The Animation State belonging to the Game Object invoking this call.
             */
            previousFrame(state: Phaser.Animations.AnimationState): void;

            /**
             * Removes the given AnimationFrame from this Animation instance.
             * This is a global action. Any Game Object using this Animation will be impacted by this change.
             * @param frame The AnimationFrame to be removed.
             */
            removeFrame(frame: Phaser.Animations.AnimationFrame): this;

            /**
             * Removes a frame from the AnimationFrame array at the provided index
             * and updates the animation accordingly.
             * @param index The index in the AnimationFrame array
             */
            removeFrameAt(index: number): this;

            /**
             * Called internally during playback. Forces the animation to repeat, providing there are enough counts left
             * in the repeat counter.
             * @param state The Animation State belonging to the Game Object invoking this call.
             */
            repeatAnimation(state: Phaser.Animations.AnimationState): void;

            /**
             * Converts the animation data to JSON.
             */
            toJSON(): Phaser.Types.Animations.JSONAnimation;

            /**
             * Called internally whenever frames are added to, or removed from, this Animation.
             */
            updateFrameSequence(): this;

            /**
             * Pauses playback of this Animation. The paused state is set immediately.
             */
            pause(): this;

            /**
             * Resumes playback of this Animation. The paused state is reset immediately.
             */
            resume(): this;

            /**
             * Destroys this Animation instance. It will remove all event listeners,
             * remove this animation and its key from the global Animation Manager,
             * and then destroy all Animation Frames in turn.
             */
            destroy(): void;

        }

        /**
         * A single frame in an Animation sequence.
         * 
         * An AnimationFrame consists of a reference to the Texture it uses for rendering, references to other
         * frames in the animation, and index data. It also has the ability to modify the animation timing.
         * 
         * AnimationFrames are generated automatically by the Animation class.
         */
        class AnimationFrame {
            /**
             * 
             * @param textureKey The key of the Texture this AnimationFrame uses.
             * @param textureFrame The key of the Frame within the Texture that this AnimationFrame uses.
             * @param index The index of this AnimationFrame within the Animation sequence.
             * @param frame A reference to the Texture Frame this AnimationFrame uses for rendering.
             * @param isKeyFrame Is this Frame a Keyframe within the Animation? Default false.
             */
            constructor(textureKey: string, textureFrame: string | number, index: number, frame: Phaser.Textures.Frame, isKeyFrame?: boolean);

            /**
             * The key of the Texture this AnimationFrame uses.
             */
            textureKey: string;

            /**
             * The key of the Frame within the Texture that this AnimationFrame uses.
             */
            textureFrame: string | number;

            /**
             * The index of this AnimationFrame within the Animation sequence.
             */
            index: number;

            /**
             * A reference to the Texture Frame this AnimationFrame uses for rendering.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Is this the first frame in an animation sequence?
             */
            readonly isFirst: boolean;

            /**
             * Is this the last frame in an animation sequence?
             */
            readonly isLast: boolean;

            /**
             * A reference to the AnimationFrame that comes before this one in the animation, if any.
             */
            readonly prevFrame: Phaser.Animations.AnimationFrame | null;

            /**
             * A reference to the AnimationFrame that comes after this one in the animation, if any.
             */
            readonly nextFrame: Phaser.Animations.AnimationFrame | null;

            /**
             * Additional time (in ms) that this frame should appear for during playback.
             * The value is added onto the msPerFrame set by the animation.
             */
            duration: number;

            /**
             * What % through the animation does this frame come?
             * This value is generated when the animation is created and cached here.
             */
            readonly progress: number;

            /**
             * Is this Frame a KeyFrame within the Animation?
             */
            isKeyFrame: boolean;

            /**
             * Generates a JavaScript object suitable for converting to JSON.
             */
            toJSON(): Phaser.Types.Animations.JSONAnimationFrame;

            /**
             * Destroys this object by removing references to external resources and callbacks.
             */
            destroy(): void;

        }

        /**
         * The Animation Manager.
         * 
         * Animations are managed by the global Animation Manager. This is a singleton class that is
         * responsible for creating and delivering animations and their corresponding data to all Game Objects.
         * Unlike plugins it is owned by the Game instance, not the Scene.
         * 
         * Sprites and other Game Objects get the data they need from the AnimationManager.
         */
        class AnimationManager extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param game A reference to the Phaser.Game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * A reference to the Phaser.Game instance.
             */
            protected game: Phaser.Game;

            /**
             * A reference to the Texture Manager.
             */
            protected textureManager: Phaser.Textures.TextureManager;

            /**
             * The global time scale of the Animation Manager.
             * 
             * This scales the time delta between two frames, thus influencing the speed of time for the Animation Manager.
             */
            globalTimeScale: number;

            /**
             * The Animations registered in the Animation Manager.
             * 
             * This map should be modified with the {@link #add} and {@link #create} methods of the Animation Manager.
             */
            protected anims: Phaser.Structs.Map<string, Phaser.Animations.Animation>;

            /**
             * A list of animation mix times.
             * 
             * See the {@link #setMix} method for more details.
             */
            mixes: Phaser.Structs.Map<string, Phaser.Animations.Animation>;

            /**
             * Whether the Animation Manager is paused along with all of its Animations.
             */
            paused: boolean;

            /**
             * The name of this Animation Manager.
             */
            name: string;

            /**
             * Registers event listeners after the Game boots.
             */
            boot(): void;

            /**
             * Adds a mix between two animations.
             * 
             * Mixing allows you to specify a unique delay between a pairing of animations.
             * 
             * When playing Animation A on a Game Object, if you then play Animation B, and a
             * mix exists, it will wait for the specified delay to be over before playing Animation B.
             * 
             * This allows you to customise smoothing between different types of animation, such
             * as blending between an idle and a walk state, or a running and a firing state.
             * 
             * Note that mixing is only applied if you use the `Sprite.play` method. If you opt to use
             * `playAfterRepeat` or `playAfterDelay` instead, those will take priority and the mix
             * delay will not be used.
             * 
             * To update an existing mix, just call this method with the new delay.
             * 
             * To remove a mix pairing, see the `removeMix` method.
             * @param animA The string-based key, or instance of, Animation A.
             * @param animB The string-based key, or instance of, Animation B.
             * @param delay The delay, in milliseconds, to wait when transitioning from Animation A to B.
             */
            addMix(animA: string | Phaser.Animations.Animation, animB: string | Phaser.Animations.Animation, delay: number): this;

            /**
             * Removes a mix between two animations.
             * 
             * Mixing allows you to specify a unique delay between a pairing of animations.
             * 
             * Calling this method lets you remove those pairings. You can either remove
             * it between `animA` and `animB`, or if you do not provide the `animB` parameter,
             * it will remove all `animA` mixes.
             * 
             * If you wish to update an existing mix instead, call the `addMix` method with the
             * new delay.
             * @param animA The string-based key, or instance of, Animation A.
             * @param animB The string-based key, or instance of, Animation B. If not given, all mixes for Animation A will be removed.
             */
            removeMix(animA: string | Phaser.Animations.Animation, animB?: string | Phaser.Animations.Animation): this;

            /**
             * Returns the mix delay between two animations.
             * 
             * If no mix has been set-up, this method will return zero.
             * 
             * If you wish to create, or update, a new mix, call the `addMix` method.
             * If you wish to remove a mix, call the `removeMix` method.
             * @param animA The string-based key, or instance of, Animation A.
             * @param animB The string-based key, or instance of, Animation B.
             */
            getMix(animA: string | Phaser.Animations.Animation, animB: string | Phaser.Animations.Animation): number;

            /**
             * Adds an existing Animation to the Animation Manager.
             * @param key The key under which the Animation should be added. The Animation will be updated with it. Must be unique.
             * @param animation The Animation which should be added to the Animation Manager.
             */
            add(key: string, animation: Phaser.Animations.Animation): this;

            /**
             * Checks to see if the given key is already in use within the Animation Manager or not.
             * 
             * Animations are global. Keys created in one scene can be used from any other Scene in your game. They are not Scene specific.
             * @param key The key of the Animation to check.
             */
            exists(key: string): boolean;

            /**
             * Create one, or more animations from a loaded Aseprite JSON file.
             * 
             * Aseprite is a powerful animated sprite editor and pixel art tool.
             * 
             * You can find more details at https://www.aseprite.org/
             * 
             * To export a compatible JSON file in Aseprite, please do the following:
             * 
             * 1. Go to "File - Export Sprite Sheet"
             * 
             * 2. On the **Layout** tab:
             * 2a. Set the "Sheet type" to "Packed"
             * 2b. Set the "Constraints" to "None"
             * 2c. Check the "Merge Duplicates" checkbox
             * 
             * 3. On the **Sprite** tab:
             * 3a. Set "Layers" to "Visible layers"
             * 3b. Set "Frames" to "All frames", unless you only wish to export a sub-set of tags
             * 
             * 4. On the **Borders** tab:
             * 4a. Check the "Trim Sprite" and "Trim Cells" options
             * 4b. Ensure "Border Padding", "Spacing" and "Inner Padding" are all > 0 (1 is usually enough)
             * 
             * 5. On the **Output** tab:
             * 5a. Check "Output File", give your image a name and make sure you choose "png files" as the file type
             * 5b. Check "JSON Data" and give your json file a name
             * 5c. The JSON Data type can be either a Hash or Array, Phaser doesn't mind.
             * 5d. Make sure "Tags" is checked in the Meta options
             * 5e. In the "Item Filename" input box, make sure it says just "{frame}" and nothing more.
             * 
             * 6. Click export
             * 
             * This was tested with Aseprite 1.2.25.
             * 
             * This will export a png and json file which you can load using the Aseprite Loader, i.e.:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.path = 'assets/animations/aseprite/';
             *     this.load.aseprite('paladin', 'paladin.png', 'paladin.json');
             * }
             * ```
             * 
             * Once loaded, you can call this method from within a Scene with the 'atlas' key:
             * 
             * ```javascript
             * this.anims.createFromAseprite('paladin');
             * ```
             * 
             * Any animations defined in the JSON will now be available to use in Phaser and you play them
             * via their Tag name. For example, if you have an animation called 'War Cry' on your Aseprite timeline,
             * you can play it in Phaser using that Tag name:
             * 
             * ```javascript
             * this.add.sprite(400, 300).play('War Cry');
             * ```
             * 
             * When calling this method you can optionally provide an array of tag names, and only those animations
             * will be created. For example:
             * 
             * ```javascript
             * this.anims.createFromAseprite('paladin', [ 'step', 'War Cry', 'Magnum Break' ]);
             * ```
             * 
             * This will only create the 3 animations defined. Note that the tag names are case-sensitive.
             * @param key The key of the loaded Aseprite atlas. It must have been loaded prior to calling this method.
             * @param tags An array of Tag names. If provided, only animations found in this array will be created.
             * @param target Create the animations on this target Sprite. If not given, they will be created globally in this Animation Manager.
             */
            createFromAseprite(key: string, tags?: string[], target?: Phaser.Animations.AnimationManager | Phaser.GameObjects.GameObject): Phaser.Animations.Animation[];

            /**
             * Creates a new Animation and adds it to the Animation Manager.
             * 
             * Animations are global. Once created, you can use them in any Scene in your game. They are not Scene specific.
             * 
             * If an invalid key is given this method will return `false`.
             * 
             * If you pass the key of an animation that already exists in the Animation Manager, that animation will be returned.
             * 
             * A brand new animation is only created if the key is valid and not already in use.
             * 
             * If you wish to re-use an existing key, call `AnimationManager.remove` first, then this method.
             * @param config The configuration settings for the Animation.
             */
            create(config: Phaser.Types.Animations.Animation): Phaser.Animations.Animation | false;

            /**
             * Loads this Animation Manager's Animations and settings from a JSON object.
             * @param data The JSON object to parse.
             * @param clearCurrentAnimations If set to `true`, the current animations will be removed (`anims.clear()`). If set to `false` (default), the animations in `data` will be added. Default false.
             */
            fromJSON(data: string | Phaser.Types.Animations.JSONAnimations | Phaser.Types.Animations.JSONAnimation, clearCurrentAnimations?: boolean): Phaser.Animations.Animation[];

            /**
             * Generate an array of {@link Phaser.Types.Animations.AnimationFrame} objects from a texture key and configuration object.
             * 
             * Generates objects with string based frame names, as configured by the given {@link Phaser.Types.Animations.GenerateFrameNames}.
             * 
             * It's a helper method, designed to make it easier for you to extract all of the frame names from texture atlases.
             * 
             * If you're working with a sprite sheet, see the `generateFrameNumbers` method instead.
             * 
             * Example:
             * 
             * If you have a texture atlases loaded called `gems` and it contains 6 frames called `ruby_0001`, `ruby_0002`, and so on,
             * then you can call this method using: `this.anims.generateFrameNames('gems', { prefix: 'ruby_', start: 1, end: 6, zeroPad: 4 })`.
             * 
             * The `end` value tells it to select frames 1 through 6, incrementally numbered, all starting with the prefix `ruby_`. The `zeroPad`
             * value tells it how many zeroes pad out the numbers. To create an animation using this method, you can do:
             * 
             * ```javascript
             * this.anims.create({
             *   key: 'ruby',
             *   repeat: -1,
             *   frames: this.anims.generateFrameNames('gems', {
             *     prefix: 'ruby_',
             *     end: 6,
             *     zeroPad: 4
             *   })
             * });
             * ```
             * 
             * Please see the animation examples for further details.
             * @param key The key for the texture containing the animation frames.
             * @param config The configuration object for the animation frame names.
             */
            generateFrameNames(key: string, config?: Phaser.Types.Animations.GenerateFrameNames): Phaser.Types.Animations.AnimationFrame[];

            /**
             * Generate an array of {@link Phaser.Types.Animations.AnimationFrame} objects from a texture key and configuration object.
             * 
             * Generates objects with numbered frame names, as configured by the given {@link Phaser.Types.Animations.GenerateFrameNumbers}.
             * 
             * If you're working with a texture atlas, see the `generateFrameNames` method instead.
             * 
             * It's a helper method, designed to make it easier for you to extract frames from sprite sheets.
             * 
             * Example:
             * 
             * If you have a sprite sheet loaded called `explosion` and it contains 12 frames, then you can call this method using:
             * 
             * `this.anims.generateFrameNumbers('explosion', { start: 0, end: 11 })`.
             * 
             * The `end` value of 11 tells it to stop after the 12th frame has been added, because it started at zero.
             * 
             * To create an animation using this method, you can do:
             * 
             * ```javascript
             * this.anims.create({
             *   key: 'boom',
             *   frames: this.anims.generateFrameNumbers('explosion', {
             *     start: 0,
             *     end: 11
             *   })
             * });
             * ```
             * 
             * Note that `start` is optional and you don't need to include it if the animation starts from frame 0.
             * 
             * To specify an animation in reverse, swap the `start` and `end` values.
             * 
             * If the frames are not sequential, you may pass an array of frame numbers instead, for example:
             * 
             * `this.anims.generateFrameNumbers('explosion', { frames: [ 0, 1, 2, 1, 2, 3, 4, 0, 1, 2 ] })`
             * 
             * Please see the animation examples and `GenerateFrameNumbers` config docs for further details.
             * @param key The key for the texture containing the animation frames.
             * @param config The configuration object for the animation frames.
             */
            generateFrameNumbers(key: string, config?: Phaser.Types.Animations.GenerateFrameNumbers): Phaser.Types.Animations.AnimationFrame[];

            /**
             * Get an Animation.
             * @param key The key of the Animation to retrieve.
             */
            get(key: string): Phaser.Animations.Animation;

            /**
             * Returns an array of all Animation keys that are using the given
             * Texture. Only Animations that have at least one AnimationFrame
             * entry using this texture will be included in the result.
             * @param key The unique string-based key of the Texture, or a Texture, or Frame instance.
             */
            getAnimsFromTexture(key: string | Phaser.Textures.Texture | Phaser.Textures.Frame): string[];

            /**
             * Pause all animations.
             */
            pauseAll(): this;

            /**
             * Play an animation on the given Game Objects that have an Animation Component.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param children An array of Game Objects to play the animation on. They must have an Animation Component.
             */
            play(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, children: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[]): this;

            /**
             * Takes an array of Game Objects that have an Animation Component and then
             * starts the given animation playing on them. The start time of each Game Object
             * is offset, incrementally, by the `stagger` amount.
             * 
             * For example, if you pass an array with 4 children and a stagger time of 1000,
             * the delays will be:
             * 
             * child 1: 1000ms delay
             * child 2: 2000ms delay
             * child 3: 3000ms delay
             * child 4: 4000ms delay
             * 
             * If you set the `staggerFirst` parameter to `false` they would be:
             * 
             * child 1: 0ms delay
             * child 2: 1000ms delay
             * child 3: 2000ms delay
             * child 4: 3000ms delay
             * 
             * You can also set `stagger` to be a negative value. If it was -1000, the above would be:
             * 
             * child 1: 3000ms delay
             * child 2: 2000ms delay
             * child 3: 1000ms delay
             * child 4: 0ms delay
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param children An array of Game Objects to play the animation on. They must have an Animation Component.
             * @param stagger The amount of time, in milliseconds, to offset each play time by. If a negative value is given, it's applied to the children in reverse order.
             * @param staggerFirst Should the first child be staggered as well? Default true.
             */
            staggerPlay<G extends Phaser.GameObjects.GameObject[]>(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, children: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], stagger: number, staggerFirst?: boolean): G;

            /**
             * Removes an Animation from this Animation Manager, based on the given key.
             * 
             * This is a global action. Once an Animation has been removed, no Game Objects
             * can carry on using it.
             * @param key The key of the animation to remove.
             */
            remove(key: string): Phaser.Animations.Animation;

            /**
             * Resume all paused animations.
             */
            resumeAll(): this;

            /**
             * Returns the Animation data as JavaScript object based on the given key.
             * Or, if not key is defined, it will return the data of all animations as array of objects.
             * @param key The animation to get the JSONAnimation data from. If not provided, all animations are returned as an array.
             */
            toJSON(key?: string): Phaser.Types.Animations.JSONAnimations;

            /**
             * Destroy this Animation Manager and clean up animation definitions and references to other objects.
             * This method should not be called directly. It will be called automatically as a response to a `destroy` event from the Phaser.Game instance.
             */
            destroy(): void;

        }

        /**
         * The Animation State Component.
         * 
         * This component provides features to apply animations to Game Objects. It is responsible for
         * loading, queuing animations for later playback, mixing between animations and setting
         * the current animation frame to the Game Object that owns this component.
         * 
         * This component lives as an instance within any Game Object that has it defined, such as Sprites.
         * 
         * You can access its properties and methods via the `anims` property, i.e. `Sprite.anims`.
         * 
         * As well as playing animations stored in the global Animation Manager, this component
         * can also create animations that are stored locally within it. See the `create` method
         * for more details.
         * 
         * Prior to Phaser 3.50 this component was called just `Animation` and lived in the
         * `Phaser.GameObjects.Components` namespace. It was renamed to `AnimationState`
         * in 3.50 to help better identify its true purpose when browsing the documentation.
         */
        class AnimationState {
            /**
             * 
             * @param parent The Game Object to which this animation component belongs.
             */
            constructor(parent: Phaser.GameObjects.GameObject);

            /**
             * The Game Object to which this animation component belongs.
             * 
             * You can typically access this component from the Game Object
             * via the `this.anims` property.
             */
            parent: Phaser.GameObjects.GameObject;

            /**
             * A reference to the global Animation Manager.
             */
            animationManager: Phaser.Animations.AnimationManager;

            /**
             * A reference to the Texture Manager.
             */
            protected textureManager: Phaser.Textures.TextureManager;

            /**
             * The Animations stored locally in this Animation component.
             * 
             * Do not modify the contents of this Map directly, instead use the
             * `add`, `create` and `remove` methods of this class instead.
             */
            protected anims: Phaser.Structs.Map<string, Phaser.Animations.Animation>;

            /**
             * Is an animation currently playing or not?
             */
            isPlaying: boolean;

            /**
             * Has the current animation started playing, or is it waiting for a delay to expire?
             */
            hasStarted: boolean;

            /**
             * The current Animation loaded into this Animation component.
             * 
             * Will by `null` if no animation is yet loaded.
             */
            currentAnim: Phaser.Animations.Animation | null;

            /**
             * The current AnimationFrame being displayed by this Animation component.
             * 
             * Will by `null` if no animation is yet loaded.
             */
            currentFrame: Phaser.Animations.AnimationFrame | null;

            /**
             * The key, instance, or config of the next Animation to be loaded into this Animation component
             * when the current animation completes.
             * 
             * Will by `null` if no animation has been queued.
             */
            nextAnim: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig | null;

            /**
             * A queue of Animations to be loaded into this Animation component when the current animation completes.
             * 
             * Populate this queue via the `chain` method.
             */
            nextAnimsQueue: any[];

            /**
             * The Time Scale factor.
             * 
             * You can adjust this value to modify the passage of time for the animation that is currently
             * playing. For example, setting it to 2 will make the animation play twice as fast. Or setting
             * it to 0.5 will slow the animation down.
             * 
             * You can change this value at run-time, or set it via the `PlayAnimationConfig`.
             * 
             * Prior to Phaser 3.50 this property was private and called `_timeScale`.
             */
            timeScale: number;

            /**
             * The frame rate of playback, of the current animation, in frames per second.
             * 
             * This value is set when a new animation is loaded into this component and should
             * be treated as read-only, as changing it once playback has started will not alter
             * the animation. To change the frame rate, provide a new value in the `PlayAnimationConfig` object.
             */
            frameRate: number;

            /**
             * The duration of the current animation, in milliseconds.
             * 
             * This value is set when a new animation is loaded into this component and should
             * be treated as read-only, as changing it once playback has started will not alter
             * the animation. To change the duration, provide a new value in the `PlayAnimationConfig` object.
             */
            duration: number;

            /**
             * The number of milliseconds per frame, not including frame specific modifiers that may be present in the
             * Animation data.
             * 
             * This value is calculated when a new animation is loaded into this component and should
             * be treated as read-only. Changing it will not alter playback speed.
             */
            msPerFrame: number;

            /**
             * Skip frames if the time lags, or always advanced anyway?
             */
            skipMissedFrames: boolean;

            /**
             * Start playback of this animation from a random frame?
             */
            randomFrame: boolean;

            /**
             * The delay before starting playback of the current animation, in milliseconds.
             * 
             * This value is set when a new animation is loaded into this component and should
             * be treated as read-only, as changing it once playback has started will not alter
             * the animation. To change the delay, provide a new value in the `PlayAnimationConfig` object.
             * 
             * Prior to Phaser 3.50 this property was private and called `_delay`.
             */
            delay: number;

            /**
             * The number of times to repeat playback of the current animation.
             * 
             * If -1, it means the animation will repeat forever.
             * 
             * This value is set when a new animation is loaded into this component and should
             * be treated as read-only, as changing it once playback has started will not alter
             * the animation. To change the number of repeats, provide a new value in the `PlayAnimationConfig` object.
             * 
             * Prior to Phaser 3.50 this property was private and called `_repeat`.
             */
            repeat: number;

            /**
             * The number of milliseconds to wait before starting the repeat playback of the current animation.
             * 
             * This value is set when a new animation is loaded into this component, but can also be modified
             * at run-time.
             * 
             * You can change the repeat delay by providing a new value in the `PlayAnimationConfig` object.
             * 
             * Prior to Phaser 3.50 this property was private and called `_repeatDelay`.
             */
            repeatDelay: number;

            /**
             * Should the current animation yoyo? An animation that yoyos will play in reverse, from the end
             * to the start, before then repeating or completing. An animation that does not yoyo will just
             * play from the start to the end.
             * 
             * This value is set when a new animation is loaded into this component, but can also be modified
             * at run-time.
             * 
             * You can change the yoyo by providing a new value in the `PlayAnimationConfig` object.
             * 
             * Prior to Phaser 3.50 this property was private and called `_yoyo`.
             */
            yoyo: boolean;

            /**
             * If the animation has a delay set, before playback will begin, this
             * controls when the first frame is set on the Sprite. If this property
             * is 'false' then the frame is set only after the delay has expired.
             * This is the default behavior.
             * 
             * If this property is 'true' then the first frame of this animation
             * is set immediately, and then when the delay expires, playback starts.
             */
            showBeforeDelay: boolean;

            /**
             * Should the GameObject's `visible` property be set to `true` when the animation starts to play?
             * 
             * This will happen _after_ any delay that may have been set.
             * 
             * This value is set when a new animation is loaded into this component, but can also be modified
             * at run-time, assuming the animation is currently delayed.
             */
            showOnStart: boolean;

            /**
             * Should the GameObject's `visible` property be set to `false` when the animation completes?
             * 
             * This value is set when a new animation is loaded into this component, but can also be modified
             * at run-time, assuming the animation is still actively playing.
             */
            hideOnComplete: boolean;

            /**
             * Is the playhead moving forwards (`true`) or in reverse (`false`) ?
             */
            forward: boolean;

            /**
             * An internal trigger that tells the component if it should plays the animation
             * in reverse mode ('true') or not ('false'). This is used because `forward` can
             * be changed by the `yoyo` feature.
             * 
             * Prior to Phaser 3.50 this property was private and called `_reverse`.
             */
            inReverse: boolean;

            /**
             * Internal time overflow accumulator.
             * 
             * This has the `delta` time added to it as part of the `update` step.
             */
            accumulator: number;

            /**
             * The time point at which the next animation frame will change.
             * 
             * This value is compared against the `accumulator` as part of the `update` step.
             */
            nextTick: number;

            /**
             * A counter keeping track of how much delay time, in milliseconds, is left before playback begins.
             * 
             * This is set via the `playAfterDelay` method, although it can be modified at run-time
             * if required, as long as the animation has not already started playing.
             */
            delayCounter: number;

            /**
             * A counter that keeps track of how many repeats are left to run.
             * 
             * This value is set when a new animation is loaded into this component, but can also be modified
             * at run-time.
             */
            repeatCounter: number;

            /**
             * An internal flag keeping track of pending repeats.
             */
            pendingRepeat: boolean;

            /**
             * Sets an animation, or an array of animations, to be played in the future, after the current one completes or stops.
             * 
             * The current animation must enter a 'completed' state for this to happen, i.e. finish all of its repeats, delays, etc,
             * or have one of the `stop` methods called.
             * 
             * An animation set to repeat forever will never enter a completed state unless stopped.
             * 
             * You can chain a new animation at any point, including before the current one starts playing, during it, or when it ends (via its `animationcomplete` event).
             * 
             * Chained animations are specific to a Game Object, meaning different Game Objects can have different chained animations without impacting the global animation they're playing.
             * 
             * Call this method with no arguments to reset all currently chained animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object, or an array of them.
             */
            chain(key?: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig | string[] | Phaser.Animations.Animation[] | Phaser.Types.Animations.PlayAnimationConfig[]): Phaser.GameObjects.GameObject;

            /**
             * Returns the key of the animation currently loaded into this component.
             * 
             * Prior to Phaser 3.50 this method was called `getCurrentKey`.
             */
            getName(): string;

            /**
             * Returns the key of the animation frame currently displayed by this component.
             */
            getFrameName(): string;

            /**
             * Internal method used to load an animation into this component.
             * @param key The string-based key of the animation to play, or a `PlayAnimationConfig` object.
             */
            protected load(key: string | Phaser.Types.Animations.PlayAnimationConfig): Phaser.GameObjects.GameObject;

            /**
             * Pause the current animation and set the `isPlaying` property to `false`.
             * You can optionally pause it at a specific frame.
             * @param atFrame An optional frame to set after pausing the animation.
             */
            pause(atFrame?: Phaser.Animations.AnimationFrame): Phaser.GameObjects.GameObject;

            /**
             * Resumes playback of a paused animation and sets the `isPlaying` property to `true`.
             * You can optionally tell it to start playback from a specific frame.
             * @param fromFrame An optional frame to set before restarting playback.
             */
            resume(fromFrame?: Phaser.Animations.AnimationFrame): Phaser.GameObjects.GameObject;

            /**
             * Waits for the specified delay, in milliseconds, then starts playback of the given animation.
             * 
             * If the animation _also_ has a delay value set in its config, it will be **added** to the delay given here.
             * 
             * If an animation is already running and a new animation is given to this method, it will wait for
             * the given delay before starting the new animation.
             * 
             * If no animation is currently running, the given one begins after the delay.
             * 
             * Prior to Phaser 3.50 this method was called 'delayedPlay' and the parameters were in the reverse order.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param delay The delay, in milliseconds, to wait before starting the animation playing.
             */
            playAfterDelay(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, delay: number): Phaser.GameObjects.GameObject;

            /**
             * Waits for the current animation to complete the `repeatCount` number of repeat cycles, then starts playback
             * of the given animation.
             * 
             * You can use this to ensure there are no harsh jumps between two sets of animations, i.e. going from an
             * idle animation to a walking animation, by making them blend smoothly into each other.
             * 
             * If no animation is currently running, the given one will start immediately.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param repeatCount How many times should the animation repeat before the next one starts? Default 1.
             */
            playAfterRepeat(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, repeatCount?: number): Phaser.GameObjects.GameObject;

            /**
             * Start playing the given animation on this Sprite.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to this Sprite.
             * 
             * The benefit of a global animation is that multiple Sprites can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any Sprite.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Sprite, and this Sprite alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Sprite.
             * 
             * With the animation created, either globally or locally, you can now play it on this Sprite:
             * 
             * ```javascript
             * this.add.sprite(x, y).play('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate, for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * this.add.sprite(x, y).play({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Sprite to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If this animation is already playing then ignore this call. Default false.
             */
            play(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): Phaser.GameObjects.GameObject;

            /**
             * Start playing the given animation on this Sprite, in reverse.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to this Sprite.
             * 
             * The benefit of a global animation is that multiple Sprites can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any Sprite.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Sprite, and this Sprite alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Sprite.
             * 
             * With the animation created, either globally or locally, you can now play it on this Sprite:
             * 
             * ```javascript
             * this.add.sprite(x, y).playReverse('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate, for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * this.add.sprite(x, y).playReverse({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Sprite to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             */
            playReverse(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): Phaser.GameObjects.GameObject;

            /**
             * Load the animation based on the key and set-up all of the internal values
             * needed for playback to start. If there is no delay, it will also fire the start events.
             * @param key The string-based key of the animation to play, or a `PlayAnimationConfig` object.
             */
            startAnimation(key: string | Phaser.Types.Animations.PlayAnimationConfig): Phaser.GameObjects.GameObject;

            /**
             * Reverse the Animation that is already playing on the Game Object.
             */
            reverse(): Phaser.GameObjects.GameObject;

            /**
             * Returns a value between 0 and 1 indicating how far this animation is through, ignoring repeats and yoyos.
             * 
             * The value is based on the current frame and how far that is in the animation, it is not based on
             * the duration of the animation.
             */
            getProgress(): number;

            /**
             * Takes a value between 0 and 1 and uses it to set how far this animation is through playback.
             * 
             * Does not factor in repeats or yoyos, but does handle playing forwards or backwards.
             * 
             * The value is based on the current frame and how far that is in the animation, it is not based on
             * the duration of the animation.
             * @param value The progress value, between 0 and 1. Default 0.
             */
            setProgress(value?: number): Phaser.GameObjects.GameObject;

            /**
             * Sets the number of times that the animation should repeat after its first play through.
             * For example, if repeat is 1, the animation will play a total of twice: the initial play plus 1 repeat.
             * 
             * To repeat indefinitely, use -1.
             * The value should always be an integer.
             * 
             * Calling this method only works if the animation is already running. Otherwise, any
             * value specified here will be overwritten when the next animation loads in. To avoid this,
             * use the `repeat` property of the `PlayAnimationConfig` object instead.
             * @param value The number of times that the animation should repeat.
             */
            setRepeat(value: number): Phaser.GameObjects.GameObject;

            /**
             * Handle the removal of an animation from the Animation Manager.
             * @param key The key of the removed Animation.
             * @param animation The removed Animation.
             */
            globalRemove(key?: string, animation?: Phaser.Animations.Animation): void;

            /**
             * Restarts the current animation from its beginning.
             * 
             * You can optionally reset the delay and repeat counters as well.
             * 
             * Calling this will fire the `ANIMATION_RESTART` event immediately.
             * 
             * If you `includeDelay` then it will also fire the `ANIMATION_START` event once
             * the delay has expired, otherwise, playback will just begin immediately.
             * @param includeDelay Whether to include the delay value of the animation when restarting. Default false.
             * @param resetRepeats Whether to reset the repeat counter or not? Default false.
             */
            restart(includeDelay?: boolean, resetRepeats?: boolean): Phaser.GameObjects.GameObject;

            /**
             * The current animation has completed. This dispatches the `ANIMATION_COMPLETE` event.
             * 
             * This method is called by the Animation instance and should not usually be invoked directly.
             * 
             * If no animation is loaded, no events will be dispatched.
             * 
             * If another animation has been queued for playback, it will be started after the events fire.
             */
            complete(): Phaser.GameObjects.GameObject;

            /**
             * Immediately stops the current animation from playing and dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing.
             */
            stop(): Phaser.GameObjects.GameObject;

            /**
             * Stops the current animation from playing after the specified time delay, given in milliseconds.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param delay The number of milliseconds to wait before stopping this animation.
             */
            stopAfterDelay(delay: number): Phaser.GameObjects.GameObject;

            /**
             * Stops the current animation from playing when it next repeats.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * 
             * Prior to Phaser 3.50 this method was called `stopOnRepeat` and had no parameters.
             * @param repeatCount How many times should the animation repeat before stopping? Default 1.
             */
            stopAfterRepeat(repeatCount?: number): Phaser.GameObjects.GameObject;

            /**
             * Stops the current animation from playing when it next sets the given frame.
             * If this frame doesn't exist within the animation it will not stop it from playing.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param frame The frame to check before stopping this animation.
             */
            stopOnFrame(frame: Phaser.Animations.AnimationFrame): Phaser.GameObjects.GameObject;

            /**
             * Returns the total number of frames in this animation, or returns zero if no
             * animation has been loaded.
             */
            getTotalFrames(): number;

            /**
             * The internal update loop for the AnimationState Component.
             * 
             * This is called automatically by the `Sprite.preUpdate` method.
             * @param time The current timestamp.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            update(time: number, delta: number): void;

            /**
             * Sets the given Animation Frame as being the current frame
             * and applies it to the parent Game Object, adjusting size and origin as needed.
             * @param animationFrame The animation frame to change to.
             */
            setCurrentFrame(animationFrame: Phaser.Animations.AnimationFrame): Phaser.GameObjects.GameObject;

            /**
             * Advances the animation to the next frame, regardless of the time or animation state.
             * If the animation is set to repeat, or yoyo, this will still take effect.
             * 
             * Calling this does not change the direction of the animation. I.e. if it was currently
             * playing in reverse, calling this method doesn't then change the direction to forwards.
             */
            nextFrame(): Phaser.GameObjects.GameObject;

            /**
             * Advances the animation to the previous frame, regardless of the time or animation state.
             * If the animation is set to repeat, or yoyo, this will still take effect.
             * 
             * Calling this does not change the direction of the animation. I.e. if it was currently
             * playing in forwards, calling this method doesn't then change the direction to backwards.
             */
            previousFrame(): Phaser.GameObjects.GameObject;

            /**
             * Get an Animation instance that has been created locally on this Sprite.
             * 
             * See the `create` method for more details.
             * @param key The key of the Animation to retrieve.
             */
            get(key: string): Phaser.Animations.Animation;

            /**
             * Checks to see if the given key is already used locally within the animations stored on this Sprite.
             * @param key The key of the Animation to check.
             */
            exists(key: string): boolean;

            /**
             * Creates a new Animation that is local specifically to this Sprite.
             * 
             * When a Sprite owns an animation, it is kept out of the global Animation Manager, which means
             * you're free to use keys that may be already defined there. Unless you specifically need a Sprite
             * to have a unique animation, you should favor using global animations instead, as they allow for
             * the same animation to be used across multiple Sprites, saving on memory. However, if this Sprite
             * is the only one to use this animation, it's sensible to create it here.
             * 
             * If an invalid key is given this method will return `false`.
             * 
             * If you pass the key of an animation that already exists locally, that animation will be returned.
             * 
             * A brand new animation is only created if the key is valid and not already in use by this Sprite.
             * 
             * If you wish to re-use an existing key, call the `remove` method first, then this method.
             * @param config The configuration settings for the Animation.
             */
            create(config: Phaser.Types.Animations.Animation): Phaser.Animations.Animation | false;

            /**
             * Create one, or more animations from a loaded Aseprite JSON file.
             * 
             * Aseprite is a powerful animated sprite editor and pixel art tool.
             * 
             * You can find more details at https://www.aseprite.org/
             * 
             * To export a compatible JSON file in Aseprite, please do the following:
             * 
             * 1. Go to "File - Export Sprite Sheet"
             * 
             * 2. On the **Layout** tab:
             * 2a. Set the "Sheet type" to "Packed"
             * 2b. Set the "Constraints" to "None"
             * 2c. Check the "Merge Duplicates" checkbox
             * 
             * 3. On the **Sprite** tab:
             * 3a. Set "Layers" to "Visible layers"
             * 3b. Set "Frames" to "All frames", unless you only wish to export a sub-set of tags
             * 
             * 4. On the **Borders** tab:
             * 4a. Check the "Trim Sprite" and "Trim Cells" options
             * 4b. Ensure "Border Padding", "Spacing" and "Inner Padding" are all > 0 (1 is usually enough)
             * 
             * 5. On the **Output** tab:
             * 5a. Check "Output File", give your image a name and make sure you choose "png files" as the file type
             * 5b. Check "JSON Data" and give your json file a name
             * 5c. The JSON Data type can be either a Hash or Array, Phaser doesn't mind.
             * 5d. Make sure "Tags" is checked in the Meta options
             * 5e. In the "Item Filename" input box, make sure it says just "{frame}" and nothing more.
             * 
             * 6. Click export
             * 
             * This was tested with Aseprite 1.2.25.
             * 
             * This will export a png and json file which you can load using the Aseprite Loader, i.e.:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.path = 'assets/animations/aseprite/';
             *     this.load.aseprite('paladin', 'paladin.png', 'paladin.json');
             * }
             * ```
             * 
             * Once loaded, you can call this method on a Sprite with the 'atlas' key:
             * 
             * ```javascript
             * const sprite = this.add.sprite(400, 300);
             * 
             * sprite.anims.createFromAseprite('paladin');
             * ```
             * 
             * Any animations defined in the JSON will now be available to use on this Sprite and you play them
             * via their Tag name. For example, if you have an animation called 'War Cry' on your Aseprite timeline,
             * you can play it on the Sprite using that Tag name:
             * 
             * ```javascript
             * const sprite = this.add.sprite(400, 300);
             * 
             * sprite.anims.createFromAseprite('paladin');
             * 
             * sprite.play('War Cry');
             * ```
             * 
             * When calling this method you can optionally provide an array of tag names, and only those animations
             * will be created. For example:
             * 
             * ```javascript
             * sprite.anims.createFromAseprite('paladin', [ 'step', 'War Cry', 'Magnum Break' ]);
             * ```
             * 
             * This will only create the 3 animations defined. Note that the tag names are case-sensitive.
             * @param key The key of the loaded Aseprite atlas. It must have been loaded prior to calling this method.
             * @param tags An array of Tag names. If provided, only animations found in this array will be created.
             */
            createFromAseprite(key: string, tags?: string[]): Phaser.Animations.Animation[];

            /**
             * Generate an array of {@link Phaser.Types.Animations.AnimationFrame} objects from a texture key and configuration object.
             * 
             * Generates objects with string based frame names, as configured by the given {@link Phaser.Types.Animations.GenerateFrameNames}.
             * 
             * It's a helper method, designed to make it easier for you to extract all of the frame names from texture atlases.
             * If you're working with a sprite sheet, see the `generateFrameNumbers` method instead.
             * 
             * Example:
             * 
             * If you have a texture atlases loaded called `gems` and it contains 6 frames called `ruby_0001`, `ruby_0002`, and so on,
             * then you can call this method using: `this.anims.generateFrameNames('gems', { prefix: 'ruby_', end: 6, zeroPad: 4 })`.
             * 
             * The `end` value tells it to look for 6 frames, incrementally numbered, all starting with the prefix `ruby_`. The `zeroPad`
             * value tells it how many zeroes pad out the numbers. To create an animation using this method, you can do:
             * 
             * ```javascript
             * this.anims.create({
             *   key: 'ruby',
             *   repeat: -1,
             *   frames: this.anims.generateFrameNames('gems', {
             *     prefix: 'ruby_',
             *     end: 6,
             *     zeroPad: 4
             *   })
             * });
             * ```
             * 
             * Please see the animation examples for further details.
             * @param key The key for the texture containing the animation frames.
             * @param config The configuration object for the animation frame names.
             */
            generateFrameNames(key: string, config?: Phaser.Types.Animations.GenerateFrameNames): Phaser.Types.Animations.AnimationFrame[];

            /**
             * Generate an array of {@link Phaser.Types.Animations.AnimationFrame} objects from a texture key and configuration object.
             * 
             * Generates objects with numbered frame names, as configured by the given {@link Phaser.Types.Animations.GenerateFrameNumbers}.
             * 
             * If you're working with a texture atlas, see the `generateFrameNames` method instead.
             * 
             * It's a helper method, designed to make it easier for you to extract frames from sprite sheets.
             * If you're working with a texture atlas, see the `generateFrameNames` method instead.
             * 
             * Example:
             * 
             * If you have a sprite sheet loaded called `explosion` and it contains 12 frames, then you can call this method using:
             * `this.anims.generateFrameNumbers('explosion', { start: 0, end: 11 })`.
             * 
             * The `end` value tells it to stop after 12 frames. To create an animation using this method, you can do:
             * 
             * ```javascript
             * this.anims.create({
             *   key: 'boom',
             *   frames: this.anims.generateFrameNumbers('explosion', {
             *     start: 0,
             *     end: 11
             *   })
             * });
             * ```
             * 
             * Note that `start` is optional and you don't need to include it if the animation starts from frame 0.
             * 
             * To specify an animation in reverse, swap the `start` and `end` values.
             * 
             * If the frames are not sequential, you may pass an array of frame numbers instead, for example:
             * 
             * `this.anims.generateFrameNumbers('explosion', { frames: [ 0, 1, 2, 1, 2, 3, 4, 0, 1, 2 ] })`
             * 
             * Please see the animation examples and `GenerateFrameNumbers` config docs for further details.
             * @param key The key for the texture containing the animation frames.
             * @param config The configuration object for the animation frames.
             */
            generateFrameNumbers(key: string, config?: Phaser.Types.Animations.GenerateFrameNumbers): Phaser.Types.Animations.AnimationFrame[];

            /**
             * Removes a locally created Animation from this Sprite, based on the given key.
             * 
             * Once an Animation has been removed, this Sprite cannot play it again without re-creating it.
             * @param key The key of the animation to remove.
             */
            remove(key: string): Phaser.Animations.Animation;

            /**
             * Destroy this Animation component.
             * 
             * Unregisters event listeners and cleans up its references.
             */
            destroy(): void;

            /**
             * `true` if the current animation is paused, otherwise `false`.
             */
            readonly isPaused: boolean;

        }

        namespace Events {
            /**
             * The Add Animation Event.
             * 
             * This event is dispatched when a new animation is added to the global Animation Manager.
             * 
             * This can happen either as a result of an animation instance being added to the Animation Manager,
             * or the Animation Manager creating a new animation directly.
             */
            const ADD_ANIMATION: string;

            /**
             * The Animation Complete Event.
             * 
             * This event is dispatched by a Sprite when an animation playing on it completes playback.
             * This happens when the animation gets to the end of its sequence, factoring in any delays
             * or repeats it may have to process.
             * 
             * An animation that is set to loop, or repeat forever, will never fire this event, because
             * it never actually completes. If you need to handle this, listen for the `ANIMATION_STOP`
             * event instead, as this is emitted when the animation is stopped directly.
             * 
             * Listen for it on the Sprite using `sprite.on('animationcomplete', listener)`
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_COMPLETE: string;

            /**
             * The Animation Complete Dynamic Key Event.
             * 
             * This event is dispatched by a Sprite when an animation playing on it completes playback.
             * This happens when the animation gets to the end of its sequence, factoring in any delays
             * or repeats it may have to process.
             * 
             * An animation that is set to loop, or repeat forever, will never fire this event, because
             * it never actually completes. If you need to handle this, listen for the `ANIMATION_STOP`
             * event instead, as this is emitted when the animation is stopped directly.
             * 
             * The difference between this and the `ANIMATION_COMPLETE` event is that this one has a
             * dynamic event name that contains the name of the animation within it. For example,
             * if you had an animation called `explode` you could listen for the completion of that
             * specific animation by using: `sprite.on('animationcomplete-explode', listener)`. Or, if you
             * wish to use types: `sprite.on(Phaser.Animations.Events.ANIMATION_COMPLETE_KEY + 'explode', listener)`.
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_COMPLETE_KEY: string;

            /**
             * The Animation Repeat Event.
             * 
             * This event is dispatched by a Sprite when an animation repeats playing on it.
             * This happens if the animation was created, or played, with a `repeat` value specified.
             * 
             * An animation will repeat when it reaches the end of its sequence.
             * 
             * Listen for it on the Sprite using `sprite.on('animationrepeat', listener)`
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_REPEAT: string;

            /**
             * The Animation Restart Event.
             * 
             * This event is dispatched by a Sprite when an animation restarts playing on it.
             * This only happens when the `Sprite.anims.restart` method is called.
             * 
             * Listen for it on the Sprite using `sprite.on('animationrestart', listener)`
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_RESTART: string;

            /**
             * The Animation Start Event.
             * 
             * This event is dispatched by a Sprite when an animation starts playing on it.
             * This happens when the animation is played, factoring in any delay that may have been specified.
             * This event happens after the delay has expired and prior to the first update event.
             * 
             * Listen for it on the Sprite using `sprite.on('animationstart', listener)`
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_START: string;

            /**
             * The Animation Stop Event.
             * 
             * This event is dispatched by a Sprite when an animation is stopped on it. An animation
             * will only be stopeed if a method such as `Sprite.stop` or `Sprite.anims.stopAfterDelay`
             * is called. It can also be emitted if a new animation is started before the current one completes.
             * 
             * Listen for it on the Sprite using `sprite.on('animationstop', listener)`
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_STOP: string;

            /**
             * The Animation Update Event.
             * 
             * This event is dispatched by a Sprite when an animation playing on it updates. This happens when the animation changes frame.
             * An animation will change frame based on the frame rate and other factors like `timeScale` and `delay`. It can also change
             * frame when stopped or restarted.
             * 
             * Listen for it on the Sprite using `sprite.on('animationupdate', listener)`
             * 
             * If an animation is playing faster than the game frame-rate can handle, it's entirely possible for it to emit several
             * update events in a single game frame, so please be aware of this in your code. The **final** event received that frame
             * is the one that is rendered to the game.
             * 
             * The animation event flow is as follows:
             * 
             * 1. `ANIMATION_START`
             * 2. `ANIMATION_UPDATE` (repeated for however many frames the animation has)
             * 3. `ANIMATION_REPEAT` (only if the animation is set to repeat, it then emits more update events after this)
             * 4. `ANIMATION_COMPLETE` (only if there is a finite, or zero, repeat count)
             * 5. `ANIMATION_COMPLETE_KEY` (only if there is a finite, or zero, repeat count)
             * 
             * If the animation is stopped directly, the `ANIMATION_STOP` event is dispatched instead of `ANIMATION_COMPLETE`.
             * 
             * If the animation is restarted while it is already playing, `ANIMATION_RESTART` is emitted.
             */
            const ANIMATION_UPDATE: string;

            /**
             * The Pause All Animations Event.
             * 
             * This event is dispatched when the global Animation Manager is told to pause.
             * 
             * When this happens all current animations will stop updating, although it doesn't necessarily mean
             * that the game has paused as well.
             */
            const PAUSE_ALL: string;

            /**
             * The Remove Animation Event.
             * 
             * This event is dispatched when an animation is removed from the global Animation Manager.
             */
            const REMOVE_ANIMATION: string;

            /**
             * The Resume All Animations Event.
             * 
             * This event is dispatched when the global Animation Manager resumes, having been previously paused.
             * 
             * When this happens all current animations will continue updating again.
             */
            const RESUME_ALL: string;

        }

    }

    namespace Cache {
        /**
         * The BaseCache is a base Cache class that can be used for storing references to any kind of data.
         * 
         * Data can be added, retrieved and removed based on the given keys.
         * 
         * Keys are string-based.
         */
        class BaseCache {
            /**
             * The Map in which the cache objects are stored.
             * 
             * You can query the Map directly or use the BaseCache methods.
             */
            entries: Phaser.Structs.Map<String, any>;

            /**
             * An instance of EventEmitter used by the cache to emit related events.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * Adds an item to this cache. The item is referenced by a unique string, which you are responsible
             * for setting and keeping track of. The item can only be retrieved by using this string.
             * @param key The unique key by which the data added to the cache will be referenced.
             * @param data The data to be stored in the cache.
             */
            add(key: string, data: any): this;

            /**
             * Checks if this cache contains an item matching the given key.
             * This performs the same action as `BaseCache.exists`.
             * @param key The unique key of the item to be checked in this cache.
             */
            has(key: string): boolean;

            /**
             * Checks if this cache contains an item matching the given key.
             * This performs the same action as `BaseCache.has` and is called directly by the Loader.
             * @param key The unique key of the item to be checked in this cache.
             */
            exists(key: string): boolean;

            /**
             * Gets an item from this cache based on the given key.
             * @param key The unique key of the item to be retrieved from this cache.
             */
            get(key: string): any;

            /**
             * Removes and item from this cache based on the given key.
             * 
             * If an entry matching the key is found it is removed from the cache and a `remove` event emitted.
             * No additional checks are done on the item removed. If other systems or parts of your game code
             * are relying on this item, it is up to you to sever those relationships prior to removing the item.
             * @param key The unique key of the item to remove from the cache.
             */
            remove(key: string): this;

            /**
             * Returns all keys in use in this cache.
             */
            getKeys(): string[];

            /**
             * Destroys this cache and all items within it.
             */
            destroy(): void;

        }

        /**
         * The Cache Manager is the global cache owned and maintained by the Game instance.
         * 
         * Various systems, such as the file Loader, rely on this cache in order to store the files
         * it has loaded. The manager itself doesn't store any files, but instead owns multiple BaseCache
         * instances, one per type of file. You can also add your own custom caches.
         */
        class CacheManager {
            /**
             * 
             * @param game A reference to the Phaser.Game instance that owns this CacheManager.
             */
            constructor(game: Phaser.Game);

            /**
             * A reference to the Phaser.Game instance that owns this CacheManager.
             */
            protected game: Phaser.Game;

            /**
             * A Cache storing all binary files, typically added via the Loader.
             */
            binary: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all bitmap font data files, typically added via the Loader.
             * Only the font data is stored in this cache, the textures are part of the Texture Manager.
             */
            bitmapFont: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all JSON data files, typically added via the Loader.
             */
            json: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all physics data files, typically added via the Loader.
             */
            physics: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all shader source files, typically added via the Loader.
             */
            shader: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all non-streaming audio files, typically added via the Loader.
             */
            audio: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all non-streaming video files, typically added via the Loader.
             */
            video: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all text files, typically added via the Loader.
             */
            text: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all html files, typically added via the Loader.
             */
            html: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all WaveFront OBJ files, typically added via the Loader.
             */
            obj: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all tilemap data files, typically added via the Loader.
             * Only the data is stored in this cache, the textures are part of the Texture Manager.
             */
            tilemap: Phaser.Cache.BaseCache;

            /**
             * A Cache storing all xml data files, typically added via the Loader.
             */
            xml: Phaser.Cache.BaseCache;

            /**
             * An object that contains your own custom BaseCache entries.
             * Add to this via the `addCustom` method.
             */
            custom: {[key: string]: Phaser.Cache.BaseCache};

            /**
             * Add your own custom Cache for storing your own files.
             * The cache will be available under `Cache.custom.key`.
             * The cache will only be created if the key is not already in use.
             * @param key The unique key of your custom cache.
             */
            addCustom(key: string): Phaser.Cache.BaseCache;

            /**
             * Removes all entries from all BaseCaches and destroys all custom caches.
             */
            destroy(): void;

        }

        namespace Events {
            /**
             * The Cache Add Event.
             * 
             * This event is dispatched by any Cache that extends the BaseCache each time a new object is added to it.
             */
            const ADD: string;

            /**
             * The Cache Remove Event.
             * 
             * This event is dispatched by any Cache that extends the BaseCache each time an object is removed from it.
             */
            const REMOVE: string;

        }

    }

    namespace Cameras {
        namespace Scene2D {
            /**
             * A Base Camera class.
             * 
             * The Camera is the way in which all games are rendered in Phaser. They provide a view into your game world,
             * and can be positioned, rotated, zoomed and scrolled accordingly.
             * 
             * A Camera consists of two elements: The viewport and the scroll values.
             * 
             * The viewport is the physical position and size of the Camera within your game. Cameras, by default, are
             * created the same size as your game, but their position and size can be set to anything. This means if you
             * wanted to create a camera that was 320x200 in size, positioned in the bottom-right corner of your game,
             * you'd adjust the viewport to do that (using methods like `setViewport` and `setSize`).
             * 
             * If you wish to change where the Camera is looking in your game, then you scroll it. You can do this
             * via the properties `scrollX` and `scrollY` or the method `setScroll`. Scrolling has no impact on the
             * viewport, and changing the viewport has no impact on the scrolling.
             * 
             * By default a Camera will render all Game Objects it can see. You can change this using the `ignore` method,
             * allowing you to filter Game Objects out on a per-Camera basis.
             * 
             * The Base Camera is extended by the Camera class, which adds in special effects including Fade,
             * Flash and Camera Shake, as well as the ability to follow Game Objects.
             * 
             * The Base Camera was introduced in Phaser 3.12. It was split off from the Camera class, to allow
             * you to isolate special effects as needed. Therefore the 'since' values for properties of this class relate
             * to when they were added to the Camera class.
             */
            class BaseCamera extends Phaser.Events.EventEmitter implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param x The x position of the Camera, relative to the top-left of the game canvas.
                 * @param y The y position of the Camera, relative to the top-left of the game canvas.
                 * @param width The width of the Camera, in pixels.
                 * @param height The height of the Camera, in pixels.
                 */
                constructor(x: number, y: number, width: number, height: number);

                /**
                 * A reference to the Scene this camera belongs to.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Game Scene Manager.
                 */
                sceneManager: Phaser.Scenes.SceneManager;

                /**
                 * A reference to the Game Scale Manager.
                 */
                scaleManager: Phaser.Scale.ScaleManager;

                /**
                 * A reference to the Scene's Camera Manager to which this Camera belongs.
                 */
                cameraManager: Phaser.Cameras.Scene2D.CameraManager;

                /**
                 * The Camera ID. Assigned by the Camera Manager and used to handle camera exclusion.
                 * This value is a bitmask.
                 */
                readonly id: number;

                /**
                 * The name of the Camera. This is left empty for your own use.
                 */
                name: string;

                /**
                 * Should this camera round its pixel values to integers?
                 */
                roundPixels: boolean;

                /**
                 * Is this Camera visible or not?
                 * 
                 * A visible camera will render and perform input tests.
                 * An invisible camera will not render anything and will skip input tests.
                 */
                visible: boolean;

                /**
                 * Is this Camera using a bounds to restrict scrolling movement?
                 * 
                 * Set this property along with the bounds via `Camera.setBounds`.
                 */
                useBounds: boolean;

                /**
                 * The World View is a Rectangle that defines the area of the 'world' the Camera is currently looking at.
                 * This factors in the Camera viewport size, zoom and scroll position and is updated in the Camera preRender step.
                 * If you have enabled Camera bounds the worldview will be clamped to those bounds accordingly.
                 * You can use it for culling or intersection checks.
                 */
                readonly worldView: Phaser.Geom.Rectangle;

                /**
                 * Is this Camera dirty?
                 * 
                 * A dirty Camera has had either its viewport size, bounds, scroll, rotation or zoom levels changed since the last frame.
                 * 
                 * This flag is cleared during the `postRenderCamera` method of the renderer.
                 */
                dirty: boolean;

                /**
                 * Does this Camera have a transparent background?
                 */
                transparent: boolean;

                /**
                 * The background color of this Camera. Only used if `transparent` is `false`.
                 */
                backgroundColor: Phaser.Display.Color;

                /**
                 * The Camera alpha value. Setting this property impacts every single object that this Camera
                 * renders. You can either set the property directly, i.e. via a Tween, to fade a Camera in or out,
                 * or via the chainable `setAlpha` method instead.
                 */
                alpha: number;

                /**
                 * Should the camera cull Game Objects before checking them for input hit tests?
                 * In some special cases it may be beneficial to disable this.
                 */
                disableCull: boolean;

                /**
                 * The mid-point of the Camera in 'world' coordinates.
                 * 
                 * Use it to obtain exactly where in the world the center of the camera is currently looking.
                 * 
                 * This value is updated in the preRender method, after the scroll values and follower
                 * have been processed.
                 */
                readonly midPoint: Phaser.Math.Vector2;

                /**
                 * The horizontal origin of rotation for this Camera.
                 * 
                 * By default the camera rotates around the center of the viewport.
                 * 
                 * Changing the origin allows you to adjust the point in the viewport from which rotation happens.
                 * A value of 0 would rotate from the top-left of the viewport. A value of 1 from the bottom right.
                 * 
                 * See `setOrigin` to set both origins in a single, chainable call.
                 */
                originX: number;

                /**
                 * The vertical origin of rotation for this Camera.
                 * 
                 * By default the camera rotates around the center of the viewport.
                 * 
                 * Changing the origin allows you to adjust the point in the viewport from which rotation happens.
                 * A value of 0 would rotate from the top-left of the viewport. A value of 1 from the bottom right.
                 * 
                 * See `setOrigin` to set both origins in a single, chainable call.
                 */
                originY: number;

                /**
                 * The Mask this Camera is using during render.
                 * Set the mask using the `setMask` method. Remove the mask using the `clearMask` method.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask | null;

                /**
                 * This array is populated with all of the Game Objects that this Camera has rendered
                 * in the previous (or current, depending on when you inspect it) frame.
                 * 
                 * It is cleared at the start of `Camera.preUpdate`, or if the Camera is destroyed.
                 * 
                 * You should not modify this array as it is used internally by the input system,
                 * however you can read it as required. Note that Game Objects may appear in this
                 * list multiple times if they belong to multiple non-exclusive Containers.
                 */
                renderList: Phaser.GameObjects.GameObject[];

                /**
                 * Is this Camera a Scene Camera? (which is the default), or a Camera
                 * belonging to a Texture?
                 */
                isSceneCamera: boolean;

                /**
                 * Adds the given Game Object to this cameras render list.
                 * 
                 * This is invoked during the rendering stage. Only objects that are actually rendered
                 * will appear in the render list.
                 * @param child The Game Object to add to the render list.
                 */
                addToRenderList(child: Phaser.GameObjects.GameObject): void;

                /**
                 * Set the Alpha level of this Camera. The alpha controls the opacity of the Camera as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * @param value The Camera alpha value. Default 1.
                 */
                setAlpha(value?: number): this;

                /**
                 * Sets the rotation origin of this Camera.
                 * 
                 * The values are given in the range 0 to 1 and are only used when calculating Camera rotation.
                 * 
                 * By default the camera rotates around the center of the viewport.
                 * 
                 * Changing the origin allows you to adjust the point in the viewport from which rotation happens.
                 * A value of 0 would rotate from the top-left of the viewport. A value of 1 from the bottom right.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;

                /**
                 * Calculates what the Camera.scrollX and scrollY values would need to be in order to move
                 * the Camera so it is centered on the given x and y coordinates, without actually moving
                 * the Camera there. The results are clamped based on the Camera bounds, if set.
                 * @param x The horizontal coordinate to center on.
                 * @param y The vertical coordinate to center on.
                 * @param out A Vector2 to store the values in. If not given a new Vector2 is created.
                 */
                getScroll(x: number, y: number, out?: Phaser.Math.Vector2): Phaser.Math.Vector2;

                /**
                 * Moves the Camera horizontally so that it is centered on the given x coordinate, bounds allowing.
                 * Calling this does not change the scrollY value.
                 * @param x The horizontal coordinate to center on.
                 */
                centerOnX(x: number): this;

                /**
                 * Moves the Camera vertically so that it is centered on the given y coordinate, bounds allowing.
                 * Calling this does not change the scrollX value.
                 * @param y The vertical coordinate to center on.
                 */
                centerOnY(y: number): this;

                /**
                 * Moves the Camera so that it is centered on the given coordinates, bounds allowing.
                 * @param x The horizontal coordinate to center on.
                 * @param y The vertical coordinate to center on.
                 */
                centerOn(x: number, y: number): this;

                /**
                 * Moves the Camera so that it is looking at the center of the Camera Bounds, if enabled.
                 */
                centerToBounds(): this;

                /**
                 * Moves the Camera so that it is re-centered based on its viewport size.
                 */
                centerToSize(): this;

                /**
                 * Takes an array of Game Objects and returns a new array featuring only those objects
                 * visible by this camera.
                 * @param renderableObjects An array of Game Objects to cull.
                 */
                cull<G extends Phaser.GameObjects.GameObject[]>(renderableObjects: G): G;

                /**
                 * Converts the given `x` and `y` coordinates into World space, based on this Cameras transform.
                 * You can optionally provide a Vector2, or similar object, to store the results in.
                 * @param x The x position to convert to world space.
                 * @param y The y position to convert to world space.
                 * @param output An optional object to store the results in. If not provided a new Vector2 will be created.
                 */
                getWorldPoint<O extends Phaser.Math.Vector2>(x: number, y: number, output?: O): O;

                /**
                 * Given a Game Object, or an array of Game Objects, it will update all of their camera filter settings
                 * so that they are ignored by this Camera. This means they will not be rendered by this Camera.
                 * @param entries The Game Object, or array of Game Objects, to be ignored by this Camera.
                 */
                ignore(entries: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[] | Phaser.GameObjects.Group | Phaser.GameObjects.Layer | Phaser.GameObjects.Layer[]): this;

                /**
                 * Internal preRender step.
                 */
                protected preRender(): void;

                /**
                 * Takes an x value and checks it's within the range of the Camera bounds, adjusting if required.
                 * Do not call this method if you are not using camera bounds.
                 * @param x The value to horizontally scroll clamp.
                 */
                clampX(x: number): number;

                /**
                 * Takes a y value and checks it's within the range of the Camera bounds, adjusting if required.
                 * Do not call this method if you are not using camera bounds.
                 * @param y The value to vertically scroll clamp.
                 */
                clampY(y: number): number;

                /**
                 * If this Camera has previously had movement bounds set on it, this will remove them.
                 */
                removeBounds(): this;

                /**
                 * Set the rotation of this Camera. This causes everything it renders to appear rotated.
                 * 
                 * Rotating a camera does not rotate the viewport itself, it is applied during rendering.
                 * @param value The cameras angle of rotation, given in degrees. Default 0.
                 */
                setAngle(value?: number): this;

                /**
                 * Sets the background color for this Camera.
                 * 
                 * By default a Camera has a transparent background but it can be given a solid color, with any level
                 * of transparency, via this method.
                 * 
                 * The color value can be specified using CSS color notation, hex or numbers.
                 * @param color The color value. In CSS, hex or numeric color notation. Default 'rgba(0,0,0,0)'.
                 */
                setBackgroundColor(color?: string | number | Phaser.Types.Display.InputColorObject): this;

                /**
                 * Set the bounds of the Camera. The bounds are an axis-aligned rectangle.
                 * 
                 * The Camera bounds controls where the Camera can scroll to, stopping it from scrolling off the
                 * edges and into blank space. It does not limit the placement of Game Objects, or where
                 * the Camera viewport can be positioned.
                 * 
                 * Temporarily disable the bounds by changing the boolean `Camera.useBounds`.
                 * 
                 * Clear the bounds entirely by calling `Camera.removeBounds`.
                 * 
                 * If you set bounds that are smaller than the viewport it will stop the Camera from being
                 * able to scroll. The bounds can be positioned where-ever you wish. By default they are from
                 * 0x0 to the canvas width x height. This means that the coordinate 0x0 is the top left of
                 * the Camera bounds. However, you can position them anywhere. So if you wanted a game world
                 * that was 2048x2048 in size, with 0x0 being the center of it, you can set the bounds x/y
                 * to be -1024, -1024, with a width and height of 2048. Depending on your game you may find
                 * it easier for 0x0 to be the top-left of the bounds, or you may wish 0x0 to be the middle.
                 * @param x The top-left x coordinate of the bounds.
                 * @param y The top-left y coordinate of the bounds.
                 * @param width The width of the bounds, in pixels.
                 * @param height The height of the bounds, in pixels.
                 * @param centerOn If `true` the Camera will automatically be centered on the new bounds. Default false.
                 */
                setBounds(x: number, y: number, width: number, height: number, centerOn?: boolean): this;

                /**
                 * Returns a rectangle containing the bounds of the Camera.
                 * 
                 * If the Camera does not have any bounds the rectangle will be empty.
                 * 
                 * The rectangle is a copy of the bounds, so is safe to modify.
                 * @param out An optional Rectangle to store the bounds in. If not given, a new Rectangle will be created.
                 */
                getBounds(out?: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle;

                /**
                 * Sets the name of this Camera.
                 * This value is for your own use and isn't used internally.
                 * @param value The name of the Camera. Default ''.
                 */
                setName(value?: string): this;

                /**
                 * Set the position of the Camera viewport within the game.
                 * 
                 * This does not change where the camera is 'looking'. See `setScroll` to control that.
                 * @param x The top-left x coordinate of the Camera viewport.
                 * @param y The top-left y coordinate of the Camera viewport. Default x.
                 */
                setPosition(x: number, y?: number): this;

                /**
                 * Set the rotation of this Camera. This causes everything it renders to appear rotated.
                 * 
                 * Rotating a camera does not rotate the viewport itself, it is applied during rendering.
                 * @param value The rotation of the Camera, in radians. Default 0.
                 */
                setRotation(value?: number): this;

                /**
                 * Should the Camera round pixel values to whole integers when rendering Game Objects?
                 * 
                 * In some types of game, especially with pixel art, this is required to prevent sub-pixel aliasing.
                 * @param value `true` to round Camera pixels, `false` to not.
                 */
                setRoundPixels(value: boolean): this;

                /**
                 * Sets the Scene the Camera is bound to.
                 * @param scene The Scene the camera is bound to.
                 * @param isSceneCamera Is this Camera being used for a Scene (true) or a Texture? (false) Default true.
                 */
                setScene(scene: Phaser.Scene, isSceneCamera?: boolean): this;

                /**
                 * Set the position of where the Camera is looking within the game.
                 * You can also modify the properties `Camera.scrollX` and `Camera.scrollY` directly.
                 * Use this method, or the scroll properties, to move your camera around the game world.
                 * 
                 * This does not change where the camera viewport is placed. See `setPosition` to control that.
                 * @param x The x coordinate of the Camera in the game world.
                 * @param y The y coordinate of the Camera in the game world. Default x.
                 */
                setScroll(x: number, y?: number): this;

                /**
                 * Set the size of the Camera viewport.
                 * 
                 * By default a Camera is the same size as the game, but can be made smaller via this method,
                 * allowing you to create mini-cam style effects by creating and positioning a smaller Camera
                 * viewport within your game.
                 * @param width The width of the Camera viewport.
                 * @param height The height of the Camera viewport. Default width.
                 */
                setSize(width: number, height?: number): this;

                /**
                 * This method sets the position and size of the Camera viewport in a single call.
                 * 
                 * If you're trying to change where the Camera is looking at in your game, then see
                 * the method `Camera.setScroll` instead. This method is for changing the viewport
                 * itself, not what the camera can see.
                 * 
                 * By default a Camera is the same size as the game, but can be made smaller via this method,
                 * allowing you to create mini-cam style effects by creating and positioning a smaller Camera
                 * viewport within your game.
                 * @param x The top-left x coordinate of the Camera viewport.
                 * @param y The top-left y coordinate of the Camera viewport.
                 * @param width The width of the Camera viewport.
                 * @param height The height of the Camera viewport. Default width.
                 */
                setViewport(x: number, y: number, width: number, height?: number): this;

                /**
                 * Set the zoom value of the Camera.
                 * 
                 * Changing to a smaller value, such as 0.5, will cause the camera to 'zoom out'.
                 * Changing to a larger value, such as 2, will cause the camera to 'zoom in'.
                 * 
                 * A value of 1 means 'no zoom' and is the default.
                 * 
                 * Changing the zoom does not impact the Camera viewport in any way, it is only applied during rendering.
                 * 
                 * As of Phaser 3.50 you can now set the horizontal and vertical zoom values independently.
                 * @param x The horizontal zoom value of the Camera. The minimum it can be is 0.001. Default 1.
                 * @param y The vertical zoom value of the Camera. The minimum it can be is 0.001. Default x.
                 */
                setZoom(x?: number, y?: number): this;

                /**
                 * Sets the mask to be applied to this Camera during rendering.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * 
                 * Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Camera it will be immediately replaced.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Camera will use when rendering.
                 * @param fixedPosition Should the mask translate along with the Camera, or be fixed in place and not impacted by the Cameras transform? Default true.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask, fixedPosition?: boolean): this;

                /**
                 * Clears the mask that this Camera was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Sets the visibility of this Camera.
                 * 
                 * An invisible Camera will skip rendering and input tests of everything it can see.
                 * @param value The visible state of the Camera.
                 */
                setVisible(value: boolean): this;

                /**
                 * Returns an Object suitable for JSON storage containing all of the Camera viewport and rendering properties.
                 */
                toJSON(): Phaser.Types.Cameras.Scene2D.JSONCamera;

                /**
                 * Internal method called automatically by the Camera Manager.
                 * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                 * @param delta The delta time, in ms, elapsed since the last frame.
                 */
                protected update(time: number, delta: number): void;

                /**
                 * Set if this Camera is being used as a Scene Camera, or a Texture
                 * Camera.
                 * @param value Is this being used as a Scene Camera, or a Texture camera?
                 */
                setIsSceneCamera(value: boolean): void;

                /**
                 * Destroys this Camera instance and its internal properties and references.
                 * Once destroyed you cannot use this Camera again, even if re-added to a Camera Manager.
                 * 
                 * This method is called automatically by `CameraManager.remove` if that methods `runDestroy` argument is `true`, which is the default.
                 * 
                 * Unless you have a specific reason otherwise, always use `CameraManager.remove` and allow it to handle the camera destruction,
                 * rather than calling this method directly.
                 */
                destroy(): void;

                /**
                 * The x position of the Camera viewport, relative to the top-left of the game canvas.
                 * The viewport is the area into which the camera renders.
                 * To adjust the position the camera is looking at in the game world, see the `scrollX` value.
                 */
                x: number;

                /**
                 * The y position of the Camera viewport, relative to the top-left of the game canvas.
                 * The viewport is the area into which the camera renders.
                 * To adjust the position the camera is looking at in the game world, see the `scrollY` value.
                 */
                y: number;

                /**
                 * The width of the Camera viewport, in pixels.
                 * 
                 * The viewport is the area into which the Camera renders. Setting the viewport does
                 * not restrict where the Camera can scroll to.
                 */
                width: number;

                /**
                 * The height of the Camera viewport, in pixels.
                 * 
                 * The viewport is the area into which the Camera renders. Setting the viewport does
                 * not restrict where the Camera can scroll to.
                 */
                height: number;

                /**
                 * The horizontal scroll position of this Camera.
                 * 
                 * Change this value to cause the Camera to scroll around your Scene.
                 * 
                 * Alternatively, setting the Camera to follow a Game Object, via the `startFollow` method,
                 * will automatically adjust the Camera scroll values accordingly.
                 * 
                 * You can set the bounds within which the Camera can scroll via the `setBounds` method.
                 */
                scrollX: number;

                /**
                 * The vertical scroll position of this Camera.
                 * 
                 * Change this value to cause the Camera to scroll around your Scene.
                 * 
                 * Alternatively, setting the Camera to follow a Game Object, via the `startFollow` method,
                 * will automatically adjust the Camera scroll values accordingly.
                 * 
                 * You can set the bounds within which the Camera can scroll via the `setBounds` method.
                 */
                scrollY: number;

                /**
                 * The Camera zoom value. Change this value to zoom in, or out of, a Scene.
                 * 
                 * A value of 0.5 would zoom the Camera out, so you can now see twice as much
                 * of the Scene as before. A value of 2 would zoom the Camera in, so every pixel
                 * now takes up 2 pixels when rendered.
                 * 
                 * Set to 1 to return to the default zoom level.
                 * 
                 * Be careful to never set this value to zero.
                 */
                zoom: number;

                /**
                 * The Camera horizontal zoom value. Change this value to zoom in, or out of, a Scene.
                 * 
                 * A value of 0.5 would zoom the Camera out, so you can now see twice as much
                 * of the Scene as before. A value of 2 would zoom the Camera in, so every pixel
                 * now takes up 2 pixels when rendered.
                 * 
                 * Set to 1 to return to the default zoom level.
                 * 
                 * Be careful to never set this value to zero.
                 */
                zoomX: number;

                /**
                 * The Camera vertical zoom value. Change this value to zoom in, or out of, a Scene.
                 * 
                 * A value of 0.5 would zoom the Camera out, so you can now see twice as much
                 * of the Scene as before. A value of 2 would zoom the Camera in, so every pixel
                 * now takes up 2 pixels when rendered.
                 * 
                 * Set to 1 to return to the default zoom level.
                 * 
                 * Be careful to never set this value to zero.
                 */
                zoomY: number;

                /**
                 * The horizontal position of the center of the Camera's viewport, relative to the left of the game canvas.
                 */
                readonly centerX: number;

                /**
                 * The vertical position of the center of the Camera's viewport, relative to the top of the game canvas.
                 */
                readonly centerY: number;

                /**
                 * The displayed width of the camera viewport, factoring in the camera zoom level.
                 * 
                 * If a camera has a viewport width of 800 and a zoom of 0.5 then its display width
                 * would be 1600, as it's displaying twice as many pixels as zoom level 1.
                 * 
                 * Equally, a camera with a width of 800 and zoom of 2 would have a display width
                 * of 400 pixels.
                 */
                readonly displayWidth: number;

                /**
                 * The displayed height of the camera viewport, factoring in the camera zoom level.
                 * 
                 * If a camera has a viewport height of 600 and a zoom of 0.5 then its display height
                 * would be 1200, as it's displaying twice as many pixels as zoom level 1.
                 * 
                 * Equally, a camera with a height of 600 and zoom of 2 would have a display height
                 * of 300 pixels.
                 */
                readonly displayHeight: number;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

            }

            /**
             * A Camera.
             * 
             * The Camera is the way in which all games are rendered in Phaser. They provide a view into your game world,
             * and can be positioned, rotated, zoomed and scrolled accordingly.
             * 
             * A Camera consists of two elements: The viewport and the scroll values.
             * 
             * The viewport is the physical position and size of the Camera within your game. Cameras, by default, are
             * created the same size as your game, but their position and size can be set to anything. This means if you
             * wanted to create a camera that was 320x200 in size, positioned in the bottom-right corner of your game,
             * you'd adjust the viewport to do that (using methods like `setViewport` and `setSize`).
             * 
             * If you wish to change where the Camera is looking in your game, then you scroll it. You can do this
             * via the properties `scrollX` and `scrollY` or the method `setScroll`. Scrolling has no impact on the
             * viewport, and changing the viewport has no impact on the scrolling.
             * 
             * By default a Camera will render all Game Objects it can see. You can change this using the `ignore` method,
             * allowing you to filter Game Objects out on a per-Camera basis.
             * 
             * A Camera also has built-in special effects including Fade, Flash and Camera Shake.
             */
            class Camera extends Phaser.Cameras.Scene2D.BaseCamera implements Phaser.GameObjects.Components.PostPipeline {
                /**
                 * 
                 * @param x The x position of the Camera, relative to the top-left of the game canvas.
                 * @param y The y position of the Camera, relative to the top-left of the game canvas.
                 * @param width The width of the Camera, in pixels.
                 * @param height The height of the Camera, in pixels.
                 */
                constructor(x: number, y: number, width: number, height: number);

                /**
                 * Does this Camera allow the Game Objects it renders to receive input events?
                 */
                inputEnabled: boolean;

                /**
                 * The Camera Fade effect handler.
                 * To fade this camera see the `Camera.fade` methods.
                 */
                fadeEffect: Phaser.Cameras.Scene2D.Effects.Fade;

                /**
                 * The Camera Flash effect handler.
                 * To flash this camera see the `Camera.flash` method.
                 */
                flashEffect: Phaser.Cameras.Scene2D.Effects.Flash;

                /**
                 * The Camera Shake effect handler.
                 * To shake this camera see the `Camera.shake` method.
                 */
                shakeEffect: Phaser.Cameras.Scene2D.Effects.Shake;

                /**
                 * The Camera Pan effect handler.
                 * To pan this camera see the `Camera.pan` method.
                 */
                panEffect: Phaser.Cameras.Scene2D.Effects.Pan;

                /**
                 * The Camera Rotate To effect handler.
                 * To rotate this camera see the `Camera.rotateTo` method.
                 */
                rotateToEffect: Phaser.Cameras.Scene2D.Effects.RotateTo;

                /**
                 * The Camera Zoom effect handler.
                 * To zoom this camera see the `Camera.zoom` method.
                 */
                zoomEffect: Phaser.Cameras.Scene2D.Effects.Zoom;

                /**
                 * The linear interpolation value to use when following a target.
                 * 
                 * Can also be set via `setLerp` or as part of the `startFollow` call.
                 * 
                 * The default values of 1 means the camera will instantly snap to the target coordinates.
                 * A lower value, such as 0.1 means the camera will more slowly track the target, giving
                 * a smooth transition. You can set the horizontal and vertical values independently, and also
                 * adjust this value in real-time during your game.
                 * 
                 * Be sure to keep the value between 0 and 1. A value of zero will disable tracking on that axis.
                 */
                lerp: Phaser.Math.Vector2;

                /**
                 * The values stored in this property are subtracted from the Camera targets position, allowing you to
                 * offset the camera from the actual target x/y coordinates by this amount.
                 * Can also be set via `setFollowOffset` or as part of the `startFollow` call.
                 */
                followOffset: Phaser.Math.Vector2;

                /**
                 * The Camera dead zone.
                 * 
                 * The deadzone is only used when the camera is following a target.
                 * 
                 * It defines a rectangular region within which if the target is present, the camera will not scroll.
                 * If the target moves outside of this area, the camera will begin scrolling in order to follow it.
                 * 
                 * The `lerp` values that you can set for a follower target also apply when using a deadzone.
                 * 
                 * You can directly set this property to be an instance of a Rectangle. Or, you can use the
                 * `setDeadzone` method for a chainable approach.
                 * 
                 * The rectangle you provide can have its dimensions adjusted dynamically, however, please
                 * note that its position is updated every frame, as it is constantly re-centered on the cameras mid point.
                 * 
                 * Calling `setDeadzone` with no arguments will reset an active deadzone, as will setting this property
                 * to `null`.
                 */
                deadzone: Phaser.Geom.Rectangle | null;

                /**
                 * Sets the Camera dead zone.
                 * 
                 * The deadzone is only used when the camera is following a target.
                 * 
                 * It defines a rectangular region within which if the target is present, the camera will not scroll.
                 * If the target moves outside of this area, the camera will begin scrolling in order to follow it.
                 * 
                 * The deadzone rectangle is re-positioned every frame so that it is centered on the mid-point
                 * of the camera. This allows you to use the object for additional game related checks, such as
                 * testing if an object is within it or not via a Rectangle.contains call.
                 * 
                 * The `lerp` values that you can set for a follower target also apply when using a deadzone.
                 * 
                 * Calling this method with no arguments will reset an active deadzone.
                 * @param width The width of the deadzone rectangle in pixels. If not specified the deadzone is removed.
                 * @param height The height of the deadzone rectangle in pixels.
                 */
                setDeadzone(width?: number, height?: number): this;

                /**
                 * Fades the Camera in from the given color over the duration specified.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 0.
                 * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 0.
                 * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 0.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                fadeIn(duration?: number, red?: number, green?: number, blue?: number, callback?: Function, context?: any): this;

                /**
                 * Fades the Camera out to the given color over the duration specified.
                 * This is an alias for Camera.fade that forces the fade to start, regardless of existing fades.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 0.
                 * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 0.
                 * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 0.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                fadeOut(duration?: number, red?: number, green?: number, blue?: number, callback?: Function, context?: any): this;

                /**
                 * Fades the Camera from the given color to transparent over the duration specified.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 0.
                 * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 0.
                 * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 0.
                 * @param force Force the effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                fadeFrom(duration?: number, red?: number, green?: number, blue?: number, force?: boolean, callback?: Function, context?: any): this;

                /**
                 * Fades the Camera from transparent to the given color over the duration specified.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 0.
                 * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 0.
                 * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 0.
                 * @param force Force the effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                fade(duration?: number, red?: number, green?: number, blue?: number, force?: boolean, callback?: Function, context?: any): this;

                /**
                 * Flashes the Camera by setting it to the given color immediately and then fading it away again quickly over the duration specified.
                 * @param duration The duration of the effect in milliseconds. Default 250.
                 * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 255.
                 * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 255.
                 * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 255.
                 * @param force Force the effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                flash(duration?: number, red?: number, green?: number, blue?: number, force?: boolean, callback?: Function, context?: any): this;

                /**
                 * Shakes the Camera by the given intensity over the duration specified.
                 * @param duration The duration of the effect in milliseconds. Default 100.
                 * @param intensity The intensity of the shake. Default 0.05.
                 * @param force Force the shake effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                shake(duration?: number, intensity?: number | Phaser.Math.Vector2, force?: boolean, callback?: Function, context?: any): this;

                /**
                 * This effect will scroll the Camera so that the center of its viewport finishes at the given destination,
                 * over the duration and with the ease specified.
                 * @param x The destination x coordinate to scroll the center of the Camera viewport to.
                 * @param y The destination y coordinate to scroll the center of the Camera viewport to.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param ease The ease to use for the pan. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                 * @param force Force the pan effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent four arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                 * the current camera scroll x coordinate and the current camera scroll y coordinate.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                pan(x: number, y: number, duration?: number, ease?: string | Function, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraPanCallback, context?: any): this;

                /**
                 * This effect will rotate the Camera so that the viewport finishes at the given angle in radians,
                 * over the duration and with the ease specified.
                 * @param radians The destination angle in radians to rotate the Camera viewport to. If the angle is positive then the rotation is clockwise else anticlockwise
                 * @param shortestPath If shortest path is set to true the camera will rotate in the quickest direction clockwise or anti-clockwise. Default false.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param ease The ease to use for the rotation. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                 * @param force Force the rotation effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent four arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                 * the current camera rotation angle in radians.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                rotateTo(radians: number, shortestPath?: boolean, duration?: number, ease?: string | Function, force?: boolean, callback?: CameraRotateCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                /**
                 * This effect will zoom the Camera to the given scale, over the duration and with the ease specified.
                 * @param zoom The target Camera zoom value.
                 * @param duration The duration of the effect in milliseconds. Default 1000.
                 * @param ease The ease to use for the pan. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                 * @param force Force the pan effect to start immediately, even if already running. Default false.
                 * @param callback This callback will be invoked every frame for the duration of the effect.
                 * It is sent four arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                 * the current camera scroll x coordinate and the current camera scroll y coordinate.
                 * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                 */
                zoomTo(zoom: number, duration?: number, ease?: string | Function, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraPanCallback, context?: any): this;

                /**
                 * Internal preRender step.
                 */
                protected preRender(): void;

                /**
                 * Sets the linear interpolation value to use when following a target.
                 * 
                 * The default values of 1 means the camera will instantly snap to the target coordinates.
                 * A lower value, such as 0.1 means the camera will more slowly track the target, giving
                 * a smooth transition. You can set the horizontal and vertical values independently, and also
                 * adjust this value in real-time during your game.
                 * 
                 * Be sure to keep the value between 0 and 1. A value of zero will disable tracking on that axis.
                 * @param x The amount added to the horizontal linear interpolation of the follow target. Default 1.
                 * @param y The amount added to the vertical linear interpolation of the follow target. Default 1.
                 */
                setLerp(x?: number, y?: number): this;

                /**
                 * Sets the horizontal and vertical offset of the camera from its follow target.
                 * The values are subtracted from the targets position during the Cameras update step.
                 * @param x The horizontal offset from the camera follow target.x position. Default 0.
                 * @param y The vertical offset from the camera follow target.y position. Default 0.
                 */
                setFollowOffset(x?: number, y?: number): this;

                /**
                 * Sets the Camera to follow a Game Object.
                 * 
                 * When enabled the Camera will automatically adjust its scroll position to keep the target Game Object
                 * in its center.
                 * 
                 * You can set the linear interpolation value used in the follow code.
                 * Use low lerp values (such as 0.1) to automatically smooth the camera motion.
                 * 
                 * If you find you're getting a slight "jitter" effect when following an object it's probably to do with sub-pixel
                 * rendering of the targets position. This can be rounded by setting the `roundPixels` argument to `true` to
                 * force full pixel rounding rendering. Note that this can still be broken if you have specified a non-integer zoom
                 * value on the camera. So be sure to keep the camera zoom to integers.
                 * @param target The target for the Camera to follow.
                 * @param roundPixels Round the camera position to whole integers to avoid sub-pixel rendering? Default false.
                 * @param lerpX A value between 0 and 1. This value specifies the amount of linear interpolation to use when horizontally tracking the target. The closer the value to 1, the faster the camera will track. Default 1.
                 * @param lerpY A value between 0 and 1. This value specifies the amount of linear interpolation to use when vertically tracking the target. The closer the value to 1, the faster the camera will track. Default 1.
                 * @param offsetX The horizontal offset from the camera follow target.x position. Default 0.
                 * @param offsetY The vertical offset from the camera follow target.y position. Default 0.
                 */
                startFollow(target: Phaser.GameObjects.GameObject | object, roundPixels?: boolean, lerpX?: number, lerpY?: number, offsetX?: number, offsetY?: number): this;

                /**
                 * Stops a Camera from following a Game Object, if previously set via `Camera.startFollow`.
                 */
                stopFollow(): this;

                /**
                 * Resets any active FX, such as a fade, flash or shake. Useful to call after a fade in order to
                 * remove the fade.
                 */
                resetFX(): this;

                /**
                 * Internal method called automatically by the Camera Manager.
                 * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                 * @param delta The delta time, in ms, elapsed since the last frame.
                 */
                protected update(time: number, delta: number): void;

                /**
                 * Destroys this Camera instance. You rarely need to call this directly.
                 * 
                 * Called by the Camera Manager. If you wish to destroy a Camera please use `CameraManager.remove` as
                 * cameras are stored in a pool, ready for recycling later, and calling this directly will prevent that.
                 */
                destroy(): void;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

            }

            /**
             * The Camera Manager is a plugin that belongs to a Scene and is responsible for managing all of the Scene Cameras.
             * 
             * By default you can access the Camera Manager from within a Scene using `this.cameras`, although this can be changed
             * in your game config.
             * 
             * Create new Cameras using the `add` method. Or extend the Camera class with your own addition code and then add
             * the new Camera in using the `addExisting` method.
             * 
             * Cameras provide a view into your game world, and can be positioned, rotated, zoomed and scrolled accordingly.
             * 
             * A Camera consists of two elements: The viewport and the scroll values.
             * 
             * The viewport is the physical position and size of the Camera within your game. Cameras, by default, are
             * created the same size as your game, but their position and size can be set to anything. This means if you
             * wanted to create a camera that was 320x200 in size, positioned in the bottom-right corner of your game,
             * you'd adjust the viewport to do that (using methods like `setViewport` and `setSize`).
             * 
             * If you wish to change where the Camera is looking in your game, then you scroll it. You can do this
             * via the properties `scrollX` and `scrollY` or the method `setScroll`. Scrolling has no impact on the
             * viewport, and changing the viewport has no impact on the scrolling.
             * 
             * By default a Camera will render all Game Objects it can see. You can change this using the `ignore` method,
             * allowing you to filter Game Objects out on a per-Camera basis. The Camera Manager can manage up to 31 unique
             * 'Game Object ignore capable' Cameras. Any Cameras beyond 31 that you create will all be given a Camera ID of
             * zero, meaning that they cannot be used for Game Object exclusion. This means if you need your Camera to ignore
             * Game Objects, make sure it's one of the first 31 created.
             * 
             * A Camera also has built-in special effects including Fade, Flash, Camera Shake, Pan and Zoom.
             */
            class CameraManager {
                /**
                 * 
                 * @param scene The Scene that owns the Camera Manager plugin.
                 */
                constructor(scene: Phaser.Scene);

                /**
                 * The Scene that owns the Camera Manager plugin.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene.Systems handler for the Scene that owns the Camera Manager.
                 */
                systems: Phaser.Scenes.Systems;

                /**
                 * All Cameras created by, or added to, this Camera Manager, will have their `roundPixels`
                 * property set to match this value. By default it is set to match the value set in the
                 * game configuration, but can be changed at any point. Equally, individual cameras can
                 * also be changed as needed.
                 */
                roundPixels: boolean;

                /**
                 * An Array of the Camera objects being managed by this Camera Manager.
                 * The Cameras are updated and rendered in the same order in which they appear in this array.
                 * Do not directly add or remove entries to this array. However, you can move the contents
                 * around the array should you wish to adjust the display order.
                 */
                cameras: Phaser.Cameras.Scene2D.Camera[];

                /**
                 * A handy reference to the 'main' camera. By default this is the first Camera the
                 * Camera Manager creates. You can also set it directly, or use the `makeMain` argument
                 * in the `add` and `addExisting` methods. It allows you to access it from your game:
                 * 
                 * ```javascript
                 * var cam = this.cameras.main;
                 * ```
                 * 
                 * Also see the properties `camera1`, `camera2` and so on.
                 */
                main: Phaser.Cameras.Scene2D.Camera;

                /**
                 * A default un-transformed Camera that doesn't exist on the camera list and doesn't
                 * count towards the total number of cameras being managed. It exists for other
                 * systems, as well as your own code, should they require a basic un-transformed
                 * camera instance from which to calculate a view matrix.
                 */
                default: Phaser.Cameras.Scene2D.Camera;

                /**
                 * Adds a new Camera into the Camera Manager. The Camera Manager can support up to 31 different Cameras.
                 * 
                 * Each Camera has its own viewport, which controls the size of the Camera and its position within the canvas.
                 * 
                 * Use the `Camera.scrollX` and `Camera.scrollY` properties to change where the Camera is looking, or the
                 * Camera methods such as `centerOn`. Cameras also have built in special effects, such as fade, flash, shake,
                 * pan and zoom.
                 * 
                 * By default Cameras are transparent and will render anything that they can see based on their `scrollX`
                 * and `scrollY` values. Game Objects can be set to be ignored by a Camera by using the `Camera.ignore` method.
                 * 
                 * The Camera will have its `roundPixels` property set to whatever `CameraManager.roundPixels` is. You can change
                 * it after creation if required.
                 * 
                 * See the Camera class documentation for more details.
                 * @param x The horizontal position of the Camera viewport. Default 0.
                 * @param y The vertical position of the Camera viewport. Default 0.
                 * @param width The width of the Camera viewport. If not given it'll be the game config size.
                 * @param height The height of the Camera viewport. If not given it'll be the game config size.
                 * @param makeMain Set this Camera as being the 'main' camera. This just makes the property `main` a reference to it. Default false.
                 * @param name The name of the Camera. Default ''.
                 */
                add(x?: number, y?: number, width?: number, height?: number, makeMain?: boolean, name?: string): Phaser.Cameras.Scene2D.Camera;

                /**
                 * Adds an existing Camera into the Camera Manager.
                 * 
                 * The Camera should either be a `Phaser.Cameras.Scene2D.Camera` instance, or a class that extends from it.
                 * 
                 * The Camera will have its `roundPixels` property set to whatever `CameraManager.roundPixels` is. You can change
                 * it after addition if required.
                 * 
                 * The Camera will be assigned an ID, which is used for Game Object exclusion and then added to the
                 * manager. As long as it doesn't already exist in the manager it will be added then returned.
                 * 
                 * If this method returns `null` then the Camera already exists in this Camera Manager.
                 * @param camera The Camera to be added to the Camera Manager.
                 * @param makeMain Set this Camera as being the 'main' camera. This just makes the property `main` a reference to it. Default false.
                 */
                addExisting(camera: Phaser.Cameras.Scene2D.Camera, makeMain?: boolean): Phaser.Cameras.Scene2D.Camera | null;

                /**
                 * Gets the total number of Cameras in this Camera Manager.
                 * 
                 * If the optional `isVisible` argument is set it will only count Cameras that are currently visible.
                 * @param isVisible Set the `true` to only include visible Cameras in the total. Default false.
                 */
                getTotal(isVisible?: boolean): number;

                /**
                 * Populates this Camera Manager based on the given configuration object, or an array of config objects.
                 * 
                 * See the `Phaser.Types.Cameras.Scene2D.CameraConfig` documentation for details of the object structure.
                 * @param config A Camera configuration object, or an array of them, to be added to this Camera Manager.
                 */
                fromJSON(config: Phaser.Types.Cameras.Scene2D.CameraConfig | Phaser.Types.Cameras.Scene2D.CameraConfig[]): this;

                /**
                 * Gets a Camera based on its name.
                 * 
                 * Camera names are optional and don't have to be set, so this method is only of any use if you
                 * have given your Cameras unique names.
                 * @param name The name of the Camera.
                 */
                getCamera(name: string): Phaser.Cameras.Scene2D.Camera | null;

                /**
                 * Returns an array of all cameras below the given Pointer.
                 * 
                 * The first camera in the array is the top-most camera in the camera list.
                 * @param pointer The Pointer to check against.
                 */
                getCamerasBelowPointer(pointer: Phaser.Input.Pointer): Phaser.Cameras.Scene2D.Camera[];

                /**
                 * Removes the given Camera, or an array of Cameras, from this Camera Manager.
                 * 
                 * If found in the Camera Manager it will be immediately removed from the local cameras array.
                 * If also currently the 'main' camera, 'main' will be reset to be camera 0.
                 * 
                 * The removed Cameras are automatically destroyed if the `runDestroy` argument is `true`, which is the default.
                 * If you wish to re-use the cameras then set this to `false`, but know that they will retain their references
                 * and internal data until destroyed or re-added to a Camera Manager.
                 * @param camera The Camera, or an array of Cameras, to be removed from this Camera Manager.
                 * @param runDestroy Automatically call `Camera.destroy` on each Camera removed from this Camera Manager. Default true.
                 */
                remove(camera: Phaser.Cameras.Scene2D.Camera | Phaser.Cameras.Scene2D.Camera[], runDestroy?: boolean): number;

                /**
                 * The internal render method. This is called automatically by the Scene and should not be invoked directly.
                 * 
                 * It will iterate through all local cameras and render them in turn, as long as they're visible and have
                 * an alpha level > 0.
                 * @param renderer The Renderer that will render the children to this camera.
                 * @param displayList The Display List for the Scene.
                 */
                protected render(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer, displayList: Phaser.GameObjects.DisplayList): void;

                /**
                 * Takes an array of Game Objects and a Camera and returns a new array
                 * containing only those Game Objects that pass the `willRender` test
                 * against the given Camera.
                 * @param children An array of Game Objects to be checked against the camera.
                 * @param camera The camera to filter the Game Objects against.
                 */
                getVisibleChildren(children: Phaser.GameObjects.GameObject[], camera: Phaser.Cameras.Scene2D.Camera): Phaser.GameObjects.GameObject[];

                /**
                 * Resets this Camera Manager.
                 * 
                 * This will iterate through all current Cameras, destroying them all, then it will reset the
                 * cameras array, reset the ID counter and create 1 new single camera using the default values.
                 */
                resetAll(): Phaser.Cameras.Scene2D.Camera;

                /**
                 * The main update loop. Called automatically when the Scene steps.
                 * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                 * @param delta The delta time, in ms, elapsed since the last frame.
                 */
                protected update(time: number, delta: number): void;

                /**
                 * The event handler that manages the `resize` event dispatched by the Scale Manager.
                 * @param gameSize The default Game Size object. This is the un-modified game dimensions.
                 * @param baseSize The base Size object. The game dimensions. The canvas width / height values match this.
                 */
                onResize(gameSize: Phaser.Structs.Size, baseSize: Phaser.Structs.Size): void;

                /**
                 * Resizes all cameras to the given dimensions.
                 * @param width The new width of the camera.
                 * @param height The new height of the camera.
                 */
                resize(width: number, height: number): void;

            }

            namespace Effects {
                /**
                 * A Camera Fade effect.
                 * 
                 * This effect will fade the camera viewport to the given color, over the duration specified.
                 * 
                 * Only the camera viewport is faded. None of the objects it is displaying are impacted, i.e. their colors do
                 * not change.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect, if required.
                 */
                class Fade {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * Has this effect finished running?
                     * 
                     * This is different from `isRunning` because it remains set to `true` when the effect is over,
                     * until the effect is either reset or started again.
                     */
                    readonly isComplete: boolean;

                    /**
                     * The direction of the fade.
                     * `true` = fade out (transparent to color), `false` = fade in (color to transparent)
                     */
                    readonly direction: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * Fades the Camera to or from the given color over the duration specified.
                     * @param direction The direction of the fade. `true` = fade out (transparent to color), `false` = fade in (color to transparent) Default true.
                     * @param duration The duration of the effect in milliseconds. Default 1000.
                     * @param red The amount to fade the red channel towards. A value between 0 and 255. Default 0.
                     * @param green The amount to fade the green channel towards. A value between 0 and 255. Default 0.
                     * @param blue The amount to fade the blue channel towards. A value between 0 and 255. Default 0.
                     * @param force Force the effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(direction?: boolean, duration?: number, red?: number, green?: number, blue?: number, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraFadeCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally by the Canvas Renderer.
                     * @param ctx The Canvas context to render to.
                     */
                    postRenderCanvas(ctx: CanvasRenderingContext2D): boolean;

                    /**
                     * Called internally by the WebGL Renderer.
                     * @param pipeline The WebGL Pipeline to render to. Must provide the `drawFillRect` method.
                     * @param getTintFunction A function that will return the gl safe tint colors.
                     */
                    postRenderWebGL(pipeline: Phaser.Renderer.WebGL.Pipelines.MultiPipeline, getTintFunction: Function): boolean;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

                /**
                 * A Camera Flash effect.
                 * 
                 * This effect will flash the camera viewport to the given color, over the duration specified.
                 * 
                 * Only the camera viewport is flashed. None of the objects it is displaying are impacted, i.e. their colors do
                 * not change.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect, if required.
                 */
                class Flash {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * The value of the alpha channel used during the flash effect.
                     * A value between 0 and 1.
                     */
                    alpha: number;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * Flashes the Camera to or from the given color over the duration specified.
                     * @param duration The duration of the effect in milliseconds. Default 250.
                     * @param red The amount to flash the red channel towards. A value between 0 and 255. Default 255.
                     * @param green The amount to flash the green channel towards. A value between 0 and 255. Default 255.
                     * @param blue The amount to flash the blue channel towards. A value between 0 and 255. Default 255.
                     * @param force Force the effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(duration?: number, red?: number, green?: number, blue?: number, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraFlashCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally by the Canvas Renderer.
                     * @param ctx The Canvas context to render to.
                     */
                    postRenderCanvas(ctx: CanvasRenderingContext2D): boolean;

                    /**
                     * Called internally by the WebGL Renderer.
                     * @param pipeline The WebGL Pipeline to render to. Must provide the `drawFillRect` method.
                     * @param getTintFunction A function that will return the gl safe tint colors.
                     */
                    postRenderWebGL(pipeline: Phaser.Renderer.WebGL.Pipelines.MultiPipeline, getTintFunction: Function): boolean;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

                /**
                 * A Camera Pan effect.
                 * 
                 * This effect will scroll the Camera so that the center of its viewport finishes at the given destination,
                 * over the duration and with the ease specified.
                 * 
                 * Only the camera scroll is moved. None of the objects it is displaying are impacted, i.e. their positions do
                 * not change.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect if required.
                 */
                class Pan {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * The starting scroll coordinates to pan the camera from.
                     */
                    source: Phaser.Math.Vector2;

                    /**
                     * The constantly updated value based on zoom.
                     */
                    current: Phaser.Math.Vector2;

                    /**
                     * The destination scroll coordinates to pan the camera to.
                     */
                    destination: Phaser.Math.Vector2;

                    /**
                     * The ease function to use during the pan.
                     */
                    ease: Function;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * This effect will scroll the Camera so that the center of its viewport finishes at the given destination,
                     * over the duration and with the ease specified.
                     * @param x The destination x coordinate to scroll the center of the Camera viewport to.
                     * @param y The destination y coordinate to scroll the center of the Camera viewport to.
                     * @param duration The duration of the effect in milliseconds. Default 1000.
                     * @param ease The ease to use for the pan. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                     * @param force Force the pan effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent four arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                     * the current camera scroll x coordinate and the current camera scroll y coordinate.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(x: number, y: number, duration?: number, ease?: string | Function, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraPanCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

                /**
                 * A Camera Rotate effect.
                 * 
                 * This effect will rotate the Camera so that the its viewport finishes at the given angle in radians,
                 * over the duration and with the ease specified.
                 * 
                 * Camera rotation always takes place based on the Camera viewport. By default, rotation happens
                 * in the center of the viewport. You can adjust this with the `originX` and `originY` properties.
                 * 
                 * Rotation influences the rendering of _all_ Game Objects visible by this Camera. However, it does not
                 * rotate the Camera viewport itself, which always remains an axis-aligned rectangle.
                 * 
                 * Only the camera is rotates. None of the objects it is displaying are impacted, i.e. their positions do
                 * not change.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect if required.
                 */
                class RotateTo {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * The starting angle to rotate the camera from.
                     */
                    source: number;

                    /**
                     * The constantly updated value based on the force.
                     */
                    current: number;

                    /**
                     * The destination angle in radians to rotate the camera to.
                     */
                    destination: number;

                    /**
                     * The ease function to use during the Rotate.
                     */
                    ease: Function;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * The direction of the rotation.
                     */
                    clockwise: boolean;

                    /**
                     * The shortest direction to the target rotation.
                     */
                    shortestPath: boolean;

                    /**
                     * This effect will scroll the Camera so that the center of its viewport finishes at the given angle,
                     * over the duration and with the ease specified.
                     * @param radians The destination angle in radians to rotate the Camera viewport to. If the angle is positive then the rotation is clockwise else anticlockwise
                     * @param shortestPath If shortest path is set to true the camera will rotate in the quickest direction clockwise or anti-clockwise. Default false.
                     * @param duration The duration of the effect in milliseconds. Default 1000.
                     * @param ease The ease to use for the Rotate. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                     * @param force Force the rotation effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent four arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                     * the current camera scroll x coordinate and the current camera scroll y coordinate.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(radians: number, shortestPath?: boolean, duration?: number, ease?: string | Function, force?: boolean, callback?: CameraRotateCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

                /**
                 * A Camera Shake effect.
                 * 
                 * This effect will shake the camera viewport by a random amount, bounded by the specified intensity, each frame.
                 * 
                 * Only the camera viewport is moved. None of the objects it is displaying are impacted, i.e. their positions do
                 * not change.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect if required.
                 */
                class Shake {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * The intensity of the effect. Use small float values. The default when the effect starts is 0.05.
                     * This is a Vector2 object, allowing you to control the shake intensity independently across x and y.
                     * You can modify this value while the effect is active to create more varied shake effects.
                     */
                    intensity: Phaser.Math.Vector2;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * Shakes the Camera by the given intensity over the duration specified.
                     * @param duration The duration of the effect in milliseconds. Default 100.
                     * @param intensity The intensity of the shake. Default 0.05.
                     * @param force Force the shake effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent two arguments: A reference to the camera and a progress amount between 0 and 1 indicating how complete the effect is.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(duration?: number, intensity?: number | Phaser.Math.Vector2, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraShakeCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The pre-render step for this effect. Called automatically by the Camera.
                     */
                    preRender(): void;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

                /**
                 * A Camera Zoom effect.
                 * 
                 * This effect will zoom the Camera to the given scale, over the duration and with the ease specified.
                 * 
                 * The effect will dispatch several events on the Camera itself and you can also specify an `onUpdate` callback,
                 * which is invoked each frame for the duration of the effect if required.
                 */
                class Zoom {
                    /**
                     * 
                     * @param camera The camera this effect is acting upon.
                     */
                    constructor(camera: Phaser.Cameras.Scene2D.Camera);

                    /**
                     * The Camera this effect belongs to.
                     */
                    readonly camera: Phaser.Cameras.Scene2D.Camera;

                    /**
                     * Is this effect actively running?
                     */
                    readonly isRunning: boolean;

                    /**
                     * The duration of the effect, in milliseconds.
                     */
                    readonly duration: number;

                    /**
                     * The starting zoom value;
                     */
                    source: number;

                    /**
                     * The destination zoom value.
                     */
                    destination: number;

                    /**
                     * The ease function to use during the zoom.
                     */
                    ease: Function;

                    /**
                     * If this effect is running this holds the current percentage of the progress, a value between 0 and 1.
                     */
                    progress: number;

                    /**
                     * This effect will zoom the Camera to the given scale, over the duration and with the ease specified.
                     * @param zoom The target Camera zoom value.
                     * @param duration The duration of the effect in milliseconds. Default 1000.
                     * @param ease The ease to use for the Zoom. Can be any of the Phaser Easing constants or a custom function. Default 'Linear'.
                     * @param force Force the zoom effect to start immediately, even if already running. Default false.
                     * @param callback This callback will be invoked every frame for the duration of the effect.
                     * It is sent three arguments: A reference to the camera, a progress amount between 0 and 1 indicating how complete the effect is,
                     * and the current camera zoom value.
                     * @param context The context in which the callback is invoked. Defaults to the Scene to which the Camera belongs.
                     */
                    start(zoom: number, duration?: number, ease?: string | Function, force?: boolean, callback?: Phaser.Types.Cameras.Scene2D.CameraZoomCallback, context?: any): Phaser.Cameras.Scene2D.Camera;

                    /**
                     * The main update loop for this effect. Called automatically by the Camera.
                     * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                     * @param delta The delta time, in ms, elapsed since the last frame.
                     */
                    update(time: number, delta: number): void;

                    /**
                     * Called internally when the effect completes.
                     */
                    effectComplete(): void;

                    /**
                     * Resets this camera effect.
                     * If it was previously running, it stops instantly without calling its onComplete callback or emitting an event.
                     */
                    reset(): void;

                    /**
                     * Destroys this effect, releasing it from the Camera.
                     */
                    destroy(): void;

                }

            }

            namespace Events {
                /**
                 * The Destroy Camera Event.
                 * 
                 * This event is dispatched by a Camera instance when it is destroyed by the Camera Manager.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('cameradestroy', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.DESTROY, () => {});
                 * ```
                 */
                const DESTROY: string;

                /**
                 * The Camera Fade In Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Fade In Effect completes.
                 * 
                 * Listen to it from a Camera instance using `Camera.on('camerafadeincomplete', listener)`.
                 */
                const FADE_IN_COMPLETE: string;

                /**
                 * The Camera Fade In Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Fade In Effect starts.
                 * 
                 * Listen to it from a Camera instance using `Camera.on('camerafadeinstart', listener)`.
                 */
                const FADE_IN_START: string;

                /**
                 * The Camera Fade Out Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Fade Out Effect completes.
                 * 
                 * Listen to it from a Camera instance using `Camera.on('camerafadeoutcomplete', listener)`.
                 */
                const FADE_OUT_COMPLETE: string;

                /**
                 * The Camera Fade Out Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Fade Out Effect starts.
                 * 
                 * Listen to it from a Camera instance using `Camera.on('camerafadeoutstart', listener)`.
                 */
                const FADE_OUT_START: string;

                /**
                 * The Camera Flash Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Flash Effect completes.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('cameraflashcomplete', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.FLASH_COMPLETE, () => {});
                 * ```
                 */
                const FLASH_COMPLETE: string;

                /**
                 * The Camera Flash Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Flash Effect starts.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('cameraflashstart', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.FLASH_START, () => {});
                 * ```
                 */
                const FLASH_START: string;

                /**
                 * The Camera Follower Update Event.
                 * 
                 * This event is dispatched by a Camera instance when it is following a
                 * Game Object and the Camera position has been updated as a result of
                 * that following.
                 * 
                 * Listen to it from a Camera instance using: `camera.on('followupdate', listener)`.
                 */
                const FOLLOW_UPDATE: string;

                /**
                 * The Camera Pan Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Pan Effect completes.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerapancomplete', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.PAN_COMPLETE, () => {});
                 * ```
                 */
                const PAN_COMPLETE: string;

                /**
                 * The Camera Pan Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Pan Effect starts.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerapanstart', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.PAN_START, () => {});
                 * ```
                 */
                const PAN_START: string;

                /**
                 * The Camera Post-Render Event.
                 * 
                 * This event is dispatched by a Camera instance after is has finished rendering.
                 * It is only dispatched if the Camera is rendering to a texture.
                 * 
                 * Listen to it from a Camera instance using: `camera.on('postrender', listener)`.
                 */
                const POST_RENDER: string;

                /**
                 * The Camera Pre-Render Event.
                 * 
                 * This event is dispatched by a Camera instance when it is about to render.
                 * It is only dispatched if the Camera is rendering to a texture.
                 * 
                 * Listen to it from a Camera instance using: `camera.on('prerender', listener)`.
                 */
                const PRE_RENDER: string;

                /**
                 * The Camera Rotate Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Rotate Effect completes.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerarotatecomplete', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.ROTATE_COMPLETE, () => {});
                 * ```
                 */
                const ROTATE_COMPLETE: string;

                /**
                 * The Camera Rotate Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Rotate Effect starts.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerarotatestart', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.ROTATE_START, () => {});
                 * ```
                 */
                const ROTATE_START: string;

                /**
                 * The Camera Shake Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Shake Effect completes.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerashakecomplete', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.SHAKE_COMPLETE, () => {});
                 * ```
                 */
                const SHAKE_COMPLETE: string;

                /**
                 * The Camera Shake Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Shake Effect starts.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerashakestart', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.SHAKE_START, () => {});
                 * ```
                 */
                const SHAKE_START: string;

                /**
                 * The Camera Zoom Complete Event.
                 * 
                 * This event is dispatched by a Camera instance when the Zoom Effect completes.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerazoomcomplete', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.ZOOM_COMPLETE, () => {});
                 * ```
                 */
                const ZOOM_COMPLETE: string;

                /**
                 * The Camera Zoom Start Event.
                 * 
                 * This event is dispatched by a Camera instance when the Zoom Effect starts.
                 * 
                 * Listen for it via either of the following:
                 * 
                 * ```js
                 * this.cameras.main.on('camerazoomstart', () => {});
                 * ```
                 * 
                 * or use the constant, to avoid having to remember the correct event string:
                 * 
                 * ```js
                 * this.cameras.main.on(Phaser.Cameras.Scene2D.Events.ZOOM_START, () => {});
                 * ```
                 */
                const ZOOM_START: string;

            }

        }

        namespace Controls {
            /**
             * A Fixed Key Camera Control.
             * 
             * This allows you to control the movement and zoom of a camera using the defined keys.
             * 
             * ```javascript
             * var camControl = new FixedKeyControl({
             *     camera: this.cameras.main,
             *     left: cursors.left,
             *     right: cursors.right,
             *     speed: float OR { x: 0, y: 0 }
             * });
             * ```
             * 
             * Movement is precise and has no 'smoothing' applied to it.
             * 
             * You must call the `update` method of this controller every frame.
             */
            class FixedKeyControl {
                /**
                 * 
                 * @param config The Fixed Key Control configuration object.
                 */
                constructor(config: Phaser.Types.Cameras.Controls.FixedKeyControlConfig);

                /**
                 * The Camera that this Control will update.
                 */
                camera: Phaser.Cameras.Scene2D.Camera | null;

                /**
                 * The Key to be pressed that will move the Camera left.
                 */
                left: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera right.
                 */
                right: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera up.
                 */
                up: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera down.
                 */
                down: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will zoom the Camera in.
                 */
                zoomIn: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will zoom the Camera out.
                 */
                zoomOut: Phaser.Input.Keyboard.Key | null;

                /**
                 * The speed at which the camera will zoom if the `zoomIn` or `zoomOut` keys are pressed.
                 */
                zoomSpeed: number;

                /**
                 * The smallest zoom value the camera will reach when zoomed out.
                 */
                minZoom: number;

                /**
                 * The largest zoom value the camera will reach when zoomed in.
                 */
                maxZoom: number;

                /**
                 * The horizontal speed the camera will move.
                 */
                speedX: number;

                /**
                 * The vertical speed the camera will move.
                 */
                speedY: number;

                /**
                 * A flag controlling if the Controls will update the Camera or not.
                 */
                active: boolean;

                /**
                 * Starts the Key Control running, providing it has been linked to a camera.
                 */
                start(): this;

                /**
                 * Stops this Key Control from running. Call `start` to start it again.
                 */
                stop(): this;

                /**
                 * Binds this Key Control to a camera.
                 * @param camera The camera to bind this Key Control to.
                 */
                setCamera(camera: Phaser.Cameras.Scene2D.Camera): this;

                /**
                 * Applies the results of pressing the control keys to the Camera.
                 * 
                 * You must call this every step, it is not called automatically.
                 * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
                 */
                update(delta: number): void;

                /**
                 * Destroys this Key Control.
                 */
                destroy(): void;

            }

            /**
             * A Smoothed Key Camera Control.
             * 
             * This allows you to control the movement and zoom of a camera using the defined keys.
             * Unlike the Fixed Camera Control you can also provide physics values for acceleration, drag and maxSpeed for smoothing effects.
             * 
             * ```javascript
             * var controlConfig = {
             *     camera: this.cameras.main,
             *     left: cursors.left,
             *     right: cursors.right,
             *     up: cursors.up,
             *     down: cursors.down,
             *     zoomIn: this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.Q),
             *     zoomOut: this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.E),
             *     zoomSpeed: 0.02,
             *     acceleration: 0.06,
             *     drag: 0.0005,
             *     maxSpeed: 1.0
             * };
             * ```
             * 
             * You must call the `update` method of this controller every frame.
             */
            class SmoothedKeyControl {
                /**
                 * 
                 * @param config The Smoothed Key Control configuration object.
                 */
                constructor(config: Phaser.Types.Cameras.Controls.SmoothedKeyControlConfig);

                /**
                 * The Camera that this Control will update.
                 */
                camera: Phaser.Cameras.Scene2D.Camera | null;

                /**
                 * The Key to be pressed that will move the Camera left.
                 */
                left: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera right.
                 */
                right: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera up.
                 */
                up: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will move the Camera down.
                 */
                down: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will zoom the Camera in.
                 */
                zoomIn: Phaser.Input.Keyboard.Key | null;

                /**
                 * The Key to be pressed that will zoom the Camera out.
                 */
                zoomOut: Phaser.Input.Keyboard.Key | null;

                /**
                 * The speed at which the camera will zoom if the `zoomIn` or `zoomOut` keys are pressed.
                 */
                zoomSpeed: number;

                /**
                 * The smallest zoom value the camera will reach when zoomed out.
                 */
                minZoom: number;

                /**
                 * The largest zoom value the camera will reach when zoomed in.
                 */
                maxZoom: number;

                /**
                 * The horizontal acceleration the camera will move.
                 */
                accelX: number;

                /**
                 * The vertical acceleration the camera will move.
                 */
                accelY: number;

                /**
                 * The horizontal drag applied to the camera when it is moving.
                 */
                dragX: number;

                /**
                 * The vertical drag applied to the camera when it is moving.
                 */
                dragY: number;

                /**
                 * The maximum horizontal speed the camera will move.
                 */
                maxSpeedX: number;

                /**
                 * The maximum vertical speed the camera will move.
                 */
                maxSpeedY: number;

                /**
                 * A flag controlling if the Controls will update the Camera or not.
                 */
                active: boolean;

                /**
                 * Starts the Key Control running, providing it has been linked to a camera.
                 */
                start(): this;

                /**
                 * Stops this Key Control from running. Call `start` to start it again.
                 */
                stop(): this;

                /**
                 * Binds this Key Control to a camera.
                 * @param camera The camera to bind this Key Control to.
                 */
                setCamera(camera: Phaser.Cameras.Scene2D.Camera): this;

                /**
                 * Applies the results of pressing the control keys to the Camera.
                 * 
                 * You must call this every step, it is not called automatically.
                 * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
                 */
                update(delta: number): void;

                /**
                 * Destroys this Key Control.
                 */
                destroy(): void;

            }

        }

    }

    /**
     * Phaser Release Version
     */
    const VERSION: string;

    /**
     * This setting will auto-detect if the browser is capable of suppporting WebGL.
     * If it is, it will use the WebGL Renderer. If not, it will fall back to the Canvas Renderer.
     */
    const AUTO: number;

    /**
     * Forces Phaser to only use the Canvas Renderer, regardless if the browser supports
     * WebGL or not.
     */
    const CANVAS: number;

    /**
     * Forces Phaser to use the WebGL Renderer. If the browser does not support it, there is
     * no fallback to Canvas with this setting, so you should trap it and display a suitable
     * message to the user.
     */
    const WEBGL: number;

    /**
     * A Headless Renderer doesn't create either a Canvas or WebGL Renderer. However, it still
     * absolutely relies on the DOM being present and available. This mode is meant for unit testing,
     * not for running Phaser on the server, which is something you really shouldn't do.
     */
    const HEADLESS: number;

    /**
     * In Phaser the value -1 means 'forever' in lots of cases, this const allows you to use it instead
     * to help you remember what the value is doing in your code.
     */
    const FOREVER: number;

    /**
     * Direction constant.
     */
    const NONE: number;

    /**
     * Direction constant.
     */
    const UP: number;

    /**
     * Direction constant.
     */
    const DOWN: number;

    /**
     * Direction constant.
     */
    const LEFT: number;

    /**
     * Direction constant.
     */
    const RIGHT: number;

    /**
     * The Phaser.Game instance is the main controller for the entire Phaser game. It is responsible
     * for handling the boot process, parsing the configuration values, creating the renderer,
     * and setting-up all of the global Phaser systems, such as sound and input.
     * Once that is complete it will start the Scene Manager and then begin the main game loop.
     * 
     * You should generally avoid accessing any of the systems created by Game, and instead use those
     * made available to you via the Phaser.Scene Systems class instead.
     */
    class Game {
        /**
         * 
         * @param GameConfig The configuration object for your Phaser Game instance.
         */
        constructor(GameConfig?: Phaser.Types.Core.GameConfig);

        /**
         * The parsed Game Configuration object.
         * 
         * The values stored within this object are read-only and should not be changed at run-time.
         */
        readonly config: Phaser.Core.Config;

        /**
         * A reference to either the Canvas or WebGL Renderer that this Game is using.
         */
        renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

        /**
         * A reference to an HTML Div Element used as the DOM Element Container.
         * 
         * Only set if `createDOMContainer` is `true` in the game config (by default it is `false`) and
         * if you provide a parent element to insert the Phaser Game inside.
         * 
         * See the DOM Element Game Object for more details.
         */
        domContainer: HTMLDivElement;

        /**
         * A reference to the HTML Canvas Element that Phaser uses to render the game.
         * This is created automatically by Phaser unless you provide a `canvas` property
         * in your Game Config.
         */
        canvas: HTMLCanvasElement;

        /**
         * A reference to the Rendering Context belonging to the Canvas Element this game is rendering to.
         * If the game is running under Canvas it will be a 2d Canvas Rendering Context.
         * If the game is running under WebGL it will be a WebGL Rendering Context.
         * This context is created automatically by Phaser unless you provide a `context` property
         * in your Game Config.
         */
        context: CanvasRenderingContext2D | WebGLRenderingContext;

        /**
         * A flag indicating when this Game instance has finished its boot process.
         */
        readonly isBooted: boolean;

        /**
         * A flag indicating if this Game is currently running its game step or not.
         */
        readonly isRunning: boolean;

        /**
         * An Event Emitter which is used to broadcast game-level events from the global systems.
         */
        events: Phaser.Events.EventEmitter;

        /**
         * An instance of the Animation Manager.
         * 
         * The Animation Manager is a global system responsible for managing all animations used within your game.
         */
        anims: Phaser.Animations.AnimationManager;

        /**
         * An instance of the Texture Manager.
         * 
         * The Texture Manager is a global system responsible for managing all textures being used by your game.
         */
        textures: Phaser.Textures.TextureManager;

        /**
         * An instance of the Cache Manager.
         * 
         * The Cache Manager is a global system responsible for caching, accessing and releasing external game assets.
         */
        cache: Phaser.Cache.CacheManager;

        /**
         * An instance of the Data Manager. This is a global manager, available from any Scene
         * and allows you to share and exchange your own game-level data or events without having
         * to use an internal event system.
         */
        registry: Phaser.Data.DataManager;

        /**
         * An instance of the Input Manager.
         * 
         * The Input Manager is a global system responsible for the capture of browser-level input events.
         */
        input: Phaser.Input.InputManager;

        /**
         * An instance of the Scene Manager.
         * 
         * The Scene Manager is a global system responsible for creating, modifying and updating the Scenes in your game.
         */
        scene: Phaser.Scenes.SceneManager;

        /**
         * A reference to the Device inspector.
         * 
         * Contains information about the device running this game, such as OS, browser vendor and feature support.
         * Used by various systems to determine capabilities and code paths.
         */
        device: Phaser.DeviceConf;

        /**
         * An instance of the Scale Manager.
         * 
         * The Scale Manager is a global system responsible for handling scaling of the game canvas.
         */
        scale: Phaser.Scale.ScaleManager;

        /**
         * An instance of the base Sound Manager.
         * 
         * The Sound Manager is a global system responsible for the playback and updating of all audio in your game.
         * 
         * You can disable the inclusion of the Sound Manager in your build by toggling the webpack `FEATURE_SOUND` flag.
         */
        sound: Phaser.Sound.NoAudioSoundManager | Phaser.Sound.HTML5AudioSoundManager | Phaser.Sound.WebAudioSoundManager;

        /**
         * An instance of the Time Step.
         * 
         * The Time Step is a global system responsible for setting-up and responding to the browser frame events, processing
         * them and calculating delta values. It then automatically calls the game step.
         */
        loop: Phaser.Core.TimeStep;

        /**
         * An instance of the Plugin Manager.
         * 
         * The Plugin Manager is a global system that allows plugins to register themselves with it, and can then install
         * those plugins into Scenes as required.
         */
        plugins: Phaser.Plugins.PluginManager;

        /**
         * An instance of the Facebook Instant Games Plugin.
         * 
         * This will only be available if the plugin has been built into Phaser,
         * or you're using the special Facebook Instant Games custom build.
         */
        facebook: Phaser.FacebookInstantGamesPlugin;

        /**
         * Does the window the game is running in currently have focus or not?
         * This is modified by the VisibilityHandler.
         */
        readonly hasFocus: boolean;

        /**
         * Is the Game currently paused? This will stop everything from updating,
         * except the `TimeStep` and related RequestAnimationFrame or setTimeout.
         * Those will continue stepping, but the core Game step will be skipped.
         */
        isPaused: boolean;

        /**
         * This method is called automatically when the DOM is ready. It is responsible for creating the renderer,
         * displaying the Debug Header, adding the game canvas to the DOM and emitting the 'boot' event.
         * It listens for a 'ready' event from the base systems and once received it will call `Game.start`.
         */
        protected boot(): void;

        /**
         * Called automatically by Game.boot once all of the global systems have finished setting themselves up.
         * By this point the Game is now ready to start the main loop running.
         * It will also enable the Visibility Handler.
         */
        protected start(): void;

        /**
         * The main Game Step. Called automatically by the Time Step, once per browser frame (typically as a result of
         * Request Animation Frame, or Set Timeout on very old browsers.)
         * 
         * The step will update the global managers first, then proceed to update each Scene in turn, via the Scene Manager.
         * 
         * It will then render each Scene in turn, via the Renderer. This process emits `prerender` and `postrender` events.
         * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
         * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
         */
        step(time: number, delta: number): void;

        /**
         * A special version of the Game Step for the HEADLESS renderer only.
         * 
         * The main Game Step. Called automatically by the Time Step, once per browser frame (typically as a result of
         * Request Animation Frame, or Set Timeout on very old browsers.)
         * 
         * The step will update the global managers first, then proceed to update each Scene in turn, via the Scene Manager.
         * 
         * This process emits `prerender` and `postrender` events, even though nothing actually displays.
         * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
         * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
         */
        headlessStep(time: number, delta: number): void;

        /**
         * Called automatically by the Visibility Handler.
         * This will pause the main loop and then emit a pause event.
         */
        protected onHidden(): void;

        /**
         * This will pause the entire game and emit a `PAUSE` event.
         * 
         * All of Phaser's internal systems will be paused and the game will not re-render.
         * 
         * Note that it does not pause any Loader requests that are currently in-flight.
         */
        pause(): void;

        /**
         * Called automatically by the Visibility Handler.
         * This will resume the main loop and then emit a resume event.
         */
        protected onVisible(): void;

        /**
         * This will resume the entire game and emit a `RESUME` event.
         * 
         * All of Phaser's internal systems will be resumed and the game will start rendering again.
         */
        resume(): void;

        /**
         * Called automatically by the Visibility Handler.
         * This will set the main loop into a 'blurred' state, which pauses it.
         */
        protected onBlur(): void;

        /**
         * Called automatically by the Visibility Handler.
         * This will set the main loop into a 'focused' state, which resumes it.
         */
        protected onFocus(): void;

        /**
         * Returns the current game frame.
         * 
         * When the game starts running, the frame is incremented every time Request Animation Frame, or Set Timeout, fires.
         */
        getFrame(): number;

        /**
         * Returns the time that the current game step started at, as based on `performance.now`.
         */
        getTime(): number;

        /**
         * Flags this Game instance as needing to be destroyed on the _next frame_, making this an asynchronous operation.
         * 
         * It will wait until the current frame has completed and then call `runDestroy` internally.
         * 
         * If you need to react to the games eventual destruction, listen for the `DESTROY` event.
         * 
         * If you **do not** need to run Phaser again on the same web page you can set the `noReturn` argument to `true` and it will free-up
         * memory being held by the core Phaser plugins. If you do need to create another game instance on the same page, leave this as `false`.
         * @param removeCanvas Set to `true` if you would like the parent canvas element removed from the DOM, or `false` to leave it in place.
         * @param noReturn If `true` all the core Phaser plugins are destroyed. You cannot create another instance of Phaser on the same web page if you do this. Default false.
         */
        destroy(removeCanvas: boolean, noReturn?: boolean): void;

    }

    namespace Core {
        /**
         * The active game configuration settings, parsed from a {@link Phaser.Types.Core.GameConfig} object.
         */
        class Config {
            /**
             * 
             * @param GameConfig The configuration object for your Phaser Game instance.
             */
            constructor(GameConfig?: Phaser.Types.Core.GameConfig);

            /**
             * The width of the underlying canvas, in pixels.
             */
            readonly width: number | string;

            /**
             * The height of the underlying canvas, in pixels.
             */
            readonly height: number | string;

            /**
             * The zoom factor, as used by the Scale Manager.
             */
            readonly zoom: Phaser.Scale.ZoomType | number;

            /**
             * A parent DOM element into which the canvas created by the renderer will be injected.
             */
            readonly parent: any | null;

            /**
             * The scale mode as used by the Scale Manager. The default is zero, which is no scaling.
             */
            readonly scaleMode: Phaser.Scale.ScaleModeType;

            /**
             * Is the Scale Manager allowed to adjust the CSS height property of the parent to be 100%?
             */
            readonly expandParent: boolean;

            /**
             * Automatically round the display and style sizes of the canvas. This can help with performance in lower-powered devices.
             */
            readonly autoRound: boolean;

            /**
             * Automatically center the canvas within the parent?
             */
            readonly autoCenter: Phaser.Scale.CenterType;

            /**
             * How many ms should elapse before checking if the browser size has changed?
             */
            readonly resizeInterval: number;

            /**
             * The DOM element that will be sent into full screen mode, or its `id`. If undefined Phaser will create its own div and insert the canvas into it when entering fullscreen mode.
             */
            readonly fullscreenTarget: HTMLElement | string | null;

            /**
             * The minimum width, in pixels, the canvas will scale down to. A value of zero means no minimum.
             */
            readonly minWidth: number;

            /**
             * The maximum width, in pixels, the canvas will scale up to. A value of zero means no maximum.
             */
            readonly maxWidth: number;

            /**
             * The minimum height, in pixels, the canvas will scale down to. A value of zero means no minimum.
             */
            readonly minHeight: number;

            /**
             * The maximum height, in pixels, the canvas will scale up to. A value of zero means no maximum.
             */
            readonly maxHeight: number;

            /**
             * Force Phaser to use a specific renderer. Can be `CONST.CANVAS`, `CONST.WEBGL`, `CONST.HEADLESS` or `CONST.AUTO` (default)
             */
            readonly renderType: number;

            /**
             * Force Phaser to use your own Canvas element instead of creating one.
             */
            readonly canvas: HTMLCanvasElement | null;

            /**
             * Force Phaser to use your own Canvas context instead of creating one.
             */
            readonly context: CanvasRenderingContext2D | WebGLRenderingContext | null;

            /**
             * Optional CSS attributes to be set on the canvas object created by the renderer.
             */
            readonly canvasStyle: string | null;

            /**
             * Is Phaser running under a custom (non-native web) environment? If so, set this to `true` to skip internal Feature detection. If `true` the `renderType` cannot be left as `AUTO`.
             */
            readonly customEnvironment: boolean;

            /**
             * The default Scene configuration object.
             */
            readonly sceneConfig: object | null;

            /**
             * A seed which the Random Data Generator will use. If not given, a dynamic seed based on the time is used.
             */
            readonly seed: string[];

            /**
             * The title of the game.
             */
            readonly gameTitle: string;

            /**
             * The URL of the game.
             */
            readonly gameURL: string;

            /**
             * The version of the game.
             */
            readonly gameVersion: string;

            /**
             * If `true` the window will automatically be given focus immediately and on any future mousedown event.
             */
            readonly autoFocus: boolean;

            /**
             * `false` or `0` = Use the built-in StableSort (needed for older browsers), `true` or `1` = Rely on ES2019 Array.sort being stable (modern browsers only), or `-1` = Try and determine this automatically based on browser inspection (not guaranteed to work, errs on side of caution).
             */
            readonly stableSort: number | boolean;

            /**
             * Should the game create a div element to act as a DOM Container? Only enable if you're using DOM Element objects. You must provide a parent object if you use this feature.
             */
            readonly domCreateContainer: boolean | null;

            /**
             * The default `pointerEvents` attribute set on the DOM Container.
             */
            readonly domPointerEvents: string | null;

            /**
             * Enable the Keyboard Plugin. This can be disabled in games that don't need keyboard input.
             */
            readonly inputKeyboard: boolean;

            /**
             * The DOM Target to listen for keyboard events on. Defaults to `window` if not specified.
             */
            readonly inputKeyboardEventTarget: any;

            /**
             * `preventDefault` will be called on every non-modified key which has a key code in this array. By default, it is empty.
             */
            readonly inputKeyboardCapture: number[] | null;

            /**
             * Enable the Mouse Plugin. This can be disabled in games that don't need mouse input.
             */
            readonly inputMouse: boolean | object;

            /**
             * The DOM Target to listen for mouse events on. Defaults to the game canvas if not specified.
             */
            readonly inputMouseEventTarget: any | null;

            /**
             * Should `mousedown` DOM events have `preventDefault` called on them?
             */
            readonly inputMousePreventDefaultDown: boolean;

            /**
             * Should `mouseup` DOM events have `preventDefault` called on them?
             */
            readonly inputMousePreventDefaultUp: boolean;

            /**
             * Should `mousemove` DOM events have `preventDefault` called on them?
             */
            readonly inputMousePreventDefaultMove: boolean;

            /**
             * Should `wheel` DOM events have `preventDefault` called on them?
             */
            readonly inputMousePreventDefaultWheel: boolean;

            /**
             * Enable the Touch Plugin. This can be disabled in games that don't need touch input.
             */
            readonly inputTouch: boolean;

            /**
             * The DOM Target to listen for touch events on. Defaults to the game canvas if not specified.
             */
            readonly inputTouchEventTarget: any | null;

            /**
             * Should touch events be captured? I.e. have prevent default called on them.
             */
            readonly inputTouchCapture: boolean;

            /**
             * The number of Pointer objects created by default. In a mouse-only, or non-multi touch game, you can leave this as 1.
             */
            readonly inputActivePointers: number;

            /**
             * The smoothing factor to apply during Pointer movement. See {@link Phaser.Input.Pointer#smoothFactor}.
             */
            readonly inputSmoothFactor: number;

            /**
             * Should Phaser listen for input events on the Window? If you disable this, events like 'POINTER_UP_OUTSIDE' will no longer fire.
             */
            readonly inputWindowEvents: boolean;

            /**
             * Enable the Gamepad Plugin. This can be disabled in games that don't need gamepad input.
             */
            readonly inputGamepad: boolean;

            /**
             * The DOM Target to listen for gamepad events on. Defaults to `window` if not specified.
             */
            readonly inputGamepadEventTarget: any;

            /**
             * Set to `true` to disable the right-click context menu.
             */
            readonly disableContextMenu: boolean;

            /**
             * The Audio Configuration object.
             */
            readonly audio: Phaser.Types.Core.AudioConfig;

            /**
             * Don't write the banner line to the console.log.
             */
            readonly hideBanner: boolean;

            /**
             * Omit Phaser's name and version from the banner.
             */
            readonly hidePhaser: boolean;

            /**
             * The color of the banner text.
             */
            readonly bannerTextColor: string;

            /**
             * The background colors of the banner.
             */
            readonly bannerBackgroundColor: string[];

            /**
             * The Frame Rate Configuration object, as parsed by the Timestep class.
             */
            readonly fps: Phaser.Types.Core.FPSConfig;

            /**
             * Disables the automatic creation of the Pre FX Pipelines. If disabled, you cannot use the built-in Pre FX on Game Objects.
             */
            readonly disablePreFX: boolean;

            /**
             * Disables the automatic creation of the Post FX Pipelines. If disabled, you cannot use the built-in Post FX on Game Objects.
             */
            readonly disablePostFX: boolean;

            /**
             * An object mapping WebGL names to WebGLPipeline classes. These should be class constructors, not instances.
             */
            readonly pipeline: Phaser.Types.Core.PipelineConfig;

            /**
             * Automatically enable the Mobile Pipeline if iOS or Android detected?
             */
            readonly autoMobilePipeline: boolean;

            /**
             * The WebGL Pipeline that Game Objects will use by default. Set to 'MultiPipeline' as standard. See also 'autoMobilePipeline'.
             */
            readonly defaultPipeline: string;

            /**
             * When set to `true`, WebGL uses linear interpolation to draw scaled or rotated textures, giving a smooth appearance. When set to `false`, WebGL uses nearest-neighbor interpolation, giving a crisper appearance. `false` also disables antialiasing of the game canvas itself, if the browser supports it, when the game canvas is scaled.
             */
            readonly antialias: boolean;

            /**
             * Sets the `antialias` property when the WebGL context is created. Setting this value does not impact any subsequent textures that are created, or the canvas style attributes.
             */
            readonly antialiasGL: boolean;

            /**
             * Sets the mipmap magFilter to be used when creating WebGL textures. Don't set unless you wish to create mipmaps. Set to one of the following: 'NEAREST', 'LINEAR', 'NEAREST_MIPMAP_NEAREST', 'LINEAR_MIPMAP_NEAREST', 'NEAREST_MIPMAP_LINEAR' or 'LINEAR_MIPMAP_LINEAR'.
             */
            readonly mipmapFilter: string;

            /**
             * When set to `true` it will create a desynchronized context for both 2D and WebGL. See https://developers.google.com/web/updates/2019/05/desynchronized for details.
             */
            readonly desynchronized: boolean;

            /**
             * Draw texture-based Game Objects at only whole-integer positions. Game Objects without textures, like Graphics, ignore this property.
             */
            readonly roundPixels: boolean;

            /**
             * Prevent pixel art from becoming blurred when scaled. It will remain crisp (tells the WebGL renderer to automatically create textures using a linear filter mode).
             */
            readonly pixelArt: boolean;

            /**
             * Whether the game canvas will have a transparent background.
             */
            readonly transparent: boolean;

            /**
             * Whether the game canvas will be cleared between each rendering frame. You can disable this if you have a full-screen background image or game object.
             */
            readonly clearBeforeRender: boolean;

            /**
             * If the value is true the WebGL buffers will not be cleared and will preserve their values until cleared or overwritten by the author.
             */
            readonly preserveDrawingBuffer: boolean;

            /**
             * In WebGL mode, sets the drawing buffer to contain colors with pre-multiplied alpha.
             */
            readonly premultipliedAlpha: boolean;

            /**
             * Let the browser abort creating a WebGL context if it judges performance would be unacceptable.
             */
            readonly failIfMajorPerformanceCaveat: boolean;

            /**
             * "high-performance", "low-power" or "default". A hint to the browser on how much device power the game might use.
             */
            readonly powerPreference: string;

            /**
             * The default WebGL Batch size. Represents the number of _quads_ that can be added to a single batch.
             */
            readonly batchSize: number;

            /**
             * When in WebGL mode, this sets the maximum number of GPU Textures to use. The default, -1, will use all available units. The WebGL1 spec says all browsers should provide a minimum of 8.
             */
            readonly maxTextures: number;

            /**
             * The maximum number of lights allowed to be visible within range of a single Camera in the LightManager.
             */
            readonly maxLights: number;

            /**
             * The background color of the game canvas. The default is black. This value is ignored if `transparent` is set to `true`.
             */
            readonly backgroundColor: Phaser.Display.Color;

            /**
             * Called before Phaser boots. Useful for initializing anything not related to Phaser that Phaser may require while booting.
             */
            readonly preBoot: Phaser.Types.Core.BootCallback;

            /**
             * A function to run at the end of the boot sequence. At this point, all the game systems have started and plugins have been loaded.
             */
            readonly postBoot: Phaser.Types.Core.BootCallback;

            /**
             * The Physics Configuration object.
             */
            readonly physics: Phaser.Types.Core.PhysicsConfig;

            /**
             * The default physics system. It will be started for each scene. Either 'arcade', 'impact' or 'matter'.
             */
            readonly defaultPhysicsSystem: boolean | string;

            /**
             * A URL used to resolve paths given to the loader. Example: 'http://labs.phaser.io/assets/'.
             */
            readonly loaderBaseURL: string;

            /**
             * A URL path used to resolve relative paths given to the loader. Example: 'images/sprites/'.
             */
            readonly loaderPath: string;

            /**
             * Maximum parallel downloads allowed for resources (Default to 32).
             */
            readonly loaderMaxParallelDownloads: number;

            /**
             * 'anonymous', 'use-credentials', or `undefined`. If you're not making cross-origin requests, leave this as `undefined`. See {@link https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes}.
             */
            readonly loaderCrossOrigin: string | undefined;

            /**
             * The response type of the XHR request, e.g. `blob`, `text`, etc.
             */
            readonly loaderResponseType: string;

            /**
             * Should the XHR request use async or not?
             */
            readonly loaderAsync: boolean;

            /**
             * Optional username for all XHR requests.
             */
            readonly loaderUser: string;

            /**
             * Optional password for all XHR requests.
             */
            readonly loaderPassword: string;

            /**
             * Optional XHR timeout value, in ms.
             */
            readonly loaderTimeout: number;

            /**
             * Optional XHR withCredentials value.
             */
            readonly loaderWithCredentials: boolean;

            /**
             * Optional load type for image, `XHR` is default, or `HTMLImageElement` for a lightweight way.
             */
            readonly loaderImageLoadType: string;

            /**
             * An array of schemes that the Loader considers as being 'local' files. Defaults to: `[ 'file://', 'capacitor://' ]`.
             */
            readonly loaderLocalScheme: string[];

            /**
             * The quality of the Glow FX (defaults to 0.1)
             */
            readonly glowFXQuality: number;

            /**
             * The distance of the Glow FX (defaults to 10)
             */
            readonly glowFXDistance: number;

            /**
             * An array of global plugins to be installed.
             */
            readonly installGlobalPlugins: any;

            /**
             * An array of Scene level plugins to be installed.
             */
            readonly installScenePlugins: any;

            /**
             * The plugins installed into every Scene (in addition to CoreScene and Global).
             */
            readonly defaultPlugins: any;

            /**
             * A base64 encoded PNG that will be used as the default blank texture.
             */
            readonly defaultImage: string;

            /**
             * A base64 encoded PNG that will be used as the default texture when a texture is assigned that is missing or not loaded.
             */
            readonly missingImage: string;

            /**
             * A base64 encoded PNG that will be used as the default texture when a texture is assigned that is white or not loaded.
             */
            readonly whiteImage: string;

        }

        /**
         * Called automatically by Phaser.Game and responsible for creating the renderer it will use.
         * 
         * Relies upon two webpack global flags to be defined: `WEBGL_RENDERER` and `CANVAS_RENDERER` during build time, but not at run-time.
         * @param game The Phaser.Game instance on which the renderer will be set.
         */
        function CreateRenderer(game: Phaser.Game): void;

        /**
         * Called automatically by Phaser.Game and responsible for creating the console.log debug header.
         * 
         * You can customize or disable the header via the Game Config object.
         * @param game The Phaser.Game instance which will output this debug header.
         */
        function DebugHeader(game: Phaser.Game): void;

        namespace Events {
            /**
             * The Game Blur Event.
             * 
             * This event is dispatched by the Game Visibility Handler when the window in which the Game instance is embedded
             * enters a blurred state. The blur event is raised when the window loses focus. This can happen if a user swaps
             * tab, or if they simply remove focus from the browser to another app.
             */
            const BLUR: string;

            /**
             * The Game Boot Event.
             * 
             * This event is dispatched when the Phaser Game instance has finished booting, but before it is ready to start running.
             * The global systems use this event to know when to set themselves up, dispatching their own `ready` events as required.
             */
            const BOOT: string;

            /**
             * The Game Context Lost Event.
             * 
             * This event is dispatched by the Game if the WebGL Renderer it is using encounters a WebGL Context Lost event from the browser.
             * 
             * The renderer halts all rendering and cannot resume after this happens.
             */
            const CONTEXT_LOST: string;

            /**
             * The Game Destroy Event.
             * 
             * This event is dispatched when the game instance has been told to destroy itself.
             * Lots of internal systems listen to this event in order to clear themselves out.
             * Custom plugins and game code should also do the same.
             */
            const DESTROY: string;

            /**
             * The Game Focus Event.
             * 
             * This event is dispatched by the Game Visibility Handler when the window in which the Game instance is embedded
             * enters a focused state. The focus event is raised when the window re-gains focus, having previously lost it.
             */
            const FOCUS: string;

            /**
             * The Game Hidden Event.
             * 
             * This event is dispatched by the Game Visibility Handler when the document in which the Game instance is embedded
             * enters a hidden state. Only browsers that support the Visibility API will cause this event to be emitted.
             * 
             * In most modern browsers, when the document enters a hidden state, the Request Animation Frame and setTimeout, which
             * control the main game loop, will automatically pause. There is no way to stop this from happening. It is something
             * your game should account for in its own code, should the pause be an issue (i.e. for multiplayer games)
             */
            const HIDDEN: string;

            /**
             * The Game Pause Event.
             * 
             * This event is dispatched when the Game loop enters a paused state, usually as a result of the Visibility Handler.
             */
            const PAUSE: string;

            /**
             * The Game Post-Render Event.
             * 
             * This event is dispatched right at the end of the render process.
             * 
             * Every Scene will have rendered and been drawn to the canvas by the time this event is fired.
             * Use it for any last minute post-processing before the next game step begins.
             */
            const POST_RENDER: string;

            /**
             * The Game Post-Step Event.
             * 
             * This event is dispatched after the Scene Manager has updated.
             * Hook into it from plugins or systems that need to do things before the render starts.
             */
            const POST_STEP: string;

            /**
             * The Game Pre-Render Event.
             * 
             * This event is dispatched immediately before any of the Scenes have started to render.
             * 
             * The renderer will already have been initialized this frame, clearing itself and preparing to receive the Scenes for rendering, but it won't have actually drawn anything yet.
             */
            const PRE_RENDER: string;

            /**
             * The Game Pre-Step Event.
             * 
             * This event is dispatched before the main Game Step starts. By this point in the game cycle none of the Scene updates have yet happened.
             * Hook into it from plugins or systems that need to update before the Scene Manager does.
             */
            const PRE_STEP: string;

            /**
             * The Game Ready Event.
             * 
             * This event is dispatched when the Phaser Game instance has finished booting, the Texture Manager is fully ready,
             * and all local systems are now able to start.
             */
            const READY: string;

            /**
             * The Game Resume Event.
             * 
             * This event is dispatched when the game loop leaves a paused state and resumes running.
             */
            const RESUME: string;

            /**
             * The Game Step Event.
             * 
             * This event is dispatched after the Game Pre-Step and before the Scene Manager steps.
             * Hook into it from plugins or systems that need to update before the Scene Manager does, but after the core Systems have.
             */
            const STEP: string;

            /**
             * This event is dispatched when the Scene Manager has created the System Scene,
             * which other plugins and systems may use to initialize themselves.
             * 
             * This event is dispatched just once by the Game instance.
             */
            const SYSTEM_READY: string;

            /**
             * The Game Visible Event.
             * 
             * This event is dispatched by the Game Visibility Handler when the document in which the Game instance is embedded
             * enters a visible state, previously having been hidden.
             * 
             * Only browsers that support the Visibility API will cause this event to be emitted.
             */
            const VISIBLE: string;

        }

        /**
         * The core runner class that Phaser uses to handle the game loop. It can use either Request Animation Frame,
         * or SetTimeout, based on browser support and config settings, to create a continuous loop within the browser.
         * 
         * Each time the loop fires, `TimeStep.step` is called and this is then passed onto the core Game update loop,
         * it is the core heartbeat of your game. It will fire as often as Request Animation Frame is capable of handling
         * on the target device.
         * 
         * Note that there are lots of situations where a browser will stop updating your game. Such as if the player
         * switches tabs, or covers up the browser window with another application. In these cases, the 'heartbeat'
         * of your game will pause, and only resume when focus is returned to it by the player. There is no way to avoid
         * this situation, all you can do is use the visibility events the browser, and Phaser, provide to detect when
         * it has happened and then gracefully recover.
         */
        class TimeStep {
            /**
             * 
             * @param game A reference to the Phaser.Game instance that owns this Time Step.
             */
            constructor(game: Phaser.Game, config: Phaser.Types.Core.FPSConfig);

            /**
             * A reference to the Phaser.Game instance.
             */
            readonly game: Phaser.Game;

            /**
             * The Request Animation Frame DOM Event handler.
             */
            readonly raf: Phaser.DOM.RequestAnimationFrame;

            /**
             * A flag that is set once the TimeStep has started running and toggled when it stops.
             */
            readonly started: boolean;

            /**
             * A flag that is set once the TimeStep has started running and toggled when it stops.
             * The difference between this value and `started` is that `running` is toggled when
             * the TimeStep is sent to sleep, where-as `started` remains `true`, only changing if
             * the TimeStep is actually stopped, not just paused.
             */
            readonly running: boolean;

            /**
             * The minimum fps rate you want the Time Step to run at.
             * 
             * Setting this cannot guarantee the browser runs at this rate, it merely influences
             * the internal timing values to help the Timestep know when it has gone out of sync.
             */
            minFps: number;

            /**
             * The target fps rate for the Time Step to run at.
             * 
             * Setting this value will not actually change the speed at which the browser runs, that is beyond
             * the control of Phaser. Instead, it allows you to determine performance issues and if the Time Step
             * is spiraling out of control.
             */
            targetFps: number;

            /**
             * Enforce a frame rate limit. This forces how often the Game step will run. By default it is zero,
             * which means it will run at whatever limit the browser (via RequestAnimationFrame) can handle, which
             * is the optimum rate for fast-action or responsive games.
             * 
             * However, if you are building a non-game app, like a graphics generator, or low-intensity game that doesn't
             * require 60fps, then you can lower the step rate via this Game Config value:
             * 
             * ```js
             * fps: {
             *   limit: 30
             * }
             * ```
             * 
             * Setting this _beyond_ the rate of RequestAnimationFrame will make no difference at all.
             * 
             * Use it purely to _restrict_ updates in low-intensity situations only.
             */
            fpsLimit: number;

            /**
             * Is the FPS rate limited?
             * 
             * This is set by setting the Game Config `limit` value to a value above zero.
             * 
             * Consider this property as read-only.
             */
            hasFpsLimit: boolean;

            /**
             * An exponential moving average of the frames per second.
             */
            readonly actualFps: number;

            /**
             * The time at which the next fps rate update will take place.
             * 
             * When an fps update happens, the `framesThisSecond` value is reset.
             */
            readonly nextFpsUpdate: number;

            /**
             * The number of frames processed this second.
             */
            readonly framesThisSecond: number;

            /**
             * A callback to be invoked each time the TimeStep steps.
             */
            callback: Phaser.Types.Core.TimeStepCallback;

            /**
             * You can force the TimeStep to use SetTimeOut instead of Request Animation Frame by setting
             * the `forceSetTimeOut` property to `true` in the Game Configuration object. It cannot be changed at run-time.
             */
            readonly forceSetTimeOut: boolean;

            /**
             * The time, updated each step by adding the elapsed delta time to the previous value.
             * 
             * This differs from the `TimeStep.now` value, which is the high resolution time value
             * as provided by Request Animation Frame.
             */
            time: number;

            /**
             * The time at which the game started running.
             * 
             * This value is adjusted if the game is then paused and resumes.
             */
            startTime: number;

            /**
             * The time of the previous step.
             * 
             * This is typically a high resolution timer value, as provided by Request Animation Frame.
             */
            lastTime: number;

            /**
             * The current frame the game is on. This counter is incremented once every game step, regardless of how much
             * time has passed and is unaffected by delta smoothing.
             */
            readonly frame: number;

            /**
             * Is the browser currently considered in focus by the Page Visibility API?
             * 
             * This value is set in the `blur` method, which is called automatically by the Game instance.
             */
            readonly inFocus: boolean;

            /**
             * The delta time, in ms, since the last game step. This is a clamped and smoothed average value.
             */
            delta: number;

            /**
             * Internal index of the delta history position.
             */
            deltaIndex: number;

            /**
             * Internal array holding the previous delta values, used for delta smoothing.
             */
            deltaHistory: number[];

            /**
             * The maximum number of delta values that are retained in order to calculate a smoothed moving average.
             * 
             * This can be changed in the Game Config via the `fps.deltaHistory` property. The default is 10.
             */
            deltaSmoothingMax: number;

            /**
             * The number of frames that the cooldown is set to after the browser panics over the FPS rate, usually
             * as a result of switching tabs and regaining focus.
             * 
             * This can be changed in the Game Config via the `fps.panicMax` property. The default is 120.
             */
            panicMax: number;

            /**
             * The actual elapsed time in ms between one update and the next.
             * 
             * Unlike with `delta`, no smoothing, capping, or averaging is applied to this value.
             * So please be careful when using this value in math calculations.
             */
            rawDelta: number;

            /**
             * The time, set at the start of the current step.
             * 
             * This is typically a high resolution timer value, as provided by Request Animation Frame.
             * 
             * This can differ from the `time` value in that it isn't calculated based on the delta value.
             */
            now: number;

            /**
             * Apply smoothing to the delta value used within Phasers internal calculations?
             * 
             * This can be changed in the Game Config via the `fps.smoothStep` property. The default is `true`.
             * 
             * Smoothing helps settle down the delta values after browser tab switches, or other situations
             * which could cause significant delta spikes or dips. By default it has been enabled in Phaser 3
             * since the first version, but is now exposed under this property (and the corresponding game config
             * `smoothStep` value), to allow you to easily disable it, should you require.
             */
            smoothStep: boolean;

            /**
             * Called by the Game instance when the DOM window.onBlur event triggers.
             */
            blur(): void;

            /**
             * Called by the Game instance when the DOM window.onFocus event triggers.
             */
            focus(): void;

            /**
             * Called when the visibility API says the game is 'hidden' (tab switch out of view, etc)
             */
            pause(): void;

            /**
             * Called when the visibility API says the game is 'visible' again (tab switch back into view, etc)
             */
            resume(): void;

            /**
             * Resets the time, lastTime, fps averages and delta history.
             * Called automatically when a browser sleeps them resumes.
             */
            resetDelta(): void;

            /**
             * Starts the Time Step running, if it is not already doing so.
             * Called automatically by the Game Boot process.
             * @param callback The callback to be invoked each time the Time Step steps.
             */
            start(callback: Phaser.Types.Core.TimeStepCallback): void;

            /**
             * Takes the delta value and smooths it based on the previous frames.
             * 
             * Called automatically as part of the step.
             * @param delta The delta value for this step.
             */
            smoothDelta(delta: number): number;

            /**
             * Update the estimate of the frame rate, `fps`. Every second, the number
             * of frames that occurred in that second are included in an exponential
             * moving average of all frames per second, with an alpha of 0.25. This
             * means that more recent seconds affect the estimated frame rate more than
             * older seconds.
             * 
             * When a browser window is NOT minimized, but is covered up (i.e. you're using
             * another app which has spawned a window over the top of the browser), then it
             * will start to throttle the raf callback time. It waits for a while, and then
             * starts to drop the frame rate at 1 frame per second until it's down to just over 1fps.
             * So if the game was running at 60fps, and the player opens a new window, then
             * after 60 seconds (+ the 'buffer time') it'll be down to 1fps, so rafin'g at 1Hz.
             * 
             * When they make the game visible again, the frame rate is increased at a rate of
             * approx. 8fps, back up to 60fps (or the max it can obtain)
             * 
             * There is no easy way to determine if this drop in frame rate is because the
             * browser is throttling raf, or because the game is struggling with performance
             * because you're asking it to do too much on the device.
             * 
             * Compute the new exponential moving average with an alpha of 0.25.
             * @param time The timestamp passed in from RequestAnimationFrame or setTimeout.
             */
            updateFPS(time: number): void;

            /**
             * The main step method with an fps limiter. This is called each time the browser updates, either by Request Animation Frame,
             * or by Set Timeout. It is responsible for calculating the delta values, frame totals, cool down history and more.
             * You generally should never call this method directly.
             * @param time The timestamp passed in from RequestAnimationFrame or setTimeout.
             */
            stepLimitFPS(time: number): void;

            /**
             * The main step method. This is called each time the browser updates, either by Request Animation Frame,
             * or by Set Timeout. It is responsible for calculating the delta values, frame totals, cool down history and more.
             * You generally should never call this method directly.
             * @param time The timestamp passed in from RequestAnimationFrame or setTimeout.
             */
            step(time: number): void;

            /**
             * Manually calls `TimeStep.step`.
             */
            tick(): void;

            /**
             * Sends the TimeStep to sleep, stopping Request Animation Frame (or SetTimeout) and toggling the `running` flag to false.
             */
            sleep(): void;

            /**
             * Wakes-up the TimeStep, restarting Request Animation Frame (or SetTimeout) and toggling the `running` flag to true.
             * The `seamless` argument controls if the wake-up should adjust the start time or not.
             * @param seamless Adjust the startTime based on the lastTime values. Default false.
             */
            wake(seamless?: boolean): void;

            /**
             * Gets the duration which the game has been running, in seconds.
             */
            getDuration(): number;

            /**
             * Gets the duration which the game has been running, in ms.
             */
            getDurationMS(): number;

            /**
             * Stops the TimeStep running.
             */
            stop(): this;

            /**
             * Destroys the TimeStep. This will stop Request Animation Frame, stop the step, clear the callbacks and null
             * any objects.
             */
            destroy(): void;

        }

        /**
         * The Visibility Handler is responsible for listening out for document level visibility change events.
         * This includes `visibilitychange` if the browser supports it, and blur and focus events. It then uses
         * the provided Event Emitter and fires the related events.
         * @param game The Game instance this Visibility Handler is working on.
         */
        function VisibilityHandler(game: Phaser.Game): void;

    }

    namespace Create {
        /**
         * Generates a texture based on the given Create configuration object.
         * 
         * The texture is drawn using a fixed-size indexed palette of 16 colors, where the hex value in the
         * data cells map to a single color. For example, if the texture config looked like this:
         * 
         * ```javascript
         * var star = [
         *   '.....828.....',
         *   '....72227....',
         *   '....82228....',
         *   '...7222227...',
         *   '2222222222222',
         *   '8222222222228',
         *   '.72222222227.',
         *   '..787777787..',
         *   '..877777778..',
         *   '.78778887787.',
         *   '.27887.78872.',
         *   '.787.....787.'
         * ];
         * 
         * this.textures.generate('star', { data: star, pixelWidth: 4 });
         * ```
         * 
         * Then it would generate a texture that is 52 x 48 pixels in size, because each cell of the data array
         * represents 1 pixel multiplied by the `pixelWidth` value. The cell values, such as `8`, maps to color
         * number 8 in the palette. If a cell contains a period character `.` then it is transparent.
         * 
         * The default palette is Arne16, but you can specify your own using the `palette` property.
         * @param config The Generate Texture Configuration object.
         */
        function GenerateTexture(config: Phaser.Types.Create.GenerateTextureConfig): HTMLCanvasElement;

        namespace Palettes {
            /**
             * A 16 color palette by [Arne](http://androidarts.com/palette/16pal.htm)
             */
            var ARNE16: Phaser.Types.Create.Palette;

            /**
             * A 16 color palette inspired by the Commodore 64.
             */
            var C64: Phaser.Types.Create.Palette;

            /**
             * A 16 color CGA inspired palette by [Arne](http://androidarts.com/palette/16pal.htm)
             */
            var CGA: Phaser.Types.Create.Palette;

            /**
             * A 16 color JMP palette by [Arne](http://androidarts.com/palette/16pal.htm)
             */
            var JMP: Phaser.Types.Create.Palette;

            /**
             * A 16 color palette inspired by Japanese computers like the MSX.
             */
            var MSX: Phaser.Types.Create.Palette;

        }

    }

    namespace Curves {
        /**
         * A higher-order Bézier curve constructed of four points.
         */
        class CubicBezier extends Phaser.Curves.Curve {
            /**
             * 
             * @param p0 Start point, or an array of point pairs.
             * @param p1 Control Point 1.
             * @param p2 Control Point 2.
             * @param p3 End Point.
             */
            constructor(p0: Phaser.Math.Vector2 | Phaser.Math.Vector2[], p1: Phaser.Math.Vector2, p2: Phaser.Math.Vector2, p3: Phaser.Math.Vector2);

            /**
             * The start point of this curve.
             */
            p0: Phaser.Math.Vector2;

            /**
             * The first control point of this curve.
             */
            p1: Phaser.Math.Vector2;

            /**
             * The second control point of this curve.
             */
            p2: Phaser.Math.Vector2;

            /**
             * The end point of this curve.
             */
            p3: Phaser.Math.Vector2;

            /**
             * Gets the starting point on the curve.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Returns the resolution of this curve.
             * @param divisions The amount of divisions used by this curve.
             */
            getResolution(divisions: number): number;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Draws this curve to the specified graphics object.
             * @param graphics The graphics object this curve should be drawn to.
             * @param pointsTotal The number of intermediary points that make up this curve. A higher number of points will result in a smoother curve. Default 32.
             */
            draw<G extends Phaser.GameObjects.Graphics>(graphics: G, pointsTotal?: number): G;

            /**
             * Returns a JSON object that describes this curve.
             */
            toJSON(): Phaser.Types.Curves.JSONCurve;

            /**
             * Generates a curve from a JSON object.
             * @param data The JSON object containing this curve data.
             */
            static fromJSON(data: Phaser.Types.Curves.JSONCurve): Phaser.Curves.CubicBezier;

        }

        /**
         * A Base Curve class, which all other curve types extend.
         * 
         * Based on the three.js Curve classes created by [zz85](http://www.lab4games.net/zz85/blog)
         */
        class Curve {
            /**
             * 
             * @param type The curve type.
             */
            constructor(type: string);

            /**
             * String based identifier for the type of curve.
             */
            type: string;

            /**
             * The default number of divisions within the curve.
             */
            defaultDivisions: number;

            /**
             * The quantity of arc length divisions within the curve.
             */
            arcLengthDivisions: number;

            /**
             * An array of cached arc length values.
             */
            cacheArcLengths: number[];

            /**
             * Does the data of this curve need updating?
             */
            needsUpdate: boolean;

            /**
             * For a curve on a Path, `false` means the Path will ignore this curve.
             */
            active: boolean;

            /**
             * Draws this curve on the given Graphics object.
             * 
             * The curve is drawn using `Graphics.strokePoints` so will be drawn at whatever the present Graphics stroke color is.
             * The Graphics object is not cleared before the draw, so the curve will appear on-top of anything else already rendered to it.
             * @param graphics The Graphics instance onto which this curve will be drawn.
             * @param pointsTotal The resolution of the curve. The higher the value the smoother it will render, at the cost of rendering performance. Default 32.
             */
            draw<G extends Phaser.GameObjects.Graphics>(graphics: G, pointsTotal?: number): G;

            /**
             * Returns a Rectangle where the position and dimensions match the bounds of this Curve.
             * 
             * You can control the accuracy of the bounds. The value given is used to work out how many points
             * to plot across the curve. Higher values are more accurate at the cost of calculation speed.
             * @param out The Rectangle to store the bounds in. If falsey a new object will be created.
             * @param accuracy The accuracy of the bounds calculations. Default 16.
             */
            getBounds(out?: Phaser.Geom.Rectangle, accuracy?: number): Phaser.Geom.Rectangle;

            /**
             * Returns an array of points, spaced out X distance pixels apart.
             * The smaller the distance, the larger the array will be.
             * @param distance The distance, in pixels, between each point along the curve.
             */
            getDistancePoints(distance: number): Phaser.Geom.Point[];

            /**
             * Get a point at the end of the curve.
             * @param out Optional Vector object to store the result in.
             */
            getEndPoint(out?: Phaser.Math.Vector2): Phaser.Math.Vector2;

            /**
             * Get total curve arc length
             */
            getLength(): number;

            /**
             * Get a list of cumulative segment lengths.
             * 
             * These lengths are
             * 
             * - [0] 0
             * - [1] The first segment
             * - [2] The first and second segment
             * - ...
             * - [divisions] All segments
             * @param divisions The number of divisions or segments.
             */
            getLengths(divisions?: number): number[];

            /**
             * Get a point at a relative position on the curve, by arc length.
             * @param u The relative position, [0..1].
             * @param out A point to store the result in.
             */
            getPointAt<O extends Phaser.Math.Vector2>(u: number, out?: O): O;

            /**
             * Get a sequence of evenly spaced points from the curve.
             * 
             * You can pass `divisions`, `stepRate`, or neither.
             * 
             * The number of divisions will be
             * 
             * 1. `divisions`, if `divisions` > 0; or
             * 2. `this.getLength / stepRate`, if `stepRate` > 0; or
             * 3. `this.defaultDivisions`
             * 
             * `1 + divisions` points will be returned.
             * @param divisions The number of divisions to make.
             * @param stepRate The curve distance between points, implying `divisions`.
             * @param out An optional array to store the points in.
             */
            getPoints<O extends Phaser.Math.Vector2[]>(divisions?: number, stepRate?: number, out?: O): O;

            /**
             * Get a random point from the curve.
             * @param out A point object to store the result in.
             */
            getRandomPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Get a sequence of equally spaced points (by arc distance) from the curve.
             * 
             * `1 + divisions` points will be returned.
             * @param divisions The number of divisions to make. Default this.defaultDivisions.
             * @param stepRate Step between points. Used to calculate the number of points to return when divisions is falsy. Ignored if divisions is positive.
             * @param out An optional array to store the points in.
             */
            getSpacedPoints(divisions?: number, stepRate?: number, out?: any[] | Phaser.Math.Vector2[]): Phaser.Math.Vector2[];

            /**
             * Get a point at the start of the curve.
             * @param out A point to store the result in.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Get a unit vector tangent at a relative position on the curve.
             * In case any sub curve does not implement its tangent derivation,
             * 2 points a small delta apart will be used to find its gradient
             * which seems to give a reasonable approximation
             * @param t The relative position on the curve, [0..1].
             * @param out A vector to store the result in.
             */
            getTangent<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Get a unit vector tangent at a relative position on the curve, by arc length.
             * @param u The relative position on the curve, [0..1].
             * @param out A vector to store the result in.
             */
            getTangentAt<O extends Phaser.Math.Vector2>(u: number, out?: O): O;

            /**
             * Given a distance in pixels, get a t to find p.
             * @param distance The distance, in pixels.
             * @param divisions Optional amount of divisions.
             */
            getTFromDistance(distance: number, divisions?: number): number;

            /**
             * Given u ( 0 .. 1 ), get a t to find p. This gives you points which are equidistant.
             * @param u A float between 0 and 1.
             * @param distance The distance, in pixels.
             * @param divisions Optional amount of divisions.
             */
            getUtoTmapping(u: number, distance: number, divisions?: number): number;

            /**
             * Calculate and cache the arc lengths.
             */
            updateArcLengths(): void;

        }

        /**
         * An Elliptical Curve derived from the Base Curve class.
         * 
         * See https://en.wikipedia.org/wiki/Elliptic_curve for more details.
         */
        class Ellipse extends Phaser.Curves.Curve {
            /**
             * 
             * @param x The x coordinate of the ellipse, or an Ellipse Curve configuration object. Default 0.
             * @param y The y coordinate of the ellipse. Default 0.
             * @param xRadius The horizontal radius of ellipse. Default 0.
             * @param yRadius The vertical radius of ellipse. Default 0.
             * @param startAngle The start angle of the ellipse, in degrees. Default 0.
             * @param endAngle The end angle of the ellipse, in degrees. Default 360.
             * @param clockwise Whether the ellipse angles are given as clockwise (`true`) or counter-clockwise (`false`). Default false.
             * @param rotation The rotation of the ellipse, in degrees. Default 0.
             */
            constructor(x?: number | Phaser.Types.Curves.EllipseCurveConfig, y?: number, xRadius?: number, yRadius?: number, startAngle?: number, endAngle?: number, clockwise?: boolean, rotation?: number);

            /**
             * The center point of the ellipse. Used for calculating rotation.
             */
            p0: Phaser.Math.Vector2;

            /**
             * Gets the starting point on the curve.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Get the resolution of the curve.
             * @param divisions Optional divisions value.
             */
            getResolution(divisions: number): number;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Sets the horizontal radius of this curve.
             * @param value The horizontal radius of this curve.
             */
            setXRadius(value: number): this;

            /**
             * Sets the vertical radius of this curve.
             * @param value The vertical radius of this curve.
             */
            setYRadius(value: number): this;

            /**
             * Sets the width of this curve.
             * @param value The width of this curve.
             */
            setWidth(value: number): this;

            /**
             * Sets the height of this curve.
             * @param value The height of this curve.
             */
            setHeight(value: number): this;

            /**
             * Sets the start angle of this curve.
             * @param value The start angle of this curve, in radians.
             */
            setStartAngle(value: number): this;

            /**
             * Sets the end angle of this curve.
             * @param value The end angle of this curve, in radians.
             */
            setEndAngle(value: number): this;

            /**
             * Sets if this curve extends clockwise or anti-clockwise.
             * @param value The clockwise state of this curve.
             */
            setClockwise(value: boolean): this;

            /**
             * Sets the rotation of this curve.
             * @param value The rotation of this curve, in radians.
             */
            setRotation(value: number): this;

            /**
             * The x coordinate of the center of the ellipse.
             */
            x: number;

            /**
             * The y coordinate of the center of the ellipse.
             */
            y: number;

            /**
             * The horizontal radius of the ellipse.
             */
            xRadius: number;

            /**
             * The vertical radius of the ellipse.
             */
            yRadius: number;

            /**
             * The start angle of the ellipse in degrees.
             */
            startAngle: number;

            /**
             * The end angle of the ellipse in degrees.
             */
            endAngle: number;

            /**
             * `true` if the ellipse rotation is clockwise or `false` if anti-clockwise.
             */
            clockwise: boolean;

            /**
             * The rotation of the ellipse, relative to the center, in degrees.
             */
            angle: number;

            /**
             * The rotation of the ellipse, relative to the center, in radians.
             */
            rotation: number;

            /**
             * JSON serialization of the curve.
             */
            toJSON(): Phaser.Types.Curves.JSONEllipseCurve;

            /**
             * Creates a curve from the provided Ellipse Curve Configuration object.
             * @param data The JSON object containing this curve data.
             */
            static fromJSON(data: Phaser.Types.Curves.JSONEllipseCurve): Phaser.Curves.Ellipse;

        }

        /**
         * A LineCurve is a "curve" comprising exactly two points (a line segment).
         */
        class Line extends Phaser.Curves.Curve {
            /**
             * 
             * @param p0 The first endpoint.
             * @param p1 The second endpoint.
             */
            constructor(p0: Phaser.Math.Vector2 | number[], p1?: Phaser.Math.Vector2);

            /**
             * The first endpoint.
             */
            p0: Phaser.Math.Vector2;

            /**
             * The second endpoint.
             */
            p1: Phaser.Math.Vector2;

            /**
             * The quantity of arc length divisions within the curve.
             */
            arcLengthDivisions: number;

            /**
             * Returns a Rectangle where the position and dimensions match the bounds of this Curve.
             * @param out A Rectangle object to store the bounds in. If not given a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(out?: O): O;

            /**
             * Gets the starting point on the curve.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Gets the resolution of the line.
             * @param divisions The number of divisions to consider. Default 1.
             */
            getResolution(divisions?: number): number;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Gets a point at a given position on the line.
             * @param u The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPointAt<O extends Phaser.Math.Vector2>(u: number, out?: O): O;

            /**
             * Gets the slope of the line as a unit vector.
             * @param t The relative position on the line, [0..1].
             * @param out A vector to store the result in.
             */
            getTangent<O extends Phaser.Math.Vector2>(t?: number, out?: O): O;

            /**
             * Given u ( 0 .. 1 ), get a t to find p. This gives you points which are equidistant.
             * @param u A float between 0 and 1.
             * @param distance The distance, in pixels.
             * @param divisions Optional amount of divisions.
             */
            getUtoTmapping(u: number, distance: number, divisions?: number): number;

            /**
             * Draws this curve on the given Graphics object.
             * 
             * The curve is drawn using `Graphics.lineBetween` so will be drawn at whatever the present Graphics line color is.
             * The Graphics object is not cleared before the draw, so the curve will appear on-top of anything else already rendered to it.
             * @param graphics The Graphics instance onto which this curve will be drawn.
             */
            draw<G extends Phaser.GameObjects.Graphics>(graphics: G): G;

            /**
             * Gets a JSON representation of the line.
             */
            toJSON(): Phaser.Types.Curves.JSONCurve;

            /**
             * Configures this line from a JSON representation.
             * @param data The JSON object containing this curve data.
             */
            static fromJSON(data: Phaser.Types.Curves.JSONCurve): Phaser.Curves.Line;

        }

        /**
         * A MoveTo Curve is a very simple curve consisting of only a single point.
         * Its intended use is to move the ending point in a Path.
         */
        class MoveTo {
            /**
             * 
             * @param x `x` pixel coordinate. Default 0.
             * @param y `y` pixel coordinate. Default 0.
             */
            constructor(x?: number, y?: number);

            /**
             * Denotes that this Curve does not influence the bounds, points, and drawing of its parent Path. Must be `false` or some methods in the parent Path will throw errors.
             */
            active: boolean;

            /**
             * The lone point which this curve consists of.
             */
            p0: Phaser.Math.Vector2;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Retrieves the point at given position in the curve. This will always return this curve's only point.
             * @param u The position in the path to retrieve, between 0 and 1. Not used.
             * @param out An optional vector in which to store the point.
             */
            getPointAt<O extends Phaser.Math.Vector2>(u: number, out?: O): O;

            /**
             * Gets the resolution of this curve.
             */
            getResolution(): number;

            /**
             * Gets the length of this curve.
             */
            getLength(): number;

            /**
             * Converts this curve into a JSON-serializable object.
             */
            toJSON(): Phaser.Types.Curves.JSONCurve;

        }

        /**
         * A Path combines multiple Curves into one continuous compound curve.
         * It does not matter how many Curves are in the Path or what type they are.
         * 
         * A Curve in a Path does not have to start where the previous Curve ends - that is to say, a Path does not
         * have to be an uninterrupted curve. Only the order of the Curves influences the actual points on the Path.
         */
        class Path {
            /**
             * 
             * @param x The X coordinate of the Path's starting point or a {@link Phaser.Types.Curves.JSONPath}. Default 0.
             * @param y The Y coordinate of the Path's starting point. Default 0.
             */
            constructor(x?: number, y?: number);

            /**
             * The name of this Path.
             * Empty by default and never populated by Phaser, this is left for developers to use.
             */
            name: string;

            /**
             * The default number of divisions within a curve.
             */
            defaultDivisions: number;

            /**
             * The list of Curves which make up this Path.
             */
            curves: Phaser.Curves.Curve[];

            /**
             * The cached length of each Curve in the Path.
             * 
             * Used internally by {@link #getCurveLengths}.
             */
            cacheLengths: number[];

            /**
             * Automatically closes the path.
             */
            autoClose: boolean;

            /**
             * The starting point of the Path.
             * 
             * This is not necessarily equivalent to the starting point of the first Curve in the Path. In an empty Path, it's also treated as the ending point.
             */
            startPoint: Phaser.Math.Vector2;

            /**
             * Appends a Curve to the end of the Path.
             * 
             * The Curve does not have to start where the Path ends or, for an empty Path, at its defined starting point.
             * @param curve The Curve to append.
             */
            add(curve: Phaser.Curves.Curve): this;

            /**
             * Creates a circular Ellipse Curve positioned at the end of the Path.
             * @param radius The radius of the circle.
             * @param clockwise `true` to create a clockwise circle as opposed to a counter-clockwise circle. Default false.
             * @param rotation The rotation of the circle in degrees. Default 0.
             */
            circleTo(radius: number, clockwise?: boolean, rotation?: number): this;

            /**
             * Ensures that the Path is closed.
             * 
             * A closed Path starts and ends at the same point. If the Path is not closed, a straight Line Curve will be created from the ending point directly to the starting point. During the check, the actual starting point of the Path, i.e. the starting point of the first Curve, will be used as opposed to the Path's defined {@link startPoint}, which could differ.
             * 
             * Calling this method on an empty Path will result in an error.
             */
            closePath(): this;

            /**
             * Creates a cubic bezier curve starting at the previous end point and ending at p3, using p1 and p2 as control points.
             * @param x The x coordinate of the end point. Or, if a Vector2, the p1 value.
             * @param y The y coordinate of the end point. Or, if a Vector2, the p2 value.
             * @param control1X The x coordinate of the first control point. Or, if a Vector2, the p3 value.
             * @param control1Y The y coordinate of the first control point. Not used if Vector2s are provided as the first 3 arguments.
             * @param control2X The x coordinate of the second control point. Not used if Vector2s are provided as the first 3 arguments.
             * @param control2Y The y coordinate of the second control point. Not used if Vector2s are provided as the first 3 arguments.
             */
            cubicBezierTo(x: number | Phaser.Math.Vector2, y: number | Phaser.Math.Vector2, control1X: number | Phaser.Math.Vector2, control1Y?: number, control2X?: number, control2Y?: number): this;

            /**
             * Creates a Quadratic Bezier Curve starting at the ending point of the Path.
             * @param x The X coordinate of the second control point or, if it's a `Vector2`, the first control point.
             * @param y The Y coordinate of the second control point or, if `x` is a `Vector2`, the second control point.
             * @param controlX If `x` is not a `Vector2`, the X coordinate of the first control point.
             * @param controlY If `x` is not a `Vector2`, the Y coordinate of the first control point.
             */
            quadraticBezierTo(x: number | Phaser.Math.Vector2[], y?: number, controlX?: number, controlY?: number): this;

            /**
             * Draws all Curves in the Path to a Graphics Game Object.
             * @param graphics The Graphics Game Object to draw to.
             * @param pointsTotal The number of points to draw for each Curve. Higher numbers result in a smoother curve but require more processing. Default 32.
             */
            draw<G extends Phaser.GameObjects.Graphics>(graphics: Phaser.GameObjects.Graphics, pointsTotal?: number): G;

            /**
             * Creates an ellipse curve positioned at the previous end point, using the given parameters.
             * @param xRadius The horizontal radius of ellipse. Default 0.
             * @param yRadius The vertical radius of ellipse. Default 0.
             * @param startAngle The start angle of the ellipse, in degrees. Default 0.
             * @param endAngle The end angle of the ellipse, in degrees. Default 360.
             * @param clockwise Whether the ellipse angles are given as clockwise (`true`) or counter-clockwise (`false`). Default false.
             * @param rotation The rotation of the ellipse, in degrees. Default 0.
             */
            ellipseTo(xRadius?: number, yRadius?: number, startAngle?: number, endAngle?: number, clockwise?: boolean, rotation?: number): this;

            /**
             * Creates a Path from a Path Configuration object.
             * 
             * The provided object should be a {@link Phaser.Types.Curves.JSONPath}, as returned by {@link #toJSON}. Providing a malformed object may cause errors.
             * @param data The JSON object containing the Path data.
             */
            fromJSON(data: Phaser.Types.Curves.JSONPath): this;

            /**
             * Returns a Rectangle with a position and size matching the bounds of this Path.
             * @param out The Rectangle to store the bounds in.
             * @param accuracy The accuracy of the bounds calculations. Higher values are more accurate at the cost of calculation speed. Default 16.
             */
            getBounds<O extends Phaser.Math.Vector2>(out?: O, accuracy?: number): O;

            /**
             * Returns an array containing the length of the Path at the end of each Curve.
             * 
             * The result of this method will be cached to avoid recalculating it in subsequent calls. The cache is only invalidated when the {@link #curves} array changes in length, leading to potential inaccuracies if a Curve in the Path is changed, or if a Curve is removed and another is added in its place.
             */
            getCurveLengths(): number[];

            /**
             * Returns the Curve that forms the Path at the given normalized location (between 0 and 1).
             * @param t The normalized location on the Path, between 0 and 1.
             */
            getCurveAt(t: number): Phaser.Curves.Curve | null;

            /**
             * Returns the ending point of the Path.
             * 
             * A Path's ending point is equivalent to the ending point of the last Curve in the Path. For an empty Path, the ending point is at the Path's defined {@link #startPoint}.
             * @param out The object to store the point in.
             */
            getEndPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Returns the total length of the Path.
             */
            getLength(): number;

            /**
             * Calculates the coordinates of the point at the given normalized location (between 0 and 1) on the Path.
             * 
             * The location is relative to the entire Path, not to an individual Curve. A location of 0.5 is always in the middle of the Path and is thus an equal distance away from both its starting and ending points. In a Path with one Curve, it would be in the middle of the Curve; in a Path with two Curves, it could be anywhere on either one of them depending on their lengths.
             * @param t The location of the point to return, between 0 and 1.
             * @param out The object in which to store the calculated point.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Get a sequence of points on the path.
             * @param divisions The number of divisions to make per resolution per curve.
             * @param stepRate The curve distance between points per curve, implying `divisions`.
             */
            getPoints(divisions?: number, stepRate?: number): Phaser.Math.Vector2[];

            /**
             * Returns a randomly chosen point anywhere on the path. This follows the same rules as `getPoint` in that it may return a point on any Curve inside this path.
             * 
             * When calling this method multiple times, the points are not guaranteed to be equally spaced spatially.
             * @param out `Vector2` instance that should be used for storing the result. If `undefined` a new `Vector2` will be created.
             */
            getRandomPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Divides this Path into a set of equally spaced points,
             * 
             * The resulting points are equally spaced with respect to the points' position on the path, but not necessarily equally spaced spatially.
             * @param divisions The amount of points to divide this Path into. Default 40.
             */
            getSpacedPoints(divisions?: number): Phaser.Math.Vector2[];

            /**
             * Returns the starting point of the Path.
             * @param out `Vector2` instance that should be used for storing the result. If `undefined` a new `Vector2` will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Gets a unit vector tangent at a relative position on the path.
             * @param t The relative position on the path, [0..1].
             * @param out A vector to store the result in.
             */
            getTangent<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Creates a line curve from the previous end point to x/y.
             * @param x The X coordinate of the line's end point, or a `Vector2` containing the entire end point.
             * @param y The Y coordinate of the line's end point, if a number was passed as the X parameter.
             */
            lineTo(x: number | Phaser.Math.Vector2, y?: number): this;

            /**
             * Creates a spline curve starting at the previous end point, using the given points on the curve.
             * @param points The points the newly created spline curve should consist of.
             */
            splineTo(points: Phaser.Math.Vector2[]): this;

            /**
             * Creates a "gap" in this path from the path's current end point to the given coordinates.
             * 
             * After calling this function, this Path's end point will be equal to the given coordinates
             * @param x The X coordinate of the position to move the path's end point to, or a `Vector2` containing the entire new end point.
             * @param y The Y coordinate of the position to move the path's end point to, if a number was passed as the X coordinate.
             */
            moveTo(x: number | Phaser.Math.Vector2, y?: number): this;

            /**
             * Converts this Path to a JSON object containing the path information and its constituent curves.
             */
            toJSON(): Phaser.Types.Curves.JSONPath;

            /**
             * cacheLengths must be recalculated.
             */
            updateArcLengths(): void;

            /**
             * Disposes of this Path, clearing its internal references to objects so they can be garbage-collected.
             */
            destroy(): void;

        }

        /**
         * A quadratic Bézier curve constructed from two control points.
         */
        class QuadraticBezier extends Phaser.Curves.Curve {
            /**
             * 
             * @param p0 Start point, or an array of point pairs.
             * @param p1 Control Point 1.
             * @param p2 Control Point 2.
             */
            constructor(p0: Phaser.Math.Vector2 | number[], p1: Phaser.Math.Vector2, p2: Phaser.Math.Vector2);

            /**
             * The start point.
             */
            p0: Phaser.Math.Vector2;

            /**
             * The first control point.
             */
            p1: Phaser.Math.Vector2;

            /**
             * The second control point.
             */
            p2: Phaser.Math.Vector2;

            /**
             * Gets the starting point on the curve.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Get the resolution of the curve.
             * @param divisions Optional divisions value.
             */
            getResolution(divisions: number): number;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Draws this curve on the given Graphics object.
             * 
             * The curve is drawn using `Graphics.strokePoints` so will be drawn at whatever the present Graphics stroke color is.
             * The Graphics object is not cleared before the draw, so the curve will appear on-top of anything else already rendered to it.
             * @param graphics `Graphics` object to draw onto.
             * @param pointsTotal Number of points to be used for drawing the curve. Higher numbers result in smoother curve but require more processing. Default 32.
             */
            draw<G extends Phaser.GameObjects.Graphics>(graphics: G, pointsTotal?: number): G;

            /**
             * Converts the curve into a JSON compatible object.
             */
            toJSON(): Phaser.Types.Curves.JSONCurve;

            /**
             * Creates a curve from a JSON object, e. g. created by `toJSON`.
             * @param data The JSON object containing this curve data.
             */
            static fromJSON(data: Phaser.Types.Curves.JSONCurve): Phaser.Curves.QuadraticBezier;

        }

        /**
         * Create a smooth 2d spline curve from a series of points.
         */
        class Spline extends Phaser.Curves.Curve {
            /**
             * 
             * @param points The points that configure the curve.
             */
            constructor(points?: Phaser.Math.Vector2[] | number[] | number[][]);

            /**
             * The Vector2 points that configure the curve.
             */
            points: Phaser.Math.Vector2[];

            /**
             * Add a list of points to the current list of Vector2 points of the curve.
             * @param points The points that configure the curve.
             */
            addPoints(points: Phaser.Math.Vector2[] | number[] | number[][]): this;

            /**
             * Add a point to the current list of Vector2 points of the curve.
             * @param x The x coordinate of this curve
             * @param y The y coordinate of this curve
             */
            addPoint(x: number, y: number): Phaser.Math.Vector2;

            /**
             * Gets the starting point on the curve.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getStartPoint<O extends Phaser.Math.Vector2>(out?: O): O;

            /**
             * Get the resolution of the curve.
             * @param divisions Optional divisions value.
             */
            getResolution(divisions: number): number;

            /**
             * Get point at relative position in curve according to length.
             * @param t The position along the curve to return. Where 0 is the start and 1 is the end.
             * @param out A Vector2 object to store the result in. If not given will be created.
             */
            getPoint<O extends Phaser.Math.Vector2>(t: number, out?: O): O;

            /**
             * Exports a JSON object containing this curve data.
             */
            toJSON(): Phaser.Types.Curves.JSONCurve;

            /**
             * Imports a JSON object containing this curve data.
             * @param data The JSON object containing this curve data.
             */
            static fromJSON(data: Phaser.Types.Curves.JSONCurve): Phaser.Curves.Spline;

        }

    }

    namespace Data {
        /**
         * The Data Manager Component features a means to store pieces of data specific to a Game Object, System or Plugin.
         * You can then search, query it, and retrieve the data. The parent must either extend EventEmitter,
         * or have a property called `events` that is an instance of it.
         */
        class DataManager {
            /**
             * 
             * @param parent The object that this DataManager belongs to.
             * @param eventEmitter The DataManager's event emitter.
             */
            constructor(parent: object, eventEmitter?: Phaser.Events.EventEmitter);

            /**
             * The object that this DataManager belongs to.
             */
            parent: any;

            /**
             * The DataManager's event emitter.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * The data list.
             */
            list: {[key: string]:  any};

            /**
             * The public values list. You can use this to access anything you have stored
             * in this Data Manager. For example, if you set a value called `gold` you can
             * access it via:
             * 
             * ```javascript
             * this.data.values.gold;
             * ```
             * 
             * You can also modify it directly:
             * 
             * ```javascript
             * this.data.values.gold += 1000;
             * ```
             * 
             * Doing so will emit a `setdata` event from the parent of this Data Manager.
             * 
             * Do not modify this object directly. Adding properties directly to this object will not
             * emit any events. Always use `DataManager.set` to create new items the first time around.
             */
            values: {[key: string]:  any};

            /**
             * Retrieves the value for the given key, or undefined if it doesn't exist.
             * 
             * You can also access values via the `values` object. For example, if you had a key called `gold` you can do either:
             * 
             * ```javascript
             * this.data.get('gold');
             * ```
             * 
             * Or access the value directly:
             * 
             * ```javascript
             * this.data.values.gold;
             * ```
             * 
             * You can also pass in an array of keys, in which case an array of values will be returned:
             * 
             * ```javascript
             * this.data.get([ 'gold', 'armor', 'health' ]);
             * ```
             * 
             * This approach is useful for destructuring arrays in ES6.
             * @param key The key of the value to retrieve, or an array of keys.
             */
            get(key: string | string[]): any;

            /**
             * Retrieves all data values in a new object.
             */
            getAll(): {[key: string]:  any};

            /**
             * Queries the DataManager for the values of keys matching the given regular expression.
             * @param search A regular expression object. If a non-RegExp object obj is passed, it is implicitly converted to a RegExp by using new RegExp(obj).
             */
            query(search: RegExp): {[key: string]:  any};

            /**
             * Sets a value for the given key. If the key doesn't already exist in the Data Manager then it is created.
             * 
             * ```javascript
             * data.set('name', 'Red Gem Stone');
             * ```
             * 
             * You can also pass in an object of key value pairs as the first argument:
             * 
             * ```javascript
             * data.set({ name: 'Red Gem Stone', level: 2, owner: 'Link', gold: 50 });
             * ```
             * 
             * To get a value back again you can call `get`:
             * 
             * ```javascript
             * data.get('gold');
             * ```
             * 
             * Or you can access the value directly via the `values` property, where it works like any other variable:
             * 
             * ```javascript
             * data.values.gold += 50;
             * ```
             * 
             * When the value is first set, a `setdata` event is emitted.
             * 
             * If the key already exists, a `changedata` event is emitted instead, along an event named after the key.
             * For example, if you updated an existing key called `PlayerLives` then it would emit the event `changedata-PlayerLives`.
             * These events will be emitted regardless if you use this method to set the value, or the direct `values` setter.
             * 
             * Please note that the data keys are case-sensitive and must be valid JavaScript Object property strings.
             * This means the keys `gold` and `Gold` are treated as two unique values within the Data Manager.
             * @param key The key to set the value for. Or an object of key value pairs. If an object the `data` argument is ignored.
             * @param data The value to set for the given key. If an object is provided as the key this argument is ignored.
             */
            set<T extends any>(key: (string|T), data?: any): this;

            /**
             * Increase a value for the given key. If the key doesn't already exist in the Data Manager then it is increased from 0.
             * 
             * When the value is first set, a `setdata` event is emitted.
             * @param key The key to change the value for.
             * @param amount The amount to increase the given key by. Pass a negative value to decrease the key. Default 1.
             */
            inc(key: string, amount?: number): this;

            /**
             * Toggle a boolean value for the given key. If the key doesn't already exist in the Data Manager then it is toggled from false.
             * 
             * When the value is first set, a `setdata` event is emitted.
             * @param key The key to toggle the value for.
             */
            toggle(key: string): this;

            /**
             * Passes all data entries to the given callback.
             * @param callback The function to call.
             * @param context Value to use as `this` when executing callback.
             * @param args Additional arguments that will be passed to the callback, after the game object, key, and data.
             */
            each(callback: DataEachCallback, context?: any, ...args: any[]): this;

            /**
             * Merge the given object of key value pairs into this DataManager.
             * 
             * Any newly created values will emit a `setdata` event. Any updated values (see the `overwrite` argument)
             * will emit a `changedata` event.
             * @param data The data to merge.
             * @param overwrite Whether to overwrite existing data. Defaults to true. Default true.
             */
            merge(data: {[key: string]:  any}, overwrite?: boolean): this;

            /**
             * Remove the value for the given key.
             * 
             * If the key is found in this Data Manager it is removed from the internal lists and a
             * `removedata` event is emitted.
             * 
             * You can also pass in an array of keys, in which case all keys in the array will be removed:
             * 
             * ```javascript
             * this.data.remove([ 'gold', 'armor', 'health' ]);
             * ```
             * @param key The key to remove, or an array of keys to remove.
             */
            remove(key: string | string[]): this;

            /**
             * Retrieves the data associated with the given 'key', deletes it from this Data Manager, then returns it.
             * @param key The key of the value to retrieve and delete.
             */
            pop(key: string): any;

            /**
             * Determines whether the given key is set in this Data Manager.
             * 
             * Please note that the keys are case-sensitive and must be valid JavaScript Object property strings.
             * This means the keys `gold` and `Gold` are treated as two unique values within the Data Manager.
             * @param key The key to check.
             */
            has(key: string): boolean;

            /**
             * Freeze or unfreeze this Data Manager. A frozen Data Manager will block all attempts
             * to create new values or update existing ones.
             * @param value Whether to freeze or unfreeze the Data Manager.
             */
            setFreeze(value: boolean): this;

            /**
             * Delete all data in this Data Manager and unfreeze it.
             */
            reset(): this;

            /**
             * Destroy this data manager.
             */
            destroy(): void;

            /**
             * Gets or sets the frozen state of this Data Manager.
             * A frozen Data Manager will block all attempts to create new values or update existing ones.
             */
            freeze: boolean;

            /**
             * Return the total number of entries in this Data Manager.
             */
            count: number;

        }

        /**
         * The Data Component features a means to store pieces of data specific to a Game Object, System or Plugin.
         * You can then search, query it, and retrieve the data. The parent must either extend EventEmitter,
         * or have a property called `events` that is an instance of it.
         */
        class DataManagerPlugin extends Phaser.Data.DataManager {
            /**
             * 
             * @param scene A reference to the Scene that this DataManager belongs to.
             */
            constructor(scene: Phaser.Scene);

            /**
             * A reference to the Scene that this DataManager belongs to.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Scene's Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The Scene that owns this plugin is being destroyed.
             * We need to shutdown and then kill off all external references.
             */
            destroy(): void;

        }

        namespace Events {
            /**
             * The Change Data Event.
             * 
             * This event is dispatched by a Data Manager when an item in the data store is changed.
             * 
             * Game Objects with data enabled have an instance of a Data Manager under the `data` property. So, to listen for
             * a change data event from a Game Object you would use: `sprite.on('changedata', listener)`.
             * 
             * This event is dispatched for all items that change in the Data Manager.
             * To listen for the change of a specific item, use the `CHANGE_DATA_KEY_EVENT` event.
             */
            const CHANGE_DATA: string;

            /**
             * The Change Data Key Event.
             * 
             * This event is dispatched by a Data Manager when an item in the data store is changed.
             * 
             * Game Objects with data enabled have an instance of a Data Manager under the `data` property. So, to listen for
             * the change of a specific data item from a Game Object you would use: `sprite.on('changedata-key', listener)`,
             * where `key` is the unique string key of the data item. For example, if you have a data item stored called `gold`
             * then you can listen for `sprite.on('changedata-gold')`.
             */
            const CHANGE_DATA_KEY: string;

            /**
             * The Data Manager Destroy Event.
             * 
             * The Data Manager will listen for the destroy event from its parent, and then close itself down.
             */
            const DESTROY: string;

            /**
             * The Remove Data Event.
             * 
             * This event is dispatched by a Data Manager when an item is removed from it.
             * 
             * Game Objects with data enabled have an instance of a Data Manager under the `data` property. So, to listen for
             * the removal of a data item on a Game Object you would use: `sprite.on('removedata', listener)`.
             */
            const REMOVE_DATA: string;

            /**
             * The Set Data Event.
             * 
             * This event is dispatched by a Data Manager when a new item is added to the data store.
             * 
             * Game Objects with data enabled have an instance of a Data Manager under the `data` property. So, to listen for
             * the addition of a new data item on a Game Object you would use: `sprite.on('setdata', listener)`.
             */
            const SET_DATA: string;

        }

    }

    namespace Device {
        /**
         * Determines the audio playback capabilities of the device running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.audio` from within any Scene.
         */
        type Audio = {
            /**
             * Can this device play HTML Audio tags?
             */
            audioData: boolean;
            /**
             * Can this device play EC-3 Dolby Digital Plus files?
             */
            dolby: boolean;
            /**
             * Can this device can play m4a files.
             */
            m4a: boolean;
            /**
             * Can this device can play aac files.
             */
            aac: boolean;
            /**
             * Can this device can play flac files.
             */
            flac: boolean;
            /**
             * Can this device play mp3 files?
             */
            mp3: boolean;
            /**
             * Can this device play ogg files?
             */
            ogg: boolean;
            /**
             * Can this device play opus files?
             */
            opus: boolean;
            /**
             * Can this device play wav files?
             */
            wav: boolean;
            /**
             * Does this device have the Web Audio API?
             */
            webAudio: boolean;
            /**
             * Can this device play webm files?
             */
            webm: boolean;
        };

        /**
         * Determines the browser type and version running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.browser` from within any Scene.
         */
        type Browser = {
            /**
             * Set to true if running in Chrome.
             */
            chrome: boolean;
            /**
             * Set to true if running in Microsoft Edge browser.
             */
            edge: boolean;
            /**
             * Set to true if running in Firefox.
             */
            firefox: boolean;
            /**
             * Set to true if running in Internet Explorer 11 or less (not Edge).
             */
            ie: boolean;
            /**
             * Set to true if running in Mobile Safari.
             */
            mobileSafari: boolean;
            /**
             * Set to true if running in Opera.
             */
            opera: boolean;
            /**
             * Set to true if running in Safari.
             */
            safari: boolean;
            /**
             * Set to true if running in the Silk browser (as used on the Amazon Kindle)
             */
            silk: boolean;
            /**
             * Set to true if running a Trident version of Internet Explorer (IE11+)
             */
            trident: boolean;
            /**
             * If running in Chrome this will contain the major version number.
             */
            chromeVersion: number;
            /**
             * If running in Firefox this will contain the major version number.
             */
            firefoxVersion: number;
            /**
             * If running in Internet Explorer this will contain the major version number. Beyond IE10 you should use Browser.trident and Browser.tridentVersion.
             */
            ieVersion: number;
            /**
             * If running in Safari this will contain the major version number.
             */
            safariVersion: number;
            /**
             * If running in Internet Explorer 11 this will contain the major version number. See {@link http://msdn.microsoft.com/en-us/library/ie/ms537503(v=vs.85).aspx}
             */
            tridentVersion: number;
        };

        /**
         * Determines the canvas features of the browser running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.canvasFeatures` from within any Scene.
         */
        type CanvasFeatures = {
            /**
             * Set to true if the browser supports inversed alpha.
             */
            supportInverseAlpha: boolean;
            /**
             * Set to true if the browser supports new canvas blend modes.
             */
            supportNewBlendModes: boolean;
        };

        /**
         * Determines the features of the browser running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.features` from within any Scene.
         */
        type Features = {
            /**
             * Is canvas available?
             */
            canvas: boolean;
            /**
             * True if canvas supports a 'copy' bitblt onto itself when the source and destination regions overlap.
             */
            canvasBitBltShift: boolean | null;
            /**
             * Is file available?
             */
            file: boolean;
            /**
             * Is fileSystem available?
             */
            fileSystem: boolean;
            /**
             * Does the device support the getUserMedia API?
             */
            getUserMedia: boolean;
            /**
             * Is the device big or little endian? (only detected if the browser supports TypedArrays)
             */
            littleEndian: boolean;
            /**
             * Is localStorage available?
             */
            localStorage: boolean;
            /**
             * Is Pointer Lock available?
             */
            pointerLock: boolean;
            /**
             * Is Array.sort stable?
             */
            stableSort: boolean;
            /**
             * Does the device context support 32bit pixel manipulation using array buffer views?
             */
            support32bit: boolean;
            /**
             * Does the device support the Vibration API?
             */
            vibration: boolean;
            /**
             * Is webGL available?
             */
            webGL: boolean;
            /**
             * Is worker available?
             */
            worker: boolean;
        };

        /**
         * Determines the full screen support of the browser running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.fullscreen` from within any Scene.
         */
        type Fullscreen = {
            /**
             * Does the browser support the Full Screen API?
             */
            available: boolean;
            /**
             * Does the browser support access to the Keyboard during Full Screen mode?
             */
            keyboard: boolean;
            /**
             * If the browser supports the Full Screen API this holds the call you need to use to cancel it.
             */
            cancel: string;
            /**
             * If the browser supports the Full Screen API this holds the call you need to use to activate it.
             */
            request: string;
        };

        /**
         * Determines the input support of the browser running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.input` from within any Scene.
         */
        type Input = {
            /**
             * The newest type of Wheel/Scroll event supported: 'wheel', 'mousewheel', 'DOMMouseScroll'
             */
            wheelType: string | null;
            /**
             * Is navigator.getGamepads available?
             */
            gamepads: boolean;
            /**
             * Is mspointer available?
             */
            mspointer: boolean;
            /**
             * Is touch available?
             */
            touch: boolean;
        };

        /**
         * Determines the operating system of the device running this Phaser Game instance.
         * These values are read-only and populated during the boot sequence of the game.
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.os` from within any Scene.
         */
        type OS = {
            /**
             * Is running on android?
             */
            android: boolean;
            /**
             * Is running on chromeOS?
             */
            chromeOS: boolean;
            /**
             * Is the game running under Apache Cordova?
             */
            cordova: boolean;
            /**
             * Is the game running under the Intel Crosswalk XDK?
             */
            crosswalk: boolean;
            /**
             * Is running on a desktop?
             */
            desktop: boolean;
            /**
             * Is the game running under Ejecta?
             */
            ejecta: boolean;
            /**
             * Is the game running under GitHub Electron?
             */
            electron: boolean;
            /**
             * Is running on iOS?
             */
            iOS: boolean;
            /**
             * Is running on iPad?
             */
            iPad: boolean;
            /**
             * Is running on iPhone?
             */
            iPhone: boolean;
            /**
             * Is running on an Amazon Kindle?
             */
            kindle: boolean;
            /**
             * Is running on linux?
             */
            linux: boolean;
            /**
             * Is running on macOS?
             */
            macOS: boolean;
            /**
             * Is the game running under Node.js?
             */
            node: boolean;
            /**
             * Is the game running under Node-Webkit?
             */
            nodeWebkit: boolean;
            /**
             * Set to true if running as a WebApp, i.e. within a WebView
             */
            webApp: boolean;
            /**
             * Is running on windows?
             */
            windows: boolean;
            /**
             * Is running on a Windows Phone?
             */
            windowsPhone: boolean;
            /**
             * If running in iOS this will contain the major version number.
             */
            iOSVersion: number;
            /**
             * PixelRatio of the host device?
             */
            pixelRatio: number;
        };

        /**
         * Determines the video support of the browser running this Phaser Game instance.
         * 
         * These values are read-only and populated during the boot sequence of the game.
         * 
         * They are then referenced by internal game systems and are available for you to access
         * via `this.sys.game.device.video` from within any Scene.
         * 
         * In Phaser 3.20 the properties were renamed to drop the 'Video' suffix.
         */
        type Video = {
            /**
             * Can this device play h264 mp4 video files?
             */
            h264: boolean;
            /**
             * Can this device play hls video files?
             */
            hls: boolean;
            /**
             * Can this device play h264 mp4 video files?
             */
            mp4: boolean;
            /**
             * Can this device play m4v (typically mp4) video files?
             */
            m4v: boolean;
            /**
             * Can this device play ogg video files?
             */
            ogg: boolean;
            /**
             * Can this device play vp9 video files?
             */
            vp9: boolean;
            /**
             * Can this device play webm video files?
             */
            webm: boolean;
            /**
             * Returns the first video URL that can be played by this browser.
             */
            getVideoURL: Function;
        };

    }

    type DeviceConf = {
        /**
         * The OS Device functions.
         */
        os: Phaser.Device.OS;
        /**
         * The Browser Device functions.
         */
        browser: Phaser.Device.Browser;
        /**
         * The Features Device functions.
         */
        features: Phaser.Device.Features;
        /**
         * The Input Device functions.
         */
        input: Phaser.Device.Input;
        /**
         * The Audio Device functions.
         */
        audio: Phaser.Device.Audio;
        /**
         * The Video Device functions.
         */
        video: Phaser.Device.Video;
        /**
         * The Fullscreen Device functions.
         */
        fullscreen: Phaser.Device.Fullscreen;
        /**
         * The Canvas Device functions.
         */
        canvasFeatures: Phaser.Device.CanvasFeatures;
    };

    namespace Display {
        namespace Align {
            /**
             * A constant representing a top-left alignment or position.
             */
            const TOP_LEFT: number;

            /**
             * A constant representing a top-center alignment or position.
             */
            const TOP_CENTER: number;

            /**
             * A constant representing a top-right alignment or position.
             */
            const TOP_RIGHT: number;

            /**
             * A constant representing a left-top alignment or position.
             */
            const LEFT_TOP: number;

            /**
             * A constant representing a left-center alignment or position.
             */
            const LEFT_CENTER: number;

            /**
             * A constant representing a left-bottom alignment or position.
             */
            const LEFT_BOTTOM: number;

            /**
             * A constant representing a center alignment or position.
             */
            const CENTER: number;

            /**
             * A constant representing a right-top alignment or position.
             */
            const RIGHT_TOP: number;

            /**
             * A constant representing a right-center alignment or position.
             */
            const RIGHT_CENTER: number;

            /**
             * A constant representing a right-bottom alignment or position.
             */
            const RIGHT_BOTTOM: number;

            /**
             * A constant representing a bottom-left alignment or position.
             */
            const BOTTOM_LEFT: number;

            /**
             * A constant representing a bottom-center alignment or position.
             */
            const BOTTOM_CENTER: number;

            /**
             * A constant representing a bottom-right alignment or position.
             */
            const BOTTOM_RIGHT: number;

            namespace In {
                /**
                 * Takes given Game Object and aligns it so that it is positioned in the bottom center of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the bottom left of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomLeft<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the bottom right of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomRight<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the center of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function Center<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the left center of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function LeftCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned relative to the other.
                 * The alignment used is based on the `position` argument, which is an `ALIGN_CONST` value, such as `LEFT_CENTER` or `TOP_RIGHT`.
                 * @param child The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param position The position to align the Game Object with. This is an align constant, such as `ALIGN_CONST.LEFT_CENTER`.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function QuickSet<G extends Phaser.GameObjects.GameObject>(child: G, alignIn: Phaser.GameObjects.GameObject, position: number, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the right center of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function RightCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the top center of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the top left of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopLeft<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned in the top right of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignIn The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopRight<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignIn: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

            }

            namespace To {
                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the bottom center position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the bottom left position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomLeft<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the bottom right position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function BottomRight<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the left bottom position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function LeftBottom<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the left center position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function LeftCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the left top position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function LeftTop<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes a Game Object and aligns it next to another, at the given position.
                 * The alignment used is based on the `position` argument, which is a `Phaser.Display.Align` property such as `LEFT_CENTER` or `TOP_RIGHT`.
                 * @param child The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param position The position to align the Game Object with. This is an align constant, such as `Phaser.Display.Align.LEFT_CENTER`.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function QuickSet<G extends Phaser.GameObjects.GameObject>(child: G, alignTo: Phaser.GameObjects.GameObject, position: number, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the right bottom position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function RightBottom<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the right center position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function RightCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the right top position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function RightTop<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the top center position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopCenter<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the top left position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopLeft<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

                /**
                 * Takes given Game Object and aligns it so that it is positioned next to the top right position of the other.
                 * @param gameObject The Game Object that will be positioned.
                 * @param alignTo The Game Object to base the alignment position on.
                 * @param offsetX Optional horizontal offset from the position. Default 0.
                 * @param offsetY Optional vertical offset from the position. Default 0.
                 */
                function TopRight<G extends Phaser.GameObjects.GameObject>(gameObject: G, alignTo: Phaser.GameObjects.GameObject, offsetX?: number, offsetY?: number): G;

            }

        }

        namespace Bounds {
            /**
             * Positions the Game Object so that it is centered on the given coordinates.
             * @param gameObject The Game Object that will be re-positioned.
             * @param x The horizontal coordinate to position the Game Object on.
             * @param y The vertical coordinate to position the Game Object on.
             */
            function CenterOn<G extends Phaser.GameObjects.GameObject>(gameObject: G, x: number, y: number): G;

            /**
             * Returns the bottom coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetBottom(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the unrotated bounds of the Game Object as a rectangle.
             * @param gameObject The Game Object to get the bounds value from.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            function GetBounds(gameObject: Phaser.GameObjects.GameObject, output?: Phaser.Geom.Rectangle | object): Phaser.Geom.Rectangle | object;

            /**
             * Returns the center x coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetCenterX(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the center y coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetCenterY(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the left coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetLeft(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the amount the Game Object is visually offset from its x coordinate.
             * This is the same as `width * origin.x`.
             * This value will only be > 0 if `origin.x` is not equal to zero.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetOffsetX(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the amount the Game Object is visually offset from its y coordinate.
             * This is the same as `width * origin.y`.
             * This value will only be > 0 if `origin.y` is not equal to zero.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetOffsetY(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the right coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetRight(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Returns the top coordinate from the bounds of the Game Object.
             * @param gameObject The Game Object to get the bounds value from.
             */
            function GetTop(gameObject: Phaser.GameObjects.GameObject): number;

            /**
             * Positions the Game Object so that the bottom of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param value The coordinate to position the Game Object bounds on.
             */
            function SetBottom<G extends Phaser.GameObjects.GameObject>(gameObject: G, value: number): G;

            /**
             * Positions the Game Object so that the center top of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param x The coordinate to position the Game Object bounds on.
             */
            function SetCenterX<G extends Phaser.GameObjects.GameObject>(gameObject: G, x: number): G;

            /**
             * Positions the Game Object so that the center top of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param y The coordinate to position the Game Object bounds on.
             */
            function SetCenterY<G extends Phaser.GameObjects.GameObject>(gameObject: G, y: number): G;

            /**
             * Positions the Game Object so that the left of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param value The coordinate to position the Game Object bounds on.
             */
            function SetLeft<G extends Phaser.GameObjects.GameObject>(gameObject: G, value: number): G;

            /**
             * Positions the Game Object so that the left of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param value The coordinate to position the Game Object bounds on.
             */
            function SetRight<G extends Phaser.GameObjects.GameObject>(gameObject: G, value: number): G;

            /**
             * Positions the Game Object so that the top of its bounds aligns with the given coordinate.
             * @param gameObject The Game Object that will be re-positioned.
             * @param value The coordinate to position the Game Object bounds on.
             */
            function SetTop<G extends Phaser.GameObjects.GameObject>(gameObject: G, value: number): G;

        }

        namespace Canvas {
            namespace CanvasInterpolation {
                /**
                 * Sets the CSS image-rendering property on the given canvas to be 'crisp' (aka 'optimize contrast' on webkit).
                 * @param canvas The canvas object to have the style set on.
                 */
                function setCrisp(canvas: HTMLCanvasElement): HTMLCanvasElement;

                /**
                 * Sets the CSS image-rendering property on the given canvas to be 'bicubic' (aka 'auto').
                 * @param canvas The canvas object to have the style set on.
                 */
                function setBicubic(canvas: HTMLCanvasElement): HTMLCanvasElement;

            }

            /**
             * The CanvasPool is a global static object, that allows Phaser to recycle and pool 2D Context Canvas DOM elements.
             * It does not pool WebGL Contexts, because once the context options are set they cannot be modified again,
             * which is useless for some of the Phaser pipelines / renderer.
             * 
             * This singleton is instantiated as soon as Phaser loads, before a Phaser.Game instance has even been created.
             * Which means all instances of Phaser Games on the same page can share the one single pool.
             */
            namespace CanvasPool {
                /**
                 * Creates a new Canvas DOM element, or pulls one from the pool if free.
                 * @param parent The parent of the Canvas object.
                 * @param width The width of the Canvas. Default 1.
                 * @param height The height of the Canvas. Default 1.
                 * @param canvasType The type of the Canvas. Either `Phaser.CANVAS` or `Phaser.WEBGL`. Default Phaser.CANVAS.
                 * @param selfParent Use the generated Canvas element as the parent? Default false.
                 */
                function create(parent: any, width?: number, height?: number, canvasType?: number, selfParent?: boolean): HTMLCanvasElement;

                /**
                 * Creates a new Canvas DOM element, or pulls one from the pool if free.
                 * @param parent The parent of the Canvas object.
                 * @param width The width of the Canvas. Default 1.
                 * @param height The height of the Canvas. Default 1.
                 */
                function create2D(parent: any, width?: number, height?: number): HTMLCanvasElement;

                /**
                 * Creates a new Canvas DOM element, or pulls one from the pool if free.
                 * @param parent The parent of the Canvas object.
                 * @param width The width of the Canvas. Default 1.
                 * @param height The height of the Canvas. Default 1.
                 */
                function createWebGL(parent: any, width?: number, height?: number): HTMLCanvasElement;

                /**
                 * Gets the first free canvas index from the pool.
                 * @param canvasType The type of the Canvas. Either `Phaser.CANVAS` or `Phaser.WEBGL`. Default Phaser.CANVAS.
                 */
                function first(canvasType?: number): HTMLCanvasElement;

                /**
                 * Looks up a canvas based on its parent, and if found puts it back in the pool, freeing it up for re-use.
                 * The canvas has its width and height set to 1, and its parent attribute nulled.
                 * @param parent The canvas or the parent of the canvas to free.
                 */
                function remove(parent: any): void;

                /**
                 * Gets the total number of used canvas elements in the pool.
                 */
                function total(): number;

                /**
                 * Gets the total number of free canvas elements in the pool.
                 */
                function free(): number;

                /**
                 * Disable context smoothing on any new Canvas element created.
                 */
                function disableSmoothing(): void;

                /**
                 * Enable context smoothing on any new Canvas element created.
                 */
                function enableSmoothing(): void;

            }

            namespace Smoothing {
                /**
                 * Gets the Smoothing Enabled vendor prefix being used on the given context, or null if not set.
                 * @param context The canvas context to check.
                 */
                function getPrefix(context: CanvasRenderingContext2D | WebGLRenderingContext): string;

                /**
                 * Sets the Image Smoothing property on the given context. Set to false to disable image smoothing.
                 * By default browsers have image smoothing enabled, which isn't always what you visually want, especially
                 * when using pixel art in a game. Note that this sets the property on the context itself, so that any image
                 * drawn to the context will be affected. This sets the property across all current browsers but support is
                 * patchy on earlier browsers, especially on mobile.
                 * @param context The context on which to enable smoothing.
                 */
                function enable(context: CanvasRenderingContext2D | WebGLRenderingContext): CanvasRenderingContext2D | WebGLRenderingContext;

                /**
                 * Sets the Image Smoothing property on the given context. Set to false to disable image smoothing.
                 * By default browsers have image smoothing enabled, which isn't always what you visually want, especially
                 * when using pixel art in a game. Note that this sets the property on the context itself, so that any image
                 * drawn to the context will be affected. This sets the property across all current browsers but support is
                 * patchy on earlier browsers, especially on mobile.
                 * @param context The context on which to disable smoothing.
                 */
                function disable(context: CanvasRenderingContext2D | WebGLRenderingContext): CanvasRenderingContext2D | WebGLRenderingContext;

                /**
                 * Returns `true` if the given context has image smoothing enabled, otherwise returns `false`.
                 * Returns null if no smoothing prefix is available.
                 * @param context The context to check.
                 */
                function isEnabled(context: CanvasRenderingContext2D | WebGLRenderingContext): boolean | null;

            }

            /**
             * Sets the touch-action property on the canvas style. Can be used to disable default browser touch actions.
             * @param canvas The canvas element to have the style applied to.
             * @param value The touch action value to set on the canvas. Set to `none` to disable touch actions. Default 'none'.
             */
            function TouchAction(canvas: HTMLCanvasElement, value?: string): HTMLCanvasElement;

            /**
             * Sets the user-select property on the canvas style. Can be used to disable default browser selection actions.
             * @param canvas The canvas element to have the style applied to.
             * @param value The touch callout value to set on the canvas. Set to `none` to disable touch callouts. Default 'none'.
             */
            function UserSelect(canvas: HTMLCanvasElement, value?: string): HTMLCanvasElement;

        }

        namespace Color {
            namespace Interpolate {
                /**
                 * Interpolates between the two given color ranges over the length supplied.
                 * @param r1 Red value.
                 * @param g1 Blue value.
                 * @param b1 Green value.
                 * @param r2 Red value.
                 * @param g2 Blue value.
                 * @param b2 Green value.
                 * @param length Distance to interpolate over. Default 100.
                 * @param index Index to start from. Default 0.
                 */
                function RGBWithRGB(r1: number, g1: number, b1: number, r2: number, g2: number, b2: number, length?: number, index?: number): Phaser.Types.Display.ColorObject;

                /**
                 * Interpolates between the two given color objects over the length supplied.
                 * @param color1 The first Color object.
                 * @param color2 The second Color object.
                 * @param length Distance to interpolate over. Default 100.
                 * @param index Index to start from. Default 0.
                 */
                function ColorWithColor(color1: Phaser.Display.Color, color2: Phaser.Display.Color, length?: number, index?: number): Phaser.Types.Display.ColorObject;

                /**
                 * Interpolates between the Color object and color values over the length supplied.
                 * @param color1 The first Color object.
                 * @param r Red value.
                 * @param g Blue value.
                 * @param b Green value.
                 * @param length Distance to interpolate over. Default 100.
                 * @param index Index to start from. Default 0.
                 */
                function ColorWithRGB(color1: Phaser.Display.Color, r: number, g: number, b: number, length?: number, index?: number): Phaser.Types.Display.ColorObject;

            }

        }

        /**
         * The Color class holds a single color value and allows for easy modification and reading of it.
         */
        class Color {
            /**
             * 
             * @param red The red color value. A number between 0 and 255. Default 0.
             * @param green The green color value. A number between 0 and 255. Default 0.
             * @param blue The blue color value. A number between 0 and 255. Default 0.
             * @param alpha The alpha value. A number between 0 and 255. Default 255.
             */
            constructor(red?: number, green?: number, blue?: number, alpha?: number);

            /**
             * An array containing the calculated color values for WebGL use.
             */
            gl: number[];

            /**
             * Sets this color to be transparent. Sets all values to zero.
             */
            transparent(): Phaser.Display.Color;

            /**
             * Sets the color of this Color component.
             * @param red The red color value. A number between 0 and 255.
             * @param green The green color value. A number between 0 and 255.
             * @param blue The blue color value. A number between 0 and 255.
             * @param alpha The alpha value. A number between 0 and 255. Default 255.
             * @param updateHSV Update the HSV values after setting the RGB values? Default true.
             */
            setTo(red: number, green: number, blue: number, alpha?: number, updateHSV?: boolean): Phaser.Display.Color;

            /**
             * Sets the red, green, blue and alpha GL values of this Color component.
             * @param red The red color value. A number between 0 and 1.
             * @param green The green color value. A number between 0 and 1.
             * @param blue The blue color value. A number between 0 and 1.
             * @param alpha The alpha value. A number between 0 and 1. Default 1.
             */
            setGLTo(red: number, green: number, blue: number, alpha?: number): Phaser.Display.Color;

            /**
             * Sets the color based on the color object given.
             * @param color An object containing `r`, `g`, `b` and optionally `a` values in the range 0 to 255.
             */
            setFromRGB(color: Phaser.Types.Display.InputColorObject): Phaser.Display.Color;

            /**
             * Sets the color based on the hue, saturation and lightness values given.
             * @param h The hue, in the range 0 - 1. This is the base color.
             * @param s The saturation, in the range 0 - 1. This controls how much of the hue will be in the final color, where 1 is fully saturated and 0 will give you white.
             * @param v The value, in the range 0 - 1. This controls how dark the color is. Where 1 is as bright as possible and 0 is black.
             */
            setFromHSV(h: number, s: number, v: number): Phaser.Display.Color;

            /**
             * Returns a new Color component using the values from this one.
             */
            clone(): Phaser.Display.Color;

            /**
             * Sets this Color object to be grayscaled based on the shade value given.
             * @param shade A value between 0 and 255.
             */
            gray(shade: number): Phaser.Display.Color;

            /**
             * Sets this Color object to be a random color between the `min` and `max` values given.
             * @param min The minimum random color value. Between 0 and 255. Default 0.
             * @param max The maximum random color value. Between 0 and 255. Default 255.
             */
            random(min?: number, max?: number): Phaser.Display.Color;

            /**
             * Sets this Color object to be a random grayscale color between the `min` and `max` values given.
             * @param min The minimum random color value. Between 0 and 255. Default 0.
             * @param max The maximum random color value. Between 0 and 255. Default 255.
             */
            randomGray(min?: number, max?: number): Phaser.Display.Color;

            /**
             * Increase the saturation of this Color by the percentage amount given.
             * The saturation is the amount of the base color in the hue.
             * @param amount The percentage amount to change this color by. A value between 0 and 100.
             */
            saturate(amount: number): Phaser.Display.Color;

            /**
             * Decrease the saturation of this Color by the percentage amount given.
             * The saturation is the amount of the base color in the hue.
             * @param amount The percentage amount to change this color by. A value between 0 and 100.
             */
            desaturate(amount: number): Phaser.Display.Color;

            /**
             * Increase the lightness of this Color by the percentage amount given.
             * @param amount The percentage amount to change this color by. A value between 0 and 100.
             */
            lighten(amount: number): Phaser.Display.Color;

            /**
             * Decrease the lightness of this Color by the percentage amount given.
             * @param amount The percentage amount to change this color by. A value between 0 and 100.
             */
            darken(amount: number): Phaser.Display.Color;

            /**
             * Brighten this Color by the percentage amount given.
             * @param amount The percentage amount to change this color by. A value between 0 and 100.
             */
            brighten(amount: number): Phaser.Display.Color;

            /**
             * The color of this Color component, not including the alpha channel.
             */
            readonly color: number;

            /**
             * The color of this Color component, including the alpha channel.
             */
            readonly color32: number;

            /**
             * The color of this Color component as a string which can be used in CSS color values.
             */
            readonly rgba: string;

            /**
             * The red color value, normalized to the range 0 to 1.
             */
            redGL: number;

            /**
             * The green color value, normalized to the range 0 to 1.
             */
            greenGL: number;

            /**
             * The blue color value, normalized to the range 0 to 1.
             */
            blueGL: number;

            /**
             * The alpha color value, normalized to the range 0 to 1.
             */
            alphaGL: number;

            /**
             * The red color value, normalized to the range 0 to 255.
             */
            red: number;

            /**
             * The green color value, normalized to the range 0 to 255.
             */
            green: number;

            /**
             * The blue color value, normalized to the range 0 to 255.
             */
            blue: number;

            /**
             * The alpha color value, normalized to the range 0 to 255.
             */
            alpha: number;

            /**
             * The hue color value. A number between 0 and 1.
             * This is the base color.
             */
            h: number;

            /**
             * The saturation color value. A number between 0 and 1.
             * This controls how much of the hue will be in the final color, where 1 is fully saturated and 0 will give you white.
             */
            s: number;

            /**
             * The lightness color value. A number between 0 and 1.
             * This controls how dark the color is. Where 1 is as bright as possible and 0 is black.
             */
            v: number;

            /**
             * Return an array of Colors in a Color Spectrum.
             * 
             * The spectrum colors flow in the order: red, yellow, green, blue.
             * 
             * By default this function will return an array with 1024 elements in.
             * 
             * However, you can reduce this to a smaller quantity if needed, by specitying the `limit` parameter.
             * @param limit How many colors should be returned? The maximum is 1024 but you can set a smaller quantity if required. Default 1024.
             */
            static ColorSpectrum(limit?: number): Phaser.Types.Display.ColorObject[];

            /**
             * Converts the given color value into an Object containing r,g,b and a properties.
             * @param color A color value, optionally including the alpha value.
             */
            static ColorToRGBA(color: number): Phaser.Types.Display.ColorObject;

            /**
             * Returns a string containing a hex representation of the given color component.
             * @param color The color channel to get the hex value for, must be a value between 0 and 255.
             */
            static ComponentToHex(color: number): string;

            /**
             * Given 3 separate color values this will return an integer representation of it.
             * @param red The red color value. A number between 0 and 255.
             * @param green The green color value. A number between 0 and 255.
             * @param blue The blue color value. A number between 0 and 255.
             */
            static GetColor(red: number, green: number, blue: number): number;

            /**
             * Given an alpha and 3 color values this will return an integer representation of it.
             * @param red The red color value. A number between 0 and 255.
             * @param green The green color value. A number between 0 and 255.
             * @param blue The blue color value. A number between 0 and 255.
             * @param alpha The alpha color value. A number between 0 and 255.
             */
            static GetColor32(red: number, green: number, blue: number, alpha: number): number;

            /**
             * Converts a hex string into a Phaser Color object.
             * 
             * The hex string can supplied as `'#0033ff'` or the short-hand format of `'#03f'`; it can begin with an optional "#" or "0x", or be unprefixed.
             * 
             * An alpha channel is _not_ supported.
             * @param hex The hex color value to convert, such as `#0033ff` or the short-hand format: `#03f`.
             */
            static HexStringToColor(hex: string): Phaser.Display.Color;

            /**
             * Converts HSL (hue, saturation and lightness) values to a Phaser Color object.
             * @param h The hue value in the range 0 to 1.
             * @param s The saturation value in the range 0 to 1.
             * @param l The lightness value in the range 0 to 1.
             */
            static HSLToColor(h: number, s: number, l: number): Phaser.Display.Color;

            /**
             * Generates an HSV color wheel which is an array of 360 Color objects, for each step of the wheel.
             * @param s The saturation, in the range 0 - 1. Default 1.
             * @param v The value, in the range 0 - 1. Default 1.
             */
            static HSVColorWheel(s?: number, v?: number): Phaser.Types.Display.ColorObject[];

            /**
             * Converts a HSV (hue, saturation and value) color set to RGB.
             * 
             * Conversion formula from https://en.wikipedia.org/wiki/HSL_and_HSV
             * 
             * Assumes HSV values are contained in the set [0, 1].
             * @param h The hue, in the range 0 - 1. This is the base color.
             * @param s The saturation, in the range 0 - 1. This controls how much of the hue will be in the final color, where 1 is fully saturated and 0 will give you white.
             * @param v The value, in the range 0 - 1. This controls how dark the color is. Where 1 is as bright as possible and 0 is black.
             * @param out A Color object to store the results in. If not given a new ColorObject will be created.
             */
            static HSVToRGB(h: number, s: number, v: number, out?: Phaser.Types.Display.ColorObject | Phaser.Display.Color): Phaser.Types.Display.ColorObject | Phaser.Display.Color;

            /**
             * Converts a hue to an RGB color.
             * Based on code by Michael Jackson (https://github.com/mjijackson)
             */
            static HueToComponent(p: number, q: number, t: number): number;

            /**
             * Converts the given color value into an instance of a Color object.
             * @param input The color value to convert into a Color object.
             */
            static IntegerToColor(input: number): Phaser.Display.Color;

            /**
             * Return the component parts of a color as an Object with the properties alpha, red, green, blue.
             * 
             * Alpha will only be set if it exists in the given color (0xAARRGGBB)
             * @param input The color value to convert into a Color object.
             */
            static IntegerToRGB(input: number): Phaser.Types.Display.ColorObject;

            /**
             * Converts an object containing `r`, `g`, `b` and `a` properties into a Color class instance.
             * @param input An object containing `r`, `g`, `b` and `a` properties in the range 0 to 255.
             */
            static ObjectToColor(input: Phaser.Types.Display.InputColorObject): Phaser.Display.Color;

            /**
             * Creates a new Color object where the r, g, and b values have been set to random values
             * based on the given min max values.
             * @param min The minimum value to set the random range from (between 0 and 255) Default 0.
             * @param max The maximum value to set the random range from (between 0 and 255) Default 255.
             */
            static RandomRGB(min?: number, max?: number): Phaser.Display.Color;

            /**
             * Converts a CSS 'web' string into a Phaser Color object.
             * 
             * The web string can be in the format `'rgb(r,g,b)'` or `'rgba(r,g,b,a)'` where r/g/b are in the range [0..255] and a is in the range [0..1].
             * @param rgb The CSS format color string, using the `rgb` or `rgba` format.
             */
            static RGBStringToColor(rgb: string): Phaser.Display.Color;

            /**
             * Converts an RGB color value to HSV (hue, saturation and value).
             * Conversion formula from http://en.wikipedia.org/wiki/HSL_color_space.
             * Assumes RGB values are contained in the set [0, 255] and returns h, s and v in the set [0, 1].
             * Based on code by Michael Jackson (https://github.com/mjijackson)
             * @param r The red color value. A number between 0 and 255.
             * @param g The green color value. A number between 0 and 255.
             * @param b The blue color value. A number between 0 and 255.
             * @param out An object to store the color values in. If not given an HSV Color Object will be created.
             */
            static RGBToHSV(r: number, g: number, b: number, out?: Phaser.Types.Display.HSVColorObject | Phaser.Display.Color): Phaser.Types.Display.HSVColorObject | Phaser.Display.Color;

            /**
             * Converts the color values into an HTML compatible color string, prefixed with either `#` or `0x`.
             * @param r The red color value. A number between 0 and 255.
             * @param g The green color value. A number between 0 and 255.
             * @param b The blue color value. A number between 0 and 255.
             * @param a The alpha value. A number between 0 and 255. Default 255.
             * @param prefix The prefix of the string. Either `#` or `0x`. Default #.
             */
            static RGBToString(r: number, g: number, b: number, a?: number, prefix?: string): string;

            /**
             * Converts the given source color value into an instance of a Color class.
             * The value can be either a string, prefixed with `rgb` or a hex string, a number or an Object.
             * @param input The source color value to convert.
             */
            static ValueToColor(input: string | number | Phaser.Types.Display.InputColorObject): Phaser.Display.Color;

        }

        /**
         * The ColorMatrix class creates a 5x4 matrix that can be used in shaders and graphics
         * operations. It provides methods required to modify the color values, such as adjusting
         * the brightness, setting a sepia tone, hue rotation and more.
         * 
         * Use the method `getData` to return a Float32Array containing the current color values.
         */
        class ColorMatrix {
            /**
             * The value that determines how much of the original color is used
             * when mixing the colors. A value between 0 (all original) and 1 (all final)
             */
            alpha: number;

            /**
             * Sets this ColorMatrix from the given array of color values.
             * @param value The ColorMatrix values to set. Must have 20 elements.
             */
            set(value: number[] | Float32Array): this;

            /**
             * Resets the ColorMatrix to default values and also resets
             * the `alpha` property back to 1.
             */
            reset(): this;

            /**
             * Gets the ColorMatrix as a Float32Array.
             * 
             * Can be used directly as a 1fv shader uniform value.
             */
            getData(): Float32Array;

            /**
             * Changes the brightness of this ColorMatrix by the given amount.
             * @param value The amount of brightness to apply to this ColorMatrix. Between 0 (black) and 1. Default 0.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            brightness(value?: number, multiply?: boolean): this;

            /**
             * Changes the saturation of this ColorMatrix by the given amount.
             * @param value The amount of saturation to apply to this ColorMatrix. Default 0.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            saturate(value?: number, multiply?: boolean): this;

            /**
             * Desaturates this ColorMatrix (removes color from it).
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            saturation(multiply?: boolean): this;

            /**
             * Rotates the hues of this ColorMatrix by the value given.
             * @param rotation The amount of hue rotation to apply to this ColorMatrix, in degrees. Default 0.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            hue(rotation?: number, multiply?: boolean): this;

            /**
             * Sets this ColorMatrix to be grayscale.
             * @param value The grayscale scale (0 is black). Default 1.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            grayscale(value?: number, multiply?: boolean): this;

            /**
             * Sets this ColorMatrix to be black and white.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            blackWhite(multiply?: boolean): this;

            /**
             * Change the contrast of this ColorMatrix by the amount given.
             * @param value The amount of contrast to apply to this ColorMatrix. Default 0.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            contrast(value?: number, multiply?: boolean): this;

            /**
             * Converts this ColorMatrix to have negative values.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            negative(multiply?: boolean): this;

            /**
             * Apply a desaturated luminance to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            desaturateLuminance(multiply?: boolean): this;

            /**
             * Applies a sepia tone to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            sepia(multiply?: boolean): this;

            /**
             * Applies a night vision tone to this ColorMatrix.
             * @param intensity The intensity of this effect. Default 0.1.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            night(intensity?: number, multiply?: boolean): this;

            /**
             * Applies a trippy color tone to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            lsd(multiply?: boolean): this;

            /**
             * Applies a brown tone to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            brown(multiply?: boolean): this;

            /**
             * Applies a vintage pinhole color effect to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            vintagePinhole(multiply?: boolean): this;

            /**
             * Applies a kodachrome color effect to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            kodachrome(multiply?: boolean): this;

            /**
             * Applies a technicolor color effect to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            technicolor(multiply?: boolean): this;

            /**
             * Applies a polaroid color effect to this ColorMatrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            polaroid(multiply?: boolean): this;

            /**
             * Shifts the values of this ColorMatrix into BGR order.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            shiftToBGR(multiply?: boolean): this;

            /**
             * Multiplies the two given matrices.
             * @param a The 5x4 array to multiply with ColorMatrix._matrix.
             * @param multiply Multiply the resulting ColorMatrix (`true`), or set it (`false`) ? Default false.
             */
            multiply(a: number[], multiply?: boolean): this;

            /**
             * A constant array used by the ColorMatrix class for black_white operations.
             */
            static readonly BLACK_WHITE: number[];

            /**
             * A constant array used by the ColorMatrix class for negative operations.
             */
            static readonly NEGATIVE: number[];

            /**
             * A constant array used by the ColorMatrix class for desatured luminance operations.
             */
            static readonly DESATURATE_LUMINANCE: number[];

            /**
             * A constant array used by the ColorMatrix class for sepia operations.
             */
            static readonly SEPIA: number[];

            /**
             * A constant array used by the ColorMatrix class for lsd operations.
             */
            static readonly LSD: number[];

            /**
             * A constant array used by the ColorMatrix class for brown operations.
             */
            static readonly BROWN: number[];

            /**
             * A constant array used by the ColorMatrix class for vintage pinhole operations.
             */
            static readonly VINTAGE: number[];

            /**
             * A constant array used by the ColorMatrix class for kodachrome operations.
             */
            static readonly KODACHROME: number[];

            /**
             * A constant array used by the ColorMatrix class for technicolor operations.
             */
            static readonly TECHNICOLOR: number[];

            /**
             * A constant array used by the ColorMatrix class for polaroid shift operations.
             */
            static readonly POLAROID: number[];

            /**
             * A constant array used by the ColorMatrix class for shift BGR operations.
             */
            static readonly SHIFT_BGR: number[];

        }

        namespace Masks {
            /**
             * A Bitmap Mask combines the alpha (opacity) of a masked pixel with the alpha of another pixel.
             * Unlike the Geometry Mask, which is a clipping path, a Bitmap Mask behaves like an alpha mask,
             * not a clipping path. It is only available when using the WebGL Renderer.
             * 
             * A Bitmap Mask can use any Game Object or Dynamic Texture to determine the alpha of each pixel of the masked Game Object(s).
             * For any given point of a masked Game Object's texture, the pixel's alpha will be multiplied by the alpha
             * of the pixel at the same position in the Bitmap Mask's Game Object. The color of the pixel from the
             * Bitmap Mask doesn't matter.
             * 
             * For example, if a pure blue pixel with an alpha of 0.95 is masked with a pure red pixel with an
             * alpha of 0.5, the resulting pixel will be pure blue with an alpha of 0.475. Naturally, this means
             * that a pixel in the mask with an alpha of 0 will hide the corresponding pixel in all masked Game Objects.
             * A pixel with an alpha of 1 in the masked Game Object will receive the same alpha as the
             * corresponding pixel in the mask.
             * 
             * Note: You cannot combine Bitmap Masks and Blend Modes on the same Game Object. You can, however,
             * combine Geometry Masks and Blend Modes together.
             * 
             * The Bitmap Mask's location matches the location of its Game Object, not the location of the
             * masked objects. Moving or transforming the underlying Game Object will change the mask
             * (and affect the visibility of any masked objects), whereas moving or transforming a masked object
             * will not affect the mask.
             * 
             * The Bitmap Mask will not render its Game Object by itself. If the Game Object is not in a
             * Scene's display list, it will only be used for the mask and its full texture will not be directly
             * visible. Adding the underlying Game Object to a Scene will not cause any problems - it will
             * render as a normal Game Object and will also serve as a mask.
             */
            class BitmapMask {
                /**
                 * 
                 * @param scene The Scene to which this mask is being added.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                constructor(scene: Phaser.Scene, maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame);

                /**
                 * The Game Object that is used as the mask. Must use a texture, such as a Sprite.
                 */
                bitmapMask: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture;

                /**
                 * Whether to invert the masks alpha.
                 * 
                 * If `true`, the alpha of the masking pixel will be inverted before it's multiplied with the masked pixel.
                 * 
                 * Essentially, this means that a masked area will be visible only if the corresponding area in the mask is invisible.
                 */
                invertAlpha: boolean;

                /**
                 * Is this mask a stencil mask? This is false by default and should not be changed.
                 */
                readonly isStencil: boolean;

                /**
                 * Sets a new Game Object or Dynamic Texture for this Bitmap Mask to use.
                 * 
                 * If a Game Object it must have a texture, such as a Sprite.
                 * 
                 * You can update the source of the mask as often as you like.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If a Game Object, it must have a texture, such as a Sprite.
                 */
                setBitmap(maskObject: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture): void;

                /**
                 * Prepares the WebGL Renderer to render a Game Object with this mask applied.
                 * 
                 * This renders the masking Game Object to the mask framebuffer and switches to the main framebuffer so that the masked Game Object will be rendered to it instead of being rendered directly to the frame.
                 * @param renderer The WebGL Renderer to prepare.
                 * @param maskedObject The masked Game Object which will be drawn.
                 * @param camera The Camera to render to.
                 */
                preRenderWebGL(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer, maskedObject: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Finalizes rendering of a masked Game Object.
                 * 
                 * This resets the previously bound framebuffer and switches the WebGL Renderer to the Bitmap Mask Pipeline, which uses a special fragment shader to apply the masking effect.
                 * @param renderer The WebGL Renderer to clean up.
                 * @param camera The Camera to render to.
                 * @param renderTarget Optional WebGL RenderTarget.
                 */
                postRenderWebGL(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer, camera: Phaser.Cameras.Scene2D.Camera, renderTarget?: Phaser.Renderer.WebGL.RenderTarget): void;

                /**
                 * This is a NOOP method. Bitmap Masks are not supported by the Canvas Renderer.
                 * @param renderer The Canvas Renderer which would be rendered to.
                 * @param mask The masked Game Object which would be rendered.
                 * @param camera The Camera to render to.
                 */
                preRenderCanvas(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer, mask: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * This is a NOOP method. Bitmap Masks are not supported by the Canvas Renderer.
                 * @param renderer The Canvas Renderer which would be rendered to.
                 */
                postRenderCanvas(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer): void;

                /**
                 * Destroys this BitmapMask and nulls any references it holds.
                 * 
                 * Note that if a Game Object is currently using this mask it will _not_ automatically detect you have destroyed it,
                 * so be sure to call `clearMask` on any Game Object using it, before destroying it.
                 */
                destroy(): void;

            }

            /**
             * A Geometry Mask can be applied to a Game Object to hide any pixels of it which don't intersect
             * a visible pixel from the geometry mask. The mask is essentially a clipping path which can only
             * make a masked pixel fully visible or fully invisible without changing its alpha (opacity).
             * 
             * A Geometry Mask uses a Graphics Game Object to determine which pixels of the masked Game Object(s)
             * should be clipped. For any given point of a masked Game Object's texture, the pixel will only be displayed
             * if the Graphics Game Object of the Geometry Mask has a visible pixel at the same position. The color and
             * alpha of the pixel from the Geometry Mask do not matter.
             * 
             * The Geometry Mask's location matches the location of its Graphics object, not the location of the masked objects.
             * Moving or transforming the underlying Graphics object will change the mask (and affect the visibility
             * of any masked objects), whereas moving or transforming a masked object will not affect the mask.
             * You can think of the Geometry Mask (or rather, of its Graphics object) as an invisible curtain placed
             * in front of all masked objects which has its own visual properties and, naturally, respects the camera's
             * visual properties, but isn't affected by and doesn't follow the masked objects by itself.
             */
            class GeometryMask {
                /**
                 * 
                 * @param scene This parameter is not used.
                 * @param graphicsGeometry The Graphics Game Object to use for the Geometry Mask. Doesn't have to be in the Display List.
                 */
                constructor(scene: Phaser.Scene, graphicsGeometry: Phaser.GameObjects.Graphics);

                /**
                 * The Graphics object which describes the Geometry Mask.
                 */
                geometryMask: Phaser.GameObjects.Graphics;

                /**
                 * Similar to the BitmapMasks invertAlpha setting this to true will then hide all pixels
                 * drawn to the Geometry Mask.
                 * 
                 * This is a WebGL only feature.
                 */
                invertAlpha: boolean;

                /**
                 * Is this mask a stencil mask?
                 */
                readonly isStencil: boolean;

                /**
                 * The current stencil level. This can change dynamically at runtime
                 * and is set in the applyStencil method.
                 */
                level: boolean;

                /**
                 * Sets a new Graphics object for the Geometry Mask.
                 * @param graphicsGeometry The Graphics object which will be used for the Geometry Mask.
                 */
                setShape(graphicsGeometry: Phaser.GameObjects.Graphics): this;

                /**
                 * Sets the `invertAlpha` property of this Geometry Mask.
                 * 
                 * Inverting the alpha essentially flips the way the mask works.
                 * 
                 * This is a WebGL only feature.
                 * @param value Invert the alpha of this mask? Default true.
                 */
                setInvertAlpha(value?: boolean): this;

                /**
                 * Renders the Geometry Mask's underlying Graphics object to the OpenGL stencil buffer and enables the stencil test, which clips rendered pixels according to the mask.
                 * @param renderer The WebGL Renderer instance to draw to.
                 * @param child The Game Object being rendered.
                 * @param camera The camera the Game Object is being rendered through.
                 */
                preRenderWebGL(renderer: Phaser.Renderer.WebGL.WebGLRenderer, child: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Applies the current stencil mask to the renderer.
                 * @param renderer The WebGL Renderer instance to draw to.
                 * @param camera The camera the Game Object is being rendered through.
                 * @param inc Is this an INCR stencil or a DECR stencil?
                 */
                applyStencil(renderer: Phaser.Renderer.WebGL.WebGLRenderer, camera: Phaser.Cameras.Scene2D.Camera, inc: boolean): void;

                /**
                 * Flushes all rendered pixels and disables the stencil test of a WebGL context, thus disabling the mask for it.
                 * @param renderer The WebGL Renderer instance to draw flush.
                 */
                postRenderWebGL(renderer: Phaser.Renderer.WebGL.WebGLRenderer): void;

                /**
                 * Sets the clipping path of a 2D canvas context to the Geometry Mask's underlying Graphics object.
                 * @param renderer The Canvas Renderer instance to set the clipping path on.
                 * @param mask The Game Object being rendered.
                 * @param camera The camera the Game Object is being rendered through.
                 */
                preRenderCanvas(renderer: Phaser.Renderer.Canvas.CanvasRenderer, mask: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Restore the canvas context's previous clipping path, thus turning off the mask for it.
                 * @param renderer The Canvas Renderer instance being restored.
                 */
                postRenderCanvas(renderer: Phaser.Renderer.Canvas.CanvasRenderer): void;

                /**
                 * Destroys this GeometryMask and nulls any references it holds.
                 * 
                 * Note that if a Game Object is currently using this mask it will _not_ automatically detect you have destroyed it,
                 * so be sure to call `clearMask` on any Game Object using it, before destroying it.
                 */
                destroy(): void;

            }

        }

        /**
         * The RGB class holds a single color value and allows for easy modification and reading of it,
         * with optional on-change callback notification and a dirty flag.
         */
        class RGB {
            /**
             * 
             * @param red The red color value. A number between 0 and 1. Default 0.
             * @param green The green color value. A number between 0 and 1. Default 0.
             * @param blue The blue color value. A number between 0 and 1. Default 0.
             */
            constructor(red?: number, green?: number, blue?: number);

            /**
             * This callback will be invoked each time one of the RGB color values change.
             * 
             * The callback is sent the new color values as the parameters.
             */
            onChangeCallback: Function;

            /**
             * Is this color dirty?
             */
            dirty: boolean;

            /**
             * Sets the red, green and blue values of this RGB object, flags it as being
             * dirty and then invokes the `onChangeCallback`, if set.
             * @param red The red color value. A number between 0 and 1. Default 0.
             * @param green The green color value. A number between 0 and 1. Default 0.
             * @param blue The blue color value. A number between 0 and 1. Default 0.
             */
            set(red?: number, green?: number, blue?: number): this;

            /**
             * Compares the given rgb parameters with those in this object and returns
             * a boolean `true` value if they are equal, otherwise it returns `false`.
             * @param red The red value to compare with this object.
             * @param green The green value to compare with this object.
             * @param blue The blue value to compare with this object.
             */
            equals(red: number, green: number, blue: number): boolean;

            /**
             * Internal on change handler. Sets this object as being dirty and
             * then invokes the `onChangeCallback`, if set, passing in the
             * new RGB values.
             */
            onChange(): void;

            /**
             * The red color value. Between 0 and 1.
             * 
             * Changing this property will flag this RGB object as being dirty
             * and invoke the `onChangeCallback` , if set.
             */
            r: number;

            /**
             * The green color value. Between 0 and 1.
             * 
             * Changing this property will flag this RGB object as being dirty
             * and invoke the `onChangeCallback` , if set.
             */
            g: number;

            /**
             * The blue color value. Between 0 and 1.
             * 
             * Changing this property will flag this RGB object as being dirty
             * and invoke the `onChangeCallback` , if set.
             */
            b: number;

            /**
             * Nulls any external references this object contains.
             */
            destroy(): void;

        }

        /**
         * A BaseShader is a small resource class that contains the data required for a WebGL Shader to be created.
         * 
         * It contains the raw source code to the fragment and vertex shader, as well as an object that defines
         * the uniforms the shader requires, if any.
         * 
         * BaseShaders are stored in the Shader Cache, available in a Scene via `this.cache.shaders` and are referenced
         * by a unique key-based string. Retrieve them via `this.cache.shaders.get(key)`.
         * 
         * BaseShaders are created automatically by the GLSL File Loader when loading an external shader resource.
         * They can also be created at runtime, allowing you to use dynamically generated shader source code.
         * 
         * Default fragment and vertex source is used if not provided in the constructor, setting-up a basic shader,
         * suitable for debug rendering.
         */
        class BaseShader {
            /**
             * 
             * @param key The key of this shader. Must be unique within the shader cache.
             * @param fragmentSrc The fragment source for the shader.
             * @param vertexSrc The vertex source for the shader.
             * @param uniforms Optional object defining the uniforms the shader uses.
             */
            constructor(key: string, fragmentSrc?: string, vertexSrc?: string, uniforms?: any);

            /**
             * The key of this shader, unique within the shader cache of this Phaser game instance.
             */
            key: string;

            /**
             * The source code, as a string, of the fragment shader being used.
             */
            fragmentSrc: string;

            /**
             * The source code, as a string, of the vertex shader being used.
             */
            vertexSrc: string;

            /**
             * The default uniforms for this shader.
             */
            uniforms: any | null;

        }

    }

    namespace DOM {
        /**
         * Adds the given element to the DOM. If a parent is provided the element is added as a child of the parent, providing it was able to access it.
         * If no parent was given it falls back to using `document.body`.
         * @param element The element to be added to the DOM. Usually a Canvas object.
         * @param parent The parent in which to add the element. Can be a string which is passed to `getElementById` or an actual DOM object.
         */
        function AddToDOM(element: HTMLElement, parent?: string | HTMLElement): HTMLElement;

        /**
         * Inspects the readyState of the document. If the document is already complete then it invokes the given callback.
         * If not complete it sets up several event listeners such as `deviceready`, and once those fire, it invokes the callback.
         * Called automatically by the Phaser.Game instance. Should not usually be accessed directly.
         * @param callback The callback to be invoked when the device is ready and the DOM content is loaded.
         */
        function DOMContentLoaded(callback: ContentLoadedCallback): void;

        /**
         * Attempts to determine the document inner height across iOS and standard devices.
         * Based on code by @tylerjpeterson
         * @param iOS Is this running on iOS?
         */
        function GetInnerHeight(iOS: boolean): number;

        /**
         * Attempts to determine the screen orientation using the Orientation API.
         * @param width The width of the viewport.
         * @param height The height of the viewport.
         */
        function GetScreenOrientation(width: number, height: number): string;

        /**
         * Attempts to get the target DOM element based on the given value, which can be either
         * a string, in which case it will be looked-up by ID, or an element node. If nothing
         * can be found it will return a reference to the document.body.
         * @param element The DOM element to look-up.
         */
        function GetTarget(element: HTMLElement): void;

        /**
         * Takes the given data string and parses it as XML.
         * First tries to use the window.DOMParser and reverts to the Microsoft.XMLDOM if that fails.
         * The parsed XML object is returned, or `null` if there was an error while parsing the data.
         * @param data The XML source stored in a string.
         */
        function ParseXML(data: string): DOMParser | ActiveXObject | null;

        /**
         * Attempts to remove the element from its parentNode in the DOM.
         * @param element The DOM element to remove from its parent node.
         */
        function RemoveFromDOM(element: HTMLElement): void;

        /**
         * Abstracts away the use of RAF or setTimeOut for the core game update loop.
         * 
         * This is invoked automatically by the Phaser.Game instance.
         */
        class RequestAnimationFrame {
            /**
             * True if RequestAnimationFrame is running, otherwise false.
             */
            isRunning: boolean;

            /**
             * The callback to be invoked each step.
             */
            callback: FrameRequestCallback;

            /**
             * True if the step is using setTimeout instead of RAF.
             */
            isSetTimeOut: boolean;

            /**
             * The setTimeout or RAF callback ID used when canceling them.
             */
            timeOutID: number | null;

            /**
             * The delay rate in ms for setTimeOut.
             */
            delay: number;

            /**
             * The RAF step function.
             * 
             * Invokes the callback and schedules another call to requestAnimationFrame.
             */
            step: FrameRequestCallback;

            /**
             * The SetTimeout step function.
             * 
             * Invokes the callback and schedules another call to setTimeout.
             */
            stepTimeout: Function;

            /**
             * Starts the requestAnimationFrame or setTimeout process running.
             * @param callback The callback to invoke each step.
             * @param forceSetTimeOut Should it use SetTimeout, even if RAF is available?
             * @param delay The setTimeout delay rate in ms.
             */
            start(callback: FrameRequestCallback, forceSetTimeOut: boolean, delay: number): void;

            /**
             * Stops the requestAnimationFrame or setTimeout from running.
             */
            stop(): void;

            /**
             * Stops the step from running and clears the callback reference.
             */
            destroy(): void;

        }

    }

    namespace Events {
        /**
         * EventEmitter is a Scene Systems plugin compatible version of eventemitter3.
         */
        class EventEmitter {
            /**
             * Removes all listeners.
             */
            shutdown(): void;

            /**
             * Removes all listeners.
             */
            destroy(): void;

            /**
             * Return an array listing the events for which the emitter has registered listeners.
             */
            eventNames(): (string|symbol)[];

            /**
             * Return the listeners registered for a given event.
             * @param event The event name.
             */
            listeners(event: string | symbol): Function[];

            /**
             * Return the number of listeners listening to a given event.
             * @param event The event name.
             */
            listenerCount(event: string | symbol): number;

            /**
             * Calls each of the listeners registered for a given event.
             * @param event The event name.
             * @param args Additional arguments that will be passed to the event handler.
             */
            emit(event: string | symbol, ...args: any[]): boolean;

            /**
             * Add a listener for a given event.
             * @param event The event name.
             * @param fn The listener function.
             * @param context The context to invoke the listener with. Default this.
             */
            on(event: string | symbol, fn: Function, context?: any): this;

            /**
             * Add a listener for a given event.
             * @param event The event name.
             * @param fn The listener function.
             * @param context The context to invoke the listener with. Default this.
             */
            addListener(event: string | symbol, fn: Function, context?: any): this;

            /**
             * Add a one-time listener for a given event.
             * @param event The event name.
             * @param fn The listener function.
             * @param context The context to invoke the listener with. Default this.
             */
            once(event: string | symbol, fn: Function, context?: any): this;

            /**
             * Remove the listeners of a given event.
             * @param event The event name.
             * @param fn Only remove the listeners that match this function.
             * @param context Only remove the listeners that have this context.
             * @param once Only remove one-time listeners.
             */
            removeListener(event: string | symbol, fn?: Function, context?: any, once?: boolean): this;

            /**
             * Remove the listeners of a given event.
             * @param event The event name.
             * @param fn Only remove the listeners that match this function.
             * @param context Only remove the listeners that have this context.
             * @param once Only remove one-time listeners.
             */
            off(event: string | symbol, fn?: Function, context?: any, once?: boolean): this;

            /**
             * Remove all listeners, or those of the specified event.
             * @param event The event name.
             */
            removeAllListeners(event?: string | symbol): this;

        }

    }

    namespace FX {
        /**
         * The Barrel FX Controller.
         * 
         * This FX controller manages the barrel distortion effect for a Game Object.
         * 
         * A barrel effect allows you to apply either a 'pinch' or 'expand' distortion to
         * a Game Object. The amount of the effect can be modified in real-time.
         * 
         * A Barrel effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addBarrel();
         * sprite.postFX.addBarrel();
         * ```
         */
        class Barrel extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param amount The amount of distortion applied to the barrel effect. A value of 1 is no distortion. Typically keep this within +- 1. Default 1.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, amount?: number);

            /**
             * The amount of distortion applied to the barrel effect.
             * 
             * Typically keep this within the range 1 (no distortion) to +- 1.
             */
            amount: number;

        }

        /**
         * The Bloom FX Controller.
         * 
         * This FX controller manages the bloom effect for a Game Object.
         * 
         * Bloom is an effect used to reproduce an imaging artifact of real-world cameras.
         * The effect produces fringes of light extending from the borders of bright areas in an image,
         * contributing to the illusion of an extremely bright light overwhelming the
         * camera or eye capturing the scene.
         * 
         * A Bloom effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addBloom();
         * sprite.postFX.addBloom();
         * ```
         */
        class Bloom extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param color The color of the Bloom, as a hex value. Default 0xffffff.
             * @param offsetX The horizontal offset of the bloom effect. Default 1.
             * @param offsetY The vertical offset of the bloom effect. Default 1.
             * @param blurStrength The strength of the blur process of the bloom effect. Default 1.
             * @param strength The strength of the blend process of the bloom effect. Default 1.
             * @param steps The number of steps to run the Bloom effect for. This value should always be an integer. Default 4.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, color?: number, offsetX?: number, offsetY?: number, blurStrength?: number, strength?: number, steps?: number);

            /**
             * The number of steps to run the Bloom effect for.
             * 
             * This value should always be an integer.
             * 
             * It defaults to 4. The higher the value, the smoother the Bloom,
             * but at the cost of exponentially more gl operations.
             * 
             * Keep this to the lowest possible number you can have it, while
             * still looking correct for your game.
             */
            steps: number;

            /**
             * The horizontal offset of the bloom effect.
             */
            offsetX: number;

            /**
             * The vertical offset of the bloom effect.
             */
            offsetY: number;

            /**
             * The strength of the blur process of the bloom effect.
             */
            blurStrength: number;

            /**
             * The strength of the blend process of the bloom effect.
             */
            strength: number;

            /**
             * The internal gl color array.
             */
            glcolor: number[];

            /**
             * The color of the bloom as a number value.
             */
            color: number;

        }

        /**
         * The Blur FX Controller.
         * 
         * This FX controller manages the blur effect for a Game Object.
         * 
         * A Gaussian blur is the result of blurring an image by a Gaussian function. It is a widely used effect,
         * typically to reduce image noise and reduce detail. The visual effect of this blurring technique is a
         * smooth blur resembling that of viewing the image through a translucent screen, distinctly different
         * from the bokeh effect produced by an out-of-focus lens or the shadow of an object under usual illumination.
         * 
         * A Blur effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addBlur();
         * sprite.postFX.addBlur();
         * ```
         */
        class Blur extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param quality The quality of the blur effect. Can be either 0 for Low Quality, 1 for Medium Quality or 2 for High Quality. Default 0.
             * @param x The horizontal offset of the blur effect. Default 2.
             * @param y The vertical offset of the blur effect. Default 2.
             * @param strength The strength of the blur effect. Default 1.
             * @param color The color of the blur, as a hex value. Default 0xffffff.
             * @param steps The number of steps to run the blur effect for. This value should always be an integer. Default 4.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, quality?: number, x?: number, y?: number, strength?: number, color?: number, steps?: number);

            /**
             * The quality of the blur effect.
             * 
             * This can be:
             * 
             * 0 for Low Quality
             * 1 for Medium Quality
             * 2 for High Quality
             * 
             * The higher the quality, the more complex shader is used
             * and the more processing time is spent on the GPU calculating
             * the final blur. This value is used in conjunction with the
             * `steps` value, as one has a direct impact on the other.
             * 
             * Keep this value as low as you can, while still achieving the
             * desired effect you need for your game.
             */
            quality: number;

            /**
             * The horizontal offset of the blur effect.
             */
            x: number;

            /**
             * The vertical offset of the blur effect.
             */
            y: number;

            /**
             * The number of steps to run the Blur effect for.
             * 
             * This value should always be an integer.
             * 
             * It defaults to 4. The higher the value, the smoother the blur,
             * but at the cost of exponentially more gl operations.
             * 
             * Keep this to the lowest possible number you can have it, while
             * still looking correct for your game.
             */
            steps: number;

            /**
             * The strength of the blur effect.
             */
            strength: number;

            /**
             * The internal gl color array.
             */
            glcolor: number[];

            /**
             * The color of the blur as a number value.
             */
            color: number;

        }

        /**
         * The Bokeh FX Controller.
         * 
         * This FX controller manages the bokeh effect for a Game Object.
         * 
         * Bokeh refers to a visual effect that mimics the photographic technique of creating a shallow depth of field.
         * This effect is used to emphasize the game's main subject or action, by blurring the background or foreground
         * elements, resulting in a more immersive and visually appealing experience. It is achieved through rendering
         * techniques that simulate the out-of-focus areas, giving a sense of depth and realism to the game's graphics.
         * 
         * This effect can also be used to generate a Tilt Shift effect, which is a technique used to create a miniature
         * effect by blurring everything except a small area of the image. This effect is achieved by blurring the
         * top and bottom elements, while keeping the center area in focus.
         * 
         * A Bokeh effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addBokeh();
         * sprite.postFX.addBokeh();
         * ```
         */
        class Bokeh extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param radius The radius of the bokeh effect. Default 0.5.
             * @param amount The amount of the bokeh effect. Default 1.
             * @param contrast The color contrast of the bokeh effect. Default 0.2.
             * @param isTiltShift Is this a bokeh or Tile Shift effect? Default false.
             * @param blurX If Tilt Shift, the amount of horizontal blur. Default 1.
             * @param blurY If Tilt Shift, the amount of vertical blur. Default 1.
             * @param strength If Tilt Shift, the strength of the blur. Default 1.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, radius?: number, amount?: number, contrast?: number, isTiltShift?: boolean, blurX?: number, blurY?: number, strength?: number);

            /**
             * The radius of the bokeh effect.
             * 
             * This is a float value, where a radius of 0 will result in no effect being applied,
             * and a radius of 1 will result in a strong bokeh. However, you can exceed this value
             * for even stronger effects.
             */
            radius: number;

            /**
             * The amount, or strength, of the bokeh effect. Defaults to 1.
             */
            amount: number;

            /**
             * The color contrast, or brightness, of the bokeh effect. Defaults to 0.2.
             */
            contrast: number;

            /**
             * Is this a Tilt Shift effect or a standard bokeh effect?
             */
            isTiltShift: boolean;

            /**
             * If a Tilt Shift effect this controls the strength of the blur.
             * 
             * Setting this value on a non-Tilt Shift effect will have no effect.
             */
            strength: number;

            /**
             * If a Tilt Shift effect this controls the amount of horizontal blur.
             * 
             * Setting this value on a non-Tilt Shift effect will have no effect.
             */
            blurX: number;

            /**
             * If a Tilt Shift effect this controls the amount of vertical blur.
             * 
             * Setting this value on a non-Tilt Shift effect will have no effect.
             */
            blurY: number;

        }

        /**
         * The Circle FX Controller.
         * 
         * This FX controller manages the circle effect for a Game Object.
         * 
         * This effect will draw a circle around the texture of the Game Object, effectively masking off
         * any area outside of the circle without the need for an actual mask. You can control the thickness
         * of the circle, the color of the circle and the color of the background, should the texture be
         * transparent. You can also control the feathering applied to the circle, allowing for a harsh or soft edge.
         * 
         * Please note that adding this effect to a Game Object will not change the input area or physics body of
         * the Game Object, should it have one.
         * 
         * A Circle effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addCircle();
         * sprite.postFX.addCircle();
         * ```
         */
        class Circle extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param thickness The width of the circle around the texture, in pixels. Default 8.
             * @param color The color of the circular ring, given as a number value. Default 0xfeedb6.
             * @param backgroundColor The color of the background, behind the texture, given as a number value. Default 0xff0000.
             * @param scale The scale of the circle. The default scale is 1, which is a circle the full size of the underlying texture. Default 1.
             * @param feather The amount of feathering to apply to the circle from the ring. Default 0.005.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, thickness?: number, color?: number, backgroundColor?: number, scale?: number, feather?: number);

            /**
             * The scale of the circle. The default scale is 1, which is a circle
             * the full size of the underlying texture. Reduce this value to create
             * a smaller circle, or increase it to create a circle that extends off
             * the edges of the texture.
             */
            scale: number;

            /**
             * The amount of feathering to apply to the circle from the ring,
             * extending into the middle of the circle. The default is 0.005,
             * which is a very low amount of feathering just making sure the ring
             * has a smooth edge. Increase this amount to a value such as 0.5
             * or 0.025 for larger amounts of feathering.
             */
            feather: number;

            /**
             * The width of the circle around the texture, in pixels. This value
             * doesn't factor in the feather, which can extend the thickness
             * internally depending on its value.
             */
            thickness: number;

            /**
             * The internal gl color array for the ring color.
             */
            glcolor: number[];

            /**
             * The internal gl color array for the background color.
             */
            glcolor2: number[];

            /**
             * The color of the circular ring, given as a number value.
             */
            color: number;

            /**
             * The color of the background, behind the texture, given as a number value.
             */
            backgroundColor: number;

            /**
             * The alpha of the background, behind the texture, given as a number value.
             */
            backgroundAlpha: number;

        }

        /**
         * The ColorMatrix FX Controller.
         * 
         * This FX controller manages the color matrix effect for a Game Object.
         * 
         * The color matrix effect is a visual technique that involves manipulating the colors of an image
         * or scene using a mathematical matrix. This process can adjust hue, saturation, brightness, and contrast,
         * allowing developers to create various stylistic appearances or mood settings within the game.
         * Common applications include simulating different lighting conditions, applying color filters,
         * or achieving a specific visual style.
         * 
         * A ColorMatrix effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addColorMatrix();
         * sprite.postFX.addColorMatrix();
         * ```
         */
        class ColorMatrix extends Phaser.Display.ColorMatrix {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject);

            /**
             * The FX_CONST type of this effect.
             */
            type: number;

            /**
             * A reference to the Game Object that owns this effect.
             */
            gameObject: Phaser.GameObjects.GameObject;

            /**
             * Toggle this boolean to enable or disable this effect,
             * without removing and adding it from the Game Object.
             */
            active: boolean;

        }

        /**
         * The Glow FX.
         */
        const GLOW: number;

        /**
         * The Shadow FX.
         */
        const SHADOW: number;

        /**
         * The Pixelate FX.
         */
        const PIXELATE: number;

        /**
         * The Vignette FX.
         */
        const VIGNETTE: number;

        /**
         * The Shine FX.
         */
        const SHINE: number;

        /**
         * The Blur FX.
         */
        const BLUR: number;

        /**
         * The Gradient FX.
         */
        const GRADIENT: number;

        /**
         * The Bloom FX.
         */
        const BLOOM: number;

        /**
         * The Color Matrix FX.
         */
        const COLOR_MATRIX: number;

        /**
         * The Circle FX.
         */
        const CIRCLE: number;

        /**
         * The Barrel FX.
         */
        const BARREL: number;

        /**
         * The Displacement FX.
         */
        const DISPLACEMENT: number;

        /**
         * The Wipe FX.
         */
        const WIPE: number;

        /**
         * The Bokeh and Tilt Shift FX.
         */
        const BOKEH: number;

        /**
         * FX Controller is the base class that all built-in FX use.
         * 
         * You should not normally create an instance of this class directly, but instead use one of the built-in FX that extend it.
         */
        class Controller {
            /**
             * 
             * @param type The FX Type constant.
             * @param gameObject A reference to the Game Object that has this fx.
             */
            constructor(type: number, gameObject: Phaser.GameObjects.GameObject);

            /**
             * The FX_CONST type of this effect.
             */
            type: number;

            /**
             * A reference to the Game Object that owns this effect.
             */
            gameObject: Phaser.GameObjects.GameObject;

            /**
             * Toggle this boolean to enable or disable this effect,
             * without removing and adding it from the Game Object.
             * 
             * Only works for Pre FX.
             * 
             * Post FX are always active.
             */
            active: boolean;

            /**
             * Sets the active state of this FX Controller.
             * 
             * A disabled FX Controller will not be updated.
             * @param value `true` to enable this FX Controller, or `false` to disable it.
             */
            setActive(value: boolean): this;

            /**
             * Destroys this FX Controller.
             */
            destroy(): void;

        }

        /**
         * The Displacement FX Controller.
         * 
         * This FX controller manages the displacement effect for a Game Object.
         * 
         * The displacement effect is a visual technique that alters the position of pixels in an image
         * or texture based on the values of a displacement map. This effect is used to create the illusion
         * of depth, surface irregularities, or distortion in otherwise flat elements. It can be applied to
         * characters, objects, or backgrounds to enhance realism, convey movement, or achieve various
         * stylistic appearances.
         * 
         * A Displacement effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addDisplacement();
         * sprite.postFX.addDisplacement();
         * ```
         */
        class Displacement extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param texture The unique string-based key of the texture to use for displacement, which must exist in the Texture Manager. Default '__WHITE'.
             * @param x The amount of horizontal displacement to apply. A very small float number, such as 0.005. Default 0.005.
             * @param y The amount of vertical displacement to apply. A very small float number, such as 0.005. Default 0.005.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, texture?: string, x?: number, y?: number);

            /**
             * The amount of horizontal displacement to apply.
             */
            x: number;

            /**
             * The amount of vertical displacement to apply.
             */
            y: number;

            /**
             * The underlying WebGLTexture used for displacement.
             */
            glTexture: WebGLTexture;

        }

        /**
         * The Glow FX Controller.
         * 
         * This FX controller manages the glow effect for a Game Object.
         * 
         * The glow effect is a visual technique that creates a soft, luminous halo around game objects,
         * characters, or UI elements. This effect is used to emphasize importance, enhance visual appeal,
         * or convey a sense of energy, magic, or otherworldly presence. The effect can also be set on
         * the inside of the Game Object. The color and strength of the glow can be modified.
         * 
         * A Glow effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addGlow();
         * sprite.postFX.addGlow();
         * ```
         */
        class Glow extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param color The color of the glow effect as a number value. Default 0xffffff.
             * @param outerStrength The strength of the glow outward from the edge of the Sprite. Default 4.
             * @param innerStrength The strength of the glow inward from the edge of the Sprite. Default 0.
             * @param knockout If `true` only the glow is drawn, not the texture itself. Default false.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, color?: number, outerStrength?: number, innerStrength?: number, knockout?: boolean);

            /**
             * The strength of the glow outward from the edge of the Sprite.
             */
            outerStrength: number;

            /**
             * The strength of the glow inward from the edge of the Sprite.
             */
            innerStrength: number;

            /**
             * If `true` only the glow is drawn, not the texture itself.
             */
            knockout: number;

            /**
             * A 4 element array of gl color values.
             */
            glcolor: number[];

            /**
             * The color of the glow as a number value.
             */
            color: number;

        }

        /**
         * The Gradient FX Controller.
         * 
         * This FX controller manages the gradient effect for a Game Object.
         * 
         * The gradient overlay effect is a visual technique where a smooth color transition is applied over Game Objects,
         * such as sprites or UI components. This effect is used to enhance visual appeal, emphasize depth, or create
         * stylistic and atmospheric variations. It can also be utilized to convey information, such as representing
         * progress or health status through color changes.
         * 
         * A Gradient effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addGradient();
         * sprite.postFX.addGradient();
         * ```
         */
        class Gradient extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param color1 The first gradient color, given as a number value. Default 0xff0000.
             * @param color2 The second gradient color, given as a number value. Default 0x00ff00.
             * @param alpha The alpha value of the gradient effect. Default 0.2.
             * @param fromX The horizontal position the gradient will start from. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
             * @param fromY The vertical position the gradient will start from. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
             * @param toX The horizontal position the gradient will end at. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
             * @param toY The vertical position the gradient will end at. This value is normalized, between 0 and 1, and is not in pixels. Default 1.
             * @param size How many 'chunks' the gradient is divided in to, as spread over the entire height of the texture. Leave this at zero for a smooth gradient, or set higher for a more retro chunky effect. Default 0.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, color1?: number, color2?: number, alpha?: number, fromX?: number, fromY?: number, toX?: number, toY?: number, size?: number);

            /**
             * The alpha value of the gradient effect.
             */
            alpha: number;

            /**
             * Sets how many 'chunks' the gradient is divided in to, as spread over the
             * entire height of the texture. Leave this at zero for a smooth gradient,
             * or set to a higher number to split the gradient into that many sections, giving
             * a more banded 'retro' effect.
             */
            size: number;

            /**
             * The horizontal position the gradient will start from. This value is normalized, between 0 and 1 and is not in pixels.
             */
            fromX: number;

            /**
             * The vertical position the gradient will start from. This value is normalized, between 0 and 1 and is not in pixels.
             */
            fromY: number;

            /**
             * The horizontal position the gradient will end. This value is normalized, between 0 and 1 and is not in pixels.
             */
            toX: number;

            /**
             * The vertical position the gradient will end. This value is normalized, between 0 and 1 and is not in pixels.
             */
            toY: number;

            /**
             * The internal gl color array for the starting color.
             */
            glcolor1: number[];

            /**
             * The internal gl color array for the ending color.
             */
            glcolor2: number[];

            /**
             * The first gradient color, given as a number value.
             */
            color1: number;

            /**
             * The second gradient color, given as a number value.
             */
            color2: number;

        }

        /**
         * The Pixelate FX Controller.
         * 
         * This FX controller manages the pixelate effect for a Game Object.
         * 
         * The pixelate effect is a visual technique that deliberately reduces the resolution or detail of an image,
         * creating a blocky or mosaic appearance composed of large, visible pixels. This effect can be used for stylistic
         * purposes, as a homage to retro gaming, or as a means to obscure certain elements within the game, such as
         * during a transition or to censor specific content.
         * 
         * A Pixelate effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addPixelate();
         * sprite.postFX.addPixelate();
         * ```
         */
        class Pixelate extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param amount The amount of pixelation to apply. Default 1.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, amount?: number);

            /**
             * The amount of pixelation to apply.
             */
            amount: number;

        }

        /**
         * The Shadow FX Controller.
         * 
         * This FX controller manages the shadow effect for a Game Object.
         * 
         * The shadow effect is a visual technique used to create the illusion of depth and realism by adding darker,
         * offset silhouettes or shapes beneath game objects, characters, or environments. These simulated shadows
         * help to enhance the visual appeal and immersion, making the 2D game world appear more dynamic and three-dimensional.
         * 
         * A Shadow effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addShadow();
         * sprite.postFX.addShadow();
         * ```
         */
        class Shadow extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param x The horizontal offset of the shadow effect. Default 0.
             * @param y The vertical offset of the shadow effect. Default 0.
             * @param decay The amount of decay for shadow effect. Default 0.1.
             * @param power The power of the shadow effect. Default 1.
             * @param color The color of the shadow. Default 0x000000.
             * @param samples The number of samples that the shadow effect will run for. An integer between 1 and 12. Default 6.
             * @param intensity The intensity of the shadow effect. Default 1.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, x?: number, y?: number, decay?: number, power?: number, color?: number, samples?: number, intensity?: number);

            /**
             * The horizontal offset of the shadow effect.
             */
            x: number;

            /**
             * The vertical offset of the shadow effect.
             */
            y: number;

            /**
             * The amount of decay for the shadow effect.
             */
            decay: number;

            /**
             * The power of the shadow effect.
             */
            power: number;

            /**
             * The internal gl color array.
             */
            glcolor: number[];

            /**
             * The number of samples that the shadow effect will run for.
             * 
             * This should be an integer with a minimum value of 1 and a maximum of 12.
             */
            samples: number;

            /**
             * The intensity of the shadow effect.
             */
            intensity: number;

            /**
             * The color of the shadow.
             */
            color: number;

        }

        /**
         * The Shine FX Controller.
         * 
         * This FX controller manages the shift effect for a Game Object.
         * 
         * The shine effect is a visual technique that simulates the appearance of reflective
         * or glossy surfaces by passing a light beam across a Game Object. This effect is used to
         * enhance visual appeal, emphasize certain features, and create a sense of depth or
         * material properties.
         * 
         * A Shine effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addShine();
         * sprite.postFX.addShine();
         * ```
         */
        class Shine extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param speed The speed of the Shine effect. Default 0.5.
             * @param lineWidth The line width of the Shine effect. Default 0.5.
             * @param gradient The gradient of the Shine effect. Default 3.
             * @param reveal Does this Shine effect reveal or get added to its target? Default false.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, speed?: number, lineWidth?: number, gradient?: number, reveal?: boolean);

            /**
             * The speed of the Shine effect.
             */
            speed: number;

            /**
             * The line width of the Shine effect.
             */
            lineWidth: number;

            /**
             * The gradient of the Shine effect.
             */
            gradient: number;

            /**
             * Does this Shine effect reveal or get added to its target?
             */
            reveal: boolean;

        }

        /**
         * The Vignette FX Controller.
         * 
         * This FX controller manages the vignette effect for a Game Object.
         * 
         * The vignette effect is a visual technique where the edges of the screen, or a Game Object, gradually darken or blur,
         * creating a frame-like appearance. This effect is used to draw the player's focus towards the central action or subject,
         * enhance immersion, and provide a cinematic or artistic quality to the game's visuals.
         * 
         * A Vignette effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addVignette();
         * sprite.postFX.addVignette();
         * ```
         */
        class Vignette extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param x The horizontal offset of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
             * @param y The vertical offset of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
             * @param radius The radius of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
             * @param strength The strength of the vignette effect. Default 0.5.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, x?: number, y?: number, radius?: number, strength?: number);

            /**
             * The horizontal offset of the vignette effect. This value is normalized to the range 0 to 1.
             */
            x: number;

            /**
             * The vertical offset of the vignette effect. This value is normalized to the range 0 to 1.
             */
            y: number;

            /**
             * The radius of the vignette effect. This value is normalized to the range 0 to 1.
             */
            radius: number;

            /**
             * The strength of the vignette effect.
             */
            strength: number;

        }

        /**
         * The Wipe FX Controller.
         * 
         * This FX controller manages the wipe effect for a Game Object.
         * 
         * The wipe or reveal effect is a visual technique that gradually uncovers or conceals elements
         * in the game, such as images, text, or scene transitions. This effect is often used to create
         * a sense of progression, reveal hidden content, or provide a smooth and visually appealing transition
         * between game states.
         * 
         * You can set both the direction and the axis of the wipe effect. The following combinations are possible:
         * 
         * * left to right: direction 0, axis 0
         * * right to left: direction 1, axis 0
         * * top to bottom: direction 1, axis 1
         * * bottom to top: direction 1, axis 0
         * 
         * It is up to you to set the `progress` value yourself, i.e. via a Tween, in order to transition the effect.
         * 
         * A Wipe effect is added to a Game Object via the FX component:
         * 
         * ```js
         * const sprite = this.add.sprite();
         * 
         * sprite.preFX.addWipe();
         * sprite.postFX.addWipe();
         * sprite.preFX.addReveal();
         * sprite.postFX.addReveal();
         * ```
         */
        class Wipe extends Phaser.FX.Controller {
            /**
             * 
             * @param gameObject A reference to the Game Object that has this fx.
             * @param wipeWidth The width of the wipe effect. This value is normalized in the range 0 to 1. Default 0.1.
             * @param direction The direction of the wipe effect. Either 0 or 1. Set in conjunction with the axis property. Default 0.
             * @param axis The axis of the wipe effect. Either 0 or 1. Set in conjunction with the direction property. Default 0.
             * @param reveal Is this a reveal (true) or a fade (false) effect? Default false.
             */
            constructor(gameObject: Phaser.GameObjects.GameObject, wipeWidth?: number, direction?: number, axis?: number, reveal?: boolean);

            /**
             * The progress of the Wipe effect. This value is normalized to the range 0 to 1.
             * 
             * Adjust this value to make the wipe transition (i.e. via a Tween)
             */
            progress: number;

            /**
             * The width of the wipe effect. This value is normalized in the range 0 to 1.
             */
            wipeWidth: number;

            /**
             * The direction of the wipe effect. Either 0 or 1. Set in conjunction with the axis property.
             */
            direction: number;

            /**
             * The axis of the wipe effect. Either 0 or 1. Set in conjunction with the direction property.
             */
            axis: number;

            /**
             * Is this a reveal (true) or a fade (false) effect?
             */
            reveal: boolean;

        }

    }

    namespace GameObjects {
        /**
         * BitmapText objects work by taking a texture file and an XML or JSON file that describes the font structure.
         * 
         * During rendering for each letter of the text is rendered to the display, proportionally spaced out and aligned to
         * match the font structure.
         * 
         * Dynamic Bitmap Text objects are different from Static Bitmap Text in that they invoke a callback for each
         * letter being rendered during the render pass. This callback allows you to manipulate the properties of
         * each letter being rendered, such as its position, scale or tint, allowing you to create interesting effects
         * like jiggling text, which can't be done with Static text. This means that Dynamic Text takes more processing
         * time, so only use them if you require the callback ability they have.
         * 
         * BitmapText objects are less flexible than Text objects, in that they have less features such as shadows, fills and the ability
         * to use Web Fonts, however you trade this flexibility for rendering speed. You can also create visually compelling BitmapTexts by
         * processing the font texture in an image editor, applying fills and any other effects required.
         * 
         * To create multi-line text insert \r, \n or \r\n escape codes into the text string.
         * 
         * To create a BitmapText data files you need a 3rd party app such as:
         * 
         * BMFont (Windows, free): {@link http://www.angelcode.com/products/bmfont/|http://www.angelcode.com/products/bmfont/}
         * Glyph Designer (OS X, commercial): {@link http://www.71squared.com/en/glyphdesigner|http://www.71squared.com/en/glyphdesigner}
         * Snow BMF (Web-based, free): {@link https://snowb.org//|https://snowb.org/}
         * Littera (Flash-based, free): {@link http://kvazars.com/littera/|http://kvazars.com/littera/}
         * 
         * For most use cases it is recommended to use XML. If you wish to use JSON, the formatting should be equal to the result of
         * converting a valid XML file through the popular X2JS library. An online tool for conversion can be found here: {@link http://codebeautify.org/xmltojson|http://codebeautify.org/xmltojson}
         */
        class DynamicBitmapText extends Phaser.GameObjects.BitmapText {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. It can only belong to one Scene at any given time.
             * @param x The x coordinate of this Game Object in world space.
             * @param y The y coordinate of this Game Object in world space.
             * @param font The key of the font to use from the Bitmap Font cache.
             * @param text The string, or array of strings, to be set as the content of this Bitmap Text.
             * @param size The font size of this Bitmap Text.
             * @param align The alignment of the text in a multi-line BitmapText object. Default 0.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, font: string, text?: string | string[], size?: number, align?: number);

            /**
             * The horizontal scroll position of the Bitmap Text.
             */
            scrollX: number;

            /**
             * The vertical scroll position of the Bitmap Text.
             */
            scrollY: number;

            /**
             * The crop width of the Bitmap Text.
             */
            cropWidth: number;

            /**
             * The crop height of the Bitmap Text.
             */
            cropHeight: number;

            /**
             * A callback that alters how each character of the Bitmap Text is rendered.
             */
            displayCallback: Phaser.Types.GameObjects.BitmapText.DisplayCallback;

            /**
             * The data object that is populated during rendering, then passed to the displayCallback.
             * You should modify this object then return it back from the callback. It's updated values
             * will be used to render the specific glyph.
             * 
             * Please note that if you need a reference to this object locally in your game code then you
             * should shallow copy it, as it's updated and re-used for every glyph in the text.
             */
            callbackData: Phaser.Types.GameObjects.BitmapText.DisplayCallbackConfig;

            /**
             * Set the crop size of this Bitmap Text.
             * @param width The width of the crop.
             * @param height The height of the crop.
             */
            setSize(width: number, height: number): this;

            /**
             * Set a callback that alters how each character of the Bitmap Text is rendered.
             * 
             * The callback receives a {@link Phaser.Types.GameObjects.BitmapText.DisplayCallbackConfig} object that contains information about the character that's
             * about to be rendered.
             * 
             * It should return an object with `x`, `y`, `scale` and `rotation` properties that will be used instead of the
             * usual values when rendering.
             * @param callback The display callback to set.
             */
            setDisplayCallback(callback: Phaser.Types.GameObjects.BitmapText.DisplayCallback): this;

            /**
             * Set the horizontal scroll position of this Bitmap Text.
             * @param value The horizontal scroll position to set.
             */
            setScrollX(value: number): this;

            /**
             * Set the vertical scroll position of this Bitmap Text.
             * @param value The vertical scroll position to set.
             */
            setScrollY(value: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        namespace RetroFont {
            /**
             * Text Set 1 =  !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~
             */
            var TEXT_SET1: string;

            /**
             * Text Set 2 =  !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ
             */
            var TEXT_SET2: string;

            /**
             * Text Set 3 = ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
             */
            var TEXT_SET3: string;

            /**
             * Text Set 4 = ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789
             */
            var TEXT_SET4: string;

            /**
             * Text Set 5 = ABCDEFGHIJKLMNOPQRSTUVWXYZ.,/() '!?-*:0123456789
             */
            var TEXT_SET5: string;

            /**
             * Text Set 6 = ABCDEFGHIJKLMNOPQRSTUVWXYZ!?:;0123456789"(),-.'
             */
            var TEXT_SET6: string;

            /**
             * Text Set 7 = AGMSY+:4BHNTZ!;5CIOU.?06DJPV,(17EKQW")28FLRX-'39
             */
            var TEXT_SET7: string;

            /**
             * Text Set 8 = 0123456789 .ABCDEFGHIJKLMNOPQRSTUVWXYZ
             */
            var TEXT_SET8: string;

            /**
             * Text Set 9 = ABCDEFGHIJKLMNOPQRSTUVWXYZ()-0123456789.:,'"?!
             */
            var TEXT_SET9: string;

            /**
             * Text Set 10 = ABCDEFGHIJKLMNOPQRSTUVWXYZ
             */
            var TEXT_SET10: string;

            /**
             * Text Set 11 = ABCDEFGHIJKLMNOPQRSTUVWXYZ.,"-+!?()':;0123456789
             */
            var TEXT_SET11: string;

            /**
             * Parses a Retro Font configuration object so you can pass it to the BitmapText constructor
             * and create a BitmapText object using a fixed-width retro font.
             * @param scene A reference to the Phaser Scene.
             * @param config The font configuration object.
             */
            function Parse(scene: Phaser.Scene, config: Phaser.Types.GameObjects.BitmapText.RetroFontConfig): Phaser.Types.GameObjects.BitmapText.BitmapFontData;

        }

        /**
         * BitmapText objects work by taking a texture file and an XML or JSON file that describes the font structure.
         * 
         * During rendering for each letter of the text is rendered to the display, proportionally spaced out and aligned to
         * match the font structure.
         * 
         * BitmapText objects are less flexible than Text objects, in that they have less features such as shadows, fills and the ability
         * to use Web Fonts, however you trade this flexibility for rendering speed. You can also create visually compelling BitmapTexts by
         * processing the font texture in an image editor, applying fills and any other effects required.
         * 
         * To create multi-line text insert \r, \n or \r\n escape codes into the text string.
         * 
         * To create a BitmapText data files you need a 3rd party app such as:
         * 
         * BMFont (Windows, free): {@link http://www.angelcode.com/products/bmfont/|http://www.angelcode.com/products/bmfont/}
         * Glyph Designer (OS X, commercial): {@link http://www.71squared.com/en/glyphdesigner|http://www.71squared.com/en/glyphdesigner}
         * Snow BMF (Web-based, free): {@link https://snowb.org//|https://snowb.org/}
         * Littera (Flash-based, free): {@link http://kvazars.com/littera/|http://kvazars.com/littera/}
         * 
         * For most use cases it is recommended to use XML. If you wish to use JSON, the formatting should be equal to the result of
         * converting a valid XML file through the popular X2JS library. An online tool for conversion can be found here: {@link http://codebeautify.org/xmltojson|http://codebeautify.org/xmltojson}
         */
        class BitmapText extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. It can only belong to one Scene at any given time.
             * @param x The x coordinate of this Game Object in world space.
             * @param y The y coordinate of this Game Object in world space.
             * @param font The key of the font to use from the Bitmap Font cache.
             * @param text The string, or array of strings, to be set as the content of this Bitmap Text.
             * @param size The font size of this Bitmap Text.
             * @param align The alignment of the text in a multi-line BitmapText object. Default 0.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, font: string, text?: string | string[], size?: number, align?: number);

            /**
             * The key of the Bitmap Font used by this Bitmap Text.
             * To change the font after creation please use `setFont`.
             */
            readonly font: string;

            /**
             * The data of the Bitmap Font used by this Bitmap Text.
             */
            readonly fontData: Phaser.Types.GameObjects.BitmapText.BitmapFontData;

            /**
             * The character code used to detect for word wrapping.
             * Defaults to 32 (a space character).
             */
            wordWrapCharCode: number;

            /**
             * The horizontal offset of the drop shadow.
             * 
             * You can set this directly, or use `Phaser.GameObjects.BitmapText#setDropShadow`.
             */
            dropShadowX: number;

            /**
             * The vertical offset of the drop shadow.
             * 
             * You can set this directly, or use `Phaser.GameObjects.BitmapText#setDropShadow`.
             */
            dropShadowY: number;

            /**
             * The color of the drop shadow.
             * 
             * You can set this directly, or use `Phaser.GameObjects.BitmapText#setDropShadow`.
             */
            dropShadowColor: number;

            /**
             * The alpha value of the drop shadow.
             * 
             * You can set this directly, or use `Phaser.GameObjects.BitmapText#setDropShadow`.
             */
            dropShadowAlpha: number;

            /**
             * Indicates whether the font texture is from an atlas or not.
             */
            readonly fromAtlas: boolean;

            /**
             * Set the lines of text in this BitmapText to be left-aligned.
             * This only has any effect if this BitmapText contains more than one line of text.
             */
            setLeftAlign(): this;

            /**
             * Set the lines of text in this BitmapText to be center-aligned.
             * This only has any effect if this BitmapText contains more than one line of text.
             */
            setCenterAlign(): this;

            /**
             * Set the lines of text in this BitmapText to be right-aligned.
             * This only has any effect if this BitmapText contains more than one line of text.
             */
            setRightAlign(): this;

            /**
             * Set the font size of this Bitmap Text.
             * @param size The font size to set.
             */
            setFontSize(size: number): this;

            /**
             * Sets the letter spacing between each character of this Bitmap Text.
             * Can be a positive value to increase the space, or negative to reduce it.
             * Spacing is applied after the kerning values have been set.
             * @param spacing The amount of horizontal space to add between each character. Default 0.
             */
            setLetterSpacing(spacing?: number): this;

            /**
             * Sets the line spacing value. This value is added to the font height to
             * calculate the overall line height.
             * 
             * Spacing can be a negative or positive number.
             * 
             * Only has an effect if this BitmapText object contains multiple lines of text.
             * @param spacing The amount of space to add between each line in multi-line text. Default 0.
             */
            setLineSpacing(spacing?: number): this;

            /**
             * Set the textual content of this BitmapText.
             * 
             * An array of strings will be converted into multi-line text. Use the align methods to change multi-line alignment.
             * @param value The string, or array of strings, to be set as the content of this BitmapText.
             */
            setText(value: string | string[]): this;

            /**
             * Sets a drop shadow effect on this Bitmap Text.
             * 
             * This is a WebGL only feature and only works with Static Bitmap Text, not Dynamic.
             * 
             * You can set the vertical and horizontal offset of the shadow, as well as the color and alpha.
             * 
             * Once a shadow has been enabled you can modify the `dropShadowX` and `dropShadowY` properties of this
             * Bitmap Text directly to adjust the position of the shadow in real-time.
             * 
             * If you wish to clear the shadow, call this method with no parameters specified.
             * @param x The horizontal offset of the drop shadow. Default 0.
             * @param y The vertical offset of the drop shadow. Default 0.
             * @param color The color of the drop shadow, given as a hex value, i.e. `0x000000` for black. Default 0x000000.
             * @param alpha The alpha of the drop shadow, given as a float between 0 and 1. This is combined with the Bitmap Text alpha as well. Default 0.5.
             */
            setDropShadow(x?: number, y?: number, color?: number, alpha?: number): this;

            /**
             * Sets a tint on a range of characters in this Bitmap Text, starting from the `start` parameter index
             * and running for `length` quantity of characters.
             * 
             * The `start` parameter can be negative. In this case, it starts at the end of the text and counts
             * backwards `start` places.
             * 
             * You can also pass in -1 as the `length` and it will tint all characters from `start`
             * up until the end of the string.
             * Remember that spaces and punctuation count as characters.
             * 
             * This is a WebGL only feature and only works with Static Bitmap Text, not Dynamic.
             * 
             * The tint works by taking the pixel color values from the Bitmap Text texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole character will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the character range.
             * 
             * To swap this from being an additive tint to a fill based tint, set the `tintFill` parameter to `true`.
             * 
             * To modify the tint color once set, call this method again with new color values.
             * 
             * Using `setWordTint` can override tints set by this function, and vice versa.
             * 
             * To remove a tint call this method with just the `start`, and optionally, the `length` parameters defined.
             * @param start The starting character to begin the tint at. If negative, it counts back from the end of the text. Default 0.
             * @param length The number of characters to tint. Remember that spaces count as a character too. Pass -1 to tint all characters from `start` onwards. Default 1.
             * @param tintFill Use a fill-based tint (true), or an additive tint (false) Default false.
             * @param topLeft The tint being applied to the top-left of the character. If not other values are given this value is applied evenly, tinting the whole character. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the character.
             * @param bottomLeft The tint being applied to the bottom-left of the character.
             * @param bottomRight The tint being applied to the bottom-right of the character.
             */
            setCharacterTint(start?: number, length?: number, tintFill?: boolean, topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a tint on a matching word within this Bitmap Text.
             * 
             * The `word` parameter can be either a string or a number.
             * 
             * If a string, it will run a string comparison against the text contents, and if matching,
             * it will tint the whole word.
             * 
             * If a number, if till that word, based on its offset within the text contents.
             * 
             * The `count` parameter controls how many words are replaced. Pass in -1 to replace them all.
             * 
             * This parameter is ignored if you pass a number as the `word` to be searched for.
             * 
             * This is a WebGL only feature and only works with Static Bitmap Text, not Dynamic.
             * 
             * The tint works by taking the pixel color values from the Bitmap Text texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole character will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the character range.
             * 
             * To swap this from being an additive tint to a fill based tint, set the `tintFill` parameter to `true`.
             * 
             * To modify the tint color once set, call this method again with new color values.
             * 
             * Using `setCharacterTint` can override tints set by this function, and vice versa.
             * @param word The word to search for. Either a string, or an index of the word in the words array.
             * @param count The number of matching words to tint. Pass -1 to tint all matching words. Default 1.
             * @param tintFill Use a fill-based tint (true), or an additive tint (false) Default false.
             * @param topLeft The tint being applied to the top-left of the word. If not other values are given this value is applied evenly, tinting the whole word. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the word.
             * @param bottomLeft The tint being applied to the bottom-left of the word.
             * @param bottomRight The tint being applied to the bottom-right of the word.
             */
            setWordTint(word: string | number, count?: number, tintFill?: boolean, topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Calculate the bounds of this Bitmap Text.
             * 
             * An object is returned that contains the position, width and height of the Bitmap Text in local and global
             * contexts.
             * 
             * Local size is based on just the font size and a [0, 0] position.
             * 
             * Global size takes into account the Game Object's scale, world position and display origin.
             * 
             * Also in the object is data regarding the length of each line, should this be a multi-line BitmapText.
             * @param round Whether to round the results up to the nearest integer. Default false.
             */
            getTextBounds(round?: boolean): Phaser.Types.GameObjects.BitmapText.BitmapTextSize;

            /**
             * Gets the character located at the given x/y coordinate within this Bitmap Text.
             * 
             * The coordinates you pass in are translated into the local space of the
             * Bitmap Text, however, it is up to you to first translate the input coordinates to world space.
             * 
             * If you wish to use this in combination with an input event, be sure
             * to pass in `Pointer.worldX` and `worldY` so they are in world space.
             * 
             * In some cases, based on kerning, characters can overlap. When this happens,
             * the first character in the word is returned.
             * 
             * Note that this does not work for DynamicBitmapText if you have changed the
             * character positions during render. It will only scan characters in their un-translated state.
             * @param x The x position to check.
             * @param y The y position to check.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getCharacterAt(x: number, y: number, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Types.GameObjects.BitmapText.BitmapTextCharacter;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * Changes the font this BitmapText is using to render.
             * 
             * The new texture is loaded and applied to the BitmapText. The existing test, size and alignment are preserved,
             * unless overridden via the arguments.
             * @param font The key of the font to use from the Bitmap Font cache.
             * @param size The font size of this Bitmap Text. If not specified the current size will be used.
             * @param align The alignment of the text in a multi-line BitmapText object. If not specified the current alignment will be used. Default 0.
             */
            setFont(font: string, size?: number, align?: number): this;

            /**
             * Sets the maximum display width of this BitmapText in pixels.
             * 
             * If `BitmapText.text` is longer than `maxWidth` then the lines will be automatically wrapped
             * based on the previous whitespace character found in the line.
             * 
             * If no whitespace was found then no wrapping will take place and consequently the `maxWidth` value will not be honored.
             * 
             * Disable maxWidth by setting the value to 0.
             * 
             * You can set the whitespace character to be searched for by setting the `wordWrapCharCode` parameter or property.
             * @param value The maximum display width of this BitmapText in pixels. Set to zero to disable.
             * @param wordWrapCharCode The character code to check for when word wrapping. Defaults to 32 (the space character).
             */
            setMaxWidth(value: number, wordWrapCharCode?: number): this;

            /**
             * Controls the alignment of each line of text in this BitmapText object.
             * 
             * Only has any effect when this BitmapText contains multiple lines of text, split with carriage-returns.
             * Has no effect with single-lines of text.
             * 
             * See the methods `setLeftAlign`, `setCenterAlign` and `setRightAlign`.
             * 
             * 0 = Left aligned (default)
             * 1 = Middle aligned
             * 2 = Right aligned
             * 
             * The alignment position is based on the longest line of text.
             */
            align: number;

            /**
             * The text that this Bitmap Text object displays.
             * 
             * You can also use the method `setText` if you want a chainable way to change the text content.
             */
            text: string;

            /**
             * The font size of this Bitmap Text.
             * 
             * You can also use the method `setFontSize` if you want a chainable way to change the font size.
             */
            fontSize: number;

            /**
             * Adds / Removes spacing between characters.
             * 
             * Can be a negative or positive number.
             * 
             * You can also use the method `setLetterSpacing` if you want a chainable way to change the letter spacing.
             */
            letterSpacing: number;

            /**
             * Adds / Removes spacing between lines.
             * 
             * Can be a negative or positive number.
             * 
             * You can also use the method `setLineSpacing` if you want a chainable way to change the line spacing.
             */
            lineSpacing: number;

            /**
             * The maximum display width of this BitmapText in pixels.
             * 
             * If BitmapText.text is longer than maxWidth then the lines will be automatically wrapped
             * based on the last whitespace character found in the line.
             * 
             * If no whitespace was found then no wrapping will take place and consequently the maxWidth value will not be honored.
             * 
             * Disable maxWidth by setting the value to 0.
             */
            maxWidth: number;

            /**
             * The width of this Bitmap Text.
             * 
             * This property is read-only.
             */
            readonly width: number;

            /**
             * The height of this Bitmap text.
             * 
             * This property is read-only.
             */
            readonly height: number;

            /**
             * The displayed width of this Bitmap Text.
             * 
             * This value takes into account the scale factor.
             * 
             * This property is read-only.
             */
            readonly displayWidth: number;

            /**
             * The displayed height of this Bitmap Text.
             * 
             * This value takes into account the scale factor.
             * 
             * This property is read-only.
             */
            readonly displayHeight: number;

            /**
             * Build a JSON representation of this Bitmap Text.
             */
            toJSON(): Phaser.Types.GameObjects.BitmapText.JSONBitmapText;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * Left align the text characters in a multi-line BitmapText object.
             */
            static ALIGN_LEFT: number;

            /**
             * Center align the text characters in a multi-line BitmapText object.
             */
            static ALIGN_CENTER: number;

            /**
             * Right align the text characters in a multi-line BitmapText object.
             */
            static ALIGN_RIGHT: number;

            /**
             * Parse an XML Bitmap Font from an Atlas.
             * 
             * Adds the parsed Bitmap Font data to the cache with the `fontName` key.
             * @param scene The Scene to parse the Bitmap Font for.
             * @param fontName The key of the font to add to the Bitmap Font cache.
             * @param textureKey The key of the BitmapFont's texture.
             * @param frameKey The key of the BitmapFont texture's frame.
             * @param xmlKey The key of the XML data of the font to parse.
             * @param xSpacing The x-axis spacing to add between each letter.
             * @param ySpacing The y-axis spacing to add to the line height.
             */
            static ParseFromAtlas(scene: Phaser.Scene, fontName: string, textureKey: string, frameKey: string, xmlKey: string, xSpacing?: number, ySpacing?: number): boolean;

            /**
             * Parse an XML font to Bitmap Font data for the Bitmap Font cache.
             * @param xml The XML Document to parse the font from.
             * @param frame The texture frame to take into account when creating the uv data.
             * @param xSpacing The x-axis spacing to add between each letter. Default 0.
             * @param ySpacing The y-axis spacing to add to the line height. Default 0.
             */
            static ParseXMLBitmapFont(xml: XMLDocument, frame: Phaser.Textures.Frame, xSpacing?: number, ySpacing?: number): Phaser.Types.GameObjects.BitmapText.BitmapFontData;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Blitter Game Object.
         * 
         * The Blitter Game Object is a special kind of container that creates, updates and manages Bob objects.
         * Bobs are designed for rendering speed rather than flexibility. They consist of a texture, or frame from a texture,
         * a position and an alpha value. You cannot scale or rotate them. They use a batched drawing method for speed
         * during rendering.
         * 
         * A Blitter Game Object has one texture bound to it. Bobs created by the Blitter can use any Frame from this
         * Texture to render with, but they cannot use any other Texture. It is this single texture-bind that allows
         * them their speed.
         * 
         * If you have a need to blast a large volume of frames around the screen then Blitter objects are well worth
         * investigating. They are especially useful for using as a base for your own special effects systems.
         */
        class Blitter extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. It can only belong to one Scene at any given time.
             * @param x The x coordinate of this Game Object in world space. Default 0.
             * @param y The y coordinate of this Game Object in world space. Default 0.
             * @param texture The key of the texture this Game Object will use for rendering. The Texture must already exist in the Texture Manager. Default '__DEFAULT'.
             * @param frame The Frame of the Texture that this Game Object will use. Only set if the Texture has multiple frames, such as a Texture Atlas or Sprite Sheet. Default 0.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, texture?: string, frame?: string | number);

            /**
             * The children of this Blitter.
             * This List contains all of the Bob objects created by the Blitter.
             */
            children: Phaser.Structs.List<Phaser.GameObjects.Bob>;

            /**
             * Is the Blitter considered dirty?
             * A 'dirty' Blitter has had its child count changed since the last frame.
             */
            dirty: boolean;

            /**
             * Creates a new Bob in this Blitter.
             * 
             * The Bob is created at the given coordinates, relative to the Blitter and uses the given frame.
             * A Bob can use any frame belonging to the texture bound to the Blitter.
             * @param x The x position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             * @param y The y position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             * @param frame The Frame the Bob will use. It _must_ be part of the Texture the parent Blitter object is using.
             * @param visible Should the created Bob render or not? Default true.
             * @param index The position in the Blitters Display List to add the new Bob at. Defaults to the top of the list.
             */
            create(x: number, y: number, frame?: string | number | Phaser.Textures.Frame, visible?: boolean, index?: number): Phaser.GameObjects.Bob;

            /**
             * Creates multiple Bob objects within this Blitter and then passes each of them to the specified callback.
             * @param callback The callback to invoke after creating a bob. It will be sent two arguments: The Bob and the index of the Bob.
             * @param quantity The quantity of Bob objects to create.
             * @param frame The Frame the Bobs will use. It must be part of the Blitter Texture.
             * @param visible Should the created Bob render or not? Default true.
             */
            createFromCallback(callback: CreateCallback, quantity: number, frame?: string | number | Phaser.Textures.Frame | string[] | number[] | Phaser.Textures.Frame[], visible?: boolean): Phaser.GameObjects.Bob[];

            /**
             * Creates multiple Bobs in one call.
             * 
             * The amount created is controlled by a combination of the `quantity` argument and the number of frames provided.
             * 
             * If the quantity is set to 10 and you provide 2 frames, then 20 Bobs will be created. 10 with the first
             * frame and 10 with the second.
             * @param quantity The quantity of Bob objects to create.
             * @param frame The Frame the Bobs will use. It must be part of the Blitter Texture.
             * @param visible Should the created Bob render or not? Default true.
             */
            createMultiple(quantity: number, frame?: string | number | Phaser.Textures.Frame | string[] | number[] | Phaser.Textures.Frame[], visible?: boolean): Phaser.GameObjects.Bob[];

            /**
             * Checks if the given child can render or not, by checking its `visible` and `alpha` values.
             * @param child The Bob to check for rendering.
             */
            childCanRender(child: Phaser.GameObjects.Bob): boolean;

            /**
             * Returns an array of Bobs to be rendered.
             * If the Blitter is dirty then a new list is generated and stored in `renderList`.
             */
            getRenderList(): Phaser.GameObjects.Bob[];

            /**
             * Removes all Bobs from the children List and clears the dirty flag.
             */
            clear(): void;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Bob Game Object.
         * 
         * A Bob belongs to a Blitter Game Object. The Blitter is responsible for managing and rendering this object.
         * 
         * A Bob has a position, alpha value and a frame from a texture that it uses to render with. You can also toggle
         * the flipped and visible state of the Bob. The Frame the Bob uses to render can be changed dynamically, but it
         * must be a Frame within the Texture used by the parent Blitter.
         * 
         * Bob positions are relative to the Blitter parent. So if you move the Blitter parent, all Bob children will
         * have their positions impacted by this change as well.
         * 
         * You can manipulate Bob objects directly from your game code, but the creation and destruction of them should be
         * handled via the Blitter parent.
         */
        class Bob {
            /**
             * 
             * @param blitter The parent Blitter object is responsible for updating this Bob.
             * @param x The horizontal position of this Game Object in the world, relative to the parent Blitter position.
             * @param y The vertical position of this Game Object in the world, relative to the parent Blitter position.
             * @param frame The Frame this Bob will render with, as defined in the Texture the parent Blitter is using.
             * @param visible Should the Bob render visible or not to start with?
             */
            constructor(blitter: Phaser.GameObjects.Blitter, x: number, y: number, frame: string | number, visible: boolean);

            /**
             * The Blitter object that this Bob belongs to.
             */
            parent: Phaser.GameObjects.Blitter;

            /**
             * The x position of this Bob, relative to the x position of the Blitter.
             */
            x: number;

            /**
             * The y position of this Bob, relative to the y position of the Blitter.
             */
            y: number;

            /**
             * The frame that the Bob uses to render with.
             * To change the frame use the `Bob.setFrame` method.
             */
            protected frame: Phaser.Textures.Frame;

            /**
             * A blank object which can be used to store data related to this Bob in.
             */
            data: object;

            /**
             * The tint value of this Bob.
             */
            tint: number;

            /**
             * The horizontally flipped state of the Bob.
             * A Bob that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Bob.
             * A Bob that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture.
             */
            flipY: boolean;

            /**
             * Changes the Texture Frame being used by this Bob.
             * The frame must be part of the Texture the parent Blitter is using.
             * If no value is given it will use the default frame of the Blitter parent.
             * @param frame The frame to be used during rendering.
             */
            setFrame(frame?: string | number | Phaser.Textures.Frame): this;

            /**
             * Resets the horizontal and vertical flipped state of this Bob back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Resets this Bob.
             * 
             * Changes the position to the values given, and optionally changes the frame.
             * 
             * Also resets the flipX and flipY values, sets alpha back to 1 and visible to true.
             * @param x The x position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             * @param y The y position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             * @param frame The Frame the Bob will use. It _must_ be part of the Texture the parent Blitter object is using.
             */
            reset(x: number, y: number, frame?: string | number | Phaser.Textures.Frame): this;

            /**
             * Changes the position of this Bob to the values given.
             * @param x The x position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             * @param y The y position of the Bob. Bob coordinate are relative to the position of the Blitter object.
             */
            setPosition(x: number, y: number): this;

            /**
             * Sets the horizontal flipped state of this Bob.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Bob.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Bob.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Sets the visibility of this Bob.
             * 
             * An invisible Bob will skip rendering.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

            /**
             * Set the Alpha level of this Bob. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * A Bob with alpha 0 will skip rendering.
             * @param value The alpha value used for this Bob. Between 0 and 1.
             */
            setAlpha(value: number): this;

            /**
             * Sets the tint of this Bob.
             * @param value The tint value used for this Bob. Between 0 and 0xffffff.
             */
            setTint(value: number): this;

            /**
             * Destroys this Bob instance.
             * Removes itself from the Blitter and clears the parent, frame and data properties.
             */
            destroy(): void;

            /**
             * The visible state of the Bob.
             * 
             * An invisible Bob will skip rendering.
             */
            visible: boolean;

            /**
             * The alpha value of the Bob, between 0 and 1.
             * 
             * A Bob with alpha 0 will skip rendering.
             */
            alpha: number;

        }

        /**
         * Builds a Game Object using the provided configuration object.
         * @param scene A reference to the Scene.
         * @param gameObject The initial GameObject.
         * @param config The config to build the GameObject with.
         */
        function BuildGameObject(scene: Phaser.Scene, gameObject: Phaser.GameObjects.GameObject, config: Phaser.Types.GameObjects.GameObjectConfig): Phaser.GameObjects.GameObject;

        /**
         * Adds an Animation component to a Sprite and populates it based on the given config.
         * @param sprite The sprite to add an Animation component to.
         * @param config The animation config.
         */
        function BuildGameObjectAnimation(sprite: Phaser.GameObjects.Sprite, config: object): Phaser.GameObjects.Sprite;

        namespace Components {
            /**
             * Provides methods used for setting the alpha properties of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface Alpha {
                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;
                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * 
                 * If your game is running under WebGL you can optionally specify four different alpha values, each of which
                 * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
                 * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
                 * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
                 * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
                 * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
                 */
                setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;
                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;
                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;
                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;
                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;
                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;
            }

            /**
             * Provides methods used for setting the alpha property of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface AlphaSingle {
                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;
                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * @param value The alpha value applied across the whole Game Object. Default 1.
                 */
                setAlpha(value?: number): this;
                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;
            }

            /**
             * Provides methods used for setting the blend mode of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface BlendMode {
                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;
                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;
            }

            /**
             * Provides methods used for calculating and setting the size of a non-Frame based Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface ComputedSize {
                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;
                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;
                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;
                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;
                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;
                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;
            }

            /**
             * Provides methods used for getting and setting the texture of a Game Object.
             */
            interface Crop {
                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;
                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;
                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;
                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;
            }

            /**
             * Provides methods used for setting the depth of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface Depth {
                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;
                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;
            }

            /**
             * Provides methods used for visually flipping a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface Flip {
                /**
                 * The horizontally flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipX: boolean;
                /**
                 * The vertically flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipY: boolean;
                /**
                 * Toggles the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                toggleFlipX(): this;
                /**
                 * Toggles the vertical flipped state of this Game Object.
                 */
                toggleFlipY(): this;
                /**
                 * Sets the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipX(value: boolean): this;
                /**
                 * Sets the vertical flipped state of this Game Object.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipY(value: boolean): this;
                /**
                 * Sets the horizontal and vertical flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped will render inversed on the flipped axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlip(x: boolean, y: boolean): this;
                /**
                 * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
                 */
                resetFlip(): this;
            }

            interface FX {
                /**
                 * Sets the Texture to be used for the displacement effect.
                 * 
                 * You can only use a whole texture, not a frame from a texture atlas or sprite sheet.
                 * @param texture The unique string-based key of the texture to use for displacement, which must exist in the Texture Manager. Default '__WHITE'.
                 */
                setTexture(texture?: string): this;
                /**
                 * A reference to the Game Object that owns this FX Component.
                 */
                readonly gameObject: Phaser.GameObjects.GameObject;
                /**
                 * Is this a Post FX Controller? or a Pre FX Controller?
                 */
                readonly isPost: boolean;
                /**
                 * Has this FX Component been enabled?
                 * 
                 * You should treat this property as read-only, although it is toggled
                 * automaticaly during internal use.
                 */
                enabled: boolean;
                /**
                 * An array containing all of the Pre FX Controllers that
                 * have been added to this FX Component. They are processed in
                 * the order they are added.
                 * 
                 * This array is empty if this is a Post FX Component.
                 */
                list: Phaser.FX.Controller[];
                /**
                 * The amount of extra padding to be applied to this Game Object
                 * when it is being rendered by a PreFX Pipeline.
                 * 
                 * Lots of FX require additional spacing added to the texture the
                 * Game Object uses, for example a glow or shadow effect, and this
                 * method allows you to control how much extra padding is included
                 * in addition to the texture size.
                 * 
                 * You do not need to set this if you're only using Post FX.
                 */
                padding: number;
                /**
                 * Sets the amount of extra padding to be applied to this Game Object
                 * when it is being rendered by a PreFX Pipeline.
                 * 
                 * Lots of FX require additional spacing added to the texture the
                 * Game Object uses, for example a glow or shadow effect, and this
                 * method allows you to control how much extra padding is included
                 * in addition to the texture size.
                 * 
                 * You do not need to set this if you're only using Post FX.
                 * @param padding The amount of padding to add to this Game Object. Default 0.
                 */
                setPadding(padding?: number): this;
                /**
                 * This callback is invoked when this Game Object is copied by a PreFX Pipeline.
                 * 
                 * This happens when the pipeline uses its `copySprite` method.
                 * 
                 * It's invoked prior to the copy, allowing you to set shader uniforms, etc on the pipeline.
                 * @param pipeline The PreFX Pipeline that invoked this callback.
                 */
                onFXCopy(pipeline: Phaser.Renderer.WebGL.Pipelines.PreFXPipeline): void;
                /**
                 * This callback is invoked when this Game Object is rendered by a PreFX Pipeline.
                 * 
                 * This happens when the pipeline uses its `drawSprite` method.
                 * 
                 * It's invoked prior to the draw, allowing you to set shader uniforms, etc on the pipeline.
                 * @param pipeline The PreFX Pipeline that invoked this callback.
                 */
                onFX(pipeline: Phaser.Renderer.WebGL.Pipelines.PreFXPipeline): void;
                /**
                 * Enables this FX Component and applies the FXPipeline to the parent Game Object.
                 * 
                 * This is called automatically whenever you call a method such as `addBloom`, etc.
                 * 
                 * You can check the `enabled` property to see if the Game Object is already enabled, or not.
                 * 
                 * This only applies to Pre FX. Post FX are always enabled.
                 * @param padding The amount of padding to add to this Game Object. Default 0.
                 */
                enable(padding?: number): void;
                /**
                 * Destroys and removes all FX Controllers that are part of this FX Component,
                 * then disables it.
                 * 
                 * If this is a Pre FX Component it will only remove Pre FX.
                 * If this is a Post FX Component it will only remove Post FX.
                 * 
                 * To remove both at once use the `GameObject.clearFX` method instead.
                 */
                clear(): this;
                /**
                 * Searches for the given FX Controller within this FX Component.
                 * 
                 * If found, the controller is removed from this component and then destroyed.
                 * @param fx The FX Controller to remove from this FX Component.
                 */
                remove<T extends Phaser.FX.Controller>(fx: T): this;
                /**
                 * Disables this FX Component.
                 * 
                 * This will reset the pipeline on the Game Object that owns this component back to its
                 * default and flag this component as disabled.
                 * 
                 * You can re-enable it again by calling `enable` for Pre FX or by adding an FX for Post FX.
                 * 
                 * Optionally, set `clear` to destroy all current FX Controllers.
                 * @param clear Destroy and remove all FX Controllers that are part of this component. Default false.
                 */
                disable(clear?: boolean): this;
                /**
                 * Adds the given FX Controler to this FX Component.
                 * 
                 * Note that adding an FX Controller does not remove any existing FX. They all stack-up
                 * on-top of each other. If you don't want this, make sure to call either `remove` or
                 * `clear` first.
                 * @param fx The FX Controller to add to this FX Component.
                 * @param config Optional configuration object that is passed to the pipeline during instantiation.
                 */
                add<T extends Phaser.FX.Controller>(fx: T, config?: object): Phaser.FX.Controller;
                /**
                 * Adds a Glow effect.
                 * 
                 * The glow effect is a visual technique that creates a soft, luminous halo around game objects,
                 * characters, or UI elements. This effect is used to emphasize importance, enhance visual appeal,
                 * or convey a sense of energy, magic, or otherworldly presence. The effect can also be set on
                 * the inside of the Game Object. The color and strength of the glow can be modified.
                 * @param color The color of the glow effect as a number value. Default 0xffffff.
                 * @param outerStrength The strength of the glow outward from the edge of the Sprite. Default 4.
                 * @param innerStrength The strength of the glow inward from the edge of the Sprite. Default 0.
                 * @param knockout If `true` only the glow is drawn, not the texture itself. Default false.
                 * @param quality Only available for PostFX. Sets the quality of this Glow effect. Default is 0.1. Cannot be changed post-creation. Default 0.1.
                 * @param distance Only available for PostFX. Sets the distance of this Glow effect. Default is 10. Cannot be changed post-creation. Default 10.
                 */
                addGlow(color?: number, outerStrength?: number, innerStrength?: number, knockout?: boolean, quality?: number, distance?: number): Phaser.FX.Glow;
                /**
                 * Adds a Shadow effect.
                 * 
                 * The shadow effect is a visual technique used to create the illusion of depth and realism by adding darker,
                 * offset silhouettes or shapes beneath game objects, characters, or environments. These simulated shadows
                 * help to enhance the visual appeal and immersion, making the 2D game world appear more dynamic and three-dimensional.
                 * @param x The horizontal offset of the shadow effect. Default 0.
                 * @param y The vertical offset of the shadow effect. Default 0.
                 * @param decay The amount of decay for shadow effect. Default 0.1.
                 * @param power The power of the shadow effect. Default 1.
                 * @param color The color of the shadow. Default 0x000000.
                 * @param samples The number of samples that the shadow effect will run for. An integer between 1 and 12. Default 6.
                 * @param intensity The intensity of the shadow effect. Default 1.
                 */
                addShadow(x?: number, y?: number, decay?: number, power?: number, color?: number, samples?: number, intensity?: number): Phaser.FX.Shadow;
                /**
                 * Adds a Pixelate effect.
                 * 
                 * The pixelate effect is a visual technique that deliberately reduces the resolution or detail of an image,
                 * creating a blocky or mosaic appearance composed of large, visible pixels. This effect can be used for stylistic
                 * purposes, as a homage to retro gaming, or as a means to obscure certain elements within the game, such as
                 * during a transition or to censor specific content.
                 * @param amount The amount of pixelation to apply. Default 1.
                 */
                addPixelate(amount?: number): Phaser.FX.Pixelate;
                /**
                 * Adds a Vignette effect.
                 * 
                 * The vignette effect is a visual technique where the edges of the screen, or a Game Object, gradually darken or blur,
                 * creating a frame-like appearance. This effect is used to draw the player's focus towards the central action or subject,
                 * enhance immersion, and provide a cinematic or artistic quality to the game's visuals.
                 * @param x The horizontal offset of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
                 * @param y The vertical offset of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
                 * @param radius The radius of the vignette effect. This value is normalized to the range 0 to 1. Default 0.5.
                 * @param strength The strength of the vignette effect. Default 0.5.
                 */
                addVignette(x?: number, y?: number, radius?: number, strength?: number): Phaser.FX.Vignette;
                /**
                 * Adds a Shine effect.
                 * 
                 * The shine effect is a visual technique that simulates the appearance of reflective
                 * or glossy surfaces by passing a light beam across a Game Object. This effect is used to
                 * enhance visual appeal, emphasize certain features, and create a sense of depth or
                 * material properties.
                 * @param speed The speed of the Shine effect. Default 0.5.
                 * @param lineWidth The line width of the Shine effect. Default 0.5.
                 * @param gradient The gradient of the Shine effect. Default 3.
                 * @param reveal Does this Shine effect reveal or get added to its target? Default false.
                 */
                addShine(speed?: number, lineWidth?: number, gradient?: number, reveal?: boolean): Phaser.FX.Shine;
                /**
                 * Adds a Blur effect.
                 * 
                 * A Gaussian blur is the result of blurring an image by a Gaussian function. It is a widely used effect,
                 * typically to reduce image noise and reduce detail. The visual effect of this blurring technique is a
                 * smooth blur resembling that of viewing the image through a translucent screen, distinctly different
                 * from the bokeh effect produced by an out-of-focus lens or the shadow of an object under usual illumination.
                 * @param quality The quality of the blur effect. Can be either 0 for Low Quality, 1 for Medium Quality or 2 for High Quality. Default 0.
                 * @param x The horizontal offset of the blur effect. Default 2.
                 * @param y The vertical offset of the blur effect. Default 2.
                 * @param strength The strength of the blur effect. Default 1.
                 * @param color The color of the blur, as a hex value. Default 0xffffff.
                 * @param steps The number of steps to run the blur effect for. This value should always be an integer. Default 4.
                 */
                addBlur(quality?: number, x?: number, y?: number, strength?: number, color?: number, steps?: number): Phaser.FX.Blur;
                /**
                 * Adds a Gradient effect.
                 * 
                 * The gradient overlay effect is a visual technique where a smooth color transition is applied over Game Objects,
                 * such as sprites or UI components. This effect is used to enhance visual appeal, emphasize depth, or create
                 * stylistic and atmospheric variations. It can also be utilized to convey information, such as representing
                 * progress or health status through color changes.
                 * @param color1 The first gradient color, given as a number value. Default 0xff0000.
                 * @param color2 The second gradient color, given as a number value. Default 0x00ff00.
                 * @param alpha The alpha value of the gradient effect. Default 0.2.
                 * @param fromX The horizontal position the gradient will start from. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
                 * @param fromY The vertical position the gradient will start from. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
                 * @param toX The horizontal position the gradient will end at. This value is normalized, between 0 and 1, and is not in pixels. Default 0.
                 * @param toY The vertical position the gradient will end at. This value is normalized, between 0 and 1, and is not in pixels. Default 1.
                 * @param size How many 'chunks' the gradient is divided in to, as spread over the entire height of the texture. Leave this at zero for a smooth gradient, or set higher for a more retro chunky effect. Default 0.
                 */
                addGradient(color1?: number, color2?: number, alpha?: number, fromX?: number, fromY?: number, toX?: number, toY?: number, size?: number): Phaser.FX.Gradient;
                /**
                 * Adds a Bloom effect.
                 * 
                 * Bloom is an effect used to reproduce an imaging artifact of real-world cameras.
                 * The effect produces fringes of light extending from the borders of bright areas in an image,
                 * contributing to the illusion of an extremely bright light overwhelming the
                 * camera or eye capturing the scene.
                 * @param color The color of the Bloom, as a hex value.
                 * @param offsetX The horizontal offset of the bloom effect. Default 1.
                 * @param offsetY The vertical offset of the bloom effect. Default 1.
                 * @param blurStrength The strength of the blur process of the bloom effect. Default 1.
                 * @param strength The strength of the blend process of the bloom effect. Default 1.
                 * @param steps The number of steps to run the Bloom effect for. This value should always be an integer. Default 4.
                 */
                addBloom(color?: number, offsetX?: number, offsetY?: number, blurStrength?: number, strength?: number, steps?: number): Phaser.FX.Bloom;
                /**
                 * Adds a ColorMatrix effect.
                 * 
                 * The color matrix effect is a visual technique that involves manipulating the colors of an image
                 * or scene using a mathematical matrix. This process can adjust hue, saturation, brightness, and contrast,
                 * allowing developers to create various stylistic appearances or mood settings within the game.
                 * Common applications include simulating different lighting conditions, applying color filters,
                 * or achieving a specific visual style.
                 */
                addColorMatrix(): Phaser.FX.ColorMatrix;
                /**
                 * Adds a Circle effect.
                 * 
                 * This effect will draw a circle around the texture of the Game Object, effectively masking off
                 * any area outside of the circle without the need for an actual mask. You can control the thickness
                 * of the circle, the color of the circle and the color of the background, should the texture be
                 * transparent. You can also control the feathering applied to the circle, allowing for a harsh or soft edge.
                 * 
                 * Please note that adding this effect to a Game Object will not change the input area or physics body of
                 * the Game Object, should it have one.
                 * @param thickness The width of the circle around the texture, in pixels. Default 8.
                 * @param color The color of the circular ring, given as a number value. Default 0xfeedb6.
                 * @param backgroundColor The color of the background, behind the texture, given as a number value. Default 0xff0000.
                 * @param scale The scale of the circle. The default scale is 1, which is a circle the full size of the underlying texture. Default 1.
                 * @param feather The amount of feathering to apply to the circle from the ring. Default 0.005.
                 */
                addCircle(thickness?: number, color?: number, backgroundColor?: number, scale?: number, feather?: number): Phaser.FX.Circle;
                /**
                 * Adds a Barrel effect.
                 * 
                 * A barrel effect allows you to apply either a 'pinch' or 'expand' distortion to
                 * a Game Object. The amount of the effect can be modified in real-time.
                 * @param amount The amount of distortion applied to the barrel effect. A value of 1 is no distortion. Typically keep this within +- 1. Default 1.
                 */
                addBarrel(amount?: number): Phaser.FX.Barrel;
                /**
                 * Adds a Displacement effect.
                 * 
                 * The displacement effect is a visual technique that alters the position of pixels in an image
                 * or texture based on the values of a displacement map. This effect is used to create the illusion
                 * of depth, surface irregularities, or distortion in otherwise flat elements. It can be applied to
                 * characters, objects, or backgrounds to enhance realism, convey movement, or achieve various
                 * stylistic appearances.
                 * @param texture The unique string-based key of the texture to use for displacement, which must exist in the Texture Manager. Default '__WHITE'.
                 * @param x The amount of horizontal displacement to apply. A very small float number, such as 0.005. Default 0.005.
                 * @param y The amount of vertical displacement to apply. A very small float number, such as 0.005. Default 0.005.
                 */
                addDisplacement(texture?: string, x?: number, y?: number): Phaser.FX.Displacement;
                /**
                 * Adds a Wipe effect.
                 * 
                 * The wipe or reveal effect is a visual technique that gradually uncovers or conceals elements
                 * in the game, such as images, text, or scene transitions. This effect is often used to create
                 * a sense of progression, reveal hidden content, or provide a smooth and visually appealing transition
                 * between game states.
                 * 
                 * You can set both the direction and the axis of the wipe effect. The following combinations are possible:
                 * 
                 * * left to right: direction 0, axis 0
                 * * right to left: direction 1, axis 0
                 * * top to bottom: direction 1, axis 1
                 * * bottom to top: direction 1, axis 0
                 * 
                 * It is up to you to set the `progress` value yourself, i.e. via a Tween, in order to transition the effect.
                 * @param wipeWidth The width of the wipe effect. This value is normalized in the range 0 to 1. Default 0.1.
                 * @param direction The direction of the wipe effect. Either 0 or 1. Set in conjunction with the axis property. Default 0.
                 * @param axis The axis of the wipe effect. Either 0 or 1. Set in conjunction with the direction property. Default 0.
                 */
                addWipe(wipeWidth?: number, direction?: number, axis?: number): Phaser.FX.Wipe;
                /**
                 * Adds a Reveal Wipe effect.
                 * 
                 * The wipe or reveal effect is a visual technique that gradually uncovers or conceals elements
                 * in the game, such as images, text, or scene transitions. This effect is often used to create
                 * a sense of progression, reveal hidden content, or provide a smooth and visually appealing transition
                 * between game states.
                 * 
                 * You can set both the direction and the axis of the wipe effect. The following combinations are possible:
                 * 
                 * * left to right: direction 0, axis 0
                 * * right to left: direction 1, axis 0
                 * * top to bottom: direction 1, axis 1
                 * * bottom to top: direction 1, axis 0
                 * 
                 * It is up to you to set the `progress` value yourself, i.e. via a Tween, in order to transition the effect.
                 * @param wipeWidth The width of the wipe effect. This value is normalized in the range 0 to 1. Default 0.1.
                 * @param direction The direction of the wipe effect. Either 0 or 1. Set in conjunction with the axis property. Default 0.
                 * @param axis The axis of the wipe effect. Either 0 or 1. Set in conjunction with the direction property. Default 0.
                 */
                addReveal(wipeWidth?: number, direction?: number, axis?: number): Phaser.FX.Wipe;
                /**
                 * Adds a Bokeh effect.
                 * 
                 * Bokeh refers to a visual effect that mimics the photographic technique of creating a shallow depth of field.
                 * This effect is used to emphasize the game's main subject or action, by blurring the background or foreground
                 * elements, resulting in a more immersive and visually appealing experience. It is achieved through rendering
                 * techniques that simulate the out-of-focus areas, giving a sense of depth and realism to the game's graphics.
                 * 
                 * See also Tilt Shift.
                 * @param radius The radius of the bokeh effect. Default 0.5.
                 * @param amount The amount of the bokeh effect. Default 1.
                 * @param contrast The color contrast of the bokeh effect. Default 0.2.
                 */
                addBokeh(radius?: number, amount?: number, contrast?: number): Phaser.FX.Bokeh;
                /**
                 * Adds a Tilt Shift effect.
                 * 
                 * This Bokeh effect can also be used to generate a Tilt Shift effect, which is a technique used to create a miniature
                 * effect by blurring everything except a small area of the image. This effect is achieved by blurring the
                 * top and bottom elements, while keeping the center area in focus.
                 * 
                 * See also Bokeh.
                 * @param radius The radius of the bokeh effect. Default 0.5.
                 * @param amount The amount of the bokeh effect. Default 1.
                 * @param contrast The color contrast of the bokeh effect. Default 0.2.
                 * @param blurX The amount of horizontal blur. Default 1.
                 * @param blurY The amount of vertical blur. Default 1.
                 * @param strength The strength of the blur. Default 1.
                 */
                addTiltShift(radius?: number, amount?: number, contrast?: number, blurX?: number, blurY?: number, strength?: number): Phaser.FX.Bokeh;
                /**
                 * Destroys this FX Component.
                 * 
                 * Called automatically when Game Objects are destroyed.
                 */
                destroy(): void;
            }

            /**
             * Provides methods used for obtaining the bounds of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface GetBounds {
                /**
                 * Gets the center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the top-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the top-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the top-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the left-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the right-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the bottom-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;
                /**
                 * Gets the bounds of this Game Object, regardless of origin.
                 * 
                 * The values are stored and returned in a Rectangle, or Rectangle-like, object.
                 * @param output An object to store the values in. If not provided a new Rectangle will be created.
                 */
                getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;
            }

            /**
             * Provides methods used for getting and setting the mask of a Game Object.
             */
            interface Mask {
                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;
                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;
                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;
                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;
                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;
            }

            /**
             * Provides methods used for getting and setting the origin of a Game Object.
             * Values are normalized, given in the range 0 to 1.
             * Display values contain the calculated pixel values.
             * Should be applied as a mixin and not used directly.
             */
            interface Origin {
                /**
                 * The horizontal origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the left of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originX: number;
                /**
                 * The vertical origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the top of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originY: number;
                /**
                 * The horizontal display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginX: number;
                /**
                 * The vertical display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginY: number;
                /**
                 * Sets the origin of this Game Object.
                 * 
                 * The values are given in the range 0 to 1.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;
                /**
                 * Sets the origin of this Game Object based on the Pivot values in its Frame.
                 */
                setOriginFromFrame(): this;
                /**
                 * Sets the display origin of this Game Object.
                 * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
                 * @param x The horizontal display origin value. Default 0.
                 * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setDisplayOrigin(x?: number, y?: number): this;
                /**
                 * Updates the Display Origin cached values internally stored on this Game Object.
                 * You don't usually call this directly, but it is exposed for edge-cases where you may.
                 */
                updateDisplayOrigin(): this;
            }

            /**
             * Provides methods used for managing a Game Object following a Path.
             * Should be applied as a mixin and not used directly.
             */
            interface PathFollower {
                /**
                 * The Path this PathFollower is following. It can only follow one Path at a time.
                 */
                path: Phaser.Curves.Path;
                /**
                 * Should the PathFollower automatically rotate to point in the direction of the Path?
                 */
                rotateToPath: boolean;
                /**
                 * Set the Path that this PathFollower should follow.
                 * 
                 * Optionally accepts {@link Phaser.Types.GameObjects.PathFollower.PathConfig} settings.
                 * @param path The Path this PathFollower is following. It can only follow one Path at a time.
                 * @param config Settings for the PathFollower.
                 */
                setPath(path: Phaser.Curves.Path, config?: number | Phaser.Types.GameObjects.PathFollower.PathConfig | Phaser.Types.Tweens.NumberTweenBuilderConfig): this;
                /**
                 * Set whether the PathFollower should automatically rotate to point in the direction of the Path.
                 * @param value Whether the PathFollower should automatically rotate to point in the direction of the Path.
                 * @param offset Rotation offset in degrees. Default 0.
                 */
                setRotateToPath(value: boolean, offset?: number): this;
                /**
                 * Is this PathFollower actively following a Path or not?
                 * 
                 * To be considered as `isFollowing` it must be currently moving on a Path, and not paused.
                 */
                isFollowing(): boolean;
                /**
                 * Starts this PathFollower following its given Path.
                 * @param config The duration of the follow, or a PathFollower config object. Default {}.
                 * @param startAt Optional start position of the follow, between 0 and 1. Default 0.
                 */
                startFollow(config?: number | Phaser.Types.GameObjects.PathFollower.PathConfig | Phaser.Types.Tweens.NumberTweenBuilderConfig, startAt?: number): this;
                /**
                 * Pauses this PathFollower. It will still continue to render, but it will remain motionless at the
                 * point on the Path at which you paused it.
                 */
                pauseFollow(): this;
                /**
                 * Resumes a previously paused PathFollower.
                 * 
                 * If the PathFollower was not paused this has no effect.
                 */
                resumeFollow(): this;
                /**
                 * Stops this PathFollower from following the path any longer.
                 * 
                 * This will invoke any 'stop' conditions that may exist on the Path, or for the follower.
                 */
                stopFollow(): this;
                /**
                 * Internal update handler that advances this PathFollower along the path.
                 * 
                 * Called automatically by the Scene step, should not typically be called directly.
                 */
                pathUpdate(): void;
            }

            /**
             * Provides methods used for setting the WebGL rendering pipeline of a Game Object.
             */
            interface Pipeline {
                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;
                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;
                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;
                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;
                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;
                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;
                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;
                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;
            }

            /**
             * Provides methods used for setting the WebGL rendering post pipeline of a Game Object.
             */
            interface PostPipeline {
                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;
                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];
                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;
                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;
                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;
                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;
                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;
                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;
                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];
                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;
                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;
                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;
            }

            /**
             * Provides methods used for getting and setting the Scroll Factor of a Game Object.
             */
            interface ScrollFactor {
                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;
                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;
                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;
            }

            /**
             * Provides methods used for getting and setting the size of a Game Object.
             */
            interface Size {
                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;
                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;
                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;
                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;
                /**
                 * Sets the size of this Game Object to be that of the given Frame.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param frame The frame to base the size of this Game Object on.
                 */
                setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;
                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;
                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;
            }

            /**
             * Provides methods used for getting and setting the texture of a Game Object.
             */
            interface Texture {
                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;
                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;
                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * 
                 * Calling this method will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
                 * @param frame The name or index of the frame within the Texture.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call change the origin of the Game Object? Default true.
                 */
                setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;
                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;
            }

            /**
             * Provides methods used for getting and setting the texture of a Game Object.
             */
            interface TextureCrop {
                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;
                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;
                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;
                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;
                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * @param key The key of the texture to be used, as stored in the Texture Manager.
                 * @param frame The name or index of the frame within the Texture.
                 */
                setTexture(key: string, frame?: string | number): this;
                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;
            }

            /**
             * Provides methods used for setting the tint of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface Tint {
                /**
                 * The tint value being applied to the top-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopLeft: number;
                /**
                 * The tint value being applied to the top-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopRight: number;
                /**
                 * The tint value being applied to the bottom-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomLeft: number;
                /**
                 * The tint value being applied to the bottom-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomRight: number;
                /**
                 * The tint fill mode.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;
                /**
                 * Clears all tint values associated with this Game Object.
                 * 
                 * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
                 * which results in no visible change to the texture.
                 */
                clearTint(): this;
                /**
                 * Sets an additive tint on this Game Object.
                 * 
                 * The tint works by taking the pixel color values from the Game Objects texture, and then
                 * multiplying it by the color value of the tint. You can provide either one color value,
                 * in which case the whole Game Object will be tinted in that color. Or you can provide a color
                 * per corner. The colors are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;
                /**
                 * Sets a fill-based tint on this Game Object.
                 * 
                 * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
                 * with those in the tint. You can use this for effects such as making a player flash 'white'
                 * if hit by something. You can provide either one color value, in which case the whole
                 * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
                 * are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;
                /**
                 * The tint value being applied to the whole of the Game Object.
                 * Return `tintTopLeft` when read this tint property.
                 */
                tint: number;
                /**
                 * Does this Game Object have a tint applied?
                 * 
                 * It checks to see if the 4 tint properties are set to the value 0xffffff
                 * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
                 */
                readonly isTinted: boolean;
            }

            /**
             * Build a JSON representation of the given Game Object.
             * 
             * This is typically extended further by Game Object specific implementations.
             */
            interface ToJSON {
            }

            /**
             * Provides methods used for getting and setting the position, scale and rotation of a Game Object.
             */
            interface Transform {
                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;
                /**
                 * The x position of this Game Object.
                 */
                x: number;
                /**
                 * The y position of this Game Object.
                 */
                y: number;
                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;
                /**
                 * The w position of this Game Object.
                 */
                w: number;
                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;
                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;
                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;
                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;
                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;
                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;
                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;
                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;
                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;
                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;
                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;
                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;
                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;
                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;
                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;
                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;
                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;
                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;
                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;
            }

            /**
             * A Matrix used for display transformations for rendering.
             * 
             * It is represented like so:
             * 
             * ```
             * | a | c | tx |
             * | b | d | ty |
             * | 0 | 0 | 1  |
             * ```
             */
            class TransformMatrix {
                /**
                 * 
                 * @param a The Scale X value. Default 1.
                 * @param b The Skew Y value. Default 0.
                 * @param c The Skew X value. Default 0.
                 * @param d The Scale Y value. Default 1.
                 * @param tx The Translate X value. Default 0.
                 * @param ty The Translate Y value. Default 0.
                 */
                constructor(a?: number, b?: number, c?: number, d?: number, tx?: number, ty?: number);

                /**
                 * The matrix values.
                 */
                matrix: Float32Array;

                /**
                 * The decomposed matrix.
                 */
                decomposedMatrix: object;

                /**
                 * The temporary quad value cache.
                 */
                quad: Float32Array;

                /**
                 * The Scale X value.
                 */
                a: number;

                /**
                 * The Skew Y value.
                 */
                b: number;

                /**
                 * The Skew X value.
                 */
                c: number;

                /**
                 * The Scale Y value.
                 */
                d: number;

                /**
                 * The Translate X value.
                 */
                e: number;

                /**
                 * The Translate Y value.
                 */
                f: number;

                /**
                 * The Translate X value.
                 */
                tx: number;

                /**
                 * The Translate Y value.
                 */
                ty: number;

                /**
                 * The rotation of the Matrix. Value is in radians.
                 */
                readonly rotation: number;

                /**
                 * The rotation of the Matrix, normalized to be within the Phaser right-handed
                 * clockwise rotation space. Value is in radians.
                 */
                readonly rotationNormalized: number;

                /**
                 * The decomposed horizontal scale of the Matrix. This value is always positive.
                 */
                readonly scaleX: number;

                /**
                 * The decomposed vertical scale of the Matrix. This value is always positive.
                 */
                readonly scaleY: number;

                /**
                 * Reset the Matrix to an identity matrix.
                 */
                loadIdentity(): this;

                /**
                 * Translate the Matrix.
                 * @param x The horizontal translation value.
                 * @param y The vertical translation value.
                 */
                translate(x: number, y: number): this;

                /**
                 * Scale the Matrix.
                 * @param x The horizontal scale value.
                 * @param y The vertical scale value.
                 */
                scale(x: number, y: number): this;

                /**
                 * Rotate the Matrix.
                 * @param angle The angle of rotation in radians.
                 */
                rotate(angle: number): this;

                /**
                 * Multiply this Matrix by the given Matrix.
                 * 
                 * If an `out` Matrix is given then the results will be stored in it.
                 * If it is not given, this matrix will be updated in place instead.
                 * Use an `out` Matrix if you do not wish to mutate this matrix.
                 * @param rhs The Matrix to multiply by.
                 * @param out An optional Matrix to store the results in.
                 */
                multiply(rhs: Phaser.GameObjects.Components.TransformMatrix, out?: Phaser.GameObjects.Components.TransformMatrix): this | Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Multiply this Matrix by the matrix given, including the offset.
                 * 
                 * The offsetX is added to the tx value: `offsetX * a + offsetY * c + tx`.
                 * The offsetY is added to the ty value: `offsetY * b + offsetY * d + ty`.
                 * @param src The source Matrix to copy from.
                 * @param offsetX Horizontal offset to factor in to the multiplication.
                 * @param offsetY Vertical offset to factor in to the multiplication.
                 */
                multiplyWithOffset(src: Phaser.GameObjects.Components.TransformMatrix, offsetX: number, offsetY: number): this;

                /**
                 * Transform the Matrix.
                 * @param a The Scale X value.
                 * @param b The Shear Y value.
                 * @param c The Shear X value.
                 * @param d The Scale Y value.
                 * @param tx The Translate X value.
                 * @param ty The Translate Y value.
                 */
                transform(a: number, b: number, c: number, d: number, tx: number, ty: number): this;

                /**
                 * Transform a point in to the local space of this Matrix.
                 * @param x The x coordinate of the point to transform.
                 * @param y The y coordinate of the point to transform.
                 * @param point Optional Point object to store the transformed coordinates in.
                 */
                transformPoint(x: number, y: number, point?: Phaser.Types.Math.Vector2Like): Phaser.Types.Math.Vector2Like;

                /**
                 * Invert the Matrix.
                 */
                invert(): this;

                /**
                 * Set the values of this Matrix to copy those of the matrix given.
                 * @param src The source Matrix to copy from.
                 */
                copyFrom(src: Phaser.GameObjects.Components.TransformMatrix): this;

                /**
                 * Set the values of this Matrix to copy those of the array given.
                 * Where array indexes 0, 1, 2, 3, 4 and 5 are mapped to a, b, c, d, e and f.
                 * @param src The array of values to set into this matrix.
                 */
                copyFromArray(src: any[]): this;

                /**
                 * Copy the values from this Matrix to the given Canvas Rendering Context.
                 * This will use the Context.transform method.
                 * @param ctx The Canvas Rendering Context to copy the matrix values to.
                 */
                copyToContext(ctx: CanvasRenderingContext2D): CanvasRenderingContext2D;

                /**
                 * Copy the values from this Matrix to the given Canvas Rendering Context.
                 * This will use the Context.setTransform method.
                 * @param ctx The Canvas Rendering Context to copy the matrix values to.
                 */
                setToContext(ctx: CanvasRenderingContext2D): CanvasRenderingContext2D;

                /**
                 * Copy the values in this Matrix to the array given.
                 * 
                 * Where array indexes 0, 1, 2, 3, 4 and 5 are mapped to a, b, c, d, e and f.
                 * @param out The array to copy the matrix values in to.
                 */
                copyToArray(out?: any[]): any[];

                /**
                 * Set the values of this Matrix.
                 * @param a The Scale X value.
                 * @param b The Shear Y value.
                 * @param c The Shear X value.
                 * @param d The Scale Y value.
                 * @param tx The Translate X value.
                 * @param ty The Translate Y value.
                 */
                setTransform(a: number, b: number, c: number, d: number, tx: number, ty: number): this;

                /**
                 * Decompose this Matrix into its translation, scale and rotation values using QR decomposition.
                 * 
                 * The result must be applied in the following order to reproduce the current matrix:
                 * 
                 * translate -> rotate -> scale
                 */
                decomposeMatrix(): Phaser.Types.GameObjects.DecomposeMatrixResults;

                /**
                 * Apply the identity, translate, rotate and scale operations on the Matrix.
                 * @param x The horizontal translation.
                 * @param y The vertical translation.
                 * @param rotation The angle of rotation in radians.
                 * @param scaleX The horizontal scale.
                 * @param scaleY The vertical scale.
                 */
                applyITRS(x: number, y: number, rotation: number, scaleX: number, scaleY: number): this;

                /**
                 * Takes the `x` and `y` values and returns a new position in the `output` vector that is the inverse of
                 * the current matrix with its transformation applied.
                 * 
                 * Can be used to translate points from world to local space.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param output A Vector2, or point-like object, to store the results in.
                 */
                applyInverse(x: number, y: number, output?: Phaser.Math.Vector2): Phaser.Math.Vector2;

                /**
                 * Performs the 8 calculations required to create the vertices of
                 * a quad based on this matrix and the given x/y/xw/yh values.
                 * 
                 * The result is stored in `TransformMatrix.quad`, which is returned
                 * from this method.
                 * @param x The x value.
                 * @param y The y value.
                 * @param xw The xw value.
                 * @param yh The yh value.
                 * @param roundPixels Pass the results via Math.round? Default false.
                 * @param quad Optional Float32Array to store the results in. Otherwises uses the local quad array.
                 */
                setQuad(x: number, y: number, xw: number, yh: number, roundPixels?: boolean, quad?: Float32Array): Float32Array;

                /**
                 * Returns the X component of this matrix multiplied by the given values.
                 * This is the same as `x * a + y * c + e`.
                 * @param x The x value.
                 * @param y The y value.
                 */
                getX(x: number, y: number): number;

                /**
                 * Returns the Y component of this matrix multiplied by the given values.
                 * This is the same as `x * b + y * d + f`.
                 * @param x The x value.
                 * @param y The y value.
                 */
                getY(x: number, y: number): number;

                /**
                 * Returns the X component of this matrix multiplied by the given values.
                 * 
                 * This is the same as `x * a + y * c + e`, optionally passing via `Math.round`.
                 * @param x The x value.
                 * @param y The y value.
                 * @param round Math.round the resulting value? Default false.
                 */
                getXRound(x: number, y: number, round?: boolean): number;

                /**
                 * Returns the Y component of this matrix multiplied by the given values.
                 * 
                 * This is the same as `x * b + y * d + f`, optionally passing via `Math.round`.
                 * @param x The x value.
                 * @param y The y value.
                 * @param round Math.round the resulting value? Default false.
                 */
                getYRound(x: number, y: number, round?: boolean): number;

                /**
                 * Returns a string that can be used in a CSS Transform call as a `matrix` property.
                 */
                getCSSMatrix(): string;

                /**
                 * Destroys this Transform Matrix.
                 */
                destroy(): void;

            }

            /**
             * Provides methods used for setting the visibility of a Game Object.
             * Should be applied as a mixin and not used directly.
             */
            interface Visible {
                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;
                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;
            }

        }

        /**
         * A Container Game Object.
         * 
         * A Container, as the name implies, can 'contain' other types of Game Object.
         * When a Game Object is added to a Container, the Container becomes responsible for the rendering of it.
         * By default it will be removed from the Display List and instead added to the Containers own internal list.
         * 
         * The position of the Game Object automatically becomes relative to the position of the Container.
         * 
         * The transform point of a Container is 0x0 (in local space) and that cannot be changed. The children you add to the
         * Container should be positioned with this value in mind. I.e. you should treat 0x0 as being the center of
         * the Container, and position children positively and negative around it as required.
         * 
         * When the Container is rendered, all of its children are rendered as well, in the order in which they exist
         * within the Container. Container children can be repositioned using methods such as `MoveUp`, `MoveDown` and `SendToBack`.
         * 
         * If you modify a transform property of the Container, such as `Container.x` or `Container.rotation` then it will
         * automatically influence all children as well.
         * 
         * Containers can include other Containers for deeply nested transforms.
         * 
         * Containers can have masks set on them and can be used as a mask too. However, Container children cannot be masked.
         * The masks do not 'stack up'. Only a Container on the root of the display list will use its mask.
         * 
         * Containers can be enabled for input. Because they do not have a texture you need to provide a shape for them
         * to use as their hit area. Container children can also be enabled for input, independent of the Container.
         * 
         * If input enabling a _child_ you should not set both the `origin` and a **negative** scale factor on the child,
         * or the input area will become misaligned.
         * 
         * Containers can be given a physics body for either Arcade Physics, Impact Physics or Matter Physics. However,
         * if Container _children_ are enabled for physics you may get unexpected results, such as offset bodies,
         * if the Container itself, or any of its ancestors, is positioned anywhere other than at 0 x 0. Container children
         * with physics do not factor in the Container due to the excessive extra calculations needed. Please structure
         * your game to work around this.
         * 
         * It's important to understand the impact of using Containers. They add additional processing overhead into
         * every one of their children. The deeper you nest them, the more the cost escalates. This is especially true
         * for input events. You also loose the ability to set the display depth of Container children in the same
         * flexible manner as those not within them. In short, don't use them for the sake of it. You pay a small cost
         * every time you create one, try to structure your game around avoiding that where possible.
         */
        class Container extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.ComputedSize, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param children An optional array of Game Objects to add to this Container.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, children?: Phaser.GameObjects.GameObject[]);

            /**
             * An array holding the children of this Container.
             */
            list: Phaser.GameObjects.GameObject[];

            /**
             * Does this Container exclusively manage its children?
             * 
             * The default is `true` which means a child added to this Container cannot
             * belong in another Container, which includes the Scene display list.
             * 
             * If you disable this then this Container will no longer exclusively manage its children.
             * This allows you to create all kinds of interesting graphical effects, such as replicating
             * Game Objects without reparenting them all over the Scene.
             * However, doing so will prevent children from receiving any kind of input event or have
             * their physics bodies work by default, as they're no longer a single entity on the
             * display list, but are being replicated where-ever this Container is.
             */
            exclusive: boolean;

            /**
             * Containers can have an optional maximum size. If set to anything above 0 it
             * will constrict the addition of new Game Objects into the Container, capping off
             * the maximum limit the Container can grow in size to.
             */
            maxSize: number;

            /**
             * The cursor position.
             */
            position: number;

            /**
             * Internal Transform Matrix used for local space conversion.
             */
            localTransform: Phaser.GameObjects.Components.TransformMatrix;

            /**
             * The horizontal scroll factor of this Container.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Container.
             * 
             * When a camera scrolls it will change the location at which this Container is rendered on-screen.
             * It does not change the Containers actual position values.
             * 
             * For a Container, setting this value will only update the Container itself, not its children.
             * If you wish to change the scrollFactor of the children as well, use the `setScrollFactor` method.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Container.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Container.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Container.
             * 
             * When a camera scrolls it will change the location at which this Container is rendered on-screen.
             * It does not change the Containers actual position values.
             * 
             * For a Container, setting this value will only update the Container itself, not its children.
             * If you wish to change the scrollFactor of the children as well, use the `setScrollFactor` method.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Container.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Internal value to allow Containers to be used for input and physics.
             * Do not change this value. It has no effect other than to break things.
             */
            readonly originX: number;

            /**
             * Internal value to allow Containers to be used for input and physics.
             * Do not change this value. It has no effect other than to break things.
             */
            readonly originY: number;

            /**
             * Internal value to allow Containers to be used for input and physics.
             * Do not change this value. It has no effect other than to break things.
             */
            readonly displayOriginX: number;

            /**
             * Internal value to allow Containers to be used for input and physics.
             * Do not change this value. It has no effect other than to break things.
             */
            readonly displayOriginY: number;

            /**
             * Does this Container exclusively manage its children?
             * 
             * The default is `true` which means a child added to this Container cannot
             * belong in another Container, which includes the Scene display list.
             * 
             * If you disable this then this Container will no longer exclusively manage its children.
             * This allows you to create all kinds of interesting graphical effects, such as replicating
             * Game Objects without reparenting them all over the Scene.
             * However, doing so will prevent children from receiving any kind of input event or have
             * their physics bodies work by default, as they're no longer a single entity on the
             * display list, but are being replicated where-ever this Container is.
             * @param value The exclusive state of this Container. Default true.
             */
            setExclusive(value?: boolean): this;

            /**
             * Gets the bounds of this Container. It works by iterating all children of the Container,
             * getting their respective bounds, and then working out a min-max rectangle from that.
             * It does not factor in if the children render or not, all are included.
             * 
             * Some children are unable to return their bounds, such as Graphics objects, in which case
             * they are skipped.
             * 
             * Depending on the quantity of children in this Container it could be a really expensive call,
             * so cache it and only poll it as needed.
             * 
             * The values are stored and returned in a Rectangle object.
             * @param output A Geom.Rectangle object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds(output?: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle;

            /**
             * Takes a Point-like object, such as a Vector2, Geom.Point or object with public x and y properties,
             * and transforms it into the space of this Container, then returns it in the output object.
             * @param source The Source Point to be transformed.
             * @param output A destination object to store the transformed point in. If none given a Vector2 will be created and returned.
             */
            pointToContainer(source: Phaser.Types.Math.Vector2Like, output?: Phaser.Types.Math.Vector2Like): Phaser.Types.Math.Vector2Like;

            /**
             * Returns the world transform matrix as used for Bounds checks.
             * 
             * The returned matrix is temporal and shouldn't be stored.
             */
            getBoundsTransformMatrix(): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Adds the given Game Object, or array of Game Objects, to this Container.
             * 
             * Each Game Object must be unique within the Container.
             * @param child The Game Object, or array of Game Objects, to add to the Container.
             */
            add<T extends Phaser.GameObjects.GameObject>(child: (T|T[])): this;

            /**
             * Adds the given Game Object, or array of Game Objects, to this Container at the specified position.
             * 
             * Existing Game Objects in the Container are shifted up.
             * 
             * Each Game Object must be unique within the Container.
             * @param child The Game Object, or array of Game Objects, to add to the Container.
             * @param index The position to insert the Game Object/s at. Default 0.
             */
            addAt<T extends Phaser.GameObjects.GameObject>(child: (T|T[]), index?: number): this;

            /**
             * Returns the Game Object at the given position in this Container.
             * @param index The position to get the Game Object from.
             */
            getAt<T extends Phaser.GameObjects.GameObject>(index: number): T;

            /**
             * Returns the index of the given Game Object in this Container.
             * @param child The Game Object to search for in this Container.
             */
            getIndex<T extends Phaser.GameObjects.GameObject>(child: T): number;

            /**
             * Sort the contents of this Container so the items are in order based on the given property.
             * For example: `sort('alpha')` would sort the elements based on the value of their `alpha` property.
             * @param property The property to lexically sort by.
             * @param handler Provide your own custom handler function. Will receive 2 children which it should compare and return a boolean.
             */
            sort(property: string, handler?: Function): this;

            /**
             * Searches for the first instance of a child with its `name` property matching the given argument.
             * Should more than one child have the same name only the first is returned.
             * @param name The name to search for.
             */
            getByName<T extends Phaser.GameObjects.GameObject>(name: string): T;

            /**
             * Returns a random Game Object from this Container.
             * @param startIndex An optional start index. Default 0.
             * @param length An optional length, the total number of elements (from the startIndex) to choose from.
             */
            getRandom<T extends Phaser.GameObjects.GameObject>(startIndex?: number, length?: number): T;

            /**
             * Gets the first Game Object in this Container.
             * 
             * You can also specify a property and value to search for, in which case it will return the first
             * Game Object in this Container with a matching property and / or value.
             * 
             * For example: `getFirst('visible', true)` would return the first Game Object that had its `visible` property set.
             * 
             * You can limit the search to the `startIndex` - `endIndex` range.
             * @param property The property to test on each Game Object in the Container.
             * @param value The value to test the property against. Must pass a strict (`===`) comparison check.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default Container.length.
             */
            getFirst<T extends Phaser.GameObjects.GameObject>(property: string, value: any, startIndex?: number, endIndex?: number): T;

            /**
             * Returns all Game Objects in this Container.
             * 
             * You can optionally specify a matching criteria using the `property` and `value` arguments.
             * 
             * For example: `getAll('body')` would return only Game Objects that have a body property.
             * 
             * You can also specify a value to compare the property to:
             * 
             * `getAll('visible', true)` would return only Game Objects that have their visible property set to `true`.
             * 
             * Optionally you can specify a start and end index. For example if this Container had 100 Game Objects,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would return matches from only
             * the first 50 Game Objects.
             * @param property The property to test on each Game Object in the Container.
             * @param value If property is set then the `property` must strictly equal this value to be included in the results.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default Container.length.
             */
            getAll<T extends Phaser.GameObjects.GameObject>(property?: string, value?: any, startIndex?: number, endIndex?: number): T[];

            /**
             * Returns the total number of Game Objects in this Container that have a property
             * matching the given value.
             * 
             * For example: `count('visible', true)` would count all the elements that have their visible property set.
             * 
             * You can optionally limit the operation to the `startIndex` - `endIndex` range.
             * @param property The property to check.
             * @param value The value to check.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default Container.length.
             */
            count(property: string, value: any, startIndex?: number, endIndex?: number): number;

            /**
             * Swaps the position of two Game Objects in this Container.
             * Both Game Objects must belong to this Container.
             * @param child1 The first Game Object to swap.
             * @param child2 The second Game Object to swap.
             */
            swap<T extends Phaser.GameObjects.GameObject>(child1: T, child2: T): this;

            /**
             * Moves a Game Object to a new position within this Container.
             * 
             * The Game Object must already be a child of this Container.
             * 
             * The Game Object is removed from its old position and inserted into the new one.
             * Therefore the Container size does not change. Other children will change position accordingly.
             * @param child The Game Object to move.
             * @param index The new position of the Game Object in this Container.
             */
            moveTo<T extends Phaser.GameObjects.GameObject>(child: T, index: number): this;

            /**
             * Moves a Game Object above another one within this Container.
             * 
             * These 2 Game Objects must already be children of this Container.
             * @param child1 The Game Object to move above base Game Object.
             * @param child2 The base Game Object.
             */
            moveAbove<T extends Phaser.GameObjects.GameObject>(child1: T, child2: T): this;

            /**
             * Moves a Game Object below another one within this Container.
             * 
             * These 2 Game Objects must already be children of this Container.
             * @param child1 The Game Object to move below base Game Object.
             * @param child2 The base Game Object.
             */
            moveBelow<T extends Phaser.GameObjects.GameObject>(child1: T, child2: T): this;

            /**
             * Removes the given Game Object, or array of Game Objects, from this Container.
             * 
             * The Game Objects must already be children of this Container.
             * 
             * You can also optionally call `destroy` on each Game Object that is removed from the Container.
             * @param child The Game Object, or array of Game Objects, to be removed from the Container.
             * @param destroyChild Optionally call `destroy` on each child successfully removed from this Container. Default false.
             */
            remove<T extends Phaser.GameObjects.GameObject>(child: (T|T[]), destroyChild?: boolean): this;

            /**
             * Removes the Game Object at the given position in this Container.
             * 
             * You can also optionally call `destroy` on the Game Object, if one is found.
             * @param index The index of the Game Object to be removed.
             * @param destroyChild Optionally call `destroy` on the Game Object if successfully removed from this Container. Default false.
             */
            removeAt(index: number, destroyChild?: boolean): this;

            /**
             * Removes the Game Objects between the given positions in this Container.
             * 
             * You can also optionally call `destroy` on each Game Object that is removed from the Container.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default Container.length.
             * @param destroyChild Optionally call `destroy` on each Game Object successfully removed from this Container. Default false.
             */
            removeBetween(startIndex?: number, endIndex?: number, destroyChild?: boolean): this;

            /**
             * Removes all Game Objects from this Container.
             * 
             * You can also optionally call `destroy` on each Game Object that is removed from the Container.
             * @param destroyChild Optionally call `destroy` on each Game Object successfully removed from this Container. Default false.
             */
            removeAll(destroyChild?: boolean): this;

            /**
             * Brings the given Game Object to the top of this Container.
             * This will cause it to render on-top of any other objects in the Container.
             * @param child The Game Object to bring to the top of the Container.
             */
            bringToTop<T extends Phaser.GameObjects.GameObject>(child: T): this;

            /**
             * Sends the given Game Object to the bottom of this Container.
             * This will cause it to render below any other objects in the Container.
             * @param child The Game Object to send to the bottom of the Container.
             */
            sendToBack<T extends Phaser.GameObjects.GameObject>(child: T): this;

            /**
             * Moves the given Game Object up one place in this Container, unless it's already at the top.
             * @param child The Game Object to be moved in the Container.
             */
            moveUp<T extends Phaser.GameObjects.GameObject>(child: T): this;

            /**
             * Moves the given Game Object down one place in this Container, unless it's already at the bottom.
             * @param child The Game Object to be moved in the Container.
             */
            moveDown<T extends Phaser.GameObjects.GameObject>(child: T): this;

            /**
             * Reverses the order of all Game Objects in this Container.
             */
            reverse(): this;

            /**
             * Shuffles the all Game Objects in this Container using the Fisher-Yates implementation.
             */
            shuffle(): this;

            /**
             * Replaces a Game Object in this Container with the new Game Object.
             * The new Game Object cannot already be a child of this Container.
             * @param oldChild The Game Object in this Container that will be replaced.
             * @param newChild The Game Object to be added to this Container.
             * @param destroyChild Optionally call `destroy` on the Game Object if successfully removed from this Container. Default false.
             */
            replace<T extends Phaser.GameObjects.GameObject>(oldChild: T, newChild: T, destroyChild?: boolean): this;

            /**
             * Returns `true` if the given Game Object is a direct child of this Container.
             * 
             * This check does not scan nested Containers.
             * @param child The Game Object to check for within this Container.
             */
            exists<T extends Phaser.GameObjects.GameObject>(child: T): boolean;

            /**
             * Sets the property to the given value on all Game Objects in this Container.
             * 
             * Optionally you can specify a start and end index. For example if this Container had 100 Game Objects,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would return matches from only
             * the first 50 Game Objects.
             * @param property The property that must exist on the Game Object.
             * @param value The value to get the property to.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default Container.length.
             */
            setAll(property: string, value: any, startIndex?: number, endIndex?: number): this;

            /**
             * Passes all Game Objects in this Container to the given callback.
             * 
             * A copy of the Container is made before passing each entry to your callback.
             * This protects against the callback itself modifying the Container.
             * 
             * If you know for sure that the callback will not change the size of this Container
             * then you can use the more performant `Container.iterate` method instead.
             * @param callback The function to call.
             * @param context Value to use as `this` when executing callback.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            each(callback: Function, context?: object, ...args: any[]): this;

            /**
             * Passes all Game Objects in this Container to the given callback.
             * 
             * Only use this method when you absolutely know that the Container will not be modified during
             * the iteration, i.e. by removing or adding to its contents.
             * @param callback The function to call.
             * @param context Value to use as `this` when executing callback.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            iterate(callback: Function, context?: object, ...args: any[]): this;

            /**
             * Sets the scroll factor of this Container and optionally all of its children.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             * @param updateChildren Apply this scrollFactor to all Container children as well? Default false.
             */
            setScrollFactor(x: number, y?: number, updateChildren?: boolean): this;

            /**
             * The number of Game Objects inside this Container.
             */
            readonly length: number;

            /**
             * Returns the first Game Object within the Container, or `null` if it is empty.
             * 
             * You can move the cursor by calling `Container.next` and `Container.previous`.
             */
            readonly first: Phaser.GameObjects.GameObject | null;

            /**
             * Returns the last Game Object within the Container, or `null` if it is empty.
             * 
             * You can move the cursor by calling `Container.next` and `Container.previous`.
             */
            readonly last: Phaser.GameObjects.GameObject | null;

            /**
             * Returns the next Game Object within the Container, or `null` if it is empty.
             * 
             * You can move the cursor by calling `Container.next` and `Container.previous`.
             */
            readonly next: Phaser.GameObjects.GameObject | null;

            /**
             * Returns the previous Game Object within the Container, or `null` if it is empty.
             * 
             * You can move the cursor by calling `Container.next` and `Container.previous`.
             */
            readonly previous: Phaser.GameObjects.GameObject | null;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Display List plugin.
         * 
         * Display Lists belong to a Scene and maintain the list of Game Objects to render every frame.
         * 
         * Some of these Game Objects may also be part of the Scene's [Update List]{@link Phaser.GameObjects.UpdateList}, for updating.
         */
        class DisplayList extends Phaser.Structs.List<Phaser.GameObjects.GameObject> {
            /**
             * 
             * @param scene The Scene that this Display List belongs to.
             */
            constructor(scene: Phaser.Scene);

            /**
             * The flag the determines whether Game Objects should be sorted when `depthSort()` is called.
             */
            sortChildrenFlag: boolean;

            /**
             * The Scene that this Display List belongs to.
             */
            scene: Phaser.Scene;

            /**
             * The Scene's Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The Scene's Event Emitter.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * Force a sort of the display list on the next call to depthSort.
             */
            queueDepthSort(): void;

            /**
             * Immediately sorts the display list if the flag is set.
             */
            depthSort(): void;

            /**
             * Compare the depth of two Game Objects.
             * @param childA The first Game Object.
             * @param childB The second Game Object.
             */
            sortByDepth(childA: Phaser.GameObjects.GameObject, childB: Phaser.GameObjects.GameObject): number;

            /**
             * Returns an array which contains all objects currently on the Display List.
             * This is a reference to the main list array, not a copy of it, so be careful not to modify it.
             */
            getChildren(): Phaser.GameObjects.GameObject[];

        }

        /**
         * DOM Element Game Objects are a way to control and manipulate HTML Elements over the top of your game.
         * 
         * In order for DOM Elements to display you have to enable them by adding the following to your game
         * configuration object:
         * 
         * ```javascript
         * dom {
         *   createContainer: true
         * }
         * ```
         * 
         * You must also have a parent container for Phaser. This is specified by the `parent` property in the
         * game config.
         * 
         * When these two things are added, Phaser will automatically create a DOM Container div that is positioned
         * over the top of the game canvas. This div is sized to match the canvas, and if the canvas size changes,
         * as a result of settings within the Scale Manager, the dom container is resized accordingly.
         * 
         * If you have not already done so, you have to provide a `parent` in the Game Configuration, or the DOM
         * Container will fail to be created.
         * 
         * You can create a DOM Element by either passing in DOMStrings, or by passing in a reference to an existing
         * Element that you wish to be placed under the control of Phaser. For example:
         * 
         * ```javascript
         * this.add.dom(x, y, 'div', 'background-color: lime; width: 220px; height: 100px; font: 48px Arial', 'Phaser');
         * ```
         * 
         * The above code will insert a div element into the DOM Container at the given x/y coordinate. The DOMString in
         * the 4th argument sets the initial CSS style of the div and the final argument is the inner text. In this case,
         * it will create a lime colored div that is 220px by 100px in size with the text Phaser in it, in an Arial font.
         * 
         * You should nearly always, without exception, use explicitly sized HTML Elements, in order to fully control
         * alignment and positioning of the elements next to regular game content.
         * 
         * Rather than specify the CSS and HTML directly you can use the `load.html` File Loader to load it into the
         * cache and then use the `createFromCache` method instead. You can also use `createFromHTML` and various other
         * methods available in this class to help construct your elements.
         * 
         * Once the element has been created you can then control it like you would any other Game Object. You can set its
         * position, scale, rotation, alpha and other properties. It will move as the main Scene Camera moves and be clipped
         * at the edge of the canvas. It's important to remember some limitations of DOM Elements: The obvious one is that
         * they appear above or below your game canvas. You cannot blend them into the display list, meaning you cannot have
         * a DOM Element, then a Sprite, then another DOM Element behind it.
         * 
         * They also cannot be enabled for input. To do that, you have to use the `addListener` method to add native event
         * listeners directly. The final limitation is to do with cameras. The DOM Container is sized to match the game canvas
         * entirely and clipped accordingly. DOM Elements respect camera scrolling and scrollFactor settings, but if you
         * change the size of the camera so it no longer matches the size of the canvas, they won't be clipped accordingly.
         * 
         * Also, all DOM Elements are inserted into the same DOM Container, regardless of which Scene they are created in.
         * 
         * Note that you should only have DOM Elements in a Scene with a _single_ Camera. If you require multiple cameras,
         * use parallel scenes to achieve this.
         * 
         * DOM Elements are a powerful way to align native HTML with your Phaser Game Objects. For example, you can insert
         * a login form for a multiplayer game directly into your title screen. Or a text input box for a highscore table.
         * Or a banner ad from a 3rd party service. Or perhaps you'd like to use them for high resolution text display and
         * UI. The choice is up to you, just remember that you're dealing with standard HTML and CSS floating over the top
         * of your game, and should treat it accordingly.
         */
        class DOMElement extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this DOM Element in the world. Default 0.
             * @param y The vertical position of this DOM Element in the world. Default 0.
             * @param element An existing DOM element, or a string. If a string starting with a # it will do a `getElementById` look-up on the string (minus the hash). Without a hash, it represents the type of element to create, i.e. 'div'.
             * @param style If a string, will be set directly as the elements `style` property value. If a plain object, will be iterated and the values transferred. In both cases the values replacing whatever CSS styles may have been previously set.
             * @param innerText If given, will be set directly as the elements `innerText` property value, replacing whatever was there before.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, element?: Element | string, style?: string | any, innerText?: string);

            /**
             * A reference to the parent DOM Container that the Game instance created when it started.
             */
            parent: Element;

            /**
             * A reference to the HTML Cache.
             */
            cache: Phaser.Cache.BaseCache;

            /**
             * The actual DOM Element that this Game Object is bound to. For example, if you've created a `<div>`
             * then this property is a direct reference to that element within the dom.
             */
            node: Element;

            /**
             * By default a DOM Element will have its transform, display, opacity, zIndex and blend mode properties
             * updated when its rendered. If, for some reason, you don't want any of these changed other than the
             * CSS transform, then set this flag to `true`. When `true` only the CSS Transform is applied and it's
             * up to you to keep track of and set the other properties as required.
             * 
             * This can be handy if, for example, you've a nested DOM Element and you don't want the opacity to be
             * picked-up by any of its children.
             */
            transformOnly: boolean;

            /**
             * The angle, in radians, by which to skew the DOM Element on the horizontal axis.
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/transform
             */
            skewX: number;

            /**
             * The angle, in radians, by which to skew the DOM Element on the vertical axis.
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/transform
             */
            skewY: number;

            /**
             * A Vector4 that contains the 3D rotation of this DOM Element around a fixed axis in 3D space.
             * 
             * All values in the Vector4 are treated as degrees, unless the `rotate3dAngle` property is changed.
             * 
             * For more details see the following MDN page:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/transform-function/rotate3d
             */
            rotate3d: Phaser.Math.Vector4;

            /**
             * The unit that represents the 3D rotation values. By default this is `deg` for degrees, but can
             * be changed to any supported unit. See this page for further details:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/transform-function/rotate3d
             */
            rotate3dAngle: string;

            /**
             * Sets the CSS `pointerEvents` attribute on the DOM Element during rendering.
             * 
             * This is 'auto' by default. Changing it may have unintended side-effects with
             * internal Phaser input handling, such as dragging, so only change this if you
             * understand the implications.
             */
            pointerEvents: string;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * For a DOM Element this property is read-only.
             * 
             * The property `displayWidth` holds the computed bounds of this DOM Element, factoring in scaling.
             */
            readonly width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * For a DOM Element this property is read-only.
             * 
             * The property `displayHeight` holds the computed bounds of this DOM Element, factoring in scaling.
             */
            readonly height: number;

            /**
             * The computed display width of this Game Object, based on the `getBoundingClientRect` DOM call.
             * 
             * The property `width` holds the un-scaled width of this DOM Element.
             */
            readonly displayWidth: number;

            /**
             * The computed display height of this Game Object, based on the `getBoundingClientRect` DOM call.
             * 
             * The property `height` holds the un-scaled height of this DOM Element.
             */
            readonly displayHeight: number;

            /**
             * Sets the horizontal and vertical skew values of this DOM Element.
             * 
             * For more information see: https://developer.mozilla.org/en-US/docs/Web/CSS/transform
             * @param x The angle, in radians, by which to skew the DOM Element on the horizontal axis. Default 0.
             * @param y The angle, in radians, by which to skew the DOM Element on the vertical axis. Default x.
             */
            setSkew(x?: number, y?: number): this;

            /**
             * Sets the perspective CSS property of the _parent DOM Container_. This determines the distance between the z=0
             * plane and the user in order to give a 3D-positioned element some perspective. Each 3D element with
             * z > 0 becomes larger; each 3D-element with z < 0 becomes smaller. The strength of the effect is determined
             * by the value of this property.
             * 
             * For more information see: https://developer.mozilla.org/en-US/docs/Web/CSS/perspective
             * 
             * **Changing this value changes it globally for all DOM Elements, as they all share the same parent container.**
             * @param value The perspective value, in pixels, that determines the distance between the z plane and the user.
             */
            setPerspective(value: number): this;

            /**
             * The perspective CSS property value of the _parent DOM Container_. This determines the distance between the z=0
             * plane and the user in order to give a 3D-positioned element some perspective. Each 3D element with
             * z > 0 becomes larger; each 3D-element with z < 0 becomes smaller. The strength of the effect is determined
             * by the value of this property.
             * 
             * For more information see: https://developer.mozilla.org/en-US/docs/Web/CSS/perspective
             * 
             * **Changing this value changes it globally for all DOM Elements, as they all share the same parent container.**
             */
            perspective: number;

            /**
             * Adds one or more native DOM event listeners onto the underlying Element of this Game Object.
             * The event is then dispatched via this Game Objects standard event emitter.
             * 
             * For example:
             * 
             * ```javascript
             * var div = this.add.dom(x, y, element);
             * 
             * div.addListener('click');
             * 
             * div.on('click', handler);
             * ```
             * @param events The DOM event/s to listen for. You can specify multiple events by separating them with spaces.
             */
            addListener(events: string): this;

            /**
             * Removes one or more native DOM event listeners from the underlying Element of this Game Object.
             * @param events The DOM event/s to stop listening for. You can specify multiple events by separating them with spaces.
             */
            removeListener(events: string): this;

            /**
             * Creates a native DOM Element, adds it to the parent DOM Container and then binds it to this Game Object,
             * so you can control it. The `tagName` should be a string and is passed to `document.createElement`:
             * 
             * ```javascript
             * this.add.dom().createElement('div');
             * ```
             * 
             * For more details on acceptable tag names see: https://developer.mozilla.org/en-US/docs/Web/API/Document/createElement
             * 
             * You can also pass in a DOMString or style object to set the CSS on the created element, and an optional `innerText`
             * value as well. Here is an example of a DOMString:
             * 
             * ```javascript
             * this.add.dom().createElement('div', 'background-color: lime; width: 220px; height: 100px; font: 48px Arial', 'Phaser');
             * ```
             * 
             * And using a style object:
             * 
             * ```javascript
             * var style = {
             *   'background-color': 'lime';
             *   'width': '200px';
             *   'height': '100px';
             *   'font': '48px Arial';
             * };
             * 
             * this.add.dom().createElement('div', style, 'Phaser');
             * ```
             * 
             * If this Game Object already has an Element, it is removed from the DOM entirely first.
             * Any event listeners you may have previously created will need to be re-created after this call.
             * @param tagName A string that specifies the type of element to be created. The nodeName of the created element is initialized with the value of tagName. Don't use qualified names (like "html:a") with this method.
             * @param style Either a DOMString that holds the CSS styles to be applied to the created element, or an object the styles will be ready from.
             * @param innerText A DOMString that holds the text that will be set as the innerText of the created element.
             */
            createElement(tagName: string, style?: string | any, innerText?: string): this;

            /**
             * Binds a new DOM Element to this Game Object. If this Game Object already has an Element it is removed from the DOM
             * entirely first. Any event listeners you may have previously created will need to be re-created on the new element.
             * 
             * The `element` argument you pass to this method can be either a string tagName:
             * 
             * ```javascript
             * <h1 id="heading">Phaser</h1>
             * 
             * this.add.dom().setElement('heading');
             * ```
             * 
             * Or a reference to an Element instance:
             * 
             * ```javascript
             * <h1 id="heading">Phaser</h1>
             * 
             * var h1 = document.getElementById('heading');
             * 
             * this.add.dom().setElement(h1);
             * ```
             * 
             * You can also pass in a DOMString or style object to set the CSS on the created element, and an optional `innerText`
             * value as well. Here is an example of a DOMString:
             * 
             * ```javascript
             * this.add.dom().setElement(h1, 'background-color: lime; width: 220px; height: 100px; font: 48px Arial', 'Phaser');
             * ```
             * 
             * And using a style object:
             * 
             * ```javascript
             * var style = {
             *   'background-color': 'lime';
             *   'width': '200px';
             *   'height': '100px';
             *   'font': '48px Arial';
             * };
             * 
             * this.add.dom().setElement(h1, style, 'Phaser');
             * ```
             * @param element If a string it is passed to `getElementById()`, or it should be a reference to an existing Element.
             * @param style Either a DOMString that holds the CSS styles to be applied to the created element, or an object the styles will be ready from.
             * @param innerText A DOMString that holds the text that will be set as the innerText of the created element.
             */
            setElement(element: string | Element, style?: string | any, innerText?: string): this;

            /**
             * Takes a block of html from the HTML Cache, that has previously been preloaded into the game, and then
             * creates a DOM Element from it. The loaded HTML is set as the `innerHTML` property of the created
             * element.
             * 
             * Assume the following html is stored in a file called `loginform.html`:
             * 
             * ```html
             * <input type="text" name="nameField" placeholder="Enter your name" style="font-size: 32px">
             * <input type="button" name="playButton" value="Let's Play" style="font-size: 32px">
             * ```
             * 
             * Which is loaded into your game using the cache key 'login':
             * 
             * ```javascript
             * this.load.html('login', 'assets/loginform.html');
             * ```
             * 
             * You can create a DOM Element from it using the cache key:
             * 
             * ```javascript
             * this.add.dom().createFromCache('login');
             * ```
             * 
             * The optional `elementType` argument controls the container that is created, into which the loaded html is inserted.
             * The default is a plain `div` object, but any valid tagName can be given.
             * 
             * If this Game Object already has an Element, it is removed from the DOM entirely first.
             * Any event listeners you may have previously created will need to be re-created after this call.
             * @param The key of the html cache entry to use for this DOM Element.
             * @param tagName The tag name of the element into which all of the loaded html will be inserted. Defaults to a plain div tag. Default 'div'.
             */
            createFromCache(The: string, tagName?: string): this;

            /**
             * Takes a string of html and then creates a DOM Element from it. The HTML is set as the `innerHTML`
             * property of the created element.
             * 
             * ```javascript
             * let form = `
             * <input type="text" name="nameField" placeholder="Enter your name" style="font-size: 32px">
             * <input type="button" name="playButton" value="Let's Play" style="font-size: 32px">
             * `;
             * ```
             * 
             * You can create a DOM Element from it using the string:
             * 
             * ```javascript
             * this.add.dom().createFromHTML(form);
             * ```
             * 
             * The optional `elementType` argument controls the type of container that is created, into which the html is inserted.
             * The default is a plain `div` object, but any valid tagName can be given.
             * 
             * If this Game Object already has an Element, it is removed from the DOM entirely first.
             * Any event listeners you may have previously created will need to be re-created after this call.
             * @param html A string of html to be set as the `innerHTML` property of the created element.
             * @param tagName The tag name of the element into which all of the html will be inserted. Defaults to a plain div tag. Default 'div'.
             */
            createFromHTML(html: string, tagName?: string): this;

            /**
             * Removes the current DOM Element bound to this Game Object from the DOM entirely and resets the
             * `node` property of this Game Object to be `null`.
             */
            removeElement(): this;

            /**
             * Internal method that calls `getBoundingClientRect` on the `node` and then sets the bounds width
             * and height into the `displayWidth` and `displayHeight` properties, and the `clientWidth` and `clientHeight`
             * values into the `width` and `height` properties respectively.
             * 
             * This is called automatically whenever a new element is created or set.
             */
            updateSize(): this;

            /**
             * Gets all children from this DOM Elements node, using `querySelectorAll('*')` and then iterates through
             * them, looking for the first one that has a property matching the given key and value. It then returns this child
             * if found, or `null` if not.
             * @param property The property to search the children for.
             * @param value The value the property must strictly equal.
             */
            getChildByProperty(property: string, value: string): Element | null;

            /**
             * Gets all children from this DOM Elements node, using `querySelectorAll('*')` and then iterates through
             * them, looking for the first one that has a matching id. It then returns this child if found, or `null` if not.
             * 
             * Be aware that class and id names are case-sensitive.
             * @param id The id to search the children for.
             */
            getChildByID(id: string): Element | null;

            /**
             * Gets all children from this DOM Elements node, using `querySelectorAll('*')` and then iterates through
             * them, looking for the first one that has a matching name. It then returns this child if found, or `null` if not.
             * 
             * Be aware that class and id names are case-sensitive.
             * @param name The name to search the children for.
             */
            getChildByName(name: string): Element | null;

            /**
             * Sets the `className` property of the DOM Element node and updates the internal sizes.
             * @param className A string representing the class or space-separated classes of the element.
             */
            setClassName(className: string): this;

            /**
             * Sets the `innerText` property of the DOM Element node and updates the internal sizes.
             * 
             * Note that only certain types of Elements can have `innerText` set on them.
             * @param text A DOMString representing the rendered text content of the element.
             */
            setText(text: string): this;

            /**
             * Sets the `innerHTML` property of the DOM Element node and updates the internal sizes.
             * @param html A DOMString of html to be set as the `innerHTML` property of the element.
             */
            setHTML(html: string): this;

            /**
             * Compares the renderMask with the renderFlags to see if this Game Object will render or not.
             * 
             * DOMElements always return `true` as they need to still set values during the render pass, even if not visible.
             */
            willRender(): boolean;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        namespace Events {
            /**
             * The Game Object Added to Scene Event.
             * 
             * This event is dispatched when a Game Object is added to a Scene.
             * 
             * Listen for it on a Game Object instance using `GameObject.on('addedtoscene', listener)`.
             */
            const ADDED_TO_SCENE: string;

            /**
             * The Game Object Destroy Event.
             * 
             * This event is dispatched when a Game Object instance is being destroyed.
             * 
             * Listen for it on a Game Object instance using `GameObject.on('destroy', listener)`.
             */
            const DESTROY: string;

            /**
             * The Game Object Removed from Scene Event.
             * 
             * This event is dispatched when a Game Object is removed from a Scene.
             * 
             * Listen for it on a Game Object instance using `GameObject.on('removedfromscene', listener)`.
             */
            const REMOVED_FROM_SCENE: string;

            /**
             * The Video Game Object Complete Event.
             * 
             * This event is dispatched when a Video finishes playback by reaching the end of its duration. It
             * is also dispatched if a video marker sequence is being played and reaches the end.
             * 
             * Note that not all videos can fire this event. Live streams, for example, have no fixed duration,
             * so never technically 'complete'.
             * 
             * If a video is stopped from playback, via the `Video.stop` method, it will emit the
             * `VIDEO_STOP` event instead of this one.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('complete', listener)`.
             */
            const VIDEO_COMPLETE: string;

            /**
             * The Video Game Object Created Event.
             * 
             * This event is dispatched when the texture for a Video has been created. This happens
             * when enough of the video source has been loaded that the browser is able to render a
             * frame from it.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('created', listener)`.
             */
            const VIDEO_CREATED: string;

            /**
             * The Video Game Object Error Event.
             * 
             * This event is dispatched when a Video tries to play a source that does not exist, or is the wrong file type.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('error', listener)`.
             */
            const VIDEO_ERROR: string;

            /**
             * The Video Game Object Locked Event.
             * 
             * This event is dispatched when a Video was attempted to be played, but the browser prevented it
             * from doing so due to the Media Engagement Interaction policy.
             * 
             * If you get this event you will need to wait for the user to interact with the browser before
             * the video will play. This is a browser security measure to prevent autoplaying videos with
             * audio. An interaction includes a mouse click, a touch, or a key press.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('locked', listener)`.
             */
            const VIDEO_LOCKED: string;

            /**
             * The Video Game Object Loop Event.
             * 
             * This event is dispatched when a Video that is currently playing has looped. This only
             * happens if the `loop` parameter was specified, or the `setLoop` method was called,
             * and if the video has a fixed duration. Video streams, for example, cannot loop, as
             * they have no duration.
             * 
             * Looping is based on the result of the Video `timeupdate` event. This event is not
             * frame-accurate, due to the way browsers work, so please do not rely on this loop
             * event to be time or frame precise.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('loop', listener)`.
             */
            const VIDEO_LOOP: string;

            /**
             * The Video Game Object Playing Event.
             * 
             * The playing event is fired after playback is first started,
             * and whenever it is restarted. For example it is fired when playback
             * resumes after having been paused or delayed due to lack of data.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('playing', listener)`.
             */
            const VIDEO_PLAYING: string;

            /**
             * The Video Game Object Play Event.
             * 
             * This event is dispatched when a Video begins playback. For videos that do not require
             * interaction unlocking, this is usually as soon as the `Video.play` method is called.
             * However, for videos that require unlocking, it is fired once playback begins after
             * they've been unlocked.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('play', listener)`.
             */
            const VIDEO_PLAY: string;

            /**
             * The Video Game Object Seeked Event.
             * 
             * This event is dispatched when a Video completes seeking to a new point in its timeline.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('seeked', listener)`.
             */
            const VIDEO_SEEKED: string;

            /**
             * The Video Game Object Seeking Event.
             * 
             * This event is dispatched when a Video _begins_ seeking to a new point in its timeline.
             * When the seek is complete, it will dispatch the `VIDEO_SEEKED` event to conclude.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('seeking', listener)`.
             */
            const VIDEO_SEEKING: string;

            /**
             * The Video Game Object Stalled Event.
             * 
             * This event is dispatched by a Video Game Object when the video playback stalls.
             * 
             * This can happen if the video is buffering.
             * 
             * If will fire for any of the following native DOM events:
             * 
             * `stalled`
             * `suspend`
             * `waiting`
             * 
             * Listen for it from a Video Game Object instance using `Video.on('stalled', listener)`.
             * 
             * Note that being stalled isn't always a negative thing. A video can be stalled if it
             * has downloaded enough data in to its buffer to not need to download any more until
             * the current batch of frames have rendered.
             */
            const VIDEO_STALLED: string;

            /**
             * The Video Game Object Stopped Event.
             * 
             * This event is dispatched when a Video is stopped from playback via a call to the `Video.stop` method,
             * either directly via game code, or indirectly as the result of changing a video source or destroying it.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('stop', listener)`.
             */
            const VIDEO_STOP: string;

            /**
             * The Video Game Object Texture Ready Event.
             * 
             * This event is dispatched by a Video Game Object when it has finished creating its texture.
             * 
             * This happens when the video has finished loading enough data for its first frame.
             * 
             * If you wish to use the Video texture elsewhere in your game, such as as a Sprite texture,
             * then you should listen for this event first, before creating the Sprites that use it.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('textureready', listener)`.
             */
            const VIDEO_TEXTURE: string;

            /**
             * The Video Game Object Unlocked Event.
             * 
             * This event is dispatched when a Video that was prevented from playback due to the browsers
             * Media Engagement Interaction policy, is unlocked by a user gesture.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('unlocked', listener)`.
             */
            const VIDEO_UNLOCKED: string;

            /**
             * The Video Game Object Unsupported Event.
             * 
             * This event is dispatched by a Video Game Object if the media source
             * (which may be specified as a MediaStream, MediaSource, Blob, or File,
             * for example) doesn't represent a supported media format.
             * 
             * Listen for it from a Video Game Object instance using `Video.on('unsupported', listener)`.
             */
            const VIDEO_UNSUPPORTED: string;

        }

        /**
         * An Extern Game Object is a special type of Game Object that allows you to pass
         * rendering off to a 3rd party.
         * 
         * When you create an Extern and place it in the display list of a Scene, the renderer will
         * process the list as usual. When it finds an Extern it will flush the current batch,
         * clear down the pipeline and prepare a transform matrix which your render function can
         * take advantage of, if required.
         * 
         * The WebGL context is then left in a 'clean' state, ready for you to bind your own shaders,
         * or draw to it, whatever you wish to do. This should all take place in the `render` method.
         * The correct way to deploy an Extern object is to create a class that extends it, then
         * override the `render` (and optionally `preUpdate`) methods and pass off control to your
         * 3rd party libraries or custom WebGL code there.
         * 
         * Once you've finished, you should free-up any of your resources.
         * The Extern will then rebind the Phaser pipeline and carry on rendering the display list.
         * 
         * Although this object has lots of properties such as Alpha, Blend Mode and Tint, none of
         * them are used during rendering unless you take advantage of them in your own render code.
         */
        class Extern extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             */
            constructor(scene: Phaser.Scene);

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The base class that all Game Objects extend.
         * You don't create GameObjects directly and they cannot be added to the display list.
         * Instead, use them as the base for your own custom classes.
         */
        class GameObject extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs.
             * @param type A textual representation of the type of Game Object, i.e. `sprite`.
             */
            constructor(scene: Phaser.Scene, type: string);

            /**
             * A reference to the Scene to which this Game Object belongs.
             * 
             * Game Objects can only belong to one Scene.
             * 
             * You should consider this property as being read-only. You cannot move a
             * Game Object to another Scene by simply changing it.
             */
            scene: Phaser.Scene;

            /**
             * Holds a reference to the Display List that contains this Game Object.
             * 
             * This is set automatically when this Game Object is added to a Scene or Layer.
             * 
             * You should treat this property as being read-only.
             */
            displayList: Phaser.GameObjects.DisplayList | Phaser.GameObjects.Layer;

            /**
             * A textual representation of this Game Object, i.e. `sprite`.
             * Used internally by Phaser but is available for your own custom classes to populate.
             */
            type: string;

            /**
             * The current state of this Game Object.
             * 
             * Phaser itself will never modify this value, although plugins may do so.
             * 
             * Use this property to track the state of a Game Object during its lifetime. For example, it could change from
             * a state of 'moving', to 'attacking', to 'dead'. The state value should be an integer (ideally mapped to a constant
             * in your game code), or a string. These are recommended to keep it light and simple, with fast comparisons.
             * If you need to store complex data about your Game Object, look at using the Data Component instead.
             */
            state: number | string;

            /**
             * The parent Container of this Game Object, if it has one.
             */
            parentContainer: Phaser.GameObjects.Container;

            /**
             * The name of this Game Object.
             * Empty by default and never populated by Phaser, this is left for developers to use.
             */
            name: string;

            /**
             * The active state of this Game Object.
             * A Game Object with an active state of `true` is processed by the Scenes UpdateList, if added to it.
             * An active object is one which is having its logic and internal systems updated.
             */
            active: boolean;

            /**
             * The Tab Index of the Game Object.
             * Reserved for future use by plugins and the Input Manager.
             */
            tabIndex: number;

            /**
             * A Data Manager.
             * It allows you to store, query and get key/value paired information specific to this Game Object.
             * `null` by default. Automatically created if you use `getData` or `setData` or `setDataEnabled`.
             */
            data: Phaser.Data.DataManager;

            /**
             * The flags that are compared against `RENDER_MASK` to determine if this Game Object will render or not.
             * The bits are 0001 | 0010 | 0100 | 1000 set by the components Visible, Alpha, Transform and Texture respectively.
             * If those components are not used by your custom class then you can use this bitmask as you wish.
             */
            renderFlags: number;

            /**
             * A bitmask that controls if this Game Object is drawn by a Camera or not.
             * Not usually set directly, instead call `Camera.ignore`, however you can
             * set this property directly using the Camera.id property:
             */
            cameraFilter: number;

            /**
             * If this Game Object is enabled for input then this property will contain an InteractiveObject instance.
             * Not usually set directly. Instead call `GameObject.setInteractive()`.
             */
            input: Phaser.Types.Input.InteractiveObject | null;

            /**
             * If this Game Object is enabled for Arcade or Matter Physics then this property will contain a reference to a Physics Body.
             */
            body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody | MatterJS.BodyType | null;

            /**
             * This Game Object will ignore all calls made to its destroy method if this flag is set to `true`.
             * This includes calls that may come from a Group, Container or the Scene itself.
             * While it allows you to persist a Game Object across Scenes, please understand you are entirely
             * responsible for managing references to and from this Game Object.
             */
            ignoreDestroy: boolean;

            /**
             * Sets the `active` property of this Game Object and returns this Game Object for further chaining.
             * A Game Object with its `active` property set to `true` will be updated by the Scenes UpdateList.
             * @param value True if this Game Object should be set as active, false if not.
             */
            setActive(value: boolean): this;

            /**
             * Sets the `name` property of this Game Object and returns this Game Object for further chaining.
             * The `name` property is not populated by Phaser and is presented for your own use.
             * @param value The name to be given to this Game Object.
             */
            setName(value: string): this;

            /**
             * Sets the current state of this Game Object.
             * 
             * Phaser itself will never modify the State of a Game Object, although plugins may do so.
             * 
             * For example, a Game Object could change from a state of 'moving', to 'attacking', to 'dead'.
             * The state value should typically be an integer (ideally mapped to a constant
             * in your game code), but could also be a string. It is recommended to keep it light and simple.
             * If you need to store complex data about your Game Object, look at using the Data Component instead.
             * @param value The state of the Game Object.
             */
            setState(value: number | string): this;

            /**
             * Adds a Data Manager component to this Game Object.
             */
            setDataEnabled(): this;

            /**
             * Allows you to store a key value pair within this Game Objects Data Manager.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * ```javascript
             * sprite.setData('name', 'Red Gem Stone');
             * ```
             * 
             * You can also pass in an object of key value pairs as the first argument:
             * 
             * ```javascript
             * sprite.setData({ name: 'Red Gem Stone', level: 2, owner: 'Link', gold: 50 });
             * ```
             * 
             * To get a value back again you can call `getData`:
             * 
             * ```javascript
             * sprite.getData('gold');
             * ```
             * 
             * Or you can access the value directly via the `values` property, where it works like any other variable:
             * 
             * ```javascript
             * sprite.data.values.gold += 50;
             * ```
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * 
             * If the key already exists, a `changedata` event is emitted instead, along an event named after the key.
             * For example, if you updated an existing key called `PlayerLives` then it would emit the event `changedata-PlayerLives`.
             * These events will be emitted regardless if you use this method to set the value, or the direct `values` setter.
             * 
             * Please note that the data keys are case-sensitive and must be valid JavaScript Object property strings.
             * This means the keys `gold` and `Gold` are treated as two unique values within the Data Manager.
             * @param key The key to set the value for. Or an object of key value pairs. If an object the `data` argument is ignored.
             * @param data The value to set for the given key. If an object is provided as the key this argument is ignored.
             */
            setData<T extends any>(key: (string|T), data?: any): this;

            /**
             * Increase a value for the given key within this Game Objects Data Manager. If the key doesn't already exist in the Data Manager then it is increased from 0.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * @param key The key to change the value for.
             * @param amount The amount to increase the given key by. Pass a negative value to decrease the key. Default 1.
             */
            incData(key: string, amount?: number): this;

            /**
             * Toggle a boolean value for the given key within this Game Objects Data Manager. If the key doesn't already exist in the Data Manager then it is toggled from false.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * @param key The key to toggle the value for.
             */
            toggleData(key: string): this;

            /**
             * Retrieves the value for the given key in this Game Objects Data Manager, or undefined if it doesn't exist.
             * 
             * You can also access values via the `values` object. For example, if you had a key called `gold` you can do either:
             * 
             * ```javascript
             * sprite.getData('gold');
             * ```
             * 
             * Or access the value directly:
             * 
             * ```javascript
             * sprite.data.values.gold;
             * ```
             * 
             * You can also pass in an array of keys, in which case an array of values will be returned:
             * 
             * ```javascript
             * sprite.getData([ 'gold', 'armor', 'health' ]);
             * ```
             * 
             * This approach is useful for destructuring arrays in ES6.
             * @param key The key of the value to retrieve, or an array of keys.
             */
            getData(key: string | string[]): any;

            /**
             * Pass this Game Object to the Input Manager to enable it for Input.
             * 
             * Input works by using hit areas, these are nearly always geometric shapes, such as rectangles or circles, that act as the hit area
             * for the Game Object. However, you can provide your own hit area shape and callback, should you wish to handle some more advanced
             * input detection.
             * 
             * If no arguments are provided it will try and create a rectangle hit area based on the texture frame the Game Object is using. If
             * this isn't a texture-bound object, such as a Graphics or BitmapText object, this will fail, and you'll need to provide a specific
             * shape for it to use.
             * 
             * You can also provide an Input Configuration Object as the only argument to this method.
             * @param hitArea Either an input configuration object, or a geometric shape that defines the hit area for the Game Object. If not given it will try to create a Rectangle based on the texture frame.
             * @param callback The callback that determines if the pointer is within the Hit Area shape or not. If you provide a shape you must also provide a callback.
             * @param dropZone Should this Game Object be treated as a drop zone target? Default false.
             */
            setInteractive(hitArea?: Phaser.Types.Input.InputConfiguration | any, callback?: Phaser.Types.Input.HitAreaCallback, dropZone?: boolean): this;

            /**
             * If this Game Object has previously been enabled for input, this will disable it.
             * 
             * An object that is disabled for input stops processing or being considered for
             * input events, but can be turned back on again at any time by simply calling
             * `setInteractive()` with no arguments provided.
             * 
             * If want to completely remove interaction from this Game Object then use `removeInteractive` instead.
             */
            disableInteractive(): this;

            /**
             * If this Game Object has previously been enabled for input, this will queue it
             * for removal, causing it to no longer be interactive. The removal happens on
             * the next game step, it is not immediate.
             * 
             * The Interactive Object that was assigned to this Game Object will be destroyed,
             * removed from the Input Manager and cleared from this Game Object.
             * 
             * If you wish to re-enable this Game Object at a later date you will need to
             * re-create its InteractiveObject by calling `setInteractive` again.
             * 
             * If you wish to only temporarily stop an object from receiving input then use
             * `disableInteractive` instead, as that toggles the interactive state, where-as
             * this erases it completely.
             * 
             * If you wish to resize a hit area, don't remove and then set it as being
             * interactive. Instead, access the hitarea object directly and resize the shape
             * being used. I.e.: `sprite.input.hitArea.setSize(width, height)` (assuming the
             * shape is a Rectangle, which it is by default.)
             */
            removeInteractive(): this;

            /**
             * This callback is invoked when this Game Object is added to a Scene.
             * 
             * Can be overriden by custom Game Objects, but be aware of some Game Objects that
             * will use this, such as Sprites, to add themselves into the Update List.
             * 
             * You can also listen for the `ADDED_TO_SCENE` event from this Game Object.
             */
            addedToScene(): void;

            /**
             * This callback is invoked when this Game Object is removed from a Scene.
             * 
             * Can be overriden by custom Game Objects, but be aware of some Game Objects that
             * will use this, such as Sprites, to removed themselves from the Update List.
             * 
             * You can also listen for the `REMOVED_FROM_SCENE` event from this Game Object.
             */
            removedFromScene(): void;

            /**
             * To be overridden by custom GameObjects. Allows base objects to be used in a Pool.
             * @param args args
             */
            update(...args: any[]): void;

            /**
             * Returns a JSON representation of the Game Object.
             */
            toJSON(): Phaser.Types.GameObjects.JSONGameObject;

            /**
             * Compares the renderMask with the renderFlags to see if this Game Object will render or not.
             * Also checks the Game Object against the given Cameras exclusion list.
             * @param camera The Camera to check against this Game Object.
             */
            willRender(camera: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Returns an array containing the display list index of either this Game Object, or if it has one,
             * its parent Container. It then iterates up through all of the parent containers until it hits the
             * root of the display list (which is index 0 in the returned array).
             * 
             * Used internally by the InputPlugin but also useful if you wish to find out the display depth of
             * this Game Object and all of its ancestors.
             */
            getIndexList(): number[];

            /**
             * Adds this Game Object to the given Display List.
             * 
             * If no Display List is specified, it will default to the Display List owned by the Scene to which
             * this Game Object belongs.
             * 
             * A Game Object can only exist on one Display List at any given time, but may move freely between them.
             * 
             * If this Game Object is already on another Display List when this method is called, it will first
             * be removed from it, before being added to the new list.
             * 
             * You can query which list it is on by looking at the `Phaser.GameObjects.GameObject#displayList` property.
             * 
             * If a Game Object isn't on any display list, it will not be rendered. If you just wish to temporarly
             * disable it from rendering, consider using the `setVisible` method, instead.
             * @param displayList The Display List to add to. Defaults to the Scene Display List.
             */
            addToDisplayList(displayList?: Phaser.GameObjects.DisplayList | Phaser.GameObjects.Layer): this;

            /**
             * Adds this Game Object to the Update List belonging to the Scene.
             * 
             * When a Game Object is added to the Update List it will have its `preUpdate` method called
             * every game frame. This method is passed two parameters: `delta` and `time`.
             * 
             * If you wish to run your own logic within `preUpdate` then you should always call
             * `super.preUpdate(delta, time)` within it, or it may fail to process required operations,
             * such as Sprite animations.
             */
            addToUpdateList(): this;

            /**
             * Removes this Game Object from the Display List it is currently on.
             * 
             * A Game Object can only exist on one Display List at any given time, but may move freely removed
             * and added back at a later stage.
             * 
             * You can query which list it is on by looking at the `Phaser.GameObjects.GameObject#displayList` property.
             * 
             * If a Game Object isn't on any Display List, it will not be rendered. If you just wish to temporarly
             * disable it from rendering, consider using the `setVisible` method, instead.
             */
            removeFromDisplayList(): this;

            /**
             * Removes this Game Object from the Scene's Update List.
             * 
             * When a Game Object is on the Update List, it will have its `preUpdate` method called
             * every game frame. Calling this method will remove it from the list, preventing this.
             * 
             * Removing a Game Object from the Update List will stop most internal functions working.
             * For example, removing a Sprite from the Update List will prevent it from being able to
             * run animations.
             */
            removeFromUpdateList(): this;

            /**
             * Destroys this Game Object removing it from the Display List and Update List and
             * severing all ties to parent resources.
             * 
             * Also removes itself from the Input Manager and Physics Manager if previously enabled.
             * 
             * Use this to remove a Game Object from your game if you don't ever plan to use it again.
             * As long as no reference to it exists within your own code it should become free for
             * garbage collection by the browser.
             * 
             * If you just want to temporarily disable an object then look at using the
             * Game Object Pool instead of destroying it, as destroyed objects cannot be resurrected.
             * @param fromScene `True` if this Game Object is being destroyed by the Scene, `false` if not. Default false.
             */
            destroy(fromScene?: boolean): void;

            /**
             * The bitmask that `GameObject.renderFlags` is compared against to determine if the Game Object will render or not.
             */
            static readonly RENDER_MASK: number;

        }

        /**
         * The Game Object Creator is a Scene plugin that allows you to quickly create many common
         * types of Game Objects and return them using a configuration object, rather than
         * having to specify a limited set of parameters such as with the GameObjectFactory.
         * 
         * Game Objects made via this class are automatically added to the Scene and Update List
         * unless you explicitly set the `add` property in the configuration object to `false`.
         */
        class GameObjectCreator {
            /**
             * 
             * @param scene The Scene to which this Game Object Factory belongs.
             */
            constructor(scene: Phaser.Scene);

            /**
             * Creates a new Dynamic Bitmap Text Game Object and returns it.
             * 
             * Note: This method will only be available if the Dynamic Bitmap Text Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            dynamicBitmapText(config: Phaser.Types.GameObjects.BitmapText.BitmapTextConfig, addToScene?: boolean): Phaser.GameObjects.DynamicBitmapText;

            /**
             * Creates a new Bitmap Text Game Object and returns it.
             * 
             * Note: This method will only be available if the Bitmap Text Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            bitmapText(config: Phaser.Types.GameObjects.BitmapText.BitmapTextConfig, addToScene?: boolean): Phaser.GameObjects.BitmapText;

            /**
             * Creates a new Blitter Game Object and returns it.
             * 
             * Note: This method will only be available if the Blitter Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            blitter(config: Phaser.Types.GameObjects.Sprite.SpriteConfig, addToScene?: boolean): Phaser.GameObjects.Blitter;

            /**
             * Creates a new Container Game Object and returns it.
             * 
             * Note: This method will only be available if the Container Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            container(config: Phaser.Types.GameObjects.Container.ContainerConfig, addToScene?: boolean): Phaser.GameObjects.Container;

            /**
             * The Scene to which this Game Object Creator belongs.
             */
            protected scene: Phaser.Scene;

            /**
             * A reference to the Scene.Systems.
             */
            protected systems: Phaser.Scenes.Systems;

            /**
             * A reference to the Scene Event Emitter.
             */
            protected events: Phaser.Events.EventEmitter;

            /**
             * A reference to the Scene Display List.
             */
            protected displayList: Phaser.GameObjects.DisplayList;

            /**
             * A reference to the Scene Update List.
             */
            protected updateList: Phaser.GameObjects.UpdateList;

            /**
             * Static method called directly by the Game Object creator functions.
             * With this method you can register a custom GameObject factory in the GameObjectCreator,
             * providing a name (`factoryType`) and the constructor (`factoryFunction`) in order
             * to be called when you invoke Phaser.Scene.make[ factoryType ] method.
             * @param factoryType The key of the factory that you will use to call to Phaser.Scene.make[ factoryType ] method.
             * @param factoryFunction The constructor function to be called when you invoke to the Phaser.Scene.make method.
             */
            static register(factoryType: string, factoryFunction: Function): void;

            /**
             * Static method called directly by the Game Object Creator functions.
             * 
             * With this method you can remove a custom Game Object Creator that has been previously
             * registered in the Game Object Creator. Pass in its `factoryType` in order to remove it.
             * @param factoryType The key of the factory that you want to remove from the GameObjectCreator.
             */
            static remove(factoryType: string): void;

            /**
             * Creates a new Graphics Game Object and returns it.
             * 
             * Note: This method will only be available if the Graphics Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            graphics(config?: Phaser.Types.GameObjects.Graphics.Options, addToScene?: boolean): Phaser.GameObjects.Graphics;

            /**
             * Creates a new Group Game Object and returns it.
             * 
             * Note: This method will only be available if the Group Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             */
            group(config: Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig): Phaser.GameObjects.Group;

            /**
             * Creates a new Image Game Object and returns it.
             * 
             * Note: This method will only be available if the Image Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            image(config: Phaser.Types.GameObjects.Sprite.SpriteConfig, addToScene?: boolean): Phaser.GameObjects.Image;

            /**
             * Creates a new Layer Game Object and returns it.
             * 
             * Note: This method will only be available if the Layer Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            layer(config: Phaser.Types.GameObjects.Sprite.SpriteConfig, addToScene?: boolean): Phaser.GameObjects.Layer;

            /**
             * Creates a new Mesh Game Object and returns it.
             * 
             * Note: This method will only be available if the Mesh Game Object and WebGL support have been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            mesh(config: Phaser.Types.GameObjects.Mesh.MeshConfig, addToScene?: boolean): Phaser.GameObjects.Mesh;

            /**
             * Creates a new Nine Slice Game Object and returns it.
             * 
             * Note: This method will only be available if the Nine Slice Game Object and WebGL support have been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            nineslice(config: Phaser.Types.GameObjects.NineSlice.NineSliceConfig, addToScene?: boolean): Phaser.GameObjects.NineSlice;

            /**
             * Creates a new Particle Emitter Game Object and returns it.
             * 
             * Prior to Phaser v3.60 this function would create a `ParticleEmitterManager`. These were removed
             * in v3.60 and replaced with creating a `ParticleEmitter` instance directly. Please see the
             * updated function parameters and class documentation for more details.
             * 
             * Note: This method will only be available if the Particles Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            particles(config: Phaser.Types.GameObjects.Particles.ParticleEmitterCreatorConfig, addToScene?: boolean): Phaser.GameObjects.Particles.ParticleEmitter;

            /**
             * Creates a new Plane Game Object and returns it.
             * 
             * Note: This method will only be available if the Plane Game Object and WebGL support have been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            plane(config: Phaser.Types.GameObjects.Plane.PlaneConfig, addToScene?: boolean): Phaser.GameObjects.Plane;

            /**
             * Creates a new Point Light Game Object and returns it.
             * 
             * Note: This method will only be available if the Point Light Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            pointlight(config: object, addToScene?: boolean): Phaser.GameObjects.PointLight;

            /**
             * Creates a new Render Texture Game Object and returns it.
             * 
             * Note: This method will only be available if the Render Texture Game Object has been built into Phaser.
             * 
             * A Render Texture is a combination of Dynamic Texture and an Image Game Object, that uses the
             * Dynamic Texture to display itself with.
             * 
             * A Dynamic Texture is a special texture that allows you to draw textures, frames and most kind of
             * Game Objects directly to it.
             * 
             * You can take many complex objects and draw them to this one texture, which can then be used as the
             * base texture for other Game Objects, such as Sprites. Should you then update this texture, all
             * Game Objects using it will instantly be updated as well, reflecting the changes immediately.
             * 
             * It's a powerful way to generate dynamic textures at run-time that are WebGL friendly and don't invoke
             * expensive GPU uploads on each change.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            renderTexture(config: Phaser.Types.GameObjects.RenderTexture.RenderTextureConfig, addToScene?: boolean): Phaser.GameObjects.RenderTexture;

            /**
             * Creates a new Rope Game Object and returns it.
             * 
             * Note: This method will only be available if the Rope Game Object and WebGL support have been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            rope(config: Phaser.Types.GameObjects.Rope.RopeConfig, addToScene?: boolean): Phaser.GameObjects.Rope;

            /**
             * Creates a new Shader Game Object and returns it.
             * 
             * Note: This method will only be available if the Shader Game Object and WebGL support have been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            shader(config: Phaser.Types.GameObjects.Shader.ShaderConfig, addToScene?: boolean): Phaser.GameObjects.Shader;

            /**
             * Creates a new Sprite Game Object and returns it.
             * 
             * Note: This method will only be available if the Sprite Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object. Default true.
             */
            sprite(config: Phaser.Types.GameObjects.Sprite.SpriteConfig, addToScene?: boolean): Phaser.GameObjects.Sprite;

            /**
             * Creates a new Text Game Object and returns it.
             * 
             * Note: This method will only be available if the Text Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            text(config: Phaser.Types.GameObjects.Text.TextConfig, addToScene?: boolean): Phaser.GameObjects.Text;

            /**
             * Creates a new TileSprite Game Object and returns it.
             * 
             * Note: This method will only be available if the TileSprite Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            tileSprite(config: Phaser.Types.GameObjects.TileSprite.TileSpriteConfig, addToScene?: boolean): Phaser.GameObjects.TileSprite;

            /**
             * Creates a new Video Game Object and returns it.
             * 
             * Note: This method will only be available if the Video Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             * @param addToScene Add this Game Object to the Scene after creating it? If set this argument overrides the `add` property in the config object.
             */
            video(config: Phaser.Types.GameObjects.Video.VideoConfig, addToScene?: boolean): Phaser.GameObjects.Video;

            /**
             * Creates a new Zone Game Object and returns it.
             * 
             * Note: This method will only be available if the Zone Game Object has been built into Phaser.
             * @param config The configuration object this Game Object will use to create itself.
             */
            zone(config: Phaser.Types.GameObjects.Zone.ZoneConfig): Phaser.GameObjects.Zone;

            /**
             * Creates a Tilemap from the given key or data, or creates a blank Tilemap if no key/data provided.
             * When loading from CSV or a 2D array, you should specify the tileWidth & tileHeight. When parsing
             * from a map from Tiled, the tileWidth, tileHeight, width & height will be pulled from the map
             * data. For an empty map, you should specify tileWidth, tileHeight, width & height.
             * @param config The config options for the Tilemap.
             */
            tilemap(config?: Phaser.Types.Tilemaps.TilemapConfig): Phaser.Tilemaps.Tilemap;

            /**
             * Creates a new Tween object and returns it.
             * 
             * Note: This method will only be available if Tweens have been built into Phaser.
             * @param config A Tween Configuration object, or a Tween or TweenChain instance.
             */
            tween(config: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenChainBuilderConfig | Phaser.Tweens.Tween | Phaser.Tweens.TweenChain): Phaser.Tweens.Tween;

            /**
             * Creates a new TweenChain object and returns it, without adding it to the Tween Manager.
             * 
             * Note: This method will only be available if Tweens have been built into Phaser.
             * @param config The TweenChain configuration.
             */
            tweenchain(config: Phaser.Types.Tweens.TweenBuilderConfig | object): Phaser.Tweens.TweenChain;

        }

        /**
         * The Game Object Factory is a Scene plugin that allows you to quickly create many common
         * types of Game Objects and have them automatically registered with the Scene.
         * 
         * Game Objects directly register themselves with the Factory and inject their own creation
         * methods into the class.
         */
        class GameObjectFactory {
            /**
             * 
             * @param scene The Scene to which this Game Object Factory belongs.
             */
            constructor(scene: Phaser.Scene);

            /**
             * Creates a new Path Object.
             * @param x The horizontal position of this Path.
             * @param y The vertical position of this Path.
             */
            path(x: number, y: number): Phaser.Curves.Path;

            /**
             * A Bitmap Mask combines the alpha (opacity) of a masked pixel with the alpha of another pixel.
             * Unlike the Geometry Mask, which is a clipping path, a Bitmap Mask behaves like an alpha mask,
             * not a clipping path. It is only available when using the WebGL Renderer.
             * 
             * A Bitmap Mask can use any Game Object, or Dynamic Texture, to determine the alpha of each pixel of the masked Game Object(s).
             * For any given point of a masked Game Object's texture, the pixel's alpha will be multiplied by the alpha
             * of the pixel at the same position in the Bitmap Mask's Game Object. The color of the pixel from the
             * Bitmap Mask doesn't matter.
             * 
             * For example, if a pure blue pixel with an alpha of 0.95 is masked with a pure red pixel with an
             * alpha of 0.5, the resulting pixel will be pure blue with an alpha of 0.475. Naturally, this means
             * that a pixel in the mask with an alpha of 0 will hide the corresponding pixel in all masked Game Objects
             *  A pixel with an alpha of 1 in the masked Game Object will receive the same alpha as the
             * corresponding pixel in the mask.
             * 
             * Note: You cannot combine Bitmap Masks and Blend Modes on the same Game Object. You can, however,
             * combine Geometry Masks and Blend Modes together.
             * 
             * The Bitmap Mask's location matches the location of its Game Object, not the location of the
             * masked objects. Moving or transforming the underlying Game Object will change the mask
             * (and affect the visibility of any masked objects), whereas moving or transforming a masked object
             * will not affect the mask.
             * 
             * The Bitmap Mask will not render its Game Object by itself. If the Game Object is not in a
             * Scene's display list, it will only be used for the mask and its full texture will not be directly
             * visible. Adding the underlying Game Object to a Scene will not cause any problems - it will
             * render as a normal Game Object and will also serve as a mask.
             * @param maskObject The Game Object or Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            bitmapMask(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates a new Dynamic Bitmap Text Game Object and adds it to the Scene.
             * 
             * BitmapText objects work by taking a texture file and an XML or JSON file that describes the font structure.
             * 
             * During rendering for each letter of the text is rendered to the display, proportionally spaced out and aligned to
             * match the font structure.
             * 
             * Dynamic Bitmap Text objects are different from Static Bitmap Text in that they invoke a callback for each
             * letter being rendered during the render pass. This callback allows you to manipulate the properties of
             * each letter being rendered, such as its position, scale or tint, allowing you to create interesting effects
             * like jiggling text, which can't be done with Static text. This means that Dynamic Text takes more processing
             * time, so only use them if you require the callback ability they have.
             * 
             * BitmapText objects are less flexible than Text objects, in that they have less features such as shadows, fills and the ability
             * to use Web Fonts, however you trade this flexibility for rendering speed. You can also create visually compelling BitmapTexts by
             * processing the font texture in an image editor, applying fills and any other effects required.
             * 
             * To create multi-line text insert \r, \n or \r\n escape codes into the text string.
             * 
             * To create a BitmapText data files you need a 3rd party app such as:
             * 
             * BMFont (Windows, free): http://www.angelcode.com/products/bmfont/
             * Glyph Designer (OS X, commercial): http://www.71squared.com/en/glyphdesigner
             * Littera (Web-based, free): http://kvazars.com/littera/
             * 
             * For most use cases it is recommended to use XML. If you wish to use JSON, the formatting should be equal to the result of
             * converting a valid XML file through the popular X2JS library. An online tool for conversion can be found here: http://codebeautify.org/xmltojson
             * 
             * Note: This method will only be available if the Dynamic Bitmap Text Game Object has been built into Phaser.
             * @param x The x position of the Game Object.
             * @param y The y position of the Game Object.
             * @param font The key of the font to use from the BitmapFont cache.
             * @param text The string, or array of strings, to be set as the content of this Bitmap Text.
             * @param size The font size to set.
             */
            dynamicBitmapText(x: number, y: number, font: string, text?: string | string[], size?: number): Phaser.GameObjects.DynamicBitmapText;

            /**
             * Creates a new Bitmap Text Game Object and adds it to the Scene.
             * 
             * BitmapText objects work by taking a texture file and an XML or JSON file that describes the font structure.
             * 
             * During rendering for each letter of the text is rendered to the display, proportionally spaced out and aligned to
             * match the font structure.
             * 
             * BitmapText objects are less flexible than Text objects, in that they have less features such as shadows, fills and the ability
             * to use Web Fonts, however you trade this flexibility for rendering speed. You can also create visually compelling BitmapTexts by
             * processing the font texture in an image editor, applying fills and any other effects required.
             * 
             * To create multi-line text insert \r, \n or \r\n escape codes into the text string.
             * 
             * To create a BitmapText data files you need a 3rd party app such as:
             * 
             * BMFont (Windows, free): http://www.angelcode.com/products/bmfont/
             * Glyph Designer (OS X, commercial): http://www.71squared.com/en/glyphdesigner
             * Littera (Web-based, free): http://kvazars.com/littera/
             * 
             * For most use cases it is recommended to use XML. If you wish to use JSON, the formatting should be equal to the result of
             * converting a valid XML file through the popular X2JS library. An online tool for conversion can be found here: http://codebeautify.org/xmltojson
             * 
             * Note: This method will only be available if the Bitmap Text Game Object has been built into Phaser.
             * @param x The x position of the Game Object.
             * @param y The y position of the Game Object.
             * @param font The key of the font to use from the BitmapFont cache.
             * @param text The string, or array of strings, to be set as the content of this Bitmap Text.
             * @param size The font size to set.
             * @param align The alignment of the text in a multi-line BitmapText object. Default 0.
             */
            bitmapText(x: number, y: number, font: string, text?: string | string[], size?: number, align?: number): Phaser.GameObjects.BitmapText;

            /**
             * Creates a new Blitter Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Blitter Game Object has been built into Phaser.
             * @param x The x position of the Game Object.
             * @param y The y position of the Game Object.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame The default Frame children of the Blitter will use.
             */
            blitter(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.GameObjects.Blitter;

            /**
             * Creates a new Container Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Container Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param children An optional array of Game Objects to add to this Container.
             */
            container(x?: number, y?: number, children?: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[]): Phaser.GameObjects.Container;

            /**
             * DOM Element Game Objects are a way to control and manipulate HTML Elements over the top of your game.
             * 
             * In order for DOM Elements to display you have to enable them by adding the following to your game
             * configuration object:
             * 
             * ```javascript
             * dom {
             *   createContainer: true
             * }
             * ```
             * 
             * When this is added, Phaser will automatically create a DOM Container div that is positioned over the top
             * of the game canvas. This div is sized to match the canvas, and if the canvas size changes, as a result of
             * settings within the Scale Manager, the dom container is resized accordingly.
             * 
             * You can create a DOM Element by either passing in DOMStrings, or by passing in a reference to an existing
             * Element that you wish to be placed under the control of Phaser. For example:
             * 
             * ```javascript
             * this.add.dom(x, y, 'div', 'background-color: lime; width: 220px; height: 100px; font: 48px Arial', 'Phaser');
             * ```
             * 
             * The above code will insert a div element into the DOM Container at the given x/y coordinate. The DOMString in
             * the 4th argument sets the initial CSS style of the div and the final argument is the inner text. In this case,
             * it will create a lime colored div that is 220px by 100px in size with the text Phaser in it, in an Arial font.
             * 
             * You should nearly always, without exception, use explicitly sized HTML Elements, in order to fully control
             * alignment and positioning of the elements next to regular game content.
             * 
             * Rather than specify the CSS and HTML directly you can use the `load.html` File Loader to load it into the
             * cache and then use the `createFromCache` method instead. You can also use `createFromHTML` and various other
             * methods available in this class to help construct your elements.
             * 
             * Once the element has been created you can then control it like you would any other Game Object. You can set its
             * position, scale, rotation, alpha and other properties. It will move as the main Scene Camera moves and be clipped
             * at the edge of the canvas. It's important to remember some limitations of DOM Elements: The obvious one is that
             * they appear above or below your game canvas. You cannot blend them into the display list, meaning you cannot have
             * a DOM Element, then a Sprite, then another DOM Element behind it.
             * 
             * They also cannot be enabled for input. To do that, you have to use the `addListener` method to add native event
             * listeners directly. The final limitation is to do with cameras. The DOM Container is sized to match the game canvas
             * entirely and clipped accordingly. DOM Elements respect camera scrolling and scrollFactor settings, but if you
             * change the size of the camera so it no longer matches the size of the canvas, they won't be clipped accordingly.
             * 
             * Also, all DOM Elements are inserted into the same DOM Container, regardless of which Scene they are created in.
             * 
             * DOM Elements are a powerful way to align native HTML with your Phaser Game Objects. For example, you can insert
             * a login form for a multiplayer game directly into your title screen. Or a text input box for a highscore table.
             * Or a banner ad from a 3rd party service. Or perhaps you'd like to use them for high resolution text display and
             * UI. The choice is up to you, just remember that you're dealing with standard HTML and CSS floating over the top
             * of your game, and should treat it accordingly.
             * 
             * Note: This method will only be available if the DOM Element Game Object has been built into Phaser.
             * @param x The horizontal position of this DOM Element in the world.
             * @param y The vertical position of this DOM Element in the world.
             * @param element An existing DOM element, or a string. If a string starting with a # it will do a `getElementById` look-up on the string (minus the hash). Without a hash, it represents the type of element to create, i.e. 'div'.
             * @param style If a string, will be set directly as the elements `style` property value. If a plain object, will be iterated and the values transferred. In both cases the values replacing whatever CSS styles may have been previously set.
             * @param innerText If given, will be set directly as the elements `innerText` property value, replacing whatever was there before.
             */
            dom(x: number, y: number, element?: HTMLElement | string, style?: string | any, innerText?: string): Phaser.GameObjects.DOMElement;

            /**
             * Creates a new Extern Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Extern Game Object has been built into Phaser.
             */
            extern(): Phaser.GameObjects.Extern;

            /**
             * The Scene to which this Game Object Factory belongs.
             */
            protected scene: Phaser.Scene;

            /**
             * A reference to the Scene.Systems.
             */
            protected systems: Phaser.Scenes.Systems;

            /**
             * A reference to the Scene Event Emitter.
             */
            protected events: Phaser.Events.EventEmitter;

            /**
             * A reference to the Scene Display List.
             */
            protected displayList: Phaser.GameObjects.DisplayList;

            /**
             * A reference to the Scene Update List.
             */
            protected updateList: Phaser.GameObjects.UpdateList;

            /**
             * Adds an existing Game Object to this Scene.
             * 
             * If the Game Object renders, it will be added to the Display List.
             * If it has a `preUpdate` method, it will be added to the Update List.
             * @param child The child to be added to this Scene.
             */
            existing<G extends (Phaser.GameObjects.GameObject|Phaser.GameObjects.Group|Phaser.GameObjects.Layer)>(child: G): G;

            /**
             * Static method called directly by the Game Object factory functions.
             * With this method you can register a custom GameObject factory in the GameObjectFactory,
             * providing a name (`factoryType`) and the constructor (`factoryFunction`) in order
             * to be called when you call to Phaser.Scene.add[ factoryType ] method.
             * @param factoryType The key of the factory that you will use to call to Phaser.Scene.add[ factoryType ] method.
             * @param factoryFunction The constructor function to be called when you invoke to the Phaser.Scene.add method.
             */
            static register(factoryType: string, factoryFunction: Function): void;

            /**
             * Static method called directly by the Game Object factory functions.
             * With this method you can remove a custom GameObject factory registered in the GameObjectFactory,
             * providing a its `factoryType`.
             * @param factoryType The key of the factory that you want to remove from the GameObjectFactory.
             */
            static remove(factoryType: string): void;

            /**
             * Creates a new Graphics Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Graphics Game Object has been built into Phaser.
             * @param config The Graphics configuration.
             */
            graphics(config?: Phaser.Types.GameObjects.Graphics.Options): Phaser.GameObjects.Graphics;

            /**
             * Creates a new Group Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Group Game Object has been built into Phaser.
             * @param children Game Objects to add to this Group; or the `config` argument.
             * @param config A Group Configuration object.
             */
            group(children?: Phaser.GameObjects.GameObject[] | Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupConfig[] | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig): Phaser.GameObjects.Group;

            /**
             * Creates a new Image Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Image Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            image(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.GameObjects.Image;

            /**
             * Creates a new Layer Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Layer Game Object has been built into Phaser.
             * @param children An optional array of Game Objects to add to this Layer.
             */
            layer(children?: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[]): Phaser.GameObjects.Layer;

            /**
             * Creates a new Mesh Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Mesh Game Object and WebGL support have been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param vertices The vertices array. Either `xy` pairs, or `xyz` if the `containsZ` parameter is `true`.
             * @param uvs The UVs pairs array.
             * @param indicies Optional vertex indicies array. If you don't have one, pass `null` or an empty array.
             * @param containsZ Does the vertices data include a `z` component? Default false.
             * @param normals Optional vertex normals array. If you don't have one, pass `null` or an empty array.
             * @param colors An array of colors, one per vertex, or a single color value applied to all vertices. Default 0xffffff.
             * @param alphas An array of alpha values, one per vertex, or a single alpha value applied to all vertices. Default 1.
             */
            mesh(x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number, vertices?: number[], uvs?: number[], indicies?: number[], containsZ?: boolean, normals?: number[], colors?: number | number[], alphas?: number | number[]): Phaser.GameObjects.Mesh;

            /**
             * A Nine Slice Game Object allows you to display a texture-based object that
             * can be stretched both horizontally and vertically, but that retains
             * fixed-sized corners. The dimensions of the corners are set via the
             * parameters to this class.
             * 
             * This is extremely useful for UI and button like elements, where you need
             * them to expand to accommodate the content without distorting the texture.
             * 
             * The texture you provide for this Game Object should be based on the
             * following layout structure:
             * 
             * ```
             *      A                          B
             *    +---+----------------------+---+
             *  C | 1 |          2           | 3 |
             *    +---+----------------------+---+
             *    |   |                      |   |
             *    | 4 |          5           | 6 |
             *    |   |                      |   |
             *    +---+----------------------+---+
             *  D | 7 |          8           | 9 |
             *    +---+----------------------+---+
             * ```
             * 
             * When changing this objects width and / or height:
             * 
             *     areas 1, 3, 7 and 9 (the corners) will remain unscaled
             *     areas 2 and 8 will be stretched horizontally only
             *     areas 4 and 6 will be stretched vertically only
             *     area 5 will be stretched both horizontally and vertically
             * 
             * You can also create a 3 slice Game Object:
             * 
             * This works in a similar way, except you can only stretch it horizontally.
             * Therefore, it requires less configuration:
             * 
             * ```
             *      A                          B
             *    +---+----------------------+---+
             *    |   |                      |   |
             *  C | 1 |          2           | 3 |
             *    |   |                      |   |
             *    +---+----------------------+---+
             * ```
             * 
             * When changing this objects width (you cannot change its height)
             * 
             *     areas 1 and 3 will remain unscaled
             *     area 2 will be stretched horizontally
             * 
             * The above configuration concept is adapted from the Pixi NineSlicePlane.
             * 
             * To specify a 3 slice object instead of a 9 slice you should only
             * provide the `leftWidth` and `rightWidth` parameters. To create a 9 slice
             * you must supply all parameters.
             * 
             * The _minimum_ width this Game Object can be is the total of
             * `leftWidth` + `rightWidth`.  The _minimum_ height this Game Object
             * can be is the total of `topHeight` + `bottomHeight`.
             * If you need to display this object at a smaller size, you can scale it.
             * 
             * In terms of performance, using a 3 slice Game Object is the equivalent of
             * having 3 Sprites in a row. Using a 9 slice Game Object is the equivalent
             * of having 9 Sprites in a row. The vertices of this object are all batched
             * together and can co-exist with other Sprites and graphics on the display
             * list, without incurring any additional overhead.
             * 
             * As of Phaser 3.60 this Game Object is WebGL only.
             * @param x The horizontal position of the center of this Game Object in the world.
             * @param y The vertical position of the center of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param width The width of the Nine Slice Game Object. You can adjust the width post-creation. Default 256.
             * @param height The height of the Nine Slice Game Object. If this is a 3 slice object the height will be fixed to the height of the texture and cannot be changed. Default 256.
             * @param leftWidth The size of the left vertical column (A). Default 10.
             * @param rightWidth The size of the right vertical column (B). Default 10.
             * @param topHeight The size of the top horiztonal row (C). Set to zero or undefined to create a 3 slice object. Default 0.
             * @param bottomHeight The size of the bottom horiztonal row (D). Set to zero or undefined to create a 3 slice object. Default 0.
             */
            nineslice(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number, width?: number, height?: number, leftWidth?: number, rightWidth?: number, topHeight?: number, bottomHeight?: number): Phaser.GameObjects.NineSlice;

            /**
             * Creates a new Particle Emitter Game Object and adds it to the Scene.
             * 
             * If you wish to configure the Emitter after creating it, use the `ParticleEmitter.setConfig` method.
             * 
             * Prior to Phaser v3.60 this function would create a `ParticleEmitterManager`. These were removed
             * in v3.60 and replaced with creating a `ParticleEmitter` instance directly. Please see the
             * updated function parameters and class documentation for more details.
             * 
             * Note: This method will only be available if the Particles Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param config Configuration settings for the Particle Emitter.
             */
            particles(x?: number, y?: number, texture?: string | Phaser.Textures.Texture, config?: Phaser.Types.GameObjects.Particles.ParticleEmitterConfig): Phaser.GameObjects.Particles.ParticleEmitter;

            /**
             * Creates a new PathFollower Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the PathFollower Game Object has been built into Phaser.
             * @param path The Path this PathFollower is connected to.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            follower(path: Phaser.Curves.Path, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.GameObjects.PathFollower;

            /**
             * Creates a new Plane Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Plane Game Object has been built into Phaser.
             * @param x The horizontal position of this Plane in the world.
             * @param y The vertical position of this Plane in the world.
             * @param texture The key, or instance of the Texture this Plane will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Plane is rendering with.
             * @param width The width of this Plane, in cells, not pixels. Default 8.
             * @param height The height of this Plane, in cells, not pixels. Default 8.
             * @param tile Is the texture tiled? I.e. repeated across each cell. Default false.
             */
            plane(x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number, width?: number, height?: number, tile?: boolean): Phaser.GameObjects.Plane;

            /**
             * Creates a new Point Light Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Point Light Game Object has been built into Phaser.
             * 
             * The Point Light Game Object provides a way to add a point light effect into your game,
             * without the expensive shader processing requirements of the traditional Light Game Object.
             * 
             * The difference is that the Point Light renders using a custom shader, designed to give the
             * impression of a point light source, of variable radius, intensity and color, in your game.
             * However, unlike the Light Game Object, it does not impact any other Game Objects, or use their
             * normal maps for calcuations. This makes them extremely fast to render compared to Lights
             * and perfect for special effects, such as flickering torches or muzzle flashes.
             * 
             * For maximum performance you should batch Point Light Game Objects together. This means
             * ensuring they follow each other consecutively on the display list. Ideally, use a Layer
             * Game Object and then add just Point Lights to it, so that it can batch together the rendering
             * of the lights. You don't _have_ to do this, and if you've only a handful of Point Lights in
             * your game then it's perfectly safe to mix them into the dislay list as normal. However, if
             * you're using a large number of them, please consider how they are mixed into the display list.
             * 
             * The renderer will automatically cull Point Lights. Those with a radius that does not intersect
             * with the Camera will be skipped in the rendering list. This happens automatically and the
             * culled state is refreshed every frame, for every camera.
             * 
             * The origin of a Point Light is always 0.5 and it cannot be changed.
             * 
             * Point Lights are a WebGL only feature and do not have a Canvas counterpart.
             * @param x The horizontal position of this Point Light in the world.
             * @param y The vertical position of this Point Light in the world.
             * @param color The color of the Point Light, given as a hex value. Default 0xffffff.
             * @param radius The radius of the Point Light. Default 128.
             * @param intensity The intensity, or color blend, of the Point Light. Default 1.
             * @param attenuation The attenuation  of the Point Light. This is the reduction of light from the center point. Default 0.1.
             */
            pointlight(x: number, y: number, color?: number, radius?: number, intensity?: number, attenuation?: number): Phaser.GameObjects.PointLight;

            /**
             * Creates a new Render Texture Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Render Texture Game Object has been built into Phaser.
             * 
             * A Render Texture is a combination of Dynamic Texture and an Image Game Object, that uses the
             * Dynamic Texture to display itself with.
             * 
             * A Dynamic Texture is a special texture that allows you to draw textures, frames and most kind of
             * Game Objects directly to it.
             * 
             * You can take many complex objects and draw them to this one texture, which can then be used as the
             * base texture for other Game Objects, such as Sprites. Should you then update this texture, all
             * Game Objects using it will instantly be updated as well, reflecting the changes immediately.
             * 
             * It's a powerful way to generate dynamic textures at run-time that are WebGL friendly and don't invoke
             * expensive GPU uploads on each change.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the Render Texture. Default 32.
             * @param height The height of the Render Texture. Default 32.
             */
            renderTexture(x: number, y: number, width?: number, height?: number): Phaser.GameObjects.RenderTexture;

            /**
             * Creates a new Rope Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Rope Game Object and WebGL support have been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param points An array containing the vertices data for this Rope. If none is provided a simple quad is created. See `setPoints` to set this post-creation.
             * @param horizontal Should the vertices of this Rope be aligned horizontally (`true`), or vertically (`false`)? Default true.
             * @param colors An optional array containing the color data for this Rope. You should provide one color value per pair of vertices.
             * @param alphas An optional array containing the alpha data for this Rope. You should provide one alpha value per pair of vertices.
             */
            rope(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number, points?: Phaser.Types.Math.Vector2Like[], horizontal?: boolean, colors?: number[], alphas?: number[]): Phaser.GameObjects.Rope;

            /**
             * Creates a new Shader Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Shader Game Object and WebGL support have been built into Phaser.
             * @param key The key of the shader to use from the shader cache, or a BaseShader instance.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the Game Object. Default 128.
             * @param height The height of the Game Object. Default 128.
             * @param textures Optional array of texture keys to bind to the iChannel0...3 uniforms. The textures must already exist in the Texture Manager.
             * @param textureData Optional additional texture data.
             */
            shader(key: string | Phaser.Display.BaseShader, x?: number, y?: number, width?: number, height?: number, textures?: string[], textureData?: object): Phaser.GameObjects.Shader;

            /**
             * Creates a new Arc Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Arc Game Object has been built into Phaser.
             * 
             * The Arc Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * When it renders it displays an arc shape. You can control the start and end angles of the arc,
             * as well as if the angles are winding clockwise or anti-clockwise. With the default settings
             * it renders as a complete circle. By changing the angles you can create other arc shapes,
             * such as half-circles.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param radius The radius of the arc. Default 128.
             * @param startAngle The start angle of the arc, in degrees. Default 0.
             * @param endAngle The end angle of the arc, in degrees. Default 360.
             * @param anticlockwise The winding order of the start and end angles. Default false.
             * @param fillColor The color the arc will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the arc will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            arc(x?: number, y?: number, radius?: number, startAngle?: number, endAngle?: number, anticlockwise?: boolean, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Arc;

            /**
             * Creates a new Circle Shape Game Object and adds it to the Scene.
             * 
             * A Circle is an Arc with no defined start and end angle, making it render as a complete circle.
             * 
             * Note: This method will only be available if the Arc Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param radius The radius of the circle. Default 128.
             * @param fillColor The color the circle will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the circle will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            circle(x?: number, y?: number, radius?: number, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Arc;

            /**
             * Creates a new Curve Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Curve Game Object has been built into Phaser.
             * 
             * The Curve Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * To render a Curve Shape you must first create a `Phaser.Curves.Curve` object, then pass it to
             * the Curve Shape in the constructor.
             * 
             * The Curve shape also has a `smoothness` property and corresponding `setSmoothness` method.
             * This allows you to control how smooth the shape renders in WebGL, by controlling the number of iterations
             * that take place during construction. Increase and decrease the default value for smoother, or more
             * jagged, shapes.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param curve The Curve object to use to create the Shape.
             * @param fillColor The color the curve will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the curve will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            curve(x?: number, y?: number, curve?: Phaser.Curves.Curve, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Curve;

            /**
             * Creates a new Ellipse Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Ellipse Game Object has been built into Phaser.
             * 
             * The Ellipse Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * When it renders it displays an ellipse shape. You can control the width and height of the ellipse.
             * If the width and height match it will render as a circle. If the width is less than the height,
             * it will look more like an egg shape.
             * 
             * The Ellipse shape also has a `smoothness` property and corresponding `setSmoothness` method.
             * This allows you to control how smooth the shape renders in WebGL, by controlling the number of iterations
             * that take place during construction. Increase and decrease the default value for smoother, or more
             * jagged, shapes.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the ellipse. An ellipse with equal width and height renders as a circle. Default 128.
             * @param height The height of the ellipse. An ellipse with equal width and height renders as a circle. Default 128.
             * @param fillColor The color the ellipse will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the ellipse will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            ellipse(x?: number, y?: number, width?: number, height?: number, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Ellipse;

            /**
             * Creates a new Grid Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Grid Game Object has been built into Phaser.
             * 
             * The Grid Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports only fill colors and cannot be stroked.
             * 
             * A Grid Shape allows you to display a grid in your game, where you can control the size of the
             * grid as well as the width and height of the grid cells. You can set a fill color for each grid
             * cell as well as an alternate fill color. When the alternate fill color is set then the grid
             * cells will alternate the fill colors as they render, creating a chess-board effect. You can
             * also optionally have an outline fill color. If set, this draws lines between the grid cells
             * in the given color. If you specify an outline color with an alpha of zero, then it will draw
             * the cells spaced out, but without the lines between them.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the grid. Default 128.
             * @param height The height of the grid. Default 128.
             * @param cellWidth The width of one cell in the grid. Default 32.
             * @param cellHeight The height of one cell in the grid. Default 32.
             * @param fillColor The color the grid cells will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the grid cells will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             * @param outlineFillColor The color of the lines between the grid cells.
             * @param outlineFillAlpha The alpha of the lines between the grid cells.
             */
            grid(x?: number, y?: number, width?: number, height?: number, cellWidth?: number, cellHeight?: number, fillColor?: number, fillAlpha?: number, outlineFillColor?: number, outlineFillAlpha?: number): Phaser.GameObjects.Grid;

            /**
             * Creates a new IsoBox Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the IsoBox Game Object has been built into Phaser.
             * 
             * The IsoBox Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports only fill colors and cannot be stroked.
             * 
             * An IsoBox is an 'isometric' rectangle. Each face of it has a different fill color. You can set
             * the color of the top, left and right faces of the rectangle respectively. You can also choose
             * which of the faces are rendered via the `showTop`, `showLeft` and `showRight` properties.
             * 
             * You cannot view an IsoBox from under-neath, however you can change the 'angle' by setting
             * the `projection` property.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param size The width of the iso box in pixels. The left and right faces will be exactly half this value. Default 48.
             * @param height The height of the iso box. The left and right faces will be this tall. The overall height of the isobox will be this value plus half the `size` value. Default 32.
             * @param fillTop The fill color of the top face of the iso box. Default 0xeeeeee.
             * @param fillLeft The fill color of the left face of the iso box. Default 0x999999.
             * @param fillRight The fill color of the right face of the iso box. Default 0xcccccc.
             */
            isobox(x?: number, y?: number, size?: number, height?: number, fillTop?: number, fillLeft?: number, fillRight?: number): Phaser.GameObjects.IsoBox;

            /**
             * Creates a new IsoTriangle Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the IsoTriangle Game Object has been built into Phaser.
             * 
             * The IsoTriangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports only fill colors and cannot be stroked.
             * 
             * An IsoTriangle is an 'isometric' triangle. Think of it like a pyramid. Each face has a different
             * fill color. You can set the color of the top, left and right faces of the triangle respectively
             * You can also choose which of the faces are rendered via the `showTop`, `showLeft` and `showRight` properties.
             * 
             * You cannot view an IsoTriangle from under-neath, however you can change the 'angle' by setting
             * the `projection` property. The `reversed` property controls if the IsoTriangle is rendered upside
             * down or not.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param size The width of the iso triangle in pixels. The left and right faces will be exactly half this value. Default 48.
             * @param height The height of the iso triangle. The left and right faces will be this tall. The overall height of the iso triangle will be this value plus half the `size` value. Default 32.
             * @param reversed Is the iso triangle upside down? Default false.
             * @param fillTop The fill color of the top face of the iso triangle. Default 0xeeeeee.
             * @param fillLeft The fill color of the left face of the iso triangle. Default 0x999999.
             * @param fillRight The fill color of the right face of the iso triangle. Default 0xcccccc.
             */
            isotriangle(x?: number, y?: number, size?: number, height?: number, reversed?: boolean, fillTop?: number, fillLeft?: number, fillRight?: number): Phaser.GameObjects.IsoTriangle;

            /**
             * Creates a new Line Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Line Game Object has been built into Phaser.
             * 
             * The Line Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports only stroke colors and cannot be filled.
             * 
             * A Line Shape allows you to draw a line between two points in your game. You can control the
             * stroke color and thickness of the line. In WebGL only you can also specify a different
             * thickness for the start and end of the line, allowing you to render lines that taper-off.
             * 
             * If you need to draw multiple lines in a sequence you may wish to use the Polygon Shape instead.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param x1 The horizontal position of the start of the line. Default 0.
             * @param y1 The vertical position of the start of the line. Default 0.
             * @param x2 The horizontal position of the end of the line. Default 128.
             * @param y2 The vertical position of the end of the line. Default 0.
             * @param strokeColor The color the line will be drawn in, i.e. 0xff0000 for red.
             * @param strokeAlpha The alpha the line will be drawn in. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            line(x?: number, y?: number, x1?: number, y1?: number, x2?: number, y2?: number, strokeColor?: number, strokeAlpha?: number): Phaser.GameObjects.Line;

            /**
             * Creates a new Polygon Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Polygon Game Object has been built into Phaser.
             * 
             * The Polygon Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * The Polygon Shape is created by providing a list of points, which are then used to create an
             * internal Polygon geometry object. The points can be set from a variety of formats:
             * 
             * - An array of Point or Vector2 objects: `[new Phaser.Math.Vector2(x1, y1), ...]`
             * - An array of objects with public x/y properties: `[obj1, obj2, ...]`
             * - An array of paired numbers that represent point coordinates: `[x1,y1, x2,y2, ...]`
             * - An array of arrays with two elements representing x/y coordinates: `[[x1, y1], [x2, y2], ...]`
             * 
             * By default the `x` and `y` coordinates of this Shape refer to the center of it. However, depending
             * on the coordinates of the points provided, the final shape may be rendered offset from its origin.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param points The points that make up the polygon.
             * @param fillColor The color the polygon will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the polygon will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            polygon(x?: number, y?: number, points?: any, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Polygon;

            /**
             * Creates a new Rectangle Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Rectangle Game Object has been built into Phaser.
             * 
             * The Rectangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * You can change the size of the rectangle by changing the `width` and `height` properties.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the rectangle. Default 128.
             * @param height The height of the rectangle. Default 128.
             * @param fillColor The color the rectangle will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the rectangle will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            rectangle(x?: number, y?: number, width?: number, height?: number, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Rectangle;

            /**
             * Creates a new Star Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Star Game Object has been built into Phaser.
             * 
             * The Star Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * As the name implies, the Star shape will display a star in your game. You can control several
             * aspects of it including the number of points that constitute the star. The default is 5. If
             * you change it to 4 it will render as a diamond. If you increase them, you'll get a more spiky
             * star shape.
             * 
             * You can also control the inner and outer radius, which is how 'long' each point of the star is.
             * Modify these values to create more interesting shapes.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param points The number of points on the star. Default 5.
             * @param innerRadius The inner radius of the star. Default 32.
             * @param outerRadius The outer radius of the star. Default 64.
             * @param fillColor The color the star will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the star will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            star(x?: number, y?: number, points?: number, innerRadius?: number, outerRadius?: number, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Star;

            /**
             * Creates a new Triangle Shape Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Triangle Game Object has been built into Phaser.
             * 
             * The Triangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
             * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
             * it for input or physics. It provides a quick and easy way for you to render this shape in your
             * game without using a texture, while still taking advantage of being fully batched in WebGL.
             * 
             * This shape supports both fill and stroke colors.
             * 
             * The Triangle consists of 3 lines, joining up to form a triangular shape. You can control the
             * position of each point of these lines. The triangle is always closed and cannot have an open
             * face. If you require that, consider using a Polygon instead.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param x1 The horizontal position of the first point in the triangle. Default 0.
             * @param y1 The vertical position of the first point in the triangle. Default 128.
             * @param x2 The horizontal position of the second point in the triangle. Default 64.
             * @param y2 The vertical position of the second point in the triangle. Default 0.
             * @param x3 The horizontal position of the third point in the triangle. Default 128.
             * @param y3 The vertical position of the third point in the triangle. Default 128.
             * @param fillColor The color the triangle will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the triangle will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            triangle(x?: number, y?: number, x1?: number, y1?: number, x2?: number, y2?: number, x3?: number, y3?: number, fillColor?: number, fillAlpha?: number): Phaser.GameObjects.Triangle;

            /**
             * Creates a new Sprite Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Sprite Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            sprite(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.GameObjects.Sprite;

            /**
             * Creates a new Text Game Object and adds it to the Scene.
             * 
             * A Text Game Object.
             * 
             * Text objects work by creating their own internal hidden Canvas and then renders text to it using
             * the standard Canvas `fillText` API. It then creates a texture from this canvas which is rendered
             * to your game during the render pass.
             * 
             * Because it uses the Canvas API you can take advantage of all the features this offers, such as
             * applying gradient fills to the text, or strokes, shadows and more. You can also use custom fonts
             * loaded externally, such as Google or TypeKit Web fonts.
             * 
             * You can only display fonts that are currently loaded and available to the browser: therefore fonts must
             * be pre-loaded. Phaser does not do this for you, so you will require the use of a 3rd party font loader,
             * or have the fonts ready available in the CSS on the page in which your Phaser game resides.
             * 
             * See {@link http://www.jordanm.co.uk/tinytype this compatibility table} for the available default fonts
             * across mobile browsers.
             * 
             * A note on performance: Every time the contents of a Text object changes, i.e. changing the text being
             * displayed, or the style of the text, it needs to remake the Text canvas, and if on WebGL, re-upload the
             * new texture to the GPU. This can be an expensive operation if used often, or with large quantities of
             * Text objects in your game. If you run into performance issues you would be better off using Bitmap Text
             * instead, as it benefits from batching and avoids expensive Canvas API calls.
             * 
             * Note: This method will only be available if the Text Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param text The text this Text object will display.
             * @param style The Text style configuration object.
             */
            text(x: number, y: number, text: string | string[], style?: Phaser.Types.GameObjects.Text.TextStyle): Phaser.GameObjects.Text;

            /**
             * Creates a new TileSprite Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the TileSprite Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the Game Object. If zero it will use the size of the texture frame.
             * @param height The height of the Game Object. If zero it will use the size of the texture frame.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager. Cannot be a DynamicTexture.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            tileSprite(x: number, y: number, width: number, height: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.GameObjects.TileSprite;

            /**
             * Creates a new Video Game Object and adds it to the Scene.
             * 
             * This Game Object is capable of handling playback of a video file, video stream or media stream.
             * 
             * You can optionally 'preload' the video into the Phaser Video Cache:
             * 
             * ```javascript
             * preload () {
             *   this.load.video('ripley', 'assets/aliens.mp4');
             * }
             * 
             * create () {
             *   this.add.video(400, 300, 'ripley');
             * }
             * ```
             * 
             * You don't have to 'preload' the video. You can also play it directly from a URL:
             * 
             * ```javascript
             * create () {
             *   this.add.video(400, 300).loadURL('assets/aliens.mp4');
             * }
             * ```
             * 
             * To all intents and purposes, a video is a standard Game Object, just like a Sprite. And as such, you can do
             * all the usual things to it, such as scaling, rotating, cropping, tinting, making interactive, giving a
             * physics body, etc.
             * 
             * Transparent videos are also possible via the WebM file format. Providing the video file has was encoded with
             * an alpha channel, and providing the browser supports WebM playback (not all of them do), then it will render
             * in-game with full transparency.
             * 
             * ### Autoplaying Videos
             * 
             * Videos can only autoplay if the browser has been unlocked with an interaction, or satisfies the MEI settings.
             * The policies that control autoplaying are vast and vary between browser. You can, and should, read more about
             * it here: https://developer.mozilla.org/en-US/docs/Web/Media/Autoplay_guide
             * 
             * If your video doesn't contain any audio, then set the `noAudio` parameter to `true` when the video is _loaded_,
             * and it will often allow the video to play immediately:
             * 
             * ```javascript
             * preload () {
             *   this.load.video('pixar', 'nemo.mp4', true);
             * }
             * ```
             * 
             * The 3rd parameter in the load call tells Phaser that the video doesn't contain any audio tracks. Video without
             * audio can autoplay without requiring a user interaction. Video with audio cannot do this unless it satisfies
             * the browsers MEI settings. See the MDN Autoplay Guide for further details.
             * 
             * Or:
             * 
             * ```javascript
             * create () {
             *   this.add.video(400, 300).loadURL('assets/aliens.mp4', true);
             * }
             * ```
             * 
             * You can set the `noAudio` parameter to `true` even if the video does contain audio. It will still allow the video
             * to play immediately, but the audio will not start.
             * 
             * Note that due to a bug in IE11 you cannot play a video texture to a Sprite in WebGL. For IE11 force Canvas mode.
             * 
             * More details about video playback and the supported media formats can be found on MDN:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/API/HTMLVideoElement
             * https://developer.mozilla.org/en-US/docs/Web/Media/Formats
             * 
             * Note: This method will only be available if the Video Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param key Optional key of the Video this Game Object will play, as stored in the Video Cache.
             */
            video(x: number, y: number, key?: string): Phaser.GameObjects.Video;

            /**
             * Creates a new Zone Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Zone Game Object has been built into Phaser.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the Game Object.
             * @param height The height of the Game Object.
             */
            zone(x: number, y: number, width: number, height: number): Phaser.GameObjects.Zone;

            /**
             * Creates a Tilemap from the given key or data, or creates a blank Tilemap if no key/data provided.
             * When loading from CSV or a 2D array, you should specify the tileWidth & tileHeight. When parsing
             * from a map from Tiled, the tileWidth, tileHeight, width & height will be pulled from the map
             * data. For an empty map, you should specify tileWidth, tileHeight, width & height.
             * @param key The key in the Phaser cache that corresponds to the loaded tilemap data.
             * @param tileWidth The width of a tile in pixels. Pass in `null` to leave as the
             * default. Default 32.
             * @param tileHeight The height of a tile in pixels. Pass in `null` to leave as the
             * default. Default 32.
             * @param width The width of the map in tiles. Pass in `null` to leave as the
             * default. Default 10.
             * @param height The height of the map in tiles. Pass in `null` to leave as the
             * default. Default 10.
             * @param data Instead of loading from the cache, you can also load directly from
             * a 2D array of tile indexes. Pass in `null` for no data.
             * @param insertNull Controls how empty tiles, tiles with an index of -1, in the
             * map data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
             * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
             * the tile data doesn't need to change then setting this value to `true` will help with memory
             * consumption. However if your map is small or you need to update the tiles dynamically, then leave
             * the default value set. Default false.
             */
            tilemap(key?: string, tileWidth?: number, tileHeight?: number, width?: number, height?: number, data?: number[][], insertNull?: boolean): Phaser.Tilemaps.Tilemap;

            /**
             * A Timeline is a way to schedule events to happen at specific times in the future.
             * 
             * You can think of it as an event sequencer for your game, allowing you to schedule the
             * running of callbacks, events and other actions at specific times in the future.
             * 
             * A Timeline is a Scene level system, meaning you can have as many Timelines as you like, each
             * belonging to a different Scene. You can also have multiple Timelines running at the same time.
             * 
             * If the Scene is paused, the Timeline will also pause. If the Scene is destroyed, the Timeline
             * will be automatically destroyed. However, you can control the Timeline directly, pausing,
             * resuming and stopping it at any time.
             * 
             * Create an instance of a Timeline via the Game Object Factory:
             * 
             * ```js
             * const timeline = this.add.timeline();
             * ```
             * 
             * The Timeline always starts paused. You must call `play` on it to start it running.
             * 
             * You can also pass in a configuration object on creation, or an array of them:
             * 
             * ```js
             * const timeline = this.add.timeline({
             *     at: 1000,
             *     run: () => {
             *         this.add.sprite(400, 300, 'logo');
             *     }
             * });
             * 
             * timeline.play();
             * ```
             * 
             * In this example we sequence a few different events:
             * 
             * ```js
             * const timeline = this.add.timeline([
             *     {
             *         at: 1000,
             *         run: () => { this.logo = this.add.sprite(400, 300, 'logo'); },
             *         sound: 'TitleMusic'
             *     },
             *     {
             *         at: 2500,
             *         tween: {
             *             targets: this.logo,
             *             y: 600,
             *             yoyo: true
             *         },
             *         sound: 'Explode'
             *     },
             *     {
             *         at: 8000,
             *         event: 'HURRY_PLAYER',
             *         target: this.background,
             *         set: {
             *             tint: 0xff0000
             *         }
             *     }
             * ]);
             * 
             * timeline.play();
             * ```
             * 
             * There are lots of options available to you via the configuration object. See the
             * {@link Phaser.Types.Time.TimelineEventConfig} typedef for more details.
             * @param config The configuration object for this Timeline Event, or an array of them.
             */
            timeline(config: Phaser.Types.Time.TimelineEventConfig | Phaser.Types.Time.TimelineEventConfig[]): Phaser.Time.Timeline;

            /**
             * Creates a new Tween object.
             * 
             * Note: This method will only be available if Tweens have been built into Phaser.
             * @param config A Tween Configuration object, or a Tween or TweenChain instance.
             */
            tween(config: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenChainBuilderConfig | Phaser.Tweens.Tween | Phaser.Tweens.TweenChain): Phaser.Tweens.Tween;

            /**
             * Creates a new TweenChain object and adds it to the Tween Manager.
             * 
             * Note: This method will only be available if Tweens have been built into Phaser.
             * @param config The TweenChain configuration.
             */
            tweenchain(config: Phaser.Types.Tweens.TweenBuilderConfig | object): Phaser.Tweens.TweenChain;

        }

        /**
         * Calculates the Transform Matrix of the given Game Object and Camera, factoring in
         * the parent matrix if provided.
         * 
         * Note that the object this results contains _references_ to the Transform Matrices,
         * not new instances of them. Therefore, you should use their values immediately, or
         * copy them to your own matrix, as they will be replaced as soon as another Game
         * Object is rendered.
         * @param src The Game Object to calculate the transform matrix for.
         * @param camera The camera being used to render the Game Object.
         * @param parentMatrix The transform matrix of the parent container, if any.
         */
        function GetCalcMatrix(src: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.Types.GameObjects.GetCalcMatrixResults;

        /**
         * A Graphics object is a way to draw primitive shapes to your game. Primitives include forms of geometry, such as
         * Rectangles, Circles, and Polygons. They also include lines, arcs and curves. When you initially create a Graphics
         * object it will be empty.
         * 
         * To draw to it you must first specify a line style or fill style (or both), draw shapes using paths, and finally
         * fill or stroke them. For example:
         * 
         * ```javascript
         * graphics.lineStyle(5, 0xFF00FF, 1.0);
         * graphics.beginPath();
         * graphics.moveTo(100, 100);
         * graphics.lineTo(200, 200);
         * graphics.closePath();
         * graphics.strokePath();
         * ```
         * 
         * There are also many helpful methods that draw and fill/stroke common shapes for you.
         * 
         * ```javascript
         * graphics.lineStyle(5, 0xFF00FF, 1.0);
         * graphics.fillStyle(0xFFFFFF, 1.0);
         * graphics.fillRect(50, 50, 400, 200);
         * graphics.strokeRect(50, 50, 400, 200);
         * ```
         * 
         * When a Graphics object is rendered it will render differently based on if the game is running under Canvas or WebGL.
         * Under Canvas it will use the HTML Canvas context drawing operations to draw the path.
         * Under WebGL the graphics data is decomposed into polygons. Both of these are expensive processes, especially with
         * complex shapes.
         * 
         * If your Graphics object doesn't change much (or at all) once you've drawn your shape to it, then you will help
         * performance by calling {@link Phaser.GameObjects.Graphics#generateTexture}. This will 'bake' the Graphics object into
         * a Texture, and return it. You can then use this Texture for Sprites or other display objects. If your Graphics object
         * updates frequently then you should avoid doing this, as it will constantly generate new textures, which will consume
         * memory.
         * 
         * As you can tell, Graphics objects are a bit of a trade-off. While they are extremely useful, you need to be careful
         * in their complexity and quantity of them in your game.
         */
        class Graphics extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible, Phaser.GameObjects.Components.ScrollFactor {
            /**
             * 
             * @param scene The Scene to which this Graphics object belongs.
             * @param options Options that set the position and default style of this Graphics object.
             */
            constructor(scene: Phaser.Scene, options?: Phaser.Types.GameObjects.Graphics.Options);

            /**
             * The horizontal display origin of the Graphics.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of the Graphics.
             */
            displayOriginY: number;

            /**
             * The array of commands used to render the Graphics.
             */
            commandBuffer: any[];

            /**
             * The default fill color for shapes rendered by this Graphics object.
             * Set this value with `setDefaultStyles()`.
             */
            readonly defaultFillColor: number;

            /**
             * The default fill alpha for shapes rendered by this Graphics object.
             * Set this value with `setDefaultStyles()`.
             */
            readonly defaultFillAlpha: number;

            /**
             * The default stroke width for shapes rendered by this Graphics object.
             * Set this value with `setDefaultStyles()`.
             */
            readonly defaultStrokeWidth: number;

            /**
             * The default stroke color for shapes rendered by this Graphics object.
             * Set this value with `setDefaultStyles()`.
             */
            readonly defaultStrokeColor: number;

            /**
             * The default stroke alpha for shapes rendered by this Graphics object.
             * Set this value with `setDefaultStyles()`.
             */
            readonly defaultStrokeAlpha: number;

            /**
             * Set the default style settings for this Graphics object.
             * @param options The styles to set as defaults.
             */
            setDefaultStyles(options: Phaser.Types.GameObjects.Graphics.Styles): this;

            /**
             * Set the current line style. Used for all 'stroke' related functions.
             * @param lineWidth The stroke width.
             * @param color The stroke color.
             * @param alpha The stroke alpha. Default 1.
             */
            lineStyle(lineWidth: number, color: number, alpha?: number): this;

            /**
             * Set the current fill style. Used for all 'fill' related functions.
             * @param color The fill color.
             * @param alpha The fill alpha. Default 1.
             */
            fillStyle(color: number, alpha?: number): this;

            /**
             * Sets a gradient fill style. This is a WebGL only feature.
             * 
             * The gradient color values represent the 4 corners of an untransformed rectangle.
             * The gradient is used to color all filled shapes and paths drawn after calling this method.
             * If you wish to turn a gradient off, call `fillStyle` and provide a new single fill color.
             * 
             * When filling a triangle only the first 3 color values provided are used for the 3 points of a triangle.
             * 
             * This feature is best used only on rectangles and triangles. All other shapes will give strange results.
             * 
             * Note that for objects such as arcs or ellipses, or anything which is made out of triangles, each triangle used
             * will be filled with a gradient on its own. There is no ability to gradient fill a shape or path as a single
             * entity at this time.
             * @param topLeft The top left fill color.
             * @param topRight The top right fill color.
             * @param bottomLeft The bottom left fill color.
             * @param bottomRight The bottom right fill color. Not used when filling triangles.
             * @param alphaTopLeft The top left alpha value. If you give only this value, it's used for all corners. Default 1.
             * @param alphaTopRight The top right alpha value. Default 1.
             * @param alphaBottomLeft The bottom left alpha value. Default 1.
             * @param alphaBottomRight The bottom right alpha value. Default 1.
             */
            fillGradientStyle(topLeft: number, topRight: number, bottomLeft: number, bottomRight: number, alphaTopLeft?: number, alphaTopRight?: number, alphaBottomLeft?: number, alphaBottomRight?: number): this;

            /**
             * Sets a gradient line style. This is a WebGL only feature.
             * 
             * The gradient color values represent the 4 corners of an untransformed rectangle.
             * The gradient is used to color all stroked shapes and paths drawn after calling this method.
             * If you wish to turn a gradient off, call `lineStyle` and provide a new single line color.
             * 
             * This feature is best used only on single lines. All other shapes will give strange results.
             * 
             * Note that for objects such as arcs or ellipses, or anything which is made out of triangles, each triangle used
             * will be filled with a gradient on its own. There is no ability to gradient stroke a shape or path as a single
             * entity at this time.
             * @param lineWidth The stroke width.
             * @param topLeft The tint being applied to the top-left of the Game Object.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             * @param alpha The fill alpha. Default 1.
             */
            lineGradientStyle(lineWidth: number, topLeft: number, topRight: number, bottomLeft: number, bottomRight: number, alpha?: number): this;

            /**
             * Start a new shape path.
             */
            beginPath(): this;

            /**
             * Close the current path.
             */
            closePath(): this;

            /**
             * Fill the current path.
             */
            fillPath(): this;

            /**
             * Fill the current path.
             * 
             * This is an alias for `Graphics.fillPath` and does the same thing.
             * It was added to match the CanvasRenderingContext 2D API.
             */
            fill(): this;

            /**
             * Stroke the current path.
             */
            strokePath(): this;

            /**
             * Stroke the current path.
             * 
             * This is an alias for `Graphics.strokePath` and does the same thing.
             * It was added to match the CanvasRenderingContext 2D API.
             */
            stroke(): this;

            /**
             * Fill the given circle.
             * @param circle The circle to fill.
             */
            fillCircleShape(circle: Phaser.Geom.Circle): this;

            /**
             * Stroke the given circle.
             * @param circle The circle to stroke.
             */
            strokeCircleShape(circle: Phaser.Geom.Circle): this;

            /**
             * Fill a circle with the given position and radius.
             * @param x The x coordinate of the center of the circle.
             * @param y The y coordinate of the center of the circle.
             * @param radius The radius of the circle.
             */
            fillCircle(x: number, y: number, radius: number): this;

            /**
             * Stroke a circle with the given position and radius.
             * @param x The x coordinate of the center of the circle.
             * @param y The y coordinate of the center of the circle.
             * @param radius The radius of the circle.
             */
            strokeCircle(x: number, y: number, radius: number): this;

            /**
             * Fill the given rectangle.
             * @param rect The rectangle to fill.
             */
            fillRectShape(rect: Phaser.Geom.Rectangle): this;

            /**
             * Stroke the given rectangle.
             * @param rect The rectangle to stroke.
             */
            strokeRectShape(rect: Phaser.Geom.Rectangle): this;

            /**
             * Fill a rectangle with the given position and size.
             * @param x The x coordinate of the top-left of the rectangle.
             * @param y The y coordinate of the top-left of the rectangle.
             * @param width The width of the rectangle.
             * @param height The height of the rectangle.
             */
            fillRect(x: number, y: number, width: number, height: number): this;

            /**
             * Stroke a rectangle with the given position and size.
             * @param x The x coordinate of the top-left of the rectangle.
             * @param y The y coordinate of the top-left of the rectangle.
             * @param width The width of the rectangle.
             * @param height The height of the rectangle.
             */
            strokeRect(x: number, y: number, width: number, height: number): this;

            /**
             * Fill a rounded rectangle with the given position, size and radius.
             * @param x The x coordinate of the top-left of the rectangle.
             * @param y The y coordinate of the top-left of the rectangle.
             * @param width The width of the rectangle.
             * @param height The height of the rectangle.
             * @param radius The corner radius; It can also be an object to specify different radius for corners. Default 20.
             */
            fillRoundedRect(x: number, y: number, width: number, height: number, radius?: Phaser.Types.GameObjects.Graphics.RoundedRectRadius | number): this;

            /**
             * Stroke a rounded rectangle with the given position, size and radius.
             * @param x The x coordinate of the top-left of the rectangle.
             * @param y The y coordinate of the top-left of the rectangle.
             * @param width The width of the rectangle.
             * @param height The height of the rectangle.
             * @param radius The corner radius; It can also be an object to specify different radii for corners. Default 20.
             */
            strokeRoundedRect(x: number, y: number, width: number, height: number, radius?: Phaser.Types.GameObjects.Graphics.RoundedRectRadius | number): this;

            /**
             * Fill the given point.
             * 
             * Draws a square at the given position, 1 pixel in size by default.
             * @param point The point to fill.
             * @param size The size of the square to draw. Default 1.
             */
            fillPointShape(point: Phaser.Geom.Point | Phaser.Math.Vector2 | object, size?: number): this;

            /**
             * Fill a point at the given position.
             * 
             * Draws a square at the given position, 1 pixel in size by default.
             * @param x The x coordinate of the point.
             * @param y The y coordinate of the point.
             * @param size The size of the square to draw. Default 1.
             */
            fillPoint(x: number, y: number, size?: number): this;

            /**
             * Fill the given triangle.
             * @param triangle The triangle to fill.
             */
            fillTriangleShape(triangle: Phaser.Geom.Triangle): this;

            /**
             * Stroke the given triangle.
             * @param triangle The triangle to stroke.
             */
            strokeTriangleShape(triangle: Phaser.Geom.Triangle): this;

            /**
             * Fill a triangle with the given points.
             * @param x0 The x coordinate of the first point.
             * @param y0 The y coordinate of the first point.
             * @param x1 The x coordinate of the second point.
             * @param y1 The y coordinate of the second point.
             * @param x2 The x coordinate of the third point.
             * @param y2 The y coordinate of the third point.
             */
            fillTriangle(x0: number, y0: number, x1: number, y1: number, x2: number, y2: number): this;

            /**
             * Stroke a triangle with the given points.
             * @param x0 The x coordinate of the first point.
             * @param y0 The y coordinate of the first point.
             * @param x1 The x coordinate of the second point.
             * @param y1 The y coordinate of the second point.
             * @param x2 The x coordinate of the third point.
             * @param y2 The y coordinate of the third point.
             */
            strokeTriangle(x0: number, y0: number, x1: number, y1: number, x2: number, y2: number): this;

            /**
             * Draw the given line.
             * @param line The line to stroke.
             */
            strokeLineShape(line: Phaser.Geom.Line): this;

            /**
             * Draw a line between the given points.
             * @param x1 The x coordinate of the start point of the line.
             * @param y1 The y coordinate of the start point of the line.
             * @param x2 The x coordinate of the end point of the line.
             * @param y2 The y coordinate of the end point of the line.
             */
            lineBetween(x1: number, y1: number, x2: number, y2: number): this;

            /**
             * Draw a line from the current drawing position to the given position.
             * 
             * Moves the current drawing position to the given position.
             * @param x The x coordinate to draw the line to.
             * @param y The y coordinate to draw the line to.
             */
            lineTo(x: number, y: number): this;

            /**
             * Move the current drawing position to the given position.
             * @param x The x coordinate to move to.
             * @param y The y coordinate to move to.
             */
            moveTo(x: number, y: number): this;

            /**
             * Stroke the shape represented by the given array of points.
             * 
             * Pass `closeShape` to automatically close the shape by joining the last to the first point.
             * 
             * Pass `closePath` to automatically close the path before it is stroked.
             * @param points The points to stroke.
             * @param closeShape When `true`, the shape is closed by joining the last point to the first point. Default false.
             * @param closePath When `true`, the path is closed before being stroked. Default false.
             * @param endIndex The index of `points` to stop drawing at. Defaults to `points.length`.
             */
            strokePoints(points: any[] | Phaser.Geom.Point[], closeShape?: boolean, closePath?: boolean, endIndex?: number): this;

            /**
             * Fill the shape represented by the given array of points.
             * 
             * Pass `closeShape` to automatically close the shape by joining the last to the first point.
             * 
             * Pass `closePath` to automatically close the path before it is filled.
             * @param points The points to fill.
             * @param closeShape When `true`, the shape is closed by joining the last point to the first point. Default false.
             * @param closePath When `true`, the path is closed before being stroked. Default false.
             * @param endIndex The index of `points` to stop at. Defaults to `points.length`.
             */
            fillPoints(points: any[] | Phaser.Geom.Point[], closeShape?: boolean, closePath?: boolean, endIndex?: number): this;

            /**
             * Stroke the given ellipse.
             * @param ellipse The ellipse to stroke.
             * @param smoothness The number of points to draw the ellipse with. Default 32.
             */
            strokeEllipseShape(ellipse: Phaser.Geom.Ellipse, smoothness?: number): this;

            /**
             * Stroke an ellipse with the given position and size.
             * @param x The x coordinate of the center of the ellipse.
             * @param y The y coordinate of the center of the ellipse.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse.
             * @param smoothness The number of points to draw the ellipse with. Default 32.
             */
            strokeEllipse(x: number, y: number, width: number, height: number, smoothness?: number): this;

            /**
             * Fill the given ellipse.
             * @param ellipse The ellipse to fill.
             * @param smoothness The number of points to draw the ellipse with. Default 32.
             */
            fillEllipseShape(ellipse: Phaser.Geom.Ellipse, smoothness?: number): this;

            /**
             * Fill an ellipse with the given position and size.
             * @param x The x coordinate of the center of the ellipse.
             * @param y The y coordinate of the center of the ellipse.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse.
             * @param smoothness The number of points to draw the ellipse with. Default 32.
             */
            fillEllipse(x: number, y: number, width: number, height: number, smoothness?: number): this;

            /**
             * Draw an arc.
             * 
             * This method can be used to create circles, or parts of circles.
             * 
             * Make sure you call `beginPath` before starting the arc unless you wish for the arc to automatically
             * close when filled or stroked.
             * 
             * Use the optional `overshoot` argument increase the number of iterations that take place when
             * the arc is rendered in WebGL. This is useful if you're drawing an arc with an especially thick line,
             * as it will allow the arc to fully join-up. Try small values at first, i.e. 0.01.
             * 
             * Call {@link Phaser.GameObjects.Graphics#fillPath} or {@link Phaser.GameObjects.Graphics#strokePath} after calling
             * this method to draw the arc.
             * @param x The x coordinate of the center of the circle.
             * @param y The y coordinate of the center of the circle.
             * @param radius The radius of the circle.
             * @param startAngle The starting angle, in radians.
             * @param endAngle The ending angle, in radians.
             * @param anticlockwise Whether the drawing should be anticlockwise or clockwise. Default false.
             * @param overshoot This value allows you to increase the segment iterations in WebGL rendering. Useful if the arc has a thick stroke and needs to overshoot to join-up cleanly. Use small numbers such as 0.01 to start with and increase as needed. Default 0.
             */
            arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise?: boolean, overshoot?: number): this;

            /**
             * Creates a pie-chart slice shape centered at `x`, `y` with the given radius.
             * You must define the start and end angle of the slice.
             * 
             * Setting the `anticlockwise` argument to `true` creates a shape similar to Pacman.
             * Setting it to `false` creates a shape like a slice of pie.
             * 
             * This method will begin a new path and close the path at the end of it.
             * To display the actual slice you need to call either `strokePath` or `fillPath` after it.
             * @param x The horizontal center of the slice.
             * @param y The vertical center of the slice.
             * @param radius The radius of the slice.
             * @param startAngle The start angle of the slice, given in radians.
             * @param endAngle The end angle of the slice, given in radians.
             * @param anticlockwise Whether the drawing should be anticlockwise or clockwise. Default false.
             * @param overshoot This value allows you to overshoot the endAngle by this amount. Useful if the arc has a thick stroke and needs to overshoot to join-up cleanly. Default 0.
             */
            slice(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise?: boolean, overshoot?: number): this;

            /**
             * Saves the state of the Graphics by pushing the current state onto a stack.
             * 
             * The most recently saved state can then be restored with {@link Phaser.GameObjects.Graphics#restore}.
             */
            save(): this;

            /**
             * Restores the most recently saved state of the Graphics by popping from the state stack.
             * 
             * Use {@link Phaser.GameObjects.Graphics#save} to save the current state, and call this afterwards to restore that state.
             * 
             * If there is no saved state, this command does nothing.
             */
            restore(): this;

            /**
             * Inserts a translation command into this Graphics objects command buffer.
             * 
             * All objects drawn _after_ calling this method will be translated
             * by the given amount.
             * 
             * This does not change the position of the Graphics object itself,
             * only of the objects drawn by it after calling this method.
             * @param x The horizontal translation to apply.
             * @param y The vertical translation to apply.
             */
            translateCanvas(x: number, y: number): this;

            /**
             * Inserts a scale command into this Graphics objects command buffer.
             * 
             * All objects drawn _after_ calling this method will be scaled
             * by the given amount.
             * 
             * This does not change the scale of the Graphics object itself,
             * only of the objects drawn by it after calling this method.
             * @param x The horizontal scale to apply.
             * @param y The vertical scale to apply.
             */
            scaleCanvas(x: number, y: number): this;

            /**
             * Inserts a rotation command into this Graphics objects command buffer.
             * 
             * All objects drawn _after_ calling this method will be rotated
             * by the given amount.
             * 
             * This does not change the rotation of the Graphics object itself,
             * only of the objects drawn by it after calling this method.
             * @param radians The rotation angle, in radians.
             */
            rotateCanvas(radians: number): this;

            /**
             * Clear the command buffer and reset the fill style and line style to their defaults.
             */
            clear(): this;

            /**
             * Generate a texture from this Graphics object.
             * 
             * If `key` is a string it'll generate a new texture using it and add it into the
             * Texture Manager (assuming no key conflict happens).
             * 
             * If `key` is a Canvas it will draw the texture to that canvas context. Note that it will NOT
             * automatically upload it to the GPU in WebGL mode.
             * 
             * Please understand that the texture is created via the Canvas API of the browser, therefore some
             * Graphics features, such as `fillGradientStyle`, will not appear on the resulting texture,
             * as they're unsupported by the Canvas API.
             * @param key The key to store the texture with in the Texture Manager, or a Canvas to draw to.
             * @param width The width of the graphics to generate.
             * @param height The height of the graphics to generate.
             */
            generateTexture(key: string | HTMLCanvasElement, width?: number, height?: number): this;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * A Camera used specifically by the Graphics system for rendering to textures.
             */
            static TargetCamera: Phaser.Cameras.Scene2D.Camera;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

        }

        /**
         * A Group is a way for you to create, manipulate, or recycle similar Game Objects.
         * 
         * Group membership is non-exclusive. A Game Object can belong to several groups, one group, or none.
         * 
         * Groups themselves aren't displayable, and can't be positioned, rotated, scaled, or hidden.
         */
        class Group extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param scene The scene this group belongs to.
             * @param children Game Objects to add to this group; or the `config` argument.
             * @param config Settings for this group. If `key` is set, Phaser.GameObjects.Group#createMultiple is also called with these settings.
             */
            constructor(scene: Phaser.Scene, children?: Phaser.GameObjects.GameObject[] | Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig);

            /**
             * This scene this group belongs to.
             */
            scene: Phaser.Scene;

            /**
             * Members of this group.
             */
            children: Phaser.Structs.Set<Phaser.GameObjects.GameObject>;

            /**
             * A flag identifying this object as a group.
             */
            isParent: boolean;

            /**
             * A textual representation of this Game Object.
             * Used internally by Phaser but is available for your own custom classes to populate.
             */
            type: string;

            /**
             * The class to create new group members from.
             */
            classType: Function;

            /**
             * The name of this group.
             * Empty by default and never populated by Phaser, this is left for developers to use.
             */
            name: string;

            /**
             * Whether this group runs its {@link Phaser.GameObjects.Group#preUpdate} method (which may update any members).
             */
            active: boolean;

            /**
             * The maximum size of this group, if used as a pool. -1 is no limit.
             */
            maxSize: number;

            /**
             * A default texture key to use when creating new group members.
             * 
             * This is used in {@link Phaser.GameObjects.Group#create}
             * but not in {@link Phaser.GameObjects.Group#createMultiple}.
             */
            defaultKey: string;

            /**
             * A default texture frame to use when creating new group members.
             */
            defaultFrame: string | number;

            /**
             * Whether to call the update method of any members.
             */
            runChildUpdate: boolean;

            /**
             * A function to be called when adding or creating group members.
             */
            createCallback: Phaser.Types.GameObjects.Group.GroupCallback | null;

            /**
             * A function to be called when removing group members.
             */
            removeCallback: Phaser.Types.GameObjects.Group.GroupCallback | null;

            /**
             * A function to be called when creating several group members at once.
             */
            createMultipleCallback: Phaser.Types.GameObjects.Group.GroupMultipleCreateCallback | null;

            /**
             * Creates a new Game Object and adds it to this group, unless the group {@link Phaser.GameObjects.Group#isFull is full}.
             * 
             * Calls {@link Phaser.GameObjects.Group#createCallback}.
             * @param x The horizontal position of the new Game Object in the world. Default 0.
             * @param y The vertical position of the new Game Object in the world. Default 0.
             * @param key The texture key of the new Game Object. Default defaultKey.
             * @param frame The texture frame of the new Game Object. Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of the new Game Object. Default true.
             * @param active The {@link Phaser.GameObjects.GameObject#active} state of the new Game Object. Default true.
             */
            create(x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean, active?: boolean): any;

            /**
             * Creates several Game Objects and adds them to this group.
             * 
             * If the group becomes {@link Phaser.GameObjects.Group#isFull}, no further Game Objects are created.
             * 
             * Calls {@link Phaser.GameObjects.Group#createMultipleCallback} and {@link Phaser.GameObjects.Group#createCallback}.
             * @param config Creation settings. This can be a single configuration object or an array of such objects, which will be applied in turn.
             */
            createMultiple(config: Phaser.Types.GameObjects.Group.GroupCreateConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig[]): any[];

            /**
             * A helper for {@link Phaser.GameObjects.Group#createMultiple}.
             * @param options Creation settings.
             */
            createFromConfig(options: Phaser.Types.GameObjects.Group.GroupCreateConfig): any[];

            /**
             * Updates any group members, if {@link Phaser.GameObjects.Group#runChildUpdate} is enabled.
             * @param time The current timestamp.
             * @param delta The delta time elapsed since the last frame.
             */
            preUpdate(time: number, delta: number): void;

            /**
             * Adds a Game Object to this group.
             * 
             * Calls {@link Phaser.GameObjects.Group#createCallback}.
             * @param child The Game Object to add.
             * @param addToScene Also add the Game Object to the scene. Default false.
             */
            add(child: Phaser.GameObjects.GameObject, addToScene?: boolean): this;

            /**
             * Adds several Game Objects to this group.
             * 
             * Calls {@link Phaser.GameObjects.Group#createCallback}.
             * @param children The Game Objects to add.
             * @param addToScene Also add the Game Objects to the scene. Default false.
             */
            addMultiple(children: Phaser.GameObjects.GameObject[], addToScene?: boolean): this;

            /**
             * Removes a member of this Group and optionally removes it from the Scene and / or destroys it.
             * 
             * Calls {@link Phaser.GameObjects.Group#removeCallback}.
             * @param child The Game Object to remove.
             * @param removeFromScene Optionally remove the Group member from the Scene it belongs to. Default false.
             * @param destroyChild Optionally call destroy on the removed Group member. Default false.
             */
            remove(child: Phaser.GameObjects.GameObject, removeFromScene?: boolean, destroyChild?: boolean): this;

            /**
             * Removes all members of this Group and optionally removes them from the Scene and / or destroys them.
             * 
             * Does not call {@link Phaser.GameObjects.Group#removeCallback}.
             * @param removeFromScene Optionally remove each Group member from the Scene. Default false.
             * @param destroyChild Optionally call destroy on the removed Group members. Default false.
             */
            clear(removeFromScene?: boolean, destroyChild?: boolean): this;

            /**
             * Tests if a Game Object is a member of this group.
             * @param child A Game Object.
             */
            contains(child: Phaser.GameObjects.GameObject): boolean;

            /**
             * All members of the group.
             */
            getChildren(): Phaser.GameObjects.GameObject[];

            /**
             * The number of members of the group.
             */
            getLength(): number;

            /**
             * Returns all children in this Group that match the given criteria based on the `property` and `value` arguments.
             * 
             * For example: `getMatching('visible', true)` would return only children that have their `visible` property set.
             * 
             * Optionally, you can specify a start and end index. For example if the Group has 100 elements,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would return matches from only
             * the first 50.
             * @param property The property to test on each array element.
             * @param value The value to test the property against. Must pass a strict (`===`) comparison check.
             * @param startIndex An optional start index to search from.
             * @param endIndex An optional end index to search to.
             */
            getMatching(property?: string, value?: any, startIndex?: number, endIndex?: number): any[];

            /**
             * Scans the Group, from top to bottom, for the first member that has an {@link Phaser.GameObjects.GameObject#active} state matching the argument,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no matching member is found and `createIfNull` is true and the group isn't full then it will create a new Game Object using `x`, `y`, `key`, `frame`, and `visible`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param state The {@link Phaser.GameObjects.GameObject#active} value to match. Default false.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getFirst(state?: boolean, createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any | null;

            /**
             * Scans the Group, from top to bottom, for the nth member that has an {@link Phaser.GameObjects.GameObject#active} state matching the argument,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no matching member is found and `createIfNull` is true and the group isn't full then it will create a new Game Object using `x`, `y`, `key`, `frame`, and `visible`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param nth The nth matching Group member to search for.
             * @param state The {@link Phaser.GameObjects.GameObject#active} value to match. Default false.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getFirstNth(nth: number, state?: boolean, createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any | null;

            /**
             * Scans the Group for the last member that has an {@link Phaser.GameObjects.GameObject#active} state matching the argument,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no matching member is found and `createIfNull` is true and the group isn't full then it will create a new Game Object using `x`, `y`, `key`, `frame`, and `visible`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param state The {@link Phaser.GameObjects.GameObject#active} value to match. Default false.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getLast(state?: boolean, createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any | null;

            /**
             * Scans the Group for the last nth member that has an {@link Phaser.GameObjects.GameObject#active} state matching the argument,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no matching member is found and `createIfNull` is true and the group isn't full then it will create a new Game Object using `x`, `y`, `key`, `frame`, and `visible`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param nth The nth matching Group member to search for.
             * @param state The {@link Phaser.GameObjects.GameObject#active} value to match. Default false.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getLastNth(nth: number, state?: boolean, createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any | null;

            /**
             * Scans the group for the first member that has an {@link Phaser.GameObjects.GameObject#active} state set to `false`,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no inactive member is found and the group isn't full then it will create a new Game Object using `x`, `y`, `key`, `frame`, and `visible`.
             * The new Game Object will have its active state set to `true`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            get(x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any | null;

            /**
             * Scans the group for the first member that has an {@link Phaser.GameObjects.GameObject#active} state set to `true`,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no active member is found and `createIfNull` is `true` and the group isn't full then it will create a new one using `x`, `y`, `key`, `frame`, and `visible`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getFirstAlive(createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any;

            /**
             * Scans the group for the first member that has an {@link Phaser.GameObjects.GameObject#active} state set to `false`,
             * assigns `x` and `y`, and returns the member.
             * 
             * If no inactive member is found and `createIfNull` is `true` and the group isn't full then it will create a new one using `x`, `y`, `key`, `frame`, and `visible`.
             * The new Game Object will have an active state set to `true`.
             * Unless a new member is created, `key`, `frame`, and `visible` are ignored.
             * @param createIfNull Create a new Game Object if no matching members are found, using the following arguments. Default false.
             * @param x The horizontal position of the Game Object in the world.
             * @param y The vertical position of the Game Object in the world.
             * @param key The texture key assigned to a new Game Object (if one is created). Default defaultKey.
             * @param frame A texture frame assigned to a new Game Object (if one is created). Default defaultFrame.
             * @param visible The {@link Phaser.GameObjects.Components.Visible#visible} state of a new Game Object (if one is created). Default true.
             */
            getFirstDead(createIfNull?: boolean, x?: number, y?: number, key?: string, frame?: string | number, visible?: boolean): any;

            /**
             * {@link Phaser.GameObjects.Components.Animation#play Plays} an animation for all members of this group.
             * @param key The string-based key of the animation to play.
             * @param startFrame Optionally start the animation playing from this frame index. Default 0.
             */
            playAnimation(key: string, startFrame?: string): this;

            /**
             * Whether this group's size at its {@link Phaser.GameObjects.Group#maxSize maximum}.
             */
            isFull(): boolean;

            /**
             * Counts the number of active (or inactive) group members.
             * @param value Count active (true) or inactive (false) group members. Default true.
             */
            countActive(value?: boolean): number;

            /**
             * Counts the number of in-use (active) group members.
             */
            getTotalUsed(): number;

            /**
             * The difference of {@link Phaser.GameObjects.Group#maxSize} and the number of active group members.
             * 
             * This represents the number of group members that could be created or reactivated before reaching the size limit.
             */
            getTotalFree(): number;

            /**
             * Sets the `active` property of this Group.
             * When active, this Group runs its `preUpdate` method.
             * @param value True if this Group should be set as active, false if not.
             */
            setActive(value: boolean): this;

            /**
             * Sets the `name` property of this Group.
             * The `name` property is not populated by Phaser and is presented for your own use.
             * @param value The name to be given to this Group.
             */
            setName(value: string): this;

            /**
             * Sets the property as defined in `key` of each group member to the given value.
             * @param key The property to be updated.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             * @param index An optional offset to start searching from within the items array. Default 0.
             * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
             */
            propertyValueSet(key: string, value: number, step?: number, index?: number, direction?: number): this;

            /**
             * Adds the given value to the property as defined in `key` of each group member.
             * @param key The property to be updated.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             * @param index An optional offset to start searching from within the items array. Default 0.
             * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
             */
            propertyValueInc(key: string, value: number, step?: number, index?: number, direction?: number): this;

            /**
             * Sets the x of each group member.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            setX(value: number, step?: number): this;

            /**
             * Sets the y of each group member.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            setY(value: number, step?: number): this;

            /**
             * Sets the x, y of each group member.
             * @param x The amount to set the `x` property to.
             * @param y The amount to set the `y` property to. If `undefined` or `null` it uses the `x` value. Default x.
             * @param stepX This is added to the `x` amount, multiplied by the iteration counter. Default 0.
             * @param stepY This is added to the `y` amount, multiplied by the iteration counter. Default 0.
             */
            setXY(x: number, y?: number, stepX?: number, stepY?: number): this;

            /**
             * Adds the given value to the x of each group member.
             * @param value The amount to be added to the `x` property.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            incX(value: number, step?: number): this;

            /**
             * Adds the given value to the y of each group member.
             * @param value The amount to be added to the `y` property.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            incY(value: number, step?: number): this;

            /**
             * Adds the given value to the x, y of each group member.
             * @param x The amount to be added to the `x` property.
             * @param y The amount to be added to the `y` property. If `undefined` or `null` it uses the `x` value. Default x.
             * @param stepX This is added to the `x` amount, multiplied by the iteration counter. Default 0.
             * @param stepY This is added to the `y` amount, multiplied by the iteration counter. Default 0.
             */
            incXY(x: number, y?: number, stepX?: number, stepY?: number): this;

            /**
             * Iterate through the group members changing the position of each element to be that of the element that came before
             * it in the array (or after it if direction = 1)
             * 
             * The first group member position is set to x/y.
             * @param x The x coordinate to place the first item in the array at.
             * @param y The y coordinate to place the first item in the array at.
             * @param direction The iteration direction. 0 = first to last and 1 = last to first. Default 0.
             */
            shiftPosition(x: number, y: number, direction?: number): this;

            /**
             * Sets the angle of each group member.
             * @param value The amount to set the angle to, in degrees.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            angle(value: number, step?: number): this;

            /**
             * Sets the rotation of each group member.
             * @param value The amount to set the rotation to, in radians.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            rotate(value: number, step?: number): this;

            /**
             * Rotates each group member around the given point by the given angle.
             * @param point Any object with public `x` and `y` properties.
             * @param angle The angle to rotate by, in radians.
             */
            rotateAround(point: Phaser.Types.Math.Vector2Like, angle: number): this;

            /**
             * Rotates each group member around the given point by the given angle and distance.
             * @param point Any object with public `x` and `y` properties.
             * @param angle The angle to rotate by, in radians.
             * @param distance The distance from the point of rotation in pixels.
             */
            rotateAroundDistance(point: Phaser.Types.Math.Vector2Like, angle: number, distance: number): this;

            /**
             * Sets the alpha of each group member.
             * @param value The amount to set the alpha to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            setAlpha(value: number, step?: number): this;

            /**
             * Sets the tint of each group member.
             * @param topLeft The tint being applied to top-left corner of item. If other parameters are given no value, this tint will be applied to whole item.
             * @param topRight The tint to be applied to top-right corner of item.
             * @param bottomLeft The tint to be applied to the bottom-left corner of item.
             * @param bottomRight The tint to be applied to the bottom-right corner of item.
             */
            setTint(topLeft: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets the originX, originY of each group member.
             * @param originX The amount to set the `originX` property to.
             * @param originY The amount to set the `originY` property to. If `undefined` or `null` it uses the `originX` value.
             * @param stepX This is added to the `originX` amount, multiplied by the iteration counter. Default 0.
             * @param stepY This is added to the `originY` amount, multiplied by the iteration counter. Default 0.
             */
            setOrigin(originX: number, originY?: number, stepX?: number, stepY?: number): this;

            /**
             * Sets the scaleX of each group member.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            scaleX(value: number, step?: number): this;

            /**
             * Sets the scaleY of each group member.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            scaleY(value: number, step?: number): this;

            /**
             * Sets the scaleX, scaleY of each group member.
             * @param scaleX The amount to be added to the `scaleX` property.
             * @param scaleY The amount to be added to the `scaleY` property. If `undefined` or `null` it uses the `scaleX` value.
             * @param stepX This is added to the `scaleX` amount, multiplied by the iteration counter. Default 0.
             * @param stepY This is added to the `scaleY` amount, multiplied by the iteration counter. Default 0.
             */
            scaleXY(scaleX: number, scaleY?: number, stepX?: number, stepY?: number): this;

            /**
             * Sets the depth of each group member.
             * @param value The amount to set the property to.
             * @param step This is added to the `value` amount, multiplied by the iteration counter. Default 0.
             */
            setDepth(value: number, step?: number): this;

            /**
             * Sets the blendMode of each group member.
             * @param value The amount to set the property to.
             */
            setBlendMode(value: number): this;

            /**
             * Passes all group members to the Input Manager to enable them for input with identical areas and callbacks.
             * @param hitArea Either an input configuration object, or a geometric shape that defines the hit area for the Game Object. If not specified a Rectangle will be used.
             * @param hitAreaCallback A callback to be invoked when the Game Object is interacted with. If you provide a shape you must also provide a callback.
             */
            setHitArea(hitArea: any, hitAreaCallback: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Shuffles the group members in place.
             */
            shuffle(): this;

            /**
             * Deactivates a member of this group.
             * @param gameObject A member of this group.
             */
            kill(gameObject: Phaser.GameObjects.GameObject): void;

            /**
             * Deactivates and hides a member of this group.
             * @param gameObject A member of this group.
             */
            killAndHide(gameObject: Phaser.GameObjects.GameObject): void;

            /**
             * Sets the visible of each group member.
             * @param value The value to set the property to.
             * @param index An optional offset to start searching from within the items array. Default 0.
             * @param direction The direction to iterate through the array. 1 is from beginning to end, -1 from end to beginning. Default 1.
             */
            setVisible(value: boolean, index?: number, direction?: number): this;

            /**
             * Toggles (flips) the visible state of each member of this group.
             */
            toggleVisible(): this;

            /**
             * Empties this Group of all children and removes it from the Scene.
             * 
             * Does not call {@link Phaser.GameObjects.Group#removeCallback}.
             * 
             * Children of this Group will _not_ be removed from the Scene by calling this method
             * unless you specify the `removeFromScene` parameter.
             * 
             * Children of this Group will also _not_ be destroyed by calling this method
             * unless you specify the `destroyChildren` parameter.
             * @param destroyChildren Also {@link Phaser.GameObjects.GameObject#destroy} each Group member. Default false.
             * @param removeFromScene Optionally remove each Group member from the Scene. Default false.
             */
            destroy(destroyChildren?: boolean, removeFromScene?: boolean): void;

        }

        /**
         * An Image Game Object.
         * 
         * An Image is a light-weight Game Object useful for the display of static images in your game,
         * such as logos, backgrounds, scenery or other non-animated elements. Images can have input
         * events and physics bodies, or be tweened, tinted or scrolled. The main difference between an
         * Image and a Sprite is that you cannot animate an Image as they do not have the Animation component.
         */
        class Image extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.TextureCrop, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number);

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Layer Game Object.
         * 
         * A Layer is a special type of Game Object that acts as a Display List. You can add any type of Game Object
         * to a Layer, just as you would to a Scene. Layers can be used to visually group together 'layers' of Game
         * Objects:
         * 
         * ```javascript
         * const spaceman = this.add.sprite(150, 300, 'spaceman');
         * const bunny = this.add.sprite(400, 300, 'bunny');
         * const elephant = this.add.sprite(650, 300, 'elephant');
         * 
         * const layer = this.add.layer();
         * 
         * layer.add([ spaceman, bunny, elephant ]);
         * ```
         * 
         * The 3 sprites in the example above will now be managed by the Layer they were added to. Therefore,
         * if you then set `layer.setVisible(false)` they would all vanish from the display.
         * 
         * You can also control the depth of the Game Objects within the Layer. For example, calling the
         * `setDepth` method of a child of a Layer will allow you to adjust the depth of that child _within the
         * Layer itself_, rather than the whole Scene. The Layer, too, can have its depth set as well.
         * 
         * The Layer class also offers many different methods for manipulating the list, such as the
         * methods `moveUp`, `moveDown`, `sendToBack`, `bringToTop` and so on. These allow you to change the
         * display list position of the Layers children, causing it to adjust the order in which they are
         * rendered. Using `setDepth` on a child allows you to override this.
         * 
         * Layers can have Post FX Pipelines set, which allows you to easily enable a post pipeline across
         * a whole range of children, which, depending on the effect, can often be far more efficient that doing so
         * on a per-child basis.
         * 
         * Layers have no position or size within the Scene. This means you cannot enable a Layer for
         * physics or input, or change the position, rotation or scale of a Layer. They also have no scroll
         * factor, texture, tint, origin, crop or bounds.
         * 
         * If you need those kind of features then you should use a Container instead. Containers can be added
         * to Layers, but Layers cannot be added to Containers.
         * 
         * However, you can set the Alpha, Blend Mode, Depth, Mask and Visible state of a Layer. These settings
         * will impact all children being rendered by the Layer.
         */
        class Layer extends Phaser.Structs.List<Phaser.GameObjects.GameObject> implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param children An optional array of Game Objects to add to this Layer.
             */
            constructor(scene: Phaser.Scene, children?: Phaser.GameObjects.GameObject[]);

            /**
             * A reference to the Scene to which this Game Object belongs.
             * 
             * Game Objects can only belong to one Scene.
             * 
             * You should consider this property as being read-only. You cannot move a
             * Game Object to another Scene by simply changing it.
             */
            scene: Phaser.Scene;

            /**
             * Holds a reference to the Display List that contains this Game Object.
             * 
             * This is set automatically when this Game Object is added to a Scene or Layer.
             * 
             * You should treat this property as being read-only.
             */
            displayList: Phaser.GameObjects.DisplayList | Phaser.GameObjects.Layer;

            /**
             * A textual representation of this Game Object, i.e. `sprite`.
             * Used internally by Phaser but is available for your own custom classes to populate.
             */
            type: string;

            /**
             * The current state of this Game Object.
             * 
             * Phaser itself will never modify this value, although plugins may do so.
             * 
             * Use this property to track the state of a Game Object during its lifetime. For example, it could change from
             * a state of 'moving', to 'attacking', to 'dead'. The state value should be an integer (ideally mapped to a constant
             * in your game code), or a string. These are recommended to keep it light and simple, with fast comparisons.
             * If you need to store complex data about your Game Object, look at using the Data Component instead.
             */
            state: number | string;

            /**
             * A Layer cannot be placed inside a Container.
             * 
             * This property is kept purely so a Layer has the same
             * shape as a Game Object.
             */
            parentContainer: Phaser.GameObjects.Container;

            /**
             * The name of this Game Object.
             * Empty by default and never populated by Phaser, this is left for developers to use.
             */
            name: string;

            /**
             * The active state of this Game Object.
             * A Game Object with an active state of `true` is processed by the Scenes UpdateList, if added to it.
             * An active object is one which is having its logic and internal systems updated.
             */
            active: boolean;

            /**
             * The Tab Index of the Game Object.
             * Reserved for future use by plugins and the Input Manager.
             */
            tabIndex: number;

            /**
             * A Data Manager.
             * It allows you to store, query and get key/value paired information specific to this Game Object.
             * `null` by default. Automatically created if you use `getData` or `setData` or `setDataEnabled`.
             */
            data: Phaser.Data.DataManager;

            /**
             * The flags that are compared against `RENDER_MASK` to determine if this Game Object will render or not.
             * The bits are 0001 | 0010 | 0100 | 1000 set by the components Visible, Alpha, Transform and Texture respectively.
             * If those components are not used by your custom class then you can use this bitmask as you wish.
             */
            renderFlags: number;

            /**
             * A bitmask that controls if this Game Object is drawn by a Camera or not.
             * Not usually set directly, instead call `Camera.ignore`, however you can
             * set this property directly using the Camera.id property:
             */
            cameraFilter: number;

            /**
             * This property is kept purely so a Layer has the same
             * shape as a Game Object. You cannot input enable a Layer.
             */
            input: Phaser.Types.Input.InteractiveObject | null;

            /**
             * This property is kept purely so a Layer has the same
             * shape as a Game Object. You cannot give a Layer a physics body.
             */
            body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody | MatterJS.BodyType | null;

            /**
             * This Game Object will ignore all calls made to its destroy method if this flag is set to `true`.
             * This includes calls that may come from a Group, Container or the Scene itself.
             * While it allows you to persist a Game Object across Scenes, please understand you are entirely
             * responsible for managing references to and from this Game Object.
             */
            ignoreDestroy: boolean;

            /**
             * A reference to the Scene Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * A reference to the Scene Event Emitter.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * The flag the determines whether Game Objects should be sorted when `depthSort()` is called.
             */
            sortChildrenFlag: boolean;

            /**
             * Sets the `active` property of this Game Object and returns this Game Object for further chaining.
             * A Game Object with its `active` property set to `true` will be updated by the Scenes UpdateList.
             * @param value True if this Game Object should be set as active, false if not.
             */
            setActive(value: boolean): this;

            /**
             * Sets the `name` property of this Game Object and returns this Game Object for further chaining.
             * The `name` property is not populated by Phaser and is presented for your own use.
             * @param value The name to be given to this Game Object.
             */
            setName(value: string): this;

            /**
             * Sets the current state of this Game Object.
             * 
             * Phaser itself will never modify the State of a Game Object, although plugins may do so.
             * 
             * For example, a Game Object could change from a state of 'moving', to 'attacking', to 'dead'.
             * The state value should typically be an integer (ideally mapped to a constant
             * in your game code), but could also be a string. It is recommended to keep it light and simple.
             * If you need to store complex data about your Game Object, look at using the Data Component instead.
             * @param value The state of the Game Object.
             */
            setState(value: number | string): this;

            /**
             * Adds a Data Manager component to this Game Object.
             */
            setDataEnabled(): this;

            /**
             * Allows you to store a key value pair within this Game Objects Data Manager.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * ```javascript
             * sprite.setData('name', 'Red Gem Stone');
             * ```
             * 
             * You can also pass in an object of key value pairs as the first argument:
             * 
             * ```javascript
             * sprite.setData({ name: 'Red Gem Stone', level: 2, owner: 'Link', gold: 50 });
             * ```
             * 
             * To get a value back again you can call `getData`:
             * 
             * ```javascript
             * sprite.getData('gold');
             * ```
             * 
             * Or you can access the value directly via the `values` property, where it works like any other variable:
             * 
             * ```javascript
             * sprite.data.values.gold += 50;
             * ```
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * 
             * If the key already exists, a `changedata` event is emitted instead, along an event named after the key.
             * For example, if you updated an existing key called `PlayerLives` then it would emit the event `changedata-PlayerLives`.
             * These events will be emitted regardless if you use this method to set the value, or the direct `values` setter.
             * 
             * Please note that the data keys are case-sensitive and must be valid JavaScript Object property strings.
             * This means the keys `gold` and `Gold` are treated as two unique values within the Data Manager.
             * @param key The key to set the value for. Or an object of key value pairs. If an object the `data` argument is ignored.
             * @param data The value to set for the given key. If an object is provided as the key this argument is ignored.
             */
            setData(key: string | object, data?: any): this;

            /**
             * Increase a value for the given key within this Game Objects Data Manager. If the key doesn't already exist in the Data Manager then it is increased from 0.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * @param key The key to increase the value for.
             * @param data The value to increase for the given key.
             */
            incData(key: string | object, data?: any): this;

            /**
             * Toggle a boolean value for the given key within this Game Objects Data Manager. If the key doesn't already exist in the Data Manager then it is toggled from false.
             * 
             * If the Game Object has not been enabled for data (via `setDataEnabled`) then it will be enabled
             * before setting the value.
             * 
             * If the key doesn't already exist in the Data Manager then it is created.
             * 
             * When the value is first set, a `setdata` event is emitted from this Game Object.
             * @param key The key to toggle the value for.
             */
            toggleData(key: string | object): this;

            /**
             * Retrieves the value for the given key in this Game Objects Data Manager, or undefined if it doesn't exist.
             * 
             * You can also access values via the `values` object. For example, if you had a key called `gold` you can do either:
             * 
             * ```javascript
             * sprite.getData('gold');
             * ```
             * 
             * Or access the value directly:
             * 
             * ```javascript
             * sprite.data.values.gold;
             * ```
             * 
             * You can also pass in an array of keys, in which case an array of values will be returned:
             * 
             * ```javascript
             * sprite.getData([ 'gold', 'armor', 'health' ]);
             * ```
             * 
             * This approach is useful for destructuring arrays in ES6.
             * @param key The key of the value to retrieve, or an array of keys.
             */
            getData(key: string | string[]): any;

            /**
             * A Layer cannot be enabled for input.
             * 
             * This method does nothing and is kept to ensure
             * the Layer has the same shape as a Game Object.
             */
            setInteractive(): this;

            /**
             * A Layer cannot be enabled for input.
             * 
             * This method does nothing and is kept to ensure
             * the Layer has the same shape as a Game Object.
             */
            disableInteractive(): this;

            /**
             * A Layer cannot be enabled for input.
             * 
             * This method does nothing and is kept to ensure
             * the Layer has the same shape as a Game Object.
             */
            removeInteractive(): this;

            /**
             * Adds the given Game Object, or array of Game Objects, to this Layer.
             * 
             * Each Game Object must be unique within the Layer.
             * @param child The Game Object, or array of Game Objects, to add to the Layer.
             */
            add<T extends Phaser.GameObjects.GameObject>(child: (T|T[])): this;

            /**
             * Removes the given Game Object, or array of Game Objects, from this Layer.
             * 
             * The Game Objects must already be children of this Layer.
             * 
             * You can also optionally call `destroy` on each Game Object that is removed from the Layer.
             * @param child The Game Object, or array of Game Objects, to be removed from the Layer.
             * @param destroyChild Optionally call `destroy` on each child successfully removed from this Layer. Default false.
             */
            remove<T extends Phaser.GameObjects.GameObject>(child: (T|T[]), destroyChild?: boolean): this;

            /**
             * Removes all Game Objects from this Layer.
             * 
             * You can also optionally call `destroy` on each Game Object that is removed from the Layer.
             * @param destroyChild Optionally call `destroy` on each Game Object successfully removed from this Layer. Default false.
             */
            removeAll(destroyChild?: boolean): this;

            /**
             * This callback is invoked when this Game Object is added to a Scene.
             * 
             * Can be overriden by custom Game Objects, but be aware of some Game Objects that
             * will use this, such as Sprites, to add themselves into the Update List.
             * 
             * You can also listen for the `ADDED_TO_SCENE` event from this Game Object.
             */
            addedToScene(): void;

            /**
             * This callback is invoked when this Game Object is removed from a Scene.
             * 
             * Can be overriden by custom Game Objects, but be aware of some Game Objects that
             * will use this, such as Sprites, to removed themselves from the Update List.
             * 
             * You can also listen for the `REMOVED_FROM_SCENE` event from this Game Object.
             */
            removedFromScene(): void;

            /**
             * To be overridden by custom GameObjects. Allows base objects to be used in a Pool.
             * @param args args
             */
            update(...args: any[]): void;

            /**
             * Returns a JSON representation of the Game Object.
             */
            toJSON(): Phaser.Types.GameObjects.JSONGameObject;

            /**
             * Compares the renderMask with the renderFlags to see if this Game Object will render or not.
             * Also checks the Game Object against the given Cameras exclusion list.
             * @param camera The Camera to check against this Game Object.
             */
            willRender(camera: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Returns an array containing the display list index of either this Game Object, or if it has one,
             * its parent Container. It then iterates up through all of the parent containers until it hits the
             * root of the display list (which is index 0 in the returned array).
             * 
             * Used internally by the InputPlugin but also useful if you wish to find out the display depth of
             * this Game Object and all of its ancestors.
             */
            getIndexList(): number[];

            /**
             * Force a sort of the display list on the next call to depthSort.
             */
            queueDepthSort(): void;

            /**
             * Immediately sorts the display list if the flag is set.
             */
            depthSort(): void;

            /**
             * Compare the depth of two Game Objects.
             * @param childA The first Game Object.
             * @param childB The second Game Object.
             */
            sortByDepth(childA: Phaser.GameObjects.GameObject, childB: Phaser.GameObjects.GameObject): number;

            /**
             * Returns an array which contains all Game Objects within this Layer.
             * 
             * This is a reference to the main list array, not a copy of it, so be careful not to modify it.
             */
            getChildren(): Phaser.GameObjects.GameObject[];

            /**
             * Adds this Layer to the given Display List.
             * 
             * If no Display List is specified, it will default to the Display List owned by the Scene to which
             * this Layer belongs.
             * 
             * A Layer can only exist on one Display List at any given time, but may move freely between them.
             * 
             * If this Layer is already on another Display List when this method is called, it will first
             * be removed from it, before being added to the new list.
             * 
             * You can query which list it is on by looking at the `Phaser.GameObjects.Layer#displayList` property.
             * 
             * If a Layer isn't on any display list, it will not be rendered. If you just wish to temporarily
             * disable it from rendering, consider using the `setVisible` method, instead.
             * @param displayList The Display List to add to. Defaults to the Scene Display List.
             */
            addToDisplayList(displayList?: Phaser.GameObjects.DisplayList | Phaser.GameObjects.Layer): this;

            /**
             * Removes this Layer from the Display List it is currently on.
             * 
             * A Layer can only exist on one Display List at any given time, but may move freely removed
             * and added back at a later stage.
             * 
             * You can query which list it is on by looking at the `Phaser.GameObjects.GameObject#displayList` property.
             * 
             * If a Layer isn't on any Display List, it will not be rendered. If you just wish to temporarily
             * disable it from rendering, consider using the `setVisible` method, instead.
             */
            removeFromDisplayList(): this;

            /**
             * Destroys this Layer removing it from the Display List and Update List and
             * severing all ties to parent resources.
             * 
             * Also destroys all children of this Layer. If you do not wish for the
             * children to be destroyed, you should move them from this Layer first.
             * 
             * Use this to remove this Layer from your game if you don't ever plan to use it again.
             * As long as no reference to it exists within your own code it should become free for
             * garbage collection by the browser.
             * 
             * If you just want to temporarily disable an object then look at using the
             * Game Object Pool instead of destroying it, as destroyed objects cannot be resurrected.
             * @param fromScene `True` if this Game Object is being destroyed by the Scene, `false` if not. Default false.
             */
            destroy(fromScene?: boolean): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A 2D point light.
         * 
         * These are typically created by a {@link Phaser.GameObjects.LightsManager}, available from within a scene via `this.lights`.
         * 
         * Any Game Objects using the Light2D pipeline will then be affected by these Lights as long as they have a normal map.
         * 
         * They can also simply be used to represent a point light for your own purposes.
         * 
         * As of Phaser 3.60 this Game Object now has the Transform and Origin components. However, changing the scale,
         * rotation or origin properties will not make any difference to the Light. They are simply present to allow you
         * to add this Light to a Container, or enable it for Physics.
         */
        class Light extends Phaser.Geom.Circle implements Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param x The horizontal position of the light.
             * @param y The vertical position of the light.
             * @param radius The radius of the light.
             * @param r The red color of the light. A value between 0 and 1.
             * @param g The green color of the light. A value between 0 and 1.
             * @param b The blue color of the light. A value between 0 and 1.
             * @param intensity The intensity of the light.
             */
            constructor(x: number, y: number, radius: number, r: number, g: number, b: number, intensity: number);

            /**
             * The color of the light.
             */
            color: Phaser.Display.RGB;

            /**
             * The intensity of the light.
             */
            intensity: number;

            /**
             * The flags that are compared against `RENDER_MASK` to determine if this Game Object will render or not.
             * The bits are 0001 | 0010 | 0100 | 1000 set by the components Visible, Alpha, Transform and Texture respectively.
             * If those components are not used by your custom class then you can use this bitmask as you wish.
             */
            renderFlags: number;

            /**
             * A bitmask that controls if this Game Object is drawn by a Camera or not.
             * Not usually set directly, instead call `Camera.ignore`, however you can
             * set this property directly using the Camera.id property:
             */
            cameraFilter: number;

            /**
             * The width of this Light Game Object. This is the same as `Light.diameter`.
             */
            displayWidth: number;

            /**
             * The height of this Light Game Object. This is the same as `Light.diameter`.
             */
            displayHeight: number;

            /**
             * The width of this Light Game Object. This is the same as `Light.diameter`.
             */
            width: number;

            /**
             * The height of this Light Game Object. This is the same as `Light.diameter`.
             */
            height: number;

            /**
             * Compares the renderMask with the renderFlags to see if this Game Object will render or not.
             * Also checks the Game Object against the given Cameras exclusion list.
             * @param camera The Camera to check against this Game Object.
             */
            willRender(camera: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Set the color of the light from a single integer RGB value.
             * @param rgb The integer RGB color of the light.
             */
            setColor(rgb: number): this;

            /**
             * Set the intensity of the light.
             * @param intensity The intensity of the light.
             */
            setIntensity(intensity: number): this;

            /**
             * Set the radius of the light.
             * @param radius The radius of the light.
             */
            setRadius(radius: number): this;

            /**
             * The bitmask that `GameObject.renderFlags` is compared against to determine if the Game Object will render or not.
             */
            static readonly RENDER_MASK: number;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * Manages Lights for a Scene.
         * 
         * Affects the rendering of Game Objects using the `Light2D` pipeline.
         */
        class LightsManager {
            /**
             * The Lights in the Scene.
             */
            lights: Phaser.GameObjects.Light[];

            /**
             * The ambient color.
             */
            ambientColor: Phaser.Display.RGB;

            /**
             * Whether the Lights Manager is enabled.
             */
            active: boolean;

            /**
             * The maximum number of lights that a single Camera and the lights shader can process.
             * Change this via the `maxLights` property in your game config, as it cannot be changed at runtime.
             */
            readonly maxLights: number;

            /**
             * The number of lights that the LightPipeline processed in the _previous_ frame.
             */
            readonly visibleLights: number;

            /**
             * Creates a new Point Light Game Object and adds it to the Scene.
             * 
             * Note: This method will only be available if the Point Light Game Object has been built into Phaser.
             * 
             * The Point Light Game Object provides a way to add a point light effect into your game,
             * without the expensive shader processing requirements of the traditional Light Game Object.
             * 
             * The difference is that the Point Light renders using a custom shader, designed to give the
             * impression of a point light source, of variable radius, intensity and color, in your game.
             * However, unlike the Light Game Object, it does not impact any other Game Objects, or use their
             * normal maps for calcuations. This makes them extremely fast to render compared to Lights
             * and perfect for special effects, such as flickering torches or muzzle flashes.
             * 
             * For maximum performance you should batch Point Light Game Objects together. This means
             * ensuring they follow each other consecutively on the display list. Ideally, use a Layer
             * Game Object and then add just Point Lights to it, so that it can batch together the rendering
             * of the lights. You don't _have_ to do this, and if you've only a handful of Point Lights in
             * your game then it's perfectly safe to mix them into the dislay list as normal. However, if
             * you're using a large number of them, please consider how they are mixed into the display list.
             * 
             * The renderer will automatically cull Point Lights. Those with a radius that does not intersect
             * with the Camera will be skipped in the rendering list. This happens automatically and the
             * culled state is refreshed every frame, for every camera.
             * 
             * The origin of a Point Light is always 0.5 and it cannot be changed.
             * 
             * Point Lights are a WebGL only feature and do not have a Canvas counterpart.
             * @param x The horizontal position of this Point Light in the world.
             * @param y The vertical position of this Point Light in the world.
             * @param color The color of the Point Light, given as a hex value. Default 0xffffff.
             * @param radius The radius of the Point Light. Default 128.
             * @param intensity The intensity, or color blend, of the Point Light. Default 1.
             * @param attenuation The attenuation  of the Point Light. This is the reduction of light from the center point. Default 0.1.
             */
            addPointLight(x: number, y: number, color?: number, radius?: number, intensity?: number, attenuation?: number): Phaser.GameObjects.PointLight;

            /**
             * Enable the Lights Manager.
             */
            enable(): this;

            /**
             * Disable the Lights Manager.
             */
            disable(): this;

            /**
             * Get all lights that can be seen by the given Camera.
             * 
             * It will automatically cull lights that are outside the world view of the Camera.
             * 
             * If more lights are returned than supported by the pipeline, the lights are then culled
             * based on the distance from the center of the camera. Only those closest are rendered.
             * @param camera The Camera to cull Lights for.
             */
            getLights(camera: Phaser.Cameras.Scene2D.Camera): Phaser.GameObjects.Light[];

            /**
             * Set the ambient light color.
             * @param rgb The integer RGB color of the ambient light.
             */
            setAmbientColor(rgb: number): this;

            /**
             * Returns the maximum number of Lights allowed to appear at once.
             */
            getMaxVisibleLights(): number;

            /**
             * Get the number of Lights managed by this Lights Manager.
             */
            getLightCount(): number;

            /**
             * Add a Light.
             * @param x The horizontal position of the Light. Default 0.
             * @param y The vertical position of the Light. Default 0.
             * @param radius The radius of the Light. Default 128.
             * @param rgb The integer RGB color of the light. Default 0xffffff.
             * @param intensity The intensity of the Light. Default 1.
             */
            addLight(x?: number, y?: number, radius?: number, rgb?: number, intensity?: number): Phaser.GameObjects.Light;

            /**
             * Remove a Light.
             * @param light The Light to remove.
             */
            removeLight(light: Phaser.GameObjects.Light): this;

            /**
             * Shut down the Lights Manager.
             * 
             * Recycles all active Lights into the Light pool, resets ambient light color and clears the lists of Lights and
             * culled Lights.
             */
            shutdown(): void;

            /**
             * Destroy the Lights Manager.
             * 
             * Cleans up all references by calling {@link Phaser.GameObjects.LightsManager#shutdown}.
             */
            destroy(): void;

        }

        /**
         * A Scene plugin that provides a {@link Phaser.GameObjects.LightsManager} for the Light2D pipeline.
         * 
         * Available from within a Scene via `this.lights`.
         * 
         * Add Lights using the {@link Phaser.GameObjects.LightsManager#addLight} method:
         * 
         * ```javascript
         * // Enable the Lights Manager because it is disabled by default
         * this.lights.enable();
         * 
         * // Create a Light at [400, 300] with a radius of 200
         * this.lights.addLight(400, 300, 200);
         * ```
         * 
         * For Game Objects to be affected by the Lights when rendered, you will need to set them to use the `Light2D` pipeline like so:
         * 
         * ```javascript
         * sprite.setPipeline('Light2D');
         * ```
         * 
         * Note that you cannot use this pipeline on Graphics Game Objects or Shape Game Objects.
         */
        class LightsPlugin extends Phaser.GameObjects.LightsManager {
            /**
             * 
             * @param scene The Scene that this Lights Plugin belongs to.
             */
            constructor(scene: Phaser.Scene);

            /**
             * A reference to the Scene that this Lights Plugin belongs to.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Scene's systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * Boot the Lights Plugin.
             */
            boot(): void;

            /**
             * Destroy the Lights Plugin.
             * 
             * Cleans up all references.
             */
            destroy(): void;

        }

        /**
         * A Mesh Game Object.
         * 
         * The Mesh Game Object allows you to render a group of textured vertices and manipulate
         * the view of those vertices, such as rotation, translation or scaling.
         * 
         * Support for generating mesh data from grids, model data or Wavefront OBJ Files is included.
         * 
         * Although you can use this to render 3D objects, its primary use is for displaying more complex
         * Sprites, or Sprites where you need fine-grained control over the vertex positions in order to
         * achieve special effects in your games. Note that rendering still takes place using Phaser's
         * orthographic camera (after being transformed via `projectionMesh`, see `setPerspective`,
         * `setOrtho`, and `panZ` methods). As a result, all depth and face tests are done in an eventually
         * orthographic space.
         * 
         * The rendering process will iterate through the faces of this Mesh and render out each face
         * that is considered as being in view of the camera. No depth buffer is used, and because of this,
         * you should be careful not to use model data with too many vertices, or overlapping geometry,
         * or you'll probably encounter z-depth fighting. The Mesh was designed to allow for more advanced
         * 2D layouts, rather than displaying 3D objects, even though it can do this to a degree.
         * 
         * In short, if you want to remake Crysis, use a 3D engine, not a Mesh. However, if you want
         * to easily add some small fun 3D elements into your game, or create some special effects involving
         * vertex warping, this is the right object for you. Mesh data becomes part of the WebGL batch,
         * just like standard Sprites, so doesn't introduce any additional shader overhead. Because
         * the Mesh just generates vertices into the WebGL batch, like any other Sprite, you can use all of
         * the common Game Object components on a Mesh too, such as a custom pipeline, mask, blend mode
         * or texture.
         * 
         * Note that the Mesh object is WebGL only and does not have a Canvas counterpart.
         * 
         * The Mesh origin is always 0.5 x 0.5 and cannot be changed.
         */
        class Mesh extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param vertices The vertices array. Either `xy` pairs, or `xyz` if the `containsZ` parameter is `true` (but see note).
             * @param uvs The UVs pairs array.
             * @param indicies Optional vertex indicies array. If you don't have one, pass `null` or an empty array.
             * @param containsZ Does the vertices data include a `z` component? Note: If not, it will be assumed `z=0`, see method `panZ` or `setOrtho`. Default false.
             * @param normals Optional vertex normals array. If you don't have one, pass `null` or an empty array.
             * @param colors An array of colors, one per vertex, or a single color value applied to all vertices. Default 0xffffff.
             * @param alphas An array of alpha values, one per vertex, or a single alpha value applied to all vertices. Default 1.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number, vertices?: number[], uvs?: number[], indicies?: number[], containsZ?: boolean, normals?: number[], colors?: number | number[], alphas?: number | number[]);

            /**
             * An array containing the Face instances belonging to this Mesh.
             * 
             * A Face consists of 3 Vertex objects.
             * 
             * This array is populated during calls such as `addVertices` or `addOBJ`.
             */
            faces: Phaser.Geom.Mesh.Face[];

            /**
             * An array containing Vertex instances. One instance per vertex in this Mesh.
             * 
             * This array is populated during calls such as `addVertex` or `addOBJ`.
             */
            vertices: Phaser.Geom.Mesh.Vertex[];

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertex colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * You can optionally choose to render the vertices of this Mesh to a Graphics instance.
             * 
             * Achieve this by setting the `debugCallback` and the `debugGraphic` properties.
             * 
             * You can do this in a single call via the `Mesh.setDebug` method, which will use the
             * built-in debug function. You can also set it to your own callback. The callback
             * will be invoked _once per render_ and sent the following parameters:
             * 
             * `debugCallback(src, meshLength, verts)`
             * 
             * `src` is the Mesh instance being debugged.
             * `meshLength` is the number of mesh vertices in total.
             * `verts` is an array of the translated vertex coordinates.
             * 
             * To disable rendering, set this property back to `null`.
             * 
             * Please note that high vertex count Meshes will struggle to debug properly.
             */
            debugCallback: Function;

            /**
             * The Graphics instance that the debug vertices will be drawn to, if `setDebug` has
             * been called.
             */
            debugGraphic: Phaser.GameObjects.Graphics;

            /**
             * When rendering, skip any Face that isn't counter clockwise?
             * 
             * Enable this to hide backward-facing Faces during rendering.
             * 
             * Disable it to render all Faces.
             */
            hideCCW: boolean;

            /**
             * A Vector3 containing the 3D position of the vertices in this Mesh.
             * 
             * Modifying the components of this property will allow you to reposition where
             * the vertices are rendered within the Mesh. This happens in the `preUpdate` phase,
             * where each vertex is transformed using the view and projection matrices.
             * 
             * Changing this property will impact all vertices being rendered by this Mesh.
             * 
             * You can also adjust the 'view' by using the `pan` methods.
             */
            modelPosition: Phaser.Math.Vector3;

            /**
             * A Vector3 containing the 3D scale of the vertices in this Mesh.
             * 
             * Modifying the components of this property will allow you to scale
             * the vertices within the Mesh. This happens in the `preUpdate` phase,
             * where each vertex is transformed using the view and projection matrices.
             * 
             * Changing this property will impact all vertices being rendered by this Mesh.
             */
            modelScale: Phaser.Math.Vector3;

            /**
             * A Vector3 containing the 3D rotation of the vertices in this Mesh.
             * 
             * The values should be given in radians, i.e. to rotate the vertices by 90
             * degrees you can use `modelRotation.x = Phaser.Math.DegToRad(90)`.
             * 
             * Modifying the components of this property will allow you to rotate
             * the vertices within the Mesh. This happens in the `preUpdate` phase,
             * where each vertex is transformed using the view and projection matrices.
             * 
             * Changing this property will impact all vertices being rendered by this Mesh.
             */
            modelRotation: Phaser.Math.Vector3;

            /**
             * The transformation matrix for this Mesh.
             */
            transformMatrix: Phaser.Math.Matrix4;

            /**
             * The view position for this Mesh.
             * 
             * Use the methods`panX`, `panY` and `panZ` to adjust the view.
             */
            viewPosition: Phaser.Math.Vector3;

            /**
             * The view matrix for this Mesh.
             */
            viewMatrix: Phaser.Math.Matrix4;

            /**
             * The projection matrix for this Mesh.
             * 
             * Update it with the `setPerspective` or `setOrtho` methods.
             */
            projectionMatrix: Phaser.Math.Matrix4;

            /**
             * How many faces were rendered by this Mesh Game Object in the last
             * draw? This is reset in the `preUpdate` method and then incremented
             * each time a face is drawn. Note that in multi-camera Scenes this
             * value may exceed that found in `Mesh.getFaceCount` due to
             * cameras drawing the same faces more than once.
             */
            readonly totalRendered: number;

            /**
             * By default, the Mesh will check to see if its model or view transform has
             * changed each frame and only recalculate the vertex positions if they have.
             * 
             * This avoids lots of additional math in the `preUpdate` step when not required.
             * 
             * However, if you are performing per-Face or per-Vertex manipulation on this Mesh,
             * such as tweening a Face, or moving it without moving the rest of the Mesh,
             * then you may need to disable the dirty cache in order for the Mesh to re-render
             * correctly. You can toggle this property to do that. Please note that leaving
             * this set to `true` will cause the Mesh to recalculate the position of every single
             * vertex in it, every single frame. So only really do this if you know you
             * need it.
             */
            ignoreDirtyCache: boolean;

            /**
             * The Camera fov (field of view) in degrees.
             * 
             * This is set automatically as part of the `Mesh.setPerspective` call, but exposed
             * here for additional math.
             * 
             * Do not modify this property directly, doing so will not change the fov. For that,
             * call the respective Mesh methods.
             */
            readonly fov: number;

            /**
             * Translates the view position of this Mesh on the x axis by the given amount.
             * @param v The amount to pan by.
             */
            panX(v: number): void;

            /**
             * Translates the view position of this Mesh on the y axis by the given amount.
             * @param v The amount to pan by.
             */
            panY(v: number): void;

            /**
             * Translates the view position of this Mesh on the z axis by the given amount.
             * 
             * As the default `panZ` value is 0, vertices with `z=0` (the default) need special
             * care or else they will not display as they are "behind" the camera.
             * 
             * Consider using `mesh.panZ(mesh.height / (2 * Math.tan(Math.PI / 16)))`,
             * which will interpret vertex geometry 1:1 with pixel geometry (or see `setOrtho`).
             * @param v The amount to pan by.
             */
            panZ(v: number): void;

            /**
             * Builds a new perspective projection matrix from the given values.
             * 
             * These are also the initial projection matrix and parameters for `Mesh` (see `Mesh.panZ` for more discussion).
             * 
             * See also `setOrtho`.
             * @param width The width of the projection matrix. Typically the same as the Mesh and/or Renderer.
             * @param height The height of the projection matrix. Typically the same as the Mesh and/or Renderer.
             * @param fov The field of view, in degrees. Default 45.
             * @param near The near value of the view. Default 0.01.
             * @param far The far value of the view. Default 1000.
             */
            setPerspective(width: number, height: number, fov?: number, near?: number, far?: number): void;

            /**
             * Builds a new orthographic projection matrix from the given values.
             * 
             * If using this mode you will often need to set `Mesh.hideCCW` to `false` as well.
             * 
             * By default, calling this method with no parameters will set the scaleX value to
             * match the renderer's aspect ratio. If you would like to render vertex positions 1:1
             * to pixel positions, consider calling as `mesh.setOrtho(mesh.width, mesh.height)`.
             * 
             * See also `setPerspective`.
             * @param scaleX The default horizontal scale in relation to the Mesh / Renderer dimensions. Default 1.
             * @param scaleY The default vertical scale in relation to the Mesh / Renderer dimensions. Default 1.
             * @param near The near value of the view. Default -1000.
             * @param far The far value of the view. Default 1000.
             */
            setOrtho(scaleX?: number, scaleY?: number, near?: number, far?: number): void;

            /**
             * Iterates and destroys all current Faces in this Mesh, then resets the
             * `faces` and `vertices` arrays.
             */
            clear(): this;

            /**
             * This method will add the data from a triangulated Wavefront OBJ model file to this Mesh.
             * 
             * The data should have been loaded via the OBJFile:
             * 
             * ```javascript
             * this.load.obj(key, url);
             * ```
             * 
             * Then use the same `key` as the first parameter to this method.
             * 
             * Multiple Mesh Game Objects can use the same model data without impacting on each other.
             * 
             * Make sure your 3D package has triangulated the model data prior to exporting it.
             * 
             * You can add multiple models to a single Mesh, although they will act as one when
             * moved or rotated. You can scale the model data, should it be too small, or too large, to see.
             * You can also offset the vertices of the model via the `x`, `y` and `z` parameters.
             * @param key The key of the model data in the OBJ Cache to add to this Mesh.
             * @param scale An amount to scale the model data by. Use this if the model has exported too small, or large, to see. Default 1.
             * @param x Translate the model x position by this amount. Default 0.
             * @param y Translate the model y position by this amount. Default 0.
             * @param z Translate the model z position by this amount. Default 0.
             * @param rotateX Rotate the model on the x axis by this amount, in radians. Default 0.
             * @param rotateY Rotate the model on the y axis by this amount, in radians. Default 0.
             * @param rotateZ Rotate the model on the z axis by this amount, in radians. Default 0.
             * @param zIsUp Is the z axis up (true), or is y axis up (false)? Default true.
             */
            addVerticesFromObj(key: string, scale?: number, x?: number, y?: number, z?: number, rotateX?: number, rotateY?: number, rotateZ?: number, zIsUp?: boolean): this;

            /**
             * Compare the depth of two Faces.
             * @param faceA The first Face.
             * @param faceB The second Face.
             */
            sortByDepth(faceA: Phaser.Geom.Mesh.Face, faceB: Phaser.Geom.Mesh.Face): number;

            /**
             * Runs a depth sort across all Faces in this Mesh, comparing their averaged depth.
             * 
             * This is called automatically if you use any of the `rotate` methods, but you can
             * also invoke it to sort the Faces should you manually position them.
             */
            depthSort(): this;

            /**
             * Adds a new Vertex into the vertices array of this Mesh.
             * 
             * Just adding a vertex isn't enough to render it. You need to also
             * make it part of a Face, with 3 Vertex instances per Face.
             * @param x The x position of the vertex.
             * @param y The y position of the vertex.
             * @param z The z position of the vertex.
             * @param u The UV u coordinate of the vertex.
             * @param v The UV v coordinate of the vertex.
             * @param color The color value of the vertex. Default 0xffffff.
             * @param alpha The alpha value of the vertex. Default 1.
             */
            addVertex(x: number, y: number, z: number, u: number, v: number, color?: number, alpha?: number): this;

            /**
             * Adds a new Face into the faces array of this Mesh.
             * 
             * A Face consists of references to 3 Vertex instances, which must be provided.
             * @param vertex1 The first vertex of the Face.
             * @param vertex2 The second vertex of the Face.
             * @param vertex3 The third vertex of the Face.
             */
            addFace(vertex1: Phaser.Geom.Mesh.Vertex, vertex2: Phaser.Geom.Mesh.Vertex, vertex3: Phaser.Geom.Mesh.Vertex): this;

            /**
             * Adds new vertices to this Mesh by parsing the given data.
             * 
             * This method will take vertex data in one of two formats, based on the `containsZ` parameter.
             * 
             * If your vertex data are `x`, `y` pairs, then `containsZ` should be `false` (this is the default, and will result in `z=0` for each vertex).
             * 
             * If your vertex data is groups of `x`, `y` and `z` values, then the `containsZ` parameter must be true.
             * 
             * The `uvs` parameter is a numeric array consisting of `u` and `v` pairs.
             * 
             * The `normals` parameter is a numeric array consisting of `x`, `y` vertex normal values and, if `containsZ` is true, `z` values as well.
             * 
             * The `indicies` parameter is an optional array that, if given, is an indexed list of vertices to be added.
             * 
             * The `colors` parameter is an optional array, or single value, that if given sets the color of each vertex created.
             * 
             * The `alphas` parameter is an optional array, or single value, that if given sets the alpha of each vertex created.
             * 
             * When providing indexed data it is assumed that _all_ of the arrays are indexed, not just the vertices.
             * 
             * The following example will create a 256 x 256 sized quad using an index array:
             * 
             * ```javascript
             * let mesh = new Mesh(this);  // Assuming `this` is a scene!
             * const vertices = [
             *   -128, 128,
             *   128, 128,
             *   -128, -128,
             *   128, -128
             * ];
             * 
             * const uvs = [
             *   0, 1,
             *   1, 1,
             *   0, 0,
             *   1, 0
             * ];
             * 
             * const indices = [ 0, 2, 1, 2, 3, 1 ];
             * 
             * mesh.addVertices(vertices, uvs, indicies);
             * // Note: Otherwise the added points will be "behind" the camera! This value will project vertex `x` & `y` values 1:1 to pixel values.
             * mesh.hideCCW = false;
             * mesh.setOrtho(mesh.width, mesh.height);
             * ```
             * 
             * If the data is not indexed, it's assumed that the arrays all contain sequential data.
             * @param vertices The vertices array. Either `xy` pairs, or `xyz` if the `containsZ` parameter is `true`.
             * @param uvs The UVs pairs array.
             * @param indicies Optional vertex indicies array. If you don't have one, pass `null` or an empty array.
             * @param containsZ Does the vertices data include a `z` component? If not, it will be assumed `z=0`, see methods `panZ` or `setOrtho`. Default false.
             * @param normals Optional vertex normals array. If you don't have one, pass `null` or an empty array.
             * @param colors An array of colors, one per vertex, or a single color value applied to all vertices. Default 0xffffff.
             * @param alphas An array of alpha values, one per vertex, or a single alpha value applied to all vertices. Default 1.
             */
            addVertices(vertices: number[], uvs: number[], indicies?: number[], containsZ?: boolean, normals?: number[], colors?: number | number[], alphas?: number | number[]): this;

            /**
             * Returns the total number of Faces in this Mesh Game Object.
             */
            getFaceCount(): number;

            /**
             * Returns the total number of Vertices in this Mesh Game Object.
             */
            getVertexCount(): number;

            /**
             * Returns the Face at the given index in this Mesh Game Object.
             * @param index The index of the Face to get.
             */
            getFace(index: number): Phaser.Geom.Mesh.Face;

            /**
             * Tests to see if _any_ face in this Mesh intersects with the given coordinates.
             * 
             * The given position is translated through the matrix of this Mesh and the given Camera,
             * before being compared against the vertices.
             * @param x The x position to check against.
             * @param y The y position to check against.
             * @param camera The camera to pass the coordinates through. If not give, the default Scene Camera is used.
             */
            hasFaceAt(x: number, y: number, camera?: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Return an array of Face objects from this Mesh that intersect with the given coordinates.
             * 
             * The given position is translated through the matrix of this Mesh and the given Camera,
             * before being compared against the vertices.
             * 
             * If more than one Face intersects, they will all be returned in the array, but the array will
             * be depth sorted first, so the first element will always be that closest to the camera.
             * @param x The x position to check against.
             * @param y The y position to check against.
             * @param camera The camera to pass the coordinates through. If not give, the default Scene Camera is used.
             */
            getFaceAt(x: number, y: number, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Geom.Mesh.Face[];

            /**
             * This method enables rendering of the Mesh vertices to the given Graphics instance.
             * 
             * If you enable this feature, you **must** call `Graphics.clear()` in your Scene `update`,
             * otherwise the Graphics instance you provide to debug will fill-up with draw calls,
             * eventually crashing the browser. This is not done automatically to allow you to debug
             * draw multiple Mesh objects to a single Graphics instance.
             * 
             * The Mesh class has a built-in debug rendering callback `Mesh.renderDebug`, however
             * you can also provide your own callback to be used instead. Do this by setting the `callback` parameter.
             * 
             * The callback is invoked _once per render_ and sent the following parameters:
             * 
             * `callback(src, faces)`
             * 
             * `src` is the Mesh instance being debugged.
             * `faces` is an array of the Faces that were rendered.
             * 
             * You can get the final drawn vertex position from a Face object like this:
             * 
             * ```javascript
             * let face = faces[i];
             * 
             * let x0 = face.vertex1.tx;
             * let y0 = face.vertex1.ty;
             * let x1 = face.vertex2.tx;
             * let y1 = face.vertex2.ty;
             * let x2 = face.vertex3.tx;
             * let y2 = face.vertex3.ty;
             * 
             * graphic.strokeTriangle(x0, y0, x1, y1, x2, y2);
             * ```
             * 
             * If using your own callback you do not have to provide a Graphics instance to this method.
             * 
             * To disable debug rendering, to either your own callback or the built-in one, call this method
             * with no arguments.
             * @param graphic The Graphic instance to render to if using the built-in callback.
             * @param callback The callback to invoke during debug render. Leave as undefined to use the built-in callback.
             */
            setDebug(graphic?: Phaser.GameObjects.Graphics, callback?: Function): this;

            /**
             * Checks if the transformation data in this mesh is dirty.
             * 
             * This is used internally by the `preUpdate` step to determine if the vertices should
             * be recalculated or not.
             */
            isDirty(): boolean;

            /**
             * The Mesh update loop. The following takes place in this method:
             * 
             * First, the `totalRendered` and `totalFrame` properties are set.
             * 
             * If the view matrix of this Mesh isn't dirty, and the model position, rotate or scale properties are
             * all clean, then the method returns at this point.
             * 
             * Otherwise, if the viewPosition is dirty (i.e. from calling a method like `panZ`), then it will
             * refresh the viewMatrix.
             * 
             * After this, a new transformMatrix is built and it then iterates through all Faces in this
             * Mesh, calling `transformCoordinatesLocal` on all of them. Internally, this updates every
             * vertex, calculating its new transformed position, based on the new transform matrix.
             * 
             * Finally, the faces are depth sorted.
             * @param time The current timestamp.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            protected preUpdate(time: number, delta: number): void;

            /**
             * The built-in Mesh debug rendering method.
             * 
             * See `Mesh.setDebug` for more details.
             * @param src The Mesh object being rendered.
             * @param faces An array of Faces.
             */
            renderDebug(src: Phaser.GameObjects.Mesh, faces: Phaser.Geom.Mesh.Face[]): void;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff on all vertices,
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Pass this Mesh Game Object to the Input Manager to enable it for Input.
             * 
             * Unlike other Game Objects, the Mesh Game Object uses its own special hit area callback, which you cannot override.
             */
            setInteractive(): this;

            /**
             * Sets an additive tint on all vertices of this Mesh Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once.
             * 
             * To remove a tint call `clearTint`.
             * @param tint The tint being applied to all vertices of this Mesh Game Object. Default 0xffffff.
             */
            setTint(tint?: number): this;

            /**
             * Scrolls the UV texture coordinates of all faces in this Mesh by
             * adding the given x/y amounts to them.
             * 
             * If you only wish to scroll one coordinate, pass a value of zero
             * to the other.
             * 
             * Use small values for scrolling. UVs are set from the range 0
             * to 1, so you should increment (or decrement) them by suitably
             * small values, such as 0.01.
             * 
             * Due to a limitation in WebGL1 you can only UV scroll textures
             * that are a power-of-two in size. Scrolling NPOT textures will
             * work but will result in clamping the pixels to the edges.
             * 
             * Note that if this Mesh is using a _frame_ from a texture atlas
             * then you will be unable to UV scroll its texture.
             * @param x The amount to horizontally shift the UV coordinates by.
             * @param y The amount to vertically shift the UV coordinates by.
             */
            uvScroll(x: number, y: number): this;

            /**
             * Scales the UV texture coordinates of all faces in this Mesh by
             * the exact given amounts.
             * 
             * If you only wish to scale one coordinate, pass a value of one
             * to the other.
             * 
             * Due to a limitation in WebGL1 you can only UV scale textures
             * that are a power-of-two in size. Scaling NPOT textures will
             * work but will result in clamping the pixels to the edges if
             * you scale beyond a value of 1. Scaling below 1 will work
             * regardless of texture size.
             * 
             * Note that if this Mesh is using a _frame_ from a texture atlas
             * then you will be unable to UV scale its texture.
             * @param x The amount to horizontally scale the UV coordinates by.
             * @param y The amount to vertically scale the UV coordinates by.
             */
            uvScale(x: number, y: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * This property is a setter-only.
             */
            tint(): number;

            /**
             * The x rotation of the Model in 3D space, as specified in degrees.
             * 
             * If you need the value in radians use the `modelRotation.x` property directly.
             */
            rotateX(): number;

            /**
             * The y rotation of the Model in 3D space, as specified in degrees.
             * 
             * If you need the value in radians use the `modelRotation.y` property directly.
             */
            rotateY(): number;

            /**
             * The z rotation of the Model in 3D space, as specified in degrees.
             * 
             * If you need the value in radians use the `modelRotation.z` property directly.
             */
            rotateZ(): number;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Nine Slice Game Object allows you to display a texture-based object that
         * can be stretched both horizontally and vertically, but that retains
         * fixed-sized corners. The dimensions of the corners are set via the
         * parameters to this class.
         * 
         * This is extremely useful for UI and button like elements, where you need
         * them to expand to accommodate the content without distorting the texture.
         * 
         * The texture you provide for this Game Object should be based on the
         * following layout structure:
         * 
         * ```
         *      A                          B
         *    +---+----------------------+---+
         *  C | 1 |          2           | 3 |
         *    +---+----------------------+---+
         *    |   |                      |   |
         *    | 4 |          5           | 6 |
         *    |   |                      |   |
         *    +---+----------------------+---+
         *  D | 7 |          8           | 9 |
         *    +---+----------------------+---+
         * ```
         * 
         * When changing this objects width and / or height:
         * 
         *     areas 1, 3, 7 and 9 (the corners) will remain unscaled
         *     areas 2 and 8 will be stretched horizontally only
         *     areas 4 and 6 will be stretched vertically only
         *     area 5 will be stretched both horizontally and vertically
         * 
         * You can also create a 3 slice Game Object:
         * 
         * This works in a similar way, except you can only stretch it horizontally.
         * Therefore, it requires less configuration:
         * 
         * ```
         *      A                          B
         *    +---+----------------------+---+
         *    |   |                      |   |
         *  C | 1 |          2           | 3 |
         *    |   |                      |   |
         *    +---+----------------------+---+
         * ```
         * 
         * When changing this objects width (you cannot change its height)
         * 
         *     areas 1 and 3 will remain unscaled
         *     area 2 will be stretched horizontally
         * 
         * The above configuration concept is adapted from the Pixi NineSlicePlane.
         * 
         * To specify a 3 slice object instead of a 9 slice you should only
         * provide the `leftWidth` and `rightWidth` parameters. To create a 9 slice
         * you must supply all parameters.
         * 
         * The _minimum_ width this Game Object can be is the total of
         * `leftWidth` + `rightWidth`.  The _minimum_ height this Game Object
         * can be is the total of `topHeight` + `bottomHeight`.
         * If you need to display this object at a smaller size, you can scale it.
         * 
         * In terms of performance, using a 3 slice Game Object is the equivalent of
         * having 3 Sprites in a row. Using a 9 slice Game Object is the equivalent
         * of having 9 Sprites in a row. The vertices of this object are all batched
         * together and can co-exist with other Sprites and graphics on the display
         * list, without incurring any additional overhead.
         * 
         * As of Phaser 3.60 this Game Object is WebGL only.
         * 
         * As of Phaser 2.61 this Game Object can now populate its values automatically
         * if they have been set within Texture Packer 7.1.0 or above and exported with
         * the atlas json. If this is the case, you can just call this method without
         * specifying anything more than the texture key and frame and it will pull the
         * area data from the atlas.
         */
        class NineSlice extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of the center of this Game Object in the world.
             * @param y The vertical position of the center of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param width The width of the Nine Slice Game Object. You can adjust the width post-creation. Default 256.
             * @param height The height of the Nine Slice Game Object. If this is a 3 slice object the height will be fixed to the height of the texture and cannot be changed. Default 256.
             * @param leftWidth The size of the left vertical column (A). Default 10.
             * @param rightWidth The size of the right vertical column (B). Default 10.
             * @param topHeight The size of the top horiztonal row (C). Set to zero or undefined to create a 3 slice object. Default 0.
             * @param bottomHeight The size of the bottom horiztonal row (D). Set to zero or undefined to create a 3 slice object. Default 0.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number, width?: number, height?: number, leftWidth?: number, rightWidth?: number, topHeight?: number, bottomHeight?: number);

            /**
             * An array of Vertex objects that correspond to the quads that make-up
             * this Nine Slice Game Object. They are stored in the following order:
             * 
             * Top Left - Indexes 0 - 5
             * Top Center - Indexes 6 - 11
             * Top Right - Indexes 12 - 17
             * Center Left - Indexes 18 - 23
             * Center - Indexes 24 - 29
             * Center Right - Indexes 30 - 35
             * Bottom Left - Indexes 36 - 41
             * Bottom Center - Indexes 42 - 47
             * Bottom Right - Indexes 48 - 53
             * 
             * Each quad is represented by 6 Vertex instances.
             * 
             * This array will contain 18 elements for a 3 slice object
             * and 54 for a nine slice object.
             * 
             * You should never modify this array once it has been populated.
             */
            vertices: Phaser.Geom.Mesh.Vertex[];

            /**
             * The size of the left vertical bar (A).
             */
            readonly leftWidth: number;

            /**
             * The size of the right vertical bar (B).
             */
            readonly rightWidth: number;

            /**
             * The size of the top horizontal bar (C).
             * 
             * If this is a 3 slice object this property will be set to the
             * height of the texture being used.
             */
            readonly topHeight: number;

            /**
             * The size of the bottom horizontal bar (D).
             * 
             * If this is a 3 slice object this property will be set to zero.
             */
            readonly bottomHeight: number;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tint: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * This property is `true` if this Nine Slice Game Object was configured
             * with just `leftWidth` and `rightWidth` values, making it a 3-slice
             * instead of a 9-slice object.
             */
            is3Slice: boolean;

            /**
             * Resets the width, height and slices for this NineSlice Game Object.
             * 
             * This allows you to modify the texture being used by this object and then reset the slice configuration,
             * to avoid having to destroy this Game Object in order to use it for a different game element.
             * 
             * Please note that you cannot change a 9-slice to a 3-slice or vice versa.
             * @param width The width of the Nine Slice Game Object. You can adjust the width post-creation. Default 256.
             * @param height The height of the Nine Slice Game Object. If this is a 3 slice object the height will be fixed to the height of the texture and cannot be changed. Default 256.
             * @param leftWidth The size of the left vertical column (A). Default 10.
             * @param rightWidth The size of the right vertical column (B). Default 10.
             * @param topHeight The size of the top horiztonal row (C). Set to zero or undefined to create a 3 slice object. Default 0.
             * @param bottomHeight The size of the bottom horiztonal row (D). Set to zero or undefined to create a 3 slice object. Default 0.
             * @param skipScale9 If this Nine Slice was created from Texture Packer scale9 atlas data, set this property to use the given column sizes instead of those specified in the JSON. Default false.
             */
            setSlices(width?: number, height?: number, leftWidth?: number, rightWidth?: number, topHeight?: number, bottomHeight?: number, skipScale9?: boolean): this;

            /**
             * Updates all of the vertice UV coordinates. This is called automatically
             * when the NineSlice Game Object is created, or if the texture frame changes.
             * 
             * Unlike with the `updateVertice` method, you do not need to call this
             * method if the Nine Slice changes size. Only if it changes texture frame.
             */
            updateUVs(): void;

            /**
             * Recalculates all of the vertices in this Nine Slice Game Object
             * based on the `leftWidth`, `rightWidth`, `topHeight` and `bottomHeight`
             * properties, combined with the Game Object size.
             * 
             * This method is called automatically when this object is created
             * or if it's origin is changed.
             * 
             * You should not typically need to call this method directly, but it
             * is left public should you find a need to modify one of those properties
             * after creation.
             */
            updateVertices(): void;

            /**
             * Internally updates the position coordinates across all vertices of the
             * given quad offset.
             * 
             * You should not typically need to call this method directly, but it
             * is left public should an extended class require it.
             * @param offset The offset in the vertices array of the quad to update.
             * @param x1 The top-left quad coordinate.
             * @param y1 The top-left quad coordinate.
             * @param x2 The bottom-right quad coordinate.
             * @param y2 The bottom-right quad coordinate.
             */
            updateQuad(offset: number, x1: number, y1: number, x2: number, y2: number): void;

            /**
             * Internally updates the UV coordinates across all vertices of the
             * given quad offset, based on the frame size.
             * 
             * You should not typically need to call this method directly, but it
             * is left public should an extended class require it.
             * @param offset The offset in the vertices array of the quad to update.
             * @param u1 The top-left UV coordinate.
             * @param v1 The top-left UV coordinate.
             * @param u2 The bottom-right UV coordinate.
             * @param v2 The bottom-right UV coordinate.
             */
            updateQuadUVs(offset: number, u1: number, v1: number, u2: number, v2: number): void;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property.
             * 
             * To remove a tint call `clearTint`, or call this method with no parameters.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param color The tint being applied to the entire Game Object. Default 0xffffff.
             */
            setTint(color?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. The whole Game Object will be rendered in the given color.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property.
             * 
             * To remove a tint call `clearTint`, or call this method with no parameters.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param color The tint being applied to the entire Game Object. Default 0xffffff.
             */
            setTintFill(color?: number): this;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the tint property is set to a value other than 0xffffff.
             * This indicates that a Game Object is tinted.
             */
            readonly isTinted: boolean;

            /**
             * The displayed width of this Game Object.
             * 
             * Setting this value will adjust the way in which this Nine Slice
             * object scales horizontally, if configured to do so.
             * 
             * The _minimum_ width this Game Object can be is the total of
             * `leftWidth` + `rightWidth`. If you need to display this object
             * at a smaller size, you can also scale it.
             */
            width: number;

            /**
             * The displayed height of this Game Object.
             * 
             * Setting this value will adjust the way in which this Nine Slice
             * object scales vertically, if configured to do so.
             * 
             * The _minimum_ height this Game Object can be is the total of
             * `topHeight` + `bottomHeight`. If you need to display this object
             * at a smaller size, you can also scale it.
             * 
             * If this is a 3-slice object, you can only stretch it horizontally
             * and changing the height will be ignored.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object.
             * 
             * For a Nine Slice Game Object this means it will be stretched (or shrunk) horizontally
             * and vertically depending on the dimensions given to this method, in accordance with
             * how it has been configured for the various corner sizes.
             * 
             * If this is a 3-slice object, you can only stretch it horizontally
             * and changing the height will be ignored.
             * 
             * If you have enabled this Game Object for input, changing the size will also change the
             * size of the hit area.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             */
            originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             */
            originY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * This method is included but does nothing for the Nine Slice Game Object,
             * because the size of the object isn't based on the texture frame.
             * 
             * You should not call this method.
             */
            setSizeToFrame(): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        namespace Particles {
            /**
             * This class is responsible for taking control over the color property
             * in the Particle class and managing its emission and updating functions.
             * 
             * See the `ParticleEmitter` class for more details on emitter op configuration.
             */
            class EmitterColorOp extends Phaser.GameObjects.Particles.EmitterOp {
                /**
                 * 
                 * @param key The name of the property.
                 */
                constructor(key: string);

                /**
                 * An array containing the red color values.
                 * 
                 * Populated during the `setMethods` method.
                 */
                r: number[];

                /**
                 * An array containing the green color values.
                 * 
                 * Populated during the `setMethods` method.
                 */
                g: number[];

                /**
                 * An array containing the blue color values.
                 * 
                 * Populated during the `setMethods` method.
                 */
                b: number[];

                /**
                 * Checks the type of `EmitterOp.propertyValue` to determine which
                 * method is required in order to return values from this op function.
                 */
                getMethod(): number;

                /**
                 * Sets the EmitterColorOp method values, if in use.
                 */
                setMethods(): this;

                /**
                 * Sets the Ease function to use for Color interpolation.
                 * @param ease The string-based name of the Ease function to use.
                 */
                setEase(ease: string): void;

                /**
                 * An `onEmit` callback for an eased property.
                 * 
                 * It prepares the particle for easing by {@link Phaser.GameObjects.Particles.EmitterColorOp#easeValueUpdate}.
                 * @param particle The particle.
                 * @param key The name of the property.
                 */
                easedValueEmit(particle: Phaser.GameObjects.Particles.Particle, key: string): number;

                /**
                 * An `onUpdate` callback that returns an eased value between the
                 * {@link Phaser.GameObjects.Particles.EmitterColorOp#start} and {@link Phaser.GameObjects.Particles.EmitterColorOp#end}
                 * range.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 */
                easeValueUpdate(particle: Phaser.GameObjects.Particles.Particle, key: string, t: number): number;

            }

            /**
             * This class is responsible for taking control over a single property
             * in the Particle class and managing its emission and updating functions.
             * 
             * Particles properties such as `x`, `y`, `scaleX`, `lifespan` and others all use
             * EmitterOp instances to manage them, as they can be given in a variety of
             * formats: from simple values, to functions, to dynamic callbacks.
             * 
             * See the `ParticleEmitter` class for more details on emitter op configuration.
             */
            class EmitterOp {
                /**
                 * 
                 * @param key The name of the property.
                 * @param defaultValue The default value of the property.
                 * @param emitOnly Whether the property can only be modified when a Particle is emitted. Default false.
                 */
                constructor(key: string, defaultValue: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType, emitOnly?: boolean);

                /**
                 * The name of this property.
                 */
                propertyKey: string;

                /**
                 * The current value of this property.
                 * 
                 * This can be a simple value, an array, a function or an onEmit
                 * configuration object.
                 */
                propertyValue: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;

                /**
                 * The default value of this property.
                 * 
                 * This can be a simple value, an array, a function or an onEmit
                 * configuration object.
                 */
                defaultValue: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;

                /**
                 * The number of steps for stepped easing between {@link Phaser.GameObjects.Particles.EmitterOp#start} and
                 * {@link Phaser.GameObjects.Particles.EmitterOp#end} values, per emit.
                 */
                steps: number;

                /**
                 * The step counter for stepped easing, per emit.
                 */
                counter: number;

                /**
                 * When the step counter reaches it's maximum, should it then
                 * yoyo back to the start again, or flip over to it?
                 */
                yoyo: boolean;

                /**
                 * The counter direction. 0 for up and 1 for down.
                 */
                direction: number;

                /**
                 * The start value for this property to ease between.
                 * 
                 * If an interpolation this holds a reference to the number data array.
                 */
                start: number | number[];

                /**
                 * The most recently calculated value. Updated every time an
                 * emission or update method is called. Treat as read-only.
                 */
                current: number;

                /**
                 * The end value for this property to ease between.
                 */
                end: number;

                /**
                 * The easing function to use for updating this property, if any.
                 */
                ease: Function | null;

                /**
                 * The interpolation function to use for updating this property, if any.
                 */
                interpolation: Function | null;

                /**
                 * Whether this property can only be modified when a Particle is emitted.
                 * 
                 * Set to `true` to allow only {@link Phaser.GameObjects.Particles.EmitterOp#onEmit} callbacks to be set and
                 * affect this property.
                 * 
                 * Set to `false` to allow both {@link Phaser.GameObjects.Particles.EmitterOp#onEmit} and
                 * {@link Phaser.GameObjects.Particles.EmitterOp#onUpdate} callbacks to be set and affect this property.
                 */
                emitOnly: boolean;

                /**
                 * The callback to run for Particles when they are emitted from the Particle Emitter.
                 */
                onEmit: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitCallback;

                /**
                 * The callback to run for Particles when they are updated.
                 */
                onUpdate: Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateCallback;

                /**
                 * Set to `false` to disable this EmitterOp.
                 */
                active: boolean;

                /**
                 * The onEmit method type of this EmitterOp.
                 * 
                 * Set as part of `setMethod` and cached here to avoid
                 * re-setting when only the value changes.
                 */
                method: number;

                /**
                 * Load the property from a Particle Emitter configuration object.
                 * 
                 * Optionally accepts a new property key to use, replacing the current one.
                 * @param config Settings for the Particle Emitter that owns this property.
                 * @param newKey The new key to use for this property, if any.
                 */
                loadConfig(config?: Phaser.Types.GameObjects.Particles.ParticleEmitterConfig, newKey?: string): void;

                /**
                 * Build a JSON representation of this Particle Emitter property.
                 */
                toJSON(): object;

                /**
                 * Change the current value of the property and update its callback methods.
                 * @param value The new numeric value of this property.
                 */
                onChange(value: number): this;

                /**
                 * Checks the type of `EmitterOp.propertyValue` to determine which
                 * method is required in order to return values from this op function.
                 */
                getMethod(): number;

                /**
                 * Update the {@link Phaser.GameObjects.Particles.EmitterOp#onEmit} and
                 * {@link Phaser.GameObjects.Particles.EmitterOp#onUpdate} callbacks based on the method returned
                 * from `getMethod`. The method is stored in the `EmitterOp.method` property
                 * and is a number between 0 and 9 inclusively.
                 */
                setMethods(): this;

                /**
                 * Check whether an object has the given property.
                 * @param object The object to check.
                 * @param key The key of the property to look for in the object.
                 */
                has(object: object, key: string): boolean;

                /**
                 * Check whether an object has both of the given properties.
                 * @param object The object to check.
                 * @param key1 The key of the first property to check the object for.
                 * @param key2 The key of the second property to check the object for.
                 */
                hasBoth(object: object, key1: string, key2: string): boolean;

                /**
                 * Check whether an object has at least one of the given properties.
                 * @param object The object to check.
                 * @param key1 The key of the first property to check the object for.
                 * @param key2 The key of the second property to check the object for.
                 */
                hasEither(object: object, key1: string, key2: string): boolean;

                /**
                 * The returned value sets what the property will be at the START of the particles life, on emit.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param value The current value of the property.
                 */
                defaultEmit(particle: Phaser.GameObjects.Particles.Particle, key: string, value?: number): number;

                /**
                 * The returned value updates the property for the duration of the particles life.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 * @param value The current value of the property.
                 */
                defaultUpdate(particle: Phaser.GameObjects.Particles.Particle, key: string, t: number, value: number): number;

                /**
                 * The returned value sets what the property will be at the START of the particles life, on emit.
                 * 
                 * This method is only used when you have provided a custom emit callback.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param value The current value of the property.
                 */
                proxyEmit(particle: Phaser.GameObjects.Particles.Particle, key: string, value?: number): number;

                /**
                 * The returned value updates the property for the duration of the particles life.
                 * 
                 * This method is only used when you have provided a custom update callback.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 * @param value The current value of the property.
                 */
                proxyUpdate(particle: Phaser.GameObjects.Particles.Particle, key: string, t: number, value: number): number;

                /**
                 * An `onEmit` callback that returns the current value of the property.
                 */
                staticValueEmit(): number;

                /**
                 * An `onUpdate` callback that returns the current value of the property.
                 */
                staticValueUpdate(): number;

                /**
                 * An `onEmit` callback that returns a random value from the current value array.
                 */
                randomStaticValueEmit(): number;

                /**
                 * An `onEmit` callback that returns a value between the {@link Phaser.GameObjects.Particles.EmitterOp#start} and
                 * {@link Phaser.GameObjects.Particles.EmitterOp#end} range.
                 * @param particle The particle.
                 * @param key The key of the property.
                 */
                randomRangedValueEmit(particle: Phaser.GameObjects.Particles.Particle, key: string): number;

                /**
                 * An `onEmit` callback that returns a value between the {@link Phaser.GameObjects.Particles.EmitterOp#start} and
                 * {@link Phaser.GameObjects.Particles.EmitterOp#end} range.
                 * @param particle The particle.
                 * @param key The key of the property.
                 */
                randomRangedIntEmit(particle: Phaser.GameObjects.Particles.Particle, key: string): number;

                /**
                 * An `onEmit` callback that returns a stepped value between the
                 * {@link Phaser.GameObjects.Particles.EmitterOp#start} and {@link Phaser.GameObjects.Particles.EmitterOp#end}
                 * range.
                 */
                steppedEmit(): number;

                /**
                 * An `onEmit` callback for an eased property.
                 * 
                 * It prepares the particle for easing by {@link Phaser.GameObjects.Particles.EmitterOp#easeValueUpdate}.
                 * @param particle The particle.
                 * @param key The name of the property.
                 */
                easedValueEmit(particle: Phaser.GameObjects.Particles.Particle, key: string): number;

                /**
                 * An `onUpdate` callback that returns an eased value between the
                 * {@link Phaser.GameObjects.Particles.EmitterOp#start} and {@link Phaser.GameObjects.Particles.EmitterOp#end}
                 * range.
                 * @param particle The particle.
                 * @param key The name of the property.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 */
                easeValueUpdate(particle: Phaser.GameObjects.Particles.Particle, key: string, t: number): number;

                /**
                 * Destroys this EmitterOp instance and all of its references.
                 * 
                 * Called automatically when the ParticleEmitter that owns this
                 * EmitterOp is destroyed.
                 */
                destroy(): void;

            }

            namespace Events {
                /**
                 * The Particle Emitter Complete Event.
                 * 
                 * This event is dispatched when the final particle, emitted from a Particle Emitter that
                 * has been stopped, dies. Upon receipt of this event you know that no particles are
                 * still rendering at this point in time.
                 * 
                 * Listen for it on a Particle Emitter instance using `ParticleEmitter.on('complete', listener)`.
                 */
                const COMPLETE: string;

                /**
                 * The Particle Emitter Death Zone Event.
                 * 
                 * This event is dispatched when a Death Zone kills a Particle instance.
                 * 
                 * Listen for it on a Particle Emitter instance using `ParticleEmitter.on('deathzone', listener)`.
                 * 
                 * If you wish to know when the final particle is killed, see the `COMPLETE` event.
                 */
                const DEATH_ZONE: string;

                /**
                 * The Particle Emitter Explode Event.
                 * 
                 * This event is dispatched when a Particle Emitter explodes a set of particles.
                 * 
                 * Listen for it on a Particle Emitter instance using `ParticleEmitter.on('explode', listener)`.
                 */
                const EXPLODE: string;

                /**
                 * The Particle Emitter Start Event.
                 * 
                 * This event is dispatched when a Particle Emitter starts emission of particles.
                 * 
                 * Listen for it on a Particle Emitter instance using `ParticleEmitter.on('start', listener)`.
                 */
                const START: string;

                /**
                 * The Particle Emitter Stop Event.
                 * 
                 * This event is dispatched when a Particle Emitter is stopped. This can happen either
                 * when you directly call the `ParticleEmitter.stop` method, or if the emitter has
                 * been configured to stop after a set time via the `duration` property, or after a
                 * set number of particles via the `stopAfter` property.
                 * 
                 * Listen for it on a Particle Emitter instance using `ParticleEmitter.on('stop', listener)`.
                 * 
                 * Note that just because the emitter has stopped, that doesn't mean there aren't still
                 * particles alive and rendering. It just means the emitter has stopped emitting particles.
                 * 
                 * If you wish to know when the final particle is killed, see the `COMPLETE` event.
                 */
                const STOP: string;

            }

            /**
             * The Gravity Well Particle Processor applies a force on the particles to draw
             * them towards, or repel them from, a single point.
             * 
             * The force applied is inversely proportional to the square of the distance
             * from the particle to the point, in accordance with Newton's law of gravity.
             * 
             * This simulates the effect of gravity over large distances (as between planets, for example).
             */
            class GravityWell extends Phaser.GameObjects.Particles.ParticleProcessor {
                /**
                 * 
                 * @param x The x coordinate of the Gravity Well, in world space. Default 0.
                 * @param y The y coordinate of the Gravity Well, in world space. Default 0.
                 * @param power The strength of the gravity force - larger numbers produce a stronger force. Default 0.
                 * @param epsilon The minimum distance for which the gravity force is calculated. Default 100.
                 * @param gravity The gravitational force of this Gravity Well. Default 50.
                 */
                constructor(x?: number | Phaser.Types.GameObjects.Particles.GravityWellConfig, y?: number, power?: number, epsilon?: number, gravity?: number);

                /**
                 * Takes a Particle and updates it based on the properties of this Gravity Well.
                 * @param particle The Particle to update.
                 * @param delta The delta time in ms.
                 * @param step The delta value divided by 1000.
                 */
                update(particle: Phaser.GameObjects.Particles.Particle, delta: number, step: number): void;

                /**
                 * The minimum distance for which the gravity force is calculated.
                 * 
                 * Defaults to 100.
                 */
                epsilon: number;

                /**
                 * The strength of the gravity force - larger numbers produce a stronger force.
                 * 
                 * Defaults to 0.
                 */
                power: number;

                /**
                 * The gravitational force of this Gravity Well.
                 * 
                 * Defaults to 50.
                 */
                gravity: number;

            }

            /**
             * A Particle is a simple object owned and controlled by a Particle Emitter.
             * 
             * It encapsulates all of the properties required to move and update according
             * to the Emitters operations.
             */
            class Particle {
                /**
                 * 
                 * @param emitter The Emitter to which this Particle belongs.
                 */
                constructor(emitter: Phaser.GameObjects.Particles.ParticleEmitter);

                /**
                 * The Emitter to which this Particle belongs.
                 * 
                 * A Particle can only belong to a single Emitter and is created, updated and destroyed by it.
                 */
                emitter: Phaser.GameObjects.Particles.ParticleEmitter;

                /**
                 * The texture used by this Particle when it renders.
                 */
                texture: Phaser.Textures.Texture;

                /**
                 * The texture frame used by this Particle when it renders.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * The x coordinate of this Particle.
                 */
                x: number;

                /**
                 * The y coordinate of this Particle.
                 */
                y: number;

                /**
                 * The coordinates of this Particle in world space.
                 * 
                 * Updated as part of `computeVelocity`.
                 */
                worldPosition: Phaser.Math.Vector2;

                /**
                 * The x velocity of this Particle.
                 */
                velocityX: number;

                /**
                 * The y velocity of this Particle.
                 */
                velocityY: number;

                /**
                 * The x acceleration of this Particle.
                 */
                accelerationX: number;

                /**
                 * The y acceleration of this Particle.
                 */
                accelerationY: number;

                /**
                 * The maximum horizontal velocity this Particle can travel at.
                 */
                maxVelocityX: number;

                /**
                 * The maximum vertical velocity this Particle can travel at.
                 */
                maxVelocityY: number;

                /**
                 * The bounciness, or restitution, of this Particle.
                 */
                bounce: number;

                /**
                 * The horizontal scale of this Particle.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Particle.
                 */
                scaleY: number;

                /**
                 * The alpha value of this Particle.
                 */
                alpha: number;

                /**
                 * The angle of this Particle in degrees.
                 */
                angle: number;

                /**
                 * The angle of this Particle in radians.
                 */
                rotation: number;

                /**
                 * The tint applied to this Particle.
                 */
                tint: number;

                /**
                 * The lifespan of this Particle in ms.
                 */
                life: number;

                /**
                 * The current life of this Particle in ms.
                 */
                lifeCurrent: number;

                /**
                 * The delay applied to this Particle upon emission, in ms.
                 */
                delayCurrent: number;

                /**
                 * The hold applied to this Particle before it expires, in ms.
                 */
                holdCurrent: number;

                /**
                 * The normalized lifespan T value, where 0 is the start and 1 is the end.
                 */
                lifeT: number;

                /**
                 * The data used by the ease equation.
                 */
                data: Phaser.Types.GameObjects.Particles.ParticleData;

                /**
                 * A reference to the Scene to which this Game Object belongs.
                 * 
                 * Game Objects can only belong to one Scene.
                 * 
                 * You should consider this property as being read-only. You cannot move a
                 * Game Object to another Scene by simply changing it.
                 */
                scene: Phaser.Scene;

                /**
                 * The Animation State component of this Particle.
                 * 
                 * This component provides features to apply animations to this Particle.
                 * It is responsible for playing, loading, queuing animations for later playback,
                 * mixing between animations and setting the current animation frame to this Particle.
                 */
                anims: Phaser.Animations.AnimationState;

                /**
                 * A rectangle that holds the bounds of this Particle after a call to
                 * the `Particle.getBounds` method has been made.
                 */
                bounds: Phaser.Geom.Rectangle;

                /**
                 * The Event Emitter proxy.
                 * 
                 * Passes on all parameters to the `ParticleEmitter` to emit directly.
                 * @param event The event name.
                 * @param a1 Optional argument 1.
                 * @param a2 Optional argument 2.
                 * @param a3 Optional argument 3.
                 * @param a4 Optional argument 4.
                 * @param a5 Optional argument 5.
                 */
                emit(event: string | Symbol, a1?: any, a2?: any, a3?: any, a4?: any, a5?: any): boolean;

                /**
                 * Checks to see if this Particle is alive and updating.
                 */
                isAlive(): boolean;

                /**
                 * Kills this particle. This sets the `lifeCurrent` value to 0, which forces
                 * the Particle to be removed the next time its parent Emitter runs an update.
                 */
                kill(): void;

                /**
                 * Sets the position of this particle to the given x/y coordinates.
                 * 
                 * If the parameters are left undefined, it resets the particle back to 0x0.
                 * @param x The x coordinate to set this Particle to. Default 0.
                 * @param y The y coordinate to set this Particle to. Default 0.
                 */
                setPosition(x?: number, y?: number): void;

                /**
                 * Starts this Particle from the given coordinates.
                 * @param x The x coordinate to launch this Particle from.
                 * @param y The y coordinate to launch this Particle from.
                 */
                fire(x?: number, y?: number): boolean;

                /**
                 * The main update method for this Particle.
                 * 
                 * Updates its life values, computes the velocity and repositions the Particle.
                 * @param delta The delta time in ms.
                 * @param step The delta value divided by 1000.
                 * @param processors An array of all active Particle Processors.
                 */
                update(delta: number, step: number, processors: Phaser.GameObjects.Particles.ParticleProcessor[]): boolean;

                /**
                 * An internal method that calculates the velocity of the Particle and
                 * its world position. It also runs it against any active Processors
                 * that are set on the Emitter.
                 * @param emitter The Emitter that is updating this Particle.
                 * @param delta The delta time in ms.
                 * @param step The delta value divided by 1000.
                 * @param processors An array of all active Particle Processors.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 */
                computeVelocity(emitter: Phaser.GameObjects.Particles.ParticleEmitter, delta: number, step: number, processors: Phaser.GameObjects.Particles.ParticleProcessor[], t: number): void;

                /**
                 * This is a NOOP method and does nothing when called.
                 */
                setSizeToFrame(): void;

                /**
                 * Gets the bounds of this particle as a Geometry Rectangle, factoring in any
                 * transforms of the parent emitter and anything else above it in the display list.
                 * 
                 * Once calculated the bounds can be accessed via the `Particle.bounds` property.
                 * @param matrix Optional transform matrix to apply to this particle.
                 */
                getBounds(matrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.Geom.Rectangle;

                /**
                 * Destroys this Particle.
                 */
                destroy(): void;

            }

            /**
             * The Particle Bounds Processor.
             * 
             * Defines a rectangular region, in world space, within which particle movement
             * is restrained.
             * 
             * Use the properties `collideLeft`, `collideRight`, `collideTop` and
             * `collideBottom` to control if a particle will rebound off the sides
             * of this boundary, or not.
             * 
             * This happens when the particles worldPosition x/y coordinate hits the boundary.
             * 
             * The strength of the rebound is determined by the `Particle.bounce` property.
             */
            class ParticleBounds extends Phaser.GameObjects.Particles.ParticleProcessor {
                /**
                 * 
                 * @param x The x position (top-left) of the bounds, in world space.
                 * @param y The y position (top-left) of the bounds, in world space.
                 * @param width The width of the bounds.
                 * @param height The height of the bounds.
                 * @param collideLeft Whether particles interact with the left edge of the bounds. Default true.
                 * @param collideRight Whether particles interact with the right edge of the bounds. Default true.
                 * @param collideTop Whether particles interact with the top edge of the bounds. Default true.
                 * @param collideBottom Whether particles interact with the bottom edge of the bounds. Default true.
                 */
                constructor(x: number, y: number, width: number, height: number, collideLeft?: boolean, collideRight?: boolean, collideTop?: boolean, collideBottom?: boolean);

                /**
                 * A rectangular boundary constraining particle movement. Use the Emitter properties `collideLeft`,
                 * `collideRight`, `collideTop` and `collideBottom` to control if a particle will rebound off
                 * the sides of this boundary, or not. This happens when the particles x/y coordinate hits
                 * the boundary.
                 */
                bounds: Phaser.Geom.Rectangle;

                /**
                 * Whether particles interact with the left edge of the emitter {@link Phaser.GameObjects.Particles.ParticleEmitter#bounds}.
                 */
                collideLeft: boolean;

                /**
                 * Whether particles interact with the right edge of the emitter {@link Phaser.GameObjects.Particles.ParticleBounds#bounds}.
                 */
                collideRight: boolean;

                /**
                 * Whether particles interact with the top edge of the emitter {@link Phaser.GameObjects.Particles.ParticleBounds#bounds}.
                 */
                collideTop: boolean;

                /**
                 * Whether particles interact with the bottom edge of the emitter {@link Phaser.GameObjects.Particles.ParticleBounds#bounds}.
                 */
                collideBottom: boolean;

                /**
                 * Takes a Particle and updates it against the bounds.
                 * @param particle The Particle to update.
                 */
                update(particle: Phaser.GameObjects.Particles.Particle): void;

            }

            /**
             * A Particle Emitter is a special kind of Game Object that controls a pool of {@link Phaser.GameObjects.Particles.Particle Particles}.
             * 
             * Particle Emitters are created via a configuration object. The properties of this object
             * can be specified in a variety of formats, given you plenty of scope over the values they
             * return, leading to complex visual effects. Here are the different forms of configuration
             * value you can give:
             * 
             * ## An explicit static value:
             * 
             * ```js
             * x: 400
             * ```
             * 
             * The x value will always be 400 when the particle is spawned.
             * 
             * ## A random value:
             * 
             * ```js
             * x: [ 100, 200, 300, 400 ]
             * ```
             * 
             * The x value will be one of the 4 elements in the given array, picked at random on emission.
             * 
             * ## A custom callback:
             * 
             * ```js
             * x: (particle, key, t, value) => {
             *   return value + 50;
             * }
             * ```
             * 
             * The x value is the result of calling this function. This is only used when the
             * particle is emitted, so it provides it's initial starting value. It is not used
             * when the particle is updated (see the onUpdate callback for that)
             * 
             * ## A start / end object:
             * 
             * This allows you to control the change in value between the given start and
             * end parameters over the course of the particles lifetime:
             * 
             * ```js
             * scale: { start: 0, end: 1 }
             * ```
             * 
             * The particle scale will start at 0 when emitted and ease to a scale of 1
             * over the course of its lifetime. You can also specify the ease function
             * used for this change (the default is Linear):
             * 
             * ```js
             * scale: { start: 0, end: 1, ease: 'bounce.out' }
             * ```
             * 
             * ## A start / end random object:
             * 
             * The start and end object can have an optional `random` parameter.
             * This forces it to pick a random value between the two values and use
             * this as the starting value, then easing to the 'end' parameter over
             * its lifetime.
             * 
             * ```js
             * scale: { start: 4, end: 0.5, random: true }
             * ```
             * 
             * The particle will start with a random scale between 0.5 and 4 and then
             * scale to the end value over its lifetime. You can combine the above
             * with the `ease` parameter as well to control the value easing.
             * 
             * ## An interpolation object:
             * 
             * You can provide an array of values which will be used for interpolation
             * during the particles lifetime. You can also define the interpolation
             * function to be used. There are three provided: `linear` (the default),
             * `bezier` and `catmull`, or you can provide your own function.
             * 
             * ```js
             * x: { values: [ 50, 500, 200, 800 ], interpolation: 'catmull' }
             * ```
             * 
             * The particle scale will interpolate from 50 when emitted to 800 via the other
             * points over the course of its lifetime. You can also specify an ease function
             * used to control the rate of change through the values (the default is Linear):
             * 
             * ```js
             * x: { values: [ 50, 500, 200, 800 ], interpolation: 'catmull', ease: 'bounce.out }
             * ```
             * 
             * ## A stepped emitter object:
             * 
             * The `steps` parameter allows you to control the placement of sequential
             * particles across the start-end range:
             * 
             * ```js
             * x: { steps: 32, start: 0, end: 576 }
             * ```
             * 
             * Here we have a range of 576 (start to end). This is divided into 32 steps.
             * 
             * The first particle will emit at the x position of 0. The next will emit
             * at the next 'step' along, which would be 18. The following particle will emit
             * at the next step, which is 36, and so on. Because the range of 576 has been
             * divided by 32, creating 18 pixels steps. When a particle reaches the 'end'
             * value the next one will start from the beginning again.
             * 
             * ## A stepped emitter object with yoyo:
             * 
             * You can add the optional `yoyo` property to a stepped object:
             * 
             * ```js
             * x: { steps: 32, start: 0, end: 576, yoyo: true }
             * ```
             * 
             * As with the stepped emitter, particles are emitted in sequence, from 'start'
             * to 'end' in step sized jumps. Normally, when a stepped emitter reaches the
             * end it snaps around to the start value again. However, if you provide the 'yoyo'
             * parameter then when it reaches the end it will reverse direction and start
             * emitting back down to 'start' again. Depending on the effect you require this
             * can often look better.
             * 
             * ## A min / max object:
             * 
             * This allows you to pick a random float value between the min and max properties:
             * 
             * ```js
             * x: { min: 100, max: 700 }
             * ```
             * 
             * The x value will be a random float between min and max.
             * 
             * You can force it select an integer by setting the 'int' flag:
             * 
             * ```js
             * x: { min: 100, max: 700, int: true }
             * ```
             * 
             * Or, you could use the 'random' array approach (see below)
             * 
             * ## A random object:
             * 
             * This allows you to pick a random integer value between the first and second array elements:
             * 
             * ```js
             * x: { random: [ 100, 700 ] }
             * ```
             * 
             * The x value will be a random integer between 100 and 700 as it takes the first
             * element in the 'random' array as the 'min' value and the 2nd element as the 'max' value.
             * 
             * ## Custom onEmit and onUpdate callbacks:
             * 
             * If the above won't give you the effect you're after, you can provide your own
             * callbacks that will be used when the particle is both emitted and updated:
             * 
             * ```js
             * x: {
             *   onEmit: (particle, key, t, value) => {
             *     return value;
             *   },
             *   onUpdate: (particle, key, t, value) => {
             *     return value;
             *   }
             * }
             * ```
             * 
             * You can provide either one or both functions. The `onEmit` is called at the
             * start of the particles life and defines the value of the property on birth.
             * 
             * The `onUpdate` function is called every time the Particle Emitter updates
             * until the particle dies. Both must return a value.
             * 
             * The properties are:
             * 
             * particle - A reference to the Particle instance.
             * key - The string based key of the property, i.e. 'x' or 'lifespan'.
             * t - The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
             * value - The current property value. At a minimum you should return this.
             * 
             * By using the above configuration options you have an unlimited about of
             * control over how your particles behave.
             * 
             * ## v3.55 Differences
             * 
             * Prior to v3.60 Phaser used a `ParticleEmitterManager`. This was removed in v3.60
             * and now calling `this.add.particles` returns a `ParticleEmitter` instance instead.
             * 
             * In order to streamline memory and the display list we have removed the
             * `ParticleEmitterManager` entirely. When you call `this.add.particles` you're now
             * creating a `ParticleEmitter` instance, which is being added directly to the
             * display list and can be manipulated just like any other Game Object, i.e.
             * scaled, rotated, positioned, added to a Container, etc. It now extends the
             * `GameObject` base class, meaning it's also an event emitter, which allowed us
             * to create some handy new events for particles.
             * 
             * So, to create an emitter, you now give it an xy coordinate, a texture and an
             * emitter configuration object (you can also set this later, but most commonly
             * you'd do it on creation). I.e.:
             * 
             * ```js
             * const emitter = this.add.particles(100, 300, 'flares', {
             *   frame: 'red',
             *   angle: { min: -30, max: 30 },
             *   speed: 150
             * });
             * ```
             * 
             * This will create a 'red flare' emitter at 100 x 300.
             * 
             * Please update your code to ensure it adheres to the new function signatures.
             */
            class ParticleEmitter extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param config Settings for this emitter.
                 */
                constructor(scene: Phaser.Scene, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, config?: Phaser.Types.GameObjects.Particles.ParticleEmitterConfig);

                /**
                 * The Particle Class which will be emitted by this Emitter.
                 */
                particleClass: Function;

                /**
                 * An internal object holding all of the EmitterOp instances.
                 * 
                 * These are populated as part of the Emitter configuration parsing.
                 * 
                 * You typically do not access them directly, but instead use the
                 * provided getters and setters on this class, such as `ParticleEmitter.speedX` etc.
                 */
                ops: Phaser.Types.GameObjects.Particles.ParticleEmitterOps;

                /**
                 * A radial emitter will emit particles in all directions between angle min and max,
                 * using {@link Phaser.GameObjects.Particles.ParticleEmitter#speed} as the value. If set to false then this acts as a point Emitter.
                 * A point emitter will emit particles only in the direction derived from the speedX and speedY values.
                 */
                radial: boolean;

                /**
                 * Horizontal acceleration applied to emitted particles, in pixels per second squared.
                 */
                gravityX: number;

                /**
                 * Vertical acceleration applied to emitted particles, in pixels per second squared.
                 */
                gravityY: number;

                /**
                 * Whether accelerationX and accelerationY are non-zero. Set automatically during configuration.
                 */
                acceleration: boolean;

                /**
                 * Whether moveToX and moveToY are set. Set automatically during configuration.
                 * 
                 * When true the particles move toward the moveToX and moveToY coordinates and arrive at the end of their life.
                 * Emitter angle, speedX, and speedY are ignored.
                 */
                moveTo: boolean;

                /**
                 * A function to call when a particle is emitted.
                 */
                emitCallback: Phaser.Types.GameObjects.Particles.ParticleEmitterCallback | null;

                /**
                 * The calling context for {@link Phaser.GameObjects.Particles.ParticleEmitter#emitCallback}.
                 */
                emitCallbackScope: any | null;

                /**
                 * A function to call when a particle dies.
                 */
                deathCallback: Phaser.Types.GameObjects.Particles.ParticleDeathCallback | null;

                /**
                 * The calling context for {@link Phaser.GameObjects.Particles.ParticleEmitter#deathCallback}.
                 */
                deathCallbackScope: any | null;

                /**
                 * Set to hard limit the amount of particle objects this emitter is allowed to create
                 * in total. This is the number of `Particle` instances it can create, not the number
                 * of 'alive' particles.
                 * 
                 * 0 means unlimited.
                 */
                maxParticles: number;

                /**
                 * The maximum number of alive and rendering particles this emitter will update.
                 * When this limit is reached, a particle needs to die before another can be emitted.
                 * 
                 * 0 means no limits.
                 */
                maxAliveParticles: number;

                /**
                 * If set, either via the Emitter config, or by directly setting this property,
                 * the Particle Emitter will stop emitting particles once this total has been
                 * reached. It will then enter a 'stopped' state, firing the `STOP`
                 * event. Note that entering a stopped state doesn't mean all the particles
                 * have finished, just that it's not emitting any further ones.
                 * 
                 * To know when the final particle expires, listen for the COMPLETE event.
                 * 
                 * Use this if you wish to launch an exact number of particles and then stop
                 * your emitter afterwards.
                 * 
                 * The counter is reset each time the `ParticleEmitter.start` method is called.
                 * 
                 * 0 means the emitter will not stop based on total emitted particles.
                 */
                stopAfter: number;

                /**
                 * The number of milliseconds this emitter will emit particles for when in flow mode,
                 * before it stops emission. A value of 0 (the default) means there is no duration.
                 * 
                 * When the duration expires the `STOP` event is emitted. Note that entering a
                 * stopped state doesn't mean all the particles have finished, just that it's
                 * not emitting any further ones.
                 * 
                 * To know when the final particle expires, listen for the COMPLETE event.
                 * 
                 * The counter is reset each time the `ParticleEmitter.start` method is called.
                 * 
                 * 0 means the emitter will not stop based on duration.
                 */
                duration: number;

                /**
                 * For a flow emitter, the time interval (>= 0) between particle flow cycles in ms.
                 * A value of 0 means there is one particle flow cycle for each logic update (the maximum flow frequency). This is the default setting.
                 * For an exploding emitter, this value will be -1.
                 * Calling {@link Phaser.GameObjects.Particles.ParticleEmitter#flow} also puts the emitter in flow mode (frequency >= 0).
                 * Calling {@link Phaser.GameObjects.Particles.ParticleEmitter#explode} also puts the emitter in explode mode (frequency = -1).
                 */
                frequency: number;

                /**
                 * Controls if the emitter is currently emitting a particle flow (when frequency >= 0).
                 * 
                 * Already alive particles will continue to update until they expire.
                 * 
                 * Controlled by {@link Phaser.GameObjects.Particles.ParticleEmitter#start} and {@link Phaser.GameObjects.Particles.ParticleEmitter#stop}.
                 */
                emitting: boolean;

                /**
                 * Newly emitted particles are added to the top of the particle list, i.e. rendered above those already alive.
                 * 
                 * Set to false to send them to the back.
                 * 
                 * Also see the `sortOrder` property for more complex particle sorting.
                 */
                particleBringToTop: boolean;

                /**
                 * The time rate applied to active particles, affecting lifespan, movement, and tweens. Values larger than 1 are faster than normal.
                 */
                timeScale: number;

                /**
                 * An array containing Particle Emission Zones. These can be either EdgeZones or RandomZones.
                 * 
                 * Particles are emitted from a randomly selected zone from this array.
                 * 
                 * Prior to Phaser v3.60 an Emitter could only have one single Emission Zone.
                 * In 3.60 they can now have an array of Emission Zones.
                 */
                emitZones: Phaser.Types.GameObjects.Particles.EmitZoneObject[];

                /**
                 * An array containing Particle Death Zone objects. A particle is immediately killed as soon as its x/y coordinates
                 * intersect with any of the configured Death Zones.
                 * 
                 * Prior to Phaser v3.60 an Emitter could only have one single Death Zone.
                 * In 3.60 they can now have an array of Death Zones.
                 */
                deathZones: Phaser.GameObjects.Particles.Zones.DeathZone[];

                /**
                 * An optional Rectangle object that is used during rendering to cull Particles from
                 * display. For example, if your particles are limited to only move within a 300x300
                 * sized area from their origin, then you can set this Rectangle to those dimensions.
                 * 
                 * The renderer will check to see if the `viewBounds` Rectangle intersects with the
                 * Camera bounds during the render step and if not it will skip rendering the Emitter
                 * entirely.
                 * 
                 * This allows you to create many emitters in a Scene without the cost of
                 * rendering if the contents aren't visible.
                 * 
                 * Note that the Emitter will not perform any checks to see if the Particles themselves
                 * are outside of these bounds, or not. It will simply check the bounds against the
                 * camera. Use the `getBounds` method with the `advance` parameter to help define
                 * the location and placement of the view bounds.
                 */
                viewBounds: Phaser.Geom.Rectangle | null;

                /**
                 * A Game Object whose position is used as the particle origin.
                 */
                follow: Phaser.Types.Math.Vector2Like | null;

                /**
                 * The offset of the particle origin from the {@link Phaser.GameObjects.Particles.ParticleEmitter#follow} target.
                 */
                followOffset: Phaser.Math.Vector2;

                /**
                 * Whether the emitter's {@link Phaser.GameObjects.Particles.ParticleEmitter#visible} state will track
                 * the {@link Phaser.GameObjects.Particles.ParticleEmitter#follow} target's visibility state.
                 */
                trackVisible: boolean;

                /**
                 * The texture frames assigned to particles.
                 */
                frames: Phaser.Textures.Frame[];

                /**
                 * Whether texture {@link Phaser.GameObjects.Particles.ParticleEmitter#frames} are selected at random.
                 */
                randomFrame: boolean;

                /**
                 * The number of consecutive particles that receive a single texture frame (per frame cycle).
                 */
                frameQuantity: number;

                /**
                 * The animations assigned to particles.
                 */
                anims: string[];

                /**
                 * Whether animations {@link Phaser.GameObjects.Particles.ParticleEmitter#anims} are selected at random.
                 */
                randomAnim: boolean;

                /**
                 * The number of consecutive particles that receive a single animation (per frame cycle).
                 */
                animQuantity: number;

                /**
                 * An internal property used to tell when the emitter is in fast-forwarc mode.
                 */
                skipping: boolean;

                /**
                 * An internal Transform Matrix used to cache this emitters world matrix.
                 */
                worldMatrix: Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Optionally sort the particles before they render based on this
                 * property. The property must exist on the `Particle` class, such
                 * as `y`, `lifeT`, `scaleX`, etc.
                 * 
                 * When set this overrides the `particleBringToTop` setting.
                 * 
                 * To reset this and disable sorting, so this property to an empty string.
                 */
                sortProperty: string;

                /**
                 * When `sortProperty` is defined this controls the sorting order,
                 * either ascending or descending. Toggle to control the visual effect.
                 */
                sortOrderAsc: boolean;

                /**
                 * The callback used to sort the particles. Only used if `sortProperty`
                 * has been set. Set this via the `setSortCallback` method.
                 */
                sortCallback: Phaser.Types.GameObjects.Particles.ParticleSortCallback | null;

                /**
                 * A list of Particle Processors being managed by this Emitter.
                 */
                processors: Phaser.Structs.List<Phaser.GameObjects.Particles.ParticleProcessor>;

                /**
                 * The tint fill mode used by the Particles in this Emitter.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;

                /**
                 * Takes an Emitter Configuration file and resets this Emitter, using any
                 * properties defined in the config to then set it up again.
                 * @param config Settings for this emitter.
                 */
                setConfig(config: Phaser.Types.GameObjects.Particles.ParticleEmitterConfig): this;

                /**
                 * Creates a description of this emitter suitable for JSON serialization.
                 */
                toJSON(): Phaser.Types.GameObjects.JSONGameObject;

                /**
                 * Resets the internal counter trackers.
                 * 
                 * You shouldn't ever need to call this directly.
                 * @param frequency The frequency counter.
                 * @param on Set the complete flag.
                 */
                resetCounters(frequency: number, on: boolean): void;

                /**
                 * Continuously moves the particle origin to follow a Game Object's position.
                 * @param target The Object to follow.
                 * @param offsetX Horizontal offset of the particle origin from the Game Object. Default 0.
                 * @param offsetY Vertical offset of the particle origin from the Game Object. Default 0.
                 * @param trackVisible Whether the emitter's visible state will track the target's visible state. Default false.
                 */
                startFollow(target: Phaser.Types.Math.Vector2Like, offsetX?: number, offsetY?: number, trackVisible?: boolean): this;

                /**
                 * Stops following a Game Object.
                 */
                stopFollow(): this;

                /**
                 * Chooses a texture frame from {@link Phaser.GameObjects.Particles.ParticleEmitter#frames}.
                 */
                getFrame(): Phaser.Textures.Frame;

                /**
                 * Sets a pattern for assigning texture frames to emitted particles. The `frames` configuration can be any of:
                 * 
                 * frame: 0
                 * frame: 'red'
                 * frame: [ 0, 1, 2, 3 ]
                 * frame: [ 'red', 'green', 'blue', 'pink', 'white' ]
                 * frame: { frames: [ 'red', 'green', 'blue', 'pink', 'white' ], [cycle: bool], [quantity: int] }
                 * @param frames One or more texture frames, or a configuration object.
                 * @param pickRandom Whether frames should be assigned at random from `frames`. Default true.
                 * @param quantity The number of consecutive particles that will receive each frame. Default 1.
                 */
                setEmitterFrame(frames: any[] | string | number | Phaser.Types.GameObjects.Particles.ParticleEmitterFrameConfig, pickRandom?: boolean, quantity?: number): this;

                /**
                 * Chooses an animation from {@link Phaser.GameObjects.Particles.ParticleEmitter#anims}, if populated.
                 */
                getAnim(): string;

                /**
                 * Sets a pattern for assigning animations to emitted particles. The `anims` configuration can be any of:
                 * 
                 * anim: 'red'
                 * anim: [ 'red', 'green', 'blue', 'pink', 'white' ]
                 * anim: { anims: [ 'red', 'green', 'blue', 'pink', 'white' ], [cycle: bool], [quantity: int] }
                 * @param anims One or more animations, or a configuration object.
                 * @param pickRandom Whether animations should be assigned at random from `anims`. If a config object is given, this parameter is ignored. Default true.
                 * @param quantity The number of consecutive particles that will receive each animation. If a config object is given, this parameter is ignored. Default 1.
                 */
                setAnim(anims: string | string[] | Phaser.Types.GameObjects.Particles.ParticleEmitterAnimConfig, pickRandom?: boolean, quantity?: number): this;

                /**
                 * Turns {@link Phaser.GameObjects.Particles.ParticleEmitter#radial} particle movement on or off.
                 * @param value Radial mode (true) or point mode (true). Default true.
                 */
                setRadial(value?: boolean): this;

                /**
                 * Creates a Particle Bounds processor and adds it to this Emitter.
                 * 
                 * This processor will check to see if any of the active Particles hit
                 * the defined boundary, as specified by a Rectangle shape in world-space.
                 * 
                 * If so, they are 'rebounded' back again by having their velocity adjusted.
                 * 
                 * The strength of the rebound is controlled by the `Particle.bounce`
                 * property.
                 * 
                 * You should be careful to ensure that you emit particles within a bounds,
                 * if set, otherwise it will lead to unpredictable visual results as the
                 * particles are hastily repositioned.
                 * 
                 * The Particle Bounds processor is returned from this method. If you wish
                 * to modify the area you can directly change its `bounds` property, along
                 * with the `collideLeft` etc values.
                 * 
                 * To disable the bounds you can either set its `active` property to `false`,
                 * or if you no longer require it, call `ParticleEmitter.removeParticleProcessor`.
                 * @param x The x-coordinate of the left edge of the boundary, or an object representing a rectangle.
                 * @param y The y-coordinate of the top edge of the boundary.
                 * @param width The width of the boundary.
                 * @param height The height of the boundary.
                 * @param collideLeft Whether particles interact with the left edge of the bounds. Default true.
                 * @param collideRight Whether particles interact with the right edge of the bounds. Default true.
                 * @param collideTop Whether particles interact with the top edge of the bounds. Default true.
                 * @param collideBottom Whether particles interact with the bottom edge of the bounds. Default true.
                 */
                addParticleBounds(x: number | Phaser.Types.GameObjects.Particles.ParticleEmitterBounds | Phaser.Types.GameObjects.Particles.ParticleEmitterBoundsAlt, y?: number, width?: number, height?: number, collideLeft?: boolean, collideRight?: boolean, collideTop?: boolean, collideBottom?: boolean): Phaser.GameObjects.Particles.ParticleBounds;

                /**
                 * Sets the initial radial speed of emitted particles.
                 * 
                 * Changes the emitter to radial mode.
                 * @param x The horizontal speed of the emitted Particles.
                 * @param y The vertical speed of emitted Particles. If not set it will use the `x` value. Default x.
                 */
                setParticleSpeed(x: number, y?: number): this;

                /**
                 * Sets the vertical and horizontal scale of the emitted particles.
                 * 
                 * You can also set the scale of the entire emitter via `setScale`.
                 * @param x The horizontal scale of the emitted Particles. Default 1.
                 * @param y The vertical scale of emitted Particles. If not set it will use the `x` value. Default x.
                 */
                setParticleScale(x?: number, y?: number): this;

                /**
                 * Sets the gravity applied to emitted particles.
                 * @param x Horizontal acceleration due to gravity, in pixels per second squared. Set to zero for no gravity.
                 * @param y Vertical acceleration due to gravity, in pixels per second squared. Set to zero for no gravity.
                 */
                setParticleGravity(x: number, y: number): this;

                /**
                 * Sets the opacity (alpha) of emitted particles.
                 * 
                 * You can also set the alpha of the entire emitter via `setAlpha`.
                 * @param value A value between 0 (transparent) and 1 (opaque).
                 */
                setParticleAlpha(value: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType): this;

                /**
                 * Sets the color tint of emitted particles.
                 * 
                 * This is a WebGL only feature.
                 * @param value A value between 0 and 0xffffff.
                 */
                setParticleTint(value: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType): this;

                /**
                 * Sets the angle of a {@link Phaser.GameObjects.Particles.ParticleEmitter#radial} particle stream.
                 * 
                 * The value is given in degrees using Phaser's right-handed coordinate system.
                 * @param value The angle of the initial velocity of emitted particles, in degrees.
                 */
                setEmitterAngle(value: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType): this;

                /**
                 * Sets the lifespan of newly emitted particles in milliseconds.
                 * @param value The lifespan of a particle, in ms.
                 */
                setParticleLifespan(value: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType): this;

                /**
                 * Sets the number of particles released at each flow cycle or explosion.
                 * @param quantity The number of particles to release at each flow cycle or explosion.
                 */
                setQuantity(quantity: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType): this;

                /**
                 * Sets the emitter's {@link Phaser.GameObjects.Particles.ParticleEmitter#frequency}
                 * and {@link Phaser.GameObjects.Particles.ParticleEmitter#quantity}.
                 * @param frequency The time interval (>= 0) of each flow cycle, in ms; or -1 to put the emitter in explosion mode.
                 * @param quantity The number of particles to release at each flow cycle or explosion.
                 */
                setFrequency(frequency: number, quantity?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType): this;

                /**
                 * Adds a new Particle Death Zone to this Emitter.
                 * 
                 * A particle is immediately killed as soon as its x/y coordinates intersect
                 * with any of the configured Death Zones.
                 * 
                 * The `source` can be a Geometry Shape, such as a Circle, Rectangle or Triangle.
                 * Any valid object from the `Phaser.Geometry` namespace is allowed, as long as
                 * it supports a `contains` function. You can set the `type` to be either `onEnter`
                 * or `onLeave`.
                 * 
                 * A single Death Zone instance can only exist once within this Emitter, but can belong
                 * to multiple Emitters.
                 * @param config A Death Zone configuration object, a Death Zone instance, a valid Geometry object or an array of them.
                 */
                addDeathZone(config: Phaser.Types.GameObjects.Particles.DeathZoneObject | Phaser.Types.GameObjects.Particles.DeathZoneObject[]): Phaser.GameObjects.Particles.Zones.DeathZone[];

                /**
                 * Removes the given Particle Death Zone from this Emitter.
                 * @param zone The Death Zone that should be removed from this Emitter.
                 */
                removeDeathZone(zone: Phaser.GameObjects.Particles.Zones.DeathZone): this;

                /**
                 * Clear all Death Zones from this Particle Emitter.
                 */
                clearDeathZones(): this;

                /**
                 * Adds a new Particle Emission Zone to this Emitter.
                 * 
                 * An {@link Phaser.Types.GameObjects.Particles.ParticleEmitterEdgeZoneConfig EdgeZone} places particles on its edges.
                 * Its {@link Phaser.Types.GameObjects.Particles.EdgeZoneSource source} can be a Curve, Path, Circle, Ellipse, Line, Polygon, Rectangle, or Triangle;
                 * or any object with a suitable {@link Phaser.Types.GameObjects.Particles.EdgeZoneSourceCallback getPoints} method.
                 * 
                 * A {@link Phaser.Types.GameObjects.Particles.ParticleEmitterRandomZoneConfig RandomZone} places the particles randomly within its interior.
                 * Its {@link RandomZoneSource source} can be a Circle, Ellipse, Line, Polygon, Rectangle, or Triangle; or any object with a suitable {@link Phaser.Types.GameObjects.Particles.RandomZoneSourceCallback getRandomPoint} method.
                 * 
                 * An Emission Zone can only exist once within this Emitter.
                 * @param zone An Emission Zone configuration object, a RandomZone or EdgeZone instance, or an array of them.
                 */
                addEmitZone(zone: Phaser.Types.GameObjects.Particles.EmitZoneData | Phaser.Types.GameObjects.Particles.EmitZoneData[]): Phaser.Types.GameObjects.Particles.EmitZoneObject[];

                /**
                 * Removes the given Particle Emission Zone from this Emitter.
                 * @param zone The Emission Zone that should be removed from this Emitter.
                 */
                removeEmitZone(zone: Phaser.GameObjects.Particles.Zones.EdgeZone | Phaser.GameObjects.Particles.Zones.RandomZone): this;

                /**
                 * Clear all Emission Zones from this Particle Emitter.
                 */
                clearEmitZones(): this;

                /**
                 * Takes the given particle and sets its x/y coordinates to match the next available
                 * emission zone, if any have been configured. This method is called automatically
                 * as part of the `Particle.fire` process.
                 * 
                 * The Emit Zones are iterated in sequence. Once a zone has had a particle emitted
                 * from it, then the next zone is used and so on, in a loop.
                 * @param particle The particle to set the emission zone for.
                 */
                getEmitZone(particle: Phaser.GameObjects.Particles.Particle): void;

                /**
                 * Takes the given particle and checks to see if any of the configured Death Zones
                 * will kill it and returns the result. This method is called automatically as part
                 * of the `Particle.update` process.
                 * @param particle The particle to test against the Death Zones.
                 */
                getDeathZone(particle: Phaser.GameObjects.Particles.Particle): boolean;

                /**
                 * Changes the currently active Emission Zone. The zones should have already
                 * been added to this Emitter either via the emitter config, or the
                 * `addEmitZone` method.
                 * 
                 * Call this method by passing either a numeric zone index value, or
                 * the zone instance itself.
                 * 
                 * Prior to v3.60 an Emitter could only have a single Emit Zone and this
                 * method was how you set it. From 3.60 and up it now performs a different
                 * function and swaps between all available active zones.
                 * @param zone The Emit Zone to set as the active zone.
                 */
                setEmitZone(zone: number | Phaser.GameObjects.Particles.Zones.EdgeZone | Phaser.GameObjects.Particles.Zones.RandomZone): this;

                /**
                 * Adds a Particle Processor, such as a Gravity Well, to this Emitter.
                 * 
                 * It will start processing particles from the next update as long as its `active`
                 * property is set.
                 * @param processor The Particle Processor to add to this Emitter Manager.
                 */
                addParticleProcessor<T extends Phaser.GameObjects.Particles.ParticleProcessor>(processor: T): T;

                /**
                 * Removes a Particle Processor from this Emitter.
                 * 
                 * The Processor must belong to this Emitter to be removed.
                 * 
                 * It is not destroyed when removed, allowing you to move it to another Emitter Manager,
                 * so if you no longer require it you should call its `destroy` method directly.
                 * @param processor The Particle Processor to remove from this Emitter Manager.
                 */
                removeParticleProcessor<T extends Phaser.GameObjects.Particles.ParticleProcessor>(processor: T): T | null;

                /**
                 * Gets all active Particle Processors.
                 */
                getProcessors(): Phaser.GameObjects.Particles.ParticleProcessor[];

                /**
                 * Creates a new Gravity Well, adds it to this Emitter and returns a reference to it.
                 * @param config Configuration settings for the Gravity Well to create.
                 */
                createGravityWell(config: Phaser.Types.GameObjects.Particles.GravityWellConfig): Phaser.GameObjects.Particles.GravityWell;

                /**
                 * Creates inactive particles and adds them to this emitter's pool.
                 * 
                 * If `ParticleEmitter.maxParticles` is set it will limit the
                 * value passed to this method to make sure it's not exceeded.
                 * @param count The number of particles to create.
                 */
                reserve(count: number): this;

                /**
                 * Gets the number of active (in-use) particles in this emitter.
                 */
                getAliveParticleCount(): number;

                /**
                 * Gets the number of inactive (available) particles in this emitter.
                 */
                getDeadParticleCount(): number;

                /**
                 * Gets the total number of particles in this emitter.
                 */
                getParticleCount(): number;

                /**
                 * Whether this emitter is at either its hard-cap limit (maxParticles), if set, or
                 * the max allowed number of 'alive' particles (maxAliveParticles).
                 */
                atLimit(): boolean;

                /**
                 * Sets a function to call for each newly emitted particle.
                 * @param callback The function.
                 * @param context The calling context.
                 */
                onParticleEmit(callback: Phaser.Types.GameObjects.Particles.ParticleEmitterCallback, context?: any): this;

                /**
                 * Sets a function to call for each particle death.
                 * @param callback The function.
                 * @param context The function's calling context.
                 */
                onParticleDeath(callback: Phaser.Types.GameObjects.Particles.ParticleDeathCallback, context?: any): this;

                /**
                 * Deactivates every particle in this emitter immediately.
                 * 
                 * This particles are killed but do not emit an event or callback.
                 */
                killAll(): this;

                /**
                 * Calls a function for each active particle in this emitter. The function is
                 * sent two parameters: a reference to the Particle instance and to this Emitter.
                 * @param callback The function.
                 * @param context The functions calling context.
                 */
                forEachAlive(callback: Phaser.Types.GameObjects.Particles.ParticleEmitterCallback, context: any): this;

                /**
                 * Calls a function for each inactive particle in this emitter.
                 * @param callback The function.
                 * @param context The functions calling context.
                 */
                forEachDead(callback: Phaser.Types.GameObjects.Particles.ParticleEmitterCallback, context: any): this;

                /**
                 * Turns {@link Phaser.GameObjects.Particles.ParticleEmitter#on} the emitter and resets the flow counter.
                 * 
                 * If this emitter is in flow mode (frequency >= 0; the default), the particle flow will start (or restart).
                 * 
                 * If this emitter is in explode mode (frequency = -1), nothing will happen.
                 * Use {@link Phaser.GameObjects.Particles.ParticleEmitter#explode} or {@link Phaser.GameObjects.Particles.ParticleEmitter#flow} instead.
                 * 
                 * Calling this method will emit the `START` event.
                 * @param advance Advance this number of ms in time through the emitter. Default 0.
                 * @param duration Limit this emitter to only emit particles for the given number of ms. Setting this parameter will override any duration already set in the Emitter configuration object. Default 0.
                 */
                start(advance?: number, duration?: number): this;

                /**
                 * Turns {@link Phaser.GameObjects.Particles.ParticleEmitter#emitting off} the emitter and
                 * stops it from emitting further particles. Currently alive particles will remain
                 * active until they naturally expire unless you set the `kill` parameter to `true`.
                 * 
                 * Calling this method will emit the `STOP` event. When the final particle has
                 * expired the `COMPLETE` event will be emitted.
                 * @param kill Kill all particles immediately (true), or leave them to die after their lifespan expires? (false, the default) Default false.
                 */
                stop(kill?: boolean): this;

                /**
                 * {@link Phaser.GameObjects.Particles.ParticleEmitter#active Deactivates} the emitter.
                 */
                pause(): this;

                /**
                 * {@link Phaser.GameObjects.Particles.ParticleEmitter#active Activates} the emitter.
                 */
                resume(): this;

                /**
                 * Set the property by which active particles are sorted prior to be rendered.
                 * 
                 * It allows you to control the rendering order of the particles.
                 * 
                 * This can be any valid property of the `Particle` class, such as `y`, `alpha`
                 * or `lifeT`.
                 * 
                 * The 'alive' particles array is sorted in place each game frame. Setting a
                 * sort property will override the `particleBringToTop` setting.
                 * 
                 * If you wish to use your own sorting function, see `setSortCallback` instead.
                 * @param property The property on the `Particle` class to sort by.
                 * @param ascending Should the particles be sorted in ascending or descending order? Default true.
                 */
                setSortProperty(property?: string, ascending?: boolean): this;

                /**
                 * Sets a callback to be used to sort the particles before rendering each frame.
                 * 
                 * This allows you to define your own logic and behavior in the callback.
                 * 
                 * The callback will be sent two parameters: the two Particles being compared,
                 * and must adhere to the criteria of the `compareFn` in `Array.sort`:
                 * 
                 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/sort#description
                 * 
                 * Call this method with no parameters to reset the sort callback.
                 * 
                 * Setting your own callback will override both the `particleBringToTop` and
                 * `sortProperty` settings of this Emitter.
                 * @param callback The callback to invoke when the particles are sorted. Leave undefined to reset to the default.
                 */
                setSortCallback(callback?: Phaser.Types.GameObjects.Particles.ParticleSortCallback): this;

                /**
                 * Sorts active particles with {@link Phaser.GameObjects.Particles.ParticleEmitter#depthSortCallback}.
                 */
                depthSort(): this;

                /**
                 * Calculates the difference of two particles, for sorting them by depth.
                 * @param a The first particle.
                 * @param b The second particle.
                 */
                depthSortCallback(a: object, b: object): number;

                /**
                 * Puts the emitter in flow mode (frequency >= 0) and starts (or restarts) a particle flow.
                 * 
                 * To resume a flow at the current frequency and quantity, use {@link Phaser.GameObjects.Particles.ParticleEmitter#start} instead.
                 * @param frequency The time interval (>= 0) of each flow cycle, in ms.
                 * @param count The number of particles to emit at each flow cycle. Default 1.
                 * @param stopAfter Stop this emitter from firing any more particles once this value is reached. Set to zero for unlimited. Setting this parameter will override any `stopAfter` value already set in the Emitter configuration object.
                 */
                flow(frequency: number, count?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType, stopAfter?: number): this;

                /**
                 * Puts the emitter in explode mode (frequency = -1), stopping any current particle flow, and emits several particles all at once.
                 * @param count The number of Particles to emit. Default this.quantity.
                 * @param x The x coordinate to emit the Particles from. Default this.x.
                 * @param y The y coordinate to emit the Particles from. Default this.x.
                 */
                explode(count?: number, x?: number, y?: number): Phaser.GameObjects.Particles.Particle | undefined;

                /**
                 * Emits particles at the given position. If no position is given, it will
                 * emit from this Emitters current location.
                 * @param x The x coordinate to emit the Particles from. Default this.x.
                 * @param y The y coordinate to emit the Particles from. Default this.x.
                 * @param count The number of Particles to emit. Default this.quantity.
                 */
                emitParticleAt(x?: number, y?: number, count?: number): Phaser.GameObjects.Particles.Particle | undefined;

                /**
                 * Emits particles at a given position (or the emitters current position).
                 * @param count The number of Particles to emit. Default this.quantity.
                 * @param x The x coordinate to emit the Particles from. Default this.x.
                 * @param y The y coordinate to emit the Particles from. Default this.x.
                 */
                emitParticle(count?: number, x?: number, y?: number): Phaser.GameObjects.Particles.Particle | undefined;

                /**
                 * Fast forwards this Particle Emitter and all of its particles.
                 * 
                 * Works by running the Emitter `preUpdate` handler in a loop until the `time`
                 * has been reached at `delta` steps per loop.
                 * 
                 * All callbacks and emitter related events that would normally be fired
                 * will still be invoked.
                 * 
                 * You can make an emitter 'fast forward' via the emitter config using the
                 * `advance` property. Set this value to the number of ms you wish the
                 * emitter to be fast-forwarded by. Or, call this method post-creation.
                 * @param time The number of ms to advance the Particle Emitter by.
                 * @param delta The amount of delta to use for each step. Defaults to 1000 / 60.
                 */
                fastForward(time: number, delta?: number): this;

                /**
                 * Updates this emitter and its particles.
                 * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                 * @param delta The delta time, in ms, elapsed since the last frame.
                 */
                preUpdate(time: number, delta: number): void;

                /**
                 * Takes either a Rectangle Geometry object or an Arcade Physics Body and tests
                 * to see if it intersects with any currently alive Particle in this Emitter.
                 * 
                 * Overlapping particles are returned in an array, where you can perform further
                 * processing on them. If nothing overlaps then the array will be empty.
                 * @param target A Rectangle or Arcade Physics Body to check for intersection against all alive particles.
                 */
                overlap(target: Phaser.Geom.Rectangle | Phaser.Physics.Arcade.Body): Phaser.GameObjects.Particles.Particle[];

                /**
                 * Returns a bounds Rectangle calculated from the bounds of all currently
                 * _active_ Particles in this Emitter. If this Emitter has only just been
                 * created and not yet rendered, then calling this method will return a Rectangle
                 * with a max safe integer for dimensions. Use the `advance` parameter to
                 * avoid this.
                 * 
                 * Typically it takes a few seconds for a flow Emitter to 'warm up'. You can
                 * use the `advance` and `delta` parameters to force the Emitter to
                 * 'fast forward' in time to try and allow the bounds to be more accurate,
                 * as it will calculate the bounds based on the particle bounds across all
                 * timesteps, giving a better result.
                 * 
                 * You can also use the `padding` parameter to increase the size of the
                 * bounds. Emitters with a lot of randomness in terms of direction or lifespan
                 * can often return a bounds smaller than their possible maximum. By using
                 * the `padding` (and `advance` if needed) you can help limit this.
                 * @param padding The amount of padding, in pixels, to add to the bounds Rectangle.
                 * @param advance The number of ms to advance the Particle Emitter by. Defaults to 0, i.e. not used.
                 * @param delta The amount of delta to use for each step. Defaults to 1000 / 60.
                 * @param output The Rectangle to store the results in. If not given a new one will be created.
                 */
                getBounds(padding?: number, advance?: number, delta?: number, output?: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle;

                /**
                 * Prints a warning to the console if you mistakenly call this function
                 * thinking it works the same way as Phaser v3.55.
                 */
                createEmitter(): void;

                /**
                 * The x coordinate the particles are emitted from.
                 * 
                 * This is relative to the Emitters x coordinate and that of any parent.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;

                /**
                 * The y coordinate the particles are emitted from.
                 * 
                 * This is relative to the Emitters x coordinate and that of any parent.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;

                /**
                 * The horizontal acceleration applied to emitted particles, in pixels per second squared.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                accelerationX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The vertical acceleration applied to emitted particles, in pixels per second squared.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                accelerationY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The maximum horizontal velocity emitted particles can reach, in pixels per second squared.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                maxVelocityX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The maximum vertical velocity emitted particles can reach, in pixels per second squared.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                maxVelocityY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The initial speed of emitted particles, in pixels per second.
                 * 
                 * If using this as a getter it will return the `speedX` value.
                 * 
                 * If using it as a setter it will update both `speedX` and `speedY` to the
                 * given value.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                speed: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The initial horizontal speed of emitted particles, in pixels per second.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                speedX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The initial vertical speed of emitted particles, in pixels per second.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                speedY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The x coordinate emitted particles move toward, when {@link Phaser.GameObjects.Particles.ParticleEmitter#moveTo} is true.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                moveToX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The y coordinate emitted particles move toward, when {@link Phaser.GameObjects.Particles.ParticleEmitter#moveTo} is true.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                moveToY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The amount of velocity particles will use when rebounding off the
                 * emitter bounds, if set. A value of 0 means no bounce. A value of 1
                 * means a full rebound.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                bounce: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The horizontal scale of emitted particles.
                 * 
                 * This is relative to the Emitters scale and that of any parent.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleScaleX: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The vertical scale of emitted particles.
                 * 
                 * This is relative to the Emitters scale and that of any parent.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleScaleY: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * A color tint value that is applied to the texture of the emitted
                 * particle. The value should be given in hex format, i.e. 0xff0000
                 * for a red tint, and should not include the alpha channel.
                 * 
                 * Tints are additive, meaning a tint value of white (0xffffff) will
                 * effectively reset the tint to nothing.
                 * 
                 * Modify the `ParticleEmitter.tintFill` property to change between
                 * an additive and replacement tint mode.
                 * 
                 * When you define the color via the Emitter config you should give
                 * it as an array of color values. The Particle will then interpolate
                 * through these colors over the course of its lifespan. Setting this
                 * will override any `tint` value that may also be given.
                 * 
                 * This is a WebGL only feature.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleColor: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * Controls the easing function used when you have created an
                 * Emitter that uses the `color` property to interpolate the
                 * tint of Particles over their lifetime.
                 * 
                 * Setting this has no effect if you haven't also applied a
                 * `particleColor` to this Emitter.
                 */
                colorEase: string;

                /**
                 * A color tint value that is applied to the texture of the emitted
                 * particle. The value should be given in hex format, i.e. 0xff0000
                 * for a red tint, and should not include the alpha channel.
                 * 
                 * Tints are additive, meaning a tint value of white (0xffffff) will
                 * effectively reset the tint to nothing.
                 * 
                 * Modify the `ParticleEmitter.tintFill` property to change between
                 * an additive and replacement tint mode.
                 * 
                 * The `tint` value will be overriden if a `color` array is provided.
                 * 
                 * This is a WebGL only feature.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleTint: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The alpha value of the emitted particles. This is a value
                 * between 0 and 1. Particles with alpha zero are invisible
                 * and are therefore not rendered, but are still processed
                 * by the Emitter.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleAlpha: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The lifespan of the emitted particles. This value is given
                 * in milliseconds and defaults to 1000ms (1 second). When a
                 * particle reaches this amount it is killed.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                lifespan: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The angle at which the particles are emitted. The values are
                 * given in degrees. This allows you to control the direction
                 * of the emitter. If you wish instead to change the rotation
                 * of the particles themselves, see the `particleRotate` property.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleAngle: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The rotation (or angle) of each particle when it is emitted.
                 * The value is given in degrees and uses a right-handed
                 * coordinate system, where 0 degrees points to the right, 90 degrees
                 * points down and -90 degrees points up.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                particleRotate: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The number of particles that are emitted each time an emission
                 * occurs, i.e. from one 'explosion' or each frame in a 'flow' cycle.
                 * 
                 * The default is 1.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                quantity: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The number of milliseconds to wait after emission before
                 * the particles start updating. This allows you to emit particles
                 * that appear 'static' or still on-screen and then, after this value,
                 * begin to move.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                delay: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The number of milliseconds to wait after a particle has finished
                 * its life before it will be removed. This allows you to 'hold' a
                 * particle on the screen once it has reached its final state
                 * before it then vanishes.
                 * 
                 * Note that all particle updates will cease, including changing
                 * alpha, scale, movement or animation.
                 * 
                 * Accessing this property should typically return a number.
                 * However, it can be set to any valid EmitterOp onEmit type.
                 */
                hold: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;

                /**
                 * The internal flow counter.
                 * 
                 * Treat this property as read-only.
                 */
                flowCounter: number;

                /**
                 * The internal frame counter.
                 * 
                 * Treat this property as read-only.
                 */
                frameCounter: number;

                /**
                 * The internal animation counter.
                 * 
                 * Treat this property as read-only.
                 */
                animCounter: number;

                /**
                 * The internal elasped counter.
                 * 
                 * Treat this property as read-only.
                 */
                elapsed: number;

                /**
                 * The internal stop counter.
                 * 
                 * Treat this property as read-only.
                 */
                stopCounter: number;

                /**
                 * The internal complete flag.
                 * 
                 * Treat this property as read-only.
                 */
                completeFlag: boolean;

                /**
                 * The internal zone index.
                 * 
                 * Treat this property as read-only.
                 */
                zoneIndex: number;

                /**
                 * The internal zone total.
                 * 
                 * Treat this property as read-only.
                 */
                zoneTotal: number;

                /**
                 * The current frame index.
                 * 
                 * Treat this property as read-only.
                 */
                currentFrame: number;

                /**
                 * The current animation index.
                 * 
                 * Treat this property as read-only.
                 */
                currentAnim: number;

                /**
                 * Destroys this Particle Emitter and all Particles it owns.
                 */
                preDestroy(): void;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * @param value The alpha value applied across the whole Game Object. Default 1.
                 */
                setAlpha(value?: number): this;

                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;

                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;

                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;

                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;

                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;

                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;

                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;

                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;

                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;

                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * 
                 * Calling this method will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
                 * @param frame The name or index of the frame within the Texture.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call change the origin of the Game Object? Default true.
                 */
                setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;

                /**
                 * The x position of this Game Object.
                 */
                x: number;

                /**
                 * The y position of this Game Object.
                 */
                y: number;

                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;

                /**
                 * The w position of this Game Object.
                 */
                w: number;

                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;

                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;

                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;

                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;

                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;

                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;

                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;

                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;

                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;

                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;

                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;

                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;

                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;

                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;

                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;

            }

            /**
             * This class provides the structured required for all Particle Processors.
             * 
             * You should extend it and add the functionality required for your processor,
             * including tidying up any resources this may create in the `destroy` method.
             * 
             * See the GravityWell for an example of a processor.
             */
            class ParticleProcessor {
                /**
                 * 
                 * @param x The x coordinate of the Particle Processor, in world space. Default 0.
                 * @param y The y coordinate of the Particle Processor, in world space. Default 0.
                 * @param active The active state of this Particle Processor. Default true.
                 */
                constructor(x?: number, y?: number, active?: boolean);

                /**
                 * A reference to the Particle Emitter that owns this Processor.
                 * This is set automatically when the Processor is added to an Emitter
                 * and nulled when removed or destroyed.
                 */
                manager: Phaser.GameObjects.Particles.ParticleEmitter;

                /**
                 * The x coordinate of the Particle Processor, in world space.
                 */
                x: number;

                /**
                 * The y coordinate of the Particle Processor, in world space.
                 */
                y: number;

                /**
                 * The active state of the Particle Processor.
                 * 
                 * An inactive Particle Processor will be skipped for processing by
                 * its parent Emitter.
                 */
                active: boolean;

                /**
                 * The Particle Processor update method should be overriden by your own
                 * method and handle the processing of the particles, typically modifying
                 * their velocityX/Y values based on the criteria of this processor.
                 * @param particle The Particle to update.
                 * @param delta The delta time in ms.
                 * @param step The delta value divided by 1000.
                 * @param t The current normalized lifetime of the particle, between 0 (birth) and 1 (death).
                 */
                update(particle: Phaser.GameObjects.Particles.Particle, delta: number, step: number, t: number): void;

                /**
                 * Destroys this Particle Processor by removing all external references.
                 * 
                 * This is called automatically when the owning Particle Emitter is destroyed.
                 */
                destroy(): void;

            }

            namespace Zones {
                /**
                 * A Death Zone.
                 * 
                 * A Death Zone is a special type of zone that will kill a Particle as soon as it either enters, or leaves, the zone.
                 * 
                 * The zone consists of a `source` which could be a Geometric shape, such as a Rectangle or Ellipse, or your own
                 * object as long as it includes a `contains` method for which the Particles can be tested against.
                 */
                class DeathZone {
                    /**
                     * 
                     * @param source An object instance that has a `contains` method that returns a boolean when given `x` and `y` arguments.
                     * @param killOnEnter Should the Particle be killed when it enters the zone? `true` or leaves it? `false`
                     */
                    constructor(source: Phaser.Types.GameObjects.Particles.DeathZoneSource, killOnEnter: boolean);

                    /**
                     * An object instance that has a `contains` method that returns a boolean when given `x` and `y` arguments.
                     * This could be a Geometry shape, such as `Phaser.Geom.Circle`, or your own custom object.
                     */
                    source: Phaser.Types.GameObjects.Particles.DeathZoneSource;

                    /**
                     * Set to `true` if the Particle should be killed if it enters this zone.
                     * Set to `false` to kill the Particle if it leaves this zone.
                     */
                    killOnEnter: boolean;

                    /**
                     * Checks if the given Particle will be killed or not by this zone.
                     * @param particle The particle to test against this Death Zones.
                     */
                    willKill(particle: Phaser.GameObjects.Particles.Particle): boolean;

                }

                /**
                 * A zone that places particles on a shape's edges.
                 */
                class EdgeZone {
                    /**
                     * 
                     * @param source An object instance with a `getPoints(quantity, stepRate)` method returning an array of points.
                     * @param quantity The number of particles to place on the source edge. Set to 0 to use `stepRate` instead.
                     * @param stepRate The distance between each particle. When set, `quantity` is implied and should be set to 0.
                     * @param yoyo Whether particles are placed from start to end and then end to start. Default false.
                     * @param seamless Whether one endpoint will be removed if it's identical to the other. Default true.
                     * @param total The total number of particles this zone will emit before passing over to the next emission zone in the Emitter. -1 means it will never pass over and you must use `setEmitZone` to change it. Default -1.
                     */
                    constructor(source: Phaser.Types.GameObjects.Particles.EdgeZoneSource, quantity: number, stepRate?: number, yoyo?: boolean, seamless?: boolean, total?: number);

                    /**
                     * An object instance with a `getPoints(quantity, stepRate)` method returning an array of points.
                     */
                    source: Phaser.Types.GameObjects.Particles.EdgeZoneSource | Phaser.Types.GameObjects.Particles.RandomZoneSource;

                    /**
                     * The points placed on the source edge.
                     */
                    points: Phaser.Geom.Point[];

                    /**
                     * The number of particles to place on the source edge. Set to 0 to use `stepRate` instead.
                     */
                    quantity: number;

                    /**
                     * The distance between each particle. When set, `quantity` is implied and should be set to 0.
                     */
                    stepRate: number;

                    /**
                     * Whether particles are placed from start to end and then end to start.
                     */
                    yoyo: boolean;

                    /**
                     * The counter used for iterating the EdgeZone's points.
                     */
                    counter: number;

                    /**
                     * Whether one endpoint will be removed if it's identical to the other.
                     */
                    seamless: boolean;

                    /**
                     * The total number of particles this zone will emit before the Emitter
                     * transfers control over to the next zone in its emission zone list.
                     * 
                     * By default this is -1, meaning it will never pass over from this
                     * zone to another one. You can call the `ParticleEmitter.setEmitZone`
                     * method to change it, or set this value to something else via the
                     * config, or directly at runtime.
                     * 
                     * A value of 1 would mean the zones rotate in order, but it can
                     * be set to any integer value.
                     */
                    total: number;

                    /**
                     * Update the {@link Phaser.GameObjects.Particles.Zones.EdgeZone#points} from the EdgeZone's
                     * {@link Phaser.GameObjects.Particles.Zones.EdgeZone#source}.
                     * 
                     * Also updates internal properties.
                     */
                    updateSource(): this;

                    /**
                     * Change the source of the EdgeZone.
                     * @param source An object instance with a `getPoints(quantity, stepRate)` method returning an array of points.
                     */
                    changeSource(source: Phaser.Types.GameObjects.Particles.EdgeZoneSource): this;

                    /**
                     * Get the next point in the Zone and set its coordinates on the given Particle.
                     * @param particle The Particle.
                     */
                    getPoint(particle: Phaser.GameObjects.Particles.Particle): void;

                }

                /**
                 * A zone that places particles randomly within a shapes area.
                 */
                class RandomZone {
                    /**
                     * 
                     * @param source An object instance with a `getRandomPoint(point)` method.
                     */
                    constructor(source: Phaser.Types.GameObjects.Particles.RandomZoneSource);

                    /**
                     * An object instance with a `getRandomPoint(point)` method.
                     */
                    source: Phaser.Types.GameObjects.Particles.RandomZoneSource;

                    /**
                     * The total number of particles this zone will emit before the Emitter
                     * transfers control over to the next zone in its emission zone list.
                     * 
                     * By default this is -1, meaning it will never pass over from this
                     * zone to another one. You can call the `ParticleEmitter.setEmitZone`
                     * method to change it, or set this value to something else via the
                     * config, or directly at runtime.
                     * 
                     * A value of 1 would mean the zones rotate in order, but it can
                     * be set to any integer value.
                     */
                    total: number;

                    /**
                     * Get the next point in the Zone and set its coordinates on the given Particle.
                     * @param particle The Particle.
                     */
                    getPoint(particle: Phaser.GameObjects.Particles.Particle): void;

                }

            }

        }

        /**
         * A PathFollower Game Object.
         * 
         * A PathFollower is a Sprite Game Object with some extra helpers to allow it to follow a Path automatically.
         * 
         * Anything you can do with a standard Sprite can be done with this PathFollower, such as animate it, tint it,
         * scale it and so on.
         * 
         * PathFollowers are bound to a single Path at any one time and can traverse the length of the Path, from start
         * to finish, forwards or backwards, or from any given point on the Path to its end. They can optionally rotate
         * to face the direction of the path, be offset from the path coordinates or rotate independently of the Path.
         */
        class PathFollower extends Phaser.GameObjects.Sprite implements Phaser.GameObjects.Components.PathFollower {
            /**
             * 
             * @param scene The Scene to which this PathFollower belongs.
             * @param path The Path this PathFollower is following. It can only follow one Path at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            constructor(scene: Phaser.Scene, path: Phaser.Curves.Path, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number);

            /**
             * If the PathFollower is rotating to match the Path (@see Phaser.GameObjects.PathFollower#rotateToPath)
             * this value is added to the rotation value. This allows you to rotate objects to a path but control
             * the angle of the rotation as well.
             */
            pathRotationOffset: number;

            /**
             * An additional vector to add to the PathFollowers position, allowing you to offset it from the
             * Path coordinates.
             */
            pathOffset: Phaser.Math.Vector2;

            /**
             * A Vector2 that stores the current point of the path the follower is on.
             */
            pathVector: Phaser.Math.Vector2;

            /**
             * The distance the follower has traveled from the previous point to the current one, at the last update.
             */
            pathDelta: Phaser.Math.Vector2;

            /**
             * The Tween used for following the Path.
             */
            pathTween: Phaser.Tweens.Tween;

            /**
             * Settings for the PathFollower.
             */
            pathConfig: Phaser.Types.GameObjects.PathFollower.PathConfig | null;

            /**
             * Internal update handler that advances this PathFollower along the path.
             * 
             * Called automatically by the Scene step, should not typically be called directly.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            protected preUpdate(time: number, delta: number): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

            /**
             * The Path this PathFollower is following. It can only follow one Path at a time.
             */
            path: Phaser.Curves.Path;

            /**
             * Should the PathFollower automatically rotate to point in the direction of the Path?
             */
            rotateToPath: boolean;

            /**
             * Set the Path that this PathFollower should follow.
             * 
             * Optionally accepts {@link Phaser.Types.GameObjects.PathFollower.PathConfig} settings.
             * @param path The Path this PathFollower is following. It can only follow one Path at a time.
             * @param config Settings for the PathFollower.
             */
            setPath(path: Phaser.Curves.Path, config?: number | Phaser.Types.GameObjects.PathFollower.PathConfig | Phaser.Types.Tweens.NumberTweenBuilderConfig): this;

            /**
             * Set whether the PathFollower should automatically rotate to point in the direction of the Path.
             * @param value Whether the PathFollower should automatically rotate to point in the direction of the Path.
             * @param offset Rotation offset in degrees. Default 0.
             */
            setRotateToPath(value: boolean, offset?: number): this;

            /**
             * Is this PathFollower actively following a Path or not?
             * 
             * To be considered as `isFollowing` it must be currently moving on a Path, and not paused.
             */
            isFollowing(): boolean;

            /**
             * Starts this PathFollower following its given Path.
             * @param config The duration of the follow, or a PathFollower config object. Default {}.
             * @param startAt Optional start position of the follow, between 0 and 1. Default 0.
             */
            startFollow(config?: number | Phaser.Types.GameObjects.PathFollower.PathConfig | Phaser.Types.Tweens.NumberTweenBuilderConfig, startAt?: number): this;

            /**
             * Pauses this PathFollower. It will still continue to render, but it will remain motionless at the
             * point on the Path at which you paused it.
             */
            pauseFollow(): this;

            /**
             * Resumes a previously paused PathFollower.
             * 
             * If the PathFollower was not paused this has no effect.
             */
            resumeFollow(): this;

            /**
             * Stops this PathFollower from following the path any longer.
             * 
             * This will invoke any 'stop' conditions that may exist on the Path, or for the follower.
             */
            stopFollow(): this;

            /**
             * Internal update handler that advances this PathFollower along the path.
             * 
             * Called automatically by the Scene step, should not typically be called directly.
             */
            pathUpdate(): void;

        }

        /**
         * A Plane Game Object.
         * 
         * The Plane Game Object is a helper class that takes the Mesh Game Object and extends it,
         * allowing for fast and easy creation of Planes. A Plane is a one-sided grid of cells,
         * where you specify the number of cells in each dimension. The Plane can have a texture
         * that is either repeated (tiled) across each cell, or applied to the full Plane.
         * 
         * The Plane can then be manipulated in 3D space, with rotation across all 3 axis.
         * 
         * This allows you to create effects not possible with regular Sprites, such as perspective
         * distortion. You can also adjust the vertices on a per-vertex basis. Plane data becomes
         * part of the WebGL batch, just like standard Sprites, so doesn't introduce any additional
         * shader overhead. Because the Plane just generates vertices into the WebGL batch, like any
         * other Sprite, you can use all of the common Game Object components on a Plane too,
         * such as a custom pipeline, mask, blend mode or texture.
         * 
         * You can use the `uvScroll` and `uvScale` methods to adjust the placement and scaling
         * of the texture if this Plane is using a single texture, and not a frame from a texture
         * atlas or sprite sheet.
         * 
         * The Plane Game Object also has the Animation component, allowing you to play animations
         * across the Plane just as you would with a Sprite.
         * 
         * Note that the Plane object is WebGL only and does not have a Canvas counterpart.
         * 
         * The Plane origin is always 0.5 x 0.5 and cannot be changed.
         */
        class Plane extends Phaser.GameObjects.Mesh {
            /**
             * 
             * @param scene The Scene to which this Plane belongs. A Plane can only belong to one Scene at a time.
             * @param x The horizontal position of this Plane in the world.
             * @param y The vertical position of this Plane in the world.
             * @param texture The key, or instance of the Texture this Plane will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Plane is rendering with.
             * @param width The width of this Plane, in cells, not pixels. Default 8.
             * @param height The height of this Plane, in cells, not pixels. Default 8.
             * @param tile Is the texture tiled? I.e. repeated across each cell. Default false.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number, width?: number, height?: number, tile?: boolean);

            /**
             * The Animation State component of this Sprite.
             * 
             * This component provides features to apply animations to this Sprite.
             * It is responsible for playing, loading, queuing animations for later playback,
             * mixing between animations and setting the current animation frame to this Sprite.
             */
            anims: Phaser.Animations.AnimationState;

            /**
             * The width of this Plane in cells, not pixels.
             * 
             * This value is read-only. To adjust it, see the `setGridSize` method.
             */
            readonly gridWidth: number;

            /**
             * The height of this Plane in cells, not pixels.
             * 
             * This value is read-only. To adjust it, see the `setGridSize` method.
             */
            readonly gridHeight: number;

            /**
             * Is the texture of this Plane tiled across all cells, or not?
             * 
             * This value is read-only. To adjust it, see the `setGridSize` method.
             */
            readonly isTiled: boolean;

            /**
             * Do not change this value. It has no effect other than to break things.
             */
            readonly originX: number;

            /**
             * Do not change this value. It has no effect other than to break things.
             */
            readonly originY: number;

            /**
             * Modifies the layout of this Plane by adjusting the grid dimensions to the
             * given width and height. The values are given in cells, not pixels.
             * 
             * The `tile` parameter allows you to control if the texture is tiled, or
             * applied across the entire Plane? A tiled texture will repeat with one
             * iteration per cell. A non-tiled texture will be applied across the whole
             * Plane.
             * 
             * Note that if this Plane is using a single texture, not from a texture atlas
             * or sprite sheet, then you can use the `Plane.uvScale` method to have much
             * more fine-grained control over the texture tiling.
             * @param width The width of this Plane, in cells, not pixels. Default 8.
             * @param height The height of this Plane, in cells, not pixels. Default 8.
             * @param tile Is the texture tiled? I.e. repeated across each cell. Default false.
             */
            preDestroy(width?: number, height?: number, tile?: boolean): void;

            /**
             * Sets the height of this Plane to match the given value, in pixels.
             * 
             * This adjusts the `Plane.viewPosition.z` value to achieve this.
             * 
             * If no `value` parameter is given, it will set the view height to match
             * that of the current texture frame the Plane is using.
             * @param value The height, in pixels, to set this Plane view height to.
             */
            setViewHeight(value?: number): void;

            /**
             * Creates a checkerboard style texture, based on the given colors and alpha
             * values and applies it to this Plane, replacing any current texture it may
             * have.
             * 
             * The colors are used in an alternating pattern, like a chess board.
             * 
             * Calling this method generates a brand new 16x16 pixel WebGLTexture internally
             * and applies it to this Plane. While quite fast to do, you should still be
             * mindful of calling this method either extensively, or in tight parts of
             * your game.
             * @param color1 The odd cell color, specified as a hex value. Default 0xffffff.
             * @param color2 The even cell color, specified as a hex value. Default 0x0000ff.
             * @param alpha1 The odd cell alpha value, specified as a number between 0 and 255. Default 255.
             * @param alpha2 The even cell alpha value, specified as a number between 0 and 255. Default 255.
             * @param height The view height of the Plane after creation, in pixels. Default 128.
             */
            createCheckerboard(color1?: number, color2?: number, alpha1?: number, alpha2?: number, height?: number): void;

            /**
             * If this Plane has a Checkerboard Texture, this method will destroy it
             * and reset the internal flag for it.
             */
            removeCheckerboard(): void;

            /**
             * Start playing the given animation on this Plane.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to this Plane.
             * 
             * The benefit of a global animation is that multiple Game Objects can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any animating Game Object.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Plane, and this Plane alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Plane.
             * 
             * With the animation created, either globally or locally, you can now play it on this Plane:
             * 
             * ```javascript
             * const plane = this.add.plane(...);
             * plane.play('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * const plane = this.add.plane(...);
             * plane.play({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Plane it will first check to see if it can find a matching key
             * locally within the Plane. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Plane to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             */
            play(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): this;

            /**
             * Start playing the given animation on this Plane, in reverse.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to a Game Object.
             * 
             * The benefit of a global animation is that multiple Game Objects can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any animating Game Object.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Game Object, and this Game Object alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Game Object.
             * 
             * With the animation created, either globally or locally, you can now play it on this Game Object:
             * 
             * ```javascript
             * const plane = this.add.plane(...);
             * plane.playReverse('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate, for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * const plane = this.add.plane(...);
             * plane.playReverse({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Game Object it will first check to see if it can find a matching key
             * locally within the Game Object. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Game Object to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             */
            playReverse(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): this;

            /**
             * Waits for the specified delay, in milliseconds, then starts playback of the given animation.
             * 
             * If the animation _also_ has a delay value set in its config, it will be **added** to the delay given here.
             * 
             * If an animation is already running and a new animation is given to this method, it will wait for
             * the given delay before starting the new animation.
             * 
             * If no animation is currently running, the given one begins after the delay.
             * 
             * When playing an animation on a Game Object it will first check to see if it can find a matching key
             * locally within the Game Object. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param delay The delay, in milliseconds, to wait before starting the animation playing.
             */
            playAfterDelay(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, delay: number): this;

            /**
             * Waits for the current animation to complete the `repeatCount` number of repeat cycles, then starts playback
             * of the given animation.
             * 
             * You can use this to ensure there are no harsh jumps between two sets of animations, i.e. going from an
             * idle animation to a walking animation, by making them blend smoothly into each other.
             * 
             * If no animation is currently running, the given one will start immediately.
             * 
             * When playing an animation on a Game Object it will first check to see if it can find a matching key
             * locally within the Game Object. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param repeatCount How many times should the animation repeat before the next one starts? Default 1.
             */
            playAfterRepeat(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, repeatCount?: number): this;

            /**
             * Immediately stops the current animation from playing and dispatches the `ANIMATION_STOP` events.
             * 
             * If no animation is playing, no event will be dispatched.
             * 
             * If there is another animation queued (via the `chain` method) then it will start playing immediately.
             */
            stop(): this;

            /**
             * Stops the current animation from playing after the specified time delay, given in milliseconds.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param delay The number of milliseconds to wait before stopping this animation.
             */
            stopAfterDelay(delay: number): this;

            /**
             * Stops the current animation from playing after the given number of repeats.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param repeatCount How many times should the animation repeat before stopping? Default 1.
             */
            stopAfterRepeat(repeatCount?: number): this;

            /**
             * Stops the current animation from playing when it next sets the given frame.
             * If this frame doesn't exist within the animation it will not stop it from playing.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param frame The frame to check before stopping this animation.
             */
            stopOnFrame(frame: Phaser.Animations.AnimationFrame): this;

            /**
             * Runs the preUpdate for this Plane, which will check its Animation State,
             * if one is playing, and refresh view / model matrices, if updated.
             * @param time The current timestamp.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            protected preUpdate(time: number, delta: number): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * An internal method that resets the perspective projection for this Plane
             * when it changes texture or frame, and also resets the cell UV coordinates,
             * if required.
             * @param resetUV Reset all of the cell UV coordinates? Default true.
             */
            setSizeToFrame(resetUV?: boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Point Light Game Object provides a way to add a point light effect into your game,
         * without the expensive shader processing requirements of the traditional Light Game Object.
         * 
         * The difference is that the Point Light renders using a custom shader, designed to give the
         * impression of a point light source, of variable radius, intensity and color, in your game.
         * However, unlike the Light Game Object, it does not impact any other Game Objects, or use their
         * normal maps for calcuations. This makes them extremely fast to render compared to Lights
         * and perfect for special effects, such as flickering torches or muzzle flashes.
         * 
         * For maximum performance you should batch Point Light Game Objects together. This means
         * ensuring they follow each other consecutively on the display list. Ideally, use a Layer
         * Game Object and then add just Point Lights to it, so that it can batch together the rendering
         * of the lights. You don't _have_ to do this, and if you've only a handful of Point Lights in
         * your game then it's perfectly safe to mix them into the dislay list as normal. However, if
         * you're using a large number of them, please consider how they are mixed into the display list.
         * 
         * The renderer will automatically cull Point Lights. Those with a radius that does not intersect
         * with the Camera will be skipped in the rendering list. This happens automatically and the
         * culled state is refreshed every frame, for every camera.
         * 
         * The origin of a Point Light is always 0.5 and it cannot be changed.
         * 
         * Point Lights are a WebGL only feature and do not have a Canvas counterpart.
         */
        class PointLight extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Point Light belongs. A Point Light can only belong to one Scene at a time.
             * @param x The horizontal position of this Point Light in the world.
             * @param y The vertical position of this Point Light in the world.
             * @param color The color of the Point Light, given as a hex value. Default 0xffffff.
             * @param radius The radius of the Point Light. Default 128.
             * @param intensity The intensity, or color blend, of the Point Light. Default 1.
             * @param attenuation The attenuation  of the Point Light. This is the reduction of light from the center point. Default 0.1.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, color?: number, radius?: number, intensity?: number, attenuation?: number);

            /**
             * The color of this Point Light. This property is an instance of a
             * Color object, so you can use the methods within it, such as `setTo(r, g, b)`
             * to change the color value.
             */
            color: Phaser.Display.Color;

            /**
             * The intensity of the Point Light.
             * 
             * The colors of the light are multiplied by this value during rendering.
             */
            intensity: number;

            /**
             * The attenuation of the Point Light.
             * 
             * This value controls the force with which the light falls-off from the center of the light.
             * 
             * Use small float-based values, i.e. 0.1.
             */
            attenuation: number;

            /**
             * The radius of the Point Light.
             */
            radius: number;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Render Texture is a combination of Dynamic Texture and an Image Game Object, that uses the
         * Dynamic Texture to display itself with.
         * 
         * A Dynamic Texture is a special texture that allows you to draw textures, frames and most kind of
         * Game Objects directly to it.
         * 
         * You can take many complex objects and draw them to this one texture, which can then be used as the
         * base texture for other Game Objects, such as Sprites. Should you then update this texture, all
         * Game Objects using it will instantly be updated as well, reflecting the changes immediately.
         * 
         * It's a powerful way to generate dynamic textures at run-time that are WebGL friendly and don't invoke
         * expensive GPU uploads on each change.
         * 
         * In versions of Phaser before 3.60 a Render Texture was the only way you could create a texture
         * like this, that had the ability to be drawn on. But in 3.60 we split the core functions out to
         * the Dynamic Texture class as it made a lot more sense for them to reside in there. As a result,
         * the Render Texture is now a light-weight shim that sits on-top of an Image Game Object and offers
         * proxy methods to the features available from a Dynamic Texture.
         * 
         * **When should you use a Render Texture vs. a Dynamic Texture?**
         * 
         * You should use a Dynamic Texture if the texture is going to be used by multiple Game Objects,
         * or you want to use it across multiple Scenes, because textures are globally stored.
         * 
         * You should use a Dynamic Texture if the texture isn't going to be displayed in-game, but is
         * instead going to be used for something like a mask or shader.
         * 
         * You should use a Render Texture if you need to display the texture in-game on a single Game Object,
         * as it provides the convenience of wrapping an Image and Dynamic Texture together for you.
         * 
         * Under WebGL1, a FrameBuffer, which is what this Dynamic Texture uses internally, cannot be anti-aliased.
         * This means that when drawing objects such as Shapes or Graphics instances to this texture, they may appear
         * to be drawn with no aliasing around the edges. This is a technical limitation of WebGL1. To get around it,
         * create your shape as a texture in an art package, then draw that to this texture.
         */
        class RenderTexture extends Phaser.GameObjects.Image {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the Render Texture. Default 32.
             * @param height The height of the Render Texture. Default 32.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, width?: number, height?: number);

            /**
             * An internal Camera that can be used to move around this Render Texture.
             * 
             * Control it just like you would any Scene Camera. The difference is that it only impacts
             * the placement of Game Objects that you then draw to this texture.
             * 
             * You can scroll, zoom and rotate this Camera.
             * 
             * This property is a reference to `RenderTexture.texture.camera`.
             */
            camera: Phaser.Cameras.Scene2D.BaseCamera;

            /**
             * Sets the internal size of this Render Texture, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Resizes the Render Texture to the new dimensions given.
             * 
             * In WebGL it will destroy and then re-create the frame buffer being used by the Render Texture.
             * In Canvas it will resize the underlying canvas element.
             * 
             * Both approaches will erase everything currently drawn to the Render Texture.
             * 
             * If the dimensions given are the same as those already being used, calling this method will do nothing.
             * @param width The new width of the Render Texture.
             * @param height The new height of the Render Texture. If not specified, will be set the same as the `width`. Default width.
             */
            resize(width: number, height?: number): this;

            /**
             * Stores a copy of this Render Texture in the Texture Manager using the given key.
             * 
             * After doing this, any texture based Game Object, such as a Sprite, can use the contents of this
             * Render Texture by using the texture key:
             * 
             * ```javascript
             * var rt = this.add.renderTexture(0, 0, 128, 128);
             * 
             * // Draw something to the Render Texture
             * 
             * rt.saveTexture('doodle');
             * 
             * this.add.image(400, 300, 'doodle');
             * ```
             * 
             * Updating the contents of this Render Texture will automatically update _any_ Game Object
             * that is using it as a texture. Calling `saveTexture` again will not save another copy
             * of the same texture, it will just rename the key of the existing copy.
             * 
             * By default it will create a single base texture. You can add frames to the texture
             * by using the `Texture.add` method. After doing this, you can then allow Game Objects
             * to use a specific frame from a Render Texture.
             * 
             * If you destroy this Render Texture, any Game Object using it via the Texture Manager will
             * stop rendering. Ensure you remove the texture from the Texture Manager and any Game Objects
             * using it first, before destroying this Render Texture.
             * @param key The unique key to store the texture as within the global Texture Manager.
             */
            saveTexture(key: string): Phaser.Textures.DynamicTexture;

            /**
             * Fills this Render Texture with the given color.
             * 
             * By default it will fill the entire texture, however you can set it to fill a specific
             * rectangular area by using the x, y, width and height arguments.
             * 
             * The color should be given in hex format, i.e. 0xff0000 for red, 0x00ff00 for green, etc.
             * @param rgb The color to fill this Render Texture with, such as 0xff0000 for red.
             * @param alpha The alpha value used by the fill. Default 1.
             * @param x The left coordinate of the fill rectangle. Default 0.
             * @param y The top coordinate of the fill rectangle. Default 0.
             * @param width The width of the fill rectangle. Default this.width.
             * @param height The height of the fill rectangle. Default this.height.
             */
            fill(rgb: number, alpha?: number, x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Fully clears this Render Texture, erasing everything from it and resetting it back to
             * a blank, transparent, texture.
             */
            clear(): this;

            /**
             * Takes the given texture key and frame and then stamps it at the given
             * x and y coordinates. You can use the optional 'config' argument to provide
             * lots more options about how the stamp is applied, including the alpha,
             * tint, angle, scale and origin.
             * 
             * By default, the frame will stamp on the x/y coordinates based on its center.
             * 
             * If you wish to stamp from the top-left, set the config `originX` and
             * `originY` properties both to zero.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param config The stamp configuration object, allowing you to set the alpha, tint, angle, scale and origin of the stamp.
             */
            stamp(key: string, frame?: string | number, x?: number, y?: number, config?: Phaser.Types.Textures.StampConfig): this;

            /**
             * Draws the given object, or an array of objects, to this Render Texture using a blend mode of ERASE.
             * This has the effect of erasing any filled pixels present in the objects from this texture.
             * 
             * It can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture, or a Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up the texture from the Texture Manager.
             * 
             * Note: You cannot erase a Render Texture from itself.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * Calling this method causes the WebGL batch to flush, so it can write the texture
             * data to the framebuffer being used internally. The batch is flushed at the end,
             * after the entries have been iterated. So if you've a bunch of objects to draw,
             * try and pass them in an array in one single call, rather than making lots of
             * separate calls.
             * @param entries Any renderable Game Object, or Group, Container, Display List, Render Texture, Texture Frame, or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             */
            erase(entries: any, x?: number, y?: number): this;

            /**
             * Draws the given object, or an array of objects, to this Render Texture.
             * 
             * It can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture, or a Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up the texture from the Texture Manager.
             * 
             * Note 1: You cannot draw a Render Texture to itself.
             * 
             * Note 2: For Game Objects that have Post FX Pipelines, the pipeline _cannot_ be
             * used when drawn to this texture.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame. If you need to specify
             * exactly which frame to draw then use the method `drawFrame` instead.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * The `alpha` and `tint` values are only used by Texture Frames.
             * Game Objects use their own alpha and tint values when being drawn.
             * 
             * Calling this method causes the WebGL batch to flush, so it can write the texture
             * data to the framebuffer being used internally. The batch is flushed at the end,
             * after the entries have been iterated. So if you've a bunch of objects to draw,
             * try and pass them in an array in one single call, rather than making lots of
             * separate calls.
             * @param entries Any renderable Game Object, or Group, Container, Display List, other Render Texture, Texture Frame or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            draw(entries: any, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Draws the Texture Frame to the Render Texture at the given position.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * ```javascript
             * var rt = this.add.renderTexture(0, 0, 800, 600);
             * rt.drawFrame(key, frame);
             * ```
             * 
             * You can optionally provide a position, alpha and tint value to apply to the frame
             * before it is drawn.
             * 
             * Calling this method will cause a batch flush, so if you've got a stack of things to draw
             * in a tight loop, try using the `draw` method instead.
             * 
             * If you need to draw a Sprite to this Render Texture, use the `draw` method instead.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. WebGL only. Default 0xffffff.
             */
            drawFrame(key: string, frame?: string | number, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Takes the given Texture Frame and draws it to this Render Texture as a fill pattern,
             * i.e. in a grid-layout based on the frame dimensions.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * You can optionally provide a position, width, height, alpha and tint value to apply to
             * the frames before they are drawn. The position controls the top-left where the repeating
             * fill will start from. The width and height control the size of the filled area.
             * 
             * The position can be negative if required, but the dimensions cannot.
             * 
             * Calling this method will cause a batch flush by default. Use the `skipBatch` argument
             * to disable this if this call is part of a larger batch draw.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to start drawing the frames from (can be negative to offset). Default 0.
             * @param y The y position to start drawing the frames from (can be negative to offset). Default 0.
             * @param width The width of the area to repeat the frame within. Defaults to the width of this Dynamic Texture. Default this.width.
             * @param height The height of the area to repeat the frame within. Defaults to the height of this Dynamic Texture. Default this.height.
             * @param alpha The alpha to use. Defaults to 1, no alpha. Default 1.
             * @param tint WebGL only. The tint color to use. Leave as undefined, or 0xffffff to have no tint. Default 0xffffff.
             * @param skipBatch Skip beginning and ending a batch with this call. Use if this is part of a bigger batched draw. Default false.
             */
            repeat(key: string, frame?: string | number, x?: number, y?: number, width?: number, height?: number, alpha?: number, tint?: number, skipBatch?: boolean): this;

            /**
             * Use this method if you need to batch draw a large number of Game Objects to
             * this Render Texture in a single pass, or on a frequent basis. This is especially
             * useful under WebGL, however, if your game is using Canvas only, it will not make
             * any speed difference in that situation.
             * 
             * This method starts the beginning of a batched draw, unless one is already open.
             * 
             * Batched drawing is faster than calling `draw` in loop, but you must be careful
             * to manage the flow of code and remember to call `endDraw()` when you're finished.
             * 
             * If you don't need to draw large numbers of objects it's much safer and easier
             * to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * RenderTexture.beginDraw();
             * 
             * // repeat n times:
             * RenderTexture.batchDraw();
             * // or
             * RenderTexture.batchDrawFrame();
             * 
             * // Call once:
             * RenderTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Render Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `RenderTexture.texture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             */
            beginDraw(): this;

            /**
             * Use this method if you have already called `beginDraw` and need to batch
             * draw a large number of objects to this Render Texture.
             * 
             * This method batches the drawing of the given objects to this texture,
             * without causing a WebGL bind or batch flush for each one.
             * 
             * It is faster than calling `draw`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()`. If you don't need to draw large
             * numbers of objects it's much safer and easier to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * RenderTexture.beginDraw();
             * 
             * // repeat n times:
             * RenderTexture.batchDraw();
             * // or
             * RenderTexture.batchDrawFrame();
             * 
             * // Call once:
             * RenderTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Render Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `RenderTexture.texture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * 
             * This method can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene's Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture or Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up a texture from the Texture Manager.
             * 
             * Note: You cannot draw a Render Texture to itself.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame. If you need to specify
             * exactly which frame to draw then use the method `drawFrame` instead.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * The `alpha` and `tint` values are only used by Texture Frames.
             * Game Objects use their own alpha and tint values when being drawn.
             * @param entries Any renderable Game Object, or Group, Container, Display List, other Dynamic or Texture, Texture Frame or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            batchDraw(entries: any, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Use this method if you have already called `beginDraw` and need to batch
             * draw a large number of texture frames to this Render Texture.
             * 
             * This method batches the drawing of the given frames to this Render Texture,
             * without causing a WebGL bind or batch flush for each one.
             * 
             * It is faster than calling `drawFrame`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()`. If you don't need to draw large
             * numbers of frames it's much safer and easier to use the `drawFrame` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * RenderTexture.beginDraw();
             * 
             * // repeat n times:
             * RenderTexture.batchDraw();
             * // or
             * RenderTexture.batchDrawFrame();
             * 
             * // Call once:
             * RenderTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Render Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `RenderTexture.texture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * You can optionally provide a position, alpha and tint value to apply to the frame
             * before it is drawn.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            batchDrawFrame(key: string, frame?: string | number, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Use this method to finish batch drawing to this Render Texture.
             * 
             * Doing so will stop the WebGL Renderer from capturing draws and then blit the
             * framebuffer to the Render Target owned by this texture.
             * 
             * Calling this method without first calling `beginDraw` will have no effect.
             * 
             * Batch drawing is faster than calling `draw`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()` when you're finished.
             * 
             * If you don't need to draw large numbers of objects it's much safer and easier
             * to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * RenderTexture.beginDraw();
             * 
             * // repeat n times:
             * RenderTexture.batchDraw();
             * // or
             * RenderTexture.batchDrawFrame();
             * 
             * // Call once:
             * RenderTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Render Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `RenderTexture.texture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * @param erase Draws all objects in this batch using a blend mode of ERASE. This has the effect of erasing any filled pixels in the objects being drawn. Default false.
             */
            endDraw(erase?: boolean): this;

            /**
             * Takes a snapshot of the given area of this Render Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture the whole Render Texture see the `snapshot` method.
             * To capture just a specific pixel, see the `snapshotPixel` method.
             * 
             * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer
             * into an ArrayBufferView. It then parses this, copying the contents to a temporary Canvas and finally
             * creating an Image object from it, which is the image returned to the callback provided.
             * 
             * All in all, this is a computationally expensive and blocking process, which gets more expensive
             * the larger the resolution this Render Texture has, so please be careful how you employ this in your game.
             * @param x The x coordinate to grab from.
             * @param y The y coordinate to grab from.
             * @param width The width of the area to grab.
             * @param height The height of the area to grab.
             * @param callback The Function to invoke after the snapshot image is created.
             * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
             * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
             */
            snapshotArea(x: number, y: number, width: number, height: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

            /**
             * Takes a snapshot of the whole of this Render Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture a portion of this Render Texture see the `snapshotArea` method.
             * To capture just a specific pixel, see the `snapshotPixel` method.
             * 
             * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer
             * into an ArrayBufferView. It then parses this, copying the contents to a temporary Canvas and finally
             * creating an Image object from it, which is the image returned to the callback provided.
             * 
             * All in all, this is a computationally expensive and blocking process, which gets more expensive
             * the larger the resolution this Render Texture has, so please be careful how you employ this in your game.
             * @param callback The Function to invoke after the snapshot image is created.
             * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
             * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
             */
            snapshot(callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

            /**
             * Takes a snapshot of the given pixel from this Render Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture the whole Render Texture see the `snapshot` method.
             * To capture a portion of this Render Texture see the `snapshotArea` method.
             * 
             * Unlike the two other snapshot methods, this one will send your callback a `Color` object
             * containing the color data for the requested pixel. It doesn't need to create an internal
             * Canvas or Image object, so is a lot faster to execute, using less memory than the other snapshot methods.
             * @param x The x coordinate of the pixel to get.
             * @param y The y coordinate of the pixel to get.
             * @param callback The Function to invoke after the snapshot pixel data is extracted.
             */
            snapshotPixel(x: number, y: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback): this;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Rope Game Object.
         * 
         * The Rope object is WebGL only and does not have a Canvas counterpart.
         * 
         * A Rope is a special kind of Game Object that has a texture is stretched along its entire length.
         * 
         * Unlike a Sprite, it isn't restricted to using just a quad and can have as many vertices as you define
         * when creating it. The vertices can be arranged in a horizontal or vertical strip and have their own
         * color and alpha values as well.
         * 
         * A Ropes origin is always 0.5 x 0.5 and cannot be changed.
         */
        class Rope extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible, Phaser.GameObjects.Components.ScrollFactor {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param texture The key of the Texture this Game Object will use to render with, as stored in the Texture Manager. If not given, `__DEFAULT` is used.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             * @param points An array containing the vertices data for this Rope, or a number that indicates how many segments to split the texture frame into. If none is provided a simple quad is created. See `setPoints` to set this post-creation. Default 2.
             * @param horizontal Should the vertices of this Rope be aligned horizontally (`true`), or vertically (`false`)? Default true.
             * @param colors An optional array containing the color data for this Rope. You should provide one color value per pair of vertices.
             * @param alphas An optional array containing the alpha data for this Rope. You should provide one alpha value per pair of vertices.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, texture?: string, frame?: string | number | null, points?: number | Phaser.Types.Math.Vector2Like[], horizontal?: boolean, colors?: number[], alphas?: number[]);

            /**
             * The Animation State of this Rope.
             */
            anims: Phaser.Animations.AnimationState;

            /**
             * An array containing the points data for this Rope.
             * 
             * Each point should be given as a Vector2Like object (i.e. a Vector2, Geom.Point or object with public x/y properties).
             * 
             * The point coordinates are given in local space, where 0 x 0 is the start of the Rope strip.
             * 
             * You can modify the contents of this array directly in real-time to create interesting effects.
             * If you do so, be sure to call `setDirty` _after_ modifying this array, so that the vertices data is
             * updated before the next render. Alternatively, you can use the `setPoints` method instead.
             * 
             * Should you need to change the _size_ of this array, then you should always use the `setPoints` method.
             */
            points: Phaser.Types.Math.Vector2Like[];

            /**
             * An array containing the vertices data for this Rope.
             * 
             * This data is calculated automatically in the `updateVertices` method, based on the points provided.
             */
            vertices: Float32Array;

            /**
             * An array containing the uv data for this Rope.
             * 
             * This data is calculated automatically in the `setPoints` method, based on the points provided.
             */
            uv: Float32Array;

            /**
             * An array containing the color data for this Rope.
             * 
             * Colors should be given as numeric RGB values, such as 0xff0000.
             * You should provide _two_ color values for every point in the Rope, one for the top and one for the bottom of each quad.
             * 
             * You can modify the contents of this array directly in real-time, however, should you need to change the _size_
             * of the array, then you should use the `setColors` method instead.
             */
            colors: Uint32Array;

            /**
             * An array containing the alpha data for this Rope.
             * 
             * Alphas should be given as float values, such as 0.5.
             * You should provide _two_ alpha values for every point in the Rope, one for the top and one for the bottom of each quad.
             * 
             * You can modify the contents of this array directly in real-time, however, should you need to change the _size_
             * of the array, then you should use the `setAlphas` method instead.
             */
            alphas: Float32Array;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * If the Rope is marked as `dirty` it will automatically recalculate its vertices
             * the next time it renders. You can also force this by calling `updateVertices`.
             */
            dirty: boolean;

            /**
             * Are the Rope vertices aligned horizontally, in a strip, or vertically, in a column?
             * 
             * This property is set during instantiation and cannot be changed directly.
             * See the `setVertical` and `setHorizontal` methods.
             */
            readonly horizontal: boolean;

            /**
             * You can optionally choose to render the vertices of this Rope to a Graphics instance.
             * 
             * Achieve this by setting the `debugCallback` and the `debugGraphic` properties.
             * 
             * You can do this in a single call via the `Rope.setDebug` method, which will use the
             * built-in debug function. You can also set it to your own callback. The callback
             * will be invoked _once per render_ and sent the following parameters:
             * 
             * `debugCallback(src, meshLength, verts)`
             * 
             * `src` is the Rope instance being debugged.
             * `meshLength` is the number of mesh vertices in total.
             * `verts` is an array of the translated vertex coordinates.
             * 
             * To disable rendering, set this property back to `null`.
             */
            debugCallback: Function;

            /**
             * The Graphics instance that the debug vertices will be drawn to, if `setDebug` has
             * been called.
             */
            debugGraphic: Phaser.GameObjects.Graphics;

            /**
             * The Rope update loop.
             * @param time The current timestamp.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            protected preUpdate(time: number, delta: number): void;

            /**
             * Start playing the given animation.
             * @param key The string-based key of the animation to play.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             * @param startFrame Optionally start the animation playing from this frame index. Default 0.
             */
            play(key: string, ignoreIfPlaying?: boolean, startFrame?: number): this;

            /**
             * Flags this Rope as being dirty. A dirty rope will recalculate all of its vertices data
             * the _next_ time it renders. You should set this rope as dirty if you update the points
             * array directly.
             */
            setDirty(): this;

            /**
             * Sets the alignment of the points in this Rope to be horizontal, in a strip format.
             * 
             * Calling this method will reset this Rope. The current points, vertices, colors and alpha
             * values will be reset to thoes values given as parameters.
             * @param points An array containing the vertices data for this Rope, or a number that indicates how many segments to split the texture frame into. If none is provided the current points length is used.
             * @param colors Either a single color value, or an array of values.
             * @param alphas Either a single alpha value, or an array of values.
             */
            setHorizontal(points?: number | Phaser.Types.Math.Vector2Like[], colors?: number | number[], alphas?: number | number[]): this;

            /**
             * Sets the alignment of the points in this Rope to be vertical, in a column format.
             * 
             * Calling this method will reset this Rope. The current points, vertices, colors and alpha
             * values will be reset to thoes values given as parameters.
             * @param points An array containing the vertices data for this Rope, or a number that indicates how many segments to split the texture frame into. If none is provided the current points length is used.
             * @param colors Either a single color value, or an array of values.
             * @param alphas Either a single alpha value, or an array of values.
             */
            setVertical(points?: number | Phaser.Types.Math.Vector2Like[], colors?: number | number[], alphas?: number | number[]): this;

            /**
             * Sets the tint fill mode.
             * 
             * Mode 0 (`false`) is an additive tint, the default, which blends the vertices colors with the texture.
             * This mode respects the texture alpha.
             * 
             * Mode 1 (`true`) is a fill tint. Unlike an additive tint, a fill-tint literally replaces the pixel colors
             * from the texture with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. This mode respects the texture alpha.
             * 
             * See the `setColors` method for details of how to color each of the vertices.
             * @param value Set to `false` for an Additive tint or `true` fill tint with alpha. Default false.
             */
            setTintFill(value?: boolean): this;

            /**
             * Set the alpha values used by the Rope during rendering.
             * 
             * You can provide the values in a number of ways:
             * 
             * 1) One single numeric value: `setAlphas(0.5)` - This will set a single alpha for the whole Rope.
             * 2) Two numeric value: `setAlphas(1, 0.5)` - This will set a 'top' and 'bottom' alpha value across the whole Rope.
             * 3) An array of values: `setAlphas([ 1, 0.5, 0.2 ])`
             * 
             * If you provide an array of values and the array has exactly the same number of values as `points` in the Rope, it
             * will use each alpha value per rope segment.
             * 
             * If the provided array has a different number of values than `points` then it will use the values in order, from
             * the first Rope segment and on, until it runs out of values. This allows you to control the alpha values at all
             * vertices in the Rope.
             * 
             * Note this method is called `setAlphas` (plural) and not `setAlpha`.
             * @param alphas Either a single alpha value, or an array of values. If nothing is provided alpha is reset to 1.
             * @param bottomAlpha An optional bottom alpha value. See the method description for details.
             */
            setAlphas(alphas?: number | number[], bottomAlpha?: number): this;

            /**
             * Set the color values used by the Rope during rendering.
             * 
             * Colors are used to control the level of tint applied across the Rope texture.
             * 
             * You can provide the values in a number of ways:
             * 
             * * One single numeric value: `setColors(0xff0000)` - This will set a single color tint for the whole Rope.
             * * An array of values: `setColors([ 0xff0000, 0x00ff00, 0x0000ff ])`
             * 
             * If you provide an array of values and the array has exactly the same number of values as `points` in the Rope, it
             * will use each color per rope segment.
             * 
             * If the provided array has a different number of values than `points` then it will use the values in order, from
             * the first Rope segment and on, until it runs out of values. This allows you to control the color values at all
             * vertices in the Rope.
             * @param colors Either a single color value, or an array of values. If nothing is provided color is reset to 0xffffff.
             */
            setColors(colors?: number | number[]): this;

            /**
             * Sets the points used by this Rope.
             * 
             * The points should be provided as an array of Vector2, or vector2-like objects (i.e. those with public x/y properties).
             * 
             * Each point corresponds to one segment of the Rope. The more points in the array, the more segments the rope has.
             * 
             * Point coordinates are given in local-space, not world-space, and are directly related to the size of the texture
             * this Rope object is using.
             * 
             * For example, a Rope using a 512 px wide texture, split into 4 segments (128px each) would use the following points:
             * 
             * ```javascript
             * rope.setPoints([
             *   { x: 0, y: 0 },
             *   { x: 128, y: 0 },
             *   { x: 256, y: 0 },
             *   { x: 384, y: 0 }
             * ]);
             * ```
             * 
             * Or, you can provide an integer to do the same thing:
             * 
             * ```javascript
             * rope.setPoints(4);
             * ```
             * 
             * Which will divide the Rope into 4 equally sized segments based on the frame width.
             * 
             * Note that calling this method with a different number of points than the Rope has currently will
             * _reset_ the color and alpha values, unless you provide them as arguments to this method.
             * @param points An array containing the vertices data for this Rope, or a number that indicates how many segments to split the texture frame into. If none is provided a simple quad is created. Default 2.
             * @param colors Either a single color value, or an array of values.
             * @param alphas Either a single alpha value, or an array of values.
             */
            setPoints(points?: number | Phaser.Types.Math.Vector2Like[], colors?: number | number[], alphas?: number | number[]): this;

            /**
             * Updates all of the UVs based on the Rope.points and `flipX` and `flipY` settings.
             */
            updateUVs(): this;

            /**
             * Resizes all of the internal arrays: `vertices`, `uv`, `colors` and `alphas` to the new
             * given Rope segment total.
             * @param newSize The amount of segments to split the Rope in to.
             */
            resizeArrays(newSize: number): this;

            /**
             * Updates the vertices based on the Rope points.
             * 
             * This method is called automatically during rendering if `Rope.dirty` is `true`, which is set
             * by the `setPoints` and `setDirty` methods. You should flag the Rope as being dirty if you modify
             * the Rope points directly.
             */
            updateVertices(): this;

            /**
             * This method enables rendering of the Rope vertices to the given Graphics instance.
             * 
             * If you enable this feature, you **must** call `Graphics.clear()` in your Scene `update`,
             * otherwise the Graphics instance you provide to debug will fill-up with draw calls,
             * eventually crashing the browser. This is not done automatically to allow you to debug
             * draw multiple Rope objects to a single Graphics instance.
             * 
             * The Rope class has a built-in debug rendering callback `Rope.renderDebugVerts`, however
             * you can also provide your own callback to be used instead. Do this by setting the `callback` parameter.
             * 
             * The callback is invoked _once per render_ and sent the following parameters:
             * 
             * `callback(src, meshLength, verts)`
             * 
             * `src` is the Rope instance being debugged.
             * `meshLength` is the number of mesh vertices in total.
             * `verts` is an array of the translated vertex coordinates.
             * 
             * If using your own callback you do not have to provide a Graphics instance to this method.
             * 
             * To disable debug rendering, to either your own callback or the built-in one, call this method
             * with no arguments.
             * @param graphic The Graphic instance to render to if using the built-in callback.
             * @param callback The callback to invoke during debug render. Leave as undefined to use the built-in callback.
             */
            setDebug(graphic?: Phaser.GameObjects.Graphics, callback?: Function): this;

            /**
             * The built-in Rope vertices debug rendering method.
             * 
             * See `Rope.setDebug` for more details.
             * @param src The Rope object being rendered.
             * @param meshLength The number of vertices in the mesh.
             * @param verts An array of translated vertex coordinates.
             */
            renderDebugVerts(src: Phaser.GameObjects.Rope, meshLength: number, verts: number[]): void;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * Calling this method will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param key The key of the texture to be used, as stored in the Texture Manager, or a Texture instance.
             * @param frame The name or index of the frame within the Texture.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call change the origin of the Game Object? Default true.
             */
            setTexture(key: string | Phaser.Textures.Texture, frame?: string | number, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

        }

        /**
         * A Shader Game Object.
         * 
         * This Game Object allows you to easily add a quad with its own shader into the display list, and manipulate it
         * as you would any other Game Object, including scaling, rotating, positioning and adding to Containers. Shaders
         * can be masked with either Bitmap or Geometry masks and can also be used as a Bitmap Mask for a Camera or other
         * Game Object. They can also be made interactive and used for input events.
         * 
         * It works by taking a reference to a `Phaser.Display.BaseShader` instance, as found in the Shader Cache. These can
         * be created dynamically at runtime, or loaded in via the GLSL File Loader:
         * 
         * ```javascript
         * function preload ()
         * {
         *     this.load.glsl('fire', 'shaders/fire.glsl.js');
         * }
         * 
         * function create ()
         * {
         *     this.add.shader('fire', 400, 300, 512, 512);
         * }
         * ```
         * 
         * Please see the Phaser 3 Examples GitHub repo for examples of loading and creating shaders dynamically.
         * 
         * Due to the way in which they work, you cannot directly change the alpha or blend mode of a Shader. This should
         * be handled via exposed uniforms in the shader code itself.
         * 
         * By default a Shader will be created with a standard set of uniforms. These were added to match those
         * found on sites such as ShaderToy or GLSLSandbox, and provide common functionality a shader may need,
         * such as the timestamp, resolution or pointer position. You can replace them by specifying your own uniforms
         * in the Base Shader.
         * 
         * These Shaders work by halting the current pipeline during rendering, creating a viewport matched to the
         * size of this Game Object and then renders a quad using the bound shader. At the end, the pipeline is restored.
         * 
         * Because it blocks the pipeline it means it will interrupt any batching that is currently going on, so you should
         * use these Game Objects sparingly. If you need to have a fully batched custom shader, then please look at using
         * a custom pipeline instead. However, for background or special masking effects, they are extremely effective.
         */
        class Shader extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.ComputedSize, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param key The key of the shader to use from the shader cache, or a BaseShader instance.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the Game Object. Default 128.
             * @param height The height of the Game Object. Default 128.
             * @param textures Optional array of texture keys to bind to the iChannel0...3 uniforms. The textures must already exist in the Texture Manager.
             * @param textureData Additional texture data if you want to create shader with none NPOT textures.
             */
            constructor(scene: Phaser.Scene, key: string | Phaser.Display.BaseShader, x?: number, y?: number, width?: number, height?: number, textures?: string[], textureData?: any);

            /**
             * The underlying shader object being used.
             * Empty by default and set during a call to the `setShader` method.
             */
            shader: Phaser.Display.BaseShader;

            /**
             * A reference to the current renderer.
             * Shaders only work with the WebGL Renderer.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The WebGL context belonging to the renderer.
             */
            gl: WebGLRenderingContext;

            /**
             * Raw byte buffer of vertices this Shader uses.
             */
            vertexData: ArrayBuffer;

            /**
             * The WebGL vertex buffer object this shader uses.
             */
            vertexBuffer: WebGLBuffer;

            /**
             * The WebGL shader program this shader uses.
             */
            program: WebGLProgram;

            /**
             * Uint8 view to the vertex raw buffer. Used for uploading vertex buffer resources to the GPU.
             */
            bytes: Uint8Array;

            /**
             * Float32 view of the array buffer containing the shaders vertices.
             */
            vertexViewF32: Float32Array;

            /**
             * The view matrix the shader uses during rendering.
             */
            readonly viewMatrix: Float32Array;

            /**
             * The projection matrix the shader uses during rendering.
             */
            readonly projectionMatrix: Float32Array;

            /**
             * The default uniform mappings. These can be added to (or replaced) by specifying your own uniforms when
             * creating this shader game object. The uniforms are updated automatically during the render step.
             * 
             * The defaults are:
             * 
             * `resolution` (2f) - Set to the size of this shader.
             * `time` (1f) - The elapsed game time, in seconds.
             * `mouse` (2f) - If a pointer has been bound (with `setPointer`), this uniform contains its position each frame.
             * `date` (4fv) - A vec4 containing the year, month, day and time in seconds.
             * `sampleRate` (1f) - Sound sample rate. 44100 by default.
             * `iChannel0...3` (sampler2D) - Input channels 0 to 3. `null` by default.
             */
            uniforms: any;

            /**
             * The pointer bound to this shader, if any.
             * Set via the chainable `setPointer` method, or by modifying this property directly.
             */
            pointer: Phaser.Input.Pointer;

            /**
             * A reference to the GL Frame Buffer this Shader is drawing to.
             * This property is only set if you have called `Shader.setRenderToTexture`.
             */
            framebuffer: WebGLFramebuffer | null;

            /**
             * A reference to the WebGLTexture this Shader is rendering to.
             * This property is only set if you have called `Shader.setRenderToTexture`.
             */
            glTexture: WebGLTexture | null;

            /**
             * A flag that indicates if this Shader has been set to render to a texture instead of the display list.
             * 
             * This property is `true` if you have called `Shader.setRenderToTexture`, otherwise it's `false`.
             * 
             * A Shader that is rendering to a texture _does not_ appear on the display list.
             */
            readonly renderToTexture: boolean;

            /**
             * A reference to the Phaser.Textures.Texture that has been stored in the Texture Manager for this Shader.
             * 
             * This property is only set if you have called `Shader.setRenderToTexture`, otherwise it is `null`.
             */
            texture: Phaser.Textures.Texture;

            /**
             * Compares the renderMask with the renderFlags to see if this Game Object will render or not.
             * Also checks the Game Object against the given Cameras exclusion list.
             * @param camera The Camera to check against this Game Object.
             */
            willRender(camera: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Changes this Shader so instead of rendering to the display list it renders to a
             * WebGL Framebuffer and WebGL Texture instead. This allows you to use the output
             * of this shader as an input for another shader, by mapping a sampler2D uniform
             * to it.
             * 
             * After calling this method the `Shader.framebuffer` and `Shader.glTexture` properties
             * are populated.
             * 
             * Additionally, you can provide a key to this method. Doing so will create a Phaser Texture
             * from this Shader and save it into the Texture Manager, allowing you to then use it for
             * any texture-based Game Object, such as a Sprite or Image:
             * 
             * ```javascript
             * var shader = this.add.shader('myShader', x, y, width, height);
             * 
             * shader.setRenderToTexture('doodle');
             * 
             * this.add.image(400, 300, 'doodle');
             * ```
             * 
             * Note that it stores an active reference to this Shader. That means as this shader updates,
             * so does the texture and any object using it to render with. Also, if you destroy this
             * shader, be sure to clear any objects that may have been using it as a texture too.
             * 
             * You can access the Phaser Texture that is created via the `Shader.texture` property.
             * 
             * By default it will create a single base texture. You can add frames to the texture
             * by using the `Texture.add` method. After doing this, you can then allow Game Objects
             * to use a specific frame from a Render Texture.
             * @param key The unique key to store the texture as within the global Texture Manager.
             * @param flipY Does this texture need vertically flipping before rendering? This should usually be set to `true` if being fed from a buffer. Default false.
             */
            setRenderToTexture(key?: string, flipY?: boolean): this;

            /**
             * Sets the fragment and, optionally, the vertex shader source code that this Shader will use.
             * This will immediately delete the active shader program, if set, and then create a new one
             * with the given source. Finally, the shader uniforms are initialized.
             * @param key The key of the shader to use from the shader cache, or a BaseShader instance.
             * @param textures Optional array of texture keys to bind to the iChannel0...3 uniforms. The textures must already exist in the Texture Manager.
             * @param textureData Additional texture data.
             */
            setShader(key: string | Phaser.Display.BaseShader, textures?: string[], textureData?: any): this;

            /**
             * Binds a Phaser Pointer object to this Shader.
             * 
             * The screen position of the pointer will be set in to the shaders `mouse` uniform
             * automatically every frame. Call this method with no arguments to unbind the pointer.
             * @param pointer The Pointer to bind to this shader.
             */
            setPointer(pointer?: Phaser.Input.Pointer): this;

            /**
             * Sets this shader to use an orthographic projection matrix.
             * This matrix is stored locally in the `projectionMatrix` property,
             * as well as being bound to the `uProjectionMatrix` uniform.
             * @param left The left value.
             * @param right The right value.
             * @param bottom The bottom value.
             * @param top The top value.
             */
            projOrtho(left: number, right: number, bottom: number, top: number): void;

            /**
             * Sets a sampler2D uniform on this shader where the source texture is a WebGLTexture.
             * 
             * This allows you to feed the output from one Shader into another:
             * 
             * ```javascript
             * let shader1 = this.add.shader(baseShader1, 0, 0, 512, 512).setRenderToTexture();
             * let shader2 = this.add.shader(baseShader2, 0, 0, 512, 512).setRenderToTexture('output');
             * 
             * shader1.setSampler2DBuffer('iChannel0', shader2.glTexture, 512, 512);
             * shader2.setSampler2DBuffer('iChannel0', shader1.glTexture, 512, 512);
             * ```
             * 
             * In the above code, the result of baseShader1 is fed into Shader2 as the `iChannel0` sampler2D uniform.
             * The result of baseShader2 is then fed back into shader1 again, creating a feedback loop.
             * 
             * If you wish to use an image from the Texture Manager as a sampler2D input for this shader,
             * see the `Shader.setSampler2D` method.
             * @param uniformKey The key of the sampler2D uniform to be updated, i.e. `iChannel0`.
             * @param texture A WebGLTexture reference.
             * @param width The width of the texture.
             * @param height The height of the texture.
             * @param textureIndex The texture index. Default 0.
             * @param textureData Additional texture data.
             */
            setSampler2DBuffer(uniformKey: string, texture: WebGLTexture, width: number, height: number, textureIndex?: number, textureData?: any): this;

            /**
             * Sets a sampler2D uniform on this shader.
             * 
             * The textureKey given is the key from the Texture Manager cache. You cannot use a single frame
             * from a texture, only the full image. Also, lots of shaders expect textures to be power-of-two sized.
             * 
             * If you wish to use another Shader as a sampler2D input for this shader, see the `Shader.setSampler2DBuffer` method.
             * @param uniformKey The key of the sampler2D uniform to be updated, i.e. `iChannel0`.
             * @param textureKey The key of the texture, as stored in the Texture Manager. Must already be loaded.
             * @param textureIndex The texture index. Default 0.
             * @param textureData Additional texture data.
             */
            setSampler2D(uniformKey: string, textureKey: string, textureIndex?: number, textureData?: any): this;

            /**
             * Sets a property of a uniform already present on this shader.
             * 
             * To modify the value of a uniform such as a 1f or 1i use the `value` property directly:
             * 
             * ```javascript
             * shader.setUniform('size.value', 16);
             * ```
             * 
             * You can use dot notation to access deeper values, for example:
             * 
             * ```javascript
             * shader.setUniform('resolution.value.x', 512);
             * ```
             * 
             * The change to the uniform will take effect the next time the shader is rendered.
             * @param key The key of the uniform to modify. Use dots for deep properties, i.e. `resolution.value.x`.
             * @param value The value to set into the uniform.
             */
            setUniform(key: string, value: any): this;

            /**
             * Returns the uniform object for the given key, or `null` if the uniform couldn't be found.
             * @param key The key of the uniform to return the value for.
             */
            getUniform(key: string): any;

            /**
             * A short-cut method that will directly set the texture being used by the `iChannel0` sampler2D uniform.
             * 
             * The textureKey given is the key from the Texture Manager cache. You cannot use a single frame
             * from a texture, only the full image. Also, lots of shaders expect textures to be power-of-two sized.
             * @param textureKey The key of the texture, as stored in the Texture Manager. Must already be loaded.
             * @param textureData Additional texture data.
             */
            setChannel0(textureKey: string, textureData?: any): this;

            /**
             * A short-cut method that will directly set the texture being used by the `iChannel1` sampler2D uniform.
             * 
             * The textureKey given is the key from the Texture Manager cache. You cannot use a single frame
             * from a texture, only the full image. Also, lots of shaders expect textures to be power-of-two sized.
             * @param textureKey The key of the texture, as stored in the Texture Manager. Must already be loaded.
             * @param textureData Additional texture data.
             */
            setChannel1(textureKey: string, textureData?: any): this;

            /**
             * A short-cut method that will directly set the texture being used by the `iChannel2` sampler2D uniform.
             * 
             * The textureKey given is the key from the Texture Manager cache. You cannot use a single frame
             * from a texture, only the full image. Also, lots of shaders expect textures to be power-of-two sized.
             * @param textureKey The key of the texture, as stored in the Texture Manager. Must already be loaded.
             * @param textureData Additional texture data.
             */
            setChannel2(textureKey: string, textureData?: any): this;

            /**
             * A short-cut method that will directly set the texture being used by the `iChannel3` sampler2D uniform.
             * 
             * The textureKey given is the key from the Texture Manager cache. You cannot use a single frame
             * from a texture, only the full image. Also, lots of shaders expect textures to be power-of-two sized.
             * @param textureKey The key of the texture, as stored in the Texture Manager. Must already be loaded.
             * @param textureData Additional texture data.
             */
            setChannel3(textureKey: string, textureData?: any): this;

            /**
             * Called automatically during render.
             * 
             * This method performs matrix ITRS and then stores the resulting value in the `uViewMatrix` uniform.
             * It then sets up the vertex buffer and shader, updates and syncs the uniforms ready
             * for flush to be called.
             * @param matrix2D The transform matrix to use during rendering.
             */
            load(matrix2D?: Phaser.GameObjects.Components.TransformMatrix): void;

            /**
             * Called automatically during render.
             * 
             * Sets the active shader, loads the vertex buffer and then draws.
             */
            flush(): void;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Arc Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * When it renders it displays an arc shape. You can control the start and end angles of the arc,
         * as well as if the angles are winding clockwise or anti-clockwise. With the default settings
         * it renders as a complete circle. By changing the angles you can create other arc shapes,
         * such as half-circles.
         * 
         * Arcs also have an `iterations` property and corresponding `setIterations` method. This allows
         * you to control how smooth the shape renders in WebGL, by controlling the number of iterations
         * that take place during construction.
         */
        class Arc extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param radius The radius of the arc. Default 128.
             * @param startAngle The start angle of the arc, in degrees. Default 0.
             * @param endAngle The end angle of the arc, in degrees. Default 360.
             * @param anticlockwise The winding order of the start and end angles. Default false.
             * @param fillColor The color the arc will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the arc will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, radius?: number, startAngle?: number, endAngle?: number, anticlockwise?: boolean, fillColor?: number, fillAlpha?: number);

            /**
             * The number of iterations used when drawing the arc.
             * Increase this value for smoother arcs, at the cost of more polygons being rendered.
             * Modify this value by small amounts, such as 0.01.
             */
            iterations: number;

            /**
             * The radius of the arc.
             */
            radius: number;

            /**
             * The start angle of the arc, in degrees.
             */
            startAngle: number;

            /**
             * The end angle of the arc, in degrees.
             */
            endAngle: number;

            /**
             * The winding order of the start and end angles.
             */
            anticlockwise: boolean;

            /**
             * Sets the radius of the arc.
             * This call can be chained.
             * @param value The value to set the radius to.
             */
            setRadius(value: number): this;

            /**
             * Sets the number of iterations used when drawing the arc.
             * Increase this value for smoother arcs, at the cost of more polygons being rendered.
             * Modify this value by small amounts, such as 0.01.
             * This call can be chained.
             * @param value The value to set the iterations to.
             */
            setIterations(value: number): this;

            /**
             * Sets the starting angle of the arc, in degrees.
             * This call can be chained.
             * @param value The value to set the starting angle to.
             */
            setStartAngle(value: number): this;

            /**
             * Sets the ending angle of the arc, in degrees.
             * This call can be chained.
             * @param value The value to set the ending angle to.
             */
            setEndAngle(value: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Curve Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * To render a Curve Shape you must first create a `Phaser.Curves.Curve` object, then pass it to
         * the Curve Shape in the constructor.
         * 
         * The Curve shape also has a `smoothness` property and corresponding `setSmoothness` method.
         * This allows you to control how smooth the shape renders in WebGL, by controlling the number of iterations
         * that take place during construction. Increase and decrease the default value for smoother, or more
         * jagged, shapes.
         */
        class Curve extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param curve The Curve object to use to create the Shape.
             * @param fillColor The color the curve will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the curve will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, curve?: Phaser.Curves.Curve, fillColor?: number, fillAlpha?: number);

            /**
             * The smoothness of the curve. The number of points used when rendering it.
             * Increase this value for smoother curves, at the cost of more polygons being rendered.
             */
            smoothness: number;

            /**
             * Sets the smoothness of the curve. The number of points used when rendering it.
             * Increase this value for smoother curves, at the cost of more polygons being rendered.
             * This call can be chained.
             * @param value The value to set the smoothness to.
             */
            setSmoothness(value: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Ellipse Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * When it renders it displays an ellipse shape. You can control the width and height of the ellipse.
         * If the width and height match it will render as a circle. If the width is less than the height,
         * it will look more like an egg shape.
         * 
         * The Ellipse shape also has a `smoothness` property and corresponding `setSmoothness` method.
         * This allows you to control how smooth the shape renders in WebGL, by controlling the number of iterations
         * that take place during construction. Increase and decrease the default value for smoother, or more
         * jagged, shapes.
         */
        class Ellipse extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the ellipse. An ellipse with equal width and height renders as a circle. Default 128.
             * @param height The height of the ellipse. An ellipse with equal width and height renders as a circle. Default 128.
             * @param fillColor The color the ellipse will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the ellipse will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, width?: number, height?: number, fillColor?: number, fillAlpha?: number);

            /**
             * The smoothness of the ellipse. The number of points used when rendering it.
             * Increase this value for a smoother ellipse, at the cost of more polygons being rendered.
             */
            smoothness: number;

            /**
             * Sets the size of the ellipse by changing the underlying geometry data, rather than scaling the object.
             * This call can be chained.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the smoothness of the ellipse. The number of points used when rendering it.
             * Increase this value for a smoother ellipse, at the cost of more polygons being rendered.
             * This call can be chained.
             * @param value The value to set the smoothness to.
             */
            setSmoothness(value: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Grid Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports only fill colors and cannot be stroked.
         * 
         * A Grid Shape allows you to display a grid in your game, where you can control the size of the
         * grid as well as the width and height of the grid cells. You can set a fill color for each grid
         * cell as well as an alternate fill color. When the alternate fill color is set then the grid
         * cells will alternate the fill colors as they render, creating a chess-board effect. You can
         * also optionally have an outline fill color. If set, this draws lines between the grid cells
         * in the given color. If you specify an outline color with an alpha of zero, then it will draw
         * the cells spaced out, but without the lines between them.
         */
        class Grid extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param width The width of the grid. Default 128.
             * @param height The height of the grid. Default 128.
             * @param cellWidth The width of one cell in the grid. Default 32.
             * @param cellHeight The height of one cell in the grid. Default 32.
             * @param fillColor The color the grid cells will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the grid cells will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             * @param outlineFillColor The color of the lines between the grid cells. See the `setOutline` method.
             * @param outlineFillAlpha The alpha of the lines between the grid cells.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, width?: number, height?: number, cellWidth?: number, cellHeight?: number, fillColor?: number, fillAlpha?: number, outlineFillColor?: number, outlineFillAlpha?: number);

            /**
             * The width of each grid cell.
             * Must be a positive value.
             */
            cellWidth: number;

            /**
             * The height of each grid cell.
             * Must be a positive value.
             */
            cellHeight: number;

            /**
             * Will the grid render its cells in the `fillColor`?
             */
            showCells: boolean;

            /**
             * The color of the lines between each grid cell.
             */
            outlineFillColor: number;

            /**
             * The alpha value for the color of the lines between each grid cell.
             */
            outlineFillAlpha: number;

            /**
             * Will the grid display the lines between each cell when it renders?
             */
            showOutline: boolean;

            /**
             * Will the grid render the alternating cells in the `altFillColor`?
             */
            showAltCells: boolean;

            /**
             * The color the alternating grid cells will be filled with, i.e. 0xff0000 for red.
             */
            altFillColor: number;

            /**
             * The alpha the alternating grid cells will be filled with.
             * You can also set the alpha of the overall Shape using its `alpha` property.
             */
            altFillAlpha: number;

            /**
             * Sets the fill color and alpha level the grid cells will use when rendering.
             * 
             * If this method is called with no values then the grid cells will not be rendered,
             * however the grid lines and alternating cells may still be.
             * 
             * Also see the `setOutlineStyle` and `setAltFillStyle` methods.
             * 
             * This call can be chained.
             * @param fillColor The color the grid cells will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the grid cells will be filled with. You can also set the alpha of the overall Shape using its `alpha` property. Default 1.
             */
            setFillStyle(fillColor?: number, fillAlpha?: number): this;

            /**
             * Sets the fill color and alpha level that the alternating grid cells will use.
             * 
             * If this method is called with no values then alternating grid cells will not be rendered in a different color.
             * 
             * Also see the `setOutlineStyle` and `setFillStyle` methods.
             * 
             * This call can be chained.
             * @param fillColor The color the alternating grid cells will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the alternating grid cells will be filled with. You can also set the alpha of the overall Shape using its `alpha` property. Default 1.
             */
            setAltFillStyle(fillColor?: number, fillAlpha?: number): this;

            /**
             * Sets the fill color and alpha level that the lines between each grid cell will use.
             * 
             * If this method is called with no values then the grid lines will not be rendered at all, however
             * the cells themselves may still be if they have colors set.
             * 
             * Also see the `setFillStyle` and `setAltFillStyle` methods.
             * 
             * This call can be chained.
             * @param fillColor The color the lines between the grid cells will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the lines between the grid cells will be filled with. You can also set the alpha of the overall Shape using its `alpha` property. Default 1.
             */
            setOutlineStyle(fillColor?: number, fillAlpha?: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The IsoBox Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports only fill colors and cannot be stroked.
         * 
         * An IsoBox is an 'isometric' rectangle. Each face of it has a different fill color. You can set
         * the color of the top, left and right faces of the rectangle respectively. You can also choose
         * which of the faces are rendered via the `showTop`, `showLeft` and `showRight` properties.
         * 
         * You cannot view an IsoBox from under-neath, however you can change the 'angle' by setting
         * the `projection` property.
         */
        class IsoBox extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param size The width of the iso box in pixels. The left and right faces will be exactly half this value. Default 48.
             * @param height The height of the iso box. The left and right faces will be this tall. The overall height of the isobox will be this value plus half the `size` value. Default 32.
             * @param fillTop The fill color of the top face of the iso box. Default 0xeeeeee.
             * @param fillLeft The fill color of the left face of the iso box. Default 0x999999.
             * @param fillRight The fill color of the right face of the iso box. Default 0xcccccc.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, size?: number, height?: number, fillTop?: number, fillLeft?: number, fillRight?: number);

            /**
             * The projection level of the iso box. Change this to change the 'angle' at which you are looking at the box.
             */
            projection: number;

            /**
             * The color used to fill in the top of the iso box.
             */
            fillTop: number;

            /**
             * The color used to fill in the left-facing side of the iso box.
             */
            fillLeft: number;

            /**
             * The color used to fill in the right-facing side of the iso box.
             */
            fillRight: number;

            /**
             * Controls if the top-face of the iso box be rendered.
             */
            showTop: boolean;

            /**
             * Controls if the left-face of the iso box be rendered.
             */
            showLeft: boolean;

            /**
             * Controls if the right-face of the iso box be rendered.
             */
            showRight: boolean;

            /**
             * Sets the projection level of the iso box. Change this to change the 'angle' at which you are looking at the box.
             * This call can be chained.
             * @param value The value to set the projection to.
             */
            setProjection(value: number): this;

            /**
             * Sets which faces of the iso box will be rendered.
             * This call can be chained.
             * @param showTop Show the top-face of the iso box. Default true.
             * @param showLeft Show the left-face of the iso box. Default true.
             * @param showRight Show the right-face of the iso box. Default true.
             */
            setFaces(showTop?: boolean, showLeft?: boolean, showRight?: boolean): this;

            /**
             * Sets the fill colors for each face of the iso box.
             * This call can be chained.
             * @param fillTop The color used to fill the top of the iso box.
             * @param fillLeft The color used to fill in the left-facing side of the iso box.
             * @param fillRight The color used to fill in the right-facing side of the iso box.
             */
            setFillStyle(fillTop?: number, fillLeft?: number, fillRight?: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The IsoTriangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports only fill colors and cannot be stroked.
         * 
         * An IsoTriangle is an 'isometric' triangle. Think of it like a pyramid. Each face has a different
         * fill color. You can set the color of the top, left and right faces of the triangle respectively
         * You can also choose which of the faces are rendered via the `showTop`, `showLeft` and `showRight` properties.
         * 
         * You cannot view an IsoTriangle from under-neath, however you can change the 'angle' by setting
         * the `projection` property. The `reversed` property controls if the IsoTriangle is rendered upside
         * down or not.
         */
        class IsoTriangle extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param size The width of the iso triangle in pixels. The left and right faces will be exactly half this value. Default 48.
             * @param height The height of the iso triangle. The left and right faces will be this tall. The overall height of the iso triangle will be this value plus half the `size` value. Default 32.
             * @param reversed Is the iso triangle upside down? Default false.
             * @param fillTop The fill color of the top face of the iso triangle. Default 0xeeeeee.
             * @param fillLeft The fill color of the left face of the iso triangle. Default 0x999999.
             * @param fillRight The fill color of the right face of the iso triangle. Default 0xcccccc.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, size?: number, height?: number, reversed?: boolean, fillTop?: number, fillLeft?: number, fillRight?: number);

            /**
             * The projection level of the iso box. Change this to change the 'angle' at which you are looking at the box.
             */
            projection: number;

            /**
             * The color used to fill in the top of the iso triangle. This is only used if the triangle is reversed.
             */
            fillTop: number;

            /**
             * The color used to fill in the left-facing side of the iso triangle.
             */
            fillLeft: number;

            /**
             * The color used to fill in the right-facing side of the iso triangle.
             */
            fillRight: number;

            /**
             * Controls if the top-face of the iso triangle be rendered.
             */
            showTop: boolean;

            /**
             * Controls if the left-face of the iso triangle be rendered.
             */
            showLeft: boolean;

            /**
             * Controls if the right-face of the iso triangle be rendered.
             */
            showRight: boolean;

            /**
             * Sets if the iso triangle will be rendered upside down or not.
             */
            isReversed: boolean;

            /**
             * Sets the projection level of the iso triangle. Change this to change the 'angle' at which you are looking at the pyramid.
             * This call can be chained.
             * @param value The value to set the projection to.
             */
            setProjection(value: number): this;

            /**
             * Sets if the iso triangle will be rendered upside down or not.
             * This call can be chained.
             * @param reversed Sets if the iso triangle will be rendered upside down or not.
             */
            setReversed(reversed: boolean): this;

            /**
             * Sets which faces of the iso triangle will be rendered.
             * This call can be chained.
             * @param showTop Show the top-face of the iso triangle (only if `reversed` is true) Default true.
             * @param showLeft Show the left-face of the iso triangle. Default true.
             * @param showRight Show the right-face of the iso triangle. Default true.
             */
            setFaces(showTop?: boolean, showLeft?: boolean, showRight?: boolean): this;

            /**
             * Sets the fill colors for each face of the iso triangle.
             * This call can be chained.
             * @param fillTop The color used to fill the top of the iso triangle.
             * @param fillLeft The color used to fill in the left-facing side of the iso triangle.
             * @param fillRight The color used to fill in the right-facing side of the iso triangle.
             */
            setFillStyle(fillTop?: number, fillLeft?: number, fillRight?: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Line Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports only stroke colors and cannot be filled.
         * 
         * A Line Shape allows you to draw a line between two points in your game. You can control the
         * stroke color and thickness of the line. In WebGL only you can also specify a different
         * thickness for the start and end of the line, allowing you to render lines that taper-off.
         * 
         * If you need to draw multiple lines in a sequence you may wish to use the Polygon Shape instead.
         * 
         * Be aware that as with all Game Objects the default origin is 0.5. If you need to draw a Line
         * between two points and want the x1/y1 values to match the x/y values, then set the origin to 0.
         */
        class Line extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param x1 The horizontal position of the start of the line. Default 0.
             * @param y1 The vertical position of the start of the line. Default 0.
             * @param x2 The horizontal position of the end of the line. Default 128.
             * @param y2 The vertical position of the end of the line. Default 0.
             * @param strokeColor The color the line will be drawn in, i.e. 0xff0000 for red.
             * @param strokeAlpha The alpha the line will be drawn in. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, x1?: number, y1?: number, x2?: number, y2?: number, strokeColor?: number, strokeAlpha?: number);

            /**
             * The width (or thickness) of the line.
             * See the setLineWidth method for extra details on changing this on WebGL.
             */
            lineWidth: number;

            /**
             * Sets the width of the line.
             * 
             * When using the WebGL renderer you can have different start and end widths.
             * When using the Canvas renderer only the `startWidth` value is used. The `endWidth` is ignored.
             * 
             * This call can be chained.
             * @param startWidth The start width of the line.
             * @param endWidth The end width of the line. Only used in WebGL.
             */
            setLineWidth(startWidth: number, endWidth?: number): this;

            /**
             * Sets the start and end coordinates of this Line.
             * @param x1 The horizontal position of the start of the line. Default 0.
             * @param y1 The vertical position of the start of the line. Default 0.
             * @param x2 The horizontal position of the end of the line. Default 0.
             * @param y2 The vertical position of the end of the line. Default 0.
             */
            setTo(x1?: number, y1?: number, x2?: number, y2?: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Polygon Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * The Polygon Shape is created by providing a list of points, which are then used to create an
         * internal Polygon geometry object. The points can be set from a variety of formats:
         * 
         * - A string containing paired values separated by a single space: `'40 0 40 20 100 20 100 80 40 80 40 100 0 50'`
         * - An array of Point or Vector2 objects: `[new Phaser.Math.Vector2(x1, y1), ...]`
         * - An array of objects with public x/y properties: `[obj1, obj2, ...]`
         * - An array of paired numbers that represent point coordinates: `[x1,y1, x2,y2, ...]`
         * - An array of arrays with two elements representing x/y coordinates: `[[x1, y1], [x2, y2], ...]`
         * 
         * By default the `x` and `y` coordinates of this Shape refer to the center of it. However, depending
         * on the coordinates of the points provided, the final shape may be rendered offset from its origin.
         */
        class Polygon extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param points The points that make up the polygon.
             * @param fillColor The color the polygon will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the polygon will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, points?: any, fillColor?: number, fillAlpha?: number);

            /**
             * Smooths the polygon over the number of iterations specified.
             * The base polygon data will be updated and replaced with the smoothed values.
             * This call can be chained.
             * @param iterations The number of times to apply the polygon smoothing. Default 1.
             */
            smooth(iterations?: number): this;

            /**
             * Sets this Polygon to the given points.
             * 
             * The points can be set from a variety of formats:
             * 
             * - A string containing paired values separated by a single space: `'40 0 40 20 100 20 100 80 40 80 40 100 0 50'`
             * - An array of Point objects: `[new Phaser.Point(x1, y1), ...]`
             * - An array of objects with public x/y properties: `[obj1, obj2, ...]`
             * - An array of paired numbers that represent point coordinates: `[x1,y1, x2,y2, ...]`
             * - An array of arrays with two elements representing x/y coordinates: `[[x1, y1], [x2, y2], ...]`
             * 
             * Calling this method will reset the size (width, height) and display origin of this Shape.
             * 
             * It also runs both GetAABB and EarCut on the given points, so please be careful not to do this
             * at a high frequency, or with too many points.
             * @param points Points defining the perimeter of this polygon. Please check function description above for the different supported formats.
             */
            setTo(points?: string | number[] | Phaser.Types.Math.Vector2Like[]): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Rectangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * You can change the size of the rectangle by changing the `width` and `height` properties.
         */
        class Rectangle extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the rectangle. Default 128.
             * @param height The height of the rectangle. Default 128.
             * @param fillColor The color the rectangle will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the rectangle will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, width?: number, height?: number, fillColor?: number, fillAlpha?: number);

            /**
             * Sets the internal size of this Rectangle, as used for frame or physics body creation.
             * 
             * If you have assigned a custom input hit area for this Rectangle, changing the Rectangle size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Shape Game Object is a base class for the various different shapes, such as the Arc, Star or Polygon.
         * You cannot add a Shape directly to your Scene, it is meant as a base for your own custom Shape classes.
         */
        class Shape extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param type The internal type of the Shape.
             * @param data The data of the source shape geometry, if any.
             */
            constructor(scene: Phaser.Scene, type?: string, data?: any);

            /**
             * The source Shape data. Typically a geometry object.
             * You should not manipulate this directly.
             */
            readonly geom: any;

            /**
             * Holds the polygon path data for filled rendering.
             */
            readonly pathData: number[];

            /**
             * Holds the earcut polygon path index data for filled rendering.
             */
            readonly pathIndexes: number[];

            /**
             * The fill color used by this Shape.
             */
            fillColor: number;

            /**
             * The fill alpha value used by this Shape.
             */
            fillAlpha: number;

            /**
             * The stroke color used by this Shape.
             */
            strokeColor: number;

            /**
             * The stroke alpha value used by this Shape.
             */
            strokeAlpha: number;

            /**
             * The stroke line width used by this Shape.
             */
            lineWidth: number;

            /**
             * Controls if this Shape is filled or not.
             * Note that some Shapes do not support being filled (such as Line shapes)
             */
            isFilled: boolean;

            /**
             * Controls if this Shape is stroked or not.
             * Note that some Shapes do not support being stroked (such as Iso Box shapes)
             */
            isStroked: boolean;

            /**
             * Controls if this Shape path is closed during rendering when stroked.
             * Note that some Shapes are always closed when stroked (such as Ellipse shapes)
             */
            closePath: boolean;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * Sets the fill color and alpha for this Shape.
             * 
             * If you wish for the Shape to not be filled then call this method with no arguments, or just set `isFilled` to `false`.
             * 
             * Note that some Shapes do not support fill colors, such as the Line shape.
             * 
             * This call can be chained.
             * @param color The color used to fill this shape. If not provided the Shape will not be filled.
             * @param alpha The alpha value used when filling this shape, if a fill color is given. Default 1.
             */
            setFillStyle(color?: number, alpha?: number): this;

            /**
             * Sets the stroke color and alpha for this Shape.
             * 
             * If you wish for the Shape to not be stroked then call this method with no arguments, or just set `isStroked` to `false`.
             * 
             * Note that some Shapes do not support being stroked, such as the Iso Box shape.
             * 
             * This call can be chained.
             * @param lineWidth The width of line to stroke with. If not provided or undefined the Shape will not be stroked.
             * @param color The color used to stroke this shape. If not provided the Shape will not be stroked.
             * @param alpha The alpha value used when stroking this shape, if a stroke color is given. Default 1.
             */
            setStrokeStyle(lineWidth?: number, color?: number, alpha?: number): this;

            /**
             * Sets if this Shape path is closed during rendering when stroked.
             * Note that some Shapes are always closed when stroked (such as Ellipse shapes)
             * 
             * This call can be chained.
             * @param value Set to `true` if the Shape should be closed when stroked, otherwise `false`.
             */
            setClosePath(value: boolean): this;

            /**
             * Sets the display size of this Shape.
             * 
             * Calling this will adjust the scale.
             * @param width The display width of this Shape.
             * @param height The display height of this Shape.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Star Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * As the name implies, the Star shape will display a star in your game. You can control several
         * aspects of it including the number of points that constitute the star. The default is 5. If
         * you change it to 4 it will render as a diamond. If you increase them, you'll get a more spiky
         * star shape.
         * 
         * You can also control the inner and outer radius, which is how 'long' each point of the star is.
         * Modify these values to create more interesting shapes.
         */
        class Star extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param points The number of points on the star. Default 5.
             * @param innerRadius The inner radius of the star. Default 32.
             * @param outerRadius The outer radius of the star. Default 64.
             * @param fillColor The color the star will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the star will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, points?: number, innerRadius?: number, outerRadius?: number, fillColor?: number, fillAlpha?: number);

            /**
             * Sets the number of points that make up the Star shape.
             * This call can be chained.
             * @param value The amount of points the Star will have.
             */
            setPoints(value: number): this;

            /**
             * Sets the inner radius of the Star shape.
             * This call can be chained.
             * @param value The amount to set the inner radius to.
             */
            setInnerRadius(value: number): this;

            /**
             * Sets the outer radius of the Star shape.
             * This call can be chained.
             * @param value The amount to set the outer radius to.
             */
            setOuterRadius(value: number): this;

            /**
             * The number of points that make up the Star shape.
             */
            points: number;

            /**
             * The inner radius of the Star shape.
             */
            innerRadius: number;

            /**
             * The outer radius of the Star shape.
             */
            outerRadius: number;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Triangle Shape is a Game Object that can be added to a Scene, Group or Container. You can
         * treat it like any other Game Object in your game, such as tweening it, scaling it, or enabling
         * it for input or physics. It provides a quick and easy way for you to render this shape in your
         * game without using a texture, while still taking advantage of being fully batched in WebGL.
         * 
         * This shape supports both fill and stroke colors.
         * 
         * The Triangle consists of 3 lines, joining up to form a triangular shape. You can control the
         * position of each point of these lines. The triangle is always closed and cannot have an open
         * face. If you require that, consider using a Polygon instead.
         */
        class Triangle extends Phaser.GameObjects.Shape {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world. Default 0.
             * @param y The vertical position of this Game Object in the world. Default 0.
             * @param x1 The horizontal position of the first point in the triangle. Default 0.
             * @param y1 The vertical position of the first point in the triangle. Default 128.
             * @param x2 The horizontal position of the second point in the triangle. Default 64.
             * @param y2 The vertical position of the second point in the triangle. Default 0.
             * @param x3 The horizontal position of the third point in the triangle. Default 128.
             * @param y3 The vertical position of the third point in the triangle. Default 128.
             * @param fillColor The color the triangle will be filled with, i.e. 0xff0000 for red.
             * @param fillAlpha The alpha the triangle will be filled with. You can also set the alpha of the overall Shape using its `alpha` property.
             */
            constructor(scene: Phaser.Scene, x?: number, y?: number, x1?: number, y1?: number, x2?: number, y2?: number, x3?: number, y3?: number, fillColor?: number, fillAlpha?: number);

            /**
             * Sets the data for the lines that make up this Triangle shape.
             * @param x1 The horizontal position of the first point in the triangle. Default 0.
             * @param y1 The vertical position of the first point in the triangle. Default 0.
             * @param x2 The horizontal position of the second point in the triangle. Default 0.
             * @param y2 The vertical position of the second point in the triangle. Default 0.
             * @param x3 The horizontal position of the third point in the triangle. Default 0.
             * @param y3 The vertical position of the third point in the triangle. Default 0.
             */
            setTo(x1?: number, y1?: number, x2?: number, y2?: number, x3?: number, y3?: number): this;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Sprite Game Object.
         * 
         * A Sprite Game Object is used for the display of both static and animated images in your game.
         * Sprites can have input events and physics bodies. They can also be tweened, tinted, scrolled
         * and animated.
         * 
         * The main difference between a Sprite and an Image Game Object is that you cannot animate Images.
         * As such, Sprites take a fraction longer to process and have a larger API footprint due to the Animation
         * Component. If you do not require animation then you can safely use Images to replace Sprites in all cases.
         */
        class Sprite extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.TextureCrop, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
             * @param frame An optional frame from the Texture this Game Object is rendering with.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number);

            /**
             * The Animation State component of this Sprite.
             * 
             * This component provides features to apply animations to this Sprite.
             * It is responsible for playing, loading, queuing animations for later playback,
             * mixing between animations and setting the current animation frame to this Sprite.
             */
            anims: Phaser.Animations.AnimationState;

            /**
             * Update this Sprite's animations.
             * @param time The current timestamp.
             * @param delta The delta time, in ms, elapsed since the last frame.
             */
            protected preUpdate(time: number, delta: number): void;

            /**
             * Start playing the given animation on this Sprite.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to this Sprite.
             * 
             * The benefit of a global animation is that multiple Sprites can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any Sprite.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Sprite, and this Sprite alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Sprite.
             * 
             * With the animation created, either globally or locally, you can now play it on this Sprite:
             * 
             * ```javascript
             * this.add.sprite(x, y).play('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate, for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * this.add.sprite(x, y).play({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Sprite to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             */
            play(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): this;

            /**
             * Start playing the given animation on this Sprite, in reverse.
             * 
             * Animations in Phaser can either belong to the global Animation Manager, or specifically to this Sprite.
             * 
             * The benefit of a global animation is that multiple Sprites can all play the same animation, without
             * having to duplicate the data. You can just create it once and then play it on any Sprite.
             * 
             * The following code shows how to create a global repeating animation. The animation will be created
             * from all of the frames within the sprite sheet that was loaded with the key 'muybridge':
             * 
             * ```javascript
             * var config = {
             *     key: 'run',
             *     frames: 'muybridge',
             *     frameRate: 15,
             *     repeat: -1
             * };
             * 
             * //  This code should be run from within a Scene:
             * this.anims.create(config);
             * ```
             * 
             * However, if you wish to create an animation that is unique to this Sprite, and this Sprite alone,
             * you can call the `Animation.create` method instead. It accepts the exact same parameters as when
             * creating a global animation, however the resulting data is kept locally in this Sprite.
             * 
             * With the animation created, either globally or locally, you can now play it on this Sprite:
             * 
             * ```javascript
             * this.add.sprite(x, y).playReverse('run');
             * ```
             * 
             * Alternatively, if you wish to run it at a different frame rate, for example, you can pass a config
             * object instead:
             * 
             * ```javascript
             * this.add.sprite(x, y).playReverse({ key: 'run', frameRate: 24 });
             * ```
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * If you need a Sprite to be able to play both local and global animations, make sure they don't
             * have conflicting keys.
             * 
             * See the documentation for the `PlayAnimationConfig` config object for more details about this.
             * 
             * Also, see the documentation in the Animation Manager for further details on creating animations.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param ignoreIfPlaying If an animation is already playing then ignore this call. Default false.
             */
            playReverse(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, ignoreIfPlaying?: boolean): this;

            /**
             * Waits for the specified delay, in milliseconds, then starts playback of the given animation.
             * 
             * If the animation _also_ has a delay value set in its config, it will be **added** to the delay given here.
             * 
             * If an animation is already running and a new animation is given to this method, it will wait for
             * the given delay before starting the new animation.
             * 
             * If no animation is currently running, the given one begins after the delay.
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * 
             * Prior to Phaser 3.50 this method was called 'delayedPlay'.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param delay The delay, in milliseconds, to wait before starting the animation playing.
             */
            playAfterDelay(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, delay: number): this;

            /**
             * Waits for the current animation to complete the `repeatCount` number of repeat cycles, then starts playback
             * of the given animation.
             * 
             * You can use this to ensure there are no harsh jumps between two sets of animations, i.e. going from an
             * idle animation to a walking animation, by making them blend smoothly into each other.
             * 
             * If no animation is currently running, the given one will start immediately.
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
             * @param repeatCount How many times should the animation repeat before the next one starts? Default 1.
             */
            playAfterRepeat(key: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig, repeatCount?: number): this;

            /**
             * Sets an animation, or an array of animations, to be played immediately after the current one completes or stops.
             * 
             * The current animation must enter a 'completed' state for this to happen, i.e. finish all of its repeats, delays, etc,
             * or have the `stop` method called directly on it.
             * 
             * An animation set to repeat forever will never enter a completed state.
             * 
             * You can chain a new animation at any point, including before the current one starts playing, during it,
             * or when it ends (via its `animationcomplete` event).
             * 
             * Chained animations are specific to a Game Object, meaning different Game Objects can have different chained
             * animations without impacting the animation they're playing.
             * 
             * Call this method with no arguments to reset all currently chained animations.
             * 
             * When playing an animation on a Sprite it will first check to see if it can find a matching key
             * locally within the Sprite. If it can, it will play the local animation. If not, it will then
             * search the global Animation Manager and look for it there.
             * @param key The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object, or an array of them.
             */
            chain(key?: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig | string[] | Phaser.Animations.Animation[] | Phaser.Types.Animations.PlayAnimationConfig[]): this;

            /**
             * Immediately stops the current animation from playing and dispatches the `ANIMATION_STOP` events.
             * 
             * If no animation is playing, no event will be dispatched.
             * 
             * If there is another animation queued (via the `chain` method) then it will start playing immediately.
             */
            stop(): this;

            /**
             * Stops the current animation from playing after the specified time delay, given in milliseconds.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param delay The number of milliseconds to wait before stopping this animation.
             */
            stopAfterDelay(delay: number): this;

            /**
             * Stops the current animation from playing after the given number of repeats.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param repeatCount How many times should the animation repeat before stopping? Default 1.
             */
            stopAfterRepeat(repeatCount?: number): this;

            /**
             * Stops the current animation from playing when it next sets the given frame.
             * If this frame doesn't exist within the animation it will not stop it from playing.
             * 
             * It then dispatches the `ANIMATION_STOP` event.
             * 
             * If no animation is running, no events will be dispatched.
             * 
             * If there is another animation in the queue (set via the `chain` method) then it will start playing,
             * when the current one stops.
             * @param frame The frame to check before stopping this animation.
             */
            stopOnFrame(frame: Phaser.Animations.AnimationFrame): this;

            /**
             * Build a JSON representation of this Sprite.
             */
            toJSON(): Phaser.Types.GameObjects.JSONGameObject;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * Returns an object containing dimensions of the Text object.
         * @param text The Text object to calculate the size from.
         * @param size The Text metrics to use when calculating the size.
         * @param lines The lines of text to calculate the size from.
         */
        function GetTextSize(text: Phaser.GameObjects.Text, size: Phaser.Types.GameObjects.Text.TextMetrics, lines: string[]): Phaser.Types.GameObjects.Text.GetTextSizeObject;

        /**
         * Calculates the ascent, descent and fontSize of a given font style.
         * @param textStyle The TextStyle object to measure.
         */
        function MeasureText(textStyle: Phaser.GameObjects.TextStyle): Phaser.Types.GameObjects.Text.TextMetrics;

        /**
         * A Text Game Object.
         * 
         * Text objects work by creating their own internal hidden Canvas and then renders text to it using
         * the standard Canvas `fillText` API. It then creates a texture from this canvas which is rendered
         * to your game during the render pass.
         * 
         * Because it uses the Canvas API you can take advantage of all the features this offers, such as
         * applying gradient fills to the text, or strokes, shadows and more. You can also use custom fonts
         * loaded externally, such as Google or TypeKit Web fonts.
         * 
         * **Important:** The font name must be quoted if it contains certain combinations of digits or
         * special characters, either when creating the Text object, or when setting the font via `setFont`
         * or `setFontFamily`, e.g.:
         * 
         * ```javascript
         * this.add.text(0, 0, 'Hello World', { fontFamily: 'Georgia, "Goudy Bookletter 1911", Times, serif' });
         * ```
         * 
         * ```javascript
         * this.add.text(0, 0, 'Hello World', { font: '"Press Start 2P"' });
         * ```
         * 
         * You can only display fonts that are currently loaded and available to the browser: therefore fonts must
         * be pre-loaded. Phaser does not do this for you, so you will require the use of a 3rd party font loader,
         * or have the fonts ready available in the CSS on the page in which your Phaser game resides.
         * 
         * See {@link http://www.jordanm.co.uk/tinytype this compatibility table} for the available default fonts
         * across mobile browsers.
         * 
         * A note on performance: Every time the contents of a Text object changes, i.e. changing the text being
         * displayed, or the style of the text, it needs to remake the Text canvas, and if on WebGL, re-upload the
         * new texture to the GPU. This can be an expensive operation if used often, or with large quantities of
         * Text objects in your game. If you run into performance issues you would be better off using Bitmap Text
         * instead, as it benefits from batching and avoids expensive Canvas API calls.
         */
        class Text extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.ComputedSize, Phaser.GameObjects.Components.Crop, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param text The text this Text object will display.
             * @param style The text style configuration object.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, text: string | string[], style: Phaser.Types.GameObjects.Text.TextStyle);

            /**
             * The renderer in use by this Text object.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The canvas element that the text is rendered to.
             */
            canvas: HTMLCanvasElement;

            /**
             * The context of the canvas element that the text is rendered to.
             */
            context: CanvasRenderingContext2D;

            /**
             * The Text Style object.
             * 
             * Manages the style of this Text object.
             */
            style: Phaser.GameObjects.TextStyle;

            /**
             * Whether to automatically round line positions.
             */
            autoRound: boolean;

            /**
             * The Regular Expression that is used to split the text up into lines, in
             * multi-line text. By default this is `/(?:\r\n|\r|\n)/`.
             * You can change this RegExp to be anything else that you may need.
             */
            splitRegExp: object;

            /**
             * Specify a padding value which is added to the line width and height when calculating the Text size.
             * Allows you to add extra spacing if the browser is unable to accurately determine the true font dimensions.
             */
            padding: Phaser.Types.GameObjects.Text.TextPadding;

            /**
             * The width of this Text object.
             */
            width: number;

            /**
             * The height of this Text object.
             */
            height: number;

            /**
             * The line spacing value.
             * This value is added to the font height to calculate the overall line height.
             * Only has an effect if this Text object contains multiple lines of text.
             * 
             * If you update this property directly, instead of using the `setLineSpacing` method, then
             * be sure to call `updateText` after, or you won't see the change reflected in the Text object.
             */
            lineSpacing: number;

            /**
             * Adds / Removes spacing between characters.
             * Can be a negative or positive number.
             * 
             * If you update this property directly, instead of using the `setLetterSpacing` method, then
             * be sure to call `updateText` after, or you won't see the change reflected in the Text object.
             */
            letterSpacing: number;

            /**
             * Initialize right to left text.
             */
            initRTL(): void;

            /**
             * Greedy wrapping algorithm that will wrap words as the line grows longer than its horizontal
             * bounds.
             * @param text The text to perform word wrap detection against.
             */
            runWordWrap(text: string): string;

            /**
             * Advanced wrapping algorithm that will wrap words as the line grows longer than its horizontal
             * bounds. Consecutive spaces will be collapsed and replaced with a single space. Lines will be
             * trimmed of white space before processing. Throws an error if wordWrapWidth is less than a
             * single character.
             * @param text The text to perform word wrap detection against.
             * @param context The Canvas Rendering Context.
             * @param wordWrapWidth The word wrap width.
             */
            advancedWordWrap(text: string, context: CanvasRenderingContext2D, wordWrapWidth: number): string;

            /**
             * Greedy wrapping algorithm that will wrap words as the line grows longer than its horizontal
             * bounds. Spaces are not collapsed and whitespace is not trimmed.
             * @param text The text to perform word wrap detection against.
             * @param context The Canvas Rendering Context.
             * @param wordWrapWidth The word wrap width.
             */
            basicWordWrap(text: string, context: CanvasRenderingContext2D, wordWrapWidth: number): string;

            /**
             * Runs the given text through this Text objects word wrapping and returns the results as an
             * array, where each element of the array corresponds to a wrapped line of text.
             * @param text The text for which the wrapping will be calculated. If unspecified, the Text objects current text will be used.
             */
            getWrappedText(text?: string): string[];

            /**
             * Set the text to display.
             * 
             * An array of strings will be joined with `\n` line breaks.
             * @param value The string, or array of strings, to be set as the content of this Text object.
             */
            setText(value: string | string[]): this;

            /**
             * Appends the given text to the content already being displayed by this Text object.
             * 
             * An array of strings will be joined with `\n` line breaks.
             * @param value The string, or array of strings, to be appended to the existing content of this Text object.
             * @param addCR Insert a carriage-return before the string value. Default true.
             */
            appendText(value: string | string[], addCR?: boolean): this;

            /**
             * Set the text style.
             * @param style The style settings to set.
             */
            setStyle(style: object): this;

            /**
             * Set the font.
             * 
             * If a string is given, the font family is set.
             * 
             * If an object is given, the `fontFamily`, `fontSize` and `fontStyle`
             * properties of that object are set.
             * 
             * **Important:** The font name must be quoted if it contains certain combinations of digits or
             * special characters:
             * 
             * ```javascript
             * Text.setFont('"Press Start 2P"');
             * ```
             * 
             * Equally, if you wish to provide a list of fallback fonts, then you should ensure they are all
             * quoted properly, too:
             * 
             * ```javascript
             * Text.setFont('Georgia, "Goudy Bookletter 1911", Times, serif');
             * ```
             * @param font The font family or font settings to set.
             */
            setFont(font: string): this;

            /**
             * Set the font family.
             * 
             * **Important:** The font name must be quoted if it contains certain combinations of digits or
             * special characters:
             * 
             * ```javascript
             * Text.setFont('"Press Start 2P"');
             * ```
             * 
             * Equally, if you wish to provide a list of fallback fonts, then you should ensure they are all
             * quoted properly, too:
             * 
             * ```javascript
             * Text.setFont('Georgia, "Goudy Bookletter 1911", Times, serif');
             * ```
             * @param family The font family.
             */
            setFontFamily(family: string): this;

            /**
             * Set the font size. Can be a string with a valid CSS unit, i.e. `16px`, or a number.
             * @param size The font size.
             */
            setFontSize(size: string | number): this;

            /**
             * Set the font style.
             * @param style The font style.
             */
            setFontStyle(style: string): this;

            /**
             * Set a fixed width and height for the text.
             * 
             * Pass in `0` for either of these parameters to disable fixed width or height respectively.
             * @param width The fixed width to set. `0` disables fixed width.
             * @param height The fixed height to set. `0` disables fixed height.
             */
            setFixedSize(width: number, height: number): this;

            /**
             * Set the background color.
             * @param color The background color.
             */
            setBackgroundColor(color: string): this;

            /**
             * Set the fill style to be used by the Text object.
             * 
             * This can be any valid CanvasRenderingContext2D fillStyle value, such as
             * a color (in hex, rgb, rgba, hsl or named values), a gradient or a pattern.
             * 
             * See the [MDN fillStyle docs](https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/fillStyle) for more details.
             * @param color The text fill style. Can be any valid CanvasRenderingContext `fillStyle` value.
             */
            setFill(color: string | CanvasGradient | CanvasPattern): this;

            /**
             * Set the text fill color.
             * @param color The text fill color.
             */
            setColor(color: string | CanvasGradient | CanvasPattern): this;

            /**
             * Set the stroke settings.
             * @param color The stroke color.
             * @param thickness The stroke thickness.
             */
            setStroke(color: string | CanvasGradient | CanvasPattern, thickness: number): this;

            /**
             * Set the shadow settings.
             * @param x The horizontal shadow offset. Default 0.
             * @param y The vertical shadow offset. Default 0.
             * @param color The shadow color. Default '#000'.
             * @param blur The shadow blur radius. Default 0.
             * @param shadowStroke Whether to stroke the shadow. Default false.
             * @param shadowFill Whether to fill the shadow. Default true.
             */
            setShadow(x?: number, y?: number, color?: string, blur?: number, shadowStroke?: boolean, shadowFill?: boolean): this;

            /**
             * Set the shadow offset.
             * @param x The horizontal shadow offset.
             * @param y The vertical shadow offset.
             */
            setShadowOffset(x: number, y: number): this;

            /**
             * Set the shadow color.
             * @param color The shadow color.
             */
            setShadowColor(color: string): this;

            /**
             * Set the shadow blur radius.
             * @param blur The shadow blur radius.
             */
            setShadowBlur(blur: number): this;

            /**
             * Enable or disable shadow stroke.
             * @param enabled Whether shadow stroke is enabled or not.
             */
            setShadowStroke(enabled: boolean): this;

            /**
             * Enable or disable shadow fill.
             * @param enabled Whether shadow fill is enabled or not.
             */
            setShadowFill(enabled: boolean): this;

            /**
             * Set the width (in pixels) to use for wrapping lines. Pass in null to remove wrapping by width.
             * @param width The maximum width of a line in pixels. Set to null to remove wrapping.
             * @param useAdvancedWrap Whether or not to use the advanced wrapping
             * algorithm. If true, spaces are collapsed and whitespace is trimmed from lines. If false,
             * spaces and whitespace are left as is. Default false.
             */
            setWordWrapWidth(width: number | undefined, useAdvancedWrap?: boolean): this;

            /**
             * Set a custom callback for wrapping lines. Pass in null to remove wrapping by callback.
             * @param callback A custom function that will be responsible for wrapping the
             * text. It will receive two arguments: text (the string to wrap), textObject (this Text
             * instance). It should return the wrapped lines either as an array of lines or as a string with
             * newline characters in place to indicate where breaks should happen.
             * @param scope The scope that will be applied when the callback is invoked. Default null.
             */
            setWordWrapCallback(callback: TextStyleWordWrapCallback, scope?: object): this;

            /**
             * Set the alignment of the text in this Text object.
             * 
             * The argument can be one of: `left`, `right`, `center` or `justify`.
             * 
             * Alignment only works if the Text object has more than one line of text.
             * @param align The text alignment for multi-line text. Default 'left'.
             */
            setAlign(align?: string): this;

            /**
             * Set the resolution used by this Text object.
             * 
             * It allows for much clearer text on High DPI devices, at the cost of memory because it uses larger
             * internal Canvas textures for the Text.
             * 
             * Therefore, please use with caution, as the more high res Text you have, the more memory it uses.
             * @param value The resolution for this Text object to use.
             */
            setResolution(value: number): this;

            /**
             * Sets the line spacing value.
             * 
             * This value is _added_ to the height of the font when calculating the overall line height.
             * This only has an effect if this Text object consists of multiple lines of text.
             * @param value The amount to add to the font height to achieve the overall line height.
             */
            setLineSpacing(value: number): this;

            /**
             * Sets the letter spacing value.
             * 
             * This will add, or remove spacing between each character of this Text Game Object. The value can be
             * either positive or negative. Positive values increase the space between each character, whilst negative
             * values decrease it. Note that some fonts are spaced naturally closer together than others.
             * 
             * Please understand that enabling this feature will cause Phaser to render each character in this Text object
             * one by one, rather than use a draw for the whole string. This makes it extremely expensive when used with
             * either long strings, or lots of strings in total. You will be better off creating bitmap font text if you
             * need to display large quantities of characters with fine control over the letter spacing.
             * @param value The amount to add to the letter width. Set to zero to disable.
             */
            setLetterSpacing(value: number): this;

            /**
             * Set the text padding.
             * 
             * 'left' can be an object.
             * 
             * If only 'left' and 'top' are given they are treated as 'x' and 'y'.
             * @param left The left padding value, or a padding config object.
             * @param top The top padding value.
             * @param right The right padding value.
             * @param bottom The bottom padding value.
             */
            setPadding(left: number | Phaser.Types.GameObjects.Text.TextPadding, top?: number, right?: number, bottom?: number): this;

            /**
             * Set the maximum number of lines to draw.
             * @param max The maximum number of lines to draw. Default 0.
             */
            setMaxLines(max?: number): this;

            /**
             * Render text from right-to-left or left-to-right.
             * @param rtl Set to `true` to render from right-to-left. Default true.
             */
            setRTL(rtl?: boolean): this;

            /**
             * Update the displayed text.
             */
            updateText(): this;

            /**
             * Get the current text metrics.
             */
            getTextMetrics(): Phaser.Types.GameObjects.Text.TextMetrics;

            /**
             * The text string being rendered by this Text Game Object.
             */
            text: string;

            /**
             * Build a JSON representation of the Text object.
             */
            toJSON(): Phaser.Types.GameObjects.JSONGameObject;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A TextStyle class manages all of the style settings for a Text object.
         * 
         * Text Game Objects create a TextStyle instance automatically, which is
         * accessed via the `Text.style` property. You do not normally need to
         * instantiate one yourself.
         */
        class TextStyle {
            /**
             * 
             * @param text The Text object that this TextStyle is styling.
             * @param style The style settings to set.
             */
            constructor(text: Phaser.GameObjects.Text, style: Phaser.Types.GameObjects.Text.TextStyle);

            /**
             * The Text object that this TextStyle is styling.
             */
            parent: Phaser.GameObjects.Text;

            /**
             * The font family.
             */
            fontFamily: string;

            /**
             * The font size.
             */
            fontSize: string | number;

            /**
             * The font style.
             */
            fontStyle: string;

            /**
             * The background color.
             */
            backgroundColor: string;

            /**
             * The text fill color.
             */
            color: string | CanvasGradient | CanvasPattern;

            /**
             * The text stroke color.
             */
            stroke: string | CanvasGradient | CanvasPattern;

            /**
             * The text stroke thickness.
             */
            strokeThickness: number;

            /**
             * The horizontal shadow offset.
             */
            shadowOffsetX: number;

            /**
             * The vertical shadow offset.
             */
            shadowOffsetY: number;

            /**
             * The shadow color.
             */
            shadowColor: string;

            /**
             * The shadow blur radius.
             */
            shadowBlur: number;

            /**
             * Whether shadow stroke is enabled or not.
             */
            shadowStroke: boolean;

            /**
             * Whether shadow fill is enabled or not.
             */
            shadowFill: boolean;

            /**
             * The text alignment.
             */
            align: string;

            /**
             * The maximum number of lines to draw.
             */
            maxLines: number;

            /**
             * The fixed width of the text.
             * 
             * `0` means no fixed with.
             */
            fixedWidth: number;

            /**
             * The fixed height of the text.
             * 
             * `0` means no fixed height.
             */
            fixedHeight: number;

            /**
             * The resolution the text is rendered to its internal canvas at.
             * The default is 0, which means it will use the resolution set in the Game Config.
             */
            resolution: number;

            /**
             * Whether the text should render right to left.
             */
            rtl: boolean;

            /**
             * The test string to use when measuring the font.
             */
            testString: string;

            /**
             * The amount of horizontal padding added to the width of the text when calculating the font metrics.
             */
            baselineX: number;

            /**
             * The amount of vertical padding added to the height of the text when calculating the font metrics.
             */
            baselineY: number;

            /**
             * The maximum width of a line of text in pixels. Null means no line wrapping. Setting this
             * property directly will not re-run the word wrapping algorithm. To change the width and
             * re-wrap, use {@link Phaser.GameObjects.TextStyle#setWordWrapWidth}.
             */
            wordWrapWidth: number | null;

            /**
             * A custom function that will be responsible for wrapping the text. It will receive two
             * arguments: text (the string to wrap), textObject (this Text instance). It should return
             * the wrapped lines either as an array of lines or as a string with newline characters in
             * place to indicate where breaks should happen. Setting this directly will not re-run the
             * word wrapping algorithm. To change the callback and re-wrap, use
             * {@link Phaser.GameObjects.TextStyle#setWordWrapCallback}.
             */
            wordWrapCallback: TextStyleWordWrapCallback | null;

            /**
             * The scope that will be applied when the wordWrapCallback is invoked. Setting this directly will not re-run the
             * word wrapping algorithm. To change the callback and re-wrap, use
             * {@link Phaser.GameObjects.TextStyle#setWordWrapCallback}.
             */
            wordWrapCallbackScope: object | null;

            /**
             * Whether or not to use the advanced wrapping algorithm. If true, spaces are collapsed and
             * whitespace is trimmed from lines. If false, spaces and whitespace are left as is. Setting
             * this property directly will not re-run the word wrapping algorithm. To change the
             * advanced setting and re-wrap, use {@link Phaser.GameObjects.TextStyle#setWordWrapWidth}.
             */
            wordWrapUseAdvanced: boolean;

            /**
             * Set the text style.
             * @param style The style settings to set.
             * @param updateText Whether to update the text immediately. Default true.
             * @param setDefaults Use the default values is not set, or the local values. Default false.
             */
            setStyle(style: Phaser.Types.GameObjects.Text.TextStyle, updateText?: boolean, setDefaults?: boolean): Phaser.GameObjects.Text;

            /**
             * Synchronize the font settings to the given Canvas Rendering Context.
             * @param canvas The Canvas Element.
             * @param context The Canvas Rendering Context.
             */
            syncFont(canvas: HTMLCanvasElement, context: CanvasRenderingContext2D): void;

            /**
             * Synchronize the text style settings to the given Canvas Rendering Context.
             * @param canvas The Canvas Element.
             * @param context The Canvas Rendering Context.
             */
            syncStyle(canvas: HTMLCanvasElement, context: CanvasRenderingContext2D): void;

            /**
             * Synchronize the shadow settings to the given Canvas Rendering Context.
             * @param context The Canvas Rendering Context.
             * @param enabled Whether shadows are enabled or not.
             */
            syncShadow(context: CanvasRenderingContext2D, enabled: boolean): void;

            /**
             * Update the style settings for the parent Text object.
             * @param recalculateMetrics Whether to recalculate font and text metrics.
             */
            update(recalculateMetrics: boolean): Phaser.GameObjects.Text;

            /**
             * Set the font.
             * 
             * If a string is given, the font family is set.
             * 
             * If an object is given, the `fontFamily`, `fontSize` and `fontStyle`
             * properties of that object are set.
             * @param font The font family or font settings to set.
             * @param updateText Whether to update the text immediately. Default true.
             */
            setFont(font: string | object, updateText?: boolean): Phaser.GameObjects.Text;

            /**
             * Set the font family.
             * @param family The font family.
             */
            setFontFamily(family: string): Phaser.GameObjects.Text;

            /**
             * Set the font style.
             * @param style The font style.
             */
            setFontStyle(style: string): Phaser.GameObjects.Text;

            /**
             * Set the font size. Can be a string with a valid CSS unit, i.e. `16px`, or a number.
             * @param size The font size.
             */
            setFontSize(size: number | string): Phaser.GameObjects.Text;

            /**
             * Set the test string to use when measuring the font.
             * @param string The test string to use when measuring the font.
             */
            setTestString(string: string): Phaser.GameObjects.Text;

            /**
             * Set a fixed width and height for the text.
             * 
             * Pass in `0` for either of these parameters to disable fixed width or height respectively.
             * @param width The fixed width to set.
             * @param height The fixed height to set.
             */
            setFixedSize(width: number, height: number): Phaser.GameObjects.Text;

            /**
             * Set the background color.
             * @param color The background color.
             */
            setBackgroundColor(color: string): Phaser.GameObjects.Text;

            /**
             * Set the text fill color.
             * @param color The text fill color.
             */
            setFill(color: string | CanvasGradient | CanvasPattern): Phaser.GameObjects.Text;

            /**
             * Set the text fill color.
             * @param color The text fill color.
             */
            setColor(color: string | CanvasGradient | CanvasPattern): Phaser.GameObjects.Text;

            /**
             * Set the resolution used by the Text object.
             * 
             * It allows for much clearer text on High DPI devices, at the cost of memory because
             * it uses larger internal Canvas textures for the Text.
             * 
             * Please use with caution, as the more high res Text you have, the more memory it uses up.
             * @param value The resolution for this Text object to use.
             */
            setResolution(value: number): Phaser.GameObjects.Text;

            /**
             * Set the stroke settings.
             * @param color The stroke color.
             * @param thickness The stroke thickness.
             */
            setStroke(color: string | CanvasGradient | CanvasPattern, thickness: number): Phaser.GameObjects.Text;

            /**
             * Set the shadow settings.
             * 
             * Calling this method always re-measures the parent Text object,
             * so only call it when you actually change the shadow settings.
             * @param x The horizontal shadow offset. Default 0.
             * @param y The vertical shadow offset. Default 0.
             * @param color The shadow color. Default '#000'.
             * @param blur The shadow blur radius. Default 0.
             * @param shadowStroke Whether to stroke the shadow. Default false.
             * @param shadowFill Whether to fill the shadow. Default true.
             */
            setShadow(x?: number, y?: number, color?: string, blur?: number, shadowStroke?: boolean, shadowFill?: boolean): Phaser.GameObjects.Text;

            /**
             * Set the shadow offset.
             * @param x The horizontal shadow offset. Default 0.
             * @param y The vertical shadow offset. Default 0.
             */
            setShadowOffset(x?: number, y?: number): Phaser.GameObjects.Text;

            /**
             * Set the shadow color.
             * @param color The shadow color. Default '#000'.
             */
            setShadowColor(color?: string): Phaser.GameObjects.Text;

            /**
             * Set the shadow blur radius.
             * @param blur The shadow blur radius. Default 0.
             */
            setShadowBlur(blur?: number): Phaser.GameObjects.Text;

            /**
             * Enable or disable shadow stroke.
             * @param enabled Whether shadow stroke is enabled or not.
             */
            setShadowStroke(enabled: boolean): Phaser.GameObjects.Text;

            /**
             * Enable or disable shadow fill.
             * @param enabled Whether shadow fill is enabled or not.
             */
            setShadowFill(enabled: boolean): Phaser.GameObjects.Text;

            /**
             * Set the width (in pixels) to use for wrapping lines.
             * 
             * Pass in null to remove wrapping by width.
             * @param width The maximum width of a line in pixels. Set to null to remove wrapping.
             * @param useAdvancedWrap Whether or not to use the advanced wrapping
             * algorithm. If true, spaces are collapsed and whitespace is trimmed from lines. If false,
             * spaces and whitespace are left as is. Default false.
             */
            setWordWrapWidth(width: number, useAdvancedWrap?: boolean): Phaser.GameObjects.Text;

            /**
             * Set a custom callback for wrapping lines.
             * 
             * Pass in null to remove wrapping by callback.
             * @param callback A custom function that will be responsible for wrapping the
             * text. It will receive two arguments: text (the string to wrap), textObject (this Text
             * instance). It should return the wrapped lines either as an array of lines or as a string with
             * newline characters in place to indicate where breaks should happen.
             * @param scope The scope that will be applied when the callback is invoked. Default null.
             */
            setWordWrapCallback(callback: TextStyleWordWrapCallback, scope?: object): Phaser.GameObjects.Text;

            /**
             * Set the alignment of the text in this Text object.
             * 
             * The argument can be one of: `left`, `right`, `center` or `justify`.
             * 
             * Alignment only works if the Text object has more than one line of text.
             * @param align The text alignment for multi-line text. Default 'left'.
             */
            setAlign(align?: string): Phaser.GameObjects.Text;

            /**
             * Set the maximum number of lines to draw.
             * @param max The maximum number of lines to draw. Default 0.
             */
            setMaxLines(max?: number): Phaser.GameObjects.Text;

            /**
             * Get the current text metrics.
             */
            getTextMetrics(): Phaser.Types.GameObjects.Text.TextMetrics;

            /**
             * Build a JSON representation of this Text Style.
             */
            toJSON(): object;

            /**
             * Destroy this Text Style.
             */
            destroy(): void;

        }

        /**
         * A TileSprite is a Sprite that has a repeating texture.
         * 
         * The texture can be scrolled and scaled independently of the TileSprite itself. Textures will automatically wrap and
         * are designed so that you can create game backdrops using seamless textures as a source.
         * 
         * You shouldn't ever create a TileSprite any larger than your actual canvas size. If you want to create a large repeating background
         * that scrolls across the whole map of your game, then you create a TileSprite that fits the canvas size and then use the `tilePosition`
         * property to scroll the texture as the player moves. If you create a TileSprite that is thousands of pixels in size then it will
         * consume huge amounts of memory and cause performance issues. Remember: use `tilePosition` to scroll your texture and `tileScale` to
         * adjust the scale of the texture - don't resize the sprite itself or make it larger than it needs.
         * 
         * An important note about Tile Sprites and NPOT textures: Internally, TileSprite textures use GL_REPEAT to provide
         * seamless repeating of the textures. This, combined with the way in which the textures are handled in WebGL, means
         * they need to be POT (power-of-two) sizes in order to wrap. If you provide a NPOT (non power-of-two) texture to a
         * TileSprite it will generate a POT sized canvas and draw your texture to it, scaled up to the POT size. It's then
         * scaled back down again during rendering to the original dimensions. While this works, in that it allows you to use
         * any size texture for a Tile Sprite, it does mean that NPOT textures are going to appear anti-aliased when rendered,
         * due to the interpolation that took place when it was resized into a POT texture. This is especially visible in
         * pixel art graphics. If you notice it and it becomes an issue, the only way to avoid it is to ensure that you
         * provide POT textures for Tile Sprites.
         */
        class TileSprite extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.ComputedSize, Phaser.GameObjects.Components.Crop, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the Game Object. If zero it will use the size of the texture frame.
             * @param height The height of the Game Object. If zero it will use the size of the texture frame.
             * @param textureKey The key of the Texture this Game Object will use to render with, as stored in the Texture Manager. Cannot be a DynamicTexture.
             * @param frameKey An optional frame from the Texture this Game Object is rendering with.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, width: number, height: number, textureKey: string, frameKey?: string | number);

            /**
             * Whether the Tile Sprite has changed in some way, requiring an re-render of its tile texture.
             * 
             * Such changes include the texture frame and scroll position of the Tile Sprite.
             */
            dirty: boolean;

            /**
             * The renderer in use by this Tile Sprite.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The Canvas element that the TileSprite renders its fill pattern in to.
             * Only used in Canvas mode.
             */
            canvas: HTMLCanvasElement | null;

            /**
             * The Context of the Canvas element that the TileSprite renders its fill pattern in to.
             * Only used in Canvas mode.
             */
            context: CanvasRenderingContext2D;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * The next power of two value from the width of the Fill Pattern frame.
             */
            potWidth: number;

            /**
             * The next power of two value from the height of the Fill Pattern frame.
             */
            potHeight: number;

            /**
             * The Canvas that the TileSprites texture is rendered to.
             * This is used to create a WebGL texture from.
             */
            fillCanvas: HTMLCanvasElement;

            /**
             * The Canvas Context used to render the TileSprites texture.
             */
            fillContext: CanvasRenderingContext2D;

            /**
             * The texture that the Tile Sprite is rendered to, which is then rendered to a Scene.
             * In WebGL this is a WebGLTexture. In Canvas it's a Canvas Fill Pattern.
             */
            fillPattern: WebGLTexture | CanvasPattern | null;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * The Frame has to belong to the current Texture being used.
             * 
             * It can be either a string or an index.
             * @param frame The name or index of the frame within the Texture.
             */
            setFrame(frame: string | number): this;

            /**
             * Sets {@link Phaser.GameObjects.TileSprite#tilePositionX} and {@link Phaser.GameObjects.TileSprite#tilePositionY}.
             * @param x The x position of this sprite's tiling texture.
             * @param y The y position of this sprite's tiling texture.
             */
            setTilePosition(x?: number, y?: number): this;

            /**
             * Sets {@link Phaser.GameObjects.TileSprite#tileScaleX} and {@link Phaser.GameObjects.TileSprite#tileScaleY}.
             * @param x The horizontal scale of the tiling texture. If not given it will use the current `tileScaleX` value.
             * @param y The vertical scale of the tiling texture. If not given it will use the `x` value. Default x.
             */
            setTileScale(x?: number, y?: number): this;

            /**
             * Internal destroy handler, called as part of the destroy process.
             */
            protected preDestroy(): void;

            /**
             * The horizontal scroll position of the Tile Sprite.
             */
            tilePositionX: number;

            /**
             * The vertical scroll position of the Tile Sprite.
             */
            tilePositionY: number;

            /**
             * The horizontal scale of the Tile Sprite texture.
             */
            tileScaleX: number;

            /**
             * The vertical scale of the Tile Sprite texture.
             */
            tileScaleY: number;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * The Update List plugin.
         * 
         * Update Lists belong to a Scene and maintain the list Game Objects to be updated every frame.
         * 
         * Some or all of these Game Objects may also be part of the Scene's [Display List]{@link Phaser.GameObjects.DisplayList}, for Rendering.
         */
        class UpdateList extends Phaser.Structs.ProcessQueue<Phaser.GameObjects.GameObject> {
            /**
             * 
             * @param scene The Scene that the Update List belongs to.
             */
            constructor(scene: Phaser.Scene);

            /**
             * The Scene that the Update List belongs to.
             */
            scene: Phaser.Scene;

            /**
             * The Scene's Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The update step.
             * 
             * Pre-updates every active Game Object in the list.
             * @param time The current timestamp.
             * @param delta The delta time elapsed since the last frame.
             */
            sceneUpdate(time: number, delta: number): void;

            /**
             * The Scene that owns this plugin is shutting down.
             * 
             * We need to kill and reset all internal properties as well as stop listening to Scene events.
             */
            shutdown(): void;

            /**
             * The Scene that owns this plugin is being destroyed.
             * 
             * We need to shutdown and then kill off all external references.
             */
            destroy(): void;

        }

        /**
         * A Video Game Object.
         * 
         * This Game Object is capable of handling playback of a video file, video stream or media stream.
         * 
         * You can optionally 'preload' the video into the Phaser Video Cache:
         * 
         * ```javascript
         * preload () {
         *   this.load.video('ripley', 'assets/aliens.mp4');
         * }
         * 
         * create () {
         *   this.add.video(400, 300, 'ripley');
         * }
         * ```
         * 
         * You don't have to 'preload' the video. You can also play it directly from a URL:
         * 
         * ```javascript
         * create () {
         *   this.add.video(400, 300).loadURL('assets/aliens.mp4');
         * }
         * ```
         * 
         * To all intents and purposes, a video is a standard Game Object, just like a Sprite. And as such, you can do
         * all the usual things to it, such as scaling, rotating, cropping, tinting, making interactive, giving a
         * physics body, etc.
         * 
         * Transparent videos are also possible via the WebM file format. Providing the video file has was encoded with
         * an alpha channel, and providing the browser supports WebM playback (not all of them do), then it will render
         * in-game with full transparency.
         * 
         * Playback is handled entirely via the Request Video Frame API, which is supported by most modern browsers.
         * A polyfill is provided for older browsers.
         * 
         * ### Autoplaying Videos
         * 
         * Videos can only autoplay if the browser has been unlocked with an interaction, or satisfies the MEI settings.
         * The policies that control autoplaying are vast and vary between browser. You can, and should, read more about
         * it here: https://developer.mozilla.org/en-US/docs/Web/Media/Autoplay_guide
         * 
         * If your video doesn't contain any audio, then set the `noAudio` parameter to `true` when the video is _loaded_,
         * and it will often allow the video to play immediately:
         * 
         * ```javascript
         * preload () {
         *   this.load.video('pixar', 'nemo.mp4', true);
         * }
         * ```
         * 
         * The 3rd parameter in the load call tells Phaser that the video doesn't contain any audio tracks. Video without
         * audio can autoplay without requiring a user interaction. Video with audio cannot do this unless it satisfies
         * the browsers MEI settings. See the MDN Autoplay Guide for further details.
         * 
         * Or:
         * 
         * ```javascript
         * create () {
         *   this.add.video(400, 300).loadURL('assets/aliens.mp4', true);
         * }
         * ```
         * 
         * You can set the `noAudio` parameter to `true` even if the video does contain audio. It will still allow the video
         * to play immediately, but the audio will not start.
         * 
         * Note that due to a bug in IE11 you cannot play a video texture to a Sprite in WebGL. For IE11 force Canvas mode.
         * 
         * More details about video playback and the supported media formats can be found on MDN:
         * 
         * https://developer.mozilla.org/en-US/docs/Web/API/HTMLVideoElement
         * https://developer.mozilla.org/en-US/docs/Web/Media/Formats
         */
        class Video extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.TextureCrop, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param key Optional key of the Video this Game Object will play, as stored in the Video Cache.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, key?: string);

            /**
             * A reference to the HTML Video Element this Video Game Object is playing.
             * 
             * Will be `undefined` until a video is loaded for playback.
             */
            video: HTMLVideoElement | null;

            /**
             * The Phaser Texture this Game Object is using to render the video to.
             * 
             * Will be `undefined` until a video is loaded for playback.
             */
            videoTexture: Phaser.Textures.Texture | null;

            /**
             * A reference to the TextureSource backing the `videoTexture` Texture object.
             * 
             * Will be `undefined` until a video is loaded for playback.
             */
            videoTextureSource: Phaser.Textures.TextureSource | null;

            /**
             * A Phaser `CanvasTexture` instance that holds the most recent snapshot taken from the video.
             * 
             * This will only be set if the `snapshot` or `snapshotArea` methods have been called.
             * 
             * Until those methods are called, this property will be `undefined`.
             */
            snapshotTexture: Phaser.Textures.CanvasTexture | null;

            /**
             * If you have saved this video to a texture via the `saveTexture` method, this controls if the video
             * is rendered with `flipY` in WebGL or not. You often need to set this if you wish to use the video texture
             * as the input source for a shader. If you find your video is appearing upside down within a shader or
             * custom pipeline, flip this property.
             */
            flipY: boolean;

            /**
             * An internal flag holding the current state of the video lock, should document interaction be required
             * before playback can begin.
             */
            readonly touchLocked: boolean;

            /**
             * Should the video auto play when document interaction is required and happens?
             */
            playWhenUnlocked: boolean;

            /**
             * Has the video created its texture and populated it with the first frame of video?
             */
            frameReady: boolean;

            /**
             * This read-only property returns `true` if the video is currently stalled, i.e. it has stopped
             * playing due to a lack of data, or too much data, but hasn't yet reached the end of the video.
             * 
             * This is set if the Video DOM element emits any of the following events:
             * 
             * `stalled`
             * `suspend`
             * `waiting`
             * 
             * And is cleared if the Video DOM element emits the `playing` event, or handles
             * a requestVideoFrame call.
             * 
             * Listen for the Phaser Event `VIDEO_STALLED` to be notified and inspect the event
             * to see which DOM event caused it.
             * 
             * Note that being stalled isn't always a negative thing. A video can be stalled if it
             * has downloaded enough data in to its buffer to not need to download any more until
             * the current batch of frames have rendered.
             */
            readonly isStalled: boolean;

            /**
             * Records the number of times the video has failed to play,
             * typically because the user hasn't interacted with the page yet.
             */
            failedPlayAttempts: number;

            /**
             * If the browser supports the Request Video Frame API then this
             * property will hold the metadata that is returned from
             * the callback each time it is invoked.
             * 
             * See https://wicg.github.io/video-rvfc/#video-frame-metadata-callback
             * for a complete list of all properties that will be in this object.
             * Likely of most interest is the `mediaTime` property:
             * 
             * The media presentation timestamp (PTS) in seconds of the frame presented
             * (e.g. its timestamp on the video.currentTime timeline). MAY have a zero
             * value for live-streams or WebRTC applications.
             * 
             * If the browser doesn't support the API then this property will be undefined.
             */
            metadata: VideoFrameCallbackMetadata;

            /**
             * The current retry elapsed time.
             */
            retry: number;

            /**
             * If a video fails to play due to a lack of user interaction, this is the
             * amount of time, in ms, that the video will wait before trying again to
             * play. The default is 500ms.
             */
            retryInterval: number;

            /**
             * An object containing in and out markers for sequence playback.
             */
            markers: any;

            /**
             * The key of the current video as stored in the Video cache.
             * 
             * If the video did not come from the cache this will be an empty string.
             */
            readonly cacheKey: string;

            /**
             * Is the video currently seeking?
             * 
             * This is set to `true` when the `seeking` event is fired,
             * and set to `false` when the `seeked` event is fired.
             */
            readonly isSeeking: boolean;

            /**
             * Loads a Video from the Video Cache, ready for playback with the `Video.play` method.
             * 
             * If a video is already playing, this method allows you to change the source of the current video element.
             * It works by first stopping the current video and then starts playback of the new source through the existing video element.
             * 
             * The reason you may wish to do this is because videos that require interaction to unlock, remain in an unlocked
             * state, even if you change the source of the video. By changing the source to a new video you avoid having to
             * go through the unlock process again.
             * @param key The key of the Video this Game Object will play, as stored in the Video Cache.
             */
            load(key: string): this;

            /**
             * This method allows you to change the source of the current video element. It works by first stopping the
             * current video, if playing. Then deleting the video texture, if one has been created. Finally, it makes a
             * new video texture and starts playback of the new source through the existing video element.
             * 
             * The reason you may wish to do this is because videos that require interaction to unlock, remain in an unlocked
             * state, even if you change the source of the video. By changing the source to a new video you avoid having to
             * go through the unlock process again.
             * @param key The key of the Video this Game Object will swap to playing, as stored in the Video Cache.
             * @param autoplay Should the video start playing immediately, once the swap is complete? Default true.
             * @param loop Should the video loop automatically when it reaches the end? Please note that not all browsers support _seamless_ video looping for all encoding formats. Default false.
             * @param markerIn Optional in marker time, in seconds, for playback of a sequence of the video.
             * @param markerOut Optional out marker time, in seconds, for playback of a sequence of the video.
             */
            changeSource(key: string, autoplay?: boolean, loop?: boolean, markerIn?: number, markerOut?: number): this;

            /**
             * Returns the key of the currently played video, as stored in the Video Cache.
             * 
             * If the video did not come from the cache this will return an empty string.
             */
            getVideoKey(): string;

            /**
             * Loads a Video from the given URL, ready for playback with the `Video.play` method.
             * 
             * If a video is already playing, this method allows you to change the source of the current video element.
             * It works by first stopping the current video and then starts playback of the new source through the existing video element.
             * 
             * The reason you may wish to do this is because videos that require interaction to unlock, remain in an unlocked
             * state, even if you change the source of the video. By changing the source to a new video you avoid having to
             * go through the unlock process again.
             * @param urls The absolute or relative URL to load the video files from.
             * @param noAudio Does the video have an audio track? If not you can enable auto-playing on it. Default false.
             * @param crossOrigin The value to use for the `crossOrigin` property in the video load request.  Either undefined, `anonymous` or `use-credentials`. If no value is given, `crossorigin` will not be set in the request.
             */
            loadURL(urls?: string | string[] | Phaser.Types.Loader.FileTypes.VideoFileURLConfig | Phaser.Types.Loader.FileTypes.VideoFileURLConfig[], noAudio?: boolean, crossOrigin?: string): this;

            /**
             * Loads a Video from the given MediaStream object, ready for playback with the `Video.play` method.
             * @param stream The MediaStream object.
             * @param noAudio Does the video have an audio track? If not you can enable auto-playing on it. Default false.
             * @param crossOrigin The value to use for the `crossOrigin` property in the video load request.  Either undefined, `anonymous` or `use-credentials`. If no value is given, `crossorigin` will not be set in the request.
             */
            loadMediaStream(stream: string, noAudio?: boolean, crossOrigin?: string): this;

            /**
             * Internal method that loads a Video from the given URL, ready for playback with the
             * `Video.play` method.
             * 
             * Normally you don't call this method directly, but instead use the `Video.loadURL` method,
             * or the `Video.load` method if you have preloaded the video.
             * 
             * Calling this method will skip checking if the browser supports the given format in
             * the URL, where-as the other two methods enforce these checks.
             * @param url The absolute or relative URL to load the video file from. Set to `null` if passing in a MediaStream object.
             * @param noAudio Does the video have an audio track? If not you can enable auto-playing on it.
             * @param crossOrigin The value to use for the `crossOrigin` property in the video load request.  Either undefined, `anonymous` or `use-credentials`. If no value is given, `crossorigin` will not be set in the request.
             * @param stream A MediaStream object if this is playing a stream instead of a file.
             */
            loadHandler(url?: string, noAudio?: boolean, crossOrigin?: string, stream?: string): this;

            /**
             * This method handles the Request Video Frame callback.
             * 
             * It is called by the browser when a new video frame is ready to be displayed.
             * 
             * It's also responsible for the creation of the video texture, if it doesn't
             * already exist. If it does, it updates the texture as required.
             * 
             * For more details about the Request Video Frame callback, see:
             * https://web.dev/requestvideoframecallback-rvfc
             * @param now The current time in milliseconds.
             * @param metadata Useful metadata about the video frame that was most recently presented for composition. See https://wicg.github.io/video-rvfc/#video-frame-metadata-callback
             */
            requestVideoFrame(now: DOMHighResTimeStamp, metadata: VideoFrameCallbackMetadata): void;

            /**
             * Starts this video playing.
             * 
             * If the video is already playing, or has been queued to play with `changeSource` then this method just returns.
             * 
             * Videos can only autoplay if the browser has been unlocked. This happens if you have interacted with the browser, i.e.
             * by clicking on it or pressing a key, or due to server settings. The policies that control autoplaying are vast and
             * vary between browser. You can read more here: https://developer.mozilla.org/en-US/docs/Web/Media/Autoplay_guide
             * 
             * If your video doesn't contain any audio, then set the `noAudio` parameter to `true` when the video is loaded,
             * and it will often allow the video to play immediately:
             * 
             * ```javascript
             * preload () {
             *   this.load.video('pixar', 'nemo.mp4', true);
             * }
             * ```
             * 
             * The 3rd parameter in the load call tells Phaser that the video doesn't contain any audio tracks. Video without
             * audio can autoplay without requiring a user interaction. Video with audio cannot do this unless it satisfies
             * the browsers MEI settings. See the MDN Autoplay Guide for details.
             * 
             * If you need audio in your videos, then you'll have to consider the fact that the video cannot start playing until the
             * user has interacted with the browser, into your game flow.
             * @param loop Should the video loop automatically when it reaches the end? Please note that not all browsers support _seamless_ video looping for all encoding formats. Default false.
             * @param markerIn Optional in marker time, in seconds, for playback of a sequence of the video.
             * @param markerOut Optional out marker time, in seconds, for playback of a sequence of the video.
             */
            play(loop?: boolean, markerIn?: number, markerOut?: number): this;

            /**
             * Adds the loading specific event handlers to the video element.
             */
            addLoadEventHandlers(): void;

            /**
             * Removes the loading specific event handlers from the video element.
             */
            removeLoadEventHandlers(): void;

            /**
             * Adds the playback specific event handlers to the video element.
             */
            addEventHandlers(): void;

            /**
             * Removes the playback specific event handlers from the video element.
             */
            removeEventHandlers(): void;

            /**
             * Creates the video.play promise and adds the success and error handlers to it.
             * 
             * Not all browsers support the video.play promise, so this method will fall back to
             * the old-school way of handling the video.play call.
             * 
             * See https://developer.mozilla.org/en-US/docs/Web/API/HTMLMediaElement/play#browser_compatibility for details.
             * @param catchError Should the error be caught and the video marked as failed to play? Default true.
             */
            createPlayPromise(catchError?: boolean): void;

            /**
             * Adds a sequence marker to this video.
             * 
             * Markers allow you to split a video up into sequences, delineated by a start and end time, given in seconds.
             * 
             * You can then play back specific markers via the `playMarker` method.
             * 
             * Note that marker timing is _not_ frame-perfect. You should construct your videos in such a way that you allow for
             * plenty of extra padding before and after each sequence to allow for discrepancies in browser seek and currentTime accuracy.
             * 
             * See https://github.com/w3c/media-and-entertainment/issues/4 for more details about this issue.
             * @param key A unique name to give this marker.
             * @param markerIn The time, in seconds, representing the start of this marker.
             * @param markerOut The time, in seconds, representing the end of this marker.
             */
            addMarker(key: string, markerIn: number, markerOut: number): this;

            /**
             * Plays a pre-defined sequence in this video.
             * 
             * Markers allow you to split a video up into sequences, delineated by a start and end time, given in seconds and
             * specified via the `addMarker` method.
             * 
             * Note that marker timing is _not_ frame-perfect. You should construct your videos in such a way that you allow for
             * plenty of extra padding before and after each sequence to allow for discrepancies in browser seek and currentTime accuracy.
             * 
             * See https://github.com/w3c/media-and-entertainment/issues/4 for more details about this issue.
             * @param key The name of the marker sequence to play.
             * @param loop Should the video loop automatically when it reaches the end? Please note that not all browsers support _seamless_ video looping for all encoding formats. Default false.
             */
            playMarker(key: string, loop?: boolean): this;

            /**
             * Removes a previously set marker from this video.
             * 
             * If the marker is currently playing it will _not_ stop playback.
             * @param key The name of the marker to remove.
             */
            removeMarker(key: string): this;

            /**
             * Takes a snapshot of the current frame of the video and renders it to a CanvasTexture object,
             * which is then returned. You can optionally resize the grab by passing a width and height.
             * 
             * This method returns a reference to the `Video.snapshotTexture` object. Calling this method
             * multiple times will overwrite the previous snapshot with the most recent one.
             * @param width The width of the resulting CanvasTexture.
             * @param height The height of the resulting CanvasTexture.
             */
            snapshot(width?: number, height?: number): Phaser.Textures.CanvasTexture;

            /**
             * Takes a snapshot of the specified area of the current frame of the video and renders it to a CanvasTexture object,
             * which is then returned. You can optionally resize the grab by passing a different `destWidth` and `destHeight`.
             * 
             * This method returns a reference to the `Video.snapshotTexture` object. Calling this method
             * multiple times will overwrite the previous snapshot with the most recent one.
             * @param x The horizontal location of the top-left of the area to grab from. Default 0.
             * @param y The vertical location of the top-left of the area to grab from. Default 0.
             * @param srcWidth The width of area to grab from the video. If not given it will grab the full video dimensions.
             * @param srcHeight The height of area to grab from the video. If not given it will grab the full video dimensions.
             * @param destWidth The destination width of the grab, allowing you to resize it.
             * @param destHeight The destination height of the grab, allowing you to resize it.
             */
            snapshotArea(x?: number, y?: number, srcWidth?: number, srcHeight?: number, destWidth?: number, destHeight?: number): Phaser.Textures.CanvasTexture;

            /**
             * Stores a copy of this Videos `snapshotTexture` in the Texture Manager using the given key.
             * 
             * This texture is created when the `snapshot` or `snapshotArea` methods are called.
             * 
             * After doing this, any texture based Game Object, such as a Sprite, can use the contents of the
             * snapshot by using the texture key:
             * 
             * ```javascript
             * var vid = this.add.video(0, 0, 'intro');
             * 
             * vid.snapshot();
             * 
             * vid.saveSnapshotTexture('doodle');
             * 
             * this.add.image(400, 300, 'doodle');
             * ```
             * 
             * Updating the contents of the `snapshotTexture`, for example by calling `snapshot` again,
             * will automatically update _any_ Game Object that is using it as a texture.
             * Calling `saveSnapshotTexture` again will not save another copy of the same texture,
             * it will just rename the existing one.
             * 
             * By default it will create a single base texture. You can add frames to the texture
             * by using the `Texture.add` method. After doing this, you can then allow Game Objects
             * to use a specific frame.
             * @param key The unique key to store the texture as within the global Texture Manager.
             */
            saveSnapshotTexture(key: string): Phaser.Textures.CanvasTexture;

            /**
             * This internal method is called automatically if the playback Promise resolves successfully.
             */
            playSuccess(): void;

            /**
             * This internal method is called automatically if the playback Promise fails to resolve.
             * @param error The Promise DOM Exception error.
             */
            playError(error: DOMException): void;

            /**
             * Called when the video emits a `playing` event.
             * 
             * This is the legacy handler for browsers that don't support Promise based playback.
             */
            legacyPlayHandler(): void;

            /**
             * Called when the video emits a `playing` event.
             */
            playingHandler(): void;

            /**
             * This internal method is called automatically if the video fails to load.
             * @param event The error Event.
             */
            loadErrorHandler(event: Event): void;

            /**
             * This internal method is called automatically if the video stalls, for whatever reason.
             * @param event The error Event.
             */
            stalledHandler(event: Event): void;

            /**
             * Called when the video completes playback, i.e. reaches an `ended` state.
             * 
             * This will never happen if the video is coming from a live stream, where the duration is `Infinity`.
             */
            completeHandler(): void;

            /**
             * Seeks to a given point in the video. The value is given as a float between 0 and 1,
             * where 0 represents the start of the video and 1 represents the end.
             * 
             * Seeking only works if the video has a duration, so will not work for live streams.
             * 
             * When seeking begins, this video will emit a `seeking` event. When the video completes
             * seeking (i.e. reaches its designated timestamp) it will emit a `seeked` event.
             * 
             * If you wish to seek based on time instead, use the `Video.setCurrentTime` method.
             * 
             * Unfortunately, the DOM video element does not guarantee frame-accurate seeking.
             * This has been an ongoing subject of discussion: https://github.com/w3c/media-and-entertainment/issues/4
             * @param value The point in the video to seek to. A value between 0 and 1.
             */
            seekTo(value: number): this;

            /**
             * A double-precision floating-point value indicating the current playback time in seconds.
             * 
             * If the media has not started to play and has not been seeked, this value is the media's initial playback time.
             * 
             * For a more accurate value, use the `Video.metadata.mediaTime` property instead.
             */
            getCurrentTime(): number;

            /**
             * Seeks to a given playback time in the video. The value is given in _seconds_ or as a string.
             * 
             * Seeking only works if the video has a duration, so will not work for live streams.
             * 
             * When seeking begins, this video will emit a `seeking` event. When the video completes
             * seeking (i.e. reaches its designated timestamp) it will emit a `seeked` event.
             * 
             * You can provide a string prefixed with either a `+` or a `-`, such as `+2.5` or `-2.5`.
             * In this case it will seek to +/- the value given, relative to the _current time_.
             * 
             * If you wish to seek based on a duration percentage instead, use the `Video.seekTo` method.
             * @param value The playback time to seek to in seconds. Can be expressed as a string, such as `+2` to seek 2 seconds ahead from the current time.
             */
            setCurrentTime(value: string | number): this;

            /**
             * Returns the current progress of the video as a float.
             * 
             * Progress is defined as a value between 0 (the start) and 1 (the end).
             * 
             * Progress can only be returned if the video has a duration. Some videos,
             * such as those coming from a live stream, do not have a duration. In this
             * case the method will return -1.
             */
            getProgress(): number;

            /**
             * A double-precision floating-point value which indicates the duration (total length) of the media in seconds,
             * on the media's timeline. If no media is present on the element, or the media is not valid, the returned value is NaN.
             * 
             * If the media has no known end (such as for live streams of unknown duration, web radio, media incoming from WebRTC,
             * and so forth), this value is +Infinity.
             * 
             * If no video has been loaded, this method will return 0.
             */
            getDuration(): number;

            /**
             * Sets the muted state of the currently playing video, if one is loaded.
             * @param value The mute value. `true` if the video should be muted, otherwise `false`. Default true.
             */
            setMute(value?: boolean): this;

            /**
             * Returns a boolean indicating if this Video is currently muted.
             */
            isMuted(): boolean;

            /**
             * Sets the paused state of the currently loaded video.
             * 
             * If the video is playing, calling this method with `true` will pause playback.
             * If the video is paused, calling this method with `false` will resume playback.
             * 
             * If no video is loaded, this method does nothing.
             * 
             * If the video has not yet been played, `Video.play` will be called with no parameters.
             * 
             * If the video has ended, this method will do nothing.
             * @param value The paused value. `true` if the video should be paused, `false` to resume it. Default true.
             */
            setPaused(value?: boolean): this;

            /**
             * Pauses the current Video, if one is playing.
             * 
             * If no video is loaded, this method does nothing.
             * 
             * Call `Video.resume` to resume playback.
             */
            pause(): this;

            /**
             * Resumes the current Video, if one was previously playing and has been paused.
             * 
             * If no video is loaded, this method does nothing.
             * 
             * Call `Video.pause` to pause playback.
             */
            resume(): this;

            /**
             * Returns a double indicating the audio volume, from 0.0 (silent) to 1.0 (loudest).
             */
            getVolume(): number;

            /**
             * Sets the volume of the currently playing video.
             * 
             * The value given is a double indicating the audio volume, from 0.0 (silent) to 1.0 (loudest).
             * @param value A double indicating the audio volume, from 0.0 (silent) to 1.0 (loudest). Default 1.
             */
            setVolume(value?: number): this;

            /**
             * Returns a double that indicates the rate at which the media is being played back.
             */
            getPlaybackRate(): number;

            /**
             * Sets the playback rate of the current video.
             * 
             * The value given is a double that indicates the rate at which the media is being played back.
             * @param rate A double that indicates the rate at which the media is being played back.
             */
            setPlaybackRate(rate?: number): this;

            /**
             * Returns a boolean which indicates whether the media element should start over when it reaches the end.
             */
            getLoop(): boolean;

            /**
             * Sets the loop state of the current video.
             * 
             * The value given is a boolean which indicates whether the media element will start over when it reaches the end.
             * 
             * Not all videos can loop, for example live streams.
             * 
             * Please note that not all browsers support _seamless_ video looping for all encoding formats.
             * @param value A boolean which indicates whether the media element will start over when it reaches the end. Default true.
             */
            setLoop(value?: boolean): this;

            /**
             * Returns a boolean which indicates whether the video is currently playing.
             */
            isPlaying(): boolean;

            /**
             * Returns a boolean which indicates whether the video is currently paused.
             */
            isPaused(): boolean;

            /**
             * Stores this Video in the Texture Manager using the given key as a dynamic texture,
             * which any texture-based Game Object, such as a Sprite, can use as its source:
             * 
             * ```javascript
             * const vid = this.add.video(0, 0, 'intro');
             * 
             * vid.play();
             * 
             * vid.saveTexture('doodle');
             * 
             * this.add.image(400, 300, 'doodle');
             * ```
             * 
             * If the video is not yet playing then you need to listen for the `TEXTURE_READY` event before
             * you can use this texture on a Game Object:
             * 
             * ```javascript
             * const vid = this.add.video(0, 0, 'intro');
             * 
             * vid.play();
             * 
             * vid.once('textureready', (video, texture, key) => {
             * 
             *     this.add.image(400, 300, key);
             * 
             * });
             * 
             * vid.saveTexture('doodle');
             * ```
             * 
             * The saved texture is automatically updated as the video plays. If you pause this video,
             * or change its source, then the saved texture updates instantly.
             * 
             * Calling `saveTexture` again will not save another copy of the same texture, it will just rename the existing one.
             * 
             * By default it will create a single base texture. You can add frames to the texture
             * by using the `Texture.add` method. After doing this, you can then allow Game Objects
             * to use a specific frame.
             * 
             * If you intend to save the texture so you can use it as the input for a Shader, you may need to set the
             * `flipY` parameter to `true` if you find the video renders upside down in your shader.
             * @param key The unique key to store the texture as within the global Texture Manager.
             * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y` during upload? Default false.
             */
            saveTexture(key: string, flipY?: boolean): boolean;

            /**
             * Stops the video playing and clears all internal event listeners.
             * 
             * If you only wish to pause playback of the video, and resume it a later time, use the `Video.pause` method instead.
             * 
             * If the video hasn't finished downloading, calling this method will not abort the download. To do that you need to
             * call `destroy` instead.
             * @param emitStopEvent Should the `VIDEO_STOP` event be emitted? Default true.
             */
            stop(emitStopEvent?: boolean): this;

            /**
             * Removes the Video element from the DOM by calling parentNode.removeChild on itself.
             * 
             * Also removes the autoplay and src attributes and nulls the `Video.video` reference.
             * 
             * If you loaded an external video via `Video.loadURL` then you should call this function
             * to clear up once you are done with the instance, but don't want to destroy this
             * Video Game Object.
             * 
             * This method is called automatically by `Video.destroy`.
             */
            removeVideoElement(): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object to be that of the given Frame.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param frame The frame to base the size of this Game Object on.
             */
            setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The Texture this Game Object is using to render with.
             */
            texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

            /**
             * The Texture Frame this Game Object is using to render with.
             */
            frame: Phaser.Textures.Frame;

            /**
             * A boolean flag indicating if this Game Object is being cropped or not.
             * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
             * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
             */
            isCropped: boolean;

            /**
             * Applies a crop to a texture based Game Object, such as a Sprite or Image.
             * 
             * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
             * 
             * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
             * changes what is shown when rendered.
             * 
             * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
             * 
             * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
             * half of it, you could call `setCrop(0, 0, 400, 600)`.
             * 
             * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
             * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
             * 
             * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
             * 
             * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
             * 
             * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
             * the renderer to skip several internal calculations.
             * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
             * @param y The y coordinate to start the crop from.
             * @param width The width of the crop rectangle in pixels.
             * @param height The height of the crop rectangle in pixels.
             */
            setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

            /**
             * Sets the texture and frame this Game Object will use to render with.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             */
            setTexture(key: string, frame?: string | number): this;

            /**
             * Sets the frame this Game Object will use to render with.
             * 
             * If you pass a string or index then the Frame has to belong to the current Texture being used
             * by this Game Object.
             * 
             * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
             * 
             * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
             * 
             * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
             * @param frame The name or index of the frame within the Texture, or a Frame instance.
             * @param updateSize Should this call adjust the size of the Game Object? Default true.
             * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
             */
            setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

            /**
             * The tint value being applied to the top-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopLeft: number;

            /**
             * The tint value being applied to the top-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintTopRight: number;

            /**
             * The tint value being applied to the bottom-left vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomLeft: number;

            /**
             * The tint value being applied to the bottom-right vertice of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
             */
            tintBottomRight: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * Clears all tint values associated with this Game Object.
             * 
             * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
             * which results in no visible change to the texture.
             */
            clearTint(): this;

            /**
             * Sets an additive tint on this Game Object.
             * 
             * The tint works by taking the pixel color values from the Game Objects texture, and then
             * multiplying it by the color value of the tint. You can provide either one color value,
             * in which case the whole Game Object will be tinted in that color. Or you can provide a color
             * per corner. The colors are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * Sets a fill-based tint on this Game Object.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint. You can use this for effects such as making a player flash 'white'
             * if hit by something. You can provide either one color value, in which case the whole
             * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
             * are blended together across the extent of the Game Object.
             * 
             * To modify the tint color once set, either call this method again with new values or use the
             * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
             * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
             * 
             * To remove a tint call `clearTint`.
             * 
             * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
             * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
             * @param topRight The tint being applied to the top-right of the Game Object.
             * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
             * @param bottomRight The tint being applied to the bottom-right of the Game Object.
             */
            setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The tint value being applied to the whole of the Game Object.
             * Return `tintTopLeft` when read this tint property.
             */
            tint: number;

            /**
             * Does this Game Object have a tint applied?
             * 
             * It checks to see if the 4 tint properties are set to the value 0xffffff
             * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
             */
            readonly isTinted: boolean;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Zone Game Object.
         * 
         * A Zone is a non-rendering rectangular Game Object that has a position and size.
         * It has no texture and never displays, but does live on the display list and
         * can be moved, scaled and rotated like any other Game Object.
         * 
         * Its primary use is for creating Drop Zones and Input Hit Areas and it has a couple of helper methods
         * specifically for this. It is also useful for object overlap checks, or as a base for your own
         * non-displaying Game Objects.
         * The default origin is 0.5, the center of the Zone, the same as with Game Objects.
         */
        class Zone extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs.
             * @param x The horizontal position of this Game Object in the world.
             * @param y The vertical position of this Game Object in the world.
             * @param width The width of the Game Object. Default 1.
             * @param height The height of the Game Object. Default 1.
             */
            constructor(scene: Phaser.Scene, x: number, y: number, width?: number, height?: number);

            /**
             * The native (un-scaled) width of this Game Object.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             */
            height: number;

            /**
             * The Blend Mode of the Game Object.
             * Although a Zone never renders, it still has a blend mode to allow it to fit seamlessly into
             * display lists without causing a batch flush.
             */
            blendMode: number;

            /**
             * The displayed width of this Game Object.
             * This value takes into account the scale factor.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * This value takes into account the scale factor.
             */
            displayHeight: number;

            /**
             * Sets the size of this Game Object.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             * @param resizeInput If this Zone has a Rectangle for a hit area this argument will resize the hit area as well. Default true.
             */
            setSize(width: number, height: number, resizeInput?: boolean): this;

            /**
             * Sets the display size of this Game Object.
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * Sets this Zone to be a Circular Drop Zone.
             * The circle is centered on this Zones `x` and `y` coordinates.
             * @param radius The radius of the Circle that will form the Drop Zone.
             */
            setCircleDropZone(radius: number): this;

            /**
             * Sets this Zone to be a Rectangle Drop Zone.
             * The rectangle is centered on this Zones `x` and `y` coordinates.
             * @param width The width of the rectangle drop zone.
             * @param height The height of the rectangle drop zone.
             */
            setRectangleDropZone(width: number, height: number): this;

            /**
             * Allows you to define your own Geometry shape to be used as a Drop Zone.
             * @param hitArea A Geometry shape instance, such as Phaser.Geom.Ellipse, or your own custom shape. If not given it will try to create a Rectangle based on the size of this zone.
             * @param hitAreaCallback A function that will return `true` if the given x/y coords it is sent are within the shape. If you provide a shape you must also provide a callback.
             */
            setDropZone(hitArea?: object, hitAreaCallback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The horizontal origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the left of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Game Object.
             * The origin maps the relationship between the size and position of the Game Object.
             * The default value is 0.5, meaning all Game Objects are positioned based on their center.
             * Setting the value to 0 means the position now relates to the top of the Game Object.
             * Set this value with `setOrigin()`.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginX: number;

            /**
             * The vertical display origin of this Game Object.
             * The origin is a normalized value between 0 and 1.
             * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
             */
            displayOriginY: number;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

    }

    namespace Geom {
        /**
         * A Circle object.
         * 
         * This is a geometry object, containing numerical values and related methods to inspect and modify them.
         * It is not a Game Object, in that you cannot add it to the display list, and it has no texture.
         * To render a Circle you should look at the capabilities of the Graphics class.
         */
        class Circle {
            /**
             * 
             * @param x The x position of the center of the circle. Default 0.
             * @param y The y position of the center of the circle. Default 0.
             * @param radius The radius of the circle. Default 0.
             */
            constructor(x?: number, y?: number, radius?: number);

            /**
             * Calculates the area of the circle.
             * @param circle The Circle to get the area of.
             */
            static Area(circle: Phaser.Geom.Circle): number;

            /**
             * The geometry constant type of this object: `GEOM_CONST.CIRCLE`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The x position of the center of the circle.
             */
            x: number;

            /**
             * The y position of the center of the circle.
             */
            y: number;

            /**
             * Check to see if the Circle contains the given x / y coordinates.
             * @param x The x coordinate to check within the circle.
             * @param y The y coordinate to check within the circle.
             */
            contains(x: number, y: number): boolean;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Circle
             * based on the given angle normalized to the range 0 to 1. I.e. a value of 0.5 will give the point
             * at 180 degrees around the circle.
             * @param position A value between 0 and 1, where 0 equals 0 degrees, 0.5 equals 180 degrees and 1 equals 360 around the circle.
             * @param out An object to store the return values in. If not given a Point object will be created.
             */
            getPoint<O extends Phaser.Geom.Point>(position: number, out?: O): O;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the circumference of the Circle,
             * based on the given quantity or stepRate values.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the circumference of the circle and dividing it by the stepRate.
             * @param output An array to insert the points in to. If not provided a new array will be created.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Returns a uniformly distributed random point from anywhere within the Circle.
             * @param point A Point or point-like object to set the random `x` and `y` values in.
             */
            getRandomPoint<O extends Phaser.Geom.Point>(point?: O): O;

            /**
             * Sets the x, y and radius of this circle.
             * @param x The x position of the center of the circle. Default 0.
             * @param y The y position of the center of the circle. Default 0.
             * @param radius The radius of the circle. Default 0.
             */
            setTo(x?: number, y?: number, radius?: number): this;

            /**
             * Sets this Circle to be empty with a radius of zero.
             * Does not change its position.
             */
            setEmpty(): this;

            /**
             * Sets the position of this Circle.
             * @param x The x position of the center of the circle. Default 0.
             * @param y The y position of the center of the circle. Default 0.
             */
            setPosition(x?: number, y?: number): this;

            /**
             * Checks to see if the Circle is empty: has a radius of zero.
             */
            isEmpty(): boolean;

            /**
             * The radius of the Circle.
             */
            radius: number;

            /**
             * The diameter of the Circle.
             */
            diameter: number;

            /**
             * The left position of the Circle.
             */
            left: number;

            /**
             * The right position of the Circle.
             */
            right: number;

            /**
             * The top position of the Circle.
             */
            top: number;

            /**
             * The bottom position of the Circle.
             */
            bottom: number;

            /**
             * Returns the circumference of the given Circle.
             * @param circle The Circle to get the circumference of.
             */
            static Circumference(circle: Phaser.Geom.Circle): number;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Circle based on the given angle.
             * @param circle The Circle to get the circumference point on.
             * @param angle The angle from the center of the Circle to the circumference to return the point from. Given in radians.
             * @param out A Point, or point-like object, to store the results in. If not given a Point will be created.
             */
            static CircumferencePoint<O extends Phaser.Geom.Point>(circle: Phaser.Geom.Circle, angle: number, out?: O): O;

            /**
             * Creates a new Circle instance based on the values contained in the given source.
             * @param source The Circle to be cloned. Can be an instance of a Circle or a circle-like object, with x, y and radius properties.
             */
            static Clone(source: Phaser.Geom.Circle | object): Phaser.Geom.Circle;

            /**
             * Check to see if the Circle contains the given x / y coordinates.
             * @param circle The Circle to check.
             * @param x The x coordinate to check within the circle.
             * @param y The y coordinate to check within the circle.
             */
            static Contains(circle: Phaser.Geom.Circle, x: number, y: number): boolean;

            /**
             * Check to see if the Circle contains the given Point object.
             * @param circle The Circle to check.
             * @param point The Point object to check if it's within the Circle or not.
             */
            static ContainsPoint(circle: Phaser.Geom.Circle, point: Phaser.Geom.Point | object): boolean;

            /**
             * Check to see if the Circle contains all four points of the given Rectangle object.
             * @param circle The Circle to check.
             * @param rect The Rectangle object to check if it's within the Circle or not.
             */
            static ContainsRect(circle: Phaser.Geom.Circle, rect: Phaser.Geom.Rectangle | object): boolean;

            /**
             * Copies the `x`, `y` and `radius` properties from the `source` Circle
             * into the given `dest` Circle, then returns the `dest` Circle.
             * @param source The source Circle to copy the values from.
             * @param dest The destination Circle to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Circle>(source: Phaser.Geom.Circle, dest: O): O;

            /**
             * Compares the `x`, `y` and `radius` properties of the two given Circles.
             * Returns `true` if they all match, otherwise returns `false`.
             * @param circle The first Circle to compare.
             * @param toCompare The second Circle to compare.
             */
            static Equals(circle: Phaser.Geom.Circle, toCompare: Phaser.Geom.Circle): boolean;

            /**
             * Returns the bounds of the Circle object.
             * @param circle The Circle to get the bounds from.
             * @param out A Rectangle, or rectangle-like object, to store the circle bounds in. If not given a new Rectangle will be created.
             */
            static GetBounds<O extends Phaser.Geom.Rectangle>(circle: Phaser.Geom.Circle, out?: O): O;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Circle
             * based on the given angle normalized to the range 0 to 1. I.e. a value of 0.5 will give the point
             * at 180 degrees around the circle.
             * @param circle The Circle to get the circumference point on.
             * @param position A value between 0 and 1, where 0 equals 0 degrees, 0.5 equals 180 degrees and 1 equals 360 around the circle.
             * @param out An object to store the return values in. If not given a Point object will be created.
             */
            static GetPoint<O extends Phaser.Geom.Point>(circle: Phaser.Geom.Circle, position: number, out?: O): O;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the circumference of the Circle,
             * based on the given quantity or stepRate values.
             * @param circle The Circle to get the points from.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the circumference of the circle and dividing it by the stepRate.
             * @param output An array to insert the points in to. If not provided a new array will be created.
             */
            static GetPoints(circle: Phaser.Geom.Circle, quantity: number, stepRate?: number, output?: any[]): Phaser.Geom.Point[];

            /**
             * Offsets the Circle by the values given.
             * @param circle The Circle to be offset (translated.)
             * @param x The amount to horizontally offset the Circle by.
             * @param y The amount to vertically offset the Circle by.
             */
            static Offset<O extends Phaser.Geom.Circle>(circle: O, x: number, y: number): O;

            /**
             * Offsets the Circle by the values given in the `x` and `y` properties of the Point object.
             * @param circle The Circle to be offset (translated.)
             * @param point The Point object containing the values to offset the Circle by.
             */
            static OffsetPoint<O extends Phaser.Geom.Circle>(circle: O, point: Phaser.Geom.Point | object): O;

            /**
             * Returns a uniformly distributed random point from anywhere within the given Circle.
             * @param circle The Circle to get a random point from.
             * @param out A Point or point-like object to set the random `x` and `y` values in.
             */
            static Random<O extends Phaser.Geom.Point>(circle: Phaser.Geom.Circle, out?: O): O;

        }

        /**
         * A Circle Geometry object type.
         */
        var CIRCLE: number;

        /**
         * An Ellipse Geometry object type.
         */
        var ELLIPSE: number;

        /**
         * A Line Geometry object type.
         */
        var LINE: number;

        /**
         * A Point Geometry object type.
         */
        var POINT: number;

        /**
         * A Polygon Geometry object type.
         */
        var POLYGON: number;

        /**
         * A Rectangle Geometry object type.
         */
        var RECTANGLE: number;

        /**
         * A Triangle Geometry object type.
         */
        var TRIANGLE: number;

        /**
         * An Ellipse object.
         * 
         * This is a geometry object, containing numerical values and related methods to inspect and modify them.
         * It is not a Game Object, in that you cannot add it to the display list, and it has no texture.
         * To render an Ellipse you should look at the capabilities of the Graphics class.
         */
        class Ellipse {
            /**
             * 
             * @param x The x position of the center of the ellipse. Default 0.
             * @param y The y position of the center of the ellipse. Default 0.
             * @param width The width of the ellipse. Default 0.
             * @param height The height of the ellipse. Default 0.
             */
            constructor(x?: number, y?: number, width?: number, height?: number);

            /**
             * Calculates the area of the Ellipse.
             * @param ellipse The Ellipse to get the area of.
             */
            static Area(ellipse: Phaser.Geom.Ellipse): number;

            /**
             * Returns the circumference of the given Ellipse.
             * @param ellipse The Ellipse to get the circumference of.
             */
            static Circumference(ellipse: Phaser.Geom.Ellipse): number;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Ellipse based on the given angle.
             * @param ellipse The Ellipse to get the circumference point on.
             * @param angle The angle from the center of the Ellipse to the circumference to return the point from. Given in radians.
             * @param out A Point, or point-like object, to store the results in. If not given a Point will be created.
             */
            static CircumferencePoint<O extends Phaser.Geom.Point>(ellipse: Phaser.Geom.Ellipse, angle: number, out?: O): O;

            /**
             * Creates a new Ellipse instance based on the values contained in the given source.
             * @param source The Ellipse to be cloned. Can be an instance of an Ellipse or a ellipse-like object, with x, y, width and height properties.
             */
            static Clone(source: Phaser.Geom.Ellipse): Phaser.Geom.Ellipse;

            /**
             * Check to see if the Ellipse contains the given x / y coordinates.
             * @param ellipse The Ellipse to check.
             * @param x The x coordinate to check within the ellipse.
             * @param y The y coordinate to check within the ellipse.
             */
            static Contains(ellipse: Phaser.Geom.Ellipse, x: number, y: number): boolean;

            /**
             * Check to see if the Ellipse contains the given Point object.
             * @param ellipse The Ellipse to check.
             * @param point The Point object to check if it's within the Circle or not.
             */
            static ContainsPoint(ellipse: Phaser.Geom.Ellipse, point: Phaser.Geom.Point | object): boolean;

            /**
             * Check to see if the Ellipse contains all four points of the given Rectangle object.
             * @param ellipse The Ellipse to check.
             * @param rect The Rectangle object to check if it's within the Ellipse or not.
             */
            static ContainsRect(ellipse: Phaser.Geom.Ellipse, rect: Phaser.Geom.Rectangle | object): boolean;

            /**
             * Copies the `x`, `y`, `width` and `height` properties from the `source` Ellipse
             * into the given `dest` Ellipse, then returns the `dest` Ellipse.
             * @param source The source Ellipse to copy the values from.
             * @param dest The destination Ellipse to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Ellipse>(source: Phaser.Geom.Ellipse, dest: O): O;

            /**
             * The geometry constant type of this object: `GEOM_CONST.ELLIPSE`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The x position of the center of the ellipse.
             */
            x: number;

            /**
             * The y position of the center of the ellipse.
             */
            y: number;

            /**
             * The width of the ellipse.
             */
            width: number;

            /**
             * The height of the ellipse.
             */
            height: number;

            /**
             * Check to see if the Ellipse contains the given x / y coordinates.
             * @param x The x coordinate to check within the ellipse.
             * @param y The y coordinate to check within the ellipse.
             */
            contains(x: number, y: number): boolean;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Ellipse
             * based on the given angle normalized to the range 0 to 1. I.e. a value of 0.5 will give the point
             * at 180 degrees around the circle.
             * @param position A value between 0 and 1, where 0 equals 0 degrees, 0.5 equals 180 degrees and 1 equals 360 around the ellipse.
             * @param out An object to store the return values in. If not given a Point object will be created.
             */
            getPoint<O extends Phaser.Geom.Point>(position: number, out?: O): O;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the circumference of the Ellipse,
             * based on the given quantity or stepRate values.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the circumference of the ellipse and dividing it by the stepRate.
             * @param output An array to insert the points in to. If not provided a new array will be created.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Returns a uniformly distributed random point from anywhere within the given Ellipse.
             * @param point A Point or point-like object to set the random `x` and `y` values in.
             */
            getRandomPoint<O extends Phaser.Geom.Point>(point?: O): O;

            /**
             * Sets the x, y, width and height of this ellipse.
             * @param x The x position of the center of the ellipse.
             * @param y The y position of the center of the ellipse.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse.
             */
            setTo(x: number, y: number, width: number, height: number): this;

            /**
             * Sets this Ellipse to be empty with a width and height of zero.
             * Does not change its position.
             */
            setEmpty(): this;

            /**
             * Sets the position of this Ellipse.
             * @param x The x position of the center of the ellipse.
             * @param y The y position of the center of the ellipse.
             */
            setPosition(x: number, y: number): this;

            /**
             * Sets the size of this Ellipse.
             * Does not change its position.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse. Default width.
             */
            setSize(width: number, height?: number): this;

            /**
             * Checks to see if the Ellipse is empty: has a width or height equal to zero.
             */
            isEmpty(): boolean;

            /**
             * Returns the minor radius of the ellipse. Also known as the Semi Minor Axis.
             */
            getMinorRadius(): number;

            /**
             * Returns the major radius of the ellipse. Also known as the Semi Major Axis.
             */
            getMajorRadius(): number;

            /**
             * The left position of the Ellipse.
             */
            left: number;

            /**
             * The right position of the Ellipse.
             */
            right: number;

            /**
             * The top position of the Ellipse.
             */
            top: number;

            /**
             * The bottom position of the Ellipse.
             */
            bottom: number;

            /**
             * Compares the `x`, `y`, `width` and `height` properties of the two given Ellipses.
             * Returns `true` if they all match, otherwise returns `false`.
             * @param ellipse The first Ellipse to compare.
             * @param toCompare The second Ellipse to compare.
             */
            static Equals(ellipse: Phaser.Geom.Ellipse, toCompare: Phaser.Geom.Ellipse): boolean;

            /**
             * Returns the bounds of the Ellipse object.
             * @param ellipse The Ellipse to get the bounds from.
             * @param out A Rectangle, or rectangle-like object, to store the ellipse bounds in. If not given a new Rectangle will be created.
             */
            static GetBounds<O extends Phaser.Geom.Rectangle>(ellipse: Phaser.Geom.Ellipse, out?: O): O;

            /**
             * Returns a Point object containing the coordinates of a point on the circumference of the Ellipse
             * based on the given angle normalized to the range 0 to 1. I.e. a value of 0.5 will give the point
             * at 180 degrees around the circle.
             * @param ellipse The Ellipse to get the circumference point on.
             * @param position A value between 0 and 1, where 0 equals 0 degrees, 0.5 equals 180 degrees and 1 equals 360 around the ellipse.
             * @param out An object to store the return values in. If not given a Point object will be created.
             */
            static GetPoint<O extends Phaser.Geom.Point>(ellipse: Phaser.Geom.Ellipse, position: number, out?: O): O;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the circumference of the Ellipse,
             * based on the given quantity or stepRate values.
             * @param ellipse The Ellipse to get the points from.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the circumference of the ellipse and dividing it by the stepRate.
             * @param out An array to insert the points in to. If not provided a new array will be created.
             */
            static GetPoints<O extends Phaser.Geom.Point[]>(ellipse: Phaser.Geom.Ellipse, quantity: number, stepRate?: number, out?: O): O;

            /**
             * Offsets the Ellipse by the values given.
             * @param ellipse The Ellipse to be offset (translated.)
             * @param x The amount to horizontally offset the Ellipse by.
             * @param y The amount to vertically offset the Ellipse by.
             */
            static Offset<O extends Phaser.Geom.Ellipse>(ellipse: O, x: number, y: number): O;

            /**
             * Offsets the Ellipse by the values given in the `x` and `y` properties of the Point object.
             * @param ellipse The Ellipse to be offset (translated.)
             * @param point The Point object containing the values to offset the Ellipse by.
             */
            static OffsetPoint<O extends Phaser.Geom.Ellipse>(ellipse: O, point: Phaser.Geom.Point | object): O;

            /**
             * Returns a uniformly distributed random point from anywhere within the given Ellipse.
             * @param ellipse The Ellipse to get a random point from.
             * @param out A Point or point-like object to set the random `x` and `y` values in.
             */
            static Random<O extends Phaser.Geom.Point>(ellipse: Phaser.Geom.Ellipse, out?: O): O;

        }

        namespace Intersects {
            /**
             * Checks if two Circles intersect.
             * @param circleA The first Circle to check for intersection.
             * @param circleB The second Circle to check for intersection.
             */
            function CircleToCircle(circleA: Phaser.Geom.Circle, circleB: Phaser.Geom.Circle): boolean;

            /**
             * Checks for intersection between a circle and a rectangle.
             * @param circle The circle to be checked.
             * @param rect The rectangle to be checked.
             */
            function CircleToRectangle(circle: Phaser.Geom.Circle, rect: Phaser.Geom.Rectangle): boolean;

            /**
             * Checks if two Circles intersect and returns the intersection points as a Point object array.
             * @param circleA The first Circle to check for intersection.
             * @param circleB The second Circle to check for intersection.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetCircleToCircle(circleA: Phaser.Geom.Circle, circleB: Phaser.Geom.Circle, out?: any[]): any[];

            /**
             * Checks for intersection between a circle and a rectangle,
             * and returns the intersection points as a Point object array.
             * @param circle The circle to be checked.
             * @param rect The rectangle to be checked.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetCircleToRectangle(circle: Phaser.Geom.Circle, rect: Phaser.Geom.Rectangle, out?: any[]): any[];

            /**
             * Checks for intersection between the line segment and circle,
             * and returns the intersection points as a Point object array.
             * @param line The line segment to check.
             * @param circle The circle to check against the line.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetLineToCircle(line: Phaser.Geom.Line, circle: Phaser.Geom.Circle, out?: any[]): any[];

            /**
             * Checks for intersection between the two line segments, or a ray and a line segment,
             * and returns the intersection point as a Vector3, or `null` if the lines are parallel, or do not intersect.
             * 
             * The `z` property of the Vector3 contains the intersection distance, which can be used to find
             * the closest intersecting point from a group of line segments.
             * @param line1 The first line segment, or a ray, to check.
             * @param line2 The second line segment to check.
             * @param isRay Is `line1` a ray or a line segment? Default false.
             * @param out A Vector3 to store the intersection results in.
             */
            function GetLineToLine(line1: Phaser.Geom.Line, line2: Phaser.Geom.Line, isRay?: boolean, out?: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Checks for the closest point of intersection between a line segment and an array of points, where each pair
             * of points are converted to line segments for the intersection tests.
             * 
             * If no intersection is found, this function returns `null`.
             * 
             * If intersection was found, a Vector3 is returned with the following properties:
             * 
             * The `x` and `y` components contain the point of the intersection.
             * The `z` component contains the closest distance.
             * @param line The line segment, or ray, to check. If a ray, set the `isRay` parameter to `true`.
             * @param points An array of points to check.
             * @param isRay Is `line` a ray or a line segment? Default false.
             * @param out A Vector3 to store the intersection results in.
             */
            function GetLineToPoints(line: Phaser.Geom.Line, points: Phaser.Math.Vector2[] | Phaser.Geom.Point[], isRay?: boolean, out?: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Checks for the closest point of intersection between a line segment and an array of polygons.
             * 
             * If no intersection is found, this function returns `null`.
             * 
             * If intersection was found, a Vector4 is returned with the following properties:
             * 
             * The `x` and `y` components contain the point of the intersection.
             * The `z` component contains the closest distance.
             * The `w` component contains the index of the polygon, in the given array, that triggered the intersection.
             * @param line The line segment, or ray, to check. If a ray, set the `isRay` parameter to `true`.
             * @param polygons A single polygon, or array of polygons, to check.
             * @param isRay Is `line` a ray or a line segment? Default false.
             * @param out A Vector4 to store the intersection results in.
             */
            function GetLineToPolygon(line: Phaser.Geom.Line, polygons: Phaser.Geom.Polygon | Phaser.Geom.Polygon[], isRay?: boolean, out?: Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Checks for intersection between the Line and a Rectangle shape,
             * and returns the intersection points as a Point object array.
             * @param line The Line to check for intersection.
             * @param rect The Rectangle to check for intersection.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetLineToRectangle(line: Phaser.Geom.Line, rect: Phaser.Geom.Rectangle | object, out?: any[]): any[];

            /**
             * Projects rays out from the given point to each line segment of the polygons.
             * 
             * If the rays intersect with the polygons, the points of intersection are returned in an array.
             * 
             * If no intersections are found, the returned array will be empty.
             * 
             * Each Vector4 intersection result has the following properties:
             * 
             * The `x` and `y` components contain the point of the intersection.
             * The `z` component contains the angle of intersection.
             * The `w` component contains the index of the polygon, in the given array, that triggered the intersection.
             * @param x The x coordinate to project the rays from.
             * @param y The y coordinate to project the rays from.
             * @param polygons A single polygon, or array of polygons, to check against the rays.
             */
            function GetRaysFromPointToPolygon(x: number, y: number, polygons: Phaser.Geom.Polygon | Phaser.Geom.Polygon[]): Phaser.Math.Vector4[];

            /**
             * Checks if two Rectangle shapes intersect and returns the area of this intersection as Rectangle object.
             * 
             * If optional `output` parameter is omitted, new Rectangle object is created and returned. If there is intersection, it will contain intersection area. If there is no intersection, it wil be empty Rectangle (all values set to zero).
             * 
             * If Rectangle object is passed as `output` and there is intersection, then intersection area data will be loaded into it and it will be returned. If there is no intersection, it will be returned without any change.
             * @param rectA The first Rectangle object.
             * @param rectB The second Rectangle object.
             * @param output Optional Rectangle object. If given, the intersection data will be loaded into it (in case of no intersection, it will be left unchanged). Otherwise, new Rectangle object will be created and returned with either intersection data or empty (all values set to zero), if there is no intersection.
             */
            function GetRectangleIntersection<O extends Phaser.Geom.Rectangle>(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle, output?: O): O;

            /**
             * Checks if two Rectangles intersect and returns the intersection points as a Point object array.
             * 
             * A Rectangle intersects another Rectangle if any part of its bounds is within the other Rectangle's bounds. As such, the two Rectangles are considered "solid". A Rectangle with no width or no height will never intersect another Rectangle.
             * @param rectA The first Rectangle to check for intersection.
             * @param rectB The second Rectangle to check for intersection.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetRectangleToRectangle(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle, out?: any[]): any[];

            /**
             * Checks for intersection between Rectangle shape and Triangle shape,
             * and returns the intersection points as a Point object array.
             * @param rect Rectangle object to test.
             * @param triangle Triangle object to test.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetRectangleToTriangle(rect: Phaser.Geom.Rectangle, triangle: Phaser.Geom.Triangle, out?: any[]): any[];

            /**
             * Checks if a Triangle and a Circle intersect, and returns the intersection points as a Point object array.
             * 
             * A Circle intersects a Triangle if its center is located within it or if any of the Triangle's sides intersect the Circle. As such, the Triangle and the Circle are considered "solid" for the intersection.
             * @param triangle The Triangle to check for intersection.
             * @param circle The Circle to check for intersection.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetTriangleToCircle(triangle: Phaser.Geom.Triangle, circle: Phaser.Geom.Circle, out?: any[]): any[];

            /**
             * Checks if a Triangle and a Line intersect, and returns the intersection points as a Point object array.
             * 
             * The Line intersects the Triangle if it starts inside of it, ends inside of it, or crosses any of the Triangle's sides. Thus, the Triangle is considered "solid".
             * @param triangle The Triangle to check with.
             * @param line The Line to check with.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetTriangleToLine(triangle: Phaser.Geom.Triangle, line: Phaser.Geom.Line, out?: any[]): any[];

            /**
             * Checks if two Triangles intersect, and returns the intersection points as a Point object array.
             * 
             * A Triangle intersects another Triangle if any pair of their lines intersects or if any point of one Triangle is within the other Triangle. Thus, the Triangles are considered "solid".
             * @param triangleA The first Triangle to check for intersection.
             * @param triangleB The second Triangle to check for intersection.
             * @param out An optional array in which to store the points of intersection.
             */
            function GetTriangleToTriangle(triangleA: Phaser.Geom.Triangle, triangleB: Phaser.Geom.Triangle, out?: any[]): any[];

            /**
             * Checks for intersection between the line segment and circle.
             * 
             * Based on code by [Matt DesLauriers](https://github.com/mattdesl/line-circle-collision/blob/master/LICENSE.md).
             * @param line The line segment to check.
             * @param circle The circle to check against the line.
             * @param nearest An optional Point-like object. If given the closest point on the Line where the circle intersects will be stored in this object.
             */
            function LineToCircle(line: Phaser.Geom.Line, circle: Phaser.Geom.Circle, nearest?: Phaser.Geom.Point | any): boolean;

            /**
             * Checks if two Lines intersect. If the Lines are identical, they will be treated as parallel and thus non-intersecting.
             * @param line1 The first Line to check.
             * @param line2 The second Line to check.
             * @param out An optional point-like object in which to store the coordinates of intersection, if needed.
             */
            function LineToLine(line1: Phaser.Geom.Line, line2: Phaser.Geom.Line, out?: Phaser.Types.Math.Vector2Like): boolean;

            /**
             * Checks for intersection between the Line and a Rectangle shape, or a rectangle-like
             * object, with public `x`, `y`, `right` and `bottom` properties, such as a Sprite or Body.
             * 
             * An intersection is considered valid if:
             * 
             * The line starts within, or ends within, the Rectangle.
             * The line segment intersects one of the 4 rectangle edges.
             * 
             * The for the purposes of this function rectangles are considered 'solid'.
             * @param line The Line to check for intersection.
             * @param rect The Rectangle to check for intersection.
             */
            function LineToRectangle(line: Phaser.Geom.Line, rect: Phaser.Geom.Rectangle | object): boolean;

            /**
             * Checks if the a Point falls between the two end-points of a Line, based on the given line thickness.
             * 
             * Assumes that the line end points are circular, not square.
             * @param point The point, or point-like object to check.
             * @param line The line segment to test for intersection on.
             * @param lineThickness The line thickness. Assumes that the line end points are circular. Default 1.
             */
            function PointToLine(point: Phaser.Geom.Point | any, line: Phaser.Geom.Line, lineThickness?: number): boolean;

            /**
             * Checks if a Point is located on the given line segment.
             * @param point The Point to check for intersection.
             * @param line The line segment to check for intersection.
             */
            function PointToLineSegment(point: Phaser.Geom.Point, line: Phaser.Geom.Line): boolean;

            /**
             * Checks if two Rectangles intersect.
             * 
             * A Rectangle intersects another Rectangle if any part of its bounds is within the other Rectangle's bounds.
             * As such, the two Rectangles are considered "solid".
             * A Rectangle with no width or no height will never intersect another Rectangle.
             * @param rectA The first Rectangle to check for intersection.
             * @param rectB The second Rectangle to check for intersection.
             */
            function RectangleToRectangle(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle): boolean;

            /**
             * Checks for intersection between Rectangle shape and Triangle shape.
             * @param rect Rectangle object to test.
             * @param triangle Triangle object to test.
             */
            function RectangleToTriangle(rect: Phaser.Geom.Rectangle, triangle: Phaser.Geom.Triangle): boolean;

            /**
             * Check if rectangle intersects with values.
             * @param rect The rectangle object
             * @param left The x coordinate of the left of the Rectangle.
             * @param right The x coordinate of the right of the Rectangle.
             * @param top The y coordinate of the top of the Rectangle.
             * @param bottom The y coordinate of the bottom of the Rectangle.
             * @param tolerance Tolerance allowed in the calculation, expressed in pixels. Default 0.
             */
            function RectangleToValues(rect: Phaser.Geom.Rectangle, left: number, right: number, top: number, bottom: number, tolerance?: number): boolean;

            /**
             * Checks if a Triangle and a Circle intersect.
             * 
             * A Circle intersects a Triangle if its center is located within it or if any of the Triangle's sides intersect the Circle. As such, the Triangle and the Circle are considered "solid" for the intersection.
             * @param triangle The Triangle to check for intersection.
             * @param circle The Circle to check for intersection.
             */
            function TriangleToCircle(triangle: Phaser.Geom.Triangle, circle: Phaser.Geom.Circle): boolean;

            /**
             * Checks if a Triangle and a Line intersect.
             * 
             * The Line intersects the Triangle if it starts inside of it, ends inside of it, or crosses any of the Triangle's sides. Thus, the Triangle is considered "solid".
             * @param triangle The Triangle to check with.
             * @param line The Line to check with.
             */
            function TriangleToLine(triangle: Phaser.Geom.Triangle, line: Phaser.Geom.Line): boolean;

            /**
             * Checks if two Triangles intersect.
             * 
             * A Triangle intersects another Triangle if any pair of their lines intersects or if any point of one Triangle is within the other Triangle. Thus, the Triangles are considered "solid".
             * @param triangleA The first Triangle to check for intersection.
             * @param triangleB The second Triangle to check for intersection.
             */
            function TriangleToTriangle(triangleA: Phaser.Geom.Triangle, triangleB: Phaser.Geom.Triangle): boolean;

        }

        /**
         * Defines a Line segment, a part of a line between two endpoints.
         */
        class Line {
            /**
             * 
             * @param x1 The x coordinate of the lines starting point. Default 0.
             * @param y1 The y coordinate of the lines starting point. Default 0.
             * @param x2 The x coordinate of the lines ending point. Default 0.
             * @param y2 The y coordinate of the lines ending point. Default 0.
             */
            constructor(x1?: number, y1?: number, x2?: number, y2?: number);

            /**
             * Calculate the angle of the line in radians.
             * @param line The line to calculate the angle of.
             */
            static Angle(line: Phaser.Geom.Line): number;

            /**
             * Using Bresenham's line algorithm this will return an array of all coordinates on this line.
             * 
             * The `start` and `end` points are rounded before this runs as the algorithm works on integers.
             * @param line The line.
             * @param stepRate The optional step rate for the points on the line. Default 1.
             * @param results An optional array to push the resulting coordinates into.
             */
            static BresenhamPoints(line: Phaser.Geom.Line, stepRate?: number, results?: Phaser.Types.Math.Vector2Like[]): Phaser.Types.Math.Vector2Like[];

            /**
             * Center a line on the given coordinates.
             * @param line The line to center.
             * @param x The horizontal coordinate to center the line on.
             * @param y The vertical coordinate to center the line on.
             */
            static CenterOn(line: Phaser.Geom.Line, x: number, y: number): Phaser.Geom.Line;

            /**
             * Clone the given line.
             * @param source The source line to clone.
             */
            static Clone(source: Phaser.Geom.Line): Phaser.Geom.Line;

            /**
             * Copy the values of one line to a destination line.
             * @param source The source line to copy the values from.
             * @param dest The destination line to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Line>(source: Phaser.Geom.Line, dest: O): O;

            /**
             * Compare two lines for strict equality.
             * @param line The first line to compare.
             * @param toCompare The second line to compare.
             */
            static Equals(line: Phaser.Geom.Line, toCompare: Phaser.Geom.Line): boolean;

            /**
             * Extends the start and end points of a Line by the given amounts.
             * 
             * The amounts can be positive or negative. Positive points will increase the length of the line,
             * while negative ones will decrease it.
             * 
             * If no `right` value is provided it will extend the length of the line equally in both directions.
             * 
             * Pass a value of zero to leave the start or end point unchanged.
             * @param line The line instance to extend.
             * @param left The amount to extend the start of the line by.
             * @param right The amount to extend the end of the line by. If not given it will be set to the `left` value.
             */
            static Extend(line: Phaser.Geom.Line, left: number, right?: number): Phaser.Geom.Line;

            /**
             * Returns an array of `quantity` Points where each point is taken from the given Line,
             * spaced out according to the ease function specified.
             * 
             * ```javascript
             * const line = new Phaser.Geom.Line(100, 300, 700, 300);
             * const points = Phaser.Geom.Line.GetEasedPoints(line, 'sine.out', 32)
             * ```
             * 
             * In the above example, the `points` array will contain 32 points spread-out across
             * the length of `line`, where the position of each point is determined by the `Sine.out`
             * ease function.
             * 
             * You can optionally provide a collinear threshold. In this case, the resulting points
             * are checked against each other, and if they are `< collinearThreshold` distance apart,
             * they are dropped from the results. This can help avoid lots of clustered points at
             * far ends of the line with tightly-packed eases such as Quartic. Leave the value set
             * to zero to skip this check.
             * 
             * Note that if you provide a collinear threshold, the resulting array may not always
             * contain `quantity` points.
             * @param line The Line object.
             * @param ease The ease to use. This can be either a string from the EaseMap, or a custom function.
             * @param quantity The number of points to return. Note that if you provide a `collinearThreshold`, the resulting array may not always contain this number of points.
             * @param collinearThreshold An optional threshold. The final array is reduced so that each point is spaced out at least this distance apart. This helps reduce clustering in noisey eases. Default 0.
             * @param easeParams An optional array of ease parameters to go with the ease.
             */
            static GetEasedPoints<O extends Phaser.Geom.Point[]>(line: Phaser.Geom.Line, ease: string | Function, quantity: number, collinearThreshold?: number, easeParams?: number[]): O;

            /**
             * Get the midpoint of the given line.
             * @param line The line to get the midpoint of.
             * @param out An optional point object to store the midpoint in.
             */
            static GetMidPoint<O extends Phaser.Geom.Point>(line: Phaser.Geom.Line, out?: O): O;

            /**
             * Get the nearest point on a line perpendicular to the given point.
             * @param line The line to get the nearest point on.
             * @param point The point to get the nearest point to.
             * @param out An optional point, or point-like object, to store the coordinates of the nearest point on the line.
             */
            static GetNearestPoint<O extends Phaser.Geom.Point>(line: Phaser.Geom.Line, point: Phaser.Geom.Point | object, out?: O): O;

            /**
             * Calculate the normal of the given line.
             * 
             * The normal of a line is a vector that points perpendicular from it.
             * @param line The line to calculate the normal of.
             * @param out An optional point object to store the normal in.
             */
            static GetNormal<O extends Phaser.Geom.Point>(line: Phaser.Geom.Line, out?: O): O;

            /**
             * Get a point on a line that's a given percentage along its length.
             * @param line The line.
             * @param position A value between 0 and 1, where 0 is the start, 0.5 is the middle and 1 is the end of the line.
             * @param out An optional point, or point-like object, to store the coordinates of the point on the line.
             */
            static GetPoint<O extends Phaser.Geom.Point>(line: Phaser.Geom.Line, position: number, out?: O): O;

            /**
             * Get a number of points along a line's length.
             * 
             * Provide a `quantity` to get an exact number of points along the line.
             * 
             * Provide a `stepRate` to ensure a specific distance between each point on the line. Set `quantity` to `0` when
             * providing a `stepRate`.
             * @param line The line.
             * @param quantity The number of points to place on the line. Set to `0` to use `stepRate` instead.
             * @param stepRate The distance between each point on the line. When set, `quantity` is implied and should be set to `0`.
             * @param out An optional array of Points, or point-like objects, to store the coordinates of the points on the line.
             */
            static GetPoints<O extends Phaser.Geom.Point[]>(line: Phaser.Geom.Line, quantity: number, stepRate?: number, out?: O): O;

            /**
             * Get the shortest distance from a Line to the given Point.
             * @param line The line to get the distance from.
             * @param point The point to get the shortest distance to.
             */
            static GetShortestDistance(line: Phaser.Geom.Line, point: Phaser.Types.Math.Vector2Like): boolean | number;

            /**
             * Calculate the height of the given line.
             * @param line The line to calculate the height of.
             */
            static Height(line: Phaser.Geom.Line): number;

            /**
             * Calculate the length of the given line.
             * @param line The line to calculate the length of.
             */
            static Length(line: Phaser.Geom.Line): number;

            /**
             * The geometry constant type of this object: `GEOM_CONST.LINE`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The x coordinate of the lines starting point.
             */
            x1: number;

            /**
             * The y coordinate of the lines starting point.
             */
            y1: number;

            /**
             * The x coordinate of the lines ending point.
             */
            x2: number;

            /**
             * The y coordinate of the lines ending point.
             */
            y2: number;

            /**
             * Get a point on a line that's a given percentage along its length.
             * @param position A value between 0 and 1, where 0 is the start, 0.5 is the middle and 1 is the end of the line.
             * @param output An optional point, or point-like object, to store the coordinates of the point on the line.
             */
            getPoint<O extends Phaser.Geom.Point>(position: number, output?: O): O;

            /**
             * Get a number of points along a line's length.
             * 
             * Provide a `quantity` to get an exact number of points along the line.
             * 
             * Provide a `stepRate` to ensure a specific distance between each point on the line. Set `quantity` to `0` when
             * providing a `stepRate`.
             * @param quantity The number of points to place on the line. Set to `0` to use `stepRate` instead.
             * @param stepRate The distance between each point on the line. When set, `quantity` is implied and should be set to `0`.
             * @param output An optional array of Points, or point-like objects, to store the coordinates of the points on the line.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Get a random Point on the Line.
             * @param point An instance of a Point to be modified.
             */
            getRandomPoint<O extends Phaser.Geom.Point>(point?: O): O;

            /**
             * Set new coordinates for the line endpoints.
             * @param x1 The x coordinate of the lines starting point. Default 0.
             * @param y1 The y coordinate of the lines starting point. Default 0.
             * @param x2 The x coordinate of the lines ending point. Default 0.
             * @param y2 The y coordinate of the lines ending point. Default 0.
             */
            setTo(x1?: number, y1?: number, x2?: number, y2?: number): this;

            /**
             * Sets this Line to match the x/y coordinates of the two given Vector2Like objects.
             * @param start Any object with public `x` and `y` properties, whose values will be assigned to the x1/y1 components of this Line.
             * @param end Any object with public `x` and `y` properties, whose values will be assigned to the x2/y2 components of this Line.
             */
            setFromObjects(start: Phaser.Types.Math.Vector2Like, end: Phaser.Types.Math.Vector2Like): this;

            /**
             * Returns a Vector2 object that corresponds to the start of this Line.
             * @param vec2 A Vector2 object to set the results in. If `undefined` a new Vector2 will be created.
             */
            getPointA<O extends Phaser.Math.Vector2>(vec2?: O): O;

            /**
             * Returns a Vector2 object that corresponds to the end of this Line.
             * @param vec2 A Vector2 object to set the results in. If `undefined` a new Vector2 will be created.
             */
            getPointB<O extends Phaser.Math.Vector2>(vec2?: O): O;

            /**
             * The left position of the Line.
             */
            left: number;

            /**
             * The right position of the Line.
             */
            right: number;

            /**
             * The top position of the Line.
             */
            top: number;

            /**
             * The bottom position of the Line.
             */
            bottom: number;

            /**
             * Get the angle of the normal of the given line in radians.
             * @param line The line to calculate the angle of the normal of.
             */
            static NormalAngle(line: Phaser.Geom.Line): number;

            /**
             * Returns the x component of the normal vector of the given line.
             * @param line The Line object to get the normal value from.
             */
            static NormalX(line: Phaser.Geom.Line): number;

            /**
             * The Y value of the normal of the given line.
             * The normal of a line is a vector that points perpendicular from it.
             * @param line The line to calculate the normal of.
             */
            static NormalY(line: Phaser.Geom.Line): number;

            /**
             * Offset a line by the given amount.
             * @param line The line to offset.
             * @param x The horizontal offset to add to the line.
             * @param y The vertical offset to add to the line.
             */
            static Offset<O extends Phaser.Geom.Line>(line: O, x: number, y: number): O;

            /**
             * Calculate the perpendicular slope of the given line.
             * @param line The line to calculate the perpendicular slope of.
             */
            static PerpSlope(line: Phaser.Geom.Line): number;

            /**
             * Returns a random point on a given Line.
             * @param line The Line to calculate the random Point on.
             * @param out An instance of a Point to be modified.
             */
            static Random<O extends Phaser.Geom.Point>(line: Phaser.Geom.Line, out?: O): O;

            /**
             * Calculate the reflected angle between two lines.
             * 
             * This is the outgoing angle based on the angle of Line 1 and the normalAngle of Line 2.
             * @param lineA The first line.
             * @param lineB The second line.
             */
            static ReflectAngle(lineA: Phaser.Geom.Line, lineB: Phaser.Geom.Line): number;

            /**
             * Rotate a line around its midpoint by the given angle in radians.
             * @param line The line to rotate.
             * @param angle The angle of rotation in radians.
             */
            static Rotate<O extends Phaser.Geom.Line>(line: O, angle: number): O;

            /**
             * Rotate a line around a point by the given angle in radians.
             * @param line The line to rotate.
             * @param point The point to rotate the line around.
             * @param angle The angle of rotation in radians.
             */
            static RotateAroundPoint<O extends Phaser.Geom.Line>(line: O, point: Phaser.Geom.Point | object, angle: number): O;

            /**
             * Rotate a line around the given coordinates by the given angle in radians.
             * @param line The line to rotate.
             * @param x The horizontal coordinate to rotate the line around.
             * @param y The vertical coordinate to rotate the line around.
             * @param angle The angle of rotation in radians.
             */
            static RotateAroundXY<O extends Phaser.Geom.Line>(line: O, x: number, y: number, angle: number): O;

            /**
             * Set a line to a given position, angle and length.
             * @param line The line to set.
             * @param x The horizontal start position of the line.
             * @param y The vertical start position of the line.
             * @param angle The angle of the line in radians.
             * @param length The length of the line.
             */
            static SetToAngle<O extends Phaser.Geom.Line>(line: O, x: number, y: number, angle: number, length: number): O;

            /**
             * Calculate the slope of the given line.
             * @param line The line to calculate the slope of.
             */
            static Slope(line: Phaser.Geom.Line): number;

            /**
             * Calculate the width of the given line.
             * @param line The line to calculate the width of.
             */
            static Width(line: Phaser.Geom.Line): number;

        }

        namespace Mesh {
            /**
             * A Face Geometry Object.
             * 
             * A Face is used by the Mesh Game Object. A Mesh consists of one, or more, faces that are
             * used to render the Mesh Game Objects in WebGL.
             * 
             * A Face consists of 3 Vertex instances, for the 3 corners of the face and methods to help
             * you modify and test them.
             */
            class Face {
                /**
                 * 
                 * @param vertex1 The first vertex of the Face.
                 * @param vertex2 The second vertex of the Face.
                 * @param vertex3 The third vertex of the Face.
                 */
                constructor(vertex1: Phaser.Geom.Mesh.Vertex, vertex2: Phaser.Geom.Mesh.Vertex, vertex3: Phaser.Geom.Mesh.Vertex);

                /**
                 * The first vertex in this Face.
                 */
                vertex1: Phaser.Geom.Mesh.Vertex;

                /**
                 * The second vertex in this Face.
                 */
                vertex2: Phaser.Geom.Mesh.Vertex;

                /**
                 * The third vertex in this Face.
                 */
                vertex3: Phaser.Geom.Mesh.Vertex;

                /**
                 * The bounds of this Face.
                 * 
                 * Be sure to call the `Face.updateBounds` method _before_ using this property.
                 */
                bounds: Phaser.Geom.Rectangle;

                /**
                 * Calculates and returns the in-center position of this Face.
                 * @param local Return the in center from the un-transformed vertex positions (`true`), or transformed? (`false`) Default true.
                 */
                getInCenter(local?: boolean): Phaser.Math.Vector2;

                /**
                 * Checks if the given coordinates are within this Face.
                 * 
                 * You can optionally provide a transform matrix. If given, the Face vertices
                 * will be transformed first, before being checked against the coordinates.
                 * @param x The horizontal position to check.
                 * @param y The vertical position to check.
                 * @param calcMatrix Optional transform matrix to apply to the vertices before comparison.
                 */
                contains(x: number, y: number, calcMatrix?: Phaser.GameObjects.Components.TransformMatrix): boolean;

                /**
                 * Checks if the vertices in this Face are orientated counter-clockwise, or not.
                 * 
                 * It checks the transformed position of the vertices, not the local one.
                 * @param z The z-axis value to test against. Typically the `Mesh.modelPosition.z`.
                 */
                isCounterClockwise(z: number): boolean;

                /**
                 * Loads the data from this Vertex into the given Typed Arrays.
                 * @param F32 A Float32 Array to insert the position, UV and unit data in to.
                 * @param U32 A Uint32 Array to insert the color and alpha data in to.
                 * @param offset The index of the array to insert this Vertex to.
                 * @param textureUnit The texture unit currently in use.
                 * @param tintEffect The tint effect to use.
                 */
                load(F32: Float32Array, U32: Uint32Array, offset: number, textureUnit: number, tintEffect: number): number;

                /**
                 * Transforms all Face vertices by the given matrix, storing the results in their `vx`, `vy` and `vz` properties.
                 * @param transformMatrix The transform matrix to apply to this vertex.
                 * @param width The width of the parent Mesh.
                 * @param height The height of the parent Mesh.
                 * @param cameraZ The z position of the MeshCamera.
                 */
                transformCoordinatesLocal(transformMatrix: Phaser.Math.Matrix4, width: number, height: number, cameraZ: number): this;

                /**
                 * Updates the bounds of this Face, based on the translated values of the vertices.
                 * 
                 * Call this method prior to accessing the `Face.bounds` property.
                 */
                updateBounds(): this;

                /**
                 * Checks if this Face is within the view of the given Camera.
                 * 
                 * This method is called in the `MeshWebGLRenderer` function. It performs the following tasks:
                 * 
                 * First, the `Vertex.update` method is called on each of the vertices. This populates them
                 * with the new translated values, updating their `tx`, `ty` and `ta` properties.
                 * 
                 * Then it tests to see if this face is visible due to the alpha values, if not, it returns.
                 * 
                 * After this, if `hideCCW` is set, it calls `isCounterClockwise` and returns if not.
                 * 
                 * Finally, it will update the `Face.bounds` based on the newly translated vertex values
                 * and return the results of an intersection test between the bounds and the camera world view
                 * rectangle.
                 * @param camera The Camera to check against.
                 * @param hideCCW Test the counter-clockwise orientation of the verts?
                 * @param z The Cameras z position, used in the CCW test.
                 * @param alpha The alpha of the parent object.
                 * @param a The parent transform matrix data a component.
                 * @param b The parent transform matrix data b component.
                 * @param c The parent transform matrix data c component.
                 * @param d The parent transform matrix data d component.
                 * @param e The parent transform matrix data e component.
                 * @param f The parent transform matrix data f component.
                 * @param roundPixels Round the vertex position or not?
                 */
                isInView(camera: Phaser.Cameras.Scene2D.Camera, hideCCW: boolean, z: number, alpha: number, a: number, b: number, c: number, d: number, e: number, f: number, roundPixels: boolean): boolean;

                /**
                 * Translates the original UV positions of each vertex by the given amounts.
                 * 
                 * The original properties `Vertex.u` and `Vertex.v`
                 * remain unchanged, only the translated properties
                 * `Vertex.tu` and `Vertex.tv`, as used in rendering,
                 * are updated.
                 * @param x The amount to scroll the UV u coordinate by.
                 * @param y The amount to scroll the UV v coordinate by.
                 */
                scrollUV(x: number, y: number): this;

                /**
                 * Scales the original UV values of each vertex by the given amounts.
                 * 
                 * The original properties `Vertex.u` and `Vertex.v`
                 * remain unchanged, only the translated properties
                 * `Vertex.tu` and `Vertex.tv`, as used in rendering,
                 * are updated.
                 * @param x The amount to scale the UV u coordinate by.
                 * @param y The amount to scale the UV v coordinate by.
                 */
                scaleUV(x: number, y: number): this;

                /**
                 * Sets the color value for each Vertex in this Face.
                 * @param color The color value for each vertex.
                 */
                setColor(color: number): this;

                /**
                 * Calls the `Vertex.update` method on each of the vertices. This populates them
                 * with the new translated values, updating their `tx`, `ty` and `ta` properties.
                 * @param alpha The alpha of the parent object.
                 * @param a The parent transform matrix data a component.
                 * @param b The parent transform matrix data b component.
                 * @param c The parent transform matrix data c component.
                 * @param d The parent transform matrix data d component.
                 * @param e The parent transform matrix data e component.
                 * @param f The parent transform matrix data f component.
                 * @param roundPixels Round the vertex position or not?
                 */
                update(alpha: number, a: number, b: number, c: number, d: number, e: number, f: number, roundPixels: boolean): this;

                /**
                 * Translates the vertices of this Face by the given amounts.
                 * 
                 * The actual vertex positions are adjusted, not their transformed position.
                 * 
                 * Therefore, this updates the vertex data directly.
                 * @param x The amount to horizontally translate by.
                 * @param y The amount to vertically translate by. Default 0.
                 */
                translate(x: number, y?: number): this;

                /**
                 * The x coordinate of this Face, based on the in center position of the Face.
                 */
                x: number;

                /**
                 * The y coordinate of this Face, based on the in center position of the Face.
                 */
                y: number;

                /**
                 * Set the alpha value of this Face.
                 * 
                 * Each vertex is given the same value. If you need to adjust the alpha on a per-vertex basis
                 * then use the `Vertex.alpha` property instead.
                 * 
                 * When getting the alpha of this Face, it will return an average of the alpha
                 * component of all three vertices.
                 */
                alpha: number;

                /**
                 * The depth of this Face, which is an average of the z component of all three vertices.
                 * 
                 * The depth is calculated based on the transformed z value, not the local one.
                 */
                readonly depth: number;

                /**
                 * Destroys this Face and nulls the references to the vertices.
                 */
                destroy(): void;

            }

            /**
             * Creates a grid of vertices based on the given configuration object and optionally adds it to a Mesh.
             * 
             * The size of the grid is given in pixels. An example configuration may be:
             * 
             * `{ width: 256, height: 256, widthSegments: 2, heightSegments: 2, tile: true }`
             * 
             * This will create a grid 256 x 256 pixels in size, split into 2 x 2 segments, with
             * the texture tiling across the cells.
             * 
             * You can split the grid into segments both vertically and horizontally. This will
             * generate two faces per grid segment as a result.
             * 
             * The `tile` parameter allows you to control if the tile will repeat across the grid
             * segments, or be displayed in full.
             * 
             * If adding this grid to a Mesh you can offset the grid via the `x` and `y` properties.
             * 
             * UV coordinates are generated based on the given texture and frame in the config. For
             * example, no frame is given, the UVs will be in the range 0 to 1. If a frame is given,
             * such as from a texture atlas, the UVs will be generated within the range of that frame.
             * @param config A Grid configuration object.
             */
            function GenerateGridVerts(config: Phaser.Types.Geom.Mesh.GenerateGridConfig): Phaser.Types.Geom.Mesh.GenerateGridVertsResult;

            /**
             * This method will return an object containing Face and Vertex instances, generated
             * from the parsed triangulated OBJ Model data given to this function.
             * 
             * The obj data should have been parsed in advance via the ParseObj function:
             * 
             * ```javascript
             * var data = Phaser.Geom.Mesh.ParseObj(rawData, flipUV);
             * 
             * var results = GenerateObjVerts(data);
             * ```
             * 
             * Alternatively, you can parse obj files loaded via the OBJFile loader:
             * 
             * ```javascript
             * preload ()
             * {
             *   this.load.obj('alien', 'assets/3d/alien.obj);
             * }
             * 
             * var results = GenerateObjVerts(this.cache.obj.get('alien));
             * ```
             * 
             * Make sure your 3D package has triangulated the model data prior to exporting it.
             * 
             * You can use the data returned by this function to populate the vertices of a Mesh Game Object.
             * 
             * You may add multiple models to a single Mesh, although they will act as one when
             * moved or rotated. You can scale the model data, should it be too small (or large) to visualize.
             * You can also offset the model via the `x`, `y` and `z` parameters.
             * @param data The parsed OBJ model data.
             * @param mesh An optional Mesh Game Object. If given, the generated Faces will be automatically added to this Mesh. Set to `null` to skip.
             * @param scale An amount to scale the model data by. Use this if the model has exported too small, or large, to see. Default 1.
             * @param x Translate the model x position by this amount. Default 0.
             * @param y Translate the model y position by this amount. Default 0.
             * @param z Translate the model z position by this amount. Default 0.
             * @param rotateX Rotate the model on the x axis by this amount, in radians. Default 0.
             * @param rotateY Rotate the model on the y axis by this amount, in radians. Default 0.
             * @param rotateZ Rotate the model on the z axis by this amount, in radians. Default 0.
             * @param zIsUp Is the z axis up (true), or is y axis up (false)? Default true.
             */
            function GenerateObjVerts(data: Phaser.Types.Geom.Mesh.OBJData, mesh?: Phaser.GameObjects.Mesh, scale?: number, x?: number, y?: number, z?: number, rotateX?: number, rotateY?: number, rotateZ?: number, zIsUp?: boolean): Phaser.Types.Geom.Mesh.GenerateVertsResult;

            /**
             * Generates a set of Face and Vertex objects by parsing the given data.
             * 
             * This method will take vertex data in one of two formats, based on the `containsZ` parameter.
             * 
             * If your vertex data are `x`, `y` pairs, then `containsZ` should be `false` (this is the default)
             * 
             * If your vertex data is groups of `x`, `y` and `z` values, then the `containsZ` parameter must be true.
             * 
             * The `uvs` parameter is a numeric array consisting of `u` and `v` pairs.
             * 
             * The `normals` parameter is a numeric array consisting of `x`, `y` vertex normal values and, if `containsZ` is true, `z` values as well.
             * 
             * The `indicies` parameter is an optional array that, if given, is an indexed list of vertices to be added.
             * 
             * The `colors` parameter is an optional array, or single value, that if given sets the color of each vertex created.
             * 
             * The `alphas` parameter is an optional array, or single value, that if given sets the alpha of each vertex created.
             * 
             * When providing indexed data it is assumed that _all_ of the arrays are indexed, not just the vertices.
             * 
             * The following example will create a 256 x 256 sized quad using an index array:
             * 
             * ```javascript
             * const vertices = [
             *   -128, 128,
             *   128, 128,
             *   -128, -128,
             *   128, -128
             * ];
             * 
             * const uvs = [
             *   0, 1,
             *   1, 1,
             *   0, 0,
             *   1, 0
             * ];
             * 
             * const indices = [ 0, 2, 1, 2, 3, 1 ];
             * 
             * GenerateVerts(vertices, uvs, indicies);
             * ```
             * 
             * If the data is not indexed, it's assumed that the arrays all contain sequential data.
             * @param vertices The vertices array. Either `xy` pairs, or `xyz` if the `containsZ` parameter is `true`.
             * @param uvs The UVs pairs array.
             * @param indicies Optional vertex indicies array. If you don't have one, pass `null` or an empty array.
             * @param containsZ Does the vertices data include a `z` component? Default false.
             * @param normals Optional vertex normals array. If you don't have one, pass `null` or an empty array.
             * @param colors An array of colors, one per vertex, or a single color value applied to all vertices. Default 0xffffff.
             * @param alphas An array of alpha values, one per vertex, or a single alpha value applied to all vertices. Default 1.
             * @param flipUV Flip the UV coordinates? Default false.
             */
            function GenerateVerts(vertices: number[], uvs: number[], indicies?: number[], containsZ?: boolean, normals?: number[], colors?: number | number[], alphas?: number | number[], flipUV?: boolean): Phaser.Types.Geom.Mesh.GenerateVertsResult;

            /**
             * Parses a Wavefront OBJ File, extracting the models from it and returning them in an array.
             * 
             * The model data *must* be triangulated for a Mesh Game Object to be able to render it.
             * @param data The OBJ File data as a raw string.
             * @param flipUV Flip the UV coordinates? Default true.
             */
            function ParseObj(data: string, flipUV?: boolean): Phaser.Types.Geom.Mesh.OBJData;

            /**
             * Takes a Wavefront Material file and extracts the diffuse reflectivity of the named
             * materials, converts them to integer color values and returns them.
             * 
             * This is used internally by the `addOBJ` and `addModel` methods, but is exposed for
             * public consumption as well.
             * 
             * Note this only works with diffuse values, specified in the `Kd r g b` format, where
             * `g` and `b` are optional, but `r` is required. It does not support spectral rfl files,
             * or any other material statement (such as `Ka` or `Ks`)
             * @param mtl The OBJ MTL file as a raw string, i.e. loaded via `this.load.text`.
             */
            function ParseObjMaterial(mtl: string): object;

            /**
             * Rotates the vertices of a Face to the given angle.
             * 
             * The actual vertex positions are adjusted, not their transformed positions.
             * 
             * Therefore, this updates the vertex data directly.
             * @param face The Face to rotate.
             * @param angle The angle to rotate to, in radians.
             * @param cx An optional center of rotation. If not given, the Face in-center is used.
             * @param cy An optional center of rotation. If not given, the Face in-center is used.
             */
            function RotateFace(face: Phaser.Geom.Mesh.Face, angle: number, cx?: number, cy?: number): void;

            /**
             * A Vertex Geometry Object.
             * 
             * This class consists of all the information required for a single vertex within a Face Geometry Object.
             * 
             * Faces, and thus Vertex objects, are used by the Mesh Game Object in order to render objects in WebGL.
             */
            class Vertex extends Phaser.Math.Vector3 {
                /**
                 * 
                 * @param x The x position of the vertex.
                 * @param y The y position of the vertex.
                 * @param z The z position of the vertex.
                 * @param u The UV u coordinate of the vertex.
                 * @param v The UV v coordinate of the vertex.
                 * @param color The color value of the vertex. Default 0xffffff.
                 * @param alpha The alpha value of the vertex. Default 1.
                 * @param nx The x normal value of the vertex. Default 0.
                 * @param ny The y normal value of the vertex. Default 0.
                 * @param nz The z normal value of the vertex. Default 0.
                 */
                constructor(x: number, y: number, z: number, u: number, v: number, color?: number, alpha?: number, nx?: number, ny?: number, nz?: number);

                /**
                 * The projected x coordinate of this vertex.
                 */
                vx: number;

                /**
                 * The projected y coordinate of this vertex.
                 */
                vy: number;

                /**
                 * The projected z coordinate of this vertex.
                 */
                vz: number;

                /**
                 * The normalized projected x coordinate of this vertex.
                 */
                nx: number;

                /**
                 * The normalized projected y coordinate of this vertex.
                 */
                ny: number;

                /**
                 * The normalized projected z coordinate of this vertex.
                 */
                nz: number;

                /**
                 * UV u coordinate of this vertex.
                 */
                u: number;

                /**
                 * UV v coordinate of this vertex.
                 */
                v: number;

                /**
                 * The color value of this vertex.
                 */
                color: number;

                /**
                 * The alpha value of this vertex.
                 */
                alpha: number;

                /**
                 * The translated x coordinate of this vertex.
                 */
                tx: number;

                /**
                 * The translated y coordinate of this vertex.
                 */
                ty: number;

                /**
                 * The translated alpha value of this vertex.
                 */
                ta: number;

                /**
                 * The translated uv u coordinate of this vertex.
                 */
                tu: number;

                /**
                 * The translated uv v coordinate of this vertex.
                 */
                tv: number;

                /**
                 * Sets the U and V properties.
                 * 
                 * Also resets the translated uv properties, undoing any scale
                 * or shift they may have had.
                 * @param u The UV u coordinate of the vertex.
                 * @param v The UV v coordinate of the vertex.
                 */
                setUVs(u: number, v: number): this;

                /**
                 * Translates the original UV positions by the given amounts.
                 * 
                 * The original properties `Vertex.u` and `Vertex.v`
                 * remain unchanged, only the translated properties
                 * `Vertex.tu` and `Vertex.tv`, as used in rendering,
                 * are updated.
                 * @param x The amount to scroll the UV u coordinate by.
                 * @param y The amount to scroll the UV v coordinate by.
                 */
                scrollUV(x: number, y: number): this;

                /**
                 * Scales the original UV values by the given amounts.
                 * 
                 * The original properties `Vertex.u` and `Vertex.v`
                 * remain unchanged, only the translated properties
                 * `Vertex.tu` and `Vertex.tv`, as used in rendering,
                 * are updated.
                 * @param x The amount to scale the UV u coordinate by.
                 * @param y The amount to scale the UV v coordinate by.
                 */
                scaleUV(x: number, y: number): this;

                /**
                 * Transforms this vertex by the given matrix, storing the results in `vx`, `vy` and `vz`.
                 * @param transformMatrix The transform matrix to apply to this vertex.
                 * @param width The width of the parent Mesh.
                 * @param height The height of the parent Mesh.
                 * @param cameraZ The z position of the MeshCamera.
                 */
                transformCoordinatesLocal(transformMatrix: Phaser.Math.Matrix4, width: number, height: number, cameraZ: number): void;

                /**
                 * Resizes this Vertex by setting the x and y coordinates, then transforms this vertex
                 * by an identity matrix and dimensions, storing the results in `vx`, `vy` and `vz`.
                 * @param x The x position of the vertex.
                 * @param y The y position of the vertex.
                 * @param width The width of the parent Mesh.
                 * @param height The height of the parent Mesh.
                 * @param originX The originX of the parent Mesh.
                 * @param originY The originY of the parent Mesh.
                 */
                resize(x: number, y: number, width: number, height: number, originX: number, originY: number): this;

                /**
                 * Updates this Vertex based on the given transform.
                 * @param a The parent transform matrix data a component.
                 * @param b The parent transform matrix data b component.
                 * @param c The parent transform matrix data c component.
                 * @param d The parent transform matrix data d component.
                 * @param e The parent transform matrix data e component.
                 * @param f The parent transform matrix data f component.
                 * @param roundPixels Round the vertex position or not?
                 * @param alpha The alpha of the parent object.
                 */
                update(a: number, b: number, c: number, d: number, e: number, f: number, roundPixels: boolean, alpha: number): this;

                /**
                 * Loads the data from this Vertex into the given Typed Arrays.
                 * @param F32 A Float32 Array to insert the position, UV and unit data in to.
                 * @param U32 A Uint32 Array to insert the color and alpha data in to.
                 * @param offset The index of the array to insert this Vertex to.
                 * @param textureUnit The texture unit currently in use.
                 * @param tintEffect The tint effect to use.
                 */
                load(F32: Float32Array, U32: Uint32Array, offset: number, textureUnit: number, tintEffect: number): number;

            }

        }

        /**
         * Defines a Point in 2D space, with an x and y component.
         */
        class Point {
            /**
             * 
             * @param x The x coordinate of this Point. Default 0.
             * @param y The y coordinate of this Point. Default x.
             */
            constructor(x?: number, y?: number);

            /**
             * Apply `Math.ceil()` to each coordinate of the given Point.
             * @param point The Point to ceil.
             */
            static Ceil<O extends Phaser.Geom.Point>(point: O): O;

            /**
             * Clone the given Point.
             * @param source The source Point to clone.
             */
            static Clone(source: Phaser.Geom.Point): Phaser.Geom.Point;

            /**
             * Copy the values of one Point to a destination Point.
             * @param source The source Point to copy the values from.
             * @param dest The destination Point to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Point>(source: Phaser.Geom.Point, dest: O): O;

            /**
             * A comparison of two `Point` objects to see if they are equal.
             * @param point The original `Point` to compare against.
             * @param toCompare The second `Point` to compare.
             */
            static Equals(point: Phaser.Geom.Point, toCompare: Phaser.Geom.Point): boolean;

            /**
             * Apply `Math.ceil()` to each coordinate of the given Point.
             * @param point The Point to floor.
             */
            static Floor<O extends Phaser.Geom.Point>(point: O): O;

            /**
             * Get the centroid or geometric center of a plane figure (the arithmetic mean position of all the points in the figure).
             * Informally, it is the point at which a cutout of the shape could be perfectly balanced on the tip of a pin.
             * @param points An array of Vector2Like objects to get the geometric center of.
             * @param out A Point object to store the output coordinates in. If not given, a new Point instance is created.
             */
            static GetCentroid<O extends Phaser.Geom.Point>(points: Phaser.Types.Math.Vector2Like[], out?: O): O;

            /**
             * Calculate the magnitude of the point, which equivalent to the length of the line from the origin to this point.
             * @param point The point to calculate the magnitude for
             */
            static GetMagnitude(point: Phaser.Geom.Point): number;

            /**
             * Calculates the square of magnitude of given point.(Can be used for fast magnitude calculation of point)
             * @param point Returns square of the magnitude/length of given point.
             */
            static GetMagnitudeSq(point: Phaser.Geom.Point): number;

            /**
             * Calculates the Axis Aligned Bounding Box (or aabb) from an array of points.
             * @param points An array of Vector2Like objects to get the AABB from.
             * @param out A Rectangle object to store the results in. If not given, a new Rectangle instance is created.
             */
            static GetRectangleFromPoints<O extends Phaser.Geom.Rectangle>(points: Phaser.Types.Math.Vector2Like[], out?: O): O;

            /**
             * Returns the linear interpolation point between the two given points, based on `t`.
             * @param pointA The starting `Point` for the interpolation.
             * @param pointB The target `Point` for the interpolation.
             * @param t The amount to interpolate between the two points. Generally, a value between 0 (returns the starting `Point`) and 1 (returns the target `Point`). If omitted, 0 is used. Default 0.
             * @param out An optional `Point` object whose `x` and `y` values will be set to the result of the interpolation (can also be any object with `x` and `y` properties). If omitted, a new `Point` created and returned.
             */
            static Interpolate<O extends Phaser.Geom.Point>(pointA: Phaser.Geom.Point, pointB: Phaser.Geom.Point, t?: number, out?: O): O;

            /**
             * Swaps the X and the Y coordinate of a point.
             * @param point The Point to modify.
             */
            static Invert<O extends Phaser.Geom.Point>(point: O): O;

            /**
             * Inverts a Point's coordinates.
             * @param point The Point to invert.
             * @param out The Point to return the inverted coordinates in.
             */
            static Negative<O extends Phaser.Geom.Point>(point: Phaser.Geom.Point, out?: O): O;

            /**
             * The geometry constant type of this object: `GEOM_CONST.POINT`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The x coordinate of this Point.
             */
            x: number;

            /**
             * The y coordinate of this Point.
             */
            y: number;

            /**
             * Set the x and y coordinates of the point to the given values.
             * @param x The x coordinate of this Point. Default 0.
             * @param y The y coordinate of this Point. Default x.
             */
            setTo(x?: number, y?: number): this;

            /**
             * Calculates the vector projection of `pointA` onto the nonzero `pointB`. This is the
             * orthogonal projection of `pointA` onto a straight line parallel to `pointB`.
             * @param pointA Point A, to be projected onto Point B.
             * @param pointB Point B, to have Point A projected upon it.
             * @param out The Point object to store the position in. If not given, a new Point instance is created.
             */
            static Project<O extends Phaser.Geom.Point>(pointA: Phaser.Geom.Point, pointB: Phaser.Geom.Point, out?: O): O;

            /**
             * Calculates the vector projection of `pointA` onto the nonzero `pointB`. This is the
             * orthogonal projection of `pointA` onto a straight line paralle to `pointB`.
             * @param pointA Point A, to be projected onto Point B. Must be a normalized point with a magnitude of 1.
             * @param pointB Point B, to have Point A projected upon it.
             * @param out The Point object to store the position in. If not given, a new Point instance is created.
             */
            static ProjectUnit<O extends Phaser.Geom.Point>(pointA: Phaser.Geom.Point, pointB: Phaser.Geom.Point, out?: O): O;

            /**
             * Changes the magnitude (length) of a two-dimensional vector without changing its direction.
             * @param point The Point to treat as the end point of the vector.
             * @param magnitude The new magnitude of the vector.
             */
            static SetMagnitude<O extends Phaser.Geom.Point>(point: O, magnitude: number): O;

        }

        /**
         * A Polygon object
         * 
         * The polygon is a closed shape consists of a series of connected straight lines defined by list of ordered points.
         * Several formats are supported to define the list of points, check the setTo method for details.
         * This is a geometry object allowing you to define and inspect the shape.
         * It is not a Game Object, in that you cannot add it to the display list, and it has no texture.
         * To render a Polygon you should look at the capabilities of the Graphics class.
         */
        class Polygon {
            /**
             * 
             * @param points List of points defining the perimeter of this Polygon. Several formats are supported:
             * - A string containing paired x y values separated by a single space: `'40 0 40 20 100 20 100 80 40 80 40 100 0 50'`
             * - An array of Point objects: `[new Phaser.Point(x1, y1), ...]`
             * - An array of objects with public x y properties: `[obj1, obj2, ...]`
             * - An array of paired numbers that represent point coordinates: `[x1,y1, x2,y2, ...]`
             * - An array of arrays with two elements representing x/y coordinates: `[[x1, y1], [x2, y2], ...]`
             */
            constructor(points?: string | number[] | Phaser.Types.Math.Vector2Like[]);

            /**
             * Create a new polygon which is a copy of the specified polygon
             * @param polygon The polygon to create a clone of
             */
            static Clone(polygon: Phaser.Geom.Polygon): Phaser.Geom.Polygon;

            /**
             * Checks if a point is within the bounds of a Polygon.
             * @param polygon The Polygon to check against.
             * @param x The X coordinate of the point to check.
             * @param y The Y coordinate of the point to check.
             */
            static Contains(polygon: Phaser.Geom.Polygon, x: number, y: number): boolean;

            /**
             * Checks the given Point again the Polygon to see if the Point lays within its vertices.
             * @param polygon The Polygon to check.
             * @param point The Point to check if it's within the Polygon.
             */
            static ContainsPoint(polygon: Phaser.Geom.Polygon, point: Phaser.Geom.Point): boolean;

            /**
             * This module implements a modified ear slicing algorithm, optimized by z-order curve hashing and extended to
             * handle holes, twisted polygons, degeneracies and self-intersections in a way that doesn't guarantee correctness
             * of triangulation, but attempts to always produce acceptable results for practical data.
             * 
             * Example:
             * 
             * ```javascript
             * const triangles = Phaser.Geom.Polygon.Earcut([10,0, 0,50, 60,60, 70,10]); // returns [1,0,3, 3,2,1]
             * ```
             * 
             * Each group of three vertex indices in the resulting array forms a triangle.
             * 
             * ```javascript
             * // triangulating a polygon with a hole
             * earcut([0,0, 100,0, 100,100, 0,100,  20,20, 80,20, 80,80, 20,80], [4]);
             * // [3,0,4, 5,4,0, 3,4,7, 5,0,1, 2,3,7, 6,5,1, 2,7,6, 6,1,2]
             * 
             * // triangulating a polygon with 3d coords
             * earcut([10,0,1, 0,50,2, 60,60,3, 70,10,4], null, 3);
             * // [1,0,3, 3,2,1]
             * ```
             * 
             * If you pass a single vertex as a hole, Earcut treats it as a Steiner point.
             * 
             * If your input is a multi-dimensional array (e.g. GeoJSON Polygon), you can convert it to the format
             * expected by Earcut with `Phaser.Geom.Polygon.Earcut.flatten`:
             * 
             * ```javascript
             * var data = earcut.flatten(geojson.geometry.coordinates);
             * var triangles = earcut(data.vertices, data.holes, data.dimensions);
             * ```
             * 
             * After getting a triangulation, you can verify its correctness with `Phaser.Geom.Polygon.Earcut.deviation`:
             * 
             * ```javascript
             * var deviation = earcut.deviation(vertices, holes, dimensions, triangles);
             * ```
             * Returns the relative difference between the total area of triangles and the area of the input polygon.
             * 0 means the triangulation is fully correct.
             * 
             * For more information see https://github.com/mapbox/earcut
             * @param data A flat array of vertex coordinate, like [x0,y0, x1,y1, x2,y2, ...]
             * @param holeIndices An array of hole indices if any (e.g. [5, 8] for a 12-vertex input would mean one hole with vertices 5–7 and another with 8–11).
             * @param dimensions The number of coordinates per vertex in the input array (2 by default). Default 2.
             */
            static Earcut(data: number[], holeIndices?: number[], dimensions?: number): number[];

            /**
             * Calculates the bounding AABB rectangle of a polygon.
             * @param polygon The polygon that should be calculated.
             * @param out The rectangle or object that has x, y, width, and height properties to store the result. Optional.
             */
            static GetAABB<O extends Phaser.Geom.Rectangle>(polygon: Phaser.Geom.Polygon, out?: O): O;

            /**
             * Stores all of the points of a Polygon into a flat array of numbers following the sequence [ x,y, x,y, x,y ],
             * i.e. each point of the Polygon, in the order it's defined, corresponds to two elements of the resultant
             * array for the point's X and Y coordinate.
             * @param polygon The Polygon whose points to export.
             * @param output An array to which the points' coordinates should be appended.
             */
            static GetNumberArray<O extends number[]>(polygon: Phaser.Geom.Polygon, output?: O): O;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the perimeter of the Polygon,
             * based on the given quantity or stepRate values.
             * @param polygon The Polygon to get the points from.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the perimeter of the Polygon and dividing it by the stepRate.
             * @param output An array to insert the points in to. If not provided a new array will be created.
             */
            static GetPoints(polygon: Phaser.Geom.Polygon, quantity: number, stepRate?: number, output?: any[]): Phaser.Geom.Point[];

            /**
             * Returns the perimeter of the given Polygon.
             * @param polygon The Polygon to get the perimeter of.
             */
            static Perimeter(polygon: Phaser.Geom.Polygon): number;

            /**
             * The geometry constant type of this object: `GEOM_CONST.POLYGON`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The area of this Polygon.
             */
            area: number;

            /**
             * An array of number pair objects that make up this polygon. I.e. [ {x,y}, {x,y}, {x,y} ]
             */
            points: Phaser.Geom.Point[];

            /**
             * Check to see if the Polygon contains the given x / y coordinates.
             * @param x The x coordinate to check within the polygon.
             * @param y The y coordinate to check within the polygon.
             */
            contains(x: number, y: number): boolean;

            /**
             * Sets this Polygon to the given points.
             * 
             * The points can be set from a variety of formats:
             * 
             * - A string containing paired values separated by a single space: `'40 0 40 20 100 20 100 80 40 80 40 100 0 50'`
             * - An array of Point objects: `[new Phaser.Point(x1, y1), ...]`
             * - An array of objects with public x/y properties: `[obj1, obj2, ...]`
             * - An array of paired numbers that represent point coordinates: `[x1,y1, x2,y2, ...]`
             * - An array of arrays with two elements representing x/y coordinates: `[[x1, y1], [x2, y2], ...]`
             * 
             * `setTo` may also be called without any arguments to remove all points.
             * @param points Points defining the perimeter of this polygon. Please check function description above for the different supported formats.
             */
            setTo(points?: string | number[] | Phaser.Types.Math.Vector2Like[]): this;

            /**
             * Calculates the area of the Polygon. This is available in the property Polygon.area
             */
            calculateArea(): number;

            /**
             * Returns an array of Point objects containing the coordinates of the points around the perimeter of the Polygon,
             * based on the given quantity or stepRate values.
             * @param quantity The amount of points to return. If a falsey value the quantity will be derived from the `stepRate` instead.
             * @param stepRate Sets the quantity by getting the perimeter of the Polygon and dividing it by the stepRate.
             * @param output An array to insert the points in to. If not provided a new array will be created.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Reverses the order of the points of a Polygon.
             * @param polygon The Polygon to modify.
             */
            static Reverse<O extends Phaser.Geom.Polygon>(polygon: O): O;

            /**
             * Takes a Polygon object and simplifies the points by running them through a combination of
             * Douglas-Peucker and Radial Distance algorithms. Simplification dramatically reduces the number of
             * points in a polygon while retaining its shape, giving a huge performance boost when processing
             * it and also reducing visual noise.
             * @param polygon The polygon to be simplified. The polygon will be modified in-place and returned.
             * @param tolerance Affects the amount of simplification (in the same metric as the point coordinates). Default 1.
             * @param highestQuality Excludes distance-based preprocessing step which leads to highest quality simplification but runs ~10-20 times slower. Default false.
             */
            static Simplify<O extends Phaser.Geom.Polygon>(polygon: O, tolerance?: number, highestQuality?: boolean): O;

            /**
             * Takes a Polygon object and applies Chaikin's smoothing algorithm on its points.
             * @param polygon The polygon to be smoothed. The polygon will be modified in-place and returned.
             */
            static Smooth<O extends Phaser.Geom.Polygon>(polygon: O): O;

            /**
             * Tranlates the points of the given Polygon.
             * @param polygon The Polygon to modify.
             * @param x The amount to horizontally translate the points by.
             * @param y The amount to vertically translate the points by.
             */
            static Translate<O extends Phaser.Geom.Polygon>(polygon: O, x: number, y: number): O;

        }

        /**
         * Encapsulates a 2D rectangle defined by its corner point in the top-left and its extends in x (width) and y (height)
         */
        class Rectangle {
            /**
             * 
             * @param x The X coordinate of the top left corner of the Rectangle. Default 0.
             * @param y The Y coordinate of the top left corner of the Rectangle. Default 0.
             * @param width The width of the Rectangle. Default 0.
             * @param height The height of the Rectangle. Default 0.
             */
            constructor(x?: number, y?: number, width?: number, height?: number);

            /**
             * Calculates the area of the given Rectangle object.
             * @param rect The rectangle to calculate the area of.
             */
            static Area(rect: Phaser.Geom.Rectangle): number;

            /**
             * Rounds a Rectangle's position up to the smallest integer greater than or equal to each current coordinate.
             * @param rect The Rectangle to adjust.
             */
            static Ceil<O extends Phaser.Geom.Rectangle>(rect: O): O;

            /**
             * Rounds a Rectangle's position and size up to the smallest integer greater than or equal to each respective value.
             * @param rect The Rectangle to modify.
             */
            static CeilAll<O extends Phaser.Geom.Rectangle>(rect: O): O;

            /**
             * Moves the top-left corner of a Rectangle so that its center is at the given coordinates.
             * @param rect The Rectangle to be centered.
             * @param x The X coordinate of the Rectangle's center.
             * @param y The Y coordinate of the Rectangle's center.
             */
            static CenterOn<O extends Phaser.Geom.Rectangle>(rect: O, x: number, y: number): O;

            /**
             * Creates a new Rectangle which is identical to the given one.
             * @param source The Rectangle to clone.
             */
            static Clone(source: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle;

            /**
             * Checks if a given point is inside a Rectangle's bounds.
             * @param rect The Rectangle to check.
             * @param x The X coordinate of the point to check.
             * @param y The Y coordinate of the point to check.
             */
            static Contains(rect: Phaser.Geom.Rectangle, x: number, y: number): boolean;

            /**
             * Determines whether the specified point is contained within the rectangular region defined by this Rectangle object.
             * @param rect The Rectangle object.
             * @param point The point object to be checked. Can be a Phaser Point object or any object with x and y values.
             */
            static ContainsPoint(rect: Phaser.Geom.Rectangle, point: Phaser.Geom.Point): boolean;

            /**
             * Tests if one rectangle fully contains another.
             * @param rectA The first rectangle.
             * @param rectB The second rectangle.
             */
            static ContainsRect(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle): boolean;

            /**
             * Copy the values of one Rectangle to a destination Rectangle.
             * @param source The source Rectangle to copy the values from.
             * @param dest The destination Rectangle to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Rectangle>(source: Phaser.Geom.Rectangle, dest: O): O;

            /**
             * Create an array of points for each corner of a Rectangle
             * If an array is specified, each point object will be added to the end of the array, otherwise a new array will be created.
             * @param rect The Rectangle object to be decomposed.
             * @param out If provided, each point will be added to this array.
             */
            static Decompose(rect: Phaser.Geom.Rectangle, out?: any[]): any[];

            /**
             * Compares the `x`, `y`, `width` and `height` properties of two rectangles.
             * @param rect Rectangle A
             * @param toCompare Rectangle B
             */
            static Equals(rect: Phaser.Geom.Rectangle, toCompare: Phaser.Geom.Rectangle): boolean;

            /**
             * Adjusts the target rectangle, changing its width, height and position,
             * so that it fits inside the area of the source rectangle, while maintaining its original
             * aspect ratio.
             * 
             * Unlike the `FitOutside` function, there may be some space inside the source area not covered.
             * @param target The target rectangle to adjust.
             * @param source The source rectangle to envelop the target in.
             */
            static FitInside<O extends Phaser.Geom.Rectangle>(target: O, source: Phaser.Geom.Rectangle): O;

            /**
             * Adjusts the target rectangle, changing its width, height and position,
             * so that it fully covers the area of the source rectangle, while maintaining its original
             * aspect ratio.
             * 
             * Unlike the `FitInside` function, the target rectangle may extend further out than the source.
             * @param target The target rectangle to adjust.
             * @param source The source rectangle to envelope the target in.
             */
            static FitOutside<O extends Phaser.Geom.Rectangle>(target: O, source: Phaser.Geom.Rectangle): O;

            /**
             * Rounds down (floors) the top left X and Y coordinates of the given Rectangle to the largest integer less than or equal to them
             * @param rect The rectangle to floor the top left X and Y coordinates of
             */
            static Floor<O extends Phaser.Geom.Rectangle>(rect: O): O;

            /**
             * Rounds a Rectangle's position and size down to the largest integer less than or equal to each current coordinate or dimension.
             * @param rect The Rectangle to adjust.
             */
            static FloorAll<O extends Phaser.Geom.Rectangle>(rect: O): O;

            /**
             * Constructs new Rectangle or repositions and resizes an existing Rectangle so that all of the given points are on or within its bounds.
             * 
             * The `points` parameter is an array of Point-like objects:
             * 
             * ```js
             * const points = [
             *     [100, 200],
             *     [200, 400],
             *     { x: 30, y: 60 }
             * ]
             * ```
             * @param points An array of points (either arrays with two elements corresponding to the X and Y coordinate or an object with public `x` and `y` properties) which should be surrounded by the Rectangle.
             * @param out Optional Rectangle to adjust.
             */
            static FromPoints<O extends Phaser.Geom.Rectangle>(points: any[], out?: O): O;

            /**
             * Create the smallest Rectangle containing two coordinate pairs.
             * @param x1 The X coordinate of the first point.
             * @param y1 The Y coordinate of the first point.
             * @param x2 The X coordinate of the second point.
             * @param y2 The Y coordinate of the second point.
             * @param out Optional Rectangle to adjust.
             */
            static FromXY<O extends Phaser.Geom.Rectangle>(x1: number, y1: number, x2: number, y2: number, out?: O): O;

            /**
             * Calculates the width/height ratio of a rectangle.
             * @param rect The rectangle.
             */
            static GetAspectRatio(rect: Phaser.Geom.Rectangle): number;

            /**
             * Returns the center of a Rectangle as a Point.
             * @param rect The Rectangle to get the center of.
             * @param out Optional point-like object to update with the center coordinates.
             */
            static GetCenter<O extends Phaser.Geom.Point>(rect: Phaser.Geom.Rectangle, out?: O): O;

            /**
             * Calculates the coordinates of a point at a certain `position` on the Rectangle's perimeter.
             * 
             * The `position` is a fraction between 0 and 1 which defines how far into the perimeter the point is.
             * 
             * A value of 0 or 1 returns the point at the top left corner of the rectangle, while a value of 0.5 returns the point at the bottom right corner of the rectangle. Values between 0 and 0.5 are on the top or the right side and values between 0.5 and 1 are on the bottom or the left side.
             * @param rectangle The Rectangle to get the perimeter point from.
             * @param position The normalized distance into the Rectangle's perimeter to return.
             * @param out An object to update with the `x` and `y` coordinates of the point.
             */
            static GetPoint<O extends Phaser.Geom.Point>(rectangle: Phaser.Geom.Rectangle, position: number, out?: O): O;

            /**
             * Return an array of points from the perimeter of the rectangle, each spaced out based on the quantity or step required.
             * @param rectangle The Rectangle object to get the points from.
             * @param step Step between points. Used to calculate the number of points to return when quantity is falsey. Ignored if quantity is positive.
             * @param quantity The number of evenly spaced points from the rectangles perimeter to return. If falsey, step param will be used to calculate the number of points.
             * @param out An optional array to store the points in.
             */
            static GetPoints<O extends Phaser.Geom.Point[]>(rectangle: Phaser.Geom.Rectangle, step: number, quantity: number, out?: O): O;

            /**
             * Returns the size of the Rectangle, expressed as a Point object.
             * With the value of the `width` as the `x` property and the `height` as the `y` property.
             * @param rect The Rectangle to get the size from.
             * @param out The Point object to store the size in. If not given, a new Point instance is created.
             */
            static GetSize<O extends Phaser.Geom.Point>(rect: Phaser.Geom.Rectangle, out?: O): O;

            /**
             * Increases the size of a Rectangle by a specified amount.
             * 
             * The center of the Rectangle stays the same. The amounts are added to each side, so the actual increase in width or height is two times bigger than the respective argument.
             * @param rect The Rectangle to inflate.
             * @param x How many pixels the left and the right side should be moved by horizontally.
             * @param y How many pixels the top and the bottom side should be moved by vertically.
             */
            static Inflate<O extends Phaser.Geom.Rectangle>(rect: O, x: number, y: number): O;

            /**
             * Takes two Rectangles and first checks to see if they intersect.
             * If they intersect it will return the area of intersection in the `out` Rectangle.
             * If they do not intersect, the `out` Rectangle will have a width and height of zero.
             * @param rectA The first Rectangle to get the intersection from.
             * @param rectB The second Rectangle to get the intersection from.
             * @param out A Rectangle to store the intersection results in.
             */
            static Intersection<O extends Phaser.Geom.Rectangle>(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle, out?: Phaser.Geom.Rectangle): O;

            /**
             * Returns an array of points from the perimeter of the Rectangle, where each point is spaced out based
             * on either the `step` value, or the `quantity`.
             * @param rect The Rectangle to get the perimeter points from.
             * @param step The distance between each point of the perimeter. Set to `null` if you wish to use the `quantity` parameter instead.
             * @param quantity The total number of points to return. The step is then calculated based on the length of the Rectangle, divided by this value.
             * @param out An array in which the perimeter points will be stored. If not given, a new array instance is created.
             */
            static MarchingAnts<O extends Phaser.Geom.Point[]>(rect: Phaser.Geom.Rectangle, step?: number, quantity?: number, out?: O): O;

            /**
             * Merges a Rectangle with a list of points by repositioning and/or resizing it such that all points are located on or within its bounds.
             * @param target The Rectangle which should be merged.
             * @param points An array of Points (or any object with public `x` and `y` properties) which should be merged with the Rectangle.
             */
            static MergePoints<O extends Phaser.Geom.Rectangle>(target: O, points: Phaser.Geom.Point[]): O;

            /**
             * Merges the source rectangle into the target rectangle and returns the target.
             * Neither rectangle should have a negative width or height.
             * @param target Target rectangle. Will be modified to include source rectangle.
             * @param source Rectangle that will be merged into target rectangle.
             */
            static MergeRect<O extends Phaser.Geom.Rectangle>(target: O, source: Phaser.Geom.Rectangle): O;

            /**
             * Merges a Rectangle with a point by repositioning and/or resizing it so that the point is on or within its bounds.
             * @param target The Rectangle which should be merged and modified.
             * @param x The X coordinate of the point which should be merged.
             * @param y The Y coordinate of the point which should be merged.
             */
            static MergeXY<O extends Phaser.Geom.Rectangle>(target: O, x: number, y: number): O;

            /**
             * Nudges (translates) the top left corner of a Rectangle by a given offset.
             * @param rect The Rectangle to adjust.
             * @param x The distance to move the Rectangle horizontally.
             * @param y The distance to move the Rectangle vertically.
             */
            static Offset<O extends Phaser.Geom.Rectangle>(rect: O, x: number, y: number): O;

            /**
             * Nudges (translates) the top-left corner of a Rectangle by the coordinates of a point (translation vector).
             * @param rect The Rectangle to adjust.
             * @param point The point whose coordinates should be used as an offset.
             */
            static OffsetPoint<O extends Phaser.Geom.Rectangle>(rect: O, point: Phaser.Geom.Point | Phaser.Math.Vector2): O;

            /**
             * Checks if two Rectangles overlap. If a Rectangle is within another Rectangle, the two will be considered overlapping. Thus, the Rectangles are treated as "solid".
             * @param rectA The first Rectangle to check.
             * @param rectB The second Rectangle to check.
             */
            static Overlaps(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle): boolean;

            /**
             * Calculates the perimeter of a Rectangle.
             * @param rect The Rectangle to use.
             */
            static Perimeter(rect: Phaser.Geom.Rectangle): number;

            /**
             * Returns a Point from the perimeter of a Rectangle based on the given angle.
             * @param rectangle The Rectangle to get the perimeter point from.
             * @param angle The angle of the point, in degrees.
             * @param out The Point object to store the position in. If not given, a new Point instance is created.
             */
            static PerimeterPoint<O extends Phaser.Geom.Point>(rectangle: Phaser.Geom.Rectangle, angle: number, out?: O): O;

            /**
             * Returns a random point within a Rectangle.
             * @param rect The Rectangle to return a point from.
             * @param out The object to update with the point's coordinates.
             */
            static Random<O extends Phaser.Geom.Point>(rect: Phaser.Geom.Rectangle, out: O): O;

            /**
             * Calculates a random point that lies within the `outer` Rectangle, but outside of the `inner` Rectangle.
             * The inner Rectangle must be fully contained within the outer rectangle.
             * @param outer The outer Rectangle to get the random point within.
             * @param inner The inner Rectangle to exclude from the returned point.
             * @param out A Point, or Point-like object to store the result in. If not specified, a new Point will be created.
             */
            static RandomOutside<O extends Phaser.Geom.Point>(outer: Phaser.Geom.Rectangle, inner: Phaser.Geom.Rectangle, out?: O): O;

            /**
             * The geometry constant type of this object: `GEOM_CONST.RECTANGLE`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * The X coordinate of the top left corner of the Rectangle.
             */
            x: number;

            /**
             * The Y coordinate of the top left corner of the Rectangle.
             */
            y: number;

            /**
             * The width of the Rectangle, i.e. the distance between its left side (defined by `x`) and its right side.
             */
            width: number;

            /**
             * The height of the Rectangle, i.e. the distance between its top side (defined by `y`) and its bottom side.
             */
            height: number;

            /**
             * Checks if the given point is inside the Rectangle's bounds.
             * @param x The X coordinate of the point to check.
             * @param y The Y coordinate of the point to check.
             */
            contains(x: number, y: number): boolean;

            /**
             * Calculates the coordinates of a point at a certain `position` on the Rectangle's perimeter.
             * 
             * The `position` is a fraction between 0 and 1 which defines how far into the perimeter the point is.
             * 
             * A value of 0 or 1 returns the point at the top left corner of the rectangle, while a value of 0.5 returns the point at the bottom right corner of the rectangle. Values between 0 and 0.5 are on the top or the right side and values between 0.5 and 1 are on the bottom or the left side.
             * @param position The normalized distance into the Rectangle's perimeter to return.
             * @param output An object to update with the `x` and `y` coordinates of the point.
             */
            getPoint<O extends Phaser.Geom.Point>(position: number, output?: O): O;

            /**
             * Returns an array of points from the perimeter of the Rectangle, each spaced out based on the quantity or step required.
             * @param quantity The number of points to return. Set to `false` or 0 to return an arbitrary number of points (`perimeter / stepRate`) evenly spaced around the Rectangle based on the `stepRate`.
             * @param stepRate If `quantity` is 0, determines the normalized distance between each returned point.
             * @param output An array to which to append the points.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Returns a random point within the Rectangle's bounds.
             * @param point The object in which to store the `x` and `y` coordinates of the point.
             */
            getRandomPoint<O extends Phaser.Geom.Point>(point?: O): O;

            /**
             * Sets the position, width, and height of the Rectangle.
             * @param x The X coordinate of the top left corner of the Rectangle.
             * @param y The Y coordinate of the top left corner of the Rectangle.
             * @param width The width of the Rectangle.
             * @param height The height of the Rectangle.
             */
            setTo(x: number, y: number, width: number, height: number): this;

            /**
             * Resets the position, width, and height of the Rectangle to 0.
             */
            setEmpty(): this;

            /**
             * Sets the position of the Rectangle.
             * @param x The X coordinate of the top left corner of the Rectangle.
             * @param y The Y coordinate of the top left corner of the Rectangle. Default x.
             */
            setPosition(x: number, y?: number): this;

            /**
             * Sets the width and height of the Rectangle.
             * @param width The width to set the Rectangle to.
             * @param height The height to set the Rectangle to. Default width.
             */
            setSize(width: number, height?: number): this;

            /**
             * Determines if the Rectangle is empty. A Rectangle is empty if its width or height is less than or equal to 0.
             */
            isEmpty(): boolean;

            /**
             * Returns a Line object that corresponds to the top of this Rectangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineA<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Returns a Line object that corresponds to the right of this Rectangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineB<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Returns a Line object that corresponds to the bottom of this Rectangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineC<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Returns a Line object that corresponds to the left of this Rectangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineD<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * The x coordinate of the left of the Rectangle.
             * Changing the left property of a Rectangle object has no effect on the y and height properties. However it does affect the width property, whereas changing the x value does not affect the width property.
             */
            left: number;

            /**
             * The sum of the x and width properties.
             * Changing the right property of a Rectangle object has no effect on the x, y and height properties, however it does affect the width property.
             */
            right: number;

            /**
             * The y coordinate of the top of the Rectangle. Changing the top property of a Rectangle object has no effect on the x and width properties.
             * However it does affect the height property, whereas changing the y value does not affect the height property.
             */
            top: number;

            /**
             * The sum of the y and height properties.
             * Changing the bottom property of a Rectangle object has no effect on the x, y and width properties, but does change the height property.
             */
            bottom: number;

            /**
             * The x coordinate of the center of the Rectangle.
             */
            centerX: number;

            /**
             * The y coordinate of the center of the Rectangle.
             */
            centerY: number;

            /**
             * Determines if the two objects (either Rectangles or Rectangle-like) have the same width and height values under strict equality.
             * @param rect The first Rectangle object.
             * @param toCompare The second Rectangle object.
             */
            static SameDimensions(rect: Phaser.Geom.Rectangle, toCompare: Phaser.Geom.Rectangle): boolean;

            /**
             * Scales the width and height of this Rectangle by the given amounts.
             * @param rect The `Rectangle` object that will be scaled by the specified amount(s).
             * @param x The factor by which to scale the rectangle horizontally.
             * @param y The amount by which to scale the rectangle vertically. If this is not specified, the rectangle will be scaled by the factor `x` in both directions.
             */
            static Scale<O extends Phaser.Geom.Rectangle>(rect: O, x: number, y: number): O;

            /**
             * Creates a new Rectangle or repositions and/or resizes an existing Rectangle so that it encompasses the two given Rectangles, i.e. calculates their union.
             * @param rectA The first Rectangle to use.
             * @param rectB The second Rectangle to use.
             * @param out The Rectangle to store the union in.
             */
            static Union<O extends Phaser.Geom.Rectangle>(rectA: Phaser.Geom.Rectangle, rectB: Phaser.Geom.Rectangle, out?: O): O;

        }

        /**
         * A triangle is a plane created by connecting three points.
         * The first two arguments specify the first point, the middle two arguments
         * specify the second point, and the last two arguments specify the third point.
         */
        class Triangle {
            /**
             * 
             * @param x1 `x` coordinate of the first point. Default 0.
             * @param y1 `y` coordinate of the first point. Default 0.
             * @param x2 `x` coordinate of the second point. Default 0.
             * @param y2 `y` coordinate of the second point. Default 0.
             * @param x3 `x` coordinate of the third point. Default 0.
             * @param y3 `y` coordinate of the third point. Default 0.
             */
            constructor(x1?: number, y1?: number, x2?: number, y2?: number, x3?: number, y3?: number);

            /**
             * Returns the area of a Triangle.
             * @param triangle The Triangle to use.
             */
            static Area(triangle: Phaser.Geom.Triangle): number;

            /**
             * Builds an equilateral triangle. In the equilateral triangle, all the sides are the same length (congruent) and all the angles are the same size (congruent).
             * The x/y specifies the top-middle of the triangle (x1/y1) and length is the length of each side.
             * @param x x coordinate of the top point of the triangle.
             * @param y y coordinate of the top point of the triangle.
             * @param length Length of each side of the triangle.
             */
            static BuildEquilateral(x: number, y: number, length: number): Phaser.Geom.Triangle;

            /**
             * Takes an array of vertex coordinates, and optionally an array of hole indices, then returns an array
             * of Triangle instances, where the given vertices have been decomposed into a series of triangles.
             * @param data A flat array of vertex coordinates like [x0,y0, x1,y1, x2,y2, ...]
             * @param holes An array of hole indices if any (e.g. [5, 8] for a 12-vertex input would mean one hole with vertices 5–7 and another with 8–11). Default null.
             * @param scaleX Horizontal scale factor to multiply the resulting points by. Default 1.
             * @param scaleY Vertical scale factor to multiply the resulting points by. Default 1.
             * @param out An array to store the resulting Triangle instances in. If not provided, a new array is created.
             */
            static BuildFromPolygon<O extends Phaser.Geom.Triangle[]>(data: any[], holes?: any[], scaleX?: number, scaleY?: number, out?: O): O;

            /**
             * Builds a right triangle, i.e. one which has a 90-degree angle and two acute angles.
             * @param x The X coordinate of the right angle, which will also be the first X coordinate of the constructed Triangle.
             * @param y The Y coordinate of the right angle, which will also be the first Y coordinate of the constructed Triangle.
             * @param width The length of the side which is to the left or to the right of the right angle.
             * @param height The length of the side which is above or below the right angle.
             */
            static BuildRight(x: number, y: number, width: number, height: number): Phaser.Geom.Triangle;

            /**
             * Positions the Triangle so that it is centered on the given coordinates.
             * @param triangle The triangle to be positioned.
             * @param x The horizontal coordinate to center on.
             * @param y The vertical coordinate to center on.
             * @param centerFunc The function used to center the triangle. Defaults to Centroid centering.
             */
            static CenterOn<O extends Phaser.Geom.Triangle>(triangle: O, x: number, y: number, centerFunc?: CenterFunction): O;

            /**
             * Calculates the position of a Triangle's centroid, which is also its center of mass (center of gravity).
             * 
             * The centroid is the point in a Triangle at which its three medians (the lines drawn from the vertices to the bisectors of the opposite sides) meet. It divides each one in a 2:1 ratio.
             * @param triangle The Triangle to use.
             * @param out An object to store the coordinates in.
             */
            static Centroid<O extends Phaser.Geom.Point>(triangle: Phaser.Geom.Triangle, out?: O): O;

            /**
             * Computes the circumcentre of a triangle. The circumcentre is the centre of
             * the circumcircle, the smallest circle which encloses the triangle. It is also
             * the common intersection point of the perpendicular bisectors of the sides of
             * the triangle, and is the only point which has equal distance to all three
             * vertices of the triangle.
             * @param triangle The Triangle to get the circumcenter of.
             * @param out The Vector2 object to store the position in. If not given, a new Vector2 instance is created.
             */
            static CircumCenter<O extends Phaser.Math.Vector2>(triangle: Phaser.Geom.Triangle, out?: O): O;

            /**
             * Finds the circumscribed circle (circumcircle) of a Triangle object. The circumcircle is the circle which touches all of the triangle's vertices.
             * @param triangle The Triangle to use as input.
             * @param out An optional Circle to store the result in.
             */
            static CircumCircle<O extends Phaser.Geom.Circle>(triangle: Phaser.Geom.Triangle, out?: O): O;

            /**
             * Clones a Triangle object.
             * @param source The Triangle to clone.
             */
            static Clone(source: Phaser.Geom.Triangle): Phaser.Geom.Triangle;

            /**
             * Checks if a point (as a pair of coordinates) is inside a Triangle's bounds.
             * @param triangle The Triangle to check.
             * @param x The X coordinate of the point to check.
             * @param y The Y coordinate of the point to check.
             */
            static Contains(triangle: Phaser.Geom.Triangle, x: number, y: number): boolean;

            /**
             * Filters an array of point-like objects to only those contained within a triangle.
             * If `returnFirst` is true, will return an array containing only the first point in the provided array that is within the triangle (or an empty array if there are no such points).
             * @param triangle The triangle that the points are being checked in.
             * @param points An array of point-like objects (objects that have an `x` and `y` property)
             * @param returnFirst If `true`, return an array containing only the first point found that is within the triangle. Default false.
             * @param out If provided, the points that are within the triangle will be appended to this array instead of being added to a new array. If `returnFirst` is true, only the first point found within the triangle will be appended. This array will also be returned by this function.
             */
            static ContainsArray(triangle: Phaser.Geom.Triangle, points: Phaser.Geom.Point[], returnFirst?: boolean, out?: any[]): Phaser.Geom.Point[];

            /**
             * Tests if a triangle contains a point.
             * @param triangle The triangle.
             * @param point The point to test, or any point-like object with public `x` and `y` properties.
             */
            static ContainsPoint(triangle: Phaser.Geom.Triangle, point: Phaser.Geom.Point | Phaser.Math.Vector2 | any): boolean;

            /**
             * Copy the values of one Triangle to a destination Triangle.
             * @param source The source Triangle to copy the values from.
             * @param dest The destination Triangle to copy the values to.
             */
            static CopyFrom<O extends Phaser.Geom.Triangle>(source: Phaser.Geom.Triangle, dest: O): O;

            /**
             * Decomposes a Triangle into an array of its points.
             * @param triangle The Triangle to decompose.
             * @param out An array to store the points into.
             */
            static Decompose(triangle: Phaser.Geom.Triangle, out?: any[]): any[];

            /**
             * Returns true if two triangles have the same coordinates.
             * @param triangle The first triangle to check.
             * @param toCompare The second triangle to check.
             */
            static Equals(triangle: Phaser.Geom.Triangle, toCompare: Phaser.Geom.Triangle): boolean;

            /**
             * Returns a Point from around the perimeter of a Triangle.
             * @param triangle The Triangle to get the point on its perimeter from.
             * @param position The position along the perimeter of the triangle. A value between 0 and 1.
             * @param out An option Point, or Point-like object to store the value in. If not given a new Point will be created.
             */
            static GetPoint<O extends Phaser.Geom.Point>(triangle: Phaser.Geom.Triangle, position: number, out?: O): O;

            /**
             * Returns an array of evenly spaced points on the perimeter of a Triangle.
             * @param triangle The Triangle to get the points from.
             * @param quantity The number of evenly spaced points to return. Set to 0 to return an arbitrary number of points based on the `stepRate`.
             * @param stepRate If `quantity` is 0, the distance between each returned point.
             * @param out An array to which the points should be appended.
             */
            static GetPoints<O extends Phaser.Geom.Point>(triangle: Phaser.Geom.Triangle, quantity: number, stepRate: number, out?: O): O;

            /**
             * Calculates the position of the incenter of a Triangle object. This is the point where its three angle bisectors meet and it's also the center of the incircle, which is the circle inscribed in the triangle.
             * @param triangle The Triangle to find the incenter of.
             * @param out An optional Point in which to store the coordinates.
             */
            static InCenter<O extends Phaser.Geom.Point>(triangle: Phaser.Geom.Triangle, out?: O): O;

            /**
             * Moves each point (vertex) of a Triangle by a given offset, thus moving the entire Triangle by that offset.
             * @param triangle The Triangle to move.
             * @param x The horizontal offset (distance) by which to move each point. Can be positive or negative.
             * @param y The vertical offset (distance) by which to move each point. Can be positive or negative.
             */
            static Offset<O extends Phaser.Geom.Triangle>(triangle: O, x: number, y: number): O;

            /**
             * Gets the length of the perimeter of the given triangle.
             * Calculated by adding together the length of each of the three sides.
             * @param triangle The Triangle to get the length from.
             */
            static Perimeter(triangle: Phaser.Geom.Triangle): number;

            /**
             * Returns a random Point from within the area of the given Triangle.
             * @param triangle The Triangle to get a random point from.
             * @param out The Point object to store the position in. If not given, a new Point instance is created.
             */
            static Random<O extends Phaser.Geom.Point>(triangle: Phaser.Geom.Triangle, out?: O): O;

            /**
             * Rotates a Triangle about its incenter, which is the point at which its three angle bisectors meet.
             * @param triangle The Triangle to rotate.
             * @param angle The angle by which to rotate the Triangle, in radians.
             */
            static Rotate<O extends Phaser.Geom.Triangle>(triangle: O, angle: number): O;

            /**
             * Rotates a Triangle at a certain angle about a given Point or object with public `x` and `y` properties.
             * @param triangle The Triangle to rotate.
             * @param point The Point to rotate the Triangle about.
             * @param angle The angle by which to rotate the Triangle, in radians.
             */
            static RotateAroundPoint<O extends Phaser.Geom.Triangle>(triangle: O, point: Phaser.Geom.Point, angle: number): O;

            /**
             * Rotates an entire Triangle at a given angle about a specific point.
             * @param triangle The Triangle to rotate.
             * @param x The X coordinate of the point to rotate the Triangle about.
             * @param y The Y coordinate of the point to rotate the Triangle about.
             * @param angle The angle by which to rotate the Triangle, in radians.
             */
            static RotateAroundXY<O extends Phaser.Geom.Triangle>(triangle: O, x: number, y: number, angle: number): O;

            /**
             * The geometry constant type of this object: `GEOM_CONST.TRIANGLE`.
             * Used for fast type comparisons.
             */
            readonly type: number;

            /**
             * `x` coordinate of the first point.
             */
            x1: number;

            /**
             * `y` coordinate of the first point.
             */
            y1: number;

            /**
             * `x` coordinate of the second point.
             */
            x2: number;

            /**
             * `y` coordinate of the second point.
             */
            y2: number;

            /**
             * `x` coordinate of the third point.
             */
            x3: number;

            /**
             * `y` coordinate of the third point.
             */
            y3: number;

            /**
             * Checks whether a given points lies within the triangle.
             * @param x The x coordinate of the point to check.
             * @param y The y coordinate of the point to check.
             */
            contains(x: number, y: number): boolean;

            /**
             * Returns a specific point  on the triangle.
             * @param position Position as float within `0` and `1`. `0` equals the first point.
             * @param output Optional Point, or point-like object, that the calculated point will be written to.
             */
            getPoint<O extends Phaser.Geom.Point>(position: number, output?: O): O;

            /**
             * Calculates a list of evenly distributed points on the triangle. It is either possible to pass an amount of points to be generated (`quantity`) or the distance between two points (`stepRate`).
             * @param quantity Number of points to be generated. Can be falsey when `stepRate` should be used. All points have the same distance along the triangle.
             * @param stepRate Distance between two points. Will only be used when `quantity` is falsey.
             * @param output Optional Array for writing the calculated points into. Otherwise a new array will be created.
             */
            getPoints<O extends Phaser.Geom.Point[]>(quantity: number, stepRate?: number, output?: O): O;

            /**
             * Returns a random point along the triangle.
             * @param point Optional `Point` that should be modified. Otherwise a new one will be created.
             */
            getRandomPoint<O extends Phaser.Geom.Point>(point?: O): O;

            /**
             * Sets all three points of the triangle. Leaving out any coordinate sets it to be `0`.
             * @param x1 `x` coordinate of the first point. Default 0.
             * @param y1 `y` coordinate of the first point. Default 0.
             * @param x2 `x` coordinate of the second point. Default 0.
             * @param y2 `y` coordinate of the second point. Default 0.
             * @param x3 `x` coordinate of the third point. Default 0.
             * @param y3 `y` coordinate of the third point. Default 0.
             */
            setTo(x1?: number, y1?: number, x2?: number, y2?: number, x3?: number, y3?: number): this;

            /**
             * Returns a Line object that corresponds to Line A of this Triangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineA<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Returns a Line object that corresponds to Line B of this Triangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineB<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Returns a Line object that corresponds to Line C of this Triangle.
             * @param line A Line object to set the results in. If `undefined` a new Line will be created.
             */
            getLineC<O extends Phaser.Geom.Line>(line?: O): O;

            /**
             * Left most X coordinate of the triangle. Setting it moves the triangle on the X axis accordingly.
             */
            left: number;

            /**
             * Right most X coordinate of the triangle. Setting it moves the triangle on the X axis accordingly.
             */
            right: number;

            /**
             * Top most Y coordinate of the triangle. Setting it moves the triangle on the Y axis accordingly.
             */
            top: number;

            /**
             * Bottom most Y coordinate of the triangle. Setting it moves the triangle on the Y axis accordingly.
             */
            bottom: number;

        }

    }

    namespace Input {
        /**
         * The mouse pointer is being held down.
         */
        var MOUSE_DOWN: number;

        /**
         * The mouse pointer is being moved.
         */
        var MOUSE_MOVE: number;

        /**
         * The mouse pointer is released.
         */
        var MOUSE_UP: number;

        /**
         * A touch pointer has been started.
         */
        var TOUCH_START: number;

        /**
         * A touch pointer has been started.
         */
        var TOUCH_MOVE: number;

        /**
         * A touch pointer has been started.
         */
        var TOUCH_END: number;

        /**
         * The pointer lock has changed.
         */
        var POINTER_LOCK_CHANGE: number;

        /**
         * A touch pointer has been been cancelled by the browser.
         */
        var TOUCH_CANCEL: number;

        /**
         * The mouse wheel changes.
         */
        var MOUSE_WHEEL: number;

        /**
         * Creates a new Interactive Object.
         * 
         * This is called automatically by the Input Manager when you enable a Game Object for input.
         * 
         * The resulting Interactive Object is mapped to the Game Object's `input` property.
         * @param gameObject The Game Object to which this Interactive Object is bound.
         * @param hitArea The hit area for this Interactive Object. Typically a geometry shape, like a Rectangle or Circle.
         * @param hitAreaCallback The 'contains' check callback that the hit area shape will use for all hit tests.
         */
        function CreateInteractiveObject(gameObject: Phaser.GameObjects.GameObject, hitArea: any, hitAreaCallback: Phaser.Types.Input.HitAreaCallback): Phaser.Types.Input.InteractiveObject;

        /**
         * Creates a new Pixel Perfect Handler function.
         * 
         * Access via `InputPlugin.makePixelPerfect` rather than calling it directly.
         * @param textureManager A reference to the Texture Manager.
         * @param alphaTolerance The alpha level that the pixel should be above to be included as a successful interaction.
         */
        function CreatePixelPerfectHandler(textureManager: Phaser.Textures.TextureManager, alphaTolerance: number): Function;

        namespace Events {
            /**
             * The Input Plugin Boot Event.
             * 
             * This internal event is dispatched by the Input Plugin when it boots, signalling to all of its systems to create themselves.
             */
            const BOOT: string;

            /**
             * The Input Plugin Destroy Event.
             * 
             * This internal event is dispatched by the Input Plugin when it is destroyed, signalling to all of its systems to destroy themselves.
             */
            const DESTROY: string;

            /**
             * The Pointer Drag End Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer stops dragging a Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('dragend', listener)`.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG_END]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG_END} event instead.
             */
            const DRAG_END: string;

            /**
             * The Pointer Drag Enter Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer drags a Game Object into a Drag Target.
             * 
             * Listen to this event from within a Scene using: `this.input.on('dragenter', listener)`.
             * 
             * A Pointer can only drag a single Game Object at once.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG_ENTER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG_ENTER} event instead.
             */
            const DRAG_ENTER: string;

            /**
             * The Pointer Drag Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer moves while dragging a Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('drag', listener)`.
             * 
             * A Pointer can only drag a single Game Object at once.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG} event instead.
             */
            const DRAG: string;

            /**
             * The Pointer Drag Leave Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer drags a Game Object out of a Drag Target.
             * 
             * Listen to this event from within a Scene using: `this.input.on('dragleave', listener)`.
             * 
             * A Pointer can only drag a single Game Object at once.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG_LEAVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG_LEAVE} event instead.
             */
            const DRAG_LEAVE: string;

            /**
             * The Pointer Drag Over Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer drags a Game Object over a Drag Target.
             * 
             * When the Game Object first enters the drag target it will emit a `dragenter` event. If it then moves while within
             * the drag target, it will emit this event instead.
             * 
             * Listen to this event from within a Scene using: `this.input.on('dragover', listener)`.
             * 
             * A Pointer can only drag a single Game Object at once.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG_OVER} event instead.
             */
            const DRAG_OVER: string;

            /**
             * The Pointer Drag Start Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer starts to drag any Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('dragstart', listener)`.
             * 
             * A Pointer can only drag a single Game Object at once.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DRAG_START]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DRAG_START} event instead.
             */
            const DRAG_START: string;

            /**
             * The Pointer Drop Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer drops a Game Object on a Drag Target.
             * 
             * Listen to this event from within a Scene using: `this.input.on('drop', listener)`.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_DROP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DROP} event instead.
             */
            const DROP: string;

            /**
             * The Game Object Down Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is pressed down on _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectdown', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_DOWN} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_DOWN}
             * 2. [GAMEOBJECT_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DOWN}
             * 3. [POINTER_DOWN]{@linkcode Phaser.Input.Events#event:POINTER_DOWN} or [POINTER_DOWN_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_DOWN_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_DOWN: string;

            /**
             * The Game Object Drag End Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer stops dragging it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('dragend', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive](Phaser.GameObjects.GameObject#setInteractive) for more details.
             */
            const GAMEOBJECT_DRAG_END: string;

            /**
             * The Game Object Drag Enter Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer drags it into a drag target.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('dragenter', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             */
            const GAMEOBJECT_DRAG_ENTER: string;

            /**
             * The Game Object Drag Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer moves while dragging it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('drag', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             */
            const GAMEOBJECT_DRAG: string;

            /**
             * The Game Object Drag Leave Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer drags it out of a drag target.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('dragleave', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             */
            const GAMEOBJECT_DRAG_LEAVE: string;

            /**
             * The Game Object Drag Over Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer drags it over a drag target.
             * 
             * When the Game Object first enters the drag target it will emit a `dragenter` event. If it then moves while within
             * the drag target, it will emit this event instead.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('dragover', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             */
            const GAMEOBJECT_DRAG_OVER: string;

            /**
             * The Game Object Drag Start Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer starts to drag it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('dragstart', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * There are lots of useful drag related properties that are set within the Game Object when dragging occurs.
             * For example, `gameObject.input.dragStartX`, `dragStartY` and so on.
             */
            const GAMEOBJECT_DRAG_START: string;

            /**
             * The Game Object Drop Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer drops it on a Drag Target.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('drop', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive and enabled for drag.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             */
            const GAMEOBJECT_DROP: string;

            /**
             * The Game Object Move Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is moved across _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectmove', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_MOVE} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_MOVE}
             * 2. [GAMEOBJECT_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_MOVE}
             * 3. [POINTER_MOVE]{@linkcode Phaser.Input.Events#event:POINTER_MOVE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_MOVE: string;

            /**
             * The Game Object Out Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer moves out of _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectout', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OUT} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OUT}
             * 2. [GAMEOBJECT_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OUT}
             * 3. [POINTER_OUT]{@linkcode Phaser.Input.Events#event:POINTER_OUT}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             * 
             * If the pointer leaves the game canvas itself, it will not trigger an this event. To handle those cases,
             * please listen for the [GAME_OUT]{@linkcode Phaser.Input.Events#event:GAME_OUT} event.
             */
            const GAMEOBJECT_OUT: string;

            /**
             * The Game Object Over Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer moves over _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectover', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OVER} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OVER}
             * 2. [GAMEOBJECT_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OVER}
             * 3. [POINTER_OVER]{@linkcode Phaser.Input.Events#event:POINTER_OVER}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_OVER: string;

            /**
             * The Game Object Pointer Down Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer is pressed down on it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('pointerdown', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_DOWN}
             * 2. [GAMEOBJECT_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DOWN}
             * 3. [POINTER_DOWN]{@linkcode Phaser.Input.Events#event:POINTER_DOWN} or [POINTER_DOWN_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_DOWN_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_POINTER_DOWN: string;

            /**
             * The Game Object Pointer Move Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer is moved while over it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('pointermove', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_MOVE}
             * 2. [GAMEOBJECT_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_MOVE}
             * 3. [POINTER_MOVE]{@linkcode Phaser.Input.Events#event:POINTER_MOVE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_POINTER_MOVE: string;

            /**
             * The Game Object Pointer Out Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer moves out of it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('pointerout', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OUT}
             * 2. [GAMEOBJECT_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OUT}
             * 3. [POINTER_OUT]{@linkcode Phaser.Input.Events#event:POINTER_OUT}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             * 
             * If the pointer leaves the game canvas itself, it will not trigger an this event. To handle those cases,
             * please listen for the [GAME_OUT]{@linkcode Phaser.Input.Events#event:GAME_OUT} event.
             */
            const GAMEOBJECT_POINTER_OUT: string;

            /**
             * The Game Object Pointer Over Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer moves over it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('pointerover', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OVER}
             * 2. [GAMEOBJECT_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OVER}
             * 3. [POINTER_OVER]{@linkcode Phaser.Input.Events#event:POINTER_OVER}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_POINTER_OVER: string;

            /**
             * The Game Object Pointer Up Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer is released while over it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('pointerup', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_UP}
             * 2. [GAMEOBJECT_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_UP}
             * 3. [POINTER_UP]{@linkcode Phaser.Input.Events#event:POINTER_UP} or [POINTER_UP_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_UP_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_POINTER_UP: string;

            /**
             * The Game Object Pointer Wheel Event.
             * 
             * This event is dispatched by an interactive Game Object if a pointer has its wheel moved while over it.
             * 
             * Listen to this event from a Game Object using: `gameObject.on('wheel', listener)`.
             * Note that the scope of the listener is automatically set to be the Game Object instance itself.
             * 
             * To receive this event, the Game Object must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_WHEEL}
             * 2. [GAMEOBJECT_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_WHEEL}
             * 3. [POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:POINTER_WHEEL}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_POINTER_WHEEL: string;

            /**
             * The Game Object Up Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is released while over _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectup', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_UP} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_UP}
             * 2. [GAMEOBJECT_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_UP}
             * 3. [POINTER_UP]{@linkcode Phaser.Input.Events#event:POINTER_UP} or [POINTER_UP_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_UP_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_UP: string;

            /**
             * The Game Object Wheel Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer has its wheel moved while over _any_ interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameobjectwheel', listener)`.
             * 
             * To receive this event, the Game Objects must have been set as interactive.
             * See [GameObject.setInteractive]{@link Phaser.GameObjects.GameObject#setInteractive} for more details.
             * 
             * To listen for this event from a _specific_ Game Object, use the [GAMEOBJECT_POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_WHEEL} event instead.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_WHEEL}
             * 2. [GAMEOBJECT_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_WHEEL}
             * 3. [POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:POINTER_WHEEL}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const GAMEOBJECT_WHEEL: string;

            /**
             * The Input Plugin Game Out Event.
             * 
             * This event is dispatched by the Input Plugin if the active pointer leaves the game canvas and is now
             * outside of it, elsewhere on the web page.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameout', listener)`.
             */
            const GAME_OUT: string;

            /**
             * The Input Plugin Game Over Event.
             * 
             * This event is dispatched by the Input Plugin if the active pointer enters the game canvas and is now
             * over of it, having previously been elsewhere on the web page.
             * 
             * Listen to this event from within a Scene using: `this.input.on('gameover', listener)`.
             */
            const GAME_OVER: string;

            /**
             * The Input Manager Boot Event.
             * 
             * This internal event is dispatched by the Input Manager when it boots.
             */
            const MANAGER_BOOT: string;

            /**
             * The Input Manager Process Event.
             * 
             * This internal event is dispatched by the Input Manager when not using the legacy queue system,
             * and it wants the Input Plugins to update themselves.
             */
            const MANAGER_PROCESS: string;

            /**
             * The Input Manager Update Event.
             * 
             * This internal event is dispatched by the Input Manager as part of its update step.
             */
            const MANAGER_UPDATE: string;

            /**
             * The Input Manager Pointer Lock Change Event.
             * 
             * This event is dispatched by the Input Manager when it is processing a native Pointer Lock Change DOM Event.
             */
            const POINTERLOCK_CHANGE: string;

            /**
             * The Pointer Down Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is pressed down anywhere.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerdown', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_DOWN}
             * 2. [GAMEOBJECT_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DOWN}
             * 3. [POINTER_DOWN]{@linkcode Phaser.Input.Events#event:POINTER_DOWN} or [POINTER_DOWN_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_DOWN_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_DOWN: string;

            /**
             * The Pointer Down Outside Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is pressed down anywhere outside of the game canvas.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerdownoutside', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_DOWN}
             * 2. [GAMEOBJECT_DOWN]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_DOWN}
             * 3. [POINTER_DOWN]{@linkcode Phaser.Input.Events#event:POINTER_DOWN} or [POINTER_DOWN_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_DOWN_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_DOWN_OUTSIDE: string;

            /**
             * The Pointer Move Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is moved anywhere.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointermove', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_MOVE}
             * 2. [GAMEOBJECT_MOVE]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_MOVE}
             * 3. [POINTER_MOVE]{@linkcode Phaser.Input.Events#event:POINTER_MOVE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_MOVE: string;

            /**
             * The Pointer Out Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer moves out of any interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerout', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OUT}
             * 2. [GAMEOBJECT_OUT]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OUT}
             * 3. [POINTER_OUT]{@linkcode Phaser.Input.Events#event:POINTER_OUT}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             * 
             * If the pointer leaves the game canvas itself, it will not trigger an this event. To handle those cases,
             * please listen for the [GAME_OUT]{@linkcode Phaser.Input.Events#event:GAME_OUT} event.
             */
            const POINTER_OUT: string;

            /**
             * The Pointer Over Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer moves over any interactive Game Object.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerover', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_OVER}
             * 2. [GAMEOBJECT_OVER]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_OVER}
             * 3. [POINTER_OVER]{@linkcode Phaser.Input.Events#event:POINTER_OVER}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_OVER: string;

            /**
             * The Pointer Up Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is released anywhere.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerup', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_UP}
             * 2. [GAMEOBJECT_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_UP}
             * 3. [POINTER_UP]{@linkcode Phaser.Input.Events#event:POINTER_UP} or [POINTER_UP_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_UP_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_UP: string;

            /**
             * The Pointer Up Outside Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer is released anywhere outside of the game canvas.
             * 
             * Listen to this event from within a Scene using: `this.input.on('pointerupoutside', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_UP}
             * 2. [GAMEOBJECT_UP]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_UP}
             * 3. [POINTER_UP]{@linkcode Phaser.Input.Events#event:POINTER_UP} or [POINTER_UP_OUTSIDE]{@linkcode Phaser.Input.Events#event:POINTER_UP_OUTSIDE}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_UP_OUTSIDE: string;

            /**
             * The Pointer Wheel Input Event.
             * 
             * This event is dispatched by the Input Plugin belonging to a Scene if a pointer has its wheel updated.
             * 
             * Listen to this event from within a Scene using: `this.input.on('wheel', listener)`.
             * 
             * The event hierarchy is as follows:
             * 
             * 1. [GAMEOBJECT_POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_POINTER_WHEEL}
             * 2. [GAMEOBJECT_WHEEL]{@linkcode Phaser.Input.Events#event:GAMEOBJECT_WHEEL}
             * 3. [POINTER_WHEEL]{@linkcode Phaser.Input.Events#event:POINTER_WHEEL}
             * 
             * With the top event being dispatched first and then flowing down the list. Note that higher-up event handlers can stop
             * the propagation of this event.
             */
            const POINTER_WHEEL: string;

            /**
             * The Input Plugin Pre-Update Event.
             * 
             * This internal event is dispatched by the Input Plugin at the start of its `preUpdate` method.
             * This hook is designed specifically for input plugins, but can also be listened to from user-land code.
             */
            const PRE_UPDATE: string;

            /**
             * The Input Plugin Shutdown Event.
             * 
             * This internal event is dispatched by the Input Plugin when it shuts down, signalling to all of its systems to shut themselves down.
             */
            const SHUTDOWN: string;

            /**
             * The Input Plugin Start Event.
             * 
             * This internal event is dispatched by the Input Plugin when it has finished setting-up,
             * signalling to all of its internal systems to start.
             */
            const START: string;

            /**
             * The Input Plugin Update Event.
             * 
             * This internal event is dispatched by the Input Plugin at the start of its `update` method.
             * This hook is designed specifically for input plugins, but can also be listened to from user-land code.
             */
            const UPDATE: string;

        }

        namespace Gamepad {
            /**
             * Contains information about a specific Gamepad Axis.
             * Axis objects are created automatically by the Gamepad as they are needed.
             */
            class Axis {
                /**
                 * 
                 * @param pad A reference to the Gamepad that this Axis belongs to.
                 * @param index The index of this Axis.
                 */
                constructor(pad: Phaser.Input.Gamepad.Gamepad, index: number);

                /**
                 * A reference to the Gamepad that this Axis belongs to.
                 */
                pad: Phaser.Input.Gamepad.Gamepad;

                /**
                 * An event emitter to use to emit the axis events.
                 */
                events: Phaser.Events.EventEmitter;

                /**
                 * The index of this Axis.
                 */
                index: number;

                /**
                 * The raw axis value, between -1 and 1 with 0 being dead center.
                 * Use the method `getValue` to get a normalized value with the threshold applied.
                 */
                value: number;

                /**
                 * Movement tolerance threshold below which axis values are ignored in `getValue`.
                 */
                threshold: number;

                /**
                 * Applies the `threshold` value to the axis and returns it.
                 */
                getValue(): number;

                /**
                 * Destroys this Axis instance and releases external references it holds.
                 */
                destroy(): void;

            }

            /**
             * Contains information about a specific button on a Gamepad.
             * Button objects are created automatically by the Gamepad as they are needed.
             */
            class Button {
                /**
                 * 
                 * @param pad A reference to the Gamepad that this Button belongs to.
                 * @param index The index of this Button.
                 */
                constructor(pad: Phaser.Input.Gamepad.Gamepad, index: number);

                /**
                 * A reference to the Gamepad that this Button belongs to.
                 */
                pad: Phaser.Input.Gamepad.Gamepad;

                /**
                 * An event emitter to use to emit the button events.
                 */
                events: Phaser.Events.EventEmitter;

                /**
                 * The index of this Button.
                 */
                index: number;

                /**
                 * Between 0 and 1.
                 */
                value: number;

                /**
                 * Can be set for analogue buttons to enable a 'pressure' threshold,
                 * before a button is considered as being 'pressed'.
                 */
                threshold: number;

                /**
                 * Is the Button being pressed down or not?
                 */
                pressed: boolean;

                /**
                 * Destroys this Button instance and releases external references it holds.
                 */
                destroy(): void;

            }

            namespace Configs {
                /**
                 * Tatar SNES USB Controller Gamepad Configuration.
                 * USB Gamepad  (STANDARD GAMEPAD Vendor: 0079 Product: 0011)
                 */
                namespace SNES_USB {
                    /**
                     * D-Pad up
                     */
                    const UP: number;

                    /**
                     * D-Pad down
                     */
                    const DOWN: number;

                    /**
                     * D-Pad left
                     */
                    const LEFT: number;

                    /**
                     * D-Pad right
                     */
                    const RIGHT: number;

                    /**
                     * Select button
                     */
                    const SELECT: number;

                    /**
                     * Start button
                     */
                    const START: number;

                    /**
                     * B Button (Bottom)
                     */
                    const B: number;

                    /**
                     * A Button (Right)
                     */
                    const A: number;

                    /**
                     * Y Button (Left)
                     */
                    const Y: number;

                    /**
                     * X Button (Top)
                     */
                    const X: number;

                    /**
                     * Left bumper
                     */
                    const LEFT_SHOULDER: number;

                    /**
                     * Right bumper
                     */
                    const RIGHT_SHOULDER: number;

                }

                /**
                 * PlayStation DualShock 4 Gamepad Configuration.
                 * Sony PlayStation DualShock 4 (v2) wireless controller
                 */
                namespace DUALSHOCK_4 {
                    /**
                     * D-Pad up
                     */
                    const UP: number;

                    /**
                     * D-Pad down
                     */
                    const DOWN: number;

                    /**
                     * D-Pad left
                     */
                    const LEFT: number;

                    /**
                     * D-Pad up
                     */
                    const RIGHT: number;

                    /**
                     * Share button
                     */
                    const SHARE: number;

                    /**
                     * Options button
                     */
                    const OPTIONS: number;

                    /**
                     * PlayStation logo button
                     */
                    const PS: number;

                    /**
                     * Touchpad click
                     */
                    const TOUCHBAR: number;

                    /**
                     * Cross button (Bottom)
                     */
                    const X: number;

                    /**
                     * Circle button (Right)
                     */
                    const CIRCLE: number;

                    /**
                     * Square button (Left)
                     */
                    const SQUARE: number;

                    /**
                     * Triangle button (Top)
                     */
                    const TRIANGLE: number;

                    /**
                     * Left bumper (L1)
                     */
                    const L1: number;

                    /**
                     * Right bumper (R1)
                     */
                    const R1: number;

                    /**
                     * Left trigger (L2)
                     */
                    const L2: number;

                    /**
                     * Right trigger (R2)
                     */
                    const R2: number;

                    /**
                     * Left stick click (L3)
                     */
                    const L3: number;

                    /**
                     * Right stick click (R3)
                     */
                    const R3: number;

                    /**
                     * Left stick horizontal
                     */
                    const LEFT_STICK_H: number;

                    /**
                     * Left stick vertical
                     */
                    const LEFT_STICK_V: number;

                    /**
                     * Right stick horizontal
                     */
                    const RIGHT_STICK_H: number;

                    /**
                     * Right stick vertical
                     */
                    const RIGHT_STICK_V: number;

                }

                /**
                 * XBox 360 Gamepad Configuration.
                 */
                namespace XBOX_360 {
                    /**
                     * D-Pad up
                     */
                    const UP: number;

                    /**
                     * D-Pad down
                     */
                    const DOWN: number;

                    /**
                     * D-Pad left
                     */
                    const LEFT: number;

                    /**
                     * D-Pad right
                     */
                    const RIGHT: number;

                    /**
                     * XBox menu button
                     */
                    const MENU: number;

                    /**
                     * A button (Bottom)
                     */
                    const A: number;

                    /**
                     * B button (Right)
                     */
                    const B: number;

                    /**
                     * X button (Left)
                     */
                    const X: number;

                    /**
                     * Y button (Top)
                     */
                    const Y: number;

                    /**
                     * Left Bumper
                     */
                    const LB: number;

                    /**
                     * Right Bumper
                     */
                    const RB: number;

                    /**
                     * Left Trigger
                     */
                    const LT: number;

                    /**
                     * Right Trigger
                     */
                    const RT: number;

                    /**
                     * Back / Change View button
                     */
                    const BACK: number;

                    /**
                     * Start button
                     */
                    const START: number;

                    /**
                     * Left Stick press
                     */
                    const LS: number;

                    /**
                     * Right stick press
                     */
                    const RS: number;

                    /**
                     * Left Stick horizontal
                     */
                    const LEFT_STICK_H: number;

                    /**
                     * Left Stick vertical
                     */
                    const LEFT_STICK_V: number;

                    /**
                     * Right Stick horizontal
                     */
                    const RIGHT_STICK_H: number;

                    /**
                     * Right Stick vertical
                     */
                    const RIGHT_STICK_V: number;

                }

            }

            namespace Events {
                /**
                 * The Gamepad Button Down Event.
                 * 
                 * This event is dispatched by the Gamepad Plugin when a button has been pressed on any active Gamepad.
                 * 
                 * Listen to this event from within a Scene using: `this.input.gamepad.on('down', listener)`.
                 * 
                 * You can also listen for a DOWN event from a Gamepad instance. See the [GAMEPAD_BUTTON_DOWN]{@linkcode Phaser.Input.Gamepad.Events#event:GAMEPAD_BUTTON_DOWN} event for details.
                 */
                const BUTTON_DOWN: string;

                /**
                 * The Gamepad Button Up Event.
                 * 
                 * This event is dispatched by the Gamepad Plugin when a button has been released on any active Gamepad.
                 * 
                 * Listen to this event from within a Scene using: `this.input.gamepad.on('up', listener)`.
                 * 
                 * You can also listen for an UP event from a Gamepad instance. See the [GAMEPAD_BUTTON_UP]{@linkcode Phaser.Input.Gamepad.Events#event:GAMEPAD_BUTTON_UP} event for details.
                 */
                const BUTTON_UP: string;

                /**
                 * The Gamepad Connected Event.
                 * 
                 * This event is dispatched by the Gamepad Plugin when a Gamepad has been connected.
                 * 
                 * Listen to this event from within a Scene using: `this.input.gamepad.once('connected', listener)`.
                 * 
                 * Note that the browser may require you to press a button on a gamepad before it will allow you to access it,
                 * this is for security reasons. However, it may also trust the page already, in which case you won't get the
                 * 'connected' event and instead should check `GamepadPlugin.total` to see if it thinks there are any gamepads
                 * already connected.
                 */
                const CONNECTED: string;

                /**
                 * The Gamepad Disconnected Event.
                 * 
                 * This event is dispatched by the Gamepad Plugin when a Gamepad has been disconnected.
                 * 
                 * Listen to this event from within a Scene using: `this.input.gamepad.once('disconnected', listener)`.
                 */
                const DISCONNECTED: string;

                /**
                 * The Gamepad Button Down Event.
                 * 
                 * This event is dispatched by a Gamepad instance when a button has been pressed on it.
                 * 
                 * Listen to this event from a Gamepad instance. Once way to get this is from the `pad1`, `pad2`, etc properties on the Gamepad Plugin:
                 * `this.input.gamepad.pad1.on('down', listener)`.
                 * 
                 * Note that you will not receive any Gamepad button events until the browser considers the Gamepad as being 'connected'.
                 * 
                 * You can also listen for a DOWN event from the Gamepad Plugin. See the [BUTTON_DOWN]{@linkcode Phaser.Input.Gamepad.Events#event:BUTTON_DOWN} event for details.
                 */
                const GAMEPAD_BUTTON_DOWN: string;

                /**
                 * The Gamepad Button Up Event.
                 * 
                 * This event is dispatched by a Gamepad instance when a button has been released on it.
                 * 
                 * Listen to this event from a Gamepad instance. Once way to get this is from the `pad1`, `pad2`, etc properties on the Gamepad Plugin:
                 * `this.input.gamepad.pad1.on('up', listener)`.
                 * 
                 * Note that you will not receive any Gamepad button events until the browser considers the Gamepad as being 'connected'.
                 * 
                 * You can also listen for an UP event from the Gamepad Plugin. See the [BUTTON_UP]{@linkcode Phaser.Input.Gamepad.Events#event:BUTTON_UP} event for details.
                 */
                const GAMEPAD_BUTTON_UP: string;

            }

            /**
             * A single Gamepad.
             * 
             * These are created, updated and managed by the Gamepad Plugin.
             */
            class Gamepad extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param manager A reference to the Gamepad Plugin.
                 * @param pad The Gamepad object, as extracted from GamepadEvent.
                 */
                constructor(manager: Phaser.Input.Gamepad.GamepadPlugin, pad: Phaser.Types.Input.Gamepad.Pad);

                /**
                 * A reference to the Gamepad Plugin.
                 */
                manager: Phaser.Input.Gamepad.GamepadPlugin;

                /**
                 * A reference to the native Gamepad object that is connected to the browser.
                 */
                pad: any;

                /**
                 * A string containing some information about the controller.
                 * 
                 * This is not strictly specified, but in Firefox it will contain three pieces of information
                 * separated by dashes (-): two 4-digit hexadecimal strings containing the USB vendor and
                 * product id of the controller, and the name of the controller as provided by the driver.
                 * In Chrome it will contain the name of the controller as provided by the driver,
                 * followed by vendor and product 4-digit hexadecimal strings.
                 */
                id: string;

                /**
                 * An integer that is unique for each Gamepad currently connected to the system.
                 * This can be used to distinguish multiple controllers.
                 * Note that disconnecting a device and then connecting a new device may reuse the previous index.
                 */
                index: number;

                /**
                 * An array of Gamepad Button objects, corresponding to the different buttons available on the Gamepad.
                 */
                buttons: Phaser.Input.Gamepad.Button[];

                /**
                 * An array of Gamepad Axis objects, corresponding to the different axes available on the Gamepad, if any.
                 */
                axes: Phaser.Input.Gamepad.Axis[];

                /**
                 * The Gamepad's Haptic Actuator (Vibration / Rumble support).
                 * This is highly experimental and only set if both present on the device,
                 * and exposed by both the hardware and browser.
                 */
                vibration: GamepadHapticActuator;

                /**
                 * A Vector2 containing the most recent values from the Gamepad's left axis stick.
                 * This is updated automatically as part of the Gamepad.update cycle.
                 * The H Axis is mapped to the `Vector2.x` property, and the V Axis to the `Vector2.y` property.
                 * The values are based on the Axis thresholds.
                 * If the Gamepad does not have a left axis stick, the values will always be zero.
                 */
                leftStick: Phaser.Math.Vector2;

                /**
                 * A Vector2 containing the most recent values from the Gamepad's right axis stick.
                 * This is updated automatically as part of the Gamepad.update cycle.
                 * The H Axis is mapped to the `Vector2.x` property, and the V Axis to the `Vector2.y` property.
                 * The values are based on the Axis thresholds.
                 * If the Gamepad does not have a right axis stick, the values will always be zero.
                 */
                rightStick: Phaser.Math.Vector2;

                /**
                 * Gets the total number of axis this Gamepad claims to support.
                 */
                getAxisTotal(): number;

                /**
                 * Gets the value of an axis based on the given index.
                 * The index must be valid within the range of axes supported by this Gamepad.
                 * The return value will be a float between 0 and 1.
                 * @param index The index of the axes to get the value for.
                 */
                getAxisValue(index: number): number;

                /**
                 * Sets the threshold value of all axis on this Gamepad.
                 * The value is a float between 0 and 1 and is the amount below which the axis is considered as not having been moved.
                 * @param value A value between 0 and 1.
                 */
                setAxisThreshold(value: number): void;

                /**
                 * Gets the total number of buttons this Gamepad claims to have.
                 */
                getButtonTotal(): number;

                /**
                 * Gets the value of a button based on the given index.
                 * The index must be valid within the range of buttons supported by this Gamepad.
                 * 
                 * The return value will be either 0 or 1 for an analogue button, or a float between 0 and 1
                 * for a pressure-sensitive digital button, such as the shoulder buttons on a Dual Shock.
                 * @param index The index of the button to get the value for.
                 */
                getButtonValue(index: number): number;

                /**
                 * Returns if the button is pressed down or not.
                 * The index must be valid within the range of buttons supported by this Gamepad.
                 * @param index The index of the button to get the value for.
                 */
                isButtonDown(index: number): boolean;

                /**
                 * Destroys this Gamepad instance, its buttons and axes, and releases external references it holds.
                 */
                destroy(): void;

                /**
                 * Is this Gamepad currently connected or not?
                 */
                connected: boolean;

                /**
                 * A timestamp containing the most recent time this Gamepad was updated.
                 */
                timestamp: number;

                /**
                 * Is the Gamepad's Left button being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * This is the d-pad left button under standard Gamepad mapping.
                 */
                left: boolean;

                /**
                 * Is the Gamepad's Right button being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * This is the d-pad right button under standard Gamepad mapping.
                 */
                right: boolean;

                /**
                 * Is the Gamepad's Up button being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * This is the d-pad up button under standard Gamepad mapping.
                 */
                up: boolean;

                /**
                 * Is the Gamepad's Down button being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * This is the d-pad down button under standard Gamepad mapping.
                 */
                down: boolean;

                /**
                 * Is the Gamepad's bottom button in the right button cluster being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * On a Dual Shock controller it's the X button.
                 * On an XBox controller it's the A button.
                 */
                A: boolean;

                /**
                 * Is the Gamepad's top button in the right button cluster being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * On a Dual Shock controller it's the Triangle button.
                 * On an XBox controller it's the Y button.
                 */
                Y: boolean;

                /**
                 * Is the Gamepad's left button in the right button cluster being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * On a Dual Shock controller it's the Square button.
                 * On an XBox controller it's the X button.
                 */
                X: boolean;

                /**
                 * Is the Gamepad's right button in the right button cluster being pressed?
                 * If the Gamepad doesn't have this button it will always return false.
                 * On a Dual Shock controller it's the Circle button.
                 * On an XBox controller it's the B button.
                 */
                B: boolean;

                /**
                 * Returns the value of the Gamepad's top left shoulder button.
                 * If the Gamepad doesn't have this button it will always return zero.
                 * The value is a float between 0 and 1, corresponding to how depressed the button is.
                 * On a Dual Shock controller it's the L1 button.
                 * On an XBox controller it's the LB button.
                 */
                L1: number;

                /**
                 * Returns the value of the Gamepad's bottom left shoulder button.
                 * If the Gamepad doesn't have this button it will always return zero.
                 * The value is a float between 0 and 1, corresponding to how depressed the button is.
                 * On a Dual Shock controller it's the L2 button.
                 * On an XBox controller it's the LT button.
                 */
                L2: number;

                /**
                 * Returns the value of the Gamepad's top right shoulder button.
                 * If the Gamepad doesn't have this button it will always return zero.
                 * The value is a float between 0 and 1, corresponding to how depressed the button is.
                 * On a Dual Shock controller it's the R1 button.
                 * On an XBox controller it's the RB button.
                 */
                R1: number;

                /**
                 * Returns the value of the Gamepad's bottom right shoulder button.
                 * If the Gamepad doesn't have this button it will always return zero.
                 * The value is a float between 0 and 1, corresponding to how depressed the button is.
                 * On a Dual Shock controller it's the R2 button.
                 * On an XBox controller it's the RT button.
                 */
                R2: number;

            }

            /**
             * The Gamepad Plugin is an input plugin that belongs to the Scene-owned Input system.
             * 
             * Its role is to listen for native DOM Gamepad Events and then process them.
             * 
             * You do not need to create this class directly, the Input system will create an instance of it automatically.
             * 
             * You can access it from within a Scene using `this.input.gamepad`.
             * 
             * To listen for a gamepad being connected:
             * 
             * ```javascript
             * this.input.gamepad.once('connected', function (pad) {
             *     //   'pad' is a reference to the gamepad that was just connected
             * });
             * ```
             * 
             * Note that the browser may require you to press a button on a gamepad before it will allow you to access it,
             * this is for security reasons. However, it may also trust the page already, in which case you won't get the
             * 'connected' event and instead should check `GamepadPlugin.total` to see if it thinks there are any gamepads
             * already connected.
             * 
             * Once you have received the connected event, or polled the gamepads and found them enabled, you can access
             * them via the built-in properties `GamepadPlugin.pad1` to `pad4`, for up to 4 game pads. With a reference
             * to the gamepads you can poll its buttons and axis sticks. See the properties and methods available on
             * the `Gamepad` class for more details.
             * 
             * As of September 2020 Chrome, and likely other browsers, will soon start to require that games requesting
             * access to the Gamepad API are running under SSL. They will actively block API access if they are not.
             * 
             * For more information about Gamepad support in browsers see the following resources:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/API/Gamepad_API
             * https://developer.mozilla.org/en-US/docs/Web/API/Gamepad_API/Using_the_Gamepad_API
             * https://www.smashingmagazine.com/2015/11/gamepad-api-in-web-games/
             * http://html5gamepad.com/
             */
            class GamepadPlugin extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param sceneInputPlugin A reference to the Scene Input Plugin that the KeyboardPlugin belongs to.
                 */
                constructor(sceneInputPlugin: Phaser.Input.InputPlugin);

                /**
                 * A reference to the Scene that this Input Plugin is responsible for.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene Systems Settings.
                 */
                settings: Phaser.Types.Scenes.SettingsObject;

                /**
                 * A reference to the Scene Input Plugin that created this Keyboard Plugin.
                 */
                sceneInputPlugin: Phaser.Input.InputPlugin;

                /**
                 * A boolean that controls if the Gamepad Manager is enabled or not.
                 * Can be toggled on the fly.
                 */
                enabled: boolean;

                /**
                 * The Gamepad Event target, as defined in the Game Config.
                 * Typically the browser window, but can be any interactive DOM element.
                 */
                target: any;

                /**
                 * An array of the connected Gamepads.
                 */
                gamepads: Phaser.Input.Gamepad.Gamepad[];

                /**
                 * Checks to see if both this plugin and the Scene to which it belongs is active.
                 */
                isActive(): boolean;

                /**
                 * Disconnects all current Gamepads.
                 */
                disconnectAll(): void;

                /**
                 * Returns an array of all currently connected Gamepads.
                 */
                getAll(): Phaser.Input.Gamepad.Gamepad[];

                /**
                 * Looks-up a single Gamepad based on the given index value.
                 * @param index The index of the Gamepad to get.
                 */
                getPad(index: number): Phaser.Input.Gamepad.Gamepad;

                /**
                 * The total number of connected game pads.
                 */
                total: number;

                /**
                 * A reference to the first connected Gamepad.
                 * 
                 * This will be undefined if either no pads are connected, or the browser
                 * has not yet issued a gamepadconnect, which can happen even if a Gamepad
                 * is plugged in, but hasn't yet had any buttons pressed on it.
                 */
                pad1: Phaser.Input.Gamepad.Gamepad;

                /**
                 * A reference to the second connected Gamepad.
                 * 
                 * This will be undefined if either no pads are connected, or the browser
                 * has not yet issued a gamepadconnect, which can happen even if a Gamepad
                 * is plugged in, but hasn't yet had any buttons pressed on it.
                 */
                pad2: Phaser.Input.Gamepad.Gamepad;

                /**
                 * A reference to the third connected Gamepad.
                 * 
                 * This will be undefined if either no pads are connected, or the browser
                 * has not yet issued a gamepadconnect, which can happen even if a Gamepad
                 * is plugged in, but hasn't yet had any buttons pressed on it.
                 */
                pad3: Phaser.Input.Gamepad.Gamepad;

                /**
                 * A reference to the fourth connected Gamepad.
                 * 
                 * This will be undefined if either no pads are connected, or the browser
                 * has not yet issued a gamepadconnect, which can happen even if a Gamepad
                 * is plugged in, but hasn't yet had any buttons pressed on it.
                 */
                pad4: Phaser.Input.Gamepad.Gamepad;

            }

        }

        /**
         * The Input Manager is responsible for handling the pointer related systems in a single Phaser Game instance.
         * 
         * Based on the Game Config it will create handlers for mouse and touch support.
         * 
         * Keyboard and Gamepad are plugins, handled directly by the InputPlugin class.
         * 
         * It then manages the events, pointer creation and general hit test related operations.
         * 
         * You rarely need to interact with the Input Manager directly, and as such, all of its properties and methods
         * should be considered private. Instead, you should use the Input Plugin, which is a Scene level system, responsible
         * for dealing with all input events for a Scene.
         */
        class InputManager {
            /**
             * 
             * @param game The Game instance that owns the Input Manager.
             * @param config The Input Configuration object, as set in the Game Config.
             */
            constructor(game: Phaser.Game, config: object);

            /**
             * The Game instance that owns the Input Manager.
             * A Game only maintains on instance of the Input Manager at any time.
             */
            readonly game: Phaser.Game;

            /**
             * A reference to the global Game Scale Manager.
             * Used for all bounds checks and pointer scaling.
             */
            scaleManager: Phaser.Scale.ScaleManager;

            /**
             * The Canvas that is used for all DOM event input listeners.
             */
            canvas: HTMLCanvasElement;

            /**
             * The Game Configuration object, as set during the game boot.
             */
            config: Phaser.Core.Config;

            /**
             * If set, the Input Manager will run its update loop every frame.
             */
            enabled: boolean;

            /**
             * The Event Emitter instance that the Input Manager uses to emit events from.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * Are any mouse or touch pointers currently over the game canvas?
             * This is updated automatically by the canvas over and out handlers.
             */
            readonly isOver: boolean;

            /**
             * The default CSS cursor to be used when interacting with your game.
             * 
             * See the `setDefaultCursor` method for more details.
             */
            defaultCursor: string;

            /**
             * A reference to the Keyboard Manager class, if enabled via the `input.keyboard` Game Config property.
             */
            keyboard: Phaser.Input.Keyboard.KeyboardManager | null;

            /**
             * A reference to the Mouse Manager class, if enabled via the `input.mouse` Game Config property.
             */
            mouse: Phaser.Input.Mouse.MouseManager | null;

            /**
             * A reference to the Touch Manager class, if enabled via the `input.touch` Game Config property.
             */
            touch: Phaser.Input.Touch.TouchManager;

            /**
             * An array of Pointers that have been added to the game.
             * The first entry is reserved for the Mouse Pointer, the rest are Touch Pointers.
             * 
             * By default there is 1 touch pointer enabled. If you need more use the `addPointer` method to start them,
             * or set the `input.activePointers` property in the Game Config.
             */
            pointers: Phaser.Input.Pointer[];

            /**
             * The number of touch objects activated and being processed each update.
             * 
             * You can change this by either calling `addPointer` at run-time, or by
             * setting the `input.activePointers` property in the Game Config.
             */
            readonly pointersTotal: number;

            /**
             * The mouse has its own unique Pointer object, which you can reference directly if making a _desktop specific game_.
             * If you are supporting both desktop and touch devices then do not use this property, instead use `activePointer`
             * which will always map to the most recently interacted pointer.
             */
            mousePointer: Phaser.Input.Pointer | null;

            /**
             * The most recently active Pointer object.
             * 
             * If you've only 1 Pointer in your game then this will accurately be either the first finger touched, or the mouse.
             * 
             * If your game doesn't need to support multi-touch then you can safely use this property in all of your game
             * code and it will adapt to be either the mouse or the touch, based on device.
             */
            activePointer: Phaser.Input.Pointer;

            /**
             * If the top-most Scene in the Scene List receives an input it will stop input from
             * propagating any lower down the scene list, i.e. if you have a UI Scene at the top
             * and click something on it, that click will not then be passed down to any other
             * Scene below. Disable this to have input events passed through all Scenes, all the time.
             */
            globalTopOnly: boolean;

            /**
             * The time this Input Manager was last updated.
             * This value is populated by the Game Step each frame.
             */
            readonly time: number;

            /**
             * The Boot handler is called by Phaser.Game when it first starts up.
             * The renderer is available by now.
             */
            protected boot(): void;

            /**
             * Tells the Input system to set a custom cursor.
             * 
             * This cursor will be the default cursor used when interacting with the game canvas.
             * 
             * If an Interactive Object also sets a custom cursor, this is the cursor that is reset after its use.
             * 
             * Any valid CSS cursor value is allowed, including paths to image files, i.e.:
             * 
             * ```javascript
             * this.input.setDefaultCursor('url(assets/cursors/sword.cur), pointer');
             * ```
             * 
             * Please read about the differences between browsers when it comes to the file formats and sizes they support:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/cursor
             * https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_User_Interface/Using_URL_values_for_the_cursor_property
             * 
             * It's up to you to pick a suitable cursor format that works across the range of browsers you need to support.
             * @param cursor The CSS to be used when setting the default cursor.
             */
            setDefaultCursor(cursor: string): void;

            /**
             * Adds new Pointer objects to the Input Manager.
             * 
             * By default Phaser creates 2 pointer objects: `mousePointer` and `pointer1`.
             * 
             * You can create more either by calling this method, or by setting the `input.activePointers` property
             * in the Game Config, up to a maximum of 10 pointers.
             * 
             * The first 10 pointers are available via the `InputPlugin.pointerX` properties, once they have been added
             * via this method.
             * @param quantity The number of new Pointers to create. A maximum of 10 is allowed in total. Default 1.
             */
            addPointer(quantity?: number): Phaser.Input.Pointer[];

            /**
             * Internal method that gets a list of all the active Input Plugins in the game
             * and updates each of them in turn, in reverse order (top to bottom), to allow
             * for DOM top-level event handling simulation.
             * @param type The type of event to process.
             * @param pointers An array of Pointers on which the event occurred.
             */
            updateInputPlugins(type: number, pointers: Phaser.Input.Pointer[]): void;

            /**
             * Performs a hit test using the given Pointer and camera, against an array of interactive Game Objects.
             * 
             * The Game Objects are culled against the camera, and then the coordinates are translated into the local camera space
             * and used to determine if they fall within the remaining Game Objects hit areas or not.
             * 
             * If nothing is matched an empty array is returned.
             * 
             * This method is called automatically by InputPlugin.hitTestPointer and doesn't usually need to be invoked directly.
             * @param pointer The Pointer to test against.
             * @param gameObjects An array of interactive Game Objects to check.
             * @param camera The Camera which is being tested against.
             * @param output An array to store the results in. If not given, a new empty array is created.
             */
            hitTest(pointer: Phaser.Input.Pointer, gameObjects: any[], camera: Phaser.Cameras.Scene2D.Camera, output?: any[]): any[];

            /**
             * Checks if the given x and y coordinate are within the hit area of the Game Object.
             * 
             * This method assumes that the coordinate values have already been translated into the space of the Game Object.
             * 
             * If the coordinates are within the hit area they are set into the Game Objects Input `localX` and `localY` properties.
             * @param gameObject The interactive Game Object to check against.
             * @param x The translated x coordinate for the hit test.
             * @param y The translated y coordinate for the hit test.
             */
            pointWithinHitArea(gameObject: Phaser.GameObjects.GameObject, x: number, y: number): boolean;

            /**
             * Checks if the given x and y coordinate are within the hit area of the Interactive Object.
             * 
             * This method assumes that the coordinate values have already been translated into the space of the Interactive Object.
             * 
             * If the coordinates are within the hit area they are set into the Interactive Objects Input `localX` and `localY` properties.
             * @param object The Interactive Object to check against.
             * @param x The translated x coordinate for the hit test.
             * @param y The translated y coordinate for the hit test.
             */
            pointWithinInteractiveObject(object: Phaser.Types.Input.InteractiveObject, x: number, y: number): boolean;

            /**
             * Transforms the pageX and pageY values of a Pointer into the scaled coordinate space of the Input Manager.
             * @param pointer The Pointer to transform the values for.
             * @param pageX The Page X value.
             * @param pageY The Page Y value.
             * @param wasMove Are we transforming the Pointer from a move event, or an up / down event?
             */
            transformPointer(pointer: Phaser.Input.Pointer, pageX: number, pageY: number, wasMove: boolean): void;

            /**
             * Destroys the Input Manager and all of its systems.
             * 
             * There is no way to recover from doing this.
             */
            destroy(): void;

        }

        /**
         * The Input Plugin belongs to a Scene and handles all input related events and operations for it.
         * 
         * You can access it from within a Scene using `this.input`.
         * 
         * It emits events directly. For example, you can do:
         * 
         * ```javascript
         * this.input.on('pointerdown', callback, context);
         * ```
         * 
         * To listen for a pointer down event anywhere on the game canvas.
         * 
         * Game Objects can be enabled for input by calling their `setInteractive` method. After which they
         * will directly emit input events:
         * 
         * ```javascript
         * var sprite = this.add.sprite(x, y, texture);
         * sprite.setInteractive();
         * sprite.on('pointerdown', callback, context);
         * ```
         * 
         * There are lots of game configuration options available relating to input.
         * See the [Input Config object]{@linkcode Phaser.Types.Core.InputConfig} for more details, including how to deal with Phaser
         * listening for input events outside of the canvas, how to set a default number of pointers, input
         * capture settings and more.
         * 
         * Please also see the Input examples and tutorials for further information.
         * 
         * **Incorrect input coordinates with Angular**
         * 
         * If you are using Phaser within Angular, and use nglf or the router, to make the component in which the Phaser game resides
         * change state (i.e. appear or disappear) then you'll need to notify the Scale Manager about this, as Angular will mess with
         * the DOM in a way in which Phaser can't detect directly. Call `this.scale.updateBounds()` as part of your game init in order
         * to refresh the canvas DOM bounds values, which Phaser uses for input point position calculations.
         */
        class InputPlugin extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param scene A reference to the Scene that this Input Plugin is responsible for.
             */
            constructor(scene: Phaser.Scene);

            /**
             * An instance of the Gamepad Plugin class, if enabled via the `input.gamepad` Scene or Game Config property.
             * Use this to create access Gamepads connected to the browser and respond to gamepad buttons.
             */
            gamepad: Phaser.Input.Gamepad.GamepadPlugin | null;

            /**
             * A reference to the Scene that this Input Plugin is responsible for.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Scene Systems class.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * A reference to the Scene Systems Settings.
             */
            settings: Phaser.Types.Scenes.SettingsObject;

            /**
             * A reference to the Game Input Manager.
             */
            manager: Phaser.Input.InputManager;

            /**
             * If `true` this Input Plugin will process DOM input events.
             */
            enabled: boolean;

            /**
             * A reference to the Scene Display List. This property is set during the `boot` method.
             */
            displayList: Phaser.GameObjects.DisplayList;

            /**
             * A reference to the Scene Cameras Manager. This property is set during the `boot` method.
             */
            cameras: Phaser.Cameras.Scene2D.CameraManager;

            /**
             * A reference to the Mouse Manager.
             * 
             * This property is only set if Mouse support has been enabled in your Game Configuration file.
             * 
             * If you just wish to get access to the mouse pointer, use the `mousePointer` property instead.
             */
            mouse: Phaser.Input.Mouse.MouseManager | null;

            /**
             * When set to `true` (the default) the Input Plugin will emulate DOM behavior by only emitting events from
             * the top-most Game Objects in the Display List.
             * 
             * If set to `false` it will emit events from all Game Objects below a Pointer, not just the top one.
             */
            topOnly: boolean;

            /**
             * How often should the Pointers be checked?
             * 
             * The value is a time, given in ms, and is the time that must have elapsed between game steps before
             * the Pointers will be polled again. When a pointer is polled it runs a hit test to see which Game
             * Objects are currently below it, or being interacted with it.
             * 
             * Pointers will *always* be checked if they have been moved by the user, or press or released.
             * 
             * This property only controls how often they will be polled if they have not been updated.
             * You should set this if you want to have Game Objects constantly check against the pointers, even
             * if the pointer didn't itself move.
             * 
             * Set to 0 to poll constantly. Set to -1 to only poll on user movement.
             */
            pollRate: number;

            /**
             * The distance, in pixels, a pointer has to move while being held down, before it thinks it is being dragged.
             */
            dragDistanceThreshold: number;

            /**
             * The amount of time, in ms, a pointer has to be held down before it thinks it is dragging.
             * 
             * The default polling rate is to poll only on move so once the time threshold is reached the
             * drag event will not start until you move the mouse. If you want it to start immediately
             * when the time threshold is reached, you must increase the polling rate by calling
             * [setPollAlways]{@linkcode Phaser.Input.InputPlugin#setPollAlways} or
             * [setPollRate]{@linkcode Phaser.Input.InputPlugin#setPollRate}.
             */
            dragTimeThreshold: number;

            /**
             * Checks to see if both this plugin and the Scene to which it belongs is active.
             */
            isActive(): boolean;

            /**
             * This is called automatically by the Input Manager.
             * It emits events for plugins to listen to and also handles polling updates, if enabled.
             * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            updatePoll(time: number, delta: number): boolean;

            /**
             * Clears a Game Object so it no longer has an Interactive Object associated with it.
             * The Game Object is then queued for removal from the Input Plugin on the next update.
             * @param gameObject The Game Object that will have its Interactive Object removed.
             * @param skipQueue Skip adding this Game Object into the removal queue? Default false.
             */
            clear(gameObject: Phaser.GameObjects.GameObject, skipQueue?: boolean): Phaser.GameObjects.GameObject;

            /**
             * Disables Input on a single Game Object.
             * 
             * An input disabled Game Object still retains its Interactive Object component and can be re-enabled
             * at any time, by passing it to `InputPlugin.enable`.
             * @param gameObject The Game Object to have its input system disabled.
             */
            disable(gameObject: Phaser.GameObjects.GameObject): this;

            /**
             * Enable a Game Object for interaction.
             * 
             * If the Game Object already has an Interactive Object component, it is enabled and returned.
             * 
             * Otherwise, a new Interactive Object component is created and assigned to the Game Object's `input` property.
             * 
             * Input works by using hit areas, these are nearly always geometric shapes, such as rectangles or circles, that act as the hit area
             * for the Game Object. However, you can provide your own hit area shape and callback, should you wish to handle some more advanced
             * input detection.
             * 
             * If no arguments are provided it will try and create a rectangle hit area based on the texture frame the Game Object is using. If
             * this isn't a texture-bound object, such as a Graphics or BitmapText object, this will fail, and you'll need to provide a specific
             * shape for it to use.
             * 
             * You can also provide an Input Configuration Object as the only argument to this method.
             * @param gameObject The Game Object to be enabled for input.
             * @param hitArea Either an input configuration object, or a geometric shape that defines the hit area for the Game Object. If not specified a Rectangle will be used.
             * @param hitAreaCallback The 'contains' function to invoke to check if the pointer is within the hit area.
             * @param dropZone Is this Game Object a drop zone or not? Default false.
             */
            enable(gameObject: Phaser.GameObjects.GameObject, hitArea?: Phaser.Types.Input.InputConfiguration | any, hitAreaCallback?: Phaser.Types.Input.HitAreaCallback, dropZone?: boolean): this;

            /**
             * Takes the given Pointer and performs a hit test against it, to see which interactive Game Objects
             * it is currently above.
             * 
             * The hit test is performed against which-ever Camera the Pointer is over. If it is over multiple
             * cameras, it starts checking the camera at the top of the camera list, and if nothing is found, iterates down the list.
             * @param pointer The Pointer to check against the Game Objects.
             */
            hitTestPointer(pointer: Phaser.Input.Pointer): Phaser.GameObjects.GameObject[];

            /**
             * Returns the drag state of the given Pointer for this Input Plugin.
             * 
             * The state will be one of the following:
             * 
             * 0 = Not dragging anything
             * 1 = Primary button down and objects below, so collect a draglist
             * 2 = Pointer being checked if meets drag criteria
             * 3 = Pointer meets criteria, notify the draglist
             * 4 = Pointer actively dragging the draglist and has moved
             * 5 = Pointer actively dragging but has been released, notify draglist
             * @param pointer The Pointer to get the drag state for.
             */
            getDragState(pointer: Phaser.Input.Pointer): number;

            /**
             * Sets the drag state of the given Pointer for this Input Plugin.
             * 
             * The state must be one of the following values:
             * 
             * 0 = Not dragging anything
             * 1 = Primary button down and objects below, so collect a draglist
             * 2 = Pointer being checked if meets drag criteria
             * 3 = Pointer meets criteria, notify the draglist
             * 4 = Pointer actively dragging the draglist and has moved
             * 5 = Pointer actively dragging but has been released, notify draglist
             * @param pointer The Pointer to set the drag state for.
             * @param state The drag state value. An integer between 0 and 5.
             */
            setDragState(pointer: Phaser.Input.Pointer, state: number): void;

            /**
             * Sets the draggable state of the given array of Game Objects.
             * 
             * They can either be set to be draggable, or can have their draggable state removed by passing `false`.
             * 
             * A Game Object will not fire drag events unless it has been specifically enabled for drag.
             * @param gameObjects An array of Game Objects to change the draggable state on.
             * @param value Set to `true` if the Game Objects should be made draggable, `false` if they should be unset. Default true.
             */
            setDraggable(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], value?: boolean): this;

            /**
             * Creates a function that can be passed to `setInteractive`, `enable` or `setHitArea` that will handle
             * pixel-perfect input detection on an Image or Sprite based Game Object, or any custom class that extends them.
             * 
             * The following will create a sprite that is clickable on any pixel that has an alpha value >= 1.
             * 
             * ```javascript
             * this.add.sprite(x, y, key).setInteractive(this.input.makePixelPerfect());
             * ```
             * 
             * The following will create a sprite that is clickable on any pixel that has an alpha value >= 150.
             * 
             * ```javascript
             * this.add.sprite(x, y, key).setInteractive(this.input.makePixelPerfect(150));
             * ```
             * 
             * Once you have made an Interactive Object pixel perfect it impacts all input related events for it: down, up,
             * dragstart, drag, etc.
             * 
             * As a pointer interacts with the Game Object it will constantly poll the texture, extracting a single pixel from
             * the given coordinates and checking its color values. This is an expensive process, so should only be enabled on
             * Game Objects that really need it.
             * 
             * You cannot make non-texture based Game Objects pixel perfect. So this will not work on Graphics, BitmapText,
             * Render Textures, Text, Tilemaps, Containers or Particles.
             * @param alphaTolerance The alpha level that the pixel should be above to be included as a successful interaction. Default 1.
             */
            makePixelPerfect(alphaTolerance?: number): Function;

            /**
             * Sets the hit area for the given array of Game Objects.
             * 
             * A hit area is typically one of the geometric shapes Phaser provides, such as a `Phaser.Geom.Rectangle`
             * or `Phaser.Geom.Circle`. However, it can be any object as long as it works with the provided callback.
             * 
             * If no hit area is provided a Rectangle is created based on the size of the Game Object, if possible
             * to calculate.
             * 
             * The hit area callback is the function that takes an `x` and `y` coordinate and returns a boolean if
             * those values fall within the area of the shape or not. All of the Phaser geometry objects provide this,
             * such as `Phaser.Geom.Rectangle.Contains`.
             * @param gameObjects An array of Game Objects to set the hit area on.
             * @param hitArea Either an input configuration object, or a geometric shape that defines the hit area for the Game Object. If not specified a Rectangle will be used.
             * @param hitAreaCallback The 'contains' function to invoke to check if the pointer is within the hit area.
             */
            setHitArea(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], hitArea?: Phaser.Types.Input.InputConfiguration | any, hitAreaCallback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Sets the hit area for an array of Game Objects to be a `Phaser.Geom.Circle` shape, using
             * the given coordinates and radius to control its position and size.
             * @param gameObjects An array of Game Objects to set as having a circle hit area.
             * @param x The center of the circle.
             * @param y The center of the circle.
             * @param radius The radius of the circle.
             * @param callback The hit area callback. If undefined it uses Circle.Contains.
             */
            setHitAreaCircle(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], x: number, y: number, radius: number, callback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Sets the hit area for an array of Game Objects to be a `Phaser.Geom.Ellipse` shape, using
             * the given coordinates and dimensions to control its position and size.
             * @param gameObjects An array of Game Objects to set as having an ellipse hit area.
             * @param x The center of the ellipse.
             * @param y The center of the ellipse.
             * @param width The width of the ellipse.
             * @param height The height of the ellipse.
             * @param callback The hit area callback. If undefined it uses Ellipse.Contains.
             */
            setHitAreaEllipse(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], x: number, y: number, width: number, height: number, callback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Sets the hit area for an array of Game Objects to be a `Phaser.Geom.Rectangle` shape, using
             * the Game Objects texture frame to define the position and size of the hit area.
             * @param gameObjects An array of Game Objects to set as having an ellipse hit area.
             * @param callback The hit area callback. If undefined it uses Rectangle.Contains.
             */
            setHitAreaFromTexture(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], callback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Sets the hit area for an array of Game Objects to be a `Phaser.Geom.Rectangle` shape, using
             * the given coordinates and dimensions to control its position and size.
             * @param gameObjects An array of Game Objects to set as having a rectangular hit area.
             * @param x The top-left of the rectangle.
             * @param y The top-left of the rectangle.
             * @param width The width of the rectangle.
             * @param height The height of the rectangle.
             * @param callback The hit area callback. If undefined it uses Rectangle.Contains.
             */
            setHitAreaRectangle(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], x: number, y: number, width: number, height: number, callback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Sets the hit area for an array of Game Objects to be a `Phaser.Geom.Triangle` shape, using
             * the given coordinates to control the position of its points.
             * @param gameObjects An array of Game Objects to set as having a  triangular hit area.
             * @param x1 The x coordinate of the first point of the triangle.
             * @param y1 The y coordinate of the first point of the triangle.
             * @param x2 The x coordinate of the second point of the triangle.
             * @param y2 The y coordinate of the second point of the triangle.
             * @param x3 The x coordinate of the third point of the triangle.
             * @param y3 The y coordinate of the third point of the triangle.
             * @param callback The hit area callback. If undefined it uses Triangle.Contains.
             */
            setHitAreaTriangle(gameObjects: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[], x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, callback?: Phaser.Types.Input.HitAreaCallback): this;

            /**
             * Creates an Input Debug Shape for the given Game Object.
             * 
             * The Game Object must have _already_ been enabled for input prior to calling this method.
             * 
             * This is intended to assist you during development and debugging.
             * 
             * Debug Shapes can only be created for Game Objects that are using standard Phaser Geometry for input,
             * including: Circle, Ellipse, Line, Polygon, Rectangle and Triangle.
             * 
             * Game Objects that are using their automatic hit areas are using Rectangles by default, so will also work.
             * 
             * The Debug Shape is created and added to the display list and is then kept in sync with the Game Object
             * it is connected with. Should you need to modify it yourself, such as to hide it, you can access it via
             * the Game Object property: `GameObject.input.hitAreaDebug`.
             * 
             * Calling this method on a Game Object that already has a Debug Shape will first destroy the old shape,
             * before creating a new one. If you wish to remove the Debug Shape entirely, you should call the
             * method `InputPlugin.removeDebug`.
             * 
             * Note that the debug shape will only show the outline of the input area. If the input test is using a
             * pixel perfect check, for example, then this is not displayed. If you are using a custom shape, that
             * doesn't extend one of the base Phaser Geometry objects, as your hit area, then this method will not
             * work.
             * @param gameObject The Game Object to create the input debug shape for.
             * @param color The outline color of the debug shape. Default 0x00ff00.
             */
            enableDebug(gameObject: Phaser.GameObjects.GameObject, color?: number): this;

            /**
             * Removes an Input Debug Shape from the given Game Object.
             * 
             * The shape is destroyed immediately and the `hitAreaDebug` property is set to `null`.
             * @param gameObject The Game Object to remove the input debug shape from.
             */
            removeDebug(gameObject: Phaser.GameObjects.GameObject): this;

            /**
             * Sets the Pointers to always poll.
             * 
             * When a pointer is polled it runs a hit test to see which Game Objects are currently below it,
             * or being interacted with it, regardless if the Pointer has actually moved or not.
             * 
             * You should enable this if you want objects in your game to fire over / out events, and the objects
             * are constantly moving, but the pointer may not have. Polling every frame has additional computation
             * costs, especially if there are a large number of interactive objects in your game.
             */
            setPollAlways(): this;

            /**
             * Sets the Pointers to only poll when they are moved or updated.
             * 
             * When a pointer is polled it runs a hit test to see which Game Objects are currently below it,
             * or being interacted with it.
             */
            setPollOnMove(): this;

            /**
             * Sets the poll rate value. This is the amount of time that should have elapsed before a pointer
             * will be polled again. See the `setPollAlways` and `setPollOnMove` methods.
             * @param value The amount of time, in ms, that should elapsed before re-polling the pointers.
             */
            setPollRate(value: number): this;

            /**
             * When set to `true` the global Input Manager will emulate DOM behavior by only emitting events from
             * the top-most Scene in the Scene List. By default, if a Scene receives an input event it will then stop the event
             * from flowing down to any Scenes below it in the Scene list. To disable this behavior call this method with `false`.
             * @param value Set to `true` to stop processing input events on the Scene that receives it, or `false` to let the event continue down the Scene list.
             */
            setGlobalTopOnly(value: boolean): this;

            /**
             * When set to `true` this Input Plugin will emulate DOM behavior by only emitting events from
             * the top-most Game Objects in the Display List.
             * 
             * If set to `false` it will emit events from all Game Objects below a Pointer, not just the top one.
             * @param value `true` to only include the top-most Game Object, or `false` to include all Game Objects in a hit test.
             */
            setTopOnly(value: boolean): this;

            /**
             * Given an array of Game Objects and a Pointer, sort the array and return it,
             * so that the objects are in render order with the lowest at the bottom.
             * @param gameObjects An array of Game Objects to be sorted.
             * @param pointer The Pointer to check against the Game Objects.
             */
            sortGameObjects(gameObjects: Phaser.GameObjects.GameObject[], pointer: Phaser.Input.Pointer): Phaser.GameObjects.GameObject[];

            /**
             * Given an array of Drop Zone Game Objects, sort the array and return it,
             * so that the objects are in depth index order with the lowest at the bottom.
             * @param gameObjects An array of Game Objects to be sorted.
             */
            sortDropZones(gameObjects: Phaser.GameObjects.GameObject[]): Phaser.GameObjects.GameObject[];

            /**
             * This method should be called from within an input event handler, such as `pointerdown`.
             * 
             * When called, it stops the Input Manager from allowing _this specific event_ to be processed by any other Scene
             * not yet handled in the scene list.
             */
            stopPropagation(): this;

            /**
             * Adds new Pointer objects to the Input Manager.
             * 
             * By default Phaser creates 2 pointer objects: `mousePointer` and `pointer1`.
             * 
             * You can create more either by calling this method, or by setting the `input.activePointers` property
             * in the Game Config, up to a maximum of 10 pointers.
             * 
             * The first 10 pointers are available via the `InputPlugin.pointerX` properties, once they have been added
             * via this method.
             * @param quantity The number of new Pointers to create. A maximum of 10 is allowed in total. Default 1.
             */
            addPointer(quantity?: number): Phaser.Input.Pointer[];

            /**
             * Tells the Input system to set a custom cursor.
             * 
             * This cursor will be the default cursor used when interacting with the game canvas.
             * 
             * If an Interactive Object also sets a custom cursor, this is the cursor that is reset after its use.
             * 
             * Any valid CSS cursor value is allowed, including paths to image files, i.e.:
             * 
             * ```javascript
             * this.input.setDefaultCursor('url(assets/cursors/sword.cur), pointer');
             * ```
             * 
             * Please read about the differences between browsers when it comes to the file formats and sizes they support:
             * 
             * https://developer.mozilla.org/en-US/docs/Web/CSS/cursor
             * https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_User_Interface/Using_URL_values_for_the_cursor_property
             * 
             * It's up to you to pick a suitable cursor format that works across the range of browsers you need to support.
             * @param cursor The CSS to be used when setting the default cursor.
             */
            setDefaultCursor(cursor: string): this;

            /**
             * Loops through all of the Input Manager Pointer instances and calls `reset` on them.
             * 
             * Use this function if you find that input has been stolen from Phaser via a 3rd
             * party component, such as Vue, and you need to tell Phaser to reset the Pointer states.
             */
            resetPointers(): void;

            /**
             * The x coordinates of the ActivePointer based on the first camera in the camera list.
             * This is only safe to use if your game has just 1 non-transformed camera and doesn't use multi-touch.
             */
            readonly x: number;

            /**
             * The y coordinates of the ActivePointer based on the first camera in the camera list.
             * This is only safe to use if your game has just 1 non-transformed camera and doesn't use multi-touch.
             */
            readonly y: number;

            /**
             * Are any mouse or touch pointers currently over the game canvas?
             */
            readonly isOver: boolean;

            /**
             * The mouse has its own unique Pointer object, which you can reference directly if making a _desktop specific game_.
             * If you are supporting both desktop and touch devices then do not use this property, instead use `activePointer`
             * which will always map to the most recently interacted pointer.
             */
            readonly mousePointer: Phaser.Input.Pointer;

            /**
             * The current active input Pointer.
             */
            readonly activePointer: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer1: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer2: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer3: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer4: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer5: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer6: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer7: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer8: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer9: Phaser.Input.Pointer;

            /**
             * A touch-based Pointer object.
             * This will be `undefined` by default unless you add a new Pointer using `addPointer`.
             */
            readonly pointer10: Phaser.Input.Pointer;

            /**
             * An instance of the Keyboard Plugin class, if enabled via the `input.keyboard` Scene or Game Config property.
             * Use this to create Key objects and listen for keyboard specific events.
             */
            keyboard: Phaser.Input.Keyboard.KeyboardPlugin | null;

        }

        namespace InputPluginCache {
            /**
             * Static method called directly by the Core internal Plugins.
             * Key is a reference used to get the plugin from the plugins object (i.e. InputPlugin)
             * Plugin is the object to instantiate to create the plugin
             * Mapping is what the plugin is injected into the Scene.Systems as (i.e. input)
             * @param key A reference used to get this plugin from the plugin cache.
             * @param plugin The plugin to be stored. Should be the core object, not instantiated.
             * @param mapping If this plugin is to be injected into the Input Plugin, this is the property key used.
             * @param settingsKey The key in the Scene Settings to check to see if this plugin should install or not.
             * @param configKey The key in the Game Config to check to see if this plugin should install or not.
             */
            function register(key: string, plugin: Function, mapping: string, settingsKey: string, configKey: string): void;

            /**
             * Returns the input plugin object from the cache based on the given key.
             * @param key The key of the input plugin to get.
             */
            function getPlugin(key: string): Phaser.Types.Input.InputPluginContainer;

            /**
             * Installs all of the registered Input Plugins into the given target.
             * @param target The target InputPlugin to install the plugins into.
             */
            function install(target: Phaser.Input.InputPlugin): void;

            /**
             * Removes an input plugin based on the given key.
             * @param key The key of the input plugin to remove.
             */
            function remove(key: string): void;

        }

        namespace Keyboard {
            /**
             * A KeyCombo will listen for a specific string of keys from the Keyboard, and when it receives them
             * it will emit a `keycombomatch` event from the Keyboard Manager.
             * 
             * The keys to be listened for can be defined as:
             * 
             * A string (i.e. 'ATARI')
             * An array of either integers (key codes) or strings, or a mixture of both
             * An array of objects (such as Key objects) with a public 'keyCode' property
             * 
             * For example, to listen for the Konami code (up, up, down, down, left, right, left, right, b, a, enter)
             * you could pass the following array of key codes:
             * 
             * ```javascript
             * this.input.keyboard.createCombo([ 38, 38, 40, 40, 37, 39, 37, 39, 66, 65, 13 ], { resetOnMatch: true });
             * 
             * this.input.keyboard.on('keycombomatch', function (event) {
             *     console.log('Konami Code entered!');
             * });
             * ```
             * 
             * Or, to listen for the user entering the word PHASER:
             * 
             * ```javascript
             * this.input.keyboard.createCombo('PHASER');
             * ```
             */
            class KeyCombo {
                /**
                 * 
                 * @param keyboardPlugin A reference to the Keyboard Plugin.
                 * @param keys The keys that comprise this combo.
                 * @param config A Key Combo configuration object.
                 */
                constructor(keyboardPlugin: Phaser.Input.Keyboard.KeyboardPlugin, keys: string | number[] | object[], config?: Phaser.Types.Input.Keyboard.KeyComboConfig);

                /**
                 * A reference to the Keyboard Manager
                 */
                manager: Phaser.Input.Keyboard.KeyboardPlugin;

                /**
                 * A flag that controls if this Key Combo is actively processing keys or not.
                 */
                enabled: boolean;

                /**
                 * An array of the keycodes that comprise this combo.
                 */
                keyCodes: any[];

                /**
                 * The current keyCode the combo is waiting for.
                 */
                current: number;

                /**
                 * The current index of the key being waited for in the 'keys' string.
                 */
                index: number;

                /**
                 * The length of this combo (in keycodes)
                 */
                size: number;

                /**
                 * The time the previous key in the combo was matched.
                 */
                timeLastMatched: number;

                /**
                 * Has this Key Combo been matched yet?
                 */
                matched: boolean;

                /**
                 * The time the entire combo was matched.
                 */
                timeMatched: number;

                /**
                 * If they press the wrong key do we reset the combo?
                 */
                resetOnWrongKey: boolean;

                /**
                 * The max delay in ms between each key press. Above this the combo is reset. 0 means disabled.
                 */
                maxKeyDelay: number;

                /**
                 * If previously matched and they press the first key of the combo again, will it reset?
                 */
                resetOnMatch: boolean;

                /**
                 * If the combo matches, will it delete itself?
                 */
                deleteOnMatch: boolean;

                /**
                 * How far complete is this combo? A value between 0 and 1.
                 */
                readonly progress: number;

                /**
                 * Destroys this Key Combo and all of its references.
                 */
                destroy(): void;

            }

            namespace Events {
                /**
                 * The Global Key Down Event.
                 * 
                 * This event is dispatched by the Keyboard Plugin when any key on the keyboard is pressed down.
                 * 
                 * Listen to this event from within a Scene using: `this.input.keyboard.on('keydown', listener)`.
                 * 
                 * You can also listen for a specific key being pressed. See [Keyboard.Events.KEY_DOWN]{@linkcode Phaser.Input.Keyboard.Events#event:KEY_DOWN} for details.
                 * 
                 * Finally, you can create Key objects, which you can also listen for events from. See [Keyboard.Events.DOWN]{@linkcode Phaser.Input.Keyboard.Events#event:DOWN} for details.
                 * 
                 * _Note_: Many keyboards are unable to process certain combinations of keys due to hardware limitations known as ghosting.
                 * Read [this article on ghosting]{@link http://www.html5gamedevs.com/topic/4876-impossible-to-use-more-than-2-keyboard-input-buttons-at-the-same-time/} for details.
                 * 
                 * Also, please be aware that some browser extensions can disable or override Phaser keyboard handling.
                 * For example, the Chrome extension vimium is known to disable Phaser from using the D key, while EverNote disables the backtick key.
                 * There are others. So, please check your extensions if you find you have specific keys that don't work.
                 */
                const ANY_KEY_DOWN: string;

                /**
                 * The Global Key Up Event.
                 * 
                 * This event is dispatched by the Keyboard Plugin when any key on the keyboard is released.
                 * 
                 * Listen to this event from within a Scene using: `this.input.keyboard.on('keyup', listener)`.
                 * 
                 * You can also listen for a specific key being released. See [Keyboard.Events.KEY_UP]{@linkcode Phaser.Input.Keyboard.Events#event:KEY_UP} for details.
                 * 
                 * Finally, you can create Key objects, which you can also listen for events from. See [Keyboard.Events.UP]{@linkcode Phaser.Input.Keyboard.Events#event:UP} for details.
                 */
                const ANY_KEY_UP: string;

                /**
                 * The Key Combo Match Event.
                 * 
                 * This event is dispatched by the Keyboard Plugin when a [Key Combo]{@link Phaser.Input.Keyboard.KeyCombo} is matched.
                 * 
                 * Listen for this event from the Key Plugin after a combo has been created:
                 * 
                 * ```javascript
                 * this.input.keyboard.createCombo([ 38, 38, 40, 40, 37, 39, 37, 39, 66, 65, 13 ], { resetOnMatch: true });
                 * 
                 * this.input.keyboard.on('keycombomatch', function (event) {
                 *     console.log('Konami Code entered!');
                 * });
                 * ```
                 */
                const COMBO_MATCH: string;

                /**
                 * The Key Down Event.
                 * 
                 * This event is dispatched by a [Key]{@link Phaser.Input.Keyboard.Key} object when it is pressed.
                 * 
                 * Listen for this event from the Key object instance directly:
                 * 
                 * ```javascript
                 * var spaceBar = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.SPACE);
                 * 
                 * spaceBar.on('down', listener)
                 * ```
                 * 
                 * You can also create a generic 'global' listener. See [Keyboard.Events.ANY_KEY_DOWN]{@linkcode Phaser.Input.Keyboard.Events#event:ANY_KEY_DOWN} for details.
                 */
                const DOWN: string;

                /**
                 * The Key Down Event.
                 * 
                 * This event is dispatched by the Keyboard Plugin when any key on the keyboard is pressed down.
                 * 
                 * Unlike the `ANY_KEY_DOWN` event, this one has a special dynamic event name. For example, to listen for the `A` key being pressed
                 * use the following from within a Scene: `this.input.keyboard.on('keydown-A', listener)`. You can replace the `-A` part of the event
                 * name with any valid [Key Code string]{@link Phaser.Input.Keyboard.KeyCodes}. For example, this will listen for the space bar:
                 * `this.input.keyboard.on('keydown-SPACE', listener)`.
                 * 
                 * You can also create a generic 'global' listener. See [Keyboard.Events.ANY_KEY_DOWN]{@linkcode Phaser.Input.Keyboard.Events#event:ANY_KEY_DOWN} for details.
                 * 
                 * Finally, you can create Key objects, which you can also listen for events from. See [Keyboard.Events.DOWN]{@linkcode Phaser.Input.Keyboard.Events#event:DOWN} for details.
                 * 
                 * _Note_: Many keyboards are unable to process certain combinations of keys due to hardware limitations known as ghosting.
                 * Read [this article on ghosting]{@link http://www.html5gamedevs.com/topic/4876-impossible-to-use-more-than-2-keyboard-input-buttons-at-the-same-time/} for details.
                 * 
                 * Also, please be aware that some browser extensions can disable or override Phaser keyboard handling.
                 * For example, the Chrome extension vimium is known to disable Phaser from using the D key, while EverNote disables the backtick key.
                 * There are others. So, please check your extensions if you find you have specific keys that don't work.
                 */
                const KEY_DOWN: string;

                /**
                 * The Key Up Event.
                 * 
                 * This event is dispatched by the Keyboard Plugin when any key on the keyboard is released.
                 * 
                 * Unlike the `ANY_KEY_UP` event, this one has a special dynamic event name. For example, to listen for the `A` key being released
                 * use the following from within a Scene: `this.input.keyboard.on('keyup-A', listener)`. You can replace the `-A` part of the event
                 * name with any valid [Key Code string]{@link Phaser.Input.Keyboard.KeyCodes}. For example, this will listen for the space bar:
                 * `this.input.keyboard.on('keyup-SPACE', listener)`.
                 * 
                 * You can also create a generic 'global' listener. See [Keyboard.Events.ANY_KEY_UP]{@linkcode Phaser.Input.Keyboard.Events#event:ANY_KEY_UP} for details.
                 * 
                 * Finally, you can create Key objects, which you can also listen for events from. See [Keyboard.Events.UP]{@linkcode Phaser.Input.Keyboard.Events#event:UP} for details.
                 */
                const KEY_UP: string;

                /**
                 * The Key Up Event.
                 * 
                 * This event is dispatched by a [Key]{@link Phaser.Input.Keyboard.Key} object when it is released.
                 * 
                 * Listen for this event from the Key object instance directly:
                 * 
                 * ```javascript
                 * var spaceBar = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.SPACE);
                 * 
                 * spaceBar.on('up', listener)
                 * ```
                 * 
                 * You can also create a generic 'global' listener. See [Keyboard.Events.ANY_KEY_UP]{@linkcode Phaser.Input.Keyboard.Events#event:ANY_KEY_UP} for details.
                 */
                const UP: string;

            }

            /**
             * The Keyboard Manager is a helper class that belongs to the global Input Manager.
             * 
             * Its role is to listen for native DOM Keyboard Events and then store them for further processing by the Keyboard Plugin.
             * 
             * You do not need to create this class directly, the Input Manager will create an instance of it automatically if keyboard
             * input has been enabled in the Game Config.
             */
            class KeyboardManager {
                /**
                 * 
                 * @param inputManager A reference to the Input Manager.
                 */
                constructor(inputManager: Phaser.Input.InputManager);

                /**
                 * A reference to the Input Manager.
                 */
                manager: Phaser.Input.InputManager;

                /**
                 * A flag that controls if the non-modified keys, matching those stored in the `captures` array,
                 * have `preventDefault` called on them or not.
                 * 
                 * A non-modified key is one that doesn't have a modifier key held down with it. The modifier keys are
                 * shift, control, alt and the meta key (Command on a Mac, the Windows Key on Windows).
                 * Therefore, if the user presses shift + r, it won't prevent this combination, because of the modifier.
                 * However, if the user presses just the r key on its own, it will have its event prevented.
                 * 
                 * If you wish to stop capturing the keys, for example switching out to a DOM based element, then
                 * you can toggle this property at run-time.
                 */
                preventDefault: boolean;

                /**
                 * An array of Key Code values that will automatically have `preventDefault` called on them,
                 * as long as the `KeyboardManager.preventDefault` boolean is set to `true`.
                 * 
                 * By default the array is empty.
                 * 
                 * The key must be non-modified when pressed in order to be captured.
                 * 
                 * A non-modified key is one that doesn't have a modifier key held down with it. The modifier keys are
                 * shift, control, alt and the meta key (Command on a Mac, the Windows Key on Windows).
                 * Therefore, if the user presses shift + r, it won't prevent this combination, because of the modifier.
                 * However, if the user presses just the r key on its own, it will have its event prevented.
                 * 
                 * If you wish to stop capturing the keys, for example switching out to a DOM based element, then
                 * you can toggle the `KeyboardManager.preventDefault` boolean at run-time.
                 * 
                 * If you need more specific control, you can create Key objects and set the flag on each of those instead.
                 * 
                 * This array can be populated via the Game Config by setting the `input.keyboard.capture` array, or you
                 * can call the `addCapture` method. See also `removeCapture` and `clearCaptures`.
                 */
                captures: number[];

                /**
                 * A boolean that controls if the Keyboard Manager is enabled or not.
                 * Can be toggled on the fly.
                 */
                enabled: boolean;

                /**
                 * The Keyboard Event target, as defined in the Game Config.
                 * Typically the window in which the game is rendering, but can be any interactive DOM element.
                 */
                target: any;

                /**
                 * The Key Down Event handler.
                 * This function is sent the native DOM KeyEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onKeyDown: Function;

                /**
                 * The Key Up Event handler.
                 * This function is sent the native DOM KeyEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onKeyUp: Function;

                /**
                 * Starts the Keyboard Event listeners running.
                 * This is called automatically and does not need to be manually invoked.
                 */
                startListeners(): void;

                /**
                 * Stops the Key Event listeners.
                 * This is called automatically and does not need to be manually invoked.
                 */
                stopListeners(): void;

                /**
                 * By default when a key is pressed Phaser will not stop the event from propagating up to the browser.
                 * There are some keys this can be annoying for, like the arrow keys or space bar, which make the browser window scroll.
                 * 
                 * This `addCapture` method enables consuming keyboard event for specific keys so it doesn't bubble up to the the browser
                 * and cause the default browser behavior.
                 * 
                 * Please note that keyboard captures are global. This means that if you call this method from within a Scene, to say prevent
                 * the SPACE BAR from triggering a page scroll, then it will prevent it for any Scene in your game, not just the calling one.
                 * 
                 * You can pass in a single key code value, or an array of key codes, or a string:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture(62);
                 * ```
                 * 
                 * An array of key codes:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture([ 62, 63, 64 ]);
                 * ```
                 * 
                 * Or a string:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture('W,S,A,D');
                 * ```
                 * 
                 * To use non-alpha numeric keys, use a string, such as 'UP', 'SPACE' or 'LEFT'.
                 * 
                 * You can also provide an array mixing both strings and key code integers.
                 * 
                 * If there are active captures after calling this method, the `preventDefault` property is set to `true`.
                 * @param keycode The Key Codes to enable capture for, preventing them reaching the browser.
                 */
                addCapture(keycode: string | number | number[] | any[]): void;

                /**
                 * Removes an existing key capture.
                 * 
                 * Please note that keyboard captures are global. This means that if you call this method from within a Scene, to remove
                 * the capture of a key, then it will remove it for any Scene in your game, not just the calling one.
                 * 
                 * You can pass in a single key code value, or an array of key codes, or a string:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture(62);
                 * ```
                 * 
                 * An array of key codes:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture([ 62, 63, 64 ]);
                 * ```
                 * 
                 * Or a string:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture('W,S,A,D');
                 * ```
                 * 
                 * To use non-alpha numeric keys, use a string, such as 'UP', 'SPACE' or 'LEFT'.
                 * 
                 * You can also provide an array mixing both strings and key code integers.
                 * 
                 * If there are no captures left after calling this method, the `preventDefault` property is set to `false`.
                 * @param keycode The Key Codes to disable capture for, allowing them reaching the browser again.
                 */
                removeCapture(keycode: string | number | number[] | any[]): void;

                /**
                 * Removes all keyboard captures and sets the `preventDefault` property to `false`.
                 */
                clearCaptures(): void;

                /**
                 * Destroys this Keyboard Manager instance.
                 */
                destroy(): void;

            }

            /**
             * The Keyboard Plugin is an input plugin that belongs to the Scene-owned Input system.
             * 
             * Its role is to listen for native DOM Keyboard Events and then process them.
             * 
             * You do not need to create this class directly, the Input system will create an instance of it automatically.
             * 
             * You can access it from within a Scene using `this.input.keyboard`. For example, you can do:
             * 
             * ```javascript
             * this.input.keyboard.on('keydown', callback, context);
             * ```
             * 
             * Or, to listen for a specific key:
             * 
             * ```javascript
             * this.input.keyboard.on('keydown-A', callback, context);
             * ```
             * 
             * You can also create Key objects, which you can then poll in your game loop:
             * 
             * ```javascript
             * var spaceBar = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.SPACE);
             * ```
             * 
             * If you have multiple parallel Scenes, each trying to get keyboard input, be sure to disable capture on them to stop them from
             * stealing input from another Scene in the list. You can do this with `this.input.keyboard.enabled = false` within the
             * Scene to stop all input, or `this.input.keyboard.preventDefault = false` to stop a Scene halting input on another Scene.
             * 
             * _Note_: Many keyboards are unable to process certain combinations of keys due to hardware limitations known as ghosting.
             * See http://www.html5gamedevs.com/topic/4876-impossible-to-use-more-than-2-keyboard-input-buttons-at-the-same-time/ for more details
             * and use the site https://w3c.github.io/uievents/tools/key-event-viewer.html to test your n-key support in browser.
             * 
             * Also please be aware that certain browser extensions can disable or override Phaser keyboard handling.
             * For example the Chrome extension vimium is known to disable Phaser from using the D key, while EverNote disables the backtick key.
             * And there are others. So, please check your extensions before opening Phaser issues about keys that don't work.
             */
            class KeyboardPlugin extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param sceneInputPlugin A reference to the Scene Input Plugin that the KeyboardPlugin belongs to.
                 */
                constructor(sceneInputPlugin: Phaser.Input.InputPlugin);

                /**
                 * A reference to the core game, so we can listen for visibility events.
                 */
                game: Phaser.Game;

                /**
                 * A reference to the Scene that this Input Plugin is responsible for.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene Systems Settings.
                 */
                settings: Phaser.Types.Scenes.SettingsObject;

                /**
                 * A reference to the Scene Input Plugin that created this Keyboard Plugin.
                 */
                sceneInputPlugin: Phaser.Input.InputPlugin;

                /**
                 * A reference to the global Keyboard Manager.
                 */
                manager: Phaser.Input.Keyboard.KeyboardManager;

                /**
                 * A boolean that controls if this Keyboard Plugin is enabled or not.
                 * Can be toggled on the fly.
                 */
                enabled: boolean;

                /**
                 * An array of Key objects to process.
                 */
                keys: Phaser.Input.Keyboard.Key[];

                /**
                 * An array of KeyCombo objects to process.
                 */
                combos: Phaser.Input.Keyboard.KeyCombo[];

                /**
                 * Checks to see if both this plugin and the Scene to which it belongs is active.
                 */
                isActive(): boolean;

                /**
                 * By default when a key is pressed Phaser will not stop the event from propagating up to the browser.
                 * There are some keys this can be annoying for, like the arrow keys or space bar, which make the browser window scroll.
                 * 
                 * This `addCapture` method enables consuming keyboard events for specific keys, so they don't bubble up the browser
                 * and cause the default behaviors.
                 * 
                 * Please note that keyboard captures are global. This means that if you call this method from within a Scene, to say prevent
                 * the SPACE BAR from triggering a page scroll, then it will prevent it for any Scene in your game, not just the calling one.
                 * 
                 * You can pass a single key code value:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture(62);
                 * ```
                 * 
                 * An array of key codes:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture([ 62, 63, 64 ]);
                 * ```
                 * 
                 * Or, a comma-delimited string:
                 * 
                 * ```javascript
                 * this.input.keyboard.addCapture('W,S,A,D');
                 * ```
                 * 
                 * To use non-alpha numeric keys, use a string, such as 'UP', 'SPACE' or 'LEFT'.
                 * 
                 * You can also provide an array mixing both strings and key code integers.
                 * @param keycode The Key Codes to enable event capture for.
                 */
                addCapture(keycode: string | number | number[] | any[]): this;

                /**
                 * Removes an existing key capture.
                 * 
                 * Please note that keyboard captures are global. This means that if you call this method from within a Scene, to remove
                 * the capture of a key, then it will remove it for any Scene in your game, not just the calling one.
                 * 
                 * You can pass a single key code value:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture(62);
                 * ```
                 * 
                 * An array of key codes:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture([ 62, 63, 64 ]);
                 * ```
                 * 
                 * Or, a comma-delimited string:
                 * 
                 * ```javascript
                 * this.input.keyboard.removeCapture('W,S,A,D');
                 * ```
                 * 
                 * To use non-alpha numeric keys, use a string, such as 'UP', 'SPACE' or 'LEFT'.
                 * 
                 * You can also provide an array mixing both strings and key code integers.
                 * @param keycode The Key Codes to disable event capture for.
                 */
                removeCapture(keycode: string | number | number[] | any[]): this;

                /**
                 * Returns an array that contains all of the keyboard captures currently enabled.
                 */
                getCaptures(): number[];

                /**
                 * Allows Phaser to prevent any key captures you may have defined from bubbling up the browser.
                 * You can use this to re-enable event capturing if you had paused it via `disableGlobalCapture`.
                 */
                enableGlobalCapture(): this;

                /**
                 * Disables Phaser from preventing any key captures you may have defined, without actually removing them.
                 * You can use this to temporarily disable event capturing if, for example, you swap to a DOM element.
                 */
                disableGlobalCapture(): this;

                /**
                 * Removes all keyboard captures.
                 * 
                 * Note that this is a global change. It will clear all event captures across your game, not just for this specific Scene.
                 */
                clearCaptures(): this;

                /**
                 * Creates and returns an object containing 4 hotkeys for Up, Down, Left and Right, and also Space Bar and shift.
                 */
                createCursorKeys(): Phaser.Types.Input.Keyboard.CursorKeys;

                /**
                 * A practical way to create an object containing user selected hotkeys.
                 * 
                 * For example:
                 * 
                 * ```javascript
                 * this.input.keyboard.addKeys({ 'up': Phaser.Input.Keyboard.KeyCodes.W, 'down': Phaser.Input.Keyboard.KeyCodes.S });
                 * ```
                 * 
                 * would return an object containing the properties (`up` and `down`) mapped to W and S {@link Phaser.Input.Keyboard.Key} objects.
                 * 
                 * You can also pass in a comma-separated string:
                 * 
                 * ```javascript
                 * this.input.keyboard.addKeys('W,S,A,D');
                 * ```
                 * 
                 * Which will return an object with the properties W, S, A and D mapped to the relevant Key objects.
                 * 
                 * To use non-alpha numeric keys, use a string, such as 'UP', 'SPACE' or 'LEFT'.
                 * @param keys An object containing Key Codes, or a comma-separated string.
                 * @param enableCapture Automatically call `preventDefault` on the native DOM browser event for the key codes being added. Default true.
                 * @param emitOnRepeat Controls if the Key will continuously emit a 'down' event while being held down (true), or emit the event just once (false, the default). Default false.
                 */
                addKeys(keys: object | string, enableCapture?: boolean, emitOnRepeat?: boolean): object;

                /**
                 * Adds a Key object to this Keyboard Plugin.
                 * 
                 * The given argument can be either an existing Key object, a string, such as `A` or `SPACE`, or a key code value.
                 * 
                 * If a Key object is given, and one already exists matching the same key code, the existing one is replaced with the new one.
                 * @param key Either a Key object, a string, such as `A` or `SPACE`, or a key code value.
                 * @param enableCapture Automatically call `preventDefault` on the native DOM browser event for the key codes being added. Default true.
                 * @param emitOnRepeat Controls if the Key will continuously emit a 'down' event while being held down (true), or emit the event just once (false, the default). Default false.
                 */
                addKey(key: Phaser.Input.Keyboard.Key | string | number, enableCapture?: boolean, emitOnRepeat?: boolean): Phaser.Input.Keyboard.Key;

                /**
                 * Removes a Key object from this Keyboard Plugin.
                 * 
                 * The given argument can be either a Key object, a string, such as `A` or `SPACE`, or a key code value.
                 * @param key Either a Key object, a string, such as `A` or `SPACE`, or a key code value.
                 * @param destroy Call `Key.destroy` on the removed Key object? Default false.
                 * @param removeCapture Remove this Key from being captured? Only applies if set to capture when created. Default false.
                 */
                removeKey(key: Phaser.Input.Keyboard.Key | string | number, destroy?: boolean, removeCapture?: boolean): this;

                /**
                 * Removes all Key objects created by _this_ Keyboard Plugin.
                 * @param destroy Call `Key.destroy` on each removed Key object? Default false.
                 * @param removeCapture Remove all key captures for Key objects owened by this plugin? Default false.
                 */
                removeAllKeys(destroy?: boolean, removeCapture?: boolean): this;

                /**
                 * Creates a new KeyCombo.
                 * 
                 * A KeyCombo will listen for a specific string of keys from the Keyboard, and when it receives them
                 * it will emit a `keycombomatch` event from this Keyboard Plugin.
                 * 
                 * The keys to be listened for can be defined as:
                 * 
                 * A string (i.e. 'ATARI')
                 * An array of either integers (key codes) or strings, or a mixture of both
                 * An array of objects (such as Key objects) with a public 'keyCode' property
                 * 
                 * For example, to listen for the Konami code (up, up, down, down, left, right, left, right, b, a, enter)
                 * you could pass the following array of key codes:
                 * 
                 * ```javascript
                 * this.input.keyboard.createCombo([ 38, 38, 40, 40, 37, 39, 37, 39, 66, 65, 13 ], { resetOnMatch: true });
                 * 
                 * this.input.keyboard.on('keycombomatch', function (event) {
                 *     console.log('Konami Code entered!');
                 * });
                 * ```
                 * 
                 * Or, to listen for the user entering the word PHASER:
                 * 
                 * ```javascript
                 * this.input.keyboard.createCombo('PHASER');
                 * ```
                 * @param keys The keys that comprise this combo.
                 * @param config A Key Combo configuration object.
                 */
                createCombo(keys: string | number[] | object[], config?: Phaser.Types.Input.Keyboard.KeyComboConfig): Phaser.Input.Keyboard.KeyCombo;

                /**
                 * Checks if the given Key object is currently being held down.
                 * 
                 * The difference between this method and checking the `Key.isDown` property directly is that you can provide
                 * a duration to this method. For example, if you wanted a key press to fire a bullet, but you only wanted
                 * it to be able to fire every 100ms, then you can call this method with a `duration` of 100 and it
                 * will only return `true` every 100ms.
                 * 
                 * If the Keyboard Plugin has been disabled, this method will always return `false`.
                 * @param key A Key object.
                 * @param duration The duration which must have elapsed before this Key is considered as being down. Default 0.
                 */
                checkDown(key: Phaser.Input.Keyboard.Key, duration?: number): boolean;

                /**
                 * Resets all Key objects created by _this_ Keyboard Plugin back to their default un-pressed states.
                 * This can only reset keys created via the `addKey`, `addKeys` or `createCursorKeys` methods.
                 * If you have created a Key object directly you'll need to reset it yourself.
                 * 
                 * This method is called automatically when the Keyboard Plugin shuts down, but can be
                 * invoked directly at any time you require.
                 */
                resetKeys(): this;

            }

            /**
             * Returns `true` if the Key was pressed down within the `duration` value given, based on the current
             * game clock time. Or `false` if it either isn't down, or was pressed down longer ago than the given duration.
             * @param key The Key object to test.
             * @param duration The duration, in ms, within which the key must have been pressed down. Default 50.
             */
            function DownDuration(key: Phaser.Input.Keyboard.Key, duration?: number): boolean;

            /**
             * The justDown value allows you to test if this Key has just been pressed down or not.
             * 
             * When you check this value it will return `true` if the Key is down, otherwise `false`.
             * 
             * You can only call justDown once per key press. It will only return `true` once, until the Key is released and pressed down again.
             * This allows you to use it in situations where you want to check if this key is down without using an event, such as in a core game loop.
             * @param key The Key to check to see if it's just down or not.
             */
            function JustDown(key: Phaser.Input.Keyboard.Key): boolean;

            /**
             * The justUp value allows you to test if this Key has just been released or not.
             * 
             * When you check this value it will return `true` if the Key is up, otherwise `false`.
             * 
             * You can only call JustUp once per key release. It will only return `true` once, until the Key is pressed down and released again.
             * This allows you to use it in situations where you want to check if this key is up without using an event, such as in a core game loop.
             * @param key The Key to check to see if it's just up or not.
             */
            function JustUp(key: Phaser.Input.Keyboard.Key): boolean;

            /**
             * A generic Key object which can be passed to the Process functions (and so on)
             * keycode must be an integer
             */
            class Key extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param plugin The Keyboard Plugin instance that owns this Key object.
                 * @param keyCode The keycode of this key.
                 */
                constructor(plugin: Phaser.Input.Keyboard.KeyboardPlugin, keyCode: number);

                /**
                 * The Keyboard Plugin instance that owns this Key object.
                 */
                plugin: Phaser.Input.Keyboard.KeyboardPlugin;

                /**
                 * The keycode of this key.
                 */
                keyCode: number;

                /**
                 * The original DOM event.
                 */
                originalEvent: KeyboardEvent;

                /**
                 * Can this Key be processed?
                 */
                enabled: boolean;

                /**
                 * The "down" state of the key. This will remain `true` for as long as the keyboard thinks this key is held down.
                 */
                isDown: boolean;

                /**
                 * The "up" state of the key. This will remain `true` for as long as the keyboard thinks this key is up.
                 */
                isUp: boolean;

                /**
                 * The down state of the ALT key, if pressed at the same time as this key.
                 */
                altKey: boolean;

                /**
                 * The down state of the CTRL key, if pressed at the same time as this key.
                 */
                ctrlKey: boolean;

                /**
                 * The down state of the SHIFT key, if pressed at the same time as this key.
                 */
                shiftKey: boolean;

                /**
                 * The down state of the Meta key, if pressed at the same time as this key.
                 * On a Mac the Meta Key is the Command key. On Windows keyboards, it's the Windows key.
                 */
                metaKey: boolean;

                /**
                 * The location of the modifier key. 0 for standard (or unknown), 1 for left, 2 for right, 3 for numpad.
                 */
                location: number;

                /**
                 * The timestamp when the key was last pressed down.
                 */
                timeDown: number;

                /**
                 * The number of milliseconds this key was held down for in the previous down - up sequence.
                 * This value isn't updated every game step, only when the Key changes state.
                 * To get the current duration use the `getDuration` method.
                 */
                duration: number;

                /**
                 * The timestamp when the key was last released.
                 */
                timeUp: number;

                /**
                 * When a key is held down should it continuously fire the `down` event each time it repeats?
                 * 
                 * By default it will emit the `down` event just once, but if you wish to receive the event
                 * for each repeat as well, enable this property.
                 */
                emitOnRepeat: boolean;

                /**
                 * If a key is held down this holds down the number of times the key has 'repeated'.
                 */
                repeats: number;

                /**
                 * Controls if this Key will continuously emit a `down` event while being held down (true),
                 * or emit the event just once, on first press, and then skip future events (false).
                 * @param value Emit `down` events on repeated key down actions, or just once?
                 */
                setEmitOnRepeat(value: boolean): this;

                /**
                 * Processes the Key Down action for this Key.
                 * Called automatically by the Keyboard Plugin.
                 * @param event The native DOM Keyboard event.
                 */
                onDown(event: KeyboardEvent): void;

                /**
                 * Processes the Key Up action for this Key.
                 * Called automatically by the Keyboard Plugin.
                 * @param event The native DOM Keyboard event.
                 */
                onUp(event: KeyboardEvent): void;

                /**
                 * Resets this Key object back to its default un-pressed state.
                 * 
                 * As of version 3.60.0 it no longer resets the `enabled` or `preventDefault` flags.
                 */
                reset(): this;

                /**
                 * Returns the duration, in ms, that the Key has been held down for.
                 * 
                 * If the key is not currently down it will return zero.
                 * 
                 * To get the duration the Key was held down for in the previous up-down cycle,
                 * use the `Key.duration` property value instead.
                 */
                getDuration(): number;

                /**
                 * Removes any bound event handlers and removes local references.
                 */
                destroy(): void;

            }

            /**
             * Keyboard Codes.
             */
            namespace KeyCodes {
                /**
                 * The BACKSPACE key.
                 */
                var BACKSPACE: number;

                /**
                 * The TAB key.
                 */
                var TAB: number;

                /**
                 * The ENTER key.
                 */
                var ENTER: number;

                /**
                 * The SHIFT key.
                 */
                var SHIFT: number;

                /**
                 * The CTRL key.
                 */
                var CTRL: number;

                /**
                 * The ALT key.
                 */
                var ALT: number;

                /**
                 * The PAUSE key.
                 */
                var PAUSE: number;

                /**
                 * The CAPS_LOCK key.
                 */
                var CAPS_LOCK: number;

                /**
                 * The ESC key.
                 */
                var ESC: number;

                /**
                 * The SPACE key.
                 */
                var SPACE: number;

                /**
                 * The PAGE_UP key.
                 */
                var PAGE_UP: number;

                /**
                 * The PAGE_DOWN key.
                 */
                var PAGE_DOWN: number;

                /**
                 * The END key.
                 */
                var END: number;

                /**
                 * The HOME key.
                 */
                var HOME: number;

                /**
                 * The LEFT key.
                 */
                var LEFT: number;

                /**
                 * The UP key.
                 */
                var UP: number;

                /**
                 * The RIGHT key.
                 */
                var RIGHT: number;

                /**
                 * The DOWN key.
                 */
                var DOWN: number;

                /**
                 * The PRINT_SCREEN key.
                 */
                var PRINT_SCREEN: number;

                /**
                 * The INSERT key.
                 */
                var INSERT: number;

                /**
                 * The DELETE key.
                 */
                var DELETE: number;

                /**
                 * The ZERO key.
                 */
                var ZERO: number;

                /**
                 * The ONE key.
                 */
                var ONE: number;

                /**
                 * The TWO key.
                 */
                var TWO: number;

                /**
                 * The THREE key.
                 */
                var THREE: number;

                /**
                 * The FOUR key.
                 */
                var FOUR: number;

                /**
                 * The FIVE key.
                 */
                var FIVE: number;

                /**
                 * The SIX key.
                 */
                var SIX: number;

                /**
                 * The SEVEN key.
                 */
                var SEVEN: number;

                /**
                 * The EIGHT key.
                 */
                var EIGHT: number;

                /**
                 * The NINE key.
                 */
                var NINE: number;

                /**
                 * The NUMPAD_ZERO key.
                 */
                var NUMPAD_ZERO: number;

                /**
                 * The NUMPAD_ONE key.
                 */
                var NUMPAD_ONE: number;

                /**
                 * The NUMPAD_TWO key.
                 */
                var NUMPAD_TWO: number;

                /**
                 * The NUMPAD_THREE key.
                 */
                var NUMPAD_THREE: number;

                /**
                 * The NUMPAD_FOUR key.
                 */
                var NUMPAD_FOUR: number;

                /**
                 * The NUMPAD_FIVE key.
                 */
                var NUMPAD_FIVE: number;

                /**
                 * The NUMPAD_SIX key.
                 */
                var NUMPAD_SIX: number;

                /**
                 * The NUMPAD_SEVEN key.
                 */
                var NUMPAD_SEVEN: number;

                /**
                 * The NUMPAD_EIGHT key.
                 */
                var NUMPAD_EIGHT: number;

                /**
                 * The NUMPAD_NINE key.
                 */
                var NUMPAD_NINE: number;

                /**
                 * The Numpad Addition (+) key.
                 */
                var NUMPAD_ADD: number;

                /**
                 * The Numpad Subtraction (-) key.
                 */
                var NUMPAD_SUBTRACT: number;

                /**
                 * The A key.
                 */
                var A: number;

                /**
                 * The B key.
                 */
                var B: number;

                /**
                 * The C key.
                 */
                var C: number;

                /**
                 * The D key.
                 */
                var D: number;

                /**
                 * The E key.
                 */
                var E: number;

                /**
                 * The F key.
                 */
                var F: number;

                /**
                 * The G key.
                 */
                var G: number;

                /**
                 * The H key.
                 */
                var H: number;

                /**
                 * The I key.
                 */
                var I: number;

                /**
                 * The J key.
                 */
                var J: number;

                /**
                 * The K key.
                 */
                var K: number;

                /**
                 * The L key.
                 */
                var L: number;

                /**
                 * The M key.
                 */
                var M: number;

                /**
                 * The N key.
                 */
                var N: number;

                /**
                 * The O key.
                 */
                var O: number;

                /**
                 * The P key.
                 */
                var P: number;

                /**
                 * The Q key.
                 */
                var Q: number;

                /**
                 * The R key.
                 */
                var R: number;

                /**
                 * The S key.
                 */
                var S: number;

                /**
                 * The T key.
                 */
                var T: number;

                /**
                 * The U key.
                 */
                var U: number;

                /**
                 * The V key.
                 */
                var V: number;

                /**
                 * The W key.
                 */
                var W: number;

                /**
                 * The X key.
                 */
                var X: number;

                /**
                 * The Y key.
                 */
                var Y: number;

                /**
                 * The Z key.
                 */
                var Z: number;

                /**
                 * The F1 key.
                 */
                var F1: number;

                /**
                 * The F2 key.
                 */
                var F2: number;

                /**
                 * The F3 key.
                 */
                var F3: number;

                /**
                 * The F4 key.
                 */
                var F4: number;

                /**
                 * The F5 key.
                 */
                var F5: number;

                /**
                 * The F6 key.
                 */
                var F6: number;

                /**
                 * The F7 key.
                 */
                var F7: number;

                /**
                 * The F8 key.
                 */
                var F8: number;

                /**
                 * The F9 key.
                 */
                var F9: number;

                /**
                 * The F10 key.
                 */
                var F10: number;

                /**
                 * The F11 key.
                 */
                var F11: number;

                /**
                 * The F12 key.
                 */
                var F12: number;

                /**
                 * The SEMICOLON key.
                 */
                var SEMICOLON: number;

                /**
                 * The PLUS key.
                 */
                var PLUS: number;

                /**
                 * The COMMA key.
                 */
                var COMMA: number;

                /**
                 * The MINUS key.
                 */
                var MINUS: number;

                /**
                 * The PERIOD key.
                 */
                var PERIOD: number;

                /**
                 * The FORWARD_SLASH key.
                 */
                var FORWARD_SLASH: number;

                /**
                 * The BACK_SLASH key.
                 */
                var BACK_SLASH: number;

                /**
                 * The QUOTES key.
                 */
                var QUOTES: number;

                /**
                 * The BACKTICK key.
                 */
                var BACKTICK: number;

                /**
                 * The OPEN_BRACKET key.
                 */
                var OPEN_BRACKET: number;

                /**
                 * The CLOSED_BRACKET key.
                 */
                var CLOSED_BRACKET: number;

                /**
                 * The SEMICOLON_FIREFOX key.
                 */
                var SEMICOLON_FIREFOX: number;

                /**
                 * The COLON key.
                 */
                var COLON: number;

                /**
                 * The COMMA_FIREFOX_WINDOWS key.
                 */
                var COMMA_FIREFOX_WINDOWS: number;

                /**
                 * The COMMA_FIREFOX key.
                 */
                var COMMA_FIREFOX: number;

                /**
                 * The BRACKET_RIGHT_FIREFOX key.
                 */
                var BRACKET_RIGHT_FIREFOX: number;

                /**
                 * The BRACKET_LEFT_FIREFOX key.
                 */
                var BRACKET_LEFT_FIREFOX: number;

            }

            /**
             * Returns `true` if the Key was released within the `duration` value given, based on the current
             * game clock time. Or returns `false` if it either isn't up, or was released longer ago than the given duration.
             * @param key The Key object to test.
             * @param duration The duration, in ms, within which the key must have been released. Default 50.
             */
            function UpDuration(key: Phaser.Input.Keyboard.Key, duration?: number): boolean;

        }

        namespace Mouse {
            /**
             * The Mouse Manager is a helper class that belongs to the Input Manager.
             * 
             * Its role is to listen for native DOM Mouse Events and then pass them onto the Input Manager for further processing.
             * 
             * You do not need to create this class directly, the Input Manager will create an instance of it automatically.
             */
            class MouseManager {
                /**
                 * 
                 * @param inputManager A reference to the Input Manager.
                 */
                constructor(inputManager: Phaser.Input.InputManager);

                /**
                 * A reference to the Input Manager.
                 */
                manager: Phaser.Input.InputManager;

                /**
                 * If `true` the DOM `mousedown` event will have `preventDefault` set.
                 */
                preventDefaultDown: boolean;

                /**
                 * If `true` the DOM `mouseup` event will have `preventDefault` set.
                 */
                preventDefaultUp: boolean;

                /**
                 * If `true` the DOM `mousemove` event will have `preventDefault` set.
                 */
                preventDefaultMove: boolean;

                /**
                 * If `true` the DOM `wheel` event will have `preventDefault` set.
                 */
                preventDefaultWheel: boolean;

                /**
                 * A boolean that controls if the Mouse Manager is enabled or not.
                 * Can be toggled on the fly.
                 */
                enabled: boolean;

                /**
                 * The Mouse target, as defined in the Game Config.
                 * Typically the canvas to which the game is rendering, but can be any interactive DOM element.
                 */
                target: any;

                /**
                 * If the mouse has been pointer locked successfully this will be set to true.
                 */
                locked: boolean;

                /**
                 * The Mouse Move Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseMove: Function;

                /**
                 * The Mouse Down Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseDown: Function;

                /**
                 * The Mouse Up Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseUp: Function;

                /**
                 * The Mouse Down Event handler specifically for events on the Window.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseDownWindow: Function;

                /**
                 * The Mouse Up Event handler specifically for events on the Window.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseUpWindow: Function;

                /**
                 * The Mouse Over Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseOver: Function;

                /**
                 * The Mouse Out Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseOut: Function;

                /**
                 * The Mouse Wheel Event handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onMouseWheel: Function;

                /**
                 * Internal pointerLockChange handler.
                 * This function is sent the native DOM MouseEvent.
                 * Initially empty and bound in the `startListeners` method.
                 */
                pointerLockChange: Function;

                /**
                 * Are the event listeners hooked into `window.top` or `window`?
                 * 
                 * This is set during the `boot` sequence. If the browser does not have access to `window.top`,
                 * such as in cross-origin iframe environments, this property gets set to `false` and the events
                 * are hooked into `window` instead.
                 */
                readonly isTop: boolean;

                /**
                 * Attempts to disable the context menu from appearing if you right-click on the game canvas, or specified input target.
                 * 
                 * Works by listening for the `contextmenu` event and prevent defaulting it.
                 * 
                 * Use this if you need to enable right-button mouse support in your game, and the context
                 * menu keeps getting in the way.
                 */
                disableContextMenu(): this;

                /**
                 * If the browser supports it, you can request that the pointer be locked to the browser window.
                 * 
                 * This is classically known as 'FPS controls', where the pointer can't leave the browser until
                 * the user presses an exit key.
                 * 
                 * If the browser successfully enters a locked state, a `POINTER_LOCK_CHANGE_EVENT` will be dispatched,
                 * from the games Input Manager, with an `isPointerLocked` property.
                 * 
                 * It is important to note that pointer lock can only be enabled after an 'engagement gesture',
                 * see: https://w3c.github.io/pointerlock/#dfn-engagement-gesture.
                 * 
                 * Note for Firefox: There is a bug in certain Firefox releases that cause native DOM events like
                 * `mousemove` to fire continuously when in pointer lock mode. You can get around this by setting
                 * `this.preventDefaultMove` to `false` in this class. You may also need to do the same for
                 * `preventDefaultDown` and/or `preventDefaultUp`. Please test combinations of these if you encounter
                 * the error.
                 */
                requestPointerLock(): void;

                /**
                 * If the browser supports pointer lock, this will request that the pointer lock is released. If
                 * the browser successfully enters a locked state, a 'POINTER_LOCK_CHANGE_EVENT' will be
                 * dispatched - from the game's input manager - with an `isPointerLocked` property.
                 */
                releasePointerLock(): void;

                /**
                 * Starts the Mouse Event listeners running.
                 * This is called automatically and does not need to be manually invoked.
                 */
                startListeners(): void;

                /**
                 * Stops the Mouse Event listeners.
                 * This is called automatically and does not need to be manually invoked.
                 */
                stopListeners(): void;

                /**
                 * Destroys this Mouse Manager instance.
                 */
                destroy(): void;

            }

        }

        /**
         * A Pointer object encapsulates both mouse and touch input within Phaser.
         * 
         * By default, Phaser will create 2 pointers for your game to use. If you require more, i.e. for a multi-touch
         * game, then use the `InputPlugin.addPointer` method to do so, rather than instantiating this class directly,
         * otherwise it won't be managed by the input system.
         * 
         * You can reference the current active pointer via `InputPlugin.activePointer`. You can also use the properties
         * `InputPlugin.pointer1` through to `pointer10`, for each pointer you have enabled in your game.
         * 
         * The properties of this object are set by the Input Plugin during processing. This object is then sent in all
         * input related events that the Input Plugin emits, so you can reference properties from it directly in your
         * callbacks.
         */
        class Pointer {
            /**
             * 
             * @param manager A reference to the Input Manager.
             * @param id The internal ID of this Pointer.
             */
            constructor(manager: Phaser.Input.InputManager, id: number);

            /**
             * A reference to the Input Manager.
             */
            manager: Phaser.Input.InputManager;

            /**
             * The internal ID of this Pointer.
             */
            readonly id: number;

            /**
             * The most recent native DOM Event this Pointer has processed.
             */
            event: TouchEvent | MouseEvent | WheelEvent;

            /**
             * The DOM element the Pointer was pressed down on, taken from the DOM event.
             * In a default set-up this will be the Canvas that Phaser is rendering to, or the Window element.
             */
            readonly downElement: any;

            /**
             * The DOM element the Pointer was released on, taken from the DOM event.
             * In a default set-up this will be the Canvas that Phaser is rendering to, or the Window element.
             */
            readonly upElement: any;

            /**
             * The camera the Pointer interacted with during its last update.
             * 
             * A Pointer can only ever interact with one camera at once, which will be the top-most camera
             * in the list should multiple cameras be positioned on-top of each other.
             */
            camera: Phaser.Cameras.Scene2D.Camera;

            /**
             * A read-only property that indicates which button was pressed, or released, on the pointer
             * during the most recent event. It is only set during `up` and `down` events.
             * 
             * On Touch devices the value is always 0.
             * 
             * Users may change the configuration of buttons on their pointing device so that if an event's button property
             * is zero, it may not have been caused by the button that is physically left–most on the pointing device;
             * however, it should behave as if the left button was clicked in the standard button layout.
             */
            readonly button: number;

            /**
             * 0: No button or un-initialized
             * 1: Left button
             * 2: Right button
             * 4: Wheel button or middle button
             * 8: 4th button (typically the "Browser Back" button)
             * 16: 5th button (typically the "Browser Forward" button)
             * 
             * For a mouse configured for left-handed use, the button actions are reversed.
             * In this case, the values are read from right to left.
             */
            buttons: number;

            /**
             * The position of the Pointer in screen space.
             */
            readonly position: Phaser.Math.Vector2;

            /**
             * The previous position of the Pointer in screen space.
             * 
             * The old x and y values are stored in here during the InputManager.transformPointer call.
             * 
             * Use the properties `velocity`, `angle` and `distance` to create your own gesture recognition.
             */
            readonly prevPosition: Phaser.Math.Vector2;

            /**
             * The current velocity of the Pointer, based on its current and previous positions.
             * 
             * This value is smoothed out each frame, according to the `motionFactor` property.
             * 
             * This property is updated whenever the Pointer moves, regardless of any button states. In other words,
             * it changes based on movement alone - a button doesn't have to be pressed first.
             */
            readonly velocity: Phaser.Math.Vector2;

            /**
             * The current angle the Pointer is moving, in radians, based on its previous and current position.
             * 
             * The angle is based on the old position facing to the current position.
             * 
             * This property is updated whenever the Pointer moves, regardless of any button states. In other words,
             * it changes based on movement alone - a button doesn't have to be pressed first.
             */
            readonly angle: number;

            /**
             * The distance the Pointer has moved, based on its previous and current position.
             * 
             * This value is smoothed out each frame, according to the `motionFactor` property.
             * 
             * This property is updated whenever the Pointer moves, regardless of any button states. In other words,
             * it changes based on movement alone - a button doesn't have to be pressed first.
             * 
             * If you need the total distance travelled since the primary buttons was pressed down,
             * then use the `Pointer.getDistance` method.
             */
            readonly distance: number;

            /**
             * The smoothing factor to apply to the Pointer position.
             * 
             * Due to their nature, pointer positions are inherently noisy. While this is fine for lots of games, if you need cleaner positions
             * then you can set this value to apply an automatic smoothing to the positions as they are recorded.
             * 
             * The default value of zero means 'no smoothing'.
             * Set to a small value, such as 0.2, to apply an average level of smoothing between positions. You can do this by changing this
             * value directly, or by setting the `input.smoothFactor` property in the Game Config.
             * 
             * Positions are only smoothed when the pointer moves. If the primary button on this Pointer enters an Up or Down state, then the position
             * is always precise, and not smoothed.
             */
            smoothFactor: number;

            /**
             * The factor applied to the motion smoothing each frame.
             * 
             * This value is passed to the Smooth Step Interpolation that is used to calculate the velocity,
             * angle and distance of the Pointer. It's applied every frame, until the midPoint reaches the current
             * position of the Pointer. 0.2 provides a good average but can be increased if you need a
             * quicker update and are working in a high performance environment. Never set this value to
             * zero.
             */
            motionFactor: number;

            /**
             * The x position of this Pointer, translated into the coordinate space of the most recent Camera it interacted with.
             * 
             * If you wish to use this value _outside_ of an input event handler then you should update it first by calling
             * the `Pointer.updateWorldPoint` method.
             */
            worldX: number;

            /**
             * The y position of this Pointer, translated into the coordinate space of the most recent Camera it interacted with.
             * 
             * If you wish to use this value _outside_ of an input event handler then you should update it first by calling
             * the `Pointer.updateWorldPoint` method.
             */
            worldY: number;

            /**
             * Time when this Pointer was most recently moved (regardless of the state of its buttons, if any)
             */
            moveTime: number;

            /**
             * X coordinate of the Pointer when Button 1 (left button), or Touch, was pressed, used for dragging objects.
             */
            downX: number;

            /**
             * Y coordinate of the Pointer when Button 1 (left button), or Touch, was pressed, used for dragging objects.
             */
            downY: number;

            /**
             * The Event timestamp when the first button, or Touch input, was pressed. Used for dragging objects.
             */
            downTime: number;

            /**
             * X coordinate of the Pointer when Button 1 (left button), or Touch, was released, used for dragging objects.
             */
            upX: number;

            /**
             * Y coordinate of the Pointer when Button 1 (left button), or Touch, was released, used for dragging objects.
             */
            upY: number;

            /**
             * The Event timestamp when the final button, or Touch input, was released. Used for dragging objects.
             */
            upTime: number;

            /**
             * Is the primary button down? (usually button 0, the left mouse button)
             */
            primaryDown: boolean;

            /**
             * Is _any_ button on this pointer considered as being down?
             */
            isDown: boolean;

            /**
             * Did the previous input event come from a Touch input (true) or Mouse? (false)
             */
            wasTouch: boolean;

            /**
             * Did this Pointer get canceled by a touchcancel event?
             * 
             * Note: "canceled" is the American-English spelling of "cancelled". Please don't submit PRs correcting it!
             */
            wasCanceled: boolean;

            /**
             * If the mouse is locked, the horizontal relative movement of the Pointer in pixels since last frame.
             */
            movementX: number;

            /**
             * If the mouse is locked, the vertical relative movement of the Pointer in pixels since last frame.
             */
            movementY: number;

            /**
             * The identifier property of the Pointer as set by the DOM event when this Pointer is started.
             */
            identifier: number;

            /**
             * The pointerId property of the Pointer as set by the DOM event when this Pointer is started.
             * The browser can and will recycle this value.
             */
            pointerId: number;

            /**
             * An active Pointer is one that is currently pressed down on the display.
             * A Mouse is always considered as active.
             */
            active: boolean;

            /**
             * Is this pointer Pointer Locked?
             * 
             * Only a mouse pointer can be locked and it only becomes locked when requested via
             * the browsers Pointer Lock API.
             * 
             * You can request this by calling the `this.input.mouse.requestPointerLock()` method from
             * a `pointerdown` or `pointerup` event handler.
             */
            readonly locked: boolean;

            /**
             * The horizontal scroll amount that occurred due to the user moving a mouse wheel or similar input device.
             */
            deltaX: number;

            /**
             * The vertical scroll amount that occurred due to the user moving a mouse wheel or similar input device.
             * This value will typically be less than 0 if the user scrolls up and greater than zero if scrolling down.
             */
            deltaY: number;

            /**
             * The z-axis scroll amount that occurred due to the user moving a mouse wheel or similar input device.
             */
            deltaZ: number;

            /**
             * Takes a Camera and updates this Pointer's `worldX` and `worldY` values so they are
             * the result of a translation through the given Camera.
             * 
             * Note that the values will be automatically replaced the moment the Pointer is
             * updated by an input event, such as a mouse move, so should be used immediately.
             * @param camera The Camera which is being tested against.
             */
            updateWorldPoint(camera: Phaser.Cameras.Scene2D.Camera): this;

            /**
             * Takes a Camera and returns a Vector2 containing the translated position of this Pointer
             * within that Camera. This can be used to convert this Pointers position into camera space.
             * @param camera The Camera to use for the translation.
             * @param output A Vector2-like object in which to store the translated position.
             */
            positionToCamera(camera: Phaser.Cameras.Scene2D.Camera, output?: Phaser.Math.Vector2 | object): Phaser.Math.Vector2 | object;

            /**
             * Checks to see if any buttons are being held down on this Pointer.
             */
            noButtonDown(): boolean;

            /**
             * Checks to see if the left button is being held down on this Pointer.
             */
            leftButtonDown(): boolean;

            /**
             * Checks to see if the right button is being held down on this Pointer.
             */
            rightButtonDown(): boolean;

            /**
             * Checks to see if the middle button is being held down on this Pointer.
             */
            middleButtonDown(): boolean;

            /**
             * Checks to see if the back button is being held down on this Pointer.
             */
            backButtonDown(): boolean;

            /**
             * Checks to see if the forward button is being held down on this Pointer.
             */
            forwardButtonDown(): boolean;

            /**
             * Checks to see if the left button was just released on this Pointer.
             */
            leftButtonReleased(): boolean;

            /**
             * Checks to see if the right button was just released on this Pointer.
             */
            rightButtonReleased(): boolean;

            /**
             * Checks to see if the middle button was just released on this Pointer.
             */
            middleButtonReleased(): boolean;

            /**
             * Checks to see if the back button was just released on this Pointer.
             */
            backButtonReleased(): boolean;

            /**
             * Checks to see if the forward button was just released on this Pointer.
             */
            forwardButtonReleased(): boolean;

            /**
             * If the Pointer has a button pressed down at the time this method is called, it will return the
             * distance between the Pointer's `downX` and `downY` values and the current position.
             * 
             * If no button is held down, it will return the last recorded distance, based on where
             * the Pointer was when the button was released.
             * 
             * If you wish to get the distance being travelled currently, based on the velocity of the Pointer,
             * then see the `Pointer.distance` property.
             */
            getDistance(): number;

            /**
             * If the Pointer has a button pressed down at the time this method is called, it will return the
             * horizontal distance between the Pointer's `downX` and `downY` values and the current position.
             * 
             * If no button is held down, it will return the last recorded horizontal distance, based on where
             * the Pointer was when the button was released.
             */
            getDistanceX(): number;

            /**
             * If the Pointer has a button pressed down at the time this method is called, it will return the
             * vertical distance between the Pointer's `downX` and `downY` values and the current position.
             * 
             * If no button is held down, it will return the last recorded vertical distance, based on where
             * the Pointer was when the button was released.
             */
            getDistanceY(): number;

            /**
             * If the Pointer has a button pressed down at the time this method is called, it will return the
             * duration since the button was pressed down.
             * 
             * If no button is held down, it will return the last recorded duration, based on the time
             * the last button on the Pointer was released.
             */
            getDuration(): number;

            /**
             * If the Pointer has a button pressed down at the time this method is called, it will return the
             * angle between the Pointer's `downX` and `downY` values and the current position.
             * 
             * If no button is held down, it will return the last recorded angle, based on where
             * the Pointer was when the button was released.
             * 
             * The angle is based on the old position facing to the current position.
             * 
             * If you wish to get the current angle, based on the velocity of the Pointer, then
             * see the `Pointer.angle` property.
             */
            getAngle(): number;

            /**
             * Takes the previous and current Pointer positions and then generates an array of interpolated values between
             * the two. The array will be populated up to the size of the `steps` argument.
             * 
             * ```javaScript
             * var points = pointer.getInterpolatedPosition(4);
             * 
             * // points[0] = { x: 0, y: 0 }
             * // points[1] = { x: 2, y: 1 }
             * // points[2] = { x: 3, y: 2 }
             * // points[3] = { x: 6, y: 3 }
             * ```
             * 
             * Use this if you need to get smoothed values between the previous and current pointer positions. DOM pointer
             * events can often fire faster than the main browser loop, and this will help you avoid janky movement
             * especially if you have an object following a Pointer.
             * 
             * Note that if you provide an output array it will only be populated up to the number of steps provided.
             * It will not clear any previous data that may have existed beyond the range of the steps count.
             * 
             * Internally it uses the Smooth Step interpolation calculation.
             * @param steps The number of interpolation steps to use. Default 10.
             * @param out An array to store the results in. If not provided a new one will be created.
             */
            getInterpolatedPosition(steps?: number, out?: any[]): any[];

            /**
             * Fully reset this Pointer back to its unitialized state.
             */
            reset(): void;

            /**
             * Destroys this Pointer instance and resets its external references.
             */
            destroy(): void;

            /**
             * The x position of this Pointer.
             * The value is in screen space.
             * See `worldX` to get a camera converted position.
             */
            x: number;

            /**
             * The y position of this Pointer.
             * The value is in screen space.
             * See `worldY` to get a camera converted position.
             */
            y: number;

            /**
             * Time when this Pointer was most recently updated by a DOM Event.
             * This comes directly from the `event.timeStamp` property.
             * If no event has yet taken place, it will return zero.
             */
            readonly time: number;

        }

        namespace Touch {
            /**
             * The Touch Manager is a helper class that belongs to the Input Manager.
             * 
             * Its role is to listen for native DOM Touch Events and then pass them onto the Input Manager for further processing.
             * 
             * You do not need to create this class directly, the Input Manager will create an instance of it automatically.
             */
            class TouchManager {
                /**
                 * 
                 * @param inputManager A reference to the Input Manager.
                 */
                constructor(inputManager: Phaser.Input.InputManager);

                /**
                 * A reference to the Input Manager.
                 */
                manager: Phaser.Input.InputManager;

                /**
                 * If true the DOM events will have event.preventDefault applied to them, if false they will propagate fully.
                 */
                capture: boolean;

                /**
                 * A boolean that controls if the Touch Manager is enabled or not.
                 * Can be toggled on the fly.
                 */
                enabled: boolean;

                /**
                 * The Touch Event target, as defined in the Game Config.
                 * Typically the canvas to which the game is rendering, but can be any interactive DOM element.
                 */
                target: any;

                /**
                 * The Touch Start event handler function.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchStart: Function;

                /**
                 * The Touch Start event handler function specifically for events on the Window.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchStartWindow: Function;

                /**
                 * The Touch Move event handler function.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchMove: Function;

                /**
                 * The Touch End event handler function.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchEnd: Function;

                /**
                 * The Touch End event handler function specifically for events on the Window.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchEndWindow: Function;

                /**
                 * The Touch Cancel event handler function.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchCancel: Function;

                /**
                 * The Touch Cancel event handler function specifically for events on the Window.
                 * Initially empty and bound in the `startListeners` method.
                 */
                onTouchCancelWindow: Function;

                /**
                 * Are the event listeners hooked into `window.top` or `window`?
                 * 
                 * This is set during the `boot` sequence. If the browser does not have access to `window.top`,
                 * such as in cross-origin iframe environments, this property gets set to `false` and the events
                 * are hooked into `window` instead.
                 */
                readonly isTop: boolean;

                /**
                 * Attempts to disable the context menu from appearing if you touch-hold on the browser.
                 * 
                 * Works by listening for the `contextmenu` event and prevent defaulting it.
                 * 
                 * Use this if you need to disable the OS context menu on mobile.
                 */
                disableContextMenu(): this;

                /**
                 * Starts the Touch Event listeners running as long as an input target is set.
                 * 
                 * This method is called automatically if Touch Input is enabled in the game config,
                 * which it is by default. However, you can call it manually should you need to
                 * delay input capturing until later in the game.
                 */
                startListeners(): void;

                /**
                 * Stops the Touch Event listeners.
                 * This is called automatically and does not need to be manually invoked.
                 */
                stopListeners(): void;

                /**
                 * Destroys this Touch Manager instance.
                 */
                destroy(): void;

            }

        }

    }

    namespace Loader {
        /**
         * The Loader is idle.
         */
        var LOADER_IDLE: number;

        /**
         * The Loader is actively loading.
         */
        var LOADER_LOADING: number;

        /**
         * The Loader is processing files is has loaded.
         */
        var LOADER_PROCESSING: number;

        /**
         * The Loader has completed loading and processing.
         */
        var LOADER_COMPLETE: number;

        /**
         * The Loader is shutting down.
         */
        var LOADER_SHUTDOWN: number;

        /**
         * The Loader has been destroyed.
         */
        var LOADER_DESTROYED: number;

        /**
         * File is in the load queue but not yet started.
         */
        var FILE_PENDING: number;

        /**
         * File has been started to load by the loader (onLoad called)
         */
        var FILE_LOADING: number;

        /**
         * File has loaded successfully, awaiting processing.
         */
        var FILE_LOADED: number;

        /**
         * File failed to load.
         */
        var FILE_FAILED: number;

        /**
         * File is being processed (onProcess callback)
         */
        var FILE_PROCESSING: number;

        /**
         * The File has errored somehow during processing.
         */
        var FILE_ERRORED: number;

        /**
         * File has finished processing.
         */
        var FILE_COMPLETE: number;

        /**
         * File has been destroyed.
         */
        var FILE_DESTROYED: number;

        /**
         * File was populated from local data and doesn't need an HTTP request.
         */
        var FILE_POPULATED: number;

        /**
         * File is pending being destroyed.
         */
        var FILE_PENDING_DESTROY: number;

        namespace Events {
            /**
             * The Loader Plugin Add File Event.
             * 
             * This event is dispatched when a new file is successfully added to the Loader and placed into the load queue.
             * 
             * Listen to it from a Scene using: `this.load.on('addfile', listener)`.
             * 
             * If you add lots of files to a Loader from a `preload` method, it will dispatch this event for each one of them.
             */
            const ADD: string;

            /**
             * The Loader Plugin Complete Event.
             * 
             * This event is dispatched when the Loader has fully processed everything in the load queue.
             * By this point every loaded file will now be in its associated cache and ready for use.
             * 
             * Listen to it from a Scene using: `this.load.on('complete', listener)`.
             */
            const COMPLETE: string;

            /**
             * The File Load Complete Event.
             * 
             * This event is dispatched by the Loader Plugin when _any_ file in the queue finishes loading.
             * 
             * Listen to it from a Scene using: `this.load.on('filecomplete', listener)`.
             * 
             * Make sure you remove this listener when you have finished, or it will continue to fire if the Scene reloads.
             * 
             * You can also listen for the completion of a specific file. See the [FILE_KEY_COMPLETE]{@linkcode Phaser.Loader.Events#event:FILE_KEY_COMPLETE} event.
             */
            const FILE_COMPLETE: string;

            /**
             * The File Load Complete Event.
             * 
             * This event is dispatched by the Loader Plugin when any file in the queue finishes loading.
             * 
             * It uses a special dynamic event name constructed from the key and type of the file.
             * 
             * For example, if you have loaded an `image` with a key of `monster`, you can listen for it
             * using the following:
             * 
             * ```javascript
             * this.load.on('filecomplete-image-monster', function (key, type, data) {
             *     // Your handler code
             * });
             * ```
             * 
             * Or, if you have loaded a texture `atlas` with a key of `Level1`:
             * 
             * ```javascript
             * this.load.on('filecomplete-atlasjson-Level1', function (key, type, data) {
             *     // Your handler code
             * });
             * ```
             * 
             * Or, if you have loaded a sprite sheet with a key of `Explosion` and a prefix of `GAMEOVER`:
             * 
             * ```javascript
             * this.load.on('filecomplete-spritesheet-GAMEOVERExplosion', function (key, type, data) {
             *     // Your handler code
             * });
             * ```
             * 
             * Make sure you remove your listeners when you have finished, or they will continue to fire if the Scene reloads.
             * 
             * You can also listen for the generic completion of files. See the [FILE_COMPLETE]{@linkcode Phaser.Loader.Events#event:FILE_COMPLETE} event.
             */
            const FILE_KEY_COMPLETE: string;

            /**
             * The File Load Error Event.
             * 
             * This event is dispatched by the Loader Plugin when a file fails to load.
             * 
             * Listen to it from a Scene using: `this.load.on('loaderror', listener)`.
             */
            const FILE_LOAD_ERROR: string;

            /**
             * The File Load Event.
             * 
             * This event is dispatched by the Loader Plugin when a file finishes loading,
             * but _before_ it is processed and added to the internal Phaser caches.
             * 
             * Listen to it from a Scene using: `this.load.on('load', listener)`.
             */
            const FILE_LOAD: string;

            /**
             * The File Load Progress Event.
             * 
             * This event is dispatched by the Loader Plugin during the load of a file, if the browser receives a DOM ProgressEvent and
             * the `lengthComputable` event property is true. Depending on the size of the file and browser in use, this may, or may not happen.
             * 
             * Listen to it from a Scene using: `this.load.on('fileprogress', listener)`.
             */
            const FILE_PROGRESS: string;

            /**
             * The Loader Plugin Post Process Event.
             * 
             * This event is dispatched by the Loader Plugin when the Loader has finished loading everything in the load queue.
             * It is dispatched before the internal lists are cleared and each File is destroyed.
             * 
             * Use this hook to perform any last minute processing of files that can only happen once the
             * Loader has completed, but prior to it emitting the `complete` event.
             * 
             * Listen to it from a Scene using: `this.load.on('postprocess', listener)`.
             */
            const POST_PROCESS: string;

            /**
             * The Loader Plugin Progress Event.
             * 
             * This event is dispatched when the Loader updates its load progress, typically as a result of a file having completed loading.
             * 
             * Listen to it from a Scene using: `this.load.on('progress', listener)`.
             */
            const PROGRESS: string;

            /**
             * The Loader Plugin Start Event.
             * 
             * This event is dispatched when the Loader starts running. At this point load progress is zero.
             * 
             * This event is dispatched even if there aren't any files in the load queue.
             * 
             * Listen to it from a Scene using: `this.load.on('start', listener)`.
             */
            const START: string;

        }

        /**
         * The base File class used by all File Types that the Loader can support.
         * You shouldn't create an instance of a File directly, but should extend it with your own class, setting a custom type and processing methods.
         */
        class File {
            /**
             * 
             * @param loader The Loader that is going to load this File.
             * @param fileConfig The file configuration object, as created by the file type.
             */
            constructor(loader: Phaser.Loader.LoaderPlugin, fileConfig: Phaser.Types.Loader.FileConfig);

            /**
             * A reference to the Loader that is going to load this file.
             */
            loader: Phaser.Loader.LoaderPlugin;

            /**
             * A reference to the Cache, or Texture Manager, that is going to store this file if it loads.
             */
            cache: Phaser.Cache.BaseCache | Phaser.Textures.TextureManager;

            /**
             * The file type string (image, json, etc) for sorting within the Loader.
             */
            type: string;

            /**
             * Unique cache key (unique within its file type)
             */
            key: string;

            /**
             * The URL of the file, not including baseURL.
             * 
             * Automatically has Loader.path prepended to it if a string.
             * 
             * Can also be a JavaScript Object, such as the results of parsing JSON data.
             */
            url: object | string;

            /**
             * The final URL this file will load from, including baseURL and path.
             * Set automatically when the Loader calls 'load' on this file.
             */
            src: string;

            /**
             * The merged XHRSettings for this file.
             */
            xhrSettings: Phaser.Types.Loader.XHRSettingsObject;

            /**
             * The XMLHttpRequest instance (as created by XHR Loader) that is loading this File.
             */
            xhrLoader: XMLHttpRequest | null;

            /**
             * The current state of the file. One of the FILE_CONST values.
             */
            state: number;

            /**
             * The total size of this file.
             * Set by onProgress and only if loading via XHR.
             */
            bytesTotal: number;

            /**
             * Updated as the file loads.
             * Only set if loading via XHR.
             */
            bytesLoaded: number;

            /**
             * A percentage value between 0 and 1 indicating how much of this file has loaded.
             * Only set if loading via XHR.
             */
            percentComplete: number;

            /**
             * For CORs based loading.
             * If this is undefined then the File will check BaseLoader.crossOrigin and use that (if set)
             */
            crossOrigin: string | undefined;

            /**
             * The processed file data, stored here after the file has loaded.
             */
            data: any;

            /**
             * A config object that can be used by file types to store transitional data.
             */
            config: any;

            /**
             * If this is a multipart file, i.e. an atlas and its json together, then this is a reference
             * to the parent MultiFile. Set and used internally by the Loader or specific file types.
             */
            multiFile: Phaser.Loader.MultiFile | null;

            /**
             * Does this file have an associated linked file? Such as an image and a normal map.
             * Atlases and Bitmap Fonts use the multiFile, because those files need loading together but aren't
             * actually bound by data, where-as a linkFile is.
             */
            linkFile: Phaser.Loader.File | null;

            /**
             * Links this File with another, so they depend upon each other for loading and processing.
             * @param fileB The file to link to this one.
             */
            setLink(fileB: Phaser.Loader.File): void;

            /**
             * Resets the XHRLoader instance this file is using.
             */
            resetXHR(): void;

            /**
             * Called by the Loader, starts the actual file downloading.
             * During the load the methods onLoad, onError and onProgress are called, based on the XHR events.
             * You shouldn't normally call this method directly, it's meant to be invoked by the Loader.
             */
            load(): void;

            /**
             * Called when the file finishes loading, is sent a DOM ProgressEvent.
             * @param xhr The XMLHttpRequest that caused this onload event.
             * @param event The DOM ProgressEvent that resulted from this load.
             */
            onLoad(xhr: XMLHttpRequest, event: ProgressEvent): void;

            /**
             * Called if the file errors while loading, is sent a DOM ProgressEvent.
             * @param xhr The XMLHttpRequest that caused this onload event.
             * @param event The DOM ProgressEvent that resulted from this error.
             */
            onError(xhr: XMLHttpRequest, event: ProgressEvent): void;

            /**
             * Called during the file load progress. Is sent a DOM ProgressEvent.
             * @param event The DOM ProgressEvent.
             */
            onProgress(event: ProgressEvent): void;

            /**
             * Usually overridden by the FileTypes and is called by Loader.nextFile.
             * This method controls what extra work this File does with its loaded data, for example a JSON file will parse itself during this stage.
             */
            onProcess(): void;

            /**
             * Called when the File has completed processing.
             * Checks on the state of its multifile, if set.
             */
            onProcessComplete(): void;

            /**
             * Called when the File has completed processing but it generated an error.
             * Checks on the state of its multifile, if set.
             */
            onProcessError(): void;

            /**
             * Checks if a key matching the one used by this file exists in the target Cache or not.
             * This is called automatically by the LoaderPlugin to decide if the file can be safely
             * loaded or will conflict.
             */
            hasCacheConflict(): boolean;

            /**
             * Adds this file to its target cache upon successful loading and processing.
             * This method is often overridden by specific file types.
             */
            addToCache(): void;

            /**
             * Called once the file has been added to its cache and is now ready for deletion from the Loader.
             * It will emit a `filecomplete` event from the LoaderPlugin.
             */
            pendingDestroy(): void;

            /**
             * Destroy this File and any references it holds.
             */
            destroy(): void;

            /**
             * Static method for creating object URL using URL API and setting it as image 'src' attribute.
             * If URL API is not supported (usually on old browsers) it falls back to creating Base64 encoded url using FileReader.
             * @param image Image object which 'src' attribute should be set to object URL.
             * @param blob A Blob object to create an object URL for.
             * @param defaultType Default mime type used if blob type is not available.
             */
            static createObjectURL(image: HTMLImageElement, blob: Blob, defaultType: string): void;

            /**
             * Static method for releasing an existing object URL which was previously created
             * by calling {@link File#createObjectURL} method.
             * @param image Image object which 'src' attribute should be revoked.
             */
            static revokeObjectURL(image: HTMLImageElement): void;

        }

        namespace FileTypes {
            /**
             * A single Animation JSON File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#animation method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#animation.
             */
            class AnimationJSONFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param dataKey When the JSON file loads only this property will be stored in the Cache.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.JSONFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, dataKey?: string);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Called at the end of the load process, after the Loader has finished all files in its queue.
                 */
                onLoadComplete(): void;

            }

            /**
             * A single JSON based Texture Atlas File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#atlas method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#atlas.
             * 
             * https://www.codeandweb.com/texturepacker/tutorials/how-to-create-sprite-sheets-for-phaser3?source=photonstorm
             */
            class AsepriteFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param atlasURL The absolute or relative URL to load the texture atlas json data file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
                 * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
                 * @param atlasXhrSettings An XHR Settings configuration object for the atlas json file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AsepriteFileConfig, textureURL?: string | string[], atlasURL?: object | string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single JSON based Texture Atlas File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#atlas method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#atlas.
             * 
             * https://www.codeandweb.com/texturepacker/tutorials/how-to-create-sprite-sheets-for-phaser3?source=photonstorm
             */
            class AtlasJSONFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param atlasURL The absolute or relative URL to load the texture atlas json data file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
                 * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
                 * @param atlasXhrSettings An XHR Settings configuration object for the atlas json file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AtlasJSONFileConfig, textureURL?: string | string[], atlasURL?: object | string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single XML based Texture Atlas File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#atlasXML method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#atlasXML.
             */
            class AtlasXMLFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param atlasURL The absolute or relative URL to load the texture atlas xml data file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
                 * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
                 * @param atlasXhrSettings An XHR Settings configuration object for the atlas xml file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AtlasXMLFileConfig, textureURL?: string | string[], atlasURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Audio File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#audio method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#audio.
             */
            class AudioFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param urlConfig The absolute or relative URL to load this file from in a config object.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param audioContext The AudioContext this file will use to process itself.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AudioFileConfig, urlConfig?: Phaser.Types.Loader.FileTypes.AudioFileURLConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, audioContext?: AudioContext);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * An Audio Sprite File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#audioSprite method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#audioSprite.
             */
            class AudioSpriteFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param jsonURL The absolute or relative URL to load the json file from. Or a well formed JSON object to use instead.
                 * @param audioURL The absolute or relative URL to load the audio file from. If empty it will be obtained by parsing the JSON file.
                 * @param audioConfig The audio configuration options.
                 * @param audioXhrSettings An XHR Settings configuration object for the audio file. Used in replacement of the Loaders default XHR Settings.
                 * @param jsonXhrSettings An XHR Settings configuration object for the json file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AudioSpriteFileConfig, jsonURL: string, audioURL?: Object, audioConfig?: any, audioXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, jsonXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called by each File when it finishes loading.
                 * @param file The File that has completed processing.
                 */
                onFileComplete(file: Phaser.Loader.File): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Binary File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#binary method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#binary.
             */
            class BinaryFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.bin`, i.e. if `key` was "alien" then the URL will be "alien.bin".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param dataType Optional type to cast the binary file to once loaded. For example, `Uint8Array`.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.BinaryFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, dataType?: any);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Bitmap Font based File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#bitmapFont method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#bitmapFont.
             */
            class BitmapFontFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param textureURL The absolute or relative URL to load the font image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param fontDataURL The absolute or relative URL to load the font xml data file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
                 * @param textureXhrSettings An XHR Settings configuration object for the font image file. Used in replacement of the Loaders default XHR Settings.
                 * @param fontDataXhrSettings An XHR Settings configuration object for the font data xml file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.BitmapFontFileConfig, textureURL?: string | string[], fontDataURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, fontDataXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A Compressed Texture File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#texture method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#texture.
             */
            class CompressedTextureFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file.
                 * @param entry The compressed texture file entry to load.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string, entry: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called by each File when it finishes loading.
                 * @param file The File that has completed processing.
                 */
                onFileComplete(file: Phaser.Loader.File): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

                /**
                 * Adds all of the multi-file entties to their target caches upon successful loading and processing.
                 */
                addMultiToCache(): void;

            }

            /**
             * A single CSS File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#css method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#css.
             */
            class CSSFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.CSSFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single GLSL File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#glsl method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#glsl.
             */
            class GLSLFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.txt`, i.e. if `key` was "alien" then the URL will be "alien.txt".
                 * @param shaderType The type of shader. Either `fragment` for a fragment shader, or `vertex` for a vertex shader. This is ignored if you load a shader bundle. Default 'fragment'.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.GLSLFileConfig, url?: string, shaderType?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

                /**
                 * Returns the name of the shader from the header block.
                 * @param headerSource The header data.
                 */
                getShaderName(headerSource: string[]): string;

                /**
                 * Returns the type of the shader from the header block.
                 * @param headerSource The header data.
                 */
                getShaderType(headerSource: string[]): string;

                /**
                 * Returns the shader uniforms from the header block.
                 * @param headerSource The header data.
                 */
                getShaderUniforms(headerSource: string[]): any;

            }

            /**
             * A single Audio File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#audio method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#audio.
             */
            class HTML5AudioFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param urlConfig The absolute or relative URL to load this file from.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.AudioFileConfig, urlConfig?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called when the file finishes loading.
                 */
                onLoad(): void;

                /**
                 * Called if the file errors while loading.
                 */
                onError(): void;

                /**
                 * Called during the file load progress. Is sent a DOM ProgressEvent.
                 */
                onProgress(): void;

                /**
                 * Called by the Loader, starts the actual file downloading.
                 * During the load the methods onLoad, onError and onProgress are called, based on the XHR events.
                 * You shouldn't normally call this method directly, it's meant to be invoked by the Loader.
                 */
                load(): void;

            }

            /**
             * A single HTML File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#html method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#html.
             */
            class HTMLFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.html`, i.e. if `key` was "alien" then the URL will be "alien.html".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.HTMLFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single HTML File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#htmlTexture method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#htmlTexture.
             */
            class HTMLTextureFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param width The width of the texture the HTML will be rendered to.
                 * @param height The height of the texture the HTML will be rendered to.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.HTMLTextureFileConfig, url?: string, width?: number, height?: number, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Image File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#image method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#image.
             */
            class ImageFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param frameConfig The frame configuration object. Only provided for, and used by, Sprite Sheets.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.ImageFileConfig, url?: string | string[], xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single JSON File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#json method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#json.
             */
            class JSONFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, can be a fully formed JSON Object.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param dataKey When the JSON file loads only this property will be stored in the Cache.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.JSONFileConfig, url?: object | string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, dataKey?: string);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Multi Texture Atlas File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#multiatlas method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#multiatlas.
             */
            class MultiAtlasFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key of the file. Must be unique within both the Loader and the Texture Manager. Or a config object.
                 * @param atlasURL The absolute or relative URL to load the multi atlas json file from.
                 * @param path Optional path to use when loading the textures defined in the atlas data.
                 * @param baseURL Optional Base URL to use when loading the textures defined in the atlas data.
                 * @param atlasXhrSettings Extra XHR Settings specifically for the atlas json file.
                 * @param textureXhrSettings Extra XHR Settings specifically for the texture files.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.MultiAtlasFileConfig, atlasURL?: string, path?: string, baseURL?: string, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called by each File when it finishes loading.
                 * @param file The File that has completed processing.
                 */
                onFileComplete(file: Phaser.Loader.File): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A Multi Script File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#scripts method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#scripts.
             */
            class MultiScriptFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url An array of absolute or relative URLs to load the script files from. They are processed in the order given in the array.
                 * @param xhrSettings An XHR Settings configuration object for the script files. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.MultiScriptFileConfig, url?: string[], xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Wavefront OBJ File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#obj method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#obj.
             */
            class OBJFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param objURL The absolute or relative URL to load the obj file from. If undefined or `null` it will be set to `<key>.obj`, i.e. if `key` was "alien" then the URL will be "alien.obj".
                 * @param matURL The absolute or relative URL to load the material file from. If undefined or `null` it will be set to `<key>.mat`, i.e. if `key` was "alien" then the URL will be "alien.mat".
                 * @param flipUV Flip the UV coordinates stored in the model data?
                 * @param xhrSettings Extra XHR Settings specifically for these files.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.OBJFileConfig, objURL?: string, matURL?: string, flipUV?: boolean, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single JSON Pack File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#pack method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#pack.
             */
            class PackFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from or a ready formed JSON object. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 * @param dataKey When the JSON file loads only this property will be stored in the Cache.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.PackFileConfig, url?: string | any, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject, dataKey?: string);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Plugin Script File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#plugin method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#plugin.
             */
            class PluginFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
                 * @param start Automatically start the plugin after loading? Default false.
                 * @param mapping If this plugin is to be injected into the Scene, this is the property key used.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.PluginFileConfig, url?: string, start?: boolean, mapping?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * An external Scene JavaScript File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#sceneFile method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#sceneFile.
             */
            class SceneFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.SceneFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Scene Plugin Script File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#scenePlugin method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#scenePlugin.
             */
            class ScenePluginFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
                 * @param systemKey If this plugin is to be added to Scene.Systems, this is the property key for it.
                 * @param sceneKey If this plugin is to be added to the Scene, this is the property key for it.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.ScenePluginFileConfig, url?: string, systemKey?: string, sceneKey?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Script File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#script method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#script.
             */
            class ScriptFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
                 * @param type The script type. Should be either 'script' for classic JavaScript, or 'module' if the file contains an exported module. Default 'script'.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.ScriptFileConfig, url?: string, type?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Sprite Sheet Image File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#spritesheet method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#spritesheet.
             */
            class SpriteSheetFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param frameConfig The frame configuration object.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.SpriteSheetFileConfig, url?: string | string[], frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single SVG File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#svg method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#svg.
             */
            class SVGFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.svg`, i.e. if `key` was "alien" then the URL will be "alien.svg".
                 * @param svgConfig The svg size configuration object.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.SVGFileConfig, url?: string, svgConfig?: Phaser.Types.Loader.FileTypes.SVGSizeConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Text File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#text method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#text.
             */
            class TextFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.txt`, i.e. if `key` was "alien" then the URL will be "alien.txt".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.TextFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

            /**
             * A single Tilemap CSV File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#tilemapCSV method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#tilemapCSV.
             */
            class TilemapCSVFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.csv`, i.e. if `key` was "alien" then the URL will be "alien.csv".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.TilemapCSVFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Impact.js Tilemap JSON File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#tilemapImpact method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#tilemapImpact.
             */
            class TilemapImpactFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.TilemapImpactFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Tiled Tilemap JSON File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#tilemapTiledJSON method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#tilemapTiledJSON.
             */
            class TilemapJSONFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.TilemapJSONFileConfig, url?: object | string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single text file based Unity Texture Atlas File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#unityAtlas method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#unityAtlas.
             */
            class UnityAtlasFile extends Phaser.Loader.MultiFile {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
                 * @param atlasURL The absolute or relative URL to load the texture atlas data file from. If undefined or `null` it will be set to `<key>.txt`, i.e. if `key` was "alien" then the URL will be "alien.txt".
                 * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
                 * @param atlasXhrSettings An XHR Settings configuration object for the atlas data file. Used in replacement of the Loaders default XHR Settings.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.UnityAtlasFileConfig, textureURL?: string | string[], atlasURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Adds this file to its target cache upon successful loading and processing.
                 */
                addToCache(): void;

            }

            /**
             * A single Video File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#video method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#video.
             */
            class VideoFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param urls The absolute or relative URL to load the video files from.
                 * @param noAudio Does the video have an audio track? If not you can enable auto-playing on it. Default false.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.VideoFileConfig, urls?: string | string[] | Phaser.Types.Loader.FileTypes.VideoFileURLConfig | Phaser.Types.Loader.FileTypes.VideoFileURLConfig[], noAudio?: boolean);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

                /**
                 * Called by the Loader, starts the actual file downloading.
                 * During the load the methods onLoad, onError and onProgress are called, based on the XHR events.
                 * You shouldn't normally call this method directly, it's meant to be invoked by the Loader.
                 */
                load(): void;

            }

            /**
             * A single XML File suitable for loading by the Loader.
             * 
             * These are created when you use the Phaser.Loader.LoaderPlugin#xml method and are not typically created directly.
             * 
             * For documentation about what all the arguments and configuration options mean please see Phaser.Loader.LoaderPlugin#xml.
             */
            class XMLFile extends Phaser.Loader.File {
                /**
                 * 
                 * @param loader A reference to the Loader that is responsible for this file.
                 * @param key The key to use for this file, or a file configuration object.
                 * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
                 * @param xhrSettings Extra XHR Settings specifically for this file.
                 */
                constructor(loader: Phaser.Loader.LoaderPlugin, key: string | Phaser.Types.Loader.FileTypes.XMLFileConfig, url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject);

                /**
                 * Called automatically by Loader.nextFile.
                 * This method controls what extra work this File does with its loaded data.
                 */
                onProcess(): void;

            }

        }

        namespace FileTypesManager {
            /**
             * Static method called when a LoaderPlugin is created.
             * 
             * Loops through the local types object and injects all of them as
             * properties into the LoaderPlugin instance.
             * @param loader The LoaderPlugin to install the types into.
             */
            function install(loader: Phaser.Loader.LoaderPlugin): void;

            /**
             * Static method called directly by the File Types.
             * 
             * The key is a reference to the function used to load the files via the Loader, i.e. `image`.
             * @param key The key that will be used as the method name in the LoaderPlugin.
             * @param factoryFunction The function that will be called when LoaderPlugin.key is invoked.
             */
            function register(key: string, factoryFunction: Function): void;

            /**
             * Removed all associated file types.
             */
            function destroy(): void;

        }

        /**
         * Given a File and a baseURL value this returns the URL the File will use to download from.
         * @param file The File object.
         * @param baseURL A default base URL.
         */
        function GetURL(file: Phaser.Loader.File, baseURL: string): string;

        /**
         * The Loader handles loading all external content such as Images, Sounds, Texture Atlases and data files.
         * You typically interact with it via `this.load` in your Scene. Scenes can have a `preload` method, which is always
         * called before the Scenes `create` method, allowing you to preload assets that the Scene may need.
         * 
         * If you call any `this.load` methods from outside of `Scene.preload` then you need to start the Loader going
         * yourself by calling `Loader.start()`. It's only automatically started during the Scene preload.
         * 
         * The Loader uses a combination of tag loading (eg. Audio elements) and XHR and provides progress and completion events.
         * Files are loaded in parallel by default. The amount of concurrent connections can be controlled in your Game Configuration.
         * 
         * Once the Loader has started loading you are still able to add files to it. These can be injected as a result of a loader
         * event, the type of file being loaded (such as a pack file) or other external events. As long as the Loader hasn't finished
         * simply adding a new file to it, while running, will ensure it's added into the current queue.
         * 
         * Every Scene has its own instance of the Loader and they are bound to the Scene in which they are created. However,
         * assets loaded by the Loader are placed into global game-level caches. For example, loading an XML file will place that
         * file inside `Game.cache.xml`, which is accessible from every Scene in your game, no matter who was responsible
         * for loading it. The same is true of Textures. A texture loaded in one Scene is instantly available to all other Scenes
         * in your game.
         * 
         * The Loader works by using custom File Types. These are stored in the FileTypesManager, which injects them into the Loader
         * when it's instantiated. You can create your own custom file types by extending either the File or MultiFile classes.
         * See those files for more details.
         */
        class LoaderPlugin extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param scene The Scene which owns this Loader instance.
             */
            constructor(scene: Phaser.Scene);

            /**
             * Adds an Animation JSON Data file, or array of Animation JSON files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.animation('baddieAnims', 'files/BaddieAnims.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * The key must be a unique String. It is used to add the file to the global JSON Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the JSON Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the JSON Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.animation({
             *     key: 'baddieAnims',
             *     url: 'files/BaddieAnims.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.JSONFileConfig` for more details.
             * 
             * Once the file has finished loading it will automatically be passed to the global Animation Managers `fromJSON` method.
             * This will parse all of the JSON data and create animation data from it. This process happens at the very end
             * of the Loader, once every other file in the load queue has finished. The reason for this is to allow you to load
             * both animation data and the images it relies upon in the same load call.
             * 
             * Once the animation data has been parsed you will be able to play animations using that data.
             * Please see the Animation Manager `fromJSON` method for more details about the format and playback.
             * 
             * You can also access the raw animation data from its Cache using its key:
             * 
             * ```javascript
             * this.load.animation('baddieAnims', 'files/BaddieAnims.json');
             * // and later in your game ...
             * var data = this.cache.json.get('baddieAnims');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Waves` the final key will be `LEVEL1.Waves` and
             * this is what you would use to retrieve the text from the JSON Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "data"
             * and no URL is given then the Loader will set the URL to be "data.json". It will always add `.json` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * You can also optionally provide a `dataKey` to use. This allows you to extract only a part of the JSON and store it in the Cache,
             * rather than the whole file. For example, if your JSON data had a structure like this:
             * 
             * ```json
             * {
             *     "level1": {
             *         "baddies": {
             *             "aliens": {},
             *             "boss": {}
             *         }
             *     },
             *     "level2": {},
             *     "level3": {}
             * }
             * ```
             * 
             * And if you only wanted to create animations from the `boss` data, then you could pass `level1.baddies.boss`as the `dataKey`.
             * 
             * Note: The ability to load this type of file will only be available if the JSON File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
             * @param dataKey When the Animation JSON file loads only this property will be stored in the Cache and used to create animation data.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            animation(key: string | Phaser.Types.Loader.FileTypes.JSONFileConfig | Phaser.Types.Loader.FileTypes.JSONFileConfig[], url?: string, dataKey?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Aseprite is a powerful animated sprite editor and pixel art tool.
             * 
             * You can find more details at https://www.aseprite.org/
             * 
             * Adds a JSON based Aseprite Animation, or array of animations, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.aseprite('gladiator', 'images/Gladiator.png', 'images/Gladiator.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * To export a compatible JSON file in Aseprite, please do the following:
             * 
             * 1. Go to "File - Export Sprite Sheet"
             * 
             * 2. On the **Layout** tab:
             * 2a. Set the "Sheet type" to "Packed"
             * 2b. Set the "Constraints" to "None"
             * 2c. Check the "Merge Duplicates" checkbox
             * 
             * 3. On the **Sprite** tab:
             * 3a. Set "Layers" to "Visible layers"
             * 3b. Set "Frames" to "All frames", unless you only wish to export a sub-set of tags
             * 
             * 4. On the **Borders** tab:
             * 4a. Check the "Trim Sprite" and "Trim Cells" options
             * 4b. Ensure "Border Padding", "Spacing" and "Inner Padding" are all > 0 (1 is usually enough)
             * 
             * 5. On the **Output** tab:
             * 5a. Check "Output File", give your image a name and make sure you choose "png files" as the file type
             * 5b. Check "JSON Data" and give your json file a name
             * 5c. The JSON Data type can be either a Hash or Array, Phaser doesn't mind.
             * 5d. Make sure "Tags" is checked in the Meta options
             * 5e. In the "Item Filename" input box, make sure it says just "{frame}" and nothing more.
             * 
             * 6. Click export
             * 
             * This was tested with Aseprite 1.2.25.
             * 
             * This will export a png and json file which you can load using the Aseprite Loader, i.e.:
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.aseprite({
             *     key: 'gladiator',
             *     textureURL: 'images/Gladiator.png',
             *     atlasURL: 'images/Gladiator.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.AsepriteFileConfig` for more details.
             * 
             * Instead of passing a URL for the JSON data you can also pass in a well formed JSON object instead.
             * 
             * Once loaded, you can call this method from within a Scene with the 'atlas' key:
             * 
             * ```javascript
             * this.anims.createFromAseprite('paladin');
             * ```
             * 
             * Any animations defined in the JSON will now be available to use in Phaser and you play them
             * via their Tag name. For example, if you have an animation called 'War Cry' on your Aseprite timeline,
             * you can play it in Phaser using that Tag name:
             * 
             * ```javascript
             * this.add.sprite(400, 300).play('War Cry');
             * ```
             * 
             * When calling this method you can optionally provide an array of tag names, and only those animations
             * will be created. For example:
             * 
             * ```javascript
             * this.anims.createFromAseprite('paladin', [ 'step', 'War Cry', 'Magnum Break' ]);
             * ```
             * 
             * This will only create the 3 animations defined. Note that the tag names are case-sensitive.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Aseprite File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param atlasURL The absolute or relative URL to load the texture atlas json data file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
             * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
             * @param atlasXhrSettings An XHR Settings configuration object for the atlas json file. Used in replacement of the Loaders default XHR Settings.
             */
            aseprite(key: string | Phaser.Types.Loader.FileTypes.AsepriteFileConfig | Phaser.Types.Loader.FileTypes.AsepriteFileConfig[], textureURL?: string | string[], atlasURL?: object | string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a JSON based Texture Atlas, or array of atlases, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.atlas('mainmenu', 'images/MainMenu.png', 'images/MainMenu.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * Phaser expects the atlas data to be provided in a JSON file, using either the JSON Hash or JSON Array format.
             * 
             * These files are created by software such as:
             * 
             * * [Texture Packer](https://www.codeandweb.com/texturepacker/tutorials/how-to-create-sprite-sheets-for-phaser3?source=photonstorm)
             * * [Shoebox](https://renderhjs.net/shoebox/)
             * * [Gamma Texture Packer](https://gammafp.com/tool/atlas-packer/)
             * * [Adobe Flash / Animate](https://www.adobe.com/uk/products/animate.html)
             * * [Free Texture Packer](http://free-tex-packer.com/)
             * * [Leshy SpriteSheet Tool](https://www.leshylabs.com/apps/sstool/)
             * 
             * If you are using Texture Packer and have enabled multi-atlas support, then please use the Phaser Multi Atlas loader
             * instead of this one.
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.atlas({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     atlasURL: 'images/MainMenu.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.AtlasJSONFileConfig` for more details.
             * 
             * Instead of passing a URL for the atlas JSON data you can also pass in a well formed JSON object instead.
             * 
             * Once the atlas has finished loading you can use frames from it as textures for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.atlas('mainmenu', 'images/MainMenu.png', 'images/MainMenu.json');
             * // and later in your game ...
             * this.add.image(x, y, 'mainmenu', 'background');
             * ```
             * 
             * To get a list of all available frames within an atlas please consult your Texture Atlas software.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.atlas('mainmenu', [ 'images/MainMenu.png', 'images/MainMenu-n.png' ], 'images/MainMenu.json');
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.atlas({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     normalMap: 'images/MainMenu-n.png',
             *     atlasURL: 'images/MainMenu.json'
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * Note: The ability to load this type of file will only be available if the Atlas JSON File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param atlasURL The absolute or relative URL to load the texture atlas json data file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
             * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
             * @param atlasXhrSettings An XHR Settings configuration object for the atlas json file. Used in replacement of the Loaders default XHR Settings.
             */
            atlas(key: string | Phaser.Types.Loader.FileTypes.AtlasJSONFileConfig | Phaser.Types.Loader.FileTypes.AtlasJSONFileConfig[], textureURL?: string | string[], atlasURL?: object | string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an XML based Texture Atlas, or array of atlases, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.atlasXML('mainmenu', 'images/MainMenu.png', 'images/MainMenu.xml');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * Phaser expects the atlas data to be provided in an XML file format.
             * These files are created by software such as Shoebox and Adobe Flash / Animate.
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.atlasXML({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     atlasURL: 'images/MainMenu.xml'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.AtlasXMLFileConfig` for more details.
             * 
             * Once the atlas has finished loading you can use frames from it as textures for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.atlasXML('mainmenu', 'images/MainMenu.png', 'images/MainMenu.xml');
             * // and later in your game ...
             * this.add.image(x, y, 'mainmenu', 'background');
             * ```
             * 
             * To get a list of all available frames within an atlas please consult your Texture Atlas software.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.atlasXML('mainmenu', [ 'images/MainMenu.png', 'images/MainMenu-n.png' ], 'images/MainMenu.xml');
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.atlasXML({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     normalMap: 'images/MainMenu-n.png',
             *     atlasURL: 'images/MainMenu.xml'
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * Note: The ability to load this type of file will only be available if the Atlas XML File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param atlasURL The absolute or relative URL to load the texture atlas xml data file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
             * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
             * @param atlasXhrSettings An XHR Settings configuration object for the atlas xml file. Used in replacement of the Loaders default XHR Settings.
             */
            atlasXML(key: string | Phaser.Types.Loader.FileTypes.AtlasXMLFileConfig | Phaser.Types.Loader.FileTypes.AtlasXMLFileConfig[], textureURL?: string | string[], atlasURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an Audio or HTML5Audio file, or array of audio files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.audio('title', [ 'music/Title.ogg', 'music/Title.mp3', 'music/Title.m4a' ]);
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Audio Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Audio Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Audio Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.audio({
             *     key: 'title',
             *     url: [ 'music/Title.ogg', 'music/Title.mp3', 'music/Title.m4a' ]
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.AudioFileConfig` for more details.
             * 
             * The URLs can be relative or absolute. If the URLs are relative the `Loader.baseURL` and `Loader.path` values will be prepended to them.
             * 
             * Due to different browsers supporting different audio file types you should usually provide your audio files in a variety of formats.
             * ogg, mp3 and m4a are the most common. If you provide an array of URLs then the Loader will determine which _one_ file to load based on
             * browser support.
             * 
             * If audio has been disabled in your game, either via the game config, or lack of support from the device, then no audio will be loaded.
             * 
             * Note: The ability to load this type of file will only be available if the Audio File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param urls The absolute or relative URL to load the audio files from.
             * @param config An object containing an `instances` property for HTML5Audio. Defaults to 1.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            audio(key: string | Phaser.Types.Loader.FileTypes.AudioFileConfig | Phaser.Types.Loader.FileTypes.AudioFileConfig[], urls?: string | string[] | Phaser.Types.Loader.FileTypes.AudioFileURLConfig | Phaser.Types.Loader.FileTypes.AudioFileURLConfig[], config?: any, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a JSON based Audio Sprite, or array of audio sprites, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.audioSprite('kyobi', 'kyobi.json', [
             *         'kyobi.ogg',
             *         'kyobi.mp3',
             *         'kyobi.m4a'
             *     ]);
             * }
             * ```
             * 
             * Audio Sprites are a combination of audio files and a JSON configuration.
             * The JSON follows the format of that created by https://github.com/tonistiigi/audiosprite
             * 
             * If the JSON file includes a 'resource' object then you can let Phaser parse it and load the audio
             * files automatically based on its content. To do this exclude the audio URLs from the load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.audioSprite('kyobi', 'kyobi.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * The key must be a unique String. It is used to add the file to the global Audio Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Audio Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Audio Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.audioSprite({
             *     key: 'kyobi',
             *     jsonURL: 'audio/Kyobi.json',
             *     audioURL: [
             *         'audio/Kyobi.ogg',
             *         'audio/Kyobi.mp3',
             *         'audio/Kyobi.m4a'
             *     ]
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.AudioSpriteFileConfig` for more details.
             * 
             * Instead of passing a URL for the audio JSON data you can also pass in a well formed JSON object instead.
             * 
             * Once the audio has finished loading you can use it create an Audio Sprite by referencing its key:
             * 
             * ```javascript
             * this.load.audioSprite('kyobi', 'kyobi.json');
             * // and later in your game ...
             * var music = this.sound.addAudioSprite('kyobi');
             * music.play('title');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * Due to different browsers supporting different audio file types you should usually provide your audio files in a variety of formats.
             * ogg, mp3 and m4a are the most common. If you provide an array of URLs then the Loader will determine which _one_ file to load based on
             * browser support.
             * 
             * If audio has been disabled in your game, either via the game config, or lack of support from the device, then no audio will be loaded.
             * 
             * Note: The ability to load this type of file will only be available if the Audio Sprite File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or an array of objects.
             * @param jsonURL The absolute or relative URL to load the json file from. Or a well formed JSON object to use instead.
             * @param audioURL The absolute or relative URL to load the audio file from. If empty it will be obtained by parsing the JSON file.
             * @param audioConfig The audio configuration options.
             * @param audioXhrSettings An XHR Settings configuration object for the audio file. Used in replacement of the Loaders default XHR Settings.
             * @param jsonXhrSettings An XHR Settings configuration object for the json file. Used in replacement of the Loaders default XHR Settings.
             */
            audioSprite(key: string | Phaser.Types.Loader.FileTypes.AudioSpriteFileConfig | Phaser.Types.Loader.FileTypes.AudioSpriteFileConfig[], jsonURL: string, audioURL?: string | string[], audioConfig?: any, audioXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, jsonXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Binary file, or array of Binary files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.binary('doom', 'files/Doom.wad');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Binary Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Binary Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Binary Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.binary({
             *     key: 'doom',
             *     url: 'files/Doom.wad',
             *     dataType: Uint8Array
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.BinaryFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.binary('doom', 'files/Doom.wad');
             * // and later in your game ...
             * var data = this.cache.binary.get('doom');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Data` the final key will be `LEVEL1.Data` and
             * this is what you would use to retrieve the text from the Binary Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "doom"
             * and no URL is given then the Loader will set the URL to be "doom.bin". It will always add `.bin` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Binary File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.bin`, i.e. if `key` was "alien" then the URL will be "alien.bin".
             * @param dataType Optional type to cast the binary file to once loaded. For example, `Uint8Array`.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            binary(key: string | Phaser.Types.Loader.FileTypes.BinaryFileConfig | Phaser.Types.Loader.FileTypes.BinaryFileConfig[], url?: string, dataType?: any, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an XML based Bitmap Font, or array of fonts, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * ```javascript
             * function preload ()
             * {
             *     this.load.bitmapFont('goldenFont', 'images/GoldFont.png', 'images/GoldFont.xml');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * Phaser expects the font data to be provided in an XML file format.
             * These files are created by software such as the [Angelcode Bitmap Font Generator](http://www.angelcode.com/products/bmfont/),
             * [Littera](http://kvazars.com/littera/) or [Glyph Designer](https://71squared.com/glyphdesigner)
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.bitmapFont({
             *     key: 'goldenFont',
             *     textureURL: 'images/GoldFont.png',
             *     fontDataURL: 'images/GoldFont.xml'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.BitmapFontFileConfig` for more details.
             * 
             * Once the atlas has finished loading you can use key of it when creating a Bitmap Text Game Object:
             * 
             * ```javascript
             * this.load.bitmapFont('goldenFont', 'images/GoldFont.png', 'images/GoldFont.xml');
             * // and later in your game ...
             * this.add.bitmapText(x, y, 'goldenFont', 'Hello World');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use when creating a Bitmap Text object.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.bitmapFont('goldenFont', [ 'images/GoldFont.png', 'images/GoldFont-n.png' ], 'images/GoldFont.xml');
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.bitmapFont({
             *     key: 'goldenFont',
             *     textureURL: 'images/GoldFont.png',
             *     normalMap: 'images/GoldFont-n.png',
             *     fontDataURL: 'images/GoldFont.xml'
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * Note: The ability to load this type of file will only be available if the Bitmap Font File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param textureURL The absolute or relative URL to load the font image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param fontDataURL The absolute or relative URL to load the font xml data file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
             * @param textureXhrSettings An XHR Settings configuration object for the font image file. Used in replacement of the Loaders default XHR Settings.
             * @param fontDataXhrSettings An XHR Settings configuration object for the font data xml file. Used in replacement of the Loaders default XHR Settings.
             */
            bitmapFont(key: string | Phaser.Types.Loader.FileTypes.BitmapFontFileConfig | Phaser.Types.Loader.FileTypes.BitmapFontFileConfig[], textureURL?: string | string[], fontDataURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, fontDataXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Compressed Texture file to the current load queue. This feature is WebGL only.
             * 
             * This method takes a key and a configuration object, which lists the different formats
             * and files associated with them.
             * 
             * The texture format object should be ordered in GPU priority order, with IMG as the last entry.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * preload ()
             * {
             *     this.load.texture('yourPic', {
             *         ASTC: { type: 'PVR', textureURL: 'pic-astc-4x4.pvr' },
             *         PVRTC: { type: 'PVR', textureURL: 'pic-pvrtc-4bpp-rgba.pvr' },
             *         S3TC: { type: 'PVR', textureURL: 'pic-dxt5.pvr' },
             *         IMG: { textureURL: 'pic.png' }
             *     });
             * ```
             * 
             * If you wish to load a texture atlas, provide the `atlasURL` property:
             * 
             * ```javascript
             * preload ()
             * {
             *     const path = 'assets/compressed';
             * 
             *     this.load.texture('yourAtlas', {
             *         'ASTC': { type: 'PVR', textureURL: `${path}/textures-astc-4x4.pvr`, atlasURL: `${path}/textures.json` },
             *         'PVRTC': { type: 'PVR', textureURL: `${path}/textures-pvrtc-4bpp-rgba.pvr`, atlasURL: `${path}/textures-pvrtc-4bpp-rgba.json` },
             *         'S3TC': { type: 'PVR', textureURL: `${path}/textures-dxt5.pvr`, atlasURL: `${path}/textures-dxt5.json` },
             *         'IMG': { textureURL: `${path}/textures.png`, atlasURL: `${path}/textures.json` }
             *     });
             * }
             * ```
             * 
             * If you wish to load a Multi Atlas, as exported from Texture Packer Pro, use the `multiAtlasURL` property instead:
             * 
             * ```javascript
             * preload ()
             * {
             *     const path = 'assets/compressed';
             * 
             *     this.load.texture('yourAtlas', {
             *         'ASTC': { type: 'PVR', atlasURL: `${path}/textures.json` },
             *         'PVRTC': { type: 'PVR', atlasURL: `${path}/textures-pvrtc-4bpp-rgba.json` },
             *         'S3TC': { type: 'PVR', atlasURL: `${path}/textures-dxt5.json` },
             *         'IMG': { atlasURL: `${path}/textures.json` }
             *     });
             * }
             * ```
             * 
             * When loading a Multi Atlas you do not need to specify the `textureURL` property as it will be read from the JSON file.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.texture({
             *     key: 'yourPic',
             *     url: {
             *         ASTC: { type: 'PVR', textureURL: 'pic-astc-4x4.pvr' },
             *         PVRTC: { type: 'PVR', textureURL: 'pic-pvrtc-4bpp-rgba.pvr' },
             *         S3TC: { type: 'PVR', textureURL: 'pic-dxt5.pvr' },
             *         IMG: { textureURL: 'pic.png' }
             *    }
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.CompressedTextureFileConfig` for more details.
             * 
             * The number of formats you provide to this function is up to you, but you should ensure you
             * cover the primary platforms where appropriate.
             * 
             * The 'IMG' entry is a fallback to a JPG or PNG, should the browser be unable to load any of the other
             * formats presented to this function. You should really always include this, although it is optional.
             * 
             * Phaser supports loading both the PVR and KTX container formats. Within those, it can parse
             * the following texture compression formats:
             * 
             * ETC
             * ETC1
             * ATC
             * ASTC
             * BPTC
             * RGTC
             * PVRTC
             * S3TC
             * S3TCSRGB
             * 
             * For more information about the benefits of compressed textures please see the
             * following articles:
             * 
             * Texture Compression in 2020 (https://aras-p.info/blog/2020/12/08/Texture-Compression-in-2020/)
             * Compressed GPU Texture Formats (https://themaister.net/blog/2020/08/12/compressed-gpu-texture-formats-a-review-and-compute-shader-decoders-part-1/)
             * 
             * To create compressed texture files use a 3rd party application such as:
             * 
             * Texture Packer (https://www.codeandweb.com/texturepacker/tutorials/how-to-create-sprite-sheets-for-phaser3?utm_source=ad&utm_medium=banner&utm_campaign=phaser-2018-10-16)
             * PVRTexTool (https://developer.imaginationtech.com/pvrtextool/) - available for Windows, macOS and Linux.
             * Mali Texture Compression Tool (https://developer.arm.com/tools-and-software/graphics-and-gaming/mali-texture-compression-tool)
             * ASTC Encoder (https://github.com/ARM-software/astc-encoder)
             * 
             * ASTCs must have a Channel Type of Unsigned Normalized Bytes (UNorm) and a Linear RGB Color Space.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Data` the final key will be `LEVEL1.Data` and
             * this is what you would use to retrieve the text from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * Unlike other file loaders in Phaser, the URLs must include the file extension.
             * 
             * Note: The ability to load this type of file will only be available if the Compressed Texture File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The compressed texture configuration object. Not required if passing a config object as the `key` parameter.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            texture(key: string | Phaser.Types.Loader.FileTypes.CompressedTextureFileConfig | Phaser.Types.Loader.FileTypes.CompressedTextureFileConfig[], url?: Phaser.Types.Loader.FileTypes.CompressedTextureFileConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a CSS file, or array of CSS files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.css('headers', 'styles/headers.css');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String and not already in-use by another file in the Loader.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.css({
             *     key: 'headers',
             *     url: 'styles/headers.css'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.CSSFileConfig` for more details.
             * 
             * Once the file has finished loading it will automatically be converted into a style DOM element
             * via `document.createElement('style')`. It will have its `defer` property set to false and then the
             * resulting element will be appended to `document.head`. The CSS styles are then applied to the current document.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.css". It will always add `.css` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the CSS File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.css`, i.e. if `key` was "alien" then the URL will be "alien.css".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            css(key: string | Phaser.Types.Loader.FileTypes.CSSFileConfig | Phaser.Types.Loader.FileTypes.CSSFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a GLSL file, or array of GLSL files, to the current load queue.
             * In Phaser 3 GLSL files are just plain Text files at the current moment in time.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.glsl('plasma', 'shaders/Plasma.glsl');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Shader Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Shader Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Shader Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.glsl({
             *     key: 'plasma',
             *     shaderType: 'fragment',
             *     url: 'shaders/Plasma.glsl'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.GLSLFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.glsl('plasma', 'shaders/Plasma.glsl');
             * // and later in your game ...
             * var data = this.cache.shader.get('plasma');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `FX.` and the key was `Plasma` the final key will be `FX.Plasma` and
             * this is what you would use to retrieve the text from the Shader Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "plasma"
             * and no URL is given then the Loader will set the URL to be "plasma.glsl". It will always add `.glsl` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the GLSL File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.glsl`, i.e. if `key` was "alien" then the URL will be "alien.glsl".
             * @param shaderType The type of shader. Either `fragment` for a fragment shader, or `vertex` for a vertex shader. This is ignored if you load a shader bundle. Default 'fragment'.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            glsl(key: string | Phaser.Types.Loader.FileTypes.GLSLFileConfig | Phaser.Types.Loader.FileTypes.GLSLFileConfig[], url?: string, shaderType?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an HTML file, or array of HTML files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.html('story', 'files/LoginForm.html');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global HTML Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the HTML Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the HTML Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.html({
             *     key: 'login',
             *     url: 'files/LoginForm.html'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.HTMLFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.html('login', 'files/LoginForm.html');
             * // and later in your game ...
             * var data = this.cache.html.get('login');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the html from the HTML Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "story"
             * and no URL is given then the Loader will set the URL to be "story.html". It will always add `.html` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the HTML File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.html`, i.e. if `key` was "alien" then the URL will be "alien.html".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            html(key: string | Phaser.Types.Loader.FileTypes.HTMLFileConfig | Phaser.Types.Loader.FileTypes.HTMLFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an HTML File, or array of HTML Files, to the current load queue. When the files are loaded they
             * will be rendered to textures and stored in the Texture Manager.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.htmlTexture('instructions', 'content/intro.html', 256, 512);
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.htmlTexture({
             *     key: 'instructions',
             *     url: 'content/intro.html',
             *     width: 256,
             *     height: 512
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.HTMLTextureFileConfig` for more details.
             * 
             * Once the file has finished loading you can use it as a texture for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.htmlTexture('instructions', 'content/intro.html', 256, 512);
             * // and later in your game ...
             * this.add.image(x, y, 'instructions');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.html". It will always add `.html` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * The width and height are the size of the texture to which the HTML will be rendered. It's not possible to determine these
             * automatically, so you will need to provide them, either as arguments or in the file config object.
             * When the HTML file has loaded a new SVG element is created with a size and viewbox set to the width and height given.
             * The SVG file has a body tag added to it, with the HTML file contents included. It then calls `window.Blob` on the SVG,
             * and if successful is added to the Texture Manager, otherwise it fails processing. The overall quality of the rendered
             * HTML depends on your browser, and some of them may not even support the svg / blob process used. Be aware that there are
             * limitations on what HTML can be inside an SVG. You can find out more details in this
             * [Mozilla MDN entry](https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Drawing_DOM_objects_into_a_canvas).
             * 
             * Note: The ability to load this type of file will only be available if the HTMLTextureFile File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.html`, i.e. if `key` was "alien" then the URL will be "alien.html".
             * @param width The width of the texture the HTML will be rendered to. Default 512.
             * @param height The height of the texture the HTML will be rendered to. Default 512.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            htmlTexture(key: string | Phaser.Types.Loader.FileTypes.HTMLTextureFileConfig | Phaser.Types.Loader.FileTypes.HTMLTextureFileConfig[], url?: string, width?: number, height?: number, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an Image, or array of Images, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.image('logo', 'images/phaserLogo.png');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * If you try to load an animated gif only the first frame will be rendered. Browsers do not natively support playback
             * of animated gifs to Canvas elements.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.image({
             *     key: 'logo',
             *     url: 'images/AtariLogo.png'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.ImageFileConfig` for more details.
             * 
             * Once the file has finished loading you can use it as a texture for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.image('logo', 'images/AtariLogo.png');
             * // and later in your game ...
             * this.add.image(x, y, 'logo');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.image('logo', [ 'images/AtariLogo.png', 'images/AtariLogo-n.png' ]);
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.image({
             *     key: 'logo',
             *     url: 'images/AtariLogo.png',
             *     normalMap: 'images/AtariLogo-n.png'
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * In Phaser 3.60 a new property was added that allows you to control how images are loaded. By default, images are loaded via XHR as Blobs.
             * However, you can set `loader.imageLoadType: "HTMLImageElement"` in the Game Configuration and instead, the Loader will load all images
             * via the Image tag instead.
             * 
             * Note: The ability to load this type of file will only be available if the Image File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            image(key: string | Phaser.Types.Loader.FileTypes.ImageFileConfig | Phaser.Types.Loader.FileTypes.ImageFileConfig[], url?: string | string[], xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a JSON file, or array of JSON files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.json('wavedata', 'files/AlienWaveData.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global JSON Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the JSON Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the JSON Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.json({
             *     key: 'wavedata',
             *     url: 'files/AlienWaveData.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.JSONFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.json('wavedata', 'files/AlienWaveData.json');
             * // and later in your game ...
             * var data = this.cache.json.get('wavedata');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Waves` the final key will be `LEVEL1.Waves` and
             * this is what you would use to retrieve the text from the JSON Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "data"
             * and no URL is given then the Loader will set the URL to be "data.json". It will always add `.json` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * You can also optionally provide a `dataKey` to use. This allows you to extract only a part of the JSON and store it in the Cache,
             * rather than the whole file. For example, if your JSON data had a structure like this:
             * 
             * ```json
             * {
             *     "level1": {
             *         "baddies": {
             *             "aliens": {},
             *             "boss": {}
             *         }
             *     },
             *     "level2": {},
             *     "level3": {}
             * }
             * ```
             * 
             * And you only wanted to store the `boss` data in the Cache, then you could pass `level1.baddies.boss`as the `dataKey`.
             * 
             * Note: The ability to load this type of file will only be available if the JSON File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, can be a fully formed JSON Object.
             * @param dataKey When the JSON file loads only this property will be stored in the Cache.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            json(key: string | Phaser.Types.Loader.FileTypes.JSONFileConfig | Phaser.Types.Loader.FileTypes.JSONFileConfig[], url?: object | string, dataKey?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Multi Texture Atlas, or array of multi atlases, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.multiatlas('level1', 'images/Level1.json');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * Phaser expects the atlas data to be provided in a JSON file as exported from the application Texture Packer,
             * version 4.6.3 or above, where you have made sure to use the Phaser 3 Export option.
             * 
             * The way it works internally is that you provide a URL to the JSON file. Phaser then loads this JSON, parses it and
             * extracts which texture files it also needs to load to complete the process. If the JSON also defines normal maps,
             * Phaser will load those as well.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.multiatlas({
             *     key: 'level1',
             *     atlasURL: 'images/Level1.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.MultiAtlasFileConfig` for more details.
             * 
             * Instead of passing a URL for the atlas JSON data you can also pass in a well formed JSON object instead.
             * 
             * Once the atlas has finished loading you can use frames from it as textures for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.multiatlas('level1', 'images/Level1.json');
             * // and later in your game ...
             * this.add.image(x, y, 'level1', 'background');
             * ```
             * 
             * To get a list of all available frames within an atlas please consult your Texture Atlas software.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Multi Atlas File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param atlasURL The absolute or relative URL to load the texture atlas json data file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
             * @param path Optional path to use when loading the textures defined in the atlas data.
             * @param baseURL Optional Base URL to use when loading the textures defined in the atlas data.
             * @param atlasXhrSettings An XHR Settings configuration object for the atlas json file. Used in replacement of the Loaders default XHR Settings.
             */
            multiatlas(key: string | Phaser.Types.Loader.FileTypes.MultiAtlasFileConfig | Phaser.Types.Loader.FileTypes.MultiAtlasFileConfig[], atlasURL?: string, path?: string, baseURL?: string, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an array of Script files to the current load queue.
             * 
             * The difference between this and the `ScriptFile` file type is that you give an array of scripts to this method,
             * and the scripts are then processed _exactly_ in that order. This allows you to load a bunch of scripts that
             * may have dependencies on each other without worrying about the async nature of traditional script loading.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.scripts('PostProcess', [
             *         'libs/shaders/CopyShader.js',
             *         'libs/postprocessing/EffectComposer.js',
             *         'libs/postprocessing/RenderPass.js',
             *         'libs/postprocessing/MaskPass.js',
             *         'libs/postprocessing/ShaderPass.js',
             *         'libs/postprocessing/AfterimagePass.js'
             *    ]);
             * }
             * ```
             * 
             * In the code above the script files will all be loaded in parallel but only processed (i.e. invoked) in the exact
             * order given in the array.
             * 
             * The files are **not** loaded right away. They are added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the files are queued
             * it means you cannot use the files immediately after calling this method, but must wait for the files to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String and not already in-use by another file in the Loader.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.scripts({
             *     key: 'PostProcess',
             *     url: [
             *         'libs/shaders/CopyShader.js',
             *         'libs/postprocessing/EffectComposer.js',
             *         'libs/postprocessing/RenderPass.js',
             *         'libs/postprocessing/MaskPass.js',
             *         'libs/postprocessing/ShaderPass.js',
             *         'libs/postprocessing/AfterimagePass.js'
             *        ]
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.MultiScriptFileConfig` for more details.
             * 
             * Once all the files have finished loading they will automatically be converted into a script element
             * via `document.createElement('script')`. They will have their language set to JavaScript, `defer` set to
             * false and then the resulting element will be appended to `document.head`. Any code then in the
             * script will be executed. This is done in the exact order the files are specified in the url array.
             * 
             * The URLs can be relative or absolute. If the URLs are relative the `Loader.baseURL` and `Loader.path` values will be prepended to them.
             * 
             * Note: The ability to load this type of file will only be available if the MultiScript File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url An array of absolute or relative URLs to load the script files from. They are processed in the order given in the array.
             * @param extension The default file extension to use if no url is provided. Default 'js'.
             * @param xhrSettings Extra XHR Settings specifically for these files.
             */
            scripts(key: string | Phaser.Types.Loader.FileTypes.MultiScriptFileConfig | Phaser.Types.Loader.FileTypes.MultiScriptFileConfig[], url?: string[], extension?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Wavefront OBJ file, or array of OBJ files, to the current load queue.
             * 
             * Note: You should ensure your 3D package has triangulated the OBJ file prior to export.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.obj('ufo', 'files/spaceship.obj');
             * }
             * ```
             * 
             * You can optionally also load a Wavefront Material file as well, by providing the 3rd parameter:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.obj('ufo', 'files/spaceship.obj', 'files/spaceship.mtl');
             * }
             * ```
             * 
             * If given, the material will be parsed and stored along with the obj data in the cache.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global OBJ Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the OBJ Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the OBJ Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.obj({
             *     key: 'ufo',
             *     url: 'files/spaceship.obj',
             *     matURL: 'files/spaceship.mtl',
             *     flipUV: true
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.OBJFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.obj('ufo', 'files/spaceship.obj');
             * // and later in your game ...
             * var data = this.cache.obj.get('ufo');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the obj from the OBJ Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "story"
             * and no URL is given then the Loader will set the URL to be "story.obj". It will always add `.obj` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the OBJ File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param objURL The absolute or relative URL to load the obj file from. If undefined or `null` it will be set to `<key>.obj`, i.e. if `key` was "alien" then the URL will be "alien.obj".
             * @param matURL Optional absolute or relative URL to load the obj material file from.
             * @param flipUV Flip the UV coordinates stored in the model data?
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            obj(key: string | Phaser.Types.Loader.FileTypes.OBJFileConfig | Phaser.Types.Loader.FileTypes.OBJFileConfig[], objURL?: string, matURL?: string, flipUV?: boolean, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a JSON File Pack, or array of packs, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.pack('level1', 'data/Level1Files.json');
             * }
             * ```
             * 
             * A File Pack is a JSON file (or object) that contains details about other files that should be added into the Loader.
             * Here is a small example:
             * 
             * ```json
             * {
             *    "test1": {
             *        "files": [
             *            {
             *                "type": "image",
             *                "key": "taikodrummaster",
             *                "url": "assets/pics/taikodrummaster.jpg"
             *            },
             *            {
             *                "type": "image",
             *                "key": "sukasuka-chtholly",
             *                "url": "assets/pics/sukasuka-chtholly.png"
             *            }
             *        ]
             *    },
             *    "meta": {
             *        "generated": "1401380327373",
             *        "app": "Phaser 3 Asset Packer",
             *        "url": "https://phaser.io",
             *        "version": "1.0",
             *        "copyright": "Photon Storm Ltd. 2018"
             *    }
             * }
             * ```
             * 
             * The pack can be split into sections. In the example above you'll see a section called `test1`. You can tell
             * the `load.pack` method to parse only a particular section of a pack. The pack is stored in the JSON Cache,
             * so you can pass it to the Loader to process additional sections as needed in your game, or you can just load
             * them all at once without specifying anything.
             * 
             * The pack file can contain an entry for any type of file that Phaser can load. The object structures exactly
             * match that of the file type configs, and all properties available within the file type configs can be used
             * in the pack file too. An entry's `type` is the name of the Loader method that will load it, e.g., 'image'.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * The key must be a unique String. It is used to add the file to the global JSON Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the JSON Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the JSON Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.pack({
             *     key: 'level1',
             *     url: 'data/Level1Files.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.PackFileConfig` for more details.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Waves` the final key will be `LEVEL1.Waves` and
             * this is what you would use to retrieve the text from the JSON Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "data"
             * and no URL is given then the Loader will set the URL to be "data.json". It will always add `.json` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * You can also optionally provide a `dataKey` to use. This allows you to extract only a part of the JSON and store it in the Cache,
             * rather than the whole file. For example, if your JSON data had a structure like this:
             * 
             * ```json
             * {
             *     "level1": {
             *         "baddies": {
             *             "aliens": {},
             *             "boss": {}
             *         }
             *     },
             *     "level2": {},
             *     "level3": {}
             * }
             * ```
             * 
             * And you only wanted to store the `boss` data in the Cache, then you could pass `level1.baddies.boss`as the `dataKey`.
             * 
             * Note: The ability to load this type of file will only be available if the Pack File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
             * @param dataKey When the JSON file loads only this property will be stored in the Cache.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            pack(key: string | Phaser.Types.Loader.FileTypes.PackFileConfig | Phaser.Types.Loader.FileTypes.PackFileConfig[], url?: string, dataKey?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Plugin Script file, or array of plugin files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.plugin('modplayer', 'plugins/ModPlayer.js');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String and not already in-use by another file in the Loader.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.plugin({
             *     key: 'modplayer',
             *     url: 'plugins/ModPlayer.js'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.PluginFileConfig` for more details.
             * 
             * Once the file has finished loading it will automatically be converted into a script element
             * via `document.createElement('script')`. It will have its language set to JavaScript, `defer` set to
             * false and then the resulting element will be appended to `document.head`. Any code then in the
             * script will be executed. It will then be passed to the Phaser PluginCache.register method.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.js". It will always add `.js` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Plugin File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js". Or, a plugin function.
             * @param start Automatically start the plugin after loading?
             * @param mapping If this plugin is to be injected into the Scene, this is the property key used.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            plugin(key: string | Phaser.Types.Loader.FileTypes.PluginFileConfig | Phaser.Types.Loader.FileTypes.PluginFileConfig[], url?: string | Function, start?: boolean, mapping?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an external Scene file, or array of Scene files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.sceneFile('Level1', 'src/Level1.js');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Scene Manager upon a successful load.
             * 
             * For a Scene File it's vitally important that the key matches the class name in the JavaScript file.
             * 
             * For example here is the source file:
             * 
             * ```javascript
             * class ExternalScene extends Phaser.Scene {
             * 
             *     constructor ()
             *     {
             *         super('myScene');
             *     }
             * 
             * }
             * ```
             * 
             * Because the class is called `ExternalScene` that is the exact same key you must use when loading it:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.sceneFile('ExternalScene', 'src/yourScene.js');
             * }
             * ```
             * 
             * The key that is used within the Scene Manager can either be set to the same, or you can override it in the Scene
             * constructor, as we've done in the example above, where the Scene key was changed to `myScene`.
             * 
             * The key should be unique both in terms of files being loaded and Scenes already present in the Scene Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Scene Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.sceneFile({
             *     key: 'Level1',
             *     url: 'src/Level1.js'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.SceneFileConfig` for more details.
             * 
             * Once the file has finished loading it will be added to the Scene Manager.
             * 
             * ```javascript
             * this.load.sceneFile('Level1', 'src/Level1.js');
             * // and later in your game ...
             * this.scene.start('Level1');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `WORLD1.` and the key was `Story` the final key will be `WORLD1.Story` and
             * this is what you would use to retrieve the text from the Scene Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "story"
             * and no URL is given then the Loader will set the URL to be "story.js". It will always add `.js` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Scene File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            sceneFile(key: string | Phaser.Types.Loader.FileTypes.SceneFileConfig | Phaser.Types.Loader.FileTypes.SceneFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Scene Plugin Script file, or array of plugin files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.scenePlugin('ModPlayer', 'plugins/ModPlayer.js', 'modPlayer', 'mods');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String and not already in-use by another file in the Loader.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.scenePlugin({
             *     key: 'modplayer',
             *     url: 'plugins/ModPlayer.js'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.ScenePluginFileConfig` for more details.
             * 
             * Once the file has finished loading it will automatically be converted into a script element
             * via `document.createElement('script')`. It will have its language set to JavaScript, `defer` set to
             * false and then the resulting element will be appended to `document.head`. Any code then in the
             * script will be executed. It will then be passed to the Phaser PluginCache.register method.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.js". It will always add `.js` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Script File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js". Or, set to a plugin function.
             * @param systemKey If this plugin is to be added to Scene.Systems, this is the property key for it.
             * @param sceneKey If this plugin is to be added to the Scene, this is the property key for it.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            scenePlugin(key: string | Phaser.Types.Loader.FileTypes.ScenePluginFileConfig | Phaser.Types.Loader.FileTypes.ScenePluginFileConfig[], url?: string | Function, systemKey?: string, sceneKey?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Script file, or array of Script files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.script('aliens', 'lib/aliens.js');
             * }
             * ```
             * 
             * If the script file contains a module, then you should specify that using the 'type' parameter:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.script('aliens', 'lib/aliens.js', 'module');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String and not already in-use by another file in the Loader.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.script({
             *     key: 'aliens',
             *     url: 'lib/aliens.js',
             *     type: 'script' // or 'module'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.ScriptFileConfig` for more details.
             * 
             * Once the file has finished loading it will automatically be converted into a script element
             * via `document.createElement('script')`. It will have its language set to JavaScript, `defer` set to
             * false and then the resulting element will be appended to `document.head`. Any code then in the
             * script will be executed.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.js". It will always add `.js` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Script File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.js`, i.e. if `key` was "alien" then the URL will be "alien.js".
             * @param type The script type. Should be either 'script' for classic JavaScript, or 'module' if the file contains an exported module. Default 'script'.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            script(key: string | Phaser.Types.Loader.FileTypes.ScriptFileConfig | Phaser.Types.Loader.FileTypes.ScriptFileConfig[], url?: string, type?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Sprite Sheet Image, or array of Sprite Sheet Images, to the current load queue.
             * 
             * The term 'Sprite Sheet' in Phaser means a fixed-size sheet. Where every frame in the sheet is the exact same size,
             * and you reference those frames using numbers, not frame names. This is not the same thing as a Texture Atlas, where
             * the frames are packed in a way where they take up the least amount of space, and are referenced by their names,
             * not numbers. Some articles and software use the term 'Sprite Sheet' to mean Texture Atlas, so please be aware of
             * what sort of file you're actually trying to load.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.spritesheet('bot', 'images/robot.png', { frameWidth: 32, frameHeight: 38 });
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * If you try to load an animated gif only the first frame will be rendered. Browsers do not natively support playback
             * of animated gifs to Canvas elements.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.spritesheet({
             *     key: 'bot',
             *     url: 'images/robot.png',
             *     frameConfig: {
             *         frameWidth: 32,
             *         frameHeight: 38,
             *         startFrame: 0,
             *         endFrame: 8
             *     }
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.SpriteSheetFileConfig` for more details.
             * 
             * Once the file has finished loading you can use it as a texture for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.spritesheet('bot', 'images/robot.png', { frameWidth: 32, frameHeight: 38 });
             * // and later in your game ...
             * this.add.image(x, y, 'bot', 0);
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `PLAYER.` and the key was `Running` the final key will be `PLAYER.Running` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.spritesheet('logo', [ 'images/AtariLogo.png', 'images/AtariLogo-n.png' ], { frameWidth: 256, frameHeight: 80 });
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.spritesheet({
             *     key: 'logo',
             *     url: 'images/AtariLogo.png',
             *     normalMap: 'images/AtariLogo-n.png',
             *     frameConfig: {
             *         frameWidth: 256,
             *         frameHeight: 80
             *     }
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * Note: The ability to load this type of file will only be available if the Sprite Sheet File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param frameConfig The frame configuration object. At a minimum it should have a `frameWidth` property.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            spritesheet(key: string | Phaser.Types.Loader.FileTypes.SpriteSheetFileConfig | Phaser.Types.Loader.FileTypes.SpriteSheetFileConfig[], url?: string, frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an SVG File, or array of SVG Files, to the current load queue. When the files are loaded they
             * will be rendered to bitmap textures and stored in the Texture Manager.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.svg('morty', 'images/Morty.svg');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.svg({
             *     key: 'morty',
             *     url: 'images/Morty.svg'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.SVGFileConfig` for more details.
             * 
             * Once the file has finished loading you can use it as a texture for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.svg('morty', 'images/Morty.svg');
             * // and later in your game ...
             * this.add.image(x, y, 'morty');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.html". It will always add `.html` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * You can optionally pass an SVG Resize Configuration object when you load an SVG file. By default the SVG will be rendered to a texture
             * at the same size defined in the SVG file attributes. However, this isn't always desirable. You may wish to resize the SVG (either down
             * or up) to improve texture clarity, or reduce texture memory consumption. You can either specify an exact width and height to resize
             * the SVG to:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.svg('morty', 'images/Morty.svg', { width: 300, height: 600 });
             * }
             * ```
             * 
             * Or when using a configuration object:
             * 
             * ```javascript
             * this.load.svg({
             *     key: 'morty',
             *     url: 'images/Morty.svg',
             *     svgConfig: {
             *         width: 300,
             *         height: 600
             *     }
             * });
             * ```
             * 
             * Alternatively, you can just provide a scale factor instead:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.svg('morty', 'images/Morty.svg', { scale: 2.5 });
             * }
             * ```
             * 
             * Or when using a configuration object:
             * 
             * ```javascript
             * this.load.svg({
             *     key: 'morty',
             *     url: 'images/Morty.svg',
             *     svgConfig: {
             *         scale: 2.5
             *     }
             * });
             * ```
             * 
             * If scale, width and height values are all given, the scale has priority and the width and height values are ignored.
             * 
             * Note: The ability to load this type of file will only be available if the SVG File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.svg`, i.e. if `key` was "alien" then the URL will be "alien.svg".
             * @param svgConfig The svg size configuration object.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            svg(key: string | Phaser.Types.Loader.FileTypes.SVGFileConfig | Phaser.Types.Loader.FileTypes.SVGFileConfig[], url?: string, svgConfig?: Phaser.Types.Loader.FileTypes.SVGSizeConfig, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Text file, or array of Text files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.text('story', 'files/IntroStory.txt');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Text Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Text Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Text Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.text({
             *     key: 'story',
             *     url: 'files/IntroStory.txt'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.TextFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.text('story', 'files/IntroStory.txt');
             * // and later in your game ...
             * var data = this.cache.text.get('story');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the text from the Text Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "story"
             * and no URL is given then the Loader will set the URL to be "story.txt". It will always add `.txt` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Text File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.txt`, i.e. if `key` was "alien" then the URL will be "alien.txt".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            text(key: string | Phaser.Types.Loader.FileTypes.TextFileConfig | Phaser.Types.Loader.FileTypes.TextFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a CSV Tilemap file, or array of CSV files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.tilemapCSV('level1', 'maps/Level1.csv');
             * }
             * ```
             * 
             * Tilemap CSV data can be created in a text editor, or a 3rd party app that exports as CSV.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Tilemap Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Tilemap Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Text Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.tilemapCSV({
             *     key: 'level1',
             *     url: 'maps/Level1.csv'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.TilemapCSVFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.tilemapCSV('level1', 'maps/Level1.csv');
             * // and later in your game ...
             * var map = this.make.tilemap({ key: 'level1' });
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the text from the Tilemap Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "level"
             * and no URL is given then the Loader will set the URL to be "level.csv". It will always add `.csv` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Tilemap CSV File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.csv`, i.e. if `key` was "alien" then the URL will be "alien.csv".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            tilemapCSV(key: string | Phaser.Types.Loader.FileTypes.TilemapCSVFileConfig | Phaser.Types.Loader.FileTypes.TilemapCSVFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds an Impact.js Tilemap file, or array of map files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.tilemapImpact('level1', 'maps/Level1.json');
             * }
             * ```
             * 
             * Impact Tilemap data is created the Impact.js Map Editor called Weltmeister.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Tilemap Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Tilemap Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Text Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.tilemapImpact({
             *     key: 'level1',
             *     url: 'maps/Level1.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.TilemapImpactFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.tilemapImpact('level1', 'maps/Level1.json');
             * // and later in your game ...
             * var map = this.make.tilemap({ key: 'level1' });
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the text from the Tilemap Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "level"
             * and no URL is given then the Loader will set the URL to be "level.json". It will always add `.json` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Tilemap Impact File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            tilemapImpact(key: string | Phaser.Types.Loader.FileTypes.TilemapImpactFileConfig | Phaser.Types.Loader.FileTypes.TilemapImpactFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Tiled JSON Tilemap file, or array of map files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.tilemapTiledJSON('level1', 'maps/Level1.json');
             * }
             * ```
             * 
             * The Tilemap data is created using the Tiled Map Editor and selecting JSON as the export format.
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Tilemap Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Tilemap Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Text Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.tilemapTiledJSON({
             *     key: 'level1',
             *     url: 'maps/Level1.json'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.TilemapJSONFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.tilemapTiledJSON('level1', 'maps/Level1.json');
             * // and later in your game ...
             * var map = this.make.tilemap({ key: 'level1' });
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Story` the final key will be `LEVEL1.Story` and
             * this is what you would use to retrieve the text from the Tilemap Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "level"
             * and no URL is given then the Loader will set the URL to be "level.json". It will always add `.json` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the Tilemap JSON File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.json`, i.e. if `key` was "alien" then the URL will be "alien.json". Or, a well formed JSON object.
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            tilemapTiledJSON(key: string | Phaser.Types.Loader.FileTypes.TilemapJSONFileConfig | Phaser.Types.Loader.FileTypes.TilemapJSONFileConfig[], url?: object | string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Unity YAML based Texture Atlas, or array of atlases, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.unityAtlas('mainmenu', 'images/MainMenu.png', 'images/MainMenu.txt');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * If you call this from outside of `preload` then you are responsible for starting the Loader afterwards and monitoring
             * its events to know when it's safe to use the asset. Please see the Phaser.Loader.LoaderPlugin class for more details.
             * 
             * Phaser expects the atlas data to be provided in a YAML formatted text file as exported from Unity.
             * 
             * Phaser can load all common image types: png, jpg, gif and any other format the browser can natively handle.
             * 
             * The key must be a unique String. It is used to add the file to the global Texture Manager upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Texture Manager.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Texture Manager first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.unityAtlas({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     atlasURL: 'images/MainMenu.txt'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.UnityAtlasFileConfig` for more details.
             * 
             * Once the atlas has finished loading you can use frames from it as textures for a Game Object by referencing its key:
             * 
             * ```javascript
             * this.load.unityAtlas('mainmenu', 'images/MainMenu.png', 'images/MainMenu.json');
             * // and later in your game ...
             * this.add.image(x, y, 'mainmenu', 'background');
             * ```
             * 
             * To get a list of all available frames within an atlas please consult your Texture Atlas software.
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `MENU.` and the key was `Background` the final key will be `MENU.Background` and
             * this is what you would use to retrieve the image from the Texture Manager.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "alien"
             * and no URL is given then the Loader will set the URL to be "alien.png". It will always add `.png` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Phaser also supports the automatic loading of associated normal maps. If you have a normal map to go with this image,
             * then you can specify it by providing an array as the `url` where the second element is the normal map:
             * 
             * ```javascript
             * this.load.unityAtlas('mainmenu', [ 'images/MainMenu.png', 'images/MainMenu-n.png' ], 'images/MainMenu.txt');
             * ```
             * 
             * Or, if you are using a config object use the `normalMap` property:
             * 
             * ```javascript
             * this.load.unityAtlas({
             *     key: 'mainmenu',
             *     textureURL: 'images/MainMenu.png',
             *     normalMap: 'images/MainMenu-n.png',
             *     atlasURL: 'images/MainMenu.txt'
             * });
             * ```
             * 
             * The normal map file is subject to the same conditions as the image file with regard to the path, baseURL, CORs and XHR Settings.
             * Normal maps are a WebGL only feature.
             * 
             * Note: The ability to load this type of file will only be available if the Unity Atlas File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param textureURL The absolute or relative URL to load the texture image file from. If undefined or `null` it will be set to `<key>.png`, i.e. if `key` was "alien" then the URL will be "alien.png".
             * @param atlasURL The absolute or relative URL to load the texture atlas data file from. If undefined or `null` it will be set to `<key>.txt`, i.e. if `key` was "alien" then the URL will be "alien.txt".
             * @param textureXhrSettings An XHR Settings configuration object for the atlas image file. Used in replacement of the Loaders default XHR Settings.
             * @param atlasXhrSettings An XHR Settings configuration object for the atlas data file. Used in replacement of the Loaders default XHR Settings.
             */
            unityAtlas(key: string | Phaser.Types.Loader.FileTypes.UnityAtlasFileConfig | Phaser.Types.Loader.FileTypes.UnityAtlasFileConfig[], textureURL?: string | string[], atlasURL?: string, textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject, atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * Adds a Video file, or array of video files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.video('intro', [ 'video/level1.mp4', 'video/level1.webm', 'video/level1.mov' ]);
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global Video Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the Video Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the Video Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.video({
             *     key: 'intro',
             *     url: [ 'video/level1.mp4', 'video/level1.webm', 'video/level1.mov' ],
             *     noAudio: true
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.VideoFileConfig` for more details.
             * 
             * The URLs can be relative or absolute. If the URLs are relative the `Loader.baseURL` and `Loader.path` values will be prepended to them.
             * 
             * Due to different browsers supporting different video file types you should usually provide your video files in a variety of formats.
             * mp4, mov and webm are the most common. If you provide an array of URLs then the Loader will determine which _one_ file to load based on
             * browser support, starting with the first in the array and progressing to the end.
             * 
             * Unlike most asset-types, videos do not _need_ to be preloaded. You can create a Video Game Object and then call its `loadURL` method,
             * to load a video at run-time, rather than in advance.
             * 
             * Note: The ability to load this type of file will only be available if the Video File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param urls The absolute or relative URL to load the video files from.
             * @param noAudio Does the video have an audio track? If not you can enable auto-playing on it. Default false.
             */
            video(key: string | Phaser.Types.Loader.FileTypes.VideoFileConfig | Phaser.Types.Loader.FileTypes.VideoFileConfig[], urls?: string | string[] | Phaser.Types.Loader.FileTypes.VideoFileURLConfig | Phaser.Types.Loader.FileTypes.VideoFileURLConfig[], noAudio?: boolean): this;

            /**
             * Adds an XML file, or array of XML files, to the current load queue.
             * 
             * You can call this method from within your Scene's `preload`, along with any other files you wish to load:
             * 
             * ```javascript
             * function preload ()
             * {
             *     this.load.xml('wavedata', 'files/AlienWaveData.xml');
             * }
             * ```
             * 
             * The file is **not** loaded right away. It is added to a queue ready to be loaded either when the loader starts,
             * or if it's already running, when the next free load slot becomes available. This happens automatically if you
             * are calling this from within the Scene's `preload` method, or a related callback. Because the file is queued
             * it means you cannot use the file immediately after calling this method, but must wait for the file to complete.
             * The typical flow for a Phaser Scene is that you load assets in the Scene's `preload` method and then when the
             * Scene's `create` method is called you are guaranteed that all of those assets are ready for use and have been
             * loaded.
             * 
             * The key must be a unique String. It is used to add the file to the global XML Cache upon a successful load.
             * The key should be unique both in terms of files being loaded and files already present in the XML Cache.
             * Loading a file using a key that is already taken will result in a warning. If you wish to replace an existing file
             * then remove it from the XML Cache first, before loading a new one.
             * 
             * Instead of passing arguments you can pass a configuration object, such as:
             * 
             * ```javascript
             * this.load.xml({
             *     key: 'wavedata',
             *     url: 'files/AlienWaveData.xml'
             * });
             * ```
             * 
             * See the documentation for `Phaser.Types.Loader.FileTypes.XMLFileConfig` for more details.
             * 
             * Once the file has finished loading you can access it from its Cache using its key:
             * 
             * ```javascript
             * this.load.xml('wavedata', 'files/AlienWaveData.xml');
             * // and later in your game ...
             * var data = this.cache.xml.get('wavedata');
             * ```
             * 
             * If you have specified a prefix in the loader, via `Loader.setPrefix` then this value will be prepended to this files
             * key. For example, if the prefix was `LEVEL1.` and the key was `Waves` the final key will be `LEVEL1.Waves` and
             * this is what you would use to retrieve the text from the XML Cache.
             * 
             * The URL can be relative or absolute. If the URL is relative the `Loader.baseURL` and `Loader.path` values will be prepended to it.
             * 
             * If the URL isn't specified the Loader will take the key and create a filename from that. For example if the key is "data"
             * and no URL is given then the Loader will set the URL to be "data.xml". It will always add `.xml` as the extension, although
             * this can be overridden if using an object instead of method arguments. If you do not desire this action then provide a URL.
             * 
             * Note: The ability to load this type of file will only be available if the XML File type has been built into Phaser.
             * It is available in the default build but can be excluded from custom builds.
             * @param key The key to use for this file, or a file configuration object, or array of them.
             * @param url The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.xml`, i.e. if `key` was "alien" then the URL will be "alien.xml".
             * @param xhrSettings An XHR Settings configuration object. Used in replacement of the Loaders default XHR Settings.
             */
            xml(key: string | Phaser.Types.Loader.FileTypes.XMLFileConfig | Phaser.Types.Loader.FileTypes.XMLFileConfig[], url?: string, xhrSettings?: Phaser.Types.Loader.XHRSettingsObject): this;

            /**
             * The Scene which owns this Loader instance.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Scene Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * A reference to the global Cache Manager.
             */
            cacheManager: Phaser.Cache.CacheManager;

            /**
             * A reference to the global Texture Manager.
             */
            textureManager: Phaser.Textures.TextureManager;

            /**
             * A reference to the global Scene Manager.
             */
            protected sceneManager: Phaser.Scenes.SceneManager;

            /**
             * An optional prefix that is automatically prepended to the start of every file key.
             * If prefix was `MENU.` and you load an image with the key 'Background' the resulting key would be `MENU.Background`.
             * You can set this directly, or call `Loader.setPrefix()`. It will then affect every file added to the Loader
             * from that point on. It does _not_ change any file already in the load queue.
             */
            prefix: string;

            /**
             * The value of `path`, if set, is placed before any _relative_ file path given. For example:
             * 
             * ```javascript
             * this.load.path = "images/sprites/";
             * this.load.image("ball", "ball.png");
             * this.load.image("tree", "level1/oaktree.png");
             * this.load.image("boom", "http://server.com/explode.png");
             * ```
             * 
             * Would load the `ball` file from `images/sprites/ball.png` and the tree from
             * `images/sprites/level1/oaktree.png` but the file `boom` would load from the URL
             * given as it's an absolute URL.
             * 
             * Please note that the path is added before the filename but *after* the baseURL (if set.)
             * 
             * If you set this property directly then it _must_ end with a "/". Alternatively, call `setPath()` and it'll do it for you.
             */
            path: string;

            /**
             * If you want to append a URL before the path of any asset you can set this here.
             * 
             * Useful if allowing the asset base url to be configured outside of the game code.
             * 
             * If you set this property directly then it _must_ end with a "/". Alternatively, call `setBaseURL()` and it'll do it for you.
             */
            baseURL: string;

            /**
             * The number of concurrent / parallel resources to try and fetch at once.
             * 
             * Old browsers limit 6 requests per domain; modern ones, especially those with HTTP/2 don't limit it at all.
             * 
             * The default is 32 but you can change this in your Game Config, or by changing this property before the Loader starts.
             */
            maxParallelDownloads: number;

            /**
             * xhr specific global settings (can be overridden on a per-file basis)
             */
            xhr: Phaser.Types.Loader.XHRSettingsObject;

            /**
             * The crossOrigin value applied to loaded images. Very often this needs to be set to 'anonymous'.
             */
            crossOrigin: string;

            /**
             * Optional load type for image files. `XHR` is the default. Set to `HTMLImageElement` to load images using the Image tag instead.
             */
            imageLoadType: string;

            /**
             * An array of all schemes that the Loader considers as being 'local'.
             * 
             * This is populated by the `Phaser.Core.Config#loaderLocalScheme` game configuration setting and defaults to
             * `[ 'file://', 'capacitor://' ]`. Additional local schemes can be added to this array as needed.
             */
            localSchemes: string[];

            /**
             * The total number of files to load. It may not always be accurate because you may add to the Loader during the process
             * of loading, especially if you load a Pack File. Therefore this value can change, but in most cases remains static.
             */
            totalToLoad: number;

            /**
             * The progress of the current load queue, as a float value between 0 and 1.
             * This is updated automatically as files complete loading.
             * Note that it is possible for this value to go down again if you add content to the current load queue during a load.
             */
            progress: number;

            /**
             * Files are placed in this Set when they're added to the Loader via `addFile`.
             * 
             * They are moved to the `inflight` Set when they start loading, and assuming a successful
             * load, to the `queue` Set for further processing.
             * 
             * By the end of the load process this Set will be empty.
             */
            list: Phaser.Structs.Set<Phaser.Loader.File>;

            /**
             * Files are stored in this Set while they're in the process of being loaded.
             * 
             * Upon a successful load they are moved to the `queue` Set.
             * 
             * By the end of the load process this Set will be empty.
             */
            inflight: Phaser.Structs.Set<Phaser.Loader.File>;

            /**
             * Files are stored in this Set while they're being processed.
             * 
             * If the process is successful they are moved to their final destination, which could be
             * a Cache or the Texture Manager.
             * 
             * At the end of the load process this Set will be empty.
             */
            queue: Phaser.Structs.Set<Phaser.Loader.File>;

            /**
             * The total number of files that failed to load during the most recent load.
             * This value is reset when you call `Loader.start`.
             */
            totalFailed: number;

            /**
             * The total number of files that successfully loaded during the most recent load.
             * This value is reset when you call `Loader.start`.
             */
            totalComplete: number;

            /**
             * The current state of the Loader.
             */
            readonly state: number;

            /**
             * If you want to append a URL before the path of any asset you can set this here.
             * 
             * Useful if allowing the asset base url to be configured outside of the game code.
             * 
             * Once a base URL is set it will affect every file loaded by the Loader from that point on. It does _not_ change any
             * file _already_ being loaded. To reset it, call this method with no arguments.
             * @param url The URL to use. Leave empty to reset.
             */
            setBaseURL(url?: string): this;

            /**
             * The value of `path`, if set, is placed before any _relative_ file path given. For example:
             * 
             * ```javascript
             * this.load.setPath("images/sprites/");
             * this.load.image("ball", "ball.png");
             * this.load.image("tree", "level1/oaktree.png");
             * this.load.image("boom", "http://server.com/explode.png");
             * ```
             * 
             * Would load the `ball` file from `images/sprites/ball.png` and the tree from
             * `images/sprites/level1/oaktree.png` but the file `boom` would load from the URL
             * given as it's an absolute URL.
             * 
             * Please note that the path is added before the filename but *after* the baseURL (if set.)
             * 
             * Once a path is set it will then affect every file added to the Loader from that point on. It does _not_ change any
             * file _already_ in the load queue. To reset it, call this method with no arguments.
             * @param path The path to use. Leave empty to reset.
             */
            setPath(path?: string): this;

            /**
             * An optional prefix that is automatically prepended to the start of every file key.
             * 
             * If prefix was `MENU.` and you load an image with the key 'Background' the resulting key would be `MENU.Background`.
             * 
             * Once a prefix is set it will then affect every file added to the Loader from that point on. It does _not_ change any
             * file _already_ in the load queue. To reset it, call this method with no arguments.
             * @param prefix The prefix to use. Leave empty to reset.
             */
            setPrefix(prefix?: string): this;

            /**
             * Sets the Cross Origin Resource Sharing value used when loading files.
             * 
             * Files can override this value on a per-file basis by specifying an alternative `crossOrigin` value in their file config.
             * 
             * Once CORs is set it will then affect every file loaded by the Loader from that point on, as long as they don't have
             * their own CORs setting. To reset it, call this method with no arguments.
             * 
             * For more details about CORs see https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS
             * @param crossOrigin The value to use for the `crossOrigin` property in the load request.
             */
            setCORS(crossOrigin?: string): this;

            /**
             * Adds a file, or array of files, into the load queue.
             * 
             * The file must be an instance of `Phaser.Loader.File`, or a class that extends it. The Loader will check that the key
             * used by the file won't conflict with any other key either in the loader, the inflight queue or the target cache.
             * If allowed it will then add the file into the pending list, read for the load to start. Or, if the load has already
             * started, ready for the next batch of files to be pulled from the list to the inflight queue.
             * 
             * You should not normally call this method directly, but rather use one of the Loader methods like `image` or `atlas`,
             * however you can call this as long as the file given to it is well formed.
             * @param file The file, or array of files, to be added to the load queue.
             */
            addFile(file: Phaser.Loader.File | Phaser.Loader.File[]): void;

            /**
             * Checks the key and type of the given file to see if it will conflict with anything already
             * in a Cache, the Texture Manager, or the list or inflight queues.
             * @param file The file to check the key of.
             */
            keyExists(file: Phaser.Loader.File): boolean;

            /**
             * Takes a well formed, fully parsed pack file object and adds its entries into the load queue. Usually you do not call
             * this method directly, but instead use `Loader.pack` and supply a path to a JSON file that holds the
             * pack data. However, if you've got the data prepared you can pass it to this method.
             * 
             * You can also provide an optional key. If you do then it will only add the entries from that part of the pack into
             * to the load queue. If not specified it will add all entries it finds. For more details about the pack file format
             * see the `LoaderPlugin.pack` method.
             * @param pack The Pack File data to be parsed and each entry of it to added to the load queue.
             * @param packKey An optional key to use from the pack file data.
             */
            addPack(pack: any, packKey?: string): boolean;

            /**
             * Is the Loader actively loading, or processing loaded files?
             */
            isLoading(): boolean;

            /**
             * Is the Loader ready to start a new load?
             */
            isReady(): boolean;

            /**
             * Starts the Loader running. This will reset the progress and totals and then emit a `start` event.
             * If there is nothing in the queue the Loader will immediately complete, otherwise it will start
             * loading the first batch of files.
             * 
             * The Loader is started automatically if the queue is populated within your Scenes `preload` method.
             * 
             * However, outside of this, you need to call this method to start it.
             * 
             * If the Loader is already running this method will simply return.
             */
            start(): void;

            /**
             * Called automatically during the load process.
             * It updates the `progress` value and then emits a progress event, which you can use to
             * display a loading bar in your game.
             */
            updateProgress(): void;

            /**
             * Called automatically during the load process.
             */
            update(): void;

            /**
             * An internal method called automatically by the XHRLoader belong to a File.
             * 
             * This method will remove the given file from the inflight Set and update the load progress.
             * If the file was successful its `onProcess` method is called, otherwise it is added to the delete queue.
             * @param file The File that just finished loading, or errored during load.
             * @param success `true` if the file loaded successfully, otherwise `false`.
             */
            nextFile(file: Phaser.Loader.File, success: boolean): void;

            /**
             * An internal method that is called automatically by the File when it has finished processing.
             * 
             * If the process was successful, and the File isn't part of a MultiFile, its `addToCache` method is called.
             * 
             * It this then removed from the queue. If there are no more files to load `loadComplete` is called.
             * @param file The file that has finished processing.
             */
            fileProcessComplete(file: Phaser.Loader.File): void;

            /**
             * Called at the end when the load queue is exhausted and all files have either loaded or errored.
             * By this point every loaded file will now be in its associated cache and ready for use.
             * 
             * Also clears down the Sets, puts progress to 1 and clears the deletion queue.
             */
            loadComplete(): void;

            /**
             * Adds a File into the pending-deletion queue.
             * @param file The File to be queued for deletion when the Loader completes.
             */
            flagForRemoval(file: Phaser.Loader.File): void;

            /**
             * Converts the given JSON data into a file that the browser then prompts you to download so you can save it locally.
             * 
             * The data must be well formed JSON and ready-parsed, not a JavaScript object.
             * @param data The JSON data, ready parsed.
             * @param filename The name to save the JSON file as. Default file.json.
             */
            saveJSON(data: any, filename?: string): this;

            /**
             * Causes the browser to save the given data as a file to its default Downloads folder.
             * 
             * Creates a DOM level anchor link, assigns it as being a `download` anchor, sets the href
             * to be an ObjectURL based on the given data, and then invokes a click event.
             * @param data The data to be saved. Will be passed through URL.createObjectURL.
             * @param filename The filename to save the file as. Default file.json.
             * @param filetype The file type to use when saving the file. Defaults to JSON. Default application/json.
             */
            save(data: any, filename?: string, filetype?: string): this;

            /**
             * Resets the Loader.
             * 
             * This will clear all lists and reset the base URL, path and prefix.
             * 
             * Warning: If the Loader is currently downloading files, or has files in its queue, they will be aborted.
             */
            reset(): void;

        }

        /**
         * Takes two XHRSettings Objects and creates a new XHRSettings object from them.
         * 
         * The new object is seeded by the values given in the global settings, but any setting in
         * the local object overrides the global ones.
         * @param global The global XHRSettings object.
         * @param local The local XHRSettings object.
         */
        function MergeXHRSettings(global: Phaser.Types.Loader.XHRSettingsObject, local: Phaser.Types.Loader.XHRSettingsObject): Phaser.Types.Loader.XHRSettingsObject;

        /**
         * A MultiFile is a special kind of parent that contains two, or more, Files as children and looks after
         * the loading and processing of them all. It is commonly extended and used as a base class for file types such as AtlasJSON or BitmapFont.
         * 
         * You shouldn't create an instance of a MultiFile directly, but should extend it with your own class, setting a custom type and processing methods.
         */
        class MultiFile {
            /**
             * 
             * @param loader The Loader that is going to load this File.
             * @param type The file type string for sorting within the Loader.
             * @param key The key of the file within the loader.
             * @param files An array of Files that make-up this MultiFile.
             */
            constructor(loader: Phaser.Loader.LoaderPlugin, type: string, key: string, files: Phaser.Loader.File[]);

            /**
             * A reference to the Loader that is going to load this file.
             */
            loader: Phaser.Loader.LoaderPlugin;

            /**
             * The file type string for sorting within the Loader.
             */
            type: string;

            /**
             * Unique cache key (unique within its file type)
             */
            key: string;

            /**
             * Array of files that make up this MultiFile.
             */
            files: Phaser.Loader.File[];

            /**
             * The current state of the file. One of the FILE_CONST values.
             */
            state: number;

            /**
             * The completion status of this MultiFile.
             */
            complete: boolean;

            /**
             * The number of files to load.
             */
            pending: number;

            /**
             * The number of files that failed to load.
             */
            failed: number;

            /**
             * A storage container for transient data that the loading files need.
             */
            config: any;

            /**
             * A reference to the Loaders baseURL at the time this MultiFile was created.
             * Used to populate child-files.
             */
            baseURL: string;

            /**
             * A reference to the Loaders path at the time this MultiFile was created.
             * Used to populate child-files.
             */
            path: string;

            /**
             * A reference to the Loaders prefix at the time this MultiFile was created.
             * Used to populate child-files.
             */
            prefix: string;

            /**
             * Checks if this MultiFile is ready to process its children or not.
             */
            isReadyToProcess(): boolean;

            /**
             * Adds another child to this MultiFile, increases the pending count and resets the completion status.
             * @param files The File to add to this MultiFile.
             */
            addToMultiFile(files: Phaser.Loader.File): Phaser.Loader.MultiFile;

            /**
             * Called by each File when it finishes loading.
             * @param file The File that has completed processing.
             */
            onFileComplete(file: Phaser.Loader.File): void;

            /**
             * Called by each File that fails to load.
             * @param file The File that has failed to load.
             */
            onFileFailed(file: Phaser.Loader.File): void;

            /**
             * Called once all children of this multi file have been added to their caches and is now
             * ready for deletion from the Loader.
             * 
             * It will emit a `filecomplete` event from the LoaderPlugin.
             */
            pendingDestroy(): void;

            /**
             * Destroy this Multi File and any references it holds.
             */
            destroy(): void;

        }

        /**
         * Creates a new XMLHttpRequest (xhr) object based on the given File and XHRSettings
         * and starts the download of it. It uses the Files own XHRSettings and merges them
         * with the global XHRSettings object to set the xhr values before download.
         * @param file The File to download.
         * @param globalXHRSettings The global XHRSettings object.
         */
        function XHRLoader(file: Phaser.Loader.File, globalXHRSettings: Phaser.Types.Loader.XHRSettingsObject): XMLHttpRequest;

        /**
         * Creates an XHRSettings Object with default values.
         * @param responseType The responseType, such as 'text'. Default ''.
         * @param async Should the XHR request use async or not? Default true.
         * @param user Optional username for the XHR request. Default ''.
         * @param password Optional password for the XHR request. Default ''.
         * @param timeout Optional XHR timeout value. Default 0.
         * @param withCredentials Optional XHR withCredentials value. Default false.
         */
        function XHRSettings(responseType?: XMLHttpRequestResponseType, async?: boolean, user?: string, password?: string, timeout?: number, withCredentials?: boolean): Phaser.Types.Loader.XHRSettingsObject;

    }

    namespace Math {
        namespace Angle {
            /**
             * Find the angle of a segment from (x1, y1) -> (x2, y2).
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function Between(x1: number, y1: number, x2: number, y2: number): number;

            /**
             * Find the angle of a segment from (point1.x, point1.y) -> (point2.x, point2.y).
             * 
             * Calculates the angle of the vector from the first point to the second point.
             * @param point1 The first point.
             * @param point2 The second point.
             */
            function BetweenPoints(point1: Phaser.Types.Math.Vector2Like, point2: Phaser.Types.Math.Vector2Like): number;

            /**
             * Find the angle of a segment from (point1.x, point1.y) -> (point2.x, point2.y).
             * 
             * The difference between this method and {@link Phaser.Math.Angle.BetweenPoints} is that this assumes the y coordinate
             * travels down the screen.
             * @param point1 The first point.
             * @param point2 The second point.
             */
            function BetweenPointsY(point1: Phaser.Types.Math.Vector2Like, point2: Phaser.Types.Math.Vector2Like): number;

            /**
             * Find the angle of a segment from (x1, y1) -> (x2, y2).
             * 
             * The difference between this method and {@link Phaser.Math.Angle.Between} is that this assumes the y coordinate
             * travels down the screen.
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function BetweenY(x1: number, y1: number, x2: number, y2: number): number;

            /**
             * Takes an angle in Phasers default clockwise format and converts it so that
             * 0 is North, 90 is West, 180 is South and 270 is East,
             * therefore running counter-clockwise instead of clockwise.
             * 
             * You can pass in the angle from a Game Object using:
             * 
             * ```javascript
             * var converted = CounterClockwise(gameobject.rotation);
             * ```
             * 
             * All values for this function are in radians.
             * @param angle The angle to convert, in radians.
             */
            function CounterClockwise(angle: number): number;

            /**
             * Normalize an angle to the [0, 2pi] range.
             * @param angle The angle to normalize, in radians.
             */
            function Normalize(angle: number): number;

            /**
             * Returns a random angle in the range [-pi, pi].
             */
            function Random(): number;

            /**
             * Returns a random angle in the range [-180, 180].
             */
            function RandomDegrees(): number;

            /**
             * Reverse the given angle.
             * @param angle The angle to reverse, in radians.
             */
            function Reverse(angle: number): number;

            /**
             * Rotates `currentAngle` towards `targetAngle`, taking the shortest rotation distance. The `lerp` argument is the amount to rotate by in this call.
             * @param currentAngle The current angle, in radians.
             * @param targetAngle The target angle to rotate to, in radians.
             * @param lerp The lerp value to add to the current angle. Default 0.05.
             */
            function RotateTo(currentAngle: number, targetAngle: number, lerp?: number): number;

            /**
             * Gets the shortest angle between `angle1` and `angle2`.
             * 
             * Both angles must be in the range -180 to 180, which is the same clamped
             * range that `sprite.angle` uses, so you can pass in two sprite angles to
             * this method and get the shortest angle back between the two of them.
             * 
             * The angle returned will be in the same range. If the returned angle is
             * greater than 0 then it's a counter-clockwise rotation, if < 0 then it's
             * a clockwise rotation.
             * @param angle1 The first angle in the range -180 to 180.
             * @param angle2 The second angle in the range -180 to 180.
             */
            function ShortestBetween(angle1: number, angle2: number): number;

            /**
             * Wrap an angle.
             * 
             * Wraps the angle to a value in the range of -PI to PI.
             * @param angle The angle to wrap, in radians.
             */
            function Wrap(angle: number): number;

            /**
             * Wrap an angle in degrees.
             * 
             * Wraps the angle to a value in the range of -180 to 180.
             * @param angle The angle to wrap, in degrees.
             */
            function WrapDegrees(angle: number): number;

        }

        /**
         * Calculate the mean average of the given values.
         * @param values The values to average.
         */
        function Average(values: number[]): number;

        /**
         * Calculates the Bernstein basis from the three factorial coefficients.
         * @param n The first value.
         * @param i The second value.
         */
        function Bernstein(n: number, i: number): number;

        /**
         * Compute a random integer between the `min` and `max` values, inclusive.
         * @param min The minimum value.
         * @param max The maximum value.
         */
        function Between(min: number, max: number): number;

        /**
         * Calculates a Catmull-Rom value from the given points, based on an alpha of 0.5.
         * @param t The amount to interpolate by.
         * @param p0 The first control point.
         * @param p1 The second control point.
         * @param p2 The third control point.
         * @param p3 The fourth control point.
         */
        function CatmullRom(t: number, p0: number, p1: number, p2: number, p3: number): number;

        /**
         * Ceils to some place comparative to a `base`, default is 10 for decimal place.
         * 
         * The `place` is represented by the power applied to `base` to get that place.
         * @param value The value to round.
         * @param place The place to round to. Default 0.
         * @param base The base to round in. Default is 10 for decimal. Default 10.
         */
        function CeilTo(value: number, place?: number, base?: number): number;

        /**
         * Force a value within the boundaries by clamping it to the range `min`, `max`.
         * @param value The value to be clamped.
         * @param min The minimum bounds.
         * @param max The maximum bounds.
         */
        function Clamp(value: number, min: number, max: number): number;

        /**
         * The value of PI * 2.
         */
        var PI2: number;

        /**
         * The value of PI * 0.5.
         * 
         * Yes, we understand that this should actually be PI * 2, but
         * it has been like this for so long we can't change it now.
         * If you need PI * 2, use the PI2 constant instead.
         */
        var TAU: number;

        /**
         * An epsilon value (1.0e-6)
         */
        var EPSILON: number;

        /**
         * For converting degrees to radians (PI / 180)
         */
        var DEG_TO_RAD: number;

        /**
         * For converting radians to degrees (180 / PI)
         */
        var RAD_TO_DEG: number;

        /**
         * An instance of the Random Number Generator.
         * This is not set until the Game boots.
         */
        var RND: Phaser.Math.RandomDataGenerator;

        /**
         * The minimum safe integer this browser supports.
         * We use a const for backward compatibility with Internet Explorer.
         */
        var MIN_SAFE_INTEGER: number;

        /**
         * The maximum safe integer this browser supports.
         * We use a const for backward compatibility with Internet Explorer.
         */
        var MAX_SAFE_INTEGER: number;

        /**
         * Convert the given angle from degrees, to the equivalent angle in radians.
         * @param degrees The angle (in degrees) to convert to radians.
         */
        function DegToRad(degrees: number): number;

        /**
         * Calculates the positive difference of two given numbers.
         * @param a The first number in the calculation.
         * @param b The second number in the calculation.
         */
        function Difference(a: number, b: number): number;

        namespace Distance {
            /**
             * Calculate the distance between two sets of coordinates (points).
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function Between(x1: number, y1: number, x2: number, y2: number): number;

            /**
             * Calculate the distance between two points.
             * @param a The first point.
             * @param b The second point.
             */
            function BetweenPoints(a: Phaser.Types.Math.Vector2Like, b: Phaser.Types.Math.Vector2Like): number;

            /**
             * Calculate the squared distance between two points.
             * @param a The first point.
             * @param b The second point.
             */
            function BetweenPointsSquared(a: Phaser.Types.Math.Vector2Like, b: Phaser.Types.Math.Vector2Like): number;

            /**
             * Calculate the Chebyshev distance between two sets of coordinates (points).
             * 
             * Chebyshev distance (or chessboard distance) is the maximum of the horizontal and vertical distances.
             * It's the effective distance when movement can be horizontal, vertical, or diagonal.
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function Chebyshev(x1: number, y1: number, x2: number, y2: number): number;

            /**
             * Calculate the distance between two sets of coordinates (points) to the power of `pow`.
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             * @param pow The exponent.
             */
            function Power(x1: number, y1: number, x2: number, y2: number, pow: number): number;

            /**
             * Calculate the snake distance between two sets of coordinates (points).
             * 
             * Snake distance (rectilinear distance, Manhattan distance) is the sum of the horizontal and vertical distances.
             * It's the effective distance when movement is allowed only horizontally or vertically (but not both).
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function Snake(x1: number, y1: number, x2: number, y2: number): number;

            /**
             * Calculate the distance between two sets of coordinates (points), squared.
             * @param x1 The x coordinate of the first point.
             * @param y1 The y coordinate of the first point.
             * @param x2 The x coordinate of the second point.
             * @param y2 The y coordinate of the second point.
             */
            function Squared(x1: number, y1: number, x2: number, y2: number): number;

        }

        namespace Easing {
            namespace Back {
                /**
                 * Back ease-in.
                 * @param v The value to be tweened.
                 * @param overshoot The overshoot amount. Default 1.70158.
                 */
                function In(v: number, overshoot?: number): number;

                /**
                 * Back ease-in/out.
                 * @param v The value to be tweened.
                 * @param overshoot The overshoot amount. Default 1.70158.
                 */
                function InOut(v: number, overshoot?: number): number;

                /**
                 * Back ease-out.
                 * @param v The value to be tweened.
                 * @param overshoot The overshoot amount. Default 1.70158.
                 */
                function Out(v: number, overshoot?: number): number;

            }

            namespace Bounce {
                /**
                 * Bounce ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Bounce ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Bounce ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Circular {
                /**
                 * Circular ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Circular ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Circular ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Cubic {
                /**
                 * Cubic ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Cubic ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Cubic ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Elastic {
                /**
                 * Elastic ease-in.
                 * @param v The value to be tweened.
                 * @param amplitude The amplitude of the elastic ease. Default 0.1.
                 * @param period Sets how tight the sine-wave is, where smaller values are tighter waves, which result in more cycles. Default 0.1.
                 */
                function In(v: number, amplitude?: number, period?: number): number;

                /**
                 * Elastic ease-in/out.
                 * @param v The value to be tweened.
                 * @param amplitude The amplitude of the elastic ease. Default 0.1.
                 * @param period Sets how tight the sine-wave is, where smaller values are tighter waves, which result in more cycles. Default 0.1.
                 */
                function InOut(v: number, amplitude?: number, period?: number): number;

                /**
                 * Elastic ease-out.
                 * @param v The value to be tweened.
                 * @param amplitude The amplitude of the elastic ease. Default 0.1.
                 * @param period Sets how tight the sine-wave is, where smaller values are tighter waves, which result in more cycles. Default 0.1.
                 */
                function Out(v: number, amplitude?: number, period?: number): number;

            }

            namespace Expo {
                /**
                 * Exponential ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Exponential ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Exponential ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            /**
             * Linear easing (no variation).
             * @param v The value to be tweened.
             */
            function Linear(v: number): number;

            namespace Quadratic {
                /**
                 * Quadratic ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Quadratic ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Quadratic ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Quartic {
                /**
                 * Quartic ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Quartic ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Quartic ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Quintic {
                /**
                 * Quintic ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Quintic ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Quintic ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Sine {
                /**
                 * Sinusoidal ease-in.
                 * @param v The value to be tweened.
                 */
                function In(v: number): number;

                /**
                 * Sinusoidal ease-in/out.
                 * @param v The value to be tweened.
                 */
                function InOut(v: number): number;

                /**
                 * Sinusoidal ease-out.
                 * @param v The value to be tweened.
                 */
                function Out(v: number): number;

            }

            namespace Stepped {
            }

            /**
             * Stepped easing.
             * @param v The value to be tweened.
             * @param steps The number of steps in the ease. Default 1.
             */
            function Stepped(v: number, steps?: number): number;

        }

        class Euler {
            /**
             * 
             * @param x The x component.
             * @param y The y component.
             * @param z The z component.
             */
            constructor(x?: number, y?: number, z?: number);

        }

        /**
         * Calculates the factorial of a given number for integer values greater than 0.
         * @param value A positive integer to calculate the factorial of.
         */
        function Factorial(value: number): number;

        /**
         * Generate a random floating point number between the two given bounds, minimum inclusive, maximum exclusive.
         * @param min The lower bound for the float, inclusive.
         * @param max The upper bound for the float exclusive.
         */
        function FloatBetween(min: number, max: number): number;

        /**
         * Floors to some place comparative to a `base`, default is 10 for decimal place.
         * 
         * The `place` is represented by the power applied to `base` to get that place.
         * @param value The value to round.
         * @param place The place to round to. Default 0.
         * @param base The base to round in. Default is 10 for decimal. Default 10.
         */
        function FloorTo(value: number, place?: number, base?: number): number;

        /**
         * Return a value based on the range between `min` and `max` and the percentage given.
         * @param percent A value between 0 and 1 representing the percentage.
         * @param min The minimum value.
         * @param max The maximum value.
         */
        function FromPercent(percent: number, min: number, max?: number): number;

        namespace Fuzzy {
            /**
             * Calculate the fuzzy ceiling of the given value.
             * @param value The value.
             * @param epsilon The epsilon. Default 0.0001.
             */
            function Ceil(value: number, epsilon?: number): number;

            /**
             * Check whether the given values are fuzzily equal.
             * 
             * Two numbers are fuzzily equal if their difference is less than `epsilon`.
             * @param a The first value.
             * @param b The second value.
             * @param epsilon The epsilon. Default 0.0001.
             */
            function Equal(a: number, b: number, epsilon?: number): boolean;

            /**
             * Calculate the fuzzy floor of the given value.
             * @param value The value.
             * @param epsilon The epsilon. Default 0.0001.
             */
            function Floor(value: number, epsilon?: number): number;

            /**
             * Check whether `a` is fuzzily greater than `b`.
             * 
             * `a` is fuzzily greater than `b` if it is more than `b - epsilon`.
             * @param a The first value.
             * @param b The second value.
             * @param epsilon The epsilon. Default 0.0001.
             */
            function GreaterThan(a: number, b: number, epsilon?: number): boolean;

            /**
             * Check whether `a` is fuzzily less than `b`.
             * 
             * `a` is fuzzily less than `b` if it is less than `b + epsilon`.
             * @param a The first value.
             * @param b The second value.
             * @param epsilon The epsilon. Default 0.0001.
             */
            function LessThan(a: number, b: number, epsilon?: number): boolean;

        }

        /**
         * Calculate a per-ms speed from a distance and time (given in seconds).
         * @param distance The distance.
         * @param time The time, in seconds.
         */
        function GetSpeed(distance: number, time: number): number;

        namespace Interpolation {
            /**
             * A bezier interpolation method.
             * @param v The input array of values to interpolate between.
             * @param k The percentage of interpolation, between 0 and 1.
             */
            function Bezier(v: number[], k: number): number;

            /**
             * A Catmull-Rom interpolation method.
             * @param v The input array of values to interpolate between.
             * @param k The percentage of interpolation, between 0 and 1.
             */
            function CatmullRom(v: number[], k: number): number;

            /**
             * A cubic bezier interpolation method.
             * 
             * https://medium.com/@adrian_cooney/bezier-interpolation-13b68563313a
             * @param t The percentage of interpolation, between 0 and 1.
             * @param p0 The start point.
             * @param p1 The first control point.
             * @param p2 The second control point.
             * @param p3 The end point.
             */
            function CubicBezier(t: number, p0: number, p1: number, p2: number, p3: number): number;

            /**
             * A linear interpolation method.
             * @param v The input array of values to interpolate between.
             * @param k The percentage of interpolation, between 0 and 1.
             */
            function Linear(v: number[], k: number): number;

            /**
             * A quadratic bezier interpolation method.
             * @param t The percentage of interpolation, between 0 and 1.
             * @param p0 The start point.
             * @param p1 The control point.
             * @param p2 The end point.
             */
            function QuadraticBezier(t: number, p0: number, p1: number, p2: number): number;

            /**
             * A Smoother Step interpolation method.
             * @param t The percentage of interpolation, between 0 and 1.
             * @param min The minimum value, also known as the 'left edge', assumed smaller than the 'right edge'.
             * @param max The maximum value, also known as the 'right edge', assumed greater than the 'left edge'.
             */
            function SmootherStep(t: number, min: number, max: number): number;

            /**
             * A Smooth Step interpolation method.
             * @param t The percentage of interpolation, between 0 and 1.
             * @param min The minimum value, also known as the 'left edge', assumed smaller than the 'right edge'.
             * @param max The maximum value, also known as the 'right edge', assumed greater than the 'left edge'.
             */
            function SmoothStep(t: number, min: number, max: number): number;

        }

        /**
         * Check if a given value is an even number.
         * @param value The number to perform the check with.
         */
        function IsEven(value: number): boolean;

        /**
         * Check if a given value is an even number using a strict type check.
         * @param value The number to perform the check with.
         */
        function IsEvenStrict(value: number): boolean;

        /**
         * Calculates a linear (interpolation) value over t.
         * @param p0 The first point.
         * @param p1 The second point.
         * @param t The percentage between p0 and p1 to return, represented as a number between 0 and 1.
         */
        function Linear(p0: number, p1: number, t: number): number;

        /**
         * Interpolates two given Vectors and returns a new Vector between them.
         * 
         * Does not modify either of the passed Vectors.
         * @param vector1 Starting vector
         * @param vector2 Ending vector
         * @param t The percentage between vector1 and vector2 to return, represented as a number between 0 and 1. Default 0.
         */
        function LinearXY(vector1: Phaser.Math.Vector2, vector2: Phaser.Math.Vector2, t?: number): Phaser.Math.Vector2;

        /**
         * A three-dimensional matrix.
         * 
         * Defaults to the identity matrix when instantiated.
         */
        class Matrix3 {
            /**
             * 
             * @param m Optional Matrix3 to copy values from.
             */
            constructor(m?: Phaser.Math.Matrix3);

            /**
             * The matrix values.
             */
            val: Float32Array;

            /**
             * Make a clone of this Matrix3.
             */
            clone(): Phaser.Math.Matrix3;

            /**
             * This method is an alias for `Matrix3.copy`.
             * @param src The Matrix to set the values of this Matrix's from.
             */
            set(src: Phaser.Math.Matrix3): Phaser.Math.Matrix3;

            /**
             * Copy the values of a given Matrix into this Matrix.
             * @param src The Matrix to copy the values from.
             */
            copy(src: Phaser.Math.Matrix3): Phaser.Math.Matrix3;

            /**
             * Copy the values of a given Matrix4 into this Matrix3.
             * @param m The Matrix4 to copy the values from.
             */
            fromMat4(m: Phaser.Math.Matrix4): Phaser.Math.Matrix3;

            /**
             * Set the values of this Matrix from the given array.
             * @param a The array to copy the values from.
             */
            fromArray(a: any[]): Phaser.Math.Matrix3;

            /**
             * Reset this Matrix to an identity (default) matrix.
             */
            identity(): Phaser.Math.Matrix3;

            /**
             * Transpose this Matrix.
             */
            transpose(): Phaser.Math.Matrix3;

            /**
             * Invert this Matrix.
             */
            invert(): Phaser.Math.Matrix3;

            /**
             * Calculate the adjoint, or adjugate, of this Matrix.
             */
            adjoint(): Phaser.Math.Matrix3;

            /**
             * Calculate the determinant of this Matrix.
             */
            determinant(): number;

            /**
             * Multiply this Matrix by the given Matrix.
             * @param src The Matrix to multiply this Matrix by.
             */
            multiply(src: Phaser.Math.Matrix3): Phaser.Math.Matrix3;

            /**
             * Translate this Matrix using the given Vector.
             * @param v The Vector to translate this Matrix with.
             */
            translate(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Matrix3;

            /**
             * Apply a rotation transformation to this Matrix.
             * @param rad The angle in radians to rotate by.
             */
            rotate(rad: number): Phaser.Math.Matrix3;

            /**
             * Apply a scale transformation to this Matrix.
             * 
             * Uses the `x` and `y` components of the given Vector to scale the Matrix.
             * @param v The Vector to scale this Matrix with.
             */
            scale(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Matrix3;

            /**
             * Set the values of this Matrix from the given Quaternion.
             * @param q The Quaternion to set the values of this Matrix from.
             */
            fromQuat(q: Phaser.Math.Quaternion): Phaser.Math.Matrix3;

            /**
             * Set the values of this Matrix3 to be normalized from the given Matrix4.
             * @param m The Matrix4 to normalize the values from.
             */
            normalFromMat4(m: Phaser.Math.Matrix4): Phaser.Math.Matrix3;

        }

        /**
         * A four-dimensional matrix.
         * 
         * Adapted from [gl-matrix](https://github.com/toji/gl-matrix) by toji
         * and [vecmath](https://github.com/mattdesl/vecmath) by mattdesl
         */
        class Matrix4 {
            /**
             * 
             * @param m Optional Matrix4 to copy values from.
             */
            constructor(m?: Phaser.Math.Matrix4);

            /**
             * The matrix values.
             */
            val: Float32Array;

            /**
             * Make a clone of this Matrix4.
             */
            clone(): Phaser.Math.Matrix4;

            /**
             * This method is an alias for `Matrix4.copy`.
             * @param src The Matrix to set the values of this Matrix's from.
             */
            set(src: Phaser.Math.Matrix4): this;

            /**
             * Sets all values of this Matrix4.
             * @param m00 The m00 value.
             * @param m01 The m01 value.
             * @param m02 The m02 value.
             * @param m03 The m03 value.
             * @param m10 The m10 value.
             * @param m11 The m11 value.
             * @param m12 The m12 value.
             * @param m13 The m13 value.
             * @param m20 The m20 value.
             * @param m21 The m21 value.
             * @param m22 The m22 value.
             * @param m23 The m23 value.
             * @param m30 The m30 value.
             * @param m31 The m31 value.
             * @param m32 The m32 value.
             * @param m33 The m33 value.
             */
            setValues(m00: number, m01: number, m02: number, m03: number, m10: number, m11: number, m12: number, m13: number, m20: number, m21: number, m22: number, m23: number, m30: number, m31: number, m32: number, m33: number): this;

            /**
             * Copy the values of a given Matrix into this Matrix.
             * @param src The Matrix to copy the values from.
             */
            copy(src: Phaser.Math.Matrix4): this;

            /**
             * Set the values of this Matrix from the given array.
             * @param a The array to copy the values from. Must have at least 16 elements.
             */
            fromArray(a: number[]): this;

            /**
             * Reset this Matrix.
             * 
             * Sets all values to `0`.
             */
            zero(): Phaser.Math.Matrix4;

            /**
             * Generates a transform matrix based on the given position, scale and rotation.
             * @param position The position vector.
             * @param scale The scale vector.
             * @param rotation The rotation quaternion.
             */
            transform(position: Phaser.Math.Vector3, scale: Phaser.Math.Vector3, rotation: Phaser.Math.Quaternion): this;

            /**
             * Set the `x`, `y` and `z` values of this Matrix.
             * @param x The x value.
             * @param y The y value.
             * @param z The z value.
             */
            xyz(x: number, y: number, z: number): this;

            /**
             * Set the scaling values of this Matrix.
             * @param x The x scaling value.
             * @param y The y scaling value.
             * @param z The z scaling value.
             */
            scaling(x: number, y: number, z: number): this;

            /**
             * Reset this Matrix to an identity (default) matrix.
             */
            identity(): this;

            /**
             * Transpose this Matrix.
             */
            transpose(): this;

            /**
             * Copies the given Matrix4 into this Matrix and then inverses it.
             * @param m The Matrix4 to invert into this Matrix4.
             */
            getInverse(m: Phaser.Math.Matrix4): this;

            /**
             * Invert this Matrix.
             */
            invert(): this;

            /**
             * Calculate the adjoint, or adjugate, of this Matrix.
             */
            adjoint(): this;

            /**
             * Calculate the determinant of this Matrix.
             */
            determinant(): number;

            /**
             * Multiply this Matrix by the given Matrix.
             * @param src The Matrix to multiply this Matrix by.
             */
            multiply(src: Phaser.Math.Matrix4): this;

            /**
             * Multiply the values of this Matrix4 by those given in the `src` argument.
             * @param src The source Matrix4 that this Matrix4 is multiplied by.
             */
            multiplyLocal(src: Phaser.Math.Matrix4): this;

            /**
             * Multiplies the given Matrix4 object with this Matrix.
             * 
             * This is the same as calling `multiplyMatrices(m, this)`.
             * @param m The Matrix4 to multiply with this one.
             */
            premultiply(m: Phaser.Math.Matrix4): this;

            /**
             * Multiplies the two given Matrix4 objects and stores the results in this Matrix.
             * @param a The first Matrix4 to multiply.
             * @param b The second Matrix4 to multiply.
             */
            multiplyMatrices(a: Phaser.Math.Matrix4, b: Phaser.Math.Matrix4): this;

            /**
             * Translate this Matrix using the given Vector.
             * @param v The Vector to translate this Matrix with.
             */
            translate(v: Phaser.Math.Vector3 | Phaser.Math.Vector4): this;

            /**
             * Translate this Matrix using the given values.
             * @param x The x component.
             * @param y The y component.
             * @param z The z component.
             */
            translateXYZ(x: number, y: number, z: number): this;

            /**
             * Apply a scale transformation to this Matrix.
             * 
             * Uses the `x`, `y` and `z` components of the given Vector to scale the Matrix.
             * @param v The Vector to scale this Matrix with.
             */
            scale(v: Phaser.Math.Vector3 | Phaser.Math.Vector4): this;

            /**
             * Apply a scale transformation to this Matrix.
             * @param x The x component.
             * @param y The y component.
             * @param z The z component.
             */
            scaleXYZ(x: number, y: number, z: number): this;

            /**
             * Derive a rotation matrix around the given axis.
             * @param axis The rotation axis.
             * @param angle The rotation angle in radians.
             */
            makeRotationAxis(axis: Phaser.Math.Vector3 | Phaser.Math.Vector4, angle: number): this;

            /**
             * Apply a rotation transformation to this Matrix.
             * @param rad The angle in radians to rotate by.
             * @param axis The axis to rotate upon.
             */
            rotate(rad: number, axis: Phaser.Math.Vector3): this;

            /**
             * Rotate this matrix on its X axis.
             * @param rad The angle in radians to rotate by.
             */
            rotateX(rad: number): this;

            /**
             * Rotate this matrix on its Y axis.
             * @param rad The angle to rotate by, in radians.
             */
            rotateY(rad: number): this;

            /**
             * Rotate this matrix on its Z axis.
             * @param rad The angle to rotate by, in radians.
             */
            rotateZ(rad: number): this;

            /**
             * Set the values of this Matrix from the given rotation Quaternion and translation Vector.
             * @param q The Quaternion to set rotation from.
             * @param v The Vector to set translation from.
             */
            fromRotationTranslation(q: Phaser.Math.Quaternion, v: Phaser.Math.Vector3): this;

            /**
             * Set the values of this Matrix from the given Quaternion.
             * @param q The Quaternion to set the values of this Matrix from.
             */
            fromQuat(q: Phaser.Math.Quaternion): this;

            /**
             * Generate a frustum matrix with the given bounds.
             * @param left The left bound of the frustum.
             * @param right The right bound of the frustum.
             * @param bottom The bottom bound of the frustum.
             * @param top The top bound of the frustum.
             * @param near The near bound of the frustum.
             * @param far The far bound of the frustum.
             */
            frustum(left: number, right: number, bottom: number, top: number, near: number, far: number): this;

            /**
             * Generate a perspective projection matrix with the given bounds.
             * @param fovy Vertical field of view in radians
             * @param aspect Aspect ratio. Typically viewport width  /height.
             * @param near Near bound of the frustum.
             * @param far Far bound of the frustum.
             */
            perspective(fovy: number, aspect: number, near: number, far: number): this;

            /**
             * Generate a perspective projection matrix with the given bounds.
             * @param width The width of the frustum.
             * @param height The height of the frustum.
             * @param near Near bound of the frustum.
             * @param far Far bound of the frustum.
             */
            perspectiveLH(width: number, height: number, near: number, far: number): this;

            /**
             * Generate an orthogonal projection matrix with the given bounds.
             * @param left The left bound of the frustum.
             * @param right The right bound of the frustum.
             * @param bottom The bottom bound of the frustum.
             * @param top The top bound of the frustum.
             * @param near The near bound of the frustum.
             * @param far The far bound of the frustum.
             */
            ortho(left: number, right: number, bottom: number, top: number, near: number, far: number): this;

            /**
             * Generate a right-handed look-at matrix with the given eye position, target and up axis.
             * @param eye Position of the viewer.
             * @param target Point the viewer is looking at.
             * @param up vec3 pointing up.
             */
            lookAtRH(eye: Phaser.Math.Vector3, target: Phaser.Math.Vector3, up: Phaser.Math.Vector3): this;

            /**
             * Generate a look-at matrix with the given eye position, focal point, and up axis.
             * @param eye Position of the viewer
             * @param center Point the viewer is looking at
             * @param up vec3 pointing up.
             */
            lookAt(eye: Phaser.Math.Vector3, center: Phaser.Math.Vector3, up: Phaser.Math.Vector3): this;

            /**
             * Set the values of this matrix from the given `yaw`, `pitch` and `roll` values.
             * @param yaw The yaw value.
             * @param pitch The pitch value.
             * @param roll The roll value.
             */
            yawPitchRoll(yaw: number, pitch: number, roll: number): this;

            /**
             * Generate a world matrix from the given rotation, position, scale, view matrix and projection matrix.
             * @param rotation The rotation of the world matrix.
             * @param position The position of the world matrix.
             * @param scale The scale of the world matrix.
             * @param viewMatrix The view matrix.
             * @param projectionMatrix The projection matrix.
             */
            setWorldMatrix(rotation: Phaser.Math.Vector3, position: Phaser.Math.Vector3, scale: Phaser.Math.Vector3, viewMatrix?: Phaser.Math.Matrix4, projectionMatrix?: Phaser.Math.Matrix4): this;

            /**
             * Multiplies this Matrix4 by the given `src` Matrix4 and stores the results in the `out` Matrix4.
             * @param src The Matrix4 to multiply with this one.
             * @param out The receiving Matrix.
             */
            multiplyToMat4(src: Phaser.Math.Matrix4, out: Phaser.Math.Matrix4): Phaser.Math.Matrix4;

            /**
             * Takes the rotation and position vectors and builds this Matrix4 from them.
             * @param rotation The rotation vector.
             * @param position The position vector.
             * @param translateFirst Should the operation translate then rotate (`true`), or rotate then translate? (`false`)
             */
            fromRotationXYTranslation(rotation: Phaser.Math.Vector3, position: Phaser.Math.Vector3, translateFirst: boolean): this;

            /**
             * Returns the maximum axis scale from this Matrix4.
             */
            getMaxScaleOnAxis(): number;

        }

        /**
         * Add an `amount` to a `value`, limiting the maximum result to `max`.
         * @param value The value to add to.
         * @param amount The amount to add.
         * @param max The maximum value to return.
         */
        function MaxAdd(value: number, amount: number, max: number): number;

        /**
         * Calculate the median of the given values. The values are sorted and the middle value is returned.
         * In case of an even number of values, the average of the two middle values is returned.
         * @param values The values to average.
         */
        function Median(values: number[]): number;

        /**
         * Subtract an `amount` from `value`, limiting the minimum result to `min`.
         * @param value The value to subtract from.
         * @param amount The amount to subtract.
         * @param min The minimum value to return.
         */
        function MinSub(value: number, amount: number, min: number): number;

        /**
         * Work out what percentage `value` is of the range between `min` and `max`.
         * If `max` isn't given then it will return the percentage of `value` to `min`.
         * 
         * You can optionally specify an `upperMax` value, which is a mid-way point in the range that represents 100%, after which the % starts to go down to zero again.
         * @param value The value to determine the percentage of.
         * @param min The minimum value.
         * @param max The maximum value.
         * @param upperMax The mid-way point in the range that represents 100%.
         */
        function Percent(value: number, min: number, max?: number, upperMax?: number): number;

        namespace Pow2 {
            /**
             * Returns the nearest power of 2 to the given `value`.
             * @param value The value.
             */
            function GetNext(value: number): number;

            /**
             * Checks if the given `width` and `height` are a power of two.
             * Useful for checking texture dimensions.
             * @param width The width.
             * @param height The height.
             */
            function IsSize(width: number, height: number): boolean;

            /**
             * Tests the value and returns `true` if it is a power of two.
             * @param value The value to check if it's a power of two.
             */
            function IsValue(value: number): boolean;

        }

        /**
         * A quaternion.
         */
        class Quaternion {
            /**
             * 
             * @param x The x component. Default 0.
             * @param y The y component. Default 0.
             * @param z The z component. Default 0.
             * @param w The w component. Default 1.
             */
            constructor(x?: number, y?: number, z?: number, w?: number);

            /**
             * This callback is invoked, if set, each time a value in this quaternion is changed.
             * The callback is passed one argument, a reference to this quaternion.
             */
            onChangeCallback: Function;

            /**
             * The x component of this Quaternion.
             */
            x: number;

            /**
             * The y component of this Quaternion.
             */
            y: number;

            /**
             * The z component of this Quaternion.
             */
            z: number;

            /**
             * The w component of this Quaternion.
             */
            w: number;

            /**
             * Copy the components of a given Quaternion or Vector into this Quaternion.
             * @param src The Quaternion or Vector to copy the components from.
             */
            copy(src: Phaser.Math.Quaternion | Phaser.Math.Vector4): Phaser.Math.Quaternion;

            /**
             * Set the components of this Quaternion and optionally call the `onChangeCallback`.
             * @param x The x component, or an object containing x, y, z, and w components. Default 0.
             * @param y The y component. Default 0.
             * @param z The z component. Default 0.
             * @param w The w component. Default 0.
             * @param update Call the `onChangeCallback`? Default true.
             */
            set(x?: number | object, y?: number, z?: number, w?: number, update?: boolean): Phaser.Math.Quaternion;

            /**
             * Add a given Quaternion or Vector to this Quaternion. Addition is component-wise.
             * @param v The Quaternion or Vector to add to this Quaternion.
             */
            add(v: Phaser.Math.Quaternion | Phaser.Math.Vector4): Phaser.Math.Quaternion;

            /**
             * Subtract a given Quaternion or Vector from this Quaternion. Subtraction is component-wise.
             * @param v The Quaternion or Vector to subtract from this Quaternion.
             */
            subtract(v: Phaser.Math.Quaternion | Phaser.Math.Vector4): Phaser.Math.Quaternion;

            /**
             * Scale this Quaternion by the given value.
             * @param scale The value to scale this Quaternion by.
             */
            scale(scale: number): Phaser.Math.Quaternion;

            /**
             * Calculate the length of this Quaternion.
             */
            length(): number;

            /**
             * Calculate the length of this Quaternion squared.
             */
            lengthSq(): number;

            /**
             * Normalize this Quaternion.
             */
            normalize(): Phaser.Math.Quaternion;

            /**
             * Calculate the dot product of this Quaternion and the given Quaternion or Vector.
             * @param v The Quaternion or Vector to dot product with this Quaternion.
             */
            dot(v: Phaser.Math.Quaternion | Phaser.Math.Vector4): number;

            /**
             * Linearly interpolate this Quaternion towards the given Quaternion or Vector.
             * @param v The Quaternion or Vector to interpolate towards.
             * @param t The percentage of interpolation. Default 0.
             */
            lerp(v: Phaser.Math.Quaternion | Phaser.Math.Vector4, t?: number): Phaser.Math.Quaternion;

            /**
             * Rotates this Quaternion based on the two given vectors.
             * @param a The transform rotation vector.
             * @param b The target rotation vector.
             */
            rotationTo(a: Phaser.Math.Vector3, b: Phaser.Math.Vector3): Phaser.Math.Quaternion;

            /**
             * Set the axes of this Quaternion.
             * @param view The view axis.
             * @param right The right axis.
             * @param up The upwards axis.
             */
            setAxes(view: Phaser.Math.Vector3, right: Phaser.Math.Vector3, up: Phaser.Math.Vector3): Phaser.Math.Quaternion;

            /**
             * Reset this Matrix to an identity (default) Quaternion.
             */
            identity(): Phaser.Math.Quaternion;

            /**
             * Set the axis angle of this Quaternion.
             * @param axis The axis.
             * @param rad The angle in radians.
             */
            setAxisAngle(axis: Phaser.Math.Vector3, rad: number): Phaser.Math.Quaternion;

            /**
             * Multiply this Quaternion by the given Quaternion or Vector.
             * @param b The Quaternion or Vector to multiply this Quaternion by.
             */
            multiply(b: Phaser.Math.Quaternion | Phaser.Math.Vector4): Phaser.Math.Quaternion;

            /**
             * Smoothly linearly interpolate this Quaternion towards the given Quaternion or Vector.
             * @param b The Quaternion or Vector to interpolate towards.
             * @param t The percentage of interpolation.
             */
            slerp(b: Phaser.Math.Quaternion | Phaser.Math.Vector4, t: number): Phaser.Math.Quaternion;

            /**
             * Invert this Quaternion.
             */
            invert(): Phaser.Math.Quaternion;

            /**
             * Convert this Quaternion into its conjugate.
             * 
             * Sets the x, y and z components.
             */
            conjugate(): Phaser.Math.Quaternion;

            /**
             * Rotate this Quaternion on the X axis.
             * @param rad The rotation angle in radians.
             */
            rotateX(rad: number): Phaser.Math.Quaternion;

            /**
             * Rotate this Quaternion on the Y axis.
             * @param rad The rotation angle in radians.
             */
            rotateY(rad: number): Phaser.Math.Quaternion;

            /**
             * Rotate this Quaternion on the Z axis.
             * @param rad The rotation angle in radians.
             */
            rotateZ(rad: number): Phaser.Math.Quaternion;

            /**
             * Create a unit (or rotation) Quaternion from its x, y, and z components.
             * 
             * Sets the w component.
             */
            calculateW(): Phaser.Math.Quaternion;

            /**
             * Set this Quaternion from the given Euler, based on Euler order.
             * @param euler The Euler to convert from.
             * @param update Run the `onChangeCallback`? Default true.
             */
            setFromEuler(euler: Phaser.Math.Euler, update?: boolean): Phaser.Math.Quaternion;

            /**
             * Sets the rotation of this Quaternion from the given Matrix4.
             * @param mat4 The Matrix4 to set the rotation from.
             */
            setFromRotationMatrix(mat4: Phaser.Math.Matrix4): Phaser.Math.Quaternion;

            /**
             * Convert the given Matrix into this Quaternion.
             * @param mat The Matrix to convert from.
             */
            fromMat3(mat: Phaser.Math.Matrix3): Phaser.Math.Quaternion;

        }

        /**
         * Convert the given angle in radians, to the equivalent angle in degrees.
         * @param radians The angle in radians to convert ot degrees.
         */
        function RadToDeg(radians: number): number;

        /**
         * A seeded Random Data Generator.
         * 
         * Access via `Phaser.Math.RND` which is an instance of this class pre-defined
         * by Phaser. Or, create your own instance to use as you require.
         * 
         * The `Math.RND` generator is seeded by the Game Config property value `seed`.
         * If no such config property exists, a random number is used.
         * 
         * If you create your own instance of this class you should provide a seed for it.
         * If no seed is given it will use a 'random' one based on Date.now.
         */
        class RandomDataGenerator {
            /**
             * 
             * @param seeds The seeds to use for the random number generator.
             */
            constructor(seeds?: string | string[]);

            /**
             * Signs to choose from.
             */
            signs: number[];

            /**
             * Initialize the state of the random data generator.
             * @param seeds The seeds to initialize the random data generator with.
             */
            init(seeds: string | string[]): void;

            /**
             * Reset the seed of the random data generator.
             * 
             * _Note_: the seed array is only processed up to the first `undefined` (or `null`) value, should such be present.
             * @param seeds The array of seeds: the `toString()` of each value is used.
             */
            sow(seeds: string[]): void;

            /**
             * Returns a random integer between 0 and 2^32.
             */
            integer(): number;

            /**
             * Returns a random real number between 0 and 1.
             */
            frac(): number;

            /**
             * Returns a random real number between 0 and 2^32.
             */
            real(): number;

            /**
             * Returns a random integer between and including min and max.
             * @param min The minimum value in the range.
             * @param max The maximum value in the range.
             */
            integerInRange(min: number, max: number): number;

            /**
             * Returns a random integer between and including min and max.
             * This method is an alias for RandomDataGenerator.integerInRange.
             * @param min The minimum value in the range.
             * @param max The maximum value in the range.
             */
            between(min: number, max: number): number;

            /**
             * Returns a random real number between min and max.
             * @param min The minimum value in the range.
             * @param max The maximum value in the range.
             */
            realInRange(min: number, max: number): number;

            /**
             * Returns a random real number between -1 and 1.
             */
            normal(): number;

            /**
             * Returns a valid RFC4122 version4 ID hex string from https://gist.github.com/1308368
             */
            uuid(): string;

            /**
             * Returns a random element from within the given array.
             * @param array The array to pick a random element from.
             */
            pick<T>(array: T[]): T;

            /**
             * Returns a sign to be used with multiplication operator.
             */
            sign(): number;

            /**
             * Returns a random element from within the given array, favoring the earlier entries.
             * @param array The array to pick a random element from.
             */
            weightedPick<T>(array: T[]): T;

            /**
             * Returns a random timestamp between min and max, or between the beginning of 2000 and the end of 2020 if min and max aren't specified.
             * @param min The minimum value in the range.
             * @param max The maximum value in the range.
             */
            timestamp(min: number, max: number): number;

            /**
             * Returns a random angle between -180 and 180.
             */
            angle(): number;

            /**
             * Returns a random rotation in radians, between -3.141 and 3.141
             */
            rotation(): number;

            /**
             * Gets or Sets the state of the generator. This allows you to retain the values
             * that the generator is using between games, i.e. in a game save file.
             * 
             * To seed this generator with a previously saved state you can pass it as the
             * `seed` value in your game config, or call this method directly after Phaser has booted.
             * 
             * Call this method with no parameters to return the current state.
             * 
             * If providing a state it should match the same format that this method
             * returns, which is a string with a header `!rnd` followed by the `c`,
             * `s0`, `s1` and `s2` values respectively, each comma-delimited.
             * @param state Generator state to be set.
             */
            state(state?: string): string;

            /**
             * Shuffles the given array, using the current seed.
             * @param array The array to be shuffled.
             */
            shuffle<T>(array?: T[]): T[];

        }

        /**
         * Compute a random unit vector.
         * 
         * Computes random values for the given vector between -1 and 1 that can be used to represent a direction.
         * 
         * Optionally accepts a scale value to scale the resulting vector by.
         * @param vector The Vector to compute random values for.
         * @param scale The scale of the random values. Default 1.
         */
        function RandomXY(vector: Phaser.Math.Vector2, scale?: number): Phaser.Math.Vector2;

        /**
         * Compute a random position vector in a spherical area, optionally defined by the given radius.
         * @param vec3 The Vector to compute random values for.
         * @param radius The radius. Default 1.
         */
        function RandomXYZ(vec3: Phaser.Math.Vector3, radius?: number): Phaser.Math.Vector3;

        /**
         * Compute a random four-dimensional vector.
         * @param vec4 The Vector to compute random values for.
         * @param scale The scale of the random values. Default 1.
         */
        function RandomXYZW(vec4: Phaser.Math.Vector4, scale?: number): Phaser.Math.Vector4;

        /**
         * Rotate a given point by a given angle around the origin (0, 0), in an anti-clockwise direction.
         * @param point The point to be rotated.
         * @param angle The angle to be rotated by in an anticlockwise direction.
         */
        function Rotate(point: Phaser.Geom.Point | object, angle: number): Phaser.Geom.Point;

        /**
         * Rotate a `point` around `x` and `y` to the given `angle`, at the same distance.
         * 
         * In polar notation, this maps a point from (r, t) to (r, angle), vs. the origin (x, y).
         * @param point The point to be rotated.
         * @param x The horizontal coordinate to rotate around.
         * @param y The vertical coordinate to rotate around.
         * @param angle The angle of rotation in radians.
         */
        function RotateAround<T extends Phaser.Types.Math.Vector2Like>(point: T, x: number, y: number, angle: number): T;

        /**
         * Rotate a `point` around `x` and `y` by the given `angle` and `distance`.
         * 
         * In polar notation, this maps a point from (r, t) to (distance, t + angle), vs. the origin (x, y).
         * @param point The point to be rotated.
         * @param x The horizontal coordinate to rotate around.
         * @param y The vertical coordinate to rotate around.
         * @param angle The angle of rotation in radians.
         * @param distance The distance from (x, y) to place the point at.
         */
        function RotateAroundDistance<T extends Phaser.Types.Math.Vector2Like>(point: T, x: number, y: number, angle: number, distance: number): T;

        /**
         * Position a `point` at the given `angle` and `distance` to (`x`, `y`).
         * @param point The point to be positioned.
         * @param x The horizontal coordinate to position from.
         * @param y The vertical coordinate to position from.
         * @param angle The angle of rotation in radians.
         * @param distance The distance from (x, y) to place the point at.
         */
        function RotateTo<T extends Phaser.Types.Math.Vector2Like>(point: T, x: number, y: number, angle: number, distance: number): T;

        /**
         * Rotates a vector in place by axis angle.
         * 
         * This is the same as transforming a point by an
         * axis-angle quaternion, but it has higher precision.
         * @param vec The vector to be rotated.
         * @param axis The axis to rotate around.
         * @param radians The angle of rotation in radians.
         */
        function RotateVec3(vec: Phaser.Math.Vector3, axis: Phaser.Math.Vector3, radians: number): Phaser.Math.Vector3;

        /**
         * Round a given number so it is further away from zero. That is, positive numbers are rounded up, and negative numbers are rounded down.
         * @param value The number to round.
         */
        function RoundAwayFromZero(value: number): number;

        /**
         * Round a value to the given precision.
         * 
         * For example:
         * 
         * ```javascript
         * RoundTo(123.456, 0) = 123
         * RoundTo(123.456, 1) = 120
         * RoundTo(123.456, 2) = 100
         * ```
         * 
         * To round the decimal, i.e. to round to precision, pass in a negative `place`:
         * 
         * ```javascript
         * RoundTo(123.456789, 0) = 123
         * RoundTo(123.456789, -1) = 123.5
         * RoundTo(123.456789, -2) = 123.46
         * RoundTo(123.456789, -3) = 123.457
         * ```
         * @param value The value to round.
         * @param place The place to round to. Positive to round the units, negative to round the decimal. Default 0.
         * @param base The base to round in. Default is 10 for decimal. Default 10.
         */
        function RoundTo(value: number, place?: number, base?: number): number;

        /**
         * Generate a series of sine and cosine values.
         * @param length The number of values to generate.
         * @param sinAmp The sine value amplitude. Default 1.
         * @param cosAmp The cosine value amplitude. Default 1.
         * @param frequency The frequency of the values. Default 1.
         */
        function SinCosTableGenerator(length: number, sinAmp?: number, cosAmp?: number, frequency?: number): Phaser.Types.Math.SinCosTable;

        /**
         * Calculate a smoother interpolation percentage of `x` between `min` and `max`.
         * 
         * The function receives the number `x` as an argument and returns 0 if `x` is less than or equal to the left edge,
         * 1 if `x` is greater than or equal to the right edge, and smoothly interpolates, using a Hermite polynomial,
         * between 0 and 1 otherwise.
         * 
         * Produces an even smoother interpolation than {@link Phaser.Math.SmoothStep}.
         * @param x The input value.
         * @param min The minimum value, also known as the 'left edge', assumed smaller than the 'right edge'.
         * @param max The maximum value, also known as the 'right edge', assumed greater than the 'left edge'.
         */
        function SmootherStep(x: number, min: number, max: number): number;

        /**
         * Calculate a smooth interpolation percentage of `x` between `min` and `max`.
         * 
         * The function receives the number `x` as an argument and returns 0 if `x` is less than or equal to the left edge,
         * 1 if `x` is greater than or equal to the right edge, and smoothly interpolates, using a Hermite polynomial,
         * between 0 and 1 otherwise.
         * @param x The input value.
         * @param min The minimum value, also known as the 'left edge', assumed smaller than the 'right edge'.
         * @param max The maximum value, also known as the 'right edge', assumed greater than the 'left edge'.
         */
        function SmoothStep(x: number, min: number, max: number): number;

        namespace Snap {
            /**
             * Snap a value to nearest grid slice, using ceil.
             * 
             * Example: if you have an interval gap of `5` and a position of `12`... you will snap to `15`.
             * As will `14` snap to `15`... but `16` will snap to `20`.
             * @param value The value to snap.
             * @param gap The interval gap of the grid.
             * @param start Optional starting offset for gap. Default 0.
             * @param divide If `true` it will divide the snapped value by the gap before returning. Default false.
             */
            function Ceil(value: number, gap: number, start?: number, divide?: boolean): number;

            /**
             * Snap a value to nearest grid slice, using floor.
             * 
             * Example: if you have an interval gap of `5` and a position of `12`... you will snap to `10`.
             * As will `14` snap to `10`... but `16` will snap to `15`.
             * @param value The value to snap.
             * @param gap The interval gap of the grid.
             * @param start Optional starting offset for gap. Default 0.
             * @param divide If `true` it will divide the snapped value by the gap before returning. Default false.
             */
            function Floor(value: number, gap: number, start?: number, divide?: boolean): number;

            /**
             * Snap a value to nearest grid slice, using rounding.
             * 
             * Example: if you have an interval gap of `5` and a position of `12`... you will snap to `10` whereas `14` will snap to `15`.
             * @param value The value to snap.
             * @param gap The interval gap of the grid.
             * @param start Optional starting offset for gap. Default 0.
             * @param divide If `true` it will divide the snapped value by the gap before returning. Default false.
             */
            function To(value: number, gap: number, start?: number, divide?: boolean): number;

        }

        /**
         * Returns a Vector2 containing the x and y position of the given index in a `width` x `height` sized grid.
         * 
         * For example, in a 6 x 4 grid, index 16 would equal x: 4 y: 2.
         * 
         * If the given index is out of range an empty Vector2 is returned.
         * @param index The position within the grid to get the x/y value for.
         * @param width The width of the grid.
         * @param height The height of the grid.
         * @param out An optional Vector2 to store the result in. If not given, a new Vector2 instance will be created.
         */
        function ToXY(index: number, width: number, height: number, out?: Phaser.Math.Vector2): Phaser.Math.Vector2;

        /**
         * Takes the `x` and `y` coordinates and transforms them into the same space as
         * defined by the position, rotation and scale values.
         * @param x The x coordinate to be transformed.
         * @param y The y coordinate to be transformed.
         * @param positionX Horizontal position of the transform point.
         * @param positionY Vertical position of the transform point.
         * @param rotation Rotation of the transform point, in radians.
         * @param scaleX Horizontal scale of the transform point.
         * @param scaleY Vertical scale of the transform point.
         * @param output The output vector, point or object for the translated coordinates.
         */
        function TransformXY(x: number, y: number, positionX: number, positionY: number, rotation: number, scaleX: number, scaleY: number, output?: Phaser.Math.Vector2 | Phaser.Geom.Point | object): Phaser.Math.Vector2 | Phaser.Geom.Point | object;

        /**
         * A representation of a vector in 2D space.
         * 
         * A two-component vector.
         */
        class Vector2 {
            /**
             * 
             * @param x The x component, or an object with `x` and `y` properties. Default 0.
             * @param y The y component. Default x.
             */
            constructor(x?: number | Phaser.Types.Math.Vector2Like, y?: number);

            /**
             * The x component of this Vector.
             */
            x: number;

            /**
             * The y component of this Vector.
             */
            y: number;

            /**
             * Make a clone of this Vector2.
             */
            clone(): Phaser.Math.Vector2;

            /**
             * Copy the components of a given Vector into this Vector.
             * @param src The Vector to copy the components from.
             */
            copy(src: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Set the component values of this Vector from a given Vector2Like object.
             * @param obj The object containing the component values to set for this Vector.
             */
            setFromObject(obj: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Set the `x` and `y` components of the this Vector to the given `x` and `y` values.
             * @param x The x value to set for this Vector.
             * @param y The y value to set for this Vector. Default x.
             */
            set(x: number, y?: number): Phaser.Math.Vector2;

            /**
             * This method is an alias for `Vector2.set`.
             * @param x The x value to set for this Vector.
             * @param y The y value to set for this Vector. Default x.
             */
            setTo(x: number, y?: number): Phaser.Math.Vector2;

            /**
             * Sets the `x` and `y` values of this object from a given polar coordinate.
             * @param azimuth The angular coordinate, in radians.
             * @param radius The radial coordinate (length). Default 1.
             */
            setToPolar(azimuth: number, radius?: number): Phaser.Math.Vector2;

            /**
             * Check whether this Vector is equal to a given Vector.
             * 
             * Performs a strict equality check against each Vector's components.
             * @param v The vector to compare with this Vector.
             */
            equals(v: Phaser.Types.Math.Vector2Like): boolean;

            /**
             * Check whether this Vector is approximately equal to a given Vector.
             * @param v The vector to compare with this Vector.
             * @param epsilon The tolerance value. Default 0.0001.
             */
            fuzzyEquals(v: Phaser.Types.Math.Vector2Like, epsilon?: number): boolean;

            /**
             * Calculate the angle between this Vector and the positive x-axis, in radians.
             */
            angle(): number;

            /**
             * Set the angle of this Vector.
             * @param angle The angle, in radians.
             */
            setAngle(angle: number): Phaser.Math.Vector2;

            /**
             * Add a given Vector to this Vector. Addition is component-wise.
             * @param src The Vector to add to this Vector.
             */
            add(src: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Subtract the given Vector from this Vector. Subtraction is component-wise.
             * @param src The Vector to subtract from this Vector.
             */
            subtract(src: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Perform a component-wise multiplication between this Vector and the given Vector.
             * 
             * Multiplies this Vector by the given Vector.
             * @param src The Vector to multiply this Vector by.
             */
            multiply(src: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Scale this Vector by the given value.
             * @param value The value to scale this Vector by.
             */
            scale(value: number): Phaser.Math.Vector2;

            /**
             * Perform a component-wise division between this Vector and the given Vector.
             * 
             * Divides this Vector by the given Vector.
             * @param src The Vector to divide this Vector by.
             */
            divide(src: Phaser.Types.Math.Vector2Like): Phaser.Math.Vector2;

            /**
             * Negate the `x` and `y` components of this Vector.
             */
            negate(): Phaser.Math.Vector2;

            /**
             * Calculate the distance between this Vector and the given Vector.
             * @param src The Vector to calculate the distance to.
             */
            distance(src: Phaser.Types.Math.Vector2Like): number;

            /**
             * Calculate the distance between this Vector and the given Vector, squared.
             * @param src The Vector to calculate the distance to.
             */
            distanceSq(src: Phaser.Types.Math.Vector2Like): number;

            /**
             * Calculate the length (or magnitude) of this Vector.
             */
            length(): number;

            /**
             * Set the length (or magnitude) of this Vector.
             */
            setLength(length: number): Phaser.Math.Vector2;

            /**
             * Calculate the length of this Vector squared.
             */
            lengthSq(): number;

            /**
             * Normalize this Vector.
             * 
             * Makes the vector a unit length vector (magnitude of 1) in the same direction.
             */
            normalize(): Phaser.Math.Vector2;

            /**
             * Rotate this Vector to its perpendicular, in the positive direction.
             */
            normalizeRightHand(): Phaser.Math.Vector2;

            /**
             * Rotate this Vector to its perpendicular, in the negative direction.
             */
            normalizeLeftHand(): Phaser.Math.Vector2;

            /**
             * Calculate the dot product of this Vector and the given Vector.
             * @param src The Vector2 to dot product with this Vector2.
             */
            dot(src: Phaser.Types.Math.Vector2Like): number;

            /**
             * Calculate the cross product of this Vector and the given Vector.
             * @param src The Vector2 to cross with this Vector2.
             */
            cross(src: Phaser.Types.Math.Vector2Like): number;

            /**
             * Linearly interpolate between this Vector and the given Vector.
             * 
             * Interpolates this Vector towards the given Vector.
             * @param src The Vector2 to interpolate towards.
             * @param t The interpolation percentage, between 0 and 1. Default 0.
             */
            lerp(src: Phaser.Types.Math.Vector2Like, t?: number): Phaser.Math.Vector2;

            /**
             * Transform this Vector with the given Matrix.
             * @param mat The Matrix3 to transform this Vector2 with.
             */
            transformMat3(mat: Phaser.Math.Matrix3): Phaser.Math.Vector2;

            /**
             * Transform this Vector with the given Matrix.
             * @param mat The Matrix4 to transform this Vector2 with.
             */
            transformMat4(mat: Phaser.Math.Matrix4): Phaser.Math.Vector2;

            /**
             * Make this Vector the zero vector (0, 0).
             */
            reset(): Phaser.Math.Vector2;

            /**
             * Limit the length (or magnitude) of this Vector.
             * @param max The maximum length.
             */
            limit(max: number): Phaser.Math.Vector2;

            /**
             * Reflect this Vector off a line defined by a normal.
             * @param normal A vector perpendicular to the line.
             */
            reflect(normal: Phaser.Math.Vector2): Phaser.Math.Vector2;

            /**
             * Reflect this Vector across another.
             * @param axis A vector to reflect across.
             */
            mirror(axis: Phaser.Math.Vector2): Phaser.Math.Vector2;

            /**
             * Rotate this Vector by an angle amount.
             * @param delta The angle to rotate by, in radians.
             */
            rotate(delta: number): Phaser.Math.Vector2;

            /**
             * Project this Vector onto another.
             * @param src The vector to project onto.
             */
            project(src: Phaser.Math.Vector2): Phaser.Math.Vector2;

            /**
             * A static zero Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly ZERO: Phaser.Math.Vector2;

            /**
             * A static right Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly RIGHT: Phaser.Math.Vector2;

            /**
             * A static left Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly LEFT: Phaser.Math.Vector2;

            /**
             * A static up Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly UP: Phaser.Math.Vector2;

            /**
             * A static down Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly DOWN: Phaser.Math.Vector2;

            /**
             * A static one Vector2 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly ONE: Phaser.Math.Vector2;

        }

        /**
         * A representation of a vector in 3D space.
         * 
         * A three-component vector.
         */
        class Vector3 {
            /**
             * 
             * @param x The x component.
             * @param y The y component.
             * @param z The z component.
             */
            constructor(x?: number, y?: number, z?: number);

            /**
             * The x component of this Vector.
             */
            x: number;

            /**
             * The y component of this Vector.
             */
            y: number;

            /**
             * The z component of this Vector.
             */
            z: number;

            /**
             * Set this Vector to point up.
             * 
             * Sets the y component of the vector to 1, and the others to 0.
             */
            up(): Phaser.Math.Vector3;

            /**
             * Sets the components of this Vector to be the `Math.min` result from the given vector.
             * @param v The Vector3 to check the minimum values against.
             */
            min(v: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Sets the components of this Vector to be the `Math.max` result from the given vector.
             * @param v The Vector3 to check the maximum values against.
             */
            max(v: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Make a clone of this Vector3.
             */
            clone(): Phaser.Math.Vector3;

            /**
             * Adds the two given Vector3s and sets the results into this Vector3.
             * @param a The first Vector to add.
             * @param b The second Vector to add.
             */
            addVectors(a: Phaser.Math.Vector3, b: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Calculate the cross (vector) product of two given Vectors.
             * @param a The first Vector to multiply.
             * @param b The second Vector to multiply.
             */
            crossVectors(a: Phaser.Math.Vector3, b: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Check whether this Vector is equal to a given Vector.
             * 
             * Performs a strict equality check against each Vector's components.
             * @param v The Vector3 to compare against.
             */
            equals(v: Phaser.Math.Vector3): boolean;

            /**
             * Copy the components of a given Vector into this Vector.
             * @param src The Vector to copy the components from.
             */
            copy(src: Phaser.Math.Vector2 | Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Set the `x`, `y`, and `z` components of this Vector to the given `x`, `y`, and `z` values.
             * @param x The x value to set for this Vector, or an object containing x, y and z components.
             * @param y The y value to set for this Vector.
             * @param z The z value to set for this Vector.
             */
            set(x: number | object, y?: number, z?: number): Phaser.Math.Vector3;

            /**
             * Sets the components of this Vector3 from the position of the given Matrix4.
             * @param mat4 The Matrix4 to get the position from.
             */
            setFromMatrixPosition(mat4: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Sets the components of this Vector3 from the Matrix4 column specified.
             * @param mat4 The Matrix4 to get the column from.
             * @param index The column index.
             */
            setFromMatrixColumn(mat4: Phaser.Math.Matrix4, index: number): Phaser.Math.Vector3;

            /**
             * Sets the components of this Vector3 from the given array, based on the offset.
             * 
             * Vector3.x = array[offset]
             * Vector3.y = array[offset + 1]
             * Vector3.z = array[offset + 2]
             * @param array The array of values to get this Vector from.
             * @param offset The offset index into the array. Default 0.
             */
            fromArray(array: number[], offset?: number): Phaser.Math.Vector3;

            /**
             * Add a given Vector to this Vector. Addition is component-wise.
             * @param v The Vector to add to this Vector.
             */
            add(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Add the given value to each component of this Vector.
             * @param s The amount to add to this Vector.
             */
            addScalar(s: number): Phaser.Math.Vector3;

            /**
             * Add and scale a given Vector to this Vector. Addition is component-wise.
             * @param v The Vector to add to this Vector.
             * @param scale The amount to scale `v` by.
             */
            addScale(v: Phaser.Math.Vector2 | Phaser.Math.Vector3, scale: number): Phaser.Math.Vector3;

            /**
             * Subtract the given Vector from this Vector. Subtraction is component-wise.
             * @param v The Vector to subtract from this Vector.
             */
            subtract(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Perform a component-wise multiplication between this Vector and the given Vector.
             * 
             * Multiplies this Vector by the given Vector.
             * @param v The Vector to multiply this Vector by.
             */
            multiply(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Scale this Vector by the given value.
             * @param scale The value to scale this Vector by.
             */
            scale(scale: number): Phaser.Math.Vector3;

            /**
             * Perform a component-wise division between this Vector and the given Vector.
             * 
             * Divides this Vector by the given Vector.
             * @param v The Vector to divide this Vector by.
             */
            divide(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Negate the `x`, `y` and `z` components of this Vector.
             */
            negate(): Phaser.Math.Vector3;

            /**
             * Calculate the distance between this Vector and the given Vector.
             * @param v The Vector to calculate the distance to.
             */
            distance(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): number;

            /**
             * Calculate the distance between this Vector and the given Vector, squared.
             * @param v The Vector to calculate the distance to.
             */
            distanceSq(v: Phaser.Math.Vector2 | Phaser.Math.Vector3): number;

            /**
             * Calculate the length (or magnitude) of this Vector.
             */
            length(): number;

            /**
             * Calculate the length of this Vector squared.
             */
            lengthSq(): number;

            /**
             * Normalize this Vector.
             * 
             * Makes the vector a unit length vector (magnitude of 1) in the same direction.
             */
            normalize(): Phaser.Math.Vector3;

            /**
             * Calculate the dot product of this Vector and the given Vector.
             * @param v The Vector3 to dot product with this Vector3.
             */
            dot(v: Phaser.Math.Vector3): number;

            /**
             * Calculate the cross (vector) product of this Vector (which will be modified) and the given Vector.
             * @param v The Vector to cross product with.
             */
            cross(v: Phaser.Math.Vector3): Phaser.Math.Vector3;

            /**
             * Linearly interpolate between this Vector and the given Vector.
             * 
             * Interpolates this Vector towards the given Vector.
             * @param v The Vector3 to interpolate towards.
             * @param t The interpolation percentage, between 0 and 1. Default 0.
             */
            lerp(v: Phaser.Math.Vector3, t?: number): Phaser.Math.Vector3;

            /**
             * Takes a Matrix3 and applies it to this Vector3.
             * @param mat3 The Matrix3 to apply to this Vector3.
             */
            applyMatrix3(mat3: Phaser.Math.Matrix3): Phaser.Math.Vector3;

            /**
             * Takes a Matrix4 and applies it to this Vector3.
             * @param mat4 The Matrix4 to apply to this Vector3.
             */
            applyMatrix4(mat4: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Transform this Vector with the given Matrix.
             * @param mat The Matrix3 to transform this Vector3 with.
             */
            transformMat3(mat: Phaser.Math.Matrix3): Phaser.Math.Vector3;

            /**
             * Transform this Vector with the given Matrix4.
             * @param mat The Matrix4 to transform this Vector3 with.
             */
            transformMat4(mat: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Transforms the coordinates of this Vector3 with the given Matrix4.
             * @param mat The Matrix4 to transform this Vector3 with.
             */
            transformCoordinates(mat: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Transform this Vector with the given Quaternion.
             * @param q The Quaternion to transform this Vector with.
             */
            transformQuat(q: Phaser.Math.Quaternion): Phaser.Math.Vector3;

            /**
             * Multiplies this Vector3 by the specified matrix, applying a W divide. This is useful for projection,
             * e.g. unprojecting a 2D point into 3D space.
             * @param mat The Matrix4 to multiply this Vector3 with.
             */
            project(mat: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Multiplies this Vector3 by the given view and projection matrices.
             * @param viewMatrix A View Matrix.
             * @param projectionMatrix A Projection Matrix.
             */
            projectViewMatrix(viewMatrix: Phaser.Math.Matrix4, projectionMatrix: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Multiplies this Vector3 by the given inversed projection matrix and world matrix.
             * @param projectionMatrix An inversed Projection Matrix.
             * @param worldMatrix A World View Matrix.
             */
            unprojectViewMatrix(projectionMatrix: Phaser.Math.Matrix4, worldMatrix: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Unproject this point from 2D space to 3D space.
             * The point should have its x and y properties set to
             * 2D screen space, and the z either at 0 (near plane)
             * or 1 (far plane). The provided matrix is assumed to already
             * be combined, i.e. projection * view * model.
             * 
             * After this operation, this vector's (x, y, z) components will
             * represent the unprojected 3D coordinate.
             * @param viewport Screen x, y, width and height in pixels.
             * @param invProjectionView Combined projection and view matrix.
             */
            unproject(viewport: Phaser.Math.Vector4, invProjectionView: Phaser.Math.Matrix4): Phaser.Math.Vector3;

            /**
             * Make this Vector the zero vector (0, 0, 0).
             */
            reset(): Phaser.Math.Vector3;

            /**
             * A static zero Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly ZERO: Phaser.Math.Vector3;

            /**
             * A static right Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly RIGHT: Phaser.Math.Vector3;

            /**
             * A static left Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly LEFT: Phaser.Math.Vector3;

            /**
             * A static up Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly UP: Phaser.Math.Vector3;

            /**
             * A static down Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly DOWN: Phaser.Math.Vector3;

            /**
             * A static forward Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly FORWARD: Phaser.Math.Vector3;

            /**
             * A static back Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly BACK: Phaser.Math.Vector3;

            /**
             * A static one Vector3 for use by reference.
             * 
             * This constant is meant for comparison operations and should not be modified directly.
             */
            static readonly ONE: Phaser.Math.Vector3;

        }

        /**
         * A representation of a vector in 4D space.
         * 
         * A four-component vector.
         */
        class Vector4 {
            /**
             * 
             * @param x The x component.
             * @param y The y component.
             * @param z The z component.
             * @param w The w component.
             */
            constructor(x?: number, y?: number, z?: number, w?: number);

            /**
             * The x component of this Vector.
             */
            x: number;

            /**
             * The y component of this Vector.
             */
            y: number;

            /**
             * The z component of this Vector.
             */
            z: number;

            /**
             * The w component of this Vector.
             */
            w: number;

            /**
             * Make a clone of this Vector4.
             */
            clone(): Phaser.Math.Vector4;

            /**
             * Copy the components of a given Vector into this Vector.
             * @param src The Vector to copy the components from.
             */
            copy(src: Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Check whether this Vector is equal to a given Vector.
             * 
             * Performs a strict quality check against each Vector's components.
             * @param v The vector to check equality with.
             */
            equals(v: Phaser.Math.Vector4): boolean;

            /**
             * Set the `x`, `y`, `z` and `w` components of the this Vector to the given `x`, `y`, `z` and `w` values.
             * @param x The x value to set for this Vector, or an object containing x, y, z and w components.
             * @param y The y value to set for this Vector.
             * @param z The z value to set for this Vector.
             * @param w The z value to set for this Vector.
             */
            set(x: number | object, y: number, z: number, w: number): Phaser.Math.Vector4;

            /**
             * Add a given Vector to this Vector. Addition is component-wise.
             * @param v The Vector to add to this Vector.
             */
            add(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Subtract the given Vector from this Vector. Subtraction is component-wise.
             * @param v The Vector to subtract from this Vector.
             */
            subtract(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Scale this Vector by the given value.
             * @param scale The value to scale this Vector by.
             */
            scale(scale: number): Phaser.Math.Vector4;

            /**
             * Calculate the length (or magnitude) of this Vector.
             */
            length(): number;

            /**
             * Calculate the length of this Vector squared.
             */
            lengthSq(): number;

            /**
             * Normalize this Vector.
             * 
             * Makes the vector a unit length vector (magnitude of 1) in the same direction.
             */
            normalize(): Phaser.Math.Vector4;

            /**
             * Calculate the dot product of this Vector and the given Vector.
             * @param v The Vector4 to dot product with this Vector4.
             */
            dot(v: Phaser.Math.Vector4): number;

            /**
             * Linearly interpolate between this Vector and the given Vector.
             * 
             * Interpolates this Vector towards the given Vector.
             * @param v The Vector4 to interpolate towards.
             * @param t The interpolation percentage, between 0 and 1. Default 0.
             */
            lerp(v: Phaser.Math.Vector4, t?: number): Phaser.Math.Vector4;

            /**
             * Perform a component-wise multiplication between this Vector and the given Vector.
             * 
             * Multiplies this Vector by the given Vector.
             * @param v The Vector to multiply this Vector by.
             */
            multiply(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Perform a component-wise division between this Vector and the given Vector.
             * 
             * Divides this Vector by the given Vector.
             * @param v The Vector to divide this Vector by.
             */
            divide(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): Phaser.Math.Vector4;

            /**
             * Calculate the distance between this Vector and the given Vector.
             * @param v The Vector to calculate the distance to.
             */
            distance(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): number;

            /**
             * Calculate the distance between this Vector and the given Vector, squared.
             * @param v The Vector to calculate the distance to.
             */
            distanceSq(v: Phaser.Math.Vector2 | Phaser.Math.Vector3 | Phaser.Math.Vector4): number;

            /**
             * Negate the `x`, `y`, `z` and `w` components of this Vector.
             */
            negate(): Phaser.Math.Vector4;

            /**
             * Transform this Vector with the given Matrix.
             * @param mat The Matrix4 to transform this Vector4 with.
             */
            transformMat4(mat: Phaser.Math.Matrix4): Phaser.Math.Vector4;

            /**
             * Transform this Vector with the given Quaternion.
             * @param q The Quaternion to transform this Vector with.
             */
            transformQuat(q: Phaser.Math.Quaternion): Phaser.Math.Vector4;

            /**
             * Make this Vector the zero vector (0, 0, 0, 0).
             */
            reset(): Phaser.Math.Vector4;

        }

        /**
         * Checks if the two values are within the given `tolerance` of each other.
         * @param a The first value to use in the calculation.
         * @param b The second value to use in the calculation.
         * @param tolerance The tolerance. Anything equal to or less than this value is considered as being within range.
         */
        function Within(a: number, b: number, tolerance: number): boolean;

        /**
         * Wrap the given `value` between `min` and `max`.
         * @param value The value to wrap.
         * @param min The minimum value.
         * @param max The maximum value.
         */
        function Wrap(value: number, min: number, max: number): number;

    }

    /**
     * The root types namespace.
     */
    namespace Types {
        namespace Actions {
            type CallCallback = (item: Phaser.GameObjects.GameObject)=>void;

            type GridAlignConfig = {
                /**
                 * The width of the grid in items (not pixels). -1 means lay all items out horizontally, regardless of quantity.
                 *                                  If both this value and height are set to -1 then this value overrides it and the `height` value is ignored.
                 */
                width?: number;
                /**
                 * The height of the grid in items (not pixels). -1 means lay all items out vertically, regardless of quantity.
                 *                                   If both this value and `width` are set to -1 then `width` overrides it and this value is ignored.
                 */
                height?: number;
                /**
                 * The width of the cell, in pixels, in which the item is positioned.
                 */
                cellWidth?: number;
                /**
                 * The height of the cell, in pixels, in which the item is positioned.
                 */
                cellHeight?: number;
                /**
                 * The alignment position. One of the Phaser.Display.Align consts such as `TOP_LEFT` or `RIGHT_CENTER`.
                 */
                position?: number;
                /**
                 * Optionally place the top-left of the final grid at this coordinate.
                 */
                x?: number;
                /**
                 * Optionally place the top-left of the final grid at this coordinate.
                 */
                y?: number;
            };

        }

        namespace Animations {
            type Animation = {
                /**
                 * The key that the animation will be associated with. i.e. sprite.animations.play(key)
                 */
                key?: string;
                /**
                 * Either a string, in which case it will use all frames from a texture with the matching key, or an array of Animation Frame configuration objects.
                 */
                frames?: string | Phaser.Types.Animations.AnimationFrame[];
                /**
                 * If you provide a string for `frames` you can optionally have the frame names numerically sorted.
                 */
                sortFrames?: boolean;
                /**
                 * The key of the texture all frames of the animation will use. Can be overridden on a per frame basis.
                 */
                defaultTextureKey?: string;
                /**
                 * The frame rate of playback in frames per second (default 24 if duration is null)
                 */
                frameRate?: number;
                /**
                 * How long the animation should play for in milliseconds. If not given its derived from frameRate.
                 */
                duration?: number;
                /**
                 * Skip frames if the time lags, or always advanced anyway?
                 */
                skipMissedFrames?: boolean;
                /**
                 * Delay before starting playback. Value given in milliseconds.
                 */
                delay?: number;
                /**
                 * Number of times to repeat the animation (-1 for infinity)
                 */
                repeat?: number;
                /**
                 * Delay before the animation repeats. Value given in milliseconds.
                 */
                repeatDelay?: number;
                /**
                 * Should the animation yoyo? (reverse back down to the start) before repeating?
                 */
                yoyo?: boolean;
                /**
                 * If this animation has a delay, should it show the first frame immediately (true), or only after the delay (false)
                 */
                showBeforeDelay?: boolean;
                /**
                 * Should sprite.visible = true when the animation starts to play? This happens _after_ any delay, if set.
                 */
                showOnStart?: boolean;
                /**
                 * Should sprite.visible = false when the animation finishes?
                 */
                hideOnComplete?: boolean;
                /**
                 * Start playback of this animation from a randomly selected frame?
                 */
                randomFrame?: boolean;
            };

            type AnimationFrame = {
                /**
                 * The key of the texture within the Texture Manager to use for this Animation Frame.
                 */
                key?: string;
                /**
                 * The key, or index number, of the frame within the texture to use for this Animation Frame.
                 */
                frame?: string | number;
                /**
                 * The duration, in ms, of this frame of the animation.
                 */
                duration?: number;
                /**
                 * Should the parent Game Object be visible during this frame of the animation?
                 */
                visible?: boolean;
            };

            type GenerateFrameNames = {
                /**
                 * The string to append to every resulting frame name if using a range or an array of `frames`.
                 */
                prefix?: string;
                /**
                 * If `frames` is not provided, the number of the first frame to return.
                 */
                start?: number;
                /**
                 * If `frames` is not provided, the number of the last frame to return.
                 */
                end?: number;
                /**
                 * The string to append to every resulting frame name if using a range or an array of `frames`.
                 */
                suffix?: string;
                /**
                 * The minimum expected lengths of each resulting frame's number. Numbers will be left-padded with zeroes until they are this long, then prepended and appended to create the resulting frame name.
                 */
                zeroPad?: number;
                /**
                 * The array to append the created configuration objects to.
                 */
                outputArray?: Phaser.Types.Animations.AnimationFrame[];
                /**
                 * If provided as an array, the range defined by `start` and `end` will be ignored and these frame numbers will be used.
                 */
                frames?: boolean | number[];
            };

            type GenerateFrameNumbers = {
                /**
                 * The starting frame of the animation.
                 */
                start?: number;
                /**
                 * The ending frame of the animation.
                 */
                end?: number;
                /**
                 * A frame to put at the beginning of the animation, before `start` or `outputArray` or `frames`.
                 */
                first?: boolean | number;
                /**
                 * An array to concatenate the output onto.
                 */
                outputArray?: Phaser.Types.Animations.AnimationFrame[];
                /**
                 * A custom sequence of frames.
                 */
                frames?: boolean | number[];
            };

            type JSONAnimation = {
                /**
                 * The key that the animation will be associated with. i.e. sprite.animations.play(key)
                 */
                key: string;
                /**
                 * A frame based animation (as opposed to a bone based animation)
                 */
                type: string;
                /**
                 * An array of the AnimationFrame objects inside this Animation.
                 */
                frames: Phaser.Types.Animations.JSONAnimationFrame[];
                /**
                 * The frame rate of playback in frames per second (default 24 if duration is null)
                 */
                frameRate: number;
                /**
                 * How long the animation should play for in milliseconds. If not given its derived from frameRate.
                 */
                duration: number;
                /**
                 * Skip frames if the time lags, or always advanced anyway?
                 */
                skipMissedFrames: boolean;
                /**
                 * Delay before starting playback. Value given in milliseconds.
                 */
                delay: number;
                /**
                 * Number of times to repeat the animation (-1 for infinity)
                 */
                repeat: number;
                /**
                 * Delay before the animation repeats. Value given in milliseconds.
                 */
                repeatDelay: number;
                /**
                 * Should the animation yoyo? (reverse back down to the start) before repeating?
                 */
                yoyo: boolean;
                /**
                 * If this animation has a delay, should it show the first frame immediately (true), or only after the delay (false)
                 */
                showBeforeDelay: boolean;
                /**
                 * Should sprite.visible = true when the animation starts to play?
                 */
                showOnStart: boolean;
                /**
                 * Should sprite.visible = false when the animation finishes?
                 */
                hideOnComplete: boolean;
                /**
                 * Start playback of this animation from a randomly selected frame?
                 */
                randomFrame?: boolean;
            };

            type JSONAnimationFrame = {
                /**
                 * The key of the Texture this AnimationFrame uses.
                 */
                key: string;
                /**
                 * The key of the Frame within the Texture that this AnimationFrame uses.
                 */
                frame: string | number;
                /**
                 * Additional time (in ms) that this frame should appear for during playback.
                 */
                duration: number;
            };

            type JSONAnimations = {
                /**
                 * An array of all Animations added to the Animation Manager.
                 */
                anims: Phaser.Types.Animations.JSONAnimation[];
                /**
                 * The global time scale of the Animation Manager.
                 */
                globalTimeScale: number;
            };

            type PlayAnimationConfig = {
                /**
                 * The string-based key of the animation to play, or an Animation instance.
                 */
                key: string | Phaser.Animations.Animation;
                /**
                 * The frame rate of playback in frames per second (default 24 if duration is null)
                 */
                frameRate?: number;
                /**
                 * How long the animation should play for in milliseconds. If not given its derived from frameRate.
                 */
                duration?: number;
                /**
                 * Delay before starting playback. Value given in milliseconds.
                 */
                delay?: number;
                /**
                 * Number of times to repeat the animation (-1 for infinity)
                 */
                repeat?: number;
                /**
                 * Delay before the animation repeats. Value given in milliseconds.
                 */
                repeatDelay?: number;
                /**
                 * Should the animation yoyo? (reverse back down to the start) before repeating?
                 */
                yoyo?: boolean;
                /**
                 * If this animation has a delay, should it show the first frame immediately (true), or only after the delay (false)
                 */
                showBeforeDelay?: boolean;
                /**
                 * Should sprite.visible = true when the animation starts to play?
                 */
                showOnStart?: boolean;
                /**
                 * Should sprite.visible = false when the animation finishes?
                 */
                hideOnComplete?: boolean;
                /**
                 * Skip frames if the time lags, or always advanced anyway?
                 */
                skipMissedFrames?: boolean;
                /**
                 * The frame of the animation to start playback from.
                 */
                startFrame?: number;
                /**
                 * The time scale to be applied to playback of this animation.
                 */
                timeScale?: number;
                /**
                 * Start playback of this animation from a randomly selected frame?
                 */
                randomFrame?: boolean;
            };

        }

        namespace Cameras {
            namespace Scene2D {
                type CameraConfig = {
                    /**
                     * The name of the Camera.
                     */
                    name?: string;
                    /**
                     * The horizontal position of the Camera viewport.
                     */
                    x?: number;
                    /**
                     * The vertical position of the Camera viewport.
                     */
                    y?: number;
                    /**
                     * The width of the Camera viewport.
                     */
                    width?: number;
                    /**
                     * The height of the Camera viewport.
                     */
                    height?: number;
                    /**
                     * The default zoom level of the Camera.
                     */
                    zoom?: number;
                    /**
                     * The rotation of the Camera, in radians.
                     */
                    rotation?: number;
                    /**
                     * Should the Camera round pixels before rendering?
                     */
                    roundPixels?: boolean;
                    /**
                     * The horizontal scroll position of the Camera.
                     */
                    scrollX?: number;
                    /**
                     * The vertical scroll position of the Camera.
                     */
                    scrollY?: number;
                    /**
                     * A CSS color string controlling the Camera background color.
                     */
                    backgroundColor?: false | string;
                    /**
                     * Defines the Camera bounds.
                     */
                    bounds?: object | null;
                    /**
                     * The top-left extent of the Camera bounds.
                     */
                    "bounds.x"?: number;
                    /**
                     * The top-left extent of the Camera bounds.
                     */
                    "bounds.y"?: number;
                    /**
                     * The width of the Camera bounds.
                     */
                    "bounds.width"?: number;
                    /**
                     * The height of the Camera bounds.
                     */
                    "bounds.height"?: number;
                };

                type CameraFadeCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number)=>void;

                type CameraFlashCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number)=>void;

                type CameraPanCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number, x: number, y: number)=>void;

                type CameraShakeCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number)=>void;

                type CameraZoomCallback = (camera: Phaser.Cameras.Scene2D.Camera, progress: number, zoom: number)=>void;

                type JSONCamera = {
                    /**
                     * The name of the camera
                     */
                    name: string;
                    /**
                     * The horizontal position of camera
                     */
                    x: number;
                    /**
                     * The vertical position of camera
                     */
                    y: number;
                    /**
                     * The width size of camera
                     */
                    width: number;
                    /**
                     * The height size of camera
                     */
                    height: number;
                    /**
                     * The zoom of camera
                     */
                    zoom: number;
                    /**
                     * The rotation of camera
                     */
                    rotation: number;
                    /**
                     * The round pixels st status of camera
                     */
                    roundPixels: boolean;
                    /**
                     * The horizontal scroll of camera
                     */
                    scrollX: number;
                    /**
                     * The vertical scroll of camera
                     */
                    scrollY: number;
                    /**
                     * The background color of camera
                     */
                    backgroundColor: string;
                    /**
                     * The bounds of camera
                     */
                    bounds?: Phaser.Types.Cameras.Scene2D.JSONCameraBounds | undefined;
                };

                type JSONCameraBounds = {
                    /**
                     * The horizontal position of camera
                     */
                    x: number;
                    /**
                     * The vertical position of camera
                     */
                    y: number;
                    /**
                     * The width size of camera
                     */
                    width: number;
                    /**
                     * The height size of camera
                     */
                    height: number;
                };

            }

            namespace Controls {
                type FixedKeyControlConfig = {
                    /**
                     * The Camera that this Control will update.
                     */
                    camera?: Phaser.Cameras.Scene2D.Camera;
                    /**
                     * The Key to be pressed that will move the Camera left.
                     */
                    left?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera right.
                     */
                    right?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera up.
                     */
                    up?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera down.
                     */
                    down?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will zoom the Camera in.
                     */
                    zoomIn?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will zoom the Camera out.
                     */
                    zoomOut?: Phaser.Input.Keyboard.Key;
                    /**
                     * The speed at which the camera will zoom if the `zoomIn` or `zoomOut` keys are pressed.
                     */
                    zoomSpeed?: number;
                    /**
                     * The horizontal and vertical speed the camera will move.
                     */
                    speed?: number | Object;
                    /**
                     * The smallest zoom value the camera will reach when zoomed out.
                     */
                    minZoom?: number;
                    /**
                     * The largest zoom value the camera will reach when zoomed in.
                     */
                    maxZoom?: number;
                };

                type SmoothedKeyControlConfig = {
                    /**
                     * The Camera that this Control will update.
                     */
                    camera?: Phaser.Cameras.Scene2D.Camera;
                    /**
                     * The Key to be pressed that will move the Camera left.
                     */
                    left?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera right.
                     */
                    right?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera up.
                     */
                    up?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will move the Camera down.
                     */
                    down?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will zoom the Camera in.
                     */
                    zoomIn?: Phaser.Input.Keyboard.Key;
                    /**
                     * The Key to be pressed that will zoom the Camera out.
                     */
                    zoomOut?: Phaser.Input.Keyboard.Key;
                    /**
                     * The speed at which the camera will zoom if the `zoomIn` or `zoomOut` keys are pressed.
                     */
                    zoomSpeed?: number;
                    /**
                     * The horizontal and vertical acceleration the camera will move.
                     */
                    acceleration?: number | Object;
                    /**
                     * The horizontal and vertical drag applied to the camera when it is moving.
                     */
                    drag?: number | Object;
                    /**
                     * The maximum horizontal and vertical speed the camera will move.
                     */
                    maxSpeed?: number | Object;
                    /**
                     * The smallest zoom value the camera will reach when zoomed out.
                     */
                    minZoom?: number;
                    /**
                     * The largest zoom value the camera will reach when zoomed in.
                     */
                    maxZoom?: number;
                };

            }

        }

        namespace Core {
            /**
             * Config object containing various sound settings.
             */
            type AudioConfig = {
                /**
                 * Use HTML5 Audio instead of Web Audio.
                 */
                disableWebAudio?: boolean;
                /**
                 * An existing Web Audio context.
                 */
                context?: AudioContext;
                /**
                 * Disable all audio output.
                 */
                noAudio?: boolean;
            };

            type BannerConfig = {
                /**
                 * Omit Phaser's name and version from the banner.
                 */
                hidePhaser?: boolean;
                /**
                 * The color of the banner text.
                 */
                text?: string;
                /**
                 * The background colors of the banner.
                 */
                background?: string[];
            };

            type BootCallback = (game: Phaser.Game)=>void;

            type CallbacksConfig = {
                /**
                 * A function to run at the start of the boot sequence.
                 */
                preBoot?: Phaser.Types.Core.BootCallback;
                /**
                 * A function to run at the end of the boot sequence. At this point, all the game systems have started and plugins have been loaded.
                 */
                postBoot?: Phaser.Types.Core.BootCallback;
            };

            type DOMContainerConfig = {
                /**
                 * Should the game create a div element to act as a DOM Container? Only enable if you're using DOM Element objects. You must provide a parent object if you use this feature.
                 */
                createContainer?: boolean;
                /**
                 * Should the DOM Container that is created (if `dom.createContainer` is true) be positioned behind (true) or over the top (false, the default) of the game canvas?
                 */
                behindCanvas?: boolean;
                /**
                 * The default `pointerEvents` attribute set on the DOM Container.
                 */
                pointerEvents?: string;
            };

            type FPSConfig = {
                /**
                 * The minimum acceptable rendering rate, in frames per second.
                 */
                min?: number;
                /**
                 * The optimum rendering rate, in frames per second. This does not enforce the fps rate, it merely tells Phaser what rate is considered optimal for this game.
                 */
                target?: number;
                /**
                 * Enforces an fps rate limit that the game step will run at, regardless of browser frequency. 0 means 'no limit'. Never set this higher than RAF can handle.
                 */
                limit?: number;
                /**
                 * Use setTimeout instead of requestAnimationFrame to run the game loop.
                 */
                forceSetTimeOut?: boolean;
                /**
                 * Calculate the average frame delta from this many consecutive frame intervals.
                 */
                deltaHistory?: number;
                /**
                 * The amount of frames the time step counts before we trust the delta values again.
                 */
                panicMax?: number;
                /**
                 * Apply delta smoothing during the game update to help avoid spikes?
                 */
                smoothStep?: boolean;
            };

            type GameConfig = {
                /**
                 * The width of the game, in game pixels.
                 */
                width?: number | string;
                /**
                 * The height of the game, in game pixels.
                 */
                height?: number | string;
                /**
                 * Simple scale applied to the game canvas. 2 is double size, 0.5 is half size, etc.
                 */
                zoom?: number;
                /**
                 * Which renderer to use. Phaser.AUTO, Phaser.CANVAS, Phaser.HEADLESS, or Phaser.WEBGL. AUTO picks WEBGL if available, otherwise CANVAS.
                 */
                type?: number;
                /**
                 * `true` or `1` = Use the built-in StableSort (needed for older browsers), `false` or `0` = Rely on ES2019 Array.sort being stable (modern browsers only), or `-1` = Try and determine this automatically based on browser inspection (not guaranteed to work, errs on side of caution).
                 */
                stableSort?: number | boolean;
                /**
                 * The DOM element that will contain the game canvas, or its `id`. If undefined, or if the named element doesn't exist, the game canvas is appended to the document body. If `null` no parent will be used and you are responsible for adding the canvas to the dom.
                 */
                parent?: HTMLElement | string;
                /**
                 * Provide your own Canvas element for Phaser to use instead of creating one.
                 */
                canvas?: HTMLCanvasElement;
                /**
                 * CSS styles to apply to the game canvas instead of Phasers default styles.
                 */
                canvasStyle?: string;
                /**
                 * Is Phaser running under a custom (non-native web) environment? If so, set this to `true` to skip internal Feature detection. If `true` the `renderType` cannot be left as `AUTO`.
                 */
                customEnvironment?: boolean;
                /**
                 * Provide your own Canvas Context for Phaser to use, instead of creating one.
                 */
                context?: CanvasRenderingContext2D;
                /**
                 * A scene or scenes to add to the game. If several are given, the first is started; the remainder are started only if they have `{ active: true }`. See the `sceneConfig` argument in `Phaser.Scenes.SceneManager#add`.
                 */
                scene?: Phaser.Types.Scenes.SceneType | Phaser.Types.Scenes.SceneType[];
                /**
                 * Seed for the random number generator.
                 */
                seed?: string[];
                /**
                 * The title of the game. Shown in the browser console.
                 */
                title?: string;
                /**
                 * The URL of the game. Shown in the browser console.
                 */
                url?: string;
                /**
                 * The version of the game. Shown in the browser console.
                 */
                version?: string;
                /**
                 * Automatically call window.focus() when the game boots. Usually necessary to capture input events if the game is in a separate frame.
                 */
                autoFocus?: boolean;
                /**
                 * Input configuration, or `false` to disable all game input.
                 */
                input?: boolean | Phaser.Types.Core.InputConfig;
                /**
                 * Disable the browser's default 'contextmenu' event (usually triggered by a right-button mouse click).
                 */
                disableContextMenu?: boolean;
                /**
                 * Configuration for the banner printed in the browser console when the game starts.
                 */
                banner?: boolean | Phaser.Types.Core.BannerConfig;
                /**
                 * The DOM Container configuration object.
                 */
                dom?: Phaser.Types.Core.DOMContainerConfig;
                /**
                 * Game loop configuration.
                 */
                fps?: Phaser.Types.Core.FPSConfig;
                /**
                 * Game renderer configuration.
                 */
                render?: Phaser.Types.Core.RenderConfig;
                /**
                 * Optional callbacks to run before or after game boot.
                 */
                callbacks?: Phaser.Types.Core.CallbacksConfig;
                /**
                 * Loader configuration.
                 */
                loader?: Phaser.Types.Core.LoaderConfig;
                /**
                 * Images configuration.
                 */
                images?: Phaser.Types.Core.ImagesConfig;
                /**
                 * Physics configuration.
                 */
                physics?: Phaser.Types.Core.PhysicsConfig;
                /**
                 * Plugins to install.
                 */
                plugins?: Phaser.Types.Core.PluginObject | Phaser.Types.Core.PluginObjectItem[];
                /**
                 * The Scale Manager configuration.
                 */
                scale?: Phaser.Types.Core.ScaleConfig;
                /**
                 * The Audio Configuration object.
                 */
                audio?: Phaser.Types.Core.AudioConfig;
                /**
                 * A WebGL Pipeline configuration object. Can also be part of the `RenderConfig`.
                 */
                pipeline?: Phaser.Types.Core.PipelineConfig;
                /**
                 * The background color of the game canvas. The default is black.
                 */
                backgroundColor?: string | number;
                /**
                 * When set to `true`, WebGL uses linear interpolation to draw scaled or rotated textures, giving a smooth appearance. When set to `false`, WebGL uses nearest-neighbor interpolation, giving a crisper appearance. `false` also disables antialiasing of the game canvas itself, if the browser supports it, when the game canvas is scaled.
                 */
                antialias?: boolean;
                /**
                 * Sets the `antialias` property when the WebGL context is created. Setting this value does not impact any subsequent textures that are created, or the canvas style attributes.
                 */
                antialiasGL?: boolean;
                /**
                 * When set to `true` it will create a desynchronized context for both 2D and WebGL. See https://developers.google.com/web/updates/2019/05/desynchronized for details.
                 */
                desynchronized?: boolean;
                /**
                 * Sets `antialias` to false and `roundPixels` to true. This is the best setting for pixel-art games.
                 */
                pixelArt?: boolean;
                /**
                 * Draw texture-based Game Objects at only whole-integer positions. Game Objects without textures, like Graphics, ignore this property.
                 */
                roundPixels?: boolean;
                /**
                 * Whether the game canvas will be transparent. Boolean that indicates if the canvas contains an alpha channel. If set to false, the browser now knows that the backdrop is always opaque, which can speed up drawing of transparent content and images.
                 */
                transparent?: boolean;
                /**
                 * Whether the game canvas will be cleared between each rendering frame.
                 */
                clearBeforeRender?: boolean;
                /**
                 * If the value is true the WebGL buffers will not be cleared and will preserve their values until cleared or overwritten by the author.
                 */
                preserveDrawingBuffer?: boolean;
                /**
                 * In WebGL mode, the drawing buffer contains colors with pre-multiplied alpha.
                 */
                premultipliedAlpha?: boolean;
                /**
                 * Let the browser abort creating a WebGL context if it judges performance would be unacceptable.
                 */
                failIfMajorPerformanceCaveat?: boolean;
                /**
                 * "high-performance", "low-power" or "default". A hint to the browser on how much device power the game might use.
                 */
                powerPreference?: string;
                /**
                 * The default WebGL batch size. Represents the number of _quads_ that can be added to a single batch.
                 */
                batchSize?: number;
                /**
                 * The maximum number of lights allowed to be visible within range of a single Camera in the LightManager.
                 */
                maxLights?: number;
                /**
                 * When in WebGL mode, this sets the maximum number of GPU Textures to use. The default, -1, will use all available units. The WebGL1 spec says all browsers should provide a minimum of 8.
                 */
                maxTextures?: number;
                /**
                 * The mipmap magFilter to be used when creating WebGL textures.
                 */
                mipmapFilter?: string;
                /**
                 * Automatically enable the Mobile Pipeline if iOS or Android detected?
                 */
                autoMobilePipeline?: boolean;
                /**
                 * The WebGL Pipeline that Game Objects will use by default. Set to 'MultiPipeline' as standard.
                 */
                defaultPipeline?: string;
                /**
                 * Is the Scale Manager allowed to adjust the CSS height property of the parent and/or document body to be 100%?
                 */
                expandParent?: boolean;
                /**
                 * The scale mode.
                 */
                mode?: Phaser.Scale.ScaleModeType;
                /**
                 * The minimum width and height the canvas can be scaled down to.
                 */
                min?: WidthHeight;
                /**
                 * The maximum width the canvas can be scaled up to.
                 */
                max?: WidthHeight;
                /**
                 * Automatically round the display and style sizes of the canvas. This can help with performance in lower-powered devices.
                 */
                autoRound?: boolean;
                /**
                 * Automatically center the canvas within the parent?
                 */
                autoCenter?: Phaser.Scale.CenterType;
                /**
                 * How many ms should elapse before checking if the browser size has changed?
                 */
                resizeInterval?: number;
                /**
                 * The DOM element that will be sent into full screen mode, or its `id`. If undefined Phaser will create its own div and insert the canvas into it when entering fullscreen mode.
                 */
                fullscreenTarget?: HTMLElement | string | null;
                /**
                 * Disables the automatic creation of the Pre FX Pipelines. If disabled, you cannot use the built-in Pre FX on Game Objects.
                 */
                disablePreFX?: boolean;
                /**
                 * Disables the automatic creation of the Post FX Pipelines. If disabled, you cannot use the built-in Post FX on Game Objects.
                 */
                disablePostFX?: boolean;
            };

            type GamepadInputConfig = {
                /**
                 * Where the Gamepad Manager listens for gamepad input events.
                 */
                target?: any;
            };

            type ImagesConfig = {
                /**
                 * A base64 encoded image file to use as the 'default' texture.
                 */
                default?: string;
                /**
                 * A base64 encoded image file to use as the 'missing' texture.
                 */
                missing?: string;
                /**
                 * A base64 encoded image file to use as the 'white' texture.
                 */
                white?: string;
            };

            type InputConfig = {
                /**
                 * Keyboard input configuration. `true` uses the default configuration and `false` disables keyboard input.
                 */
                keyboard?: boolean | Phaser.Types.Core.KeyboardInputConfig;
                /**
                 * Mouse input configuration. `true` uses the default configuration and `false` disables mouse input.
                 */
                mouse?: boolean | Phaser.Types.Core.MouseInputConfig;
                /**
                 * Touch input configuration. `true` uses the default configuration and `false` disables touch input.
                 */
                touch?: boolean | Phaser.Types.Core.TouchInputConfig;
                /**
                 * Gamepad input configuration. `true` enables gamepad input.
                 */
                gamepad?: boolean | Phaser.Types.Core.GamepadInputConfig;
                /**
                 * The maximum number of touch pointers. See {@link Phaser.Input.InputManager#pointers}.
                 */
                activePointers?: number;
                /**
                 * The smoothing factor to apply during Pointer movement. See {@link Phaser.Input.Pointer#smoothFactor}.
                 */
                smoothFactor?: number;
                /**
                 * Should Phaser listen for input events on the Window? If you disable this, events like 'POINTER_UP_OUTSIDE' will no longer fire.
                 */
                windowEvents?: boolean;
            };

            type KeyboardInputConfig = {
                /**
                 * Where the Keyboard Manager listens for keyboard input events.
                 */
                target?: any;
                /**
                 * `preventDefault` will be called on every non-modified key which has a key code in this array. By default it is empty.
                 */
                capture?: number[] | null;
            };

            type LoaderConfig = {
                /**
                 * A URL used to resolve paths given to the loader. Example: 'http://labs.phaser.io/assets/'.
                 */
                baseURL?: string;
                /**
                 * A URL path used to resolve relative paths given to the loader. Example: 'images/sprites/'.
                 */
                path?: string;
                /**
                 * The maximum number of resources the loader will start loading at once.
                 */
                maxParallelDownloads?: number;
                /**
                 * 'anonymous', 'use-credentials', or `undefined`. If you're not making cross-origin requests, leave this as `undefined`. See {@link https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes}.
                 */
                crossOrigin?: string | undefined;
                /**
                 * The response type of the XHR request, e.g. `blob`, `text`, etc.
                 */
                responseType?: string;
                /**
                 * Should the XHR request use async or not?
                 */
                async?: boolean;
                /**
                 * Optional username for all XHR requests.
                 */
                user?: string;
                /**
                 * Optional password for all XHR requests.
                 */
                password?: string;
                /**
                 * Optional XHR timeout value, in ms.
                 */
                timeout?: number;
                /**
                 * An optional array of schemes that the Loader considers as being 'local' files. Defaults to: `[ 'file://', 'capacitor://' ]` if not specified.
                 */
                localScheme?: string[];
            };

            type MouseInputConfig = {
                /**
                 * Where the Mouse Manager listens for mouse input events. The default is the game canvas.
                 */
                target?: any;
                /**
                 * If `true` the DOM `mousedown` event will have `preventDefault` set.
                 */
                preventDefaultDown?: boolean;
                /**
                 * If `true` the DOM `mouseup` event will have `preventDefault` set.
                 */
                preventDefaultUp?: boolean;
                /**
                 * If `true` the DOM `mousemove` event will have `preventDefault` set.
                 */
                preventDefaultMove?: boolean;
                /**
                 * If `true` the DOM `wheel` event will have `preventDefault` set.
                 */
                preventDefaultWheel?: boolean;
            };

            /**
             * This callback type is completely empty, a no-operation.
             */
            type NOOP = ()=>void;

            type PhysicsConfig = {
                /**
                 * The default physics system. It will be started for each scene. Phaser provides 'arcade', 'impact', and 'matter'.
                 */
                default?: string;
                /**
                 * Arcade Physics configuration.
                 */
                arcade?: Phaser.Types.Physics.Arcade.ArcadeWorldConfig;
                /**
                 * Matter Physics configuration.
                 */
                matter?: Phaser.Types.Physics.Matter.MatterWorldConfig;
            };

            type PipelineConfig = {
                /**
                 * The name of the pipeline. Must be unique within the Pipeline Manager.
                 */
                name: string;
                /**
                 * The pipeline class. This should be a constructable object, **not** an instance of a class.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;
                /**
                 * Sets the `PipelineManager.frameInc` value to control the dimension increase in the Render Targets.
                 */
                frameInc?: number;
            };

            type PluginObject = {
                /**
                 * Global plugins to install.
                 */
                global?: Phaser.Types.Core.PluginObjectItem[] | null;
                /**
                 * Scene plugins to install.
                 */
                scene?: Phaser.Types.Core.PluginObjectItem[] | null;
                /**
                 * The default set of scene plugins (names).
                 */
                default?: string[];
                /**
                 * Plugins to *add* to the default set of scene plugins.
                 */
                defaultMerge?: string[];
            };

            type PluginObjectItem = {
                /**
                 * A key to identify the plugin in the Plugin Manager.
                 */
                key?: string;
                /**
                 * The plugin itself. Usually a class/constructor.
                 */
                plugin?: any;
                /**
                 * Whether the plugin should be started automatically.
                 */
                start?: boolean;
                /**
                 * For a scene plugin, add the plugin to the scene's systems object under this key (`this.sys.KEY`, from the scene).
                 */
                systemKey?: string;
                /**
                 * For a scene plugin, add the plugin to the scene object under this key (`this.KEY`, from the scene).
                 */
                sceneKey?: string;
                /**
                 * If this plugin is to be injected into the Scene Systems, this is the property key map used.
                 */
                mapping?: string;
                /**
                 * Arbitrary data passed to the plugin's init() method.
                 */
                data?: any;
            };

            type RenderConfig = {
                /**
                 * When set to `true`, WebGL uses linear interpolation to draw scaled or rotated textures, giving a smooth appearance. When set to `false`, WebGL uses nearest-neighbor interpolation, giving a crisper appearance. `false` also disables antialiasing of the game canvas itself, if the browser supports it, when the game canvas is scaled.
                 */
                antialias?: boolean;
                /**
                 * Sets the `antialias` property when the WebGL context is created. Setting this value does not impact any subsequent textures that are created, or the canvas style attributes.
                 */
                antialiasGL?: boolean;
                /**
                 * When set to `true` it will create a desynchronized context for both 2D and WebGL. See https://developers.google.com/web/updates/2019/05/desynchronized for details.
                 */
                desynchronized?: boolean;
                /**
                 * Sets `antialias` to false and `roundPixels` to true. This is the best setting for pixel-art games.
                 */
                pixelArt?: boolean;
                /**
                 * Draw texture-based Game Objects at only whole-integer positions. Game Objects without textures, like Graphics, ignore this property.
                 */
                roundPixels?: boolean;
                /**
                 * Whether the game canvas will be transparent. Boolean that indicates if the canvas contains an alpha channel. If set to false, the browser now knows that the backdrop is always opaque, which can speed up drawing of transparent content and images.
                 */
                transparent?: boolean;
                /**
                 * Whether the game canvas will be cleared between each rendering frame.
                 */
                clearBeforeRender?: boolean;
                /**
                 * If the value is true the WebGL buffers will not be cleared and will preserve their values until cleared or overwritten by the author.
                 */
                preserveDrawingBuffer?: boolean;
                /**
                 * In WebGL mode, the drawing buffer contains colors with pre-multiplied alpha.
                 */
                premultipliedAlpha?: boolean;
                /**
                 * Let the browser abort creating a WebGL context if it judges performance would be unacceptable.
                 */
                failIfMajorPerformanceCaveat?: boolean;
                /**
                 * "high-performance", "low-power" or "default". A hint to the browser on how much device power the game might use.
                 */
                powerPreference?: string;
                /**
                 * The default WebGL batch size. Represents the number of _quads_ that can be added to a single batch.
                 */
                batchSize?: number;
                /**
                 * The maximum number of lights allowed to be visible within range of a single Camera in the LightManager.
                 */
                maxLights?: number;
                /**
                 * When in WebGL mode, this sets the maximum number of GPU Textures to use. The default, -1, will use all available units. The WebGL1 spec says all browsers should provide a minimum of 8.
                 */
                maxTextures?: number;
                /**
                 * The mipmap magFilter to be used when creating WebGL textures. Don't set unless you wish to create mipmaps. Set to one of the following: 'NEAREST', 'LINEAR', 'NEAREST_MIPMAP_NEAREST', 'LINEAR_MIPMAP_NEAREST', 'NEAREST_MIPMAP_LINEAR' or 'LINEAR_MIPMAP_LINEAR'.
                 */
                mipmapFilter?: string;
                /**
                 * The WebGL Pipeline configuration object.
                 */
                pipeline?: Phaser.Types.Core.PipelineConfig;
                /**
                 * Automatically enable the Mobile Pipeline if iOS or Android detected?
                 */
                autoMobilePipeline?: boolean;
                /**
                 * The WebGL Pipeline that Game Objects will use by default. Set to 'MultiPipeline' as standard.
                 */
                defaultPipeline?: string;
            };

            type ScaleConfig = {
                /**
                 * The base width of your game. Can be an integer or a string: '100%'. If a string it will only work if you have set a parent element that has a size.
                 */
                width?: number | string;
                /**
                 * The base height of your game. Can be an integer or a string: '100%'. If a string it will only work if you have set a parent element that has a size.
                 */
                height?: number | string;
                /**
                 * The zoom value of the game canvas.
                 */
                zoom?: Phaser.Scale.ZoomType | number;
                /**
                 * The DOM element that will contain the game canvas, or its `id`. If undefined, or if the named element doesn't exist, the game canvas is inserted directly into the document body. If `null` no parent will be used and you are responsible for adding the canvas to your environment.
                 */
                parent?: HTMLElement | string | null;
                /**
                 * Is the Scale Manager allowed to adjust the CSS height property of the parent and/or document body to be 100%?
                 */
                expandParent?: boolean;
                /**
                 * The scale mode.
                 */
                mode?: Phaser.Scale.ScaleModeType;
                /**
                 * The minimum width and height the canvas can be scaled down to.
                 */
                min?: WidthHeight;
                /**
                 * The maximum width the canvas can be scaled up to.
                 */
                max?: WidthHeight;
                /**
                 * Automatically round the display and style sizes of the canvas. This can help with performance in lower-powered devices.
                 */
                autoRound?: boolean;
                /**
                 * Automatically center the canvas within the parent?
                 */
                autoCenter?: Phaser.Scale.CenterType;
                /**
                 * How many ms should elapse before checking if the browser size has changed?
                 */
                resizeInterval?: number;
                /**
                 * The DOM element that will be sent into full screen mode, or its `id`. If undefined Phaser will create its own div and insert the canvas into it when entering fullscreen mode.
                 */
                fullscreenTarget?: HTMLElement | string | null;
            };

            type TimeStepCallback = (time: number, average: number)=>void;

            type TouchInputConfig = {
                /**
                 * Where the Touch Manager listens for touch input events. The default is the game canvas.
                 */
                target?: any;
                /**
                 * Whether touch input events have preventDefault() called on them.
                 */
                capture?: boolean;
            };

            type WidthHeight = {
                /**
                 * The width.
                 */
                width?: number;
                /**
                 * The height.
                 */
                height?: number;
            };

        }

        namespace Create {
            type GenerateTextureCallback = (canvas: HTMLCanvasElement, context: CanvasRenderingContext2D)=>void;

            type GenerateTextureConfig = {
                /**
                 * An array of data, where each row is a string of single values 0-9A-F, or the period character.
                 */
                data?: any[];
                /**
                 * The HTML Canvas to draw the texture to.
                 */
                canvas?: HTMLCanvasElement;
                /**
                 * The indexed palette that the data cell values map to.
                 */
                palette?: Phaser.Types.Create.Palette;
                /**
                 * The width of each 'pixel' in the generated texture.
                 */
                pixelWidth?: number;
                /**
                 * The height of each 'pixel' in the generated texture.
                 */
                pixelHeight?: number;
                /**
                 * Should the canvas be resized before the texture is drawn?
                 */
                resizeCanvas?: boolean;
                /**
                 * Should the canvas be cleared before the texture is drawn?
                 */
                clearCanvas?: boolean;
                /**
                 * A callback to send the canvas to prior to the texture being drawn.
                 */
                preRender?: Phaser.Types.Create.GenerateTextureCallback;
                /**
                 * A callback to send the canvas to after the texture has been drawn.
                 */
                postRender?: Phaser.Types.Create.GenerateTextureCallback;
            };

            type Palette = {
                /**
                 * Color value 1.
                 */
                "0": string;
                /**
                 * Color value 2.
                 */
                "1": string;
                /**
                 * Color value 3.
                 */
                "2": string;
                /**
                 * Color value 4.
                 */
                "3": string;
                /**
                 * Color value 5.
                 */
                "4": string;
                /**
                 * Color value 6.
                 */
                "5": string;
                /**
                 * Color value 7.
                 */
                "6": string;
                /**
                 * Color value 8.
                 */
                "7": string;
                /**
                 * Color value 9.
                 */
                "8": string;
                /**
                 * Color value 10.
                 */
                "9": string;
                /**
                 * Color value 11.
                 */
                A: string;
                /**
                 * Color value 12.
                 */
                B: string;
                /**
                 * Color value 13.
                 */
                C: string;
                /**
                 * Color value 14.
                 */
                D: string;
                /**
                 * Color value 15.
                 */
                E: string;
                /**
                 * Color value 16.
                 */
                F: string;
            };

        }

        namespace Curves {
            type EllipseCurveConfig = {
                /**
                 * The x coordinate of the ellipse.
                 */
                x?: number;
                /**
                 * The y coordinate of the ellipse.
                 */
                y?: number;
                /**
                 * The horizontal radius of the ellipse.
                 */
                xRadius?: number;
                /**
                 * The vertical radius of the ellipse.
                 */
                yRadius?: number;
                /**
                 * The start angle of the ellipse, in degrees.
                 */
                startAngle?: number;
                /**
                 * The end angle of the ellipse, in degrees.
                 */
                endAngle?: number;
                /**
                 * Sets if the the ellipse rotation is clockwise (true) or anti-clockwise (false)
                 */
                clockwise?: boolean;
                /**
                 * The rotation of the ellipse, in degrees.
                 */
                rotation?: number;
            };

            type JSONCurve = {
                /**
                 * The of the curve
                 */
                type: string;
                /**
                 * The arrays of points like `[x1, y1, x2, y2]`
                 */
                points: number[];
            };

            type JSONEllipseCurve = {
                /**
                 * The of the curve.
                 */
                type: string;
                /**
                 * The x coordinate of the ellipse.
                 */
                x: number;
                /**
                 * The y coordinate of the ellipse.
                 */
                y: number;
                /**
                 * The horizontal radius of ellipse.
                 */
                xRadius: number;
                /**
                 * The vertical radius of ellipse.
                 */
                yRadius: number;
                /**
                 * The start angle of the ellipse, in degrees.
                 */
                startAngle: number;
                /**
                 * The end angle of the ellipse, in degrees.
                 */
                endAngle: number;
                /**
                 * Sets if the the ellipse rotation is clockwise (true) or anti-clockwise (false)
                 */
                clockwise: boolean;
                /**
                 * The rotation of ellipse, in degrees.
                 */
                rotation: number;
            };

            type JSONPath = {
                /**
                 * The of the curve.
                 */
                type: string;
                /**
                 * The X coordinate of the curve's starting point.
                 */
                x: number;
                /**
                 * The Y coordinate of the path's starting point.
                 */
                y: number;
                /**
                 * The path is auto closed.
                 */
                autoClose: boolean;
                /**
                 * The list of the curves
                 */
                curves: Phaser.Types.Curves.JSONCurve[];
            };

        }

        namespace Display {
            type ColorObject = {
                /**
                 * The red color value in the range 0 to 255.
                 */
                r: number;
                /**
                 * The green color value in the range 0 to 255.
                 */
                g: number;
                /**
                 * The blue color value in the range 0 to 255.
                 */
                b: number;
                /**
                 * The alpha color value in the range 0 to 255.
                 */
                a: number;
                /**
                 * The combined color value.
                 */
                color: number;
            };

            type HSVColorObject = {
                /**
                 * The hue color value. A number between 0 and 1
                 */
                h: number;
                /**
                 * The saturation color value. A number between 0 and 1
                 */
                s: number;
                /**
                 * The lightness color value. A number between 0 and 1
                 */
                v: number;
            };

            type InputColorObject = {
                /**
                 * The red color value in the range 0 to 255.
                 */
                r?: number;
                /**
                 * The green color value in the range 0 to 255.
                 */
                g?: number;
                /**
                 * The blue color value in the range 0 to 255.
                 */
                b?: number;
                /**
                 * The alpha color value in the range 0 to 255.
                 */
                a?: number;
            };

        }

        namespace GameObjects {
            namespace BitmapText {
                /**
                 * The font data for an individual character of a Bitmap Font.
                 * 
                 * Describes the character's position, size, offset and kerning.
                 * 
                 * As of version 3.50 it also includes the WebGL texture uv data.
                 */
                type BitmapFontCharacterData = {
                    /**
                     * The x position of the character.
                     */
                    x: number;
                    /**
                     * The y position of the character.
                     */
                    y: number;
                    /**
                     * The width of the character.
                     */
                    width: number;
                    /**
                     * The height of the character.
                     */
                    height: number;
                    /**
                     * The center x position of the character.
                     */
                    centerX: number;
                    /**
                     * The center y position of the character.
                     */
                    centerY: number;
                    /**
                     * The x offset of the character.
                     */
                    xOffset: number;
                    /**
                     * The y offset of the character.
                     */
                    yOffset: number;
                    /**
                     * WebGL texture u0.
                     */
                    u0: number;
                    /**
                     * WebGL texture v0.
                     */
                    v0: number;
                    /**
                     * WebGL texture u1.
                     */
                    u1: number;
                    /**
                     * WebGL texture v1.
                     */
                    v1: number;
                    /**
                     * Extra data for the character.
                     */
                    data: object;
                    /**
                     * Kerning values, keyed by character code.
                     */
                    kerning: {[key: string]: number};
                };

                /**
                 * Bitmap Font data that can be used by a BitmapText Game Object.
                 */
                type BitmapFontData = {
                    /**
                     * The name of the font.
                     */
                    font: string;
                    /**
                     * The size of the font.
                     */
                    size: number;
                    /**
                     * The line height of the font.
                     */
                    lineHeight: number;
                    /**
                     * Whether this font is a retro font (monospace).
                     */
                    retroFont: boolean;
                    /**
                     * The character data of the font, keyed by character code. Each character datum includes a position, size, offset and more.
                     */
                    chars: {[key: number]:  Phaser.Types.GameObjects.BitmapText.BitmapFontCharacterData};
                };

                /**
                 * A single entry from the `BitmapTextSize` characters array.
                 * 
                 * The position and dimensions take the font size into account,
                 * but are not translated into the local space of the Game Object itself.
                 */
                type BitmapTextCharacter = {
                    /**
                     * The index of this character within the BitmapText wrapped text string.
                     */
                    i: number;
                    /**
                     * The index of this character within the BitmapText text string.
                     */
                    idx: number;
                    /**
                     * The character.
                     */
                    char: string;
                    /**
                     * The character code of the character.
                     */
                    code: number;
                    /**
                     * The x position of the character in the BitmapText.
                     */
                    x: number;
                    /**
                     * The y position of the character in the BitmapText.
                     */
                    y: number;
                    /**
                     * The width of the character.
                     */
                    w: number;
                    /**
                     * The height of the character.
                     */
                    h: number;
                    /**
                     * The top of the line this character is on.
                     */
                    t: number;
                    /**
                     * The right-most point of this character, including xAdvance.
                     */
                    r: number;
                    /**
                     * The bottom of the line this character is on.
                     */
                    b: number;
                    /**
                     * The line number the character appears on.
                     */
                    line: number;
                    /**
                     * Reference to the glyph object this character is using.
                     */
                    glyph: Phaser.Types.GameObjects.BitmapText.BitmapFontCharacterData;
                };

                type BitmapTextConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key of the font to use from the BitmapFont cache.
                     */
                    font?: string;
                    /**
                     * The string, or array of strings, to be set as the content of this Bitmap Text.
                     */
                    text?: string;
                    /**
                     * The font size to set.
                     */
                    size?: number | false;
                };

                /**
                 * Details about the line data in the `BitmapTextSize` object.
                 */
                type BitmapTextLines = {
                    /**
                     * The width of the shortest line of text.
                     */
                    shortest: number;
                    /**
                     * The width of the longest line of text.
                     */
                    longest: number;
                    /**
                     * The height of a line of text.
                     */
                    height: number;
                    /**
                     * An array where each entry contains the length of that line of text.
                     */
                    lengths: number[];
                };

                type BitmapTextSize = {
                    /**
                     * The position and size of the BitmapText, taking into account the position and scale of the Game Object.
                     */
                    global: Phaser.Types.GameObjects.BitmapText.GlobalBitmapTextSize;
                    /**
                     * The position and size of the BitmapText, taking just the font size into account.
                     */
                    local: Phaser.Types.GameObjects.BitmapText.LocalBitmapTextSize;
                    /**
                     * Data about the lines of text within the BitmapText.
                     */
                    lines: Phaser.Types.GameObjects.BitmapText.BitmapTextLines;
                    /**
                     * An array containing per-character data. Only populated if `includeChars` is `true` in the `getTextBounds` call.
                     */
                    characters: Phaser.Types.GameObjects.BitmapText.BitmapTextCharacter[];
                    /**
                     * An array containing the word data from the BitmapText.
                     */
                    words: Phaser.Types.GameObjects.BitmapText.BitmapTextWord[];
                    /**
                     * The scale of the BitmapText font being rendered vs. font size in the text data.
                     */
                    scale: number;
                    /**
                     * The scale X value of the BitmapText.
                     */
                    scaleX: number;
                    /**
                     * The scale Y value of the BitmapText.
                     */
                    scaleY: number;
                    /**
                     * The wrapped text, if wrapping enabled and required.
                     */
                    wrappedText: string;
                };

                /**
                 * Details about a single world entry in the `BitmapTextSize` object words array.
                 */
                type BitmapTextWord = {
                    /**
                     * The x position of the word in the BitmapText.
                     */
                    x: number;
                    /**
                     * The y position of the word in the BitmapText.
                     */
                    y: number;
                    /**
                     * The width of the word.
                     */
                    w: number;
                    /**
                     * The height of the word.
                     */
                    h: number;
                    /**
                     * The index of the first character of this word within the entire string. Note: this index factors in spaces, quotes, carriage-returns, etc.
                     */
                    i: number;
                    /**
                     * The word.
                     */
                    word: string;
                };

                type DisplayCallbackConfig = {
                    /**
                     * The Dynamic Bitmap Text object that owns this character being rendered.
                     */
                    parent: Phaser.GameObjects.DynamicBitmapText;
                    /**
                     * The tint of the character being rendered. Always zero in Canvas.
                     */
                    tint: Phaser.Types.GameObjects.BitmapText.TintConfig;
                    /**
                     * The index of the character being rendered.
                     */
                    index: number;
                    /**
                     * The character code of the character being rendered.
                     */
                    charCode: number;
                    /**
                     * The x position of the character being rendered.
                     */
                    x: number;
                    /**
                     * The y position of the character being rendered.
                     */
                    y: number;
                    /**
                     * The scale of the character being rendered.
                     */
                    scale: number;
                    /**
                     * The rotation of the character being rendered.
                     */
                    rotation: number;
                    /**
                     * Custom data stored with the character being rendered.
                     */
                    data: any;
                };

                type DisplayCallback = (display: Phaser.Types.GameObjects.BitmapText.DisplayCallbackConfig)=>Phaser.Types.GameObjects.BitmapText.DisplayCallbackConfig;

                /**
                 * The position and size of the Bitmap Text in global space, taking into account the Game Object's scale and world position.
                 */
                type GlobalBitmapTextSize = {
                    /**
                     * The x position of the BitmapText, taking into account the x position and scale of the Game Object.
                     */
                    x: number;
                    /**
                     * The y position of the BitmapText, taking into account the y position and scale of the Game Object.
                     */
                    y: number;
                    /**
                     * The width of the BitmapText, taking into account the x scale of the Game Object.
                     */
                    width: number;
                    /**
                     * The height of the BitmapText, taking into account the y scale of the Game Object.
                     */
                    height: number;
                };

                type JSONBitmapText = Phaser.Types.GameObjects.JSONGameObject & {
                    /**
                     * The name of the font.
                     */
                    font: string;
                    /**
                     * The text that this Bitmap Text displays.
                     */
                    text: string;
                    /**
                     * The size of the font.
                     */
                    fontSize: number;
                    /**
                     * Adds / Removes spacing between characters.
                     */
                    letterSpacing: number;
                    /**
                     * Adds / Removes spacing between lines in multi-line text.
                     */
                    lineSpacing: number;
                    /**
                     * The alignment of the text in a multi-line BitmapText object.
                     */
                    align: number;
                };

                /**
                 * The position and size of the Bitmap Text in local space, taking just the font size into account.
                 */
                type LocalBitmapTextSize = {
                    /**
                     * The x position of the BitmapText.
                     */
                    x: number;
                    /**
                     * The y position of the BitmapText.
                     */
                    y: number;
                    /**
                     * The width of the BitmapText.
                     */
                    width: number;
                    /**
                     * The height of the BitmapText.
                     */
                    height: number;
                };

                type RetroFontConfig = {
                    /**
                     * The key of the image containing the font.
                     */
                    image: string;
                    /**
                     * If the font set doesn't start at the top left of the given image, specify the X coordinate offset here.
                     */
                    "offset.x": number;
                    /**
                     * If the font set doesn't start at the top left of the given image, specify the Y coordinate offset here.
                     */
                    "offset.y": number;
                    /**
                     * The width of each character in the font set.
                     */
                    width: number;
                    /**
                     * The height of each character in the font set.
                     */
                    height: number;
                    /**
                     * The characters used in the font set, in display order. You can use the TEXT_SET consts for common font set arrangements.
                     */
                    chars: string;
                    /**
                     * The number of characters per row in the font set. If not given charsPerRow will be the image width / characterWidth.
                     */
                    charsPerRow: number;
                    /**
                     * If the characters in the font set have horizontal spacing between them set the required amount here.
                     */
                    "spacing.x": number;
                    /**
                     * If the characters in the font set have vertical spacing between them set the required amount here.
                     */
                    "spacing.y": number;
                    /**
                     * The amount of vertical space to add to the line height of the font.
                     */
                    lineSpacing: number;
                };

                type TintConfig = {
                    /**
                     * The top left tint value. Always zero in canvas.
                     */
                    topLeft: number;
                    /**
                     * The top right tint value. Always zero in canvas.
                     */
                    topRight: number;
                    /**
                     * The bottom left tint value. Always zero in canvas.
                     */
                    bottomLeft: number;
                    /**
                     * The bottom right tint value. Always zero in canvas.
                     */
                    bottomRight: number;
                };

            }

            namespace Container {
                type ContainerConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * An optional array of Game Objects to add to the Container.
                     */
                    children?: Phaser.GameObjects.GameObject[];
                };

            }

            namespace Graphics {
                /**
                 * Graphics fill style settings.
                 */
                type FillStyle = {
                    /**
                     * The fill color.
                     */
                    color?: number;
                    /**
                     * The fill alpha.
                     */
                    alpha?: number;
                };

                /**
                 * Graphics line style (or stroke style) settings.
                 */
                type LineStyle = {
                    /**
                     * The stroke width.
                     */
                    width?: number;
                    /**
                     * The stroke color.
                     */
                    color?: number;
                    /**
                     * The stroke alpha.
                     */
                    alpha?: number;
                };

                /**
                 * Options for the Graphics Game Object.
                 */
                type Options = Phaser.Types.GameObjects.Graphics.Styles & {
                    /**
                     * The x coordinate of the Graphics.
                     */
                    x?: number;
                    /**
                     * The y coordinate of the Graphics.
                     */
                    y?: number;
                };

                type RoundedRectRadius = {
                    /**
                     * Top left corner radius. Draw concave arc if this radius is negative.
                     */
                    tl?: number;
                    /**
                     * Top right corner radius. Draw concave arc if this radius is negative.
                     */
                    tr?: number;
                    /**
                     * Bottom right corner radius. Draw concave arc if this radius is negative.
                     */
                    br?: number;
                    /**
                     * Bottom left corner radius. Draw concave arc if this radius is negative.
                     */
                    bl?: number;
                };

                /**
                 * Graphics style settings.
                 */
                type Styles = {
                    /**
                     * The style applied to shape outlines.
                     */
                    lineStyle?: Phaser.Types.GameObjects.Graphics.LineStyle;
                    /**
                     * The style applied to shape areas.
                     */
                    fillStyle?: Phaser.Types.GameObjects.Graphics.FillStyle;
                };

            }

            namespace Group {
                type GroupCallback = (item: Phaser.GameObjects.GameObject)=>void;

                type GroupClassTypeConstructor = (scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number)=>void;

                type GroupConfig = {
                    /**
                     * Sets {@link Phaser.GameObjects.Group#classType}.
                     */
                    classType?: Function | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#name}.
                     */
                    name?: string | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#active}.
                     */
                    active?: boolean | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#maxSize}.
                     */
                    maxSize?: number | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#defaultKey}.
                     */
                    defaultKey?: string | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#defaultFrame}.
                     */
                    defaultFrame?: string | number | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#runChildUpdate}.
                     */
                    runChildUpdate?: boolean | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#createCallback}.
                     */
                    createCallback?: Phaser.Types.GameObjects.Group.GroupCallback | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#removeCallback}.
                     */
                    removeCallback?: Phaser.Types.GameObjects.Group.GroupCallback | null;
                    /**
                     * Sets {@link Phaser.GameObjects.Group#createMultipleCallback}.
                     */
                    createMultipleCallback?: Phaser.Types.GameObjects.Group.GroupMultipleCreateCallback | null;
                };

                /**
                 * The total number of objects created will be
                 * 
                 *     key.length * frame.length * frameQuantity * (yoyo ? 2 : 1) * (1 + repeat)
                 * 
                 * If `max` is nonzero, then the total created will not exceed `max`.
                 * 
                 * `key` is required. {@link Phaser.GameObjects.Group#defaultKey} is not used.
                 */
                type GroupCreateConfig = {
                    /**
                     * The texture key of each new Game Object. Must be provided or not objects will be created.
                     */
                    key: string | string[];
                    /**
                     * The class of each new Game Object.
                     */
                    classType?: Function | null;
                    /**
                     * The texture frame of each new Game Object.
                     */
                    frame?: string | string[] | number | number[] | null;
                    /**
                     * The number of Game Objects to create. If set, this overrides the `frameQuantity` value. Use `frameQuantity` for more advanced control.
                     */
                    quantity?: number | null;
                    /**
                     * The visible state of each new Game Object.
                     */
                    visible?: boolean | null;
                    /**
                     * The active state of each new Game Object.
                     */
                    active?: boolean | null;
                    /**
                     * The number of times each `key` × `frame` combination will be *repeated* (after the first combination).
                     */
                    repeat?: number | null;
                    /**
                     * Select a `key` at random.
                     */
                    randomKey?: boolean | null;
                    /**
                     * Select a `frame` at random.
                     */
                    randomFrame?: boolean | null;
                    /**
                     * Select keys and frames by moving forward then backward through `key` and `frame`.
                     */
                    yoyo?: boolean | null;
                    /**
                     * The number of times each `frame` should be combined with one `key`.
                     */
                    frameQuantity?: number | null;
                    /**
                     * The maximum number of new Game Objects to create. 0 is no maximum.
                     */
                    max?: number | null;
                    setXY?: object | null;
                    /**
                     * The horizontal position of each new Game Object.
                     */
                    "setXY.x"?: number | null;
                    /**
                     * The vertical position of each new Game Object.
                     */
                    "setXY.y"?: number | null;
                    /**
                     * Increment each Game Object's horizontal position from the previous by this amount, starting from `setXY.x`.
                     */
                    "setXY.stepX"?: number | null;
                    /**
                     * Increment each Game Object's vertical position from the previous by this amount, starting from `setXY.y`.
                     */
                    "setXY.stepY"?: number | null;
                    setRotation?: object | null;
                    /**
                     * Rotation of each new Game Object.
                     */
                    "setRotation.value"?: number | null;
                    /**
                     * Increment each Game Object's rotation from the previous by this amount, starting at `setRotation.value`.
                     */
                    "setRotation.step"?: number | null;
                    setScale?: object | null;
                    /**
                     * The horizontal scale of each new Game Object.
                     */
                    "setScale.x"?: number | null;
                    /**
                     * The vertical scale of each new Game Object.
                     */
                    "setScale.y"?: number | null;
                    /**
                     * Increment each Game Object's horizontal scale from the previous by this amount, starting from `setScale.x`.
                     */
                    "setScale.stepX"?: number | null;
                    /**
                     * Increment each Game object's vertical scale from the previous by this amount, starting from `setScale.y`.
                     */
                    "setScale.stepY"?: number | null;
                    setOrigin?: object | null;
                    /**
                     * The horizontal origin of each new Game Object.
                     */
                    "setOrigin.x"?: number | null;
                    /**
                     * The vertical origin of each new Game Object.
                     */
                    "setOrigin.y"?: number | null;
                    /**
                     * Increment each Game Object's horizontal origin from the previous by this amount, starting from `setOrigin.x`.
                     */
                    "setOrigin.stepX"?: number | null;
                    /**
                     * Increment each Game object's vertical origin from the previous by this amount, starting from `setOrigin.y`.
                     */
                    "setOrigin.stepY"?: number | null;
                    setAlpha?: object | null;
                    /**
                     * The alpha value of each new Game Object.
                     */
                    "setAlpha.value"?: number | null;
                    /**
                     * Increment each Game Object's alpha from the previous by this amount, starting from `setAlpha.value`.
                     */
                    "setAlpha.step"?: number | null;
                    setDepth?: object | null;
                    /**
                     * The depth value of each new Game Object.
                     */
                    "setDepth.value"?: number | null;
                    /**
                     * Increment each Game Object's depth from the previous by this amount, starting from `setDepth.value`.
                     */
                    "setDepth.step"?: number | null;
                    setScrollFactor?: object | null;
                    /**
                     * The horizontal scroll factor of each new Game Object.
                     */
                    "setScrollFactor.x"?: number | null;
                    /**
                     * The vertical scroll factor of each new Game Object.
                     */
                    "setScrollFactor.y"?: number | null;
                    /**
                     * Increment each Game Object's horizontal scroll factor from the previous by this amount, starting from `setScrollFactor.x`.
                     */
                    "setScrollFactor.stepX"?: number | null;
                    /**
                     * Increment each Game object's vertical scroll factor from the previous by this amount, starting from `setScrollFactor.y`.
                     */
                    "setScrollFactor.stepY"?: number | null;
                    /**
                     * A geometric shape that defines the hit area for the Game Object.
                     */
                    hitArea?: any | null;
                    /**
                     * A callback to be invoked when the Game Object is interacted with.
                     */
                    hitAreaCallback?: Phaser.Types.Input.HitAreaCallback | null;
                    /**
                     * Align the new Game Objects in a grid using these settings.
                     */
                    gridAlign?: false | Phaser.Types.Actions.GridAlignConfig | null;
                };

                type GroupMultipleCreateCallback = (items: Phaser.GameObjects.GameObject[])=>void;

            }

            namespace Mesh {
                type MeshConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                     */
                    key?: string | Phaser.Textures.Texture;
                    /**
                     * An optional frame from the Texture this Game Object is rendering with.
                     */
                    frame?: string | number;
                    /**
                     * The vertices array. Either `xy` pairs, or `xyz` if the `containsZ` parameter is `true`.
                     */
                    vertices?: number[];
                    /**
                     * The UVs pairs array.
                     */
                    uvs?: number[];
                    /**
                     * Optional vertex indicies array. If you don't have one, pass `null` or an empty array.
                     */
                    indicies?: number[];
                    /**
                     * Does the vertices data include a `z` component?
                     */
                    containsZ?: boolean;
                    /**
                     * Optional vertex normals array. If you don't have one, pass `null` or an empty array.
                     */
                    normals?: number[];
                    /**
                     * An array of colors, one per vertex, or a single color value applied to all vertices.
                     */
                    colors?: number | number[];
                    /**
                     * An array of alpha values, one per vertex, or a single alpha value applied to all vertices.
                     */
                    alphas?: number | number[];
                };

            }

            namespace NineSlice {
                type NineSliceConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                     */
                    key?: string | Phaser.Textures.Texture;
                    /**
                     * An optional frame from the Texture this Game Object is rendering with.
                     */
                    frame?: string | number;
                    /**
                     * The width of the Nine Slice Game Object. You can adjust the width post-creation.
                     */
                    width?: number;
                    /**
                     * The height of the Nine Slice Game Object. If this is a 3 slice object the height will be fixed to the height of the texture and cannot be changed.
                     */
                    height?: number;
                    /**
                     * The size of the left vertical column (A).
                     */
                    leftWidth?: number;
                    /**
                     * The size of the right vertical column (B).
                     */
                    rightWidth?: number;
                    /**
                     * The size of the top horiztonal row (C). Set to zero or undefined to create a 3 slice object.
                     */
                    topHeight?: number;
                    /**
                     * The size of the bottom horiztonal row (D). Set to zero or undefined to create a 3 slice object.
                     */
                    bottomHeight?: number;
                };

            }

            namespace Particles {
                type DeathZoneObject = Phaser.GameObjects.Particles.Zones.DeathZone | Phaser.Types.GameObjects.Particles.ParticleEmitterDeathZoneConfig | Phaser.Types.GameObjects.Particles.DeathZoneSource;

                type DeathZoneSource = {
                    contains: Phaser.Types.GameObjects.Particles.DeathZoneSourceCallback;
                };

                type DeathZoneSourceCallback = (x: number, y: number)=>boolean;

                type EdgeZoneSource = {
                    /**
                     * A function placing points on the sources edge or edges.
                     */
                    getPoints: Phaser.Types.GameObjects.Particles.EdgeZoneSourceCallback;
                };

                type EdgeZoneSourceCallback = (quantity: number, stepRate?: number)=>Phaser.Types.Math.Vector2Like[];

                type EmitterOpCustomEmitConfig = {
                    /**
                     * A callback that is invoked each time the emitter emits a particle.
                     */
                    onEmit: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitCallback;
                };

                type EmitterOpCustomUpdateConfig = {
                    /**
                     * A callback that is invoked each time the emitter emits a particle.
                     */
                    onEmit?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitCallback;
                    /**
                     * A callback that is invoked each time the emitter updates.
                     */
                    onUpdate: Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateCallback;
                };

                /**
                 * Defines an operation yielding a value incremented continuously across a range.
                 */
                type EmitterOpEaseConfig = {
                    /**
                     * The starting value.
                     */
                    start: number;
                    /**
                     * The ending value.
                     */
                    end: number;
                    /**
                     * If true, the particle starts with a minimum random value between the start and end values.
                     */
                    random?: boolean;
                    /**
                     * The ease to find. This can be either a string from the EaseMap, or a custom function.
                     */
                    ease?: string | Function;
                    /**
                     * An optional array of ease parameters to go with the ease.
                     */
                    easeParams?: number[];
                };

                /**
                 * Defines an operation yielding a value incremented continuously across an interpolated data set.
                 */
                type EmitterOpInterpolationConfig = {
                    /**
                     * The array of number values to interpolate through.
                     */
                    values: number[];
                    /**
                     * The interpolation function to use. Typically one of `linear`, `bezier` or `catmull` or a custom function.
                     */
                    interpolation?: string | Function;
                    /**
                     * An optional ease function to use. This can be either a string from the EaseMap, or a custom function.
                     */
                    ease?: string | Function;
                    /**
                     * An optional array of ease parameters to go with the ease.
                     */
                    easeParams?: number[];
                };

                /**
                 * The returned value sets what the property will be at the START of the particle's life, on emit.
                 */
                type EmitterOpOnEmitCallback = (particle?: Phaser.GameObjects.Particles.Particle, key?: string, value?: number)=>number;

                type EmitterOpOnEmitType = number | number[] | Phaser.Types.GameObjects.Particles.EmitterOpOnEmitCallback | Phaser.Types.GameObjects.Particles.EmitterOpRandomConfig | Phaser.Types.GameObjects.Particles.EmitterOpRandomMinMaxConfig | Phaser.Types.GameObjects.Particles.EmitterOpSteppedConfig | Phaser.Types.GameObjects.Particles.EmitterOpCustomEmitConfig;

                /**
                 * The returned value updates the property for the duration of the particle's life.
                 */
                type EmitterOpOnUpdateCallback = (particle: Phaser.GameObjects.Particles.Particle, key: string, t: number, value: number)=>number;

                type EmitterOpOnUpdateType = Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateCallback | Phaser.Types.GameObjects.Particles.EmitterOpEaseConfig | Phaser.Types.GameObjects.Particles.EmitterOpCustomUpdateConfig | Phaser.Types.GameObjects.Particles.EmitterOpInterpolationConfig;

                /**
                 * Defines an operation yielding a random value within a range.
                 */
                type EmitterOpRandomConfig = {
                    /**
                     * The minimum and maximum values, as [min, max].
                     */
                    random: number[];
                };

                /**
                 * Defines an operation yielding a random value within a range.
                 */
                type EmitterOpRandomMinMaxConfig = {
                    /**
                     * The minimum value.
                     */
                    min: number;
                    /**
                     * The maximum value.
                     */
                    max: number;
                    /**
                     * If true, only integers are selected from the range.
                     */
                    int?: boolean;
                };

                /**
                 * Defines an operation yielding a value incremented by steps across a range.
                 */
                type EmitterOpSteppedConfig = {
                    /**
                     * The starting value.
                     */
                    start: number;
                    /**
                     * The ending value.
                     */
                    end: number;
                    /**
                     * The number of steps between start and end.
                     */
                    steps: number;
                };

                type EmitZoneData = Phaser.Types.GameObjects.Particles.ParticleEmitterEdgeZoneConfig | Phaser.Types.GameObjects.Particles.ParticleEmitterRandomZoneConfig | Phaser.GameObjects.Particles.Zones.EdgeZone | Phaser.GameObjects.Particles.Zones.RandomZone;

                type EmitZoneObject = Phaser.GameObjects.Particles.Zones.EdgeZone | Phaser.GameObjects.Particles.Zones.RandomZone;

                type GravityWellConfig = {
                    /**
                     * The x coordinate of the Gravity Well, in world space.
                     */
                    x?: number;
                    /**
                     * The y coordinate of the Gravity Well, in world space.
                     */
                    y?: number;
                    /**
                     * The strength of the gravity force - larger numbers produce a stronger force.
                     */
                    power?: number;
                    /**
                     * The minimum distance for which the gravity force is calculated.
                     */
                    epsilon?: number;
                    /**
                     * The gravitational force of this Gravity Well.
                     */
                    gravity?: number;
                };

                type ParticleClassConstructor = (emitter: Phaser.GameObjects.Particles.ParticleEmitter)=>void;

                type ParticleData = {
                    tint?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    alpha?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    rotate?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    scaleX?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    scaleY?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    x?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    y?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    accelerationX?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    accelerationY?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    maxVelocityX?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    maxVelocityY?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    moveToX?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    moveToY?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                    bounce?: Phaser.Types.GameObjects.Particles.ParticleDataValue;
                };

                type ParticleDataValue = {
                    /**
                     * The minimum value.
                     */
                    min: number;
                    /**
                     * The maximum value.
                     */
                    max: number;
                };

                type ParticleDeathCallback = (particle: Phaser.GameObjects.Particles.Particle)=>void;

                type ParticleEmitterAnimConfig = {
                    /**
                     * One or more animations names, or Play Animation Config objects.
                     */
                    anims?: string | string[] | Phaser.Types.Animations.PlayAnimationConfig | Phaser.Types.Animations.PlayAnimationConfig[];
                    /**
                     * Whether animations will be assigned consecutively (true) or at random (false).
                     */
                    cycle?: boolean;
                    /**
                     * The number of consecutive particles receiving each animation, when `cycle` is true.
                     */
                    quantity?: number;
                };

                type ParticleEmitterBounds = {
                    /**
                     * The left edge of the rectangle.
                     */
                    x: number;
                    /**
                     * The top edge of the rectangle.
                     */
                    y: number;
                    /**
                     * The width of the rectangle.
                     */
                    width: number;
                    /**
                     * The height of the rectangle.
                     */
                    height: number;
                };

                type ParticleEmitterBoundsAlt = {
                    /**
                     * The left edge of the rectangle.
                     */
                    x: number;
                    /**
                     * The top edge of the rectangle.
                     */
                    y: number;
                    /**
                     * The width of the rectangle.
                     */
                    w: number;
                    /**
                     * The height of the rectangle.
                     */
                    h: number;
                };

                type ParticleEmitterCallback = (particle: Phaser.GameObjects.Particles.Particle, emitter: Phaser.GameObjects.Particles.ParticleEmitter)=>void;

                type ParticleEmitterConfig = {
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#active}. Setting this to false will stop the emitter from running at all. If you just wish to stop particles from emitting, set `emitting` property instead.
                     */
                    active?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#blendMode}.
                     */
                    blendMode?: Phaser.BlendModes | string;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#deathCallbackScope} and {@link Phaser.GameObjects.Particles.ParticleEmitter#emitCallbackScope}.
                     */
                    callbackScope?: any;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#collideBottom}.
                     */
                    collideBottom?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#collideLeft}.
                     */
                    collideLeft?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#collideRight}.
                     */
                    collideRight?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#collideTop}.
                     */
                    collideTop?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#deathCallback}.
                     */
                    deathCallback?: Function;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#deathCallbackScope}.
                     */
                    deathCallbackScope?: any;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#emitCallback}.
                     */
                    emitCallback?: Function;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#emitCallbackScope}.
                     */
                    emitCallbackScope?: any;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#follow}.
                     */
                    follow?: Phaser.Types.Math.Vector2Like;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#frequency}.
                     */
                    frequency?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#gravityX}.
                     */
                    gravityX?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#gravityY}.
                     */
                    gravityY?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#maxParticles}.
                     */
                    maxParticles?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#maxAliveParticles}.
                     */
                    maxAliveParticles?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#name}.
                     */
                    name?: string;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#emitting}.
                     */
                    emitting?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleBringToTop}.
                     */
                    particleBringToTop?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleClass}.
                     */
                    particleClass?: Function;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#radial}.
                     */
                    radial?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#timeScale}.
                     */
                    timeScale?: number;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#trackVisible}.
                     */
                    trackVisible?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#visible}.
                     */
                    visible?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#accelerationX}.
                     */
                    accelerationX?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#accelerationY}.
                     */
                    accelerationY?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleAlpha}.
                     */
                    alpha?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleAngle} (emit only).
                     */
                    angle?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#bounce}.
                     */
                    bounce?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#delay} (emit only).
                     */
                    delay?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#hold} (emit only).
                     */
                    hold?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#lifespan} (emit only).
                     */
                    lifespan?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#maxVelocityX}.
                     */
                    maxVelocityX?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#maxVelocityY}.
                     */
                    maxVelocityY?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#moveToX}. If set, overrides `angle` and `speed` properties.
                     */
                    moveToX?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#moveToY}. If set, overrides `angle` and `speed` properties.
                     */
                    moveToY?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#quantity} (emit only).
                     */
                    quantity?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleRotate}.
                     */
                    rotate?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * As {@link Phaser.GameObjects.Particles.ParticleEmitter#setScale}.
                     */
                    scale?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleScaleX}.
                     */
                    scaleX?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleScaleY}.
                     */
                    scaleY?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * As {@link Phaser.GameObjects.Particles.ParticleEmitter#setSpeed} (emit only).
                     */
                    speed?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#speedX} (emit only).
                     */
                    speedX?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#speedY} (emit only).
                     */
                    speedY?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleTint}.
                     */
                    tint?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * An array of color values that the Particles interpolate through during their life. If set, overrides any `tint` property.
                     */
                    color?: number[];
                    /**
                     * The string-based name of the Easing function to use if you have enabled Particle color interpolation via the `color` property, otherwise has no effect.
                     */
                    colorEase?: string;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleX}.
                     */
                    x?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#particleY}.
                     */
                    y?: Phaser.Types.GameObjects.Particles.EmitterOpOnEmitType | Phaser.Types.GameObjects.Particles.EmitterOpOnUpdateType;
                    /**
                     * As {@link Phaser.GameObjects.Particles.ParticleEmitter#setEmitZone}.
                     */
                    emitZone?: Phaser.Types.GameObjects.Particles.EmitZoneData | Phaser.Types.GameObjects.Particles.EmitZoneData[];
                    /**
                     * As {@link Phaser.GameObjects.Particles.ParticleEmitter#setDeathZone}.
                     */
                    deathZone?: Phaser.Types.GameObjects.Particles.DeathZoneObject | Phaser.Types.GameObjects.Particles.DeathZoneObject[];
                    /**
                     * As {@link Phaser.GameObjects.Particles.ParticleEmitter#setBounds}.
                     */
                    bounds?: Phaser.Types.GameObjects.Particles.ParticleEmitterBounds | Phaser.Types.GameObjects.Particles.ParticleEmitterBoundsAlt;
                    /**
                     * Offset coordinates that assigns to {@link Phaser.GameObjects.Particles.ParticleEmitter#followOffset}.
                     */
                    followOffset?: Phaser.Types.Math.Vector2Like;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#anims}.
                     */
                    anim?: string | string[] | Phaser.Types.GameObjects.Particles.ParticleEmitterAnimConfig;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#frames}.
                     */
                    frame?: number | number[] | string | string[] | Phaser.Textures.Frame | Phaser.Textures.Frame[] | Phaser.Types.GameObjects.Particles.ParticleEmitterFrameConfig;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#texture}. Overrides any texture already set on the Emitter.
                     */
                    texture?: string | Phaser.Textures.Texture;
                    /**
                     * Creates specified number of inactive particles and adds them to this emitter's pool. {@link Phaser.GameObjects.Particles.ParticleEmitter#reserve}
                     */
                    reserve?: number;
                    /**
                     * If you wish to 'fast forward' the emitter in time, set this value to a number representing the amount of ms the emitter should advance.
                     */
                    advance?: number;
                    /**
                     * Limit the emitter to emit particles for a maximum of `duration` ms. Default to zero, meaning 'forever'.
                     */
                    duration?: number;
                    /**
                     * Limit the emitter to emit this exact number of particles and then stop. Default to zero, meaning no limit.
                     */
                    stopAfter?: number;
                    /**
                     * A custom callback that sorts particles prior to rendering. Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#sortCallback}.
                     */
                    sortCallback?: Phaser.Types.GameObjects.Particles.ParticleSortCallback;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#sortOrderAsc}.
                     */
                    sortOrderAsc?: boolean;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#sortProperty}.
                     */
                    sortProperty?: string;
                    /**
                     * Sets {@link Phaser.GameObjects.Particles.ParticleEmitter#tintFill}.
                     */
                    tintFill?: boolean;
                };

                type ParticleEmitterCreatorConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key of the Texture this Emitter will use to render particles, as stored in the Texture Manager.
                     */
                    key?: string;
                    /**
                     * The Particle Emitter configuration object.
                     */
                    config?: Phaser.Types.GameObjects.Particles.ParticleEmitterConfig;
                };

                type ParticleEmitterDeathZoneConfig = {
                    /**
                     * A shape representing the zone. See {@link Phaser.GameObjects.Particles.Zones.DeathZone#source}.
                     */
                    source: Phaser.Types.GameObjects.Particles.DeathZoneSource;
                    /**
                     * 'onEnter' or 'onLeave'.
                     */
                    type?: string;
                };

                type ParticleEmitterEdgeZoneConfig = {
                    /**
                     * A shape representing the zone. See {@link Phaser.GameObjects.Particles.Zones.EdgeZone#source}.
                     */
                    source: Phaser.Types.GameObjects.Particles.EdgeZoneSource;
                    /**
                     * 'edge'.
                     */
                    type: string;
                    /**
                     * The number of particles to place on the source edge. Set to 0 to use `stepRate` instead.
                     */
                    quantity: number;
                    /**
                     * The distance between each particle. When set, `quantity` is implied and should be set to 0.
                     */
                    stepRate?: number;
                    /**
                     * Whether particles are placed from start to end and then end to start.
                     */
                    yoyo?: boolean;
                    /**
                     * Whether one endpoint will be removed if it's identical to the other.
                     */
                    seamless?: boolean;
                    /**
                     * The total number of particles this zone will emit before passing over to the next emission zone in the Emitter.
                     */
                    total?: number;
                };

                type ParticleEmitterFrameConfig = {
                    /**
                     * Array of texture frames.
                     */
                    frames?: number[] | string[] | Phaser.Textures.Frame[];
                    /**
                     * Whether texture frames will be assigned consecutively (true) or at random (false).
                     */
                    cycle?: boolean;
                    /**
                     * The number of consecutive particles receiving each texture frame, when `cycle` is true.
                     */
                    quantity?: number;
                };

                type ParticleEmitterOps = {
                    /**
                     * The accelerationX EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    accelerationX: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The accelerationY EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    accelerationY: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The alpha EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    alpha: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The angle EmitterOp instance. This is an onEmit operator only.
                     */
                    angle: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The bounce EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    bounce: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The color EmitterColorOp instance. This is an onEmit and onUpdate operator.
                     */
                    color: Phaser.GameObjects.Particles.EmitterColorOp;
                    /**
                     * The delay EmitterOp instance. This is an onEmit operator only.
                     */
                    delay: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The hold EmitterOp instance. This is an onEmit operator only.
                     */
                    hold: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The lifespan EmitterOp instance. This is an onEmit operator only.
                     */
                    lifespan: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The maxVelocityX EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    maxVelocityX: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The maxVelocityY EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    maxVelocityY: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The moveToX EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    moveToX: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The moveToY EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    moveToY: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The quantity EmitterOp instance. This is an onEmit operator only.
                     */
                    quantity: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The rotate EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    rotate: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The scaleX EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    scaleX: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The scaleY EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    scaleY: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The speedX EmitterOp instance. This is an onEmit operator only.
                     */
                    speedX: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The speedY EmitterOp instance. This is an onEmit operator only.
                     */
                    speedY: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The tint EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    tint: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The x EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    x: Phaser.GameObjects.Particles.EmitterOp;
                    /**
                     * The y EmitterOp instance. This is an onEmit and onUpdate operator.
                     */
                    y: Phaser.GameObjects.Particles.EmitterOp;
                };

                type ParticleEmitterRandomZoneConfig = {
                    /**
                     * A shape representing the zone. See {@link Phaser.GameObjects.Particles.Zones.RandomZone#source}.
                     */
                    source: Phaser.Types.GameObjects.Particles.RandomZoneSource;
                    /**
                     * 'random'.
                     */
                    type?: string;
                };

                type ParticleSortCallback = (a: Phaser.GameObjects.Particles.Particle, b: Phaser.GameObjects.Particles.Particle)=>void;

                type RandomZoneSource = {
                    /**
                     * A function modifying its point argument.
                     */
                    getRandomPoint: Phaser.Types.GameObjects.Particles.RandomZoneSourceCallback;
                };

                type RandomZoneSourceCallback = (point: Phaser.Types.Math.Vector2Like)=>void;

            }

            namespace PathFollower {
                /**
                 * Settings for a PathFollower.
                 */
                type PathConfig = {
                    /**
                     * The duration of the path follow in ms. Must be `> 0`.
                     */
                    duration?: number;
                    /**
                     * The start position of the path follow, between 0 and 1. Must be less than `to`.
                     */
                    from?: number;
                    /**
                     * The end position of the path follow, between 0 and 1. Must be more than `from`.
                     */
                    to?: number;
                    /**
                     * Whether to position the PathFollower on the Path using its path offset.
                     */
                    positionOnPath?: boolean;
                    /**
                     * Should the PathFollower automatically rotate to point in the direction of the Path?
                     */
                    rotateToPath?: boolean;
                    /**
                     * If the PathFollower is rotating to match the Path, this value is added to the rotation value. This allows you to rotate objects to a path but control the angle of the rotation as well.
                     */
                    rotationOffset?: number;
                    /**
                     * Current start position of the path follow, must be between `from` and `to`.
                     */
                    startAt?: number;
                };

            }

            namespace Plane {
                type PlaneCheckerboardConfig = {
                    /**
                     * The odd cell color, specified as a hex value.
                     */
                    color1?: number;
                    /**
                     * The even cell color, specified as a hex value.
                     */
                    color2?: number;
                    /**
                     * The odd cell alpha value, specified as a number between 0 and 255.
                     */
                    alpha1?: number;
                    /**
                     * The even cell alpha value, specified as a number between 0 and 255.
                     */
                    alpha2?: number;
                    /**
                     * The view height of the Plane after creation, in pixels.
                     */
                    height?: number;
                };

                type PlaneConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                     */
                    key?: string | Phaser.Textures.Texture;
                    /**
                     * An optional frame from the Texture this Game Object is rendering with.
                     */
                    frame?: string | number;
                    /**
                     * The width of this Plane, in cells, not pixels.
                     */
                    width?: number;
                    /**
                     * The height of this Plane, in cells, not pixels.
                     */
                    height?: number;
                    /**
                     * Is the texture tiled? I.e. repeated across each cell.
                     */
                    tile?: boolean;
                    /**
                     * Plane checkerboard configuration object.
                     */
                    checkerboard?: Phaser.Types.GameObjects.Plane.PlaneCheckerboardConfig;
                };

            }

            namespace RenderTexture {
                type RenderTextureConfig = {
                    /**
                     * The x coordinate of the RenderTextures position.
                     */
                    x?: number;
                    /**
                     * The y coordinate of the RenderTextures position.
                     */
                    y?: number;
                    /**
                     * The width of the RenderTexture.
                     */
                    width?: number;
                    /**
                     * The height of the RenderTexture.
                     */
                    height?: number;
                };

            }

            namespace Rope {
                type RopeConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key of the Texture this Game Object will use to render with, as stored in the Texture Manager. If not given, `__DEFAULT` is used.
                     */
                    key?: string;
                    /**
                     * An optional frame from the Texture this Game Object is rendering with.
                     */
                    frame?: string | integer | null;
                    /**
                     * An array containing the vertices data for this Rope, or a number that indicates how many segments to split the texture frame into. If none is provided a simple quad is created. See `setPoints` to set this post-creation.
                     */
                    points?: integer | Phaser.Types.Math.Vector2Like[];
                    /**
                     * Should the vertices of this Rope be aligned horizontally (`true`), or vertically (`false`)?
                     */
                    horizontal?: boolean;
                    /**
                     * An optional array containing the color data for this Rope. You should provide one color value per pair of vertices.
                     */
                    colors?: number[];
                    /**
                     * An optional array containing the alpha data for this Rope. You should provide one alpha value per pair of vertices.
                     */
                    alphas?: number[];
                };

            }

            namespace Shader {
                type ShaderConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key of the shader to use from the shader cache, or a BaseShader instance.
                     */
                    key: string | Phaser.Display.BaseShader;
                    /**
                     * The width of the Game Object.
                     */
                    width?: number;
                    /**
                     * The height of the Game Object.
                     */
                    height?: number;
                };

            }

            namespace Sprite {
                type SpriteConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                     */
                    key?: string | Phaser.Textures.Texture;
                    /**
                     * An optional frame from the Texture this Game Object is rendering with.
                     */
                    frame?: string | number;
                    /**
                     * The string-based key of the animation to play, or an Animation instance, or a `PlayAnimationConfig` object.
                     */
                    anims?: string | Phaser.Animations.Animation | Phaser.Types.Animations.PlayAnimationConfig;
                };

            }

            namespace Text {
                /**
                 * Results object from a call to GetTextSize.
                 */
                type GetTextSizeObject = {
                    /**
                     * The width of the longest line in the Text object.
                     */
                    width: number;
                    /**
                     * The height of the Text object.
                     */
                    height: number;
                    /**
                     * The number of lines in the Text object.
                     */
                    lines: number;
                    /**
                     * An array of the lines for each line in the Text object.
                     */
                    lineWidths: number[];
                    /**
                     * The line spacing of the Text object.
                     */
                    lineSpacing: number;
                    /**
                     * The height of a line factoring in font and stroke.
                     */
                    lineHeight: number;
                };

                type TextConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The text this Text object will display.
                     */
                    text?: string | string[];
                    /**
                     * The Text style configuration object.
                     */
                    style?: Phaser.Types.GameObjects.Text.TextStyle;
                    /**
                     * A Text Padding object.
                     */
                    padding?: Phaser.Types.GameObjects.Text.TextPadding;
                };

                /**
                 * Font metrics for a Text Style object.
                 */
                type TextMetrics = {
                    /**
                     * The ascent of the font.
                     */
                    ascent: number;
                    /**
                     * The descent of the font.
                     */
                    descent: number;
                    /**
                     * The size of the font.
                     */
                    fontSize: number;
                };

                /**
                 * A Text Padding configuration object as used by the Text Style.
                 */
                type TextPadding = {
                    /**
                     * If set this value is used for both the left and right padding.
                     */
                    x?: number;
                    /**
                     * If set this value is used for both the top and bottom padding.
                     */
                    y?: number;
                    /**
                     * The amount of padding added to the left of the Text object.
                     */
                    left?: number;
                    /**
                     * The amount of padding added to the right of the Text object.
                     */
                    right?: number;
                    /**
                     * The amount of padding added to the top of the Text object.
                     */
                    top?: number;
                    /**
                     * The amount of padding added to the bottom of the Text object.
                     */
                    bottom?: number;
                };

                /**
                 * A Text Shadow configuration object as used by the Text Style.
                 */
                type TextShadow = {
                    /**
                     * The horizontal offset of the shadow.
                     */
                    offsetX?: number;
                    /**
                     * The vertical offset of the shadow.
                     */
                    offsetY?: number;
                    /**
                     * The color of the shadow, given as a CSS string value.
                     */
                    color?: string;
                    /**
                     * The amount of blur applied to the shadow. Leave as zero for a hard shadow.
                     */
                    blur?: number;
                    /**
                     * Apply the shadow to the stroke effect on the Text object?
                     */
                    stroke?: boolean;
                    /**
                     * Apply the shadow to the fill effect on the Text object?
                     */
                    fill?: boolean;
                };

                /**
                 * A Text Style configuration object as used by the Text Game Object.
                 */
                type TextStyle = {
                    /**
                     * The font the Text object will render with. This is a Canvas style font string.
                     */
                    fontFamily?: string;
                    /**
                     * The font size, as a CSS size string.
                     */
                    fontSize?: number | string;
                    /**
                     * Any addition font styles, such as 'strong'.
                     */
                    fontStyle?: string;
                    /**
                     * The font family or font settings to set. Overrides the other font settings.
                     */
                    font?: string;
                    /**
                     * A solid fill color that is rendered behind the Text object. Given as a CSS string color such as `#ff0`.
                     */
                    backgroundColor?: string;
                    /**
                     * The color the Text is drawn in. Given as a CSS string color such as `#fff` or `rgb()`.
                     */
                    color?: string | CanvasGradient | CanvasPattern;
                    /**
                     * The color used to stroke the Text if the `strokeThickness` property is greater than zero.
                     */
                    stroke?: string | CanvasGradient | CanvasPattern;
                    /**
                     * The thickness of the stroke around the Text. Set to zero for no stroke.
                     */
                    strokeThickness?: number;
                    /**
                     * The Text shadow configuration object.
                     */
                    shadow?: Phaser.Types.GameObjects.Text.TextShadow;
                    /**
                     * A Text Padding object.
                     */
                    padding?: Phaser.Types.GameObjects.Text.TextPadding;
                    /**
                     * The alignment of the Text. This only impacts multi-line text. Either `left`, `right`, `center` or `justify`.
                     */
                    align?: string;
                    /**
                     * The maximum number of lines to display within the Text object.
                     */
                    maxLines?: number;
                    /**
                     * Force the Text object to have the exact width specified in this property. Leave as zero for it to change accordingly to content.
                     */
                    fixedWidth?: number;
                    /**
                     * Force the Text object to have the exact height specified in this property. Leave as zero for it to change accordingly to content.
                     */
                    fixedHeight?: number;
                    /**
                     * Sets the resolution (DPI setting) of the Text object. Leave at zero for it to use the game resolution.
                     */
                    resolution?: number;
                    /**
                     * Set to `true` if this Text object should render from right-to-left.
                     */
                    rtl?: boolean;
                    /**
                     * This is the string used to aid Canvas in calculating the height of the font.
                     */
                    testString?: string;
                    /**
                     * The amount of horizontal padding added to the width of the text when calculating the font metrics.
                     */
                    baselineX?: number;
                    /**
                     * The amount of vertical padding added to the height of the text when calculating the font metrics.
                     */
                    baselineY?: number;
                    /**
                     * The Text Word wrap configuration object.
                     */
                    wordWrap?: Phaser.Types.GameObjects.Text.TextWordWrap;
                    /**
                     * A Text Metrics object. Use this to avoid expensive font size calculations in text heavy games.
                     */
                    metrics?: Phaser.Types.GameObjects.Text.TextMetrics;
                    /**
                     * The amount to add to the font height to achieve the overall line height.
                     */
                    lineSpacing?: number;
                };

                /**
                 * A Text Word Wrap configuration object as used by the Text Style configuration.
                 */
                type TextWordWrap = {
                    /**
                     * The width at which text should be considered for word-wrapping.
                     */
                    width?: number;
                    /**
                     * Provide a custom callback when word wrapping is enabled.
                     */
                    callback?: TextStyleWordWrapCallback;
                    /**
                     * The context in which the word wrap callback is invoked.
                     */
                    callbackScope?: any;
                    /**
                     * Use basic or advanced word wrapping?
                     */
                    useAdvancedWrap?: boolean;
                };

            }

            namespace TileSprite {
                type TileSpriteConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The x coordinate of the Tile Sprite.
                     */
                    x?: number;
                    /**
                     * The y coordinate of the Tile Sprite.
                     */
                    y?: number;
                    /**
                     * The width of the Tile Sprite. If zero it will use the size of the texture frame.
                     */
                    width?: number;
                    /**
                     * The height of the Tile Sprite. If zero it will use the size of the texture frame.
                     */
                    height?: number;
                    /**
                     * The key of the Texture this Tile Sprite will use to render with, as stored in the Texture Manager.
                     */
                    key?: string;
                    /**
                     * An optional frame from the Texture this Tile Sprite is rendering with.
                     */
                    frame?: number | string | Phaser.Textures.Frame;
                };

            }

            type DecomposeMatrixResults = {
                /**
                 * The translated x value.
                 */
                translateX: number;
                /**
                 * The translated y value.
                 */
                translateY: number;
                /**
                 * The rotation value.
                 */
                rotation: number;
                /**
                 * The scale x value.
                 */
                scaleX: number;
                /**
                 * The scale y value.
                 */
                scaleY: number;
            };

            type Face = {
                /**
                 * The first face vertex.
                 */
                vertex1: Phaser.Types.GameObjects.Vertex;
                /**
                 * The second face vertex.
                 */
                vertex2: Phaser.Types.GameObjects.Vertex;
                /**
                 * The third face vertex.
                 */
                vertex3: Phaser.Types.GameObjects.Vertex;
                /**
                 * Are the vertices counter-clockwise?
                 */
                isCounterClockwise: boolean;
            };

            type GameObjectConfig = {
                /**
                 * The x position of the Game Object.
                 */
                x?: number | object;
                /**
                 * The y position of the Game Object.
                 */
                y?: number | object;
                /**
                 * The depth of the GameObject.
                 */
                depth?: number;
                /**
                 * The horizontally flipped state of the Game Object.
                 */
                flipX?: boolean;
                /**
                 * The vertically flipped state of the Game Object.
                 */
                flipY?: boolean;
                /**
                 * The scale of the GameObject.
                 */
                scale?: number | object | null;
                /**
                 * The scroll factor of the GameObject.
                 */
                scrollFactor?: number | object | null;
                /**
                 * The rotation angle of the Game Object, in radians.
                 */
                rotation?: number | object;
                /**
                 * The rotation angle of the Game Object, in degrees.
                 */
                angle?: number | object | null;
                /**
                 * The alpha (opacity) of the Game Object.
                 */
                alpha?: number | object;
                /**
                 * The origin of the Game Object.
                 */
                origin?: number | object | null;
                /**
                 * The scale mode of the GameObject.
                 */
                scaleMode?: number;
                /**
                 * The blend mode of the GameObject.
                 */
                blendMode?: number;
                /**
                 * The visible state of the Game Object.
                 */
                visible?: boolean;
                /**
                 * Add the GameObject to the scene.
                 */
                add?: boolean;
            };

            type GetCalcMatrixResults = {
                /**
                 * The calculated Camera matrix.
                 */
                camera: Phaser.GameObjects.Components.TransformMatrix;
                /**
                 * The calculated Sprite (Game Object) matrix.
                 */
                sprite: Phaser.GameObjects.Components.TransformMatrix;
                /**
                 * The calculated results matrix, factoring all others in.
                 */
                calc: Phaser.GameObjects.Components.TransformMatrix;
            };

            type JSONGameObject = {
                /**
                 * The name of this Game Object.
                 */
                name: string;
                /**
                 * A textual representation of this Game Object, i.e. `sprite`.
                 */
                type: string;
                /**
                 * The x position of this Game Object.
                 */
                x: number;
                /**
                 * The y position of this Game Object.
                 */
                y: number;
                /**
                 * The scale of this Game Object
                 */
                scale: object;
                /**
                 * The horizontal scale of this Game Object.
                 */
                "scale.x": number;
                /**
                 * The vertical scale of this Game Object.
                 */
                "scale.y": number;
                /**
                 * The origin of this Game Object.
                 */
                origin: object;
                /**
                 * The horizontal origin of this Game Object.
                 */
                "origin.x": number;
                /**
                 * The vertical origin of this Game Object.
                 */
                "origin.y": number;
                /**
                 * The horizontally flipped state of the Game Object.
                 */
                flipX: boolean;
                /**
                 * The vertically flipped state of the Game Object.
                 */
                flipY: boolean;
                /**
                 * The angle of this Game Object in radians.
                 */
                rotation: number;
                /**
                 * The alpha value of the Game Object.
                 */
                alpha: number;
                /**
                 * The visible state of the Game Object.
                 */
                visible: boolean;
                /**
                 * The Scale Mode being used by this Game Object.
                 */
                scaleMode: number;
                /**
                 * Sets the Blend Mode being used by this Game Object.
                 */
                blendMode: number | string;
                /**
                 * The texture key of this Game Object.
                 */
                textureKey: string;
                /**
                 * The frame key of this Game Object.
                 */
                frameKey: string;
                /**
                 * The data of this Game Object.
                 */
                data: object;
            };

            type Vertex = {
                /**
                 * The x coordinate of the vertex.
                 */
                x: number;
                /**
                 * The y coordinate of the vertex.
                 */
                y: number;
                /**
                 * The z coordinate of the vertex.
                 */
                z: number;
                /**
                 * The x normal of the vertex.
                 */
                normalX: number;
                /**
                 * The y normal of the vertex.
                 */
                normalY: number;
                /**
                 * The z normal of the vertex.
                 */
                normalZ: number;
                /**
                 * UV u texture coordinate of the vertex.
                 */
                u: number;
                /**
                 * UV v texture coordinate of the vertex.
                 */
                v: number;
                /**
                 * The alpha value of the vertex.
                 */
                alpha: number;
            };

            namespace Video {
                type VideoConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * Optional key of the Video this Game Object will play, as stored in the Video Cache.
                     */
                    key?: string;
                };

            }

            namespace Zone {
                type ZoneConfig = Phaser.Types.GameObjects.GameObjectConfig & {
                    /**
                     * The width of the Game Object.
                     */
                    width?: number;
                    /**
                     * The height of the Game Object.
                     */
                    height?: number;
                };

            }

        }

        namespace Geom {
            namespace Mesh {
                type GenerateGridConfig = {
                    /**
                     * The texture to be used for this Grid. Must be a Texture instance. Can also be a string but only if the `mesh` property is set.
                     */
                    texture: string | Phaser.Textures.Texture;
                    /**
                     * The name or index of the frame within the Texture.
                     */
                    frame?: string | number;
                    /**
                     * If specified, the vertices of the generated grid will be added to this Mesh Game Object.
                     */
                    mesh?: Phaser.GameObjects.Mesh;
                    /**
                     * The width of the grid in 3D units. If you wish to get a pixel accurate grid based on a texture, you can use an Ortho Mesh or the `isOrtho` parameter.
                     */
                    width?: number;
                    /**
                     * The height of the grid in 3D units.
                     */
                    height?: number;
                    /**
                     * The number of segments to split the grid horizontally in to.
                     */
                    widthSegments?: number;
                    /**
                     * The number of segments to split the grid vertically in to.
                     */
                    heightSegments?: number;
                    /**
                     * Offset the grid x position by this amount.
                     */
                    x?: number;
                    /**
                     * Offset the grid y position by this amount.
                     */
                    y?: number;
                    /**
                     * An array of colors, one per vertex, or a single color value applied to all vertices.
                     */
                    colors?: number | number[];
                    /**
                     * An array of alpha values, one per vertex, or a single alpha value applied to all vertices.
                     */
                    alphas?: number | number[];
                    /**
                     * Should the texture tile (repeat) across the grid segments, or display as a single texture?
                     */
                    tile?: boolean;
                    /**
                     * If set and using a texture with an ortho Mesh, the `width` and `height` parameters will be calculated based on the frame size for you.
                     */
                    isOrtho?: boolean;
                    /**
                     * If set and using a texture, vertically flipping render result.
                     */
                    flipY?: boolean;
                };

                type GenerateGridVertsResult = {
                    /**
                     * An array of vertex values in x, y pairs.
                     */
                    verts: number[];
                    /**
                     * An array of vertex indexes. This array will be empty if the `tile` parameter was `true`.
                     */
                    indices: number[];
                    /**
                     * An array of UV values, two per vertex.
                     */
                    uvs: number[];
                    /**
                     * An array of colors, one per vertex, or a single color value applied to all vertices.
                     */
                    colors?: number | number[];
                    /**
                     * An array of alpha values, one per vertex, or a single alpha value applied to all vertices.
                     */
                    alphas?: number | number[];
                };

                type GenerateVertsResult = {
                    /**
                     * An array of Face objects generated from the OBJ Data.
                     */
                    faces: Phaser.Geom.Mesh.Face[];
                    /**
                     * An array of Vertex objects generated from the OBJ Data.
                     */
                    vertices: Phaser.Geom.Mesh.Vertex[];
                };

                type OBJData = {
                    /**
                     * An array of material library filenames found in the OBJ file.
                     */
                    materialLibraries: string[];
                    /**
                     * If the obj was loaded with an mtl file, the parsed material names are stored in this object.
                     */
                    materials: object;
                    /**
                     * An array of parsed models extracted from the OBJ file.
                     */
                    models: Phaser.Types.Geom.Mesh.OBJModel[];
                };

                type OBJFace = {
                    /**
                     * The name of the Group this Face is in.
                     */
                    group: string;
                    /**
                     * The name of the material this Face uses.
                     */
                    material: string;
                    /**
                     * An array of vertices in this Face.
                     */
                    vertices: Phaser.Types.Geom.Mesh.OBJFaceVertice[];
                };

                type OBJFaceVertice = {
                    /**
                     * The index in the `textureCoords` array that this vertex uses.
                     */
                    textureCoordsIndex: number;
                    /**
                     * The index in the `vertices` array that this vertex uses.
                     */
                    vertexIndex: number;
                    /**
                     * The index in the `vertexNormals` array that this vertex uses.
                     */
                    vertexNormalIndex: number;
                };

                type OBJModel = {
                    /**
                     * An array of Faces.
                     */
                    faces: Phaser.Types.Geom.Mesh.OBJFace[];
                    /**
                     * The name of the model.
                     */
                    name: string;
                    /**
                     * An array of texture coordinates.
                     */
                    textureCoords: Phaser.Types.Geom.Mesh.UV[];
                    /**
                     * An array of vertex normals.
                     */
                    vertexNormals: Phaser.Types.Math.Vector3Like[];
                    /**
                     * An array of vertices in the model.
                     */
                    vertices: Phaser.Types.Math.Vector3Like[];
                };

                type UV = {
                    /**
                     * The u component.
                     */
                    u: number;
                    /**
                     * The v component.
                     */
                    v: number;
                    /**
                     * The w component.
                     */
                    w: number;
                };

            }

        }

        namespace Input {
            namespace Gamepad {
                /**
                 * The Gamepad object, as extracted from GamepadEvent.
                 */
                type Pad = {
                    /**
                     * The ID of the Gamepad.
                     */
                    id: string;
                    /**
                     * The index of the Gamepad.
                     */
                    index: number;
                };

            }

            namespace Keyboard {
                type CursorKeys = {
                    /**
                     * A Key object mapping to the UP arrow key.
                     */
                    up: Phaser.Input.Keyboard.Key;
                    /**
                     * A Key object mapping to the DOWN arrow key.
                     */
                    down: Phaser.Input.Keyboard.Key;
                    /**
                     * A Key object mapping to the LEFT arrow key.
                     */
                    left: Phaser.Input.Keyboard.Key;
                    /**
                     * A Key object mapping to the RIGHT arrow key.
                     */
                    right: Phaser.Input.Keyboard.Key;
                    /**
                     * A Key object mapping to the SPACE BAR key.
                     */
                    space: Phaser.Input.Keyboard.Key;
                    /**
                     * A Key object mapping to the SHIFT key.
                     */
                    shift: Phaser.Input.Keyboard.Key;
                };

                type KeyboardKeydownCallback = (event: KeyboardEvent)=>void;

                type KeyComboConfig = {
                    /**
                     * If they press the wrong key do we reset the combo?
                     */
                    resetOnWrongKey?: boolean;
                    /**
                     * The max delay in ms between each key press. Above this the combo is reset. 0 means disabled.
                     */
                    maxKeyDelay?: number;
                    /**
                     * If previously matched and they press the first key of the combo again, will it reset?
                     */
                    resetOnMatch?: boolean;
                    /**
                     * If the combo matches, will it delete itself?
                     */
                    deleteOnMatch?: boolean;
                };

            }

            /**
             * A Phaser Input Event Data object.
             * 
             * This object is passed to the registered event listeners and allows you to stop any further propagation.
             */
            type EventData = {
                /**
                 * The cancelled state of this Event.
                 */
                cancelled?: boolean;
                /**
                 * Call this method to stop this event from passing any further down the event chain.
                 */
                stopPropagation: Function;
            };

            type HitAreaCallback = (hitArea: any, x: number, y: number, gameObject: Phaser.GameObjects.GameObject)=>boolean;

            type InputConfiguration = {
                /**
                 * The object / shape to use as the Hit Area. If not given it will try to create a Rectangle based on the texture frame.
                 */
                hitArea?: any;
                /**
                 * The callback that determines if the pointer is within the Hit Area shape or not.
                 */
                hitAreaCallback?: Phaser.Types.Input.HitAreaCallback;
                /**
                 * If `true` the Interactive Object will be set to be draggable and emit drag events.
                 */
                draggable?: boolean;
                /**
                 * If `true` the Interactive Object will be set to be a drop zone for draggable objects.
                 */
                dropZone?: boolean;
                /**
                 * If `true` the Interactive Object will set the `pointer` hand cursor when a pointer is over it. This is a short-cut for setting `cursor: 'pointer'`.
                 */
                useHandCursor?: boolean;
                /**
                 * The CSS string to be used when the cursor is over this Interactive Object.
                 */
                cursor?: string;
                /**
                 * If `true` the a pixel perfect function will be set for the hit area callback. Only works with image texture based Game Objects, not Render Textures.
                 */
                pixelPerfect?: boolean;
                /**
                 * If `pixelPerfect` is set, this is the alpha tolerance threshold value used in the callback. A value of 255 will match only fully opaque pixels.
                 */
                alphaTolerance?: number;
            };

            type InputPluginContainer = {
                /**
                 * The unique name of this plugin in the input plugin cache.
                 */
                key: string;
                /**
                 * The plugin to be stored. Should be the source object, not instantiated.
                 */
                plugin: Function;
                /**
                 * If this plugin is to be injected into the Input Plugin, this is the property key map used.
                 */
                mapping?: string;
            };

            type InteractiveObject = {
                /**
                 * The Game Object to which this Interactive Object is bound.
                 */
                gameObject: Phaser.GameObjects.GameObject;
                /**
                 * Is this Interactive Object currently enabled for input events?
                 */
                enabled: boolean;
                /**
                 * Is this Interactive Object draggable? Enable with `InputPlugin.setDraggable`.
                 */
                draggable: boolean;
                /**
                 * Is this Interactive Object a drag-targets drop zone? Set when the object is created.
                 */
                dropZone: boolean;
                /**
                 * Should this Interactive Object change the cursor (via css) when over? (desktop only)
                 */
                cursor: boolean | string;
                /**
                 * An optional drop target for a draggable Interactive Object.
                 */
                target: Phaser.GameObjects.GameObject | null;
                /**
                 * The most recent Camera to be tested against this Interactive Object.
                 */
                camera: Phaser.Cameras.Scene2D.Camera;
                /**
                 * The hit area for this Interactive Object. Typically a geometry shape, like a Rectangle or Circle.
                 */
                hitArea: any;
                /**
                 * The 'contains' check callback that the hit area shape will use for all hit tests.
                 */
                hitAreaCallback: Phaser.Types.Input.HitAreaCallback;
                /**
                 * If this Interactive Object has been enabled for debug, via `InputPlugin.enableDebug` then this property holds its debug shape.
                 */
                hitAreaDebug: Phaser.GameObjects.Shape;
                /**
                 * Was the hitArea for this Interactive Object created based on texture size (false), or a custom shape? (true)
                 */
                customHitArea: boolean;
                /**
                 * The x coordinate that the Pointer interacted with this object on, relative to the Game Object's top-left position.
                 */
                localX: number;
                /**
                 * The y coordinate that the Pointer interacted with this object on, relative to the Game Object's top-left position.
                 */
                localY: number;
                /**
                 * The current drag state of this Interactive Object. 0 = Not being dragged, 1 = being checked for drag, or 2 = being actively dragged.
                 */
                dragState: 0 | 1 | 2;
                /**
                 * The x coordinate of the Game Object that owns this Interactive Object when the drag started.
                 */
                dragStartX: number;
                /**
                 * The y coordinate of the Game Object that owns this Interactive Object when the drag started.
                 */
                dragStartY: number;
                /**
                 * The x coordinate that the Pointer started dragging this Interactive Object from.
                 */
                dragStartXGlobal: number;
                /**
                 * The y coordinate that the Pointer started dragging this Interactive Object from.
                 */
                dragStartYGlobal: number;
                /**
                 * The x coordinate that this Interactive Object is currently being dragged to.
                 */
                dragX: number;
                /**
                 * The y coordinate that this Interactive Object is currently being dragged to.
                 */
                dragY: number;
            };

        }

        namespace Loader {
            namespace FileTypes {
                type AsepriteFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the texture image file from.
                     */
                    textureURL?: string;
                    /**
                     * The default file extension to use for the image texture if no url is provided.
                     */
                    textureExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the texture image file.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The absolute or relative URL to load the atlas json file from. Or, a well formed JSON object to use instead.
                     */
                    atlasURL?: object | string;
                    /**
                     * The default file extension to use for the atlas json if no url is provided.
                     */
                    atlasExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the atlas json file.
                     */
                    atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type AtlasJSONFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the texture image file from.
                     */
                    textureURL?: string;
                    /**
                     * The default file extension to use for the image texture if no url is provided.
                     */
                    textureExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the texture image file.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the texture image.
                     */
                    normalMap?: string;
                    /**
                     * The absolute or relative URL to load the atlas json file from. Or, a well formed JSON object to use instead.
                     */
                    atlasURL?: object | string;
                    /**
                     * The default file extension to use for the atlas json if no url is provided.
                     */
                    atlasExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the atlas json file.
                     */
                    atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type AtlasXMLFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the texture image file from.
                     */
                    textureURL?: string;
                    /**
                     * The default file extension to use for the image texture if no url is provided.
                     */
                    textureExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the texture image file.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the texture image.
                     */
                    normalMap?: string;
                    /**
                     * The absolute or relative URL to load the atlas xml file from.
                     */
                    atlasURL?: string;
                    /**
                     * The default file extension to use for the atlas xml if no url is provided.
                     */
                    atlasExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the atlas xml file.
                     */
                    atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type AudioFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader and Audio Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URLs to load the audio files from.
                     */
                    url?: string | string[] | Phaser.Types.Loader.FileTypes.AudioFileURLConfig | Phaser.Types.Loader.FileTypes.AudioFileURLConfig[];
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The optional AudioContext this file will use to process itself.
                     */
                    context?: AudioContext;
                };

                type AudioFileURLConfig = {
                    /**
                     * The audio file format. See property names in {@link Phaser.Device.Audio}.
                     */
                    type: string;
                    /**
                     * The absolute or relative URL of the audio file.
                     */
                    url: string;
                };

                type AudioSpriteFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Audio Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the json file from. Or a well formed JSON object to use instead.
                     */
                    jsonURL: string;
                    /**
                     * Extra XHR Settings specifically for the json file.
                     */
                    jsonXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The absolute or relative URL to load the audio file from.
                     */
                    audioURL?: Object;
                    /**
                     * The audio configuration options.
                     */
                    audioConfig?: any;
                    /**
                     * Extra XHR Settings specifically for the audio file.
                     */
                    audioXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type BinaryFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Binary Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * Optional type to cast the binary file to once loaded. For example, `Uint8Array`.
                     */
                    dataType?: any;
                };

                type BitmapFontFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the texture image file from.
                     */
                    textureURL?: string;
                    /**
                     * The default file extension to use for the image texture if no url is provided.
                     */
                    textureExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the texture image file.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the texture image.
                     */
                    normalMap?: string;
                    /**
                     * The absolute or relative URL to load the font data xml file from.
                     */
                    fontDataURL?: string;
                    /**
                     * The default file extension to use for the font data xml if no url is provided.
                     */
                    fontDataExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the font data xml file.
                     */
                    fontDataXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type CompressedTextureFileEntry = {
                    /**
                     * The texture compression base format that the browser must support in order to load this file. Can be any of: 'ETC', 'ETC1', 'ATC', 'ASTC', 'BPTC', 'RGTC', 'PVRTC', 'S3TC', 'S3TCSRGB' or the fallback format of 'IMG'.
                     */
                    format?: string;
                    /**
                     * The container format, either PVR or KTX. If not given it will try to extract it from the textureURL extension.
                     */
                    type?: string;
                    /**
                     * The URL of the compressed texture file to load.
                     */
                    textureURL?: string;
                    /**
                     * Optional URL of a texture atlas JSON data file. If not given, the texture will be loaded as a single image.
                     */
                    atlasURL?: string;
                    /**
                     * Optional URL of a multi-texture atlas JSON data file as created by Texture Packer Pro.
                     */
                    multiAtlasURL?: string;
                    /**
                     * Optional path to use when loading the textures defined in the multi atlas data.
                     */
                    multiPath?: string;
                    /**
                     * Optional Base URL to use when loading the textures defined in the multi atlas data.
                     */
                    multiBaseURL?: string;
                };

                type CompressedTextureFileConfig = {
                    /**
                     * The string, or file entry object, for an ETC format texture.
                     */
                    ETC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an ETC1 format texture.
                     */
                    ETC1?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an ATC format texture.
                     */
                    ATC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an ASTC format texture.
                     */
                    ASTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an BPTC format texture.
                     */
                    BPTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an RGTC format texture.
                     */
                    RGTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an PVRTC format texture.
                     */
                    PVRTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an S3TC format texture.
                     */
                    S3TC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for an S3TCRGB format texture.
                     */
                    S3TCRGB?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                    /**
                     * The string, or file entry object, for the fallback image file.
                     */
                    IMG?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                };

                type CSSFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type GLSLFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Text Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The type of shader. Either `fragment` for a fragment shader, or `vertex` for a vertex shader. This is ignored if you load a shader bundle.
                     */
                    shaderType?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type HTMLFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Text Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type HTMLTextureFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The width of the texture the HTML will be rendered to.
                     */
                    width?: number;
                    /**
                     * The height of the texture the HTML will be rendered to.
                     */
                    height?: number;
                };

                type ImageFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the image.
                     */
                    normalMap?: string;
                    /**
                     * The frame configuration object. Only provided for, and used by, Sprite Sheets.
                     */
                    frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type ImageFrameConfig = {
                    /**
                     * The width of the frame in pixels.
                     */
                    frameWidth: number;
                    /**
                     * The height of the frame in pixels. Uses the `frameWidth` value if not provided.
                     */
                    frameHeight?: number;
                    /**
                     * The first frame to start parsing from.
                     */
                    startFrame?: number;
                    /**
                     * The frame to stop parsing at. If not provided it will calculate the value based on the image and frame dimensions.
                     */
                    endFrame?: number;
                    /**
                     * The margin in the image. This is the space around the edge of the frames.
                     */
                    margin?: number;
                    /**
                     * The spacing between each frame in the image.
                     */
                    spacing?: number;
                };

                type JSONFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the JSON Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from. Or can be a ready formed JSON object, in which case it will be directly added to the Cache.
                     */
                    url?: string | any;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * If specified instead of the whole JSON file being parsed and added to the Cache, only the section corresponding to this property key will be added. If the property you want to extract is nested, use periods to divide it.
                     */
                    dataKey?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type MultiAtlasFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the multi atlas json file from. Or, a well formed JSON object.
                     */
                    atlasURL?: string;
                    /**
                     * An alias for 'atlasURL'. If given, it overrides anything set in 'atlasURL'.
                     */
                    url?: string;
                    /**
                     * The default file extension to use for the atlas json if no url is provided.
                     */
                    atlasExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the atlas json file.
                     */
                    atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * Optional path to use when loading the textures defined in the atlas data.
                     */
                    path?: string;
                    /**
                     * Optional Base URL to use when loading the textures defined in the atlas data.
                     */
                    baseURL?: string;
                    /**
                     * Extra XHR Settings specifically for the texture files.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type MultiScriptFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader.
                     */
                    key: string;
                    /**
                     * An array of absolute or relative URLs to load the script files from. They are processed in the order given in the array.
                     */
                    url?: string[];
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for these files.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type OBJFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the OBJ Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load this file from. If undefined or `null` it will be set to `<key>.obj`, i.e. if `key` was "alien" then the URL will be "alien.obj".
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Flip the UV coordinates stored in the model data?
                     */
                    flipUV?: boolean;
                    /**
                     * An optional absolute or relative URL to the object material file from. If undefined or `null`, no material file will be loaded.
                     */
                    matURL?: string;
                    /**
                     * The default material file extension to use if no url is provided.
                     */
                    matExtension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type PackFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the JSON Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from. Or can be a ready formed JSON object, in which case it will be directly processed.
                     */
                    url?: string | any;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * If specified instead of the whole JSON file being parsed, only the section corresponding to this property key will be added. If the property you want to extract is nested, use periods to divide it.
                     */
                    dataKey?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type PackFileSection = {
                    /**
                     * The files to load. See {@link Phaser.Types.Loader.FileTypes}.
                     */
                    files: Phaser.Types.Loader.FileConfig[];
                    /**
                     * A URL used to resolve paths in `files`. Example: 'http://labs.phaser.io/assets/'.
                     */
                    baseURL?: string;
                    /**
                     * The default {@link Phaser.Types.Loader.FileConfig} `type`.
                     */
                    defaultType?: string;
                    /**
                     * A URL path used to resolve relative paths in `files`. Example: 'images/sprites/'.
                     */
                    path?: string;
                    /**
                     * An optional prefix that is automatically prepended to each file key.
                     */
                    prefix?: string;
                };

                type PluginFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Automatically start the plugin after loading?
                     */
                    start?: boolean;
                    /**
                     * If this plugin is to be injected into the Scene, this is the property key used.
                     */
                    mapping?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type SceneFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Text Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type ScenePluginFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from. Or, a Scene Plugin.
                     */
                    url?: string | Function;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * If this plugin is to be added to Scene.Systems, this is the property key for it.
                     */
                    systemKey?: string;
                    /**
                     * If this plugin is to be added to the Scene, this is the property key for it.
                     */
                    sceneKey?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type ScriptFileConfig = {
                    /**
                     * The key of the file. Must be unique within the Loader.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * The script type. Should be either 'script' for classic JavaScript, or 'module' if the file contains an exported module.
                     */
                    type?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type SpriteSheetFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the image.
                     */
                    normalMap?: string;
                    /**
                     * The frame configuration object.
                     */
                    frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type SVGFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The svg size configuration object.
                     */
                    svgConfig?: Phaser.Types.Loader.FileTypes.SVGSizeConfig;
                };

                type SVGSizeConfig = {
                    /**
                     * An optional width. The SVG will be resized to this size before being rendered to a texture.
                     */
                    width?: number;
                    /**
                     * An optional height. The SVG will be resized to this size before being rendered to a texture.
                     */
                    height?: number;
                    /**
                     * An optional scale. If given it overrides the width / height properties. The SVG is scaled by the scale factor before being rendered to a texture.
                     */
                    scale?: number;
                };

                type TextFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Text Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type TilemapCSVFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Tilemap Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type TilemapImpactFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Tilemap Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type TilemapJSONFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Tilemap Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from. Or, a well formed JSON object.
                     */
                    url?: object | string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type UnityAtlasFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Texture Manager.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the texture image file from.
                     */
                    textureURL?: string;
                    /**
                     * The default file extension to use for the image texture if no url is provided.
                     */
                    textureExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the texture image file.
                     */
                    textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                    /**
                     * The filename of an associated normal map. It uses the same path and url to load as the texture image.
                     */
                    normalMap?: string;
                    /**
                     * The absolute or relative URL to load the atlas data file from.
                     */
                    atlasURL?: string;
                    /**
                     * The default file extension to use for the atlas data if no url is provided.
                     */
                    atlasExtension?: string;
                    /**
                     * Extra XHR Settings specifically for the atlas data file.
                     */
                    atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

                type VideoFileConfig = {
                    /**
                     * The key to use for this file, or a file configuration object.
                     */
                    key: string | Phaser.Types.Loader.FileTypes.VideoFileConfig;
                    /**
                     * The absolute or relative URLs to load the video files from.
                     */
                    url?: string | string[] | Phaser.Types.Loader.FileTypes.VideoFileURLConfig | Phaser.Types.Loader.FileTypes.VideoFileURLConfig[];
                    /**
                     * Does the video have an audio track? If not you can enable auto-playing on it.
                     */
                    noAudio?: boolean;
                };

                type VideoFileURLConfig = {
                    /**
                     * The video file format. See property names in {@link Phaser.Device.Video}.
                     */
                    type: string;
                    /**
                     * The absolute or relative URL of the video file.
                     */
                    url: string;
                };

                type XMLFileConfig = {
                    /**
                     * The key of the file. Must be unique within both the Loader and the Text Cache.
                     */
                    key: string;
                    /**
                     * The absolute or relative URL to load the file from.
                     */
                    url?: string;
                    /**
                     * The default file extension to use if no url is provided.
                     */
                    extension?: string;
                    /**
                     * Extra XHR Settings specifically for this file.
                     */
                    xhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                };

            }

            type FileConfig = {
                /**
                 * The name of the Loader method that loads this file, e.g., 'image', 'json', 'spritesheet'.
                 */
                type: string;
                /**
                 * Unique cache key (unique within its file type)
                 */
                key: string;
                /**
                 * The URL of the file, not including baseURL.
                 */
                url?: object | string;
                /**
                 * The path of the file, not including the baseURL.
                 */
                path?: string;
                /**
                 * The default extension this file uses.
                 */
                extension?: string;
                /**
                 * The responseType to be used by the XHR request.
                 */
                responseType?: XMLHttpRequestResponseType;
                /**
                 * Custom XHR Settings specific to this file and merged with the Loader defaults.
                 */
                xhrSettings?: Phaser.Types.Loader.XHRSettingsObject | false;
                /**
                 * A config object that can be used by file types to store transitional data.
                 */
                config?: any;
                /**
                 * The absolute or relative URL to load the texture image file from.
                 */
                textureURL?: string;
                /**
                 * The default file extension to use for the image texture if no url is provided.
                 */
                textureExtension?: string;
                /**
                 * Extra XHR Settings specifically for the texture image file.
                 */
                textureXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                /**
                 * The absolute or relative URL to load the atlas json file from. Or, a well formed JSON object to use instead.
                 */
                atlasURL?: object | string;
                /**
                 * The default file extension to use for the atlas json if no url is provided.
                 */
                atlasExtension?: string;
                /**
                 * Extra XHR Settings specifically for the atlas json file.
                 */
                atlasXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                /**
                 * The filename of an associated normal map. It uses the same path and url to load as the texture image.
                 */
                normalMap?: string;
                /**
                 * The optional AudioContext this file will use to process itself (only used by Sound objects).
                 */
                context?: AudioContext;
                /**
                 * The absolute or relative URL to load the json file from. Or a well formed JSON object to use instead.
                 */
                jsonURL?: string;
                /**
                 * Extra XHR Settings specifically for the json file.
                 */
                jsonXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                /**
                 * The absolute or relative URL to load the audio file from.
                 */
                audioURL?: Object;
                /**
                 * The audio configuration options.
                 */
                audioConfig?: any;
                /**
                 * Extra XHR Settings specifically for the audio file.
                 */
                audioXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                /**
                 * Optional type to cast the binary file to once loaded. For example, `Uint8Array`.
                 */
                dataType?: any;
                /**
                 * The absolute or relative URL to load the font data xml file from.
                 */
                fontDataURL?: string;
                /**
                 * The default file extension to use for the font data xml if no url is provided.
                 */
                fontDataExtension?: string;
                /**
                 * Extra XHR Settings specifically for the font data xml file.
                 */
                fontDataXhrSettings?: Phaser.Types.Loader.XHRSettingsObject;
                /**
                 * The string, or file entry object, for an ETC format texture.
                 */
                ETC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an ETC1 format texture.
                 */
                ETC1?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an ATC format texture.
                 */
                ATC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an ASTC format texture.
                 */
                ASTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an BPTC format texture.
                 */
                BPTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an RGTC format texture.
                 */
                RGTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an PVRTC format texture.
                 */
                PVRTC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an S3TC format texture.
                 */
                S3TC?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for an S3TCRGB format texture.
                 */
                S3TCRGB?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The string, or file entry object, for the fallback image file.
                 */
                IMG?: Phaser.Types.Loader.FileTypes.CompressedTextureFileEntry | string;
                /**
                 * The type of shader. Either `fragment` for a fragment shader, or `vertex` for a vertex shader. This is ignored if you load a shader bundle.
                 */
                shaderType?: string;
                /**
                 * The width of the texture the HTML will be rendered to.
                 */
                width?: number;
                /**
                 * The height of the texture the HTML will be rendered to.
                 */
                height?: number;
                /**
                 * The frame configuration object. Only provided for, and used by, Sprite Sheets.
                 */
                frameConfig?: Phaser.Types.Loader.FileTypes.ImageFrameConfig;
                /**
                 * If specified instead of the whole JSON file being parsed and added to the Cache, only the section corresponding to this property key will be added. If the property you want to extract is nested, use periods to divide it.
                 */
                dataKey?: string;
                /**
                 * Optional Base URL to use when loading the textures defined in the atlas data.
                 */
                baseURL?: string;
                /**
                 * Flip the UV coordinates stored in the model data?
                 */
                flipUV?: boolean;
                /**
                 * An optional absolute or relative URL to the object material file from. If undefined or `null`, no material file will be loaded.
                 */
                matURL?: string;
                /**
                 * The default material file extension to use if no url is provided.
                 */
                matExtension?: string;
                /**
                 * Automatically start the plugin after loading?
                 */
                start?: boolean;
                /**
                 * If this plugin is to be injected into the Scene, this is the property key used.
                 */
                mapping?: string;
                /**
                 * If this plugin is to be added to Scene.Systems, this is the property key for it.
                 */
                systemKey?: string;
                /**
                 * If this plugin is to be added to the Scene, this is the property key for it.
                 */
                sceneKey?: string;
                /**
                 * The svg size configuration object.
                 */
                svgConfig?: Phaser.Types.Loader.FileTypes.SVGSizeConfig;
            };

            type XHRSettingsObject = {
                /**
                 * The response type of the XHR request, i.e. `blob`, `text`, etc.
                 */
                responseType: XMLHttpRequestResponseType;
                /**
                 * Should the XHR request use async or not?
                 */
                async?: boolean;
                /**
                 * Optional username for the XHR request.
                 */
                user?: string;
                /**
                 * Optional password for the XHR request.
                 */
                password?: string;
                /**
                 * Optional XHR timeout value.
                 */
                timeout?: number;
                /**
                 * This value is used to populate the XHR `setRequestHeader` and is undefined by default.
                 */
                headers?: object | undefined;
                /**
                 * This value is used to populate the XHR `setRequestHeader` and is undefined by default.
                 */
                header?: string | undefined;
                /**
                 * This value is used to populate the XHR `setRequestHeader` and is undefined by default.
                 */
                headerValue?: string | undefined;
                /**
                 * This value is used to populate the XHR `setRequestHeader` and is undefined by default.
                 */
                requestedWith?: string | undefined;
                /**
                 * Provide a custom mime-type to use instead of the default.
                 */
                overrideMimeType?: string | undefined;
                /**
                 * The withCredentials property indicates whether or not cross-site Access-Control requests should be made using credentials such as cookies, authorization headers or TLS client certificates. Setting withCredentials has no effect on same-site requests.
                 */
                withCredentials?: boolean;
            };

        }

        namespace Math {
            type SinCosTable = {
                /**
                 * The sine value.
                 */
                sin: number;
                /**
                 * The cosine value.
                 */
                cos: number;
                /**
                 * The length.
                 */
                length: number;
            };

            type Vector2Like = {
                /**
                 * The x component.
                 */
                x?: number;
                /**
                 * The y component.
                 */
                y?: number;
            };

            type Vector3Like = {
                /**
                 * The x component.
                 */
                x?: number;
                /**
                 * The y component.
                 */
                y?: number;
                /**
                 * The z component.
                 */
                z?: number;
            };

            type Vector4Like = {
                /**
                 * The x component.
                 */
                x?: number;
                /**
                 * The y component.
                 */
                y?: number;
                /**
                 * The z component.
                 */
                z?: number;
                /**
                 * The w component.
                 */
                w?: number;
            };

        }

        namespace Physics {
            namespace Arcade {
                type ArcadeBodyBounds = {
                    /**
                     * The left edge.
                     */
                    x: number;
                    /**
                     * The upper edge.
                     */
                    y: number;
                    /**
                     * The right edge.
                     */
                    right: number;
                    /**
                     * The lower edge.
                     */
                    bottom: number;
                };

                type ArcadeBodyCollision = {
                    /**
                     * True if the Body is not colliding.
                     */
                    none: boolean;
                    /**
                     * True if the Body is colliding on its upper edge.
                     */
                    up: boolean;
                    /**
                     * True if the Body is colliding on its lower edge.
                     */
                    down: boolean;
                    /**
                     * True if the Body is colliding on its left edge.
                     */
                    left: boolean;
                    /**
                     * True if the Body is colliding on its right edge.
                     */
                    right: boolean;
                };

                /**
                 * An Arcade Physics Collider Type.
                 */
                type ArcadeCollider = Phaser.Physics.Arcade.Sprite | Phaser.Physics.Arcade.Image | Phaser.Physics.Arcade.StaticGroup | Phaser.Physics.Arcade.Group | Phaser.Tilemaps.TilemapLayer;

                /**
                 * An Arcade Physics Collider Type.
                 */
                type ArcadeColliderType = Phaser.GameObjects.GameObject | Phaser.GameObjects.Group | Phaser.Physics.Arcade.Sprite | Phaser.Physics.Arcade.Image | Phaser.Physics.Arcade.StaticGroup | Phaser.Physics.Arcade.Group | Phaser.Tilemaps.TilemapLayer | Phaser.GameObjects.GameObject[] | Phaser.Physics.Arcade.Sprite[] | Phaser.Physics.Arcade.Image[] | Phaser.Physics.Arcade.StaticGroup[] | Phaser.Physics.Arcade.Group[] | Phaser.Tilemaps.TilemapLayer[];

                type ArcadePhysicsCallback = (object1: Phaser.Types.Physics.Arcade.GameObjectWithBody | Phaser.Tilemaps.Tile, object2: Phaser.Types.Physics.Arcade.GameObjectWithBody | Phaser.Tilemaps.Tile)=>void;

                type ArcadeWorldConfig = {
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#fps}.
                     */
                    fps?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#fixedStep}.
                     */
                    fixedStep?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#timeScale}.
                     */
                    timeScale?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#gravity}.
                     */
                    gravity?: Phaser.Types.Math.Vector2Like;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#bounds bounds.x}.
                     */
                    x?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#bounds bounds.y}.
                     */
                    y?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#bounds bounds.width}.
                     */
                    width?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#bounds bounds.height}.
                     */
                    height?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#checkCollision}.
                     */
                    checkCollision?: Phaser.Types.Physics.Arcade.CheckCollisionObject;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#OVERLAP_BIAS}.
                     */
                    overlapBias?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#TILE_BIAS}.
                     */
                    tileBias?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#forceX}.
                     */
                    forceX?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#isPaused}.
                     */
                    isPaused?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#debug}.
                     */
                    debug?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults debugShowBody}.
                     */
                    debugShowBody?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults debugShowStaticBody}.
                     */
                    debugShowStaticBody?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults debugShowStaticBody}.
                     */
                    debugShowVelocity?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults bodyDebugColor}.
                     */
                    debugBodyColor?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults staticBodyDebugColor}.
                     */
                    debugStaticBodyColor?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#defaults velocityDebugColor}.
                     */
                    debugVelocityColor?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#maxEntries}.
                     */
                    maxEntries?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.World#useTree}.
                     */
                    useTree?: boolean;
                    /**
                     * If enabled, you need to call `World.update` yourself.
                     */
                    customUpdate?: boolean;
                };

                type ArcadeWorldDefaults = {
                    /**
                     * Set to `true` to render dynamic body outlines to the debug display.
                     */
                    debugShowBody: boolean;
                    /**
                     * Set to `true` to render static body outlines to the debug display.
                     */
                    debugShowStaticBody: boolean;
                    /**
                     * Set to `true` to render body velocity markers to the debug display.
                     */
                    debugShowVelocity: boolean;
                    /**
                     * The color of dynamic body outlines when rendered to the debug display.
                     */
                    bodyDebugColor: number;
                    /**
                     * The color of static body outlines when rendered to the debug display.
                     */
                    staticBodyDebugColor: number;
                    /**
                     * The color of the velocity markers when rendered to the debug display.
                     */
                    velocityDebugColor: number;
                };

                type ArcadeWorldTreeMinMax = {
                    /**
                     * The minimum x value used in RTree searches.
                     */
                    minX: number;
                    /**
                     * The minimum y value used in RTree searches.
                     */
                    minY: number;
                    /**
                     * The maximum x value used in RTree searches.
                     */
                    maxX: number;
                    /**
                     * The maximum y value used in RTree searches.
                     */
                    maxY: number;
                };

                type CheckCollisionObject = {
                    /**
                     * Will bodies collide with the top side of the world bounds?
                     */
                    up: boolean;
                    /**
                     * Will bodies collide with the bottom side of the world bounds?
                     */
                    down: boolean;
                    /**
                     * Will bodies collide with the left side of the world bounds?
                     */
                    left: boolean;
                    /**
                     * Will bodies collide with the right side of the world bounds?
                     */
                    right: boolean;
                };

                type GameObjectWithBody = Phaser.GameObjects.GameObject & {
                    body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody;
                };

                type GameObjectWithDynamicBody = Phaser.GameObjects.GameObject & {
                    body: Phaser.Physics.Arcade.Body;
                };

                type GameObjectWithStaticBody = Phaser.GameObjects.GameObject & {
                    body: Phaser.Physics.Arcade.StaticBody;
                };

                type ImageWithDynamicBody = Phaser.Physics.Arcade.Image & {
                    body: Phaser.Physics.Arcade.Body;
                };

                type ImageWithStaticBody = Phaser.Physics.Arcade.Image & {
                    body: Phaser.Physics.Arcade.StaticBody;
                };

                type PhysicsGroupConfig = Phaser.Types.GameObjects.Group.GroupConfig & {
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#collideWorldBounds}.
                     */
                    collideWorldBounds?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#setBoundsRectangle setBoundsRectangle}.
                     */
                    customBoundsRectangle?: Phaser.Geom.Rectangle;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#acceleration acceleration.x}.
                     */
                    accelerationX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#acceleration acceleration.y}.
                     */
                    accelerationY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#allowDrag}.
                     */
                    allowDrag?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#allowGravity}.
                     */
                    allowGravity?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#allowRotation}.
                     */
                    allowRotation?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#useDamping useDamping}.
                     */
                    useDamping?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#bounce bounce.x}.
                     */
                    bounceX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#bounce bounce.y}.
                     */
                    bounceY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#drag drag.x}.
                     */
                    dragX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#drag drag.y}.
                     */
                    dragY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#enable enable}.
                     */
                    enable?: boolean;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#gravity gravity.x}.
                     */
                    gravityX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#gravity gravity.y}.
                     */
                    gravityY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#friction friction.x}.
                     */
                    frictionX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#friction friction.y}.
                     */
                    frictionY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#maxSpeed maxSpeed}.
                     */
                    maxSpeed?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#maxVelocity maxVelocity.x}.
                     */
                    maxVelocityX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#maxVelocity maxVelocity.y}.
                     */
                    maxVelocityY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#velocity velocity.x}.
                     */
                    velocityX?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#velocity velocity.y}.
                     */
                    velocityY?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#angularVelocity}.
                     */
                    angularVelocity?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#angularAcceleration}.
                     */
                    angularAcceleration?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#angularDrag}.
                     */
                    angularDrag?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#mass}.
                     */
                    mass?: number;
                    /**
                     * Sets {@link Phaser.Physics.Arcade.Body#immovable}.
                     */
                    immovable?: boolean;
                };

                type PhysicsGroupDefaults = {
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setCollideWorldBounds}.
                     */
                    setCollideWorldBounds: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setBoundsRectangle}.
                     */
                    setBoundsRectangle: Phaser.Geom.Rectangle;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAccelerationX}.
                     */
                    setAccelerationX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAccelerationY}.
                     */
                    setAccelerationY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAllowDrag}.
                     */
                    setAllowDrag: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAllowGravity}.
                     */
                    setAllowGravity: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAllowRotation}.
                     */
                    setAllowRotation: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setDamping}.
                     */
                    setDamping: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setBounceX}.
                     */
                    setBounceX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setBounceY}.
                     */
                    setBounceY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setDragX}.
                     */
                    setDragX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setDragY}.
                     */
                    setDragY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setEnable}.
                     */
                    setEnable: boolean;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setGravityX}.
                     */
                    setGravityX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setGravityY}.
                     */
                    setGravityY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setFrictionX}.
                     */
                    setFrictionX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setFrictionY}.
                     */
                    setFrictionY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setMaxSpeed}.
                     */
                    setMaxSpeed: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setVelocityX}.
                     */
                    setVelocityX: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setVelocityY}.
                     */
                    setVelocityY: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAngularVelocity}.
                     */
                    setAngularVelocity: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAngularAcceleration}.
                     */
                    setAngularAcceleration: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setAngularDrag}.
                     */
                    setAngularDrag: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setMass}.
                     */
                    setMass: number;
                    /**
                     * As {@link Phaser.Physics.Arcade.Body#setImmovable}.
                     */
                    setImmovable: boolean;
                };

                type SpriteWithDynamicBody = Phaser.Physics.Arcade.Sprite & {
                    body: Phaser.Physics.Arcade.Body;
                };

                type SpriteWithStaticBody = Phaser.Physics.Arcade.Sprite & {
                    body: Phaser.Physics.Arcade.StaticBody;
                };

            }

            namespace Matter {
                type MatterBody = MatterJS.BodyType | Phaser.GameObjects.GameObject | Phaser.Physics.Matter.Image | Phaser.Physics.Matter.Sprite | Phaser.Physics.Matter.TileBody;

                type MatterBodyConfig = {
                    /**
                     * An arbitrary string-based name to help identify this body.
                     */
                    label?: string;
                    /**
                     * Set this Game Object to create and use a new Body based on the configuration object given.
                     */
                    shape?: string | Phaser.Types.Physics.Matter.MatterSetBodyConfig;
                    /**
                     * An array of bodies that make up this body. The first body in the array must always be a self reference to the current body instance. All bodies in the `parts` array together form a single rigid compound body.
                     */
                    parts?: MatterJS.BodyType[];
                    /**
                     * An object reserved for storing plugin-specific properties.
                     */
                    plugin?: any;
                    /**
                     * A number specifying the angle of the body, in radians.
                     */
                    angle?: number;
                    /**
                     * An array of `Vector` objects that specify the convex hull of the rigid body. These should be provided about the origin `(0, 0)`.
                     */
                    vertices?: Phaser.Types.Math.Vector2Like[];
                    /**
                     * A `Vector` that specifies the current world-space position of the body.
                     */
                    position?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A `Vector` that specifies the force to apply in the current step. It is zeroed after every `Body.update`. See also `Body.applyForce`.
                     */
                    force?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A `Number` that specifies the torque (turning force) to apply in the current step. It is zeroed after every `Body.update`.
                     */
                    torque?: number;
                    /**
                     * A flag that indicates whether a body is a sensor. Sensor triggers collision events, but doesn't react with colliding body physically.
                     */
                    isSensor?: boolean;
                    /**
                     * A flag that indicates whether a body is considered static. A static body can never change position or angle and is completely fixed.
                     */
                    isStatic?: boolean;
                    /**
                     * A `Number` that defines the number of updates in which this body must have near-zero velocity before it is set as sleeping by the `Matter.Sleeping` module (if sleeping is enabled by the engine).
                     */
                    sleepThreshold?: number;
                    /**
                     * A `Number` that defines the density of the body, that is its mass per unit area. If you pass the density via `Body.create` the `mass` property is automatically calculated for you based on the size (area) of the object. This is generally preferable to simply setting mass and allows for more intuitive definition of materials (e.g. rock has a higher density than wood).
                     */
                    density?: number;
                    /**
                     * A `Number` that defines the restitution (elasticity) of the body. The value is always positive and is in the range `(0, 1)`.
                     */
                    restitution?: number;
                    /**
                     * A `Number` that defines the friction of the body. The value is always positive and is in the range `(0, 1)`. A value of `0` means that the body may slide indefinitely. A value of `1` means the body may come to a stop almost instantly after a force is applied.
                     */
                    friction?: number;
                    /**
                     * A `Number` that defines the static friction of the body (in the Coulomb friction model). A value of `0` means the body will never 'stick' when it is nearly stationary and only dynamic `friction` is used. The higher the value (e.g. `10`), the more force it will take to initially get the body moving when nearly stationary. This value is multiplied with the `friction` property to make it easier to change `friction` and maintain an appropriate amount of static friction.
                     */
                    frictionStatic?: number;
                    /**
                     * A `Number` that defines the air friction of the body (air resistance). A value of `0` means the body will never slow as it moves through space. The higher the value, the faster a body slows when moving through space.
                     */
                    frictionAir?: number;
                    /**
                     * An `Object` that specifies the collision filtering properties of this body.
                     */
                    collisionFilter?: Phaser.Types.Physics.Matter.MatterCollisionFilter;
                    /**
                     * A `Number` that specifies a tolerance on how far a body is allowed to 'sink' or rotate into other bodies. Avoid changing this value unless you understand the purpose of `slop` in physics engines. The default should generally suffice, although very large bodies may require larger values for stable stacking.
                     */
                    slop?: number;
                    /**
                     * A `Number` that allows per-body time scaling, e.g. a force-field where bodies inside are in slow-motion, while others are at full speed.
                     */
                    timeScale?: number;
                    /**
                     * A number, or array of numbers, to chamfer the vertices of the body, or a full Chamfer configuration object.
                     */
                    chamfer?: number | number[] | Phaser.Types.Physics.Matter.MatterChamferConfig;
                    /**
                     * The radius of this body if a circle.
                     */
                    circleRadius?: number;
                    /**
                     * A `Number` that defines the mass of the body, although it may be more appropriate to specify the `density` property instead. If you modify this value, you must also modify the `body.inverseMass` property (`1 / mass`).
                     */
                    mass?: number;
                    /**
                     * A `Number` that defines the inverse mass of the body (`1 / mass`). If you modify this value, you must also modify the `body.mass` property.
                     */
                    inverseMass?: number;
                    /**
                     * A `Vector` that specifies the initial scale of the body.
                     */
                    scale?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A `Vector` that scales the influence of World gravity when applied to this body.
                     */
                    gravityScale?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A boolean that toggles if this body should ignore world gravity or not.
                     */
                    ignoreGravity?: boolean;
                    /**
                     * A boolean that toggles if this body should ignore pointer / mouse constraints or not.
                     */
                    ignorePointer?: boolean;
                    /**
                     * The Debug Render configuration object for this body.
                     */
                    render?: Phaser.Types.Physics.Matter.MatterBodyRenderConfig;
                    /**
                     * A callback that is invoked when this Body starts colliding with any other Body. You can register callbacks by providing a function of type `( pair: Matter.Pair) => void`.
                     */
                    onCollideCallback?: Function;
                    /**
                     * A callback that is invoked when this Body stops colliding with any other Body. You can register callbacks by providing a function of type `( pair: Matter.Pair) => void`.
                     */
                    onCollideEndCallback?: Function;
                    /**
                     * A callback that is invoked for the duration that this Body is colliding with any other Body. You can register callbacks by providing a function of type `( pair: Matter.Pair) => void`.
                     */
                    onCollideActiveCallback?: Function;
                    /**
                     * A collision callback dictionary used by the `Body.setOnCollideWith` function.
                     */
                    onCollideWith?: any;
                };

                type MatterBodyRenderConfig = {
                    /**
                     * Should this body be rendered by the Debug Renderer?
                     */
                    visible?: boolean;
                    /**
                     * The opacity of the body and all parts within it.
                     */
                    opacity?: number;
                    /**
                     * The color value of the fill when rendering this body.
                     */
                    fillColor?: number;
                    /**
                     * The opacity of the fill when rendering this body, a value between 0 and 1.
                     */
                    fillOpacity?: number;
                    /**
                     * The color value of the line stroke when rendering this body.
                     */
                    lineColor?: number;
                    /**
                     * The opacity of the line when rendering this body, a value between 0 and 1.
                     */
                    lineOpacity?: number;
                    /**
                     * If rendering lines, the thickness of the line.
                     */
                    lineThickness?: number;
                    /**
                     * Controls the offset between the body and the parent Game Object, if it has one.
                     */
                    sprite?: object;
                    /**
                     * The horizontal offset between the body and the parent Game Object texture, if it has one.
                     */
                    "sprite.xOffset"?: number;
                    /**
                     * The vertical offset between the body and the parent Game Object texture, if it has one.
                     */
                    "sprite.yOffset"?: number;
                };

                type MatterBodyTileOptions = {
                    /**
                     * Whether or not the newly created body should be made static. This defaults to true since typically tiles should not be moved.
                     */
                    isStatic?: boolean;
                    /**
                     * Whether or not to add the newly created body (or existing body if options.body is used) to the Matter world.
                     */
                    addToWorld?: boolean;
                };

                type MatterChamferConfig = {
                    /**
                     * A single number, or an array, to specify the radius for each vertex.
                     */
                    radius?: number | number[];
                    /**
                     * The quality of the chamfering. -1 means 'auto'.
                     */
                    quality?: number;
                    /**
                     * The minimum quality of the chamfering. The higher this value, the more vertices are created.
                     */
                    qualityMin?: number;
                    /**
                     * The maximum quality of the chamfering. The higher this value, the more vertices are created.
                     */
                    qualityMax?: number;
                };

                type MatterCollisionData = {
                    /**
                     * Have the pair collided or not?
                     */
                    collided: boolean;
                    /**
                     * A reference to the first body involved in the collision.
                     */
                    bodyA: MatterJS.BodyType;
                    /**
                     * A reference to the second body involved in the collision.
                     */
                    bodyB: MatterJS.BodyType;
                    /**
                     * A reference to the dominant axis body.
                     */
                    axisBody: MatterJS.BodyType;
                    /**
                     * The index of the dominant collision axis vector (edge normal)
                     */
                    axisNumber: number;
                    /**
                     * The depth of the collision on the minimum overlap.
                     */
                    depth: number;
                    /**
                     * A reference to the parent of Body A, or to Body A itself if it has no parent.
                     */
                    parentA: MatterJS.BodyType;
                    /**
                     * A reference to the parent of Body B, or to Body B itself if it has no parent.
                     */
                    parentB: MatterJS.BodyType;
                    /**
                     * The collision normal, facing away from Body A.
                     */
                    normal: MatterJS.Vector;
                    /**
                     * The tangent of the collision normal.
                     */
                    tangent: MatterJS.Vector;
                    /**
                     * The penetration distances between the two bodies.
                     */
                    penetration: MatterJS.Vector;
                    /**
                     * An array of support points, either exactly one or two points.
                     */
                    supports: MatterJS.Vector[];
                    /**
                     * The resulting inverse mass from the collision.
                     */
                    inverseMass: number;
                    /**
                     * The resulting friction from the collision.
                     */
                    friction: number;
                    /**
                     * The resulting static friction from the collision.
                     */
                    frictionStatic: number;
                    /**
                     * The resulting restitution from the collision.
                     */
                    restitution: number;
                    /**
                     * The resulting slop from the collision.
                     */
                    slop: number;
                };

                /**
                 * An `Object` that specifies the collision filtering properties of this body.
                 * 
                 * Collisions between two bodies will obey the following rules:
                 * - If the two bodies have the same non-zero value of `collisionFilter.group`,
                 *   they will always collide if the value is positive, and they will never collide
                 *   if the value is negative.
                 * - If the two bodies have different values of `collisionFilter.group` or if one
                 *   (or both) of the bodies has a value of 0, then the category/mask rules apply as follows:
                 * 
                 * Each body belongs to a collision category, given by `collisionFilter.category`. This
                 * value is used as a bit field and the category should have only one bit set, meaning that
                 * the value of this property is a power of two in the range [1, 2^31]. Thus, there are 32
                 * different collision categories available.
                 * 
                 * Each body also defines a collision bitmask, given by `collisionFilter.mask` which specifies
                 * the categories it collides with (the value is the bitwise AND value of all these categories).
                 * 
                 * Using the category/mask rules, two bodies `A` and `B` collide if each includes the other's
                 * category in its mask, i.e. `(categoryA & maskB) !== 0` and `(categoryB & maskA) !== 0`
                 * are both true.
                 */
                type MatterCollisionFilter = {
                    /**
                     * A bit field that specifies the collision category this body belongs to. The category value should have only one bit set, for example `0x0001`. This means there are up to 32 unique collision categories available.
                     */
                    category?: number;
                    /**
                     * A bit mask that specifies the collision categories this body may collide with.
                     */
                    mask?: number;
                    /**
                     * An Integer `Number`, that specifies the collision group this body belongs to.
                     */
                    group?: number;
                };

                type MatterCollisionPair = {
                    /**
                     * The unique auto-generated collision pair id. A combination of the body A and B IDs.
                     */
                    id: string;
                    /**
                     * A reference to the first body involved in the collision.
                     */
                    bodyA: MatterJS.BodyType;
                    /**
                     * A reference to the second body involved in the collision.
                     */
                    bodyB: MatterJS.BodyType;
                    /**
                     * An array containing all of the active contacts between bodies A and B.
                     */
                    activeContacts: MatterJS.Vector[];
                    /**
                     * The amount of separation that occurred between bodies A and B.
                     */
                    separation: number;
                    /**
                     * Is the collision still active or not?
                     */
                    isActive: boolean;
                    /**
                     * Has Matter determined the collision are being active yet?
                     */
                    confirmedActive: boolean;
                    /**
                     * Is either body A or B a sensor?
                     */
                    isSensor: boolean;
                    /**
                     * The timestamp when the collision pair was created.
                     */
                    timeCreated: number;
                    /**
                     * The timestamp when the collision pair was most recently updated.
                     */
                    timeUpdated: number;
                    /**
                     * The collision data object.
                     */
                    collision: Phaser.Types.Physics.Matter.MatterCollisionData;
                    /**
                     * The resulting inverse mass from the collision.
                     */
                    inverseMass: number;
                    /**
                     * The resulting friction from the collision.
                     */
                    friction: number;
                    /**
                     * The resulting static friction from the collision.
                     */
                    frictionStatic: number;
                    /**
                     * The resulting restitution from the collision.
                     */
                    restitution: number;
                    /**
                     * The resulting slop from the collision.
                     */
                    slop: number;
                };

                type MatterConstraintConfig = {
                    /**
                     * An arbitrary string-based name to help identify this constraint.
                     */
                    label?: string;
                    /**
                     * The first possible `Body` that this constraint is attached to.
                     */
                    bodyA?: MatterJS.BodyType;
                    /**
                     * The second possible `Body` that this constraint is attached to.
                     */
                    bodyB?: MatterJS.BodyType;
                    /**
                     * A `Vector` that specifies the offset of the constraint from center of the `constraint.bodyA` if defined, otherwise a world-space position.
                     */
                    pointA?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A `Vector` that specifies the offset of the constraint from center of the `constraint.bodyB` if defined, otherwise a world-space position.
                     */
                    pointB?: Phaser.Types.Math.Vector2Like;
                    /**
                     * A `Number` that specifies the stiffness of the constraint, i.e. the rate at which it returns to its resting `constraint.length`. A value of `1` means the constraint should be very stiff. A value of `0.2` means the constraint acts like a soft spring.
                     */
                    stiffness?: number;
                    /**
                     * A `Number` that specifies the angular stiffness of the constraint.
                     */
                    angularStiffness?: number;
                    /**
                     * The angleA of the constraint. If bodyA is set, the angle of bodyA is used instead.
                     */
                    angleA?: number;
                    /**
                     * The angleB of the constraint. If bodyB is set, the angle of bodyB is used instead.
                     */
                    angleB?: number;
                    /**
                     * A `Number` that specifies the damping of the constraint, i.e. the amount of resistance applied to each body based on their velocities to limit the amount of oscillation. Damping will only be apparent when the constraint also has a very low `stiffness`. A value of `0.1` means the constraint will apply heavy damping, resulting in little to no oscillation. A value of `0` means the constraint will apply no damping.
                     */
                    damping?: number;
                    /**
                     * A `Number` that specifies the target resting length of the constraint. It is calculated automatically in `Constraint.create` from initial positions of the `constraint.bodyA` and `constraint.bodyB`.
                     */
                    length?: number;
                    /**
                     * An object reserved for storing plugin-specific properties.
                     */
                    plugin?: any;
                    /**
                     * The Debug Render configuration object for this constraint.
                     */
                    render?: Phaser.Types.Physics.Matter.MatterConstraintRenderConfig;
                };

                type MatterConstraintRenderConfig = {
                    /**
                     * Should this constraint be rendered by the Debug Renderer?
                     */
                    visible?: boolean;
                    /**
                     * If this constraint has anchors, should they be rendered? Pin constraints never have anchors.
                     */
                    anchors?: boolean;
                    /**
                     * The color value of the line stroke when rendering this constraint.
                     */
                    lineColor?: number;
                    /**
                     * The opacity of the line when rendering this constraint, a value between 0 and 1.
                     */
                    lineOpacity?: number;
                    /**
                     * If rendering lines, the thickness of the line.
                     */
                    lineThickness?: number;
                    /**
                     * The size of the circles drawn when rendering pin constraints.
                     */
                    pinSize?: number;
                    /**
                     * The size of the circles drawn as the constraint anchors.
                     */
                    anchorSize?: number;
                    /**
                     * The color value of constraint anchors.
                     */
                    anchorColor?: number;
                };

                type MatterDebugConfig = {
                    /**
                     * Render all of the body axes?
                     */
                    showAxes?: boolean;
                    /**
                     * Render just a single body axis?
                     */
                    showAngleIndicator?: boolean;
                    /**
                     * The color of the body angle / axes lines.
                     */
                    angleColor?: number;
                    /**
                     * Render the broadphase grid?
                     */
                    showBroadphase?: boolean;
                    /**
                     * The color of the broadphase grid.
                     */
                    broadphaseColor?: number;
                    /**
                     * Render the bounds of the bodies in the world?
                     */
                    showBounds?: boolean;
                    /**
                     * The color of the body bounds.
                     */
                    boundsColor?: number;
                    /**
                     * Render the velocity of the bodies in the world?
                     */
                    showVelocity?: boolean;
                    /**
                     * The color of the body velocity line.
                     */
                    velocityColor?: number;
                    /**
                     * Render the collision points and normals for colliding pairs.
                     */
                    showCollisions?: boolean;
                    /**
                     * The color of the collision points.
                     */
                    collisionColor?: number;
                    /**
                     * Render lines showing the separation between bodies.
                     */
                    showSeparation?: boolean;
                    /**
                     * The color of the body separation line.
                     */
                    separationColor?: number;
                    /**
                     * Render the dynamic bodies in the world to the Graphics object?
                     */
                    showBody?: boolean;
                    /**
                     * Render the static bodies in the world to the Graphics object?
                     */
                    showStaticBody?: boolean;
                    /**
                     * When rendering bodies, render the internal edges as well?
                     */
                    showInternalEdges?: boolean;
                    /**
                     * Render the bodies using a fill color.
                     */
                    renderFill?: boolean;
                    /**
                     * Render the bodies using a line stroke.
                     */
                    renderLine?: boolean;
                    /**
                     * The color value of the fill when rendering dynamic bodies.
                     */
                    fillColor?: number;
                    /**
                     * The opacity of the fill when rendering dynamic bodies, a value between 0 and 1.
                     */
                    fillOpacity?: number;
                    /**
                     * The color value of the line stroke when rendering dynamic bodies.
                     */
                    lineColor?: number;
                    /**
                     * The opacity of the line when rendering dynamic bodies, a value between 0 and 1.
                     */
                    lineOpacity?: number;
                    /**
                     * If rendering lines, the thickness of the line.
                     */
                    lineThickness?: number;
                    /**
                     * The color value of the fill when rendering static bodies.
                     */
                    staticFillColor?: number;
                    /**
                     * The color value of the line stroke when rendering static bodies.
                     */
                    staticLineColor?: number;
                    /**
                     * Render any sleeping bodies (dynamic or static) in the world to the Graphics object?
                     */
                    showSleeping?: boolean;
                    /**
                     * The amount to multiply the opacity of sleeping static bodies by.
                     */
                    staticBodySleepOpacity?: number;
                    /**
                     * The color value of the fill when rendering sleeping dynamic bodies.
                     */
                    sleepFillColor?: number;
                    /**
                     * The color value of the line stroke when rendering sleeping dynamic bodies.
                     */
                    sleepLineColor?: number;
                    /**
                     * Render bodies or body parts that are flagged as being a sensor?
                     */
                    showSensors?: boolean;
                    /**
                     * The fill color when rendering body sensors.
                     */
                    sensorFillColor?: number;
                    /**
                     * The line color when rendering body sensors.
                     */
                    sensorLineColor?: number;
                    /**
                     * Render the position of non-static bodies?
                     */
                    showPositions?: boolean;
                    /**
                     * The size of the rectangle drawn when rendering the body position.
                     */
                    positionSize?: number;
                    /**
                     * The color value of the rectangle drawn when rendering the body position.
                     */
                    positionColor?: number;
                    /**
                     * Render all world constraints to the Graphics object?
                     */
                    showJoint?: boolean;
                    /**
                     * The color value of joints when `showJoint` is set.
                     */
                    jointColor?: number;
                    /**
                     * The line opacity when rendering joints, a value between 0 and 1.
                     */
                    jointLineOpacity?: number;
                    /**
                     * The line thickness when rendering joints.
                     */
                    jointLineThickness?: number;
                    /**
                     * The size of the circles drawn when rendering pin constraints.
                     */
                    pinSize?: number;
                    /**
                     * The color value of the circles drawn when rendering pin constraints.
                     */
                    pinColor?: number;
                    /**
                     * The color value of spring constraints.
                     */
                    springColor?: number;
                    /**
                     * The color value of constraint anchors.
                     */
                    anchorColor?: number;
                    /**
                     * The size of the circles drawn as the constraint anchors.
                     */
                    anchorSize?: number;
                    /**
                     * When rendering polygon bodies, render the convex hull as well?
                     */
                    showConvexHulls?: boolean;
                    /**
                     * The color value of hulls when `showConvexHulls` is set.
                     */
                    hullColor?: number;
                };

                type MatterRunnerConfig = {
                    /**
                     * A boolean that specifies if the runner should use a fixed timestep (otherwise it is variable). If timing is fixed, then the apparent simulation speed will change depending on the frame rate (but behaviour will be deterministic). If the timing is variable, then the apparent simulation speed will be constant (approximately, but at the cost of determininism).
                     */
                    isFixed?: boolean;
                    /**
                     * A number that specifies the frame rate in seconds. If you don't specify this, but do specify `delta`, those values set the fps rate.
                     */
                    fps?: number;
                    /**
                     * A number that specifies the time correction factor to apply to the update. This can help improve the accuracy of the simulation in cases where delta is changing between updates.
                     */
                    correction?: number;
                    /**
                     * The size of the delta smoothing array when `isFixed` is `false`.
                     */
                    deltaSampleSize?: number;
                    /**
                     * A number that specifies the time step between updates in milliseconds. If you set the `fps` property, this value is set based on that. If `isFixed` is set to `true`, then `delta` is fixed. If it is `false`, then `delta` can dynamically change to maintain the correct apparent simulation speed.
                     */
                    delta?: number;
                    /**
                     * A number that specifies the minimum time step between updates in milliseconds.
                     */
                    deltaMin?: number;
                    /**
                     * A number that specifies the maximum time step between updates in milliseconds.
                     */
                    deltaMax?: number;
                };

                type MatterSetBodyConfig = {
                    /**
                     * The shape type. Either `rectangle`, `circle`, `trapezoid`, `polygon`, `fromVertices`, `fromVerts` or `fromPhysicsEditor`.
                     */
                    type?: string;
                    /**
                     * The horizontal world position to place the body at.
                     */
                    x?: number;
                    /**
                     * The vertical world position to place the body at.
                     */
                    y?: number;
                    /**
                     * The width of the body.
                     */
                    width?: number;
                    /**
                     * The height of the body.
                     */
                    height?: number;
                    /**
                     * The radius of the body. Used by `circle` and `polygon` shapes.
                     */
                    radius?: number;
                    /**
                     * The max sizes of the body. Used by the `circle` shape.
                     */
                    maxSides?: number;
                    /**
                     * Used by the `trapezoid` shape. The slope of the trapezoid. 0 creates a rectangle, while 1 creates a triangle. Positive values make the top side shorter, while negative values make the bottom side shorter.
                     */
                    slope?: number;
                    /**
                     * Used by the `polygon` shape. The number of sides the polygon will have.
                     */
                    sides?: number;
                    /**
                     * Used by the `fromVerts` shape. The vertices data. Either a path string or an array of vertices.
                     */
                    verts?: string | any[];
                    /**
                     * Used by the `fromVerts` shape. Flag internal edges (coincident part edges)
                     */
                    flagInternal?: boolean;
                    /**
                     * Used by the `fromVerts` shape. Whether Matter.js will discard collinear edges (to improve performance).
                     */
                    removeCollinear?: number;
                    /**
                     * Used by the `fromVerts` shape. During decomposition discard parts that have an area less than this.
                     */
                    minimumArea?: number;
                    /**
                     * Should the new body be automatically added to the world?
                     */
                    addToWorld?: boolean;
                };

                type MatterTileOptions = {
                    /**
                     * An existing Matter body to be used instead of creating a new one.
                     */
                    body?: MatterJS.BodyType;
                    /**
                     * Whether or not the newly created body should be made static. This defaults to true since typically tiles should not be moved.
                     */
                    isStatic?: boolean;
                    /**
                     * Whether or not to add the newly created body (or existing body if options.body is used) to the Matter world.
                     */
                    addToWorld?: boolean;
                };

                type MatterWalls = {
                    /**
                     * The left wall for the Matter World.
                     */
                    left?: MatterJS.BodyType;
                    /**
                     * The right wall for the Matter World.
                     */
                    right?: MatterJS.BodyType;
                    /**
                     * The top wall for the Matter World.
                     */
                    top?: MatterJS.BodyType;
                    /**
                     * The bottom wall for the Matter World.
                     */
                    bottom?: MatterJS.BodyType;
                };

                type MatterWorldConfig = {
                    /**
                     * Sets {@link Phaser.Physics.Matter.World#gravity}.
                     */
                    gravity?: Phaser.Types.Math.Vector2Like;
                    /**
                     * Should the world have bounds enabled by default?
                     */
                    setBounds?: object | boolean;
                    /**
                     * The x coordinate of the world bounds.
                     */
                    "setBounds.x"?: number;
                    /**
                     * The y coordinate of the world bounds.
                     */
                    "setBounds.y"?: number;
                    /**
                     * The width of the world bounds.
                     */
                    "setBounds.width"?: number;
                    /**
                     * The height of the world bounds.
                     */
                    "setBounds.height"?: number;
                    /**
                     * The thickness of the walls of the world bounds.
                     */
                    "setBounds.thickness"?: number;
                    /**
                     * Should the left-side world bounds wall be created?
                     */
                    "setBounds.left"?: boolean;
                    /**
                     * Should the right-side world bounds wall be created?
                     */
                    "setBounds.right"?: boolean;
                    /**
                     * Should the top world bounds wall be created?
                     */
                    "setBounds.top"?: boolean;
                    /**
                     * Should the bottom world bounds wall be created?
                     */
                    "setBounds.bottom"?: boolean;
                    /**
                     * The number of position iterations to perform each update. The higher the value, the higher quality the simulation will be at the expense of performance.
                     */
                    positionIterations?: number;
                    /**
                     * The number of velocity iterations to perform each update. The higher the value, the higher quality the simulation will be at the expense of performance.
                     */
                    velocityIterations?: number;
                    /**
                     * The number of constraint iterations to perform each update. The higher the value, the higher quality the simulation will be at the expense of performance.
                     */
                    constraintIterations?: number;
                    /**
                     * A flag that specifies whether the engine should allow sleeping via the `Matter.Sleeping` module. Sleeping can improve stability and performance, but often at the expense of accuracy.
                     */
                    enableSleeping?: boolean;
                    /**
                     * A `Number` that specifies the current simulation-time in milliseconds starting from `0`. It is incremented on every `Engine.update` by the given `delta` argument.
                     */
                    "timing.timestamp"?: number;
                    /**
                     * A `Number` that specifies the global scaling factor of time for all bodies. A value of `0` freezes the simulation. A value of `0.1` gives a slow-motion effect. A value of `1.2` gives a speed-up effect.
                     */
                    "timing.timeScale"?: number;
                    /**
                     * Should the Matter Attractor Plugin be enabled? An attractors plugin that makes it easy to apply continual forces on bodies. It's possible to simulate effects such as wind, gravity and magnetism.
                     */
                    "plugins.attractors"?: boolean;
                    /**
                     * Should the Matter Wrap Plugin be enabled? A coordinate wrapping plugin that automatically wraps the position of bodies such that they always stay within the given bounds. Upon crossing a boundary the body will appear on the opposite side of the bounds, while maintaining its velocity.
                     */
                    "plugins.wrap"?: boolean;
                    /**
                     * Should the Matter Collision Events Plugin be enabled?
                     */
                    "plugins.collisionevents"?: boolean;
                    /**
                     * Toggles if the world is enabled or not.
                     */
                    enabled?: boolean;
                    /**
                     * An optional Number that specifies the time correction factor to apply to the update.
                     */
                    correction?: number;
                    /**
                     * This function is called every time the core game loop steps, which is bound to the Request Animation Frame frequency unless otherwise modified.
                     */
                    getDelta?: Function;
                    /**
                     * Automatically call Engine.update every time the game steps.
                     */
                    autoUpdate?: boolean;
                    /**
                     * Sets the Resolver resting threshold property.
                     */
                    restingThresh?: number;
                    /**
                     * Sets the Resolver resting threshold tangent property.
                     */
                    restingThreshTangent?: number;
                    /**
                     * Sets the Resolver position dampen property.
                     */
                    positionDampen?: number;
                    /**
                     * Sets the Resolver position warming property.
                     */
                    positionWarming?: number;
                    /**
                     * Sets the Resolver friction normal multiplier property.
                     */
                    frictionNormalMultiplier?: number;
                    /**
                     * Controls the Matter Debug Rendering options. If a boolean it will use the default values, otherwise, specify a Debug Config object.
                     */
                    debug?: boolean | Phaser.Types.Physics.Matter.MatterDebugConfig;
                    /**
                     * Sets the Matter Runner options.
                     */
                    runner?: Phaser.Types.Physics.Matter.MatterRunnerConfig;
                };

            }

        }

        namespace Plugins {
            type CorePluginContainer = {
                /**
                 * The unique name of this plugin in the core plugin cache.
                 */
                key: string;
                /**
                 * The plugin to be stored. Should be the source object, not instantiated.
                 */
                plugin: Function;
                /**
                 * If this plugin is to be injected into the Scene Systems, this is the property key map used.
                 */
                mapping?: string;
                /**
                 * Core Scene plugin or a Custom Scene plugin?
                 */
                custom?: boolean;
            };

            type CustomPluginContainer = {
                /**
                 * The unique name of this plugin in the custom plugin cache.
                 */
                key: string;
                /**
                 * The plugin to be stored. Should be the source object, not instantiated.
                 */
                plugin: Function;
            };

            type GlobalPlugin = {
                /**
                 * The unique name of this plugin within the plugin cache.
                 */
                key: string;
                /**
                 * An instance of the plugin.
                 */
                plugin: Function;
                /**
                 * Is the plugin active or not?
                 */
                active?: boolean;
                /**
                 * If this plugin is to be injected into the Scene Systems, this is the property key map used.
                 */
                mapping?: string;
            };

        }

        namespace Renderer {
            namespace Snapshot {
                type SnapshotCallback = (snapshot: Phaser.Display.Color | HTMLImageElement)=>void;

                type SnapshotState = {
                    /**
                     * The function to call after the snapshot is taken.
                     */
                    callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback;
                    /**
                     * The format of the image to create, usually `image/png` or `image/jpeg`.
                     */
                    type?: string;
                    /**
                     * The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`.
                     */
                    encoderOptions?: number;
                    /**
                     * The x coordinate to start the snapshot from.
                     */
                    x?: number;
                    /**
                     * The y coordinate to start the snapshot from.
                     */
                    y?: number;
                    /**
                     * The width of the snapshot.
                     */
                    width?: number;
                    /**
                     * The height of the snapshot.
                     */
                    height?: number;
                    /**
                     * Is this a snapshot to get a single pixel, or an area?
                     */
                    getPixel?: boolean;
                    /**
                     * Is this snapshot grabbing from a frame buffer or a canvas?
                     */
                    isFramebuffer?: boolean;
                    /**
                     * The width of the frame buffer, if a frame buffer grab.
                     */
                    bufferWidth?: number;
                    /**
                     * The height of the frame buffer, if a frame buffer grab.
                     */
                    bufferHeight?: number;
                };

            }

            namespace WebGL {
                type RenderTargetConfig = {
                    /**
                     * A value between 0 and 1. Controls the size of this Render Target in relation to the Renderer. A value of 1 matches it. 0.5 makes the Render Target half the size of the renderer, etc.
                     */
                    scale?: number;
                    /**
                     * The minFilter mode of the texture. 0 is `LINEAR`, 1 is `NEAREST`.
                     */
                    minFilter?: number;
                    /**
                     * Controls if this Render Target is automatically cleared (via `gl.COLOR_BUFFER_BIT`) during the bind.
                     */
                    autoClear?: boolean;
                    /**
                     * The width of the Render Target. This is optional. If given it overrides the `scale` property.
                     */
                    width?: number;
                    /**
                     * The height of the Render Target. This is optional. If not given, it will be set to the same as the `width` value.
                     */
                    height?: number;
                };

                type WebGLConst = {
                    /**
                     * The data type of the attribute, i.e. `gl.BYTE`, `gl.SHORT`, `gl.UNSIGNED_BYTE`, `gl.FLOAT`, etc.
                     */
                    enum: GLenum;
                    /**
                     * The size, in bytes, of the data type.
                     */
                    size: number;
                };

                type WebGLPipelineAttribute = {
                    /**
                     * The name of the attribute as defined in the vertex shader.
                     */
                    name: string;
                    /**
                     * The number of components in the attribute, i.e. 1 for a float, 2 for a vec2, 3 for a vec3, etc.
                     */
                    size: number;
                    /**
                     * The data type of the attribute. Either `gl.BYTE`, `gl.SHORT`, `gl.UNSIGNED_BYTE`, `gl.UNSIGNED_SHORT` or `gl.FLOAT`.
                     */
                    type: GLenum;
                    /**
                     * The offset, in bytes, of this attribute data in the vertex array. Equivalent to `offsetof(vertex, attrib)` in C.
                     */
                    offset: number;
                    /**
                     * Should the attribute data be normalized?
                     */
                    normalized: boolean;
                    /**
                     * You should set this to `false` by default. The pipeline will enable it on boot.
                     */
                    enabled: boolean;
                    /**
                     * You should set this to `-1` by default. The pipeline will set it on boot.
                     */
                    location: number;
                };

                type WebGLPipelineAttributeConfig = {
                    /**
                     * The name of the attribute as defined in the vertex shader.
                     */
                    name: string;
                    /**
                     * The number of components in the attribute, i.e. 1 for a float, 2 for a vec2, 3 for a vec3, etc.
                     */
                    size: number;
                    /**
                     * The data type of the attribute, one of the `WEBGL_CONST` values, i.e. `WEBGL_CONST.FLOAT`, `WEBGL_CONST.UNSIGNED_BYTE`, etc.
                     */
                    type: Phaser.Types.Renderer.WebGL.WebGLConst;
                    /**
                     * Should the attribute data be normalized?
                     */
                    normalized?: boolean;
                };

                type WebGLPipelineBatchEntry = {
                    /**
                     * The vertext count this batch entry starts from.
                     */
                    start: number;
                    /**
                     * The total number of vertices in this batch entry.
                     */
                    count: number;
                    /**
                     * The current texture unit of the batch entry.
                     */
                    unit: number;
                    /**
                     * The maximum number of texture units in this batch entry.
                     */
                    maxUnit: number;
                    /**
                     * An array of WebGLTexture references used in this batch entry.
                     */
                    texture: WebGLTexture[];
                };

                type WebGLPipelineConfig = {
                    /**
                     * The Phaser.Game instance that owns this pipeline.
                     */
                    game: Phaser.Game;
                    /**
                     * The name of the pipeline.
                     */
                    name?: string;
                    /**
                     * How the primitives are rendered. The default value is GL_TRIANGLES. Here is the full list of rendering primitives: (https://developer.mozilla.org/en-US/docs/Web/API/WebGL_API/Constants).
                     */
                    topology?: GLenum;
                    /**
                     * The source code, as a string, for the vertex shader. If you need to assign multiple shaders, see the `shaders` property.
                     */
                    vertShader?: string;
                    /**
                     * The source code, as a string, for the fragment shader. Can include `%count%` and `%forloop%` declarations for multi-texture support. If you need to assign multiple shaders, see the `shaders` property.
                     */
                    fragShader?: string;
                    /**
                     * The number of quads to hold in the batch. Defaults to `RenderConfig.batchSize`. This amount * 6 gives the vertex capacity.
                     */
                    batchSize?: number;
                    /**
                     * The size, in bytes, of a single entry in the vertex buffer. Defaults to Float32Array.BYTES_PER_ELEMENT * 6 + Uint8Array.BYTES_PER_ELEMENT * 4.
                     */
                    vertexSize?: number;
                    /**
                     * An optional Array or Typed Array of pre-calculated vertices data that is copied into the vertex data.
                     */
                    vertices?: number[] | Float32Array;
                    /**
                     * An array of shader attribute data. All shaders bound to this pipeline must use the same attributes.
                     */
                    attributes?: Phaser.Types.Renderer.WebGL.WebGLPipelineAttributeConfig[];
                    /**
                     * An array of shaders, all of which are created for this one pipeline. Uses the `vertShader`, `fragShader`, `attributes` and `uniforms` properties of this object as defaults.
                     */
                    shaders?: Phaser.Types.Renderer.WebGL.WebGLPipelineShaderConfig[];
                    /**
                     * Force the shader to use just a single sampler2d? Set for anything that extends the Single Pipeline.
                     */
                    forceZero?: boolean;
                    /**
                     * Create Render Targets for this pipeline. Can be a number, which determines the quantity, a boolean (sets quantity to 1), or an array of Render Target configuration objects.
                     */
                    renderTarget?: boolean | number | Phaser.Types.Renderer.WebGL.RenderTargetConfig[];
                };

                type WebGLPipelineShaderConfig = {
                    /**
                     * The name of the shader. Doesn't have to be unique, but makes shader look-up easier if it is.
                     */
                    name?: string;
                    /**
                     * The source code, as a string, for the vertex shader. If not given, uses the `Phaser.Types.Renderer.WebGL.WebGLPipelineConfig.vertShader` property instead.
                     */
                    vertShader?: string;
                    /**
                     * The source code, as a string, for the fragment shader. Can include `%count%` and `%forloop%` declarations for multi-texture support. If not given, uses the `Phaser.Types.Renderer.WebGL.WebGLPipelineConfig.fragShader` property instead.
                     */
                    fragShader?: string;
                    /**
                     * An array of shader attribute data. All shaders bound to this pipeline must use the same attributes.
                     */
                    attributes?: Phaser.Types.Renderer.WebGL.WebGLPipelineAttributeConfig[];
                };

                type WebGLPipelineUniformsConfig = {
                    /**
                     * The name of the uniform as defined in the shader.
                     */
                    name: string;
                    /**
                     * The location of the uniform.
                     */
                    location: number;
                    /**
                     * The first cached value of the uniform.
                     */
                    value1?: number;
                    /**
                     * The first cached value of the uniform.
                     */
                    value2?: number;
                    /**
                     * The first cached value of the uniform.
                     */
                    value3?: number;
                    /**
                     * The first cached value of the uniform.
                     */
                    value4?: number;
                };

                type WebGLTextureCompression = {
                    /**
                     * Indicates if ASTC compression is supported (mostly iOS).
                     */
                    ASTC: object | undefined;
                    /**
                     * Indicates if ATC compression is supported.
                     */
                    ATC: object | undefined;
                    /**
                     * Indicates if BPTC compression is supported.
                     */
                    BPTC: object | undefined;
                    /**
                     * Indicates if ETC compression is supported (mostly Android).
                     */
                    ETC: object | undefined;
                    /**
                     * Indicates if ETC1 compression is supported (mostly Android).
                     */
                    ETC1: object | undefined;
                    /**
                     * Indicates the browser supports true color images (all browsers).
                     */
                    IMG: object | undefined;
                    /**
                     * Indicates if PVRTC compression is supported (mostly iOS).
                     */
                    PVRTC: object | undefined;
                    /**
                     * Indicates if RGTC compression is supported (mostly iOS).
                     */
                    RGTC: object | undefined;
                    /**
                     * Indicates if S3TC compression is supported on current device (mostly Windows).
                     */
                    S3TC: object | undefined;
                    /**
                     * Indicates if S3TCRGB compression is supported on current device (mostly Windows).
                     */
                    S3TCRGB: object | undefined;
                };

            }

        }

        namespace Scenes {
            type CreateSceneFromObjectConfig = {
                /**
                 * The scene's init callback.
                 */
                init?: Phaser.Types.Scenes.SceneInitCallback;
                /**
                 * The scene's preload callback.
                 */
                preload?: Phaser.Types.Scenes.ScenePreloadCallback;
                /**
                 * The scene's create callback.
                 */
                create?: Phaser.Types.Scenes.SceneCreateCallback;
                /**
                 * The scene's update callback. See {@link Phaser.Scene#update}.
                 */
                update?: Phaser.Types.Scenes.SceneUpdateCallback;
                /**
                 * Any additional properties, which will be copied to the Scene after it's created (except `data` or `sys`).
                 */
                extend?: any;
                /**
                 * Any values, which will be merged into the Scene's Data Manager store.
                 */
                "extend.data"?: any;
            };

            /**
             * Can be defined on your own Scenes. Use it to create your game objects.
             * This method is called by the Scene Manager when the scene starts, after `init()` and `preload()`.
             * If the LoaderPlugin started after `preload()`, then this method is called only after loading is complete.
             */
            type SceneCreateCallback = (this: Phaser.Scene, data: object)=>void;

            /**
             * Can be defined on your own Scenes.
             * This method is called by the Scene Manager when the scene starts, before `preload()` and `create()`.
             */
            type SceneInitCallback = (this: Phaser.Scene, data: object)=>void;

            /**
             * Can be defined on your own Scenes. Use it to load assets.
             * This method is called by the Scene Manager, after `init()` and before `create()`, only if the Scene has a LoaderPlugin.
             * After this method completes, if the LoaderPlugin's queue isn't empty, the LoaderPlugin will start automatically.
             */
            type ScenePreloadCallback = (this: Phaser.Scene)=>void;

            type SceneTransitionConfig = {
                /**
                 * The Scene key to transition to.
                 */
                target: string;
                /**
                 * The duration, in ms, for the transition to last.
                 */
                duration?: number;
                /**
                 * Will the Scene responsible for the transition be sent to sleep on completion (`true`), or stopped? (`false`)
                 */
                sleep?: boolean;
                /**
                 * Will the Scene responsible for the transition be removed from the Scene Manager after the transition completes?
                 */
                remove?: boolean;
                /**
                 * Will the Scenes Input system be able to process events while it is transitioning in or out?
                 */
                allowInput?: boolean;
                /**
                 * Move the target Scene to be above this one before the transition starts.
                 */
                moveAbove?: boolean;
                /**
                 * Move the target Scene to be below this one before the transition starts.
                 */
                moveBelow?: boolean;
                /**
                 * This callback is invoked every frame for the duration of the transition.
                 */
                onUpdate?: Function;
                /**
                 * The context in which the callback is invoked.
                 */
                onUpdateScope?: any;
                /**
                 * This callback is invoked when transition starting.
                 */
                onStart?: Phaser.Types.Scenes.SceneTransitionOnStartCallback;
                /**
                 * The context in which the callback is invoked.
                 */
                onStartScope?: any;
                /**
                 * An object containing any data you wish to be passed to the target scene's init / create methods (if sleep is false) or to the target scene's wake event callback (if sleep is true).
                 */
                data?: any;
            };

            type SceneTransitionOnStartCallback = (this: Phaser.Scene, fromScene: Phaser.Scene, toScene: Phaser.Scene)=>void;

            type SceneType = Phaser.Scene | Phaser.Types.Scenes.SettingsConfig | Phaser.Types.Scenes.CreateSceneFromObjectConfig | Function;

            type SceneUpdateCallback = (this: Phaser.Scene, time: number, delta: number)=>void;

            type SettingsConfig = {
                /**
                 * The unique key of this Scene. Must be unique within the entire Game instance.
                 */
                key?: string;
                /**
                 * Does the Scene start as active or not? An active Scene updates each step.
                 */
                active?: boolean;
                /**
                 * Does the Scene start as visible or not? A visible Scene renders each step.
                 */
                visible?: boolean;
                /**
                 * Files to be loaded before the Scene begins.
                 */
                pack?: false | Phaser.Types.Loader.FileTypes.PackFileSection;
                /**
                 * An optional Camera configuration object.
                 */
                cameras?: Phaser.Types.Cameras.Scene2D.CameraConfig | Phaser.Types.Cameras.Scene2D.CameraConfig[] | null;
                /**
                 * Overwrites the default injection map for a scene.
                 */
                map?: {[key: string]:  string};
                /**
                 * Extends the injection map for a scene.
                 */
                mapAdd?: {[key: string]:  string};
                /**
                 * The physics configuration object for the Scene.
                 */
                physics?: Phaser.Types.Core.PhysicsConfig;
                /**
                 * The loader configuration object for the Scene.
                 */
                loader?: Phaser.Types.Core.LoaderConfig;
                /**
                 * The plugin configuration object for the Scene.
                 */
                plugins?: false | any;
            };

            type SettingsObject = {
                /**
                 * The current status of the Scene. Maps to the Scene constants.
                 */
                status: number;
                /**
                 * The unique key of this Scene. Unique within the entire Game instance.
                 */
                key: string;
                /**
                 * The active state of this Scene. An active Scene updates each step.
                 */
                active: boolean;
                /**
                 * The visible state of this Scene. A visible Scene renders each step.
                 */
                visible: boolean;
                /**
                 * Has the Scene finished booting?
                 */
                isBooted: boolean;
                /**
                 * Is the Scene in a state of transition?
                 */
                isTransition: boolean;
                /**
                 * The Scene this Scene is transitioning from, if set.
                 */
                transitionFrom: Phaser.Scene | null;
                /**
                 * The duration of the transition, if set.
                 */
                transitionDuration: number;
                /**
                 * Is this Scene allowed to receive input during transitions?
                 */
                transitionAllowInput: boolean;
                /**
                 * a data bundle passed to this Scene from the Scene Manager.
                 */
                data: object;
                /**
                 * Files to be loaded before the Scene begins.
                 */
                pack: false | Phaser.Types.Loader.FileTypes.PackFileSection;
                /**
                 * The Camera configuration object.
                 */
                cameras: Phaser.Types.Cameras.Scene2D.CameraConfig | Phaser.Types.Cameras.Scene2D.CameraConfig[] | null;
                /**
                 * The Scene's Injection Map.
                 */
                map: {[key: string]:  string};
                /**
                 * The physics configuration object for the Scene.
                 */
                physics: Phaser.Types.Core.PhysicsConfig;
                /**
                 * The loader configuration object for the Scene.
                 */
                loader: Phaser.Types.Core.LoaderConfig;
                /**
                 * The plugin configuration object for the Scene.
                 */
                plugins: false | any;
            };

        }

        namespace Sound {
            /**
             * Audio sprite sound type.
             */
            type AudioSpriteSound = {
                /**
                 * Local reference to 'spritemap' object form json file generated by audiosprite tool.
                 */
                spritemap: object;
            };

            /**
             * A Audio Data object.
             * 
             * You can pass an array of these objects to the WebAudioSoundManager `decodeAudio` method to have it decode
             * them all at once.
             */
            type DecodeAudioConfig = {
                /**
                 * The string-based key to be used to reference the decoded audio in the audio cache.
                 */
                key: string;
                /**
                 * The audio data, either a base64 encoded string, an audio media-type data uri, or an ArrayBuffer instance.
                 */
                data: ArrayBuffer | string;
            };

            type EachActiveSoundCallback = (manager: Phaser.Sound.BaseSoundManager, sound: Phaser.Sound.BaseSound, index: number, sounds: Phaser.Sound.BaseSound[])=>void;

            /**
             * Config object containing various sound settings.
             */
            type SoundConfig = {
                /**
                 * Boolean indicating whether the sound should be muted or not.
                 */
                mute?: boolean;
                /**
                 * A value between 0 (silence) and 1 (full volume).
                 */
                volume?: number;
                /**
                 * Defines the speed at which the sound should be played.
                 */
                rate?: number;
                /**
                 * Represents detuning of sound in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
                 */
                detune?: number;
                /**
                 * Position of playback for this sound, in seconds.
                 */
                seek?: number;
                /**
                 * Whether or not the sound or current sound marker should loop.
                 */
                loop?: boolean;
                /**
                 * Time, in seconds, that should elapse before the sound actually starts its playback.
                 */
                delay?: number;
                /**
                 * A value between -1 (full left pan) and 1 (full right pan). 0 means no pan.
                 */
                pan?: number;
                /**
                 * An optional config object containing default spatial sound settings.
                 */
                source?: Phaser.Types.Sound.SpatialSoundConfig;
            };

            /**
             * Marked section of a sound represented by name, and optionally start time, duration, and config object.
             */
            type SoundMarker = {
                /**
                 * Unique identifier of a sound marker.
                 */
                name: string;
                /**
                 * Sound position offset at witch playback should start.
                 */
                start?: number;
                /**
                 * Playback duration of this marker.
                 */
                duration?: number;
                /**
                 * An optional config object containing default marker settings.
                 */
                config?: Phaser.Types.Sound.SoundConfig;
            };

            /**
             * Config object containing settings for the source of the spatial sound.
             * 
             * See https://developer.mozilla.org/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialization_basics
             */
            type SpatialSoundConfig = {
                /**
                 * The horizontal position of the audio in a right-hand Cartesian coordinate system.
                 */
                x?: number;
                /**
                 * The vertical position of the audio in a right-hand Cartesian coordinate system.
                 */
                y?: number;
                /**
                 * Represents the longitudinal (back and forth) position of the audio in a right-hand Cartesian coordinate system.
                 */
                z?: number;
                /**
                 * An enumerated value determining which spatialization algorithm to use to position the audio in 3D space.
                 */
                panningModel?: 'equalpower' | 'HRTF';
                /**
                 * Which algorithm to use to reduce the volume of the audio source as it moves away from the listener. Possible values are "linear", "inverse" and "exponential". The default value is "inverse".
                 */
                distanceModel?: 'linear' | 'inverse' | 'exponential';
                /**
                 * The horizontal position of the audio source's vector in a right-hand Cartesian coordinate system.
                 */
                orientationX?: number;
                /**
                 * The vertical position of the audio source's vector in a right-hand Cartesian coordinate system.
                 */
                orientationY?: number;
                /**
                 * Represents the longitudinal (back and forth) position of the audio source's vector in a right-hand Cartesian coordinate system.
                 */
                orientationZ?: number;
                /**
                 * A double value representing the reference distance for reducing volume as the audio source moves further from the listener. For distances greater than this the volume will be reduced based on `rolloffFactor` and `distanceModel`.
                 */
                refDistance?: number;
                /**
                 * The maximum distance between the audio source and the listener, after which the volume is not reduced any further.
                 */
                maxDistance?: number;
                /**
                 * A double value describing how quickly the volume is reduced as the source moves away from the listener. This value is used by all distance models.
                 */
                rolloffFactor?: number;
                /**
                 * The angle, in degrees, of a cone inside of which there will be no volume reduction.
                 */
                coneInnerAngle?: number;
                /**
                 * The angle, in degrees, of a cone outside of which the volume will be reduced by a constant value, defined by the `coneOuterGain` property.
                 */
                coneOuterAngle?: number;
                /**
                 * The amount of volume reduction outside the cone defined by the `coneOuterAngle` attribute. Its default value is 0, meaning that no sound can be heard. A value between 0 and 1.
                 */
                coneOuterGain?: number;
                /**
                 * Set this Sound object to automatically track the x/y position of this object. Can be a Phaser Game Object, Vec2 or anything that exposes public x/y properties.
                 */
                follow?: Phaser.Types.Math.Vector2Like;
            };

            /**
             * An entry in the Web Audio Decoding Queue.
             */
            type WebAudioDecodeEntry = {
                /**
                 * The key of the sound.
                 */
                key: string;
                /**
                 * The callback to invoke on successful decoding.
                 */
                success: Function;
                /**
                 * The callback to invoke if the decoding fails.
                 */
                failure: Function;
                /**
                 * Has the decoding of this sound file started?
                 */
                decoding: boolean;
            };

        }

        namespace Textures {
            /**
             * An object containing the dimensions and mipmap data for a Compressed Texture.
             */
            type CompressedTextureData = {
                /**
                 * Is this a compressed texture?
                 */
                compressed: boolean;
                /**
                 * Should this texture have mipmaps generated?
                 */
                generateMipmap: boolean;
                /**
                 * The width of the maximum size of the texture.
                 */
                width: number;
                /**
                 * The height of the maximum size of the texture.
                 */
                height: number;
                /**
                 * The WebGL internal texture format.
                 */
                internalFormat: GLenum;
                /**
                 * An array of MipmapType objects.
                 */
                mipmaps: Phaser.Types.Textures.MipmapType[];
            };

            /**
             * A Mipmap Data entry for a Compressed Texture.
             */
            type MipmapType = {
                /**
                 * The width of this level of the mipmap.
                 */
                width: number;
                /**
                 * The height of this level of the mipmap.
                 */
                height: number;
                /**
                 * The decoded pixel data.
                 */
                data: Uint8Array;
            };

            /**
             * An object containing the position and color data for a single pixel in a CanvasTexture.
             */
            type PixelConfig = {
                /**
                 * The x-coordinate of the pixel.
                 */
                x: number;
                /**
                 * The y-coordinate of the pixel.
                 */
                y: number;
                /**
                 * The color of the pixel, not including the alpha channel.
                 */
                color: number;
                /**
                 * The alpha of the pixel, between 0 and 1.
                 */
                alpha: number;
            };

            type SpriteSheetConfig = {
                /**
                 * The fixed width of each frame.
                 */
                frameWidth: number;
                /**
                 * The fixed height of each frame. If not set it will use the frameWidth as the height.
                 */
                frameHeight?: number;
                /**
                 * Skip a number of frames. Useful when there are multiple sprite sheets in one Texture.
                 */
                startFrame?: number;
                /**
                 * The total number of frames to extract from the Sprite Sheet. The default value of -1 means "extract all frames".
                 */
                endFrame?: number;
                /**
                 * If the frames have been drawn with a margin, specify the amount here.
                 */
                margin?: number;
                /**
                 * If the frames have been drawn with spacing between them, specify the amount here.
                 */
                spacing?: number;
            };

            type SpriteSheetFromAtlasConfig = {
                /**
                 * The key of the Texture Atlas in which this Sprite Sheet can be found.
                 */
                atlas: string;
                /**
                 * The key of the Texture Atlas Frame in which this Sprite Sheet can be found.
                 */
                frame: string;
                /**
                 * The fixed width of each frame.
                 */
                frameWidth: number;
                /**
                 * The fixed height of each frame. If not set it will use the frameWidth as the height.
                 */
                frameHeight?: number;
                /**
                 * Skip a number of frames. Useful when there are multiple sprite sheets in one Texture.
                 */
                startFrame?: number;
                /**
                 * The total number of frames to extract from the Sprite Sheet. The default value of -1 means "extract all frames".
                 */
                endFrame?: number;
                /**
                 * If the frames have been drawn with a margin, specify the amount here.
                 */
                margin?: number;
                /**
                 * If the frames have been drawn with spacing between them, specify the amount here.
                 */
                spacing?: number;
            };

            /**
             * An object containing the position and color data for a single pixel in a CanvasTexture.
             */
            type StampConfig = {
                /**
                 * The alpha value used by the stamp.
                 */
                alpha?: number;
                /**
                 * The tint color value used by the stamp. WebGL only.
                 */
                tint?: number;
                /**
                 * The angle of the stamp in degrees. Rotation takes place around its origin.
                 */
                angle?: number;
                /**
                 * The rotation of the stamp in radians. Rotation takes place around its origin.
                 */
                rotation?: number;
                /**
                 * Sets both the horizontal and vertical scale of the stamp with a single value.
                 */
                scale?: number;
                /**
                 * Set the horizontal scale of the stamp. Overrides the scale property, if provided.
                 */
                scaleX?: number;
                /**
                 * Set the vertical scale of the stamp. Overrides the scale property, if provided.
                 */
                scaleY?: number;
                /**
                 * The horizontal origin of the stamp. 0 is the left, 0.5 is the center and 1 is the right.
                 */
                originX?: number;
                /**
                 * The vertical origin of the stamp. 0 is the top, 0.5 is the center and 1 is the bottom.
                 */
                originY?: number;
                /**
                 * The blend mode used when drawing the stamp. Defaults to 0 (normal).
                 */
                blendMode?: string | Phaser.BlendModes | number;
                /**
                 * Erase this stamp from the texture?
                 */
                erase?: boolean;
                /**
                 * Skip beginning and ending a batch with this call. Use if this is part of a bigger batched draw.
                 */
                skipBatch?: boolean;
            };

        }

        namespace Tilemaps {
            type CreateFromObjectLayerConfig = {
                /**
                 * A unique Object ID to convert.
                 */
                id?: number;
                /**
                 * An Object GID to convert.
                 */
                gid?: number;
                /**
                 * An Object Name to convert.
                 */
                name?: string;
                /**
                 * An Object Type to convert.
                 */
                type?: string;
                /**
                 * A custom class type to convert the objects in to. The default is {@link Phaser.GameObjects.Sprite}. A custom class should resemble Sprite or Image; see {@link Phaser.Types.Tilemaps.CreateFromObjectsClassTypeConstructor}.
                 */
                classType?: Function;
                /**
                 * By default, gid-based objects copy properties and respect the type of the tile at that gid and treat the object as an override. If this is true, they don't, and use only the fields set on the object itself.
                 */
                ignoreTileset?: boolean;
                /**
                 * A Scene reference, passed to the Game Objects constructors.
                 */
                scene?: Phaser.Scene;
                /**
                 * Optional Container to which the Game Objects are added.
                 */
                container?: Phaser.GameObjects.Container;
                /**
                 * Optional key of a Texture to be used, as stored in the Texture Manager, or a Texture instance. If omitted, the object's gid's tileset key is used if available.
                 */
                key?: string | Phaser.Textures.Texture;
                /**
                 * Optional name or index of the frame within the Texture. If omitted, the tileset index is used, assuming that spritesheet frames exactly match tileset indices & geometries -- if available.
                 */
                frame?: string | number;
            };

            type CreateFromObjectsClassTypeConstructor = (scene: Phaser.Scene)=>void;

            type DebugStyleOptions = {
                /**
                 * Color to use for drawing a filled rectangle at
                 * non-colliding tile locations. If set to null, non-colliding tiles will not be drawn.
                 */
                "styleConfig.tileColor"?: Phaser.Display.Color | null;
                /**
                 * Color to use for drawing a filled
                 * rectangle at colliding tile locations. If set to null, colliding tiles will not be drawn.
                 */
                "styleConfig.collidingTileColor"?: Phaser.Display.Color | null;
                /**
                 * Color to use for drawing a line at interesting
                 * tile faces. If set to null, interesting tile faces will not be drawn.
                 */
                "styleConfig.faceColor"?: Phaser.Display.Color | null;
            };

            type FilteringOptions = {
                /**
                 * If true, only return tiles that don't have -1 for an index.
                 */
                isNotEmpty?: boolean;
                /**
                 * If true, only return tiles that collide on at least one side.
                 */
                isColliding?: boolean;
                /**
                 * If true, only return tiles that have at least one interesting face.
                 */
                hasInterestingFace?: boolean;
            };

            type GIDData = {
                /**
                 * The Tiled GID.
                 */
                gid: number;
                /**
                 * Horizontal flip flag.
                 */
                flippedHorizontal: boolean;
                /**
                 * Vertical flip flag.
                 */
                flippedVertical: boolean;
                /**
                 * Diagonal flip flag.
                 */
                flippedAntiDiagonal: boolean;
                /**
                 * Amount of rotation.
                 */
                rotation: number;
                /**
                 * Is flipped?
                 */
                flipped: boolean;
            };

            type LayerDataConfig = {
                /**
                 * The name of the layer, if specified in Tiled.
                 */
                name?: string;
                /**
                 * The x offset of where to draw from the top left.
                 */
                x?: number;
                /**
                 * The y offset of where to draw from the top left.
                 */
                y?: number;
                /**
                 * The width of the layer in tiles.
                 */
                width?: number;
                /**
                 * The height of the layer in tiles.
                 */
                height?: number;
                /**
                 * The pixel width of the tiles.
                 */
                tileWidth?: number;
                /**
                 * The pixel height of the tiles.
                 */
                tileHeight?: number;
                /**
                 * The base tile width.
                 */
                baseTileWidth?: number;
                /**
                 * The base tile height.
                 */
                baseTileHeight?: number;
                /**
                 * The width in pixels of the entire layer.
                 */
                widthInPixels?: number;
                /**
                 * The height in pixels of the entire layer.
                 */
                heightInPixels?: number;
                /**
                 * The alpha value of the layer.
                 */
                alpha?: number;
                /**
                 * Is the layer visible or not?
                 */
                visible?: boolean;
                /**
                 * Layer specific properties (can be specified in Tiled)
                 */
                properties?: object[];
                /**
                 * Tile ID index map.
                 */
                indexes?: any[];
                /**
                 * Tile Collision ID index map.
                 */
                collideIndexes?: any[];
                /**
                 * An array of callbacks.
                 */
                callbacks?: any[];
                /**
                 * An array of physics bodies.
                 */
                bodies?: any[];
                /**
                 * An array of the tile data indexes.
                 */
                data?: any[];
                /**
                 * A reference to the Tilemap layer that owns this data.
                 */
                tilemapLayer?: Phaser.Tilemaps.TilemapLayer;
            };

            type MapDataConfig = {
                /**
                 * The key in the Phaser cache that corresponds to the loaded tilemap data.
                 */
                name?: string;
                /**
                 * The width of the entire tilemap.
                 */
                width?: number;
                /**
                 * The height of the entire tilemap.
                 */
                height?: number;
                /**
                 * The width of the tiles.
                 */
                tileWidth?: number;
                /**
                 * The height of the tiles.
                 */
                tileHeight?: number;
                /**
                 * The width in pixels of the entire tilemap.
                 */
                widthInPixels?: number;
                /**
                 * The height in pixels of the entire tilemap.
                 */
                heightInPixels?: number;
                /**
                 * The format of the Tilemap, as defined in Tiled.
                 */
                format?: number;
                /**
                 * The orientation of the map data (i.e. orthogonal, isometric, hexagonal), default 'orthogonal'.
                 */
                orientation?: string | Phaser.Tilemaps.Orientation;
                /**
                 * Determines the draw order of tilemap. Default is right-down.
                 */
                renderOrder?: string;
                /**
                 * The version of Tiled the map uses.
                 */
                version?: number;
                /**
                 * Map specific properties (can be specified in Tiled).
                 */
                properties?: number;
                /**
                 * The layers of the tilemap.
                 */
                layers?: Phaser.Tilemaps.LayerData[];
                /**
                 * An array with all the layers configured to the MapData.
                 */
                images?: any[];
                /**
                 * An array of Tiled Image Layers.
                 */
                objects?: object;
                /**
                 * An object of Tiled Object Layers.
                 */
                collision?: object;
                /**
                 * The tilesets the map uses.
                 */
                tilesets?: Phaser.Tilemaps.Tileset[];
                /**
                 * The collection of images the map uses(specified in Tiled).
                 */
                imageCollections?: any[];
                /**
                 * Array of Tile instances.
                 */
                tiles?: any[];
            };

            type ObjectLayerConfig = {
                /**
                 * The name of the Object Layer.
                 */
                name?: string;
                /**
                 * The opacity of the layer, between 0 and 1.
                 */
                opacity?: number;
                /**
                 * The custom properties defined on the Object Layer, keyed by their name.
                 */
                properties?: any;
                /**
                 * The type of each custom property defined on the Object Layer, keyed by its name.
                 */
                propertytypes?: any;
                /**
                 * The type of the layer, which should be `objectgroup`.
                 */
                type?: string;
                /**
                 * Whether the layer is shown (`true`) or hidden (`false`).
                 */
                visible?: boolean;
                /**
                 * An array of all objects on this Object Layer.
                 */
                objects?: any[];
            };

            type StyleConfig = {
                /**
                 * Color to use for drawing a filled rectangle at non-colliding tile locations. If set to null, non-colliding tiles will not be drawn.
                 */
                tileColor?: Phaser.Display.Color | number | null | null;
                /**
                 * Color to use for drawing a filled rectangle at colliding tile locations. If set to null, colliding tiles will not be drawn.
                 */
                collidingTileColor?: Phaser.Display.Color | number | null | null;
                /**
                 * Color to use for drawing a line at interesting tile faces. If set to null, interesting tile faces will not be drawn.
                 */
                faceColor?: Phaser.Display.Color | number | null | null;
            };

            type TiledObject = {
                /**
                 * The unique object ID.
                 */
                id: number;
                /**
                 * The name this object was assigned in Tiled.
                 */
                name: string;
                /**
                 * The string type of this instance, as assigned in Tiled. Tiled supports inheriting instance types from tilesets; in that case, the type will be set in the tile's data, but will be `''` here; use the `gid` to fetch the tile data or properties.
                 */
                type: string;
                /**
                 * The visible state of this object.
                 */
                visible?: boolean;
                /**
                 * The horizontal position of this object, in pixels, relative to the tilemap.
                 */
                x?: number;
                /**
                 * The vertical position of this object, in pixels, relative to the tilemap.
                 */
                y?: number;
                /**
                 * The width of this object, in pixels.
                 */
                width?: number;
                /**
                 * The height of this object, in pixels.
                 */
                height?: number;
                /**
                 * The rotation of the object in clockwise degrees.
                 */
                rotation?: number;
                /**
                 * Custom properties object.
                 */
                properties?: any;
                /**
                 * Only set if of type 'tile'.
                 */
                gid?: number;
                /**
                 * Only set if a tile object. The horizontal flip value.
                 */
                flippedHorizontal?: boolean;
                /**
                 * Only set if a tile object. The vertical flip value.
                 */
                flippedVertical?: boolean;
                /**
                 * Only set if a tile object. The diagonal flip value.
                 */
                flippedAntiDiagonal?: boolean;
                /**
                 * Only set if a polyline object. An array of objects corresponding to points, where each point has an `x` property and a `y` property.
                 */
                polyline?: Phaser.Types.Math.Vector2Like[];
                /**
                 * Only set if a polygon object. An array of objects corresponding to points, where each point has an `x` property and a `y` property.
                 */
                polygon?: Phaser.Types.Math.Vector2Like[];
                /**
                 * Only set if a text object. Contains the text objects properties.
                 */
                text?: any;
                /**
                 * Only set, and set to `true`, if a rectangle object.
                 */
                rectangle?: boolean;
                /**
                 * Only set, and set to `true`, if a ellipse object.
                 */
                ellipse?: boolean;
                /**
                 * Only set, and set to `true`, if a point object.
                 */
                point?: boolean;
            };

            type TilemapConfig = {
                /**
                 * The key in the Phaser cache that corresponds to the loaded tilemap data.
                 */
                key?: string;
                /**
                 * Instead of loading from the cache, you can also load directly from a 2D array of tile indexes.
                 */
                data?: number[][];
                /**
                 * The width of a tile in pixels.
                 */
                tileWidth?: number;
                /**
                 * The height of a tile in pixels.
                 */
                tileHeight?: number;
                /**
                 * The width of the map in tiles.
                 */
                width?: number;
                /**
                 * The height of the map in tiles.
                 */
                height?: number;
                /**
                 * Controls how empty tiles, tiles with an index of -1,
                 * in the map data are handled. If `true`, empty locations will get a value of `null`. If `false`,
                 * empty location will get a Tile object with an index of -1. If you've a large sparsely populated
                 * map and the tile data doesn't need to change then setting this value to `true` will help with
                 * memory consumption. However if your map is small or you need to update the tiles dynamically,
                 * then leave the default value set.
                 */
                insertNull?: boolean;
            };

        }

        namespace Time {
            type TimelineEvent = {
                /**
                 * Has this event completed yet?
                 */
                complete: boolean;
                /**
                 * Is this a once only event?
                 */
                once: boolean;
                /**
                 * The time (in elapsed ms) at which this event will fire.
                 */
                time: number;
                /**
                 * User-land callback which will be called if set. If it returns `true` then this event run all of its actions, otherwise it will be skipped.
                 */
                if?: Function;
                /**
                 * User-land callback which will be called when the Event fires.
                 */
                run?: Function;
                /**
                 * Tween configuration object which will be used to create a Tween when the Event fires if set.
                 */
                tween?: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenChainBuilderConfig | Phaser.Tweens.Tween | Phaser.Tweens.TweenChain;
                /**
                 * Object containing properties to set on the `target` when the Event fires if set.
                 */
                set?: object;
                /**
                 * Sound configuration object which will be used to create a Sound when the Event fires if set.
                 */
                sound?: string | object;
                /**
                 * The scope (`this` object) with which to invoke the run `callback`.
                 */
                target?: any;
                /**
                 * Optional event name to emit when the Event fires.
                 */
                event?: string;
            };

            type TimelineEventConfig = {
                /**
                 * The time (in ms) at which the Event will fire. The Timeline starts at 0.
                 */
                at?: number;
                /**
                 * If the Timeline is already running, this is the time (in ms) at which the Event will fire based on its current elapsed value. If set, overrides the `at` property.
                 */
                in?: number;
                /**
                 * Fire this event 'from' milliseconds after the previous event in the Timeline. If set it overrides the `at` and `in` properties.
                 */
                from?: number;
                /**
                 * A function which will be called when the Event fires.
                 */
                run?: Function;
                /**
                 * Optional string-based event name to emit when the Event fires. The event is emitted from the Timeline instance.
                 */
                event?: string;
                /**
                 * The scope (`this` object) with which to invoke the run `callback`, if set.
                 */
                target?: any;
                /**
                 * If set, the Event will be removed from the Timeline when it fires.
                 */
                once?: boolean;
                /**
                 * If set, the Timeline will stop and enter a complete state when this Event fires, even if there are other events after it.
                 */
                stop?: boolean;
                /**
                 * A Tween or TweenChain configuration object or instance. If set, the Event will create this Tween when it fires.
                 */
                tween?: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenChainBuilderConfig | Phaser.Tweens.Tween | Phaser.Tweens.TweenChain;
                /**
                 * A key-value object of properties to set on the `target` when the Event fires. Ignored if no `target` is given.
                 */
                set?: object;
                /**
                 * A key from the Sound Manager to play, or a config object for a sound to play when the Event fires. If a config object it must provide two properties: `key` and `config`. The `key` is the key of the sound to play, and the `config` is the config is a Phaser.Types.Sound.SoundConfig object.
                 */
                sound?: string | object;
            };

            type TimerEventConfig = {
                /**
                 * The delay after which the Timer Event should fire, in milliseconds.
                 */
                delay?: number;
                /**
                 * The total number of times the Timer Event will repeat before finishing.
                 */
                repeat?: number;
                /**
                 * `true` if the Timer Event should repeat indefinitely.
                 */
                loop?: boolean;
                /**
                 * The callback which will be called when the Timer Event fires.
                 */
                callback?: Function;
                /**
                 * The scope (`this` object) with which to invoke the `callback`. The default is the Timer Event.
                 */
                callbackScope?: any;
                /**
                 * Additional arguments to be passed to the `callback`.
                 */
                args?: any[];
                /**
                 * The scale of the elapsed time.
                 */
                timeScale?: number;
                /**
                 * The initial elapsed time in milliseconds. Useful if you want a long duration with repeat, but for the first loop to fire quickly.
                 */
                startAt?: number;
                /**
                 * `true` if the Timer Event should be paused.
                 */
                paused?: boolean;
            };

        }

        namespace Tweens {
            type TweenConfigDefaults = {
                /**
                 * The object, or an array of objects, to run the tween on.
                 */
                targets: object | object[];
                /**
                 * The number of milliseconds to delay before the tween will start.
                 */
                delay?: number;
                /**
                 * The duration of the tween in milliseconds.
                 */
                duration?: number;
                /**
                 * The easing equation to use for the tween.
                 */
                ease?: string;
                /**
                 * Optional easing parameters.
                 */
                easeParams?: any[];
                /**
                 * The number of milliseconds to hold the tween for before yoyo'ing.
                 */
                hold?: number;
                /**
                 * The number of times to repeat the tween.
                 */
                repeat?: number;
                /**
                 * The number of milliseconds to pause before a tween will repeat.
                 */
                repeatDelay?: number;
                /**
                 * Should the tween complete, then reverse the values incrementally to get back to the starting tween values? The reverse tweening will also take `duration` milliseconds to complete.
                 */
                yoyo?: boolean;
                /**
                 * Horizontally flip the target of the Tween when it completes (before it yoyos, if set to do so). Only works for targets that support the `flipX` property.
                 */
                flipX?: boolean;
                /**
                 * Vertically flip the target of the Tween when it completes (before it yoyos, if set to do so). Only works for targets that support the `flipY` property.
                 */
                flipY?: boolean;
                /**
                 * Retain the tween within the Tween Manager, even after playback completes?
                 */
                persist?: boolean;
                /**
                 * The interpolation function to use for array-based tween values.
                 */
                interpolation?: Function;
            };

            /**
             * A Tween Event.
             */
            type Event = string;

            type GetActiveCallback = (target: any, key: string, value: number, targetIndex: number, totalTargets: number, tween: Phaser.Tweens.Tween)=>number;

            type GetEndCallback = (target: any, key: string, value: number, targetIndex: number, totalTargets: number, tween: Phaser.Tweens.Tween)=>number;

            type GetStartCallback = (target: any, key: string, value: number, targetIndex: number, totalTargets: number, tween: Phaser.Tweens.Tween)=>number;

            type NumberTweenBuilderConfig = {
                /**
                 * The start number.
                 */
                from?: number;
                /**
                 * The end number.
                 */
                to?: number;
                /**
                 * The number of milliseconds to delay before the counter will start.
                 */
                delay?: number;
                /**
                 * The duration of the counter in milliseconds.
                 */
                duration?: number;
                /**
                 * The easing equation to use for the counter.
                 */
                ease?: string | Function;
                /**
                 * Optional easing parameters.
                 */
                easeParams?: any[];
                /**
                 * The number of milliseconds to hold the counter for before yoyo'ing.
                 */
                hold?: number;
                /**
                 * The number of times to repeat the counter.
                 */
                repeat?: number;
                /**
                 * The number of milliseconds to pause before the counter will repeat.
                 */
                repeatDelay?: number;
                /**
                 * Should the counter play forward to the end value and then backwards to the start? The reverse playback will also take `duration` milliseconds to complete.
                 */
                yoyo?: boolean;
                /**
                 * The time the counter will wait before the onComplete event is dispatched once it has completed, in ms.
                 */
                completeDelay?: string | number | Function | object | any[];
                /**
                 * The number of times the counter will repeat. (A value of 1 means the counter will play twice, as it repeated once.)
                 */
                loop?: string | number | Function | object | any[];
                /**
                 * The time the counter will pause before starting either a yoyo or returning to the start for a repeat.
                 */
                loopDelay?: string | number | Function | object | any[];
                /**
                 * Does the counter start in a paused state (true) or playing (false)?
                 */
                paused?: boolean;
                /**
                 * Scope (this) for the callbacks. The default scope is the counter.
                 */
                callbackScope?: any;
                /**
                 * A function to call when the counter completes.
                 */
                onComplete?: Phaser.Types.Tweens.TweenOnCompleteCallback;
                /**
                 * Additional parameters to pass to `onComplete`.
                 */
                onCompleteParams?: any[];
                /**
                 * A function to call each time the counter loops.
                 */
                onLoop?: Phaser.Types.Tweens.TweenOnLoopCallback;
                /**
                 * Additional parameters to pass to `onLoop`.
                 */
                onLoopParams?: any[];
                /**
                 * A function to call each time the counter repeats.
                 */
                onRepeat?: Phaser.Types.Tweens.TweenOnRepeatCallback;
                /**
                 * Additional parameters to pass to `onRepeat`.
                 */
                onRepeatParams?: any[];
                /**
                 * A function to call when the counter starts.
                 */
                onStart?: Phaser.Types.Tweens.TweenOnStartCallback;
                /**
                 * Additional parameters to pass to `onStart`.
                 */
                onStartParams?: any[];
                /**
                 * A function to call when the counter is stopped.
                 */
                onStop?: Phaser.Types.Tweens.TweenOnStopCallback;
                /**
                 * Additional parameters to pass to `onStop`.
                 */
                onStopParams?: any[];
                /**
                 * A function to call each time the counter steps.
                 */
                onUpdate?: Phaser.Types.Tweens.TweenOnUpdateCallback;
                /**
                 * Additional parameters to pass to `onUpdate`.
                 */
                onUpdateParams?: any[];
                /**
                 * A function to call each time the counter yoyos.
                 */
                onYoyo?: Phaser.Types.Tweens.TweenOnYoyoCallback;
                /**
                 * Additional parameters to pass to `onYoyo`.
                 */
                onYoyoParams?: any[];
                /**
                 * A function to call when the counter is paused.
                 */
                onPause?: Phaser.Types.Tweens.TweenOnPauseCallback;
                /**
                 * Additional parameters to pass to `onPause`.
                 */
                onPauseParams?: any[];
                /**
                 * A function to call when the counter is resumed after being paused.
                 */
                onResume?: Phaser.Types.Tweens.TweenOnResumeCallback;
                /**
                 * Additional parameters to pass to `onResume`.
                 */
                onResumeParams?: any[];
                /**
                 * Will the counter be automatically destroyed on completion, or retained for future playback?
                 */
                persist?: boolean;
                /**
                 * The interpolation function to use if the `value` given is an array of numbers.
                 */
                interpolation?: string | Function;
            };

            type StaggerConfig = {
                /**
                 * The value to start the stagger from. Can be used as a way to offset the stagger while still using a range for the value.
                 */
                start?: number;
                /**
                 * An ease to apply across the staggered values. Can either be a string, such as 'sine.inout', or a function.
                 */
                ease?: string | Function;
                /**
                 * The index to start the stagger from. Can be the strings `first`, `last` or `center`, or an integer representing the stagger position.
                 */
                from?: string | number;
                /**
                 * Set the stagger to run across a grid by providing an array where element 0 is the width of the grid and element 1 is the height. Combine with the 'from' property to control direction.
                 */
                grid?: number[];
            };

            type TweenBuilderConfig = {[key: string]: any} & {
                /**
                 * The object, or an array of objects, to run the tween on.
                 */
                targets: any;
                /**
                 * The number of milliseconds to delay before the tween will start.
                 */
                delay?: number | Function;
                /**
                 * The duration of the tween in milliseconds.
                 */
                duration?: number;
                /**
                 * The easing equation to use for the tween.
                 */
                ease?: string | Function;
                /**
                 * Optional easing parameters.
                 */
                easeParams?: any[];
                /**
                 * The number of milliseconds to hold the tween for before yoyo'ing.
                 */
                hold?: number;
                /**
                 * The number of times each property tween repeats.
                 */
                repeat?: number;
                /**
                 * The number of milliseconds to pause before a repeat.
                 */
                repeatDelay?: number;
                /**
                 * Should the tween complete, then reverse the values incrementally to get back to the starting tween values? The reverse tweening will also take `duration` milliseconds to complete.
                 */
                yoyo?: boolean;
                /**
                 * Horizontally flip the target of the Tween when it completes (before it yoyos, if set to do so). Only works for targets that support the `flipX` property.
                 */
                flipX?: boolean;
                /**
                 * Vertically flip the target of the Tween when it completes (before it yoyos, if set to do so). Only works for targets that support the `flipY` property.
                 */
                flipY?: boolean;
                /**
                 * The time the tween will wait before the onComplete event is dispatched once it has completed, in ms.
                 */
                completeDelay?: string | number | Function | object | any[];
                /**
                 * The number of times the tween will repeat. (A value of 1 means the tween will play twice, as it repeated once.) The first loop starts after every property in the tween has completed once.
                 */
                loop?: string | number | Function | object | any[];
                /**
                 * The time the tween will pause before starting either a yoyo or returning to the start for a repeat.
                 */
                loopDelay?: string | number | Function | object | any[];
                /**
                 * Does the tween start in a paused state (true) or playing (false)?
                 */
                paused?: boolean;
                /**
                 * The properties to tween.
                 */
                props?: {[key: string]:  (number|string|Phaser.Types.Tweens.GetEndCallback|Phaser.Types.Tweens.TweenPropConfig)};
                /**
                 * The scope (or context) for all of the callbacks. The default scope is the tween.
                 */
                callbackScope?: any;
                /**
                 * A function to call when the tween completes.
                 */
                onComplete?: Phaser.Types.Tweens.TweenOnCompleteCallback;
                /**
                 * Additional parameters to pass to `onComplete`.
                 */
                onCompleteParams?: any[];
                /**
                 * A function to call each time the tween loops.
                 */
                onLoop?: Phaser.Types.Tweens.TweenOnLoopCallback;
                /**
                 * Additional parameters to pass to `onLoop`.
                 */
                onLoopParams?: any[];
                /**
                 * A function to call each time a property tween repeats. Called once per property per target.
                 */
                onRepeat?: Phaser.Types.Tweens.TweenOnRepeatCallback;
                /**
                 * Additional parameters to pass to `onRepeat`.
                 */
                onRepeatParams?: any[];
                /**
                 * A function to call when the tween starts playback, after any delays have expired.
                 */
                onStart?: Phaser.Types.Tweens.TweenOnStartCallback;
                /**
                 * Additional parameters to pass to `onStart`.
                 */
                onStartParams?: any[];
                /**
                 * A function to call when the tween is stopped.
                 */
                onStop?: Phaser.Types.Tweens.TweenOnStopCallback;
                /**
                 * Additional parameters to pass to `onStop`.
                 */
                onStopParams?: any[];
                /**
                 * A function to call each time the tween steps. Called once per property per target.
                 */
                onUpdate?: Phaser.Types.Tweens.TweenOnUpdateCallback;
                /**
                 * Additional parameters to pass to `onUpdate`.
                 */
                onUpdateParams?: any[];
                /**
                 * A function to call each time a property tween yoyos. Called once per property per target.
                 */
                onYoyo?: Phaser.Types.Tweens.TweenOnYoyoCallback;
                /**
                 * Additional parameters to pass to `onYoyo`.
                 */
                onYoyoParams?: any[];
                /**
                 * A function to call when the tween becomes active within the Tween Manager.
                 */
                onActive?: Phaser.Types.Tweens.TweenOnActiveCallback;
                /**
                 * Additional parameters to pass to `onActive`.
                 */
                onActiveParams?: any[];
                /**
                 * A function to call when the tween is paused.
                 */
                onPause?: Phaser.Types.Tweens.TweenOnPauseCallback;
                /**
                 * Additional parameters to pass to `onPause`.
                 */
                onPauseParams?: any[];
                /**
                 * A function to call when the tween is resumed after being paused.
                 */
                onResume?: Phaser.Types.Tweens.TweenOnResumeCallback;
                /**
                 * Additional parameters to pass to `onResume`.
                 */
                onResumeParams?: any[];
                /**
                 * Will the Tween be automatically destroyed on completion, or retained for future playback?
                 */
                persist?: boolean;
                /**
                 * The interpolation function to use if the `value` given is an array of numbers.
                 */
                interpolation?: string | Function;
            };

            type TweenCallbacks = {
                /**
                 * A function to call when the tween becomes active within the Tween Manager.
                 */
                onActive?: Phaser.Types.Tweens.TweenOnActiveCallback;
                /**
                 * A function to call when the tween starts playback, after any delays have expired.
                 */
                onStart?: Phaser.Types.Tweens.TweenOnStartCallback;
                /**
                 * A function to call when the tween completes.
                 */
                onComplete?: Phaser.Types.Tweens.TweenOnCompleteCallback;
                /**
                 * A function to call each time the tween loops.
                 */
                onLoop?: Phaser.Types.Tweens.TweenOnLoopCallback;
                /**
                 * A function to call each time the tween is paused.
                 */
                onPause?: Phaser.Types.Tweens.TweenOnPauseCallback;
                /**
                 * A function to call each time the tween is resumed.
                 */
                onResume?: Phaser.Types.Tweens.TweenOnResumeCallback;
                /**
                 * A function to call each time the tween repeats. Called once per property per target.
                 */
                onRepeat?: Phaser.Types.Tweens.TweenOnRepeatCallback;
                /**
                 * A function to call when the tween is stopped.
                 */
                onStop?: Phaser.Types.Tweens.TweenOnStopCallback;
                /**
                 * A function to call each time the tween steps. Called once per property per target.
                 */
                onUpdate?: Phaser.Types.Tweens.TweenOnUpdateCallback;
                /**
                 * A function to call each time the tween yoyos. Called once per property per target.
                 */
                onYoyo?: Phaser.Types.Tweens.TweenOnYoyoCallback;
            };

            type TweenCallbackTypes = 'onActive' | 'onComplete' | 'onLoop' | 'onPause' | 'onRepeat' | 'onResume' | 'onStart' | 'onStop' | 'onUpdate' | 'onYoyo';

            type TweenChainBuilderConfig = {[key: string]: any} & {
                /**
                 * The object, or an array of objects, to run the tween on.
                 */
                targets: any;
                /**
                 * The number of milliseconds to delay before the tween will start.
                 */
                delay?: number | Function;
                /**
                 * The number of milliseconds to hold the tween for before yoyo'ing.
                 */
                hold?: number;
                /**
                 * The number of times each property tween repeats.
                 */
                repeat?: number;
                /**
                 * The number of milliseconds to pause before a repeat.
                 */
                repeatDelay?: number;
                /**
                 * The time the tween will wait before the onComplete event is dispatched once it has completed, in ms.
                 */
                completeDelay?: string | number | Function | object | any[];
                /**
                 * The number of times the tween will repeat. (A value of 1 means the tween will play twice, as it repeated once.) The first loop starts after every property in the tween has completed once.
                 */
                loop?: string | number | Function | object | any[];
                /**
                 * The time the tween will pause before starting either a yoyo or returning to the start for a repeat.
                 */
                loopDelay?: string | number | Function | object | any[];
                /**
                 * Does the tween start in a paused state (true) or playing (false)?
                 */
                paused?: boolean;
                /**
                 * The tweens to chain together.
                 */
                tweens?: Phaser.Types.Tweens.TweenBuilderConfig[];
                /**
                 * The scope (or context) for all of the callbacks. The default scope is the tween.
                 */
                callbackScope?: any;
                /**
                 * A function to call when the tween completes.
                 */
                onComplete?: Phaser.Types.Tweens.TweenOnCompleteCallback;
                /**
                 * Additional parameters to pass to `onComplete`.
                 */
                onCompleteParams?: any[];
                /**
                 * A function to call each time the tween loops.
                 */
                onLoop?: Phaser.Types.Tweens.TweenOnLoopCallback;
                /**
                 * Additional parameters to pass to `onLoop`.
                 */
                onLoopParams?: any[];
                /**
                 * A function to call each time the tween repeats. Called once per property per target.
                 */
                onRepeat?: Phaser.Types.Tweens.TweenOnRepeatCallback;
                /**
                 * Additional parameters to pass to `onRepeat`.
                 */
                onRepeatParams?: any[];
                /**
                 * A function to call when the tween starts playback, after any delays have expired.
                 */
                onStart?: Phaser.Types.Tweens.TweenOnStartCallback;
                /**
                 * Additional parameters to pass to `onStart`.
                 */
                onStartParams?: any[];
                /**
                 * A function to call when the tween is stopped.
                 */
                onStop?: Phaser.Types.Tweens.TweenOnStopCallback;
                /**
                 * Additional parameters to pass to `onStop`.
                 */
                onStopParams?: any[];
                /**
                 * A function to call each time the tween steps. Called once per property per target.
                 */
                onUpdate?: Phaser.Types.Tweens.TweenOnUpdateCallback;
                /**
                 * Additional parameters to pass to `onUpdate`.
                 */
                onUpdateParams?: any[];
                /**
                 * A function to call each time the tween yoyos. Called once per property per target.
                 */
                onYoyo?: Phaser.Types.Tweens.TweenOnYoyoCallback;
                /**
                 * Additional parameters to pass to `onYoyo`.
                 */
                onYoyoParams?: any[];
                /**
                 * A function to call when the tween becomes active within the Tween Manager.
                 */
                onActive?: Phaser.Types.Tweens.TweenOnActiveCallback;
                /**
                 * Additional parameters to pass to `onActive`.
                 */
                onActiveParams?: any[];
                /**
                 * A function to call when the tween is paused.
                 */
                onPause?: Phaser.Types.Tweens.TweenOnPauseCallback;
                /**
                 * Additional parameters to pass to `onPause`.
                 */
                onPauseParams?: any[];
                /**
                 * A function to call when the tween is resumed after being paused.
                 */
                onResume?: Phaser.Types.Tweens.TweenOnResumeCallback;
                /**
                 * Additional parameters to pass to `onResume`.
                 */
                onResumeParams?: any[];
                /**
                 * Will the Tween be automatically destroyed on completion, or retained for future playback?
                 */
                persist?: boolean;
            };

            type TweenDataConfig = {
                /**
                 * The target to tween.
                 */
                target: any;
                /**
                 * The target index within the Tween targets array.
                 */
                index: number;
                /**
                 * The property of the target being tweened.
                 */
                key: string;
                /**
                 * If not null, is invoked _immediately_ as soon as the TweenData is running, and is set on the target property.
                 */
                getActiveValue: Phaser.Types.Tweens.GetActiveCallback | null;
                /**
                 * The returned value sets what the property will be at the END of the Tween.
                 */
                getEndValue: Phaser.Types.Tweens.GetEndCallback;
                /**
                 * The returned value sets what the property will be at the START of the Tween.
                 */
                getStartValue: Phaser.Types.Tweens.GetStartCallback;
                /**
                 * The ease function this tween uses.
                 */
                ease: Function;
                /**
                 * Duration of the tween in milliseconds, excludes time for yoyo or repeats.
                 */
                duration?: number;
                /**
                 * The total calculated duration of this TweenData (based on duration, repeat, delay and yoyo)
                 */
                totalDuration?: number;
                /**
                 * Time in milliseconds before tween will start.
                 */
                delay?: number;
                /**
                 * Cause the tween to return back to its start value after hold has expired.
                 */
                yoyo?: boolean;
                /**
                 * Time in milliseconds the tween will pause before running the yoyo or starting a repeat.
                 */
                hold?: number;
                /**
                 * Number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
                 */
                repeat?: number;
                /**
                 * Time in milliseconds before the repeat will start.
                 */
                repeatDelay?: number;
                /**
                 * Automatically call toggleFlipX when the TweenData yoyos or repeats
                 */
                flipX?: boolean;
                /**
                 * Automatically call toggleFlipY when the TweenData yoyos or repeats
                 */
                flipY?: boolean;
                /**
                 * Between 0 and 1 showing completion of this TweenData.
                 */
                progress?: number;
                /**
                 * Delta counter
                 */
                elapsed?: number;
                /**
                 * How many repeats are left to run?
                 */
                repeatCounter?: number;
                /**
                 * The property value at the start of the ease.
                 */
                start?: number;
                /**
                 * The current propety value.
                 */
                current?: number;
                /**
                 * The previous property value.
                 */
                previous?: number;
                /**
                 * The property value at the end of the ease.
                 */
                end?: number;
                /**
                 * LoadValue generation functions.
                 */
                gen?: Phaser.Types.Tweens.TweenDataGenConfig;
                /**
                 * TWEEN_CONST.CREATED
                 */
                state?: Phaser.Tweens.StateType;
            };

            type TweenDataGenConfig = {
                /**
                 * Time in milliseconds before tween will start.
                 */
                delay: Function;
                /**
                 * Duration of the tween in milliseconds, excludes time for yoyo or repeats.
                 */
                duration: Function;
                /**
                 * Time in milliseconds the tween will pause before running the yoyo or starting a repeat.
                 */
                hold: Function;
                /**
                 * Number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
                 */
                repeat: Function;
                /**
                 * Time in milliseconds before the repeat will start.
                 */
                repeatDelay: Function;
            };

            type TweenFrameDataConfig = {
                /**
                 * The target to tween.
                 */
                target: any;
                /**
                 * The target index within the Tween targets array.
                 */
                index: number;
                /**
                 * The property of the target being tweened.
                 */
                key: string;
                /**
                 * Duration of the tween in milliseconds, excludes time for yoyo or repeats.
                 */
                duration?: number;
                /**
                 * The total calculated duration of this TweenData (based on duration, repeat, delay and yoyo)
                 */
                totalDuration?: number;
                /**
                 * Time in milliseconds before tween will start.
                 */
                delay?: number;
                /**
                 * Time in milliseconds the tween will pause before running the yoyo or starting a repeat.
                 */
                hold?: number;
                /**
                 * Number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
                 */
                repeat?: number;
                /**
                 * Time in milliseconds before the repeat will start.
                 */
                repeatDelay?: number;
                /**
                 * Automatically call toggleFlipX when the TweenData yoyos or repeats
                 */
                flipX?: boolean;
                /**
                 * Automatically call toggleFlipY when the TweenData yoyos or repeats
                 */
                flipY?: boolean;
                /**
                 * Between 0 and 1 showing completion of this TweenData.
                 */
                progress?: number;
                /**
                 * Delta counter
                 */
                elapsed?: number;
                /**
                 * How many repeats are left to run?
                 */
                repeatCounter?: number;
                /**
                 * LoadValue generation functions.
                 */
                gen?: Phaser.Types.Tweens.TweenDataGenConfig;
                /**
                 * TWEEN_CONST.CREATED
                 */
                state?: Phaser.Tweens.StateType;
            };

            type TweenOnActiveCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnCompleteCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnLoopCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnPauseCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnRepeatCallback = (tween: Phaser.Tweens.Tween, target: any, key: string, current: number, previous: number, ...param: any[])=>void;

            type TweenOnResumeCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnStartCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnStopCallback = (tween: Phaser.Tweens.Tween, targets: any | any[], ...param: any[])=>void;

            type TweenOnUpdateCallback = (tween: Phaser.Tweens.Tween, target: any, key: string, current: number, previous: number, ...param: any[])=>void;

            type TweenOnYoyoCallback = (tween: Phaser.Tweens.Tween, target: any, key: string, current: number, previous: number, ...param: any[])=>void;

            type TweenPropConfig = {
                /**
                 * What the property will be at the END of the Tween.
                 */
                value?: number | number[] | string | Phaser.Types.Tweens.GetEndCallback | Phaser.Types.Tweens.TweenPropConfig;
                /**
                 * What the property will be set to immediately when this tween becomes active.
                 */
                getActive?: Phaser.Types.Tweens.GetActiveCallback;
                /**
                 * What the property will be at the END of the Tween.
                 */
                getEnd?: Phaser.Types.Tweens.GetEndCallback;
                /**
                 * What the property will be at the START of the Tween.
                 */
                getStart?: Phaser.Types.Tweens.GetStartCallback;
                /**
                 * The ease function this tween uses.
                 */
                ease?: string | Function;
                /**
                 * Time in milliseconds before tween will start.
                 */
                delay?: number;
                /**
                 * Duration of the tween in milliseconds.
                 */
                duration?: number;
                /**
                 * Determines whether the tween should return back to its start value after hold has expired.
                 */
                yoyo?: boolean;
                /**
                 * Time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
                 */
                hold?: number;
                /**
                 * Number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
                 */
                repeat?: number;
                /**
                 * Time in milliseconds before the repeat will start.
                 */
                repeatDelay?: number;
                /**
                 * Should toggleFlipX be called when yoyo or repeat happens?
                 */
                flipX?: boolean;
                /**
                 * Should toggleFlipY be called when yoyo or repeat happens?
                 */
                flipY?: boolean;
                /**
                 * The interpolation function to use if the `value` given is an array of numbers.
                 */
                interpolation?: string | Function;
            };

        }

    }

    namespace Physics {
        namespace Arcade {
            /**
             * An Arcade Physics Image is an Image with an Arcade Physics body and related components.
             * The body can be dynamic or static.
             * 
             * The main difference between an Arcade Image and an Arcade Sprite is that you cannot animate an Arcade Image.
             */
            class Image extends Phaser.GameObjects.Image implements Phaser.Physics.Arcade.Components.Acceleration, Phaser.Physics.Arcade.Components.Angular, Phaser.Physics.Arcade.Components.Bounce, Phaser.Physics.Arcade.Components.Collision, Phaser.Physics.Arcade.Components.Debug, Phaser.Physics.Arcade.Components.Drag, Phaser.Physics.Arcade.Components.Enable, Phaser.Physics.Arcade.Components.Friction, Phaser.Physics.Arcade.Components.Gravity, Phaser.Physics.Arcade.Components.Immovable, Phaser.Physics.Arcade.Components.Mass, Phaser.Physics.Arcade.Components.Pushable, Phaser.Physics.Arcade.Components.Size, Phaser.Physics.Arcade.Components.Velocity, Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                constructor(scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number);

                /**
                 * This Game Object's Physics Body.
                 */
                body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody | null;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * 
                 * If your game is running under WebGL you can optionally specify four different alpha values, each of which
                 * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
                 * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
                 * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
                 * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
                 * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
                 */
                setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;

                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;

                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;

                /**
                 * The horizontally flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipX: boolean;

                /**
                 * The vertically flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipY: boolean;

                /**
                 * Toggles the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                toggleFlipX(): this;

                /**
                 * Toggles the vertical flipped state of this Game Object.
                 */
                toggleFlipY(): this;

                /**
                 * Sets the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipX(value: boolean): this;

                /**
                 * Sets the vertical flipped state of this Game Object.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipY(value: boolean): this;

                /**
                 * Sets the horizontal and vertical flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped will render inversed on the flipped axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlip(x: boolean, y: boolean): this;

                /**
                 * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
                 */
                resetFlip(): this;

                /**
                 * Gets the center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the left-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the right-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bounds of this Game Object, regardless of origin.
                 * 
                 * The values are stored and returned in a Rectangle, or Rectangle-like, object.
                 * @param output An object to store the values in. If not provided a new Rectangle will be created.
                 */
                getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

                /**
                 * The horizontal origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the left of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originX: number;

                /**
                 * The vertical origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the top of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originY: number;

                /**
                 * The horizontal display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginX: number;

                /**
                 * The vertical display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginY: number;

                /**
                 * Sets the origin of this Game Object.
                 * 
                 * The values are given in the range 0 to 1.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;

                /**
                 * Sets the origin of this Game Object based on the Pivot values in its Frame.
                 */
                setOriginFromFrame(): this;

                /**
                 * Sets the display origin of this Game Object.
                 * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
                 * @param x The horizontal display origin value. Default 0.
                 * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setDisplayOrigin(x?: number, y?: number): this;

                /**
                 * Updates the Display Origin cached values internally stored on this Game Object.
                 * You don't usually call this directly, but it is exposed for edge-cases where you may.
                 */
                updateDisplayOrigin(): this;

                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;

                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;

                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;

                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;

                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;

                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;

                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;

                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;

                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;

                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;

                /**
                 * Sets the size of this Game Object to be that of the given Frame.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param frame The frame to base the size of this Game Object on.
                 */
                setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;

                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;

                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;

                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * @param key The key of the texture to be used, as stored in the Texture Manager.
                 * @param frame The name or index of the frame within the Texture.
                 */
                setTexture(key: string, frame?: string | number): this;

                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * The tint value being applied to the top-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopLeft: number;

                /**
                 * The tint value being applied to the top-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopRight: number;

                /**
                 * The tint value being applied to the bottom-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomLeft: number;

                /**
                 * The tint value being applied to the bottom-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomRight: number;

                /**
                 * The tint fill mode.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;

                /**
                 * Clears all tint values associated with this Game Object.
                 * 
                 * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
                 * which results in no visible change to the texture.
                 */
                clearTint(): this;

                /**
                 * Sets an additive tint on this Game Object.
                 * 
                 * The tint works by taking the pixel color values from the Game Objects texture, and then
                 * multiplying it by the color value of the tint. You can provide either one color value,
                 * in which case the whole Game Object will be tinted in that color. Or you can provide a color
                 * per corner. The colors are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * Sets a fill-based tint on this Game Object.
                 * 
                 * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
                 * with those in the tint. You can use this for effects such as making a player flash 'white'
                 * if hit by something. You can provide either one color value, in which case the whole
                 * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
                 * are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The tint value being applied to the whole of the Game Object.
                 * Return `tintTopLeft` when read this tint property.
                 */
                tint: number;

                /**
                 * Does this Game Object have a tint applied?
                 * 
                 * It checks to see if the 4 tint properties are set to the value 0xffffff
                 * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
                 */
                readonly isTinted: boolean;

                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;

                /**
                 * The x position of this Game Object.
                 */
                x: number;

                /**
                 * The y position of this Game Object.
                 */
                y: number;

                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;

                /**
                 * The w position of this Game Object.
                 */
                w: number;

                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;

                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;

                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;

                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;

                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;

                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;

                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;

                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;

                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;

                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;

                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;

                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;

                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;

                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;

                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;

                /**
                 * Sets the body's horizontal and vertical acceleration. If the vertical acceleration value is not provided, the vertical acceleration is set to the same value as the horizontal acceleration.
                 * @param x The horizontal acceleration
                 * @param y The vertical acceleration Default x.
                 */
                setAcceleration(x: number, y?: number): this;

                /**
                 * Sets the body's horizontal acceleration.
                 * @param value The horizontal acceleration
                 */
                setAccelerationX(value: number): this;

                /**
                 * Sets the body's vertical acceleration.
                 * @param value The vertical acceleration
                 */
                setAccelerationY(value: number): this;

                /**
                 * Sets the angular velocity of the body.
                 * 
                 * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                 * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                 * causing them to visually rotate, even though the body remains axis-aligned.
                 * @param value The amount of angular velocity.
                 */
                setAngularVelocity(value: number): this;

                /**
                 * Sets the angular acceleration of the body.
                 * 
                 * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                 * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                 * causing them to visually rotate, even though the body remains axis-aligned.
                 * @param value The amount of angular acceleration.
                 */
                setAngularAcceleration(value: number): this;

                /**
                 * Sets the angular drag of the body. Drag is applied to the current velocity, providing a form of deceleration.
                 * @param value The amount of drag.
                 */
                setAngularDrag(value: number): this;

                /**
                 * Sets the bounce values of this body.
                 * 
                 * Bounce is the amount of restitution, or elasticity, the body has when it collides with another object.
                 * A value of 1 means that it will retain its full velocity after the rebound. A value of 0 means it will not rebound at all.
                 * @param x The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                 * @param y The amount of vertical bounce to apply on collision. A float, typically between 0 and 1. Default x.
                 */
                setBounce(x: number, y?: number): this;

                /**
                 * Sets the horizontal bounce value for this body.
                 * @param value The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                 */
                setBounceX(value: number): this;

                /**
                 * Sets the vertical bounce value for this body.
                 * @param value The amount of vertical bounce to apply on collision. A float, typically between 0 and 1.
                 */
                setBounceY(value: number): this;

                /**
                 * Sets whether this Body collides with the world boundary.
                 * 
                 * Optionally also sets the World Bounce values. If the `Body.worldBounce` is null, it's set to a new Phaser.Math.Vector2 first.
                 * @param value `true` if this body should collide with the world bounds, otherwise `false`. Default true.
                 * @param bounceX If given this will be replace the `worldBounce.x` value.
                 * @param bounceY If given this will be replace the `worldBounce.y` value.
                 * @param onWorldBounds If given this replaces the Body's `onWorldBounds` value.
                 */
                setCollideWorldBounds(value?: boolean, bounceX?: number, bounceY?: number, onWorldBounds?: boolean): this;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

                /**
                 * Sets the debug values of this body.
                 * 
                 * Bodies will only draw their debug if debug has been enabled for Arcade Physics as a whole.
                 * Note that there is a performance cost in drawing debug displays. It should never be used in production.
                 * @param showBody Set to `true` to have this body render its outline to the debug display.
                 * @param showVelocity Set to `true` to have this body render a velocity marker to the debug display.
                 * @param bodyColor The color of the body outline when rendered to the debug display.
                 */
                setDebug(showBody: boolean, showVelocity: boolean, bodyColor: number): this;

                /**
                 * Sets the color of the body outline when it renders to the debug display.
                 * @param value The color of the body outline when rendered to the debug display.
                 */
                setDebugBodyColor(value: number): this;

                /**
                 * Set to `true` to have this body render its outline to the debug display.
                 */
                debugShowBody: boolean;

                /**
                 * Set to `true` to have this body render a velocity marker to the debug display.
                 */
                debugShowVelocity: boolean;

                /**
                 * The color of the body outline when it renders to the debug display.
                 */
                debugBodyColor: number;

                /**
                 * Sets the body's horizontal and vertical drag. If the vertical drag value is not provided, the vertical drag is set to the same value as the horizontal drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param x The amount of horizontal drag to apply.
                 * @param y The amount of vertical drag to apply. Default x.
                 */
                setDrag(x: number, y?: number): this;

                /**
                 * Sets the body's horizontal drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param value The amount of horizontal drag to apply.
                 */
                setDragX(value: number): this;

                /**
                 * Sets the body's vertical drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param value The amount of vertical drag to apply.
                 */
                setDragY(value: number): this;

                /**
                 * If this Body is using `drag` for deceleration this function controls how the drag is applied.
                 * If set to `true` drag will use a damping effect rather than a linear approach. If you are
                 * creating a game where the Body moves freely at any angle (i.e. like the way the ship moves in
                 * the game Asteroids) then you will get a far smoother and more visually correct deceleration
                 * by using damping, avoiding the axis-drift that is prone with linear deceleration.
                 * 
                 * If you enable this property then you should use far smaller `drag` values than with linear, as
                 * they are used as a multiplier on the velocity. Values such as 0.95 will give a nice slow
                 * deceleration, where-as smaller values, such as 0.5 will stop an object almost immediately.
                 * @param value `true` to use damping for deceleration, or `false` to use linear deceleration.
                 */
                setDamping(value: boolean): this;

                /**
                 * Sets whether this Body should calculate its velocity based on its change in
                 * position every frame. The default, which is to not do this, means that you
                 * make this Body move by setting the velocity directly. However, if you are
                 * trying to move this Body via a Tween, or have it follow a Path, then you
                 * should enable this instead. This will allow it to still collide with other
                 * bodies, something that isn't possible if you're just changing its position directly.
                 * @param value `true` if the Body calculate velocity based on changes in position, otherwise `false`. Default true.
                 */
                setDirectControl(value?: boolean): this;

                /**
                 * Enables this Game Object's Body.
                 * If you reset the Body you must also pass `x` and `y`.
                 * @param reset Also reset the Body and place the Game Object at (x, y).
                 * @param x The horizontal position to place the Game Object, if `reset` is true.
                 * @param y The horizontal position to place the Game Object, if `reset` is true.
                 * @param enableGameObject Also set this Game Object's `active` to true.
                 * @param showGameObject Also set this Game Object's `visible` to true.
                 */
                enableBody(reset?: boolean, x?: number, y?: number, enableGameObject?: boolean, showGameObject?: boolean): this;

                /**
                 * Stops and disables this Game Object's Body.
                 * @param disableGameObject Also set this Game Object's `active` to false. Default false.
                 * @param hideGameObject Also set this Game Object's `visible` to false. Default false.
                 */
                disableBody(disableGameObject?: boolean, hideGameObject?: boolean): this;

                /**
                 * Syncs the Body's position and size with its parent Game Object.
                 * You don't need to call this for Dynamic Bodies, as it happens automatically.
                 * But for Static bodies it's a useful way of modifying the position of a Static Body
                 * in the Physics World, based on its Game Object.
                 */
                refreshBody(): this;

                /**
                 * Sets the friction of this game object's physics body.
                 * In Arcade Physics, friction is a special case of motion transfer from an "immovable" body to a riding body.
                 * @param x The amount of horizontal friction to apply, [0, 1].
                 * @param y The amount of vertical friction to apply, [0, 1]. Default x.
                 */
                setFriction(x: number, y?: number): this;

                /**
                 * Sets the horizontal friction of this game object's physics body.
                 * This can move a riding body horizontally when it collides with this one on the vertical axis.
                 * @param x The amount of friction to apply, [0, 1].
                 */
                setFrictionX(x: number): this;

                /**
                 * Sets the vertical friction of this game object's physics body.
                 * This can move a riding body vertically when it collides with this one on the horizontal axis.
                 * @param y The amount of friction to apply, [0, 1].
                 */
                setFrictionY(y: number): this;

                /**
                 * Set the X and Y values of the gravitational pull to act upon this Arcade Physics Game Object. Values can be positive or negative. Larger values result in a stronger effect.
                 * 
                 * If only one value is provided, this value will be used for both the X and Y axis.
                 * @param x The gravitational force to be applied to the X-axis.
                 * @param y The gravitational force to be applied to the Y-axis. If this is not specified, the X value will be used. Default x.
                 */
                setGravity(x: number, y?: number): this;

                /**
                 * Set the gravitational force to be applied to the X axis. Value can be positive or negative. Larger values result in a stronger effect.
                 * @param x The gravitational force to be applied to the X-axis.
                 */
                setGravityX(x: number): this;

                /**
                 * Set the gravitational force to be applied to the Y axis. Value can be positive or negative. Larger values result in a stronger effect.
                 * @param y The gravitational force to be applied to the Y-axis.
                 */
                setGravityY(y: number): this;

                /**
                 * Sets if this Body can be separated during collisions with other bodies.
                 * 
                 * When a body is immovable it means it won't move at all, not even to separate it from collision
                 * overlap. If you just wish to prevent a body from being knocked around by other bodies, see
                 * the `setPushable` method instead.
                 * @param value Sets if this body will be separated during collisions with other bodies. Default true.
                 */
                setImmovable(value?: boolean): this;

                /**
                 * Sets the mass of the physics body
                 * @param value New value for the mass of the body.
                 */
                setMass(value: number): this;

                /**
                 * Sets if this Body can be pushed by another Body.
                 * 
                 * A body that cannot be pushed will reflect back all of the velocity it is given to the
                 * colliding body. If that body is also not pushable, then the separation will be split
                 * between them evenly.
                 * 
                 * If you want your body to never move or seperate at all, see the `setImmovable` method.
                 * @param value Sets if this body can be pushed by collisions with another Body. Default true.
                 */
                setPushable(value?: boolean): this;

                /**
                 * Sets the body offset. This allows you to adjust the difference between the center of the body
                 * and the x and y coordinates of the parent Game Object.
                 * @param x The amount to offset the body from the parent Game Object along the x-axis.
                 * @param y The amount to offset the body from the parent Game Object along the y-axis. Defaults to the value given for the x-axis. Default x.
                 */
                setOffset(x: number, y?: number): this;

                /**
                 * Sets the size of this physics body. Setting the size does not adjust the dimensions of the parent Game Object.
                 * @param width The new width of the physics body, in pixels.
                 * @param height The new height of the physics body, in pixels.
                 * @param center Should the body be re-positioned so its center aligns with the parent Game Object? Default true.
                 */
                setBodySize(width: number, height: number, center?: boolean): this;

                /**
                 * Sets this physics body to use a circle for collision instead of a rectangle.
                 * @param radius The radius of the physics body, in pixels.
                 * @param offsetX The amount to offset the body from the parent Game Object along the x-axis.
                 * @param offsetY The amount to offset the body from the parent Game Object along the y-axis.
                 */
                setCircle(radius: number, offsetX?: number, offsetY?: number): this;

                /**
                 * Sets the velocity of the Body.
                 * @param x The horizontal velocity of the body. Positive values move the body to the right, while negative values move it to the left.
                 * @param y The vertical velocity of the body. Positive values move the body down, while negative values move it up. Default x.
                 */
                setVelocity(x: number, y?: number): this;

                /**
                 * Sets the horizontal component of the body's velocity.
                 * 
                 * Positive values move the body to the right, while negative values move it to the left.
                 * @param x The new horizontal velocity.
                 */
                setVelocityX(x: number): this;

                /**
                 * Sets the vertical component of the body's velocity.
                 * 
                 * Positive values move the body down, while negative values move it up.
                 * @param y The new vertical velocity of the body.
                 */
                setVelocityY(y: number): this;

                /**
                 * Sets the maximum velocity of the body.
                 * @param x The new maximum horizontal velocity.
                 * @param y The new maximum vertical velocity. Default x.
                 */
                setMaxVelocity(x: number, y?: number): this;

            }

            /**
             * The Arcade Physics Plugin belongs to a Scene and sets up and manages the Scene's physics simulation.
             * It also holds some useful methods for moving and rotating Arcade Physics Bodies.
             * 
             * You can access it from within a Scene using `this.physics`.
             * 
             * Arcade Physics uses the Projection Method of collision resolution and separation. While it's fast and suitable
             * for 'arcade' style games it lacks stability when multiple objects are in close proximity or resting upon each other.
             * The separation that stops two objects penetrating may create a new penetration against a different object. If you
             * require a high level of stability please consider using an alternative physics system, such as Matter.js.
             */
            class ArcadePhysics {
                /**
                 * 
                 * @param scene The Scene that this Plugin belongs to.
                 */
                constructor(scene: Phaser.Scene);

                /**
                 * The Scene that this Plugin belongs to.
                 */
                scene: Phaser.Scene;

                /**
                 * The Scene's Systems.
                 */
                systems: Phaser.Scenes.Systems;

                /**
                 * A configuration object. Union of the `physics.arcade.*` properties of the GameConfig and SceneConfig objects.
                 */
                config: Phaser.Types.Physics.Arcade.ArcadeWorldConfig;

                /**
                 * The physics simulation.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * An object holding the Arcade Physics factory methods.
                 */
                add: Phaser.Physics.Arcade.Factory;

                /**
                 * Causes `World.update` to be automatically called each time the Scene
                 * emits and `UPDATE` event. This is the default setting, so only needs
                 * calling if you have specifically disabled it.
                 */
                enableUpdate(): void;

                /**
                 * Causes `World.update` to **not** be automatically called each time the Scene
                 * emits and `UPDATE` event.
                 * 
                 * If you wish to run the World update at your own rate, or from your own
                 * component, then you should call this method to disable the built-in link,
                 * and then call `World.update(delta, time)` accordingly.
                 * 
                 * Note that `World.postUpdate` is always automatically called when the Scene
                 * emits a `POST_UPDATE` event, regardless of this setting.
                 */
                disableUpdate(): void;

                /**
                 * Creates the physics configuration for the current Scene.
                 */
                getConfig(): Phaser.Types.Physics.Arcade.ArcadeWorldConfig;

                /**
                 * Returns the next available collision category.
                 * 
                 * You can have a maximum of 32 categories.
                 * 
                 * By default all bodies collide with all other bodies.
                 * 
                 * Use the `Body.setCollisionCategory()` and
                 * `Body.setCollidesWith()` methods to change this.
                 */
                nextCategory(): number;

                /**
                 * Tests if Game Objects overlap. See {@link Phaser.Physics.Arcade.World#overlap}
                 * @param object1 The first object or array of objects to check.
                 * @param object2 The second object or array of objects to check, or `undefined`.
                 * @param overlapCallback An optional callback function that is called if the objects overlap.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they overlap. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                overlap(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2?: Phaser.Types.Physics.Arcade.ArcadeColliderType, overlapCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Performs a collision check and separation between the two physics enabled objects given, which can be single
                 * Game Objects, arrays of Game Objects, Physics Groups, arrays of Physics Groups or normal Groups.
                 * 
                 * If you don't require separation then use {@link #overlap} instead.
                 * 
                 * If two Groups or arrays are passed, each member of one will be tested against each member of the other.
                 * 
                 * If **only** one Group is passed (as `object1`), each member of the Group will be collided against the other members.
                 * 
                 * If **only** one Array is passed, the array is iterated and every element in it is tested against the others.
                 * 
                 * Two callbacks can be provided. The `collideCallback` is invoked if a collision occurs and the two colliding
                 * objects are passed to it.
                 * 
                 * Arcade Physics uses the Projection Method of collision resolution and separation. While it's fast and suitable
                 * for 'arcade' style games it lacks stability when multiple objects are in close proximity or resting upon each other.
                 * The separation that stops two objects penetrating may create a new penetration against a different object. If you
                 * require a high level of stability please consider using an alternative physics system, such as Matter.js.
                 * @param object1 The first object or array of objects to check.
                 * @param object2 The second object or array of objects to check, or `undefined`.
                 * @param collideCallback An optional callback function that is called if the objects collide.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                collide(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2?: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * This advanced method is specifically for testing for collision between a single Sprite and an array of Tile objects.
                 * 
                 * You should generally use the `collide` method instead, with a Sprite vs. a Tilemap Layer, as that will perform
                 * tile filtering and culling for you, as well as handle the interesting face collision automatically.
                 * 
                 * This method is offered for those who would like to check for collision with specific Tiles in a layer, without
                 * having to set any collision attributes on the tiles in question. This allows you to perform quick dynamic collisions
                 * on small sets of Tiles. As such, no culling or checks are made to the array of Tiles given to this method,
                 * you should filter them before passing them to this method.
                 * 
                 * Important: Use of this method skips the `interesting faces` system that Tilemap Layers use. This means if you have
                 * say a row or column of tiles, and you jump into, or walk over them, it's possible to get stuck on the edges of the
                 * tiles as the interesting face calculations are skipped. However, for quick-fire small collision set tests on
                 * dynamic maps, this method can prove very useful.
                 * @param sprite The first object to check for collision.
                 * @param tiles An array of Tiles to check for collision against.
                 * @param collideCallback An optional callback function that is called if the objects collide.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                collideTiles(sprite: Phaser.GameObjects.GameObject, tiles: Phaser.Tilemaps.Tile[], collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * This advanced method is specifically for testing for overlaps between a single Sprite and an array of Tile objects.
                 * 
                 * You should generally use the `overlap` method instead, with a Sprite vs. a Tilemap Layer, as that will perform
                 * tile filtering and culling for you, as well as handle the interesting face collision automatically.
                 * 
                 * This method is offered for those who would like to check for overlaps with specific Tiles in a layer, without
                 * having to set any collision attributes on the tiles in question. This allows you to perform quick dynamic overlap
                 * tests on small sets of Tiles. As such, no culling or checks are made to the array of Tiles given to this method,
                 * you should filter them before passing them to this method.
                 * @param sprite The first object to check for collision.
                 * @param tiles An array of Tiles to check for collision against.
                 * @param collideCallback An optional callback function that is called if the objects overlap.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                overlapTiles(sprite: Phaser.GameObjects.GameObject, tiles: Phaser.Tilemaps.Tile[], collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Pauses the simulation.
                 */
                pause(): Phaser.Physics.Arcade.World;

                /**
                 * Resumes the simulation (if paused).
                 */
                resume(): Phaser.Physics.Arcade.World;

                /**
                 * Sets the acceleration.x/y property on the game object so it will move towards the x/y coordinates at the given rate (in pixels per second squared)
                 * 
                 * You must give a maximum speed value, beyond which the game object won't go any faster.
                 * 
                 * Note: The game object does not continuously track the target. If the target changes location during transit the game object will not modify its course.
                 * Note: The game object doesn't stop moving once it reaches the destination coordinates.
                 * @param gameObject Any Game Object with an Arcade Physics body.
                 * @param x The x coordinate to accelerate towards.
                 * @param y The y coordinate to accelerate towards.
                 * @param speed The acceleration (change in speed) in pixels per second squared. Default 60.
                 * @param xSpeedMax The maximum x velocity the game object can reach. Default 500.
                 * @param ySpeedMax The maximum y velocity the game object can reach. Default 500.
                 */
                accelerateTo(gameObject: Phaser.GameObjects.GameObject, x: number, y: number, speed?: number, xSpeedMax?: number, ySpeedMax?: number): number;

                /**
                 * Sets the acceleration.x/y property on the game object so it will move towards the x/y coordinates at the given rate (in pixels per second squared)
                 * 
                 * You must give a maximum speed value, beyond which the game object won't go any faster.
                 * 
                 * Note: The game object does not continuously track the target. If the target changes location during transit the game object will not modify its course.
                 * Note: The game object doesn't stop moving once it reaches the destination coordinates.
                 * @param gameObject Any Game Object with an Arcade Physics body.
                 * @param destination The Game Object to move towards. Can be any object but must have visible x/y properties.
                 * @param speed The acceleration (change in speed) in pixels per second squared. Default 60.
                 * @param xSpeedMax The maximum x velocity the game object can reach. Default 500.
                 * @param ySpeedMax The maximum y velocity the game object can reach. Default 500.
                 */
                accelerateToObject(gameObject: Phaser.GameObjects.GameObject, destination: Phaser.GameObjects.GameObject, speed?: number, xSpeedMax?: number, ySpeedMax?: number): number;

                /**
                 * Finds the Body or Game Object closest to a source point or object.
                 * 
                 * If a `targets` argument is passed, this method finds the closest of those.
                 * The targets can be Arcade Physics Game Objects, Dynamic Bodies, or Static Bodies.
                 * 
                 * If no `targets` argument is passed, this method finds the closest Dynamic Body.
                 * 
                 * If two or more targets are the exact same distance from the source point, only the first target
                 * is returned.
                 * @param source Any object with public `x` and `y` properties, such as a Game Object or Geometry object.
                 * @param targets The targets.
                 */
                closest<Target extends Phaser.Physics.Arcade.Body|Phaser.Physics.Arcade.StaticBody|Phaser.GameObjects.GameObject>(source: Phaser.Types.Math.Vector2Like, targets?: Target[]): Target | null;

                /**
                 * Finds the Body or Game Object farthest from a source point or object.
                 * 
                 * If a `targets` argument is passed, this method finds the farthest of those.
                 * The targets can be Arcade Physics Game Objects, Dynamic Bodies, or Static Bodies.
                 * 
                 * If no `targets` argument is passed, this method finds the farthest Dynamic Body.
                 * 
                 * If two or more targets are the exact same distance from the source point, only the first target
                 * is returned.
                 * @param source Any object with public `x` and `y` properties, such as a Game Object or Geometry object.
                 * @param targets The targets.
                 */
                furthest(source: any, targets?: Phaser.Physics.Arcade.Body[] | Phaser.Physics.Arcade.StaticBody[] | Phaser.GameObjects.GameObject[]): Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody | Phaser.GameObjects.GameObject | null;

                /**
                 * Move the given display object towards the x/y coordinates at a steady velocity.
                 * If you specify a maxTime then it will adjust the speed (over-writing what you set) so it arrives at the destination in that number of seconds.
                 * Timings are approximate due to the way browser timers work. Allow for a variance of +- 50ms.
                 * Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course.
                 * Note: The display object doesn't stop moving once it reaches the destination coordinates.
                 * Note: Doesn't take into account acceleration, maxVelocity or drag (if you've set drag or acceleration too high this object may not move at all)
                 * @param gameObject Any Game Object with an Arcade Physics body.
                 * @param x The x coordinate to move towards.
                 * @param y The y coordinate to move towards.
                 * @param speed The speed it will move, in pixels per second (default is 60 pixels/sec) Default 60.
                 * @param maxTime Time given in milliseconds (1000 = 1 sec). If set the speed is adjusted so the object will arrive at destination in the given number of ms. Default 0.
                 */
                moveTo(gameObject: Phaser.GameObjects.GameObject, x: number, y: number, speed?: number, maxTime?: number): number;

                /**
                 * Move the given display object towards the destination object at a steady velocity.
                 * If you specify a maxTime then it will adjust the speed (overwriting what you set) so it arrives at the destination in that number of seconds.
                 * Timings are approximate due to the way browser timers work. Allow for a variance of +- 50ms.
                 * Note: The display object does not continuously track the target. If the target changes location during transit the display object will not modify its course.
                 * Note: The display object doesn't stop moving once it reaches the destination coordinates.
                 * Note: Doesn't take into account acceleration, maxVelocity or drag (if you've set drag or acceleration too high this object may not move at all)
                 * @param gameObject Any Game Object with an Arcade Physics body.
                 * @param destination Any object with public `x` and `y` properties, such as a Game Object or Geometry object.
                 * @param speed The speed it will move, in pixels per second (default is 60 pixels/sec) Default 60.
                 * @param maxTime Time given in milliseconds (1000 = 1 sec). If set the speed is adjusted so the object will arrive at destination in the given number of ms. Default 0.
                 */
                moveToObject(gameObject: Phaser.GameObjects.GameObject, destination: object, speed?: number, maxTime?: number): number;

                /**
                 * Given the angle (in degrees) and speed calculate the velocity and return it as a vector, or set it to the given vector object.
                 * One way to use this is: velocityFromAngle(angle, 200, sprite.body.velocity) which will set the values directly to the sprite's velocity and not create a new vector object.
                 * @param angle The angle in degrees calculated in clockwise positive direction (down = 90 degrees positive, right = 0 degrees positive, up = 90 degrees negative)
                 * @param speed The speed it will move, in pixels per second squared. Default 60.
                 * @param vec2 The Vector2 in which the x and y properties will be set to the calculated velocity.
                 */
                velocityFromAngle(angle: number, speed?: number, vec2?: Phaser.Math.Vector2): Phaser.Math.Vector2;

                /**
                 * Given the rotation (in radians) and speed calculate the velocity and return it as a vector, or set it to the given vector object.
                 * One way to use this is: velocityFromRotation(rotation, 200, sprite.body.velocity) which will set the values directly to the sprite's velocity and not create a new vector object.
                 * @param rotation The angle in radians.
                 * @param speed The speed it will move, in pixels per second squared Default 60.
                 * @param vec2 The Vector2 in which the x and y properties will be set to the calculated velocity.
                 */
                velocityFromRotation(rotation: number, speed?: number, vec2?: Phaser.Math.Vector2): Phaser.Math.Vector2;

                /**
                 * This method will search the given rectangular area and return an array of all physics bodies that
                 * overlap with it. It can return either Dynamic, Static bodies or a mixture of both.
                 * 
                 * A body only has to intersect with the search area to be considered, it doesn't have to be fully
                 * contained within it.
                 * 
                 * If Arcade Physics is set to use the RTree (which it is by default) then the search for is extremely fast,
                 * otherwise the search is O(N) for Dynamic Bodies.
                 * @param x The top-left x coordinate of the area to search within.
                 * @param y The top-left y coordinate of the area to search within.
                 * @param width The width of the area to search within.
                 * @param height The height of the area to search within.
                 * @param includeDynamic Should the search include Dynamic Bodies? Default true.
                 * @param includeStatic Should the search include Static Bodies? Default false.
                 */
                overlapRect(x: number, y: number, width: number, height: number, includeDynamic?: boolean, includeStatic?: boolean): Phaser.Physics.Arcade.Body[] | Phaser.Physics.Arcade.StaticBody[];

                /**
                 * This method will search the given circular area and return an array of all physics bodies that
                 * overlap with it. It can return either Dynamic, Static bodies or a mixture of both.
                 * 
                 * A body only has to intersect with the search area to be considered, it doesn't have to be fully
                 * contained within it.
                 * 
                 * If Arcade Physics is set to use the RTree (which it is by default) then the search is rather fast,
                 * otherwise the search is O(N) for Dynamic Bodies.
                 * @param x The x coordinate of the center of the area to search within.
                 * @param y The y coordinate of the center of the area to search within.
                 * @param radius The radius of the area to search within.
                 * @param includeDynamic Should the search include Dynamic Bodies? Default true.
                 * @param includeStatic Should the search include Static Bodies? Default false.
                 */
                overlapCirc(x: number, y: number, radius: number, includeDynamic?: boolean, includeStatic?: boolean): Phaser.Physics.Arcade.Body[] | Phaser.Physics.Arcade.StaticBody[];

                /**
                 * The Scene that owns this plugin is shutting down.
                 * We need to kill and reset all internal properties as well as stop listening to Scene events.
                 */
                shutdown(): void;

                /**
                 * The Scene that owns this plugin is being destroyed.
                 * We need to shutdown and then kill off all external references.
                 */
                destroy(): void;

            }

            /**
             * An Arcade Physics Sprite is a Sprite with an Arcade Physics body and related components.
             * The body can be dynamic or static.
             * 
             * The main difference between an Arcade Sprite and an Arcade Image is that you cannot animate an Arcade Image.
             * If you do not require animation then you can safely use Arcade Images instead of Arcade Sprites.
             */
            class Sprite extends Phaser.GameObjects.Sprite implements Phaser.Physics.Arcade.Components.Acceleration, Phaser.Physics.Arcade.Components.Angular, Phaser.Physics.Arcade.Components.Bounce, Phaser.Physics.Arcade.Components.Collision, Phaser.Physics.Arcade.Components.Debug, Phaser.Physics.Arcade.Components.Drag, Phaser.Physics.Arcade.Components.Enable, Phaser.Physics.Arcade.Components.Friction, Phaser.Physics.Arcade.Components.Gravity, Phaser.Physics.Arcade.Components.Immovable, Phaser.Physics.Arcade.Components.Mass, Phaser.Physics.Arcade.Components.Pushable, Phaser.Physics.Arcade.Components.Size, Phaser.Physics.Arcade.Components.Velocity, Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param scene The Scene to which this Game Object belongs. A Game Object can only belong to one Scene at a time.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                constructor(scene: Phaser.Scene, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number);

                /**
                 * This Game Object's Physics Body.
                 */
                body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody | null;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * 
                 * If your game is running under WebGL you can optionally specify four different alpha values, each of which
                 * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
                 * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
                 * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
                 * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
                 * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
                 */
                setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;

                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;

                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;

                /**
                 * The horizontally flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipX: boolean;

                /**
                 * The vertically flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipY: boolean;

                /**
                 * Toggles the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                toggleFlipX(): this;

                /**
                 * Toggles the vertical flipped state of this Game Object.
                 */
                toggleFlipY(): this;

                /**
                 * Sets the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipX(value: boolean): this;

                /**
                 * Sets the vertical flipped state of this Game Object.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipY(value: boolean): this;

                /**
                 * Sets the horizontal and vertical flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped will render inversed on the flipped axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlip(x: boolean, y: boolean): this;

                /**
                 * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
                 */
                resetFlip(): this;

                /**
                 * Gets the center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the left-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the right-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bounds of this Game Object, regardless of origin.
                 * 
                 * The values are stored and returned in a Rectangle, or Rectangle-like, object.
                 * @param output An object to store the values in. If not provided a new Rectangle will be created.
                 */
                getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

                /**
                 * The horizontal origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the left of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originX: number;

                /**
                 * The vertical origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the top of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originY: number;

                /**
                 * The horizontal display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginX: number;

                /**
                 * The vertical display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginY: number;

                /**
                 * Sets the origin of this Game Object.
                 * 
                 * The values are given in the range 0 to 1.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;

                /**
                 * Sets the origin of this Game Object based on the Pivot values in its Frame.
                 */
                setOriginFromFrame(): this;

                /**
                 * Sets the display origin of this Game Object.
                 * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
                 * @param x The horizontal display origin value. Default 0.
                 * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setDisplayOrigin(x?: number, y?: number): this;

                /**
                 * Updates the Display Origin cached values internally stored on this Game Object.
                 * You don't usually call this directly, but it is exposed for edge-cases where you may.
                 */
                updateDisplayOrigin(): this;

                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;

                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;

                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;

                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;

                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;

                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;

                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;

                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;

                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;

                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;

                /**
                 * Sets the size of this Game Object to be that of the given Frame.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param frame The frame to base the size of this Game Object on.
                 */
                setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;

                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;

                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;

                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * @param key The key of the texture to be used, as stored in the Texture Manager.
                 * @param frame The name or index of the frame within the Texture.
                 */
                setTexture(key: string, frame?: string | number): this;

                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * The tint value being applied to the top-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopLeft: number;

                /**
                 * The tint value being applied to the top-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopRight: number;

                /**
                 * The tint value being applied to the bottom-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomLeft: number;

                /**
                 * The tint value being applied to the bottom-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomRight: number;

                /**
                 * The tint fill mode.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;

                /**
                 * Clears all tint values associated with this Game Object.
                 * 
                 * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
                 * which results in no visible change to the texture.
                 */
                clearTint(): this;

                /**
                 * Sets an additive tint on this Game Object.
                 * 
                 * The tint works by taking the pixel color values from the Game Objects texture, and then
                 * multiplying it by the color value of the tint. You can provide either one color value,
                 * in which case the whole Game Object will be tinted in that color. Or you can provide a color
                 * per corner. The colors are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * Sets a fill-based tint on this Game Object.
                 * 
                 * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
                 * with those in the tint. You can use this for effects such as making a player flash 'white'
                 * if hit by something. You can provide either one color value, in which case the whole
                 * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
                 * are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The tint value being applied to the whole of the Game Object.
                 * Return `tintTopLeft` when read this tint property.
                 */
                tint: number;

                /**
                 * Does this Game Object have a tint applied?
                 * 
                 * It checks to see if the 4 tint properties are set to the value 0xffffff
                 * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
                 */
                readonly isTinted: boolean;

                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;

                /**
                 * The x position of this Game Object.
                 */
                x: number;

                /**
                 * The y position of this Game Object.
                 */
                y: number;

                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;

                /**
                 * The w position of this Game Object.
                 */
                w: number;

                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;

                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;

                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;

                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;

                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;

                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;

                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;

                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;

                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;

                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;

                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;

                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;

                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;

                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;

                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;

                /**
                 * Sets the body's horizontal and vertical acceleration. If the vertical acceleration value is not provided, the vertical acceleration is set to the same value as the horizontal acceleration.
                 * @param x The horizontal acceleration
                 * @param y The vertical acceleration Default x.
                 */
                setAcceleration(x: number, y?: number): this;

                /**
                 * Sets the body's horizontal acceleration.
                 * @param value The horizontal acceleration
                 */
                setAccelerationX(value: number): this;

                /**
                 * Sets the body's vertical acceleration.
                 * @param value The vertical acceleration
                 */
                setAccelerationY(value: number): this;

                /**
                 * Sets the angular velocity of the body.
                 * 
                 * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                 * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                 * causing them to visually rotate, even though the body remains axis-aligned.
                 * @param value The amount of angular velocity.
                 */
                setAngularVelocity(value: number): this;

                /**
                 * Sets the angular acceleration of the body.
                 * 
                 * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                 * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                 * causing them to visually rotate, even though the body remains axis-aligned.
                 * @param value The amount of angular acceleration.
                 */
                setAngularAcceleration(value: number): this;

                /**
                 * Sets the angular drag of the body. Drag is applied to the current velocity, providing a form of deceleration.
                 * @param value The amount of drag.
                 */
                setAngularDrag(value: number): this;

                /**
                 * Sets the bounce values of this body.
                 * 
                 * Bounce is the amount of restitution, or elasticity, the body has when it collides with another object.
                 * A value of 1 means that it will retain its full velocity after the rebound. A value of 0 means it will not rebound at all.
                 * @param x The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                 * @param y The amount of vertical bounce to apply on collision. A float, typically between 0 and 1. Default x.
                 */
                setBounce(x: number, y?: number): this;

                /**
                 * Sets the horizontal bounce value for this body.
                 * @param value The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                 */
                setBounceX(value: number): this;

                /**
                 * Sets the vertical bounce value for this body.
                 * @param value The amount of vertical bounce to apply on collision. A float, typically between 0 and 1.
                 */
                setBounceY(value: number): this;

                /**
                 * Sets whether this Body collides with the world boundary.
                 * 
                 * Optionally also sets the World Bounce values. If the `Body.worldBounce` is null, it's set to a new Phaser.Math.Vector2 first.
                 * @param value `true` if this body should collide with the world bounds, otherwise `false`. Default true.
                 * @param bounceX If given this will be replace the `worldBounce.x` value.
                 * @param bounceY If given this will be replace the `worldBounce.y` value.
                 * @param onWorldBounds If given this replaces the Body's `onWorldBounds` value.
                 */
                setCollideWorldBounds(value?: boolean, bounceX?: number, bounceY?: number, onWorldBounds?: boolean): this;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

                /**
                 * Sets the debug values of this body.
                 * 
                 * Bodies will only draw their debug if debug has been enabled for Arcade Physics as a whole.
                 * Note that there is a performance cost in drawing debug displays. It should never be used in production.
                 * @param showBody Set to `true` to have this body render its outline to the debug display.
                 * @param showVelocity Set to `true` to have this body render a velocity marker to the debug display.
                 * @param bodyColor The color of the body outline when rendered to the debug display.
                 */
                setDebug(showBody: boolean, showVelocity: boolean, bodyColor: number): this;

                /**
                 * Sets the color of the body outline when it renders to the debug display.
                 * @param value The color of the body outline when rendered to the debug display.
                 */
                setDebugBodyColor(value: number): this;

                /**
                 * Set to `true` to have this body render its outline to the debug display.
                 */
                debugShowBody: boolean;

                /**
                 * Set to `true` to have this body render a velocity marker to the debug display.
                 */
                debugShowVelocity: boolean;

                /**
                 * The color of the body outline when it renders to the debug display.
                 */
                debugBodyColor: number;

                /**
                 * Sets the body's horizontal and vertical drag. If the vertical drag value is not provided, the vertical drag is set to the same value as the horizontal drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param x The amount of horizontal drag to apply.
                 * @param y The amount of vertical drag to apply. Default x.
                 */
                setDrag(x: number, y?: number): this;

                /**
                 * Sets the body's horizontal drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param value The amount of horizontal drag to apply.
                 */
                setDragX(value: number): this;

                /**
                 * Sets the body's vertical drag.
                 * 
                 * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                 * It is the absolute loss of velocity due to movement, in pixels per second squared.
                 * The x and y components are applied separately.
                 * 
                 * When `useDamping` is true, this is 1 minus the damping factor.
                 * A value of 1 means the Body loses no velocity.
                 * A value of 0.95 means the Body loses 5% of its velocity per step.
                 * A value of 0.5 means the Body loses 50% of its velocity per step.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 * @param value The amount of vertical drag to apply.
                 */
                setDragY(value: number): this;

                /**
                 * If this Body is using `drag` for deceleration this function controls how the drag is applied.
                 * If set to `true` drag will use a damping effect rather than a linear approach. If you are
                 * creating a game where the Body moves freely at any angle (i.e. like the way the ship moves in
                 * the game Asteroids) then you will get a far smoother and more visually correct deceleration
                 * by using damping, avoiding the axis-drift that is prone with linear deceleration.
                 * 
                 * If you enable this property then you should use far smaller `drag` values than with linear, as
                 * they are used as a multiplier on the velocity. Values such as 0.95 will give a nice slow
                 * deceleration, where-as smaller values, such as 0.5 will stop an object almost immediately.
                 * @param value `true` to use damping for deceleration, or `false` to use linear deceleration.
                 */
                setDamping(value: boolean): this;

                /**
                 * Sets whether this Body should calculate its velocity based on its change in
                 * position every frame. The default, which is to not do this, means that you
                 * make this Body move by setting the velocity directly. However, if you are
                 * trying to move this Body via a Tween, or have it follow a Path, then you
                 * should enable this instead. This will allow it to still collide with other
                 * bodies, something that isn't possible if you're just changing its position directly.
                 * @param value `true` if the Body calculate velocity based on changes in position, otherwise `false`. Default true.
                 */
                setDirectControl(value?: boolean): this;

                /**
                 * Enables this Game Object's Body.
                 * If you reset the Body you must also pass `x` and `y`.
                 * @param reset Also reset the Body and place the Game Object at (x, y).
                 * @param x The horizontal position to place the Game Object, if `reset` is true.
                 * @param y The horizontal position to place the Game Object, if `reset` is true.
                 * @param enableGameObject Also set this Game Object's `active` to true.
                 * @param showGameObject Also set this Game Object's `visible` to true.
                 */
                enableBody(reset?: boolean, x?: number, y?: number, enableGameObject?: boolean, showGameObject?: boolean): this;

                /**
                 * Stops and disables this Game Object's Body.
                 * @param disableGameObject Also set this Game Object's `active` to false. Default false.
                 * @param hideGameObject Also set this Game Object's `visible` to false. Default false.
                 */
                disableBody(disableGameObject?: boolean, hideGameObject?: boolean): this;

                /**
                 * Syncs the Body's position and size with its parent Game Object.
                 * You don't need to call this for Dynamic Bodies, as it happens automatically.
                 * But for Static bodies it's a useful way of modifying the position of a Static Body
                 * in the Physics World, based on its Game Object.
                 */
                refreshBody(): this;

                /**
                 * Sets the friction of this game object's physics body.
                 * In Arcade Physics, friction is a special case of motion transfer from an "immovable" body to a riding body.
                 * @param x The amount of horizontal friction to apply, [0, 1].
                 * @param y The amount of vertical friction to apply, [0, 1]. Default x.
                 */
                setFriction(x: number, y?: number): this;

                /**
                 * Sets the horizontal friction of this game object's physics body.
                 * This can move a riding body horizontally when it collides with this one on the vertical axis.
                 * @param x The amount of friction to apply, [0, 1].
                 */
                setFrictionX(x: number): this;

                /**
                 * Sets the vertical friction of this game object's physics body.
                 * This can move a riding body vertically when it collides with this one on the horizontal axis.
                 * @param y The amount of friction to apply, [0, 1].
                 */
                setFrictionY(y: number): this;

                /**
                 * Set the X and Y values of the gravitational pull to act upon this Arcade Physics Game Object. Values can be positive or negative. Larger values result in a stronger effect.
                 * 
                 * If only one value is provided, this value will be used for both the X and Y axis.
                 * @param x The gravitational force to be applied to the X-axis.
                 * @param y The gravitational force to be applied to the Y-axis. If this is not specified, the X value will be used. Default x.
                 */
                setGravity(x: number, y?: number): this;

                /**
                 * Set the gravitational force to be applied to the X axis. Value can be positive or negative. Larger values result in a stronger effect.
                 * @param x The gravitational force to be applied to the X-axis.
                 */
                setGravityX(x: number): this;

                /**
                 * Set the gravitational force to be applied to the Y axis. Value can be positive or negative. Larger values result in a stronger effect.
                 * @param y The gravitational force to be applied to the Y-axis.
                 */
                setGravityY(y: number): this;

                /**
                 * Sets if this Body can be separated during collisions with other bodies.
                 * 
                 * When a body is immovable it means it won't move at all, not even to separate it from collision
                 * overlap. If you just wish to prevent a body from being knocked around by other bodies, see
                 * the `setPushable` method instead.
                 * @param value Sets if this body will be separated during collisions with other bodies. Default true.
                 */
                setImmovable(value?: boolean): this;

                /**
                 * Sets the mass of the physics body
                 * @param value New value for the mass of the body.
                 */
                setMass(value: number): this;

                /**
                 * Sets if this Body can be pushed by another Body.
                 * 
                 * A body that cannot be pushed will reflect back all of the velocity it is given to the
                 * colliding body. If that body is also not pushable, then the separation will be split
                 * between them evenly.
                 * 
                 * If you want your body to never move or seperate at all, see the `setImmovable` method.
                 * @param value Sets if this body can be pushed by collisions with another Body. Default true.
                 */
                setPushable(value?: boolean): this;

                /**
                 * Sets the body offset. This allows you to adjust the difference between the center of the body
                 * and the x and y coordinates of the parent Game Object.
                 * @param x The amount to offset the body from the parent Game Object along the x-axis.
                 * @param y The amount to offset the body from the parent Game Object along the y-axis. Defaults to the value given for the x-axis. Default x.
                 */
                setOffset(x: number, y?: number): this;

                /**
                 * Sets the size of this physics body. Setting the size does not adjust the dimensions of the parent Game Object.
                 * @param width The new width of the physics body, in pixels.
                 * @param height The new height of the physics body, in pixels.
                 * @param center Should the body be re-positioned so its center aligns with the parent Game Object? Default true.
                 */
                setBodySize(width: number, height: number, center?: boolean): this;

                /**
                 * Sets this physics body to use a circle for collision instead of a rectangle.
                 * @param radius The radius of the physics body, in pixels.
                 * @param offsetX The amount to offset the body from the parent Game Object along the x-axis.
                 * @param offsetY The amount to offset the body from the parent Game Object along the y-axis.
                 */
                setCircle(radius: number, offsetX?: number, offsetY?: number): this;

                /**
                 * Sets the velocity of the Body.
                 * @param x The horizontal velocity of the body. Positive values move the body to the right, while negative values move it to the left.
                 * @param y The vertical velocity of the body. Positive values move the body down, while negative values move it up. Default x.
                 */
                setVelocity(x: number, y?: number): this;

                /**
                 * Sets the horizontal component of the body's velocity.
                 * 
                 * Positive values move the body to the right, while negative values move it to the left.
                 * @param x The new horizontal velocity.
                 */
                setVelocityX(x: number): this;

                /**
                 * Sets the vertical component of the body's velocity.
                 * 
                 * Positive values move the body down, while negative values move it up.
                 * @param y The new vertical velocity of the body.
                 */
                setVelocityY(y: number): this;

                /**
                 * Sets the maximum velocity of the body.
                 * @param x The new maximum horizontal velocity.
                 * @param y The new maximum vertical velocity. Default x.
                 */
                setMaxVelocity(x: number, y?: number): this;

            }

            /**
             * A Dynamic Arcade Body.
             * 
             * Its static counterpart is {@link Phaser.Physics.Arcade.StaticBody}.
             */
            class Body implements Phaser.Physics.Arcade.Components.Collision {
                /**
                 * 
                 * @param world The Arcade Physics simulation this Body belongs to.
                 * @param gameObject The Game Object this Body belongs to. As of Phaser 3.60 this is now optional.
                 */
                constructor(world: Phaser.Physics.Arcade.World, gameObject?: Phaser.GameObjects.GameObject);

                /**
                 * The Arcade Physics simulation this Body belongs to.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * The Game Object this Body belongs to.
                 * 
                 * As of Phaser 3.60 this is now optional and can be undefined.
                 */
                gameObject: Phaser.GameObjects.GameObject;

                /**
                 * A quick-test flag that signifies this is a Body, used in the World collision handler.
                 */
                readonly isBody: boolean;

                /**
                 * Transformations applied to this Body.
                 */
                transform: object;

                /**
                 * Whether the Body is drawn to the debug display.
                 */
                debugShowBody: boolean;

                /**
                 * Whether the Body's velocity is drawn to the debug display.
                 */
                debugShowVelocity: boolean;

                /**
                 * The color of this Body on the debug display.
                 */
                debugBodyColor: number;

                /**
                 * Whether this Body is updated by the physics simulation.
                 */
                enable: boolean;

                /**
                 * Whether this Body is circular (true) or rectangular (false).
                 */
                isCircle: boolean;

                /**
                 * If this Body is circular, this is the unscaled radius of the Body, as set by setCircle(), in source pixels.
                 * The true radius is equal to `halfWidth`.
                 */
                radius: number;

                /**
                 * The offset of this Body's position from its Game Object's position, in source pixels.
                 */
                offset: Phaser.Math.Vector2;

                /**
                 * The position of this Body within the simulation.
                 */
                position: Phaser.Math.Vector2;

                /**
                 * The position of this Body during the previous step.
                 */
                prev: Phaser.Math.Vector2;

                /**
                 * The position of this Body during the previous frame.
                 */
                prevFrame: Phaser.Math.Vector2;

                /**
                 * Whether this Body's `rotation` is affected by its angular acceleration and angular velocity.
                 */
                allowRotation: boolean;

                /**
                 * This body's rotation, in degrees, based on its angular acceleration and angular velocity.
                 * The Body's rotation controls the `angle` of its Game Object.
                 * It doesn't rotate the Body's own geometry, which is always an axis-aligned rectangle or a circle.
                 */
                rotation: number;

                /**
                 * The Body rotation, in degrees, during the previous step.
                 */
                preRotation: number;

                /**
                 * The width of the Body, in pixels.
                 * If the Body is circular, this is also the diameter.
                 * If you wish to change the width use the `Body.setSize` method.
                 */
                readonly width: number;

                /**
                 * The height of the Body, in pixels.
                 * If the Body is circular, this is also the diameter.
                 * If you wish to change the height use the `Body.setSize` method.
                 */
                readonly height: number;

                /**
                 * The unscaled width of the Body, in source pixels, as set by setSize().
                 * The default is the width of the Body's Game Object's texture frame.
                 */
                sourceWidth: number;

                /**
                 * The unscaled height of the Body, in source pixels, as set by setSize().
                 * The default is the height of the Body's Game Object's texture frame.
                 */
                sourceHeight: number;

                /**
                 * Half the Body's width, in pixels.
                 */
                halfWidth: number;

                /**
                 * Half the Body's height, in pixels.
                 */
                halfHeight: number;

                /**
                 * The center of the Body.
                 * The midpoint of its `position` (top-left corner) and its bottom-right corner.
                 */
                center: Phaser.Math.Vector2;

                /**
                 * The Body's velocity, in pixels per second.
                 */
                velocity: Phaser.Math.Vector2;

                /**
                 * The Body's change in position (due to velocity) at the last step, in pixels.
                 * 
                 * The size of this value depends on the simulation's step rate.
                 */
                readonly newVelocity: Phaser.Math.Vector2;

                /**
                 * The Body's absolute maximum change in position, in pixels per step.
                 */
                deltaMax: Phaser.Math.Vector2;

                /**
                 * The Body's change in velocity, in pixels per second squared.
                 */
                acceleration: Phaser.Math.Vector2;

                /**
                 * Whether this Body's velocity is affected by its `drag`.
                 */
                allowDrag: boolean;

                /**
                 * When `useDamping` is false (the default), this is absolute loss of velocity due to movement, in pixels per second squared.
                 * 
                 * When `useDamping` is true, this is a damping multiplier between 0 and 1.
                 * A value of 0 means the Body stops instantly.
                 * A value of 0.01 mean the Body keeps 1% of its velocity per second, losing 99%.
                 * A value of 0.1 means the Body keeps 10% of its velocity per second, losing 90%.
                 * A value of 1 means the Body loses no velocity.
                 * You can use very small values (e.g., 0.001) to stop the Body quickly.
                 * 
                 * The x and y components are applied separately.
                 * 
                 * Drag is applied only when `acceleration` is zero.
                 */
                drag: Phaser.Math.Vector2;

                /**
                 * Whether this Body's position is affected by gravity (local or world).
                 */
                allowGravity: boolean;

                /**
                 * Acceleration due to gravity (specific to this Body), in pixels per second squared.
                 * Total gravity is the sum of this vector and the simulation's `gravity`.
                 */
                gravity: Phaser.Math.Vector2;

                /**
                 * Rebound following a collision, relative to 1.
                 */
                bounce: Phaser.Math.Vector2;

                /**
                 * Rebound following a collision with the world boundary, relative to 1.
                 * If null, `bounce` is used instead.
                 */
                worldBounce: Phaser.Math.Vector2 | null;

                /**
                 * The rectangle used for world boundary collisions.
                 * 
                 * By default it is set to the world boundary rectangle. Or, if this Body was
                 * created by a Physics Group, then whatever rectangle that Group defined.
                 * 
                 * You can also change it by using the `Body.setBoundsRectangle` method.
                 */
                customBoundsRectangle: Phaser.Geom.Rectangle;

                /**
                 * Whether the simulation emits a `worldbounds` event when this Body collides with the world boundary
                 * (and `collideWorldBounds` is also true).
                 */
                onWorldBounds: boolean;

                /**
                 * Whether the simulation emits a `collide` event when this Body collides with another.
                 */
                onCollide: boolean;

                /**
                 * Whether the simulation emits an `overlap` event when this Body overlaps with another.
                 */
                onOverlap: boolean;

                /**
                 * The absolute maximum velocity of this body, in pixels per second.
                 * The horizontal and vertical components are applied separately.
                 */
                maxVelocity: Phaser.Math.Vector2;

                /**
                 * The maximum speed this Body is allowed to reach, in pixels per second.
                 * 
                 * If not negative it limits the scalar value of speed.
                 * 
                 * Any negative value means no maximum is being applied (the default).
                 */
                maxSpeed: number;

                /**
                 * If this Body is `immovable` and in motion, `friction` is the proportion of this Body's motion received by the riding Body on each axis, relative to 1.
                 * The horizontal component (x) is applied only when two colliding Bodies are separated vertically.
                 * The vertical component (y) is applied only when two colliding Bodies are separated horizontally.
                 * The default value (1, 0) moves the riding Body horizontally in equal proportion to this Body and vertically not at all.
                 */
                friction: Phaser.Math.Vector2;

                /**
                 * If this Body is using `drag` for deceleration this property controls how the drag is applied.
                 * If set to `true` drag will use a damping effect rather than a linear approach. If you are
                 * creating a game where the Body moves freely at any angle (i.e. like the way the ship moves in
                 * the game Asteroids) then you will get a far smoother and more visually correct deceleration
                 * by using damping, avoiding the axis-drift that is prone with linear deceleration.
                 * 
                 * If you enable this property then you should use far smaller `drag` values than with linear, as
                 * they are used as a multiplier on the velocity. Values such as 0.05 will give a nice slow
                 * deceleration.
                 */
                useDamping: boolean;

                /**
                 * The rate of change of this Body's `rotation`, in degrees per second.
                 */
                angularVelocity: number;

                /**
                 * The Body's angular acceleration (change in angular velocity), in degrees per second squared.
                 */
                angularAcceleration: number;

                /**
                 * Loss of angular velocity due to angular movement, in degrees per second.
                 * 
                 * Angular drag is applied only when angular acceleration is zero.
                 */
                angularDrag: number;

                /**
                 * The Body's maximum angular velocity, in degrees per second.
                 */
                maxAngular: number;

                /**
                 * The Body's inertia, relative to a default unit (1).
                 * With `bounce`, this affects the exchange of momentum (velocities) during collisions.
                 */
                mass: number;

                /**
                 * The calculated angle of this Body's velocity vector, in radians, during the last step.
                 */
                angle: number;

                /**
                 * The calculated magnitude of the Body's velocity, in pixels per second, during the last step.
                 */
                speed: number;

                /**
                 * The direction of the Body's velocity, as calculated during the last step.
                 * This is a numeric constant value (FACING_UP, FACING_DOWN, FACING_LEFT, FACING_RIGHT).
                 * If the Body is moving on both axes, this describes motion on the vertical axis only.
                 */
                facing: number;

                /**
                 * Whether this Body can be moved by collisions with another Body.
                 */
                immovable: boolean;

                /**
                 * Sets if this Body can be pushed by another Body.
                 * 
                 * A body that cannot be pushed will reflect back all of the velocity it is given to the
                 * colliding body. If that body is also not pushable, then the separation will be split
                 * between them evenly.
                 * 
                 * If you want your body to never move or seperate at all, see the `setImmovable` method.
                 * 
                 * By default, Dynamic Bodies are always pushable.
                 */
                pushable: boolean;

                /**
                 * The Slide Factor of this Body.
                 * 
                 * The Slide Factor controls how much velocity is preserved when
                 * this Body is pushed by another Body.
                 * 
                 * The default value is 1, which means that it will take on all
                 * velocity given in the push. You can adjust this value to control
                 * how much velocity is retained by this Body when the push ends.
                 * 
                 * A value of 0, for example, will allow this Body to be pushed
                 * but then remain completely still after the push ends, such as
                 * you see in a game like Sokoban.
                 * 
                 * Or you can set a mid-point, such as 0.25 which will allow it
                 * to keep 25% of the original velocity when the push ends. You
                 * can combine this with the `setDrag()` method to create deceleration.
                 */
                slideFactor: Phaser.Math.Vector2;

                /**
                 * Whether the Body's position and rotation are affected by its velocity, acceleration, drag, and gravity.
                 */
                moves: boolean;

                /**
                 * A flag disabling the default horizontal separation of colliding bodies.
                 * Pass your own `collideCallback` to the collider.
                 */
                customSeparateX: boolean;

                /**
                 * A flag disabling the default vertical separation of colliding bodies.
                 * Pass your own `collideCallback` to the collider.
                 */
                customSeparateY: boolean;

                /**
                 * The amount of horizontal overlap (before separation), if this Body is colliding with another.
                 */
                overlapX: number;

                /**
                 * The amount of vertical overlap (before separation), if this Body is colliding with another.
                 */
                overlapY: number;

                /**
                 * The amount of overlap (before separation), if this Body is circular and colliding with another circular body.
                 */
                overlapR: number;

                /**
                 * Whether this Body is overlapped with another and both are not moving, on at least one axis.
                 */
                embedded: boolean;

                /**
                 * Whether this Body interacts with the world boundary.
                 */
                collideWorldBounds: boolean;

                /**
                 * Whether this Body is checked for collisions and for which directions.
                 * You can set `checkCollision.none = true` to disable collision checks.
                 */
                checkCollision: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * Whether this Body is colliding with a Body or Static Body and in which direction.
                 * In a collision where both bodies have zero velocity, `embedded` will be set instead.
                 */
                touching: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * This Body's `touching` value during the previous step.
                 */
                wasTouching: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * Whether this Body is colliding with a Static Body, a tile, or the world boundary.
                 * In a collision with a Static Body, if this Body has zero velocity then `embedded` will be set instead.
                 */
                blocked: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * Whether to automatically synchronize this Body's dimensions to the dimensions of its Game Object's visual bounds.
                 */
                syncBounds: boolean;

                /**
                 * The Body's physics type (dynamic or static).
                 */
                readonly physicsType: number;

                /**
                 * The Arcade Physics Body Collision Category.
                 * 
                 * This can be set to any valid collision bitfield value.
                 * 
                 * See the `setCollisionCategory` method for more details.
                 */
                collisionCategory: number;

                /**
                 * The Arcade Physics Body Collision Mask.
                 * 
                 * See the `setCollidesWith` method for more details.
                 */
                collisionMask: number;

                /**
                 * Is this Body under direct control, outside of the physics engine? For example,
                 * are you trying to move it via a Tween? Or have it follow a path? If so then
                 * you can enable this boolean so that the Body will calculate its velocity based
                 * purely on its change in position each frame. This allows you to then tween
                 * the position and still have it collide with other objects. However, setting
                 * the velocity will have no impact on this Body while this is set.
                 */
                directControl: boolean;

                /**
                 * Updates the Body's `transform`, `width`, `height`, and `center` from its Game Object.
                 * The Body's `position` isn't changed.
                 */
                updateBounds(): void;

                /**
                 * Updates the Body's `center` from its `position`, `width`, and `height`.
                 */
                updateCenter(): void;

                /**
                 * Updates the Body's `position`, `width`, `height`, and `center` from its Game Object and `offset`.
                 * 
                 * You don't need to call this for Dynamic Bodies, as it happens automatically during the physics step.
                 * But you could use it if you have modified the Body offset or Game Object transform and need to immediately
                 * read the Body's new `position` or `center`.
                 * 
                 * To resynchronize the Body with its Game Object, use `reset()` instead.
                 */
                updateFromGameObject(): void;

                /**
                 * Prepares the Body for a physics step by resetting the `wasTouching`, `touching` and `blocked` states.
                 * 
                 * This method is only called if the physics world is going to run a step this frame.
                 * @param clear Set the `wasTouching` values to their defaults. Default false.
                 */
                resetFlags(clear?: boolean): void;

                /**
                 * Syncs the position body position with the parent Game Object.
                 * 
                 * This method is called every game frame, regardless if the world steps or not.
                 * @param willStep Will this Body run an update as well?
                 * @param delta The delta time, in seconds, elapsed since the last frame.
                 */
                preUpdate(willStep: boolean, delta: number): void;

                /**
                 * Performs a single physics step and updates the body velocity, angle, speed and other properties.
                 * 
                 * This method can be called multiple times per game frame, depending on the physics step rate.
                 * 
                 * The results are synced back to the Game Object in `postUpdate`.
                 * @param delta The delta time, in seconds, elapsed since the last frame.
                 */
                update(delta: number): void;

                /**
                 * Feeds the Body results back into the parent Game Object.
                 * 
                 * This method is called every game frame, regardless if the world steps or not.
                 */
                postUpdate(): void;

                /**
                 * Sets a custom collision boundary rectangle. Use if you want to have a custom
                 * boundary instead of the world boundaries.
                 * @param bounds The new boundary rectangle. Pass `null` to use the World bounds.
                 */
                setBoundsRectangle(bounds?: Phaser.Geom.Rectangle | undefined): this;

                /**
                 * Checks for collisions between this Body and the world boundary and separates them.
                 */
                checkWorldBounds(): boolean;

                /**
                 * Sets the offset of the Body's position from its Game Object's position.
                 * The Body's `position` isn't changed until the next `preUpdate`.
                 * @param x The horizontal offset, in source pixels.
                 * @param y The vertical offset, in source pixels. Default x.
                 */
                setOffset(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Assign this Body to a new Game Object.
                 * 
                 * Removes this body from the Physics World, assigns to the new Game Object, calls `setSize` and then
                 * adds this body back into the World again, setting it enabled, unless the `enable` argument is set to `false`.
                 * 
                 * If this body already has a Game Object, then it will remove itself from that Game Object first.
                 * 
                 * Only if the given `gameObject` has a `body` property will this Body be assigned to it.
                 * @param gameObject The Game Object this Body belongs to.
                 * @param enable Automatically enable this Body for physics. Default true.
                 */
                setGameObject(gameObject: Phaser.GameObjects.GameObject, enable?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sizes and positions this Body, as a rectangle.
                 * Modifies the Body `offset` if `center` is true (the default).
                 * Resets the width and height to match current frame, if no width and height provided and a frame is found.
                 * @param width The width of the Body in pixels. Cannot be zero. If not given, and the parent Game Object has a frame, it will use the frame width.
                 * @param height The height of the Body in pixels. Cannot be zero. If not given, and the parent Game Object has a frame, it will use the frame height.
                 * @param center Modify the Body's `offset`, placing the Body's center on its Game Object's center. Only works if the Game Object has the `getCenter` method. Default true.
                 */
                setSize(width?: number, height?: number, center?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sizes and positions this Body, as a circle.
                 * @param radius The radius of the Body, in source pixels.
                 * @param offsetX The horizontal offset of the Body from its Game Object, in source pixels.
                 * @param offsetY The vertical offset of the Body from its Game Object, in source pixels.
                 */
                setCircle(radius: number, offsetX?: number, offsetY?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets this Body's parent Game Object to the given coordinates and resets this Body at the new coordinates.
                 * If the Body had any velocity or acceleration it is lost as a result of calling this.
                 * @param x The horizontal position to place the Game Object.
                 * @param y The vertical position to place the Game Object.
                 */
                reset(x: number, y: number): void;

                /**
                 * Sets acceleration, velocity, and speed to zero.
                 */
                stop(): Phaser.Physics.Arcade.Body;

                /**
                 * Copies the coordinates of this Body's edges into an object.
                 * @param obj An object to copy the values into.
                 */
                getBounds(obj: Phaser.Types.Physics.Arcade.ArcadeBodyBounds): Phaser.Types.Physics.Arcade.ArcadeBodyBounds;

                /**
                 * Tests if the coordinates are within this Body.
                 * @param x The horizontal coordinate.
                 * @param y The vertical coordinate.
                 */
                hitTest(x: number, y: number): boolean;

                /**
                 * Whether this Body is touching a tile or the world boundary while moving down.
                 */
                onFloor(): boolean;

                /**
                 * Whether this Body is touching a tile or the world boundary while moving up.
                 */
                onCeiling(): boolean;

                /**
                 * Whether this Body is touching a tile or the world boundary while moving left or right.
                 */
                onWall(): boolean;

                /**
                 * The absolute (non-negative) change in this Body's horizontal position from the previous step.
                 */
                deltaAbsX(): number;

                /**
                 * The absolute (non-negative) change in this Body's vertical position from the previous step.
                 */
                deltaAbsY(): number;

                /**
                 * The change in this Body's horizontal position from the previous step.
                 * This value is set during the Body's update phase.
                 * 
                 * As a Body can update multiple times per step this may not hold the final
                 * delta value for the Body. In this case, please see the `deltaXFinal` method.
                 */
                deltaX(): number;

                /**
                 * The change in this Body's vertical position from the previous step.
                 * This value is set during the Body's update phase.
                 * 
                 * As a Body can update multiple times per step this may not hold the final
                 * delta value for the Body. In this case, please see the `deltaYFinal` method.
                 */
                deltaY(): number;

                /**
                 * The change in this Body's horizontal position from the previous game update.
                 * 
                 * This value is set during the `postUpdate` phase and takes into account the
                 * `deltaMax` and final position of the Body.
                 * 
                 * Because this value is not calculated until `postUpdate`, you must listen for it
                 * during a Scene `POST_UPDATE` or `RENDER` event, and not in `update`, as it will
                 * not be calculated by that point. If you _do_ use these values in `update` they
                 * will represent the delta from the _previous_ game frame.
                 */
                deltaXFinal(): number;

                /**
                 * The change in this Body's vertical position from the previous game update.
                 * 
                 * This value is set during the `postUpdate` phase and takes into account the
                 * `deltaMax` and final position of the Body.
                 * 
                 * Because this value is not calculated until `postUpdate`, you must listen for it
                 * during a Scene `POST_UPDATE` or `RENDER` event, and not in `update`, as it will
                 * not be calculated by that point. If you _do_ use these values in `update` they
                 * will represent the delta from the _previous_ game frame.
                 */
                deltaYFinal(): number;

                /**
                 * The change in this Body's rotation from the previous step, in degrees.
                 */
                deltaZ(): number;

                /**
                 * Disables this Body and marks it for deletion by the simulation.
                 */
                destroy(): void;

                /**
                 * Draws this Body and its velocity, if enabled.
                 * @param graphic The Graphics object to draw on.
                 */
                drawDebug(graphic: Phaser.GameObjects.Graphics): void;

                /**
                 * Whether this Body will be drawn to the debug display.
                 */
                willDrawDebug(): boolean;

                /**
                 * Sets whether this Body should calculate its velocity based on its change in
                 * position every frame. The default, which is to not do this, means that you
                 * make this Body move by setting the velocity directly. However, if you are
                 * trying to move this Body via a Tween, or have it follow a Path, then you
                 * should enable this instead. This will allow it to still collide with other
                 * bodies, something that isn't possible if you're just changing its position directly.
                 * @param value `true` if the Body calculate velocity based on changes in position, otherwise `false`. Default true.
                 */
                setDirectControl(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sets whether this Body collides with the world boundary.
                 * 
                 * Optionally also sets the World Bounce and `onWorldBounds` values.
                 * @param value `true` if the Body should collide with the world bounds, otherwise `false`. Default true.
                 * @param bounceX If given this replaces the Body's `worldBounce.x` value.
                 * @param bounceY If given this replaces the Body's `worldBounce.y` value.
                 * @param onWorldBounds If given this replaces the Body's `onWorldBounds` value.
                 */
                setCollideWorldBounds(value?: boolean, bounceX?: number, bounceY?: number, onWorldBounds?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's velocity.
                 * @param x The horizontal velocity, in pixels per second.
                 * @param y The vertical velocity, in pixels per second. Default x.
                 */
                setVelocity(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal velocity.
                 * @param value The velocity, in pixels per second.
                 */
                setVelocityX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical velocity.
                 * @param value The velocity, in pixels per second.
                 */
                setVelocityY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's maximum velocity.
                 * @param x The horizontal velocity, in pixels per second.
                 * @param y The vertical velocity, in pixels per second. Default x.
                 */
                setMaxVelocity(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's maximum horizontal velocity.
                 * @param value The maximum horizontal velocity, in pixels per second.
                 */
                setMaxVelocityX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's maximum vertical velocity.
                 * @param value The maximum vertical velocity, in pixels per second.
                 */
                setMaxVelocityY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the maximum speed the Body can move.
                 * @param value The maximum speed value, in pixels per second. Set to a negative value to disable.
                 */
                setMaxSpeed(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Slide Factor of this Body.
                 * 
                 * The Slide Factor controls how much velocity is preserved when
                 * this Body is pushed by another Body.
                 * 
                 * The default value is 1, which means that it will take on all
                 * velocity given in the push. You can adjust this value to control
                 * how much velocity is retained by this Body when the push ends.
                 * 
                 * A value of 0, for example, will allow this Body to be pushed
                 * but then remain completely still after the push ends, such as
                 * you see in a game like Sokoban.
                 * 
                 * Or you can set a mid-point, such as 0.25 which will allow it
                 * to keep 25% of the original velocity when the push ends. You
                 * can combine this with the `setDrag()` method to create deceleration.
                 * @param x The horizontal slide factor. A value between 0 and 1.
                 * @param y The vertical slide factor. A value between 0 and 1. Default x.
                 */
                setSlideFactor(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's bounce.
                 * @param x The horizontal bounce, relative to 1.
                 * @param y The vertical bounce, relative to 1. Default x.
                 */
                setBounce(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal bounce.
                 * @param value The bounce, relative to 1.
                 */
                setBounceX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical bounce.
                 * @param value The bounce, relative to 1.
                 */
                setBounceY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's acceleration.
                 * @param x The horizontal component, in pixels per second squared.
                 * @param y The vertical component, in pixels per second squared. Default x.
                 */
                setAcceleration(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal acceleration.
                 * @param value The acceleration, in pixels per second squared.
                 */
                setAccelerationX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical acceleration.
                 * @param value The acceleration, in pixels per second squared.
                 */
                setAccelerationY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Enables or disables drag.
                 * @param value `true` to allow drag on this body, or `false` to disable it. Default true.
                 */
                setAllowDrag(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Enables or disables gravity's effect on this Body.
                 * @param value `true` to allow gravity on this body, or `false` to disable it. Default true.
                 */
                setAllowGravity(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Enables or disables rotation.
                 * @param value `true` to allow rotation on this body, or `false` to disable it. Default true.
                 */
                setAllowRotation(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's drag.
                 * @param x The horizontal component, in pixels per second squared.
                 * @param y The vertical component, in pixels per second squared. Default x.
                 */
                setDrag(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * If this Body is using `drag` for deceleration this property controls how the drag is applied.
                 * If set to `true` drag will use a damping effect rather than a linear approach. If you are
                 * creating a game where the Body moves freely at any angle (i.e. like the way the ship moves in
                 * the game Asteroids) then you will get a far smoother and more visually correct deceleration
                 * by using damping, avoiding the axis-drift that is prone with linear deceleration.
                 * 
                 * If you enable this property then you should use far smaller `drag` values than with linear, as
                 * they are used as a multiplier on the velocity. Values such as 0.95 will give a nice slow
                 * deceleration, where-as smaller values, such as 0.5 will stop an object almost immediately.
                 * @param value `true` to use damping, or `false` to use drag.
                 */
                setDamping(value: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal drag.
                 * @param value The drag, in pixels per second squared.
                 */
                setDragX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical drag.
                 * @param value The drag, in pixels per second squared.
                 */
                setDragY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's gravity.
                 * @param x The horizontal component, in pixels per second squared.
                 * @param y The vertical component, in pixels per second squared. Default x.
                 */
                setGravity(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal gravity.
                 * @param value The gravity, in pixels per second squared.
                 */
                setGravityX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical gravity.
                 * @param value The gravity, in pixels per second squared.
                 */
                setGravityY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's friction.
                 * @param x The horizontal component, relative to 1.
                 * @param y The vertical component, relative to 1. Default x.
                 */
                setFriction(x: number, y?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's horizontal friction.
                 * @param value The friction value, relative to 1.
                 */
                setFrictionX(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's vertical friction.
                 * @param value The friction value, relative to 1.
                 */
                setFrictionY(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's angular velocity.
                 * @param value The velocity, in degrees per second.
                 */
                setAngularVelocity(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's angular acceleration.
                 * @param value The acceleration, in degrees per second squared.
                 */
                setAngularAcceleration(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's angular drag.
                 * @param value The drag, in degrees per second squared.
                 */
                setAngularDrag(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's mass.
                 * @param value The mass value, relative to 1.
                 */
                setMass(value: number): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's `immovable` property.
                 * @param value The value to assign to `immovable`. Default true.
                 */
                setImmovable(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * Sets the Body's `enable` property.
                 * @param value The value to assign to `enable`. Default true.
                 */
                setEnable(value?: boolean): Phaser.Physics.Arcade.Body;

                /**
                 * This is an internal handler, called by the `ProcessX` function as part
                 * of the collision step. You should almost never call this directly.
                 * @param x The amount to add to the Body position.
                 * @param vx The amount to add to the Body velocity.
                 * @param left Set the blocked.left value?
                 * @param right Set the blocked.right value?
                 */
                processX(x: number, vx?: number, left?: boolean, right?: boolean): void;

                /**
                 * This is an internal handler, called by the `ProcessY` function as part
                 * of the collision step. You should almost never call this directly.
                 * @param y The amount to add to the Body position.
                 * @param vy The amount to add to the Body velocity.
                 * @param up Set the blocked.up value?
                 * @param down Set the blocked.down value?
                 */
                processY(y: number, vy?: number, up?: boolean, down?: boolean): void;

                /**
                 * The Bodys horizontal position (left edge).
                 */
                x: number;

                /**
                 * The Bodys vertical position (top edge).
                 */
                y: number;

                /**
                 * The left edge of the Body. Identical to x.
                 */
                readonly left: number;

                /**
                 * The right edge of the Body.
                 */
                readonly right: number;

                /**
                 * The top edge of the Body. Identical to y.
                 */
                readonly top: number;

                /**
                 * The bottom edge of this Body.
                 */
                readonly bottom: number;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

            }

            /**
             * An Arcade Physics Collider will automatically check for collision, or overlaps, between two objects
             * every step. If a collision, or overlap, occurs it will invoke the given callbacks.
             */
            class Collider {
                /**
                 * 
                 * @param world The Arcade physics World that will manage the collisions.
                 * @param overlapOnly Whether to check for collisions or overlap.
                 * @param object1 The first object to check for collision.
                 * @param object2 The second object to check for collision.
                 * @param collideCallback The callback to invoke when the two objects collide.
                 * @param processCallback The callback to invoke when the two objects collide. Must return a boolean.
                 * @param callbackContext The scope in which to call the callbacks.
                 */
                constructor(world: Phaser.Physics.Arcade.World, overlapOnly: boolean, object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext: any);

                /**
                 * The world in which the bodies will collide.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * The name of the collider (unused by Phaser).
                 */
                name: string;

                /**
                 * Whether the collider is active.
                 */
                active: boolean;

                /**
                 * Whether to check for collisions or overlaps.
                 */
                overlapOnly: boolean;

                /**
                 * The first object to check for collision.
                 */
                object1: Phaser.Types.Physics.Arcade.ArcadeColliderType;

                /**
                 * The second object to check for collision.
                 */
                object2: Phaser.Types.Physics.Arcade.ArcadeColliderType;

                /**
                 * The callback to invoke when the two objects collide.
                 */
                collideCallback: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback;

                /**
                 * If a processCallback exists it must return true or collision checking will be skipped.
                 */
                processCallback: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback;

                /**
                 * The context the collideCallback and processCallback will run in.
                 */
                callbackContext: object;

                /**
                 * A name for the Collider.
                 * 
                 * Phaser does not use this value, it's for your own reference.
                 * @param name The name to assign to the Collider.
                 */
                setName(name: string): Phaser.Physics.Arcade.Collider;

                /**
                 * Called by World as part of its step processing, initial operation of collision checking.
                 */
                update(): void;

                /**
                 * Removes Collider from World and disposes of its resources.
                 */
                destroy(): void;

            }

            namespace Components {
                /**
                 * Provides methods used for setting the acceleration properties of an Arcade Physics Body.
                 */
                interface Acceleration {
                    /**
                     * Sets the body's horizontal and vertical acceleration. If the vertical acceleration value is not provided, the vertical acceleration is set to the same value as the horizontal acceleration.
                     * @param x The horizontal acceleration
                     * @param y The vertical acceleration Default x.
                     */
                    setAcceleration(x: number, y?: number): this;
                    /**
                     * Sets the body's horizontal acceleration.
                     * @param value The horizontal acceleration
                     */
                    setAccelerationX(value: number): this;
                    /**
                     * Sets the body's vertical acceleration.
                     * @param value The vertical acceleration
                     */
                    setAccelerationY(value: number): this;
                }

                /**
                 * Provides methods used for setting the angular acceleration properties of an Arcade Physics Body.
                 */
                interface Angular {
                    /**
                     * Sets the angular velocity of the body.
                     * 
                     * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                     * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                     * causing them to visually rotate, even though the body remains axis-aligned.
                     * @param value The amount of angular velocity.
                     */
                    setAngularVelocity(value: number): this;
                    /**
                     * Sets the angular acceleration of the body.
                     * 
                     * In Arcade Physics, bodies cannot rotate. They are always axis-aligned.
                     * However, they can have angular motion, which is passed on to the Game Object bound to the body,
                     * causing them to visually rotate, even though the body remains axis-aligned.
                     * @param value The amount of angular acceleration.
                     */
                    setAngularAcceleration(value: number): this;
                    /**
                     * Sets the angular drag of the body. Drag is applied to the current velocity, providing a form of deceleration.
                     * @param value The amount of drag.
                     */
                    setAngularDrag(value: number): this;
                }

                /**
                 * Provides methods used for setting the bounce properties of an Arcade Physics Body.
                 */
                interface Bounce {
                    /**
                     * Sets the bounce values of this body.
                     * 
                     * Bounce is the amount of restitution, or elasticity, the body has when it collides with another object.
                     * A value of 1 means that it will retain its full velocity after the rebound. A value of 0 means it will not rebound at all.
                     * @param x The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                     * @param y The amount of vertical bounce to apply on collision. A float, typically between 0 and 1. Default x.
                     */
                    setBounce(x: number, y?: number): this;
                    /**
                     * Sets the horizontal bounce value for this body.
                     * @param value The amount of horizontal bounce to apply on collision. A float, typically between 0 and 1.
                     */
                    setBounceX(value: number): this;
                    /**
                     * Sets the vertical bounce value for this body.
                     * @param value The amount of vertical bounce to apply on collision. A float, typically between 0 and 1.
                     */
                    setBounceY(value: number): this;
                    /**
                     * Sets whether this Body collides with the world boundary.
                     * 
                     * Optionally also sets the World Bounce values. If the `Body.worldBounce` is null, it's set to a new Phaser.Math.Vector2 first.
                     * @param value `true` if this body should collide with the world bounds, otherwise `false`. Default true.
                     * @param bounceX If given this will be replace the `worldBounce.x` value.
                     * @param bounceY If given this will be replace the `worldBounce.y` value.
                     * @param onWorldBounds If given this replaces the Body's `onWorldBounds` value.
                     */
                    setCollideWorldBounds(value?: boolean, bounceX?: number, bounceY?: number, onWorldBounds?: boolean): this;
                }

                /**
                 * Provides methods used for setting the collision category and mask of an Arcade Physics Body.
                 */
                interface Collision {
                    /**
                     * Sets the Collision Category that this Arcade Physics Body
                     * will use in order to determine what it can collide with.
                     * 
                     * It can only have one single category assigned to it.
                     * 
                     * If you wish to reset the collision category and mask, call
                     * the `resetCollisionCategory` method.
                     * @param category The collision category.
                     */
                    setCollisionCategory(category: number): this;
                    /**
                     * Checks to see if the given Collision Category will collide with
                     * this Arcade Physics object or not.
                     * @param category Collision category value to test.
                     */
                    willCollideWith(category: number): boolean;
                    /**
                     * Adds the given Collision Category to the list of those that this
                     * Arcade Physics Body will collide with.
                     * @param category The collision category to add.
                     */
                    addCollidesWith(category: number): this;
                    /**
                     * Removes the given Collision Category from the list of those that this
                     * Arcade Physics Body will collide with.
                     * @param category The collision category to add.
                     */
                    removeCollidesWith(category: number): this;
                    /**
                     * Sets all of the Collision Categories that this Arcade Physics Body
                     * will collide with. You can either pass a single category value, or
                     * an array of them.
                     * 
                     * Calling this method will reset all of the collision categories,
                     * so only those passed to this method are enabled.
                     * 
                     * If you wish to add a new category to the existing mask, call
                     * the `addCollisionCategory` method.
                     * 
                     * If you wish to reset the collision category and mask, call
                     * the `resetCollisionCategory` method.
                     * @param categories The collision category to collide with, or an array of them.
                     */
                    setCollidesWith(categories: number | number[]): this;
                    /**
                     * Resets the Collision Category and Mask back to the defaults,
                     * which is to collide with everything.
                     */
                    resetCollisionCategory(): this;
                }

                /**
                 * Provides methods used for setting the debug properties of an Arcade Physics Body.
                 */
                interface Debug {
                    /**
                     * Sets the debug values of this body.
                     * 
                     * Bodies will only draw their debug if debug has been enabled for Arcade Physics as a whole.
                     * Note that there is a performance cost in drawing debug displays. It should never be used in production.
                     * @param showBody Set to `true` to have this body render its outline to the debug display.
                     * @param showVelocity Set to `true` to have this body render a velocity marker to the debug display.
                     * @param bodyColor The color of the body outline when rendered to the debug display.
                     */
                    setDebug(showBody: boolean, showVelocity: boolean, bodyColor: number): this;
                    /**
                     * Sets the color of the body outline when it renders to the debug display.
                     * @param value The color of the body outline when rendered to the debug display.
                     */
                    setDebugBodyColor(value: number): this;
                    /**
                     * Set to `true` to have this body render its outline to the debug display.
                     */
                    debugShowBody: boolean;
                    /**
                     * Set to `true` to have this body render a velocity marker to the debug display.
                     */
                    debugShowVelocity: boolean;
                    /**
                     * The color of the body outline when it renders to the debug display.
                     */
                    debugBodyColor: number;
                }

                /**
                 * Provides methods used for setting the drag properties of an Arcade Physics Body.
                 */
                interface Drag {
                    /**
                     * Sets the body's horizontal and vertical drag. If the vertical drag value is not provided, the vertical drag is set to the same value as the horizontal drag.
                     * 
                     * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                     * It is the absolute loss of velocity due to movement, in pixels per second squared.
                     * The x and y components are applied separately.
                     * 
                     * When `useDamping` is true, this is 1 minus the damping factor.
                     * A value of 1 means the Body loses no velocity.
                     * A value of 0.95 means the Body loses 5% of its velocity per step.
                     * A value of 0.5 means the Body loses 50% of its velocity per step.
                     * 
                     * Drag is applied only when `acceleration` is zero.
                     * @param x The amount of horizontal drag to apply.
                     * @param y The amount of vertical drag to apply. Default x.
                     */
                    setDrag(x: number, y?: number): this;
                    /**
                     * Sets the body's horizontal drag.
                     * 
                     * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                     * It is the absolute loss of velocity due to movement, in pixels per second squared.
                     * The x and y components are applied separately.
                     * 
                     * When `useDamping` is true, this is 1 minus the damping factor.
                     * A value of 1 means the Body loses no velocity.
                     * A value of 0.95 means the Body loses 5% of its velocity per step.
                     * A value of 0.5 means the Body loses 50% of its velocity per step.
                     * 
                     * Drag is applied only when `acceleration` is zero.
                     * @param value The amount of horizontal drag to apply.
                     */
                    setDragX(value: number): this;
                    /**
                     * Sets the body's vertical drag.
                     * 
                     * Drag can be considered as a form of deceleration that will return the velocity of a body back to zero over time.
                     * It is the absolute loss of velocity due to movement, in pixels per second squared.
                     * The x and y components are applied separately.
                     * 
                     * When `useDamping` is true, this is 1 minus the damping factor.
                     * A value of 1 means the Body loses no velocity.
                     * A value of 0.95 means the Body loses 5% of its velocity per step.
                     * A value of 0.5 means the Body loses 50% of its velocity per step.
                     * 
                     * Drag is applied only when `acceleration` is zero.
                     * @param value The amount of vertical drag to apply.
                     */
                    setDragY(value: number): this;
                    /**
                     * If this Body is using `drag` for deceleration this function controls how the drag is applied.
                     * If set to `true` drag will use a damping effect rather than a linear approach. If you are
                     * creating a game where the Body moves freely at any angle (i.e. like the way the ship moves in
                     * the game Asteroids) then you will get a far smoother and more visually correct deceleration
                     * by using damping, avoiding the axis-drift that is prone with linear deceleration.
                     * 
                     * If you enable this property then you should use far smaller `drag` values than with linear, as
                     * they are used as a multiplier on the velocity. Values such as 0.95 will give a nice slow
                     * deceleration, where-as smaller values, such as 0.5 will stop an object almost immediately.
                     * @param value `true` to use damping for deceleration, or `false` to use linear deceleration.
                     */
                    setDamping(value: boolean): this;
                }

                /**
                 * Provides methods used for setting the enable properties of an Arcade Physics Body.
                 */
                interface Enable {
                    /**
                     * Sets whether this Body should calculate its velocity based on its change in
                     * position every frame. The default, which is to not do this, means that you
                     * make this Body move by setting the velocity directly. However, if you are
                     * trying to move this Body via a Tween, or have it follow a Path, then you
                     * should enable this instead. This will allow it to still collide with other
                     * bodies, something that isn't possible if you're just changing its position directly.
                     * @param value `true` if the Body calculate velocity based on changes in position, otherwise `false`. Default true.
                     */
                    setDirectControl(value?: boolean): this;
                    /**
                     * Enables this Game Object's Body.
                     * If you reset the Body you must also pass `x` and `y`.
                     * @param reset Also reset the Body and place the Game Object at (x, y).
                     * @param x The horizontal position to place the Game Object, if `reset` is true.
                     * @param y The horizontal position to place the Game Object, if `reset` is true.
                     * @param enableGameObject Also set this Game Object's `active` to true.
                     * @param showGameObject Also set this Game Object's `visible` to true.
                     */
                    enableBody(reset?: boolean, x?: number, y?: number, enableGameObject?: boolean, showGameObject?: boolean): this;
                    /**
                     * Stops and disables this Game Object's Body.
                     * @param disableGameObject Also set this Game Object's `active` to false. Default false.
                     * @param hideGameObject Also set this Game Object's `visible` to false. Default false.
                     */
                    disableBody(disableGameObject?: boolean, hideGameObject?: boolean): this;
                    /**
                     * Syncs the Body's position and size with its parent Game Object.
                     * You don't need to call this for Dynamic Bodies, as it happens automatically.
                     * But for Static bodies it's a useful way of modifying the position of a Static Body
                     * in the Physics World, based on its Game Object.
                     */
                    refreshBody(): this;
                }

                /**
                 * Methods for setting the friction of an Arcade Physics Body.
                 * 
                 * In Arcade Physics, friction is a special case of motion transfer from an "immovable" body to a riding body.
                 */
                interface Friction {
                    /**
                     * Sets the friction of this game object's physics body.
                     * In Arcade Physics, friction is a special case of motion transfer from an "immovable" body to a riding body.
                     * @param x The amount of horizontal friction to apply, [0, 1].
                     * @param y The amount of vertical friction to apply, [0, 1]. Default x.
                     */
                    setFriction(x: number, y?: number): this;
                    /**
                     * Sets the horizontal friction of this game object's physics body.
                     * This can move a riding body horizontally when it collides with this one on the vertical axis.
                     * @param x The amount of friction to apply, [0, 1].
                     */
                    setFrictionX(x: number): this;
                    /**
                     * Sets the vertical friction of this game object's physics body.
                     * This can move a riding body vertically when it collides with this one on the horizontal axis.
                     * @param y The amount of friction to apply, [0, 1].
                     */
                    setFrictionY(y: number): this;
                }

                /**
                 * Provides methods for setting the gravity properties of an Arcade Physics Game Object.
                 * Should be applied as a mixin and not used directly.
                 */
                interface Gravity {
                    /**
                     * Set the X and Y values of the gravitational pull to act upon this Arcade Physics Game Object. Values can be positive or negative. Larger values result in a stronger effect.
                     * 
                     * If only one value is provided, this value will be used for both the X and Y axis.
                     * @param x The gravitational force to be applied to the X-axis.
                     * @param y The gravitational force to be applied to the Y-axis. If this is not specified, the X value will be used. Default x.
                     */
                    setGravity(x: number, y?: number): this;
                    /**
                     * Set the gravitational force to be applied to the X axis. Value can be positive or negative. Larger values result in a stronger effect.
                     * @param x The gravitational force to be applied to the X-axis.
                     */
                    setGravityX(x: number): this;
                    /**
                     * Set the gravitational force to be applied to the Y axis. Value can be positive or negative. Larger values result in a stronger effect.
                     * @param y The gravitational force to be applied to the Y-axis.
                     */
                    setGravityY(y: number): this;
                }

                /**
                 * Provides methods used for setting the immovable properties of an Arcade Physics Body.
                 */
                interface Immovable {
                    /**
                     * Sets if this Body can be separated during collisions with other bodies.
                     * 
                     * When a body is immovable it means it won't move at all, not even to separate it from collision
                     * overlap. If you just wish to prevent a body from being knocked around by other bodies, see
                     * the `setPushable` method instead.
                     * @param value Sets if this body will be separated during collisions with other bodies. Default true.
                     */
                    setImmovable(value?: boolean): this;
                }

                /**
                 * Provides methods used for setting the mass properties of an Arcade Physics Body.
                 */
                interface Mass {
                    /**
                     * Sets the mass of the physics body
                     * @param value New value for the mass of the body.
                     */
                    setMass(value: number): this;
                }

                /**
                 * This method will search the given circular area and return an array of all physics bodies that
                 * overlap with it. It can return either Dynamic, Static bodies or a mixture of both.
                 * 
                 * A body only has to intersect with the search area to be considered, it doesn't have to be fully
                 * contained within it.
                 * 
                 * If Arcade Physics is set to use the RTree (which it is by default) then the search is rather fast,
                 * otherwise the search is O(N) for Dynamic Bodies.
                 */
                interface OverlapCirc {
                }

                /**
                 * This method will search the given rectangular area and return an array of all physics bodies that
                 * overlap with it. It can return either Dynamic, Static bodies or a mixture of both.
                 * 
                 * A body only has to intersect with the search area to be considered, it doesn't have to be fully
                 * contained within it.
                 * 
                 * If Arcade Physics is set to use the RTree (which it is by default) then the search for is extremely fast,
                 * otherwise the search is O(N) for Dynamic Bodies.
                 */
                interface OverlapRect {
                }

                /**
                 * Provides methods used for setting the pushable property of an Arcade Physics Body.
                 */
                interface Pushable {
                    /**
                     * Sets if this Body can be pushed by another Body.
                     * 
                     * A body that cannot be pushed will reflect back all of the velocity it is given to the
                     * colliding body. If that body is also not pushable, then the separation will be split
                     * between them evenly.
                     * 
                     * If you want your body to never move or seperate at all, see the `setImmovable` method.
                     * @param value Sets if this body can be pushed by collisions with another Body. Default true.
                     */
                    setPushable(value?: boolean): this;
                }

                /**
                 * Provides methods for setting the size of an Arcade Physics Game Object.
                 * Should be applied as a mixin and not used directly.
                 */
                interface Size {
                    /**
                     * Sets the body offset. This allows you to adjust the difference between the center of the body
                     * and the x and y coordinates of the parent Game Object.
                     * @param x The amount to offset the body from the parent Game Object along the x-axis.
                     * @param y The amount to offset the body from the parent Game Object along the y-axis. Defaults to the value given for the x-axis. Default x.
                     */
                    setOffset(x: number, y?: number): this;
                    /**
                     * **DEPRECATED**: Please use `setBodySize` instead.
                     * 
                     * Sets the size of this physics body. Setting the size does not adjust the dimensions of the parent Game Object.
                     * @param width The new width of the physics body, in pixels.
                     * @param height The new height of the physics body, in pixels.
                     * @param center Should the body be re-positioned so its center aligns with the parent Game Object? Default true.
                     */
                    setSize(width: number, height: number, center?: boolean): this;
                    /**
                     * Sets the size of this physics body. Setting the size does not adjust the dimensions of the parent Game Object.
                     * @param width The new width of the physics body, in pixels.
                     * @param height The new height of the physics body, in pixels.
                     * @param center Should the body be re-positioned so its center aligns with the parent Game Object? Default true.
                     */
                    setBodySize(width: number, height: number, center?: boolean): this;
                    /**
                     * Sets this physics body to use a circle for collision instead of a rectangle.
                     * @param radius The radius of the physics body, in pixels.
                     * @param offsetX The amount to offset the body from the parent Game Object along the x-axis.
                     * @param offsetY The amount to offset the body from the parent Game Object along the y-axis.
                     */
                    setCircle(radius: number, offsetX?: number, offsetY?: number): this;
                }

                /**
                 * Provides methods for modifying the velocity of an Arcade Physics body.
                 * 
                 * Should be applied as a mixin and not used directly.
                 */
                interface Velocity {
                    /**
                     * Sets the velocity of the Body.
                     * @param x The horizontal velocity of the body. Positive values move the body to the right, while negative values move it to the left.
                     * @param y The vertical velocity of the body. Positive values move the body down, while negative values move it up. Default x.
                     */
                    setVelocity(x: number, y?: number): this;
                    /**
                     * Sets the horizontal component of the body's velocity.
                     * 
                     * Positive values move the body to the right, while negative values move it to the left.
                     * @param x The new horizontal velocity.
                     */
                    setVelocityX(x: number): this;
                    /**
                     * Sets the vertical component of the body's velocity.
                     * 
                     * Positive values move the body down, while negative values move it up.
                     * @param y The new vertical velocity of the body.
                     */
                    setVelocityY(y: number): this;
                    /**
                     * Sets the maximum velocity of the body.
                     * @param x The new maximum horizontal velocity.
                     * @param y The new maximum vertical velocity. Default x.
                     */
                    setMaxVelocity(x: number, y?: number): this;
                }

            }

            /**
             * Dynamic Body.
             */
            var DYNAMIC_BODY: number;

            /**
             * Static Body.
             */
            var STATIC_BODY: number;

            /**
             * Arcade Physics Group containing Dynamic Bodies.
             */
            var GROUP: number;

            /**
             * A Tilemap Layer.
             */
            var TILEMAPLAYER: number;

            /**
             * Facing no direction (initial value).
             */
            var FACING_NONE: number;

            /**
             * Facing up.
             */
            var FACING_UP: number;

            /**
             * Facing down.
             */
            var FACING_DOWN: number;

            /**
             * Facing left.
             */
            var FACING_LEFT: number;

            /**
             * Facing right.
             */
            var FACING_RIGHT: number;

            namespace Events {
                /**
                 * The Arcade Physics World Collide Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance if two bodies collide _and_ at least
                 * one of them has their [onCollide]{@link Phaser.Physics.Arcade.Body#onCollide} property set to `true`.
                 * 
                 * It provides an alternative means to handling collide events rather than using the callback approach.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('collide', listener)`.
                 * 
                 * Please note that 'collide' and 'overlap' are two different things in Arcade Physics.
                 */
                const COLLIDE: string;

                /**
                 * The Arcade Physics World Overlap Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance if two bodies overlap _and_ at least
                 * one of them has their [onOverlap]{@link Phaser.Physics.Arcade.Body#onOverlap} property set to `true`.
                 * 
                 * It provides an alternative means to handling overlap events rather than using the callback approach.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('overlap', listener)`.
                 * 
                 * Please note that 'collide' and 'overlap' are two different things in Arcade Physics.
                 */
                const OVERLAP: string;

                /**
                 * The Arcade Physics World Pause Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance when it is paused.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('pause', listener)`.
                 */
                const PAUSE: string;

                /**
                 * The Arcade Physics World Resume Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance when it resumes from a paused state.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('resume', listener)`.
                 */
                const RESUME: string;

                /**
                 * The Arcade Physics Tile Collide Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance if a body collides with a Tile _and_
                 * has its [onCollide]{@link Phaser.Physics.Arcade.Body#onCollide} property set to `true`.
                 * 
                 * It provides an alternative means to handling collide events rather than using the callback approach.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('tilecollide', listener)`.
                 * 
                 * Please note that 'collide' and 'overlap' are two different things in Arcade Physics.
                 */
                const TILE_COLLIDE: string;

                /**
                 * The Arcade Physics Tile Overlap Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance if a body overlaps with a Tile _and_
                 * has its [onOverlap]{@link Phaser.Physics.Arcade.Body#onOverlap} property set to `true`.
                 * 
                 * It provides an alternative means to handling overlap events rather than using the callback approach.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('tileoverlap', listener)`.
                 * 
                 * Please note that 'collide' and 'overlap' are two different things in Arcade Physics.
                 */
                const TILE_OVERLAP: string;

                /**
                 * The Arcade Physics World Bounds Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance if a body makes contact with the world bounds _and_
                 * it has its [onWorldBounds]{@link Phaser.Physics.Arcade.Body#onWorldBounds} property set to `true`.
                 * 
                 * It provides an alternative means to handling collide events rather than using the callback approach.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('worldbounds', listener)`.
                 */
                const WORLD_BOUNDS: string;

                /**
                 * The Arcade Physics World Step Event.
                 * 
                 * This event is dispatched by an Arcade Physics World instance whenever a physics step is run.
                 * It is emitted _after_ the bodies and colliders have been updated.
                 * 
                 * In high framerate settings this can be multiple times per game frame.
                 * 
                 * Listen to it from a Scene using: `this.physics.world.on('worldstep', listener)`.
                 */
                const WORLD_STEP: string;

            }

            /**
             * The Arcade Physics Factory allows you to easily create Arcade Physics enabled Game Objects.
             * Objects that are created by this Factory are automatically added to the physics world.
             */
            class Factory {
                /**
                 * 
                 * @param world The Arcade Physics World instance.
                 */
                constructor(world: Phaser.Physics.Arcade.World);

                /**
                 * A reference to the Arcade Physics World.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * A reference to the Scene this Arcade Physics instance belongs to.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene.Systems this Arcade Physics instance belongs to.
                 */
                sys: Phaser.Scenes.Systems;

                /**
                 * Creates a new Arcade Physics Collider object.
                 * @param object1 The first object to check for collision.
                 * @param object2 The second object to check for collision.
                 * @param collideCallback The callback to invoke when the two objects collide.
                 * @param processCallback The callback to invoke when the two objects collide. Must return a boolean.
                 * @param callbackContext The scope in which to call the callbacks.
                 */
                collider(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): Phaser.Physics.Arcade.Collider;

                /**
                 * Creates a new Arcade Physics Collider Overlap object.
                 * @param object1 The first object to check for overlap.
                 * @param object2 The second object to check for overlap.
                 * @param collideCallback The callback to invoke when the two objects collide.
                 * @param processCallback The callback to invoke when the two objects collide. Must return a boolean.
                 * @param callbackContext The scope in which to call the callbacks.
                 */
                overlap(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): Phaser.Physics.Arcade.Collider;

                /**
                 * Adds an Arcade Physics Body to the given Game Object.
                 * @param gameObject A Game Object.
                 * @param isStatic Create a Static body (true) or Dynamic body (false). Default false.
                 */
                existing<G extends Phaser.GameObjects.GameObject>(gameObject: G, isStatic?: boolean): G;

                /**
                 * Creates a new Arcade Image object with a Static body.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                staticImage(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.Types.Physics.Arcade.ImageWithStaticBody;

                /**
                 * Creates a new Arcade Image object with a Dynamic body.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                image(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.Types.Physics.Arcade.ImageWithDynamicBody;

                /**
                 * Creates a new Arcade Sprite object with a Static body.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                staticSprite(x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number): Phaser.Types.Physics.Arcade.SpriteWithStaticBody;

                /**
                 * Creates a new Arcade Sprite object with a Dynamic body.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param key The key of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 */
                sprite(x: number, y: number, key: string, frame?: string | number): Phaser.Types.Physics.Arcade.SpriteWithDynamicBody;

                /**
                 * Creates a Static Physics Group object.
                 * All Game Objects created by this Group will automatically be static Arcade Physics objects.
                 * @param children Game Objects to add to this group; or the `config` argument.
                 * @param config Settings for this group.
                 */
                staticGroup(children?: Phaser.GameObjects.GameObject[] | Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig): Phaser.Physics.Arcade.StaticGroup;

                /**
                 * Creates a Physics Group object.
                 * All Game Objects created by this Group will automatically be dynamic Arcade Physics objects.
                 * @param children Game Objects to add to this group; or the `config` argument.
                 * @param config Settings for this group.
                 */
                group(children?: Phaser.GameObjects.GameObject[] | Phaser.Types.Physics.Arcade.PhysicsGroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.Physics.Arcade.PhysicsGroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig): Phaser.Physics.Arcade.Group;

                /**
                 * Creates a new physics Body with the given position and size.
                 * 
                 * This Body is not associated with any Game Object, but still exists within the world
                 * and can be tested for collision, have velocity, etc.
                 * @param x The horizontal position of this Body in the physics world.
                 * @param y The vertical position of this Body in the physics world.
                 * @param width The width of the Body in pixels. Cannot be negative or zero. Default 64.
                 * @param height The height of the Body in pixels. Cannot be negative or zero. Default 64.
                 */
                body(x: number, y: number, width?: number, height?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Creates a new static physics Body with the given position and size.
                 * 
                 * This Body is not associated with any Game Object, but still exists within the world
                 * and can be tested for collision, etc.
                 * @param x The horizontal position of this Body in the physics world.
                 * @param y The vertical position of this Body in the physics world.
                 * @param width The width of the Body in pixels. Cannot be negative or zero. Default 64.
                 * @param height The height of the Body in pixels. Cannot be negative or zero. Default 64.
                 */
                staticBody(x: number, y: number, width?: number, height?: number): Phaser.Physics.Arcade.Body;

                /**
                 * Destroys this Factory.
                 */
                destroy(): void;

            }

            /**
             * Calculates and returns the bitmask needed to determine if the given
             * categories will collide with each other or not.
             * @param categories A unique category bitfield, or an array of them.
             */
            function GetCollidesWith(categories: number | number[]): number;

            /**
             * Calculates and returns the horizontal overlap between two arcade physics bodies and sets their properties
             * accordingly, including: `touching.left`, `touching.right`, `touching.none` and `overlapX'.
             * @param body1 The first Body to separate.
             * @param body2 The second Body to separate.
             * @param overlapOnly Is this an overlap only check, or part of separation?
             * @param bias A value added to the delta values during collision checks. Increase it to prevent sprite tunneling(sprites passing through another instead of colliding).
             */
            function GetOverlapX(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, overlapOnly: boolean, bias: number): number;

            /**
             * Calculates and returns the vertical overlap between two arcade physics bodies and sets their properties
             * accordingly, including: `touching.up`, `touching.down`, `touching.none` and `overlapY'.
             * @param body1 The first Body to separate.
             * @param body2 The second Body to separate.
             * @param overlapOnly Is this an overlap only check, or part of separation?
             * @param bias A value added to the delta values during collision checks. Increase it to prevent sprite tunneling(sprites passing through another instead of colliding).
             */
            function GetOverlapY(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, overlapOnly: boolean, bias: number): number;

            /**
             * An Arcade Physics Group object.
             * 
             * The primary use of a Physics Group is a way to collect together physics enable objects
             * that share the same intrinsic structure into a single pool. They can they be easily
             * compared against other Groups, or Game Objects.
             * 
             * All Game Objects created by, or added to this Group will automatically be given **dynamic**
             * Arcade Physics bodies (if they have no body already) and the bodies will receive the
             * Groups {@link Phaser.Physics.Arcade.Group#defaults default values}.
             * 
             * You should not pass objects into this Group that should not receive a body. For example,
             * do not add basic Geometry or Tilemap Layers into a Group, as they will not behave in the
             * way you may expect. Groups should all ideally have objects of the same type in them.
             * 
             * If you wish to create a Group filled with Static Bodies, please see {@link Phaser.Physics.Arcade.StaticGroup}.
             */
            class Group extends Phaser.GameObjects.Group implements Phaser.Physics.Arcade.Components.Collision {
                /**
                 * 
                 * @param world The physics simulation.
                 * @param scene The scene this group belongs to.
                 * @param children Game Objects to add to this group; or the `config` argument.
                 * @param config Settings for this group.
                 */
                constructor(world: Phaser.Physics.Arcade.World, scene: Phaser.Scene, children?: Phaser.GameObjects.GameObject[] | Phaser.Types.Physics.Arcade.PhysicsGroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.Physics.Arcade.PhysicsGroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig);

                /**
                 * The physics simulation.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * The class to create new Group members from.
                 * 
                 * This should be either `Phaser.Physics.Arcade.Image`, `Phaser.Physics.Arcade.Sprite`, or a class extending one of those.
                 */
                classType: Function;

                /**
                 * The physics type of the Group's members.
                 */
                physicsType: number;

                /**
                 * The Arcade Physics Group Collision Category.
                 * 
                 * This can be set to any valid collision bitfield value.
                 * 
                 * See the `setCollisionCategory` method for more details.
                 */
                collisionCategory: number;

                /**
                 * The Arcade Physics Group Collision Mask.
                 * 
                 * See the `setCollidesWith` method for more details.
                 */
                collisionMask: number;

                /**
                 * Default physics properties applied to Game Objects added to the Group or created by the Group. Derived from the `config` argument.
                 * 
                 * You can remove the default values by setting this property to `{}`.
                 */
                defaults: Phaser.Types.Physics.Arcade.PhysicsGroupDefaults;

                /**
                 * A textual representation of this Game Object.
                 * Used internally by Phaser but is available for your own custom classes to populate.
                 */
                type: string;

                /**
                 * Enables a Game Object's Body and assigns `defaults`. Called when a Group member is added or created.
                 * @param child The Game Object being added.
                 */
                createCallbackHandler(child: Phaser.GameObjects.GameObject): void;

                /**
                 * Disables a Game Object's Body. Called when a Group member is removed.
                 * @param child The Game Object being removed.
                 */
                removeCallbackHandler(child: Phaser.GameObjects.GameObject): void;

                /**
                 * Sets the velocity of each Group member.
                 * @param x The horizontal velocity.
                 * @param y The vertical velocity.
                 * @param step The velocity increment. When set, the first member receives velocity (x, y), the second (x + step, y + step), and so on. Default 0.
                 */
                setVelocity(x: number, y: number, step?: number): Phaser.Physics.Arcade.Group;

                /**
                 * Sets the horizontal velocity of each Group member.
                 * @param value The velocity value.
                 * @param step The velocity increment. When set, the first member receives velocity (x), the second (x + step), and so on. Default 0.
                 */
                setVelocityX(value: number, step?: number): Phaser.Physics.Arcade.Group;

                /**
                 * Sets the vertical velocity of each Group member.
                 * @param value The velocity value.
                 * @param step The velocity increment. When set, the first member receives velocity (y), the second (y + step), and so on. Default 0.
                 */
                setVelocityY(value: number, step?: number): Phaser.Physics.Arcade.Group;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

            }

            /**
             * Separates two overlapping bodies on the X-axis (horizontally).
             * 
             * Separation involves moving two overlapping bodies so they don't overlap anymore and adjusting their velocities based on their mass. This is a core part of collision detection.
             * 
             * The bodies won't be separated if there is no horizontal overlap between them, if they are static, or if either one uses custom logic for its separation.
             * @param body1 The first Body to separate.
             * @param body2 The second Body to separate.
             * @param overlapOnly If `true`, the bodies will only have their overlap data set and no separation will take place.
             * @param bias A value to add to the delta value during overlap checking. Used to prevent sprite tunneling.
             * @param overlap If given then this value will be used as the overlap and no check will be run.
             */
            function SeparateX(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, overlapOnly: boolean, bias: number, overlap?: number): boolean;

            /**
             * Separates two overlapping bodies on the Y-axis (vertically).
             * 
             * Separation involves moving two overlapping bodies so they don't overlap anymore and adjusting their velocities based on their mass. This is a core part of collision detection.
             * 
             * The bodies won't be separated if there is no vertical overlap between them, if they are static, or if either one uses custom logic for its separation.
             * @param body1 The first Body to separate.
             * @param body2 The second Body to separate.
             * @param overlapOnly If `true`, the bodies will only have their overlap data set and no separation will take place.
             * @param bias A value to add to the delta value during overlap checking. Used to prevent sprite tunneling.
             * @param overlap If given then this value will be used as the overlap and no check will be run.
             */
            function SeparateY(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, overlapOnly: boolean, bias: number, overlap?: number): boolean;

            /**
             * Either sets or creates the Arcade Body Collision object.
             * 
             * Mostly only used internally.
             * @param noneFlip Is `none` true or false?
             * @param data The collision data object to populate, or create if not given.
             */
            function SetCollisionObject(noneFlip: boolean, data?: Phaser.Types.Physics.Arcade.ArcadeBodyCollision): Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

            /**
             * A Static Arcade Physics Body.
             * 
             * A Static Body never moves, and isn't automatically synchronized with its parent Game Object.
             * That means if you make any change to the parent's origin, position, or scale after creating or adding the body, you'll need to update the Static Body manually.
             * 
             * A Static Body can collide with other Bodies, but is never moved by collisions.
             * 
             * Its dynamic counterpart is {@link Phaser.Physics.Arcade.Body}.
             */
            class StaticBody implements Phaser.Physics.Arcade.Components.Collision {
                /**
                 * 
                 * @param world The Arcade Physics simulation this Static Body belongs to.
                 * @param gameObject The Game Object this Body belongs to. As of Phaser 3.60 this is now optional.
                 */
                constructor(world: Phaser.Physics.Arcade.World, gameObject?: Phaser.GameObjects.GameObject);

                /**
                 * The Arcade Physics simulation this Static Body belongs to.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * The Game Object this Static Body belongs to.
                 * 
                 * As of Phaser 3.60 this is now optional and can be undefined.
                 */
                gameObject: Phaser.GameObjects.GameObject;

                /**
                 * A quick-test flag that signifies this is a Body, used in the World collision handler.
                 */
                readonly isBody: boolean;

                /**
                 * Whether the Static Body's boundary is drawn to the debug display.
                 */
                debugShowBody: boolean;

                /**
                 * The color of this Static Body on the debug display.
                 */
                debugBodyColor: number;

                /**
                 * Whether this Static Body is updated by the physics simulation.
                 */
                enable: boolean;

                /**
                 * Whether this Static Body's boundary is circular (`true`) or rectangular (`false`).
                 */
                isCircle: boolean;

                /**
                 * If this Static Body is circular, this is the radius of the boundary, as set by {@link Phaser.Physics.Arcade.StaticBody#setCircle}, in pixels.
                 * Equal to `halfWidth`.
                 */
                radius: number;

                /**
                 * The offset set by {@link Phaser.Physics.Arcade.StaticBody#setCircle} or {@link Phaser.Physics.Arcade.StaticBody#setSize}.
                 * 
                 * This doesn't affect the Static Body's position, because a Static Body does not follow its Game Object.
                 */
                readonly offset: Phaser.Math.Vector2;

                /**
                 * The position of this Static Body within the simulation.
                 */
                position: Phaser.Math.Vector2;

                /**
                 * The width of the Static Body's boundary, in pixels.
                 * If the Static Body is circular, this is also the Static Body's diameter.
                 */
                width: number;

                /**
                 * The height of the Static Body's boundary, in pixels.
                 * If the Static Body is circular, this is also the Static Body's diameter.
                 */
                height: number;

                /**
                 * Half the Static Body's width, in pixels.
                 * If the Static Body is circular, this is also the Static Body's radius.
                 */
                halfWidth: number;

                /**
                 * Half the Static Body's height, in pixels.
                 * If the Static Body is circular, this is also the Static Body's radius.
                 */
                halfHeight: number;

                /**
                 * The center of the Static Body's boundary.
                 * This is the midpoint of its `position` (top-left corner) and its bottom-right corner.
                 */
                center: Phaser.Math.Vector2;

                /**
                 * A constant zero velocity used by the Arcade Physics simulation for calculations.
                 */
                readonly velocity: Phaser.Math.Vector2;

                /**
                 * A constant `false` value expected by the Arcade Physics simulation.
                 */
                readonly allowGravity: boolean;

                /**
                 * Gravitational force applied specifically to this Body. Values are in pixels per second squared. Always zero for a Static Body.
                 */
                readonly gravity: Phaser.Math.Vector2;

                /**
                 * Rebound, or restitution, following a collision, relative to 1. Always zero for a Static Body.
                 */
                readonly bounce: Phaser.Math.Vector2;

                /**
                 * Whether the simulation emits a `worldbounds` event when this StaticBody collides with the world boundary.
                 * Always false for a Static Body. (Static Bodies never collide with the world boundary and never trigger a `worldbounds` event.)
                 */
                readonly onWorldBounds: boolean;

                /**
                 * Whether the simulation emits a `collide` event when this StaticBody collides with another.
                 */
                onCollide: boolean;

                /**
                 * Whether the simulation emits an `overlap` event when this StaticBody overlaps with another.
                 */
                onOverlap: boolean;

                /**
                 * The StaticBody's inertia, relative to a default unit (1). With `bounce`, this affects the exchange of momentum (velocities) during collisions.
                 */
                mass: number;

                /**
                 * Whether this object can be moved by collisions with another body.
                 */
                immovable: boolean;

                /**
                 * Sets if this Body can be pushed by another Body.
                 * 
                 * A body that cannot be pushed will reflect back all of the velocity it is given to the
                 * colliding body. If that body is also not pushable, then the separation will be split
                 * between them evenly.
                 * 
                 * If you want your body to never move or seperate at all, see the `setImmovable` method.
                 * 
                 * By default, Static Bodies are not pushable.
                 */
                pushable: boolean;

                /**
                 * A flag disabling the default horizontal separation of colliding bodies. Pass your own `collideHandler` to the collider.
                 */
                customSeparateX: boolean;

                /**
                 * A flag disabling the default vertical separation of colliding bodies. Pass your own `collideHandler` to the collider.
                 */
                customSeparateY: boolean;

                /**
                 * The amount of horizontal overlap (before separation), if this Body is colliding with another.
                 */
                overlapX: number;

                /**
                 * The amount of vertical overlap (before separation), if this Body is colliding with another.
                 */
                overlapY: number;

                /**
                 * The amount of overlap (before separation), if this StaticBody is circular and colliding with another circular body.
                 */
                overlapR: number;

                /**
                 * Whether this StaticBody has ever overlapped with another while both were not moving.
                 */
                embedded: boolean;

                /**
                 * Whether this StaticBody interacts with the world boundary.
                 * Always false for a Static Body. (Static Bodies never collide with the world boundary.)
                 */
                readonly collideWorldBounds: boolean;

                /**
                 * Whether this StaticBody is checked for collisions and for which directions. You can set `checkCollision.none = false` to disable collision checks.
                 */
                checkCollision: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * This property is kept for compatibility with Dynamic Bodies.
                 * Avoid using it.
                 */
                touching: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * This property is kept for compatibility with Dynamic Bodies.
                 * Avoid using it.
                 * The values are always false for a Static Body.
                 */
                wasTouching: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * This property is kept for compatibility with Dynamic Bodies.
                 * Avoid using it.
                 */
                blocked: Phaser.Types.Physics.Arcade.ArcadeBodyCollision;

                /**
                 * The StaticBody's physics type (static by default).
                 */
                physicsType: number;

                /**
                 * The Arcade Physics Body Collision Category.
                 * 
                 * This can be set to any valid collision bitfield value.
                 * 
                 * See the `setCollisionCategory` method for more details.
                 */
                collisionCategory: number;

                /**
                 * The Arcade Physics Body Collision Mask.
                 * 
                 * See the `setCollidesWith` method for more details.
                 */
                collisionMask: number;

                /**
                 * Changes the Game Object this Body is bound to.
                 * First it removes its reference from the old Game Object, then sets the new one.
                 * You can optionally update the position and dimensions of this Body to reflect that of the new Game Object.
                 * @param gameObject The new Game Object that will own this Body.
                 * @param update Reposition and resize this Body to match the new Game Object? Default true.
                 */
                setGameObject(gameObject: Phaser.GameObjects.GameObject, update?: boolean): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Syncs the Static Body's position and size with its parent Game Object.
                 */
                updateFromGameObject(): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Positions the Static Body at an offset from its Game Object.
                 * @param x The horizontal offset of the Static Body from the Game Object's `x`.
                 * @param y The vertical offset of the Static Body from the Game Object's `y`.
                 */
                setOffset(x: number, y: number): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Sets the size of the Static Body.
                 * When `center` is true, also repositions it.
                 * Resets the width and height to match current frame, if no width and height provided and a frame is found.
                 * @param width The width of the Static Body in pixels. Cannot be zero. If not given, and the parent Game Object has a frame, it will use the frame width.
                 * @param height The height of the Static Body in pixels. Cannot be zero. If not given, and the parent Game Object has a frame, it will use the frame height.
                 * @param center Place the Static Body's center on its Game Object's center. Only works if the Game Object has the `getCenter` method. Default true.
                 */
                setSize(width?: number, height?: number, center?: boolean): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Sets this Static Body to have a circular body and sets its size and position.
                 * @param radius The radius of the StaticBody, in pixels.
                 * @param offsetX The horizontal offset of the StaticBody from its Game Object, in pixels.
                 * @param offsetY The vertical offset of the StaticBody from its Game Object, in pixels.
                 */
                setCircle(radius: number, offsetX?: number, offsetY?: number): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Updates the StaticBody's `center` from its `position` and dimensions.
                 */
                updateCenter(): void;

                /**
                 * Resets this Static Body to its parent Game Object's position.
                 * 
                 * If `x` and `y` are given, the parent Game Object is placed there and this Static Body is centered on it.
                 * Otherwise this Static Body is centered on the Game Object's current position.
                 * @param x The x coordinate to reset the body to. If not given will use the parent Game Object's coordinate.
                 * @param y The y coordinate to reset the body to. If not given will use the parent Game Object's coordinate.
                 */
                reset(x?: number, y?: number): void;

                /**
                 * NOOP function. A Static Body cannot be stopped.
                 */
                stop(): Phaser.Physics.Arcade.StaticBody;

                /**
                 * Returns the x and y coordinates of the top left and bottom right points of the StaticBody.
                 * @param obj The object which will hold the coordinates of the bounds.
                 */
                getBounds(obj: Phaser.Types.Physics.Arcade.ArcadeBodyBounds): Phaser.Types.Physics.Arcade.ArcadeBodyBounds;

                /**
                 * Checks to see if a given x,y coordinate is colliding with this Static Body.
                 * @param x The x coordinate to check against this body.
                 * @param y The y coordinate to check against this body.
                 */
                hitTest(x: number, y: number): boolean;

                /**
                 * NOOP
                 */
                postUpdate(): void;

                /**
                 * The absolute (non-negative) change in this StaticBody's horizontal position from the previous step. Always zero.
                 */
                deltaAbsX(): number;

                /**
                 * The absolute (non-negative) change in this StaticBody's vertical position from the previous step. Always zero.
                 */
                deltaAbsY(): number;

                /**
                 * The change in this StaticBody's horizontal position from the previous step. Always zero.
                 */
                deltaX(): number;

                /**
                 * The change in this StaticBody's vertical position from the previous step. Always zero.
                 */
                deltaY(): number;

                /**
                 * The change in this StaticBody's rotation from the previous step. Always zero.
                 */
                deltaZ(): number;

                /**
                 * Disables this Body and marks it for destruction during the next step.
                 */
                destroy(): void;

                /**
                 * Draws a graphical representation of the StaticBody for visual debugging purposes.
                 * @param graphic The Graphics object to use for the debug drawing of the StaticBody.
                 */
                drawDebug(graphic: Phaser.GameObjects.Graphics): void;

                /**
                 * Indicates whether the StaticBody is going to be showing a debug visualization during postUpdate.
                 */
                willDrawDebug(): boolean;

                /**
                 * Sets the Mass of the StaticBody. Will set the Mass to 0.1 if the value passed is less than or equal to zero.
                 * @param value The value to set the Mass to. Values of zero or less are changed to 0.1.
                 */
                setMass(value: number): Phaser.Physics.Arcade.StaticBody;

                /**
                 * The x coordinate of the StaticBody.
                 */
                x: number;

                /**
                 * The y coordinate of the StaticBody.
                 */
                y: number;

                /**
                 * Returns the left-most x coordinate of the area of the StaticBody.
                 */
                readonly left: number;

                /**
                 * The right-most x coordinate of the area of the StaticBody.
                 */
                readonly right: number;

                /**
                 * The highest y coordinate of the area of the StaticBody.
                 */
                readonly top: number;

                /**
                 * The lowest y coordinate of the area of the StaticBody. (y + height)
                 */
                readonly bottom: number;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

            }

            /**
             * An Arcade Physics Static Group object.
             * 
             * All Game Objects created by or added to this Group will automatically be given static Arcade Physics bodies, if they have no body.
             * 
             * Its dynamic counterpart is {@link Phaser.Physics.Arcade.Group}.
             */
            class StaticGroup extends Phaser.GameObjects.Group implements Phaser.Physics.Arcade.Components.Collision {
                /**
                 * 
                 * @param world The physics simulation.
                 * @param scene The scene this group belongs to.
                 * @param children Game Objects to add to this group; or the `config` argument.
                 * @param config Settings for this group.
                 */
                constructor(world: Phaser.Physics.Arcade.World, scene: Phaser.Scene, children?: Phaser.GameObjects.GameObject[] | Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig, config?: Phaser.Types.GameObjects.Group.GroupConfig | Phaser.Types.GameObjects.Group.GroupCreateConfig);

                /**
                 * The physics simulation.
                 */
                world: Phaser.Physics.Arcade.World;

                /**
                 * The scene this group belongs to.
                 */
                physicsType: number;

                /**
                 * The Arcade Physics Static Group Collision Category.
                 * 
                 * This can be set to any valid collision bitfield value.
                 * 
                 * See the `setCollisionCategory` method for more details.
                 */
                collisionCategory: number;

                /**
                 * The Arcade Physics Static Group Collision Mask.
                 * 
                 * See the `setCollidesWith` method for more details.
                 */
                collisionMask: number;

                /**
                 * A textual representation of this Game Object.
                 * Used internally by Phaser but is available for your own custom classes to populate.
                 */
                type: string;

                /**
                 * Adds a static physics body to the new group member (if it lacks one) and adds it to the simulation.
                 * @param child The new group member.
                 */
                createCallbackHandler(child: Phaser.GameObjects.GameObject): void;

                /**
                 * Disables the group member's physics body, removing it from the simulation.
                 * @param child The group member being removed.
                 */
                removeCallbackHandler(child: Phaser.GameObjects.GameObject): void;

                /**
                 * Refreshes the group.
                 * @param entries The newly created group members.
                 */
                createMultipleCallbackHandler(entries: Phaser.GameObjects.GameObject[]): void;

                /**
                 * Resets each Body to the position of its parent Game Object.
                 * Body sizes aren't changed (use {@link Phaser.Physics.Arcade.Components.Enable#refreshBody} for that).
                 */
                refresh(): Phaser.Physics.Arcade.StaticGroup;

                /**
                 * Sets the Collision Category that this Arcade Physics Body
                 * will use in order to determine what it can collide with.
                 * 
                 * It can only have one single category assigned to it.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param category The collision category.
                 */
                setCollisionCategory(category: number): this;

                /**
                 * Checks to see if the given Collision Category will collide with
                 * this Arcade Physics object or not.
                 * @param category Collision category value to test.
                 */
                willCollideWith(category: number): boolean;

                /**
                 * Adds the given Collision Category to the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                addCollidesWith(category: number): this;

                /**
                 * Removes the given Collision Category from the list of those that this
                 * Arcade Physics Body will collide with.
                 * @param category The collision category to add.
                 */
                removeCollidesWith(category: number): this;

                /**
                 * Sets all of the Collision Categories that this Arcade Physics Body
                 * will collide with. You can either pass a single category value, or
                 * an array of them.
                 * 
                 * Calling this method will reset all of the collision categories,
                 * so only those passed to this method are enabled.
                 * 
                 * If you wish to add a new category to the existing mask, call
                 * the `addCollisionCategory` method.
                 * 
                 * If you wish to reset the collision category and mask, call
                 * the `resetCollisionCategory` method.
                 * @param categories The collision category to collide with, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * Resets the Collision Category and Mask back to the defaults,
                 * which is to collide with everything.
                 */
                resetCollisionCategory(): this;

            }

            namespace Tilemap {
                /**
                 * A function to process the collision callbacks between a single tile and an Arcade Physics enabled Game Object.
                 * @param tile The Tile to process.
                 * @param sprite The Game Object to process with the Tile.
                 */
                function ProcessTileCallbacks(tile: Phaser.Tilemaps.Tile, sprite: Phaser.GameObjects.Sprite): boolean;

                /**
                 * Internal function to process the separation of a physics body from a tile.
                 * @param body The Body object to separate.
                 * @param x The x separation amount.
                 */
                function ProcessTileSeparationX(body: Phaser.Physics.Arcade.Body, x: number): void;

                /**
                 * Internal function to process the separation of a physics body from a tile.
                 * @param body The Body object to separate.
                 * @param y The y separation amount.
                 */
                function ProcessTileSeparationY(body: Phaser.Physics.Arcade.Body, y: number): void;

                /**
                 * The core separation function to separate a physics body and a tile.
                 * @param i The index of the tile within the map data.
                 * @param body The Body object to separate.
                 * @param tile The tile to collide against.
                 * @param tileWorldRect A rectangle-like object defining the dimensions of the tile.
                 * @param tilemapLayer The tilemapLayer to collide against.
                 * @param tileBias The tile bias value. Populated by the `World.TILE_BIAS` constant.
                 * @param isLayer Is this check coming from a TilemapLayer or an array of tiles?
                 */
                function SeparateTile(i: number, body: Phaser.Physics.Arcade.Body, tile: Phaser.Tilemaps.Tile, tileWorldRect: Phaser.Geom.Rectangle, tilemapLayer: Phaser.Tilemaps.TilemapLayer, tileBias: number, isLayer: boolean): boolean;

                /**
                 * Check the body against the given tile on the X axis.
                 * Used internally by the SeparateTile function.
                 * @param body The Body object to separate.
                 * @param tile The tile to check.
                 * @param tileLeft The left position of the tile within the tile world.
                 * @param tileRight The right position of the tile within the tile world.
                 * @param tileBias The tile bias value. Populated by the `World.TILE_BIAS` constant.
                 * @param isLayer Is this check coming from a TilemapLayer or an array of tiles?
                 */
                function TileCheckX(body: Phaser.Physics.Arcade.Body, tile: Phaser.Tilemaps.Tile, tileLeft: number, tileRight: number, tileBias: number, isLayer: boolean): number;

                /**
                 * Check the body against the given tile on the Y axis.
                 * Used internally by the SeparateTile function.
                 * @param body The Body object to separate.
                 * @param tile The tile to check.
                 * @param tileTop The top position of the tile within the tile world.
                 * @param tileBottom The bottom position of the tile within the tile world.
                 * @param tileBias The tile bias value. Populated by the `World.TILE_BIAS` constant.
                 * @param isLayer Is this check coming from a TilemapLayer or an array of tiles?
                 */
                function TileCheckY(body: Phaser.Physics.Arcade.Body, tile: Phaser.Tilemaps.Tile, tileTop: number, tileBottom: number, tileBias: number, isLayer: boolean): number;

                /**
                 * Checks for intersection between the given tile rectangle-like object and an Arcade Physics body.
                 * @param tileWorldRect A rectangle object that defines the tile placement in the world.
                 * @param body The body to check for intersection against.
                 */
                function TileIntersectsBody(tileWorldRect: Object, body: Phaser.Physics.Arcade.Body): boolean;

            }

            /**
             * The Arcade Physics World.
             * 
             * The World is responsible for creating, managing, colliding and updating all of the bodies within it.
             * 
             * An instance of the World belongs to a Phaser.Scene and is accessed via the property `physics.world`.
             */
            class World extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param scene The Scene to which this World instance belongs.
                 * @param config An Arcade Physics Configuration object.
                 */
                constructor(scene: Phaser.Scene, config: Phaser.Types.Physics.Arcade.ArcadeWorldConfig);

                /**
                 * The Scene this simulation belongs to.
                 */
                scene: Phaser.Scene;

                /**
                 * Dynamic Bodies in this simulation.
                 */
                bodies: Phaser.Structs.Set<Phaser.Physics.Arcade.Body>;

                /**
                 * Static Bodies in this simulation.
                 */
                staticBodies: Phaser.Structs.Set<Phaser.Physics.Arcade.StaticBody>;

                /**
                 * Static Bodies marked for deletion.
                 */
                pendingDestroy: Phaser.Structs.Set<(Phaser.Physics.Arcade.Body|Phaser.Physics.Arcade.StaticBody)>;

                /**
                 * This simulation's collision processors.
                 */
                colliders: Phaser.Structs.ProcessQueue<Phaser.Physics.Arcade.Collider>;

                /**
                 * Acceleration of Bodies due to gravity, in pixels per second.
                 */
                gravity: Phaser.Math.Vector2;

                /**
                 * A boundary constraining Bodies.
                 */
                bounds: Phaser.Geom.Rectangle;

                /**
                 * The boundary edges that Bodies can collide with.
                 */
                checkCollision: Phaser.Types.Physics.Arcade.CheckCollisionObject;

                /**
                 * The number of physics steps to be taken per second.
                 * 
                 * This property is read-only. Use the `setFPS` method to modify it at run-time.
                 */
                readonly fps: number;

                /**
                 * Should Physics use a fixed update time-step (true) or sync to the render fps (false)?.
                 * False value of this property disables fps and timeScale properties.
                 */
                fixedStep: boolean;

                /**
                 * The number of steps that took place in the last frame.
                 */
                readonly stepsLastFrame: number;

                /**
                 * Scaling factor applied to the frame rate.
                 * 
                 * - 1.0 = normal speed
                 * - 2.0 = half speed
                 * - 0.5 = double speed
                 */
                timeScale: number;

                /**
                 * The maximum absolute difference of a Body's per-step velocity and its overlap with another Body that will result in separation on *each axis*.
                 * Larger values favor separation.
                 * Smaller values favor no separation.
                 */
                OVERLAP_BIAS: number;

                /**
                 * The maximum absolute value of a Body's overlap with a tile that will result in separation on *each axis*.
                 * Larger values favor separation.
                 * Smaller values favor no separation.
                 * The optimum value may be similar to the tile size.
                 */
                TILE_BIAS: number;

                /**
                 * Always separate overlapping Bodies horizontally before vertically.
                 * False (the default) means Bodies are first separated on the axis of greater gravity, or the vertical axis if neither is greater.
                 */
                forceX: boolean;

                /**
                 * Whether the simulation advances with the game loop.
                 */
                isPaused: boolean;

                /**
                 * Enables the debug display.
                 */
                drawDebug: boolean;

                /**
                 * The graphics object drawing the debug display.
                 */
                debugGraphic: Phaser.GameObjects.Graphics;

                /**
                 * Default debug display settings for new Bodies.
                 */
                defaults: Phaser.Types.Physics.Arcade.ArcadeWorldDefaults;

                /**
                 * The maximum number of items per node on the RTree.
                 * 
                 * This is ignored if `useTree` is `false`. If you have a large number of bodies in
                 * your world then you may find search performance improves by increasing this value,
                 * to allow more items per node and less node division.
                 */
                maxEntries: number;

                /**
                 * Should this Arcade Physics World use an RTree for Dynamic bodies?
                 * 
                 * An RTree is a fast way of spatially sorting of all the bodies in the world.
                 * However, at certain limits, the cost of clearing and inserting the bodies into the
                 * tree every frame becomes more expensive than the search speed gains it provides.
                 * 
                 * If you have a large number of dynamic bodies in your world then it may be best to
                 * disable the use of the RTree by setting this property to `false` in the physics config.
                 * 
                 * The number it can cope with depends on browser and device, but a conservative estimate
                 * of around 5,000 bodies should be considered the max before disabling it.
                 * 
                 * This only applies to dynamic bodies. Static bodies are always kept in an RTree,
                 * because they don't have to be cleared every frame, so you benefit from the
                 * massive search speeds all the time.
                 */
                useTree: boolean;

                /**
                 * The spatial index of Dynamic Bodies.
                 */
                tree: Phaser.Structs.RTree;

                /**
                 * The spatial index of Static Bodies.
                 */
                staticTree: Phaser.Structs.RTree;

                /**
                 * Recycled input for tree searches.
                 */
                treeMinMax: Phaser.Types.Physics.Arcade.ArcadeWorldTreeMinMax;

                /**
                 * The Filtering Options passed to `GetTilesWithinWorldXY` as part of the `collideSpriteVsTilemapLayer` check.
                 */
                tileFilterOptions: Phaser.Types.Tilemaps.FilteringOptions;

                /**
                 * Adds an Arcade Physics Body to a Game Object, an array of Game Objects, or the children of a Group.
                 * 
                 * The difference between this and the `enableBody` method is that you can pass arrays or Groups
                 * to this method.
                 * 
                 * You can specify if the bodies are to be Dynamic or Static. A dynamic body can move via velocity and
                 * acceleration. A static body remains fixed in place and as such is able to use an optimized search
                 * tree, making it ideal for static elements such as level objects. You can still collide and overlap
                 * with static bodies.
                 * 
                 * Normally, rather than calling this method directly, you'd use the helper methods available in the
                 * Arcade Physics Factory, such as:
                 * 
                 * ```javascript
                 * this.physics.add.image(x, y, textureKey);
                 * this.physics.add.sprite(x, y, textureKey);
                 * ```
                 * 
                 * Calling factory methods encapsulates the creation of a Game Object and the creation of its
                 * body at the same time. If you are creating custom classes then you can pass them to this
                 * method to have their bodies created.
                 * @param object The object, or objects, on which to create the bodies.
                 * @param bodyType The type of Body to create. Either `DYNAMIC_BODY` or `STATIC_BODY`.
                 */
                enable(object: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[] | Phaser.GameObjects.Group | Phaser.GameObjects.Group[], bodyType?: number): void;

                /**
                 * Creates an Arcade Physics Body on a single Game Object.
                 * 
                 * If the Game Object already has a body, this method will simply add it back into the simulation.
                 * 
                 * You can specify if the body is Dynamic or Static. A dynamic body can move via velocity and
                 * acceleration. A static body remains fixed in place and as such is able to use an optimized search
                 * tree, making it ideal for static elements such as level objects. You can still collide and overlap
                 * with static bodies.
                 * 
                 * Normally, rather than calling this method directly, you'd use the helper methods available in the
                 * Arcade Physics Factory, such as:
                 * 
                 * ```javascript
                 * this.physics.add.image(x, y, textureKey);
                 * this.physics.add.sprite(x, y, textureKey);
                 * ```
                 * 
                 * Calling factory methods encapsulates the creation of a Game Object and the creation of its
                 * body at the same time. If you are creating custom classes then you can pass them to this
                 * method to have their bodies created.
                 * @param object The Game Object on which to create the body.
                 * @param bodyType The type of Body to create. Either `DYNAMIC_BODY` or `STATIC_BODY`.
                 */
                enableBody(object: Phaser.GameObjects.GameObject, bodyType?: number): Phaser.GameObjects.GameObject;

                /**
                 * Adds an existing Arcade Physics Body or StaticBody to the simulation.
                 * 
                 * The body is enabled and added to the local search trees.
                 * @param body The Body to be added to the simulation.
                 */
                add(body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody): Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody;

                /**
                 * Disables the Arcade Physics Body of a Game Object, an array of Game Objects, or the children of a Group.
                 * 
                 * The difference between this and the `disableBody` method is that you can pass arrays or Groups
                 * to this method.
                 * 
                 * The body itself is not deleted, it just has its `enable` property set to false, which
                 * means you can re-enable it again at any point by passing it to enable `World.enable` or `World.add`.
                 * @param object The object, or objects, on which to disable the bodies.
                 */
                disable(object: Phaser.GameObjects.GameObject | Phaser.GameObjects.GameObject[] | Phaser.GameObjects.Group | Phaser.GameObjects.Group[]): void;

                /**
                 * Disables an existing Arcade Physics Body or StaticBody and removes it from the simulation.
                 * 
                 * The body is disabled and removed from the local search trees.
                 * 
                 * The body itself is not deleted, it just has its `enable` property set to false, which
                 * means you can re-enable it again at any point by passing it to enable `World.enable` or `World.add`.
                 * @param body The Body to be disabled.
                 */
                disableBody(body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody): void;

                /**
                 * Removes an existing Arcade Physics Body or StaticBody from the simulation.
                 * 
                 * The body is disabled and removed from the local search trees.
                 * 
                 * The body itself is not deleted, it just has its `enabled` property set to false, which
                 * means you can re-enable it again at any point by passing it to enable `enable` or `add`.
                 * @param body The body to be removed from the simulation.
                 */
                remove(body: Phaser.Physics.Arcade.Body | Phaser.Physics.Arcade.StaticBody): void;

                /**
                 * Creates a Graphics Game Object that the world will use to render the debug display to.
                 * 
                 * This is called automatically when the World is instantiated if the `debug` config property
                 * was set to `true`. However, you can call it at any point should you need to display the
                 * debug Graphic from a fixed point.
                 * 
                 * You can control which objects are drawn to the Graphics object, and the colors they use,
                 * by setting the debug properties in the physics config.
                 * 
                 * You should not typically use this in a production game. Use it to aid during debugging.
                 */
                createDebugGraphic(): Phaser.GameObjects.Graphics;

                /**
                 * Sets the position, size and properties of the World boundary.
                 * 
                 * The World boundary is an invisible rectangle that defines the edges of the World.
                 * If a Body is set to collide with the world bounds then it will automatically stop
                 * when it reaches any of the edges. You can optionally set which edges of the boundary
                 * should be checked against.
                 * @param x The top-left x coordinate of the boundary.
                 * @param y The top-left y coordinate of the boundary.
                 * @param width The width of the boundary.
                 * @param height The height of the boundary.
                 * @param checkLeft Should bodies check against the left edge of the boundary?
                 * @param checkRight Should bodies check against the right edge of the boundary?
                 * @param checkUp Should bodies check against the top edge of the boundary?
                 * @param checkDown Should bodies check against the bottom edge of the boundary?
                 */
                setBounds(x: number, y: number, width: number, height: number, checkLeft?: boolean, checkRight?: boolean, checkUp?: boolean, checkDown?: boolean): Phaser.Physics.Arcade.World;

                /**
                 * Enables or disables collisions on each edge of the World boundary.
                 * @param left Should bodies check against the left edge of the boundary? Default true.
                 * @param right Should bodies check against the right edge of the boundary? Default true.
                 * @param up Should bodies check against the top edge of the boundary? Default true.
                 * @param down Should bodies check against the bottom edge of the boundary? Default true.
                 */
                setBoundsCollision(left?: boolean, right?: boolean, up?: boolean, down?: boolean): Phaser.Physics.Arcade.World;

                /**
                 * Pauses the simulation.
                 * 
                 * A paused simulation does not update any existing bodies, or run any Colliders.
                 * 
                 * However, you can still enable and disable bodies within it, or manually run collide or overlap
                 * checks.
                 */
                pause(): Phaser.Physics.Arcade.World;

                /**
                 * Resumes the simulation, if paused.
                 */
                resume(): Phaser.Physics.Arcade.World;

                /**
                 * Creates a new Collider object and adds it to the simulation.
                 * 
                 * A Collider is a way to automatically perform collision checks between two objects,
                 * calling the collide and process callbacks if they occur.
                 * 
                 * Colliders are run as part of the World update, after all of the Bodies have updated.
                 * 
                 * By creating a Collider you don't need then call `World.collide` in your `update` loop,
                 * as it will be handled for you automatically.
                 * @param object1 The first object to check for collision.
                 * @param object2 The second object to check for collision.
                 * @param collideCallback The callback to invoke when the two objects collide.
                 * @param processCallback The callback to invoke when the two objects collide. Must return a boolean.
                 * @param callbackContext The scope in which to call the callbacks.
                 */
                addCollider(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): Phaser.Physics.Arcade.Collider;

                /**
                 * Creates a new Overlap Collider object and adds it to the simulation.
                 * 
                 * A Collider is a way to automatically perform overlap checks between two objects,
                 * calling the collide and process callbacks if they occur.
                 * 
                 * Colliders are run as part of the World update, after all of the Bodies have updated.
                 * 
                 * By creating a Collider you don't need then call `World.overlap` in your `update` loop,
                 * as it will be handled for you automatically.
                 * @param object1 The first object to check for overlap.
                 * @param object2 The second object to check for overlap.
                 * @param collideCallback The callback to invoke when the two objects overlap.
                 * @param processCallback The callback to invoke when the two objects overlap. Must return a boolean.
                 * @param callbackContext The scope in which to call the callbacks.
                 */
                addOverlap(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): Phaser.Physics.Arcade.Collider;

                /**
                 * Removes a Collider from the simulation so it is no longer processed.
                 * 
                 * This method does not destroy the Collider. If you wish to add it back at a later stage you can call
                 * `World.colliders.add(Collider)`.
                 * 
                 * If you no longer need the Collider you can call the `Collider.destroy` method instead, which will
                 * automatically clear all of its references and then remove it from the World. If you call destroy on
                 * a Collider you _don't_ need to pass it to this method too.
                 * @param collider The Collider to remove from the simulation.
                 */
                removeCollider(collider: Phaser.Physics.Arcade.Collider): Phaser.Physics.Arcade.World;

                /**
                 * Sets the frame rate to run the simulation at.
                 * 
                 * The frame rate value is used to simulate a fixed update time step. This fixed
                 * time step allows for a straightforward implementation of a deterministic game state.
                 * 
                 * This frame rate is independent of the frequency at which the game is rendering. The
                 * higher you set the fps, the more physics simulation steps will occur per game step.
                 * Conversely, the lower you set it, the less will take place.
                 * 
                 * You can optionally advance the simulation directly yourself by calling the `step` method.
                 * @param framerate The frame rate to advance the simulation at.
                 */
                setFPS(framerate: number): this;

                /**
                 * Advances the simulation based on the elapsed time and fps rate.
                 * 
                 * This is called automatically by your Scene and does not need to be invoked directly.
                 * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
                 * @param delta The delta time, in ms, elapsed since the last frame.
                 */
                update(time: number, delta: number): void;

                /**
                 * Advances the simulation by a time increment.
                 * @param delta The delta time amount, in seconds, by which to advance the simulation.
                 */
                step(delta: number): void;

                /**
                 * Advances the simulation by a single step.
                 */
                singleStep(): void;

                /**
                 * Updates bodies, draws the debug display, and handles pending queue operations.
                 */
                postUpdate(): void;

                /**
                 * Calculates a Body's velocity and updates its position.
                 * @param body The Body to be updated.
                 * @param delta The delta value to be used in the motion calculations, in seconds.
                 */
                updateMotion(body: Phaser.Physics.Arcade.Body, delta: number): void;

                /**
                 * Calculates a Body's angular velocity.
                 * @param body The Body to compute the velocity for.
                 * @param delta The delta value to be used in the calculation, in seconds.
                 */
                computeAngularVelocity(body: Phaser.Physics.Arcade.Body, delta: number): void;

                /**
                 * Calculates a Body's per-axis velocity.
                 * @param body The Body to compute the velocity for.
                 * @param delta The delta value to be used in the calculation, in seconds.
                 */
                computeVelocity(body: Phaser.Physics.Arcade.Body, delta: number): void;

                /**
                 * Separates two Bodies.
                 * @param body1 The first Body to be separated.
                 * @param body2 The second Body to be separated.
                 * @param processCallback The process callback.
                 * @param callbackContext The context in which to invoke the callback.
                 * @param overlapOnly If this a collide or overlap check?
                 */
                separate(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any, overlapOnly?: boolean): boolean;

                /**
                 * Separates two Bodies, when both are circular.
                 * @param body1 The first Body to be separated.
                 * @param body2 The second Body to be separated.
                 * @param overlapOnly If this a collide or overlap check?
                 */
                separateCircle(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body, overlapOnly?: boolean): boolean;

                /**
                 * Checks to see if two Bodies intersect at all.
                 * @param body1 The first body to check.
                 * @param body2 The second body to check.
                 */
                intersects(body1: Phaser.Physics.Arcade.Body, body2: Phaser.Physics.Arcade.Body): boolean;

                /**
                 * Tests if a circular Body intersects with another Body.
                 * @param circle The circular body to test.
                 * @param body The rectangular body to test.
                 */
                circleBodyIntersects(circle: Phaser.Physics.Arcade.Body, body: Phaser.Physics.Arcade.Body): boolean;

                /**
                 * Tests if Game Objects overlap.
                 * 
                 * See details in {@link Phaser.Physics.Arcade.World#collide}.
                 * @param object1 The first object or array of objects to check.
                 * @param object2 The second object or array of objects to check, or `undefined`.
                 * @param overlapCallback An optional callback function that is called if the objects overlap.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they overlap. If this is set then `overlapCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                overlap(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2?: Phaser.Types.Physics.Arcade.ArcadeColliderType, overlapCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Performs a collision check and separation between the two physics enabled objects given, which can be single
                 * Game Objects, arrays of Game Objects, Physics Groups, arrays of Physics Groups or normal Groups.
                 * 
                 * If you don't require separation then use {@link Phaser.Physics.Arcade.World#overlap} instead.
                 * 
                 * If two Groups or arrays are passed, each member of one will be tested against each member of the other.
                 * 
                 * If **only** one Group is passed (as `object1`), each member of the Group will be collided against the other members.
                 * 
                 * If **only** one Array is passed, the array is iterated and every element in it is tested against the others.
                 * 
                 * Two callbacks can be provided; they receive the colliding game objects as arguments.
                 * If an overlap is detected, the `processCallback` is called first. It can cancel the collision by returning false.
                 * Next the objects are separated and `collideCallback` is invoked.
                 * 
                 * Arcade Physics uses the Projection Method of collision resolution and separation. While it's fast and suitable
                 * for 'arcade' style games it lacks stability when multiple objects are in close proximity or resting upon each other.
                 * The separation that stops two objects penetrating may create a new penetration against a different object. If you
                 * require a high level of stability please consider using an alternative physics system, such as Matter.js.
                 * @param object1 The first object or array of objects to check.
                 * @param object2 The second object or array of objects to check, or `undefined`.
                 * @param collideCallback An optional callback function that is called if the objects collide.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                collide(object1: Phaser.Types.Physics.Arcade.ArcadeColliderType, object2?: Phaser.Types.Physics.Arcade.ArcadeColliderType, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Checks if the two given Arcade Physics bodies will collide, or not,
                 * based on their collision mask and collision categories.
                 * @param body1 The first body to check.
                 * @param body2 The second body to check.
                 */
                canCollide(body1: Phaser.Types.Physics.Arcade.ArcadeCollider, body2: Phaser.Types.Physics.Arcade.ArcadeCollider): boolean;

                /**
                 * This advanced method is specifically for testing for collision between a single Sprite and an array of Tile objects.
                 * 
                 * You should generally use the `collide` method instead, with a Sprite vs. a Tilemap Layer, as that will perform
                 * tile filtering and culling for you, as well as handle the interesting face collision automatically.
                 * 
                 * This method is offered for those who would like to check for collision with specific Tiles in a layer, without
                 * having to set any collision attributes on the tiles in question. This allows you to perform quick dynamic collisions
                 * on small sets of Tiles. As such, no culling or checks are made to the array of Tiles given to this method,
                 * you should filter them before passing them to this method.
                 * 
                 * Important: Use of this method skips the `interesting faces` system that Tilemap Layers use. This means if you have
                 * say a row or column of tiles, and you jump into, or walk over them, it's possible to get stuck on the edges of the
                 * tiles as the interesting face calculations are skipped. However, for quick-fire small collision set tests on
                 * dynamic maps, this method can prove very useful.
                 * 
                 * This method does not factor in the Collision Mask or Category.
                 * @param sprite The first object to check for collision.
                 * @param tiles An array of Tiles to check for collision against.
                 * @param collideCallback An optional callback function that is called if the objects collide.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                collideTiles(sprite: Phaser.GameObjects.GameObject, tiles: Phaser.Tilemaps.Tile[], collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * This advanced method is specifically for testing for overlaps between a single Sprite and an array of Tile objects.
                 * 
                 * You should generally use the `overlap` method instead, with a Sprite vs. a Tilemap Layer, as that will perform
                 * tile filtering and culling for you, as well as handle the interesting face collision automatically.
                 * 
                 * This method is offered for those who would like to check for overlaps with specific Tiles in a layer, without
                 * having to set any collision attributes on the tiles in question. This allows you to perform quick dynamic overlap
                 * tests on small sets of Tiles. As such, no culling or checks are made to the array of Tiles given to this method,
                 * you should filter them before passing them to this method.
                 * 
                 * This method does not factor in the Collision Mask or Category.
                 * @param sprite The first object to check for collision.
                 * @param tiles An array of Tiles to check for collision against.
                 * @param collideCallback An optional callback function that is called if the objects overlap.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 */
                overlapTiles(sprite: Phaser.GameObjects.GameObject, tiles: Phaser.Tilemaps.Tile[], collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Internal handler for Sprite vs. Tilemap collisions.
                 * Please use Phaser.Physics.Arcade.World#collide instead.
                 * @param sprite The first object to check for collision.
                 * @param tilemapLayer The second object to check for collision.
                 * @param collideCallback An optional callback function that is called if the objects collide.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two objects if they collide. If this is set then `collideCallback` will only be called if this callback returns `true`.
                 * @param callbackContext The context in which to run the callbacks.
                 * @param overlapOnly Whether this is a collision or overlap check.
                 */
                collideSpriteVsTilemapLayer(sprite: Phaser.GameObjects.GameObject, tilemapLayer: Phaser.Tilemaps.TilemapLayer, collideCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any, overlapOnly?: boolean): boolean;

                /**
                 * Wrap an object's coordinates (or several objects' coordinates) within {@link Phaser.Physics.Arcade.World#bounds}.
                 * 
                 * If the object is outside any boundary edge (left, top, right, bottom), it will be moved to the same offset from the opposite edge (the interior).
                 * @param object A Game Object, a Group, an object with `x` and `y` coordinates, or an array of such objects.
                 * @param padding An amount added to each boundary edge during the operation. Default 0.
                 */
                wrap(object: any, padding?: number): void;

                /**
                 * Wrap each object's coordinates within {@link Phaser.Physics.Arcade.World#bounds}.
                 * @param objects An array of objects to be wrapped.
                 * @param padding An amount added to the boundary. Default 0.
                 */
                wrapArray(objects: any[], padding?: number): void;

                /**
                 * Wrap an object's coordinates within {@link Phaser.Physics.Arcade.World#bounds}.
                 * @param object A Game Object, a Physics Body, or any object with `x` and `y` coordinates
                 * @param padding An amount added to the boundary. Default 0.
                 */
                wrapObject(object: any, padding?: number): void;

                /**
                 * Shuts down the simulation, clearing physics data and removing listeners.
                 */
                shutdown(): void;

                /**
                 * Shuts down the simulation and disconnects it from the current scene.
                 */
                destroy(): void;

            }

        }

        namespace Matter {
            /**
             * The Body Bounds class contains methods to help you extract the world coordinates from various points around
             * the bounds of a Matter Body. Because Matter bodies are positioned based on their center of mass, and not a
             * dimension based center, you often need to get the bounds coordinates in order to properly align them in the world.
             * 
             * You can access this class via the MatterPhysics class from a Scene, i.e.:
             * 
             * ```javascript
             * this.matter.bodyBounds.getTopLeft(body);
             * ```
             * 
             * See also the `MatterPhysics.alignBody` method.
             */
            class BodyBounds {
                /**
                 * A Vector2 that stores the temporary bounds center value during calculations by methods in this class.
                 */
                boundsCenter: Phaser.Math.Vector2;

                /**
                 * A Vector2 that stores the temporary center diff values during calculations by methods in this class.
                 */
                centerDiff: Phaser.Math.Vector2;

                /**
                 * Parses the given body to get the bounds diff values from it.
                 * 
                 * They're stored in this class in the temporary properties `boundsCenter` and `centerDiff`.
                 * 
                 * This method is called automatically by all other methods in this class.
                 * @param body The Body to get the bounds position from.
                 */
                parseBody(body: Phaser.Types.Physics.Matter.MatterBody): boolean;

                /**
                 * Takes a Body and returns the world coordinates of the top-left of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getTopLeft(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the top-center of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getTopCenter(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the top-right of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getTopRight(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the left-center of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getLeftCenter(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the center of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getCenter(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the right-center of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getRightCenter(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the bottom-left of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getBottomLeft(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the bottom-center of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getBottomCenter(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

                /**
                 * Takes a Body and returns the world coordinates of the bottom-right of its _bounds_.
                 * 
                 * Body bounds are updated by Matter each step and factor in scale and rotation.
                 * This will return the world coordinate based on the bodies _current_ position and bounds.
                 * @param body The Body to get the position from.
                 * @param x Optional horizontal offset to add to the returned coordinates. Default 0.
                 * @param y Optional vertical offset to add to the returned coordinates. Default 0.
                 */
                getBottomRight(body: Phaser.Types.Physics.Matter.MatterBody, x?: number, y?: number): Phaser.Math.Vector2 | false;

            }

            namespace Components {
                /**
                 * A component to set restitution on objects.
                 */
                interface Bounce {
                    /**
                     * Sets the restitution on the physics object.
                     * @param value A Number that defines the restitution (elasticity) of the body. The value is always positive and is in the range (0, 1). A value of 0 means collisions may be perfectly inelastic and no bouncing may occur. A value of 0.8 means the body may bounce back with approximately 80% of its kinetic energy. Note that collision response is based on pairs of bodies, and that restitution values are combined with the following formula: `Math.max(bodyA.restitution, bodyB.restitution)`
                     */
                    setBounce(value: number): this;
                }

                /**
                 * Contains methods for changing the collision filter of a Matter Body. Should be used as a mixin and not called directly.
                 */
                interface Collision {
                    /**
                     * Sets the collision category of this Game Object's Matter Body. This number must be a power of two between 2^0 (= 1) and 2^31.
                     * Two bodies with different collision groups (see {@link #setCollisionGroup}) will only collide if their collision
                     * categories are included in their collision masks (see {@link #setCollidesWith}).
                     * @param value Unique category bitfield.
                     */
                    setCollisionCategory(value: number): this;
                    /**
                     * Sets the collision group of this Game Object's Matter Body. If this is zero or two Matter Bodies have different values,
                     * they will collide according to the usual rules (see {@link #setCollisionCategory} and {@link #setCollisionGroup}).
                     * If two Matter Bodies have the same positive value, they will always collide; if they have the same negative value,
                     * they will never collide.
                     * @param value Unique group index.
                     */
                    setCollisionGroup(value: number): this;
                    /**
                     * Sets the collision mask for this Game Object's Matter Body. Two Matter Bodies with different collision groups will only
                     * collide if each one includes the other's category in its mask based on a bitwise AND, i.e. `(categoryA & maskB) !== 0`
                     * and `(categoryB & maskA) !== 0` are both true.
                     * @param categories A unique category bitfield, or an array of them.
                     */
                    setCollidesWith(categories: number | number[]): this;
                    /**
                     * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                     * 
                     * This does not change the bodies collision category, group or filter. Those must be set in addition
                     * to the callback.
                     * @param callback The callback to invoke when this body starts colliding with another.
                     */
                    setOnCollide(callback: Function): this;
                    /**
                     * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                     * 
                     * This does not change the bodies collision category, group or filter. Those must be set in addition
                     * to the callback.
                     * @param callback The callback to invoke when this body stops colliding with another.
                     */
                    setOnCollideEnd(callback: Function): this;
                    /**
                     * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                     * 
                     * This does not change the bodies collision category, group or filter. Those must be set in addition
                     * to the callback.
                     * @param callback The callback to invoke for the duration of this body colliding with another.
                     */
                    setOnCollideActive(callback: Function): this;
                    /**
                     * The callback is sent a reference to the other body, along with a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                     * 
                     * This does not change the bodies collision category, group or filter. Those must be set in addition
                     * to the callback.
                     * @param body The body, or an array of bodies, to test for collisions with.
                     * @param callback The callback to invoke when this body collides with the given body or bodies.
                     */
                    setOnCollideWith(body: MatterJS.Body | MatterJS.Body[], callback: Function): this;
                }

                /**
                 * A component to apply force to Matter.js bodies.
                 */
                interface Force {
                    /**
                     * Applies a force to a body.
                     * @param force A Vector that specifies the force to apply.
                     */
                    applyForce(force: Phaser.Math.Vector2): this;
                    /**
                     * Applies a force to a body from a given position.
                     * @param position The position in which the force comes from.
                     * @param force A Vector that specifies the force to apply.
                     */
                    applyForceFrom(position: Phaser.Math.Vector2, force: Phaser.Math.Vector2): this;
                    /**
                     * Apply thrust to the forward position of the body.
                     * 
                     * Use very small values, such as 0.1, depending on the mass and required speed.
                     * @param speed A speed value to be applied to a directional force.
                     */
                    thrust(speed: number): this;
                    /**
                     * Apply thrust to the left position of the body.
                     * 
                     * Use very small values, such as 0.1, depending on the mass and required speed.
                     * @param speed A speed value to be applied to a directional force.
                     */
                    thrustLeft(speed: number): this;
                    /**
                     * Apply thrust to the right position of the body.
                     * 
                     * Use very small values, such as 0.1, depending on the mass and required speed.
                     * @param speed A speed value to be applied to a directional force.
                     */
                    thrustRight(speed: number): this;
                    /**
                     * Apply thrust to the back position of the body.
                     * 
                     * Use very small values, such as 0.1, depending on the mass and required speed.
                     * @param speed A speed value to be applied to a directional force.
                     */
                    thrustBack(speed: number): this;
                }

                /**
                 * Contains methods for changing the friction of a Game Object's Matter Body. Should be used a mixin, not called directly.
                 */
                interface Friction {
                    /**
                     * Sets new friction values for this Game Object's Matter Body.
                     * @param value The new friction of the body, between 0 and 1, where 0 allows the Body to slide indefinitely, while 1 allows it to stop almost immediately after a force is applied.
                     * @param air If provided, the new air resistance of the Body. The higher the value, the faster the Body will slow as it moves through space. 0 means the body has no air resistance.
                     * @param fstatic If provided, the new static friction of the Body. The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary. 0 means the body will never "stick" when it is nearly stationary.
                     */
                    setFriction(value: number, air?: number, fstatic?: number): this;
                    /**
                     * Sets a new air resistance for this Game Object's Matter Body.
                     * A value of 0 means the Body will never slow as it moves through space.
                     * The higher the value, the faster a Body slows when moving through space.
                     * @param value The new air resistance for the Body.
                     */
                    setFrictionAir(value: number): this;
                    /**
                     * Sets a new static friction for this Game Object's Matter Body.
                     * A value of 0 means the Body will never "stick" when it is nearly stationary.
                     * The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary.
                     * @param value The new static friction for the Body.
                     */
                    setFrictionStatic(value: number): this;
                }

                /**
                 * A component to manipulate world gravity for Matter.js bodies.
                 */
                interface Gravity {
                    /**
                     * A togglable function for ignoring world gravity in real-time on the current body.
                     * @param value Set to true to ignore the effect of world gravity, or false to not ignore it.
                     */
                    setIgnoreGravity(value: boolean): this;
                }

                /**
                 * Allows accessing the mass, density, and center of mass of a Matter-enabled Game Object. Should be used as a mixin and not directly.
                 */
                interface Mass {
                    /**
                     * Sets the mass of the Game Object's Matter Body.
                     * @param value The new mass of the body.
                     */
                    setMass(value: number): this;
                    /**
                     * Sets density of the body.
                     * @param value The new density of the body.
                     */
                    setDensity(value: number): this;
                    /**
                     * The body's center of mass.
                     * 
                     * Calling this creates a new `Vector2 each time to avoid mutation.
                     * 
                     * If you only need to read the value and won't change it, you can get it from `GameObject.body.centerOfMass`.
                     */
                    readonly centerOfMass: Phaser.Math.Vector2;
                }

                /**
                 * Enables a Matter-enabled Game Object to be a sensor. Should be used as a mixin and not directly.
                 */
                interface Sensor {
                    /**
                     * Set the body belonging to this Game Object to be a sensor.
                     * Sensors trigger collision events, but don't react with colliding body physically.
                     * @param value `true` to set the body as a sensor, or `false` to disable it.
                     */
                    setSensor(value: boolean): this;
                    /**
                     * Is the body belonging to this Game Object a sensor or not?
                     */
                    isSensor(): boolean;
                }

                /**
                 * Enables a Matter-enabled Game Object to set its Body. Should be used as a mixin and not directly.
                 */
                interface SetBody {
                    /**
                     * Set this Game Objects Matter physics body to be a rectangle shape.
                     * 
                     * Calling this methods resets all previous properties you may have set on the body, including
                     * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                     * @param width Width of the rectangle.
                     * @param height Height of the rectangle.
                     * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                     */
                    setRectangle(width: number, height: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;
                    /**
                     * Set this Game Objects Matter physics body to be a circle shape.
                     * 
                     * Calling this methods resets all previous properties you may have set on the body, including
                     * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                     * @param radius The radius of the circle.
                     * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                     */
                    setCircle(radius: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;
                    /**
                     * Set this Game Objects Matter physics body to be a polygon shape.
                     * 
                     * Calling this methods resets all previous properties you may have set on the body, including
                     * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                     * @param radius The "radius" of the polygon, i.e. the distance from its center to any vertex. This is also the radius of its circumcircle.
                     * @param sides The number of sides the polygon will have.
                     * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                     */
                    setPolygon(radius: number, sides: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;
                    /**
                     * Set this Game Objects Matter physics body to be a trapezoid shape.
                     * 
                     * Calling this methods resets all previous properties you may have set on the body, including
                     * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                     * @param width The width of the trapezoid Body.
                     * @param height The height of the trapezoid Body.
                     * @param slope The slope of the trapezoid. 0 creates a rectangle, while 1 creates a triangle. Positive values make the top side shorter, while negative values make the bottom side shorter.
                     * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                     */
                    setTrapezoid(width: number, height: number, slope: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;
                    /**
                     * Set this Game Object to use the given existing Matter Body.
                     * 
                     * The body is first removed from the world before being added to this Game Object.
                     * @param body The Body this Game Object should use.
                     * @param addToWorld Should the body be immediately added to the World? Default true.
                     */
                    setExistingBody(body: MatterJS.BodyType, addToWorld?: boolean): this;
                    /**
                     * Set this Game Object to create and use a new Body based on the configuration object given.
                     * 
                     * Calling this methods resets all previous properties you may have set on the body, including
                     * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                     * @param config Either a string, such as `circle`, or a Matter Set Body Configuration object.
                     * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                     */
                    setBody(config: string | Phaser.Types.Physics.Matter.MatterSetBodyConfig, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;
                }

                /**
                 * Enables a Matter-enabled Game Object to be able to go to sleep. Should be used as a mixin and not directly.
                 */
                interface Sleep {
                    /**
                     * Sets this Body to sleep.
                     */
                    setToSleep(): this;
                    /**
                     * Wakes this Body if asleep.
                     */
                    setAwake(): this;
                    /**
                     * Sets the number of updates in which this body must have near-zero velocity before it is set as sleeping (if sleeping is enabled by the engine).
                     * @param value A `Number` that defines the number of updates in which this body must have near-zero velocity before it is set as sleeping. Default 60.
                     */
                    setSleepThreshold(value?: number): this;
                    /**
                     * Enable sleep and wake events for this body.
                     * 
                     * By default when a body goes to sleep, or wakes up, it will not emit any events.
                     * 
                     * The events are emitted by the Matter World instance and can be listened to via
                     * the `SLEEP_START` and `SLEEP_END` events.
                     * @param start `true` if you want the sleep start event to be emitted for this body.
                     * @param end `true` if you want the sleep end event to be emitted for this body.
                     */
                    setSleepEvents(start: boolean, end: boolean): this;
                    /**
                     * Enables or disables the Sleep Start event for this body.
                     * @param value `true` to enable the sleep event, or `false` to disable it.
                     */
                    setSleepStartEvent(value: boolean): this;
                    /**
                     * Enables or disables the Sleep End event for this body.
                     * @param value `true` to enable the sleep event, or `false` to disable it.
                     */
                    setSleepEndEvent(value: boolean): this;
                }

                /**
                 * Provides methods used for getting and setting the static state of a physics body.
                 */
                interface Static {
                    /**
                     * Changes the physics body to be either static `true` or dynamic `false`.
                     * @param value `true` to set the body as being static, or `false` to make it dynamic.
                     */
                    setStatic(value: boolean): this;
                    /**
                     * Returns `true` if the body is static, otherwise `false` for a dynamic body.
                     */
                    isStatic(): boolean;
                }

                /**
                 * Provides methods used for getting and setting the position, scale and rotation of a Game Object.
                 */
                interface Transform {
                    /**
                     * The x position of this Game Object.
                     */
                    x: number;
                    /**
                     * The y position of this Game Object.
                     */
                    y: number;
                    /**
                     * The horizontal scale of this Game Object.
                     */
                    scaleX: number;
                    /**
                     * The vertical scale of this Game Object.
                     */
                    scaleY: number;
                    /**
                     * Use `angle` to set or get rotation of the physics body associated to this GameObject.
                     * Unlike rotation, when using set the value can be in degrees, which will be converted to radians internally.
                     */
                    angle: number;
                    /**
                     * Use `rotation` to set or get the rotation of the physics body associated with this GameObject.
                     * The value when set must be in radians.
                     */
                    rotation: number;
                    /**
                     * Sets the position of the physics body along x and y axes.
                     * Both the parameters to this function are optional and if not passed any they default to 0.
                     * Velocity, angle, force etc. are unchanged.
                     * @param x The horizontal position of the body. Default 0.
                     * @param y The vertical position of the body. Default x.
                     */
                    setPosition(x?: number, y?: number): this;
                    /**
                     * Immediately sets the angle of the Body.
                     * Angular velocity, position, force etc. are unchanged.
                     * @param radians The angle of the body, in radians. Default 0.
                     */
                    setRotation(radians?: number): this;
                    /**
                     * Setting fixed rotation sets the Body inertia to Infinity, which stops it
                     * from being able to rotate when forces are applied to it.
                     */
                    setFixedRotation(): this;
                    /**
                     * Immediately sets the angle of the Body.
                     * Angular velocity, position, force etc. are unchanged.
                     * @param degrees The angle to set, in degrees. Default 0.
                     */
                    setAngle(degrees?: number): this;
                    /**
                     * Sets the scale of this Game Object.
                     * @param x The horizontal scale of this Game Object. Default 1.
                     * @param y The vertical scale of this Game Object. If not set it will use the x value. Default x.
                     * @param point The point (Vector2) from which scaling will occur.
                     */
                    setScale(x?: number, y?: number, point?: Phaser.Math.Vector2): this;
                }

                /**
                 * Contains methods for changing the velocity of a Matter Body. Should be used as a mixin and not called directly.
                 */
                interface Velocity {
                    /**
                     * Sets the horizontal velocity of the physics body.
                     * @param x The horizontal velocity value.
                     */
                    setVelocityX(x: number): this;
                    /**
                     * Sets vertical velocity of the physics body.
                     * @param y The vertical velocity value.
                     */
                    setVelocityY(y: number): this;
                    /**
                     * Sets both the horizontal and vertical velocity of the physics body.
                     * @param x The horizontal velocity value.
                     * @param y The vertical velocity value, it can be either positive or negative. If not given, it will be the same as the `x` value. Default x.
                     */
                    setVelocity(x: number, y?: number): this;
                    /**
                     * Gets the current linear velocity of the physics body.
                     */
                    getVelocity(): Phaser.Types.Math.Vector2Like;
                    /**
                     * Sets the angular velocity of the body instantly.
                     * Position, angle, force etc. are unchanged.
                     * @param velocity The angular velocity.
                     */
                    setAngularVelocity(velocity: number): this;
                    /**
                     * Gets the current rotational velocity of the body.
                     */
                    getAngularVelocity(): number;
                    /**
                     * Sets the current rotational speed of the body.
                     * Direction is maintained. Affects body angular velocity.
                     * @param speed The angular speed.
                     */
                    setAngularSpeed(speed: number): this;
                    /**
                     * Gets the current rotational speed of the body.
                     * Equivalent to the magnitude of its angular velocity.
                     */
                    getAngularSpeed(): number;
                }

            }

            namespace Matter {
            }

            namespace Events {
                type AfterAddEvent = {
                    /**
                     * An array of the object(s) that have been added. May be a single body, constraint, composite or a mixture of these.
                     */
                    object: any[];
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics After Add Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance at the end of the process when a new Body
                 * or Constraint has just been added to the world.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('afteradd', listener)`.
                 */
                const AFTER_ADD: string;

                type AfterRemoveEvent = {
                    /**
                     * An array of the object(s) that were removed. May be a single body, constraint, composite or a mixture of these.
                     */
                    object: any[];
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics After Remove Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance at the end of the process when a
                 * Body or Constraint was removed from the world.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('afterremove', listener)`.
                 */
                const AFTER_REMOVE: string;

                type AfterUpdateEvent = {
                    /**
                     * The Matter Engine `timing.timestamp` value for the event.
                     */
                    timestamp: number;
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics After Update Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance after the engine has updated and all collision events have resolved.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('afterupdate', listener)`.
                 */
                const AFTER_UPDATE: string;

                type BeforeAddEvent = {
                    /**
                     * An array of the object(s) to be added. May be a single body, constraint, composite or a mixture of these.
                     */
                    object: any[];
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Before Add Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance at the start of the process when a new Body
                 * or Constraint is being added to the world.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('beforeadd', listener)`.
                 */
                const BEFORE_ADD: string;

                type BeforeRemoveEvent = {
                    /**
                     * An array of the object(s) to be removed. May be a single body, constraint, composite or a mixture of these.
                     */
                    object: any[];
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Before Remove Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance at the start of the process when a
                 * Body or Constraint is being removed from the world.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('beforeremove', listener)`.
                 */
                const BEFORE_REMOVE: string;

                type BeforeUpdateEvent = {
                    /**
                     * The Matter Engine `timing.timestamp` value for the event.
                     */
                    timestamp: number;
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Before Update Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance right before all the collision processing takes place.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('beforeupdate', listener)`.
                 */
                const BEFORE_UPDATE: string;

                type CollisionActiveEvent = {
                    /**
                     * A list of all affected pairs in the collision.
                     */
                    pairs: Phaser.Types.Physics.Matter.MatterCollisionData[];
                    /**
                     * The Matter Engine `timing.timestamp` value for the event.
                     */
                    timestamp: number;
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Collision Active Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance after the engine has updated.
                 * It provides a list of all pairs that are colliding in the current tick (if any).
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('collisionactive', listener)`.
                 */
                const COLLISION_ACTIVE: string;

                type CollisionEndEvent = {
                    /**
                     * A list of all affected pairs in the collision.
                     */
                    pairs: Phaser.Types.Physics.Matter.MatterCollisionData[];
                    /**
                     * The Matter Engine `timing.timestamp` value for the event.
                     */
                    timestamp: number;
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Collision End Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance after the engine has updated.
                 * It provides a list of all pairs that have finished colliding in the current tick (if any).
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('collisionend', listener)`.
                 */
                const COLLISION_END: string;

                type CollisionStartEvent = {
                    /**
                     * A list of all affected pairs in the collision.
                     */
                    pairs: Phaser.Types.Physics.Matter.MatterCollisionData[];
                    /**
                     * The Matter Engine `timing.timestamp` value for the event.
                     */
                    timestamp: number;
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Collision Start Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance after the engine has updated.
                 * It provides a list of all pairs that have started to collide in the current tick (if any).
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('collisionstart', listener)`.
                 */
                const COLLISION_START: string;

                /**
                 * The Matter Physics Drag End Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance when a Pointer Constraint
                 * stops dragging a body.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('dragend', listener)`.
                 */
                const DRAG_END: string;

                /**
                 * The Matter Physics Drag Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance when a Pointer Constraint
                 * is actively dragging a body. It is emitted each time the pointer moves.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('drag', listener)`.
                 */
                const DRAG: string;

                /**
                 * The Matter Physics Drag Start Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance when a Pointer Constraint
                 * starts dragging a body.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('dragstart', listener)`.
                 */
                const DRAG_START: string;

                /**
                 * The Matter Physics World Pause Event.
                 * 
                 * This event is dispatched by an Matter Physics World instance when it is paused.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('pause', listener)`.
                 */
                const PAUSE: string;

                /**
                 * The Matter Physics World Resume Event.
                 * 
                 * This event is dispatched by an Matter Physics World instance when it resumes from a paused state.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('resume', listener)`.
                 */
                const RESUME: string;

                type SleepEndEvent = {
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Sleep End Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance when a Body stop sleeping.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('sleepend', listener)`.
                 */
                const SLEEP_END: string;

                type SleepStartEvent = {
                    /**
                     * The source object of the event.
                     */
                    source: any;
                    /**
                     * The name of the event.
                     */
                    name: string;
                };

                /**
                 * The Matter Physics Sleep Start Event.
                 * 
                 * This event is dispatched by a Matter Physics World instance when a Body goes to sleep.
                 * 
                 * Listen to it from a Scene using: `this.matter.world.on('sleepstart', listener)`.
                 */
                const SLEEP_START: string;

            }

            /**
             * The Matter Factory is responsible for quickly creating a variety of different types of
             * bodies, constraints and Game Objects and adding them into the physics world.
             * 
             * You access the factory from within a Scene using `add`:
             * 
             * ```javascript
             * this.matter.add.rectangle(x, y, width, height);
             * ```
             * 
             * Use of the Factory is optional. All of the objects it creates can also be created
             * directly via your own code or constructors. It is provided as a means to keep your
             * code concise.
             */
            class Factory {
                /**
                 * 
                 * @param world The Matter World which this Factory adds to.
                 */
                constructor(world: Phaser.Physics.Matter.World);

                /**
                 * The Matter World which this Factory adds to.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * The Scene which this Factory's Matter World belongs to.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene.Systems this Matter Physics instance belongs to.
                 */
                sys: Phaser.Scenes.Systems;

                /**
                 * Creates a new rigid rectangular Body and adds it to the World.
                 * @param x The X coordinate of the center of the Body.
                 * @param y The Y coordinate of the center of the Body.
                 * @param width The width of the Body.
                 * @param height The height of the Body.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                rectangle(x: number, y: number, width: number, height: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType;

                /**
                 * Creates a new rigid trapezoidal Body and adds it to the World.
                 * @param x The X coordinate of the center of the Body.
                 * @param y The Y coordinate of the center of the Body.
                 * @param width The width of the trapezoid Body.
                 * @param height The height of the trapezoid Body.
                 * @param slope The slope of the trapezoid. 0 creates a rectangle, while 1 creates a triangle. Positive values make the top side shorter, while negative values make the bottom side shorter.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                trapezoid(x: number, y: number, width: number, height: number, slope: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType;

                /**
                 * Creates a new rigid circular Body and adds it to the World.
                 * @param x The X coordinate of the center of the Body.
                 * @param y The Y coordinate of the center of the Body.
                 * @param radius The radius of the circle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param maxSides The maximum amount of sides to use for the polygon which will approximate this circle.
                 */
                circle(x: number, y: number, radius: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig, maxSides?: number): MatterJS.BodyType;

                /**
                 * Creates a new rigid polygonal Body and adds it to the World.
                 * @param x The X coordinate of the center of the Body.
                 * @param y The Y coordinate of the center of the Body.
                 * @param sides The number of sides the polygon will have.
                 * @param radius The "radius" of the polygon, i.e. the distance from its center to any vertex. This is also the radius of its circumcircle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                polygon(x: number, y: number, sides: number, radius: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType;

                /**
                 * Creates a body using the supplied vertices (or an array containing multiple sets of vertices) and adds it to the World.
                 * If the vertices are convex, they will pass through as supplied. Otherwise, if the vertices are concave, they will be decomposed. Note that this process is not guaranteed to support complex sets of vertices, e.g. ones with holes.
                 * @param x The X coordinate of the center of the Body.
                 * @param y The Y coordinate of the center of the Body.
                 * @param vertexSets The vertices data. Either a path string or an array of vertices.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param flagInternal Flag internal edges (coincident part edges) Default false.
                 * @param removeCollinear Whether Matter.js will discard collinear edges (to improve performance). Default 0.01.
                 * @param minimumArea During decomposition discard parts that have an area less than this. Default 10.
                 */
                fromVertices(x: number, y: number, vertexSets: string | any[], options?: Phaser.Types.Physics.Matter.MatterBodyConfig, flagInternal?: boolean, removeCollinear?: number, minimumArea?: number): MatterJS.BodyType;

                /**
                 * Creates a body using data exported from the application PhysicsEditor (https://www.codeandweb.com/physicseditor)
                 * 
                 * The PhysicsEditor file should be loaded as JSON:
                 * 
                 * ```javascript
                 * preload ()
                 * {
                 *   this.load.json('vehicles', 'assets/vehicles.json);
                 * }
                 * 
                 * create ()
                 * {
                 *   const vehicleShapes = this.cache.json.get('vehicles');
                 *   this.matter.add.fromPhysicsEditor(400, 300, vehicleShapes.truck);
                 * }
                 * ```
                 * 
                 * Do not pass the entire JSON file to this method, but instead pass one of the shapes contained within it.
                 * 
                 * If you pas in an `options` object, any settings in there will override those in the PhysicsEditor config object.
                 * @param x The horizontal world location of the body.
                 * @param y The vertical world location of the body.
                 * @param config The JSON data exported from PhysicsEditor.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param addToWorld Should the newly created body be immediately added to the World? Default true.
                 */
                fromPhysicsEditor(x: number, y: number, config: any, options?: Phaser.Types.Physics.Matter.MatterBodyConfig, addToWorld?: boolean): MatterJS.BodyType;

                /**
                 * Creates a body using the path data from an SVG file.
                 * 
                 * SVG Parsing requires the pathseg polyfill from https://github.com/progers/pathseg
                 * 
                 * The SVG file should be loaded as XML, as this method requires the ability to extract
                 * the path data from it. I.e.:
                 * 
                 * ```javascript
                 * preload ()
                 * {
                 *   this.load.xml('face', 'assets/face.svg);
                 * }
                 * 
                 * create ()
                 * {
                 *   this.matter.add.fromSVG(400, 300, this.cache.xml.get('face'));
                 * }
                 * ```
                 * @param x The X coordinate of the body.
                 * @param y The Y coordinate of the body.
                 * @param xml The SVG Path data.
                 * @param scale Scale the vertices by this amount after creation. Default 1.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param addToWorld Should the newly created body be immediately added to the World? Default true.
                 */
                fromSVG(x: number, y: number, xml: object, scale?: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig, addToWorld?: boolean): MatterJS.BodyType;

                /**
                 * Creates a body using the supplied physics data, as provided by a JSON file.
                 * 
                 * The data file should be loaded as JSON:
                 * 
                 * ```javascript
                 * preload ()
                 * {
                 *   this.load.json('ninjas', 'assets/ninjas.json);
                 * }
                 * 
                 * create ()
                 * {
                 *   const ninjaShapes = this.cache.json.get('ninjas');
                 * 
                 *   this.matter.add.fromJSON(400, 300, ninjaShapes.shinobi);
                 * }
                 * ```
                 * 
                 * Do not pass the entire JSON file to this method, but instead pass one of the shapes contained within it.
                 * 
                 * If you pas in an `options` object, any settings in there will override those in the config object.
                 * 
                 * The structure of the JSON file is as follows:
                 * 
                 * ```text
                 * {
                 *   'generator_info': // The name of the application that created the JSON data
                 *   'shapeName': {
                 *     'type': // The type of body
                 *     'label': // Optional body label
                 *     'vertices': // An array, or an array of arrays, containing the vertex data in x/y object pairs
                 *   }
                 * }
                 * ```
                 * 
                 * At the time of writing, only the Phaser Physics Tracer App exports in this format.
                 * @param x The X coordinate of the body.
                 * @param y The Y coordinate of the body.
                 * @param config The JSON physics data.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param addToWorld Should the newly created body be immediately added to the World? Default true.
                 */
                fromJSON(x: number, y: number, config: any, options?: Phaser.Types.Physics.Matter.MatterBodyConfig, addToWorld?: boolean): MatterJS.BodyType;

                /**
                 * Create a new composite containing Matter Image objects created in a grid arrangement.
                 * This function uses the body bounds to prevent overlaps.
                 * @param key The key of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with. Set to `null` to skip this value.
                 * @param x The horizontal position of this composite in the world.
                 * @param y The vertical position of this composite in the world.
                 * @param columns The number of columns in the grid.
                 * @param rows The number of rows in the grid.
                 * @param columnGap The distance between each column. Default 0.
                 * @param rowGap The distance between each row. Default 0.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                imageStack(key: string, frame: string | number, x: number, y: number, columns: number, rows: number, columnGap?: number, rowGap?: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.CompositeType;

                /**
                 * Create a new composite containing bodies created in the callback in a grid arrangement.
                 * 
                 * This function uses the body bounds to prevent overlaps.
                 * @param x The horizontal position of this composite in the world.
                 * @param y The vertical position of this composite in the world.
                 * @param columns The number of columns in the grid.
                 * @param rows The number of rows in the grid.
                 * @param columnGap The distance between each column.
                 * @param rowGap The distance between each row.
                 * @param callback The callback that creates the stack.
                 */
                stack(x: number, y: number, columns: number, rows: number, columnGap: number, rowGap: number, callback: Function): MatterJS.CompositeType;

                /**
                 * Create a new composite containing bodies created in the callback in a pyramid arrangement.
                 * This function uses the body bounds to prevent overlaps.
                 * @param x The horizontal position of this composite in the world.
                 * @param y The vertical position of this composite in the world.
                 * @param columns The number of columns in the pyramid.
                 * @param rows The number of rows in the pyramid.
                 * @param columnGap The distance between each column.
                 * @param rowGap The distance between each row.
                 * @param callback The callback function to be invoked.
                 */
                pyramid(x: number, y: number, columns: number, rows: number, columnGap: number, rowGap: number, callback: Function): MatterJS.CompositeType;

                /**
                 * Chains all bodies in the given composite together using constraints.
                 * @param composite The composite in which all bodies will be chained together sequentially.
                 * @param xOffsetA The horizontal offset of the BodyA constraint. This is a percentage based on the body size, not a world position.
                 * @param yOffsetA The vertical offset of the BodyA constraint. This is a percentage based on the body size, not a world position.
                 * @param xOffsetB The horizontal offset of the BodyB constraint. This is a percentage based on the body size, not a world position.
                 * @param yOffsetB The vertical offset of the BodyB constraint. This is a percentage based on the body size, not a world position.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                chain(composite: MatterJS.CompositeType, xOffsetA: number, yOffsetA: number, xOffsetB: number, yOffsetB: number, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.CompositeType;

                /**
                 * Connects bodies in the composite with constraints in a grid pattern, with optional cross braces.
                 * @param composite The composite in which all bodies will be chained together.
                 * @param columns The number of columns in the mesh.
                 * @param rows The number of rows in the mesh.
                 * @param crossBrace Create cross braces for the mesh as well?
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                mesh(composite: MatterJS.CompositeType, columns: number, rows: number, crossBrace: boolean, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.CompositeType;

                /**
                 * Creates a composite with a Newton's Cradle setup of bodies and constraints.
                 * @param x The horizontal position of the start of the cradle.
                 * @param y The vertical position of the start of the cradle.
                 * @param number The number of balls in the cradle.
                 * @param size The radius of each ball in the cradle.
                 * @param length The length of the 'string' the balls hang from.
                 */
                newtonsCradle(x: number, y: number, number: number, size: number, length: number): MatterJS.CompositeType;

                /**
                 * Creates a composite with simple car setup of bodies and constraints.
                 * @param x The horizontal position of the car in the world.
                 * @param y The vertical position of the car in the world.
                 * @param width The width of the car chasis.
                 * @param height The height of the car chasis.
                 * @param wheelSize The radius of the car wheels.
                 */
                car(x: number, y: number, width: number, height: number, wheelSize: number): MatterJS.CompositeType;

                /**
                 * Creates a simple soft body like object.
                 * @param x The horizontal position of this composite in the world.
                 * @param y The vertical position of this composite in the world.
                 * @param columns The number of columns in the Composite.
                 * @param rows The number of rows in the Composite.
                 * @param columnGap The distance between each column.
                 * @param rowGap The distance between each row.
                 * @param crossBrace `true` to create cross braces between the bodies, or `false` to create just straight braces.
                 * @param particleRadius The radius of this circlular composite.
                 * @param particleOptions An optional Body configuration object that is used to set initial Body properties on creation.
                 * @param constraintOptions An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                softBody(x: number, y: number, columns: number, rows: number, columnGap: number, rowGap: number, crossBrace: boolean, particleRadius: number, particleOptions?: Phaser.Types.Physics.Matter.MatterBodyConfig, constraintOptions?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.CompositeType;

                /**
                 * This method is an alias for `Factory.constraint`.
                 * 
                 * Constraints (or joints) are used for specifying that a fixed distance must be maintained
                 * between two bodies, or a body and a fixed world-space position.
                 * 
                 * The stiffness of constraints can be modified to create springs or elastic.
                 * 
                 * To simulate a revolute constraint (or pin joint) set `length: 0` and a high `stiffness`
                 * value (e.g. `0.7` or above).
                 * 
                 * If the constraint is unstable, try lowering the `stiffness` value and / or increasing
                 * `constraintIterations` within the Matter Config.
                 * 
                 * For compound bodies, constraints must be applied to the parent body and not one of its parts.
                 * @param bodyA The first possible `Body` that this constraint is attached to.
                 * @param bodyB The second possible `Body` that this constraint is attached to.
                 * @param length A Number that specifies the target resting length of the constraint. If not given it is calculated automatically in `Constraint.create` from initial positions of the `constraint.bodyA` and `constraint.bodyB`.
                 * @param stiffness A Number that specifies the stiffness of the constraint, i.e. the rate at which it returns to its resting `constraint.length`. A value of `1` means the constraint should be very stiff. A value of `0.2` means the constraint acts as a soft spring. Default 1.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                joint(bodyA: MatterJS.BodyType, bodyB: MatterJS.BodyType, length?: number, stiffness?: number, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * This method is an alias for `Factory.constraint`.
                 * 
                 * Constraints (or joints) are used for specifying that a fixed distance must be maintained
                 * between two bodies, or a body and a fixed world-space position.
                 * 
                 * The stiffness of constraints can be modified to create springs or elastic.
                 * 
                 * To simulate a revolute constraint (or pin joint) set `length: 0` and a high `stiffness`
                 * value (e.g. `0.7` or above).
                 * 
                 * If the constraint is unstable, try lowering the `stiffness` value and / or increasing
                 * `constraintIterations` within the Matter Config.
                 * 
                 * For compound bodies, constraints must be applied to the parent body and not one of its parts.
                 * @param bodyA The first possible `Body` that this constraint is attached to.
                 * @param bodyB The second possible `Body` that this constraint is attached to.
                 * @param length A Number that specifies the target resting length of the constraint. If not given it is calculated automatically in `Constraint.create` from initial positions of the `constraint.bodyA` and `constraint.bodyB`.
                 * @param stiffness A Number that specifies the stiffness of the constraint, i.e. the rate at which it returns to its resting `constraint.length`. A value of `1` means the constraint should be very stiff. A value of `0.2` means the constraint acts as a soft spring. Default 1.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                spring(bodyA: MatterJS.BodyType, bodyB: MatterJS.BodyType, length?: number, stiffness?: number, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * Constraints (or joints) are used for specifying that a fixed distance must be maintained
                 * between two bodies, or a body and a fixed world-space position.
                 * 
                 * The stiffness of constraints can be modified to create springs or elastic.
                 * 
                 * To simulate a revolute constraint (or pin joint) set `length: 0` and a high `stiffness`
                 * value (e.g. `0.7` or above).
                 * 
                 * If the constraint is unstable, try lowering the `stiffness` value and / or increasing
                 * `constraintIterations` within the Matter Config.
                 * 
                 * For compound bodies, constraints must be applied to the parent body and not one of its parts.
                 * @param bodyA The first possible `Body` that this constraint is attached to.
                 * @param bodyB The second possible `Body` that this constraint is attached to.
                 * @param length A Number that specifies the target resting length of the constraint. If not given it is calculated automatically in `Constraint.create` from initial positions of the `constraint.bodyA` and `constraint.bodyB`.
                 * @param stiffness A Number that specifies the stiffness of the constraint, i.e. the rate at which it returns to its resting `constraint.length`. A value of `1` means the constraint should be very stiff. A value of `0.2` means the constraint acts as a soft spring. Default 1.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                constraint(bodyA: MatterJS.BodyType, bodyB: MatterJS.BodyType, length?: number, stiffness?: number, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * Constraints (or joints) are used for specifying that a fixed distance must be maintained
                 * between two bodies, or a body and a fixed world-space position.
                 * 
                 * A world constraint has only one body, you should specify a `pointA` position in
                 * the constraint options parameter to attach the constraint to the world.
                 * 
                 * The stiffness of constraints can be modified to create springs or elastic.
                 * 
                 * To simulate a revolute constraint (or pin joint) set `length: 0` and a high `stiffness`
                 * value (e.g. `0.7` or above).
                 * 
                 * If the constraint is unstable, try lowering the `stiffness` value and / or increasing
                 * `constraintIterations` within the Matter Config.
                 * 
                 * For compound bodies, constraints must be applied to the parent body and not one of its parts.
                 * @param body The Matter `Body` that this constraint is attached to.
                 * @param length A number that specifies the target resting length of the constraint. If not given it is calculated automatically in `Constraint.create` from initial positions of the `constraint.bodyA` and `constraint.bodyB`.
                 * @param stiffness A Number that specifies the stiffness of the constraint, i.e. the rate at which it returns to its resting `constraint.length`. A value of `1` means the constraint should be very stiff. A value of `0.2` means the constraint acts as a soft spring. Default 1.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                worldConstraint(body: MatterJS.BodyType, length?: number, stiffness?: number, options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * This method is an alias for `Factory.pointerConstraint`.
                 * 
                 * A Pointer Constraint is a special type of constraint that allows you to click
                 * and drag bodies in a Matter World. It monitors the active Pointers in a Scene,
                 * and when one is pressed down it checks to see if that hit any part of any active
                 * body in the world. If it did, and the body has input enabled, it will begin to
                 * drag it until either released, or you stop it via the `stopDrag` method.
                 * 
                 * You can adjust the stiffness, length and other properties of the constraint via
                 * the `options` object on creation.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                mouseSpring(options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * A Pointer Constraint is a special type of constraint that allows you to click
                 * and drag bodies in a Matter World. It monitors the active Pointers in a Scene,
                 * and when one is pressed down it checks to see if that hit any part of any active
                 * body in the world. If it did, and the body has input enabled, it will begin to
                 * drag it until either released, or you stop it via the `stopDrag` method.
                 * 
                 * You can adjust the stiffness, length and other properties of the constraint via
                 * the `options` object on creation.
                 * @param options An optional Constraint configuration object that is used to set initial Constraint properties on creation.
                 */
                pointerConstraint(options?: Phaser.Types.Physics.Matter.MatterConstraintConfig): MatterJS.ConstraintType;

                /**
                 * Creates a Matter Physics Image Game Object.
                 * 
                 * An Image is a light-weight Game Object useful for the display of static images in your game,
                 * such as logos, backgrounds, scenery or other non-animated elements. Images can have input
                 * events and physics bodies, or be tweened, tinted or scrolled. The main difference between an
                 * Image and a Sprite is that you cannot animate an Image as they do not have the Animation component.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param key The key of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with. Set to `null` to skip this value.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                image(x: number, y: number, key: string, frame?: string | number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): Phaser.Physics.Matter.Image;

                /**
                 * Creates a wrapper around a Tile that provides access to a corresponding Matter body. A tile can only
                 * have one Matter body associated with it. You can either pass in an existing Matter body for
                 * the tile or allow the constructor to create the corresponding body for you. If the Tile has a
                 * collision group (defined in Tiled), those shapes will be used to create the body. If not, the
                 * tile's rectangle bounding box will be used.
                 * 
                 * The corresponding body will be accessible on the Tile itself via Tile.physics.matterBody.
                 * 
                 * Note: not all Tiled collision shapes are supported. See
                 * Phaser.Physics.Matter.TileBody#setFromTileCollision for more information.
                 * @param tile The target tile that should have a Matter body.
                 * @param options Options to be used when creating the Matter body.
                 */
                tileBody(tile: Phaser.Tilemaps.Tile, options?: Phaser.Types.Physics.Matter.MatterTileOptions): Phaser.Physics.Matter.TileBody;

                /**
                 * Creates a Matter Physics Sprite Game Object.
                 * 
                 * A Sprite Game Object is used for the display of both static and animated images in your game.
                 * Sprites can have input events and physics bodies. They can also be tweened, tinted, scrolled
                 * and animated.
                 * 
                 * The main difference between a Sprite and an Image Game Object is that you cannot animate Images.
                 * As such, Sprites take a fraction longer to process and have a larger API footprint due to the Animation
                 * Component. If you do not require animation then you can safely use Images to replace Sprites in all cases.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param key The key of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with. Set to `null` to skip this value.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                sprite(x: number, y: number, key: string, frame?: string | number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): Phaser.Physics.Matter.Sprite;

                /**
                 * Takes an existing Game Object and injects all of the Matter Components into it.
                 * 
                 * This enables you to use component methods such as `setVelocity` or `isSensor` directly from
                 * this Game Object.
                 * 
                 * You can also pass in either a Matter Body Configuration object, or a Matter Body instance
                 * to link with this Game Object.
                 * @param gameObject The Game Object to inject the Matter Components in to.
                 * @param options A Matter Body configuration object, or an instance of a Matter Body.
                 * @param addToWorld Add this Matter Body to the World? Default true.
                 */
                gameObject(gameObject: Phaser.GameObjects.GameObject, options?: Phaser.Types.Physics.Matter.MatterBodyConfig | MatterJS.Body, addToWorld?: boolean): Phaser.Physics.Matter.Image | Phaser.Physics.Matter.Sprite | Phaser.GameObjects.GameObject;

                /**
                 * Destroys this Factory.
                 */
                destroy(): void;

            }

            /**
             * A Matter Game Object is a generic object that allows you to combine any Phaser Game Object,
             * including those you have extended or created yourself, with all of the Matter Components.
             * 
             * This enables you to use component methods such as `setVelocity` or `isSensor` directly from
             * this Game Object.
             * @param world The Matter world to add the body to.
             * @param gameObject The Game Object that will have the Matter body applied to it.
             * @param options A Matter Body configuration object, or an instance of a Matter Body.
             * @param addToWorld Should the newly created body be immediately added to the World? Default true.
             */
            function MatterGameObject(world: Phaser.Physics.Matter.World, gameObject: Phaser.GameObjects.GameObject, options?: Phaser.Types.Physics.Matter.MatterBodyConfig | MatterJS.Body, addToWorld?: boolean): Phaser.GameObjects.GameObject;

            /**
             * A Matter Physics Image Game Object.
             * 
             * An Image is a light-weight Game Object useful for the display of static images in your game,
             * such as logos, backgrounds, scenery or other non-animated elements. Images can have input
             * events and physics bodies, or be tweened, tinted or scrolled. The main difference between an
             * Image and a Sprite is that you cannot animate an Image as they do not have the Animation component.
             */
            class Image extends Phaser.GameObjects.Image implements Phaser.Physics.Matter.Components.Bounce, Phaser.Physics.Matter.Components.Collision, Phaser.Physics.Matter.Components.Force, Phaser.Physics.Matter.Components.Friction, Phaser.Physics.Matter.Components.Gravity, Phaser.Physics.Matter.Components.Mass, Phaser.Physics.Matter.Components.Sensor, Phaser.Physics.Matter.Components.SetBody, Phaser.Physics.Matter.Components.Sleep, Phaser.Physics.Matter.Components.Static, Phaser.Physics.Matter.Components.Transform, Phaser.Physics.Matter.Components.Velocity, Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param world A reference to the Matter.World instance that this body belongs to.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                constructor(world: Phaser.Physics.Matter.World, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig);

                /**
                 * A reference to the Matter.World instance that this body belongs to.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * 
                 * If your game is running under WebGL you can optionally specify four different alpha values, each of which
                 * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
                 * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
                 * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
                 * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
                 * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
                 */
                setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;

                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;

                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;

                /**
                 * The horizontally flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipX: boolean;

                /**
                 * The vertically flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipY: boolean;

                /**
                 * Toggles the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                toggleFlipX(): this;

                /**
                 * Toggles the vertical flipped state of this Game Object.
                 */
                toggleFlipY(): this;

                /**
                 * Sets the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipX(value: boolean): this;

                /**
                 * Sets the vertical flipped state of this Game Object.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipY(value: boolean): this;

                /**
                 * Sets the horizontal and vertical flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped will render inversed on the flipped axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlip(x: boolean, y: boolean): this;

                /**
                 * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
                 */
                resetFlip(): this;

                /**
                 * Gets the center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the left-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the right-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bounds of this Game Object, regardless of origin.
                 * 
                 * The values are stored and returned in a Rectangle, or Rectangle-like, object.
                 * @param output An object to store the values in. If not provided a new Rectangle will be created.
                 */
                getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

                /**
                 * The horizontal origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the left of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originX: number;

                /**
                 * The vertical origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the top of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originY: number;

                /**
                 * The horizontal display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginX: number;

                /**
                 * The vertical display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginY: number;

                /**
                 * Sets the origin of this Game Object.
                 * 
                 * The values are given in the range 0 to 1.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;

                /**
                 * Sets the origin of this Game Object based on the Pivot values in its Frame.
                 */
                setOriginFromFrame(): this;

                /**
                 * Sets the display origin of this Game Object.
                 * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
                 * @param x The horizontal display origin value. Default 0.
                 * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setDisplayOrigin(x?: number, y?: number): this;

                /**
                 * Updates the Display Origin cached values internally stored on this Game Object.
                 * You don't usually call this directly, but it is exposed for edge-cases where you may.
                 */
                updateDisplayOrigin(): this;

                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;

                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;

                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;

                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;

                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;

                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;

                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;

                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;

                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;

                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;

                /**
                 * Sets the size of this Game Object to be that of the given Frame.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param frame The frame to base the size of this Game Object on.
                 */
                setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;

                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;

                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;

                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * @param key The key of the texture to be used, as stored in the Texture Manager.
                 * @param frame The name or index of the frame within the Texture.
                 */
                setTexture(key: string, frame?: string | number): this;

                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * The tint value being applied to the top-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopLeft: number;

                /**
                 * The tint value being applied to the top-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopRight: number;

                /**
                 * The tint value being applied to the bottom-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomLeft: number;

                /**
                 * The tint value being applied to the bottom-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomRight: number;

                /**
                 * The tint fill mode.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;

                /**
                 * Clears all tint values associated with this Game Object.
                 * 
                 * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
                 * which results in no visible change to the texture.
                 */
                clearTint(): this;

                /**
                 * Sets an additive tint on this Game Object.
                 * 
                 * The tint works by taking the pixel color values from the Game Objects texture, and then
                 * multiplying it by the color value of the tint. You can provide either one color value,
                 * in which case the whole Game Object will be tinted in that color. Or you can provide a color
                 * per corner. The colors are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * Sets a fill-based tint on this Game Object.
                 * 
                 * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
                 * with those in the tint. You can use this for effects such as making a player flash 'white'
                 * if hit by something. You can provide either one color value, in which case the whole
                 * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
                 * are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The tint value being applied to the whole of the Game Object.
                 * Return `tintTopLeft` when read this tint property.
                 */
                tint: number;

                /**
                 * Does this Game Object have a tint applied?
                 * 
                 * It checks to see if the 4 tint properties are set to the value 0xffffff
                 * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
                 */
                readonly isTinted: boolean;

                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;

                /**
                 * The x position of this Game Object.
                 */
                x: number;

                /**
                 * The y position of this Game Object.
                 */
                y: number;

                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;

                /**
                 * The w position of this Game Object.
                 */
                w: number;

                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;

                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;

                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;

                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;

                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;

                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;

                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;

                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;

                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;

                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;

                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;

                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;

                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;

                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;

                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;

                /**
                 * Sets the restitution on the physics object.
                 * @param value A Number that defines the restitution (elasticity) of the body. The value is always positive and is in the range (0, 1). A value of 0 means collisions may be perfectly inelastic and no bouncing may occur. A value of 0.8 means the body may bounce back with approximately 80% of its kinetic energy. Note that collision response is based on pairs of bodies, and that restitution values are combined with the following formula: `Math.max(bodyA.restitution, bodyB.restitution)`
                 */
                setBounce(value: number): this;

                /**
                 * Sets the collision category of this Game Object's Matter Body. This number must be a power of two between 2^0 (= 1) and 2^31.
                 * Two bodies with different collision groups (see {@link #setCollisionGroup}) will only collide if their collision
                 * categories are included in their collision masks (see {@link #setCollidesWith}).
                 * @param value Unique category bitfield.
                 */
                setCollisionCategory(value: number): this;

                /**
                 * Sets the collision group of this Game Object's Matter Body. If this is zero or two Matter Bodies have different values,
                 * they will collide according to the usual rules (see {@link #setCollisionCategory} and {@link #setCollisionGroup}).
                 * If two Matter Bodies have the same positive value, they will always collide; if they have the same negative value,
                 * they will never collide.
                 * @param value Unique group index.
                 */
                setCollisionGroup(value: number): this;

                /**
                 * Sets the collision mask for this Game Object's Matter Body. Two Matter Bodies with different collision groups will only
                 * collide if each one includes the other's category in its mask based on a bitwise AND, i.e. `(categoryA & maskB) !== 0`
                 * and `(categoryB & maskA) !== 0` are both true.
                 * @param categories A unique category bitfield, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body starts colliding with another.
                 */
                setOnCollide(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body stops colliding with another.
                 */
                setOnCollideEnd(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke for the duration of this body colliding with another.
                 */
                setOnCollideActive(callback: Function): this;

                /**
                 * The callback is sent a reference to the other body, along with a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param body The body, or an array of bodies, to test for collisions with.
                 * @param callback The callback to invoke when this body collides with the given body or bodies.
                 */
                setOnCollideWith(body: MatterJS.Body | MatterJS.Body[], callback: Function): this;

                /**
                 * Applies a force to a body.
                 * @param force A Vector that specifies the force to apply.
                 */
                applyForce(force: Phaser.Math.Vector2): this;

                /**
                 * Applies a force to a body from a given position.
                 * @param position The position in which the force comes from.
                 * @param force A Vector that specifies the force to apply.
                 */
                applyForceFrom(position: Phaser.Math.Vector2, force: Phaser.Math.Vector2): this;

                /**
                 * Apply thrust to the forward position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrust(speed: number): this;

                /**
                 * Apply thrust to the left position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustLeft(speed: number): this;

                /**
                 * Apply thrust to the right position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustRight(speed: number): this;

                /**
                 * Apply thrust to the back position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustBack(speed: number): this;

                /**
                 * Sets new friction values for this Game Object's Matter Body.
                 * @param value The new friction of the body, between 0 and 1, where 0 allows the Body to slide indefinitely, while 1 allows it to stop almost immediately after a force is applied.
                 * @param air If provided, the new air resistance of the Body. The higher the value, the faster the Body will slow as it moves through space. 0 means the body has no air resistance.
                 * @param fstatic If provided, the new static friction of the Body. The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary. 0 means the body will never "stick" when it is nearly stationary.
                 */
                setFriction(value: number, air?: number, fstatic?: number): this;

                /**
                 * Sets a new air resistance for this Game Object's Matter Body.
                 * A value of 0 means the Body will never slow as it moves through space.
                 * The higher the value, the faster a Body slows when moving through space.
                 * @param value The new air resistance for the Body.
                 */
                setFrictionAir(value: number): this;

                /**
                 * Sets a new static friction for this Game Object's Matter Body.
                 * A value of 0 means the Body will never "stick" when it is nearly stationary.
                 * The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary.
                 * @param value The new static friction for the Body.
                 */
                setFrictionStatic(value: number): this;

                /**
                 * A togglable function for ignoring world gravity in real-time on the current body.
                 * @param value Set to true to ignore the effect of world gravity, or false to not ignore it.
                 */
                setIgnoreGravity(value: boolean): this;

                /**
                 * Sets the mass of the Game Object's Matter Body.
                 * @param value The new mass of the body.
                 */
                setMass(value: number): this;

                /**
                 * Sets density of the body.
                 * @param value The new density of the body.
                 */
                setDensity(value: number): this;

                /**
                 * The body's center of mass.
                 * 
                 * Calling this creates a new `Vector2 each time to avoid mutation.
                 * 
                 * If you only need to read the value and won't change it, you can get it from `GameObject.body.centerOfMass`.
                 */
                readonly centerOfMass: Phaser.Math.Vector2;

                /**
                 * Set the body belonging to this Game Object to be a sensor.
                 * Sensors trigger collision events, but don't react with colliding body physically.
                 * @param value `true` to set the body as a sensor, or `false` to disable it.
                 */
                setSensor(value: boolean): this;

                /**
                 * Is the body belonging to this Game Object a sensor or not?
                 */
                isSensor(): boolean;

                /**
                 * Set this Game Objects Matter physics body to be a rectangle shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param width Width of the rectangle.
                 * @param height Height of the rectangle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setRectangle(width: number, height: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a circle shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param radius The radius of the circle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setCircle(radius: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a polygon shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param radius The "radius" of the polygon, i.e. the distance from its center to any vertex. This is also the radius of its circumcircle.
                 * @param sides The number of sides the polygon will have.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setPolygon(radius: number, sides: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a trapezoid shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param width The width of the trapezoid Body.
                 * @param height The height of the trapezoid Body.
                 * @param slope The slope of the trapezoid. 0 creates a rectangle, while 1 creates a triangle. Positive values make the top side shorter, while negative values make the bottom side shorter.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setTrapezoid(width: number, height: number, slope: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Object to use the given existing Matter Body.
                 * 
                 * The body is first removed from the world before being added to this Game Object.
                 * @param body The Body this Game Object should use.
                 * @param addToWorld Should the body be immediately added to the World? Default true.
                 */
                setExistingBody(body: MatterJS.BodyType, addToWorld?: boolean): this;

                /**
                 * Set this Game Object to create and use a new Body based on the configuration object given.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param config Either a string, such as `circle`, or a Matter Set Body Configuration object.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setBody(config: string | Phaser.Types.Physics.Matter.MatterSetBodyConfig, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Sets this Body to sleep.
                 */
                setToSleep(): this;

                /**
                 * Wakes this Body if asleep.
                 */
                setAwake(): this;

                /**
                 * Sets the number of updates in which this body must have near-zero velocity before it is set as sleeping (if sleeping is enabled by the engine).
                 * @param value A `Number` that defines the number of updates in which this body must have near-zero velocity before it is set as sleeping. Default 60.
                 */
                setSleepThreshold(value?: number): this;

                /**
                 * Enable sleep and wake events for this body.
                 * 
                 * By default when a body goes to sleep, or wakes up, it will not emit any events.
                 * 
                 * The events are emitted by the Matter World instance and can be listened to via
                 * the `SLEEP_START` and `SLEEP_END` events.
                 * @param start `true` if you want the sleep start event to be emitted for this body.
                 * @param end `true` if you want the sleep end event to be emitted for this body.
                 */
                setSleepEvents(start: boolean, end: boolean): this;

                /**
                 * Enables or disables the Sleep Start event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepStartEvent(value: boolean): this;

                /**
                 * Enables or disables the Sleep End event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepEndEvent(value: boolean): this;

                /**
                 * Changes the physics body to be either static `true` or dynamic `false`.
                 * @param value `true` to set the body as being static, or `false` to make it dynamic.
                 */
                setStatic(value: boolean): this;

                /**
                 * Returns `true` if the body is static, otherwise `false` for a dynamic body.
                 */
                isStatic(): boolean;

                /**
                 * Setting fixed rotation sets the Body inertia to Infinity, which stops it
                 * from being able to rotate when forces are applied to it.
                 */
                setFixedRotation(): this;

                /**
                 * Sets the horizontal velocity of the physics body.
                 * @param x The horizontal velocity value.
                 */
                setVelocityX(x: number): this;

                /**
                 * Sets vertical velocity of the physics body.
                 * @param y The vertical velocity value.
                 */
                setVelocityY(y: number): this;

                /**
                 * Sets both the horizontal and vertical velocity of the physics body.
                 * @param x The horizontal velocity value.
                 * @param y The vertical velocity value, it can be either positive or negative. If not given, it will be the same as the `x` value. Default x.
                 */
                setVelocity(x: number, y?: number): this;

                /**
                 * Gets the current linear velocity of the physics body.
                 */
                getVelocity(): Phaser.Types.Math.Vector2Like;

                /**
                 * Sets the angular velocity of the body instantly.
                 * Position, angle, force etc. are unchanged.
                 * @param velocity The angular velocity.
                 */
                setAngularVelocity(velocity: number): this;

                /**
                 * Gets the current rotational velocity of the body.
                 */
                getAngularVelocity(): number;

                /**
                 * Sets the current rotational speed of the body.
                 * Direction is maintained. Affects body angular velocity.
                 * @param speed The angular speed.
                 */
                setAngularSpeed(speed: number): this;

                /**
                 * Gets the current rotational speed of the body.
                 * Equivalent to the magnitude of its angular velocity.
                 */
                getAngularSpeed(): number;

            }

            /**
             * The Phaser Matter plugin provides the ability to use the Matter JS Physics Engine within your Phaser games.
             * 
             * Unlike Arcade Physics, the other physics system provided with Phaser, Matter JS is a full-body physics system.
             * It features:
             * 
             * * Rigid bodies
             * * Compound bodies
             * * Composite bodies
             * * Concave and convex hulls
             * * Physical properties (mass, area, density etc.)
             * * Restitution (elastic and inelastic collisions)
             * * Collisions (broad-phase, mid-phase and narrow-phase)
             * * Stable stacking and resting
             * * Conservation of momentum
             * * Friction and resistance
             * * Constraints
             * * Gravity
             * * Sleeping and static bodies
             * * Rounded corners (chamfering)
             * * Views (translate, zoom)
             * * Collision queries (raycasting, region tests)
             * * Time scaling (slow-mo, speed-up)
             * 
             * Configuration of Matter is handled via the Matter World Config object, which can be passed in either the
             * Phaser Game Config, or Phaser Scene Config. Here is a basic example:
             * 
             * ```js
             * physics: {
             *     default: 'matter',
             *     matter: {
             *         enableSleeping: true,
             *         gravity: {
             *             y: 0
             *         },
             *         debug: {
             *             showBody: true,
             *             showStaticBody: true
             *         }
             *     }
             * }
             * ```
             * 
             * This class acts as an interface between a Phaser Scene and a single instance of the Matter Engine.
             * 
             * Use it to access the most common Matter features and helper functions.
             * 
             * You can find details, documentation and examples on the Matter JS website: https://brm.io/matter-js/
             */
            class MatterPhysics {
                /**
                 * 
                 * @param scene The Phaser Scene that owns this Matter Physics instance.
                 */
                constructor(scene: Phaser.Scene);

                /**
                 * The Phaser Scene that owns this Matter Physics instance
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Scene Systems that belong to the Scene owning this Matter Physics instance.
                 */
                systems: Phaser.Scenes.Systems;

                /**
                 * The parsed Matter Configuration object.
                 */
                config: Phaser.Types.Physics.Matter.MatterWorldConfig;

                /**
                 * An instance of the Matter World class. This class is responsible for the updating of the
                 * Matter Physics world, as well as handling debug drawing functions.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * An instance of the Matter Factory. This class provides lots of functions for creating a
                 * wide variety of physics objects and adds them automatically to the Matter World.
                 * 
                 * You can use this class to cut-down on the amount of code required in your game, however,
                 * use of the Factory is entirely optional and should be seen as a development aid. It's
                 * perfectly possible to create and add components to the Matter world without using it.
                 */
                add: Phaser.Physics.Matter.Factory;

                /**
                 * An instance of the Body Bounds class. This class contains functions used for getting the
                 * world position from various points around the bounds of a physics body.
                 */
                bodyBounds: Phaser.Physics.Matter.BodyBounds;

                /**
                 * A reference to the `Matter.Body` module.
                 * 
                 * The `Matter.Body` module contains methods for creating and manipulating body models.
                 * A `Matter.Body` is a rigid body that can be simulated by a `Matter.Engine`.
                 * Factories for commonly used body configurations (such as rectangles, circles and other polygons) can be found in the `Bodies` module.
                 */
                body: MatterJS.BodyFactory;

                /**
                 * A reference to the `Matter.Composite` module.
                 * 
                 * The `Matter.Composite` module contains methods for creating and manipulating composite bodies.
                 * A composite body is a collection of `Matter.Body`, `Matter.Constraint` and other `Matter.Composite`, therefore composites form a tree structure.
                 * It is important to use the functions in this module to modify composites, rather than directly modifying their properties.
                 * Note that the `Matter.World` object is also a type of `Matter.Composite` and as such all composite methods here can also operate on a `Matter.World`.
                 */
                composite: MatterJS.CompositeFactory;

                /**
                 * A reference to the `Matter.Collision` module.
                 * 
                 * The `Matter.Collision` module contains methods for detecting collisions between a given pair of bodies.
                 * 
                 * For efficient detection between a list of bodies, see `Matter.Detector` and `Matter.Query`.
                 */
                collision: MatterJS.Collision;

                /**
                 * A reference to the `Matter.Detector` module.
                 * 
                 * The `Matter.Detector` module contains methods for detecting collisions given a set of pairs.
                 */
                detector: MatterJS.DetectorFactory;

                /**
                 * A reference to the `Matter.Pair` module.
                 * 
                 * The `Matter.Pair` module contains methods for creating and manipulating collision pairs.
                 */
                pair: MatterJS.PairFactory;

                /**
                 * A reference to the `Matter.Pairs` module.
                 * 
                 * The `Matter.Pairs` module contains methods for creating and manipulating collision pair sets.
                 */
                pairs: MatterJS.PairsFactory;

                /**
                 * A reference to the `Matter.Query` module.
                 * 
                 * The `Matter.Query` module contains methods for performing collision queries.
                 */
                query: MatterJS.QueryFactory;

                /**
                 * A reference to the `Matter.Resolver` module.
                 * 
                 * The `Matter.Resolver` module contains methods for resolving collision pairs.
                 */
                resolver: MatterJS.ResolverFactory;

                /**
                 * A reference to the `Matter.Constraint` module.
                 * 
                 * The `Matter.Constraint` module contains methods for creating and manipulating constraints.
                 * Constraints are used for specifying that a fixed distance must be maintained between two bodies (or a body and a fixed world-space position).
                 * The stiffness of constraints can be modified to create springs or elastic.
                 */
                constraint: MatterJS.ConstraintFactory;

                /**
                 * A reference to the `Matter.Bodies` module.
                 * 
                 * The `Matter.Bodies` module contains factory methods for creating rigid bodies
                 * with commonly used body configurations (such as rectangles, circles and other polygons).
                 */
                bodies: MatterJS.BodiesFactory;

                /**
                 * A reference to the `Matter.Composites` module.
                 * 
                 * The `Matter.Composites` module contains factory methods for creating composite bodies
                 * with commonly used configurations (such as stacks and chains).
                 */
                composites: MatterJS.CompositesFactory;

                /**
                 * A reference to the `Matter.Axes` module.
                 * 
                 * The `Matter.Axes` module contains methods for creating and manipulating sets of axes.
                 */
                axes: MatterJS.AxesFactory;

                /**
                 * A reference to the `Matter.Bounds` module.
                 * 
                 * The `Matter.Bounds` module contains methods for creating and manipulating axis-aligned bounding boxes (AABB).
                 */
                bounds: MatterJS.BoundsFactory;

                /**
                 * A reference to the `Matter.Svg` module.
                 * 
                 * The `Matter.Svg` module contains methods for converting SVG images into an array of vector points.
                 * 
                 * To use this module you also need the SVGPathSeg polyfill: https://github.com/progers/pathseg
                 */
                svg: MatterJS.SvgFactory;

                /**
                 * A reference to the `Matter.Vector` module.
                 * 
                 * The `Matter.Vector` module contains methods for creating and manipulating vectors.
                 * Vectors are the basis of all the geometry related operations in the engine.
                 * A `Matter.Vector` object is of the form `{ x: 0, y: 0 }`.
                 */
                vector: MatterJS.VectorFactory;

                /**
                 * A reference to the `Matter.Vertices` module.
                 * 
                 * The `Matter.Vertices` module contains methods for creating and manipulating sets of vertices.
                 * A set of vertices is an array of `Matter.Vector` with additional indexing properties inserted by `Vertices.create`.
                 * A `Matter.Body` maintains a set of vertices to represent the shape of the object (its convex hull).
                 */
                vertices: MatterJS.VerticesFactory;

                /**
                 * A reference to the `Matter.Vertices` module.
                 * 
                 * The `Matter.Vertices` module contains methods for creating and manipulating sets of vertices.
                 * A set of vertices is an array of `Matter.Vector` with additional indexing properties inserted by `Vertices.create`.
                 * A `Matter.Body` maintains a set of vertices to represent the shape of the object (its convex hull).
                 */
                verts: MatterJS.VerticesFactory;

                /**
                 * This internal method is called when this class starts and retrieves the final Matter World Config.
                 */
                getConfig(): Phaser.Types.Physics.Matter.MatterWorldConfig;

                /**
                 * Enables the Matter Attractors Plugin.
                 * 
                 * The attractors plugin that makes it easy to apply continual forces on bodies.
                 * It's possible to simulate effects such as wind, gravity and magnetism.
                 * 
                 * https://github.com/liabru/matter-attractors
                 * 
                 * This method is called automatically if `plugins.attractors` is set in the Matter World Config.
                 * However, you can also call it directly from within your game.
                 */
                enableAttractorPlugin(): this;

                /**
                 * Enables the Matter Wrap Plugin.
                 * 
                 * The coordinate wrapping plugin that automatically wraps the position of bodies such that they always stay
                 * within the given bounds. Upon crossing a boundary the body will appear on the opposite side of the bounds,
                 * while maintaining its velocity.
                 * 
                 * https://github.com/liabru/matter-wrap
                 * 
                 * This method is called automatically if `plugins.wrap` is set in the Matter World Config.
                 * However, you can also call it directly from within your game.
                 */
                enableWrapPlugin(): this;

                /**
                 * Enables the Matter Collision Events Plugin.
                 * 
                 * Note that this plugin is enabled by default. So you should only ever need to call this
                 * method if you have specifically disabled the plugin in your Matter World Config.
                 * You can disable it by setting `plugins.collisionevents: false` in your Matter World Config.
                 * 
                 * This plugin triggers three new events on Matter.Body:
                 * 
                 * 1. `onCollide`
                 * 2. `onCollideEnd`
                 * 3. `onCollideActive`
                 * 
                 * These events correspond to the Matter.js events `collisionStart`, `collisionActive` and `collisionEnd`, respectively.
                 * You can listen to these events via Matter.Events or they will also be emitted from the Matter World.
                 * 
                 * This plugin also extends Matter.Body with three convenience functions:
                 * 
                 * `Matter.Body.setOnCollide(callback)`
                 * `Matter.Body.setOnCollideEnd(callback)`
                 * `Matter.Body.setOnCollideActive(callback)`
                 * 
                 * You can register event callbacks by providing a function of type (pair: Matter.Pair) => void
                 * 
                 * https://github.com/dxu/matter-collision-events
                 */
                enableCollisionEventsPlugin(): this;

                /**
                 * Pauses the Matter World instance and sets `enabled` to `false`.
                 * 
                 * A paused world will not run any simulations for the duration it is paused.
                 */
                pause(): Phaser.Physics.Matter.World;

                /**
                 * Resumes this Matter World instance from a paused state and sets `enabled` to `true`.
                 */
                resume(): Phaser.Physics.Matter.World;

                /**
                 * Sets the Matter Engine to run at fixed timestep of 60Hz and enables `autoUpdate`.
                 * If you have set a custom `getDelta` function then this will override it.
                 */
                set60Hz(): this;

                /**
                 * Sets the Matter Engine to run at fixed timestep of 30Hz and enables `autoUpdate`.
                 * If you have set a custom `getDelta` function then this will override it.
                 */
                set30Hz(): this;

                /**
                 * Manually advances the physics simulation by one iteration.
                 * 
                 * You can optionally pass in the `delta` and `correction` values to be used by Engine.update.
                 * If undefined they use the Matter defaults of 60Hz and no correction.
                 * 
                 * Calling `step` directly bypasses any checks of `enabled` or `autoUpdate`.
                 * 
                 * It also ignores any custom `getDelta` functions, as you should be passing the delta
                 * value in to this call.
                 * 
                 * You can adjust the number of iterations that Engine.update performs internally.
                 * Use the Scene Matter Physics config object to set the following properties:
                 * 
                 * positionIterations (defaults to 6)
                 * velocityIterations (defaults to 4)
                 * constraintIterations (defaults to 2)
                 * 
                 * Adjusting these values can help performance in certain situations, depending on the physics requirements
                 * of your game.
                 * @param delta The delta value. Default 16.666.
                 * @param correction Optional delta correction value. Default 1.
                 */
                step(delta?: number, correction?: number): void;

                /**
                 * Checks if the vertices of the given body, or an array of bodies, contains the given point, or not.
                 * 
                 * You can pass in either a single body, or an array of bodies to be checked. This method will
                 * return `true` if _any_ of the bodies in the array contain the point. See the `intersectPoint` method if you need
                 * to get a list of intersecting bodies.
                 * 
                 * The point should be transformed into the Matter World coordinate system in advance. This happens by
                 * default with Input Pointers, but if you wish to use points from another system you may need to
                 * transform them before passing them.
                 * @param body The body, or an array of bodies, to check against the point.
                 * @param x The horizontal coordinate of the point.
                 * @param y The vertical coordinate of the point.
                 */
                containsPoint(body: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], x: number, y: number): boolean;

                /**
                 * Checks the given coordinates to see if any vertices of the given bodies contain it.
                 * 
                 * If no bodies are provided it will search all bodies in the Matter World, including within Composites.
                 * 
                 * The coordinates should be transformed into the Matter World coordinate system in advance. This happens by
                 * default with Input Pointers, but if you wish to use coordinates from another system you may need to
                 * transform them before passing them.
                 * @param x The horizontal coordinate of the point.
                 * @param y The vertical coordinate of the point.
                 * @param bodies An array of bodies to check. If not provided it will search all bodies in the world.
                 */
                intersectPoint(x: number, y: number, bodies?: Phaser.Types.Physics.Matter.MatterBody[]): Phaser.Types.Physics.Matter.MatterBody[];

                /**
                 * Checks the given rectangular area to see if any vertices of the given bodies intersect with it.
                 * Or, if the `outside` parameter is set to `true`, it checks to see which bodies do not
                 * intersect with it.
                 * 
                 * If no bodies are provided it will search all bodies in the Matter World, including within Composites.
                 * @param x The horizontal coordinate of the top-left of the area.
                 * @param y The vertical coordinate of the top-left of the area.
                 * @param width The width of the area.
                 * @param height The height of the area.
                 * @param outside If `false` it checks for vertices inside the area, if `true` it checks for vertices outside the area. Default false.
                 * @param bodies An array of bodies to check. If not provided it will search all bodies in the world.
                 */
                intersectRect(x: number, y: number, width: number, height: number, outside?: boolean, bodies?: Phaser.Types.Physics.Matter.MatterBody[]): Phaser.Types.Physics.Matter.MatterBody[];

                /**
                 * Checks the given ray segment to see if any vertices of the given bodies intersect with it.
                 * 
                 * If no bodies are provided it will search all bodies in the Matter World.
                 * 
                 * The width of the ray can be specified via the `rayWidth` parameter.
                 * @param x1 The horizontal coordinate of the start of the ray segment.
                 * @param y1 The vertical coordinate of the start of the ray segment.
                 * @param x2 The horizontal coordinate of the end of the ray segment.
                 * @param y2 The vertical coordinate of the end of the ray segment.
                 * @param rayWidth The width of the ray segment. Default 1.
                 * @param bodies An array of bodies to check. If not provided it will search all bodies in the world.
                 */
                intersectRay(x1: number, y1: number, x2: number, y2: number, rayWidth?: number, bodies?: Phaser.Types.Physics.Matter.MatterBody[]): Phaser.Types.Physics.Matter.MatterBody[];

                /**
                 * Checks the given Matter Body to see if it intersects with any of the given bodies.
                 * 
                 * If no bodies are provided it will check against all bodies in the Matter World.
                 * @param body The target body.
                 * @param bodies An array of bodies to check the target body against. If not provided it will search all bodies in the world.
                 */
                intersectBody(body: Phaser.Types.Physics.Matter.MatterBody, bodies?: Phaser.Types.Physics.Matter.MatterBody[]): Phaser.Types.Physics.Matter.MatterBody[];

                /**
                 * Checks to see if the target body, or an array of target bodies, intersects with any of the given bodies.
                 * 
                 * If intersection occurs this method will return `true` and, if provided, invoke the callbacks.
                 * 
                 * If no bodies are provided for the second parameter the target will check against all bodies in the Matter World.
                 * 
                 * **Note that bodies can only overlap if they are in non-colliding collision groups or categories.**
                 * 
                 * If you provide a `processCallback` then the two bodies that overlap are sent to it. This callback
                 * must return a boolean and is used to allow you to perform additional processing tests before a final
                 * outcome is decided. If it returns `true` then the bodies are finally passed to the `overlapCallback`, if set.
                 * 
                 * If you provide an `overlapCallback` then the matching pairs of overlapping bodies will be sent to it.
                 * 
                 * Both callbacks have the following signature: `function (bodyA, bodyB, collisionInfo)` where `bodyA` is always
                 * the target body. The `collisionInfo` object contains additional data, such as the angle and depth of penetration.
                 * @param target The target body, or array of target bodies, to check.
                 * @param bodies The second body, or array of bodies, to check. If falsey it will check against all bodies in the world.
                 * @param overlapCallback An optional callback function that is called if the bodies overlap.
                 * @param processCallback An optional callback function that lets you perform additional checks against the two bodies if they overlap. If this is set then `overlapCallback` will only be invoked if this callback returns `true`.
                 * @param callbackContext The context, or scope, in which to run the callbacks.
                 */
                overlap(target: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], bodies?: Phaser.Types.Physics.Matter.MatterBody[], overlapCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, processCallback?: Phaser.Types.Physics.Arcade.ArcadePhysicsCallback, callbackContext?: any): boolean;

                /**
                 * Sets the collision filter category of all given Matter Bodies to the given value.
                 * 
                 * This number must be a power of two between 2^0 (= 1) and 2^31.
                 * 
                 * Bodies with different collision groups (see {@link #setCollisionGroup}) will only collide if their collision
                 * categories are included in their collision masks (see {@link #setCollidesWith}).
                 * @param bodies An array of bodies to update. If falsey it will use all bodies in the world.
                 * @param value Unique category bitfield.
                 */
                setCollisionCategory(bodies: Phaser.Types.Physics.Matter.MatterBody[], value: number): this;

                /**
                 * Sets the collision filter group of all given Matter Bodies to the given value.
                 * 
                 * If the group value is zero, or if two Matter Bodies have different group values,
                 * they will collide according to the usual collision filter rules (see {@link #setCollisionCategory} and {@link #setCollisionGroup}).
                 * 
                 * If two Matter Bodies have the same positive group value, they will always collide;
                 * if they have the same negative group value they will never collide.
                 * @param bodies An array of bodies to update. If falsey it will use all bodies in the world.
                 * @param value Unique group index.
                 */
                setCollisionGroup(bodies: Phaser.Types.Physics.Matter.MatterBody[], value: number): this;

                /**
                 * Sets the collision filter mask of all given Matter Bodies to the given value.
                 * 
                 * Two Matter Bodies with different collision groups will only collide if each one includes the others
                 * category in its mask based on a bitwise AND operation: `(categoryA & maskB) !== 0` and
                 * `(categoryB & maskA) !== 0` are both true.
                 * @param bodies An array of bodies to update. If falsey it will use all bodies in the world.
                 * @param categories A unique category bitfield, or an array of them.
                 */
                setCollidesWith(bodies: Phaser.Types.Physics.Matter.MatterBody[], categories: number | number[]): this;

                /**
                 * Takes an array and returns a new array made from all of the Matter Bodies found in the original array.
                 * 
                 * For example, passing in Matter Game Objects, such as a bunch of Matter Sprites, to this method, would
                 * return an array containing all of their native Matter Body objects.
                 * 
                 * If the `bodies` argument is falsey, it will return all bodies in the world.
                 * @param bodies An array of objects to extract the bodies from. If falsey, it will return all bodies in the world.
                 */
                getMatterBodies(bodies?: any[]): MatterJS.BodyType[];

                /**
                 * Sets both the horizontal and vertical linear velocity of the physics bodies.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param x The horizontal linear velocity value.
                 * @param y The vertical linear velocity value.
                 */
                setVelocity(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], x: number, y: number): this;

                /**
                 * Sets just the horizontal linear velocity of the physics bodies.
                 * The vertical velocity of the body is unchanged.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param x The horizontal linear velocity value.
                 */
                setVelocityX(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], x: number): this;

                /**
                 * Sets just the vertical linear velocity of the physics bodies.
                 * The horizontal velocity of the body is unchanged.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param y The vertical linear velocity value.
                 */
                setVelocityY(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], y: number): this;

                /**
                 * Sets the angular velocity of the bodies instantly.
                 * Position, angle, force etc. are unchanged.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param value The angular velocity.
                 */
                setAngularVelocity(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], value: number): this;

                /**
                 * Applies a force to a body, at the bodies current position, including resulting torque.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param force A Vector that specifies the force to apply.
                 */
                applyForce(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], force: Phaser.Types.Math.Vector2Like): this;

                /**
                 * Applies a force to a body, from the given world position, including resulting torque.
                 * If no angle is given, the current body angle is used.
                 * 
                 * Use very small speed values, such as 0.1, depending on the mass and required velocity.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param position A Vector that specifies the world-space position to apply the force at.
                 * @param speed A speed value to be applied to a directional force.
                 * @param angle The angle, in radians, to apply the force from. Leave undefined to use the current body angle.
                 */
                applyForceFromPosition(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], position: Phaser.Types.Math.Vector2Like, speed: number, angle?: number): this;

                /**
                 * Apply a force to a body based on the given angle and speed.
                 * If no angle is given, the current body angle is used.
                 * 
                 * Use very small speed values, such as 0.1, depending on the mass and required velocity.
                 * @param bodies Either a single Body, or an array of bodies to update. If falsey it will use all bodies in the world.
                 * @param speed A speed value to be applied to a directional force.
                 * @param angle The angle, in radians, to apply the force from. Leave undefined to use the current body angle.
                 */
                applyForceFromAngle(bodies: Phaser.Types.Physics.Matter.MatterBody | Phaser.Types.Physics.Matter.MatterBody[], speed: number, angle?: number): this;

                /**
                 * Returns the length of the given constraint, which is the distance between the two points.
                 * @param constraint The constraint to get the length from.
                 */
                getConstraintLength(constraint: MatterJS.ConstraintType): number;

                /**
                 * Aligns a Body, or Matter Game Object, against the given coordinates.
                 * 
                 * The alignment takes place using the body bounds, which take into consideration things
                 * like body scale and rotation.
                 * 
                 * Although a Body has a `position` property, it is based on the center of mass for the body,
                 * not a dimension based center. This makes aligning bodies difficult, especially if they have
                 * rotated or scaled. This method will derive the correct position based on the body bounds and
                 * its center of mass offset, in order to align the body with the given coordinate.
                 * 
                 * For example, if you wanted to align a body so it sat in the bottom-center of the
                 * Scene, and the world was 800 x 600 in size:
                 * 
                 * ```javascript
                 * this.matter.alignBody(body, 400, 600, Phaser.Display.Align.BOTTOM_CENTER);
                 * ```
                 * 
                 * You pass in 400 for the x coordinate, because that is the center of the world, and 600 for
                 * the y coordinate, as that is the base of the world.
                 * @param body The Body to align.
                 * @param x The horizontal position to align the body to.
                 * @param y The vertical position to align the body to.
                 * @param align One of the `Phaser.Display.Align` constants, such as `Phaser.Display.Align.TOP_LEFT`.
                 */
                alignBody(body: Phaser.Types.Physics.Matter.MatterBody, x: number, y: number, align: number): this;

            }

            /**
             * A Matter Physics Sprite Game Object.
             * 
             * A Sprite Game Object is used for the display of both static and animated images in your game.
             * Sprites can have input events and physics bodies. They can also be tweened, tinted, scrolled
             * and animated.
             * 
             * The main difference between a Sprite and an Image Game Object is that you cannot animate Images.
             * As such, Sprites take a fraction longer to process and have a larger API footprint due to the Animation
             * Component. If you do not require animation then you can safely use Images to replace Sprites in all cases.
             */
            class Sprite extends Phaser.GameObjects.Sprite implements Phaser.Physics.Matter.Components.Bounce, Phaser.Physics.Matter.Components.Collision, Phaser.Physics.Matter.Components.Force, Phaser.Physics.Matter.Components.Friction, Phaser.Physics.Matter.Components.Gravity, Phaser.Physics.Matter.Components.Mass, Phaser.Physics.Matter.Components.Sensor, Phaser.Physics.Matter.Components.SetBody, Phaser.Physics.Matter.Components.Sleep, Phaser.Physics.Matter.Components.Static, Phaser.Physics.Matter.Components.Transform, Phaser.Physics.Matter.Components.Velocity, Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Size, Phaser.GameObjects.Components.Texture, Phaser.GameObjects.Components.Tint, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible {
                /**
                 * 
                 * @param world A reference to the Matter.World instance that this body belongs to.
                 * @param x The horizontal position of this Game Object in the world.
                 * @param y The vertical position of this Game Object in the world.
                 * @param texture The key, or instance of the Texture this Game Object will use to render with, as stored in the Texture Manager.
                 * @param frame An optional frame from the Texture this Game Object is rendering with.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                constructor(world: Phaser.Physics.Matter.World, x: number, y: number, texture: string | Phaser.Textures.Texture, frame?: string | number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig);

                /**
                 * A reference to the Matter.World instance that this body belongs to.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * Clears all alpha values associated with this Game Object.
                 * 
                 * Immediately sets the alpha levels back to 1 (fully opaque).
                 */
                clearAlpha(): this;

                /**
                 * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
                 * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
                 * 
                 * If your game is running under WebGL you can optionally specify four different alpha values, each of which
                 * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
                 * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
                 * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
                 * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
                 * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
                 */
                setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The alpha value of the Game Object.
                 * 
                 * This is a global value, impacting the entire Game Object, not just a region of it.
                 */
                alpha: number;

                /**
                 * The alpha value starting from the top-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopLeft: number;

                /**
                 * The alpha value starting from the top-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaTopRight: number;

                /**
                 * The alpha value starting from the bottom-left of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomLeft: number;

                /**
                 * The alpha value starting from the bottom-right of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 */
                alphaBottomRight: number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
                 * are used.
                 */
                blendMode: Phaser.BlendModes | string | number;

                /**
                 * Sets the Blend Mode being used by this Game Object.
                 * 
                 * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
                 * 
                 * Under WebGL only the following Blend Modes are available:
                 * 
                 * * NORMAL
                 * * ADD
                 * * MULTIPLY
                 * * SCREEN
                 * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
                 * 
                 * Canvas has more available depending on browser support.
                 * 
                 * You can also create your own custom Blend Modes in WebGL.
                 * 
                 * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
                 * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
                 * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
                 * are used.
                 * @param value The BlendMode value. Either a string, a CONST or a number.
                 */
                setBlendMode(value: string | Phaser.BlendModes | number): this;

                /**
                 * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 */
                depth: number;

                /**
                 * The depth of this Game Object within the Scene.
                 * 
                 * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
                 * of Game Objects, without actually moving their position in the display list.
                 * 
                 * The default depth is zero. A Game Object with a higher depth
                 * value will always render in front of one with a lower value.
                 * 
                 * Setting the depth will queue a depth sort event within the Scene.
                 * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
                 */
                setDepth(value: number): this;

                /**
                 * The horizontally flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipX: boolean;

                /**
                 * The vertically flipped state of the Game Object.
                 * 
                 * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                flipY: boolean;

                /**
                 * Toggles the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 */
                toggleFlipX(): this;

                /**
                 * Toggles the vertical flipped state of this Game Object.
                 */
                toggleFlipY(): this;

                /**
                 * Sets the horizontal flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipX(value: boolean): this;

                /**
                 * Sets the vertical flipped state of this Game Object.
                 * @param value The flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlipY(value: boolean): this;

                /**
                 * Sets the horizontal and vertical flipped state of this Game Object.
                 * 
                 * A Game Object that is flipped will render inversed on the flipped axis.
                 * Flipping always takes place from the middle of the texture and does not impact the scale value.
                 * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
                 * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
                 */
                setFlip(x: boolean, y: boolean): this;

                /**
                 * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
                 */
                resetFlip(): this;

                /**
                 * Gets the center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the top-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the left-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the right-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-center coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
                 * 
                 * The returned point is calculated in local space and does not factor in any parent Containers,
                 * unless the `includeParent` argument is set to `true`.
                 * @param output An object to store the values in. If not provided a new Vector2 will be created.
                 * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
                 */
                getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

                /**
                 * Gets the bounds of this Game Object, regardless of origin.
                 * 
                 * The values are stored and returned in a Rectangle, or Rectangle-like, object.
                 * @param output An object to store the values in. If not provided a new Rectangle will be created.
                 */
                getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

                /**
                 * The Mask this Game Object is using during render.
                 */
                mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

                /**
                 * Sets the mask that this Game Object will use to render with.
                 * 
                 * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * If a mask is already set on this Game Object it will be immediately replaced.
                 * 
                 * Masks are positioned in global space and are not relative to the Game Object to which they
                 * are applied. The reason for this is that multiple Game Objects can all share the same mask.
                 * 
                 * Masks have no impact on physics or input detection. They are purely a rendering component
                 * that allows you to limit what is visible during the render pass.
                 * @param mask The mask this Game Object will use when rendering.
                 */
                setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

                /**
                 * Clears the mask that this Game Object was using.
                 * @param destroyMask Destroy the mask before clearing it? Default false.
                 */
                clearMask(destroyMask?: boolean): this;

                /**
                 * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
                 * including this one, or a Dynamic Texture.
                 * 
                 * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
                 * 
                 * To create the mask you need to pass in a reference to a renderable Game Object.
                 * A renderable Game Object is one that uses a texture to render with, such as an
                 * Image, Sprite, Render Texture or BitmapText.
                 * 
                 * If you do not provide a renderable object, and this Game Object has a texture,
                 * it will use itself as the object. This means you can call this method to create
                 * a Bitmap Mask from any renderable texture-based Game Object.
                 * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
                 * @param x If creating a Game Object, the horizontal position in the world.
                 * @param y If creating a Game Object, the vertical position in the world.
                 * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
                 * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
                 */
                createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

                /**
                 * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
                 * including this one.
                 * 
                 * To create the mask you need to pass in a reference to a Graphics Game Object.
                 * 
                 * If you do not provide a graphics object, and this Game Object is an instance
                 * of a Graphics object, then it will use itself to create the mask.
                 * 
                 * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
                 * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
                 */
                createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

                /**
                 * The horizontal origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the left of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originX: number;

                /**
                 * The vertical origin of this Game Object.
                 * The origin maps the relationship between the size and position of the Game Object.
                 * The default value is 0.5, meaning all Game Objects are positioned based on their center.
                 * Setting the value to 0 means the position now relates to the top of the Game Object.
                 * Set this value with `setOrigin()`.
                 */
                readonly originY: number;

                /**
                 * The horizontal display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginX: number;

                /**
                 * The vertical display origin of this Game Object.
                 * The origin is a normalized value between 0 and 1.
                 * The displayOrigin is a pixel value, based on the size of the Game Object combined with the origin.
                 */
                displayOriginY: number;

                /**
                 * Sets the origin of this Game Object.
                 * 
                 * The values are given in the range 0 to 1.
                 * @param x The horizontal origin value. Default 0.5.
                 * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setOrigin(x?: number, y?: number): this;

                /**
                 * Sets the origin of this Game Object based on the Pivot values in its Frame.
                 */
                setOriginFromFrame(): this;

                /**
                 * Sets the display origin of this Game Object.
                 * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
                 * @param x The horizontal display origin value. Default 0.
                 * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
                 */
                setDisplayOrigin(x?: number, y?: number): this;

                /**
                 * Updates the Display Origin cached values internally stored on this Game Object.
                 * You don't usually call this directly, but it is exposed for edge-cases where you may.
                 */
                updateDisplayOrigin(): this;

                /**
                 * The initial WebGL pipeline of this Game Object.
                 * 
                 * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
                 */
                defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The current WebGL pipeline of this Game Object.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                pipelineData: object;

                /**
                 * Sets the initial WebGL Pipeline of this Game Object.
                 * 
                 * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 */
                initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Sets the main WebGL Pipeline of this Game Object.
                 * 
                 * Also sets the `pipelineData` property, if the parameter is given.
                 * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
                 * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `pipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPipelineData(key: string, value?: any): this;

                /**
                 * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
                 * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
                 */
                resetPipeline(resetData?: boolean): boolean;

                /**
                 * Gets the name of the WebGL Pipeline this Game Object is currently using.
                 */
                getPipelineName(): string;

                /**
                 * Does this Game Object have any Post Pipelines set?
                 */
                hasPostPipeline: boolean;

                /**
                 * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
                 * 
                 * The pipelines are processed in the order in which they appear in this array.
                 * 
                 * If you modify this array directly, be sure to set the
                 * `hasPostPipeline` property accordingly.
                 */
                postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
                 */
                postPipelineData: object;

                /**
                 * The Pre FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.preFX.addBloom();
                 * ```
                 * 
                 * Only the following Game Objects support Pre FX:
                 * 
                 * * Image
                 * * Sprite
                 * * TileSprite
                 * * Text
                 * * RenderTexture
                 * * Video
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 */
                preFX: Phaser.GameObjects.Components.FX | null;

                /**
                 * The Post FX component of this Game Object.
                 * 
                 * This component allows you to apply a variety of built-in effects to this Game Object, such
                 * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
                 * for example:
                 * 
                 * ```js
                 * const player = this.add.sprite();
                 * player.postFX.addBloom();
                 * ```
                 * 
                 * All FX are WebGL only and do not have Canvas counterparts.
                 * 
                 * Please see the FX Class for more details and available methods.
                 * 
                 * This property is always `null` until the `initPostPipeline` method is called.
                 */
                postFX: Phaser.GameObjects.Components.FX;

                /**
                 * This should only be called during the instantiation of the Game Object.
                 * 
                 * It is called by default by all core Game Objects and doesn't need
                 * calling again.
                 * 
                 * After that, use `setPostPipeline`.
                 * @param preFX Does this Game Object support Pre FX? Default false.
                 */
                initPostPipeline(preFX?: boolean): void;

                /**
                 * Sets one, or more, Post Pipelines on this Game Object.
                 * 
                 * Post Pipelines are invoked after this Game Object has rendered to its target and
                 * are commonly used for post-fx.
                 * 
                 * The post pipelines are appended to the `postPipelines` array belonging to this
                 * Game Object. When the renderer processes this Game Object, it iterates through the post
                 * pipelines in the order in which they appear in the array. If you are stacking together
                 * multiple effects, be aware that the order is important.
                 * 
                 * If you call this method multiple times, the new pipelines will be appended to any existing
                 * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
                 * 
                 * You can optionally also set the `postPipelineData` property, if the parameter is given.
                 * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
                 * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
                 */
                setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

                /**
                 * Adds an entry to the `postPipelineData` object belonging to this Game Object.
                 * 
                 * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
                 * 
                 * If `value` is undefined, and `key` exists, `key` is removed from the data object.
                 * @param key The key of the pipeline data to set, update, or delete.
                 * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
                 */
                setPostPipelineData(key: string, value?: any): this;

                /**
                 * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

                /**
                 * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
                 * the `destroy` method on each post pipeline and then clearing the local array.
                 * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
                 */
                resetPostPipeline(resetData?: boolean): void;

                /**
                 * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
                 * 
                 * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
                 * @param pipeline The string-based name of the pipeline, or a pipeline class.
                 */
                removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

                /**
                 * Removes all Pre and Post FX Controllers from this Game Object.
                 * 
                 * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
                 * 
                 * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
                 */
                clearFX(): this;

                /**
                 * The horizontal scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorX: number;

                /**
                 * The vertical scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 */
                scrollFactorY: number;

                /**
                 * Sets the scroll factor of this Game Object.
                 * 
                 * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
                 * 
                 * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
                 * It does not change the Game Objects actual position values.
                 * 
                 * A value of 1 means it will move exactly in sync with a camera.
                 * A value of 0 means it will not move at all, even if the camera moves.
                 * Other values control the degree to which the camera movement is mapped to this Game Object.
                 * 
                 * Please be aware that scroll factor values other than 1 are not taken in to consideration when
                 * calculating physics collisions. Bodies always collide based on their world position, but changing
                 * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
                 * them from physics bodies if not accounted for in your code.
                 * @param x The horizontal scroll factor of this Game Object.
                 * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScrollFactor(x: number, y?: number): this;

                /**
                 * The native (un-scaled) width of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayWidth` property.
                 */
                width: number;

                /**
                 * The native (un-scaled) height of this Game Object.
                 * 
                 * Changing this value will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or use
                 * the `displayHeight` property.
                 */
                height: number;

                /**
                 * The displayed width of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayWidth: number;

                /**
                 * The displayed height of this Game Object.
                 * 
                 * This value takes into account the scale factor.
                 * 
                 * Setting this value will adjust the Game Object's scale property.
                 */
                displayHeight: number;

                /**
                 * Sets the size of this Game Object to be that of the given Frame.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param frame The frame to base the size of this Game Object on.
                 */
                setSizeToFrame(frame?: Phaser.Textures.Frame | boolean): this;

                /**
                 * Sets the internal size of this Game Object, as used for frame or physics body creation.
                 * 
                 * This will not change the size that the Game Object is rendered in-game.
                 * For that you need to either set the scale of the Game Object (`setScale`) or call the
                 * `setDisplaySize` method, which is the same thing as changing the scale but allows you
                 * to do so by giving pixel values.
                 * 
                 * If you have enabled this Game Object for input, changing the size will _not_ change the
                 * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setSize(width: number, height: number): this;

                /**
                 * Sets the display size of this Game Object.
                 * 
                 * Calling this will adjust the scale.
                 * @param width The width of this Game Object.
                 * @param height The height of this Game Object.
                 */
                setDisplaySize(width: number, height: number): this;

                /**
                 * The Texture this Game Object is using to render with.
                 */
                texture: Phaser.Textures.Texture | Phaser.Textures.CanvasTexture;

                /**
                 * The Texture Frame this Game Object is using to render with.
                 */
                frame: Phaser.Textures.Frame;

                /**
                 * A boolean flag indicating if this Game Object is being cropped or not.
                 * You can toggle this at any time after `setCrop` has been called, to turn cropping on or off.
                 * Equally, calling `setCrop` with no arguments will reset the crop and disable it.
                 */
                isCropped: boolean;

                /**
                 * Applies a crop to a texture based Game Object, such as a Sprite or Image.
                 * 
                 * The crop is a rectangle that limits the area of the texture frame that is visible during rendering.
                 * 
                 * Cropping a Game Object does not change its size, dimensions, physics body or hit area, it just
                 * changes what is shown when rendered.
                 * 
                 * The crop coordinates are relative to the texture frame, not the Game Object, meaning 0 x 0 is the top-left.
                 * 
                 * Therefore, if you had a Game Object that had an 800x600 sized texture, and you wanted to show only the left
                 * half of it, you could call `setCrop(0, 0, 400, 600)`.
                 * 
                 * It is also scaled to match the Game Object scale automatically. Therefore a crop rect of 100x50 would crop
                 * an area of 200x100 when applied to a Game Object that had a scale factor of 2.
                 * 
                 * You can either pass in numeric values directly, or you can provide a single Rectangle object as the first argument.
                 * 
                 * Call this method with no arguments at all to reset the crop, or toggle the property `isCropped` to `false`.
                 * 
                 * You should do this if the crop rectangle becomes the same size as the frame itself, as it will allow
                 * the renderer to skip several internal calculations.
                 * @param x The x coordinate to start the crop from. Or a Phaser.Geom.Rectangle object, in which case the rest of the arguments are ignored.
                 * @param y The y coordinate to start the crop from.
                 * @param width The width of the crop rectangle in pixels.
                 * @param height The height of the crop rectangle in pixels.
                 */
                setCrop(x?: number | Phaser.Geom.Rectangle, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the texture and frame this Game Object will use to render with.
                 * 
                 * Textures are referenced by their string-based keys, as stored in the Texture Manager.
                 * @param key The key of the texture to be used, as stored in the Texture Manager.
                 * @param frame The name or index of the frame within the Texture.
                 */
                setTexture(key: string, frame?: string | number): this;

                /**
                 * Sets the frame this Game Object will use to render with.
                 * 
                 * If you pass a string or index then the Frame has to belong to the current Texture being used
                 * by this Game Object.
                 * 
                 * If you pass a Frame instance, then the Texture being used by this Game Object will also be updated.
                 * 
                 * Calling `setFrame` will modify the `width` and `height` properties of your Game Object.
                 * 
                 * It will also change the `origin` if the Frame has a custom pivot point, as exported from packages like Texture Packer.
                 * @param frame The name or index of the frame within the Texture, or a Frame instance.
                 * @param updateSize Should this call adjust the size of the Game Object? Default true.
                 * @param updateOrigin Should this call adjust the origin of the Game Object? Default true.
                 */
                setFrame(frame: string | number | Phaser.Textures.Frame, updateSize?: boolean, updateOrigin?: boolean): this;

                /**
                 * The tint value being applied to the top-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopLeft: number;

                /**
                 * The tint value being applied to the top-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintTopRight: number;

                /**
                 * The tint value being applied to the bottom-left vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomLeft: number;

                /**
                 * The tint value being applied to the bottom-right vertice of the Game Object.
                 * This value is interpolated from the corner to the center of the Game Object.
                 * The value should be set as a hex number, i.e. 0xff0000 for red, or 0xff00ff for purple.
                 */
                tintBottomRight: number;

                /**
                 * The tint fill mode.
                 * 
                 * `false` = An additive tint (the default), where vertices colors are blended with the texture.
                 * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
                 */
                tintFill: boolean;

                /**
                 * Clears all tint values associated with this Game Object.
                 * 
                 * Immediately sets the color values back to 0xffffff and the tint type to 'additive',
                 * which results in no visible change to the texture.
                 */
                clearTint(): this;

                /**
                 * Sets an additive tint on this Game Object.
                 * 
                 * The tint works by taking the pixel color values from the Game Objects texture, and then
                 * multiplying it by the color value of the tint. You can provide either one color value,
                 * in which case the whole Game Object will be tinted in that color. Or you can provide a color
                 * per corner. The colors are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being an additive tint to a fill based tint set the property `tintFill` to `true`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If no other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTint(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * Sets a fill-based tint on this Game Object.
                 * 
                 * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
                 * with those in the tint. You can use this for effects such as making a player flash 'white'
                 * if hit by something. You can provide either one color value, in which case the whole
                 * Game Object will be rendered in that color. Or you can provide a color per corner. The colors
                 * are blended together across the extent of the Game Object.
                 * 
                 * To modify the tint color once set, either call this method again with new values or use the
                 * `tint` property to set all colors at once. Or, use the properties `tintTopLeft`, `tintTopRight,
                 * `tintBottomLeft` and `tintBottomRight` to set the corner color values independently.
                 * 
                 * To remove a tint call `clearTint`.
                 * 
                 * To swap this from being a fill-tint to an additive tint set the property `tintFill` to `false`.
                 * @param topLeft The tint being applied to the top-left of the Game Object. If not other values are given this value is applied evenly, tinting the whole Game Object. Default 0xffffff.
                 * @param topRight The tint being applied to the top-right of the Game Object.
                 * @param bottomLeft The tint being applied to the bottom-left of the Game Object.
                 * @param bottomRight The tint being applied to the bottom-right of the Game Object.
                 */
                setTintFill(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

                /**
                 * The tint value being applied to the whole of the Game Object.
                 * Return `tintTopLeft` when read this tint property.
                 */
                tint: number;

                /**
                 * Does this Game Object have a tint applied?
                 * 
                 * It checks to see if the 4 tint properties are set to the value 0xffffff
                 * and that the `tintFill` property is `false`. This indicates that a Game Object isn't tinted.
                 */
                readonly isTinted: boolean;

                /**
                 * A property indicating that a Game Object has this component.
                 */
                readonly hasTransformComponent: boolean;

                /**
                 * The x position of this Game Object.
                 */
                x: number;

                /**
                 * The y position of this Game Object.
                 */
                y: number;

                /**
                 * The z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#depth} instead.
                 */
                z: number;

                /**
                 * The w position of this Game Object.
                 */
                w: number;

                /**
                 * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
                 * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
                 * 
                 * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
                 * isn't the case, use the `scaleX` or `scaleY` properties instead.
                 */
                scale: number;

                /**
                 * The horizontal scale of this Game Object.
                 */
                scaleX: number;

                /**
                 * The vertical scale of this Game Object.
                 */
                scaleY: number;

                /**
                 * The angle of this Game Object as expressed in degrees.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
                 * and -90 is up.
                 * 
                 * If you prefer to work in radians, see the `rotation` property instead.
                 */
                angle: number;

                /**
                 * The angle of this Game Object in radians.
                 * 
                 * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
                 * and -PI/2 is up.
                 * 
                 * If you prefer to work in degrees, see the `angle` property instead.
                 */
                rotation: number;

                /**
                 * Sets the position of this Game Object.
                 * @param x The x position of this Game Object. Default 0.
                 * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
                 * @param z The z position of this Game Object. Default 0.
                 * @param w The w position of this Game Object. Default 0.
                 */
                setPosition(x?: number, y?: number, z?: number, w?: number): this;

                /**
                 * Copies an object's coordinates to this Game Object's position.
                 * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
                 */
                copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

                /**
                 * Sets the position of this Game Object to be a random position within the confines of
                 * the given area.
                 * 
                 * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
                 * 
                 * The position does not factor in the size of this Game Object, meaning that only the origin is
                 * guaranteed to be within the area.
                 * @param x The x position of the top-left of the random area. Default 0.
                 * @param y The y position of the top-left of the random area. Default 0.
                 * @param width The width of the random area.
                 * @param height The height of the random area.
                 */
                setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

                /**
                 * Sets the rotation of this Game Object.
                 * @param radians The rotation of this Game Object, in radians. Default 0.
                 */
                setRotation(radians?: number): this;

                /**
                 * Sets the angle of this Game Object.
                 * @param degrees The rotation of this Game Object, in degrees. Default 0.
                 */
                setAngle(degrees?: number): this;

                /**
                 * Sets the scale of this Game Object.
                 * @param x The horizontal scale of this Game Object. Default 1.
                 * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
                 */
                setScale(x?: number, y?: number): this;

                /**
                 * Sets the x position of this Game Object.
                 * @param value The x position of this Game Object. Default 0.
                 */
                setX(value?: number): this;

                /**
                 * Sets the y position of this Game Object.
                 * @param value The y position of this Game Object. Default 0.
                 */
                setY(value?: number): this;

                /**
                 * Sets the z position of this Game Object.
                 * 
                 * Note: The z position does not control the rendering order of 2D Game Objects. Use
                 * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
                 * @param value The z position of this Game Object. Default 0.
                 */
                setZ(value?: number): this;

                /**
                 * Sets the w position of this Game Object.
                 * @param value The w position of this Game Object. Default 0.
                 */
                setW(value?: number): this;

                /**
                 * Gets the local transform matrix for this Game Object.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 */
                getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
                 * @param tempMatrix The matrix to populate with the values from this Game Object.
                 * @param parentMatrix A temporary matrix to hold parent values during the calculations.
                 */
                getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

                /**
                 * Takes the given `x` and `y` coordinates and converts them into local space for this
                 * Game Object, taking into account parent and local transforms, and the Display Origin.
                 * 
                 * The returned Vector2 contains the translated point in its properties.
                 * 
                 * A Camera needs to be provided in order to handle modified scroll factors. If no
                 * camera is specified, it will use the `main` camera from the Scene to which this
                 * Game Object belongs.
                 * @param x The x position to translate.
                 * @param y The y position to translate.
                 * @param point A Vector2, or point-like object, to store the results in.
                 * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
                 */
                getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

                /**
                 * Gets the sum total rotation of all of this Game Objects parent Containers.
                 * 
                 * The returned value is in radians and will be zero if this Game Object has no parent container.
                 */
                getParentRotation(): number;

                /**
                 * The visible state of the Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 */
                visible: boolean;

                /**
                 * Sets the visibility of this Game Object.
                 * 
                 * An invisible Game Object will skip rendering, but will still process update logic.
                 * @param value The visible state of the Game Object.
                 */
                setVisible(value: boolean): this;

                /**
                 * Sets the restitution on the physics object.
                 * @param value A Number that defines the restitution (elasticity) of the body. The value is always positive and is in the range (0, 1). A value of 0 means collisions may be perfectly inelastic and no bouncing may occur. A value of 0.8 means the body may bounce back with approximately 80% of its kinetic energy. Note that collision response is based on pairs of bodies, and that restitution values are combined with the following formula: `Math.max(bodyA.restitution, bodyB.restitution)`
                 */
                setBounce(value: number): this;

                /**
                 * Sets the collision category of this Game Object's Matter Body. This number must be a power of two between 2^0 (= 1) and 2^31.
                 * Two bodies with different collision groups (see {@link #setCollisionGroup}) will only collide if their collision
                 * categories are included in their collision masks (see {@link #setCollidesWith}).
                 * @param value Unique category bitfield.
                 */
                setCollisionCategory(value: number): this;

                /**
                 * Sets the collision group of this Game Object's Matter Body. If this is zero or two Matter Bodies have different values,
                 * they will collide according to the usual rules (see {@link #setCollisionCategory} and {@link #setCollisionGroup}).
                 * If two Matter Bodies have the same positive value, they will always collide; if they have the same negative value,
                 * they will never collide.
                 * @param value Unique group index.
                 */
                setCollisionGroup(value: number): this;

                /**
                 * Sets the collision mask for this Game Object's Matter Body. Two Matter Bodies with different collision groups will only
                 * collide if each one includes the other's category in its mask based on a bitwise AND, i.e. `(categoryA & maskB) !== 0`
                 * and `(categoryB & maskA) !== 0` are both true.
                 * @param categories A unique category bitfield, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body starts colliding with another.
                 */
                setOnCollide(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body stops colliding with another.
                 */
                setOnCollideEnd(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke for the duration of this body colliding with another.
                 */
                setOnCollideActive(callback: Function): this;

                /**
                 * The callback is sent a reference to the other body, along with a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param body The body, or an array of bodies, to test for collisions with.
                 * @param callback The callback to invoke when this body collides with the given body or bodies.
                 */
                setOnCollideWith(body: MatterJS.Body | MatterJS.Body[], callback: Function): this;

                /**
                 * Applies a force to a body.
                 * @param force A Vector that specifies the force to apply.
                 */
                applyForce(force: Phaser.Math.Vector2): this;

                /**
                 * Applies a force to a body from a given position.
                 * @param position The position in which the force comes from.
                 * @param force A Vector that specifies the force to apply.
                 */
                applyForceFrom(position: Phaser.Math.Vector2, force: Phaser.Math.Vector2): this;

                /**
                 * Apply thrust to the forward position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrust(speed: number): this;

                /**
                 * Apply thrust to the left position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustLeft(speed: number): this;

                /**
                 * Apply thrust to the right position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustRight(speed: number): this;

                /**
                 * Apply thrust to the back position of the body.
                 * 
                 * Use very small values, such as 0.1, depending on the mass and required speed.
                 * @param speed A speed value to be applied to a directional force.
                 */
                thrustBack(speed: number): this;

                /**
                 * Sets new friction values for this Game Object's Matter Body.
                 * @param value The new friction of the body, between 0 and 1, where 0 allows the Body to slide indefinitely, while 1 allows it to stop almost immediately after a force is applied.
                 * @param air If provided, the new air resistance of the Body. The higher the value, the faster the Body will slow as it moves through space. 0 means the body has no air resistance.
                 * @param fstatic If provided, the new static friction of the Body. The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary. 0 means the body will never "stick" when it is nearly stationary.
                 */
                setFriction(value: number, air?: number, fstatic?: number): this;

                /**
                 * Sets a new air resistance for this Game Object's Matter Body.
                 * A value of 0 means the Body will never slow as it moves through space.
                 * The higher the value, the faster a Body slows when moving through space.
                 * @param value The new air resistance for the Body.
                 */
                setFrictionAir(value: number): this;

                /**
                 * Sets a new static friction for this Game Object's Matter Body.
                 * A value of 0 means the Body will never "stick" when it is nearly stationary.
                 * The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary.
                 * @param value The new static friction for the Body.
                 */
                setFrictionStatic(value: number): this;

                /**
                 * A togglable function for ignoring world gravity in real-time on the current body.
                 * @param value Set to true to ignore the effect of world gravity, or false to not ignore it.
                 */
                setIgnoreGravity(value: boolean): this;

                /**
                 * Sets the mass of the Game Object's Matter Body.
                 * @param value The new mass of the body.
                 */
                setMass(value: number): this;

                /**
                 * Sets density of the body.
                 * @param value The new density of the body.
                 */
                setDensity(value: number): this;

                /**
                 * The body's center of mass.
                 * 
                 * Calling this creates a new `Vector2 each time to avoid mutation.
                 * 
                 * If you only need to read the value and won't change it, you can get it from `GameObject.body.centerOfMass`.
                 */
                readonly centerOfMass: Phaser.Math.Vector2;

                /**
                 * Set the body belonging to this Game Object to be a sensor.
                 * Sensors trigger collision events, but don't react with colliding body physically.
                 * @param value `true` to set the body as a sensor, or `false` to disable it.
                 */
                setSensor(value: boolean): this;

                /**
                 * Is the body belonging to this Game Object a sensor or not?
                 */
                isSensor(): boolean;

                /**
                 * Set this Game Objects Matter physics body to be a rectangle shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param width Width of the rectangle.
                 * @param height Height of the rectangle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setRectangle(width: number, height: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a circle shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param radius The radius of the circle.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setCircle(radius: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a polygon shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param radius The "radius" of the polygon, i.e. the distance from its center to any vertex. This is also the radius of its circumcircle.
                 * @param sides The number of sides the polygon will have.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setPolygon(radius: number, sides: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Objects Matter physics body to be a trapezoid shape.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param width The width of the trapezoid Body.
                 * @param height The height of the trapezoid Body.
                 * @param slope The slope of the trapezoid. 0 creates a rectangle, while 1 creates a triangle. Positive values make the top side shorter, while negative values make the bottom side shorter.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setTrapezoid(width: number, height: number, slope: number, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Set this Game Object to use the given existing Matter Body.
                 * 
                 * The body is first removed from the world before being added to this Game Object.
                 * @param body The Body this Game Object should use.
                 * @param addToWorld Should the body be immediately added to the World? Default true.
                 */
                setExistingBody(body: MatterJS.BodyType, addToWorld?: boolean): this;

                /**
                 * Set this Game Object to create and use a new Body based on the configuration object given.
                 * 
                 * Calling this methods resets all previous properties you may have set on the body, including
                 * plugins, mass, friction, collision categories, etc. So be sure to re-apply these as needed.
                 * @param config Either a string, such as `circle`, or a Matter Set Body Configuration object.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                setBody(config: string | Phaser.Types.Physics.Matter.MatterSetBodyConfig, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): this;

                /**
                 * Sets this Body to sleep.
                 */
                setToSleep(): this;

                /**
                 * Wakes this Body if asleep.
                 */
                setAwake(): this;

                /**
                 * Sets the number of updates in which this body must have near-zero velocity before it is set as sleeping (if sleeping is enabled by the engine).
                 * @param value A `Number` that defines the number of updates in which this body must have near-zero velocity before it is set as sleeping. Default 60.
                 */
                setSleepThreshold(value?: number): this;

                /**
                 * Enable sleep and wake events for this body.
                 * 
                 * By default when a body goes to sleep, or wakes up, it will not emit any events.
                 * 
                 * The events are emitted by the Matter World instance and can be listened to via
                 * the `SLEEP_START` and `SLEEP_END` events.
                 * @param start `true` if you want the sleep start event to be emitted for this body.
                 * @param end `true` if you want the sleep end event to be emitted for this body.
                 */
                setSleepEvents(start: boolean, end: boolean): this;

                /**
                 * Enables or disables the Sleep Start event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepStartEvent(value: boolean): this;

                /**
                 * Enables or disables the Sleep End event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepEndEvent(value: boolean): this;

                /**
                 * Changes the physics body to be either static `true` or dynamic `false`.
                 * @param value `true` to set the body as being static, or `false` to make it dynamic.
                 */
                setStatic(value: boolean): this;

                /**
                 * Returns `true` if the body is static, otherwise `false` for a dynamic body.
                 */
                isStatic(): boolean;

                /**
                 * Setting fixed rotation sets the Body inertia to Infinity, which stops it
                 * from being able to rotate when forces are applied to it.
                 */
                setFixedRotation(): this;

                /**
                 * Sets the horizontal velocity of the physics body.
                 * @param x The horizontal velocity value.
                 */
                setVelocityX(x: number): this;

                /**
                 * Sets vertical velocity of the physics body.
                 * @param y The vertical velocity value.
                 */
                setVelocityY(y: number): this;

                /**
                 * Sets both the horizontal and vertical velocity of the physics body.
                 * @param x The horizontal velocity value.
                 * @param y The vertical velocity value, it can be either positive or negative. If not given, it will be the same as the `x` value. Default x.
                 */
                setVelocity(x: number, y?: number): this;

                /**
                 * Gets the current linear velocity of the physics body.
                 */
                getVelocity(): Phaser.Types.Math.Vector2Like;

                /**
                 * Sets the angular velocity of the body instantly.
                 * Position, angle, force etc. are unchanged.
                 * @param velocity The angular velocity.
                 */
                setAngularVelocity(velocity: number): this;

                /**
                 * Gets the current rotational velocity of the body.
                 */
                getAngularVelocity(): number;

                /**
                 * Sets the current rotational speed of the body.
                 * Direction is maintained. Affects body angular velocity.
                 * @param speed The angular speed.
                 */
                setAngularSpeed(speed: number): this;

                /**
                 * Gets the current rotational speed of the body.
                 * Equivalent to the magnitude of its angular velocity.
                 */
                getAngularSpeed(): number;

            }

            /**
             * A wrapper around a Tile that provides access to a corresponding Matter body. A tile can only
             * have one Matter body associated with it. You can either pass in an existing Matter body for
             * the tile or allow the constructor to create the corresponding body for you. If the Tile has a
             * collision group (defined in Tiled), those shapes will be used to create the body. If not, the
             * tile's rectangle bounding box will be used.
             * 
             * The corresponding body will be accessible on the Tile itself via Tile.physics.matterBody.
             * 
             * Note: not all Tiled collision shapes are supported. See
             * Phaser.Physics.Matter.TileBody#setFromTileCollision for more information.
             */
            class TileBody extends Phaser.Events.EventEmitter implements Phaser.Physics.Matter.Components.Bounce, Phaser.Physics.Matter.Components.Collision, Phaser.Physics.Matter.Components.Friction, Phaser.Physics.Matter.Components.Gravity, Phaser.Physics.Matter.Components.Mass, Phaser.Physics.Matter.Components.Sensor, Phaser.Physics.Matter.Components.Sleep, Phaser.Physics.Matter.Components.Static {
                /**
                 * 
                 * @param world The Matter world instance this body belongs to.
                 * @param tile The target tile that should have a Matter body.
                 * @param options Options to be used when creating the Matter body.
                 */
                constructor(world: Phaser.Physics.Matter.World, tile: Phaser.Tilemaps.Tile, options?: Phaser.Types.Physics.Matter.MatterTileOptions);

                /**
                 * The tile object the body is associated with.
                 */
                tile: Phaser.Tilemaps.Tile;

                /**
                 * The Matter world the body exists within.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * Sets the current body to a rectangle that matches the bounds of the tile.
                 * @param options Options to be used when creating the Matter body. See MatterJS.Body for a list of what Matter accepts.
                 */
                setFromTileRectangle(options?: Phaser.Types.Physics.Matter.MatterBodyTileOptions): Phaser.Physics.Matter.TileBody;

                /**
                 * Sets the current body from the collision group associated with the Tile. This is typically
                 * set up in Tiled's collision editor.
                 * 
                 * Note: Matter doesn't support all shapes from Tiled. Rectangles and polygons are directly
                 * supported. Ellipses are converted into circle bodies. Polylines are treated as if they are
                 * closed polygons. If a tile has multiple shapes, a multi-part body will be created. Concave
                 * shapes are supported if poly-decomp library is included. Decomposition is not guaranteed to
                 * work for complex shapes (e.g. holes), so it's often best to manually decompose a concave
                 * polygon into multiple convex polygons yourself.
                 * @param options Options to be used when creating the Matter body. See MatterJS.Body for a list of what Matter accepts.
                 */
                setFromTileCollision(options?: Phaser.Types.Physics.Matter.MatterBodyTileOptions): Phaser.Physics.Matter.TileBody;

                /**
                 * Sets the current body to the given body. This will remove the previous body, if one already
                 * exists.
                 * @param body The new Matter body to use.
                 * @param addToWorld Whether or not to add the body to the Matter world. Default true.
                 */
                setBody(body: MatterJS.BodyType, addToWorld?: boolean): Phaser.Physics.Matter.TileBody;

                /**
                 * Removes the current body from the TileBody and from the Matter world
                 */
                removeBody(): Phaser.Physics.Matter.TileBody;

                /**
                 * Removes the current body from the tile and the world.
                 */
                destroy(): Phaser.Physics.Matter.TileBody;

                /**
                 * Sets the restitution on the physics object.
                 * @param value A Number that defines the restitution (elasticity) of the body. The value is always positive and is in the range (0, 1). A value of 0 means collisions may be perfectly inelastic and no bouncing may occur. A value of 0.8 means the body may bounce back with approximately 80% of its kinetic energy. Note that collision response is based on pairs of bodies, and that restitution values are combined with the following formula: `Math.max(bodyA.restitution, bodyB.restitution)`
                 */
                setBounce(value: number): this;

                /**
                 * Sets the collision category of this Game Object's Matter Body. This number must be a power of two between 2^0 (= 1) and 2^31.
                 * Two bodies with different collision groups (see {@link #setCollisionGroup}) will only collide if their collision
                 * categories are included in their collision masks (see {@link #setCollidesWith}).
                 * @param value Unique category bitfield.
                 */
                setCollisionCategory(value: number): this;

                /**
                 * Sets the collision group of this Game Object's Matter Body. If this is zero or two Matter Bodies have different values,
                 * they will collide according to the usual rules (see {@link #setCollisionCategory} and {@link #setCollisionGroup}).
                 * If two Matter Bodies have the same positive value, they will always collide; if they have the same negative value,
                 * they will never collide.
                 * @param value Unique group index.
                 */
                setCollisionGroup(value: number): this;

                /**
                 * Sets the collision mask for this Game Object's Matter Body. Two Matter Bodies with different collision groups will only
                 * collide if each one includes the other's category in its mask based on a bitwise AND, i.e. `(categoryA & maskB) !== 0`
                 * and `(categoryB & maskA) !== 0` are both true.
                 * @param categories A unique category bitfield, or an array of them.
                 */
                setCollidesWith(categories: number | number[]): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body starts colliding with another.
                 */
                setOnCollide(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke when this body stops colliding with another.
                 */
                setOnCollideEnd(callback: Function): this;

                /**
                 * The callback is sent a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param callback The callback to invoke for the duration of this body colliding with another.
                 */
                setOnCollideActive(callback: Function): this;

                /**
                 * The callback is sent a reference to the other body, along with a `Phaser.Types.Physics.Matter.MatterCollisionData` object.
                 * 
                 * This does not change the bodies collision category, group or filter. Those must be set in addition
                 * to the callback.
                 * @param body The body, or an array of bodies, to test for collisions with.
                 * @param callback The callback to invoke when this body collides with the given body or bodies.
                 */
                setOnCollideWith(body: MatterJS.Body | MatterJS.Body[], callback: Function): this;

                /**
                 * Sets new friction values for this Game Object's Matter Body.
                 * @param value The new friction of the body, between 0 and 1, where 0 allows the Body to slide indefinitely, while 1 allows it to stop almost immediately after a force is applied.
                 * @param air If provided, the new air resistance of the Body. The higher the value, the faster the Body will slow as it moves through space. 0 means the body has no air resistance.
                 * @param fstatic If provided, the new static friction of the Body. The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary. 0 means the body will never "stick" when it is nearly stationary.
                 */
                setFriction(value: number, air?: number, fstatic?: number): this;

                /**
                 * Sets a new air resistance for this Game Object's Matter Body.
                 * A value of 0 means the Body will never slow as it moves through space.
                 * The higher the value, the faster a Body slows when moving through space.
                 * @param value The new air resistance for the Body.
                 */
                setFrictionAir(value: number): this;

                /**
                 * Sets a new static friction for this Game Object's Matter Body.
                 * A value of 0 means the Body will never "stick" when it is nearly stationary.
                 * The higher the value (e.g. 10), the more force it will take to initially get the Body moving when it is nearly stationary.
                 * @param value The new static friction for the Body.
                 */
                setFrictionStatic(value: number): this;

                /**
                 * A togglable function for ignoring world gravity in real-time on the current body.
                 * @param value Set to true to ignore the effect of world gravity, or false to not ignore it.
                 */
                setIgnoreGravity(value: boolean): this;

                /**
                 * Sets the mass of the Game Object's Matter Body.
                 * @param value The new mass of the body.
                 */
                setMass(value: number): this;

                /**
                 * Sets density of the body.
                 * @param value The new density of the body.
                 */
                setDensity(value: number): this;

                /**
                 * The body's center of mass.
                 * 
                 * Calling this creates a new `Vector2 each time to avoid mutation.
                 * 
                 * If you only need to read the value and won't change it, you can get it from `GameObject.body.centerOfMass`.
                 */
                readonly centerOfMass: Phaser.Math.Vector2;

                /**
                 * Set the body belonging to this Game Object to be a sensor.
                 * Sensors trigger collision events, but don't react with colliding body physically.
                 * @param value `true` to set the body as a sensor, or `false` to disable it.
                 */
                setSensor(value: boolean): this;

                /**
                 * Is the body belonging to this Game Object a sensor or not?
                 */
                isSensor(): boolean;

                /**
                 * Sets this Body to sleep.
                 */
                setToSleep(): this;

                /**
                 * Wakes this Body if asleep.
                 */
                setAwake(): this;

                /**
                 * Sets the number of updates in which this body must have near-zero velocity before it is set as sleeping (if sleeping is enabled by the engine).
                 * @param value A `Number` that defines the number of updates in which this body must have near-zero velocity before it is set as sleeping. Default 60.
                 */
                setSleepThreshold(value?: number): this;

                /**
                 * Enable sleep and wake events for this body.
                 * 
                 * By default when a body goes to sleep, or wakes up, it will not emit any events.
                 * 
                 * The events are emitted by the Matter World instance and can be listened to via
                 * the `SLEEP_START` and `SLEEP_END` events.
                 * @param start `true` if you want the sleep start event to be emitted for this body.
                 * @param end `true` if you want the sleep end event to be emitted for this body.
                 */
                setSleepEvents(start: boolean, end: boolean): this;

                /**
                 * Enables or disables the Sleep Start event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepStartEvent(value: boolean): this;

                /**
                 * Enables or disables the Sleep End event for this body.
                 * @param value `true` to enable the sleep event, or `false` to disable it.
                 */
                setSleepEndEvent(value: boolean): this;

                /**
                 * Changes the physics body to be either static `true` or dynamic `false`.
                 * @param value `true` to set the body as being static, or `false` to make it dynamic.
                 */
                setStatic(value: boolean): this;

                /**
                 * Returns `true` if the body is static, otherwise `false` for a dynamic body.
                 */
                isStatic(): boolean;

            }

            /**
             * Use PhysicsEditorParser.parseBody() to build a Matter body object, based on a physics data file
             * created and exported with PhysicsEditor (https://www.codeandweb.com/physicseditor).
             */
            namespace PhysicsEditorParser {
                /**
                 * Parses a body element exported by PhysicsEditor.
                 * @param x The horizontal world location of the body.
                 * @param y The vertical world location of the body.
                 * @param config The body configuration and fixture (child body) definitions, as exported by PhysicsEditor.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                function parseBody(x: number, y: number, config: object, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType;

                /**
                 * Parses an element of the "fixtures" list exported by PhysicsEditor
                 * @param fixtureConfig The fixture object to parse.
                 */
                function parseFixture(fixtureConfig: object): MatterJS.BodyType[];

                /**
                 * Parses the "vertices" lists exported by PhysicsEditor.
                 * @param vertexSets The vertex lists to parse.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                function parseVertices(vertexSets: any[], options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType[];

            }

            /**
             * Creates a body using the supplied physics data, as provided by a JSON file.
             * 
             * The data file should be loaded as JSON:
             * 
             * ```javascript
             * preload ()
             * {
             *   this.load.json('ninjas', 'assets/ninjas.json);
             * }
             * 
             * create ()
             * {
             *   const ninjaShapes = this.cache.json.get('ninjas');
             * 
             *   this.matter.add.fromJSON(400, 300, ninjaShapes.shinobi);
             * }
             * ```
             * 
             * Do not pass the entire JSON file to this method, but instead pass one of the shapes contained within it.
             * 
             * If you pas in an `options` object, any settings in there will override those in the config object.
             * 
             * The structure of the JSON file is as follows:
             * 
             * ```text
             * {
             *   'generator_info': // The name of the application that created the JSON data
             *   'shapeName': {
             *     'type': // The type of body
             *     'label': // Optional body label
             *     'vertices': // An array, or an array of arrays, containing the vertex data in x/y object pairs
             *   }
             * }
             * ```
             * 
             * At the time of writing, only the Phaser Physics Tracer App exports in this format.
             */
            namespace PhysicsJSONParser {
                /**
                 * Parses a body element from the given JSON data.
                 * @param x The horizontal world location of the body.
                 * @param y The vertical world location of the body.
                 * @param config The body configuration data.
                 * @param options An optional Body configuration object that is used to set initial Body properties on creation.
                 */
                function parseBody(x: number, y: number, config: object, options?: Phaser.Types.Physics.Matter.MatterBodyConfig): MatterJS.BodyType;

            }

            /**
             * A Pointer Constraint is a special type of constraint that allows you to click
             * and drag bodies in a Matter World. It monitors the active Pointers in a Scene,
             * and when one is pressed down it checks to see if that hit any part of any active
             * body in the world. If it did, and the body has input enabled, it will begin to
             * drag it until either released, or you stop it via the `stopDrag` method.
             * 
             * You can adjust the stiffness, length and other properties of the constraint via
             * the `options` object on creation.
             */
            class PointerConstraint {
                /**
                 * 
                 * @param scene A reference to the Scene to which this Pointer Constraint belongs.
                 * @param world A reference to the Matter World instance to which this Constraint belongs.
                 * @param options A Constraint configuration object.
                 */
                constructor(scene: Phaser.Scene, world: Phaser.Physics.Matter.World, options?: object);

                /**
                 * A reference to the Scene to which this Pointer Constraint belongs.
                 * This is the same Scene as the Matter World instance.
                 */
                scene: Phaser.Scene;

                /**
                 * A reference to the Matter World instance to which this Constraint belongs.
                 */
                world: Phaser.Physics.Matter.World;

                /**
                 * The Camera the Pointer was interacting with when the input
                 * down event was processed.
                 */
                camera: Phaser.Cameras.Scene2D.Camera;

                /**
                 * A reference to the Input Pointer that activated this Constraint.
                 * This is set in the `onDown` handler.
                 */
                pointer: Phaser.Input.Pointer;

                /**
                 * Is this Constraint active or not?
                 * 
                 * An active constraint will be processed each update. An inactive one will be skipped.
                 * Use this to toggle a Pointer Constraint on and off.
                 */
                active: boolean;

                /**
                 * The internal transformed position.
                 */
                position: Phaser.Math.Vector2;

                /**
                 * The body that is currently being dragged, if any.
                 */
                body: MatterJS.BodyType | null;

                /**
                 * The part of the body that was clicked on to start the drag.
                 */
                part: MatterJS.BodyType | null;

                /**
                 * The native Matter Constraint that is used to attach to bodies.
                 */
                constraint: MatterJS.ConstraintType;

                /**
                 * A Pointer has been pressed down onto the Scene.
                 * 
                 * If this Constraint doesn't have an active Pointer then a hit test is set to
                 * run against all active bodies in the world during the _next_ call to `update`.
                 * If a body is found, it is bound to this constraint and the drag begins.
                 * @param pointer A reference to the Pointer that was pressed.
                 */
                onDown(pointer: Phaser.Input.Pointer): void;

                /**
                 * A Pointer has been released from the Scene. If it was the one this constraint was using, it's cleared.
                 * @param pointer A reference to the Pointer that was pressed.
                 */
                onUp(pointer: Phaser.Input.Pointer): void;

                /**
                 * Scans all active bodies in the current Matter World to see if any of them
                 * are hit by the Pointer. The _first one_ found to hit is set as the active contraint
                 * body.
                 */
                getBody(): boolean;

                /**
                 * Scans the current body to determine if a part of it was clicked on.
                 * If a part is found the body is set as the `constraint.bodyB` property,
                 * as well as the `body` property of this class. The part is also set.
                 * @param body The Matter Body to check.
                 * @param position A translated hit test position.
                 */
                hitTestBody(body: MatterJS.BodyType, position: Phaser.Math.Vector2): boolean;

                /**
                 * Internal update handler. Called in the Matter BEFORE_UPDATE step.
                 */
                update(): void;

                /**
                 * Stops the Pointer Constraint from dragging the body any further.
                 * 
                 * This is called automatically if the Pointer is released while actively
                 * dragging a body. Or, you can call it manually to release a body from a
                 * constraint without having to first release the pointer.
                 */
                stopDrag(): void;

                /**
                 * Destroys this Pointer Constraint instance and all of its references.
                 */
                destroy(): void;

            }

            /**
             * The Matter World class is responsible for managing one single instance of a Matter Physics World for Phaser.
             * 
             * Access this via `this.matter.world` from within a Scene.
             * 
             * This class creates a Matter JS World Composite along with the Matter JS Engine during instantiation. It also
             * handles delta timing, bounds, body and constraint creation and debug drawing.
             * 
             * If you wish to access the Matter JS World object directly, see the `localWorld` property.
             * If you wish to access the Matter Engine directly, see the `engine` property.
             * 
             * This class is an Event Emitter and will proxy _all_ Matter JS events, as they are received.
             */
            class World extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param scene The Scene to which this Matter World instance belongs.
                 * @param config The Matter World configuration object.
                 */
                constructor(scene: Phaser.Scene, config: Phaser.Types.Physics.Matter.MatterWorldConfig);

                /**
                 * The Scene to which this Matter World instance belongs.
                 */
                scene: Phaser.Scene;

                /**
                 * An instance of the MatterJS Engine.
                 */
                engine: MatterJS.Engine;

                /**
                 * A `World` composite object that will contain all simulated bodies and constraints.
                 */
                localWorld: MatterJS.World;

                /**
                 * An object containing the 4 wall bodies that bound the physics world.
                 */
                walls: Phaser.Types.Physics.Matter.MatterWalls;

                /**
                 * A flag that toggles if the world is enabled or not.
                 */
                enabled: boolean;

                /**
                 * This function is called every time the core game loop steps, which is bound to the
                 * Request Animation Frame frequency unless otherwise modified.
                 * 
                 * The function is passed two values: `time` and `delta`, both of which come from the game step values.
                 * 
                 * It must return a number. This number is used as the delta value passed to Matter.Engine.update.
                 * 
                 * You can override this function with your own to define your own timestep.
                 * 
                 * If you need to update the Engine multiple times in a single game step then call
                 * `World.update` as many times as required. Each call will trigger the `getDelta` function.
                 * If you wish to have full control over when the Engine updates then see the property `autoUpdate`.
                 * 
                 * You can also adjust the number of iterations that Engine.update performs.
                 * Use the Scene Matter Physics config object to set the following properties:
                 * 
                 * positionIterations (defaults to 6)
                 * velocityIterations (defaults to 4)
                 * constraintIterations (defaults to 2)
                 * 
                 * Adjusting these values can help performance in certain situations, depending on the physics requirements
                 * of your game.
                 */
                getDelta: Function;

                /**
                 * The Matter JS Runner Configuration object.
                 * 
                 * This object is populated via the Matter Configuration object's `runner` property and is
                 * updated constantly during the game step.
                 */
                runner: Phaser.Types.Physics.Matter.MatterRunnerConfig;

                /**
                 * Automatically call Engine.update every time the game steps.
                 * If you disable this then you are responsible for calling `World.step` directly from your game.
                 * If you call `set60Hz` or `set30Hz` then `autoUpdate` is reset to `true`.
                 */
                autoUpdate: boolean;

                /**
                 * A flag that controls if the debug graphics will be drawn to or not.
                 */
                drawDebug: boolean;

                /**
                 * An instance of the Graphics object the debug bodies are drawn to, if enabled.
                 */
                debugGraphic: Phaser.GameObjects.Graphics;

                /**
                 * The debug configuration object.
                 * 
                 * The values stored in this object are read from the Matter World Config `debug` property.
                 * 
                 * When a new Body or Constraint is _added to the World_, they are given the values stored in this object,
                 * unless they have their own `render` object set that will override them.
                 * 
                 * Note that while you can modify the values of properties in this object at run-time, it will not change
                 * any of the Matter objects _already added_. It will only impact objects newly added to the world, or one
                 * that is removed and then re-added at a later time.
                 */
                debugConfig: Phaser.Types.Physics.Matter.MatterDebugConfig;

                /**
                 * Sets the debug render style for the children of the given Matter Composite.
                 * 
                 * Composites themselves do not render, but they can contain bodies, constraints and other composites that may do.
                 * So the children of this composite are passed to the `setBodyRenderStyle`, `setCompositeRenderStyle` and
                 * `setConstraintRenderStyle` methods accordingly.
                 * @param composite The Matter Composite to set the render style on.
                 */
                setCompositeRenderStyle(composite: MatterJS.CompositeType): this;

                /**
                 * Sets the debug render style for the given Matter Body.
                 * 
                 * If you are using this on a Phaser Game Object, such as a Matter Sprite, then pass in the body property
                 * to this method, not the Game Object itself.
                 * 
                 * If you wish to skip a parameter, so it retains its current value, pass `false` for it.
                 * 
                 * If you wish to reset the Body render colors to the defaults found in the World Debug Config, then call
                 * this method with just the `body` parameter provided and no others.
                 * @param body The Matter Body to set the render style on.
                 * @param lineColor The line color. If `null` it will use the World Debug Config value.
                 * @param lineOpacity The line opacity, between 0 and 1. If `null` it will use the World Debug Config value.
                 * @param lineThickness The line thickness. If `null` it will use the World Debug Config value.
                 * @param fillColor The fill color. If `null` it will use the World Debug Config value.
                 * @param fillOpacity The fill opacity, between 0 and 1. If `null` it will use the World Debug Config value.
                 */
                setBodyRenderStyle(body: MatterJS.BodyType, lineColor?: number, lineOpacity?: number, lineThickness?: number, fillColor?: number, fillOpacity?: number): this;

                /**
                 * Sets the debug render style for the given Matter Constraint.
                 * 
                 * If you are using this on a Phaser Game Object, then pass in the body property
                 * to this method, not the Game Object itself.
                 * 
                 * If you wish to skip a parameter, so it retains its current value, pass `false` for it.
                 * 
                 * If you wish to reset the Constraint render colors to the defaults found in the World Debug Config, then call
                 * this method with just the `constraint` parameter provided and no others.
                 * @param constraint The Matter Constraint to set the render style on.
                 * @param lineColor The line color. If `null` it will use the World Debug Config value.
                 * @param lineOpacity The line opacity, between 0 and 1. If `null` it will use the World Debug Config value.
                 * @param lineThickness The line thickness. If `null` it will use the World Debug Config value.
                 * @param pinSize If this constraint is a pin, this sets the size of the pin circle. If `null` it will use the World Debug Config value.
                 * @param anchorColor The color used when rendering this constraints anchors.  If `null` it will use the World Debug Config value.
                 * @param anchorSize The size of the anchor circle, if this constraint has anchors. If `null` it will use the World Debug Config value.
                 */
                setConstraintRenderStyle(constraint: MatterJS.ConstraintType, lineColor?: number, lineOpacity?: number, lineThickness?: number, pinSize?: number, anchorColor?: number, anchorSize?: number): this;

                /**
                 * This internal method acts as a proxy between all of the Matter JS events and then re-emits them
                 * via this class.
                 */
                setEventsProxy(): void;

                /**
                 * Sets the bounds of the Physics world to match the given world pixel dimensions.
                 * 
                 * You can optionally set which 'walls' to create: left, right, top or bottom.
                 * If none of the walls are given it will default to use the walls settings it had previously.
                 * I.e. if you previously told it to not have the left or right walls, and you then adjust the world size
                 * the newly created bounds will also not have the left and right walls.
                 * Explicitly state them in the parameters to override this.
                 * @param x The x coordinate of the top-left corner of the bounds. Default 0.
                 * @param y The y coordinate of the top-left corner of the bounds. Default 0.
                 * @param width The width of the bounds.
                 * @param height The height of the bounds.
                 * @param thickness The thickness of each wall, in pixels. Default 64.
                 * @param left If true will create the left bounds wall. Default true.
                 * @param right If true will create the right bounds wall. Default true.
                 * @param top If true will create the top bounds wall. Default true.
                 * @param bottom If true will create the bottom bounds wall. Default true.
                 */
                setBounds(x?: number, y?: number, width?: number, height?: number, thickness?: number, left?: boolean, right?: boolean, top?: boolean, bottom?: boolean): Phaser.Physics.Matter.World;

                /**
                 * Updates the 4 rectangle bodies that were created, if `setBounds` was set in the Matter config, to use
                 * the new positions and sizes. This method is usually only called internally via the `setBounds` method.
                 * @param add `true` if the walls are being added or updated, `false` to remove them from the world.
                 * @param position Either `left`, `right`, `top` or `bottom`. Only optional if `add` is `false`.
                 * @param x The horizontal position to place the walls at. Only optional if `add` is `false`.
                 * @param y The vertical position to place the walls at. Only optional if `add` is `false`.
                 * @param width The width of the walls, in pixels. Only optional if `add` is `false`.
                 * @param height The height of the walls, in pixels. Only optional if `add` is `false`.
                 */
                updateWall(add: boolean, position?: string, x?: number, y?: number, width?: number, height?: number): void;

                /**
                 * Creates a Phaser.GameObjects.Graphics object that is used to render all of the debug bodies and joints to.
                 * 
                 * This method is called automatically by the constructor, if debugging has been enabled.
                 * 
                 * The created Graphics object is automatically added to the Scene at 0x0 and given a depth of `Number.MAX_VALUE`,
                 * so it renders above all else in the Scene.
                 * 
                 * The Graphics object is assigned to the `debugGraphic` property of this class and `drawDebug` is enabled.
                 */
                createDebugGraphic(): Phaser.GameObjects.Graphics;

                /**
                 * Sets the world gravity and gravity scale to 0.
                 */
                disableGravity(): this;

                /**
                 * Sets the worlds gravity to the values given.
                 * 
                 * Gravity effects all bodies in the world, unless they have the `ignoreGravity` flag set.
                 * @param x The world gravity x component. Default 0.
                 * @param y The world gravity y component. Default 1.
                 * @param scale The gravity scale factor. Default 0.001.
                 */
                setGravity(x?: number, y?: number, scale?: number): this;

                /**
                 * Creates a rectangle Matter body and adds it to the world.
                 * @param x The horizontal position of the body in the world.
                 * @param y The vertical position of the body in the world.
                 * @param width The width of the body.
                 * @param height The height of the body.
                 * @param options Optional Matter configuration object.
                 */
                create(x: number, y: number, width: number, height: number, options: object): MatterJS.BodyType;

                /**
                 * Adds a Matter JS object, or array of objects, to the world.
                 * 
                 * The objects should be valid Matter JS entities, such as a Body, Composite or Constraint.
                 * 
                 * Triggers `beforeAdd` and `afterAdd` events.
                 * @param object Can be single object, or an array, and can be a body, composite or constraint.
                 */
                add(object: object | object[]): this;

                /**
                 * Removes a Matter JS object, or array of objects, from the world.
                 * 
                 * The objects should be valid Matter JS entities, such as a Body, Composite or Constraint.
                 * 
                 * Triggers `beforeRemove` and `afterRemove` events.
                 * @param object Can be single object, or an array, and can be a body, composite or constraint.
                 * @param deep Optionally search the objects children and recursively remove those as well. Default false.
                 */
                remove(object: object | object[], deep?: boolean): this;

                /**
                 * Removes a Matter JS constraint, or array of constraints, from the world.
                 * 
                 * Triggers `beforeRemove` and `afterRemove` events.
                 * @param constraint A Matter JS Constraint, or an array of constraints, to be removed.
                 * @param deep Optionally search the objects children and recursively remove those as well. Default false.
                 */
                removeConstraint(constraint: MatterJS.ConstraintType | MatterJS.ConstraintType[], deep?: boolean): this;

                /**
                 * Adds `MatterTileBody` instances for all the colliding tiles within the given tilemap layer.
                 * 
                 * Set the appropriate tiles in your layer to collide before calling this method!
                 * 
                 * If you modify the map after calling this method, i.e. via a function like `putTileAt` then
                 * you should call the `Phaser.Physics.Matter.World.convertTiles` function directly, passing
                 * it an array of the tiles you've added to your map.
                 * @param tilemapLayer An array of tiles.
                 * @param options Options to be passed to the MatterTileBody constructor. {@see Phaser.Physics.Matter.TileBody}
                 */
                convertTilemapLayer(tilemapLayer: Phaser.Tilemaps.TilemapLayer, options?: object): this;

                /**
                 * Creates `MatterTileBody` instances for all of the given tiles. This creates bodies regardless of whether the
                 * tiles are set to collide or not, or if they have a body already, or not.
                 * 
                 * If you wish to pass an array of tiles that may already have bodies, you should filter the array before hand.
                 * @param tiles An array of tiles.
                 * @param options Options to be passed to the MatterTileBody constructor. {@see Phaser.Physics.Matter.TileBody}
                 */
                convertTiles(tiles: Phaser.Tilemaps.Tile[], options?: object): this;

                /**
                 * Returns the next unique group index for which bodies will collide.
                 * If `isNonColliding` is `true`, returns the next unique group index for which bodies will not collide.
                 * @param isNonColliding If `true`, returns the next unique group index for which bodies will _not_ collide. Default false.
                 */
                nextGroup(isNonColliding?: boolean): number;

                /**
                 * Returns the next unique category bitfield (starting after the initial default category 0x0001).
                 * There are 32 available.
                 */
                nextCategory(): number;

                /**
                 * Pauses this Matter World instance and sets `enabled` to `false`.
                 * 
                 * A paused world will not run any simulations for the duration it is paused.
                 */
                pause(): this;

                /**
                 * Resumes this Matter World instance from a paused state and sets `enabled` to `true`.
                 */
                resume(): this;

                /**
                 * The internal update method. This is called automatically by the parent Scene.
                 * 
                 * Moves the simulation forward in time by delta ms. Uses `World.correction` value as an optional number that
                 * specifies the time correction factor to apply to the update. This can help improve the accuracy of the
                 * simulation in cases where delta is changing between updates. The value of correction is defined as `delta / lastDelta`,
                 * i.e. the percentage change of delta over the last step. Therefore the value is always 1 (no correction) when
                 * delta is constant (or when no correction is desired, which is the default).
                 * See the paper on Time Corrected Verlet for more information.
                 * 
                 * Triggers `beforeUpdate` and `afterUpdate` events. Triggers `collisionStart`, `collisionActive` and `collisionEnd` events.
                 * 
                 * If the World is paused, `update` is still run, but exits early and does not update the Matter Engine.
                 * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
                 * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
                 */
                update(time: number, delta: number): void;

                /**
                 * Manually advances the physics simulation by one iteration.
                 * 
                 * You can optionally pass in the `delta` and `correction` values to be used by Engine.update.
                 * If undefined they use the Matter defaults of 60Hz and no correction.
                 * 
                 * Calling `step` directly bypasses any checks of `enabled` or `autoUpdate`.
                 * 
                 * It also ignores any custom `getDelta` functions, as you should be passing the delta
                 * value in to this call.
                 * 
                 * You can adjust the number of iterations that Engine.update performs internally.
                 * Use the Scene Matter Physics config object to set the following properties:
                 * 
                 * positionIterations (defaults to 6)
                 * velocityIterations (defaults to 4)
                 * constraintIterations (defaults to 2)
                 * 
                 * Adjusting these values can help performance in certain situations, depending on the physics requirements
                 * of your game.
                 * @param delta The delta value. Default 16.666.
                 */
                step(delta?: number): void;

                /**
                 * Runs the Matter Engine.update at a fixed timestep of 60Hz.
                 */
                update60Hz(): number;

                /**
                 * Runs the Matter Engine.update at a fixed timestep of 30Hz.
                 */
                update30Hz(): number;

                /**
                 * Returns `true` if the given body can be found within the World.
                 * @param body The Matter Body, or Game Object, to search for within the world.
                 */
                has(body: MatterJS.Body | Phaser.GameObjects.GameObject): MatterJS.BodyType[];

                /**
                 * Returns all the bodies in the Matter World, including all bodies in children, recursively.
                 */
                getAllBodies(): MatterJS.BodyType[];

                /**
                 * Returns all the constraints in the Matter World, including all constraints in children, recursively.
                 */
                getAllConstraints(): MatterJS.ConstraintType[];

                /**
                 * Returns all the composites in the Matter World, including all composites in children, recursively.
                 */
                getAllComposites(): MatterJS.CompositeType[];

                /**
                 * Renders the Engine Broadphase Controller Grid to the given Graphics instance.
                 * 
                 * The debug renderer calls this method if the `showBroadphase` config value is set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render the Grid to your own Graphics instance.
                 * @param grid The Matter Grid to be rendered.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 */
                renderGrid(grid: MatterJS.Grid, graphics: Phaser.GameObjects.Graphics, lineColor: number, lineOpacity: number): this;

                /**
                 * Renders the list of Pair separations to the given Graphics instance.
                 * 
                 * The debug renderer calls this method if the `showSeparations` config value is set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render the Grid to your own Graphics instance.
                 * @param pairs An array of Matter Pairs to be rendered.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 */
                renderSeparations(pairs: MatterJS.Pair[], graphics: Phaser.GameObjects.Graphics, lineColor: number): this;

                /**
                 * Renders the list of collision points and normals to the given Graphics instance.
                 * 
                 * The debug renderer calls this method if the `showCollisions` config value is set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render the Grid to your own Graphics instance.
                 * @param pairs An array of Matter Pairs to be rendered.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 */
                renderCollisions(pairs: MatterJS.Pair[], graphics: Phaser.GameObjects.Graphics, lineColor: number): this;

                /**
                 * Renders the bounds of an array of Bodies to the given Graphics instance.
                 * 
                 * If the body is a compound body, it will render the bounds for the parent compound.
                 * 
                 * The debug renderer calls this method if the `showBounds` config value is set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render bounds to your own Graphics instance.
                 * @param bodies An array of bodies from the localWorld.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 */
                renderBodyBounds(bodies: any[], graphics: Phaser.GameObjects.Graphics, lineColor: number, lineOpacity: number): void;

                /**
                 * Renders either all axes, or a single axis indicator, for an array of Bodies, to the given Graphics instance.
                 * 
                 * The debug renderer calls this method if the `showAxes` or `showAngleIndicator` config values are set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render bounds to your own Graphics instance.
                 * @param bodies An array of bodies from the localWorld.
                 * @param graphics The Graphics object to render to.
                 * @param showAxes If `true` it will render all body axes. If `false` it will render a single axis indicator.
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 */
                renderBodyAxes(bodies: any[], graphics: Phaser.GameObjects.Graphics, showAxes: boolean, lineColor: number, lineOpacity: number): void;

                /**
                 * Renders a velocity indicator for an array of Bodies, to the given Graphics instance.
                 * 
                 * The debug renderer calls this method if the `showVelocity` config value is set.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render bounds to your own Graphics instance.
                 * @param bodies An array of bodies from the localWorld.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 * @param lineThickness The line thickness.
                 */
                renderBodyVelocity(bodies: any[], graphics: Phaser.GameObjects.Graphics, lineColor: number, lineOpacity: number, lineThickness: number): void;

                /**
                 * Renders a single Matter Body to the given Phaser Graphics Game Object.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render a Body to your own Graphics instance.
                 * 
                 * If you don't wish to render a line around the body, set the `lineColor` parameter to `null`.
                 * Equally, if you don't wish to render a fill, set the `fillColor` parameter to `null`.
                 * @param body The Matter Body to be rendered.
                 * @param graphics The Graphics object to render to.
                 * @param showInternalEdges Render internal edges of the polygon?
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 * @param lineThickness The line thickness. Default 1.
                 * @param fillColor The fill color.
                 * @param fillOpacity The fill opacity, between 0 and 1.
                 */
                renderBody(body: MatterJS.BodyType, graphics: Phaser.GameObjects.Graphics, showInternalEdges: boolean, lineColor?: number, lineOpacity?: number, lineThickness?: number, fillColor?: number, fillOpacity?: number): this;

                /**
                 * Renders the Convex Hull for a single Matter Body to the given Phaser Graphics Game Object.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render a Body hull to your own Graphics instance.
                 * @param body The Matter Body to be rendered.
                 * @param graphics The Graphics object to render to.
                 * @param hullColor The color used to render the hull.
                 * @param lineThickness The hull line thickness. Default 1.
                 */
                renderConvexHull(body: MatterJS.BodyType, graphics: Phaser.GameObjects.Graphics, hullColor: number, lineThickness?: number): this;

                /**
                 * Renders a single Matter Constraint, such as a Pin or a Spring, to the given Phaser Graphics Game Object.
                 * 
                 * This method is used internally by the Matter Debug Renderer, but is also exposed publically should
                 * you wish to render a Constraint to your own Graphics instance.
                 * @param constraint The Matter Constraint to render.
                 * @param graphics The Graphics object to render to.
                 * @param lineColor The line color.
                 * @param lineOpacity The line opacity, between 0 and 1.
                 * @param lineThickness The line thickness.
                 * @param pinSize If this constraint is a pin, this sets the size of the pin circle.
                 * @param anchorColor The color used when rendering this constraints anchors. Set to `null` to not render anchors.
                 * @param anchorSize The size of the anchor circle, if this constraint has anchors and is rendering them.
                 */
                renderConstraint(constraint: MatterJS.ConstraintType, graphics: Phaser.GameObjects.Graphics, lineColor: number, lineOpacity: number, lineThickness: number, pinSize: number, anchorColor: number, anchorSize: number): this;

                /**
                 * Resets the internal collision IDs that Matter.JS uses for Body collision groups.
                 * 
                 * You should call this before destroying your game if you need to restart the game
                 * again on the same page, without first reloading the page. Or, if you wish to
                 * consistently destroy a Scene that contains Matter.js and then run it again
                 * later in the same game.
                 */
                resetCollisionIDs(): void;

                /**
                 * Will remove all Matter physics event listeners and clear the matter physics world,
                 * engine and any debug graphics, if any.
                 */
                shutdown(): void;

                /**
                 * Will remove all Matter physics event listeners and clear the matter physics world,
                 * engine and any debug graphics, if any.
                 * 
                 * After destroying the world it cannot be re-used again.
                 */
                destroy(): void;

            }

        }

    }

    namespace Plugins {
        /**
         * A Global Plugin is installed just once into the Game owned Plugin Manager.
         * It can listen for Game events and respond to them.
         */
        class BasePlugin {
            /**
             * 
             * @param pluginManager A reference to the Plugin Manager.
             */
            constructor(pluginManager: Phaser.Plugins.PluginManager);

            /**
             * A handy reference to the Plugin Manager that is responsible for this plugin.
             * Can be used as a route to gain access to game systems and  events.
             */
            protected pluginManager: Phaser.Plugins.PluginManager;

            /**
             * A reference to the Game instance this plugin is running under.
             */
            protected game: Phaser.Game;

            /**
             * The PluginManager calls this method on a Global Plugin when the plugin is first instantiated.
             * It will never be called again on this instance.
             * In here you can set-up whatever you need for this plugin to run.
             * If a plugin is set to automatically start then `BasePlugin.start` will be called immediately after this.
             * On a Scene Plugin, this method is never called. Use {@link Phaser.Plugins.ScenePlugin#boot} instead.
             * @param data A value specified by the user, if any, from the `data` property of the plugin's configuration object (if started at game boot) or passed in the PluginManager's `install` method (if started manually).
             */
            init(data?: any | undefined): void;

            /**
             * The PluginManager calls this method on a Global Plugin when the plugin is started.
             * If a plugin is stopped, and then started again, this will get called again.
             * Typically called immediately after `BasePlugin.init`.
             * On a Scene Plugin, this method is never called.
             */
            start(): void;

            /**
             * The PluginManager calls this method on a Global Plugin when the plugin is stopped.
             * The game code has requested that your plugin stop doing whatever it does.
             * It is now considered as 'inactive' by the PluginManager.
             * Handle that process here (i.e. stop listening for events, etc)
             * If the plugin is started again then `BasePlugin.start` will be called again.
             * On a Scene Plugin, this method is never called.
             */
            stop(): void;

            /**
             * Game instance has been destroyed.
             * You must release everything in here, all references, all objects, free it all up.
             */
            destroy(): void;

        }

        /**
         * The Default Plugins.
         */
        namespace DefaultPlugins {
            /**
             * These are the Global Managers that are created by the Phaser.Game instance.
             * They are referenced from Scene.Systems so that plugins can use them.
             */
            var Global: any[];

            /**
             * These are the core plugins that are installed into every Scene.Systems instance, no matter what.
             * They are optionally exposed in the Scene as well (see the InjectionMap for details)
             * 
             * They are created in the order in which they appear in this array and EventEmitter is always first.
             */
            var CoreScene: any[];

            /**
             * These plugins are created in Scene.Systems in addition to the CoreScenePlugins.
             * 
             * You can elect not to have these plugins by either creating a DefaultPlugins object as part
             * of the Game Config, by creating a Plugins object as part of a Scene Config, or by modifying this array
             * and building your own bundle.
             * 
             * They are optionally exposed in the Scene as well (see the InjectionMap for details)
             * 
             * They are always created in the order in which they appear in the array.
             */
            var DefaultScene: any[];

        }

        namespace PluginCache {
            /**
             * Static method called directly by the Core internal Plugins.
             * Key is a reference used to get the plugin from the plugins object (i.e. InputPlugin)
             * Plugin is the object to instantiate to create the plugin
             * Mapping is what the plugin is injected into the Scene.Systems as (i.e. input)
             * @param key A reference used to get this plugin from the plugin cache.
             * @param plugin The plugin to be stored. Should be the core object, not instantiated.
             * @param mapping If this plugin is to be injected into the Scene Systems, this is the property key map used.
             * @param custom Core Scene plugin or a Custom Scene plugin? Default false.
             */
            function register(key: string, plugin: Function, mapping: string, custom?: boolean): void;

            /**
             * Stores a custom plugin in the global plugin cache.
             * The key must be unique, within the scope of the cache.
             * @param key A reference used to get this plugin from the plugin cache.
             * @param plugin The plugin to be stored. Should be the core object, not instantiated.
             * @param mapping If this plugin is to be injected into the Scene Systems, this is the property key map used.
             * @param data A value to be passed to the plugin's `init` method.
             */
            function registerCustom(key: string, plugin: Function, mapping: string, data: any | undefined): void;

            /**
             * Checks if the given key is already being used in the core plugin cache.
             * @param key The key to check for.
             */
            function hasCore(key: string): boolean;

            /**
             * Checks if the given key is already being used in the custom plugin cache.
             * @param key The key to check for.
             */
            function hasCustom(key: string): boolean;

            /**
             * Returns the core plugin object from the cache based on the given key.
             * @param key The key of the core plugin to get.
             */
            function getCore(key: string): Phaser.Types.Plugins.CorePluginContainer;

            /**
             * Returns the custom plugin object from the cache based on the given key.
             * @param key The key of the custom plugin to get.
             */
            function getCustom(key: string): Phaser.Types.Plugins.CustomPluginContainer;

            /**
             * Returns an object from the custom cache based on the given key that can be instantiated.
             * @param key The key of the custom plugin to get.
             */
            function getCustomClass(key: string): Function;

            /**
             * Removes a core plugin based on the given key.
             * @param key The key of the core plugin to remove.
             */
            function remove(key: string): void;

            /**
             * Removes a custom plugin based on the given key.
             * @param key The key of the custom plugin to remove.
             */
            function removeCustom(key: string): void;

            /**
             * Removes all Core Plugins.
             * 
             * This includes all of the internal system plugins that Phaser needs, like the Input Plugin and Loader Plugin.
             * So be sure you only call this if you do not wish to run Phaser again.
             */
            function destroyCorePlugins(): void;

            /**
             * Removes all Custom Plugins.
             */
            function destroyCustomPlugins(): void;

        }

        /**
         * The PluginManager is responsible for installing and adding plugins to Phaser.
         * 
         * It is a global system and therefore belongs to the Game instance, not a specific Scene.
         * 
         * It works in conjunction with the PluginCache. Core internal plugins automatically register themselves
         * with the Cache, but it's the Plugin Manager that is responsible for injecting them into the Scenes.
         * 
         * There are two types of plugin:
         * 
         * 1. A Global Plugin
         * 2. A Scene Plugin
         * 
         * A Global Plugin is a plugin that lives within the Plugin Manager rather than a Scene. You can get
         * access to it by calling `PluginManager.get` and providing a key. Any Scene that requests a plugin in
         * this way will all get access to the same plugin instance, allowing you to use a single plugin across
         * multiple Scenes.
         * 
         * A Scene Plugin is a plugin dedicated to running within a Scene. These are different to Global Plugins
         * in that their instances do not live within the Plugin Manager, but within the Scene Systems class instead.
         * And that every Scene created is given its own unique instance of a Scene Plugin. Examples of core Scene
         * Plugins include the Input Plugin, the Tween Plugin and the physics Plugins.
         * 
         * You can add a plugin to Phaser in three different ways:
         * 
         * 1. Preload it
         * 2. Include it in your source code and install it via the Game Config
         * 3. Include it in your source code and install it within a Scene
         * 
         * For examples of all of these approaches please see the Phaser 3 Examples Repo `plugins` folder.
         * 
         * For information on creating your own plugin please see the Phaser 3 Plugin Template.
         */
        class PluginManager {
            /**
             * 
             * @param game The game instance that owns this Plugin Manager.
             */
            constructor(game: Phaser.Game);

            /**
             * The game instance that owns this Plugin Manager.
             */
            game: Phaser.Game;

            /**
             * The global plugins currently running and managed by this Plugin Manager.
             * A plugin must have been started at least once in order to appear in this list.
             */
            plugins: Phaser.Types.Plugins.GlobalPlugin[];

            /**
             * A list of plugin keys that should be installed into Scenes as well as the Core Plugins.
             */
            scenePlugins: string[];

            /**
             * Run once the game has booted and installs all of the plugins configured in the Game Config.
             */
            protected boot(): void;

            /**
             * Called by the Scene Systems class. Tells the plugin manager to install all Scene plugins into it.
             * 
             * First it will install global references, i.e. references from the Game systems into the Scene Systems (and Scene if mapped.)
             * Then it will install Core Scene Plugins followed by Scene Plugins registered with the PluginManager.
             * Finally it will install any references to Global Plugins that have a Scene mapping property into the Scene itself.
             * @param sys The Scene Systems class to install all the plugins in to.
             * @param globalPlugins An array of global plugins to install.
             * @param scenePlugins An array of scene plugins to install.
             */
            protected addToScene(sys: Phaser.Scenes.Systems, globalPlugins: any[], scenePlugins: any[]): void;

            /**
             * Called by the Scene Systems class. Returns a list of plugins to be installed.
             */
            protected getDefaultScenePlugins(): string[];

            /**
             * Installs a new Scene Plugin into the Plugin Manager and optionally adds it
             * to the given Scene as well. A Scene Plugin added to the manager in this way
             * will be automatically installed into all new Scenes using the key and mapping given.
             * 
             * The `key` property is what the plugin is injected into Scene.Systems as.
             * The `mapping` property is optional, and if specified is what the plugin is installed into
             * the Scene as. For example:
             * 
             * ```javascript
             * this.plugins.installScenePlugin('powerupsPlugin', pluginCode, 'powerups');
             * 
             * // and from within the scene:
             * this.sys.powerupsPlugin; // key value
             * this.powerups; // mapping value
             * ```
             * 
             * This method is called automatically by Phaser if you install your plugins using either the
             * Game Configuration object, or by preloading them via the Loader.
             * @param key The property key that will be used to add this plugin to Scene.Systems.
             * @param plugin The plugin code. This should be the non-instantiated version.
             * @param mapping If this plugin is injected into the Phaser.Scene class, this is the property key to use.
             * @param addToScene Optionally automatically add this plugin to the given Scene.
             * @param fromLoader Is this being called by the Loader? Default false.
             */
            installScenePlugin(key: string, plugin: Function, mapping?: string, addToScene?: Phaser.Scene, fromLoader?: boolean): void;

            /**
             * Installs a new Global Plugin into the Plugin Manager and optionally starts it running.
             * A global plugin belongs to the Plugin Manager, rather than a specific Scene, and can be accessed
             * and used by all Scenes in your game.
             * 
             * The `key` property is what you use to access this plugin from the Plugin Manager.
             * 
             * ```javascript
             * this.plugins.install('powerupsPlugin', pluginCode);
             * 
             * // and from within the scene:
             * this.plugins.get('powerupsPlugin');
             * ```
             * 
             * This method is called automatically by Phaser if you install your plugins using either the
             * Game Configuration object, or by preloading them via the Loader.
             * 
             * The same plugin can be installed multiple times into the Plugin Manager by simply giving each
             * instance its own unique key.
             * @param key The unique handle given to this plugin within the Plugin Manager.
             * @param plugin The plugin code. This should be the non-instantiated version.
             * @param start Automatically start the plugin running? This is always `true` if you provide a mapping value. Default false.
             * @param mapping If this plugin is injected into the Phaser.Scene class, this is the property key to use.
             * @param data A value passed to the plugin's `init` method.
             */
            install(key: string, plugin: Function, start?: boolean, mapping?: string, data?: any): Phaser.Plugins.BasePlugin | null;

            /**
             * Gets an index of a global plugin based on the given key.
             * @param key The unique plugin key.
             */
            protected getIndex(key: string): number;

            /**
             * Gets a global plugin based on the given key.
             * @param key The unique plugin key.
             */
            protected getEntry(key: string): Phaser.Types.Plugins.GlobalPlugin;

            /**
             * Checks if the given global plugin, based on its key, is active or not.
             * @param key The unique plugin key.
             */
            isActive(key: string): boolean;

            /**
             * Starts a global plugin running.
             * 
             * If the plugin was previously active then calling `start` will reset it to an active state and then
             * call its `start` method.
             * 
             * If the plugin has never been run before a new instance of it will be created within the Plugin Manager,
             * its active state set and then both of its `init` and `start` methods called, in that order.
             * 
             * If the plugin is already running under the given key then nothing happens.
             * @param key The key of the plugin to start.
             * @param runAs Run the plugin under a new key. This allows you to run one plugin multiple times.
             */
            start(key: string, runAs?: string): Phaser.Plugins.BasePlugin | null;

            /**
             * Stops a global plugin from running.
             * 
             * If the plugin is active then its active state will be set to false and the plugins `stop` method
             * will be called.
             * 
             * If the plugin is not already running, nothing will happen.
             * @param key The key of the plugin to stop.
             */
            stop(key: string): this;

            /**
             * Gets a global plugin from the Plugin Manager based on the given key and returns it.
             * 
             * If it cannot find an active plugin based on the key, but there is one in the Plugin Cache with the same key,
             * then it will create a new instance of the cached plugin and return that.
             * @param key The key of the plugin to get.
             * @param autoStart Automatically start a new instance of the plugin if found in the cache, but not actively running. Default true.
             */
            get(key: string, autoStart?: boolean): Phaser.Plugins.BasePlugin | Function | null;

            /**
             * Returns the plugin class from the cache.
             * Used internally by the Plugin Manager.
             * @param key The key of the plugin to get.
             */
            getClass(key: string): Phaser.Plugins.BasePlugin;

            /**
             * Removes a global plugin from the Plugin Manager and Plugin Cache.
             * 
             * It is up to you to remove all references to this plugin that you may hold within your game code.
             * @param key The key of the plugin to remove.
             */
            removeGlobalPlugin(key: string): void;

            /**
             * Removes a scene plugin from the Plugin Manager and Plugin Cache.
             * 
             * This will not remove the plugin from any active Scenes that are already using it.
             * 
             * It is up to you to remove all references to this plugin that you may hold within your game code.
             * @param key The key of the plugin to remove.
             */
            removeScenePlugin(key: string): void;

            /**
             * Registers a new type of Game Object with the global Game Object Factory and / or Creator.
             * This is usually called from within your Plugin code and is a helpful short-cut for creating
             * new Game Objects.
             * 
             * The key is the property that will be injected into the factories and used to create the
             * Game Object. For example:
             * 
             * ```javascript
             * this.plugins.registerGameObject('clown', clownFactoryCallback, clownCreatorCallback);
             * // later in your game code:
             * this.add.clown();
             * this.make.clown();
             * ```
             * 
             * The callbacks are what are called when the factories try to create a Game Object
             * matching the given key. It's important to understand that the callbacks are invoked within
             * the context of the GameObjectFactory. In this context there are several properties available
             * to use:
             * 
             * this.scene - A reference to the Scene that owns the GameObjectFactory.
             * this.displayList - A reference to the Display List the Scene owns.
             * this.updateList - A reference to the Update List the Scene owns.
             * 
             * See the GameObjectFactory and GameObjectCreator classes for more details.
             * Any public property or method listed is available from your callbacks under `this`.
             * @param key The key of the Game Object that the given callbacks will create, i.e. `image`, `sprite`.
             * @param factoryCallback The callback to invoke when the Game Object Factory is called.
             * @param creatorCallback The callback to invoke when the Game Object Creator is called.
             */
            registerGameObject(key: string, factoryCallback?: Function, creatorCallback?: Function): void;

            /**
             * Removes a previously registered Game Object from the global Game Object Factory and / or Creator.
             * This is usually called from within your Plugin destruction code to help clean-up after your plugin has been removed.
             * @param key The key of the Game Object to be removed from the factories.
             * @param removeFromFactory Should the Game Object be removed from the Game Object Factory? Default true.
             * @param removeFromCreator Should the Game Object be removed from the Game Object Creator? Default true.
             */
            removeGameObject(key: string, removeFromFactory?: boolean, removeFromCreator?: boolean): void;

            /**
             * Registers a new file type with the global File Types Manager, making it available to all Loader
             * Plugins created after this.
             * 
             * This is usually called from within your Plugin code and is a helpful short-cut for creating
             * new loader file types.
             * 
             * The key is the property that will be injected into the Loader Plugin and used to load the
             * files. For example:
             * 
             * ```javascript
             * this.plugins.registerFileType('wad', doomWadLoaderCallback);
             * // later in your preload code:
             * this.load.wad();
             * ```
             * 
             * The callback is what is called when the loader tries to load a file  matching the given key.
             * It's important to understand that the callback is invoked within
             * the context of the LoaderPlugin. In this context there are several properties / methods available
             * to use:
             * 
             * this.addFile - A method to add the new file to the load queue.
             * this.scene - The Scene that owns the Loader Plugin instance.
             * 
             * See the LoaderPlugin class for more details. Any public property or method listed is available from
             * your callback under `this`.
             * @param key The key of the Game Object that the given callbacks will create, i.e. `image`, `sprite`.
             * @param callback The callback to invoke when the Game Object Factory is called.
             * @param addToScene Optionally add this file type into the Loader Plugin owned by the given Scene.
             */
            registerFileType(key: string, callback: Function, addToScene?: Phaser.Scene): void;

            /**
             * Destroys this Plugin Manager and all associated plugins.
             * It will iterate all plugins found and call their `destroy` methods.
             * 
             * The PluginCache will remove all custom plugins.
             */
            destroy(): void;

        }

        /**
         * A Scene Level Plugin is installed into every Scene and belongs to that Scene.
         * It can listen for Scene events and respond to them.
         * It can map itself to a Scene property, or into the Scene Systems, or both.
         */
        class ScenePlugin extends Phaser.Plugins.BasePlugin {
            /**
             * 
             * @param scene A reference to the Scene that has installed this plugin.
             * @param pluginManager A reference to the Plugin Manager.
             * @param pluginKey The key under which this plugin has been installed into the Scene Systems.
             */
            constructor(scene: Phaser.Scene, pluginManager: Phaser.Plugins.PluginManager, pluginKey: string);

            /**
             * A reference to the Scene that has installed this plugin.
             * Only set if it's a Scene Plugin, otherwise `null`.
             * This property is only set when the plugin is instantiated and added to the Scene, not before.
             * You can use it during the `boot` method.
             */
            protected scene: Phaser.Scene | null;

            /**
             * A reference to the Scene Systems of the Scene that has installed this plugin.
             * Only set if it's a Scene Plugin, otherwise `null`.
             * This property is only set when the plugin is instantiated and added to the Scene, not before.
             * You can use it during the `boot` method.
             */
            protected systems: Phaser.Scenes.Systems | null;

            /**
             * The key under which this plugin was installed into the Scene Systems.
             * 
             * This property is only set when the plugin is instantiated and added to the Scene, not before.
             * You can use it during the `boot` method.
             */
            readonly pluginKey: string;

            /**
             * This method is called when the Scene boots. It is only ever called once.
             * 
             * By this point the plugin properties `scene` and `systems` will have already been set.
             * 
             * In here you can listen for {@link Phaser.Scenes.Events Scene events} and set-up whatever you need for this plugin to run.
             * Here are the Scene events you can listen to:
             * 
             * - start
             * - ready
             * - preupdate
             * - update
             * - postupdate
             * - resize
             * - pause
             * - resume
             * - sleep
             * - wake
             * - transitioninit
             * - transitionstart
             * - transitioncomplete
             * - transitionout
             * - shutdown
             * - destroy
             * 
             * At the very least you should offer a destroy handler for when the Scene closes down, i.e:
             * 
             * ```javascript
             * var eventEmitter = this.systems.events;
             * eventEmitter.once('destroy', this.sceneDestroy, this);
             * ```
             */
            boot(): void;

            /**
             * Game instance has been destroyed.
             * 
             * You must release everything in here, all references, all objects, free it all up.
             */
            destroy(): void;

        }

    }

    /**
     * Phaser Blend Modes.
     */
    enum BlendModes {
        /**
         * Skips the Blend Mode check in the renderer.
         */
        SKIP_CHECK,
        /**
         * Normal blend mode. For Canvas and WebGL.
         * This is the default setting and draws new shapes on top of the existing canvas content.
         */
        NORMAL,
        /**
         * Add blend mode. For Canvas and WebGL.
         * Where both shapes overlap the color is determined by adding color values.
         */
        ADD,
        /**
         * Multiply blend mode. For Canvas and WebGL.
         * The pixels are of the top layer are multiplied with the corresponding pixel of the bottom layer. A darker picture is the result.
         */
        MULTIPLY,
        /**
         * Screen blend mode. For Canvas and WebGL.
         * The pixels are inverted, multiplied, and inverted again. A lighter picture is the result (opposite of multiply)
         */
        SCREEN,
        /**
         * Overlay blend mode. For Canvas only.
         * A combination of multiply and screen. Dark parts on the base layer become darker, and light parts become lighter.
         */
        OVERLAY,
        /**
         * Darken blend mode. For Canvas only.
         * Retains the darkest pixels of both layers.
         */
        DARKEN,
        /**
         * Lighten blend mode. For Canvas only.
         * Retains the lightest pixels of both layers.
         */
        LIGHTEN,
        /**
         * Color Dodge blend mode. For Canvas only.
         * Divides the bottom layer by the inverted top layer.
         */
        COLOR_DODGE,
        /**
         * Color Burn blend mode. For Canvas only.
         * Divides the inverted bottom layer by the top layer, and then inverts the result.
         */
        COLOR_BURN,
        /**
         * Hard Light blend mode. For Canvas only.
         * A combination of multiply and screen like overlay, but with top and bottom layer swapped.
         */
        HARD_LIGHT,
        /**
         * Soft Light blend mode. For Canvas only.
         * A softer version of hard-light. Pure black or white does not result in pure black or white.
         */
        SOFT_LIGHT,
        /**
         * Difference blend mode. For Canvas only.
         * Subtracts the bottom layer from the top layer or the other way round to always get a positive value.
         */
        DIFFERENCE,
        /**
         * Exclusion blend mode. For Canvas only.
         * Like difference, but with lower contrast.
         */
        EXCLUSION,
        /**
         * Hue blend mode. For Canvas only.
         * Preserves the luma and chroma of the bottom layer, while adopting the hue of the top layer.
         */
        HUE,
        /**
         * Saturation blend mode. For Canvas only.
         * Preserves the luma and hue of the bottom layer, while adopting the chroma of the top layer.
         */
        SATURATION,
        /**
         * Color blend mode. For Canvas only.
         * Preserves the luma of the bottom layer, while adopting the hue and chroma of the top layer.
         */
        COLOR,
        /**
         * Luminosity blend mode. For Canvas only.
         * Preserves the hue and chroma of the bottom layer, while adopting the luma of the top layer.
         */
        LUMINOSITY,
        /**
         * Alpha erase blend mode. For Canvas and WebGL.
         */
        ERASE,
        /**
         * Source-in blend mode. For Canvas only.
         * The new shape is drawn only where both the new shape and the destination canvas overlap. Everything else is made transparent.
         */
        SOURCE_IN,
        /**
         * Source-out blend mode. For Canvas only.
         * The new shape is drawn where it doesn't overlap the existing canvas content.
         */
        SOURCE_OUT,
        /**
         * Source-out blend mode. For Canvas only.
         * The new shape is only drawn where it overlaps the existing canvas content.
         */
        SOURCE_ATOP,
        /**
         * Destination-over blend mode. For Canvas only.
         * New shapes are drawn behind the existing canvas content.
         */
        DESTINATION_OVER,
        /**
         * Destination-in blend mode. For Canvas only.
         * The existing canvas content is kept where both the new shape and existing canvas content overlap. Everything else is made transparent.
         */
        DESTINATION_IN,
        /**
         * Destination-out blend mode. For Canvas only.
         * The existing content is kept where it doesn't overlap the new shape.
         */
        DESTINATION_OUT,
        /**
         * Destination-out blend mode. For Canvas only.
         * The existing canvas is only kept where it overlaps the new shape. The new shape is drawn behind the canvas content.
         */
        DESTINATION_ATOP,
        /**
         * Lighten blend mode. For Canvas only.
         * Where both shapes overlap the color is determined by adding color values.
         */
        LIGHTER,
        /**
         * Copy blend mode. For Canvas only.
         * Only the new shape is shown.
         */
        COPY,
        /**
         * Xor blend mode. For Canvas only.
         * Shapes are made transparent where both overlap and drawn normal everywhere else.
         */
        XOR,
    }

    namespace Renderer {
        namespace Canvas {
            /**
             * The Canvas Renderer is responsible for managing 2D canvas rendering contexts,
             * including the one used by the Games canvas. It tracks the internal state of a
             * given context and can renderer textured Game Objects to it, taking into
             * account alpha, blending, and scaling.
             */
            class CanvasRenderer extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param game The Phaser Game instance that owns this renderer.
                 */
                constructor(game: Phaser.Game);

                /**
                 * The local configuration settings of the CanvasRenderer.
                 */
                config: object;

                /**
                 * The Phaser Game instance that owns this renderer.
                 */
                game: Phaser.Game;

                /**
                 * A constant which allows the renderer to be easily identified as a Canvas Renderer.
                 */
                type: number;

                /**
                 * The total number of Game Objects which were rendered in a frame.
                 */
                drawCount: number;

                /**
                 * The width of the canvas being rendered to.
                 */
                width: number;

                /**
                 * The height of the canvas being rendered to.
                 */
                height: number;

                /**
                 * The canvas element which the Game uses.
                 */
                gameCanvas: HTMLCanvasElement;

                /**
                 * The canvas context used to render all Cameras in all Scenes during the game loop.
                 */
                gameContext: CanvasRenderingContext2D;

                /**
                 * The canvas context currently used by the CanvasRenderer for all rendering operations.
                 */
                currentContext: CanvasRenderingContext2D;

                /**
                 * Should the Canvas use Image Smoothing or not when drawing Sprites?
                 */
                antialias: boolean;

                /**
                 * The blend modes supported by the Canvas Renderer.
                 * 
                 * This object maps the {@link Phaser.BlendModes} to canvas compositing operations.
                 */
                blendModes: any[];

                /**
                 * Details about the currently scheduled snapshot.
                 * 
                 * If a non-null `callback` is set in this object, a snapshot of the canvas will be taken after the current frame is fully rendered.
                 */
                snapshotState: Phaser.Types.Renderer.Snapshot.SnapshotState;

                /**
                 * Has this renderer fully booted yet?
                 */
                isBooted: boolean;

                /**
                 * Prepares the game canvas for rendering.
                 */
                init(): void;

                /**
                 * The event handler that manages the `resize` event dispatched by the Scale Manager.
                 * @param gameSize The default Game Size object. This is the un-modified game dimensions.
                 * @param baseSize The base Size object. The game dimensions multiplied by the resolution. The canvas width / height values match this.
                 */
                onResize(gameSize: Phaser.Structs.Size, baseSize: Phaser.Structs.Size): void;

                /**
                 * Resize the main game canvas.
                 * @param width The new width of the renderer.
                 * @param height The new height of the renderer.
                 */
                resize(width?: number, height?: number): void;

                /**
                 * Resets the transformation matrix of the current context to the identity matrix, thus resetting any transformation.
                 */
                resetTransform(): void;

                /**
                 * Sets the blend mode (compositing operation) of the current context.
                 * @param blendMode The new blend mode which should be used.
                 */
                setBlendMode(blendMode: string): this;

                /**
                 * Changes the Canvas Rendering Context that all draw operations are performed against.
                 * @param ctx The new Canvas Rendering Context to draw everything to. Leave empty to reset to the Game Canvas.
                 */
                setContext(ctx?: CanvasRenderingContext2D | undefined): this;

                /**
                 * Sets the global alpha of the current context.
                 * @param alpha The new alpha to use, where 0 is fully transparent and 1 is fully opaque.
                 */
                setAlpha(alpha: number): this;

                /**
                 * Called at the start of the render loop.
                 */
                preRender(): void;

                /**
                 * The core render step for a Scene Camera.
                 * 
                 * Iterates through the given array of Game Objects and renders them with the given Camera.
                 * 
                 * This is called by the `CameraManager.render` method. The Camera Manager instance belongs to a Scene, and is invoked
                 * by the Scene Systems.render method.
                 * 
                 * This method is not called if `Camera.visible` is `false`, or `Camera.alpha` is zero.
                 * @param scene The Scene to render.
                 * @param children An array of filtered Game Objects that can be rendered by the given Camera.
                 * @param camera The Scene Camera to render with.
                 */
                render(scene: Phaser.Scene, children: Phaser.GameObjects.GameObject[], camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Restores the game context's global settings and takes a snapshot if one is scheduled.
                 * 
                 * The post-render step happens after all Cameras in all Scenes have been rendered.
                 */
                postRender(): void;

                /**
                 * Takes a snapshot of the given area of the given canvas.
                 * 
                 * Unlike the other snapshot methods, this one is processed immediately and doesn't wait for the next render.
                 * 
                 * Snapshots work by creating an Image object from the canvas data, this is a blocking process, which gets
                 * more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param canvas The canvas to grab from.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param getPixel Grab a single pixel as a Color object, or an area as an Image object? Default false.
                 * @param x The x coordinate to grab from. Default 0.
                 * @param y The y coordinate to grab from. Default 0.
                 * @param width The width of the area to grab. Default canvas.width.
                 * @param height The height of the area to grab. Default canvas.height.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshotCanvas(canvas: HTMLCanvasElement, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, getPixel?: boolean, x?: number, y?: number, width?: number, height?: number, type?: string, encoderOptions?: number): this;

                /**
                 * Schedules a snapshot of the entire game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture a specific area see the `snapshotArea` method. To capture a specific pixel, see `snapshotPixel`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotPixel`, for example, then
                 * calling this method will override it.
                 * 
                 * Snapshots work by creating an Image object from the canvas data, this is a blocking process, which gets
                 * more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshot(callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

                /**
                 * Schedules a snapshot of the given area of the game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture the whole game viewport see the `snapshot` method. To capture a specific pixel, see `snapshotPixel`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotPixel`, for example, then
                 * calling this method will override it.
                 * 
                 * Snapshots work by creating an Image object from the canvas data, this is a blocking process, which gets
                 * more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param x The x coordinate to grab from.
                 * @param y The y coordinate to grab from.
                 * @param width The width of the area to grab.
                 * @param height The height of the area to grab.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshotArea(x: number, y: number, width: number, height: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

                /**
                 * Schedules a snapshot of the given pixel from the game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture the whole game viewport see the `snapshot` method. To capture a specific area, see `snapshotArea`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotArea`, for example, then
                 * calling this method will override it.
                 * 
                 * Unlike the other two snapshot methods, this one will return a `Color` object containing the color data for
                 * the requested pixel. It doesn't need to create an internal Canvas or Image object, so is a lot faster to execute,
                 * using less memory.
                 * @param x The x coordinate of the pixel to get.
                 * @param y The y coordinate of the pixel to get.
                 * @param callback The Function to invoke after the snapshot pixel data is extracted.
                 */
                snapshotPixel(x: number, y: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback): this;

                /**
                 * Takes a Sprite Game Object, or any object that extends it, and draws it to the current context.
                 * @param sprite The texture based Game Object to draw.
                 * @param frame The frame to draw, doesn't have to be that owned by the Game Object.
                 * @param camera The Camera to use for the rendering transform.
                 * @param parentTransformMatrix The transform matrix of the parent container, if set.
                 */
                batchSprite(sprite: Phaser.GameObjects.GameObject, frame: Phaser.Textures.Frame, camera: Phaser.Cameras.Scene2D.Camera, parentTransformMatrix?: Phaser.GameObjects.Components.TransformMatrix): void;

                /**
                 * Destroys all object references in the Canvas Renderer.
                 */
                destroy(): void;

            }

            /**
             * Returns an array which maps the default blend modes to supported Canvas blend modes.
             * 
             * If the browser doesn't support a blend mode, it will default to the normal `source-over` blend mode.
             */
            function GetBlendModes(): any[];

            /**
             * Takes a reference to the Canvas Renderer, a Canvas Rendering Context, a Game Object, a Camera and a parent matrix
             * and then performs the following steps:
             * 
             * 1. Checks the alpha of the source combined with the Camera alpha. If 0 or less it aborts.
             * 2. Takes the Camera and Game Object matrix and multiplies them, combined with the parent matrix if given.
             * 3. Sets the blend mode of the context to be that used by the Game Object.
             * 4. Sets the alpha value of the context to be that used by the Game Object combined with the Camera.
             * 5. Saves the context state.
             * 6. Sets the final matrix values into the context via setTransform.
             * 7. If the Game Object has a texture frame, imageSmoothingEnabled is set based on frame.source.scaleMode.
             * 8. If the Game Object does not have a texture frame, imageSmoothingEnabled is set based on Renderer.antialias.
             * 
             * This function is only meant to be used internally. Most of the Canvas Renderer classes use it.
             * @param renderer A reference to the current active Canvas renderer.
             * @param ctx The canvas context to set the transform on.
             * @param src The Game Object being rendered. Can be any type that extends the base class.
             * @param camera The Camera that is rendering the Game Object.
             * @param parentMatrix A parent transform matrix to apply to the Game Object before rendering.
             */
            function SetTransform(renderer: Phaser.Renderer.Canvas.CanvasRenderer, ctx: CanvasRenderingContext2D, src: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): boolean;

        }

        namespace Events {
            /**
             * The Post-Render Event.
             * 
             * This event is dispatched by the Renderer when all rendering, for all cameras in all Scenes,
             * has completed, but before any pending snap shots have been taken.
             */
            const POST_RENDER: string;

            /**
             * The Pre-Render Event.
             * 
             * This event is dispatched by the Phaser Renderer. This happens right at the start of the render
             * process, after the context has been cleared, the scissors enabled (WebGL only) and everything has been
             * reset ready for the render.
             */
            const PRE_RENDER: string;

            /**
             * The Render Event.
             * 
             * This event is dispatched by the Phaser Renderer for every camera in every Scene.
             * 
             * It is dispatched before any of the children in the Scene have been rendered.
             */
            const RENDER: string;

            /**
             * The Renderer Resize Event.
             * 
             * This event is dispatched by the Phaser Renderer when it is resized, usually as a result
             * of the Scale Manager resizing.
             */
            const RESIZE: string;

        }

        namespace Snapshot {
            /**
             * Takes a snapshot of an area from the current frame displayed by a canvas.
             * 
             * This is then copied to an Image object. When this loads, the results are sent
             * to the callback provided in the Snapshot Configuration object.
             * @param sourceCanvas The canvas to take a snapshot of.
             * @param config The snapshot configuration object.
             */
            function Canvas(sourceCanvas: HTMLCanvasElement, config: Phaser.Types.Renderer.Snapshot.SnapshotState): void;

            /**
             * Takes a snapshot of an area from the current frame displayed by a WebGL canvas.
             * 
             * This is then copied to an Image object. When this loads, the results are sent
             * to the callback provided in the Snapshot Configuration object.
             * @param sourceContext The WebGL context to take a snapshot of.
             * @param config The snapshot configuration object.
             */
            function WebGL(sourceContext: WebGLRenderingContext, config: Phaser.Types.Renderer.Snapshot.SnapshotState): void;

        }

        namespace WebGL {
            /**
             * 8-bit twos complement signed integer.
             */
            var BYTE: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 8-bit twos complement unsigned integer.
             */
            var UNSIGNED_BYTE: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 16-bit twos complement signed integer.
             */
            var SHORT: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 16-bit twos complement unsigned integer.
             */
            var UNSIGNED_SHORT: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 32-bit twos complement signed integer.
             */
            var INT: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 32-bit twos complement unsigned integer.
             */
            var UNSIGNED_INT: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * 32-bit IEEE floating point number.
             */
            var FLOAT: Phaser.Types.Renderer.WebGL.WebGLConst;

            /**
             * The Pipeline Manager is responsible for the creation, activation, running and destruction
             * of WebGL Pipelines and Post FX Pipelines in Phaser 3.
             * 
             * The `WebGLRenderer` owns a single instance of the Pipeline Manager, which you can access
             * via the `WebGLRenderer.pipelines` property.
             * 
             * By default, there are 9 pipelines installed into the Pipeline Manager when Phaser boots:
             * 
             * 1. The Multi Pipeline. Responsible for all multi-texture rendering, i.e. Sprites and Tilemaps.
             * 2. The Rope Pipeline. Responsible for rendering the Rope Game Object.
             * 3. The Light Pipeline. Responsible for rendering the Light Game Object.
             * 4. The Point Light Pipeline. Responsible for rendering the Point Light Game Object.
             * 5. The Single Pipeline. Responsible for rendering Game Objects that explicitly require one bound texture.
             * 6. The Bitmap Mask Pipeline. Responsible for Bitmap Mask rendering.
             * 7. The Utility Pipeline. Responsible for providing lots of handy texture manipulation functions.
             * 8. The Mobile Pipeline. Responsible for rendering on mobile with single-bound textures.
             * 9. The FX Pipeline. Responsible for rendering Game Objects with special FX applied to them.
             * 
             * You can add your own custom pipeline via the `PipelineManager.add` method. Pipelines are
             * identified by unique string-based keys.
             */
            class PipelineManager {
                /**
                 * 
                 * @param renderer A reference to the WebGL Renderer that owns this Pipeline Manager.
                 */
                constructor(renderer: Phaser.Renderer.WebGL.WebGLRenderer);

                /**
                 * A reference to the Game instance.
                 */
                game: Phaser.Game;

                /**
                 * A reference to the WebGL Renderer instance.
                 */
                renderer: Phaser.Renderer.WebGL.WebGLRenderer;

                /**
                 * This map stores all pipeline classes available in this manager.
                 * 
                 * The Utility Class must always come first.
                 */
                classes: Phaser.Structs.Map<string, Class>;

                /**
                 * This map stores all Post FX Pipeline classes available in this manager.
                 * 
                 * As of v3.60 this is now populated by default with the following
                 * Post FX Pipelines:
                 * 
                 * * Barrel
                 * * Bloom
                 * * Blur
                 * * Bokeh / TiltShift
                 * * Circle
                 * * ColorMatrix
                 * * Displacement
                 * * Glow
                 * * Gradient
                 * * Pixelate
                 * * Shadow
                 * * Shine
                 * * Vignette
                 * * Wipe
                 * 
                 * These are added as part of the boot process.
                 * 
                 * If you do not wish to add them, specify `disableFX: true` in your game config.
                 * 
                 * See the FX Controller class for more details about each FX.
                 */
                postPipelineClasses: Phaser.Structs.Map<string, Class>;

                /**
                 * This map stores all pipeline instances in this manager.
                 * 
                 * This is populated with the default pipelines in the `boot` method.
                 */
                pipelines: Phaser.Structs.Map<string, Phaser.Renderer.WebGL.WebGLPipeline>;

                /**
                 * The default Game Object pipeline.
                 */
                default: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * Current pipeline in use by the WebGLRenderer.
                 */
                current: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The previous WebGLPipeline that was in use.
                 * 
                 * This is set when `clearPipeline` is called and restored in `rebindPipeline` if none is given.
                 */
                previous: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * A constant-style reference to the Multi Pipeline Instance.
                 * 
                 * This is the default Phaser 3 pipeline and is used by the WebGL Renderer to manage
                 * camera effects and more. This property is set during the `boot` method.
                 */
                MULTI_PIPELINE: Phaser.Renderer.WebGL.Pipelines.MultiPipeline;

                /**
                 * A constant-style reference to the Bitmap Mask Pipeline Instance.
                 * 
                 * This is the default Phaser 3 mask pipeline and is used Game Objects using
                 * a Bitmap Mask. This property is set during the `boot` method.
                 */
                BITMAPMASK_PIPELINE: Phaser.Renderer.WebGL.Pipelines.BitmapMaskPipeline;

                /**
                 * A constant-style reference to the Utility Pipeline Instance.
                 */
                UTILITY_PIPELINE: Phaser.Renderer.WebGL.Pipelines.UtilityPipeline;

                /**
                 * A constant-style reference to the Mobile Pipeline Instance.
                 * 
                 * This is the default Phaser 3 mobile pipeline and is used by the WebGL Renderer to manage
                 * camera effects and more on mobile devices. This property is set during the `boot` method.
                 */
                MOBILE_PIPELINE: Phaser.Renderer.WebGL.Pipelines.MobilePipeline;

                /**
                 * A constant-style reference to the FX Pipeline Instance.
                 * 
                 * This is the default Phaser 3 FX pipeline and is used by the WebGL Renderer to manage
                 * Game Objects with special effects enabled. This property is set during the `boot` method.
                 */
                FX_PIPELINE: Phaser.Renderer.WebGL.Pipelines.FXPipeline;

                /**
                 * A reference to the Full Frame 1 Render Target that belongs to the
                 * Utility Pipeline. This property is set during the `boot` method.
                 * 
                 * This Render Target is the full size of the renderer.
                 * 
                 * You can use this directly in Post FX Pipelines for multi-target effects.
                 * However, be aware that these targets are shared between all post fx pipelines.
                 */
                fullFrame1: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * A reference to the Full Frame 2 Render Target that belongs to the
                 * Utility Pipeline. This property is set during the `boot` method.
                 * 
                 * This Render Target is the full size of the renderer.
                 * 
                 * You can use this directly in Post FX Pipelines for multi-target effects.
                 * However, be aware that these targets are shared between all post fx pipelines.
                 */
                fullFrame2: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * A reference to the Half Frame 1 Render Target that belongs to the
                 * Utility Pipeline. This property is set during the `boot` method.
                 * 
                 * This Render Target is half the size of the renderer.
                 * 
                 * You can use this directly in Post FX Pipelines for multi-target effects.
                 * However, be aware that these targets are shared between all post fx pipelines.
                 */
                halfFrame1: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * A reference to the Half Frame 2 Render Target that belongs to the
                 * Utility Pipeline. This property is set during the `boot` method.
                 * 
                 * This Render Target is half the size of the renderer.
                 * 
                 * You can use this directly in Post FX Pipelines for multi-target effects.
                 * However, be aware that these targets are shared between all post fx pipelines.
                 */
                halfFrame2: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * An array of RenderTarget instances that belong to this pipeline.
                 */
                renderTargets: Phaser.Renderer.WebGL.RenderTarget[];

                /**
                 * The largest render target dimension before we just use a full-screen target.
                 */
                maxDimension: number;

                /**
                 * The amount in which each target frame will increase.
                 * 
                 * Defaults to 32px but can be overridden in the config.
                 */
                frameInc: number;

                /**
                 * The Render Target index. Used internally by the methods
                 * in this class. Do not modify directly.
                 */
                targetIndex: number;

                /**
                 * Internal boot handler, called by the WebGLRenderer durings its boot process.
                 * 
                 * Adds all of the default pipelines, based on the game config, and then calls
                 * the `boot` method on each one of them.
                 * 
                 * Finally, the default pipeline is set.
                 * @param pipelineConfig The pipeline configuration object as set in the Game Config.
                 * @param defaultPipeline The name of the default Game Object pipeline, as set in the Game Config
                 * @param autoMobilePipeline Automatically set the default pipeline to mobile if non-desktop detected?
                 */
                boot(pipelineConfig: Phaser.Types.Core.PipelineConfig, defaultPipeline: string, autoMobilePipeline: boolean): void;

                /**
                 * Sets the default pipeline being used by Game Objects.
                 * 
                 * If no instance, or matching name, exists in this manager, it returns `undefined`.
                 * 
                 * You can use this to override the default pipeline, for example by forcing
                 * the Mobile or Multi Tint Pipelines, which is especially useful for development
                 * testing.
                 * 
                 * Make sure you call this method _before_ creating any Game Objects, as it will
                 * only impact Game Objects created after you call it.
                 * @param pipeline Either the string-based name of the pipeline to get, or a pipeline instance to look-up.
                 */
                setDefaultPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline): Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * Adds a pipeline instance to this Pipeline Manager.
                 * 
                 * The name of the instance must be unique within this manager.
                 * 
                 * Make sure to pass an instance to this method, not a base class.
                 * 
                 * For example, you should pass it like this:
                 * 
                 * ```javascript
                 * this.add('yourName', new CustomPipeline(game));`
                 * ```
                 * 
                 * and **not** like this:
                 * 
                 * ```javascript
                 * this.add('yourName', CustomPipeline);`
                 * ```
                 * 
                 * To add a **Post Pipeline**, see `addPostPipeline` instead.
                 * @param name A unique string-based key for the pipeline within the manager.
                 * @param pipeline A pipeline _instance_ which must extend `WebGLPipeline`.
                 */
                add(name: string, pipeline: Phaser.Renderer.WebGL.WebGLPipeline): Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * Adds a Post Pipeline to this Pipeline Manager.
                 * 
                 * Make sure to pass a base class to this method, not an instance.
                 * 
                 * For example, you should pass it like this:
                 * 
                 * ```javascript
                 * this.addPostPipeline('yourName', CustomPipeline);`
                 * ```
                 * 
                 * and **not** like this:
                 * 
                 * ```javascript
                 * this.addPostPipeline('yourName', new CustomPipeline());`
                 * ```
                 * 
                 * To add a regular pipeline, see the `add` method instead.
                 * @param name A unique string-based key for the pipeline within the manager.
                 * @param pipeline A pipeline class which must extend `PostFXPipeline`.
                 */
                addPostPipeline(name: string, pipeline: Function): this;

                /**
                 * Flushes the current pipeline, if one is bound.
                 */
                flush(): void;

                /**
                 * Checks if a pipeline is present in this Pipeline Manager.
                 * @param pipeline Either the string-based name of the pipeline to get, or a pipeline instance to look-up.
                 */
                has(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

                /**
                 * Returns the pipeline instance based on the given name, or instance.
                 * 
                 * If no instance, or matching name, exists in this manager, it returns `undefined`.
                 * @param pipeline Either the string-based name of the pipeline to get, or a pipeline instance to look-up.
                 */
                get(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline): Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * Returns a _new instance_ of the post pipeline based on the given name, or class.
                 * 
                 * If no instance, or matching name, exists in this manager, it returns `undefined`.
                 * @param pipeline Either the string-based name of the pipeline to get, or a pipeline instance, or class to look-up.
                 * @param gameObject If this post pipeline is being installed into a Game Object or Camera, this is a reference to it.
                 * @param config Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
                 */
                getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline, gameObject?: Phaser.GameObjects.GameObject, config?: object): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline;

                /**
                 * Removes a pipeline instance based on the given name.
                 * 
                 * If no pipeline matches the name, this method does nothing.
                 * 
                 * Note that the pipeline will not be flushed or destroyed, it's simply removed from
                 * this manager.
                 * @param name The name of the pipeline to be removed.
                 * @param removeClass Remove the pipeline class as well as the instance? Default true.
                 * @param removePostPipelineClass Remove the post pipeline class as well as the instance? Default true.
                 */
                remove(name: string, removeClass?: boolean, removePostPipelineClass?: boolean): void;

                /**
                 * Sets the current pipeline to be used by the `WebGLRenderer`.
                 * 
                 * This method accepts a pipeline instance as its parameter, not the name.
                 * 
                 * If the pipeline isn't already the current one it will call `WebGLPipeline.bind` and then `onBind`.
                 * 
                 * You cannot set Post FX Pipelines using this method. To use a Post FX Pipeline, you should
                 * apply it to either a Camera, Container or other supporting Game Object.
                 * @param pipeline The pipeline instance to be set as current.
                 * @param gameObject The Game Object that invoked this pipeline, if any.
                 * @param currentShader The shader to set as being current.
                 */
                set(pipeline: Phaser.Renderer.WebGL.WebGLPipeline, gameObject?: Phaser.GameObjects.GameObject, currentShader?: Phaser.Renderer.WebGL.WebGLShader): Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * This method is called by the `WebGLPipeline.batchQuad` method, right before a quad
                 * belonging to a Game Object is about to be added to the batch.
                 * 
                 * It is also called directly bu custom Game Objects, such as Nine Slice or Mesh,
                 * from their render methods.
                 * 
                 * It causes a batch flush, then calls the `preBatch` method on the Post FX Pipelines
                 * belonging to the Game Object.
                 * 
                 * It should be followed by a call to `postBatch` to complete the process.
                 * @param gameObject The Game Object about to be batched.
                 */
                preBatch(gameObject: Phaser.GameObjects.GameObject): void;

                /**
                 * This method is called by the `WebGLPipeline.batchQuad` method, right after a quad
                 * belonging to a Game Object has been added to the batch.
                 * 
                 * It is also called directly bu custom Game Objects, such as Nine Slice or Mesh,
                 * from their render methods.
                 * 
                 * It causes a batch flush, then calls the `postBatch` method on the Post FX Pipelines
                 * belonging to the Game Object.
                 * 
                 * It should be preceeded by a call to `preBatch` to start the process.
                 * @param gameObject The Game Object that was just added to the batch.
                 */
                postBatch(gameObject: Phaser.GameObjects.GameObject): void;

                /**
                 * Called at the start of the `WebGLRenderer.preRenderCamera` method.
                 * 
                 * If the Camera has post pipelines set, it will flush the batch and then call the
                 * `preBatch` method on the post-fx pipelines belonging to the Camera.
                 * @param camera The Camera about to be rendered.
                 */
                preBatchCamera(camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Called at the end of the `WebGLRenderer.postRenderCamera` method.
                 * 
                 * If the Camera has post pipelines set, it will flush the batch and then call the
                 * `postBatch` method on the post-fx pipelines belonging to the Camera.
                 * @param camera The Camera that was just rendered.
                 */
                postBatchCamera(camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Checks to see if the given pipeline is already the active pipeline, both within this
                 * Pipeline Manager and also has the same shader set in the Renderer.
                 * @param pipeline The pipeline instance to be checked.
                 * @param currentShader The shader to set as being current.
                 */
                isCurrent(pipeline: Phaser.Renderer.WebGL.WebGLPipeline, currentShader?: Phaser.Renderer.WebGL.WebGLShader): boolean;

                /**
                 * Copy the `source` Render Target to the `target` Render Target.
                 * 
                 * You can optionally set the brightness factor of the copy.
                 * 
                 * The difference between this method and `drawFrame` is that this method
                 * uses a faster copy shader, where only the brightness can be modified.
                 * If you need color level manipulation, see `drawFrame` instead.
                 * 
                 * The copy itself is handled by the Utility Pipeline.
                 * @param source The source Render Target.
                 * @param target The target Render Target.
                 * @param brightness The brightness value applied to the frame copy. Default 1.
                 * @param clear Clear the target before copying? Default true.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 */
                copyFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean): this;

                /**
                 * Pops the framebuffer from the renderers FBO stack and sets that as the active target,
                 * then draws the `source` Render Target to it. It then resets the renderer textures.
                 * 
                 * This should be done when you need to draw the _final_ results of a pipeline to the game
                 * canvas, or the next framebuffer in line on the FBO stack. You should only call this once
                 * in the `onDraw` handler and it should be the final thing called. Be careful not to call
                 * this if you need to actually use the pipeline shader, instead of the copy shader. In
                 * those cases, use the `bindAndDraw` method.
                 * @param source The Render Target to draw from.
                 */
                copyToGame(source: Phaser.Renderer.WebGL.RenderTarget): void;

                /**
                 * Copy the `source` Render Target to the `target` Render Target, using the
                 * given Color Matrix.
                 * 
                 * The difference between this method and `copyFrame` is that this method
                 * uses a color matrix shader, where you have full control over the luminance
                 * values used during the copy. If you don't need this, you can use the faster
                 * `copyFrame` method instead.
                 * 
                 * The copy itself is handled by the Utility Pipeline.
                 * @param source The source Render Target.
                 * @param target The target Render Target.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 * @param colorMatrix The Color Matrix to use when performing the draw.
                 */
                drawFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean, colorMatrix?: Phaser.Display.ColorMatrix): this;

                /**
                 * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                 * using a linear blend effect, which is controlled by the `strength` parameter.
                 * 
                 * The draw itself is handled by the Utility Pipeline.
                 * @param source1 The first source Render Target.
                 * @param source2 The second source Render Target.
                 * @param target The target Render Target.
                 * @param strength The strength of the blend. Default 1.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 */
                blendFrames(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): this;

                /**
                 * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                 * using an additive blend effect, which is controlled by the `strength` parameter.
                 * 
                 * The draw itself is handled by the Utility Pipeline.
                 * @param source1 The first source Render Target.
                 * @param source2 The second source Render Target.
                 * @param target The target Render Target.
                 * @param strength The strength of the blend. Default 1.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 */
                blendFramesAdditive(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): this;

                /**
                 * Clears the given Render Target.
                 * @param target The Render Target to clear.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 */
                clearFrame(target: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean): this;

                /**
                 * Copy the `source` Render Target to the `target` Render Target.
                 * 
                 * The difference with this copy is that no resizing takes place. If the `source`
                 * Render Target is larger than the `target` then only a portion the same size as
                 * the `target` dimensions is copied across.
                 * 
                 * You can optionally set the brightness factor of the copy.
                 * @param source The source Render Target.
                 * @param target The target Render Target.
                 * @param brightness The brightness value applied to the frame copy. Default 1.
                 * @param clear Clear the target before copying? Default true.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 * @param eraseMode Erase source from target using ERASE Blend Mode? Default false.
                 */
                blitFrame(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean, eraseMode?: boolean): this;

                /**
                 * Binds the `source` Render Target and then copies a section of it to the `target` Render Target.
                 * 
                 * This method is extremely fast because it uses `gl.copyTexSubImage2D` and doesn't
                 * require the use of any shaders. Remember the coordinates are given in standard WebGL format,
                 * where x and y specify the lower-left corner of the section, not the top-left. Also, the
                 * copy entirely replaces the contents of the target texture, no 'merging' or 'blending' takes
                 * place.
                 * @param source The source Render Target.
                 * @param target The target Render Target.
                 * @param x The x coordinate of the lower left corner where to start copying.
                 * @param y The y coordinate of the lower left corner where to start copying.
                 * @param width The width of the texture.
                 * @param height The height of the texture.
                 * @param clear Clear the target before copying? Default true.
                 * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                 */
                copyFrameRect(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, x: number, y: number, width: number, height: number, clear?: boolean, clearAlpha?: boolean): this;

                /**
                 * Returns `true` if the current pipeline is forced to use texture unit zero.
                 */
                forceZero(): boolean;

                /**
                 * Sets the Multi Pipeline to be the currently bound pipeline.
                 * 
                 * This is the default Phaser 3 rendering pipeline.
                 */
                setMulti(): Phaser.Renderer.WebGL.Pipelines.MultiPipeline;

                /**
                 * Sets the Utility Pipeline to be the currently bound pipeline.
                 * @param currentShader The shader to set as being current.
                 */
                setUtility(currentShader?: Phaser.Renderer.WebGL.WebGLShader): Phaser.Renderer.WebGL.Pipelines.UtilityPipeline;

                /**
                 * Sets the FX Pipeline to be the currently bound pipeline.
                 */
                setFX(): Phaser.Renderer.WebGL.Pipelines.FXPipeline;

                /**
                 * Use this to reset the gl context to the state that Phaser requires to continue rendering.
                 * 
                 * Calling this will:
                 * 
                 * * Disable `DEPTH_TEST`, `CULL_FACE` and `STENCIL_TEST`.
                 * * Clear the depth buffer and stencil buffers.
                 * * Reset the viewport size.
                 * * Reset the blend mode.
                 * * Bind a blank texture as the active texture on texture unit zero.
                 * * Rebinds the given pipeline instance.
                 * 
                 * You should call this if you have previously called `clear`, and then wish to return
                 * rendering control to Phaser again.
                 * @param pipeline The pipeline instance to be rebound. If not given, the previous pipeline will be bound.
                 */
                rebind(pipeline?: Phaser.Renderer.WebGL.WebGLPipeline): void;

                /**
                 * Flushes the current pipeline being used and then clears it, along with the
                 * the current shader program and vertex buffer from the `WebGLRenderer`.
                 * 
                 * Then resets the blend mode to NORMAL.
                 * 
                 * Call this before jumping to your own gl context handler, and then call `rebind` when
                 * you wish to return control to Phaser again.
                 */
                clear(): void;

                /**
                 * Gets a Render Target the right size to render the Sprite on.
                 * 
                 * If the Sprite exceeds the size of the renderer, the Render Target will only ever be the maximum
                 * size of the renderer.
                 * @param size The maximum dimension required.
                 */
                getRenderTarget(size: number): Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * Gets a matching Render Target, the same size as the one the Sprite was drawn to,
                 * useful for double-buffer style effects such as blurs.
                 */
                getSwapRenderTarget(): Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * Gets a matching Render Target, the same size as the one the Sprite was drawn to,
                 * useful for double-buffer style effects such as blurs.
                 */
                getAltSwapRenderTarget(): Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * Destroy the Pipeline Manager, cleaning up all related resources and references.
                 */
                destroy(): void;

            }

            namespace Pipelines {
                /**
                 * The Bitmap Mask Pipeline handles all of the bitmap mask rendering in WebGL for applying
                 * alpha masks to Game Objects. It works by sampling two texture on the fragment shader and
                 * using the fragments alpha to clip the region.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/BitmapMask.frag`.
                 * The vertex shader it uses can be found in `shaders/src/BitmapMask.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uResolution` (vec2)
                 * `uMainSampler` (sampler2D)
                 * `uMaskSampler` (sampler2D)
                 * `uInvertMaskAlpha` (bool)
                 */
                class BitmapMaskPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * Binds necessary resources and renders the mask to a separated framebuffer.
                     * The framebuffer for the masked object is also bound for further use.
                     * @param mask The BitmapMask instance that called beginMask.
                     * @param maskedObject GameObject masked by the mask GameObject.
                     * @param camera The camera rendering the current mask.
                     */
                    beginMask(mask: Phaser.Display.Masks.BitmapMask, maskedObject: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

                    /**
                     * The masked game objects framebuffer is unbound and its texture
                     * is bound together with the mask texture and the mask shader and
                     * a draw call with a single quad is processed. Here is where the
                     * masking effect is applied.
                     * @param mask The BitmapMask instance that called endMask.
                     * @param camera The Camera to render to.
                     * @param renderTarget Optional WebGL RenderTarget.
                     */
                    endMask(mask: Phaser.Display.Masks.BitmapMask, camera: Phaser.Cameras.Scene2D.Camera, renderTarget?: Phaser.Renderer.WebGL.RenderTarget): void;

                }

                /**
                 * The Bitmap Mask Pipeline.
                 */
                const BITMAPMASK_PIPELINE: string;

                /**
                 * The Light 2D Pipeline.
                 */
                const LIGHT_PIPELINE: string;

                /**
                 * The Point Light Pipeline.
                 */
                const POINTLIGHT_PIPELINE: string;

                /**
                 * The Single Texture Pipeline.
                 */
                const SINGLE_PIPELINE: string;

                /**
                 * The Multi Texture Pipeline.
                 */
                const MULTI_PIPELINE: string;

                /**
                 * The Rope Pipeline.
                 */
                const ROPE_PIPELINE: string;

                /**
                 * The Graphics and Shapes Pipeline.
                 */
                const GRAPHICS_PIPELINE: string;

                /**
                 * The Post FX Pipeline.
                 */
                const POSTFX_PIPELINE: string;

                /**
                 * The Utility Pipeline.
                 */
                const UTILITY_PIPELINE: string;

                /**
                 * The Mobile Texture Pipeline.
                 */
                const MOBILE_PIPELINE: string;

                /**
                 * The Special FX Pipeline.
                 */
                const FX_PIPELINE: string;

                namespace Events {
                    /**
                     * The WebGLPipeline After Flush Event.
                     * 
                     * This event is dispatched by a WebGLPipeline right after it has issued a drawArrays command
                     * and cleared its vertex count.
                     */
                    const AFTER_FLUSH: any;

                    /**
                     * The WebGLPipeline Before Flush Event.
                     * 
                     * This event is dispatched by a WebGLPipeline right before it is about to
                     * flush and issue a bufferData and drawArrays command.
                     */
                    const BEFORE_FLUSH: any;

                    /**
                     * The WebGLPipeline Bind Event.
                     * 
                     * This event is dispatched by a WebGLPipeline when it is bound by the Pipeline Manager.
                     */
                    const BIND: any;

                    /**
                     * The WebGLPipeline Boot Event.
                     * 
                     * This event is dispatched by a WebGLPipeline when it has completed its `boot` phase.
                     */
                    const BOOT: any;

                    /**
                     * The WebGLPipeline Destroy Event.
                     * 
                     * This event is dispatched by a WebGLPipeline when it is starting its destroy process.
                     */
                    const DESTROY: any;

                    /**
                     * The WebGLPipeline ReBind Event.
                     * 
                     * This event is dispatched by a WebGLPipeline when it is re-bound by the Pipeline Manager.
                     */
                    const REBIND: any;

                    /**
                     * The WebGLPipeline Resize Event.
                     * 
                     * This event is dispatched by a WebGLPipeline when it is resized, usually as a result
                     * of the Renderer resizing.
                     */
                    const RESIZE: any;

                }

                namespace FX {
                    /**
                     * The Barrel FX Pipeline.
                     * 
                     * A barrel effect allows you to apply either a 'pinch' or 'expand' distortion to
                     * a Game Object. The amount of the effect can be modified in real-time.
                     * 
                     * A Barrel effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addBarrel();
                     * ```
                     */
                    class BarrelFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The amount of distortion applied to the barrel effect.
                         * 
                         * Typically keep this within the range 1 (no distortion) to +- 1.
                         */
                        amount: number;

                    }

                    /**
                     * The Bloom FX Pipeline.
                     * 
                     * Bloom is an effect used to reproduce an imaging artifact of real-world cameras.
                     * The effect produces fringes of light extending from the borders of bright areas in an image,
                     * contributing to the illusion of an extremely bright light overwhelming the
                     * camera or eye capturing the scene.
                     * 
                     * A Bloom effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addBloom();
                     * ```
                     */
                    class BloomFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The number of steps to run the Bloom effect for.
                         * 
                         * This value should always be an integer.
                         * 
                         * It defaults to 4. The higher the value, the smoother the Bloom,
                         * but at the cost of exponentially more gl operations.
                         * 
                         * Keep this to the lowest possible number you can have it, while
                         * still looking correct for your game.
                         */
                        steps: number;

                        /**
                         * The horizontal offset of the bloom effect.
                         */
                        offsetX: number;

                        /**
                         * The vertical offset of the bloom effect.
                         */
                        offsetY: number;

                        /**
                         * The strength of the blur process of the bloom effect.
                         */
                        blurStrength: number;

                        /**
                         * The strength of the blend process of the bloom effect.
                         */
                        strength: number;

                        /**
                         * The internal gl color array.
                         */
                        glcolor: number[];

                    }

                    /**
                     * The Blur FX Pipeline.
                     * 
                     * A Gaussian blur is the result of blurring an image by a Gaussian function. It is a widely used effect,
                     * typically to reduce image noise and reduce detail. The visual effect of this blurring technique is a
                     * smooth blur resembling that of viewing the image through a translucent screen, distinctly different
                     * from the bokeh effect produced by an out-of-focus lens or the shadow of an object under usual illumination.
                     * 
                     * A Blur effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addBlur();
                     * ```
                     */
                    class BlurFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The horizontal offset of the blur effect.
                         */
                        x: number;

                        /**
                         * The vertical offset of the blur effect.
                         */
                        y: number;

                        /**
                         * The number of steps to run the Blur effect for.
                         * 
                         * This value should always be an integer.
                         * 
                         * It defaults to 4. The higher the value, the smoother the blur,
                         * but at the cost of exponentially more gl operations.
                         * 
                         * Keep this to the lowest possible number you can have it, while
                         * still looking correct for your game.
                         */
                        steps: number;

                        /**
                         * The strength of the blur effect.
                         */
                        strength: number;

                        /**
                         * The internal gl color array.
                         */
                        glcolor: number[];

                        /**
                         * Sets the quality of the blur effect to low.
                         */
                        setQualityLow(): this;

                        /**
                         * Sets the quality of the blur effect to medium.
                         */
                        setQualityMedium(): this;

                        /**
                         * Sets the quality of the blur effect to high.
                         */
                        setQualityHigh(): this;

                    }

                    /**
                     * The Bokeh FX Pipeline.
                     * 
                     * Bokeh refers to a visual effect that mimics the photographic technique of creating a shallow depth of field.
                     * This effect is used to emphasize the game's main subject or action, by blurring the background or foreground
                     * elements, resulting in a more immersive and visually appealing experience. It is achieved through rendering
                     * techniques that simulate the out-of-focus areas, giving a sense of depth and realism to the game's graphics.
                     * 
                     * This effect can also be used to generate a Tilt Shift effect, which is a technique used to create a miniature
                     * effect by blurring everything except a small area of the image. This effect is achieved by blurring the
                     * top and bottom elements, while keeping the center area in focus.
                     * 
                     * A Bokeh effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addBokeh();
                     * ```
                     */
                    class BokehFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * Is this a Tilt Shift effect or a standard bokeh effect?
                         */
                        isTiltShift: boolean;

                        /**
                         * If a Tilt Shift effect this controls the strength of the blur.
                         * 
                         * Setting this value on a non-Tilt Shift effect will have no effect.
                         */
                        strength: number;

                        /**
                         * If a Tilt Shift effect this controls the amount of horizontal blur.
                         * 
                         * Setting this value on a non-Tilt Shift effect will have no effect.
                         */
                        blurX: number;

                        /**
                         * If a Tilt Shift effect this controls the amount of vertical blur.
                         * 
                         * Setting this value on a non-Tilt Shift effect will have no effect.
                         */
                        blurY: number;

                        /**
                         * The radius of the bokeh effect.
                         * 
                         * This is a float value, where a radius of 0 will result in no effect being applied,
                         * and a radius of 1 will result in a strong bokeh. However, you can exceed this value
                         * for even stronger effects.
                         */
                        radius: number;

                        /**
                         * The amount, or strength, of the bokeh effect. Defaults to 1.
                         */
                        amount: number;

                        /**
                         * The color contrast, or brightness, of the bokeh effect. Defaults to 0.2.
                         */
                        contrast: number;

                    }

                    /**
                     * The Circle FX Pipeline.
                     * 
                     * This effect will draw a circle around the texture of the Game Object, effectively masking off
                     * any area outside of the circle without the need for an actual mask. You can control the thickness
                     * of the circle, the color of the circle and the color of the background, should the texture be
                     * transparent. You can also control the feathering applied to the circle, allowing for a harsh or soft edge.
                     * 
                     * Please note that adding this effect to a Game Object will not change the input area or physics body of
                     * the Game Object, should it have one.
                     * 
                     * A Circle effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addCircle();
                     * ```
                     */
                    class CircleFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The scale of the circle. The default scale is 1, which is a circle
                         * the full size of the underlying texture. Reduce this value to create
                         * a smaller circle, or increase it to create a circle that extends off
                         * the edges of the texture.
                         */
                        scale: number;

                        /**
                         * The amount of feathering to apply to the circle from the ring,
                         * extending into the middle of the circle. The default is 0.005,
                         * which is a very low amount of feathering just making sure the ring
                         * has a smooth edge. Increase this amount to a value such as 0.5
                         * or 0.025 for larger amounts of feathering.
                         */
                        feather: number;

                        /**
                         * The width of the circle around the texture, in pixels. This value
                         * doesn't factor in the feather, which can extend the thickness
                         * internally depending on its value.
                         */
                        thickness: number;

                        /**
                         * The internal gl color array for the ring color.
                         */
                        glcolor: number[];

                        /**
                         * The internal gl color array for the background color.
                         */
                        glcolor2: number[];

                    }

                    /**
                     * The ColorMatrix FX Pipeline.
                     * 
                     * The color matrix effect is a visual technique that involves manipulating the colors of an image
                     * or scene using a mathematical matrix. This process can adjust hue, saturation, brightness, and contrast,
                     * allowing developers to create various stylistic appearances or mood settings within the game.
                     * Common applications include simulating different lighting conditions, applying color filters,
                     * or achieving a specific visual style.
                     * 
                     * A ColorMatrix effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addColorMatrix();
                     * ```
                     */
                    class ColorMatrixFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                    }

                    /**
                     * The Displacement FX Pipeline.
                     * 
                     * The displacement effect is a visual technique that alters the position of pixels in an image
                     * or texture based on the values of a displacement map. This effect is used to create the illusion
                     * of depth, surface irregularities, or distortion in otherwise flat elements. It can be applied to
                     * characters, objects, or backgrounds to enhance realism, convey movement, or achieve various
                     * stylistic appearances.
                     * 
                     * A Displacement effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addDisplacement();
                     * ```
                     */
                    class DisplacementFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The amount of horizontal displacement to apply.
                         */
                        x: number;

                        /**
                         * The amount of vertical displacement to apply.
                         */
                        y: number;

                        /**
                         * The underlying WebGLTexture used for displacement.
                         */
                        glTexture: WebGLTexture;

                    }

                    /**
                     * The Glow FX Pipeline.
                     * 
                     * The glow effect is a visual technique that creates a soft, luminous halo around game objects,
                     * characters, or UI elements. This effect is used to emphasize importance, enhance visual appeal,
                     * or convey a sense of energy, magic, or otherworldly presence. The effect can also be set on
                     * the inside of the Game Object. The color and strength of the glow can be modified.
                     * 
                     * A Glow effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addGlow();
                     * ```
                     */
                    class GlowFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         * @param config The configuration options for this pipeline.
                         */
                        constructor(game: Phaser.Game, config: object);

                        /**
                         * The strength of the glow outward from the edge of the Sprite.
                         */
                        outerStrength: number;

                        /**
                         * The strength of the glow inward from the edge of the Sprite.
                         */
                        innerStrength: number;

                        /**
                         * If `true` only the glow is drawn, not the texture itself.
                         */
                        knockout: number;

                        /**
                         * A 4 element array of gl color values.
                         */
                        glcolor: number[];

                    }

                    /**
                     * The Gradient FX Pipeline.
                     * 
                     * The gradient overlay effect is a visual technique where a smooth color transition is applied over Game Objects,
                     * such as sprites or UI components. This effect is used to enhance visual appeal, emphasize depth, or create
                     * stylistic and atmospheric variations. It can also be utilized to convey information, such as representing
                     * progress or health status through color changes.
                     * 
                     * A Gradient effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addGradient();
                     * ```
                     */
                    class GradientFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The alpha value of the gradient effect.
                         */
                        alpha: number;

                        /**
                         * Sets how many 'chunks' the gradient is divided in to, as spread over the
                         * entire height of the texture. Leave this at zero for a smooth gradient,
                         * or set to a higher number to split the gradient into that many sections, giving
                         * a more banded 'retro' effect.
                         */
                        size: number;

                        /**
                         * The horizontal position the gradient will start from. This value is normalized, between 0 and 1 and is not in pixels.
                         */
                        fromX: number;

                        /**
                         * The vertical position the gradient will start from. This value is normalized, between 0 and 1 and is not in pixels.
                         */
                        fromY: number;

                        /**
                         * The horizontal position the gradient will end. This value is normalized, between 0 and 1 and is not in pixels.
                         */
                        toX: number;

                        /**
                         * The vertical position the gradient will end. This value is normalized, between 0 and 1 and is not in pixels.
                         */
                        toY: number;

                        /**
                         * The internal gl color array for the starting color.
                         */
                        glcolor1: number[];

                        /**
                         * The internal gl color array for the ending color.
                         */
                        glcolor2: number[];

                    }

                    /**
                     * The Pixelate FX Pipeline.
                     * 
                     * The pixelate effect is a visual technique that deliberately reduces the resolution or detail of an image,
                     * creating a blocky or mosaic appearance composed of large, visible pixels. This effect can be used for stylistic
                     * purposes, as a homage to retro gaming, or as a means to obscure certain elements within the game, such as
                     * during a transition or to censor specific content.
                     * 
                     * A Pixelate effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addPixelate();
                     * ```
                     */
                    class PixelateFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The amount of pixelation to apply.
                         */
                        amount: number;

                    }

                    /**
                     * The Shadow FX Pipeline.
                     * 
                     * The shadow effect is a visual technique used to create the illusion of depth and realism by adding darker,
                     * offset silhouettes or shapes beneath game objects, characters, or environments. These simulated shadows
                     * help to enhance the visual appeal and immersion, making the 2D game world appear more dynamic and three-dimensional.
                     * 
                     * A Shadow effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addShadow();
                     * ```
                     */
                    class ShadowFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The horizontal offset of the shadow effect.
                         */
                        x: number;

                        /**
                         * The vertical offset of the shadow effect.
                         */
                        y: number;

                        /**
                         * The amount of decay for the shadow effect.
                         */
                        decay: number;

                        /**
                         * The power of the shadow effect.
                         */
                        power: number;

                        /**
                         * The internal gl color array.
                         */
                        glcolor: number[];

                        /**
                         * The number of samples that the shadow effect will run for.
                         * 
                         * This should be an integer with a minimum value of 1 and a maximum of 12.
                         */
                        samples: number;

                        /**
                         * The intensity of the shadow effect.
                         */
                        intensity: number;

                    }

                    /**
                     * The Shine FX Pipeline.
                     * 
                     * The shine effect is a visual technique that simulates the appearance of reflective
                     * or glossy surfaces by passing a light beam across a Game Object. This effect is used to
                     * enhance visual appeal, emphasize certain features, and create a sense of depth or
                     * material properties.
                     * 
                     * A Shine effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addShine();
                     * ```
                     */
                    class ShineFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The speed of the Shine effect.
                         */
                        speed: number;

                        /**
                         * The line width of the Shine effect.
                         */
                        lineWidth: number;

                        /**
                         * The gradient of the Shine effect.
                         */
                        gradient: number;

                        /**
                         * Does this Shine effect reveal or get added to its target?
                         */
                        reveal: boolean;

                    }

                    /**
                     * The Vignette FX Pipeline.
                     * 
                     * The vignette effect is a visual technique where the edges of the screen, or a Game Object, gradually darken or blur,
                     * creating a frame-like appearance. This effect is used to draw the player's focus towards the central action or subject,
                     * enhance immersion, and provide a cinematic or artistic quality to the game's visuals.
                     * 
                     * A Vignette effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addVignette();
                     * ```
                     */
                    class VignetteFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The horizontal offset of the vignette effect. This value is normalized to the range 0 to 1.
                         */
                        x: number;

                        /**
                         * The vertical offset of the vignette effect. This value is normalized to the range 0 to 1.
                         */
                        y: number;

                        /**
                         * The radius of the vignette effect. This value is normalized to the range 0 to 1.
                         */
                        radius: number;

                        /**
                         * The strength of the vignette effect.
                         */
                        strength: number;

                    }

                    /**
                     * The Wipe FX Pipeline.
                     * 
                     * The wipe or reveal effect is a visual technique that gradually uncovers or conceals elements
                     * in the game, such as images, text, or scene transitions. This effect is often used to create
                     * a sense of progression, reveal hidden content, or provide a smooth and visually appealing transition
                     * between game states.
                     * 
                     * You can set both the direction and the axis of the wipe effect. The following combinations are possible:
                     * 
                     * * left to right: direction 0, axis 0
                     * * right to left: direction 1, axis 0
                     * * top to bottom: direction 1, axis 1
                     * * bottom to top: direction 1, axis 0
                     * 
                     * It is up to you to set the `progress` value yourself, i.e. via a Tween, in order to transition the effect.
                     * 
                     * A Wipe effect is added to a Game Object via the FX component:
                     * 
                     * ```js
                     * const sprite = this.add.sprite();
                     * 
                     * sprite.postFX.addWipe();
                     * sprite.postFX.addReveal();
                     * ```
                     */
                    class WipeFXPipeline extends Phaser.Renderer.WebGL.Pipelines.PostFXPipeline {
                        /**
                         * 
                         * @param game A reference to the Phaser Game instance.
                         */
                        constructor(game: Phaser.Game);

                        /**
                         * The progress of the Wipe effect. This value is normalized to the range 0 to 1.
                         * 
                         * Adjust this value to make the wipe transition (i.e. via a Tween)
                         */
                        progress: number;

                        /**
                         * The width of the wipe effect. This value is normalized in the range 0 to 1.
                         */
                        wipeWidth: number;

                        /**
                         * The direction of the wipe effect. Either 0 or 1. Set in conjunction with the axis property.
                         */
                        direction: number;

                        /**
                         * The axis of the wipe effect. Either 0 or 1. Set in conjunction with the direction property.
                         */
                        axis: number;

                        /**
                         * Is this a reveal (true) or a fade (false) effect?
                         */
                        reveal: boolean;

                    }

                }

                /**
                 * The FXPipeline is a built-in pipeline that controls the application of FX Controllers during
                 * the rendering process. It maintains all of the FX shaders, instances of Post FX Pipelines and
                 * is responsible for rendering.
                 * 
                 * You should rarely interact with this pipeline directly. Instead, use the FX Controllers that
                 * is part of the Game Object class in order to manage the effects.
                 */
                class FXPipeline extends Phaser.Renderer.WebGL.Pipelines.PreFXPipeline {
                    /**
                     * 
                     * @param game A reference to the Phaser game instance.
                     */
                    constructor(game: Phaser.Game);

                    /**
                     * An instance of the Glow Post FX Pipeline.
                     */
                    glow: Phaser.Renderer.WebGL.Pipelines.FX.GlowFXPipeline;

                    /**
                     * An instance of the Shadow Post FX Pipeline.
                     */
                    shadow: Phaser.Renderer.WebGL.Pipelines.FX.ShadowFXPipeline;

                    /**
                     * An instance of the Pixelate Post FX Pipeline.
                     */
                    pixelate: Phaser.Renderer.WebGL.Pipelines.FX.PixelateFXPipeline;

                    /**
                     * An instance of the Vignette Post FX Pipeline.
                     */
                    vignette: Phaser.Renderer.WebGL.Pipelines.FX.VignetteFXPipeline;

                    /**
                     * An instance of the Shine Post FX Pipeline.
                     */
                    shine: Phaser.Renderer.WebGL.Pipelines.FX.ShineFXPipeline;

                    /**
                     * An instance of the Gradient Post FX Pipeline.
                     */
                    gradient: Phaser.Renderer.WebGL.Pipelines.FX.GradientFXPipeline;

                    /**
                     * An instance of the Circle Post FX Pipeline.
                     */
                    circle: Phaser.Renderer.WebGL.Pipelines.FX.CircleFXPipeline;

                    /**
                     * An instance of the Barrel Post FX Pipeline.
                     */
                    barrel: Phaser.Renderer.WebGL.Pipelines.FX.BarrelFXPipeline;

                    /**
                     * An instance of the Wipe Post FX Pipeline.
                     */
                    wipe: Phaser.Renderer.WebGL.Pipelines.FX.WipeFXPipeline;

                    /**
                     * An instance of the Bokeh Post FX Pipeline.
                     */
                    bokeh: Phaser.Renderer.WebGL.Pipelines.FX.BokehFXPipeline;

                    /**
                     * An array containing references to the methods that map to the FX CONSTs.
                     * 
                     * This array is intentionally sparse. Do not adjust.
                     */
                    fxHandlers: Function[];

                    /**
                     * The source Render Target.
                     */
                    source: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * The target Render Target.
                     */
                    target: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * The swap Render Target.
                     */
                    swap: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * Takes the currently bound Game Object and runs all of its pre-render effects,
                     * using the given Render Target as the source.
                     * 
                     * Finally calls `drawToGame` to copy the result to the Game Canvas.
                     * @param target1 The source Render Target.
                     * @param target2 The target Render Target.
                     * @param target3 The swap Render Target.
                     */
                    onDraw(target1: Phaser.Renderer.WebGL.RenderTarget, target2: Phaser.Renderer.WebGL.RenderTarget, target3: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Takes the source and target and runs a copy from source to target.
                     * 
                     * This will use the current shader and pipeline.
                     */
                    runDraw(): void;

                    /**
                     * Runs the Glow FX controller.
                     * @param config The Glow FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onGlow(config: Phaser.FX.Glow, width: number, height: number): void;

                    /**
                     * Runs the Shadow FX controller.
                     * @param config The Shadow FX controller.
                     */
                    onShadow(config: Phaser.FX.Shadow): void;

                    /**
                     * Runs the Pixelate FX controller.
                     * @param config The Pixelate FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onPixelate(config: Phaser.FX.Pixelate, width: number, height: number): void;

                    /**
                     * Runs the Vignette FX controller.
                     * @param config The Vignette FX controller.
                     */
                    onVignette(config: Phaser.FX.Vignette): void;

                    /**
                     * Runs the Shine FX controller.
                     * @param config The Shine FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onShine(config: Phaser.FX.Shine, width: number, height: number): void;

                    /**
                     * Runs the Blur FX controller.
                     * @param config The Blur FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onBlur(config: Phaser.FX.Blur, width: number, height: number): void;

                    /**
                     * Runs the Gradient FX controller.
                     * @param config The Gradient FX controller.
                     */
                    onGradient(config: Phaser.FX.Gradient): void;

                    /**
                     * Runs the Bloom FX controller.
                     * @param config The Bloom FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onBloom(config: Phaser.FX.Bloom, width: number, height: number): void;

                    /**
                     * Runs the ColorMatrix FX controller.
                     * @param config The ColorMatrix FX controller.
                     */
                    onColorMatrix(config: Phaser.FX.ColorMatrix): void;

                    /**
                     * Runs the Circle FX controller.
                     * @param config The Circle FX controller.
                     * @param width The width of the target.
                     * @param height The height of the target.
                     */
                    onCircle(config: Phaser.FX.Circle, width: number, height: number): void;

                    /**
                     * Runs the Barrel FX controller.
                     * @param config The Barrel FX controller.
                     */
                    onBarrel(config: Phaser.FX.Barrel): void;

                    /**
                     * Runs the Displacement FX controller.
                     * @param config The Displacement FX controller.
                     */
                    onDisplacement(config: Phaser.FX.Displacement): void;

                    /**
                     * Runs the Wipe FX controller.
                     * @param config The Wipe FX controller.
                     */
                    onWipe(config: Phaser.FX.Wipe): void;

                    /**
                     * Runs the Bokeh FX controller.
                     * @param config The Bokeh FX controller.
                     */
                    onBokeh(config: Phaser.FX.Bokeh): void;

                    /**
                     * Destroys all shader instances, removes all object references and nulls all external references.
                     */
                    destroy(): this;

                }

                /**
                 * The Light Pipeline is an extension of the Multi Pipeline and uses a custom shader
                 * designed to handle forward diffused rendering of 2D lights in a Scene.
                 * 
                 * The shader works in tandem with Light Game Objects, and optionally texture normal maps,
                 * to provide an ambient illumination effect.
                 * 
                 * If you wish to provide your own shader, you can use the `%LIGHT_COUNT%` declaration in the source,
                 * and it will be automatically replaced at run-time with the total number of configured lights.
                 * 
                 * The maximum number of lights can be set in the Render Config `maxLights` property and defaults to 10.
                 * 
                 * Prior to Phaser v3.50 this pipeline was called the `ForwardDiffuseLightPipeline`.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/Light.frag`.
                 * The vertex shader it uses can be found in `shaders/src/Multi.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * `inTexId` (float, offset 16)
                 * `inTintEffect` (float, offset 20)
                 * `inTint` (vec4, offset 24, normalized)
                 * 
                 * The default shader uniforms for this pipeline are those from the Multi Pipeline, plus:
                 * 
                 * `uMainSampler` (sampler2D)
                 * `uNormSampler` (sampler2D)
                 * `uCamera` (vec4)
                 * `uResolution` (vec2)
                 * `uAmbientLightColor` (vec3)
                 * `uInverseRotationMatrix` (mat3)
                 * `uLights` (Light struct)
                 */
                class LightPipeline extends Phaser.Renderer.WebGL.Pipelines.MultiPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * Stores a default normal map, which is an object with a `glTexture` property that
                     * maps to a 1x1 texture of the color #7f7fff created in the `boot` method.
                     */
                    defaultNormalMap: object;

                    /**
                     * A boolean that is set automatically during `onRender` that determines
                     * if the Scene LightManager is active, or not.
                     */
                    readonly lightsActive: boolean;

                    /**
                     * A persistent calculation vector used when processing the lights.
                     */
                    tempVec2: Phaser.Math.Vector2;

                    /**
                     * Called when the Game has fully booted and the Renderer has finished setting up.
                     * 
                     * By this stage all Game level systems are now in place and you can perform any final
                     * tasks that the pipeline may need that relied on game systems such as the Texture Manager.
                     */
                    boot(): void;

                    /**
                     * Rotates the normal map vectors inversely by the given angle.
                     * Only works in 2D space.
                     * @param rotation The angle of rotation in radians.
                     */
                    setNormalMapRotation(rotation: number): void;

                    /**
                     * Returns the normal map WebGLTexture from the given Game Object.
                     * If the Game Object doesn't have one, it returns the default normal map from this pipeline instead.
                     * @param gameObject The Game Object to get the normal map from.
                     */
                    getNormalMap(gameObject?: Phaser.GameObjects.GameObject): WebGLTexture;

                    /**
                     * Takes a Sprite Game Object, or any object that extends it, and adds it to the batch.
                     * @param gameObject The texture based Game Object to add to the batch.
                     * @param camera The Camera to use for the rendering transform.
                     * @param parentTransformMatrix The transform matrix of the parent container, if set.
                     */
                    batchSprite(gameObject: Phaser.GameObjects.Image | Phaser.GameObjects.Sprite, camera: Phaser.Cameras.Scene2D.Camera, parentTransformMatrix?: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Generic function for batching a textured quad using argument values instead of a Game Object.
                     * @param gameObject Source GameObject.
                     * @param texture Raw WebGLTexture associated with the quad.
                     * @param textureWidth Real texture width.
                     * @param textureHeight Real texture height.
                     * @param srcX X coordinate of the quad.
                     * @param srcY Y coordinate of the quad.
                     * @param srcWidth Width of the quad.
                     * @param srcHeight Height of the quad.
                     * @param scaleX X component of scale.
                     * @param scaleY Y component of scale.
                     * @param rotation Rotation of the quad.
                     * @param flipX Indicates if the quad is horizontally flipped.
                     * @param flipY Indicates if the quad is vertically flipped.
                     * @param scrollFactorX By which factor is the quad affected by the camera horizontal scroll.
                     * @param scrollFactorY By which factor is the quad effected by the camera vertical scroll.
                     * @param displayOriginX Horizontal origin in pixels.
                     * @param displayOriginY Vertical origin in pixels.
                     * @param frameX X coordinate of the texture frame.
                     * @param frameY Y coordinate of the texture frame.
                     * @param frameWidth Width of the texture frame.
                     * @param frameHeight Height of the texture frame.
                     * @param tintTL Tint for top left.
                     * @param tintTR Tint for top right.
                     * @param tintBL Tint for bottom left.
                     * @param tintBR Tint for bottom right.
                     * @param tintEffect The tint effect.
                     * @param uOffset Horizontal offset on texture coordinate.
                     * @param vOffset Vertical offset on texture coordinate.
                     * @param camera Current used camera.
                     * @param parentTransformMatrix Parent container.
                     * @param skipFlip Skip the renderTexture check. Default false.
                     * @param textureUnit Use the currently bound texture unit?
                     */
                    batchTexture(gameObject: Phaser.GameObjects.GameObject, texture: WebGLTexture, textureWidth: number, textureHeight: number, srcX: number, srcY: number, srcWidth: number, srcHeight: number, scaleX: number, scaleY: number, rotation: number, flipX: boolean, flipY: boolean, scrollFactorX: number, scrollFactorY: number, displayOriginX: number, displayOriginY: number, frameX: number, frameY: number, frameWidth: number, frameHeight: number, tintTL: number, tintTR: number, tintBL: number, tintBR: number, tintEffect: number, uOffset: number, vOffset: number, camera: Phaser.Cameras.Scene2D.Camera, parentTransformMatrix: Phaser.GameObjects.Components.TransformMatrix, skipFlip?: boolean, textureUnit?: number): void;

                    /**
                     * Adds a Texture Frame into the batch for rendering.
                     * @param frame The Texture Frame to be rendered.
                     * @param x The horizontal position to render the texture at.
                     * @param y The vertical position to render the texture at.
                     * @param tint The tint color.
                     * @param alpha The alpha value.
                     * @param transformMatrix The Transform Matrix to use for the texture.
                     * @param parentTransformMatrix A parent Transform Matrix.
                     */
                    batchTextureFrame(frame: Phaser.Textures.Frame, x: number, y: number, tint: number, alpha: number, transformMatrix: Phaser.GameObjects.Components.TransformMatrix, parentTransformMatrix?: Phaser.GameObjects.Components.TransformMatrix): void;

                }

                /**
                 * The Mobile Pipeline is the core 2D texture rendering pipeline used by Phaser in WebGL
                 * when the device running the game is detected to be a mobile.
                 * 
                 * You can control the use of this pipeline by setting the Game Configuration
                 * property `autoMobilePipeline`. If set to `false` then all devices will use
                 * the Multi Tint Pipeline. You can also call the `PipelineManager.setDefaultPipeline`
                 * method at run-time, rather than boot-time, to modify the default Game Object
                 * pipeline.
                 * 
                 * Virtually all Game Objects use this pipeline by default, including Sprites, Graphics
                 * and Tilemaps. It handles the batching of quads and tris, as well as methods for
                 * drawing and batching geometry data.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/Mobile.frag`.
                 * The vertex shader it uses can be found in `shaders/src/Mobile.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * `inTexId` (float, offset 16)
                 * `inTintEffect` (float, offset 20)
                 * `inTint` (vec4, offset 24, normalized)
                 * 
                 * Note that `inTexId` isn't used in the shader, it's just kept to allow us
                 * to piggy-back on the Multi Tint Pipeline functions.
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uProjectionMatrix` (mat4)
                 * `uRoundPixels` (int)
                 * `uResolution` (vec2)
                 * `uMainSampler` (sampler2D, or sampler2D array)
                 */
                class MobilePipeline extends Phaser.Renderer.WebGL.Pipelines.MultiPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * Called when the Game has fully booted and the Renderer has finished setting up.
                     * 
                     * By this stage all Game level systems are now in place and you can perform any final
                     * tasks that the pipeline may need that relied on game systems such as the Texture Manager.
                     */
                    boot(): void;

                }

                /**
                 * The Multi Pipeline is the core 2D texture rendering pipeline used by Phaser in WebGL.
                 * Virtually all Game Objects use this pipeline by default, including Sprites, Graphics
                 * and Tilemaps. It handles the batching of quads and tris, as well as methods for
                 * drawing and batching geometry data.
                 * 
                 * Prior to Phaser v3.50 this pipeline was called the `TextureTintPipeline`.
                 * 
                 * In previous versions of Phaser only one single texture unit was supported at any one time.
                 * The Multi Pipeline is an evolution of the old Texture Tint Pipeline, updated to support
                 * multi-textures for increased performance.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/Multi.frag`.
                 * The vertex shader it uses can be found in `shaders/src/Multi.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * `inTexId` (float, offset 16)
                 * `inTintEffect` (float, offset 20)
                 * `inTint` (vec4, offset 24, normalized)
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uProjectionMatrix` (mat4)
                 * `uRoundPixels` (int)
                 * `uResolution` (vec2)
                 * `uMainSampler` (sampler2D, or sampler2D array)
                 * 
                 * If you wish to create a custom pipeline extending from this one, you can use two string
                 * declarations in your fragment shader source: `%count%` and `%forloop%`, where `count` is
                 * used to set the number of `sampler2Ds` available, and `forloop` is a block of GLSL code
                 * that will get the currently bound texture unit.
                 * 
                 * This pipeline will automatically inject that code for you, should those values exist
                 * in your shader source. If you wish to handle this yourself, you can also use the
                 * function `Utils.parseFragmentShaderMaxTextures`.
                 * 
                 * The following fragment shader shows how to use the two variables:
                 * 
                 * ```glsl
                 * #define SHADER_NAME PHASER_MULTI_FS
                 * 
                 * #ifdef GL_FRAGMENT_PRECISION_HIGH
                 * precision highp float;
                 * #else
                 * precision mediump float;
                 * #endif
                 * 
                 * uniform sampler2D uMainSampler[%count%];
                 * 
                 * varying vec2 outTexCoord;
                 * varying float outTexId;
                 * varying float outTintEffect;
                 * varying vec4 outTint;
                 * 
                 * void main ()
                 * {
                 *     vec4 texture;
                 * 
                 *     %forloop%
                 * 
                 *     vec4 texel = vec4(outTint.bgr * outTint.a, outTint.a);
                 * 
                 *     //  Multiply texture tint
                 *     vec4 color = texture * texel;
                 * 
                 *     if (outTintEffect == 1.0)
                 *     {
                 *         //  Solid color + texture alpha
                 *         color.rgb = mix(texture.rgb, outTint.bgr * outTint.a, texture.a);
                 *     }
                 *     else if (outTintEffect == 2.0)
                 *     {
                 *         //  Solid color, no texture
                 *         color = texel;
                 *     }
                 * 
                 *     gl_FragColor = color;
                 * }
                 * ```
                 * 
                 * If you wish to create a pipeline that works from a single texture, or that doesn't have
                 * internal texture iteration, please see the `SinglePipeline` instead. If you wish to create
                 * a special effect, especially one that can impact the pixels around a texture (i.e. such as
                 * a glitch effect) then you should use the PreFX and PostFX Pipelines for this task.
                 */
                class MultiPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * A temporary Transform Matrix, re-used internally during batching by the
                     * Shape Game Objects.
                     */
                    calcMatrix: Phaser.GameObjects.Components.TransformMatrix;

                    /**
                     * Called every time the pipeline is bound by the renderer.
                     * Sets the shader program, vertex buffer and other resources.
                     * Should only be called when changing pipeline.
                     */
                    boot(): void;

                    /**
                     * Takes a Sprite Game Object, or any object that extends it, and adds it to the batch.
                     * @param gameObject The texture based Game Object to add to the batch.
                     * @param camera The Camera to use for the rendering transform.
                     * @param parentTransformMatrix The transform matrix of the parent container, if set.
                     */
                    batchSprite(gameObject: Phaser.GameObjects.Image | Phaser.GameObjects.Sprite, camera: Phaser.Cameras.Scene2D.Camera, parentTransformMatrix?: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Generic function for batching a textured quad using argument values instead of a Game Object.
                     * @param gameObject Source GameObject.
                     * @param texture Raw WebGLTexture associated with the quad.
                     * @param textureWidth Real texture width.
                     * @param textureHeight Real texture height.
                     * @param srcX X coordinate of the quad.
                     * @param srcY Y coordinate of the quad.
                     * @param srcWidth Width of the quad.
                     * @param srcHeight Height of the quad.
                     * @param scaleX X component of scale.
                     * @param scaleY Y component of scale.
                     * @param rotation Rotation of the quad.
                     * @param flipX Indicates if the quad is horizontally flipped.
                     * @param flipY Indicates if the quad is vertically flipped.
                     * @param scrollFactorX By which factor is the quad affected by the camera horizontal scroll.
                     * @param scrollFactorY By which factor is the quad effected by the camera vertical scroll.
                     * @param displayOriginX Horizontal origin in pixels.
                     * @param displayOriginY Vertical origin in pixels.
                     * @param frameX X coordinate of the texture frame.
                     * @param frameY Y coordinate of the texture frame.
                     * @param frameWidth Width of the texture frame.
                     * @param frameHeight Height of the texture frame.
                     * @param tintTL Tint for top left.
                     * @param tintTR Tint for top right.
                     * @param tintBL Tint for bottom left.
                     * @param tintBR Tint for bottom right.
                     * @param tintEffect The tint effect.
                     * @param uOffset Horizontal offset on texture coordinate.
                     * @param vOffset Vertical offset on texture coordinate.
                     * @param camera Current used camera.
                     * @param parentTransformMatrix Parent container.
                     * @param skipFlip Skip the renderTexture check. Default false.
                     * @param textureUnit The texture unit to set (defaults to currently bound if undefined or null)
                     * @param skipPrePost Skip the pre and post manager calls? Default false.
                     */
                    batchTexture(gameObject: Phaser.GameObjects.GameObject, texture: WebGLTexture, textureWidth: number, textureHeight: number, srcX: number, srcY: number, srcWidth: number, srcHeight: number, scaleX: number, scaleY: number, rotation: number, flipX: boolean, flipY: boolean, scrollFactorX: number, scrollFactorY: number, displayOriginX: number, displayOriginY: number, frameX: number, frameY: number, frameWidth: number, frameHeight: number, tintTL: number, tintTR: number, tintBL: number, tintBR: number, tintEffect: number, uOffset: number, vOffset: number, camera: Phaser.Cameras.Scene2D.Camera, parentTransformMatrix: Phaser.GameObjects.Components.TransformMatrix, skipFlip?: boolean, textureUnit?: number, skipPrePost?: boolean): void;

                    /**
                     * Adds a Texture Frame into the batch for rendering.
                     * @param frame The Texture Frame to be rendered.
                     * @param x The horizontal position to render the texture at.
                     * @param y The vertical position to render the texture at.
                     * @param tint The tint color.
                     * @param alpha The alpha value.
                     * @param transformMatrix The Transform Matrix to use for the texture.
                     * @param parentTransformMatrix A parent Transform Matrix.
                     */
                    batchTextureFrame(frame: Phaser.Textures.Frame, x: number, y: number, tint: number, alpha: number, transformMatrix: Phaser.GameObjects.Components.TransformMatrix, parentTransformMatrix?: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Pushes a filled rectangle into the vertex batch.
                     * 
                     * Rectangle factors in the given transform matrices before adding to the batch.
                     * @param x Horizontal top left coordinate of the rectangle.
                     * @param y Vertical top left coordinate of the rectangle.
                     * @param width Width of the rectangle.
                     * @param height Height of the rectangle.
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchFillRect(x: number, y: number, width: number, height: number, currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Pushes a filled triangle into the vertex batch.
                     * 
                     * Triangle factors in the given transform matrices before adding to the batch.
                     * @param x0 Point 0 x coordinate.
                     * @param y0 Point 0 y coordinate.
                     * @param x1 Point 1 x coordinate.
                     * @param y1 Point 1 y coordinate.
                     * @param x2 Point 2 x coordinate.
                     * @param y2 Point 2 y coordinate.
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchFillTriangle(x0: number, y0: number, x1: number, y1: number, x2: number, y2: number, currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Pushes a stroked triangle into the vertex batch.
                     * 
                     * Triangle factors in the given transform matrices before adding to the batch.
                     * 
                     * The triangle is created from 3 lines and drawn using the `batchStrokePath` method.
                     * @param x0 Point 0 x coordinate.
                     * @param y0 Point 0 y coordinate.
                     * @param x1 Point 1 x coordinate.
                     * @param y1 Point 1 y coordinate.
                     * @param x2 Point 2 x coordinate.
                     * @param y2 Point 2 y coordinate.
                     * @param lineWidth The width of the line in pixels.
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchStrokeTriangle(x0: number, y0: number, x1: number, y1: number, x2: number, y2: number, lineWidth: number, currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Adds the given path to the vertex batch for rendering.
                     * 
                     * It works by taking the array of path data and then passing it through Earcut, which
                     * creates a list of polygons. Each polygon is then added to the batch.
                     * 
                     * The path is always automatically closed because it's filled.
                     * @param path Collection of points that represent the path.
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchFillPath(path: Phaser.Types.Math.Vector2Like[], currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Adds the given path to the vertex batch for rendering.
                     * 
                     * It works by taking the array of path data and calling `batchLine` for each section
                     * of the path.
                     * 
                     * The path is optionally closed at the end.
                     * @param path Collection of points that represent the path.
                     * @param lineWidth The width of the line segments in pixels.
                     * @param pathOpen Indicates if the path should be closed or left open.
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchStrokePath(path: Phaser.Types.Math.Vector2Like[], lineWidth: number, pathOpen: boolean, currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Creates a line out of 4 quads and adds it to the vertex batch based on the given line values.
                     * @param ax x coordinate of the start of the line.
                     * @param ay y coordinate of the start of the line.
                     * @param bx x coordinate of the end of the line.
                     * @param by y coordinate of the end of the line.
                     * @param aLineWidth Width of the start of the line.
                     * @param bLineWidth Width of the end of the line.
                     * @param index If this line is part of a multi-line draw, the index of the line in the draw.
                     * @param closePath Does this line close a multi-line path?
                     * @param currentMatrix The current transform.
                     * @param parentMatrix The parent transform.
                     */
                    batchLine(ax: number, ay: number, bx: number, by: number, aLineWidth: number, bLineWidth: number, index: number, closePath: boolean, currentMatrix: Phaser.GameObjects.Components.TransformMatrix, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

                    /**
                     * Destroys all shader instances, removes all object references and nulls all external references.
                     */
                    destroy(): this;

                }

                /**
                 * The Point Light Pipeline handles rendering the Point Light Game Objects in WebGL.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/PointLight.frag`.
                 * The vertex shader it uses can be found in `shaders/src/PointLight.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2)
                 * `inLightPosition` (vec2)
                 * `inLightRadius` (float)
                 * `inLightAttenuation` (float)
                 * `inLightColor` (vec4)
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uProjectionMatrix` (mat4)
                 * `uResolution` (vec2)
                 * `uCameraZoom` (sampler2D)
                 */
                class PointLightPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * Adds a Point Light Game Object to the batch, flushing if required.
                     * @param light The Point Light Game Object.
                     * @param camera The camera rendering the Point Light.
                     * @param x0 The top-left x position.
                     * @param y0 The top-left y position.
                     * @param x1 The bottom-left x position.
                     * @param y1 The bottom-left y position.
                     * @param x2 The bottom-right x position.
                     * @param y2 The bottom-right y position.
                     * @param x3 The top-right x position.
                     * @param y3 The top-right y position.
                     * @param lightX The horizontal center of the light.
                     * @param lightY The vertical center of the light.
                     */
                    batchPointLight(light: Phaser.GameObjects.PointLight, camera: Phaser.Cameras.Scene2D.Camera, x0: number, y0: number, x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, lightX: number, lightY: number): void;

                    /**
                     * Adds a single Point Light vertex to the current vertex buffer and increments the
                     * `vertexCount` property by 1.
                     * 
                     * This method is called directly by `batchPointLight`.
                     * @param x The vertex x position.
                     * @param y The vertex y position.
                     * @param lightX The horizontal center of the light.
                     * @param lightY The vertical center of the light.
                     * @param radius The radius of the light.
                     * @param attenuation The attenuation of the light.
                     * @param r The red color channel of the light.
                     * @param g The green color channel of the light.
                     * @param b The blue color channel of the light.
                     * @param a The alpha color channel of the light.
                     */
                    batchLightVert(x: number, y: number, lightX: number, lightY: number, radius: number, attenuation: number, r: number, g: number, b: number, a: number): void;

                }

                /**
                 * The Post FX Pipeline is a special kind of pipeline specifically for handling post
                 * processing effects. Where-as a standard Pipeline allows you to control the process
                 * of rendering Game Objects by configuring the shaders and attributes used to draw them,
                 * a Post FX Pipeline is designed to allow you to apply processing _after_ the Game Object/s
                 * have been rendered. Typical examples of post processing effects are bloom filters,
                 * blurs, light effects and color manipulation.
                 * 
                 * The pipeline works by creating a tiny vertex buffer with just one single hard-coded quad
                 * in it. Game Objects can have a Post Pipeline set on them. Those objects are then rendered
                 * using their standard pipeline, but are redirected to the Render Targets owned by the
                 * post pipeline, which can then apply their own shaders and effects, before passing them
                 * back to the main renderer.
                 * 
                 * Please see the Phaser 3 examples for further details on this extensive subject.
                 * 
                 * The default fragment shader it uses can be found in `shaders/src/PostFX.frag`.
                 * The default vertex shader it uses can be found in `shaders/src/Quad.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * 
                 * The vertices array layout is:
                 * 
                 * -1,  1   B----C   1,  1
                 *  0,  1   |   /|   1,  1
                 *          |  / |
                 *          | /  |
                 *          |/   |
                 * -1, -1   A----D   1, -1
                 *  0,  0            1,  0
                 * 
                 * A = -1, -1 (pos) and 0, 0 (uv)
                 * B = -1,  1 (pos) and 0, 1 (uv)
                 * C =  1,  1 (pos) and 1, 1 (uv)
                 * D =  1, -1 (pos) and 1, 0 (uv)
                 * 
                 * First tri: A, B, C
                 * Second tri: A, C, D
                 * 
                 * Array index:
                 * 
                 * 0  = Tri 1 - Vert A - x pos
                 * 1  = Tri 1 - Vert A - y pos
                 * 2  = Tri 1 - Vert A - uv u
                 * 3  = Tri 1 - Vert A - uv v
                 * 
                 * 4  = Tri 1 - Vert B - x pos
                 * 5  = Tri 1 - Vert B - y pos
                 * 6  = Tri 1 - Vert B - uv u
                 * 7  = Tri 1 - Vert B - uv v
                 * 
                 * 8  = Tri 1 - Vert C - x pos
                 * 9  = Tri 1 - Vert C - y pos
                 * 10 = Tri 1 - Vert C - uv u
                 * 11 = Tri 1 - Vert C - uv v
                 * 
                 * 12 = Tri 2 - Vert A - x pos
                 * 13 = Tri 2 - Vert A - y pos
                 * 14 = Tri 2 - Vert A - uv u
                 * 15 = Tri 2 - Vert A - uv v
                 * 
                 * 16 = Tri 2 - Vert C - x pos
                 * 17 = Tri 2 - Vert C - y pos
                 * 18 = Tri 2 - Vert C - uv u
                 * 19 = Tri 2 - Vert C - uv v
                 * 
                 * 20 = Tri 2 - Vert D - x pos
                 * 21 = Tri 2 - Vert D - y pos
                 * 22 = Tri 2 - Vert D - uv u
                 * 23 = Tri 2 - Vert D - uv v
                 */
                class PostFXPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * If this Post Pipeline belongs to a Game Object or Camera,
                     * this property contains a reference to it.
                     */
                    gameObject: Phaser.GameObjects.GameObject | Phaser.Cameras.Scene2D.Camera;

                    /**
                     * If this Post Pipeline belongs to an FX Controller, this is a
                     * reference to it.
                     */
                    controller: Phaser.FX.Controller;

                    /**
                     * A Color Matrix instance belonging to this pipeline.
                     * 
                     * Used during calls to the `drawFrame` method.
                     */
                    colorMatrix: Phaser.Display.ColorMatrix;

                    /**
                     * A reference to the Full Frame 1 Render Target that belongs to the
                     * Utility Pipeline. This property is set during the `boot` method.
                     * 
                     * This Render Target is the full size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    fullFrame1: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Full Frame 2 Render Target that belongs to the
                     * Utility Pipeline. This property is set during the `boot` method.
                     * 
                     * This Render Target is the full size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    fullFrame2: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Half Frame 1 Render Target that belongs to the
                     * Utility Pipeline. This property is set during the `boot` method.
                     * 
                     * This Render Target is half the size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    halfFrame1: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Half Frame 2 Render Target that belongs to the
                     * Utility Pipeline. This property is set during the `boot` method.
                     * 
                     * This Render Target is half the size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    halfFrame2: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * This method is called once, when this Post FX Pipeline needs to be used.
                     * 
                     * Normally, pipelines will boot automatically, ready for instant-use, but Post FX
                     * Pipelines create quite a lot of internal resources, such as Render Targets, so
                     * they don't boot until they are told to do so by the Pipeline Manager, when an
                     * actual Game Object needs to use them.
                     */
                    bootFX(): void;

                    /**
                     * This method is called as a result of the `WebGLPipeline.batchQuad` method, right after a quad
                     * belonging to a Game Object has been added to the batch. When this is called, the
                     * renderer has just performed a flush.
                     * 
                     * It calls the `onDraw` hook followed by the `onPostBatch` hook, which can be used to perform
                     * additional Post FX Pipeline processing.
                     * 
                     * It is also called as part of the `PipelineManager.postBatch` method when processing Post FX Pipelines.
                     * @param gameObject The Game Object or Camera that invoked this pipeline, if any.
                     */
                    postBatch(gameObject?: Phaser.GameObjects.GameObject | Phaser.Cameras.Scene2D.Camera): this;

                    /**
                     * Returns the FX Controller for this Post FX Pipeline.
                     * 
                     * This is called internally and not typically required outside.
                     * @param controller An FX Controller, or undefined.
                     */
                    getController(controller?: Phaser.FX.Controller): Phaser.FX.Controller | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * This method does _not_ bind a shader. It uses whatever shader
                     * is currently bound in this pipeline. It also does _not_ clear
                     * the frame buffers after use. You should take care of both of
                     * these things if you call this method directly.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     */
                    copySprite(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * You can optionally set the brightness factor of the copy.
                     * 
                     * The difference between this method and `drawFrame` is that this method
                     * uses a faster copy shader, where only the brightness can be modified.
                     * If you need color level manipulation, see `drawFrame` instead.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param brightness The brightness value applied to the frame copy. Default 1.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    copyFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean): void;

                    /**
                     * Pops the framebuffer from the renderers FBO stack and sets that as the active target,
                     * then draws the `source` Render Target to it. It then resets the renderer textures.
                     * 
                     * This should be done when you need to draw the _final_ results of a pipeline to the game
                     * canvas, or the next framebuffer in line on the FBO stack. You should only call this once
                     * in the `onDraw` handler and it should be the final thing called. Be careful not to call
                     * this if you need to actually use the pipeline shader, instead of the copy shader. In
                     * those cases, use the `bindAndDraw` method.
                     * @param source The Render Target to draw from.
                     */
                    copyToGame(source: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target, using this pipelines
                     * Color Matrix.
                     * 
                     * The difference between this method and `copyFrame` is that this method
                     * uses a color matrix shader, where you have full control over the luminance
                     * values used during the copy. If you don't need this, you can use the faster
                     * `copyFrame` method instead.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    drawFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using a linear blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    blendFrames(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using an additive blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    blendFramesAdditive(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): void;

                    /**
                     * Clears the given Render Target.
                     * @param target The Render Target to clear.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    clearFrame(target: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * The difference with this copy is that no resizing takes place. If the `source`
                     * Render Target is larger than the `target` then only a portion the same size as
                     * the `target` dimensions is copied across.
                     * 
                     * You can optionally set the brightness factor of the copy.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param brightness The brightness value applied to the frame copy. Default 1.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param eraseMode Erase source from target using ERASE Blend Mode? Default false.
                     */
                    blitFrame(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean, eraseMode?: boolean): void;

                    /**
                     * Binds the `source` Render Target and then copies a section of it to the `target` Render Target.
                     * 
                     * This method is extremely fast because it uses `gl.copyTexSubImage2D` and doesn't
                     * require the use of any shaders. Remember the coordinates are given in standard WebGL format,
                     * where x and y specify the lower-left corner of the section, not the top-left. Also, the
                     * copy entirely replaces the contents of the target texture, no 'merging' or 'blending' takes
                     * place.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param x The x coordinate of the lower left corner where to start copying.
                     * @param y The y coordinate of the lower left corner where to start copying.
                     * @param width The width of the texture.
                     * @param height The height of the texture.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    copyFrameRect(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, x: number, y: number, width: number, height: number, clear?: boolean, clearAlpha?: boolean): void;

                    /**
                     * Binds this pipeline and draws the `source` Render Target to the `target` Render Target.
                     * 
                     * If no `target` is specified, it will pop the framebuffer from the Renderers FBO stack
                     * and use that instead, which should be done when you need to draw the final results of
                     * this pipeline to the game canvas.
                     * 
                     * You can optionally set the shader to be used for the draw here, if this is a multi-shader
                     * pipeline. By default `currentShader` will be used. If you need to set a shader but not
                     * a target, just pass `null` as the `target` parameter.
                     * @param source The Render Target to draw from.
                     * @param target The Render Target to draw to. If not set, it will pop the fbo from the stack.
                     * @param clear Clear the target before copying? Only used if `target` parameter is set. Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param currentShader The shader to use during the draw.
                     */
                    bindAndDraw(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, clear?: boolean, clearAlpha?: boolean, currentShader?: Phaser.Renderer.WebGL.WebGLShader): void;

                    /**
                     * Destroys all shader instances, removes all object references and nulls all external references.
                     */
                    destroy(): this;

                }

                /**
                 * The Pre FX Pipeline is a special kind of pipeline designed specifically for applying
                 * special effects to Game Objects before they are rendered. Where-as the Post FX Pipeline applies an effect _after_ the
                 * object has been rendered, the Pre FX Pipeline allows you to control the rendering of
                 * the object itself - passing it off to its own texture, where multi-buffer compositing
                 * can take place.
                 * 
                 * You can only use the PreFX Pipeline on the following types of Game Objects, or those
                 * that extend from them:
                 * 
                 * Sprite
                 * Image
                 * Text
                 * TileSprite
                 * RenderTexture
                 * Video
                 */
                class PreFXPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * A reference to the Draw Sprite Shader belonging to this Pipeline.
                     * 
                     * This shader is used when the sprite is drawn to this fbo (or to the game if drawToFrame is false)
                     * 
                     * This property is set during the `boot` method.
                     */
                    drawSpriteShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Copy Shader belonging to this Pipeline.
                     * 
                     * This shader is used when you call the `copySprite` method.
                     * 
                     * This property is set during the `boot` method.
                     */
                    copyShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Game Draw Shader belonging to this Pipeline.
                     * 
                     * This shader draws the fbo to the game.
                     * 
                     * This property is set during the `boot` method.
                     */
                    gameShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Color Matrix Shader belonging to this Pipeline.
                     * 
                     * This property is set during the `boot` method.
                     */
                    colorMatrixShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * Raw byte buffer of vertices used specifically during the copySprite method.
                     */
                    readonly quadVertexData: ArrayBuffer;

                    /**
                     * The WebGLBuffer that holds the quadVertexData.
                     */
                    readonly quadVertexBuffer: WebGLBuffer;

                    /**
                     * Float32 view of the quad array buffer.
                     */
                    quadVertexViewF32: Float32Array;

                    /**
                     * The full-screen Render Target that the sprite is first drawn to.
                     */
                    fsTarget: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * Handles the resizing of the quad vertex data.
                     * @param width The new width of the quad.
                     * @param height The new height of the quad.
                     */
                    onResize(width: number, height: number): void;

                    /**
                     * Adds the vertices data into the batch and flushes if full.
                     * 
                     * Assumes 6 vertices in the following arrangement:
                     * 
                     * ```
                     * 0----3
                     * |\  B|
                     * | \  |
                     * |  \ |
                     * | A \|
                     * |    \
                     * 1----2
                     * ```
                     * 
                     * Where x0 / y0 = 0, x1 / y1 = 1, x2 / y2 = 2 and x3 / y3 = 3
                     * @param gameObject The Game Object, if any, drawing this quad.
                     * @param x0 The top-left x position.
                     * @param y0 The top-left y position.
                     * @param x1 The bottom-left x position.
                     * @param y1 The bottom-left y position.
                     * @param x2 The bottom-right x position.
                     * @param y2 The bottom-right y position.
                     * @param x3 The top-right x position.
                     * @param y3 The top-right y position.
                     * @param u0 UV u0 value.
                     * @param v0 UV v0 value.
                     * @param u1 UV u1 value.
                     * @param v1 UV v1 value.
                     * @param tintTL The top-left tint color value.
                     * @param tintTR The top-right tint color value.
                     * @param tintBL The bottom-left tint color value.
                     * @param tintBR The bottom-right tint color value.
                     * @param tintEffect The tint effect for the shader to use.
                     * @param texture WebGLTexture that will be assigned to the current batch if a flush occurs.
                     */
                    batchQuad(gameObject: Phaser.GameObjects.GameObject | null, x0: number, y0: number, x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, u0: number, v0: number, u1: number, v1: number, tintTL: number, tintTR: number, tintBL: number, tintBR: number, tintEffect: number | boolean, texture?: WebGLTexture): boolean;

                    /**
                     * This callback is invoked when a sprite is drawn by this pipeline.
                     * 
                     * It will fire after the shader has been set, but before the sprite has been drawn,
                     * so use it to set any additional uniforms you may need.
                     * 
                     * Note: Manipulating the Sprite during this callback will _not_ change how it is drawn to the Render Target.
                     * @param gameObject The Sprite being drawn.
                     * @param target The Render Target the Sprite will be drawn to.
                     */
                    onDrawSprite(gameObject: Phaser.GameObjects.Sprite, target: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * This callback is invoked when you call the `copySprite` method.
                     * 
                     * It will fire after the shader has been set, but before the source target has been copied,
                     * so use it to set any additional uniforms you may need.
                     * 
                     * Note: Manipulating the Sprite during this callback will _not_ change the Render Targets.
                     * @param source The source Render Target being copied from.
                     * @param target The target Render Target that will be copied to.
                     * @param gameObject The Sprite being copied.
                     */
                    onCopySprite(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, gameObject: Phaser.GameObjects.Sprite): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * No target resizing takes place. If the `source` Render Target is larger than the `target`,
                     * then only a portion the same size as the `target` dimensions is copied across.
                     * 
                     * Calling this method will invoke the `onCopySprite` handler and will also call
                     * the `onFXCopy` callback on the Sprite. Both of these happen prior to the copy, allowing you
                     * to use them to set shader uniforms and other values.
                     * 
                     * You can optionally pass in a ColorMatrix. If so, it will use the ColorMatrix shader
                     * during the copy, allowing you to manipulate the colors to a fine degree.
                     * See the `ColorMatrix` class for more details.
                     * @param source The source Render Target being copied from.
                     * @param target The target Render Target that will be copied to.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param eraseMode Erase source from target using ERASE Blend Mode? Default false.
                     * @param colorMatrix Optional ColorMatrix to use when copying the Sprite.
                     * @param shader The shader to use to copy the target. Defaults to the `copyShader`.
                     */
                    copySprite(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, clear?: boolean, clearAlpha?: boolean, eraseMode?: boolean, colorMatrix?: Phaser.Display.ColorMatrix, shader?: Phaser.Renderer.WebGL.WebGLShader): void;

                    /**
                     * Draws the `source` Render Target to the `target` Render Target.
                     * 
                     * This is done using whatever the currently bound shader is. This method does
                     * not set a shader. All it does is bind the source texture, set the viewport and UVs
                     * then bind the target framebuffer, clears it and draws the source to it.
                     * 
                     * At the end a null framebuffer is bound. No other clearing-up takes place, so
                     * use this method carefully.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     */
                    copy(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using a linear blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    blendFrames(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using an additive blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    blendFramesAdditive(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): void;

                    /**
                     * This method will copy the given Render Target to the game canvas using the `copyShader`.
                     * 
                     * This applies the results of the copy shader during the draw.
                     * 
                     * If you wish to copy the target without any effects see the `copyToGame` method instead.
                     * 
                     * This method should be the final thing called in your pipeline.
                     * @param source The Render Target to draw to the game.
                     */
                    drawToGame(source: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * This method will copy the given Render Target to the game canvas using the `gameShader`.
                     * 
                     * Unless you've changed it, the `gameShader` copies the target without modifying it, just
                     * ensuring it is placed in the correct location on the canvas.
                     * 
                     * If you wish to draw the target with and apply the fragment shader at the same time,
                     * see the `drawToGame` method instead.
                     * 
                     * This method should be the final thing called in your pipeline.
                     * @param source The Render Target to copy to the game.
                     */
                    copyToGame(source: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * This method is called by `drawToGame` and `copyToGame`. It takes the source Render Target
                     * and copies it back to the game canvas, or the next frame buffer in the stack, and should
                     * be considered the very last thing this pipeline does.
                     * 
                     * You don't normally need to call this method, or override it, however it is left public
                     * should you wish to do so.
                     * 
                     * Note that it does _not_ set a shader. You should do this yourself if invoking this.
                     * @param source The Render Target to draw to the game.
                     */
                    bindAndDraw(source: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * This method is called every time the `batchSprite` method is called and is passed a
                     * reference to the current render target.
                     * 
                     * If you override this method, then it should make sure it calls either the
                     * `drawToGame` or `copyToGame` methods as the final thing it does. However, you can do as
                     * much additional processing as you like prior to this.
                     * @param target The Render Target to draw to the game.
                     * @param swapTarget The Swap Render Target, useful for double-buffer effects.
                     * @param altSwapTarget The Swap Render Target, useful for double-buffer effects.
                     */
                    onDraw(target: Phaser.Renderer.WebGL.RenderTarget, swapTarget?: Phaser.Renderer.WebGL.RenderTarget, altSwapTarget?: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Set the UV values for the 6 vertices that make up the quad used by the copy shader.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     * @param uA The u value of vertex A.
                     * @param vA The v value of vertex A.
                     * @param uB The u value of vertex B.
                     * @param vB The v value of vertex B.
                     * @param uC The u value of vertex C.
                     * @param vC The v value of vertex C.
                     * @param uD The u value of vertex D.
                     * @param vD The v value of vertex D.
                     */
                    setUVs(uA: number, vA: number, uB: number, vB: number, uC: number, vC: number, uD: number, vD: number): void;

                    /**
                     * Sets the vertex UV coordinates of the quad used by the copy shaders
                     * so that they correctly adjust the texture coordinates for a blit frame effect.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     */
                    setTargetUVs(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Resets the quad vertice UV values to their default settings.
                     * 
                     * The quad is used by the copy shader in this pipeline.
                     */
                    resetUVs(): void;

                    /**
                     * Destroys all shader instances, removes all object references and nulls all external references.
                     */
                    destroy(): this;

                }

                /**
                 * The Rope Pipeline is a variation of the Multi Pipeline that uses a `TRIANGLE_STRIP` for
                 * its topology, instead of TRIANGLES. This is primarily used by the Rope Game Object,
                 * or anything that extends it.
                 * 
                 * Prior to Phaser v3.50 this pipeline was called the `TextureTintStripPipeline`.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/Multi.frag`.
                 * The vertex shader it uses can be found in `shaders/src/Multi.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * `inTexId` (float, offset 16)
                 * `inTintEffect` (float, offset 20)
                 * `inTint` (vec4, offset 24, normalized)
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uProjectionMatrix` (mat4)
                 * `uRoundPixels` (int)
                 * `uResolution` (vec2)
                 * `uMainSampler` (sampler2D, or sampler2D array)
                 * 
                 * The pipeline is structurally identical to the Multi Pipeline and should be treated as such.
                 */
                class RopePipeline extends Phaser.Renderer.WebGL.Pipelines.MultiPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                }

                /**
                 * The Single Pipeline is a special version of the Multi Pipeline that only ever
                 * uses one texture, bound to texture unit zero. Although not as efficient as the
                 * Multi Pipeline, it provides an easier way to create custom pipelines that only require
                 * a single bound texture.
                 * 
                 * Prior to Phaser v3.50 this pipeline didn't exist, but could be compared to the old `TextureTintPipeline`.
                 * 
                 * The fragment shader it uses can be found in `shaders/src/Single.frag`.
                 * The vertex shader it uses can be found in `shaders/src/Single.vert`.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * `inTexId` (float, offset 16) - this value is always zero in the Single Pipeline
                 * `inTintEffect` (float, offset 20)
                 * `inTint` (vec4, offset 24, normalized)
                 * 
                 * The default shader uniforms for this pipeline are:
                 * 
                 * `uProjectionMatrix` (mat4)
                 * `uRoundPixels` (int)
                 * `uResolution` (vec2)
                 * `uMainSampler` (sampler2D, or sampler2D array)
                 */
                class SinglePipeline extends Phaser.Renderer.WebGL.Pipelines.MultiPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                }

                /**
                 * The Utility Pipeline is a special-use pipeline that belongs to the Pipeline Manager.
                 * 
                 * It provides 4 shaders and handy associated methods:
                 * 
                 * 1) Copy Shader. A fast texture to texture copy shader with optional brightness setting.
                 * 2) Additive Blend Mode Shader. Blends two textures using an additive blend mode.
                 * 3) Linear Blend Mode Shader. Blends two textures using a linear blend mode.
                 * 4) Color Matrix Copy Shader. Draws a texture to a target using a Color Matrix.
                 * 
                 * You do not extend this pipeline, but instead get a reference to it from the Pipeline
                 * Manager via the `setUtility` method. You can also access methods such as `copyFrame`
                 * directly from the Pipeline Manager.
                 * 
                 * This pipeline provides methods for manipulating framebuffer backed textures, such as
                 * copying or blending one texture to another, copying a portion of a texture, additively
                 * blending two textures, flipping textures and more.
                 * 
                 * The default shader attributes for this pipeline are:
                 * 
                 * `inPosition` (vec2, offset 0)
                 * `inTexCoord` (vec2, offset 8)
                 * 
                 * This pipeline has a hard-coded batch size of 1 and a hard coded set of vertices.
                 */
                class UtilityPipeline extends Phaser.Renderer.WebGL.WebGLPipeline {
                    /**
                     * 
                     * @param config The configuration options for this pipeline.
                     */
                    constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                    /**
                     * A default Color Matrix, used by the Color Matrix Shader when one
                     * isn't provided.
                     */
                    colorMatrix: Phaser.Display.ColorMatrix;

                    /**
                     * A reference to the Copy Shader belonging to this Utility Pipeline.
                     * 
                     * This property is set during the `boot` method.
                     */
                    copyShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Additive Blend Shader belonging to this Utility Pipeline.
                     * 
                     * This property is set during the `boot` method.
                     */
                    addShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Linear Blend Shader belonging to this Utility Pipeline.
                     * 
                     * This property is set during the `boot` method.
                     */
                    linearShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Color Matrix Shader belonging to this Utility Pipeline.
                     * 
                     * This property is set during the `boot` method.
                     */
                    colorMatrixShader: Phaser.Renderer.WebGL.WebGLShader;

                    /**
                     * A reference to the Full Frame 1 Render Target.
                     * 
                     * This property is set during the `boot` method.
                     * 
                     * This Render Target is the full size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    fullFrame1: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Full Frame 2 Render Target.
                     * 
                     * This property is set during the `boot` method.
                     * 
                     * This Render Target is the full size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    fullFrame2: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Half Frame 1 Render Target.
                     * 
                     * This property is set during the `boot` method.
                     * 
                     * This Render Target is half the size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    halfFrame1: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * A reference to the Half Frame 2 Render Target.
                     * 
                     * This property is set during the `boot` method.
                     * 
                     * This Render Target is half the size of the renderer.
                     * 
                     * You can use this directly in Post FX Pipelines for multi-target effects.
                     * However, be aware that these targets are shared between all post fx pipelines.
                     */
                    halfFrame2: Phaser.Renderer.WebGL.RenderTarget;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * You can optionally set the brightness factor of the copy.
                     * 
                     * The difference between this method and `drawFrame` is that this method
                     * uses a faster copy shader, where only the brightness can be modified.
                     * If you need color level manipulation, see `drawFrame` instead.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param brightness The brightness value applied to the frame copy. Default 1.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    copyFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target.
                     * 
                     * The difference with this copy is that no resizing takes place. If the `source`
                     * Render Target is larger than the `target` then only a portion the same size as
                     * the `target` dimensions is copied across.
                     * 
                     * You can optionally set the brightness factor of the copy.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param brightness The brightness value applied to the frame copy. Default 1.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param eraseMode Erase source from target using ERASE Blend Mode? Default false.
                     * @param flipY Flip the UV on the Y axis before drawing? Default false.
                     */
                    blitFrame(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, brightness?: number, clear?: boolean, clearAlpha?: boolean, eraseMode?: boolean, flipY?: boolean): void;

                    /**
                     * Binds the `source` Render Target and then copies a section of it to the `target` Render Target.
                     * 
                     * This method is extremely fast because it uses `gl.copyTexSubImage2D` and doesn't
                     * require the use of any shaders. Remember the coordinates are given in standard WebGL format,
                     * where x and y specify the lower-left corner of the section, not the top-left. Also, the
                     * copy entirely replaces the contents of the target texture, no 'merging' or 'blending' takes
                     * place.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param x The x coordinate of the lower left corner where to start copying.
                     * @param y The y coordinate of the lower left corner where to start copying.
                     * @param width The width of the texture.
                     * @param height The height of the texture.
                     * @param clear Clear the target before copying? Default true.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    copyFrameRect(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget, x: number, y: number, width: number, height: number, clear?: boolean, clearAlpha?: boolean): void;

                    /**
                     * Pops the framebuffer from the renderers FBO stack and sets that as the active target,
                     * then draws the `source` Render Target to it. It then resets the renderer textures.
                     * 
                     * This should be done when you need to draw the _final_ results of a pipeline to the game
                     * canvas, or the next framebuffer in line on the FBO stack. You should only call this once
                     * in the `onDraw` handler and it should be the final thing called. Be careful not to call
                     * this if you need to actually use the pipeline shader, instead of the copy shader. In
                     * those cases, use the `bindAndDraw` method.
                     * @param source The Render Target to draw from.
                     */
                    copyToGame(source: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Copy the `source` Render Target to the `target` Render Target, using the
                     * given Color Matrix.
                     * 
                     * The difference between this method and `copyFrame` is that this method
                     * uses a color matrix shader, where you have full control over the luminance
                     * values used during the copy. If you don't need this, you can use the faster
                     * `copyFrame` method instead.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param colorMatrix The Color Matrix to use when performing the draw.
                     */
                    drawFrame(source: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean, colorMatrix?: Phaser.Display.ColorMatrix): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using a linear blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     * @param blendShader The shader to use during the blend copy.
                     */
                    blendFrames(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean, blendShader?: Phaser.Renderer.WebGL.WebGLShader): void;

                    /**
                     * Draws the `source1` and `source2` Render Targets to the `target` Render Target
                     * using an additive blend effect, which is controlled by the `strength` parameter.
                     * @param source1 The first source Render Target.
                     * @param source2 The second source Render Target.
                     * @param target The target Render Target.
                     * @param strength The strength of the blend. Default 1.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    blendFramesAdditive(source1: Phaser.Renderer.WebGL.RenderTarget, source2: Phaser.Renderer.WebGL.RenderTarget, target?: Phaser.Renderer.WebGL.RenderTarget, strength?: number, clearAlpha?: boolean): void;

                    /**
                     * Clears the given Render Target.
                     * @param target The Render Target to clear.
                     * @param clearAlpha Clear the alpha channel when running `gl.clear` on the target? Default true.
                     */
                    clearFrame(target: Phaser.Renderer.WebGL.RenderTarget, clearAlpha?: boolean): void;

                    /**
                     * Set the UV values for the 6 vertices that make up the quad used by the shaders
                     * in the Utility Pipeline.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     * @param uA The u value of vertex A.
                     * @param vA The v value of vertex A.
                     * @param uB The u value of vertex B.
                     * @param vB The v value of vertex B.
                     * @param uC The u value of vertex C.
                     * @param vC The v value of vertex C.
                     * @param uD The u value of vertex D.
                     * @param vD The v value of vertex D.
                     */
                    setUVs(uA: number, vA: number, uB: number, vB: number, uC: number, vC: number, uD: number, vD: number): void;

                    /**
                     * Sets the vertex UV coordinates of the quad used by the shaders in the Utility Pipeline
                     * so that they correctly adjust the texture coordinates for a blit frame effect.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     * @param source The source Render Target.
                     * @param target The target Render Target.
                     */
                    setTargetUVs(source: Phaser.Renderer.WebGL.RenderTarget, target: Phaser.Renderer.WebGL.RenderTarget): void;

                    /**
                     * Horizontally flips the UV coordinates of the quad used by the shaders in this
                     * Utility Pipeline.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     */
                    flipX(): void;

                    /**
                     * Vertically flips the UV coordinates of the quad used by the shaders in this
                     * Utility Pipeline.
                     * 
                     * Be sure to call `resetUVs` once you have finished manipulating the UV coordinates.
                     */
                    flipY(): void;

                    /**
                     * Resets the quad vertice UV values to their default settings.
                     * 
                     * The quad is used by all shaders of the Utility Pipeline.
                     */
                    resetUVs(): void;

                }

            }

            /**
             * A Render Target encapsulates a WebGL framebuffer and the WebGL Texture that displays it.
             * 
             * Instances of this class are typically created by, and belong to WebGL Pipelines, however
             * other Game Objects and classes can take advantage of Render Targets as well.
             */
            class RenderTarget {
                /**
                 * 
                 * @param renderer A reference to the WebGLRenderer.
                 * @param width The width of this Render Target.
                 * @param height The height of this Render Target.
                 * @param scale A value between 0 and 1. Controls the size of this Render Target in relation to the Renderer. Default 1.
                 * @param minFilter The minFilter mode of the texture when created. 0 is `LINEAR`, 1 is `NEAREST`. Default 0.
                 * @param autoClear Automatically clear this framebuffer when bound? Default true.
                 * @param autoResize Automatically resize this Render Target if the WebGL Renderer resizes? Default false.
                 * @param addDepthBuffer Add a DEPTH_STENCIL and attachment to this Render Target? Default true.
                 * @param forceClamp Force the texture to use the CLAMP_TO_EDGE wrap mode, even if a power of two? Default true.
                 */
                constructor(renderer: Phaser.Renderer.WebGL.WebGLRenderer, width: number, height: number, scale?: number, minFilter?: number, autoClear?: boolean, autoResize?: boolean, addDepthBuffer?: boolean, forceClamp?: boolean);

                /**
                 * A reference to the WebGLRenderer instance.
                 */
                renderer: Phaser.Renderer.WebGL.WebGLRenderer;

                /**
                 * The WebGLFramebuffer of this Render Target.
                 * 
                 * This is created in the `RenderTarget.resize` method.
                 */
                framebuffer: WebGLFramebuffer;

                /**
                 * The WebGLTexture of this Render Target.
                 * 
                 * This is created in the `RenderTarget.resize` method.
                 */
                texture: WebGLTexture;

                /**
                 * The width of the texture.
                 */
                readonly width: number;

                /**
                 * The height of the texture.
                 */
                readonly height: number;

                /**
                 * A value between 0 and 1. Controls the size of this Render Target in relation to the Renderer.
                 * 
                 * A value of 1 matches it. 0.5 makes the Render Target half the size of the renderer, etc.
                 */
                scale: number;

                /**
                 * The minFilter mode of the texture. 0 is `LINEAR`, 1 is `NEAREST`.
                 */
                minFilter: number;

                /**
                 * Controls if this Render Target is automatically cleared (via `gl.COLOR_BUFFER_BIT`)
                 * during the `RenderTarget.bind` method.
                 * 
                 * If you need more control over how, or if, the target is cleared, you can disable
                 * this via the config on creation, or even toggle it directly at runtime.
                 */
                autoClear: boolean;

                /**
                 * Does this Render Target automatically resize when the WebGL Renderer does?
                 * 
                 * Modify this property via the `setAutoResize` method.
                 */
                readonly autoResize: boolean;

                /**
                 * Does this Render Target have a Depth Buffer?
                 */
                readonly hasDepthBuffer: boolean;

                /**
                 * Force the WebGL Texture to use the CLAMP_TO_EDGE wrap mode, even if a power of two?
                 * 
                 * If `false` it will use `gl.REPEAT` instead, which may be required for some effects, such
                 * as using this Render Target as a texture for a Shader.
                 */
                forceClamp: boolean;

                /**
                 * Sets if this Render Target should automatically resize when the WebGL Renderer
                 * emits a resize event.
                 * @param autoResize Automatically resize this Render Target when the WebGL Renderer resizes?
                 */
                setAutoResize(autoResize: boolean): this;

                /**
                 * Resizes this Render Target.
                 * 
                 * Deletes both the frame buffer and texture, if they exist and then re-creates
                 * them using the new sizes.
                 * 
                 * This method is called automatically by the pipeline during its resize handler.
                 * @param width The new width of this Render Target.
                 * @param height The new height of this Render Target.
                 */
                resize(width: number, height: number): this;

                /**
                 * Checks if this Render Target will resize, or not, if given the new
                 * width and height values.
                 * @param width The new width of this Render Target.
                 * @param height The new height of this Render Target.
                 */
                willResize(width: number, height: number): boolean;

                /**
                 * Pushes this Render Target as the current frame buffer of the renderer.
                 * 
                 * If `autoClear` is set, then clears the texture.
                 * 
                 * If `adjustViewport` is `true` then it will flush the renderer and then adjust the GL viewport.
                 * @param adjustViewport Adjust the GL viewport by calling `RenderTarget.adjustViewport` ? Default false.
                 * @param width Optional new width of this Render Target.
                 * @param height Optional new height of this Render Target.
                 */
                bind(adjustViewport?: boolean, width?: number, height?: number): void;

                /**
                 * Adjusts the GL viewport to match the width and height of this Render Target.
                 * 
                 * Also disables `SCISSOR_TEST`.
                 */
                adjustViewport(): void;

                /**
                 * Clears this Render Target.
                 */
                clear(): void;

                /**
                 * Unbinds this Render Target and optionally flushes the WebGL Renderer first.
                 */
                unbind: any;

                /**
                 * Removes all external references from this class and deletes the
                 * WebGL framebuffer and texture instances.
                 * 
                 * Does not remove this Render Target from the parent pipeline.
                 */
                destroy: any;

            }

            namespace Shaders {
            }

            namespace Utils {
                /**
                 * Packs four floats on a range from 0.0 to 1.0 into a single Uint32
                 * @param r Red component in a range from 0.0 to 1.0
                 * @param g Green component in a range from 0.0 to 1.0
                 * @param b Blue component in a range from 0.0 to 1.0
                 * @param a Alpha component in a range from 0.0 to 1.0
                 */
                function getTintFromFloats(r: number, g: number, b: number, a: number): number;

                /**
                 * Packs a Uint24, representing RGB components, with a Float32, representing
                 * the alpha component, with a range between 0.0 and 1.0 and return a Uint32
                 * @param rgb Uint24 representing RGB components
                 * @param a Float32 representing Alpha component
                 */
                function getTintAppendFloatAlpha(rgb: number, a: number): number;

                /**
                 * Packs a Uint24, representing RGB components, with a Float32, representing
                 * the alpha component, with a range between 0.0 and 1.0 and return a
                 * swizzled Uint32
                 * @param rgb Uint24 representing RGB components
                 * @param a Float32 representing Alpha component
                 */
                function getTintAppendFloatAlphaAndSwap(rgb: number, a: number): number;

                /**
                 * Unpacks a Uint24 RGB into an array of floats of ranges of 0.0 and 1.0
                 * @param rgb RGB packed as a Uint24
                 */
                function getFloatsFromUintRGB(rgb: number): any[];

                /**
                 * Check to see how many texture units the GPU supports in a fragment shader
                 * and if the value specific in the game config is allowed.
                 * 
                 * This value is hard-clamped to 16 for performance reasons on Android devices.
                 * @param gl The WebGLContext used to create the shaders.
                 * @param maxTextures The Game Config maxTextures value.
                 */
                function checkShaderMax(gl: WebGLRenderingContext, maxTextures: number): number;

                /**
                 * Checks the given Fragment Shader Source for `%count%` and `%forloop%` declarations and
                 * replaces those with GLSL code for setting `texture = texture2D(uMainSampler[i], outTexCoord)`.
                 * @param fragmentShaderSource The Fragment Shader source code to operate on.
                 * @param maxTextures The number of maxTextures value.
                 */
                function parseFragmentShaderMaxTextures(fragmentShaderSource: string, maxTextures: number): string;

                /**
                 * Takes the Glow FX Shader source and parses out the __SIZE__ and __DIST__
                 * consts with the configuration values.
                 * @param shader The Fragment Shader source code to operate on.
                 * @param game The Phaser Game instance.
                 * @param quality The quality of the glow (defaults to 0.1)
                 * @param distance The distance of the glow (defaults to 10)
                 */
                function setGlowQuality(shader: string, game: Phaser.Game, quality?: number, distance?: number): string;

            }

            /**
             * The `WebGLPipeline` is a base class used by all of the core Phaser pipelines.
             * 
             * It describes the way elements will be rendered in WebGL. Internally, it handles
             * compiling the shaders, creating vertex buffers, assigning primitive topology and
             * binding vertex attributes, all based on the given configuration data.
             * 
             * The pipeline is configured by passing in a `WebGLPipelineConfig` object. Please
             * see the documentation for this type to fully understand the configuration options
             * available to you.
             * 
             * Usually, you would not extend from this class directly, but would instead extend
             * from one of the core pipelines, such as the Multi Pipeline.
             * 
             * The pipeline flow per render-step is as follows:
             * 
             * 1) onPreRender - called once at the start of the render step
             * 2) onRender - call for each Scene Camera that needs to render (so can be multiple times per render step)
             * 3) Internal flow:
             * 3a)   bind (only called if a Game Object is using this pipeline and it's not currently active)
             * 3b)   onBind (called for every Game Object that uses this pipeline)
             * 3c)   flush (can be called by a Game Object, internal method or from outside by changing pipeline)
             * 4) onPostRender - called once at the end of the render step
             */
            class WebGLPipeline extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param config The configuration object for this WebGL Pipeline.
                 */
                constructor(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig);

                /**
                 * Name of the pipeline. Used for identification and setting from Game Objects.
                 */
                name: string;

                /**
                 * The Phaser Game instance to which this pipeline is bound.
                 */
                game: Phaser.Game;

                /**
                 * The WebGL Renderer instance to which this pipeline is bound.
                 */
                renderer: Phaser.Renderer.WebGL.WebGLRenderer;

                /**
                 * A reference to the WebGL Pipeline Manager.
                 * 
                 * This is initially undefined and only set when this pipeline is added
                 * to the manager.
                 */
                manager: Phaser.Renderer.WebGL.PipelineManager | null;

                /**
                 * The WebGL context this WebGL Pipeline uses.
                 */
                gl: WebGLRenderingContext;

                /**
                 * The canvas which this WebGL Pipeline renders to.
                 */
                view: HTMLCanvasElement;

                /**
                 * Width of the current viewport.
                 */
                width: number;

                /**
                 * Height of the current viewport.
                 */
                height: number;

                /**
                 * The current number of vertices that have been added to the pipeline batch.
                 */
                vertexCount: number;

                /**
                 * The total number of vertices that this pipeline batch can hold before it will flush.
                 * 
                 * This defaults to `renderer batchSize * 6`, where `batchSize` is defined in the Renderer Game Config.
                 */
                vertexCapacity: number;

                /**
                 * Raw byte buffer of vertices.
                 * 
                 * Either set via the config object `vertices` property, or generates a new Array Buffer of
                 * size `vertexCapacity * vertexSize`.
                 */
                readonly vertexData: ArrayBuffer;

                /**
                 * The WebGLBuffer that holds the vertex data.
                 * 
                 * Created from the `vertexData` ArrayBuffer. If `vertices` are set in the config, a `STATIC_DRAW` buffer
                 * is created. If not, a `DYNAMIC_DRAW` buffer is created.
                 */
                readonly vertexBuffer: WebGLBuffer;

                /**
                 * The currently active WebGLBuffer.
                 */
                activeBuffer: WebGLBuffer;

                /**
                 * The primitive topology which the pipeline will use to submit draw calls.
                 * 
                 * Defaults to GL_TRIANGLES if not otherwise set in the config.
                 */
                topology: GLenum;

                /**
                 * Uint8 view to the `vertexData` ArrayBuffer. Used for uploading vertex buffer resources to the GPU.
                 */
                bytes: Uint8Array;

                /**
                 * Float32 view of the array buffer containing the pipeline's vertices.
                 */
                vertexViewF32: Float32Array;

                /**
                 * Uint32 view of the array buffer containing the pipeline's vertices.
                 */
                vertexViewU32: Uint32Array;

                /**
                 * Indicates if the current pipeline is active, or not.
                 * 
                 * Toggle this property to enable or disable a pipeline from rendering anything.
                 */
                active: boolean;

                /**
                 * Some pipelines require the forced use of texture zero (like the light pipeline).
                 * 
                 * This property should be set when that is the case.
                 */
                forceZero: boolean;

                /**
                 * Indicates if this pipeline has booted or not.
                 * 
                 * A pipeline boots only when the Game instance itself, and all associated systems, is
                 * fully ready.
                 */
                readonly hasBooted: boolean;

                /**
                 * Indicates if this is a Post FX Pipeline, or not.
                 */
                readonly isPostFX: boolean;

                /**
                 * Indicates if this is a Pre FX Pipeline, or not.
                 */
                readonly isPreFX: boolean;

                /**
                 * An array of RenderTarget instances that belong to this pipeline.
                 */
                renderTargets: Phaser.Renderer.WebGL.RenderTarget[];

                /**
                 * A reference to the currently bound Render Target instance from the `WebGLPipeline.renderTargets` array.
                 */
                currentRenderTarget: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * An array of all the WebGLShader instances that belong to this pipeline.
                 * 
                 * Shaders manage their own attributes and uniforms, but share the same vertex data buffer,
                 * which belongs to this pipeline.
                 * 
                 * Shaders are set in a call to the `setShadersFromConfig` method, which happens automatically,
                 * but can also be called at any point in your game. See the method documentation for details.
                 */
                shaders: Phaser.Renderer.WebGL.WebGLShader[];

                /**
                 * A reference to the currently bound WebGLShader instance from the `WebGLPipeline.shaders` array.
                 * 
                 * For lots of pipelines, this is the only shader, so it is a quick way to reference it without
                 * an array look-up.
                 */
                currentShader: Phaser.Renderer.WebGL.WebGLShader;

                /**
                 * The Projection matrix, used by shaders as 'uProjectionMatrix' uniform.
                 */
                projectionMatrix: Phaser.Math.Matrix4;

                /**
                 * The cached width of the Projection matrix.
                 */
                projectionWidth: number;

                /**
                 * The cached height of the Projection matrix.
                 */
                projectionHeight: number;

                /**
                 * The configuration object that was used to create this pipeline.
                 * 
                 * Treat this object as 'read only', because changing it post-creation will not
                 * impact this pipeline in any way. However, it is used internally for cloning
                 * and post-boot set-up.
                 */
                config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig;

                /**
                 * Has the GL Context been reset to the Phaser defaults since the last time
                 * this pipeline was bound? This is set automatically when the Pipeline Manager
                 * resets itself, usually after handing off to a 3rd party renderer like Spine.
                 * 
                 * You should treat this property as read-only.
                 */
                glReset: boolean;

                /**
                 * The temporary Pipeline batch. This array contains the batch entries for
                 * the current frame, which is a package of textures and vertex offsets used
                 * for drawing. This package is built dynamically as the frame is built
                 * and cleared during the flush method.
                 * 
                 * Treat this array and all of its contents as read-only.
                 */
                batch: Phaser.Types.Renderer.WebGL.WebGLPipelineBatchEntry[];

                /**
                 * The most recently created Pipeline batch entry.
                 * 
                 * Reset to null as part of the flush method.
                 * 
                 * Treat this value as read-only.
                 */
                currentBatch: Phaser.Types.Renderer.WebGL.WebGLPipelineBatchEntry | null;

                /**
                 * The most recently bound WebGLTexture, used as part of the batch process.
                 * 
                 * Reset to null as part of the flush method.
                 * 
                 * Treat this value as read-only.
                 */
                currentTexture: WebGLTexture | null;

                /**
                 * Holds the most recently assigned texture unit.
                 * 
                 * Treat this value as read-only.
                 */
                currentUnit: number;

                /**
                 * The currently active WebGLTextures, used as part of the batch process.
                 * 
                 * Reset to empty as part of the bind method.
                 * 
                 * Treat this array as read-only.
                 */
                activeTextures: WebGLTexture[];

                /**
                 * Called when the Game has fully booted and the Renderer has finished setting up.
                 * 
                 * By this stage all Game level systems are now in place. You can perform any final tasks that the
                 * pipeline may need, that relies on game systems such as the Texture Manager being ready.
                 */
                boot(): void;

                /**
                 * This method is called once when this pipeline has finished being set-up
                 * at the end of the boot process. By the time this method is called, all
                 * of the shaders are ready and configured.
                 */
                onBoot(): void;

                /**
                 * This method is called once when this pipeline has finished being set-up
                 * at the end of the boot process. By the time this method is called, all
                 * of the shaders are ready and configured. It's also called if the renderer
                 * changes size.
                 * @param width The new width of this WebGL Pipeline.
                 * @param height The new height of this WebGL Pipeline.
                 */
                onResize(width: number, height: number): void;

                /**
                 * Sets the currently active shader within this pipeline.
                 * @param shader The shader to set as being current.
                 * @param setAttributes Should the vertex attribute pointers be set? Default false.
                 * @param vertexBuffer The vertex buffer to be set before the shader is bound. Defaults to the one owned by this pipeline.
                 */
                setShader(shader: Phaser.Renderer.WebGL.WebGLShader, setAttributes?: boolean, vertexBuffer?: WebGLBuffer): this;

                /**
                 * Searches all shaders in this pipeline for one matching the given name, then returns it.
                 * @param name The index of the shader to set.
                 */
                getShaderByName(name: string): Phaser.Renderer.WebGL.WebGLShader;

                /**
                 * Destroys all shaders currently set in the `WebGLPipeline.shaders` array and then parses the given
                 * `config` object, extracting the shaders from it, creating `WebGLShader` instances and finally
                 * setting them into the `shaders` array of this pipeline.
                 * 
                 * This is a destructive process. Be very careful when you call it, should you need to.
                 * @param config The configuration object for this WebGL Pipeline.
                 */
                setShadersFromConfig(config: Phaser.Types.Renderer.WebGL.WebGLPipelineConfig): this;

                /**
                 * Creates a new WebGL Pipeline Batch Entry, sets the texture unit as zero
                 * and pushes the entry into the batch.
                 * @param texture The WebGLTexture assigned to this batch entry.
                 */
                createBatch(texture: WebGLTexture): number;

                /**
                 * Adds the given texture to the current WebGL Pipeline Batch Entry and
                 * increases the batch entry unit and maxUnit values by 1.
                 * @param texture The WebGLTexture assigned to this batch entry.
                 */
                addTextureToBatch(texture: WebGLTexture): void;

                /**
                 * Takes the given WebGLTexture and determines what to do with it.
                 * 
                 * If there is no current batch (i.e. after a flush) it will create a new
                 * batch from it.
                 * 
                 * If the texture is already bound, it will return the current texture unit.
                 * 
                 * If the texture already exists in the current batch, the unit gets reset
                 * to match it.
                 * 
                 * If the texture cannot be found in the current batch, and it supports
                 * multiple textures, it's added into the batch and the unit indexes are
                 * advanced.
                 * @param texture The WebGLTexture assigned to this batch entry.
                 */
                pushBatch(texture: WebGLTexture): number;

                /**
                 * Custom pipelines can use this method in order to perform any required pre-batch tasks
                 * for the given Game Object. It must return the texture unit the Game Object was assigned.
                 * @param gameObject The Game Object being rendered or added to the batch.
                 * @param frame Optional frame to use. Can override that of the Game Object.
                 */
                setGameObject(gameObject: Phaser.GameObjects.GameObject, frame?: Phaser.Textures.Frame): number;

                /**
                 * Check if the current batch of vertices is full.
                 * 
                 * You can optionally provide an `amount` parameter. If given, it will check if the batch
                 * needs to flush _if_ the `amount` is added to it. This allows you to test if you should
                 * flush before populating the batch.
                 * @param amount Will the batch need to flush if this many vertices are added to it? Default 0.
                 */
                shouldFlush(amount?: number): boolean;

                /**
                 * Returns the number of vertices that can be added to the current batch before
                 * it will trigger a flush to happen.
                 */
                vertexAvailable(): number;

                /**
                 * Resizes the properties used to describe the viewport.
                 * 
                 * This method is called automatically by the renderer during its resize handler.
                 * @param width The new width of this WebGL Pipeline.
                 * @param height The new height of this WebGL Pipeline.
                 */
                resize(width: number, height: number): this;

                /**
                 * Adjusts this pipelines ortho Projection Matrix to use the given dimensions
                 * and resets the `uProjectionMatrix` uniform on all bound shaders.
                 * 
                 * This method is called automatically by the renderer during its resize handler.
                 * @param width The new width of this WebGL Pipeline.
                 * @param height The new height of this WebGL Pipeline.
                 */
                setProjectionMatrix(width: number, height: number): this;

                /**
                 * Adjusts this pipelines ortho Projection Matrix to flip the y
                 * and bottom values. Call with 'false' as the parameter to flip
                 * them back again.
                 * @param flipY Flip the y and bottom values? Default true.
                 */
                flipProjectionMatrix(flipY?: boolean): void;

                /**
                 * Adjusts this pipelines ortho Projection Matrix to match that of the global
                 * WebGL Renderer Projection Matrix.
                 * 
                 * This method is called automatically by the Pipeline Manager when this
                 * pipeline is set.
                 */
                updateProjectionMatrix(): void;

                /**
                 * This method is called every time the Pipeline Manager makes this pipeline the currently active one.
                 * 
                 * It binds the resources and shader needed for this pipeline, including setting the vertex buffer
                 * and attribute pointers.
                 * @param currentShader The shader to set as being current.
                 */
                bind(currentShader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * This method is called every time the Pipeline Manager rebinds this pipeline.
                 * 
                 * It resets all shaders this pipeline uses, setting their attributes again.
                 * @param currentShader The shader to set as being current.
                 */
                rebind(currentShader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Binds the vertex buffer to be the active ARRAY_BUFFER on the WebGL context.
                 * 
                 * It first checks to see if it's already set as the active buffer and only
                 * binds itself if not.
                 * @param buffer The Vertex Buffer to be bound. Defaults to the one owned by this pipeline.
                 */
                setVertexBuffer(buffer?: WebGLBuffer): boolean;

                /**
                 * This method is called as a result of the `WebGLPipeline.batchQuad` method, right before a quad
                 * belonging to a Game Object is about to be added to the batch. When this is called, the
                 * renderer has just performed a flush. It will bind the current render target, if any are set
                 * and finally call the `onPreBatch` hook.
                 * 
                 * It is also called as part of the `PipelineManager.preBatch` method when processing Post FX Pipelines.
                 * @param gameObject The Game Object or Camera that invoked this pipeline, if any.
                 */
                preBatch(gameObject?: Phaser.GameObjects.GameObject | Phaser.Cameras.Scene2D.Camera): this;

                /**
                 * This method is called as a result of the `WebGLPipeline.batchQuad` method, right after a quad
                 * belonging to a Game Object has been added to the batch. When this is called, the
                 * renderer has just performed a flush.
                 * 
                 * It calls the `onDraw` hook followed by the `onPostBatch` hook, which can be used to perform
                 * additional Post FX Pipeline processing.
                 * 
                 * It is also called as part of the `PipelineManager.postBatch` method when processing Post FX Pipelines.
                 * @param gameObject The Game Object or Camera that invoked this pipeline, if any.
                 */
                postBatch(gameObject?: Phaser.GameObjects.GameObject | Phaser.Cameras.Scene2D.Camera): this;

                /**
                 * This method is only used by Sprite FX and Post FX Pipelines and those that extend from them.
                 * 
                 * This method is called every time the `postBatch` method is called and is passed a
                 * reference to the current render target.
                 * 
                 * At the very least a Post FX Pipeline should call `this.bindAndDraw(renderTarget)`,
                 * however, you can do as much additional processing as you like in this method if
                 * you override it from within your own pipelines.
                 * @param renderTarget The Render Target.
                 * @param swapTarget A Swap Render Target, useful for double-buffer effects. Only set by SpriteFX Pipelines.
                 */
                onDraw(renderTarget: Phaser.Renderer.WebGL.RenderTarget, swapTarget?: Phaser.Renderer.WebGL.RenderTarget): void;

                /**
                 * This method is called every time the Pipeline Manager deactivates this pipeline, swapping from
                 * it to another one. This happens after a call to `flush` and before the new pipeline is bound.
                 */
                unbind(): void;

                /**
                 * Uploads the vertex data and emits a draw call for the current batch of vertices.
                 * @param isPostFlush Was this flush invoked as part of a post-process, or not? Default false.
                 */
                flush(isPostFlush?: boolean): this;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called every time the Pipeline Manager makes this the active pipeline. It is called
                 * at the end of the `WebGLPipeline.bind` method, after the current shader has been set. The current
                 * shader is passed to this hook.
                 * 
                 * For example, if a display list has 3 Sprites in it that all use the same pipeline, this hook will
                 * only be called for the first one, as the 2nd and 3rd Sprites do not cause the pipeline to be changed.
                 * 
                 * If you need to listen for that event instead, use the `onBind` hook.
                 * @param currentShader The shader that was set as current.
                 */
                onActive(currentShader: Phaser.Renderer.WebGL.WebGLShader): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called every time a **Game Object** asks the Pipeline Manager to use this pipeline,
                 * even if the pipeline is already active.
                 * 
                 * Unlike the `onActive` method, which is only called when the Pipeline Manager makes this pipeline
                 * active, this hook is called for every Game Object that requests use of this pipeline, allowing you to
                 * perform per-object set-up, such as loading shader uniform data.
                 * @param gameObject The Game Object that invoked this pipeline, if any.
                 */
                onBind(gameObject?: Phaser.GameObjects.GameObject): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called when the Pipeline Manager needs to rebind this pipeline. This happens after a
                 * pipeline has been cleared, usually when passing control over to a 3rd party WebGL library, like Spine,
                 * and then returing to Phaser again.
                 */
                onRebind(): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called every time the `batchQuad` or `batchTri` methods are called. If this was
                 * as a result of a Game Object, then the Game Object reference is passed to this hook too.
                 * 
                 * This hook is called _after_ the quad (or tri) has been added to the batch, so you can safely
                 * call 'flush' from within this.
                 * 
                 * Note that Game Objects may call `batchQuad` or `batchTri` multiple times for a single draw,
                 * for example the Graphics Game Object.
                 * @param gameObject The Game Object that invoked this pipeline, if any.
                 */
                onBatch(gameObject?: Phaser.GameObjects.GameObject): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called immediately before a **Game Object** is about to add itself to the batch.
                 * @param gameObject The Game Object that invoked this pipeline, if any.
                 */
                onPreBatch(gameObject?: Phaser.GameObjects.GameObject): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called immediately after a **Game Object** has been added to the batch.
                 * @param gameObject The Game Object that invoked this pipeline, if any.
                 */
                onPostBatch(gameObject?: Phaser.GameObjects.GameObject): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called once per frame, right before anything has been rendered, but after the canvas
                 * has been cleared. If this pipeline has a render target, it will also have been cleared by this point.
                 */
                onPreRender(): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called _once per frame_, by every Camera in a Scene that wants to render.
                 * 
                 * It is called at the start of the rendering process, before anything has been drawn to the Camera.
                 * @param scene The Scene being rendered.
                 * @param camera The Scene Camera being rendered with.
                 */
                onRender(scene: Phaser.Scene, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called _once per frame_, after all rendering has happened and snapshots have been taken.
                 * 
                 * It is called at the very end of the rendering process, once all Cameras, for all Scenes, have
                 * been rendered.
                 */
                onPostRender(): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called every time this pipeline is asked to flush its batch.
                 * 
                 * It is called immediately before the `gl.bufferData` and `gl.drawArrays` calls are made, so you can
                 * perform any final pre-render modifications. To apply changes post-render, see `onAfterFlush`.
                 * @param isPostFlush Was this flush invoked as part of a post-process, or not? Default false.
                 */
                onBeforeFlush(isPostFlush?: boolean): void;

                /**
                 * By default this is an empty method hook that you can override and use in your own custom pipelines.
                 * 
                 * This method is called immediately after this pipeline has finished flushing its batch.
                 * 
                 * It is called after the `gl.drawArrays` call.
                 * 
                 * You can perform additional post-render effects, but be careful not to call `flush`
                 * on this pipeline from within this method, or you'll cause an infinite loop.
                 * 
                 * To apply changes pre-render, see `onBeforeFlush`.
                 * @param isPostFlush Was this flush invoked as part of a post-process, or not? Default false.
                 */
                onAfterFlush(isPostFlush?: boolean): void;

                /**
                 * Adds a single vertex to the current vertex buffer and increments the
                 * `vertexCount` property by 1.
                 * 
                 * This method is called directly by `batchTri` and `batchQuad`.
                 * 
                 * It does not perform any batch limit checking itself, so if you need to call
                 * this method directly, do so in the same way that `batchQuad` does, for example.
                 * @param x The vertex x position.
                 * @param y The vertex y position.
                 * @param u UV u value.
                 * @param v UV v value.
                 * @param unit Texture unit to which the texture needs to be bound.
                 * @param tintEffect The tint effect for the shader to use.
                 * @param tint The tint color value.
                 */
                batchVert(x: number, y: number, u: number, v: number, unit: number, tintEffect: number | boolean, tint: number): void;

                /**
                 * Adds the vertices data into the batch and flushes if full.
                 * 
                 * Assumes 6 vertices in the following arrangement:
                 * 
                 * ```
                 * 0----3
                 * |\  B|
                 * | \  |
                 * |  \ |
                 * | A \|
                 * |    \
                 * 1----2
                 * ```
                 * 
                 * Where tx0/ty0 = 0, tx1/ty1 = 1, tx2/ty2 = 2 and tx3/ty3 = 3
                 * @param gameObject The Game Object, if any, drawing this quad.
                 * @param x0 The top-left x position.
                 * @param y0 The top-left y position.
                 * @param x1 The bottom-left x position.
                 * @param y1 The bottom-left y position.
                 * @param x2 The bottom-right x position.
                 * @param y2 The bottom-right y position.
                 * @param x3 The top-right x position.
                 * @param y3 The top-right y position.
                 * @param u0 UV u0 value.
                 * @param v0 UV v0 value.
                 * @param u1 UV u1 value.
                 * @param v1 UV v1 value.
                 * @param tintTL The top-left tint color value.
                 * @param tintTR The top-right tint color value.
                 * @param tintBL The bottom-left tint color value.
                 * @param tintBR The bottom-right tint color value.
                 * @param tintEffect The tint effect for the shader to use.
                 * @param texture WebGLTexture that will be assigned to the current batch if a flush occurs.
                 * @param unit Texture unit to which the texture needs to be bound. Default 0.
                 */
                batchQuad(gameObject: Phaser.GameObjects.GameObject | null, x0: number, y0: number, x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, u0: number, v0: number, u1: number, v1: number, tintTL: number, tintTR: number, tintBL: number, tintBR: number, tintEffect: number | boolean, texture?: WebGLTexture, unit?: number): boolean;

                /**
                 * Adds the vertices data into the batch and flushes if full.
                 * 
                 * Assumes 3 vertices in the following arrangement:
                 * 
                 * ```
                 * 0
                 * |\
                 * | \
                 * |  \
                 * |   \
                 * |    \
                 * 1-----2
                 * ```
                 * @param gameObject The Game Object, if any, drawing this quad.
                 * @param x1 The bottom-left x position.
                 * @param y1 The bottom-left y position.
                 * @param x2 The bottom-right x position.
                 * @param y2 The bottom-right y position.
                 * @param x3 The top-right x position.
                 * @param y3 The top-right y position.
                 * @param u0 UV u0 value.
                 * @param v0 UV v0 value.
                 * @param u1 UV u1 value.
                 * @param v1 UV v1 value.
                 * @param tintTL The top-left tint color value.
                 * @param tintTR The top-right tint color value.
                 * @param tintBL The bottom-left tint color value.
                 * @param tintEffect The tint effect for the shader to use.
                 * @param texture WebGLTexture that will be assigned to the current batch if a flush occurs.
                 * @param unit Texture unit to which the texture needs to be bound. Default 0.
                 */
                batchTri(gameObject: Phaser.GameObjects.GameObject | null, x1: number, y1: number, x2: number, y2: number, x3: number, y3: number, u0: number, v0: number, u1: number, v1: number, tintTL: number, tintTR: number, tintBL: number, tintEffect: number | boolean, texture?: WebGLTexture, unit?: number): boolean;

                /**
                 * Pushes a filled rectangle into the vertex batch.
                 * 
                 * The dimensions are run through `Math.floor` before the quad is generated.
                 * 
                 * Rectangle has no transform values and isn't transformed into the local space.
                 * 
                 * Used for directly batching untransformed rectangles, such as Camera background colors.
                 * @param x Horizontal top left coordinate of the rectangle.
                 * @param y Vertical top left coordinate of the rectangle.
                 * @param width Width of the rectangle.
                 * @param height Height of the rectangle.
                 * @param color Color of the rectangle to draw.
                 * @param alpha Alpha value of the rectangle to draw.
                 * @param texture WebGLTexture that will be assigned to the current batch if a flush occurs.
                 * @param flipUV Flip the vertical UV coordinates of the texture before rendering? Default true.
                 */
                drawFillRect(x: number, y: number, width: number, height: number, color: number, alpha: number, texture?: WebGLTexture, flipUV?: boolean): void;

                /**
                 * Sets the texture to be bound to the next available texture unit and returns
                 * the unit id.
                 * @param texture WebGLTexture that will be assigned to the current batch. If not given uses `whiteTexture`.
                 */
                setTexture2D(texture?: WebGLTexture): number;

                /**
                 * Activates the given WebGL Texture and binds it to the requested texture slot.
                 * @param target The WebGLTexture to activate and bind.
                 * @param unit The WebGL texture ID to activate. Defaults to `gl.TEXTURE0`. Default 0.
                 */
                bindTexture(target?: WebGLTexture, unit?: number): this;

                /**
                 * Activates the given Render Target texture and binds it to the
                 * requested WebGL texture slot.
                 * @param target The Render Target to activate and bind.
                 * @param unit The WebGL texture ID to activate. Defaults to `gl.TEXTURE0`. Default 0.
                 */
                bindRenderTarget(target?: Phaser.Renderer.WebGL.RenderTarget, unit?: number): this;

                /**
                 * Sets the current duration into a 1f uniform value based on the given name.
                 * 
                 * This can be used for mapping time uniform values, such as `iTime`.
                 * @param name The name of the uniform to set.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                setTime(name: string, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a boolean uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param value The new value of the `boolean` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                setBoolean(name: string, value: boolean, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 1f uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new value of the `float` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set1f(name: string, x: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 2f uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `vec2` uniform.
                 * @param y The new Y component of the `vec2` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set2f(name: string, x: number, y: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 3f uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `vec3` uniform.
                 * @param y The new Y component of the `vec3` uniform.
                 * @param z The new Z component of the `vec3` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set3f(name: string, x: number, y: number, z: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 4f uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x X component of the uniform
                 * @param y Y component of the uniform
                 * @param z Z component of the uniform
                 * @param w W component of the uniform
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set4f(name: string, x: number, y: number, z: number, w: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 1fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set1fv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 2fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set2fv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 3fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set3fv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 4fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set4fv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 1iv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set1iv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 2iv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set2iv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 3iv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set3iv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 4iv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set4iv(name: string, arr: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 1i uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new value of the `int` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set1i(name: string, x: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 2i uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `ivec2` uniform.
                 * @param y The new Y component of the `ivec2` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set2i(name: string, x: number, y: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 3i uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `ivec3` uniform.
                 * @param y The new Y component of the `ivec3` uniform.
                 * @param z The new Z component of the `ivec3` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set3i(name: string, x: number, y: number, z: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a 4i uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param x X component of the uniform.
                 * @param y Y component of the uniform.
                 * @param z Z component of the uniform.
                 * @param w W component of the uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                set4i(name: string, x: number, y: number, z: number, w: number, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a matrix 2fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param transpose Whether to transpose the matrix. Should be `false`.
                 * @param matrix The new values for the `mat2` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                setMatrix2fv(name: string, transpose: boolean, matrix: number[] | Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a matrix 3fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param transpose Whether to transpose the matrix. Should be `false`.
                 * @param matrix The new values for the `mat3` uniform.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                setMatrix3fv(name: string, transpose: boolean, matrix: Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Sets a matrix 4fv uniform value based on the given name on the currently set shader.
                 * 
                 * The current shader is bound, before the uniform is set, making it active within the
                 * WebGLRenderer. This means you can safely call this method from a location such as
                 * a Scene `create` or `update` method. However, when working within a Shader file
                 * directly, use the `WebGLShader` method equivalent instead, to avoid the program
                 * being set.
                 * @param name The name of the uniform to set.
                 * @param transpose Whether to transpose the matrix. Should be `false`.
                 * @param matrix The matrix data. If using a Matrix4 this should be the `Matrix4.val` property.
                 * @param shader The shader to set the value on. If not given, the `currentShader` is used.
                 */
                setMatrix4fv(name: string, transpose: boolean, matrix: Float32Array, shader?: Phaser.Renderer.WebGL.WebGLShader): this;

                /**
                 * Destroys all shader instances, removes all object references and nulls all external references.
                 */
                destroy(): this;

            }

            /**
             * WebGLRenderer is a class that contains the needed functionality to keep the
             * WebGLRenderingContext state clean. The main idea of the WebGLRenderer is to keep track of
             * any context change that happens for WebGL rendering inside of Phaser. This means
             * if raw webgl functions are called outside the WebGLRenderer of the Phaser WebGL
             * rendering ecosystem they might pollute the current WebGLRenderingContext state producing
             * unexpected behavior. It's recommended that WebGL interaction is done through
             * WebGLRenderer and/or WebGLPipeline.
             */
            class WebGLRenderer extends Phaser.Events.EventEmitter {
                /**
                 * 
                 * @param game The Game instance which owns this WebGL Renderer.
                 */
                constructor(game: Phaser.Game);

                /**
                 * The currently bound normal map texture at texture unit one, if any.
                 */
                "currentNormalMap;": WebGLTexture | null;

                /**
                 * Checks to see if the given diffuse and normal map textures are already bound, or not.
                 * @param texture The WebGL diffuse texture.
                 * @param normalMap The WebGL normal map texture.
                 */
                isNewNormalMap(texture: WebGLTexture, normalMap: WebGLTexture): boolean;

                /**
                 * The local configuration settings of this WebGL Renderer.
                 */
                config: object;

                /**
                 * The Game instance which owns this WebGL Renderer.
                 */
                game: Phaser.Game;

                /**
                 * A constant which allows the renderer to be easily identified as a WebGL Renderer.
                 */
                type: number;

                /**
                 * An instance of the Pipeline Manager class, that handles all WebGL Pipelines.
                 * 
                 * Use this to manage all of your interactions with pipelines, such as adding, getting,
                 * setting and rendering them.
                 * 
                 * The Pipeline Manager class is created in the `init` method and then populated
                 * with pipelines during the `boot` method.
                 * 
                 * Prior to Phaser v3.50.0 this was just a plain JavaScript object, not a class.
                 */
                pipelines: Phaser.Renderer.WebGL.PipelineManager;

                /**
                 * The width of the canvas being rendered to.
                 * This is populated in the onResize event handler.
                 */
                width: number;

                /**
                 * The height of the canvas being rendered to.
                 * This is populated in the onResize event handler.
                 */
                height: number;

                /**
                 * The canvas which this WebGL Renderer draws to.
                 */
                canvas: HTMLCanvasElement;

                /**
                 * An array of blend modes supported by the WebGL Renderer.
                 * 
                 * This array includes the default blend modes as well as any custom blend modes added through {@link #addBlendMode}.
                 */
                blendModes: any[];

                /**
                 * This property is set to `true` if the WebGL context of the renderer is lost.
                 */
                contextLost: boolean;

                /**
                 * Details about the currently scheduled snapshot.
                 * 
                 * If a non-null `callback` is set in this object, a snapshot of the canvas will be taken after the current frame is fully rendered.
                 */
                snapshotState: Phaser.Types.Renderer.Snapshot.SnapshotState;

                /**
                 * The maximum number of textures the GPU can handle. The minimum under the WebGL1 spec is 8.
                 * This is set via the Game Config `maxTextures` property and should never be changed after boot.
                 */
                maxTextures: number;

                /**
                 * An array of the available WebGL texture units, used to populate the uSampler uniforms.
                 * 
                 * This array is populated during the init phase and should never be changed after boot.
                 */
                textureIndexes: any[];

                /**
                 * The currently bound framebuffer in use.
                 */
                currentFramebuffer: WebGLFramebuffer;

                /**
                 * A stack into which the frame buffer objects are pushed and popped.
                 */
                fboStack: WebGLFramebuffer[];

                /**
                 * Current WebGLProgram in use.
                 */
                currentProgram: WebGLProgram;

                /**
                 * Current blend mode in use
                 */
                currentBlendMode: number;

                /**
                 * Indicates if the the scissor state is enabled in WebGLRenderingContext
                 */
                currentScissorEnabled: boolean;

                /**
                 * Stores the current scissor data
                 */
                currentScissor: Uint32Array;

                /**
                 * Stack of scissor data
                 */
                scissorStack: Uint32Array;

                /**
                 * The handler to invoke when the context is lost.
                 * This should not be changed and is set in the boot method.
                 */
                contextLostHandler: Function;

                /**
                 * The handler to invoke when the context is restored.
                 * This should not be changed and is set in the boot method.
                 */
                contextRestoredHandler: Function;

                /**
                 * The underlying WebGL context of the renderer.
                 */
                gl: WebGLRenderingContext;

                /**
                 * Array of strings that indicate which WebGL extensions are supported by the browser.
                 * This is populated in the `boot` method.
                 */
                supportedExtensions: string[];

                /**
                 * If the browser supports the `ANGLE_instanced_arrays` extension, this property will hold
                 * a reference to the glExtension for it.
                 */
                instancedArraysExtension: ANGLE_instanced_arrays;

                /**
                 * If the browser supports the `OES_vertex_array_object` extension, this property will hold
                 * a reference to the glExtension for it.
                 */
                vaoExtension: OES_vertex_array_object;

                /**
                 * The WebGL Extensions loaded into the current context.
                 */
                extensions: object;

                /**
                 * Stores the current WebGL component formats for further use.
                 * 
                 * This array is populated in the `init` method.
                 */
                glFormats: any[];

                /**
                 * Stores the WebGL texture compression formats that this device and browser supports.
                 * 
                 * Support for using compressed texture formats was added in Phaser version 3.60.
                 */
                compression: Phaser.Types.Renderer.WebGL.WebGLTextureCompression;

                /**
                 * Cached drawing buffer height to reduce gl calls.
                 */
                readonly drawingBufferHeight: number;

                /**
                 * A blank 32x32 transparent texture, as used by the Graphics system where needed.
                 * This is set in the `boot` method.
                 */
                readonly blankTexture: WebGLTexture;

                /**
                 * A pure white 4x4 texture, as used by the Graphics system where needed.
                 * This is set in the `boot` method.
                 */
                readonly whiteTexture: WebGLTexture;

                /**
                 * The total number of masks currently stacked.
                 */
                maskCount: number;

                /**
                 * The mask stack.
                 */
                maskStack: Phaser.Display.Masks.GeometryMask[];

                /**
                 * Internal property that tracks the currently set mask.
                 */
                currentMask: any;

                /**
                 * Internal property that tracks the currently set camera mask.
                 */
                currentCameraMask: any;

                /**
                 * Internal gl function mapping for uniform look-up.
                 * https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/uniform
                 */
                glFuncMap: any;

                /**
                 * The `type` of the Game Object being currently rendered.
                 * This can be used by advanced render functions for batching look-ahead.
                 */
                currentType: string;

                /**
                 * Is the `type` of the Game Object being currently rendered different than the
                 * type of the object before it in the display list? I.e. it's a 'new' type.
                 */
                newType: boolean;

                /**
                 * Does the `type` of the next Game Object in the display list match that
                 * of the object being currently rendered?
                 */
                nextTypeMatch: boolean;

                /**
                 * Is the Game Object being currently rendered the final one in the list?
                 */
                finalType: boolean;

                /**
                 * The mipmap magFilter to be used when creating textures.
                 * 
                 * You can specify this as a string in the game config, i.e.:
                 * 
                 * `render: { mipmapFilter: 'NEAREST_MIPMAP_LINEAR' }`
                 * 
                 * The 6 options for WebGL1 are, in order from least to most computationally expensive:
                 * 
                 * NEAREST (for pixel art)
                 * LINEAR (the default)
                 * NEAREST_MIPMAP_NEAREST
                 * LINEAR_MIPMAP_NEAREST
                 * NEAREST_MIPMAP_LINEAR
                 * LINEAR_MIPMAP_LINEAR
                 * 
                 * Mipmaps only work with textures that are fully power-of-two in size.
                 * 
                 * For more details see https://webglfundamentals.org/webgl/lessons/webgl-3d-textures.html
                 * 
                 * As of v3.60 no mipmaps will be generated unless a string is given in
                 * the game config. This saves on VRAM use when it may not be required.
                 * To obtain the previous result set the property to `LINEAR` in the config.
                 */
                mipmapFilter: GLenum;

                /**
                 * Has this renderer fully booted yet?
                 */
                isBooted: boolean;

                /**
                 * A Render Target you can use to capture the current state of the Renderer.
                 * 
                 * A Render Target encapsulates a framebuffer and texture for the WebGL Renderer.
                 */
                renderTarget: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * The global game Projection matrix, used by shaders as 'uProjectionMatrix' uniform.
                 */
                projectionMatrix: Phaser.Math.Matrix4;

                /**
                 * The cached width of the Projection matrix.
                 */
                projectionWidth: number;

                /**
                 * The cached height of the Projection matrix.
                 */
                projectionHeight: number;

                /**
                 * A RenderTarget used by the BitmapMask Pipeline.
                 * 
                 * This is the source, i.e. the masked Game Object itself.
                 */
                maskSource: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * A RenderTarget used by the BitmapMask Pipeline.
                 * 
                 * This is the target, i.e. the framebuffer the masked objects are drawn to.
                 */
                maskTarget: Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * An instance of SpectorJS used for WebGL Debugging.
                 * 
                 * Only available in the Phaser Debug build.
                 */
                spector: Function;

                /**
                 * Creates a new WebGLRenderingContext and initializes all internal state.
                 * @param config The configuration object for the renderer.
                 */
                init(config: object): this;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method will capture the current WebGL frame and send it to the Spector.js tool for inspection.
                 * @param quickCapture If `true` thumbnails are not captured in order to speed up the capture. Default false.
                 * @param fullCapture If `true` all details are captured. Default false.
                 */
                captureFrame(quickCapture?: boolean, fullCapture?: boolean): void;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method will capture the next WebGL frame and send it to the Spector.js tool for inspection.
                 */
                captureNextFrame(): void;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method will return the current FPS of the WebGL canvas.
                 */
                getFps(): number;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method adds a command with the name value in the list. This can be filtered in the search.
                 * All logs can be filtered searching for "LOG".
                 * @param arguments The arguments to log to Spector.
                 */
                log(...arguments: any[]): string;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method will start a capture on the Phaser canvas. The capture will stop once it reaches
                 * the number of commands specified as a parameter, or after 10 seconds. If quick capture is true,
                 * the thumbnails are not captured in order to speed up the capture.
                 * @param commandCount The number of commands to capture. If zero it will capture for 10 seconds. Default 0.
                 * @param quickCapture If `true` thumbnails are not captured in order to speed up the capture. Default false.
                 * @param fullCapture If `true` all details are captured. Default false.
                 */
                startCapture(commandCount?: number, quickCapture?: boolean, fullCapture?: boolean): void;

                /**
                 * This method is only available in the Debug Build of Phaser, or a build with the
                 * `WEBGL_DEBUG` flag set in the Webpack Config.
                 * 
                 * Phaser v3.60 Debug has a build of Spector.js embedded in it, which is a WebGL inspector
                 * that allows for live inspection of your WebGL calls. Although it's easy to add the Spector
                 * extension to a desktop browsr, by embedding it in Phaser we can make it available in mobile
                 * browsers too, making it a powerful tool for debugging WebGL games on mobile devices where
                 * extensions are not permitted.
                 * 
                 * See https://github.com/BabylonJS/Spector.js for more details.
                 * 
                 * This method will stop the current capture and returns the result in JSON. It displays the
                 * result if the UI has been displayed. This returns undefined if the capture has not been completed
                 * or did not find any commands.
                 */
                stopCapture(): object;

                /**
                 * The event handler that manages the `resize` event dispatched by the Scale Manager.
                 * @param gameSize The default Game Size object. This is the un-modified game dimensions.
                 * @param baseSize The base Size object. The game dimensions. The canvas width / height values match this.
                 */
                onResize(gameSize: Phaser.Structs.Size, baseSize: Phaser.Structs.Size): void;

                /**
                 * Binds the WebGL Renderers Render Target, so all drawn content is now redirected to it.
                 * 
                 * Make sure to call `endCapture` when you are finished.
                 * @param width Optional new width of the Render Target.
                 * @param height Optional new height of the Render Target.
                 */
                beginCapture(width?: number, height?: number): void;

                /**
                 * Unbinds the WebGL Renderers Render Target and returns it, stopping any further content being drawn to it.
                 * 
                 * If the viewport or scissors were modified during the capture, you should reset them by calling
                 * `resetViewport` and `resetScissor` accordingly.
                 */
                endCapture(): Phaser.Renderer.WebGL.RenderTarget;

                /**
                 * Resizes the drawing buffer to match that required by the Scale Manager.
                 * @param width The new width of the renderer.
                 * @param height The new height of the renderer.
                 */
                resize(width?: number, height?: number): this;

                /**
                 * Determines which compressed texture formats this browser and device supports.
                 * 
                 * Called automatically as part of the WebGL Renderer init process. If you need to investigate
                 * which formats it supports, see the `Phaser.Renderer.WebGL.WebGLRenderer#compression` property instead.
                 */
                getCompressedTextures(): Phaser.Types.Renderer.WebGL.WebGLTextureCompression;

                /**
                 * Returns a compressed texture format GLenum name based on the given format.
                 * @param baseFormat The Base Format to check.
                 * @param format An optional GLenum format to check within the base format.
                 */
                getCompressedTextureName(baseFormat: string, format?: GLenum): string;

                /**
                 * Checks if the given compressed texture format is supported, or not.
                 * @param baseFormat The Base Format to check.
                 * @param format An optional GLenum format to check within the base format.
                 */
                supportsCompressedTexture(baseFormat: string, format?: GLenum): boolean;

                /**
                 * Gets the aspect ratio of the WebGLRenderer dimensions.
                 */
                getAspectRatio(): number;

                /**
                 * Sets the Projection Matrix of this renderer to the given dimensions.
                 * @param width The new width of the Projection Matrix.
                 * @param height The new height of the Projection Matrix.
                 */
                setProjectionMatrix(width: number, height: number): this;

                /**
                 * Resets the Projection Matrix back to this renderers width and height.
                 * 
                 * This is called during `endCapture`, should the matrix have been changed
                 * as a result of the capture process.
                 */
                resetProjectionMatrix(): this;

                /**
                 * Checks if a WebGL extension is supported
                 * @param extensionName Name of the WebGL extension
                 */
                hasExtension(extensionName: string): boolean;

                /**
                 * Loads a WebGL extension
                 * @param extensionName The name of the extension to load.
                 */
                getExtension(extensionName: string): object;

                /**
                 * Flushes the current pipeline if the pipeline is bound
                 */
                flush(): void;

                /**
                 * Pushes a new scissor state. This is used to set nested scissor states.
                 * @param x The x position of the scissor.
                 * @param y The y position of the scissor.
                 * @param width The width of the scissor.
                 * @param height The height of the scissor.
                 * @param drawingBufferHeight Optional drawingBufferHeight override value.
                 */
                pushScissor(x: number, y: number, width: number, height: number, drawingBufferHeight?: number): number[];

                /**
                 * Sets the current scissor state.
                 * @param x The x position of the scissor.
                 * @param y The y position of the scissor.
                 * @param width The width of the scissor.
                 * @param height The height of the scissor.
                 * @param drawingBufferHeight Optional drawingBufferHeight override value.
                 */
                setScissor(x: number, y: number, width: number, height: number, drawingBufferHeight?: number): void;

                /**
                 * Resets the gl scissor state to be whatever the current scissor is, if there is one, without
                 * modifying the scissor stack.
                 */
                resetScissor(): void;

                /**
                 * Pops the last scissor state and sets it.
                 */
                popScissor(): void;

                /**
                 * Is there an active stencil mask?
                 */
                hasActiveStencilMask(): boolean;

                /**
                 * Resets the gl viewport to the current renderer dimensions.
                 */
                resetViewport(): void;

                /**
                 * Sets the blend mode to the value given.
                 * 
                 * If the current blend mode is different from the one given, the pipeline is flushed and the new
                 * blend mode is enabled.
                 * @param blendModeId The blend mode to be set. Can be a `BlendModes` const or an integer value.
                 * @param force Force the blend mode to be set, regardless of the currently set blend mode. Default false.
                 */
                setBlendMode(blendModeId: number, force?: boolean): boolean;

                /**
                 * Creates a new custom blend mode for the renderer.
                 * 
                 * See https://developer.mozilla.org/en-US/docs/Web/API/WebGL_API/Constants#Blending_modes
                 * @param func An array containing the WebGL functions to use for the source and the destination blending factors, respectively. See the possible constants for {@link WebGLRenderingContext#blendFunc()}.
                 * @param equation The equation to use for combining the RGB and alpha components of a new pixel with a rendered one. See the possible constants for {@link WebGLRenderingContext#blendEquation()}.
                 */
                addBlendMode(func: GLenum[], equation: GLenum): number;

                /**
                 * Updates the function bound to a given custom blend mode.
                 * @param index The index of the custom blend mode.
                 * @param func The function to use for the blend mode.
                 * @param equation The equation to use for the blend mode.
                 */
                updateBlendMode(index: number, func: Function, equation: Function): this;

                /**
                 * Removes a custom blend mode from the renderer.
                 * Any Game Objects still using this blend mode will error, so be sure to clear them first.
                 * @param index The index of the custom blend mode to be removed.
                 */
                removeBlendMode(index: number): this;

                /**
                 * Pushes a new framebuffer onto the FBO stack and makes it the currently bound framebuffer.
                 * 
                 * If there was another framebuffer already bound it will force a pipeline flush.
                 * 
                 * Call `popFramebuffer` to remove it again.
                 * @param framebuffer The framebuffer that needs to be bound.
                 * @param updateScissor Set the gl scissor to match the frame buffer size? Or, if `null` given, pop the scissor from the stack. Default false.
                 * @param setViewport Should the WebGL viewport be set? Default true.
                 * @param texture Bind the given frame buffer texture? Default null.
                 * @param clear Clear the frame buffer after binding? Default false.
                 */
                pushFramebuffer(framebuffer: WebGLFramebuffer, updateScissor?: boolean, setViewport?: boolean, texture?: WebGLTexture, clear?: boolean): this;

                /**
                 * Sets the given framebuffer as the active and currently bound framebuffer.
                 * 
                 * If there was another framebuffer already bound it will force a pipeline flush.
                 * 
                 * Typically, you should call `pushFramebuffer` instead of this method.
                 * @param framebuffer The framebuffer that needs to be bound.
                 * @param updateScissor If a framebuffer is given, set the gl scissor to match the frame buffer size? Or, if `null` given, pop the scissor from the stack. Default false.
                 * @param setViewport Should the WebGL viewport be set? Default true.
                 * @param texture Bind the given frame buffer texture? Default null.
                 * @param clear Clear the frame buffer after binding? Default false.
                 */
                setFramebuffer(framebuffer: WebGLFramebuffer, updateScissor?: boolean, setViewport?: boolean, texture?: WebGLTexture, clear?: boolean): this;

                /**
                 * Pops the previous framebuffer from the fbo stack and sets it.
                 * @param updateScissor If a framebuffer is given, set the gl scissor to match the frame buffer size? Or, if `null` given, pop the scissor from the stack. Default false.
                 * @param setViewport Should the WebGL viewport be set? Default true.
                 */
                popFramebuffer(updateScissor?: boolean, setViewport?: boolean): WebGLFramebuffer;

                /**
                 * Restores the previous framebuffer from the fbo stack and sets it.
                 * @param updateScissor If a framebuffer is given, set the gl scissor to match the frame buffer size? Or, if `null` given, pop the scissor from the stack. Default false.
                 * @param setViewport Should the WebGL viewport be set? Default true.
                 */
                restoreFramebuffer(updateScissor?: boolean, setViewport?: boolean): void;

                /**
                 * Binds a shader program.
                 * 
                 * If there was a different program already bound it will force a pipeline flush first.
                 * 
                 * If the same program given to this method is already set as the current program, no change
                 * will take place and this method will return `false`.
                 * @param program The program that needs to be bound.
                 */
                setProgram(program: WebGLProgram): boolean;

                /**
                 * Rebinds whatever program `WebGLRenderer.currentProgram` is set as, without
                 * changing anything, or flushing.
                 */
                resetProgram(): this;

                /**
                 * Creates a texture from an image source. If the source is not valid it creates an empty texture.
                 * @param source The source of the texture.
                 * @param width The width of the texture.
                 * @param height The height of the texture.
                 * @param scaleMode The scale mode to be used by the texture.
                 * @param forceClamp Force the texture to use the CLAMP_TO_EDGE wrap mode, even if a power of two? Default false.
                 */
                createTextureFromSource(source: object, width: number, height: number, scaleMode: number, forceClamp?: boolean): WebGLTexture | null;

                /**
                 * A wrapper for creating a WebGLTexture. If no pixel data is passed it will create an empty texture.
                 * @param mipLevel Mip level of the texture.
                 * @param minFilter Filtering of the texture.
                 * @param magFilter Filtering of the texture.
                 * @param wrapT Wrapping mode of the texture.
                 * @param wrapS Wrapping mode of the texture.
                 * @param format Which format does the texture use.
                 * @param pixels pixel data.
                 * @param width Width of the texture in pixels.
                 * @param height Height of the texture in pixels.
                 * @param pma Does the texture have premultiplied alpha? Default true.
                 * @param forceSize If `true` it will use the width and height passed to this method, regardless of the pixels dimension. Default false.
                 * @param flipY Sets the `UNPACK_FLIP_Y_WEBGL` flag the WebGL Texture uses during upload. Default false.
                 */
                createTexture2D(mipLevel: number, minFilter: number, magFilter: number, wrapT: number, wrapS: number, format: number, pixels: object | undefined, width: number, height: number, pma?: boolean, forceSize?: boolean, flipY?: boolean): WebGLTexture;

                /**
                 * Creates a WebGL Framebuffer object and optionally binds a depth stencil render buffer.
                 * @param width If `addDepthStencilBuffer` is true, this controls the width of the depth stencil.
                 * @param height If `addDepthStencilBuffer` is true, this controls the height of the depth stencil.
                 * @param renderTexture The color texture where the color pixels are written.
                 * @param addDepthStencilBuffer Create a Renderbuffer for the depth stencil? Default false.
                 */
                createFramebuffer(width: number, height: number, renderTexture: WebGLTexture, addDepthStencilBuffer?: boolean): WebGLFramebuffer;

                /**
                 * Binds necessary resources and renders the mask to a separated framebuffer.
                 * The framebuffer for the masked object is also bound for further use.
                 * @param mask The BitmapMask instance that called beginMask.
                 * @param camera The camera rendering the current mask.
                 */
                beginBitmapMask(mask: Phaser.Display.Masks.BitmapMask, camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Binds necessary resources and renders the mask to a separated framebuffer.
                 * The framebuffer for the masked object is also bound for further use.
                 * @param mask The BitmapMask instance that called beginMask.
                 * @param camera The camera rendering the current mask.
                 * @param bitmapMaskPipeline The BitmapMask Pipeline instance that is requesting the draw.
                 */
                drawBitmapMask(mask: Phaser.Display.Masks.BitmapMask, camera: Phaser.Cameras.Scene2D.Camera, bitmapMaskPipeline: Phaser.Renderer.WebGL.Pipelines.BitmapMaskPipeline): void;

                /**
                 * Creates a WebGLProgram instance based on the given vertex and fragment shader source.
                 * 
                 * Then compiles, attaches and links the program before returning it.
                 * @param vertexShader The vertex shader source code as a single string.
                 * @param fragmentShader The fragment shader source code as a single string.
                 */
                createProgram(vertexShader: string, fragmentShader: string): WebGLProgram;

                /**
                 * Wrapper for creating a vertex buffer.
                 * @param initialDataOrSize It's either ArrayBuffer or an integer indicating the size of the vbo
                 * @param bufferUsage How the buffer is used. gl.DYNAMIC_DRAW, gl.STATIC_DRAW or gl.STREAM_DRAW
                 */
                createVertexBuffer(initialDataOrSize: ArrayBuffer, bufferUsage: number): WebGLBuffer;

                /**
                 * Wrapper for creating a vertex buffer.
                 * @param initialDataOrSize Either ArrayBuffer or an integer indicating the size of the vbo.
                 * @param bufferUsage How the buffer is used. gl.DYNAMIC_DRAW, gl.STATIC_DRAW or gl.STREAM_DRAW.
                 */
                createIndexBuffer(initialDataOrSize: ArrayBuffer, bufferUsage: number): WebGLBuffer;

                /**
                 * Calls `GL.deleteTexture` on the given WebGLTexture and also optionally
                 * resets the currently defined textures.
                 * @param texture The WebGL Texture to be deleted.
                 */
                deleteTexture(texture: WebGLTexture): this;

                /**
                 * Deletes a WebGLFramebuffer from the GL instance.
                 * @param framebuffer The Framebuffer to be deleted.
                 */
                deleteFramebuffer(framebuffer: WebGLFramebuffer): this;

                /**
                 * Deletes a WebGLProgram from the GL instance.
                 * @param program The shader program to be deleted.
                 */
                deleteProgram(program: WebGLProgram): this;

                /**
                 * Deletes a WebGLBuffer from the GL instance.
                 * @param vertexBuffer The WebGLBuffer to be deleted.
                 */
                deleteBuffer(vertexBuffer: WebGLBuffer): this;

                /**
                 * Controls the pre-render operations for the given camera.
                 * Handles any clipping needed by the camera and renders the background color if a color is visible.
                 * @param camera The Camera to pre-render.
                 */
                preRenderCamera(camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Controls the post-render operations for the given camera.
                 * 
                 * Renders the foreground camera effects like flash and fading, then resets the current scissor state.
                 * @param camera The Camera to post-render.
                 */
                postRenderCamera(camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * Clears the current vertex buffer and updates pipelines.
                 */
                preRender(): void;

                /**
                 * The core render step for a Scene Camera.
                 * 
                 * Iterates through the given array of Game Objects and renders them with the given Camera.
                 * 
                 * This is called by the `CameraManager.render` method. The Camera Manager instance belongs to a Scene, and is invoked
                 * by the Scene Systems.render method.
                 * 
                 * This method is not called if `Camera.visible` is `false`, or `Camera.alpha` is zero.
                 * @param scene The Scene to render.
                 * @param children An array of filtered Game Objects that can be rendered by the given Camera.
                 * @param camera The Scene Camera to render with.
                 */
                render(scene: Phaser.Scene, children: Phaser.GameObjects.GameObject[], camera: Phaser.Cameras.Scene2D.Camera): void;

                /**
                 * The post-render step happens after all Cameras in all Scenes have been rendered.
                 */
                postRender(): void;

                /**
                 * Disables the STENCIL_TEST but does not change the status
                 * of the current stencil mask.
                 */
                clearStencilMask(): void;

                /**
                 * Restores the current stencil function to the one that was in place
                 * before `clearStencilMask` was called.
                 */
                restoreStencilMask(): void;

                /**
                 * Schedules a snapshot of the entire game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture a specific area see the `snapshotArea` method. To capture a specific pixel, see `snapshotPixel`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotPixel`, for example, then
                 * calling this method will override it.
                 * 
                 * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer into an ArrayBufferView.
                 * It then parses this, copying the contents to a temporary Canvas and finally creating an Image object from it,
                 * which is the image returned to the callback provided. All in all, this is a computationally expensive and blocking process,
                 * which gets more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshot(callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

                /**
                 * Schedules a snapshot of the given area of the game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture the whole game viewport see the `snapshot` method. To capture a specific pixel, see `snapshotPixel`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotPixel`, for example, then
                 * calling this method will override it.
                 * 
                 * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer into an ArrayBufferView.
                 * It then parses this, copying the contents to a temporary Canvas and finally creating an Image object from it,
                 * which is the image returned to the callback provided. All in all, this is a computationally expensive and blocking process,
                 * which gets more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param x The x coordinate to grab from. This is based on the game viewport, not the world.
                 * @param y The y coordinate to grab from. This is based on the game viewport, not the world.
                 * @param width The width of the area to grab.
                 * @param height The height of the area to grab.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshotArea(x: number, y: number, width: number, height: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

                /**
                 * Schedules a snapshot of the given pixel from the game viewport to be taken after the current frame is rendered.
                 * 
                 * To capture the whole game viewport see the `snapshot` method. To capture a specific area, see `snapshotArea`.
                 * 
                 * Only one snapshot can be active _per frame_. If you have already called `snapshotArea`, for example, then
                 * calling this method will override it.
                 * 
                 * Unlike the other two snapshot methods, this one will return a `Color` object containing the color data for
                 * the requested pixel. It doesn't need to create an internal Canvas or Image object, so is a lot faster to execute,
                 * using less memory.
                 * @param x The x coordinate of the pixel to get. This is based on the game viewport, not the world.
                 * @param y The y coordinate of the pixel to get. This is based on the game viewport, not the world.
                 * @param callback The Function to invoke after the snapshot pixel data is extracted.
                 */
                snapshotPixel(x: number, y: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback): this;

                /**
                 * Takes a snapshot of the given area of the given frame buffer.
                 * 
                 * Unlike the other snapshot methods, this one is processed immediately and doesn't wait for the next render.
                 * 
                 * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer into an ArrayBufferView.
                 * It then parses this, copying the contents to a temporary Canvas and finally creating an Image object from it,
                 * which is the image returned to the callback provided. All in all, this is a computationally expensive and blocking process,
                 * which gets more expensive the larger the canvas size gets, so please be careful how you employ this in your game.
                 * @param framebuffer The framebuffer to grab from.
                 * @param bufferWidth The width of the framebuffer.
                 * @param bufferHeight The height of the framebuffer.
                 * @param callback The Function to invoke after the snapshot image is created.
                 * @param getPixel Grab a single pixel as a Color object, or an area as an Image object? Default false.
                 * @param x The x coordinate to grab from. This is based on the framebuffer, not the world. Default 0.
                 * @param y The y coordinate to grab from. This is based on the framebuffer, not the world. Default 0.
                 * @param width The width of the area to grab. Default bufferWidth.
                 * @param height The height of the area to grab. Default bufferHeight.
                 * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
                 * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
                 */
                snapshotFramebuffer(framebuffer: WebGLFramebuffer, bufferWidth: number, bufferHeight: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, getPixel?: boolean, x?: number, y?: number, width?: number, height?: number, type?: string, encoderOptions?: number): this;

                /**
                 * Creates a new WebGL Texture based on the given Canvas Element.
                 * 
                 * If the `dstTexture` parameter is given, the WebGL Texture is updated, rather than created fresh.
                 * @param srcCanvas The Canvas to create the WebGL Texture from
                 * @param dstTexture The destination WebGL Texture to set.
                 * @param noRepeat Should this canvas be allowed to set `REPEAT` (such as for Text objects?) Default false.
                 * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y`? Default false.
                 */
                canvasToTexture(srcCanvas: HTMLCanvasElement, dstTexture?: WebGLTexture, noRepeat?: boolean, flipY?: boolean): WebGLTexture;

                /**
                 * Creates a new WebGL Texture based on the given Canvas Element.
                 * @param srcCanvas The Canvas to create the WebGL Texture from.
                 * @param noRepeat Should this canvas be allowed to set `REPEAT` (such as for Text objects?) Default false.
                 * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y`? Default false.
                 */
                createCanvasTexture(srcCanvas: HTMLCanvasElement, noRepeat?: boolean, flipY?: boolean): WebGLTexture;

                /**
                 * Updates a WebGL Texture based on the given Canvas Element.
                 * @param srcCanvas The Canvas to update the WebGL Texture from.
                 * @param dstTexture The destination WebGL Texture to update.
                 * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y`? Default false.
                 */
                updateCanvasTexture(srcCanvas: HTMLCanvasElement, dstTexture: WebGLTexture, flipY?: boolean): WebGLTexture;

                /**
                 * Creates a new WebGL Texture based on the given HTML Video Element.
                 * @param srcVideo The Video to create the WebGL Texture from
                 * @param noRepeat Should this canvas be allowed to set `REPEAT`? Default false.
                 * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y`? Default false.
                 */
                createVideoTexture(srcVideo: HTMLVideoElement, noRepeat?: boolean, flipY?: boolean): WebGLTexture;

                /**
                 * Updates a WebGL Texture based on the given HTML Video Element.
                 * @param srcVideo The Video to update the WebGL Texture with.
                 * @param dstTexture The destination WebGL Texture to update.
                 * @param flipY Should the WebGL Texture set `UNPACK_MULTIPLY_FLIP_Y`? Default false.
                 */
                updateVideoTexture(srcVideo: HTMLVideoElement, dstTexture: WebGLTexture, flipY?: boolean): WebGLTexture;

                /**
                 * Sets the minification and magnification filter for a texture.
                 * @param texture The texture to set the filter for.
                 * @param filter The filter to set. 0 for linear filtering, 1 for nearest neighbor (blocky) filtering.
                 */
                setTextureFilter(texture: number, filter: number): this;

                /**
                 * Returns the largest texture size (either width or height) that can be created.
                 * Note that VRAM may not allow a texture of any given size, it just expresses
                 * hardware / driver support for a given size.
                 */
                getMaxTextureSize(): number;

                /**
                 * Destroy this WebGLRenderer, cleaning up all related resources such as pipelines, native textures, etc.
                 */
                destroy(): void;

            }

            /**
             * Instances of the WebGLShader class belong to the WebGL Pipeline classes. When the pipeline is
             * created it will create an instance of this class for each one of its shaders, as defined in
             * the pipeline configuration.
             * 
             * This class encapsulates everything needed to manage a shader in a pipeline, including the
             * shader attributes and uniforms, as well as lots of handy methods such as `set2f`, for setting
             * uniform values on this shader.
             * 
             * Typically, you do not create an instance of this class directly, as it works in unison with
             * the pipeline to which it belongs. You can gain access to this class via a pipeline's `shaders`
             * array, post-creation.
             */
            class WebGLShader {
                /**
                 * 
                 * @param pipeline The WebGLPipeline to which this Shader belongs.
                 * @param name The name of this Shader.
                 * @param vertexShader The vertex shader source code as a single string.
                 * @param fragmentShader The fragment shader source code as a single string.
                 * @param attributes An array of attributes.
                 */
                constructor(pipeline: Phaser.Renderer.WebGL.WebGLPipeline, name: string, vertexShader: string, fragmentShader: string, attributes: Phaser.Types.Renderer.WebGL.WebGLPipelineAttributeConfig[]);

                /**
                 * A reference to the WebGLPipeline that owns this Shader.
                 * 
                 * A Shader class can only belong to a single pipeline.
                 */
                pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

                /**
                 * The name of this shader.
                 */
                name: string;

                /**
                 * A reference to the WebGLRenderer instance.
                 */
                renderer: Phaser.Renderer.WebGL.WebGLRenderer;

                /**
                 * A reference to the WebGL Rendering Context the WebGL Renderer is using.
                 */
                gl: WebGLRenderingContext;

                /**
                 * The fragment shader source code.
                 */
                fragSrc: string;

                /**
                 * The vertex shader source code.
                 */
                vertSrc: string;

                /**
                 * The WebGLProgram created from the vertex and fragment shaders.
                 */
                program: WebGLProgram;

                /**
                 * Array of objects that describe the vertex attributes.
                 */
                attributes: Phaser.Types.Renderer.WebGL.WebGLPipelineAttribute[];

                /**
                 * The amount of vertex attribute components of 32 bit length.
                 */
                vertexComponentCount: number;

                /**
                 * The size, in bytes, of a single vertex.
                 * 
                 * This is derived by adding together all of the vertex attributes.
                 * 
                 * For example, the Multi Pipeline has the following attributes:
                 * 
                 * inPosition - (size 2 x gl.FLOAT) = 8
                 * inTexCoord - (size 2 x gl.FLOAT) = 8
                 * inTexId - (size 1 x gl.FLOAT) = 4
                 * inTintEffect - (size 1 x gl.FLOAT) = 4
                 * inTint - (size 4 x gl.UNSIGNED_BYTE) = 4
                 * 
                 * The total, in this case, is 8 + 8 + 4 + 4 + 4 = 28.
                 * 
                 * This is calculated automatically during the `createAttributes` method.
                 */
                readonly vertexSize: number;

                /**
                 * The active uniforms that this shader has.
                 * 
                 * This is an object that maps the uniform names to their WebGL location and cached values.
                 * 
                 * It is populated automatically via the `createUniforms` method.
                 */
                uniforms: Phaser.Types.Renderer.WebGL.WebGLPipelineUniformsConfig;

                /**
                 * Takes the vertex attributes config and parses it, creating the resulting array that is stored
                 * in this shaders `attributes` property, calculating the offset, normalization and location
                 * in the process.
                 * 
                 * Calling this method resets `WebGLShader.attributes`, `WebGLShader.vertexSize` and
                 * `WebGLShader.vertexComponentCount`.
                 * 
                 * It is called automatically when this class is created, but can be called manually if required.
                 * @param attributes An array of attributes configs.
                 */
                createAttributes(attributes: Phaser.Types.Renderer.WebGL.WebGLPipelineAttributeConfig[]): void;

                /**
                 * Sets the program this shader uses as being the active shader in the WebGL Renderer.
                 * 
                 * This method is called every time the parent pipeline is made the current active pipeline.
                 * @param setAttributes Should the vertex attribute pointers be set? Default false.
                 * @param flush Flush the pipeline before binding this shader? Default false.
                 */
                bind(setAttributes?: boolean, flush?: boolean): this;

                /**
                 * Sets the program this shader uses as being the active shader in the WebGL Renderer.
                 * 
                 * Then resets all of the attribute pointers.
                 */
                rebind(): this;

                /**
                 * Sets the vertex attribute pointers.
                 * 
                 * This should only be called after the vertex buffer has been bound.
                 * 
                 * It is called automatically during the `bind` method.
                 * @param reset Reset the vertex attribute locations? Default false.
                 */
                setAttribPointers(reset?: boolean): this;

                /**
                 * Sets up the `WebGLShader.uniforms` object, populating it with the names
                 * and locations of the shader uniforms this shader requires.
                 * 
                 * It works by first calling `gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS)` to
                 * find out how many active uniforms this shader has. It then iterates through them,
                 * calling `gl.getActiveUniform` to get the WebGL Active Info from each one. Finally,
                 * the name and location are stored in the local array.
                 * 
                 * This method is called automatically when this class is created.
                 */
                createUniforms(): this;

                /**
                 * Checks to see if the given uniform name exists and is active in this shader.
                 * @param name The name of the uniform to check for.
                 */
                hasUniform(name: string): boolean;

                /**
                 * Resets the cached values of the given uniform.
                 * @param name The name of the uniform to reset.
                 */
                resetUniform(name: string): this;

                /**
                 * Sets the given uniform value/s based on the name and GL function.
                 * 
                 * This method is called internally by other methods such as `set1f` and `set3iv`.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param setter The GL function to call.
                 * @param name The name of the uniform to set.
                 * @param value1 The new value of the uniform.
                 * @param skipCheck Skip the value comparison? Default false.
                 */
                setUniform1(setter: Function, name: string, value1: boolean | number | number[] | Float32Array, skipCheck?: boolean): this;

                /**
                 * Sets the given uniform value/s based on the name and GL function.
                 * 
                 * This method is called internally by other methods such as `set1f` and `set3iv`.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param setter The GL function to call.
                 * @param name The name of the uniform to set.
                 * @param value1 The new value of the uniform.
                 * @param value2 The new value of the uniform.
                 * @param skipCheck Skip the value comparison? Default false.
                 */
                setUniform2(setter: Function, name: string, value1: boolean | number | number[] | Float32Array, value2: boolean | number | number[] | Float32Array, skipCheck?: boolean): this;

                /**
                 * Sets the given uniform value/s based on the name and GL function.
                 * 
                 * This method is called internally by other methods such as `set1f` and `set3iv`.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param setter The GL function to call.
                 * @param name The name of the uniform to set.
                 * @param value1 The new value of the uniform.
                 * @param value2 The new value of the uniform.
                 * @param value3 The new value of the uniform.
                 * @param skipCheck Skip the value comparison? Default false.
                 */
                setUniform3(setter: Function, name: string, value1: boolean | number | number[] | Float32Array, value2: boolean | number | number[] | Float32Array, value3: boolean | number | number[] | Float32Array, skipCheck?: boolean): this;

                /**
                 * Sets the given uniform value/s based on the name and GL function.
                 * 
                 * This method is called internally by other methods such as `set1f` and `set3iv`.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param setter The GL function to call.
                 * @param name The name of the uniform to set.
                 * @param value1 The new value of the uniform.
                 * @param value2 The new value of the uniform.
                 * @param value3 The new value of the uniform.
                 * @param value4 The new value of the uniform.
                 * @param skipCheck Skip the value comparison? Default false.
                 */
                setUniform4(setter: Function, name: string, value1: boolean | number | number[] | Float32Array, value2: boolean | number | number[] | Float32Array, value3: boolean | number | number[] | Float32Array, value4: boolean | number | number[] | Float32Array, skipCheck?: boolean): this;

                /**
                 * Sets a boolean uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param value The new value of the `boolean` uniform.
                 */
                setBoolean(name: string, value: boolean): this;

                /**
                 * Sets a 1f uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new value of the `float` uniform.
                 */
                set1f(name: string, x: number): this;

                /**
                 * Sets a 2f uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `vec2` uniform.
                 * @param y The new Y component of the `vec2` uniform.
                 */
                set2f(name: string, x: number, y: number): this;

                /**
                 * Sets a 3f uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `vec3` uniform.
                 * @param y The new Y component of the `vec3` uniform.
                 * @param z The new Z component of the `vec3` uniform.
                 */
                set3f(name: string, x: number, y: number, z: number): this;

                /**
                 * Sets a 4f uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x X component of the uniform
                 * @param y Y component of the uniform
                 * @param z Z component of the uniform
                 * @param w W component of the uniform
                 */
                set4f(name: string, x: number, y: number, z: number, w: number): this;

                /**
                 * Sets a 1fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set1fv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 2fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set2fv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 3fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set3fv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 4fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set4fv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 1iv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set1iv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 2iv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set2iv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 3iv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set3iv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 4iv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param arr The new value to be used for the uniform variable.
                 */
                set4iv(name: string, arr: number[] | Float32Array): this;

                /**
                 * Sets a 1i uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new value of the `int` uniform.
                 */
                set1i(name: string, x: number): this;

                /**
                 * Sets a 2i uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `ivec2` uniform.
                 * @param y The new Y component of the `ivec2` uniform.
                 */
                set2i(name: string, x: number, y: number): this;

                /**
                 * Sets a 3i uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x The new X component of the `ivec3` uniform.
                 * @param y The new Y component of the `ivec3` uniform.
                 * @param z The new Z component of the `ivec3` uniform.
                 */
                set3i(name: string, x: number, y: number, z: number): this;

                /**
                 * Sets a 4i uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param x X component of the uniform
                 * @param y Y component of the uniform
                 * @param z Z component of the uniform
                 * @param w W component of the uniform
                 */
                set4i(name: string, x: number, y: number, z: number, w: number): this;

                /**
                 * Sets a matrix 2fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param transpose Whether to transpose the matrix. Should be `false`.
                 * @param matrix The new values for the `mat2` uniform.
                 */
                setMatrix2fv(name: string, transpose: boolean, matrix: number[] | Float32Array): this;

                /**
                 * Sets a matrix 3fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param transpose Whether to transpose the matrix. Should be `false`.
                 * @param matrix The new values for the `mat3` uniform.
                 */
                setMatrix3fv(name: string, transpose: boolean, matrix: Float32Array): this;

                /**
                 * Sets a matrix 4fv uniform value based on the given name on this shader.
                 * 
                 * The uniform is only set if the value/s given are different to those previously set.
                 * 
                 * This method works by first setting this shader as being the current shader within the
                 * WebGL Renderer, if it isn't already. It also sets this shader as being the current
                 * one within the pipeline it belongs to.
                 * @param name The name of the uniform to set.
                 * @param transpose Should the matrix be transpose
                 * @param matrix Matrix data
                 */
                setMatrix4fv(name: string, transpose: boolean, matrix: Float32Array): this;

                /**
                 * This method will create the Shader Program on the current GL context.
                 * 
                 * If a program already exists, it will be destroyed and the new one will take its place.
                 * 
                 * After the program is created the uniforms will be reset and
                 * this shader will be rebound.
                 * 
                 * This is a very expensive process and if your shader is referenced elsewhere in
                 * your game those references may then be lost, so be sure to use this carefully.
                 * 
                 * However, if you need to update say the fragment shader source, then you can pass
                 * the new source into this method and it'll rebuild the program using it. If you
                 * don't want to change the vertex shader src, pass `undefined` as the parameter.
                 * @param vertSrc The source code of the vertex shader. If not given, uses the source already defined in this Shader.
                 * @param fragSrc The source code of the fragment shader. If not given, uses the source already defined in this Shader.
                 */
                createProgram(vertSrc?: string, fragSrc?: string): this;

                /**
                 * Removes all external references from this class and deletes the WebGL program from the WebGL context.
                 * 
                 * Does not remove this shader from the parent pipeline.
                 */
                destroy(): void;

            }

        }

    }

    /**
     * Phaser Scale Modes.
     */
    enum ScaleModes {
        /**
         * Default Scale Mode (Linear).
         */
        DEFAULT,
        /**
         * Linear Scale Mode.
         */
        LINEAR,
        /**
         * Nearest Scale Mode.
         */
        NEAREST,
    }

    namespace Scale {
        /**
         * Phaser Scale Manager constants for centering the game canvas.
         */
        enum Center {
            /**
             * The game canvas is not centered within the parent by Phaser.
             * You can still center it yourself via CSS.
             */
            NO_CENTER,
            /**
             * The game canvas is centered both horizontally and vertically within the parent.
             * To do this, the parent has to have a bounds that can be calculated and not be empty.
             * 
             * Centering is achieved by setting the margin left and top properties of the
             * game canvas, and does not factor in any other CSS styles you may have applied.
             */
            CENTER_BOTH,
            /**
             * The game canvas is centered horizontally within the parent.
             * To do this, the parent has to have a bounds that can be calculated and not be empty.
             * 
             * Centering is achieved by setting the margin left and top properties of the
             * game canvas, and does not factor in any other CSS styles you may have applied.
             */
            CENTER_HORIZONTALLY,
            /**
             * The game canvas is centered both vertically within the parent.
             * To do this, the parent has to have a bounds that can be calculated and not be empty.
             * 
             * Centering is achieved by setting the margin left and top properties of the
             * game canvas, and does not factor in any other CSS styles you may have applied.
             */
            CENTER_VERTICALLY,
        }

        /**
         * Phaser Scale Manager constants for centering the game canvas.
         * 
         * To find out what each mode does please see [Phaser.Scale.Center]{@link Phaser.Scale.Center}.
         */
        type CenterType = Phaser.Scale.Center;

        /**
         * Phaser Scale Manager constants for orientation.
         */
        enum Orientation {
            /**
             * A landscape orientation.
             */
            LANDSCAPE,
            /**
             * A portrait orientation.
             */
            PORTRAIT,
        }

        /**
         * Phaser Scale Manager constants for orientation.
         * 
         * To find out what each mode does please see [Phaser.Scale.Orientation]{@link Phaser.Scale.Orientation}.
         */
        type OrientationType = Phaser.Scale.Orientation;

        /**
         * Phaser Scale Manager constants for the different scale modes available.
         */
        enum ScaleModes {
            /**
             * No scaling happens at all. The canvas is set to the size given in the game config and Phaser doesn't change it
             * again from that point on. If you change the canvas size, either via CSS, or directly via code, then you need
             * to call the Scale Managers `resize` method to give the new dimensions, or input events will stop working.
             */
            NONE,
            /**
             * The height is automatically adjusted based on the width.
             */
            WIDTH_CONTROLS_HEIGHT,
            /**
             * The width is automatically adjusted based on the height.
             */
            HEIGHT_CONTROLS_WIDTH,
            /**
             * The width and height are automatically adjusted to fit inside the given target area,
             * while keeping the aspect ratio. Depending on the aspect ratio there may be some space
             * inside the area which is not covered.
             */
            FIT,
            /**
             * The width and height are automatically adjusted to make the size cover the entire target
             * area while keeping the aspect ratio. This may extend further out than the target size.
             */
            ENVELOP,
            /**
             * The Canvas is resized to fit all available _parent_ space, regardless of aspect ratio.
             */
            RESIZE,
        }

        /**
         * Phaser Scale Manager constants for the different scale modes available.
         * 
         * To find out what each mode does please see [Phaser.Scale.ScaleModes]{@link Phaser.Scale.ScaleModes}.
         */
        type ScaleModeType = Phaser.Scale.ScaleModes;

        /**
         * Phaser Scale Manager constants for zoom modes.
         */
        enum Zoom {
            /**
             * The game canvas will not be zoomed by Phaser.
             */
            NO_ZOOM,
            /**
             * The game canvas will be 2x zoomed by Phaser.
             */
            ZOOM_2X,
            /**
             * The game canvas will be 4x zoomed by Phaser.
             */
            ZOOM_4X,
            /**
             * Calculate the zoom value based on the maximum multiplied game size that will
             * fit into the parent, or browser window if no parent is set.
             */
            MAX_ZOOM,
        }

        /**
         * Phaser Scale Manager constants for zoom modes.
         * 
         * To find out what each mode does please see [Phaser.Scale.Zoom]{@link Phaser.Scale.Zoom}.
         */
        type ZoomType = Phaser.Scale.Zoom;

        namespace Events {
            /**
             * The Scale Manager has successfully entered fullscreen mode.
             */
            const ENTER_FULLSCREEN: string;

            /**
             * The Scale Manager tried to enter fullscreen mode but failed.
             */
            const FULLSCREEN_FAILED: string;

            /**
             * The Scale Manager tried to enter fullscreen mode, but it is unsupported by the browser.
             */
            const FULLSCREEN_UNSUPPORTED: string;

            /**
             * The Scale Manager was in fullscreen mode, but has since left, either directly via game code,
             * or via a user gestured, such as pressing the ESC key.
             */
            const LEAVE_FULLSCREEN: string;

            /**
             * The Scale Manager Orientation Change Event.
             * 
             * This event is dispatched whenever the Scale Manager detects an orientation change event from the browser.
             */
            const ORIENTATION_CHANGE: string;

            /**
             * The Scale Manager Resize Event.
             * 
             * This event is dispatched whenever the Scale Manager detects a resize event from the browser.
             * It sends three parameters to the callback, each of them being Size components. You can read
             * the `width`, `height`, `aspectRatio` and other properties of these components to help with
             * scaling your own game content.
             */
            const RESIZE: string;

        }

        /**
         * The Scale Manager handles the scaling, resizing and alignment of the game canvas.
         * 
         * The way scaling is handled is by setting the game canvas to a fixed size, which is defined in the
         * game configuration. You also define the parent container in the game config. If no parent is given,
         * it will default to using the document body. The Scale Manager will then look at the available space
         * within the _parent_ and scale the canvas accordingly. Scaling is handled by setting the canvas CSS
         * width and height properties, leaving the width and height of the canvas element itself untouched.
         * Scaling is therefore achieved by keeping the core canvas the same size and 'stretching'
         * it via its CSS properties. This gives the same result and speed as using the `transform-scale` CSS
         * property, without the need for browser prefix handling.
         * 
         * The calculations for the scale are heavily influenced by the bounding parent size, which is the computed
         * dimensions of the canvas's parent. The CSS rules of the parent element play an important role in the
         * operation of the Scale Manager. For example, if the parent has no defined width or height, then actions
         * like auto-centering will fail to achieve the required result. The Scale Manager works in tandem with the
         * CSS you set-up on the page hosting your game, rather than taking control of it.
         * 
         * #### Parent and Display canvas containment guidelines:
         * 
         * - Style the Parent element (of the game canvas) to control the Parent size and thus the games size and layout.
         * 
         * - The Parent element's CSS styles should _effectively_ apply maximum (and minimum) bounding behavior.
         * 
         * - The Parent element should _not_ apply a padding as this is not accounted for.
         *   If a padding is required apply it to the Parent's parent or apply a margin to the Parent.
         *   If you need to add a border, margin or any other CSS around your game container, then use a parent element and
         *   apply the CSS to this instead, otherwise you'll be constantly resizing the shape of the game container.
         * 
         * - The Display canvas layout CSS styles (i.e. margins, size) should not be altered / specified as
         *   they may be updated by the Scale Manager.
         * 
         * #### Scale Modes
         * 
         * The way the scaling is handled is determined by the `scaleMode` property. The default is `NONE`,
         * which prevents Phaser from scaling or touching the canvas, or its parent, at all. In this mode, you are
         * responsible for all scaling. The other scaling modes afford you automatic scaling.
         * 
         * If you wish to scale your game so that it always fits into the available space within the parent, you
         * should use the scale mode `FIT`. Look at the documentation for other scale modes to see what options are
         * available. Here is a basic config showing how to set this scale mode:
         * 
         * ```javascript
         * scale: {
         *     parent: 'yourgamediv',
         *     mode: Phaser.Scale.FIT,
         *     width: 800,
         *     height: 600
         * }
         * ```
         * 
         * Place the `scale` config object within your game config.
         * 
         * If you wish for the canvas to be resized directly, so that the canvas itself fills the available space
         * (i.e. it isn't scaled, it's resized) then use the `RESIZE` scale mode. This will give you a 1:1 mapping
         * of canvas pixels to game size. In this mode CSS isn't used to scale the canvas, it's literally adjusted
         * to fill all available space within the parent. You should be extremely careful about the size of the
         * canvas you're creating when doing this, as the larger the area, the more work the GPU has to do and it's
         * very easy to hit fill-rate limits quickly.
         * 
         * For complex, custom-scaling requirements, you should probably consider using the `RESIZE` scale mode,
         * with your own limitations in place re: canvas dimensions and managing the scaling with the game scenes
         * yourself. For the vast majority of games, however, the `FIT` mode is likely to be the most used.
         * 
         * Please appreciate that the Scale Manager cannot perform miracles. All it does is scale your game canvas
         * as best it can, based on what it can infer from its surrounding area. There are all kinds of environments
         * where it's up to you to guide and help the canvas position itself, especially when built into rendering
         * frameworks like React and Vue. If your page requires meta tags to prevent user scaling gestures, or such
         * like, then it's up to you to ensure they are present in the html.
         * 
         * #### Centering
         * 
         * You can also have the game canvas automatically centered. Again, this relies heavily on the parent being
         * properly configured and styled, as the centering offsets are based entirely on the available space
         * within the parent element. Centering is disabled by default, or can be applied horizontally, vertically,
         * or both. Here's an example:
         * 
         * ```javascript
         * scale: {
         *     parent: 'yourgamediv',
         *     autoCenter: Phaser.Scale.CENTER_BOTH,
         *     width: 800,
         *     height: 600
         * }
         * ```
         * 
         * #### Fullscreen API
         * 
         * If the browser supports it, you can send your game into fullscreen mode. In this mode, the game will fill
         * the entire display, removing all browser UI and anything else present on the screen. It will remain in this
         * mode until your game either disables it, or until the user tabs out or presses ESCape if on desktop. It's a
         * great way to achieve a desktop-game like experience from the browser, but it does require a modern browser
         * to handle it. Some mobile browsers also support this.
         */
        class ScaleManager extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param game A reference to the Phaser.Game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * A reference to the Phaser.Game instance.
             */
            readonly game: Phaser.Game;

            /**
             * A reference to the HTML Canvas Element that Phaser uses to render the game.
             */
            canvas: HTMLCanvasElement;

            /**
             * The DOM bounds of the canvas element.
             */
            canvasBounds: Phaser.Geom.Rectangle;

            /**
             * The parent object of the Canvas. Often a div, or the browser window, or nothing in non-browser environments.
             * 
             * This is set in the Game Config as the `parent` property. If undefined (or just not present), it will default
             * to use the document body. If specifically set to `null` Phaser will ignore all parent operations.
             */
            parent: any | null;

            /**
             * Is the parent element the browser window?
             */
            parentIsWindow: boolean;

            /**
             * The Parent Size component.
             */
            parentSize: Phaser.Structs.Size;

            /**
             * The Game Size component.
             * 
             * The un-modified game size, as requested in the game config (the raw width / height),
             * as used for world bounds, cameras, etc
             */
            gameSize: Phaser.Structs.Size;

            /**
             * The Base Size component.
             * 
             * The modified game size, which is the auto-rounded gameSize, used to set the canvas width and height
             * (but not the CSS style)
             */
            baseSize: Phaser.Structs.Size;

            /**
             * The Display Size component.
             * 
             * The size used for the canvas style, factoring in the scale mode, parent and other values.
             */
            displaySize: Phaser.Structs.Size;

            /**
             * The game scale mode.
             */
            scaleMode: Phaser.Scale.ScaleModeType;

            /**
             * The game zoom factor.
             * 
             * This value allows you to multiply your games base size by the given zoom factor.
             * This is then used when calculating the display size, even in `NONE` situations.
             * If you don't want Phaser to touch the canvas style at all, this value should be 1.
             * 
             * Can also be set to `MAX_ZOOM` in which case the zoom value will be derived based
             * on the game size and available space within the parent.
             */
            zoom: number;

            /**
             * Internal flag set when the game zoom factor is modified.
             */
            readonly _resetZoom: boolean;

            /**
             * The scale factor between the baseSize and the canvasBounds.
             */
            displayScale: Phaser.Math.Vector2;

            /**
             * If set, the canvas sizes will be automatically passed through Math.floor.
             * This results in rounded pixel display values, which is important for performance on legacy
             * and low powered devices, but at the cost of not achieving a 'perfect' fit in some browser windows.
             */
            autoRound: boolean;

            /**
             * Automatically center the canvas within the parent? The different centering modes are:
             * 
             * 1. No centering.
             * 2. Center both horizontally and vertically.
             * 3. Center horizontally.
             * 4. Center vertically.
             * 
             * Please be aware that in order to center the game canvas, you must have specified a parent
             * that has a size set, or the canvas parent is the document.body.
             */
            autoCenter: Phaser.Scale.CenterType;

            /**
             * The current device orientation.
             * 
             * Orientation events are dispatched via the Device Orientation API, typically only on mobile browsers.
             */
            orientation: Phaser.Scale.OrientationType;

            /**
             * A reference to the Device.Fullscreen object.
             */
            fullscreen: Phaser.Device.Fullscreen;

            /**
             * The DOM Element which is sent into fullscreen mode.
             */
            fullscreenTarget: any | null;

            /**
             * The dirty state of the Scale Manager.
             * Set if there is a change between the parent size and the current size.
             */
            dirty: boolean;

            /**
             * How many milliseconds should elapse before checking if the browser size has changed?
             * 
             * Most modern browsers dispatch a 'resize' event, which the Scale Manager will listen for.
             * However, older browsers fail to do this, or do it consistently, so we fall back to a
             * more traditional 'size check' based on a time interval. You can control how often it is
             * checked here.
             */
            resizeInterval: number;

            /**
             * Called _before_ the canvas object is created and added to the DOM.
             */
            protected preBoot(): void;

            /**
             * The Boot handler is called by Phaser.Game when it first starts up.
             * The renderer is available by now and the canvas has been added to the DOM.
             */
            protected boot(): void;

            /**
             * Parses the game configuration to set-up the scale defaults.
             * @param config The Game configuration object.
             */
            protected parseConfig(config: Phaser.Types.Core.GameConfig): void;

            /**
             * Determines the parent element of the game canvas, if any, based on the game configuration.
             * @param config The Game configuration object.
             */
            getParent(config: Phaser.Types.Core.GameConfig): void;

            /**
             * Calculates the size of the parent bounds and updates the `parentSize`
             * properties, only if the canvas has a dom parent.
             */
            getParentBounds(): boolean;

            /**
             * Attempts to lock the orientation of the web browser using the Screen Orientation API.
             * 
             * This API is only available on modern mobile browsers.
             * See https://developer.mozilla.org/en-US/docs/Web/API/Screen/lockOrientation for details.
             * @param orientation The orientation you'd like to lock the browser in. Should be an API string such as 'landscape', 'landscape-primary', 'portrait', etc.
             */
            lockOrientation(orientation: string): boolean;

            /**
             * This method will set the size of the Parent Size component, which is used in scaling
             * and centering calculations. You only need to call this method if you have explicitly
             * disabled the use of a parent in your game config, but still wish to take advantage of
             * other Scale Manager features.
             * @param width The new width of the parent.
             * @param height The new height of the parent.
             */
            setParentSize(width: number, height: number): this;

            /**
             * This method will set a new size for your game.
             * 
             * It should only be used if you're looking to change the base size of your game and are using
             * one of the Scale Manager scaling modes, i.e. `FIT`. If you're using `NONE` and wish to
             * change the game and canvas size directly, then please use the `resize` method instead.
             * @param width The new width of the game.
             * @param height The new height of the game.
             */
            setGameSize(width: number, height: number): this;

            /**
             * Call this to modify the size of the Phaser canvas element directly.
             * You should only use this if you are using the `NONE` scale mode,
             * it will update all internal components completely.
             * 
             * If all you want to do is change the size of the parent, see the `setParentSize` method.
             * 
             * If all you want is to change the base size of the game, but still have the Scale Manager
             * manage all the scaling (i.e. you're **not** using `NONE`), then see the `setGameSize` method.
             * 
             * This method will set the `gameSize`, `baseSize` and `displaySize` components to the given
             * dimensions. It will then resize the canvas width and height to the values given, by
             * directly setting the properties. Finally, if you have set the Scale Manager zoom value
             * to anything other than 1 (the default), it will set the canvas CSS width and height to
             * be the given size multiplied by the zoom factor (the canvas pixel size remains untouched).
             * 
             * If you have enabled `autoCenter`, it is then passed to the `updateCenter` method and
             * the margins are set, allowing the canvas to be centered based on its parent element
             * alone. Finally, the `displayScale` is adjusted and the RESIZE event dispatched.
             * @param width The new width of the game.
             * @param height The new height of the game.
             */
            resize(width: number, height: number): this;

            /**
             * Sets the zoom value of the Scale Manager.
             * @param value The new zoom value of the game.
             */
            setZoom(value: number): this;

            /**
             * Sets the zoom to be the maximum possible based on the _current_ parent size.
             */
            setMaxZoom(): this;

            /**
             * Refreshes the internal scale values, bounds sizes and orientation checks.
             * 
             * Once finished, dispatches the resize event.
             * 
             * This is called automatically by the Scale Manager when the browser window size changes,
             * as long as it is using a Scale Mode other than 'NONE'.
             * @param previousWidth The previous width of the game. Only set if the gameSize has changed.
             * @param previousHeight The previous height of the game. Only set if the gameSize has changed.
             */
            refresh(previousWidth?: number, previousHeight?: number): this;

            /**
             * Internal method that checks the current screen orientation, only if the internal check flag is set.
             * 
             * If the orientation has changed it updates the orientation property and then dispatches the orientation change event.
             */
            updateOrientation(): void;

            /**
             * Internal method that manages updating the size components based on the scale mode.
             */
            updateScale(): void;

            /**
             * Calculates and returns the largest possible zoom factor, based on the current
             * parent and game sizes. If the parent has no dimensions (i.e. an unstyled div),
             * or is smaller than the un-zoomed game, then this will return a value of 1 (no zoom)
             */
            getMaxZoom(): number;

            /**
             * Calculates and updates the canvas CSS style in order to center it within the
             * bounds of its parent. If you have explicitly set parent to be `null` in your
             * game config then this method will likely give incorrect results unless you have called the
             * `setParentSize` method first.
             * 
             * It works by modifying the canvas CSS `marginLeft` and `marginTop` properties.
             * 
             * If they have already been set by your own style sheet, or code, this will overwrite them.
             * 
             * To prevent the Scale Manager from centering the canvas, either do not set the
             * `autoCenter` property in your game config, or make sure it is set to `NO_CENTER`.
             */
            updateCenter(): void;

            /**
             * Updates the `canvasBounds` rectangle to match the bounding client rectangle of the
             * canvas element being used to track input events.
             */
            updateBounds(): void;

            /**
             * Transforms the pageX value into the scaled coordinate space of the Scale Manager.
             * @param pageX The DOM pageX value.
             */
            transformX(pageX: number): number;

            /**
             * Transforms the pageY value into the scaled coordinate space of the Scale Manager.
             * @param pageY The DOM pageY value.
             */
            transformY(pageY: number): number;

            /**
             * Sends a request to the browser to ask it to go in to full screen mode, using the {@link https://developer.mozilla.org/en-US/docs/Web/API/Fullscreen_API Fullscreen API}.
             * 
             * If the browser does not support this, a `FULLSCREEN_UNSUPPORTED` event will be emitted.
             * 
             * This method _must_ be called from a `pointerup` user-input gesture (**not** `pointerdown`). You cannot launch
             * games fullscreen without this, as most browsers block it. Games within an iframe will also be blocked
             * from fullscreen unless the iframe has the `allowfullscreen` attribute.
             * 
             * On touch devices, such as Android and iOS Safari, you should always use `pointerup` and NOT `pointerdown`,
             * otherwise the request will fail unless the document in which your game is embedded has already received
             * some form of touch input, which you cannot guarantee. Activating fullscreen via `pointerup` circumvents
             * this issue.
             * 
             * Performing an action that navigates to another page, or opens another tab, will automatically cancel
             * fullscreen mode, as will the user pressing the ESC key. To cancel fullscreen mode directly from your game,
             * i.e. by clicking an icon, call the `stopFullscreen` method.
             * 
             * A browser can only send one DOM element into fullscreen. You can control which element this is by
             * setting the `fullscreenTarget` property in your game config, or changing the property in the Scale Manager.
             * Note that the game canvas _must_ be a child of the target. If you do not give a target, Phaser will
             * automatically create a blank `<div>` element and move the canvas into it, before going fullscreen.
             * When it leaves fullscreen, the div will be removed.
             * @param fullscreenOptions The FullscreenOptions dictionary is used to provide configuration options when entering full screen.
             */
            startFullscreen(fullscreenOptions?: object): void;

            /**
             * An internal method that gets the target element that is used when entering fullscreen mode.
             */
            getFullscreenTarget(): object;

            /**
             * Removes the fullscreen target that was added to the DOM.
             */
            removeFullscreenTarget(): void;

            /**
             * Calling this method will cancel fullscreen mode, if the browser has entered it.
             */
            stopFullscreen(): void;

            /**
             * Toggles the fullscreen mode. If already in fullscreen, calling this will cancel it.
             * If not in fullscreen, this will request the browser to enter fullscreen mode.
             * 
             * If the browser does not support this, a `FULLSCREEN_UNSUPPORTED` event will be emitted.
             * 
             * This method _must_ be called from a user-input gesture, such as `pointerdown`. You cannot launch
             * games fullscreen without this, as most browsers block it. Games within an iframe will also be blocked
             * from fullscreen unless the iframe has the `allowfullscreen` attribute.
             * @param fullscreenOptions The FullscreenOptions dictionary is used to provide configuration options when entering full screen.
             */
            toggleFullscreen(fullscreenOptions?: object): void;

            /**
             * An internal method that starts the different DOM event listeners running.
             */
            startListeners(): void;

            /**
             * Triggered when a fullscreenchange event is dispatched by the DOM.
             */
            protected onFullScreenChange(): void;

            /**
             * Triggered when a fullscreenerror event is dispatched by the DOM.
             */
            onFullScreenError(): void;

            /**
             * Get Rectange of visible area.
             * @param camera The camera this viewport is respond upon.
             * @param out The Rectangle of visible area.
             */
            getViewPort(camera?: Phaser.Cameras.Scene2D.Camera, out?: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle;

            /**
             * Internal method, called automatically by the game step.
             * Monitors the elapsed time and resize interval to see if a parent bounds check needs to take place.
             * @param time The time value from the most recent Game step. Typically a high-resolution timer value, or Date.now().
             * @param delta The delta value since the last frame. This is smoothed to avoid delta spikes by the TimeStep class.
             */
            step(time: number, delta: number): void;

            /**
             * Stops all DOM event listeners.
             */
            stopListeners(): void;

            /**
             * Destroys this Scale Manager, releasing all references to external resources.
             * Once destroyed, the Scale Manager cannot be used again.
             */
            destroy(): void;

            /**
             * Is the browser currently in fullscreen mode or not?
             */
            readonly isFullscreen: boolean;

            /**
             * The game width.
             * 
             * This is typically the size given in the game configuration.
             */
            readonly width: number;

            /**
             * The game height.
             * 
             * This is typically the size given in the game configuration.
             */
            readonly height: number;

            /**
             * Is the device in a portrait orientation as reported by the Orientation API?
             * This value is usually only available on mobile devices.
             */
            readonly isPortrait: boolean;

            /**
             * Is the device in a landscape orientation as reported by the Orientation API?
             * This value is usually only available on mobile devices.
             */
            readonly isLandscape: boolean;

            /**
             * Are the game dimensions portrait? (i.e. taller than they are wide)
             * 
             * This is different to the device itself being in a portrait orientation.
             */
            readonly isGamePortrait: boolean;

            /**
             * Are the game dimensions landscape? (i.e. wider than they are tall)
             * 
             * This is different to the device itself being in a landscape orientation.
             */
            readonly isGameLandscape: boolean;

        }

        /**
         * The game canvas is not centered within the parent by Phaser.
         * You can still center it yourself via CSS.
         */
        const NO_CENTER: number;

        /**
         * The game canvas is centered both horizontally and vertically within the parent.
         * To do this, the parent has to have a bounds that can be calculated and not be empty.
         * 
         * Centering is achieved by setting the margin left and top properties of the
         * game canvas, and does not factor in any other CSS styles you may have applied.
         */
        const CENTER_BOTH: number;

        /**
         * The game canvas is centered horizontally within the parent.
         * To do this, the parent has to have a bounds that can be calculated and not be empty.
         * 
         * Centering is achieved by setting the margin left and top properties of the
         * game canvas, and does not factor in any other CSS styles you may have applied.
         */
        const CENTER_HORIZONTALLY: number;

        /**
         * The game canvas is centered both vertically within the parent.
         * To do this, the parent has to have a bounds that can be calculated and not be empty.
         * 
         * Centering is achieved by setting the margin left and top properties of the
         * game canvas, and does not factor in any other CSS styles you may have applied.
         */
        const CENTER_VERTICALLY: number;

        /**
         * A landscape orientation.
         */
        const LANDSCAPE: string;

        /**
         * A portrait orientation.
         */
        const PORTRAIT: string;

        /**
         * No scaling happens at all. The canvas is set to the size given in the game config and Phaser doesn't change it
         * again from that point on. If you change the canvas size, either via CSS, or directly via code, then you need
         * to call the Scale Managers `resize` method to give the new dimensions, or input events will stop working.
         */
        const NONE: number;

        /**
         * The height is automatically adjusted based on the width.
         */
        const WIDTH_CONTROLS_HEIGHT: number;

        /**
         * The width is automatically adjusted based on the height.
         */
        const HEIGHT_CONTROLS_WIDTH: number;

        /**
         * The width and height are automatically adjusted to fit inside the given target area,
         * while keeping the aspect ratio. Depending on the aspect ratio there may be some space
         * inside the area which is not covered.
         */
        const FIT: number;

        /**
         * The width and height are automatically adjusted to make the size cover the entire target
         * area while keeping the aspect ratio. This may extend further out than the target size.
         */
        const ENVELOP: number;

        /**
         * The Canvas is resized to fit all available _parent_ space, regardless of aspect ratio.
         */
        const RESIZE: number;

        /**
         * The game canvas will not be zoomed by Phaser.
         */
        const NO_ZOOM: number;

        /**
         * The game canvas will be 2x zoomed by Phaser.
         */
        const ZOOM_2X: number;

        /**
         * The game canvas will be 4x zoomed by Phaser.
         */
        const ZOOM_4X: number;

        /**
         * Calculate the zoom value based on the maximum multiplied game size that will
         * fit into the parent, or browser window if no parent is set.
         */
        const MAX_ZOOM: number;

    }

    namespace Scenes {
        /**
         * Scene state.
         */
        var PENDING: number;

        /**
         * Scene state.
         */
        var INIT: number;

        /**
         * Scene state.
         */
        var START: number;

        /**
         * Scene state.
         */
        var LOADING: number;

        /**
         * Scene state.
         */
        var CREATING: number;

        /**
         * Scene state.
         */
        var RUNNING: number;

        /**
         * Scene state.
         */
        var PAUSED: number;

        /**
         * Scene state.
         */
        var SLEEPING: number;

        /**
         * Scene state.
         */
        var SHUTDOWN: number;

        /**
         * Scene state.
         */
        var DESTROYED: number;

        namespace Events {
            /**
             * The Game Object Added to Scene Event.
             * 
             * This event is dispatched when a Game Object is added to a Scene.
             * 
             * Listen for it from a Scene using `this.events.on('addedtoscene', listener)`.
             */
            const ADDED_TO_SCENE: string;

            /**
             * The Scene Systems Boot Event.
             * 
             * This event is dispatched by a Scene during the Scene Systems boot process. Primarily used by Scene Plugins.
             * 
             * Listen to it from a Scene using `this.events.on('boot', listener)`.
             */
            const BOOT: string;

            /**
             * The Scene Create Event.
             * 
             * This event is dispatched by a Scene after it has been created by the Scene Manager.
             * 
             * If a Scene has a `create` method then this event is emitted _after_ that has run.
             * 
             * If there is a transition, this event will be fired after the `TRANSITION_START` event.
             * 
             * Listen to it from a Scene using `this.events.on('create', listener)`.
             */
            const CREATE: string;

            /**
             * The Scene Systems Destroy Event.
             * 
             * This event is dispatched by a Scene during the Scene Systems destroy process.
             * 
             * Listen to it from a Scene using `this.events.on('destroy', listener)`.
             * 
             * You should destroy any resources that may be in use by your Scene in this event handler.
             */
            const DESTROY: string;

            /**
             * The Scene Systems Pause Event.
             * 
             * This event is dispatched by a Scene when it is paused, either directly via the `pause` method, or as an
             * action from another Scene.
             * 
             * Listen to it from a Scene using `this.events.on('pause', listener)`.
             */
            const PAUSE: string;

            /**
             * The Scene Systems Post Update Event.
             * 
             * This event is dispatched by a Scene during the main game loop step.
             * 
             * The event flow for a single step of a Scene is as follows:
             * 
             * 1. [PRE_UPDATE]{@linkcode Phaser.Scenes.Events#event:PRE_UPDATE}
             * 2. [UPDATE]{@linkcode Phaser.Scenes.Events#event:UPDATE}
             * 3. The `Scene.update` method is called, if it exists
             * 4. [POST_UPDATE]{@linkcode Phaser.Scenes.Events#event:POST_UPDATE}
             * 5. [PRE_RENDER]{@linkcode Phaser.Scenes.Events#event:PRE_RENDER}
             * 6. [RENDER]{@linkcode Phaser.Scenes.Events#event:RENDER}
             * 
             * Listen to it from a Scene using `this.events.on('postupdate', listener)`.
             * 
             * A Scene will only run its step if it is active.
             */
            const POST_UPDATE: string;

            /**
             * The Scene Systems Pre-Render Event.
             * 
             * This event is dispatched by a Scene during the main game loop step.
             * 
             * The event flow for a single step of a Scene is as follows:
             * 
             * 1. [PRE_UPDATE]{@linkcode Phaser.Scenes.Events#event:PRE_UPDATE}
             * 2. [UPDATE]{@linkcode Phaser.Scenes.Events#event:UPDATE}
             * 3. The `Scene.update` method is called, if it exists
             * 4. [POST_UPDATE]{@linkcode Phaser.Scenes.Events#event:POST_UPDATE}
             * 5. [PRE_RENDER]{@linkcode Phaser.Scenes.Events#event:PRE_RENDER}
             * 6. [RENDER]{@linkcode Phaser.Scenes.Events#event:RENDER}
             * 
             * Listen to this event from a Scene using `this.events.on('prerender', listener)`.
             * 
             * A Scene will only render if it is visible.
             * 
             * This event is dispatched after the Scene Display List is sorted and before the Scene is rendered.
             */
            const PRE_RENDER: string;

            /**
             * The Scene Systems Pre Update Event.
             * 
             * This event is dispatched by a Scene during the main game loop step.
             * 
             * The event flow for a single step of a Scene is as follows:
             * 
             * 1. [PRE_UPDATE]{@linkcode Phaser.Scenes.Events#event:PRE_UPDATE}
             * 2. [UPDATE]{@linkcode Phaser.Scenes.Events#event:UPDATE}
             * 3. The `Scene.update` method is called, if it exists
             * 4. [POST_UPDATE]{@linkcode Phaser.Scenes.Events#event:POST_UPDATE}
             * 5. [PRE_RENDER]{@linkcode Phaser.Scenes.Events#event:PRE_RENDER}
             * 6. [RENDER]{@linkcode Phaser.Scenes.Events#event:RENDER}
             * 
             * Listen to it from a Scene using `this.events.on('preupdate', listener)`.
             * 
             * A Scene will only run its step if it is active.
             */
            const PRE_UPDATE: string;

            /**
             * The Scene Systems Ready Event.
             * 
             * This event is dispatched by a Scene during the Scene Systems start process.
             * By this point in the process the Scene is now fully active and rendering.
             * This event is meant for your game code to use, as all plugins have responded to the earlier 'start' event.
             * 
             * Listen to it from a Scene using `this.events.on('ready', listener)`.
             */
            const READY: string;

            /**
             * The Game Object Removed from Scene Event.
             * 
             * This event is dispatched when a Game Object is removed from a Scene.
             * 
             * Listen for it from a Scene using `this.events.on('removedfromscene', listener)`.
             */
            const REMOVED_FROM_SCENE: string;

            /**
             * The Scene Systems Render Event.
             * 
             * This event is dispatched by a Scene during the main game loop step.
             * 
             * The event flow for a single step of a Scene is as follows:
             * 
             * 1. [PRE_UPDATE]{@linkcode Phaser.Scenes.Events#event:PRE_UPDATE}
             * 2. [UPDATE]{@linkcode Phaser.Scenes.Events#event:UPDATE}
             * 3. The `Scene.update` method is called, if it exists
             * 4. [POST_UPDATE]{@linkcode Phaser.Scenes.Events#event:POST_UPDATE}
             * 5. [PRE_RENDER]{@linkcode Phaser.Scenes.Events#event:PRE_RENDER}
             * 6. [RENDER]{@linkcode Phaser.Scenes.Events#event:RENDER}
             * 
             * Listen to it from a Scene using `this.events.on('render', listener)`.
             * 
             * A Scene will only render if it is visible.
             * 
             * By the time this event is dispatched, the Scene will have already been rendered.
             */
            const RENDER: string;

            /**
             * The Scene Systems Resume Event.
             * 
             * This event is dispatched by a Scene when it is resumed from a paused state, either directly via the `resume` method,
             * or as an action from another Scene.
             * 
             * Listen to it from a Scene using `this.events.on('resume', listener)`.
             */
            const RESUME: string;

            /**
             * The Scene Systems Shutdown Event.
             * 
             * This event is dispatched by a Scene during the Scene Systems shutdown process.
             * 
             * Listen to it from a Scene using `this.events.on('shutdown', listener)`.
             * 
             * You should free-up any resources that may be in use by your Scene in this event handler, on the understanding
             * that the Scene may, at any time, become active again. A shutdown Scene is not 'destroyed', it's simply not
             * currently active. Use the [DESTROY]{@linkcode Phaser.Scenes.Events#event:DESTROY} event to completely clear resources.
             */
            const SHUTDOWN: string;

            /**
             * The Scene Systems Sleep Event.
             * 
             * This event is dispatched by a Scene when it is sent to sleep, either directly via the `sleep` method,
             * or as an action from another Scene.
             * 
             * Listen to it from a Scene using `this.events.on('sleep', listener)`.
             */
            const SLEEP: string;

            /**
             * The Scene Systems Start Event.
             * 
             * This event is dispatched by a Scene during the Scene Systems start process. Primarily used by Scene Plugins.
             * 
             * Listen to it from a Scene using `this.events.on('start', listener)`.
             */
            const START: string;

            /**
             * The Scene Transition Complete Event.
             * 
             * This event is dispatched by the Target Scene of a transition.
             * 
             * It happens when the transition process has completed. This occurs when the duration timer equals or exceeds the duration
             * of the transition.
             * 
             * Listen to it from a Scene using `this.events.on('transitioncomplete', listener)`.
             * 
             * The Scene Transition event flow is as follows:
             * 
             * 1. [TRANSITION_OUT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_OUT} - the Scene that started the transition will emit this event.
             * 2. [TRANSITION_INIT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_INIT} - the Target Scene will emit this event if it has an `init` method.
             * 3. [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} - the Target Scene will emit this event after its `create` method is called, OR ...
             * 4. [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} - the Target Scene will emit this event if it was asleep and has been woken-up to be transitioned to.
             * 5. [TRANSITION_COMPLETE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_COMPLETE} - the Target Scene will emit this event when the transition finishes.
             */
            const TRANSITION_COMPLETE: string;

            /**
             * The Scene Transition Init Event.
             * 
             * This event is dispatched by the Target Scene of a transition.
             * 
             * It happens immediately after the `Scene.init` method is called. If the Scene does not have an `init` method,
             * this event is not dispatched.
             * 
             * Listen to it from a Scene using `this.events.on('transitioninit', listener)`.
             * 
             * The Scene Transition event flow is as follows:
             * 
             * 1. [TRANSITION_OUT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_OUT} - the Scene that started the transition will emit this event.
             * 2. [TRANSITION_INIT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_INIT} - the Target Scene will emit this event if it has an `init` method.
             * 3. [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} - the Target Scene will emit this event after its `create` method is called, OR ...
             * 4. [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} - the Target Scene will emit this event if it was asleep and has been woken-up to be transitioned to.
             * 5. [TRANSITION_COMPLETE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_COMPLETE} - the Target Scene will emit this event when the transition finishes.
             */
            const TRANSITION_INIT: string;

            /**
             * The Scene Transition Out Event.
             * 
             * This event is dispatched by a Scene when it initiates a transition to another Scene.
             * 
             * Listen to it from a Scene using `this.events.on('transitionout', listener)`.
             * 
             * The Scene Transition event flow is as follows:
             * 
             * 1. [TRANSITION_OUT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_OUT} - the Scene that started the transition will emit this event.
             * 2. [TRANSITION_INIT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_INIT} - the Target Scene will emit this event if it has an `init` method.
             * 3. [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} - the Target Scene will emit this event after its `create` method is called, OR ...
             * 4. [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} - the Target Scene will emit this event if it was asleep and has been woken-up to be transitioned to.
             * 5. [TRANSITION_COMPLETE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_COMPLETE} - the Target Scene will emit this event when the transition finishes.
             */
            const TRANSITION_OUT: string;

            /**
             * The Scene Transition Start Event.
             * 
             * This event is dispatched by the Target Scene of a transition, only if that Scene was not asleep.
             * 
             * It happens immediately after the `Scene.create` method is called. If the Scene does not have a `create` method,
             * this event is dispatched anyway.
             * 
             * If the Target Scene was sleeping then the [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} event is
             * dispatched instead of this event.
             * 
             * Listen to it from a Scene using `this.events.on('transitionstart', listener)`.
             * 
             * The Scene Transition event flow is as follows:
             * 
             * 1. [TRANSITION_OUT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_OUT} - the Scene that started the transition will emit this event.
             * 2. [TRANSITION_INIT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_INIT} - the Target Scene will emit this event if it has an `init` method.
             * 3. [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} - the Target Scene will emit this event after its `create` method is called, OR ...
             * 4. [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} - the Target Scene will emit this event if it was asleep and has been woken-up to be transitioned to.
             * 5. [TRANSITION_COMPLETE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_COMPLETE} - the Target Scene will emit this event when the transition finishes.
             */
            const TRANSITION_START: string;

            /**
             * The Scene Transition Wake Event.
             * 
             * This event is dispatched by the Target Scene of a transition, only if that Scene was asleep before
             * the transition began. If the Scene was not asleep the [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} event is dispatched instead.
             * 
             * Listen to it from a Scene using `this.events.on('transitionwake', listener)`.
             * 
             * The Scene Transition event flow is as follows:
             * 
             * 1. [TRANSITION_OUT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_OUT} - the Scene that started the transition will emit this event.
             * 2. [TRANSITION_INIT]{@linkcode Phaser.Scenes.Events#event:TRANSITION_INIT} - the Target Scene will emit this event if it has an `init` method.
             * 3. [TRANSITION_START]{@linkcode Phaser.Scenes.Events#event:TRANSITION_START} - the Target Scene will emit this event after its `create` method is called, OR ...
             * 4. [TRANSITION_WAKE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_WAKE} - the Target Scene will emit this event if it was asleep and has been woken-up to be transitioned to.
             * 5. [TRANSITION_COMPLETE]{@linkcode Phaser.Scenes.Events#event:TRANSITION_COMPLETE} - the Target Scene will emit this event when the transition finishes.
             */
            const TRANSITION_WAKE: string;

            /**
             * The Scene Systems Update Event.
             * 
             * This event is dispatched by a Scene during the main game loop step.
             * 
             * The event flow for a single step of a Scene is as follows:
             * 
             * 1. [PRE_UPDATE]{@linkcode Phaser.Scenes.Events#event:PRE_UPDATE}
             * 2. [UPDATE]{@linkcode Phaser.Scenes.Events#event:UPDATE}
             * 3. The `Scene.update` method is called, if it exists and the Scene is in a Running state, otherwise this is skipped.
             * 4. [POST_UPDATE]{@linkcode Phaser.Scenes.Events#event:POST_UPDATE}
             * 5. [PRE_RENDER]{@linkcode Phaser.Scenes.Events#event:PRE_RENDER}
             * 6. [RENDER]{@linkcode Phaser.Scenes.Events#event:RENDER}
             * 
             * Listen to it from a Scene using `this.events.on('update', listener)`.
             * 
             * A Scene will only run its step if it is active.
             */
            const UPDATE: string;

            /**
             * The Scene Systems Wake Event.
             * 
             * This event is dispatched by a Scene when it is woken from sleep, either directly via the `wake` method,
             * or as an action from another Scene.
             * 
             * Listen to it from a Scene using `this.events.on('wake', listener)`.
             */
            const WAKE: string;

        }

        /**
         * Builds an array of which physics plugins should be activated for the given Scene.
         * @param sys The scene system to get the physics systems of.
         */
        function GetPhysicsPlugins(sys: Phaser.Scenes.Systems): any[];

        /**
         * Builds an array of which plugins (not including physics plugins) should be activated for the given Scene.
         * @param sys The Scene Systems object to check for plugins.
         */
        function GetScenePlugins(sys: Phaser.Scenes.Systems): any[];

        /**
         * The Scene Manager.
         * 
         * The Scene Manager is a Game level system, responsible for creating, processing and updating all of the
         * Scenes in a Game instance.
         * 
         * You should not usually interact directly with the Scene Manager at all. Instead, you should use
         * the Scene Plugin, which is available from every Scene in your game via the `this.scene` property.
         * 
         * Using methods in this Scene Manager directly will break queued operations and can cause runtime
         * errors. Instead, go via the Scene Plugin. Every feature this Scene Manager provides is also
         * available via the Scene Plugin.
         */
        class SceneManager {
            /**
             * 
             * @param game The Phaser.Game instance this Scene Manager belongs to.
             * @param sceneConfig Scene specific configuration settings.
             */
            constructor(game: Phaser.Game, sceneConfig: object);

            /**
             * The Game that this SceneManager belongs to.
             */
            game: Phaser.Game;

            /**
             * An object that maps the keys to the scene so we can quickly get a scene from a key without iteration.
             */
            keys: Record<string, Phaser.Scene>;

            /**
             * The array in which all of the scenes are kept.
             */
            scenes: Phaser.Scene[];

            /**
             * Is the Scene Manager actively processing the Scenes list?
             */
            readonly isProcessing: boolean;

            /**
             * Has the Scene Manager properly started?
             */
            readonly isBooted: boolean;

            /**
             * Do any of the Cameras in any of the Scenes require a custom viewport?
             * If not we can skip scissor tests.
             */
            customViewports: number;

            /**
             * This system Scene is created during `bootQueue` and is a default
             * empty Scene that lives outside of the Scene list, but can be used
             * by plugins and managers that need access to a live Scene, without
             * being tied to one.
             */
            systemScene: Phaser.Scene;

            /**
             * Process the Scene operations queue.
             */
            processQueue(): void;

            /**
             * Adds a new Scene into the SceneManager.
             * You must give each Scene a unique key by which you'll identify it.
             * 
             * The `sceneConfig` can be:
             * 
             * * A `Phaser.Scene` object, or an object that extends it.
             * * A plain JavaScript object
             * * A JavaScript ES6 Class that extends `Phaser.Scene`
             * * A JavaScript ES5 prototype based Class
             * * A JavaScript function
             * 
             * If a function is given then a new Scene will be created by calling it.
             * @param key A unique key used to reference the Scene, i.e. `MainMenu` or `Level1`.
             * @param sceneConfig The config for the Scene
             * @param autoStart If `true` the Scene will be started immediately after being added. Default false.
             * @param data Optional data object. This will be set as `Scene.settings.data` and passed to `Scene.init`, and `Scene.create`.
             */
            add(key: string, sceneConfig: Phaser.Types.Scenes.SceneType, autoStart?: boolean, data?: object): Phaser.Scene | null;

            /**
             * Removes a Scene from the SceneManager.
             * 
             * The Scene is removed from the local scenes array, it's key is cleared from the keys
             * cache and Scene.Systems.destroy is then called on it.
             * 
             * If the SceneManager is processing the Scenes when this method is called it will
             * queue the operation for the next update sequence.
             * @param key A unique key used to reference the Scene, i.e. `MainMenu` or `Level1`.
             */
            remove(key: string): this;

            /**
             * Updates the Scenes.
             * @param time Time elapsed.
             * @param delta Delta time from the last update.
             */
            update(time: number, delta: number): void;

            /**
             * Renders the Scenes.
             * @param renderer The renderer to use.
             */
            render(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer): void;

            /**
             * Returns an array of all the current Scenes being managed by this Scene Manager.
             * 
             * You can filter the output by the active state of the Scene and choose to have
             * the array returned in normal or reversed order.
             * @param isActive Only include Scene's that are currently active? Default true.
             * @param inReverse Return the array of Scenes in reverse? Default false.
             */
            getScenes<T extends Phaser.Scene[]>(isActive?: boolean, inReverse?: boolean): T;

            /**
             * Retrieves a Scene based on the given key.
             * 
             * If an actual Scene is passed to this method, it can be used to check if
             * its currently within the Scene Manager, or not.
             * @param key The key of the Scene to retrieve.
             */
            getScene<T extends Phaser.Scene>(key: (T|string)): T;

            /**
             * Determines whether a Scene is running.
             * @param key The Scene to check.
             */
            isActive<T extends Phaser.Scene>(key: (T|string)): boolean;

            /**
             * Determines whether a Scene is paused.
             * @param key The Scene to check.
             */
            isPaused<T extends Phaser.Scene>(key: (T|string)): boolean;

            /**
             * Determines whether a Scene is visible.
             * @param key The Scene to check.
             */
            isVisible<T extends Phaser.Scene>(key: (T|string)): boolean;

            /**
             * Determines whether a Scene is sleeping.
             * @param key The Scene to check.
             */
            isSleeping<T extends Phaser.Scene>(key: (T|string)): boolean;

            /**
             * Pauses the given Scene.
             * @param key The Scene to pause.
             * @param data An optional data object that will be passed to the Scene and emitted by its pause event.
             */
            pause<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Resumes the given Scene.
             * @param key The Scene to resume.
             * @param data An optional data object that will be passed to the Scene and emitted by its resume event.
             */
            resume<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Puts the given Scene to sleep.
             * @param key The Scene to put to sleep.
             * @param data An optional data object that will be passed to the Scene and emitted by its sleep event.
             */
            sleep<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Awakens the given Scene.
             * @param key The Scene to wake up.
             * @param data An optional data object that will be passed to the Scene and emitted by its wake event.
             */
            wake<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Runs the given Scene.
             * 
             * If the given Scene is paused, it will resume it. If sleeping, it will wake it.
             * If not running at all, it will be started.
             * 
             * Use this if you wish to open a modal Scene by calling `pause` on the current
             * Scene, then `run` on the modal Scene.
             * @param key The Scene to run.
             * @param data A data object that will be passed to the Scene on start, wake, or resume.
             */
            run<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Starts the given Scene, if it is not starting, loading, or creating.
             * 
             * If the Scene is running, paused, or sleeping, it will be shutdown and then started.
             * @param key The Scene to start.
             * @param data Optional data object to pass to `Scene.Settings` and `Scene.init`, and `Scene.create`.
             */
            start<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Stops the given Scene.
             * @param key The Scene to stop.
             * @param data Optional data object to pass to Scene.shutdown.
             */
            stop<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Sleeps one one Scene and starts the other.
             * @param from The Scene to sleep.
             * @param to The Scene to start.
             */
            switch<T extends Phaser.Scene>(from: (T|string), to: (T|string)): this;

            /**
             * Retrieves a Scene by numeric index.
             * @param index The index of the Scene to retrieve.
             */
            getAt<T extends Phaser.Scene>(index: number): T;

            /**
             * Retrieves the numeric index of a Scene.
             * @param key The key of the Scene.
             */
            getIndex<T extends Phaser.Scene>(key: (T|string)): number;

            /**
             * Brings a Scene to the top of the Scenes list.
             * 
             * This means it will render above all other Scenes.
             * @param key The Scene to move.
             */
            bringToTop<T extends Phaser.Scene>(key: (T|string)): this;

            /**
             * Sends a Scene to the back of the Scenes list.
             * 
             * This means it will render below all other Scenes.
             * @param key The Scene to move.
             */
            sendToBack<T extends Phaser.Scene>(key: (T|string)): this;

            /**
             * Moves a Scene down one position in the Scenes list.
             * @param key The Scene to move.
             */
            moveDown<T extends Phaser.Scene>(key: (T|string)): this;

            /**
             * Moves a Scene up one position in the Scenes list.
             * @param key The Scene to move.
             */
            moveUp<T extends Phaser.Scene>(key: (T|string)): this;

            /**
             * Moves a Scene so it is immediately above another Scene in the Scenes list.
             * 
             * This means it will render over the top of the other Scene.
             * @param keyA The Scene that Scene B will be moved above.
             * @param keyB The Scene to be moved.
             */
            moveAbove<T extends Phaser.Scene>(keyA: (T|string), keyB: (T|string)): this;

            /**
             * Moves a Scene so it is immediately below another Scene in the Scenes list.
             * 
             * This means it will render behind the other Scene.
             * @param keyA The Scene that Scene B will be moved below.
             * @param keyB The Scene to be moved.
             */
            moveBelow<T extends Phaser.Scene>(keyA: (T|string), keyB: (T|string)): this;

            /**
             * Swaps the positions of two Scenes in the Scenes list.
             * @param keyA The first Scene to swap.
             * @param keyB The second Scene to swap.
             */
            swapPosition<T extends Phaser.Scene>(keyA: (T|string), keyB: (T|string)): this;

            /**
             * Dumps debug information about each Scene to the developer console.
             */
            dump(): void;

            /**
             * Destroy this Scene Manager and all of its systems.
             * 
             * This process cannot be reversed.
             * 
             * This method is called automatically when a Phaser Game instance is destroyed.
             */
            destroy(): void;

        }

        /**
         * The Scene Plugin is the main interface to the Scene Manager and allows you to control
         * any Scene running in your game. You should always use this plugin. By default, it is
         * mapped to the Scene property `this.scene`. Meaning, from within a Scene, you can call
         * methods such as `this.scene.start()`.
         * 
         * Note that nearly all methods in this class are run on a queue-basis and not
         * immediately. For example, calling `this.scene.launch('SceneB')` will try to
         * launch SceneB when the Scene Manager next updates, which is at the start of the game
         * step. All operations are queued and run in the order in which they are invoked here.
         */
        class ScenePlugin {
            /**
             * 
             * @param scene The Scene that this ScenePlugin belongs to.
             */
            constructor(scene: Phaser.Scene);

            /**
             * The Scene that this ScenePlugin belongs to.
             */
            scene: Phaser.Scene;

            /**
             * The Scene Systems instance of the Scene that this ScenePlugin belongs to.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The settings of the Scene this ScenePlugin belongs to.
             */
            settings: Phaser.Types.Scenes.SettingsObject;

            /**
             * The key of the Scene this ScenePlugin belongs to.
             */
            key: string;

            /**
             * The Game's SceneManager.
             */
            manager: Phaser.Scenes.SceneManager;

            /**
             * If this Scene is currently transitioning to another, this holds
             * the current percentage of the transition progress, between 0 and 1.
             */
            transitionProgress: number;

            /**
             * Shutdown this Scene and run the given one.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to start.
             * @param data The Scene data. If no value is given it will not overwrite any previous data that may exist.
             */
            start<T extends Phaser.Scene>(key?: (T|string), data?: object): this;

            /**
             * Restarts this Scene.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param data The Scene data. If no value is given it will not overwrite any previous data that may exist.
             */
            restart(data?: object): this;

            /**
             * This will start a transition from the current Scene to the target Scene given.
             * 
             * The target Scene cannot be the same as the current Scene.
             * 
             * The transition will last for the duration specified in milliseconds.
             * 
             * You can have the target Scene moved above or below this one in the display list.
             * 
             * You can specify an update callback. This callback will be invoked _every frame_ for the duration
             * of the transition.
             * 
             * This Scene can either be sent to sleep at the end of the transition, or stopped. The default is to stop.
             * 
             * There are also 5 transition related events: This scene will emit the event `transitionout` when
             * the transition begins, which is typically the frame after calling this method.
             * 
             * The target Scene will emit the event `transitioninit` when that Scene's `init` method is called.
             * It will then emit the event `transitionstart` when its `create` method is called.
             * If the Scene was sleeping and has been woken up, it will emit the event `transitionwake` instead of these two,
             * as the Scenes `init` and `create` methods are not invoked when a Scene wakes up.
             * 
             * When the duration of the transition has elapsed it will emit the event `transitioncomplete`.
             * These events are cleared of all listeners when the Scene shuts down, but not if it is sent to sleep.
             * 
             * It's important to understand that the duration of the transition begins the moment you call this method.
             * If the Scene you are transitioning to includes delayed processes, such as waiting for files to load, the
             * time still counts down even while that is happening. If the game itself pauses, or something else causes
             * this Scenes update loop to stop, then the transition will also pause for that duration. There are
             * checks in place to prevent you accidentally stopping a transitioning Scene but if you've got code to
             * override this understand that until the target Scene completes it might never be unlocked for input events.
             * @param config The transition configuration object.
             */
            transition(config: Phaser.Types.Scenes.SceneTransitionConfig): boolean;

            /**
             * Add the Scene into the Scene Manager and start it if 'autoStart' is true or the Scene config 'active' property is set.
             * @param key A unique key used to reference the Scene, i.e. `MainMenu` or `Level1`.
             * @param sceneConfig The config for the Scene
             * @param autoStart If `true` the Scene will be started immediately after being added. Default false.
             * @param data Optional data object. This will be set as `Scene.settings.data` and passed to `Scene.init`, and `Scene.create`.
             */
            add(key: string, sceneConfig: Phaser.Types.Scenes.SceneType, autoStart?: boolean, data?: object): Phaser.Scene | null;

            /**
             * Launch the given Scene and run it in parallel with this one.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to launch.
             * @param data The Scene data.
             */
            launch<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Runs the given Scene, but does not change the state of this Scene.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * 
             * If the given Scene is paused, it will resume it. If sleeping, it will wake it.
             * If not running at all, it will be started.
             * 
             * Use this if you wish to open a modal Scene by calling `pause` on the current
             * Scene, then `run` on the modal Scene.
             * @param key The Scene to run.
             * @param data A data object that will be passed to the Scene and emitted in its ready, wake, or resume events.
             */
            run<T extends Phaser.Scene>(key: (T|string), data?: object): this;

            /**
             * Pause the Scene - this stops the update step from happening but it still renders.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to pause.
             * @param data An optional data object that will be passed to the Scene and emitted in its pause event.
             */
            pause<T extends Phaser.Scene>(key?: (T|string), data?: object): this;

            /**
             * Resume the Scene - starts the update loop again.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to resume.
             * @param data An optional data object that will be passed to the Scene and emitted in its resume event.
             */
            resume<T extends Phaser.Scene>(key?: (T|string), data?: object): this;

            /**
             * Makes the Scene sleep (no update, no render) but doesn't shutdown.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to put to sleep.
             * @param data An optional data object that will be passed to the Scene and emitted in its sleep event.
             */
            sleep<T extends Phaser.Scene>(key?: (T|string), data?: object): this;

            /**
             * Makes the Scene wake-up (starts update and render)
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to wake up.
             * @param data An optional data object that will be passed to the Scene and emitted in its wake event.
             */
            wake<T extends Phaser.Scene>(key?: (T|string), data?: object): this;

            /**
             * Makes this Scene sleep then starts the Scene given.
             * 
             * This will happen at the next Scene Manager update, not immediately.
             * @param key The Scene to start.
             */
            switch<T extends Phaser.Scene>(key: (T|string)): this;

            /**
             * Shutdown the Scene, clearing display list, timers, etc.
             * 
             * This happens at the next Scene Manager update, not immediately.
             * @param key The Scene to stop.
             * @param data Optional data object to pass to Scene.Systems.shutdown.
             */
            stop<T extends Phaser.Scene>(key?: (T|string), data?: any): this;

            /**
             * Sets the active state of the given Scene.
             * @param value If `true` the Scene will be resumed. If `false` it will be paused.
             * @param key The Scene to set the active state of.
             * @param data An optional data object that will be passed to the Scene and emitted with its events.
             */
            setActive<T extends Phaser.Scene>(value: boolean, key?: (T|string), data?: object): this;

            /**
             * Sets the visible state of the given Scene.
             * @param value The visible value.
             * @param key The Scene to set the visible state for.
             */
            setVisible<T extends Phaser.Scene>(value: boolean, key?: (T|string)): this;

            /**
             * Checks if the given Scene is sleeping or not?
             * @param key The Scene to check.
             */
            isSleeping<T extends Phaser.Scene>(key?: (T|string)): boolean;

            /**
             * Checks if the given Scene is running or not?
             * @param key The Scene to check.
             */
            isActive<T extends Phaser.Scene>(key?: (T|string)): boolean;

            /**
             * Checks if the given Scene is paused or not?
             * @param key The Scene to check.
             */
            isPaused<T extends Phaser.Scene>(key?: (T|string)): boolean;

            /**
             * Checks if the given Scene is visible or not?
             * @param key The Scene to check.
             */
            isVisible<T extends Phaser.Scene>(key?: (T|string)): boolean;

            /**
             * Swaps the position of two scenes in the Scenes list.
             * 
             * This controls the order in which they are rendered and updated.
             * @param keyA The first Scene to swap.
             * @param keyB The second Scene to swap. If none is given it defaults to this Scene.
             */
            swapPosition<T extends Phaser.Scene>(keyA: (T|string), keyB?: (T|string)): this;

            /**
             * Swaps the position of two scenes in the Scenes list, so that Scene B is directly above Scene A.
             * 
             * This controls the order in which they are rendered and updated.
             * @param keyA The Scene that Scene B will be moved to be above.
             * @param keyB The Scene to be moved. If none is given it defaults to this Scene.
             */
            moveAbove<T extends Phaser.Scene>(keyA: (T|string), keyB?: (T|string)): this;

            /**
             * Swaps the position of two scenes in the Scenes list, so that Scene B is directly below Scene A.
             * 
             * This controls the order in which they are rendered and updated.
             * @param keyA The Scene that Scene B will be moved to be below.
             * @param keyB The Scene to be moved. If none is given it defaults to this Scene.
             */
            moveBelow<T extends Phaser.Scene>(keyA: (T|string), keyB?: (T|string)): this;

            /**
             * Removes a Scene from the SceneManager.
             * 
             * The Scene is removed from the local scenes array, it's key is cleared from the keys
             * cache and Scene.Systems.destroy is then called on it.
             * 
             * If the SceneManager is processing the Scenes when this method is called it will
             * queue the operation for the next update sequence.
             * @param key The Scene to be removed.
             */
            remove<T extends Phaser.Scene>(key?: (T|string)): this;

            /**
             * Moves a Scene up one position in the Scenes list.
             * @param key The Scene to move.
             */
            moveUp<T extends Phaser.Scene>(key?: (T|string)): this;

            /**
             * Moves a Scene down one position in the Scenes list.
             * @param key The Scene to move.
             */
            moveDown<T extends Phaser.Scene>(key?: (T|string)): this;

            /**
             * Brings a Scene to the top of the Scenes list.
             * 
             * This means it will render above all other Scenes.
             * @param key The Scene to move.
             */
            bringToTop<T extends Phaser.Scene>(key?: (T|string)): this;

            /**
             * Sends a Scene to the back of the Scenes list.
             * 
             * This means it will render below all other Scenes.
             * @param key The Scene to move.
             */
            sendToBack<T extends Phaser.Scene>(key?: (T|string)): this;

            /**
             * Retrieve a Scene.
             * @param key The Scene to retrieve.
             */
            get<T extends Phaser.Scene>(key: (T|string)): T;

            /**
             * Return the status of the Scene.
             * @param key The Scene to get the status from.
             */
            getStatus<T extends Phaser.Scene>(key: (T|string)): number;

            /**
             * Retrieves the numeric index of a Scene in the Scenes list.
             * @param key The Scene to get the index of.
             */
            getIndex<T extends Phaser.Scene>(key?: (T|string)): number;

        }

        namespace Settings {
            /**
             * Takes a Scene configuration object and returns a fully formed System Settings object.
             * @param config The Scene configuration object used to create this Scene Settings.
             */
            function create(config: string | Phaser.Types.Scenes.SettingsConfig): Phaser.Types.Scenes.SettingsObject;

        }

        /**
         * The Scene Systems class.
         * 
         * This class is available from within a Scene under the property `sys`.
         * It is responsible for managing all of the plugins a Scene has running, including the display list, and
         * handling the update step and renderer. It also contains references to global systems belonging to Game.
         */
        class Systems {
            /**
             * 
             * @param scene The Scene that owns this Systems instance.
             * @param config Scene specific configuration settings.
             */
            constructor(scene: Phaser.Scene, config: string | Phaser.Types.Scenes.SettingsConfig);

            /**
             * A reference to the Scene that these Systems belong to.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Phaser Game instance.
             */
            game: Phaser.Game;

            /**
             * A reference to either the Canvas or WebGL Renderer that this Game is using.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The Facebook Instant Games Plugin.
             */
            facebook: Phaser.FacebookInstantGamesPlugin;

            /**
             * The Scene Configuration object, as passed in when creating the Scene.
             */
            config: string | Phaser.Types.Scenes.SettingsConfig;

            /**
             * The Scene Settings. This is the parsed output based on the Scene configuration.
             */
            settings: Phaser.Types.Scenes.SettingsObject;

            /**
             * A handy reference to the Scene canvas / context.
             */
            canvas: HTMLCanvasElement;

            /**
             * A reference to the Canvas Rendering Context being used by the renderer.
             */
            context: CanvasRenderingContext2D;

            /**
             * A reference to the global Animations Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.anims` property.
             */
            anims: Phaser.Animations.AnimationManager;

            /**
             * A reference to the global Cache. The Cache stores all files bought in to Phaser via
             * the Loader, with the exception of images. Images are stored in the Texture Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.cache` property.
             */
            cache: Phaser.Cache.CacheManager;

            /**
             * A reference to the global Plugins Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.plugins` property.
             */
            plugins: Phaser.Plugins.PluginManager;

            /**
             * A reference to the global registry. This is a game-wide instance of the Data Manager, allowing
             * you to exchange data between Scenes via a universal and shared point.
             * 
             * In the default set-up you can access this from within a Scene via the `this.registry` property.
             */
            registry: Phaser.Data.DataManager;

            /**
             * A reference to the global Scale Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.scale` property.
             */
            scale: Phaser.Scale.ScaleManager;

            /**
             * A reference to the global Sound Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.sound` property.
             */
            sound: Phaser.Sound.NoAudioSoundManager | Phaser.Sound.HTML5AudioSoundManager | Phaser.Sound.WebAudioSoundManager;

            /**
             * A reference to the global Texture Manager.
             * 
             * In the default set-up you can access this from within a Scene via the `this.textures` property.
             */
            textures: Phaser.Textures.TextureManager;

            /**
             * A reference to the Scene's Game Object Factory.
             * 
             * Use this to quickly and easily create new Game Object's.
             * 
             * In the default set-up you can access this from within a Scene via the `this.add` property.
             */
            add: Phaser.GameObjects.GameObjectFactory;

            /**
             * A reference to the Scene's Camera Manager.
             * 
             * Use this to manipulate and create Cameras for this specific Scene.
             * 
             * In the default set-up you can access this from within a Scene via the `this.cameras` property.
             */
            cameras: Phaser.Cameras.Scene2D.CameraManager;

            /**
             * A reference to the Scene's Display List.
             * 
             * Use this to organize the children contained in the display list.
             * 
             * In the default set-up you can access this from within a Scene via the `this.children` property.
             */
            displayList: Phaser.GameObjects.DisplayList;

            /**
             * A reference to the Scene's Event Manager.
             * 
             * Use this to listen for Scene specific events, such as `pause` and `shutdown`.
             * 
             * In the default set-up you can access this from within a Scene via the `this.events` property.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * A reference to the Scene's Game Object Creator.
             * 
             * Use this to quickly and easily create new Game Object's. The difference between this and the
             * Game Object Factory, is that the Creator just creates and returns Game Object instances, it
             * doesn't then add them to the Display List or Update List.
             * 
             * In the default set-up you can access this from within a Scene via the `this.make` property.
             */
            make: Phaser.GameObjects.GameObjectCreator;

            /**
             * A reference to the Scene Manager Plugin.
             * 
             * Use this to manipulate both this and other Scene's in your game, for example to launch a parallel Scene,
             * or pause or resume a Scene, or switch from this Scene to another.
             * 
             * In the default set-up you can access this from within a Scene via the `this.scene` property.
             */
            scenePlugin: Phaser.Scenes.ScenePlugin;

            /**
             * A reference to the Scene's Update List.
             * 
             * Use this to organize the children contained in the update list.
             * 
             * The Update List is responsible for managing children that need their `preUpdate` methods called,
             * in order to process so internal components, such as Sprites with Animations.
             * 
             * In the default set-up there is no reference to this from within the Scene itself.
             */
            updateList: Phaser.GameObjects.UpdateList;

            /**
             * This method is called only once by the Scene Manager when the Scene is instantiated.
             * It is responsible for setting up all of the Scene plugins and references.
             * It should never be called directly.
             * @param game A reference to the Phaser Game instance.
             */
            protected init(game: Phaser.Game): void;

            /**
             * A single game step. Called automatically by the Scene Manager as a result of a Request Animation
             * Frame or Set Timeout call to the main Game instance.
             * @param time The time value from the most recent Game step. Typically a high-resolution timer value, or Date.now().
             * @param delta The delta value since the last frame. This is smoothed to avoid delta spikes by the TimeStep class.
             */
            step(time: number, delta: number): void;

            /**
             * Called automatically by the Scene Manager.
             * Instructs the Scene to render itself via its Camera Manager to the renderer given.
             * @param renderer The renderer that invoked the render call.
             */
            render(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer): void;

            /**
             * Force a sort of the display list on the next render.
             */
            queueDepthSort(): void;

            /**
             * Immediately sorts the display list if the flag is set.
             */
            depthSort(): void;

            /**
             * Pause this Scene.
             * 
             * A paused Scene still renders, it just doesn't run any of its update handlers or systems.
             * @param data A data object that will be passed in the 'pause' event.
             */
            pause(data?: object): Phaser.Scenes.Systems;

            /**
             * Resume this Scene from a paused state.
             * @param data A data object that will be passed in the 'resume' event.
             */
            resume(data?: object): Phaser.Scenes.Systems;

            /**
             * Send this Scene to sleep.
             * 
             * A sleeping Scene doesn't run its update step or render anything, but it also isn't shut down
             * or has any of its systems or children removed, meaning it can be re-activated at any point and
             * will carry on from where it left off. It also keeps everything in memory and events and callbacks
             * from other Scenes may still invoke changes within it, so be careful what is left active.
             * @param data A data object that will be passed in the 'sleep' event.
             */
            sleep(data?: object): Phaser.Scenes.Systems;

            /**
             * Wake-up this Scene if it was previously asleep.
             * @param data A data object that will be passed in the 'wake' event.
             */
            wake(data?: object): Phaser.Scenes.Systems;

            /**
             * Returns any data that was sent to this Scene by another Scene.
             * 
             * The data is also passed to `Scene.init` and in various Scene events, but
             * you can access it at any point via this method.
             */
            getData(): any;

            /**
             * Returns the current status of this Scene.
             */
            getStatus(): number;

            /**
             * Can this Scene receive Input events?
             */
            canInput(): boolean;

            /**
             * Is this Scene sleeping?
             */
            isSleeping(): boolean;

            /**
             * Is this Scene running?
             */
            isActive(): boolean;

            /**
             * Is this Scene paused?
             */
            isPaused(): boolean;

            /**
             * Is this Scene currently transitioning out to, or in from another Scene?
             */
            isTransitioning(): boolean;

            /**
             * Is this Scene currently transitioning out from itself to another Scene?
             */
            isTransitionOut(): boolean;

            /**
             * Is this Scene currently transitioning in from another Scene?
             */
            isTransitionIn(): boolean;

            /**
             * Is this Scene visible and rendering?
             */
            isVisible(): boolean;

            /**
             * Sets the visible state of this Scene.
             * An invisible Scene will not render, but will still process updates.
             * @param value `true` to render this Scene, otherwise `false`.
             */
            setVisible(value: boolean): Phaser.Scenes.Systems;

            /**
             * Set the active state of this Scene.
             * 
             * An active Scene will run its core update loop.
             * @param value If `true` the Scene will be resumed, if previously paused. If `false` it will be paused.
             * @param data A data object that will be passed in the 'resume' or 'pause' events.
             */
            setActive(value: boolean, data?: object): Phaser.Scenes.Systems;

            /**
             * Start this Scene running and rendering.
             * Called automatically by the SceneManager.
             * @param data Optional data object that may have been passed to this Scene from another.
             */
            start(data: object): void;

            /**
             * Shutdown this Scene and send a shutdown event to all of its systems.
             * A Scene that has been shutdown will not run its update loop or render, but it does
             * not destroy any of its plugins or references. It is put into hibernation for later use.
             * If you don't ever plan to use this Scene again, then it should be destroyed instead
             * to free-up resources.
             * @param data A data object that will be passed in the 'shutdown' event.
             */
            shutdown(data?: object): void;

        }

    }

    /**
     * A base Phaser.Scene class which can be extended for your own use.
     * 
     * You can also define the optional methods {@link Phaser.Types.Scenes.SceneInitCallback init()}, {@link Phaser.Types.Scenes.ScenePreloadCallback preload()}, and {@link Phaser.Types.Scenes.SceneCreateCallback create()}.
     */
    class Scene {
        /**
         * 
         * @param config The scene key or scene specific configuration settings.
         */
        constructor(config?: string | Phaser.Types.Scenes.SettingsConfig);

        /**
         * The Scene Systems. You must never overwrite this property, or all hell will break lose.
         */
        sys: Phaser.Scenes.Systems;

        /**
         * A reference to the Phaser.Game instance.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        game: Phaser.Game;

        /**
         * A reference to the global Animation Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        anims: Phaser.Animations.AnimationManager;

        /**
         * A reference to the global Cache.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        cache: Phaser.Cache.CacheManager;

        /**
         * A reference to the global Data Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        registry: Phaser.Data.DataManager;

        /**
         * A reference to the Sound Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        sound: Phaser.Sound.NoAudioSoundManager | Phaser.Sound.HTML5AudioSoundManager | Phaser.Sound.WebAudioSoundManager;

        /**
         * A reference to the Texture Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        textures: Phaser.Textures.TextureManager;

        /**
         * A Scene specific Event Emitter.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        events: Phaser.Events.EventEmitter;

        /**
         * The Scene Camera Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        cameras: Phaser.Cameras.Scene2D.CameraManager;

        /**
         * The Scene Game Object Factory.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        add: Phaser.GameObjects.GameObjectFactory;

        /**
         * The Scene Game Object Creator.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        make: Phaser.GameObjects.GameObjectCreator;

        /**
         * A reference to the Scene Manager Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        scene: Phaser.Scenes.ScenePlugin;

        /**
         * The Game Object Display List belonging to this Scene.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        children: Phaser.GameObjects.DisplayList;

        /**
         * The Scene Lights Manager Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        lights: Phaser.GameObjects.LightsManager;

        /**
         * A Scene specific Data Manager Plugin.
         * 
         * See the `registry` property for the global Data Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        data: Phaser.Data.DataManager;

        /**
         * The Scene Input Manager Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        input: Phaser.Input.InputPlugin;

        /**
         * The Scene Loader Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        load: Phaser.Loader.LoaderPlugin;

        /**
         * The Scene Time and Clock Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        time: Phaser.Time.Clock;

        /**
         * The Scene Tween Manager Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map and the plugin is installed.
         */
        tweens: Phaser.Tweens.TweenManager;

        /**
         * The Scene Arcade Physics Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.
         */
        physics: Phaser.Physics.Arcade.ArcadePhysics;

        /**
         * The Scene Matter Physics Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.
         */
        matter: Phaser.Physics.Matter.MatterPhysics;

        /**
         * The Facebook Instant Games Plugin.
         * 
         * This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.
         */
        facebook: Phaser.FacebookInstantGamesPlugin;

        /**
         * A reference to the global Scale Manager.
         * 
         * This property will only be available if defined in the Scene Injection Map.
         */
        scale: Phaser.Scale.ScaleManager;

        /**
         * A reference to the global Plugin Manager.
         * 
         * The Plugin Manager is a global system that allows plugins to register themselves with it, and can then install
         * those plugins into Scenes as required.
         */
        plugins: Phaser.Plugins.PluginManager;

        /**
         * A reference to the renderer instance Phaser is using, either Canvas Renderer or WebGL Renderer.
         */
        renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

        /**
         * This method should be overridden by your own Scenes.
         * 
         * This method is called once per game step while the scene is running.
         * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
         * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
         */
        update(time: number, delta: number): void;

    }

    namespace Sound {
        /**
         * Class containing all the shared state and behavior of a sound object, independent of the implementation.
         */
        class BaseSound extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param manager Reference to the current sound manager instance.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            constructor(manager: Phaser.Sound.BaseSoundManager, key: string, config?: Phaser.Types.Sound.SoundConfig);

            /**
             * Local reference to the sound manager.
             */
            manager: Phaser.Sound.BaseSoundManager;

            /**
             * Asset key for the sound.
             */
            readonly key: string;

            /**
             * Flag indicating if sound is currently playing.
             */
            readonly isPlaying: boolean;

            /**
             * Flag indicating if sound is currently paused.
             */
            readonly isPaused: boolean;

            /**
             * A property that holds the value of sound's actual playback rate,
             * after its rate and detune values has been combined with global
             * rate and detune values.
             */
            readonly totalRate: number;

            /**
             * A value representing the duration, in seconds.
             * It could be total sound duration or a marker duration.
             */
            readonly duration: number;

            /**
             * The total duration of the sound in seconds.
             */
            readonly totalDuration: number;

            /**
             * Object containing markers definitions.
             */
            readonly markers: {[key: string]:  Phaser.Types.Sound.SoundMarker};

            /**
             * Currently playing marker.
             * 'null' if whole sound is playing.
             */
            readonly currentMarker: Phaser.Types.Sound.SoundMarker;

            /**
             * Flag indicating if destroy method was called on this sound.
             */
            pendingRemove: boolean;

            /**
             * Adds a marker into the current sound. A marker is represented by name, start time, duration, and optionally config object.
             * This allows you to bundle multiple sounds together into a single audio file and use markers to jump between them for playback.
             * @param marker Marker object.
             */
            addMarker(marker: Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * Updates previously added marker.
             * @param marker Marker object with updated values.
             */
            updateMarker(marker: Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * Removes a marker from the sound.
             * @param markerName The name of the marker to remove.
             */
            removeMarker(markerName: string): Phaser.Types.Sound.SoundMarker | null;

            /**
             * Play this sound, or a marked section of it.
             * 
             * It always plays the sound from the start. If you want to start playback from a specific time
             * you can set 'seek' setting of the config object, provided to this call, to that value.
             * @param markerName If you want to play a marker then provide the marker name here. Alternatively, this parameter can be a SoundConfig object. Default ''.
             * @param config Optional sound config object to be applied to this marker or entire sound if no marker name is provided. It gets memorized for future plays of current section of the sound.
             */
            play(markerName?: string | Phaser.Types.Sound.SoundConfig, config?: Phaser.Types.Sound.SoundConfig): boolean;

            /**
             * Pauses the sound. This only works if the sound is currently playing.
             * 
             * You can inspect the `isPlaying` and `isPaused` properties to check the state.
             */
            pause(): boolean;

            /**
             * Resumes the sound. This only works if the sound is paused and not already playing.
             * 
             * You can inspect the `isPlaying` and `isPaused` properties to check the state.
             */
            resume(): boolean;

            /**
             * Stop playing this sound.
             */
            stop(): boolean;

            /**
             * Method used internally for applying config values to some of the sound properties.
             */
            applyConfig(): void;

            /**
             * Method used internally for resetting values of some of the config properties.
             */
            resetConfig(): void;

            /**
             * Update method called automatically by sound manager on every game step.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             * @param delta The delta time elapsed since the last frame.
             */
            update(time: number, delta: number): void;

            /**
             * Method used internally to calculate total playback rate of the sound.
             */
            calculateRate(): void;

            /**
             * Destroys this sound and all associated events and marks it for removal from the sound manager.
             */
            destroy(): void;

        }

        /**
         * Base class for other Sound Manager classes.
         */
        class BaseSoundManager extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param game Reference to the current game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * Local reference to game.
             */
            readonly game: Phaser.Game;

            /**
             * Local reference to the JSON Cache, as used by Audio Sprites.
             */
            readonly jsonCache: Phaser.Cache.BaseCache;

            /**
             * Global mute setting.
             */
            mute: boolean;

            /**
             * Global volume setting.
             */
            volume: number;

            /**
             * Flag indicating if sounds should be paused when game looses focus,
             * for instance when user switches to another tab/program/app.
             */
            pauseOnBlur: boolean;

            /**
             * Mobile devices require sounds to be triggered from an explicit user action,
             * such as a tap, before any sound can be loaded/played on a web page.
             * Set to true if the audio system is currently locked awaiting user interaction.
             */
            readonly locked: boolean;

            /**
             * Flag used to track if the game has lost focus.
             */
            gameLostFocus: boolean;

            /**
             * The Spatial Audio listener position.
             * 
             * Only available with WebAudio.
             * 
             * You can modify the x/y properties of this Vec2 directly to
             * adjust the listener position within the game world.
             */
            listenerPosition: Phaser.Math.Vector2;

            /**
             * Adds a new sound into the sound manager.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            add(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.BaseSound;

            /**
             * Adds a new audio sprite sound into the sound manager.
             * Audio Sprites are a combination of audio files and a JSON configuration.
             * The JSON follows the format of that created by https://github.com/tonistiigi/audiosprite
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            addAudioSprite(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.NoAudioSound | Phaser.Sound.HTML5AudioSound | Phaser.Sound.WebAudioSound;

            /**
             * Gets the first sound in this Sound Manager that matches the given key.
             * If none can be found it returns `null`.
             * @param key Sound asset key.
             */
            get<T extends Phaser.Sound.BaseSound>(key: string): T;

            /**
             * Gets all sounds in this Sound Manager.
             * 
             * You can optionally specify a key, in which case only Sound instances that match the given key
             * will be returned.
             * @param key Optional asset key. If given, only Sound instances with this key will be returned.
             */
            getAll<T extends Phaser.Sound.BaseSound>(key?: string): T[];

            /**
             * Returns all sounds from this Sound Manager that are currently
             * playing. That is, Sound instances that have their `isPlaying`
             * property set to `true`.
             */
            getAllPlaying<T extends Phaser.Sound.BaseSound>(): T[];

            /**
             * Adds a new sound to the sound manager and plays it.
             * 
             * The sound will be automatically removed (destroyed) once playback ends.
             * 
             * This lets you play a new sound on the fly without the need to keep a reference to it.
             * @param key Asset key for the sound.
             * @param extra An optional additional object containing settings to be applied to the sound. It could be either config or marker object.
             */
            play(key: string, extra?: Phaser.Types.Sound.SoundConfig | Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * Adds a new audio sprite sound to the sound manager and plays it.
             * The sprite will be automatically removed (destroyed) once playback ends.
             * This lets you play a new sound on the fly without the need to keep a reference to it.
             * @param key Asset key for the sound.
             * @param spriteName The name of the sound sprite to play.
             * @param config An optional config object containing default sound settings.
             */
            playAudioSprite(key: string, spriteName: string, config?: Phaser.Types.Sound.SoundConfig): boolean;

            /**
             * Removes a sound from the sound manager.
             * The removed sound is destroyed before removal.
             * @param sound The sound object to remove.
             */
            remove(sound: Phaser.Sound.BaseSound): boolean;

            /**
             * Removes all sounds from the manager, destroying the sounds.
             */
            removeAll(): void;

            /**
             * Removes all sounds from the sound manager that have an asset key matching the given value.
             * The removed sounds are destroyed before removal.
             * @param key The key to match when removing sound objects.
             */
            removeByKey(key: string): number;

            /**
             * Pauses all the sounds in the game.
             */
            pauseAll(): void;

            /**
             * Resumes all the sounds in the game.
             */
            resumeAll(): void;

            /**
             * Sets the X and Y position of the Spatial Audio listener on this Web Audios context.
             * 
             * If you call this method with no parameters it will default to the center-point of
             * the game canvas. Depending on the type of game you're making, you may need to call
             * this method constantly to reset the listener position as the camera scrolls.
             * 
             * Calling this method does nothing on HTML5Audio.
             * @param x The x position of the Spatial Audio listener.
             * @param y The y position of the Spatial Audio listener.
             */
            setListenerPosition(x?: number, y?: number): void;

            /**
             * Stops all the sounds in the game.
             */
            stopAll(): void;

            /**
             * Stops any sounds matching the given key.
             * @param key Sound asset key.
             */
            stopByKey(key: string): number;

            /**
             * Method used internally for unlocking audio playback on devices that
             * require user interaction before any sound can be played on a web page.
             * 
             * Read more about how this issue is handled here in [this article](https://medium.com/@pgoloskokovic/unlocking-web-audio-the-smarter-way-8858218c0e09).
             */
            protected unlock(): void;

            /**
             * Method used internally for pausing sound manager if
             * Phaser.Sound.BaseSoundManager#pauseOnBlur is set to true.
             */
            protected onBlur(): void;

            /**
             * Method used internally for resuming sound manager if
             * Phaser.Sound.BaseSoundManager#pauseOnBlur is set to true.
             */
            protected onFocus(): void;

            /**
             * Update method called on every game step.
             * Removes destroyed sounds and updates every active sound in the game.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             * @param delta The delta time elapsed since the last frame.
             */
            protected update(time: number, delta: number): void;

            /**
             * Destroys all the sounds in the game and all associated events.
             */
            destroy(): void;

            /**
             * Sets the global playback rate at which all the sounds will be played.
             * 
             * For example, a value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             * @param value Global playback rate at which all the sounds will be played.
             */
            setRate(value: number): this;

            /**
             * Global playback rate at which all the sounds will be played.
             * Value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audio's playback speed.
             */
            rate: number;

            /**
             * Sets the global detuning of all sounds in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             * @param value The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            setDetune(value: number): this;

            /**
             * Global detuning of all sounds in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            detune: number;

        }

        namespace Events {
            /**
             * The Sound Complete Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they complete playback.
             * 
             * Listen to it from a Sound instance using `Sound.on('complete', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('complete', listener);
             * music.play();
             * ```
             */
            const COMPLETE: string;

            /**
             * The Audio Data Decoded All Event.
             * 
             * This event is dispatched by the Web Audio Sound Manager as a result of calling the `decodeAudio` method,
             * once all files passed to the method have been decoded (or errored).
             * 
             * Use `Phaser.Sound.Events#DECODED` to listen for single sounds being decoded, and `DECODED_ALL` to
             * listen for them all completing.
             * 
             * Listen to it from the Sound Manager in a Scene using `this.sound.on('decodedall', listener)`, i.e.:
             * 
             * ```javascript
             * this.sound.once('decodedall', handler);
             * this.sound.decodeAudio([ audioFiles ]);
             * ```
             */
            const DECODED_ALL: string;

            /**
             * The Audio Data Decoded Event.
             * 
             * This event is dispatched by the Web Audio Sound Manager as a result of calling the `decodeAudio` method.
             * 
             * Listen to it from the Sound Manager in a Scene using `this.sound.on('decoded', listener)`, i.e.:
             * 
             * ```javascript
             * this.sound.on('decoded', handler);
             * this.sound.decodeAudio(key, audioData);
             * ```
             */
            const DECODED: string;

            /**
             * The Sound Destroy Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are destroyed, either
             * directly or via a Sound Manager.
             * 
             * Listen to it from a Sound instance using `Sound.on('destroy', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('destroy', listener);
             * music.destroy();
             * ```
             */
            const DESTROY: string;

            /**
             * The Sound Detune Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their detune value changes.
             * 
             * Listen to it from a Sound instance using `Sound.on('detune', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('detune', listener);
             * music.play();
             * music.setDetune(200);
             * ```
             */
            const DETUNE: string;

            /**
             * The Sound Manager Global Detune Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched when the `detune` property of the Sound Manager is changed, which globally
             * adjusts the detuning of all active sounds.
             * 
             * Listen to it from a Scene using: `this.sound.on('rate', listener)`.
             */
            const GLOBAL_DETUNE: string;

            /**
             * The Sound Manager Global Mute Event.
             * 
             * This event is dispatched by the Sound Manager when its `mute` property is changed, either directly
             * or via the `setMute` method. This changes the mute state of all active sounds.
             * 
             * Listen to it from a Scene using: `this.sound.on('mute', listener)`.
             */
            const GLOBAL_MUTE: string;

            /**
             * The Sound Manager Global Rate Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched when the `rate` property of the Sound Manager is changed, which globally
             * adjusts the playback rate of all active sounds.
             * 
             * Listen to it from a Scene using: `this.sound.on('rate', listener)`.
             */
            const GLOBAL_RATE: string;

            /**
             * The Sound Manager Global Volume Event.
             * 
             * This event is dispatched by the Sound Manager when its `volume` property is changed, either directly
             * or via the `setVolume` method. This changes the volume of all active sounds.
             * 
             * Listen to it from a Scene using: `this.sound.on('volume', listener)`.
             */
            const GLOBAL_VOLUME: string;

            /**
             * The Sound Looped Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they loop during playback.
             * 
             * Listen to it from a Sound instance using `Sound.on('looped', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('looped', listener);
             * music.setLoop(true);
             * music.play();
             * ```
             * 
             * This is not to be confused with the [LOOP]{@linkcode Phaser.Sound.Events#event:LOOP} event, which only emits when the loop state of a Sound is changed.
             */
            const LOOPED: string;

            /**
             * The Sound Loop Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their loop state is changed.
             * 
             * Listen to it from a Sound instance using `Sound.on('loop', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('loop', listener);
             * music.setLoop(true);
             * ```
             * 
             * This is not to be confused with the [LOOPED]{@linkcode Phaser.Sound.Events#event:LOOPED} event, which emits each time a Sound loops during playback.
             */
            const LOOP: string;

            /**
             * The Sound Mute Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their mute state changes.
             * 
             * Listen to it from a Sound instance using `Sound.on('mute', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('mute', listener);
             * music.play();
             * music.setMute(true);
             * ```
             */
            const MUTE: string;

            /**
             * The Sound Pan Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their pan changes.
             * 
             * Listen to it from a Sound instance using `Sound.on('pan', listener)`, i.e.:
             * 
             * ```javascript
             * var sound = this.sound.add('key');
             * sound.on('pan', listener);
             * sound.play();
             * sound.setPan(0.5);
             * ```
             */
            const PAN: string;

            /**
             * The Pause All Sounds Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched when the `pauseAll` method is invoked and after all current Sounds
             * have been paused.
             * 
             * Listen to it from a Scene using: `this.sound.on('pauseall', listener)`.
             */
            const PAUSE_ALL: string;

            /**
             * The Sound Pause Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are paused.
             * 
             * Listen to it from a Sound instance using `Sound.on('pause', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('pause', listener);
             * music.play();
             * music.pause();
             * ```
             */
            const PAUSE: string;

            /**
             * The Sound Play Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are played.
             * 
             * Listen to it from a Sound instance using `Sound.on('play', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('play', listener);
             * music.play();
             * ```
             */
            const PLAY: string;

            /**
             * The Sound Rate Change Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their rate changes.
             * 
             * Listen to it from a Sound instance using `Sound.on('rate', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('rate', listener);
             * music.play();
             * music.setRate(0.5);
             * ```
             */
            const RATE: string;

            /**
             * The Resume All Sounds Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched when the `resumeAll` method is invoked and after all current Sounds
             * have been resumed.
             * 
             * Listen to it from a Scene using: `this.sound.on('resumeall', listener)`.
             */
            const RESUME_ALL: string;

            /**
             * The Sound Resume Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are resumed from a paused state.
             * 
             * Listen to it from a Sound instance using `Sound.on('resume', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('resume', listener);
             * music.play();
             * music.pause();
             * music.resume();
             * ```
             */
            const RESUME: string;

            /**
             * The Sound Seek Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are seeked to a new position.
             * 
             * Listen to it from a Sound instance using `Sound.on('seek', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('seek', listener);
             * music.play();
             * music.setSeek(5000);
             * ```
             */
            const SEEK: string;

            /**
             * The Stop All Sounds Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched when the `stopAll` method is invoked and after all current Sounds
             * have been stopped.
             * 
             * Listen to it from a Scene using: `this.sound.on('stopall', listener)`.
             */
            const STOP_ALL: string;

            /**
             * The Sound Stop Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when they are stopped.
             * 
             * Listen to it from a Sound instance using `Sound.on('stop', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('stop', listener);
             * music.play();
             * music.stop();
             * ```
             */
            const STOP: string;

            /**
             * The Sound Manager Unlocked Event.
             * 
             * This event is dispatched by the Base Sound Manager, or more typically, an instance of the Web Audio Sound Manager,
             * or the HTML5 Audio Manager. It is dispatched during the update loop when the Sound Manager becomes unlocked. For
             * Web Audio this is on the first user gesture on the page.
             * 
             * Listen to it from a Scene using: `this.sound.on('unlocked', listener)`.
             */
            const UNLOCKED: string;

            /**
             * The Sound Volume Event.
             * 
             * This event is dispatched by both Web Audio and HTML5 Audio Sound objects when their volume changes.
             * 
             * Listen to it from a Sound instance using `Sound.on('volume', listener)`, i.e.:
             * 
             * ```javascript
             * var music = this.sound.add('key');
             * music.on('volume', listener);
             * music.play();
             * music.setVolume(0.5);
             * ```
             */
            const VOLUME: string;

        }

        /**
         * HTML5 Audio implementation of the sound.
         */
        class HTML5AudioSound extends Phaser.Sound.BaseSound {
            /**
             * 
             * @param manager Reference to the current sound manager instance.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings. Default {}.
             */
            constructor(manager: Phaser.Sound.HTML5AudioSoundManager, key: string, config?: Phaser.Types.Sound.SoundConfig);

            /**
             * An array containing all HTML5 Audio tags that could be used for individual
             * sound playback. Number of instances depends on the config value passed
             * to the `Loader#audio` method call, default is 1.
             */
            tags: HTMLAudioElement[];

            /**
             * Reference to an HTML5 Audio tag used for playing sound.
             */
            audio: HTMLAudioElement;

            /**
             * Timestamp as generated by the Request Animation Frame or SetTimeout
             * representing the time at which the delayed sound playback should start.
             * Set to 0 if sound playback is not delayed.
             */
            startTime: number;

            /**
             * Audio tag's playback position recorded on previous
             * update method call. Set to 0 if sound is not playing.
             */
            previousTime: number;

            /**
             * Play this sound, or a marked section of it.
             * 
             * It always plays the sound from the start. If you want to start playback from a specific time
             * you can set 'seek' setting of the config object, provided to this call, to that value.
             * 
             * If you want to play the same sound simultaneously, then you need to create another instance
             * of it and play that Sound. For HTML5 Audio this also requires creating multiple audio instances
             * when loading the audio files.
             * @param markerName If you want to play a marker then provide the marker name here. Alternatively, this parameter can be a SoundConfig object. Default ''.
             * @param config Optional sound config object to be applied to this marker or entire sound if no marker name is provided. It gets memorized for future plays of current section of the sound.
             */
            play(markerName?: string | Phaser.Types.Sound.SoundConfig, config?: Phaser.Types.Sound.SoundConfig): boolean;

            /**
             * Pauses the sound.
             */
            pause(): boolean;

            /**
             * Resumes the sound.
             */
            resume(): boolean;

            /**
             * Stop playing this sound.
             */
            stop(): boolean;

            /**
             * This method is used internally to pick and play the next available audio tag.
             */
            pickAndPlayAudioTag(): boolean;

            /**
             * This method performs the audio tag pooling logic. It first looks for
             * unused audio tag to assign to this sound object. If there are no unused
             * audio tags, based on HTML5AudioSoundManager#override property value, it
             * looks for sound with most advanced playback and hijacks its audio tag or
             * does nothing.
             */
            pickAudioTag(): boolean;

            /**
             * Method used for playing audio tag and catching possible exceptions
             * thrown from rejected Promise returned from play method call.
             */
            playCatchPromise(): void;

            /**
             * This method is used internally to stop and release the current audio tag.
             */
            stopAndReleaseAudioTag(): void;

            /**
             * Method used internally to reset sound state, usually when stopping sound
             * or when hijacking audio tag from another sound.
             */
            reset(): void;

            /**
             * Method used internally by sound manager for pausing sound if
             * Phaser.Sound.HTML5AudioSoundManager#pauseOnBlur is set to true.
             */
            onBlur(): void;

            /**
             * Method used internally by sound manager for resuming sound if
             * Phaser.Sound.HTML5AudioSoundManager#pauseOnBlur is set to true.
             */
            onFocus(): void;

            /**
             * Update method called automatically by sound manager on every game step.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             */
            update(time: number): void;

            /**
             * Calls Phaser.Sound.BaseSound#destroy method
             * and cleans up all HTML5 Audio related stuff.
             */
            destroy(): void;

            /**
             * This method is used internally to update the mute setting of this sound.
             */
            updateMute(): void;

            /**
             * This method is used internally to update the volume of this sound.
             */
            updateVolume(): void;

            /**
             * This method is used internally to update the playback rate of this sound.
             */
            calculateRate(): void;

            /**
             * Boolean indicating whether the sound is muted or not.
             * Gets or sets the muted state of this sound.
             */
            mute: boolean;

            /**
             * Sets the muted state of this Sound.
             * @param value `true` to mute this sound, `false` to unmute it.
             */
            setMute(value: boolean): this;

            /**
             * Gets or sets the volume of this sound, a value between 0 (silence) and 1 (full volume).
             */
            volume: number;

            /**
             * Sets the volume of this Sound.
             * @param value The volume of the sound.
             */
            setVolume(value: number): this;

            /**
             * Rate at which this Sound will be played.
             * Value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             */
            rate: number;

            /**
             * Sets the playback rate of this Sound.
             * 
             * For example, a value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             * @param value The playback rate at of this Sound.
             */
            setRate(value: number): this;

            /**
             * The detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            detune: number;

            /**
             * Sets the detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             * @param value The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            setDetune(value: number): this;

            /**
             * Property representing the position of playback for this sound, in seconds.
             * Setting it to a specific value moves current playback to that position.
             * The value given is clamped to the range 0 to current marker duration.
             * Setting seek of a stopped sound has no effect.
             */
            seek: number;

            /**
             * Seeks to a specific point in this sound.
             * @param value The point in the sound to seek to.
             */
            setSeek(value: number): this;

            /**
             * Flag indicating whether or not the sound or current sound marker will loop.
             */
            loop: boolean;

            /**
             * Sets the loop state of this Sound.
             * @param value `true` to loop this sound, `false` to not loop it.
             */
            setLoop(value: boolean): Phaser.Sound.HTML5AudioSound;

            /**
             * Gets or sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Has no audible effect on HTML5 Audio Sound, but still generates the PAN Event.
             */
            pan: number;

            /**
             * Sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Has no audible effect on HTML5 Audio Sound, but still generates the PAN Event.
             * @param value The pan of the sound. A value between -1 (full left pan) and 1 (full right pan).
             */
            setPan(value: number): this;

        }

        /**
         * HTML5AudioSoundManager
         */
        class HTML5AudioSoundManager extends Phaser.Sound.BaseSoundManager {
            /**
             * 
             * @param game Reference to the current game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * Flag indicating whether if there are no idle instances of HTML5 Audio tag,
             * for any particular sound, if one of the used tags should be hijacked and used
             * for succeeding playback or if succeeding Phaser.Sound.HTML5AudioSound#play
             * call should be ignored.
             */
            override: boolean;

            /**
             * Value representing time difference, in seconds, between calling
             * play method on an audio tag and when it actually starts playing.
             * It is used to achieve more accurate delayed sound playback.
             * 
             * You might need to tweak this value to get the desired results
             * since audio play delay varies depending on the browser/platform.
             */
            audioPlayDelay: number;

            /**
             * A value by which we should offset the loop end marker of the
             * looping sound to compensate for lag, caused by changing audio
             * tag playback position, in order to achieve gapless looping.
             * 
             * You might need to tweak this value to get the desired results
             * since loop lag varies depending on the browser/platform.
             */
            loopEndOffset: number;

            /**
             * Adds a new sound into the sound manager.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            add(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.HTML5AudioSound;

            /**
             * Unlocks HTML5 Audio loading and playback on mobile
             * devices on the initial explicit user interaction.
             */
            unlock(): void;

            /**
             * Method used internally for pausing sound manager if
             * Phaser.Sound.HTML5AudioSoundManager#pauseOnBlur is set to true.
             */
            protected onBlur(): void;

            /**
             * Method used internally for resuming sound manager if
             * Phaser.Sound.HTML5AudioSoundManager#pauseOnBlur is set to true.
             */
            protected onFocus(): void;

            /**
             * Calls Phaser.Sound.BaseSoundManager#destroy method
             * and cleans up all HTML5 Audio related stuff.
             */
            destroy(): void;

            /**
             * Method used internally by Phaser.Sound.HTML5AudioSound class methods and property setters
             * to check if sound manager is locked and then either perform action immediately or queue it
             * to be performed once the sound manager gets unlocked.
             * @param sound Sound object on which to perform queued action.
             * @param prop Name of the method to be called or property to be assigned a value to.
             * @param value An optional parameter that either holds an array of arguments to be passed to the method call or value to be set to the property.
             */
            protected isLocked(sound: Phaser.Sound.HTML5AudioSound, prop: string, value?: any): boolean;

            /**
             * Sets the muted state of all this Sound Manager.
             * @param value `true` to mute all sounds, `false` to unmute them.
             */
            setMute(value: boolean): Phaser.Sound.HTML5AudioSoundManager;

            mute: boolean;

            /**
             * Sets the volume of this Sound Manager.
             * @param value The global volume of this Sound Manager.
             */
            setVolume(value: number): Phaser.Sound.HTML5AudioSoundManager;

            volume: number;

        }

        /**
         * No audio implementation of the sound. It is used if audio has been
         * disabled in the game config or the device doesn't support any audio.
         * 
         * It represents a graceful degradation of sound logic that provides
         * minimal functionality and prevents Phaser projects that use audio from
         * breaking on devices that don't support any audio playback technologies.
         */
        class NoAudioSound extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param manager Reference to the current sound manager instance.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings. Default {}.
             */
            constructor(manager: Phaser.Sound.NoAudioSoundManager, key: string, config?: Phaser.Types.Sound.SoundConfig);

            /**
             * Local reference to the sound manager.
             */
            manager: Phaser.Sound.BaseSoundManager;

            /**
             * Asset key for the sound.
             */
            readonly key: string;

            /**
             * Flag indicating if sound is currently playing.
             */
            readonly isPlaying: boolean;

            /**
             * Flag indicating if sound is currently paused.
             */
            readonly isPaused: boolean;

            /**
             * A property that holds the value of sound's actual playback rate,
             * after its rate and detune values has been combined with global
             * rate and detune values.
             */
            readonly totalRate: number;

            /**
             * A value representing the duration, in seconds.
             * It could be total sound duration or a marker duration.
             */
            readonly duration: number;

            /**
             * The total duration of the sound in seconds.
             */
            readonly totalDuration: number;

            /**
             * A config object used to store default sound settings' values.
             * Default values will be set by properties' setters.
             */
            config: Phaser.Types.Sound.SoundConfig;

            /**
             * Reference to the currently used config.
             * It could be default config or marker config.
             */
            currentConfig: Phaser.Types.Sound.SoundConfig;

            /**
             * Boolean indicating whether the sound is muted or not.
             * Gets or sets the muted state of this sound.
             */
            mute: boolean;

            /**
             * Gets or sets the volume of this sound, a value between 0 (silence) and 1 (full volume).
             */
            volume: number;

            /**
             * Rate at which this Sound will be played.
             * Value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             */
            rate: number;

            /**
             * The detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            detune: number;

            /**
             * Property representing the position of playback for this sound, in seconds.
             * Setting it to a specific value moves current playback to that position.
             * The value given is clamped to the range 0 to current marker duration.
             * Setting seek of a stopped sound has no effect.
             */
            seek: number;

            /**
             * Flag indicating whether or not the sound or current sound marker will loop.
             */
            loop: boolean;

            /**
             * Gets or sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Always returns zero on iOS / Safari as it doesn't support the stereo panner node.
             */
            pan: number;

            /**
             * Object containing markers definitions.
             */
            readonly markers: {[key: string]:  Phaser.Types.Sound.SoundMarker};

            /**
             * Currently playing marker.
             * 'null' if whole sound is playing.
             */
            readonly currentMarker: Phaser.Types.Sound.SoundMarker;

            /**
             * Flag indicating if destroy method was called on this sound.
             */
            pendingRemove: boolean;

            /**
             * 
             * @param marker Marker object.
             */
            addMarker(marker: Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * 
             * @param marker Marker object with updated values.
             */
            updateMarker(marker: Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * 
             * @param markerName The name of the marker to remove.
             */
            removeMarker(markerName: string): null;

            /**
             * 
             * @param markerName If you want to play a marker then provide the marker name here. Alternatively, this parameter can be a SoundConfig object. Default ''.
             * @param config Optional sound config object to be applied to this marker or entire sound if no marker name is provided. It gets memorized for future plays of current section of the sound.
             */
            play(markerName?: string | Phaser.Types.Sound.SoundConfig, config?: Phaser.Types.Sound.SoundConfig): boolean;

            pause(): boolean;

            /**
             * Resumes the sound.
             */
            resume(): boolean;

            /**
             * Stop playing this sound.
             */
            stop(): boolean;

            /**
             * Sets the muted state of this Sound.
             * @param value `true` to mute this sound, `false` to unmute it.
             */
            setMute(value: boolean): this;

            /**
             * Sets the volume of this Sound.
             * @param value The volume of the sound.
             */
            setVolume(value: number): this;

            /**
             * Sets the playback rate of this Sound.
             * 
             * For example, a value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             * @param value The playback rate at of this Sound.
             */
            setRate(value: number): this;

            /**
             * Sets the detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             * @param value The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            setDetune(value: number): this;

            /**
             * Seeks to a specific point in this sound.
             * @param value The point in the sound to seek to.
             */
            setSeek(value: number): this;

            /**
             * Sets the loop state of this Sound.
             * @param value `true` to loop this sound, `false` to not loop it.
             */
            setLoop(value: boolean): this;

            /**
             * Sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Note: iOS / Safari doesn't support the stereo panner node.
             * @param value The pan of the sound. A value between -1 (full left pan) and 1 (full right pan).
             */
            setPan(value: number): this;

            /**
             * Method used internally for applying config values to some of the sound properties.
             */
            applyConfig(): void;

            /**
             * Method used internally for resetting values of some of the config properties.
             */
            resetConfig(): void;

            /**
             * Update method called automatically by sound manager on every game step.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             * @param delta The delta time elapsed since the last frame.
             */
            update(time: number, delta: number): void;

            /**
             * Method used internally to calculate total playback rate of the sound.
             */
            calculateRate(): void;

            /**
             * Destroys this sound and all associated events and marks it for removal from the sound manager.
             */
            destroy(): void;

        }

        /**
         * No-audio implementation of the Sound Manager. It is used if audio has been
         * disabled in the game config or the device doesn't support any audio.
         * 
         * It represents a graceful degradation of Sound Manager logic that provides
         * minimal functionality and prevents Phaser projects that use audio from
         * breaking on devices that don't support any audio playback technologies.
         */
        class NoAudioSoundManager extends Phaser.Sound.BaseSoundManager {
            /**
             * 
             * @param game Reference to the current game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * Adds a new sound into the sound manager.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            add(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.NoAudioSound;

            /**
             * Adds a new audio sprite sound into the sound manager.
             * Audio Sprites are a combination of audio files and a JSON configuration.
             * The JSON follows the format of that created by https://github.com/tonistiigi/audiosprite
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            addAudioSprite(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.NoAudioSound;

            /**
             * Gets the first sound in the manager matching the given key, if any.
             * @param key Sound asset key.
             */
            get<T extends Phaser.Sound.BaseSound>(key: string): T;

            /**
             * Gets any sounds in the manager matching the given key.
             * @param key Sound asset key.
             */
            getAll<T extends Phaser.Sound.BaseSound>(key: string): T[];

            /**
             * This method does nothing but return 'false' for the No Audio Sound Manager, to maintain
             * compatibility with the other Sound Managers.
             * @param key Asset key for the sound.
             * @param extra An optional additional object containing settings to be applied to the sound. It could be either config or marker object.
             */
            play(key: string, extra?: Phaser.Types.Sound.SoundConfig | Phaser.Types.Sound.SoundMarker): boolean;

            /**
             * This method does nothing but return 'false' for the No Audio Sound Manager, to maintain
             * compatibility with the other Sound Managers.
             * @param key Asset key for the sound.
             * @param spriteName The name of the sound sprite to play.
             * @param config An optional config object containing default sound settings.
             */
            playAudioSprite(key: string, spriteName: string, config?: Phaser.Types.Sound.SoundConfig): boolean;

            /**
             * Removes a sound from the sound manager.
             * The removed sound is destroyed before removal.
             * @param sound The sound object to remove.
             */
            remove(sound: Phaser.Sound.BaseSound): boolean;

            /**
             * Removes all sounds from the manager, destroying the sounds.
             */
            removeAll(): void;

            /**
             * Removes all sounds from the sound manager that have an asset key matching the given value.
             * The removed sounds are destroyed before removal.
             * @param key The key to match when removing sound objects.
             */
            removeByKey(key: string): number;

            /**
             * Stops any sounds matching the given key.
             * @param key Sound asset key.
             */
            stopByKey(key: string): number;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            onBlur(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            onFocus(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            onGameBlur(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            onGameFocus(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            pauseAll(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            resumeAll(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            stopAll(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            update(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            setRate(): this;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            setDetune(): this;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            setMute(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            setVolume(): void;

            /**
             * Empty function for the No Audio Sound Manager.
             */
            unlock(): void;

            /**
             * Destroys all the sounds in the game and all associated events.
             */
            destroy(): void;

        }

        /**
         * Creates a Web Audio, HTML5 Audio or No Audio Sound Manager based on config and device settings.
         * 
         * Be aware of https://developers.google.com/web/updates/2017/09/autoplay-policy-changes
         * @param game Reference to the current game instance.
         */
        function SoundManagerCreator(game: Phaser.Game): Phaser.Sound.HTML5AudioSoundManager | Phaser.Sound.WebAudioSoundManager | Phaser.Sound.NoAudioSoundManager;

        /**
         * Web Audio API implementation of the sound.
         */
        class WebAudioSound extends Phaser.Sound.BaseSound {
            /**
             * 
             * @param manager Reference to the WebAudio Sound Manager that owns this Sound instance.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings. Default {}.
             */
            constructor(manager: Phaser.Sound.WebAudioSoundManager, key: string, config?: Phaser.Types.Sound.SoundConfig);

            /**
             * Audio buffer containing decoded data of the audio asset to be played.
             */
            audioBuffer: AudioBuffer;

            /**
             * A reference to an audio source node used for playing back audio from
             * audio data stored in Phaser.Sound.WebAudioSound#audioBuffer.
             */
            source: AudioBufferSourceNode;

            /**
             * A reference to a second audio source used for gapless looped playback.
             */
            loopSource: AudioBufferSourceNode;

            /**
             * Gain node responsible for controlling this sound's muting.
             */
            muteNode: GainNode;

            /**
             * Gain node responsible for controlling this sound's volume.
             */
            volumeNode: GainNode;

            /**
             * Panner node responsible for controlling this sound's pan.
             * 
             * Doesn't work on iOS / Safari.
             */
            pannerNode: StereoPannerNode;

            /**
             * The Stereo Spatial Panner node.
             */
            spatialNode: PannerNode;

            /**
             * If the Spatial Panner node has been set to track a vector or
             * Game Object, this retains a reference to it.
             */
            spatialSource: Phaser.Types.Math.Vector2Like;

            /**
             * The time at which the sound should have started playback from the beginning.
             * 
             * Treat this property as read-only.
             * 
             * Based on `BaseAudioContext.currentTime` value.
             */
            playTime: number;

            /**
             * The time at which the sound source should have actually started playback.
             * 
             * Treat this property as read-only.
             * 
             * Based on `BaseAudioContext.currentTime` value.
             */
            startTime: number;

            /**
             * The time at which the sound loop source should actually start playback.
             * 
             * Based on `BaseAudioContext.currentTime` value.
             */
            loopTime: number;

            /**
             * An array where we keep track of all rate updates during playback.
             * 
             * Treat this property as read-only.
             * 
             * Array of object types: `{ time: number, rate: number }`
             */
            rateUpdates: any[];

            /**
             * Used for keeping track when sound source playback has ended
             * so its state can be updated accordingly.
             */
            readonly hasEnded: boolean;

            /**
             * Used for keeping track when sound source has looped
             * so its state can be updated accordingly.
             */
            readonly hasLooped: boolean;

            /**
             * Play this sound, or a marked section of it.
             * 
             * It always plays the sound from the start. If you want to start playback from a specific time
             * you can set 'seek' setting of the config object, provided to this call, to that value.
             * 
             * If you want to play the same sound simultaneously, then you need to create another instance
             * of it and play that Sound.
             * @param markerName If you want to play a marker then provide the marker name here. Alternatively, this parameter can be a SoundConfig object. Default ''.
             * @param config Optional sound config object to be applied to this marker or entire sound if no marker name is provided. It gets memorized for future plays of current section of the sound.
             */
            play(markerName?: string | Phaser.Types.Sound.SoundConfig, config?: Phaser.Types.Sound.SoundConfig): boolean;

            /**
             * Pauses the sound.
             */
            pause(): boolean;

            /**
             * Resumes the sound.
             */
            resume(): boolean;

            /**
             * Stop playing this sound.
             */
            stop(): boolean;

            /**
             * This method is only used internally and it creates a looping buffer source.
             */
            createAndStartLoopBufferSource(): void;

            /**
             * This method is only used internally and it creates a buffer source.
             */
            createBufferSource(): AudioBufferSourceNode;

            /**
             * This method is only used internally and it stops and removes a buffer source.
             */
            stopAndRemoveBufferSource(): void;

            /**
             * This method is only used internally and it stops and removes a looping buffer source.
             */
            stopAndRemoveLoopBufferSource(): void;

            /**
             * Method used internally for applying config values to some of the sound properties.
             */
            applyConfig(): void;

            /**
             * Sets the x position of this Sound in Spatial Audio space.
             * 
             * This only has any effect if the sound was created with a SpatialSoundConfig object.
             * 
             * Also see the `WebAudioSoundManager.setListenerPosition` method.
             * 
             * If you find that the sound becomes too quiet, too quickly, as it moves away from
             * the listener, then try different `refDistance` property values when configuring
             * the spatial sound.
             */
            x: number;

            /**
             * Sets the y position of this Sound in Spatial Audio space.
             * 
             * This only has any effect if the sound was created with a SpatialSoundConfig object.
             * 
             * Also see the `WebAudioSoundManager.setListenerPosition` method.
             * 
             * If you find that the sound becomes too quiet, too quickly, as it moves away from
             * the listener, then try different `refDistance` property values when configuring
             * the spatial sound.
             */
            y: number;

            /**
             * Update method called automatically by sound manager on every game step.
             */
            update(): void;

            /**
             * Calls Phaser.Sound.BaseSound#destroy method
             * and cleans up all Web Audio API related stuff.
             */
            destroy(): void;

            /**
             * Method used internally to calculate total playback rate of the sound.
             */
            calculateRate(): void;

            /**
             * Method used internally for calculating current playback time of a playing sound.
             */
            getCurrentTime(): void;

            /**
             * Method used internally for calculating the time
             * at witch the loop source should start playing.
             */
            getLoopTime(): void;

            /**
             * Rate at which this Sound will be played.
             * Value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             */
            rate: number;

            /**
             * Sets the playback rate of this Sound.
             * 
             * For example, a value of 1.0 plays the audio at full speed, 0.5 plays the audio at half speed
             * and 2.0 doubles the audios playback speed.
             * @param value The playback rate at of this Sound.
             */
            setRate(value: number): this;

            /**
             * The detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            detune: number;

            /**
             * Sets the detune value of this Sound, given in [cents](https://en.wikipedia.org/wiki/Cent_%28music%29).
             * The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             * @param value The range of the value is -1200 to 1200, but we recommend setting it to [50](https://en.wikipedia.org/wiki/50_Cent).
             */
            setDetune(value: number): this;

            /**
             * Boolean indicating whether the sound is muted or not.
             * Gets or sets the muted state of this sound.
             */
            mute: boolean;

            /**
             * Sets the muted state of this Sound.
             * @param value `true` to mute this sound, `false` to unmute it.
             */
            setMute(value: boolean): this;

            /**
             * Gets or sets the volume of this sound, a value between 0 (silence) and 1 (full volume).
             */
            volume: number;

            /**
             * Sets the volume of this Sound.
             * @param value The volume of the sound.
             */
            setVolume(value: number): this;

            /**
             * Property representing the position of playback for this sound, in seconds.
             * Setting it to a specific value moves current playback to that position.
             * The value given is clamped to the range 0 to current marker duration.
             * Setting seek of a stopped sound has no effect.
             */
            seek: number;

            /**
             * Seeks to a specific point in this sound.
             * @param value The point in the sound to seek to.
             */
            setSeek(value: number): this;

            /**
             * Flag indicating whether or not the sound or current sound marker will loop.
             */
            loop: boolean;

            /**
             * Sets the loop state of this Sound.
             * @param value `true` to loop this sound, `false` to not loop it.
             */
            setLoop(value: boolean): this;

            /**
             * Gets or sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Always returns zero on iOS / Safari as it doesn't support the stereo panner node.
             */
            pan: number;

            /**
             * Sets the pan of this sound, a value between -1 (full left pan) and 1 (full right pan).
             * 
             * Note: iOS / Safari doesn't support the stereo panner node.
             * @param value The pan of the sound. A value between -1 (full left pan) and 1 (full right pan).
             */
            setPan(value: number): this;

        }

        /**
         * Web Audio API implementation of the Sound Manager.
         * 
         * Not all browsers can play all audio formats.
         * 
         * There is a good guide to what's supported: [Cross-browser audio basics: Audio codec support](https://developer.mozilla.org/en-US/Apps/Fundamentals/Audio_and_video_delivery/Cross-browser_audio_basics#Audio_Codec_Support).
         */
        class WebAudioSoundManager extends Phaser.Sound.BaseSoundManager {
            /**
             * 
             * @param game Reference to the current game instance.
             */
            constructor(game: Phaser.Game);

            /**
             * The AudioContext being used for playback.
             */
            context: AudioContext;

            /**
             * Gain node responsible for controlling global muting.
             */
            masterMuteNode: GainNode;

            /**
             * Gain node responsible for controlling global volume.
             */
            masterVolumeNode: GainNode;

            /**
             * Destination node for connecting individual sounds to.
             */
            destination: AudioNode;

            /**
             * Method responsible for instantiating and returning AudioContext instance.
             * If an instance of an AudioContext class was provided through the game config,
             * that instance will be returned instead. This can come in handy if you are reloading
             * a Phaser game on a page that never properly refreshes (such as in an SPA project)
             * and you want to reuse already instantiated AudioContext.
             * @param game Reference to the current game instance.
             */
            createAudioContext(game: Phaser.Game): AudioContext;

            /**
             * This method takes a new AudioContext reference and then sets
             * this Sound Manager to use that context for all playback.
             * 
             * As part of this call it also disconnects the master mute and volume
             * nodes and then re-creates them on the new given context.
             * @param context Reference to an already created AudioContext instance.
             */
            setAudioContext(context: AudioContext): this;

            /**
             * Adds a new sound into the sound manager.
             * @param key Asset key for the sound.
             * @param config An optional config object containing default sound settings.
             */
            add(key: string, config?: Phaser.Types.Sound.SoundConfig): Phaser.Sound.WebAudioSound;

            /**
             * Decode audio data into a format ready for playback via Web Audio.
             * 
             * The audio data can be a base64 encoded string, an audio media-type data uri, or an ArrayBuffer instance.
             * 
             * The `audioKey` is the key that will be used to save the decoded audio to the audio cache.
             * 
             * Instead of passing a single entry you can instead pass an array of `Phaser.Types.Sound.DecodeAudioConfig`
             * objects as the first and only argument.
             * 
             * Decoding is an async process, so be sure to listen for the events to know when decoding has completed.
             * 
             * Once the audio has decoded it can be added to the Sound Manager or played via its key.
             * @param audioKey The string-based key to be used to reference the decoded audio in the audio cache, or an array of audio config objects.
             * @param audioData The audio data, either a base64 encoded string, an audio media-type data uri, or an ArrayBuffer instance.
             */
            decodeAudio(audioKey?: Phaser.Types.Sound.DecodeAudioConfig[] | string, audioData?: ArrayBuffer | string): void;

            /**
             * Sets the X and Y position of the Spatial Audio listener on this Web Audios context.
             * 
             * If you call this method with no parameters it will default to the center-point of
             * the game canvas. Depending on the type of game you're making, you may need to call
             * this method constantly to reset the listener position as the camera scrolls.
             * 
             * Calling this method does nothing on HTML5Audio.
             * @param x The x position of the Spatial Audio listener.
             * @param y The y position of the Spatial Audio listener.
             */
            setListenerPosition(x?: number, y?: number): void;

            /**
             * Unlocks Web Audio API on the initial input event.
             * 
             * Read more about how this issue is handled here in [this article](https://medium.com/@pgoloskokovic/unlocking-web-audio-the-smarter-way-8858218c0e09).
             */
            unlock(): void;

            /**
             * Method used internally for pausing sound manager if
             * Phaser.Sound.WebAudioSoundManager#pauseOnBlur is set to true.
             */
            protected onBlur(): void;

            /**
             * Method used internally for resuming sound manager if
             * Phaser.Sound.WebAudioSoundManager#pauseOnBlur is set to true.
             */
            protected onFocus(): void;

            /**
             * Update method called on every game step.
             * 
             * Removes destroyed sounds and updates every active sound in the game.
             * @param time The current timestamp as generated by the Request Animation Frame or SetTimeout.
             * @param delta The delta time elapsed since the last frame.
             */
            protected update(time: number, delta: number): void;

            /**
             * Calls Phaser.Sound.BaseSoundManager#destroy method
             * and cleans up all Web Audio API related stuff.
             */
            destroy(): void;

            /**
             * Sets the muted state of all this Sound Manager.
             * @param value `true` to mute all sounds, `false` to unmute them.
             */
            setMute(value: boolean): Phaser.Sound.WebAudioSoundManager;

            mute: boolean;

            /**
             * Sets the volume of this Sound Manager.
             * @param value The global volume of this Sound Manager.
             */
            setVolume(value: number): Phaser.Sound.WebAudioSoundManager;

            volume: number;

        }

    }

    namespace Structs {
        namespace Events {
            /**
             * The Process Queue Add Event.
             * 
             * This event is dispatched by a Process Queue when a new item is successfully moved to its active list.
             * 
             * You will most commonly see this used by a Scene's Update List when a new Game Object has been added.
             * 
             * In that instance, listen to this event from within a Scene using: `this.sys.updateList.on('add', listener)`.
             */
            const PROCESS_QUEUE_ADD: string;

            /**
             * The Process Queue Remove Event.
             * 
             * This event is dispatched by a Process Queue when a new item is successfully removed from its active list.
             * 
             * You will most commonly see this used by a Scene's Update List when a Game Object has been removed.
             * 
             * In that instance, listen to this event from within a Scene using: `this.sys.updateList.on('remove', listener)`.
             */
            const PROCESS_QUEUE_REMOVE: string;

        }

        /**
         * List is a generic implementation of an ordered list which contains utility methods for retrieving, manipulating, and iterating items.
         */
        class List<T> {
            /**
             * 
             * @param parent The parent of this list.
             */
            constructor(parent: any);

            /**
             * The parent of this list.
             */
            parent: any;

            /**
             * The objects that belong to this collection.
             */
            list: T[];

            /**
             * The index of the current element.
             * 
             * This is used internally when iterating through the list with the {@link #first}, {@link #last}, {@link #get}, and {@link #previous} properties.
             */
            position: number;

            /**
             * A callback that is invoked every time a child is added to this list.
             */
            addCallback: Function;

            /**
             * A callback that is invoked every time a child is removed from this list.
             */
            removeCallback: Function;

            /**
             * The property key to sort by.
             */
            _sortKey: string;

            /**
             * Adds the given item to the end of the list. Each item must be unique.
             * @param child The item, or array of items, to add to the list.
             * @param skipCallback Skip calling the List.addCallback if this child is added successfully. Default false.
             */
            add(child: any | any[], skipCallback?: boolean): any;

            /**
             * Adds an item to list, starting at a specified index. Each item must be unique within the list.
             * @param child The item, or array of items, to add to the list.
             * @param index The index in the list at which the element(s) will be inserted. Default 0.
             * @param skipCallback Skip calling the List.addCallback if this child is added successfully. Default false.
             */
            addAt(child: (T|T[]), index?: number, skipCallback?: boolean): (T|T[]);

            /**
             * Retrieves the item at a given position inside the List.
             * @param index The index of the item.
             */
            getAt(index: number): T;

            /**
             * Locates an item within the List and returns its index.
             * @param child The item to locate.
             */
            getIndex(child: T): number;

            /**
             * Sort the contents of this List so the items are in order based on the given property.
             * For example, `sort('alpha')` would sort the List contents based on the value of their `alpha` property.
             * @param property The property to lexically sort by.
             * @param handler Provide your own custom handler function. Will receive 2 children which it should compare and return a boolean.
             */
            sort(property: string, handler?: Function): T[];

            /**
             * Searches for the first instance of a child with its `name`
             * property matching the given argument. Should more than one child have
             * the same name only the first is returned.
             * @param name The name to search for.
             */
            getByName(name: string): T | null;

            /**
             * Returns a random child from the group.
             * @param startIndex Offset from the front of the group (lowest child). Default 0.
             * @param length Restriction on the number of values you want to randomly select from. Default (to top).
             */
            getRandom(startIndex?: number, length?: number): T | null;

            /**
             * Returns the first element in a given part of the List which matches a specific criterion.
             * @param property The name of the property to test or a falsey value to have no criterion.
             * @param value The value to test the `property` against, or `undefined` to allow any value and only check for existence.
             * @param startIndex The position in the List to start the search at. Default 0.
             * @param endIndex The position in the List to optionally stop the search at. It won't be checked.
             */
            getFirst(property: string, value: any, startIndex?: number, endIndex?: number): T | null;

            /**
             * Returns all children in this List.
             * 
             * You can optionally specify a matching criteria using the `property` and `value` arguments.
             * 
             * For example: `getAll('parent')` would return only children that have a property called `parent`.
             * 
             * You can also specify a value to compare the property to:
             * 
             * `getAll('visible', true)` would return only children that have their visible property set to `true`.
             * 
             * Optionally you can specify a start and end index. For example if this List had 100 children,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would return matches from only
             * the first 50 children in the List.
             * @param property An optional property to test against the value argument.
             * @param value If property is set then Child.property must strictly equal this value to be included in the results.
             * @param startIndex The first child index to start the search from.
             * @param endIndex The last child index to search up until.
             */
            getAll(property?: string, value?: any, startIndex?: number, endIndex?: number): T[];

            /**
             * Returns the total number of items in the List which have a property matching the given value.
             * @param property The property to test on each item.
             * @param value The value to test the property against.
             */
            count(property: string, value: T): number;

            /**
             * Swaps the positions of two items in the list.
             * @param child1 The first item to swap.
             * @param child2 The second item to swap.
             */
            swap(child1: T, child2: T): void;

            /**
             * Moves an item in the List to a new position.
             * @param child The item to move.
             * @param index Moves an item in the List to a new position.
             */
            moveTo(child: T, index: number): T;

            /**
             * Moves the given array element above another one in the array.
             * @param child1 The element to move above base element.
             * @param child2 The base element.
             */
            moveAbove(child1: T, child2: T): void;

            /**
             * Moves the given array element below another one in the array.
             * @param child1 The element to move below base element.
             * @param child2 The base element.
             */
            moveBelow(child1: T, child2: T): void;

            /**
             * Removes one or many items from the List.
             * @param child The item, or array of items, to remove.
             * @param skipCallback Skip calling the List.removeCallback. Default false.
             */
            remove(child: any, skipCallback?: boolean): any;

            /**
             * Removes the item at the given position in the List.
             * @param index The position to remove the item from.
             * @param skipCallback Skip calling the List.removeCallback. Default false.
             */
            removeAt(index: number, skipCallback?: boolean): T;

            /**
             * Removes the items within the given range in the List.
             * @param startIndex The index to start removing from. Default 0.
             * @param endIndex The position to stop removing at. The item at this position won't be removed.
             * @param skipCallback Skip calling the List.removeCallback. Default false.
             */
            removeBetween(startIndex?: number, endIndex?: number, skipCallback?: boolean): T[];

            /**
             * Removes all the items.
             * @param skipCallback Skip calling the List.removeCallback. Default false.
             */
            removeAll(skipCallback?: boolean): this;

            /**
             * Brings the given child to the top of this List.
             * @param child The item to bring to the top of the List.
             */
            bringToTop(child: T): T;

            /**
             * Sends the given child to the bottom of this List.
             * @param child The item to send to the back of the list.
             */
            sendToBack(child: T): T;

            /**
             * Moves the given child up one place in this group unless it's already at the top.
             * @param child The item to move up.
             */
            moveUp(child: T): T;

            /**
             * Moves the given child down one place in this group unless it's already at the bottom.
             * @param child The item to move down.
             */
            moveDown(child: T): T;

            /**
             * Reverses the order of all children in this List.
             */
            reverse(): Phaser.Structs.List<T>;

            /**
             * Shuffles the items in the list.
             */
            shuffle(): Phaser.Structs.List<T>;

            /**
             * Replaces a child of this List with the given newChild. The newChild cannot be a member of this List.
             * @param oldChild The child in this List that will be replaced.
             * @param newChild The child to be inserted into this List.
             */
            replace(oldChild: T, newChild: T): T;

            /**
             * Checks if an item exists within the List.
             * @param child The item to check for the existence of.
             */
            exists(child: T): boolean;

            /**
             * Sets the property `key` to the given value on all members of this List.
             * @param property The name of the property to set.
             * @param value The value to set the property to.
             * @param startIndex The first child index to start the search from.
             * @param endIndex The last child index to search up until.
             */
            setAll(property: string, value: T, startIndex?: number, endIndex?: number): void;

            /**
             * Passes all children to the given callback.
             * @param callback The function to call.
             * @param context Value to use as `this` when executing callback.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            each(callback: EachListCallback<T>, context?: any, ...args: any[]): void;

            /**
             * Clears the List and recreates its internal array.
             */
            shutdown(): void;

            /**
             * Destroys this List.
             */
            destroy(): void;

            /**
             * The number of items inside the List.
             */
            readonly length: number;

            /**
             * The first item in the List or `null` for an empty List.
             */
            readonly first: T;

            /**
             * The last item in the List, or `null` for an empty List.
             */
            readonly last: T;

            /**
             * The next item in the List, or `null` if the entire List has been traversed.
             * 
             * This property can be read successively after reading {@link #first} or manually setting the {@link #position} to iterate the List.
             */
            readonly next: T;

            /**
             * The previous item in the List, or `null` if the entire List has been traversed.
             * 
             * This property can be read successively after reading {@link #last} or manually setting the {@link #position} to iterate the List backwards.
             */
            readonly previous: T;

        }

        /**
         * The keys of a Map can be arbitrary values.
         * 
         * ```javascript
         * var map = new Map([
         *    [ 1, 'one' ],
         *    [ 2, 'two' ],
         *    [ 3, 'three' ]
         * ]);
         * ```
         */
        class Map<K, V> {
            /**
             * 
             * @param elements An optional array of key-value pairs to populate this Map with.
             */
            constructor(elements: V[]);

            /**
             * The entries in this Map.
             */
            entries: {[key: string]:  V};

            /**
             * The number of key / value pairs in this Map.
             */
            size: number;

            /**
             * Adds all the elements in the given array to this Map.
             * 
             * If the element already exists, the value will be skipped.
             * @param elements An array of key-value pairs to populate this Map with.
             */
            setAll<K, V>(elements: V[]): this;

            /**
             * Adds an element with a specified `key` and `value` to this Map.
             * 
             * If the `key` already exists, the value will be replaced.
             * 
             * If you wish to add multiple elements in a single call, use the `setAll` method instead.
             * @param key The key of the element to be added to this Map.
             * @param value The value of the element to be added to this Map.
             */
            set(key: K, value: V): Phaser.Structs.Map<K, V>;

            /**
             * Returns the value associated to the `key`, or `undefined` if there is none.
             * @param key The key of the element to return from the `Map` object.
             */
            get(key: K): V;

            /**
             * Returns an `Array` of all the values stored in this Map.
             */
            getArray(): V[];

            /**
             * Returns a boolean indicating whether an element with the specified key exists or not.
             * @param key The key of the element to test for presence of in this Map.
             */
            has(key: K): boolean;

            /**
             * Delete the specified element from this Map.
             * @param key The key of the element to delete from this Map.
             */
            delete(key: K): Phaser.Structs.Map<K, V>;

            /**
             * Delete all entries from this Map.
             */
            clear(): Phaser.Structs.Map<K, V>;

            /**
             * Returns all entries keys in this Map.
             */
            keys(): K[];

            /**
             * Returns an `Array` of all entries.
             */
            values(): V[];

            /**
             * Dumps the contents of this Map to the console via `console.group`.
             */
            dump(): void;

            /**
             * Iterates through all entries in this Map, passing each one to the given callback.
             * 
             * If the callback returns `false`, the iteration will break.
             * @param callback The callback which will receive the keys and entries held in this Map.
             */
            each(callback: EachMapCallback<V>): Phaser.Structs.Map<K, V>;

            /**
             * Returns `true` if the value exists within this Map. Otherwise, returns `false`.
             * @param value The value to search for.
             */
            contains(value: V): boolean;

            /**
             * Merges all new keys from the given Map into this one.
             * If it encounters a key that already exists it will be skipped unless override is set to `true`.
             * @param map The Map to merge in to this Map.
             * @param override Set to `true` to replace values in this Map with those from the source map, or `false` to skip them. Default false.
             */
            merge(map: Phaser.Structs.Map<K, V>, override?: boolean): Phaser.Structs.Map<K, V>;

        }

        /**
         * A Process Queue maintains three internal lists.
         * 
         * The `pending` list is a selection of items which are due to be made 'active' in the next update.
         * The `active` list is a selection of items which are considered active and should be updated.
         * The `destroy` list is a selection of items that were active and are awaiting being destroyed in the next update.
         * 
         * When new items are added to a Process Queue they are put in the pending list, rather than being added
         * immediately the active list. Equally, items that are removed are put into the destroy list, rather than
         * being destroyed immediately. This allows the Process Queue to carefully process each item at a specific, fixed
         * time, rather than at the time of the request from the API.
         */
        class ProcessQueue<T> extends Phaser.Events.EventEmitter {
            /**
             * If `true` only unique objects will be allowed in the queue.
             */
            checkQueue: boolean;

            /**
             * Checks the given item to see if it is already active within this Process Queue.
             * @param item The item to check.
             */
            isActive(item: T): Phaser.Structs.ProcessQueue<T>;

            /**
             * Checks the given item to see if it is already pending addition to this Process Queue.
             * @param item The item to check.
             */
            isPending(item: T): Phaser.Structs.ProcessQueue<T>;

            /**
             * Checks the given item to see if it is already pending destruction from this Process Queue.
             * @param item The item to check.
             */
            isDestroying(item: T): Phaser.Structs.ProcessQueue<T>;

            /**
             * Adds a new item to the Process Queue.
             * 
             * The item is added to the pending list and made active in the next update.
             * @param item The item to add to the queue.
             */
            add(item: T): Phaser.Structs.ProcessQueue<T>;

            /**
             * Removes an item from the Process Queue.
             * 
             * The item is added to the 'destroy' list and is fully removed in the next update.
             * @param item The item to be removed from the queue.
             */
            remove(item: T): Phaser.Structs.ProcessQueue<T>;

            /**
             * Removes all active items from this Process Queue.
             * 
             * All the items are marked as 'pending destroy' and fully removed in the next update.
             */
            removeAll(): this;

            /**
             * Update this queue. First it will process any items awaiting destruction, and remove them.
             * 
             * Then it will check to see if there are any items pending insertion, and move them to an
             * active state. Finally, it will return a list of active items for further processing.
             */
            update(): T[];

            /**
             * Returns the current list of active items.
             * 
             * This method returns a reference to the active list array, not a copy of it.
             * Therefore, be careful to not modify this array outside of the ProcessQueue.
             */
            getActive(): T[];

            /**
             * The number of entries in the active list.
             */
            readonly length: number;

            /**
             * Immediately destroys this process queue, clearing all of its internal arrays and resetting the process totals.
             */
            destroy(): void;

        }

        /**
         * RBush is a high-performance JavaScript library for 2D spatial indexing of points and rectangles.
         * It's based on an optimized R-tree data structure with bulk insertion support.
         * 
         * Spatial index is a special data structure for points and rectangles that allows you to perform queries like
         * "all items within this bounding box" very efficiently (e.g. hundreds of times faster than looping over all items).
         * 
         * This version of RBush uses a fixed min/max accessor structure of `[ '.left', '.top', '.right', '.bottom' ]`.
         * This is to avoid the eval like function creation that the original library used, which caused CSP policy violations.
         * 
         * rbush is forked from https://github.com/mourner/rbush by Vladimir Agafonkin
         */
        class RTree {
        }

        /**
         * A Set is a collection of unique elements.
         */
        class Set<T> {
            /**
             * 
             * @param elements An optional array of elements to insert into this Set.
             */
            constructor(elements?: T[]);

            /**
             * The entries of this Set. Stored internally as an array.
             */
            entries: T[];

            /**
             * Inserts the provided value into this Set. If the value is already contained in this Set this method will have no effect.
             * @param value The value to insert into this Set.
             */
            set(value: T): Phaser.Structs.Set<T>;

            /**
             * Get an element of this Set which has a property of the specified name, if that property is equal to the specified value.
             * If no elements of this Set satisfy the condition then this method will return `null`.
             * @param property The property name to check on the elements of this Set.
             * @param value The value to check for.
             */
            get(property: string, value: T): T;

            /**
             * Returns an array containing all the values in this Set.
             */
            getArray(): T[];

            /**
             * Removes the given value from this Set if this Set contains that value.
             * @param value The value to remove from the Set.
             */
            delete(value: T): Phaser.Structs.Set<T>;

            /**
             * Dumps the contents of this Set to the console via `console.group`.
             */
            dump(): void;

            /**
             * Passes each value in this Set to the given callback.
             * Use this function when you know this Set will be modified during the iteration, otherwise use `iterate`.
             * @param callback The callback to be invoked and passed each value this Set contains.
             * @param callbackScope The scope of the callback.
             */
            each(callback: EachSetCallback<T>, callbackScope?: any): Phaser.Structs.Set<T>;

            /**
             * Passes each value in this Set to the given callback.
             * 
             * For when you absolutely know this Set won't be modified during the iteration.
             * 
             * The callback must return a boolean. If it returns `false` then it will abort
             * the Set iteration immediately. If it returns `true`, it will carry on
             * iterating the next child in the Set.
             * @param callback The callback to be invoked and passed each value this Set contains.
             * @param callbackScope The scope of the callback.
             */
            iterate(callback: EachSetCallback<T>, callbackScope?: any): Phaser.Structs.Set<T>;

            /**
             * Goes through each entry in this Set and invokes the given function on them, passing in the arguments.
             * @param callbackKey The key of the function to be invoked on each Set entry.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            iterateLocal(callbackKey: string, ...args: any[]): Phaser.Structs.Set<T>;

            /**
             * Clears this Set so that it no longer contains any values.
             */
            clear(): Phaser.Structs.Set<T>;

            /**
             * Returns `true` if this Set contains the given value, otherwise returns `false`.
             * @param value The value to check for in this Set.
             */
            contains(value: T): boolean;

            /**
             * Returns a new Set containing all values that are either in this Set or in the Set provided as an argument.
             * @param set The Set to perform the union with.
             */
            union(set: Phaser.Structs.Set<T>): Phaser.Structs.Set<T>;

            /**
             * Returns a new Set that contains only the values which are in this Set and that are also in the given Set.
             * @param set The Set to intersect this set with.
             */
            intersect(set: Phaser.Structs.Set<T>): Phaser.Structs.Set<T>;

            /**
             * Returns a new Set containing all the values in this Set which are *not* also in the given Set.
             * @param set The Set to perform the difference with.
             */
            difference(set: Phaser.Structs.Set<T>): Phaser.Structs.Set<T>;

            /**
             * The size of this Set. This is the number of entries within it.
             * Changing the size will truncate the Set if the given value is smaller than the current size.
             * Increasing the size larger than the current size has no effect.
             */
            size: number;

        }

        /**
         * The Size component allows you to set `width` and `height` properties and define the relationship between them.
         * 
         * The component can automatically maintain the aspect ratios between the two values, and clamp them
         * to a defined min-max range. You can also control the dominant axis. When dimensions are given to the Size component
         * that would cause it to exceed its min-max range, the dimensions are adjusted based on the dominant axis.
         */
        class Size {
            /**
             * 
             * @param width The width of the Size component. Default 0.
             * @param height The height of the Size component. If not given, it will use the `width`. Default width.
             * @param aspectMode The aspect mode of the Size component. Defaults to 0, no mode. Default 0.
             * @param parent The parent of this Size component. Can be any object with public `width` and `height` properties. Dimensions are clamped to keep them within the parent bounds where possible. Default null.
             */
            constructor(width?: number, height?: number, aspectMode?: number, parent?: any);

            /**
             * The aspect mode this Size component will use when calculating its dimensions.
             * This property is read-only. To change it use the `setAspectMode` method.
             */
            readonly aspectMode: number;

            /**
             * The proportional relationship between the width and height.
             * 
             * This property is read-only and is updated automatically when either the `width` or `height` properties are changed,
             * depending on the aspect mode.
             */
            readonly aspectRatio: number;

            /**
             * The minimum allowed width.
             * Cannot be less than zero.
             * This value is read-only. To change it see the `setMin` method.
             */
            readonly minWidth: number;

            /**
             * The minimum allowed height.
             * Cannot be less than zero.
             * This value is read-only. To change it see the `setMin` method.
             */
            readonly minHeight: number;

            /**
             * The maximum allowed width.
             * This value is read-only. To change it see the `setMax` method.
             */
            readonly maxWidth: number;

            /**
             * The maximum allowed height.
             * This value is read-only. To change it see the `setMax` method.
             */
            readonly maxHeight: number;

            /**
             * A Vector2 containing the horizontal and vertical snap values, which the width and height are snapped to during resizing.
             * 
             * By default this is disabled.
             * 
             * This property is read-only. To change it see the `setSnap` method.
             */
            readonly snapTo: Phaser.Math.Vector2;

            /**
             * Sets the aspect mode of this Size component.
             * 
             * The aspect mode controls what happens when you modify the `width` or `height` properties, or call `setSize`.
             * 
             * It can be a number from 0 to 4, or a Size constant:
             * 
             * 0. NONE = Do not make the size fit the aspect ratio. Change the ratio when the size changes.
             * 1. WIDTH_CONTROLS_HEIGHT = The height is automatically adjusted based on the width.
             * 2. HEIGHT_CONTROLS_WIDTH = The width is automatically adjusted based on the height.
             * 3. FIT = The width and height are automatically adjusted to fit inside the given target area, while keeping the aspect ratio. Depending on the aspect ratio there may be some space inside the area which is not covered.
             * 4. ENVELOP = The width and height are automatically adjusted to make the size cover the entire target area while keeping the aspect ratio. This may extend further out than the target size.
             * 
             * Calling this method automatically recalculates the `width` and the `height`, if required.
             * @param value The aspect mode value. Default 0.
             */
            setAspectMode(value?: number): this;

            /**
             * By setting a Snap To value when this Size component is modified its dimensions will automatically
             * by snapped to the nearest grid slice, using floor. For example, if you have snap value of 16,
             * and the width changes to 68, then it will snap down to 64 (the closest multiple of 16 when floored)
             * 
             * Note that snapping takes place before adjustments by the parent, or the min / max settings. If these
             * values are not multiples of the given snap values, then this can result in un-snapped dimensions.
             * 
             * Call this method with no arguments to reset the snap values.
             * 
             * Calling this method automatically recalculates the `width` and the `height`, if required.
             * @param snapWidth The amount to snap the width to. If you don't want to snap the width, pass a value of zero. Default 0.
             * @param snapHeight The amount to snap the height to. If not provided it will use the `snapWidth` value. If you don't want to snap the height, pass a value of zero. Default snapWidth.
             */
            setSnap(snapWidth?: number, snapHeight?: number): this;

            /**
             * Sets, or clears, the parent of this Size component.
             * 
             * To clear the parent call this method with no arguments.
             * 
             * The parent influences the maximum extents to which this Size component can expand,
             * based on the aspect mode:
             * 
             * NONE - The parent clamps both the width and height.
             * WIDTH_CONTROLS_HEIGHT - The parent clamps just the width.
             * HEIGHT_CONTROLS_WIDTH - The parent clamps just the height.
             * FIT - The parent clamps whichever axis is required to ensure the size fits within it.
             * ENVELOP - The parent is used to ensure the size fully envelops the parent.
             * 
             * Calling this method automatically calls `setSize`.
             * @param parent Sets the parent of this Size component. Don't provide a value to clear an existing parent.
             */
            setParent(parent?: any): this;

            /**
             * Set the minimum width and height values this Size component will allow.
             * 
             * The minimum values can never be below zero, or greater than the maximum values.
             * 
             * Setting this will automatically adjust both the `width` and `height` properties to ensure they are within range.
             * 
             * Note that based on the aspect mode, and if this Size component has a parent set or not, the minimums set here
             * _can_ be exceed in some situations.
             * @param width The minimum allowed width of the Size component. Default 0.
             * @param height The minimum allowed height of the Size component. If not given, it will use the `width`. Default width.
             */
            setMin(width?: number, height?: number): this;

            /**
             * Set the maximum width and height values this Size component will allow.
             * 
             * Setting this will automatically adjust both the `width` and `height` properties to ensure they are within range.
             * 
             * Note that based on the aspect mode, and if this Size component has a parent set or not, the maximums set here
             * _can_ be exceed in some situations.
             * @param width The maximum allowed width of the Size component. Default Number.MAX_VALUE.
             * @param height The maximum allowed height of the Size component. If not given, it will use the `width`. Default width.
             */
            setMax(width?: number, height?: number): this;

            /**
             * Sets the width and height of this Size component based on the aspect mode.
             * 
             * If the aspect mode is 'none' then calling this method will change the aspect ratio, otherwise the current
             * aspect ratio is honored across all other modes.
             * 
             * If snapTo values have been set then the given width and height are snapped first, prior to any further
             * adjustment via min/max values, or a parent.
             * 
             * If minimum and/or maximum dimensions have been specified, the values given to this method will be clamped into
             * that range prior to adjustment, but may still exceed them depending on the aspect mode.
             * 
             * If this Size component has a parent set, and the aspect mode is `fit` or `envelop`, then the given sizes will
             * be clamped to the range specified by the parent.
             * @param width The new width of the Size component. Default 0.
             * @param height The new height of the Size component. If not given, it will use the `width`. Default width.
             */
            setSize(width?: number, height?: number): this;

            /**
             * Sets a new aspect ratio, overriding what was there previously.
             * 
             * It then calls `setSize` immediately using the current dimensions.
             * @param ratio The new aspect ratio.
             */
            setAspectRatio(ratio: number): this;

            /**
             * Sets a new width and height for this Size component and updates the aspect ratio based on them.
             * 
             * It _doesn't_ change the `aspectMode` and still factors in size limits such as the min max and parent bounds.
             * @param width The new width of the Size component.
             * @param height The new height of the Size component. If not given, it will use the `width`. Default width.
             */
            resize(width: number, height?: number): this;

            /**
             * Takes a new width and passes it through the min/max clamp and then checks it doesn't exceed the parent width.
             * @param value The value to clamp and check.
             * @param checkParent Check the given value against the parent, if set. Default true.
             */
            getNewWidth(value: number, checkParent?: boolean): number;

            /**
             * Takes a new height and passes it through the min/max clamp and then checks it doesn't exceed the parent height.
             * @param value The value to clamp and check.
             * @param checkParent Check the given value against the parent, if set. Default true.
             */
            getNewHeight(value: number, checkParent?: boolean): number;

            /**
             * The current `width` and `height` are adjusted to fit inside the given dimensions, while keeping the aspect ratio.
             * 
             * If `fit` is true there may be some space inside the target area which is not covered if its aspect ratio differs.
             * If `fit` is false the size may extend further out than the target area if the aspect ratios differ.
             * 
             * If this Size component has a parent set, then the width and height passed to this method will be clamped so
             * it cannot exceed that of the parent.
             * @param width The new width of the Size component. Default 0.
             * @param height The new height of the Size component. If not given, it will use the width value.
             * @param fit Perform a `fit` (true) constraint, or an `envelop` (false) constraint. Default true.
             */
            constrain(width?: number, height?: number, fit?: boolean): this;

            /**
             * The current `width` and `height` are adjusted to fit inside the given dimensions, while keeping the aspect ratio.
             * 
             * There may be some space inside the target area which is not covered if its aspect ratio differs.
             * 
             * If this Size component has a parent set, then the width and height passed to this method will be clamped so
             * it cannot exceed that of the parent.
             * @param width The new width of the Size component. Default 0.
             * @param height The new height of the Size component. If not given, it will use the width value.
             */
            fitTo(width?: number, height?: number): this;

            /**
             * The current `width` and `height` are adjusted so that they fully envelope the given dimensions, while keeping the aspect ratio.
             * 
             * The size may extend further out than the target area if the aspect ratios differ.
             * 
             * If this Size component has a parent set, then the values are clamped so that it never exceeds the parent
             * on the longest axis.
             * @param width The new width of the Size component. Default 0.
             * @param height The new height of the Size component. If not given, it will use the width value.
             */
            envelop(width?: number, height?: number): this;

            /**
             * Sets the width of this Size component.
             * 
             * Depending on the aspect mode, changing the width may also update the height and aspect ratio.
             * @param width The new width of the Size component.
             */
            setWidth(width: number): this;

            /**
             * Sets the height of this Size component.
             * 
             * Depending on the aspect mode, changing the height may also update the width and aspect ratio.
             * @param height The new height of the Size component.
             */
            setHeight(height: number): this;

            /**
             * Returns a string representation of this Size component.
             */
            toString(): string;

            /**
             * Sets the values of this Size component to the `element.style.width` and `height`
             * properties of the given DOM Element. The properties are set as `px` values.
             * @param element The DOM Element to set the CSS style on.
             */
            setCSS(element: HTMLElement): void;

            /**
             * Copies the aspect mode, aspect ratio, width and height from this Size component
             * to the given Size component. Note that the parent, if set, is not copied across.
             * @param destination The Size component to copy the values to.
             */
            copy(destination: Phaser.Structs.Size): Phaser.Structs.Size;

            /**
             * Destroys this Size component.
             * 
             * This clears the local properties and any parent object, if set.
             * 
             * A destroyed Size component cannot be re-used.
             */
            destroy(): void;

            /**
             * The width of this Size component.
             * 
             * This value is clamped to the range specified by `minWidth` and `maxWidth`, if enabled.
             * 
             * A width can never be less than zero.
             * 
             * Changing this value will automatically update the `height` if the aspect ratio lock is enabled.
             * You can also use the `setWidth` and `getWidth` methods.
             */
            width: number;

            /**
             * The height of this Size component.
             * 
             * This value is clamped to the range specified by `minHeight` and `maxHeight`, if enabled.
             * 
             * A height can never be less than zero.
             * 
             * Changing this value will automatically update the `width` if the aspect ratio lock is enabled.
             * You can also use the `setHeight` and `getHeight` methods.
             */
            height: number;

            /**
             * Do not make the size fit the aspect ratio. Change the ratio when the size changes.
             */
            static readonly NONE: number;

            /**
             * The height is automatically adjusted based on the width.
             */
            static readonly WIDTH_CONTROLS_HEIGHT: number;

            /**
             * The width is automatically adjusted based on the height.
             */
            static readonly HEIGHT_CONTROLS_WIDTH: number;

            /**
             * The width and height are automatically adjusted to fit inside the given target area, while keeping the aspect ratio. Depending on the aspect ratio there may be some space inside the area which is not covered.
             */
            static readonly FIT: number;

            /**
             * The width and height are automatically adjusted to make the size cover the entire target area while keeping the aspect ratio. This may extend further out than the target size.
             */
            static readonly ENVELOP: number;

        }

    }

    namespace Textures {
        /**
         * A Canvas Texture is a special kind of Texture that is backed by an HTML Canvas Element as its source.
         * 
         * You can use the properties of this texture to draw to the canvas element directly, using all of the standard
         * canvas operations available in the browser. Any Game Object can be given this texture and will render with it.
         * 
         * Note: When running under WebGL the Canvas Texture needs to re-generate its base WebGLTexture and reupload it to
         * the GPU every time you modify it, otherwise the changes you make to this texture will not be visible. To do this
         * you should call `CanvasTexture.refresh()` once you are finished with your changes to the canvas. Try and keep
         * this to a minimum, especially on large canvas sizes, or you may inadvertently thrash the GPU by constantly uploading
         * texture data to it. This restriction does not apply if using the Canvas Renderer.
         * 
         * It starts with only one frame that covers the whole of the canvas. You can add further frames, that specify
         * sections of the canvas using the `add` method.
         * 
         * Should you need to resize the canvas use the `setSize` method so that it accurately updates all of the underlying
         * texture data as well. Forgetting to do this (i.e. by changing the canvas size directly from your code) could cause
         * graphical errors.
         */
        class CanvasTexture extends Phaser.Textures.Texture {
            /**
             * 
             * @param manager A reference to the Texture Manager this Texture belongs to.
             * @param key The unique string-based key of this Texture.
             * @param source The canvas element that is used as the base of this texture.
             * @param width The width of the canvas.
             * @param height The height of the canvas.
             */
            constructor(manager: Phaser.Textures.TextureManager, key: string, source: HTMLCanvasElement, width: number, height: number);

            /**
             * The source Canvas Element.
             */
            readonly canvas: HTMLCanvasElement;

            /**
             * The 2D Canvas Rendering Context.
             */
            readonly context: CanvasRenderingContext2D;

            /**
             * The width of the Canvas.
             * This property is read-only, if you wish to change it use the `setSize` method.
             */
            readonly width: number;

            /**
             * The height of the Canvas.
             * This property is read-only, if you wish to change it use the `setSize` method.
             */
            readonly height: number;

            /**
             * The context image data.
             * Use the `update` method to populate this when the canvas changes.
             */
            imageData: ImageData;

            /**
             * A Uint8ClampedArray view into the `buffer`.
             * Use the `update` method to populate this when the canvas changes.
             * Note that this is unavailable in some browsers, such as Epic Browser, due to their security restrictions.
             */
            data: Uint8ClampedArray;

            /**
             * An Uint32Array view into the `buffer`.
             */
            pixels: Uint32Array;

            /**
             * An ArrayBuffer the same size as the context ImageData.
             */
            buffer: ArrayBuffer;

            /**
             * This re-creates the `imageData` from the current context.
             * It then re-builds the ArrayBuffer, the `data` Uint8ClampedArray reference and the `pixels` Int32Array.
             * 
             * Warning: This is a very expensive operation, so use it sparingly.
             */
            update(): Phaser.Textures.CanvasTexture;

            /**
             * Draws the given Image or Canvas element to this CanvasTexture, then updates the internal
             * ImageData buffer and arrays.
             * @param x The x coordinate to draw the source at.
             * @param y The y coordinate to draw the source at.
             * @param source The element to draw to this canvas.
             * @param update Update the internal ImageData buffer and arrays. Default true.
             */
            draw(x: number, y: number, source: HTMLImageElement | HTMLCanvasElement, update?: boolean): Phaser.Textures.CanvasTexture;

            /**
             * Draws the given texture frame to this CanvasTexture, then updates the internal
             * ImageData buffer and arrays.
             * @param key The unique string-based key of the Texture.
             * @param frame The string-based name, or integer based index, of the Frame to get from the Texture.
             * @param x The x coordinate to draw the source at. Default 0.
             * @param y The y coordinate to draw the source at. Default 0.
             * @param update Update the internal ImageData buffer and arrays. Default true.
             */
            drawFrame(key: string, frame?: string | number, x?: number, y?: number, update?: boolean): Phaser.Textures.CanvasTexture;

            /**
             * Sets a pixel in the CanvasTexture to the given color and alpha values.
             * 
             * This is an expensive operation to run in large quantities, so use sparingly.
             * @param x The x coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param y The y coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param red The red color value. A number between 0 and 255.
             * @param green The green color value. A number between 0 and 255.
             * @param blue The blue color value. A number between 0 and 255.
             * @param alpha The alpha value. A number between 0 and 255. Default 255.
             */
            setPixel(x: number, y: number, red: number, green: number, blue: number, alpha?: number): this;

            /**
             * Puts the ImageData into the context of this CanvasTexture at the given coordinates.
             * @param imageData The ImageData to put at the given location.
             * @param x The x coordinate to put the imageData. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param y The y coordinate to put the imageData. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param dirtyX Horizontal position (x coordinate) of the top-left corner from which the image data will be extracted. Default 0.
             * @param dirtyY Vertical position (x coordinate) of the top-left corner from which the image data will be extracted. Default 0.
             * @param dirtyWidth Width of the rectangle to be painted. Defaults to the width of the image data.
             * @param dirtyHeight Height of the rectangle to be painted. Defaults to the height of the image data.
             */
            putData(imageData: ImageData, x: number, y: number, dirtyX?: number, dirtyY?: number, dirtyWidth?: number, dirtyHeight?: number): this;

            /**
             * Gets an ImageData region from this CanvasTexture from the position and size specified.
             * You can write this back using `CanvasTexture.putData`, or manipulate it.
             * @param x The x coordinate of the top-left of the area to get the ImageData from. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param y The y coordinate of the top-left of the area to get the ImageData from. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param width The width of the rectangle from which the ImageData will be extracted. Positive values are to the right, and negative to the left.
             * @param height The height of the rectangle from which the ImageData will be extracted. Positive values are down, and negative are up.
             */
            getData(x: number, y: number, width: number, height: number): ImageData;

            /**
             * Get the color of a specific pixel from this texture and store it in a Color object.
             * 
             * If you have drawn anything to this CanvasTexture since it was created you must call `CanvasTexture.update` to refresh the array buffer,
             * otherwise this may return out of date color values, or worse - throw a run-time error as it tries to access an array element that doesn't exist.
             * @param x The x coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param y The y coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param out A Color object to store the pixel values in. If not provided a new Color object will be created.
             */
            getPixel(x: number, y: number, out?: Phaser.Display.Color): Phaser.Display.Color;

            /**
             * Returns an array containing all of the pixels in the given region.
             * 
             * If the requested region extends outside the bounds of this CanvasTexture,
             * the region is truncated to fit.
             * 
             * If you have drawn anything to this CanvasTexture since it was created you must call `CanvasTexture.update` to refresh the array buffer,
             * otherwise this may return out of date color values, or worse - throw a run-time error as it tries to access an array element that doesn't exist.
             * @param x The x coordinate of the top-left of the region. Must lay within the dimensions of this CanvasTexture and be an integer. Default 0.
             * @param y The y coordinate of the top-left of the region. Must lay within the dimensions of this CanvasTexture and be an integer. Default 0.
             * @param width The width of the region to get. Must be an integer. Defaults to the canvas width if not given.
             * @param height The height of the region to get. Must be an integer. If not given will be set to the `width`.
             */
            getPixels(x?: number, y?: number, width?: number, height?: number): Phaser.Types.Textures.PixelConfig[][];

            /**
             * Returns the Image Data index for the given pixel in this CanvasTexture.
             * 
             * The index can be used to read directly from the `this.data` array.
             * 
             * The index points to the red value in the array. The subsequent 3 indexes
             * point to green, blue and alpha respectively.
             * @param x The x coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             * @param y The y coordinate of the pixel to get. Must lay within the dimensions of this CanvasTexture and be an integer.
             */
            getIndex(x: number, y: number): number;

            /**
             * This should be called manually if you are running under WebGL.
             * It will refresh the WebGLTexture from the Canvas source. Only call this if you know that the
             * canvas has changed, as there is a significant GPU texture allocation cost involved in doing so.
             */
            refresh(): Phaser.Textures.CanvasTexture;

            /**
             * Gets the Canvas Element.
             */
            getCanvas(): HTMLCanvasElement;

            /**
             * Gets the 2D Canvas Rendering Context.
             */
            getContext(): CanvasRenderingContext2D;

            /**
             * Clears the given region of this Canvas Texture, resetting it back to transparent.
             * If no region is given, the whole Canvas Texture is cleared.
             * @param x The x coordinate of the top-left of the region to clear. Default 0.
             * @param y The y coordinate of the top-left of the region to clear. Default 0.
             * @param width The width of the region.
             * @param height The height of the region.
             * @param update Update the internal ImageData buffer and arrays. Default true.
             */
            clear(x?: number, y?: number, width?: number, height?: number, update?: boolean): Phaser.Textures.CanvasTexture;

            /**
             * Changes the size of this Canvas Texture.
             * @param width The new width of the Canvas.
             * @param height The new height of the Canvas. If not given it will use the width as the height.
             */
            setSize(width: number, height?: number): Phaser.Textures.CanvasTexture;

            /**
             * Destroys this Texture and releases references to its sources and frames.
             */
            destroy(): void;

        }

        /**
         * Filter Types.
         */
        enum FilterMode {
            /**
             * Linear filter type.
             */
            LINEAR,
            /**
             * Nearest neighbor filter type.
             */
            NEAREST,
        }

        /**
         * A Dynamic Texture is a special texture that allows you to draw textures, frames and most kind of
         * Game Objects directly to it.
         * 
         * You can take many complex objects and draw them to this one texture, which can then be used as the
         * base texture for other Game Objects, such as Sprites. Should you then update this texture, all
         * Game Objects using it will instantly be updated as well, reflecting the changes immediately.
         * 
         * It's a powerful way to generate dynamic textures at run-time that are WebGL friendly and don't invoke
         * expensive GPU uploads on each change.
         * 
         * ```js
         * const t = this.textures.addDynamicTexture('player', 64, 128);
         * // draw objects to t
         * this.add.sprite(x, y, 'player');
         * ```
         * 
         * Because this is a standard Texture within Phaser, you can add frames to it, meaning you can use it
         * to generate sprite sheets, texture atlases or tile sets.
         * 
         * Under WebGL1, a FrameBuffer, which is what this Dynamic Texture uses internally, cannot be anti-aliased.
         * This means that when drawing objects such as Shapes or Graphics instances to this texture, they may appear
         * to be drawn with no aliasing around the edges. This is a technical limitation of WebGL1. To get around it,
         * create your shape as a texture in an art package, then draw that to this texture.
         * 
         * Based on the assumption that you will be using this Dynamic Texture as a source for Sprites, it will
         * automatically invert any drawing done to it on the y axis. If you do not require this, please call the
         * `setIsSpriteTexture()` method and pass it `false` as its parameter. Do this before you start drawing
         * to this texture, otherwise you will get vertically inverted frames under WebGL. This isn't required
         * for Canvas.
         */
        class DynamicTexture extends Phaser.Textures.Texture {
            /**
             * 
             * @param manager A reference to the Texture Manager this Texture belongs to.
             * @param key The unique string-based key of this Texture.
             * @param width The width of this Dymamic Texture in pixels. Defaults to 256 x 256. Default 256.
             * @param height The height of this Dymamic Texture in pixels. Defaults to 256 x 256. Default 256.
             */
            constructor(manager: Phaser.Textures.TextureManager, key: string, width?: number, height?: number);

            /**
             * The internal data type of this object.
             */
            readonly type: string;

            /**
             * A reference to either the Canvas or WebGL Renderer that the Game instance is using.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The width of this Dynamic Texture.
             * 
             * Treat this property as read-only. Use the `setSize` method to change the size.
             */
            width: number;

            /**
             * The height of this Dynamic Texture.
             * 
             * Treat this property as read-only. Use the `setSize` method to change the size.
             */
            height: number;

            /**
             * This flag is set to 'true' during `beginDraw` and reset to 'false` in `endDraw`,
             * allowing you to determine if this Dynamic Texture is batch drawing, or not.
             */
            readonly isDrawing: boolean;

            /**
             * A reference to the Rendering Context belonging to the Canvas Element this Dynamic Texture is drawing to.
             */
            canvas: HTMLCanvasElement;

            /**
             * The 2D Canvas Rendering Context.
             */
            readonly context: CanvasRenderingContext2D;

            /**
             * Is this Dynamic Texture dirty or not? If not it won't spend time clearing or filling itself.
             */
            dirty: boolean;

            /**
             * Is this Dynamic Texture being used as the base texture for a Sprite Game Object?
             * 
             * This is enabled by default, as we expect that will be the core use for Dynamic Textures.
             * 
             * However, to disable it, call `RenderTexture.setIsSpriteTexture(false)`.
             * 
             * You should do this _before_ drawing to this texture, so that it correctly
             * inverses the frames for WebGL rendering. Not doing so will result in vertically flipped frames.
             * 
             * This property is used in the `endDraw` method.
             */
            isSpriteTexture: boolean;

            /**
             * An internal Camera that can be used to move around this Dynamic Texture.
             * 
             * Control it just like you would any Scene Camera. The difference is that it only impacts
             * the placement of **Game Objects** (not textures) that you then draw to this texture.
             * 
             * You can scroll, zoom and rotate this Camera.
             */
            camera: Phaser.Cameras.Scene2D.BaseCamera;

            /**
             * The Render Target that belongs to this Dynamic Texture.
             * 
             * A Render Target encapsulates a framebuffer and texture for the WebGL Renderer.
             * 
             * This property remains `null` under Canvas.
             */
            renderTarget: Phaser.Renderer.WebGL.RenderTarget;

            /**
             * A reference to the WebGL Single Pipeline.
             * 
             * This property remains `null` under Canvas.
             */
            pipeline: Phaser.Renderer.WebGL.Pipelines.SinglePipeline;

            /**
             * Resizes this Dynamic Texture to the new dimensions given.
             * 
             * In WebGL it will destroy and then re-create the frame buffer being used by this Dynamic Texture.
             * In Canvas it will resize the underlying canvas DOM element.
             * 
             * Both approaches will erase everything currently drawn to this texture.
             * 
             * If the dimensions given are the same as those already being used, calling this method will do nothing.
             * @param width The new width of this Dynamic Texture.
             * @param height The new height of this Dynamic Texture. If not specified, will be set the same as the `width`. Default width.
             */
            setSize(width: number, height?: number): this;

            /**
             * Links the WebGL Textures used by this Dynamic Texture to its Render Target.
             * 
             * This method is called internally by the Dynamic Texture when it is first created,
             * or if you change its size.
             */
            setFromRenderTarget(): this;

            /**
             * If you are planning on using this Render Texture as a base texture for Sprite
             * Game Objects, then you should call this method with a value of `true` before
             * drawing anything to it, otherwise you will get inverted frames in WebGL.
             * @param value Is this Render Target being used as a Sprite Texture, or not?
             */
            setIsSpriteTexture(value: boolean): this;

            /**
             * Fills this Dynamic Texture with the given color.
             * 
             * By default it will fill the entire texture, however you can set it to fill a specific
             * rectangular area by using the x, y, width and height arguments.
             * 
             * The color should be given in hex format, i.e. 0xff0000 for red, 0x00ff00 for green, etc.
             * @param rgb The color to fill this Dynamic Texture with, such as 0xff0000 for red.
             * @param alpha The alpha value used by the fill. Default 1.
             * @param x The left coordinate of the fill rectangle. Default 0.
             * @param y The top coordinate of the fill rectangle. Default 0.
             * @param width The width of the fill rectangle. Default this.width.
             * @param height The height of the fill rectangle. Default this.height.
             */
            fill(rgb: number, alpha?: number, x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Fully clears this Dynamic Texture, erasing everything from it and resetting it back to
             * a blank, transparent, texture.
             */
            clear(): this;

            /**
             * Takes the given texture key and frame and then stamps it at the given
             * x and y coordinates. You can use the optional 'config' argument to provide
             * lots more options about how the stamp is applied, including the alpha,
             * tint, angle, scale and origin.
             * 
             * By default, the frame will stamp on the x/y coordinates based on its center.
             * 
             * If you wish to stamp from the top-left, set the config `originX` and
             * `originY` properties both to zero.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param config The stamp configuration object, allowing you to set the alpha, tint, angle, scale and origin of the stamp.
             */
            stamp(key: string, frame?: string | number, x?: number, y?: number, config?: Phaser.Types.Textures.StampConfig): this;

            /**
             * Draws the given object, or an array of objects, to this Dynamic Texture using a blend mode of ERASE.
             * This has the effect of erasing any filled pixels present in the objects from this texture.
             * 
             * It can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture, or a Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up the texture from the Texture Manager.
             * 
             * Note: You cannot erase a Dynamic Texture from itself.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * Calling this method causes the WebGL batch to flush, so it can write the texture
             * data to the framebuffer being used internally. The batch is flushed at the end,
             * after the entries have been iterated. So if you've a bunch of objects to draw,
             * try and pass them in an array in one single call, rather than making lots of
             * separate calls.
             * 
             * If you are not planning on using this Dynamic Texture as a base texture for Sprite
             * Game Objects, then you should set `DynamicTexture.isSpriteTexture = false` before
             * calling this method, otherwise you will get vertically inverted frames in WebGL.
             * @param entries Any renderable Game Object, or Group, Container, Display List, Render Texture, Texture Frame, or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             */
            erase(entries: any, x?: number, y?: number): this;

            /**
             * Draws the given object, or an array of objects, to this Dynamic Texture.
             * 
             * It can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture, or a Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up the texture from the Texture Manager.
             * 
             * Note 1: You cannot draw a Dynamic Texture to itself.
             * 
             * Note 2: For Game Objects that have Post FX Pipelines, the pipeline _cannot_ be
             * used when drawn to this texture.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame. If you need to specify
             * exactly which frame to draw then use the method `drawFrame` instead.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * The `alpha` and `tint` values are only used by Texture Frames.
             * Game Objects use their own alpha and tint values when being drawn.
             * 
             * Calling this method causes the WebGL batch to flush, so it can write the texture
             * data to the framebuffer being used internally. The batch is flushed at the end,
             * after the entries have been iterated. So if you've a bunch of objects to draw,
             * try and pass them in an array in one single call, rather than making lots of
             * separate calls.
             * 
             * If you are not planning on using this Dynamic Texture as a base texture for Sprite
             * Game Objects, then you should set `DynamicTexture.isSpriteTexture = false` before
             * calling this method, otherwise you will get vertically inverted frames in WebGL.
             * @param entries Any renderable Game Object, or Group, Container, Display List, other Render Texture, Texture Frame or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            draw(entries: any, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Draws the Texture Frame to the Render Texture at the given position.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * ```javascript
             * var rt = this.add.renderTexture(0, 0, 800, 600);
             * rt.drawFrame(key, frame);
             * ```
             * 
             * You can optionally provide a position, alpha and tint value to apply to the frame
             * before it is drawn.
             * 
             * Calling this method will cause a batch flush, so if you've got a stack of things to draw
             * in a tight loop, try using the `draw` method instead.
             * 
             * If you need to draw a Sprite to this Render Texture, use the `draw` method instead.
             * 
             * If you are not planning on using this Dynamic Texture as a base texture for Sprite
             * Game Objects, then you should set `DynamicTexture.isSpriteTexture = false` before
             * calling this method, otherwise you will get vertically inverted frames in WebGL.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. WebGL only. Default 0xffffff.
             */
            drawFrame(key: string, frame?: string | number, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Takes the given Texture Frame and draws it to this Dynamic Texture as a fill pattern,
             * i.e. in a grid-layout based on the frame dimensions.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * You can optionally provide a position, width, height, alpha and tint value to apply to
             * the frames before they are drawn. The position controls the top-left where the repeating
             * fill will start from. The width and height control the size of the filled area.
             * 
             * The position can be negative if required, but the dimensions cannot.
             * 
             * Calling this method will cause a batch flush by default. Use the `skipBatch` argument
             * to disable this if this call is part of a larger batch draw.
             * 
             * If you are not planning on using this Dynamic Texture as a base texture for Sprite
             * Game Objects, then you should set `DynamicTexture.isSpriteTexture = false` before
             * calling this method, otherwise you will get vertically inverted frames in WebGL.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture. Set to `null` to skip this argument if not required.
             * @param x The x position to start drawing the frames from (can be negative to offset). Default 0.
             * @param y The y position to start drawing the frames from (can be negative to offset). Default 0.
             * @param width The width of the area to repeat the frame within. Defaults to the width of this Dynamic Texture. Default this.width.
             * @param height The height of the area to repeat the frame within. Defaults to the height of this Dynamic Texture. Default this.height.
             * @param alpha The alpha to use. Defaults to 1, no alpha. Default 1.
             * @param tint WebGL only. The tint color to use. Leave as undefined, or 0xffffff to have no tint. Default 0xffffff.
             * @param skipBatch Skip beginning and ending a batch with this call. Use if this is part of a bigger batched draw. Default false.
             */
            repeat(key: string, frame?: string | number, x?: number, y?: number, width?: number, height?: number, alpha?: number, tint?: number, skipBatch?: boolean): this;

            /**
             * Use this method if you need to batch draw a large number of Game Objects to
             * this Dynamic Texture in a single pass, or on a frequent basis. This is especially
             * useful under WebGL, however, if your game is using Canvas only, it will not make
             * any speed difference in that situation.
             * 
             * This method starts the beginning of a batched draw, unless one is already open.
             * 
             * Batched drawing is faster than calling `draw` in loop, but you must be careful
             * to manage the flow of code and remember to call `endDraw()` when you're finished.
             * 
             * If you don't need to draw large numbers of objects it's much safer and easier
             * to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * DynamicTexture.beginDraw();
             * 
             * // repeat n times:
             * DynamicTexture.batchDraw();
             * // or
             * DynamicTexture.batchDrawFrame();
             * 
             * // Call once:
             * DynamicTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Dynamic Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `DynamicTexture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             */
            beginDraw(): this;

            /**
             * Use this method if you have already called `beginDraw` and need to batch
             * draw a large number of objects to this Dynamic Texture.
             * 
             * This method batches the drawing of the given objects to this texture,
             * without causing a WebGL bind or batch flush for each one.
             * 
             * It is faster than calling `draw`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()`. If you don't need to draw large
             * numbers of objects it's much safer and easier to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * DynamicTexture.beginDraw();
             * 
             * // repeat n times:
             * DynamicTexture.batchDraw();
             * // or
             * DynamicTexture.batchDrawFrame();
             * 
             * // Call once:
             * DynamicTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Dynamic Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `DynamicTexture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * 
             * This method can accept any of the following:
             * 
             * * Any renderable Game Object, such as a Sprite, Text, Graphics or TileSprite.
             * * Tilemap Layers.
             * * A Group. The contents of which will be iterated and drawn in turn.
             * * A Container. The contents of which will be iterated fully, and drawn in turn.
             * * A Scene's Display List. Pass in `Scene.children` to draw the whole list.
             * * Another Dynamic Texture or Render Texture.
             * * A Texture Frame instance.
             * * A string. This is used to look-up a texture from the Texture Manager.
             * 
             * Note: You cannot draw a Dynamic Texture to itself.
             * 
             * If passing in a Group or Container it will only draw children that return `true`
             * when their `willRender()` method is called. I.e. a Container with 10 children,
             * 5 of which have `visible=false` will only draw the 5 visible ones.
             * 
             * If passing in an array of Game Objects it will draw them all, regardless if
             * they pass a `willRender` check or not.
             * 
             * You can pass in a string in which case it will look for a texture in the Texture
             * Manager matching that string, and draw the base frame. If you need to specify
             * exactly which frame to draw then use the method `drawFrame` instead.
             * 
             * You can pass in the `x` and `y` coordinates to draw the objects at. The use of
             * the coordinates differ based on what objects are being drawn. If the object is
             * a Group, Container or Display List, the coordinates are _added_ to the positions
             * of the children. For all other types of object, the coordinates are exact.
             * 
             * The `alpha` and `tint` values are only used by Texture Frames.
             * Game Objects use their own alpha and tint values when being drawn.
             * @param entries Any renderable Game Object, or Group, Container, Display List, other Dynamic or Texture, Texture Frame or an array of any of these.
             * @param x The x position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param y The y position to draw the Frame at, or the offset applied to the object. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            batchDraw(entries: any, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Use this method if you have already called `beginDraw` and need to batch
             * draw a large number of texture frames to this Dynamic Texture.
             * 
             * This method batches the drawing of the given frames to this Dynamic Texture,
             * without causing a WebGL bind or batch flush for each one.
             * 
             * It is faster than calling `drawFrame`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()`. If you don't need to draw large
             * numbers of frames it's much safer and easier to use the `drawFrame` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * DynamicTexture.beginDraw();
             * 
             * // repeat n times:
             * DynamicTexture.batchDraw();
             * // or
             * DynamicTexture.batchDrawFrame();
             * 
             * // Call once:
             * DynamicTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Dynamic Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `DynamicTexture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * 
             * Textures are referenced by their string-based keys, as stored in the Texture Manager.
             * 
             * You can optionally provide a position, alpha and tint value to apply to the frame
             * before it is drawn.
             * @param key The key of the texture to be used, as stored in the Texture Manager.
             * @param frame The name or index of the frame within the Texture.
             * @param x The x position to draw the frame at. Default 0.
             * @param y The y position to draw the frame at. Default 0.
             * @param alpha The alpha value. Only used when drawing Texture Frames to this texture. Game Objects use their own alpha. Default 1.
             * @param tint The tint color value. Only used when drawing Texture Frames to this texture. Game Objects use their own tint. WebGL only. Default 0xffffff.
             */
            batchDrawFrame(key: string, frame?: string | number, x?: number, y?: number, alpha?: number, tint?: number): this;

            /**
             * Use this method to finish batch drawing to this Dynamic Texture.
             * 
             * Doing so will stop the WebGL Renderer from capturing draws and then blit the
             * framebuffer to the Render Target owned by this texture.
             * 
             * Calling this method without first calling `beginDraw` will have no effect.
             * 
             * Batch drawing is faster than calling `draw`, but you must be careful to manage the
             * flow of code and remember to call `endDraw()` when you're finished.
             * 
             * If you don't need to draw large numbers of objects it's much safer and easier
             * to use the `draw` method instead.
             * 
             * The flow should be:
             * 
             * ```javascript
             * // Call once:
             * DynamicTexture.beginDraw();
             * 
             * // repeat n times:
             * DynamicTexture.batchDraw();
             * // or
             * DynamicTexture.batchDrawFrame();
             * 
             * // Call once:
             * DynamicTexture.endDraw();
             * ```
             * 
             * Do not call any methods other than `batchDraw`, `batchDrawFrame`, or `endDraw` once you
             * have started a batch. Also, be very careful not to destroy this Dynamic Texture while the
             * batch is still open. Doing so will cause a run-time error in the WebGL Renderer.
             * 
             * You can use the `DynamicTexture.isDrawing` boolean property to tell if a batch is
             * currently open, or not.
             * @param erase Draws all objects in this batch using a blend mode of ERASE. This has the effect of erasing any filled pixels in the objects being drawn. Default false.
             */
            endDraw(erase?: boolean): this;

            /**
             * Takes a snapshot of the given area of this Dynamic Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture the whole Dynamic Texture see the `snapshot` method.
             * To capture just a specific pixel, see the `snapshotPixel` method.
             * 
             * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer
             * into an ArrayBufferView. It then parses this, copying the contents to a temporary Canvas and finally
             * creating an Image object from it, which is the image returned to the callback provided.
             * 
             * All in all, this is a computationally expensive and blocking process, which gets more expensive
             * the larger the resolution this Dynamic Texture has, so please be careful how you employ this in your game.
             * @param x The x coordinate to grab from.
             * @param y The y coordinate to grab from.
             * @param width The width of the area to grab.
             * @param height The height of the area to grab.
             * @param callback The Function to invoke after the snapshot image is created.
             * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
             * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
             */
            snapshotArea(x: number, y: number, width: number, height: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

            /**
             * Takes a snapshot of the whole of this Dynamic Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture a portion of this Dynamic Texture see the `snapshotArea` method.
             * To capture just a specific pixel, see the `snapshotPixel` method.
             * 
             * Snapshots work by using the WebGL `readPixels` feature to grab every pixel from the frame buffer
             * into an ArrayBufferView. It then parses this, copying the contents to a temporary Canvas and finally
             * creating an Image object from it, which is the image returned to the callback provided.
             * 
             * All in all, this is a computationally expensive and blocking process, which gets more expensive
             * the larger the resolution this Dynamic Texture has, so please be careful how you employ this in your game.
             * @param callback The Function to invoke after the snapshot image is created.
             * @param type The format of the image to create, usually `image/png` or `image/jpeg`. Default 'image/png'.
             * @param encoderOptions The image quality, between 0 and 1. Used for image formats with lossy compression, such as `image/jpeg`. Default 0.92.
             */
            snapshot(callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback, type?: string, encoderOptions?: number): this;

            /**
             * Takes a snapshot of the given pixel from this Dynamic Texture.
             * 
             * The snapshot is taken immediately, but the results are returned via the given callback.
             * 
             * To capture the whole Dynamic Texture see the `snapshot` method.
             * To capture a portion of this Dynamic Texture see the `snapshotArea` method.
             * 
             * Unlike the two other snapshot methods, this one will send your callback a `Color` object
             * containing the color data for the requested pixel. It doesn't need to create an internal
             * Canvas or Image object, so is a lot faster to execute, using less memory than the other snapshot methods.
             * @param x The x coordinate of the pixel to get.
             * @param y The y coordinate of the pixel to get.
             * @param callback The Function to invoke after the snapshot pixel data is extracted.
             */
            snapshotPixel(x: number, y: number, callback: Phaser.Types.Renderer.Snapshot.SnapshotCallback): this;

            /**
             * Returns the underlying WebGLTexture, if not running in Canvas mode.
             */
            getWebGLTexture(): WebGLTexture | null;

            /**
             * Renders this Dynamic Texture onto the Stamp Game Object as a BitmapMask.
             * @param renderer A reference to the current active WebGL renderer.
             * @param src The Game Object being rendered in this call.
             * @param camera The Camera that is rendering the Game Object.
             * @param parentMatrix This transform matrix is defined if the game object is nested
             */
            renderWebGL(renderer: Phaser.Renderer.WebGL.WebGLRenderer, src: Phaser.GameObjects.Image, camera: Phaser.Cameras.Scene2D.Camera, parentMatrix: Phaser.GameObjects.Components.TransformMatrix): void;

            /**
             * This is a NOOP method. Bitmap Masks are not supported by the Canvas Renderer.
             * @param renderer The Canvas Renderer which would be rendered to.
             * @param mask The masked Game Object which would be rendered.
             * @param camera The Camera to render to.
             */
            renderCanvas(renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer, mask: Phaser.GameObjects.GameObject, camera: Phaser.Cameras.Scene2D.Camera): void;

            /**
             * Destroys this Texture and releases references to its sources and frames.
             */
            destroy(): void;

        }

        namespace Events {
            /**
             * The Texture Add Event.
             * 
             * This event is dispatched by the Texture Manager when a texture is added to it.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('addtexture', listener)`.
             */
            const ADD: string;

            /**
             * The Texture Add Key Event.
             * 
             * This event is dispatched by the Texture Manager when a texture with the given key is added to it.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('addtexture-key', listener)`.
             */
            const ADD_KEY: string;

            /**
             * The Texture Load Error Event.
             * 
             * This event is dispatched by the Texture Manager when a texture it requested to load failed.
             * This only happens when base64 encoded textures fail. All other texture types are loaded via the Loader Plugin.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('onerror', listener)`.
             */
            const ERROR: string;

            /**
             * The Texture Load Event.
             * 
             * This event is dispatched by the Texture Manager when a texture has finished loading on it.
             * This only happens for base64 encoded textures. All other texture types are loaded via the Loader Plugin.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('onload', listener)`.
             * 
             * This event is dispatched after the [ADD]{@linkcode Phaser.Textures.Events#event:ADD} event.
             */
            const LOAD: string;

            /**
             * This internal event signifies that the Texture Manager is now ready and the Game can continue booting.
             * 
             * When a Phaser Game instance is booting for the first time, the Texture Manager has to wait on a couple of non-blocking
             * async events before it's fully ready to carry on. When those complete the Texture Manager emits this event via the Game
             * instance, which tells the Game to carry on booting.
             */
            const READY: string;

            /**
             * The Texture Remove Event.
             * 
             * This event is dispatched by the Texture Manager when a texture is removed from it.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('removetexture', listener)`.
             * 
             * If you have any Game Objects still using the removed texture, they will start throwing
             * errors the next time they try to render. Be sure to clear all use of the texture in this event handler.
             */
            const REMOVE: string;

            /**
             * The Texture Remove Key Event.
             * 
             * This event is dispatched by the Texture Manager when a texture with the given key is removed from it.
             * 
             * Listen to this event from within a Scene using: `this.textures.on('removetexture-key', listener)`.
             * 
             * If you have any Game Objects still using the removed texture, they will start throwing
             * errors the next time they try to render. Be sure to clear all use of the texture in this event handler.
             */
            const REMOVE_KEY: string;

        }

        /**
         * A Frame is a section of a Texture.
         */
        class Frame {
            /**
             * 
             * @param texture The Texture this Frame is a part of.
             * @param name The name of this Frame. The name is unique within the Texture.
             * @param sourceIndex The index of the TextureSource that this Frame is a part of.
             * @param x The x coordinate of the top-left of this Frame.
             * @param y The y coordinate of the top-left of this Frame.
             * @param width The width of this Frame.
             * @param height The height of this Frame.
             */
            constructor(texture: Phaser.Textures.Texture, name: number | string, sourceIndex: number, x: number, y: number, width: number, height: number);

            /**
             * The Texture this Frame is a part of.
             */
            texture: Phaser.Textures.Texture;

            /**
             * The name of this Frame.
             * The name is unique within the Texture.
             */
            name: string;

            /**
             * The TextureSource this Frame is part of.
             */
            source: Phaser.Textures.TextureSource;

            /**
             * The index of the TextureSource in the Texture sources array.
             */
            sourceIndex: number;

            /**
             * A reference to the Texture Source WebGL Texture that this Frame is using.
             */
            glTexture: WebGLTexture | null;

            /**
             * X position within the source image to cut from.
             */
            cutX: number;

            /**
             * Y position within the source image to cut from.
             */
            cutY: number;

            /**
             * The width of the area in the source image to cut.
             */
            cutWidth: number;

            /**
             * The height of the area in the source image to cut.
             */
            cutHeight: number;

            /**
             * The X rendering offset of this Frame, taking trim into account.
             */
            x: number;

            /**
             * The Y rendering offset of this Frame, taking trim into account.
             */
            y: number;

            /**
             * The rendering width of this Frame, taking trim into account.
             */
            width: number;

            /**
             * The rendering height of this Frame, taking trim into account.
             */
            height: number;

            /**
             * Half the width, floored.
             * Precalculated for the renderer.
             */
            halfWidth: number;

            /**
             * Half the height, floored.
             * Precalculated for the renderer.
             */
            halfHeight: number;

            /**
             * The x center of this frame, floored.
             */
            centerX: number;

            /**
             * The y center of this frame, floored.
             */
            centerY: number;

            /**
             * The horizontal pivot point of this Frame.
             */
            pivotX: number;

            /**
             * The vertical pivot point of this Frame.
             */
            pivotY: number;

            /**
             * Does this Frame have a custom pivot point?
             */
            customPivot: boolean;

            /**
             * **CURRENTLY UNSUPPORTED**
             * 
             * Is this frame is rotated or not in the Texture?
             * Rotation allows you to use rotated frames in texture atlas packing.
             * It has nothing to do with Sprite rotation.
             */
            rotated: boolean;

            /**
             * Over-rides the Renderer setting.
             * -1 = use Renderer Setting
             * 0 = No rounding
             * 1 = Round
             */
            autoRound: number;

            /**
             * Any Frame specific custom data can be stored here.
             */
            customData: object;

            /**
             * WebGL UV u0 value.
             */
            u0: number;

            /**
             * WebGL UV v0 value.
             */
            v0: number;

            /**
             * WebGL UV u1 value.
             */
            u1: number;

            /**
             * WebGL UV v1 value.
             */
            v1: number;

            /**
             * Sets the width, height, x and y of this Frame.
             * 
             * This is called automatically by the constructor
             * and should rarely be changed on-the-fly.
             * @param width The width of the frame before being trimmed.
             * @param height The height of the frame before being trimmed.
             * @param x The x coordinate of the top-left of this Frame. Default 0.
             * @param y The y coordinate of the top-left of this Frame. Default 0.
             */
            setSize(width: number, height: number, x?: number, y?: number): this;

            /**
             * If the frame was trimmed when added to the Texture Atlas, this records the trim and source data.
             * @param actualWidth The width of the frame before being trimmed.
             * @param actualHeight The height of the frame before being trimmed.
             * @param destX The destination X position of the trimmed frame for display.
             * @param destY The destination Y position of the trimmed frame for display.
             * @param destWidth The destination width of the trimmed frame for display.
             * @param destHeight The destination height of the trimmed frame for display.
             */
            setTrim(actualWidth: number, actualHeight: number, destX: number, destY: number, destWidth: number, destHeight: number): this;

            /**
             * Sets the scale9 center rectangle values.
             * 
             * Scale9 is a feature of Texture Packer, allowing you to define a nine-slice scaling grid.
             * 
             * This is set automatically by the JSONArray and JSONHash parsers.
             * @param x The left coordinate of the center scale9 rectangle.
             * @param y The top coordinate of the center scale9 rectangle.
             * @param width The width of the center scale9 rectangle.
             * @param height The height coordinate of the center scale9 rectangle.
             */
            setScale9(x: number, y: number, width: number, height: number): this;

            /**
             * Takes a crop data object and, based on the rectangular region given, calculates the
             * required UV coordinates in order to crop this Frame for WebGL and Canvas rendering.
             * 
             * This is called directly by the Game Object Texture Components `setCrop` method.
             * Please use that method to crop a Game Object.
             * @param crop The crop data object. This is the `GameObject._crop` property.
             * @param x The x coordinate to start the crop from. Cannot be negative or exceed the Frame width.
             * @param y The y coordinate to start the crop from. Cannot be negative or exceed the Frame height.
             * @param width The width of the crop rectangle. Cannot exceed the Frame width.
             * @param height The height of the crop rectangle. Cannot exceed the Frame height.
             * @param flipX Does the parent Game Object have flipX set?
             * @param flipY Does the parent Game Object have flipY set?
             */
            setCropUVs(crop: object, x: number, y: number, width: number, height: number, flipX: boolean, flipY: boolean): object;

            /**
             * Takes a crop data object and recalculates the UVs based on the dimensions inside the crop object.
             * Called automatically by `setFrame`.
             * @param crop The crop data object. This is the `GameObject._crop` property.
             * @param flipX Does the parent Game Object have flipX set?
             * @param flipY Does the parent Game Object have flipY set?
             */
            updateCropUVs(crop: object, flipX: boolean, flipY: boolean): object;

            /**
             * Directly sets the canvas and WebGL UV data for this frame.
             * 
             * Use this if you need to override the values that are generated automatically
             * when the Frame is created.
             * @param width Width of this frame for the Canvas data.
             * @param height Height of this frame for the Canvas data.
             * @param u0 UV u0 value.
             * @param v0 UV v0 value.
             * @param u1 UV u1 value.
             * @param v1 UV v1 value.
             */
            setUVs(width: number, height: number, u0: number, v0: number, u1: number, v1: number): this;

            /**
             * Updates the internal WebGL UV cache and the drawImage cache.
             */
            updateUVs(): this;

            /**
             * Updates the internal WebGL UV cache.
             */
            updateUVsInverted(): this;

            /**
             * Clones this Frame into a new Frame object.
             */
            clone(): Phaser.Textures.Frame;

            /**
             * Destroys this Frame by nulling its reference to the parent Texture and and data objects.
             */
            destroy(): void;

            /**
             * The width of the Frame in its un-trimmed, un-padded state, as prepared in the art package,
             * before being packed.
             */
            readonly realWidth: number;

            /**
             * The height of the Frame in its un-trimmed, un-padded state, as prepared in the art package,
             * before being packed.
             */
            readonly realHeight: number;

            /**
             * The radius of the Frame (derived from sqrt(w * w + h * h) / 2)
             */
            readonly radius: number;

            /**
             * Is the Frame trimmed or not?
             */
            readonly trimmed: boolean;

            /**
             * Does the Frame have scale9 border data?
             */
            readonly scale9: boolean;

            /**
             * If the Frame has scale9 border data, is it 3-slice or 9-slice data?
             */
            readonly is3Slice: boolean;

            /**
             * The Canvas drawImage data object.
             */
            readonly canvasData: object;

        }

        /**
         * Linear filter type.
         */
        const LINEAR: number;

        /**
         * Nearest Neighbor filter type.
         */
        const NEAREST: number;

        namespace Parsers {
            /**
             * Parses a KTX format Compressed Texture file and generates texture data suitable for WebGL from it.
             * @param data The data object created by the Compressed Texture File Loader.
             */
            function KTXParser(data: ArrayBuffer): Phaser.Types.Textures.CompressedTextureData;

            /**
             * Parses a PVR format Compressed Texture file and generates texture data suitable for WebGL from it.
             * @param data The data object created by the Compressed Texture File Loader.
             */
            function PVRParser(data: ArrayBuffer): Phaser.Types.Textures.CompressedTextureData;

        }

        /**
         * A Texture consists of a source, usually an Image from the Cache, and a collection of Frames.
         * The Frames represent the different areas of the Texture. For example a texture atlas
         * may have many Frames, one for each element within the atlas. Where-as a single image would have
         * just one frame, that encompasses the whole image.
         * 
         * Every Texture, no matter where it comes from, always has at least 1 frame called the `__BASE` frame.
         * This frame represents the entirety of the source image.
         * 
         * Textures are managed by the global TextureManager. This is a singleton class that is
         * responsible for creating and delivering Textures and their corresponding Frames to Game Objects.
         * 
         * Sprites and other Game Objects get the texture data they need from the TextureManager.
         */
        class Texture {
            /**
             * 
             * @param manager A reference to the Texture Manager this Texture belongs to.
             * @param key The unique string-based key of this Texture.
             * @param source An array of sources that are used to create the texture. Usually Images, but can also be a Canvas.
             * @param width The width of the Texture. This is optional and automatically derived from the source images.
             * @param height The height of the Texture. This is optional and automatically derived from the source images.
             */
            constructor(manager: Phaser.Textures.TextureManager, key: string, source: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[], width?: number, height?: number);

            /**
             * A reference to the Texture Manager this Texture belongs to.
             */
            manager: Phaser.Textures.TextureManager;

            /**
             * The unique string-based key of this Texture.
             */
            key: string;

            /**
             * An array of TextureSource instances.
             * These are unique to this Texture and contain the actual Image (or Canvas) data.
             */
            source: Phaser.Textures.TextureSource[];

            /**
             * An array of TextureSource data instances.
             * Used to store additional data images, such as normal maps or specular maps.
             */
            dataSource: any[];

            /**
             * A key-value object pair associating the unique Frame keys with the Frames objects.
             */
            frames: object;

            /**
             * Any additional data that was set in the source JSON (if any),
             * or any extra data you'd like to store relating to this texture
             */
            customData: object;

            /**
             * The name of the first frame of the Texture.
             */
            firstFrame: string;

            /**
             * The total number of Frames in this Texture, including the `__BASE` frame.
             * 
             * A Texture will always contain at least 1 frame because every Texture contains a `__BASE` frame by default,
             * in addition to any extra frames that have been added to it, such as when parsing a Sprite Sheet or Texture Atlas.
             */
            frameTotal: number;

            /**
             * Adds a new Frame to this Texture.
             * 
             * A Frame is a rectangular region of a TextureSource with a unique index or string-based key.
             * 
             * The name given must be unique within this Texture. If it already exists, this method will return `null`.
             * @param name The name of this Frame. The name is unique within the Texture.
             * @param sourceIndex The index of the TextureSource that this Frame is a part of.
             * @param x The x coordinate of the top-left of this Frame.
             * @param y The y coordinate of the top-left of this Frame.
             * @param width The width of this Frame.
             * @param height The height of this Frame.
             */
            add(name: number | string, sourceIndex: number, x: number, y: number, width: number, height: number): Phaser.Textures.Frame | null;

            /**
             * Removes the given Frame from this Texture. The Frame is destroyed immediately.
             * 
             * Any Game Objects using this Frame should stop using it _before_ you remove it,
             * as it does not happen automatically.
             * @param name The key of the Frame to remove.
             */
            remove(name: string): boolean;

            /**
             * Checks to see if a Frame matching the given key exists within this Texture.
             * @param name The key of the Frame to check for.
             */
            has(name: string): boolean;

            /**
             * Gets a Frame from this Texture based on either the key or the index of the Frame.
             * 
             * In a Texture Atlas Frames are typically referenced by a key.
             * In a Sprite Sheet Frames are referenced by an index.
             * Passing no value for the name returns the base texture.
             * @param name The string-based name, or integer based index, of the Frame to get from this Texture.
             */
            get(name?: string | number): Phaser.Textures.Frame;

            /**
             * Takes the given TextureSource and returns the index of it within this Texture.
             * If it's not in this Texture, it returns -1.
             * Unless this Texture has multiple TextureSources, such as with a multi-atlas, this
             * method will always return zero or -1.
             * @param source The TextureSource to check.
             */
            getTextureSourceIndex(source: Phaser.Textures.TextureSource): number;

            /**
             * Returns an array of all the Frames in the given TextureSource.
             * @param sourceIndex The index of the TextureSource to get the Frames from.
             * @param includeBase Include the `__BASE` Frame in the output array? Default false.
             */
            getFramesFromTextureSource(sourceIndex: number, includeBase?: boolean): Phaser.Textures.Frame[];

            /**
             * Returns an array with all of the names of the Frames in this Texture.
             * 
             * Useful if you want to randomly assign a Frame to a Game Object, as you can
             * pick a random element from the returned array.
             * @param includeBase Include the `__BASE` Frame in the output array? Default false.
             */
            getFrameNames(includeBase?: boolean): string[];

            /**
             * Given a Frame name, return the source image it uses to render with.
             * 
             * This will return the actual DOM Image or Canvas element.
             * @param name The string-based name, or integer based index, of the Frame to get from this Texture.
             */
            getSourceImage(name?: string | number): HTMLImageElement | HTMLCanvasElement | Phaser.GameObjects.RenderTexture;

            /**
             * Given a Frame name, return the data source image it uses to render with.
             * You can use this to get the normal map for an image for example.
             * 
             * This will return the actual DOM Image.
             * @param name The string-based name, or integer based index, of the Frame to get from this Texture.
             */
            getDataSourceImage(name?: string | number): HTMLImageElement | HTMLCanvasElement;

            /**
             * Adds a data source image to this Texture.
             * 
             * An example of a data source image would be a normal map, where all of the Frames for this Texture
             * equally apply to the normal map.
             * @param data The source image.
             */
            setDataSource(data: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): void;

            /**
             * Sets the Filter Mode for this Texture.
             * 
             * The mode can be either Linear, the default, or Nearest.
             * 
             * For pixel-art you should use Nearest.
             * 
             * The mode applies to the entire Texture, not just a specific Frame of it.
             * @param filterMode The Filter Mode.
             */
            setFilter(filterMode: Phaser.Textures.FilterMode): void;

            /**
             * Destroys this Texture and releases references to its sources and frames.
             */
            destroy(): void;

        }

        /**
         * When Phaser boots it will create an instance of this Texture Manager class.
         * 
         * It is a global manager that handles all textures in your game. You can access it from within
         * a Scene via the `this.textures` property.
         * 
         * Its role is as a manager for all textures that your game uses. It can create, update and remove
         * textures globally, as well as parse texture data from external files, such as sprite sheets
         * and texture atlases.
         * 
         * Sprites and other texture-based Game Objects get their texture data directly from this class.
         */
        class TextureManager extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param game The Phaser.Game instance this Texture Manager belongs to.
             */
            constructor(game: Phaser.Game);

            /**
             * The Game that the Texture Manager belongs to.
             * 
             * A game will only ever have one instance of a Texture Manager.
             */
            game: Phaser.Game;

            /**
             * The internal name of this manager.
             */
            readonly name: string;

            /**
             * This object contains all Textures that belong to this Texture Manager.
             * 
             * Textures are identified by string-based keys, which are used as the property
             * within this object. Therefore, you can access any texture directly from this
             * object without any iteration.
             * 
             * You should not typically modify this object directly, but instead use the
             * methods provided by the Texture Manager to add and remove entries from it.
             */
            list: object;

            /**
             * An Image Game Object that belongs to this Texture Manager.
             * 
             * Used as a drawing stamp within Dynamic Textures.
             * 
             * This is not part of the display list and doesn't render.
             */
            readonly stamp: Phaser.GameObjects.Image;

            /**
             * The crop Rectangle as used by the Stamp when it needs to crop itself.
             */
            stampCrop: Phaser.Geom.Rectangle;

            /**
             * If this flag is `true` then the Texture Manager will never emit any
             * warnings to the console log that report missing textures.
             */
            silentWarnings: boolean;

            /**
             * Checks the given texture key and throws a console.warn if the key is already in use, then returns false.
             * 
             * If you wish to avoid the console.warn then use `TextureManager.exists` instead.
             * @param key The texture key to check.
             */
            checkKey(key: string): boolean;

            /**
             * Removes a Texture from the Texture Manager and destroys it. This will immediately
             * clear all references to it from the Texture Manager, and if it has one, destroy its
             * WebGLTexture. This will emit a `removetexture` event.
             * 
             * Note: If you have any Game Objects still using this texture they will start throwing
             * errors the next time they try to render. Make sure that removing the texture is the final
             * step when clearing down to avoid this.
             * @param key The key of the Texture to remove, or a reference to it.
             */
            remove(key: string | Phaser.Textures.Texture): Phaser.Textures.TextureManager;

            /**
             * Removes a key from the Texture Manager but does not destroy the Texture that was using the key.
             * @param key The key to remove from the texture list.
             */
            removeKey(key: string): Phaser.Textures.TextureManager;

            /**
             * Adds a new Texture to the Texture Manager created from the given Base64 encoded data.
             * 
             * It works by creating an `Image` DOM object, then setting the `src` attribute to
             * the given base64 encoded data. As a result, the process is asynchronous by its nature,
             * so be sure to listen for the events this method dispatches before using the texture.
             * @param key The unique string-based key of the Texture.
             * @param data The Base64 encoded data.
             */
            addBase64(key: string, data: any): this;

            /**
             * Gets an existing texture frame and converts it into a base64 encoded image and returns the base64 data.
             * 
             * You can also provide the image type and encoder options.
             * 
             * This will only work with bitmap based texture frames, such as those created from Texture Atlases.
             * It will not work with GL Texture objects, such as Shaders, or Render Textures. For those please
             * see the WebGL Snapshot function instead.
             * @param key The unique string-based key of the Texture.
             * @param frame The string-based name, or integer based index, of the Frame to get from the Texture.
             * @param type A DOMString indicating the image format. The default format type is image/png. Default 'image/png'.
             * @param encoderOptions A Number between 0 and 1 indicating the image quality to use for image formats that use lossy compression such as image/jpeg and image/webp. If this argument is anything else, the default value for image quality is used. The default value is 0.92. Other arguments are ignored. Default 0.92.
             */
            getBase64(key: string, frame?: string | number, type?: string, encoderOptions?: number): string;

            /**
             * Adds a new Texture to the Texture Manager created from the given Image element.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element.
             * @param dataSource An optional data Image element.
             */
            addImage(key: string, source: HTMLImageElement, dataSource?: HTMLImageElement | HTMLCanvasElement): Phaser.Textures.Texture | null;

            /**
             * Takes a WebGL Texture and creates a Phaser Texture from it, which is added to the Texture Manager using the given key.
             * 
             * This allows you to then use the Texture as a normal texture for texture based Game Objects like Sprites.
             * 
             * If the `width` and `height` arguments are omitted, but the WebGL Texture was created by Phaser's WebGL Renderer
             * and has `glTexture.width` and `glTexture.height` properties, these values will be used instead.
             * 
             * This is a WebGL only feature.
             * @param key The unique string-based key of the Texture.
             * @param glTexture The source Render Texture.
             * @param width The new width of the Texture. Read from `glTexture.width` if omitted.
             * @param height The new height of the Texture. Read from `glTexture.height` if omitted.
             */
            addGLTexture(key: string, glTexture: WebGLTexture, width?: number, height?: number): Phaser.Textures.Texture | null;

            /**
             * Adds a Compressed Texture to this Texture Manager.
             * 
             * The texture should typically have been loaded via the `CompressedTextureFile` loader,
             * in order to prepare the correct data object this method requires.
             * 
             * You can optionally also pass atlas data to this method, in which case a texture atlas
             * will be generated from the given compressed texture, combined with the atlas data.
             * @param key The unique string-based key of the Texture.
             * @param textureData The Compressed Texture data object.
             * @param atlasData Optional Texture Atlas data.
             */
            addCompressedTexture(key: string, textureData: Phaser.Types.Textures.CompressedTextureData, atlasData?: object): Phaser.Textures.Texture | null;

            /**
             * Adds a Render Texture to the Texture Manager using the given key.
             * This allows you to then use the Render Texture as a normal texture for texture based Game Objects like Sprites.
             * @param key The unique string-based key of the Texture.
             * @param renderTexture The source Render Texture.
             */
            addRenderTexture(key: string, renderTexture: Phaser.GameObjects.RenderTexture): Phaser.Textures.Texture | null;

            /**
             * Creates a new Texture using the given config values.
             * 
             * Generated textures consist of a Canvas element to which the texture data is drawn.
             * 
             * Generates a texture based on the given Create configuration object.
             * 
             * The texture is drawn using a fixed-size indexed palette of 16 colors, where the hex value in the
             * data cells map to a single color. For example, if the texture config looked like this:
             * 
             * ```javascript
             * var star = [
             *   '.....828.....',
             *   '....72227....',
             *   '....82228....',
             *   '...7222227...',
             *   '2222222222222',
             *   '8222222222228',
             *   '.72222222227.',
             *   '..787777787..',
             *   '..877777778..',
             *   '.78778887787.',
             *   '.27887.78872.',
             *   '.787.....787.'
             * ];
             * 
             * this.textures.generate('star', { data: star, pixelWidth: 4 });
             * ```
             * 
             * Then it would generate a texture that is 52 x 48 pixels in size, because each cell of the data array
             * represents 1 pixel multiplied by the `pixelWidth` value. The cell values, such as `8`, maps to color
             * number 8 in the palette. If a cell contains a period character `.` then it is transparent.
             * 
             * The default palette is Arne16, but you can specify your own using the `palette` property.
             * @param key The unique string-based key of the Texture.
             * @param config The configuration object needed to generate the texture.
             */
            generate(key: string, config: Phaser.Types.Create.GenerateTextureConfig): Phaser.Textures.Texture | null;

            /**
             * Creates a new Texture using a blank Canvas element of the size given.
             * 
             * Canvas elements are automatically pooled and calling this method will
             * extract a free canvas from the CanvasPool, or create one if none are available.
             * @param key The unique string-based key of the Texture.
             * @param width The width of the Canvas element. Default 256.
             * @param height The height of the Canvas element. Default 256.
             */
            createCanvas(key: string, width?: number, height?: number): Phaser.Textures.CanvasTexture | null;

            /**
             * Creates a new Canvas Texture object from an existing Canvas element
             * and adds it to this Texture Manager, unless `skipCache` is true.
             * @param key The unique string-based key of the Texture.
             * @param source The Canvas element to form the base of the new Texture.
             * @param skipCache Skip adding this Texture into the Cache? Default false.
             */
            addCanvas(key: string, source: HTMLCanvasElement, skipCache?: boolean): Phaser.Textures.CanvasTexture | null;

            /**
             * Creates a Dynamic Texture instance and adds itself to this Texture Manager.
             * 
             * A Dynamic Texture is a special texture that allows you to draw textures, frames and most kind of
             * Game Objects directly to it.
             * 
             * You can take many complex objects and draw them to this one texture, which can then be used as the
             * base texture for other Game Objects, such as Sprites. Should you then update this texture, all
             * Game Objects using it will instantly be updated as well, reflecting the changes immediately.
             * 
             * It's a powerful way to generate dynamic textures at run-time that are WebGL friendly and don't invoke
             * expensive GPU uploads on each change.
             * 
             * See the methods available on the `DynamicTexture` class for more details.
             * 
             * Optionally, you can also pass a Dynamic Texture instance to this method to have
             * it added to the Texture Manager.
             * @param key The string-based key of this Texture. Must be unique within the Texture Manager. Or, a DynamicTexture instance.
             * @param width The width of this Dynamic Texture in pixels. Defaults to 256 x 256. Ignored if an instance is passed as the key. Default 256.
             * @param height The height of this Dynamic Texture in pixels. Defaults to 256 x 256. Ignored if an instance is passed as the key. Default 256.
             */
            addDynamicTexture(key: string | Phaser.Textures.DynamicTexture, width?: number, height?: number): Phaser.Textures.DynamicTexture | null;

            /**
             * Adds a Texture Atlas to this Texture Manager.
             * 
             * In Phaser terminology, a Texture Atlas is a combination of an atlas image and a JSON data file,
             * such as those exported by applications like Texture Packer.
             * 
             * It can accept either JSON Array or JSON Hash formats, as exported by Texture Packer and similar software.
             * 
             * As of Phaser 3.60 you can use this method to add a atlas data to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element/s, or a Phaser Texture.
             * @param data The Texture Atlas data/s.
             * @param dataSource An optional data Image element.
             */
            addAtlas(key: string, source: HTMLImageElement | HTMLImageElement[] | Phaser.Textures.Texture, data: object | object[], dataSource?: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): Phaser.Textures.Texture | null;

            /**
             * Adds a Texture Atlas to this Texture Manager.
             * 
             * In Phaser terminology, a Texture Atlas is a combination of an atlas image and a JSON data file,
             * such as those exported by applications like Texture Packer.
             * 
             * The frame data of the atlas must be stored in an Array within the JSON.
             * 
             * This is known as a JSON Array in software such as Texture Packer.
             * 
             * As of Phaser 3.60 you can use this method to add a atlas data to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element/s, or a Phaser Texture.
             * @param data The Texture Atlas data/s.
             * @param dataSource An optional data Image element.
             */
            addAtlasJSONArray(key: string, source: HTMLImageElement | HTMLImageElement[] | Phaser.Textures.Texture, data: object | object[], dataSource?: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): Phaser.Textures.Texture | null;

            /**
             * Adds a Texture Atlas to this Texture Manager.
             * 
             * In Phaser terminology, a Texture Atlas is a combination of an atlas image and a JSON data file,
             * such as those exported by applications like Texture Packer.
             * 
             * The frame data of the atlas must be stored in an Object within the JSON.
             * 
             * This is known as a JSON Hash in software such as Texture Packer.
             * 
             * As of Phaser 3.60 you can use this method to add a atlas data to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element/s, or a Phaser Texture.
             * @param data The Texture Atlas data/s.
             * @param dataSource An optional data Image element.
             */
            addAtlasJSONHash(key: string, source: HTMLImageElement | HTMLImageElement[] | Phaser.Textures.Texture, data: object | object[], dataSource?: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): Phaser.Textures.Texture | null;

            /**
             * Adds a Texture Atlas to this Texture Manager.
             * 
             * In Phaser terminology, a Texture Atlas is a combination of an atlas image and a data file,
             * such as those exported by applications like Texture Packer.
             * 
             * The frame data of the atlas must be stored in an XML file.
             * 
             * As of Phaser 3.60 you can use this method to add a atlas data to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element, or a Phaser Texture.
             * @param data The Texture Atlas XML data.
             * @param dataSource An optional data Image element.
             */
            addAtlasXML(key: string, source: HTMLImageElement | Phaser.Textures.Texture, data: object, dataSource?: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): Phaser.Textures.Texture | null;

            /**
             * Adds a Unity Texture Atlas to this Texture Manager.
             * 
             * In Phaser terminology, a Texture Atlas is a combination of an atlas image and a data file,
             * such as those exported by applications like Texture Packer or Unity.
             * 
             * The frame data of the atlas must be stored in a Unity YAML file.
             * 
             * As of Phaser 3.60 you can use this method to add a atlas data to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element.
             * @param data The Texture Atlas data.
             * @param dataSource An optional data Image element.
             */
            addUnityAtlas(key: string, source: HTMLImageElement, data: object, dataSource?: HTMLImageElement | HTMLCanvasElement | HTMLImageElement[] | HTMLCanvasElement[]): Phaser.Textures.Texture | null;

            /**
             * Adds a Sprite Sheet to this Texture Manager.
             * 
             * In Phaser terminology a Sprite Sheet is a texture containing different frames, but each frame is the exact
             * same size and cannot be trimmed or rotated. This is different to a Texture Atlas, created by tools such as
             * Texture Packer, and more akin with the fixed-frame exports you get from apps like Aseprite or old arcade
             * games.
             * 
             * As of Phaser 3.60 you can use this method to add a sprite sheet to an existing Phaser Texture.
             * @param key The unique string-based key of the Texture. Give an empty string if you provide a Phaser Texture as the 2nd argument.
             * @param source The source Image element, or a Phaser Texture.
             * @param config The configuration object for this Sprite Sheet.
             * @param dataSource An optional data Image element.
             */
            addSpriteSheet(key: string, source: HTMLImageElement | Phaser.Textures.Texture, config: Phaser.Types.Textures.SpriteSheetConfig, dataSource?: HTMLImageElement | HTMLCanvasElement): Phaser.Textures.Texture | null;

            /**
             * Adds a Sprite Sheet to this Texture Manager, where the Sprite Sheet exists as a Frame within a Texture Atlas.
             * 
             * In Phaser terminology a Sprite Sheet is a texture containing different frames, but each frame is the exact
             * same size and cannot be trimmed or rotated.
             * @param key The unique string-based key of the Texture.
             * @param config The configuration object for this Sprite Sheet.
             */
            addSpriteSheetFromAtlas(key: string, config: Phaser.Types.Textures.SpriteSheetFromAtlasConfig): Phaser.Textures.Texture | null;

            /**
             * Creates a new Texture using the given source and dimensions.
             * @param key The unique string-based key of the Texture.
             * @param source The source Image element.
             * @param width The width of the Texture.
             * @param height The height of the Texture.
             */
            create(key: string, source: HTMLImageElement, width: number, height: number): Phaser.Textures.Texture | null;

            /**
             * Checks the given key to see if a Texture using it exists within this Texture Manager.
             * @param key The unique string-based key of the Texture.
             */
            exists(key: string): boolean;

            /**
             * Returns a Texture from the Texture Manager that matches the given key.
             * 
             * If the key is `undefined` it will return the `__DEFAULT` Texture.
             * 
             * If the key is an instance of a Texture, it will return the instance.
             * 
             * If the key is an instance of a Frame, it will return the frames parent Texture instance.
             * 
             * Finally, if the key is given, but not found, and not a Texture or Frame instance, it will return the `__MISSING` Texture.
             * @param key The unique string-based key of the Texture, or a Texture, or Frame instance.
             */
            get(key: string | Phaser.Textures.Texture | Phaser.Textures.Frame): Phaser.Textures.Texture;

            /**
             * Takes a Texture key and Frame name and returns a clone of that Frame if found.
             * @param key The unique string-based key of the Texture.
             * @param frame The string or index of the Frame to be cloned.
             */
            cloneFrame(key: string, frame: string | number): Phaser.Textures.Frame;

            /**
             * Takes a Texture key and Frame name and returns a reference to that Frame, if found.
             * @param key The unique string-based key of the Texture.
             * @param frame The string-based name, or integer based index, of the Frame to get from the Texture.
             */
            getFrame(key: string, frame?: string | number): Phaser.Textures.Frame;

            /**
             * Parses the 'key' parameter and returns a Texture Frame instance.
             * 
             * It can accept the following formats:
             * 
             * 1) A string
             * 2) An array where the elements are: [ key, [frame] ]
             * 3) An object with the properties: { key, [frame] }
             * 4) A Texture instance - which returns the default frame from the Texture
             * 5) A Frame instance - returns itself
             * @param key The key to be parsed.
             */
            parseFrame(key: string | any[] | object | Phaser.Textures.Texture | Phaser.Textures.Frame): Phaser.Textures.Frame;

            /**
             * Returns an array with all of the keys of all Textures in this Texture Manager.
             * The output array will exclude the `__DEFAULT`, `__MISSING`, and `__WHITE` keys.
             */
            getTextureKeys(): string[];

            /**
             * Given a Texture and an `x` and `y` coordinate this method will return a new
             * Color object that has been populated with the color and alpha values of the pixel
             * at that location in the Texture.
             * @param x The x coordinate of the pixel within the Texture.
             * @param y The y coordinate of the pixel within the Texture.
             * @param key The unique string-based key of the Texture.
             * @param frame The string or index of the Frame.
             */
            getPixel(x: number, y: number, key: string, frame?: string | number): Phaser.Display.Color | null;

            /**
             * Given a Texture and an `x` and `y` coordinate this method will return a value between 0 and 255
             * corresponding to the alpha value of the pixel at that location in the Texture. If the coordinate
             * is out of bounds it will return null.
             * @param x The x coordinate of the pixel within the Texture.
             * @param y The y coordinate of the pixel within the Texture.
             * @param key The unique string-based key of the Texture.
             * @param frame The string or index of the Frame.
             */
            getPixelAlpha(x: number, y: number, key: string, frame?: string | number): number;

            /**
             * Sets the given Game Objects `texture` and `frame` properties so that it uses
             * the Texture and Frame specified in the `key` and `frame` arguments to this method.
             * @param gameObject The Game Object the texture would be set on.
             * @param key The unique string-based key of the Texture.
             * @param frame The string or index of the Frame.
             */
            setTexture(gameObject: Phaser.GameObjects.GameObject, key: string, frame?: string | number): Phaser.GameObjects.GameObject;

            /**
             * Changes the key being used by a Texture to the new key provided.
             * 
             * The old key is removed, allowing it to be re-used.
             * 
             * Game Objects are linked to Textures by a reference to the Texture object, so
             * all existing references will be retained.
             * @param currentKey The current string-based key of the Texture you wish to rename.
             * @param newKey The new unique string-based key to use for the Texture.
             */
            renameTexture(currentKey: string, newKey: string): boolean;

            /**
             * Passes all Textures to the given callback.
             * @param callback The callback function to be sent the Textures.
             * @param scope The value to use as `this` when executing the callback.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            each(callback: EachTextureCallback, scope: object, ...args: any[]): void;

            /**
             * Resets the internal Stamp object, ready for drawing and returns it.
             * @param alpha The alpha to use. Default 1.
             * @param tint WebGL only. The tint color to use. Default 0xffffff.
             */
            resetStamp(alpha?: number, tint?: number): Phaser.GameObjects.Image;

            /**
             * Destroys the Texture Manager and all Textures stored within it.
             */
            destroy(): void;

        }

        /**
         * A Texture Source is the encapsulation of the actual source data for a Texture.
         * 
         * This is typically an Image Element, loaded from the file system or network, a Canvas Element or a Video Element.
         * 
         * A Texture can contain multiple Texture Sources, which only happens when a multi-atlas is loaded.
         */
        class TextureSource {
            /**
             * 
             * @param texture The Texture this TextureSource belongs to.
             * @param source The source image data.
             * @param width Optional width of the source image. If not given it's derived from the source itself.
             * @param height Optional height of the source image. If not given it's derived from the source itself.
             * @param flipY Sets the `UNPACK_FLIP_Y_WEBGL` flag the WebGL Texture uses during upload. Default false.
             */
            constructor(texture: Phaser.Textures.Texture, source: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement | Phaser.GameObjects.RenderTexture | WebGLTexture | Phaser.Types.Textures.CompressedTextureData | Phaser.Textures.DynamicTexture, width?: number, height?: number, flipY?: boolean);

            /**
             * A reference to the Canvas or WebGL Renderer.
             */
            renderer: Phaser.Renderer.Canvas.CanvasRenderer | Phaser.Renderer.WebGL.WebGLRenderer;

            /**
             * The Texture this TextureSource instance belongs to.
             */
            texture: Phaser.Textures.Texture;

            /**
             * The source of the image data.
             * 
             * This is either an Image Element, a Canvas Element, a Video Element, a RenderTexture or a WebGLTexture.
             * 
             * In Phaser 3.60 and above it can also be a Compressed Texture data object.
             */
            source: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement | Phaser.GameObjects.RenderTexture | WebGLTexture | Phaser.Types.Textures.CompressedTextureData | Phaser.Textures.DynamicTexture;

            /**
             * The image data.
             * 
             * This is either an Image element, Canvas element or a Video Element.
             */
            image: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement;

            /**
             * Holds the compressed textured algorithm, or `null` if it's not a compressed texture.
             * 
             * Prior to Phaser 3.60 this value always held `null`.
             */
            compressionAlgorithm: number;

            /**
             * The resolution of the source image.
             */
            resolution: number;

            /**
             * The width of the source image. If not specified in the constructor it will check
             * the `naturalWidth` and then `width` properties of the source image.
             */
            width: number;

            /**
             * The height of the source image. If not specified in the constructor it will check
             * the `naturalHeight` and then `height` properties of the source image.
             */
            height: number;

            /**
             * The Scale Mode the image will use when rendering.
             * Either Linear or Nearest.
             */
            scaleMode: number;

            /**
             * Is the source image a Canvas Element?
             */
            isCanvas: boolean;

            /**
             * Is the source image a Video Element?
             */
            isVideo: boolean;

            /**
             * Is the source image a Render Texture?
             */
            isRenderTexture: boolean;

            /**
             * Is the source image a WebGLTexture?
             */
            isGLTexture: boolean;

            /**
             * Are the source image dimensions a power of two?
             */
            isPowerOf2: boolean;

            /**
             * The WebGL Texture of the source image. If this TextureSource is driven from a WebGLTexture
             * already, then this is a reference to that WebGLTexture.
             */
            glTexture: WebGLTexture | null;

            /**
             * Sets the `UNPACK_FLIP_Y_WEBGL` flag the WebGL Texture uses during upload.
             */
            flipY: boolean;

            /**
             * Creates a WebGL Texture, if required, and sets the Texture filter mode.
             * @param game A reference to the Phaser Game instance.
             */
            init(game: Phaser.Game): void;

            /**
             * Sets the Filter Mode for this Texture.
             * 
             * The mode can be either Linear, the default, or Nearest.
             * 
             * For pixel-art you should use Nearest.
             * @param filterMode The Filter Mode.
             */
            setFilter(filterMode: Phaser.Textures.FilterMode): void;

            /**
             * Sets the `UNPACK_FLIP_Y_WEBGL` flag for the WebGL Texture during texture upload.
             * @param value Should the WebGL Texture be flipped on the Y axis on texture upload or not? Default true.
             */
            setFlipY(value?: boolean): void;

            /**
             * If this TextureSource is backed by a Canvas and is running under WebGL,
             * it updates the WebGLTexture using the canvas data.
             */
            update(): void;

            /**
             * Destroys this Texture Source and nulls the references.
             */
            destroy(): void;

        }

    }

    namespace Tilemaps {
        namespace Components {
            /**
             * Calculates interesting faces at the given tile coordinates of the specified layer. Interesting
             * faces are used internally for optimizing collisions against tiles. This method is mostly used
             * internally to optimize recalculating faces when only one tile has been changed.
             * @param tileX The x coordinate.
             * @param tileY The y coordinate.
             * @param layer The Tilemap Layer to act upon.
             */
            function CalculateFacesAt(tileX: number, tileY: number, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Calculates interesting faces within the rectangular area specified (in tile coordinates) of the
             * layer. Interesting faces are used internally for optimizing collisions against tiles. This method
             * is mostly used internally.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The Tilemap Layer to act upon.
             */
            function CalculateFacesWithin(tileX: number, tileY: number, width: number, height: number, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Checks if the given tile coordinate is within the isometric layer bounds, or not.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param layer The Tilemap Layer to check against.
             * @param camera The Camera to run the cull check against.
             */
            function CheckIsoBounds(tileX: number, tileY: number, layer: Phaser.Tilemaps.LayerData, camera?: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Copies the tiles in the source rectangular area to a new destination (all specified in tile
             * coordinates) within the layer. This copies all tile properties and recalculates collision
             * information in the destination region.
             * @param srcTileX The x coordinate of the area to copy from, in tiles, not pixels.
             * @param srcTileY The y coordinate of the area to copy from, in tiles, not pixels.
             * @param width The width of the area to copy, in tiles, not pixels.
             * @param height The height of the area to copy, in tiles, not pixels.
             * @param destTileX The x coordinate of the area to copy to, in tiles, not pixels.
             * @param destTileY The y coordinate of the area to copy to, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The Tilemap Layer to act upon.
             */
            function Copy(srcTileX: number, srcTileY: number, width: number, height: number, destTileX: number, destTileY: number, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Creates a Sprite for every object matching the given tile indexes in the layer. You can
             * optionally specify if each tile will be replaced with a new tile after the Sprite has been
             * created. This is useful if you want to lay down special tiles in a level that are converted to
             * Sprites, but want to replace the tile itself with a floor tile or similar once converted.
             * @param indexes The tile index, or array of indexes, to create Sprites from.
             * @param replacements The tile index, or array of indexes, to change a converted tile to. Set to `null` to leave the tiles unchanged. If an array is given, it is assumed to be a one-to-one mapping with the indexes array.
             * @param spriteConfig The config object to pass into the Sprite creator (i.e. scene.make.sprite).
             * @param scene The Scene to create the Sprites within.
             * @param camera The Camera to use when determining the world XY
             * @param layer The Tilemap Layer to act upon.
             */
            function CreateFromTiles(indexes: number | number[], replacements: number | number[] | undefined, spriteConfig: Phaser.Types.GameObjects.Sprite.SpriteConfig, scene: Phaser.Scene, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.GameObjects.Sprite[];

            /**
             * Returns the bounds in the given orthogonal layer that are within the cameras viewport.
             * This is used internally by the cull tiles function.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             */
            function CullBounds(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera): Phaser.Geom.Rectangle;

            /**
             * Returns the tiles in the given layer that are within the cameras viewport. This is used internally.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             * @param outputArray An optional array to store the Tile objects within.
             * @param renderOrder The rendering order constant. Default 0.
             */
            function CullTiles(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera, outputArray?: any[], renderOrder?: number): Phaser.Tilemaps.Tile[];

            /**
             * Sets the tiles in the given rectangular area (in tile coordinates) of the layer with the
             * specified index. Tiles will be set to collide if the given index is a colliding index.
             * Collision information in the region will be recalculated.
             * @param index The tile index to fill the area with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            function Fill(index: number, tileX: number, tileY: number, width: number, height: number, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * filter callback function. Any tiles that pass the filter test (i.e. where the callback returns
             * true) will returned as a new array. Similar to Array.prototype.Filter in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this
             * callback as the first and only parameter. The callback should return true for tiles that pass the
             * filter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tilemap Layer to act upon.
             */
            function FilterTiles(callback: Function, context: object, tileX: number, tileY: number, width: number, height: number, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile[];

            /**
             * Searches the entire map layer for the first tile matching the given index, then returns that Tile
             * object. If no match is found, it returns null. The search starts from the top-left tile and
             * continues horizontally until it hits the end of the row, then it drops down to the next column.
             * If the reverse boolean is true, it scans starting from the bottom-right corner traveling up to
             * the top-left.
             * @param index The tile index value to search for.
             * @param skip The number of times to skip a matching tile before returning.
             * @param reverse If true it will scan the layer in reverse, starting at the bottom-right. Otherwise it scans from the top-left.
             * @param layer The Tilemap Layer to act upon.
             */
            function FindByIndex(index: number, skip: number, reverse: boolean, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile | null;

            /**
             * Find the first tile in the given rectangular area (in tile coordinates) of the layer that
             * satisfies the provided testing function. I.e. finds the first tile for which `callback` returns
             * true. Similar to Array.prototype.find in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tilemap Layer to act upon.
             */
            function FindTile(callback: FindTileCallback, context: object, tileX: number, tileY: number, width: number, height: number, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile | null;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * callback. Similar to Array.prototype.forEach in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tilemap Layer to act upon.
             */
            function ForEachTile(callback: EachTileCallback, context: object, tileX: number, tileY: number, width: number, height: number, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Gets the correct function to use to cull tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetCullTilesFunction(orientation: number): Function;

            /**
             * Gets a tile at the given tile coordinates from the given layer.
             * @param tileX X position to get the tile from (given in tile units, not pixels).
             * @param tileY Y position to get the tile from (given in tile units, not pixels).
             * @param nonNull If true getTile won't return null for empty tiles, but a Tile object with an index of -1.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTileAt(tileX: number, tileY: number, nonNull: boolean, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Gets a tile at the given world coordinates from the given layer.
             * @param worldX X position to get the tile from (given in pixels)
             * @param worldY Y position to get the tile from (given in pixels)
             * @param nonNull If true, function won't return null for empty tiles, but a Tile object with an index of -1.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTileAtWorldXY(worldX: number, worldY: number, nonNull: boolean, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Gets the corners of the Tile as an array of Vector2s.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTileCorners(tileX: number, tileY: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2[];

            /**
             * Gets the correct function to use to get the tile corners, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetTileCornersFunction(orientation: number): Function;

            /**
             * Gets the tiles in the given rectangular area (in tile coordinates) of the layer.
             * 
             * This returns an array with references to the Tile instances in, so be aware of
             * modifying them directly.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTilesWithin(tileX: number, tileY: number, width: number, height: number, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile[];

            /**
             * Gets the tiles that overlap with the given shape in the given layer. The shape must be a Circle,
             * Line, Rectangle or Triangle. The shape should be in world coordinates.
             * @param shape A shape in world (pixel) coordinates
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTilesWithinShape(shape: Phaser.Geom.Circle | Phaser.Geom.Line | Phaser.Geom.Rectangle | Phaser.Geom.Triangle, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile[];

            /**
             * Gets the tiles in the given rectangular area (in world coordinates) of the layer.
             * @param worldX The world x coordinate for the top-left of the area.
             * @param worldY The world y coordinate for the top-left of the area.
             * @param width The width of the area.
             * @param height The height of the area.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when factoring in which tiles to return.
             * @param layer The Tilemap Layer to act upon.
             */
            function GetTilesWithinWorldXY(worldX: number, worldY: number, width: number, height: number, filteringOptions: Phaser.Types.Tilemaps.FilteringOptions, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile[];

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetTileToWorldXFunction(orientation: number): Function;

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetTileToWorldXYFunction(orientation: number): Function;

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetTileToWorldYFunction(orientation: number): Function;

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * 
             * Only orthogonal maps support this feature.
             * @param orientation The Tilemap orientation constant.
             */
            function GetWorldToTileXFunction(orientation: number): Function;

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetWorldToTileXYFunction(orientation: number): Function;

            /**
             * Gets the correct function to use to translate tiles, based on the map orientation.
             * @param orientation The Tilemap orientation constant.
             */
            function GetWorldToTileYFunction(orientation: number): Function;

            /**
             * Checks if there is a tile at the given location (in tile coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * @param tileX X position to get the tile from (given in tile units, not pixels).
             * @param tileY Y position to get the tile from (given in tile units, not pixels).
             * @param layer The Tilemap Layer to act upon.
             */
            function HasTileAt(tileX: number, tileY: number, layer: Phaser.Tilemaps.LayerData): boolean | null;

            /**
             * Checks if there is a tile at the given location (in world coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * @param worldX The X coordinate of the world position.
             * @param worldY The Y coordinate of the world position.
             * @param camera The Camera to use when factoring in which tiles to return.
             * @param layer The Tilemap Layer to act upon.
             */
            function HasTileAtWorldXY(worldX: number, worldY: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): boolean | null;

            /**
             * Returns the bounds in the given layer that are within the camera's viewport.
             * This is used internally by the cull tiles function.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             */
            function HexagonalCullBounds(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera): object;

            /**
             * Returns the tiles in the given layer that are within the cameras viewport. This is used internally.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             * @param outputArray An optional array to store the Tile objects within.
             * @param renderOrder The rendering order constant. Default 0.
             */
            function HexagonalCullTiles(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera, outputArray?: any[], renderOrder?: number): Phaser.Tilemaps.Tile[];

            /**
             * Gets the corners of the Hexagonal Tile as an array of Vector2s.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function HexagonalGetTileCorners(tileX: number, tileY: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2[];

            /**
             * Converts from hexagonal tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function HexagonalTileToWorldXY(tileX: number, tileY: number, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from world XY coordinates (pixels) to hexagonal tile XY coordinates (tile units), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinates down to the nearest integer.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function HexagonalWorldToTileXY(worldX: number, worldY: number, snapToFloor: boolean, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Checks if the given tile coordinates are within the bounds of the layer.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param layer The Tilemap Layer to act upon.
             */
            function IsInLayerBounds(tileX: number, tileY: number, layer: Phaser.Tilemaps.LayerData): boolean;

            /**
             * Returns the tiles in the given layer that are within the cameras viewport. This is used internally.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             * @param outputArray An optional array to store the Tile objects within.
             * @param renderOrder The rendering order constant. Default 0.
             */
            function IsometricCullTiles(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera, outputArray?: any[], renderOrder?: number): Phaser.Tilemaps.Tile[];

            /**
             * Converts from isometric tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function IsometricTileToWorldXY(tileX: number, tileY: number, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from world XY coordinates (pixels) to isometric tile XY coordinates (tile units), factoring in the
             * layers position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             * @param originTop Which is the active face of the isometric tile? The top (default, true), or the base? (false) Default true.
             */
            function IsometricWorldToTileXY(worldX: number, worldY: number, snapToFloor: boolean, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData, originTop?: boolean): Phaser.Math.Vector2;

            /**
             * Puts a tile at the given tile coordinates in the specified layer. You can pass in either an index
             * or a Tile object. If you pass in a Tile, all attributes will be copied over to the specified
             * location. If you pass in an index, only the index at the specified location will be changed.
             * Collision information will be recalculated at the specified location.
             * @param tile The index of this tile to set or a Tile object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The Tilemap Layer to act upon.
             */
            function PutTileAt(tile: number | Phaser.Tilemaps.Tile, tileX: number, tileY: number, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Puts a tile at the given world coordinates (pixels) in the specified layer. You can pass in either
             * an index or a Tile object. If you pass in a Tile, all attributes will be copied over to the
             * specified location. If you pass in an index, only the index at the specified location will be
             * changed. Collision information will be recalculated at the specified location.
             * @param tile The index of this tile to set or a Tile object.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function PutTileAtWorldXY(tile: number | Phaser.Tilemaps.Tile, worldX: number, worldY: number, recalculateFaces: boolean, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Puts an array of tiles or a 2D array of tiles at the given tile coordinates in the specified
             * layer. The array can be composed of either tile indexes or Tile objects. If you pass in a Tile,
             * all attributes will be copied over to the specified location. If you pass in an index, only the
             * index at the specified location will be changed. Collision information will be recalculated
             * within the region tiles were changed.
             * @param tile A row (array) or grid (2D array) of Tiles or tile indexes to place.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The Tilemap Layer to act upon.
             */
            function PutTilesAt(tile: number[] | number[][] | Phaser.Tilemaps.Tile[] | Phaser.Tilemaps.Tile[][], tileX: number, tileY: number, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. If an array of indexes is passed in, then
             * those will be used for randomly assigning new tile indexes. If an array is not provided, the
             * indexes found within the region (excluding -1) will be used for randomly assigning new tile
             * indexes. This method only modifies tile indexes and does not change collision information.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param indexes An array of indexes to randomly draw from during randomization.
             * @param layer The Tilemap Layer to act upon.
             */
            function Randomize(tileX: number, tileY: number, width: number, height: number, indexes: number[], layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Removes the tile at the given tile coordinates in the specified layer and updates the layer's
             * collision information.
             * @param tileX The x coordinate.
             * @param tileY The y coordinate.
             * @param replaceWithNull If true, this will replace the tile at the specified location with null instead of a Tile with an index of -1.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The Tilemap Layer to act upon.
             */
            function RemoveTileAt(tileX: number, tileY: number, replaceWithNull: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Removes the tile at the given world coordinates in the specified layer and updates the layer's
             * collision information.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param replaceWithNull If true, this will replace the tile at the specified location with null instead of a Tile with an index of -1.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function RemoveTileAtWorldXY(worldX: number, worldY: number, replaceWithNull: boolean, recalculateFaces: boolean, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Tilemaps.Tile;

            /**
             * Draws a debug representation of the layer to the given Graphics. This is helpful when you want to
             * get a quick idea of which of your tiles are colliding and which have interesting faces. The tiles
             * are drawn starting at (0, 0) in the Graphics, allowing you to place the debug representation
             * wherever you want on the screen.
             * @param graphics The target Graphics object to draw upon.
             * @param styleConfig An object specifying the colors to use for the debug drawing.
             * @param layer The Tilemap Layer to act upon.
             */
            function RenderDebug(graphics: Phaser.GameObjects.Graphics, styleConfig: Phaser.Types.Tilemaps.DebugStyleOptions, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `findIndex` and updates their index to match `newIndex`. This only modifies the index and does
             * not change collision information.
             * @param findIndex The index of the tile to search for.
             * @param newIndex The index of the tile to replace it with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The Tilemap Layer to act upon.
             */
            function ReplaceByIndex(findIndex: number, newIndex: number, tileX: number, tileY: number, width: number, height: number, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Returns the tiles in the given layer that are within the cameras viewport. This is used internally.
             * @param layer The Tilemap Layer to act upon.
             * @param bounds An object containing the `left`, `right`, `top` and `bottom` bounds.
             * @param renderOrder The rendering order constant.
             * @param outputArray The array to store the Tile objects within.
             */
            function RunCull(layer: Phaser.Tilemaps.LayerData, bounds: object, renderOrder: number, outputArray: any[]): Phaser.Tilemaps.Tile[];

            /**
             * Sets collision on the given tile or tiles within a layer by index. You can pass in either a
             * single numeric index or an array of indexes: [2, 3, 15, 20]. The `collides` parameter controls if
             * collision will be enabled (true) or disabled (false).
             * @param indexes Either a single tile index, or an array of tile indexes.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The Tilemap Layer to act upon.
             * @param updateLayer If true, updates the current tiles on the layer. Set to false if no tiles have been placed for significant performance boost. Default true.
             */
            function SetCollision(indexes: number | any[], collides: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData, updateLayer?: boolean): void;

            /**
             * Sets collision on a range of tiles in a layer whose index is between the specified `start` and
             * `stop` (inclusive). Calling this with a start value of 10 and a stop value of 14 would set
             * collision for tiles 10, 11, 12, 13 and 14. The `collides` parameter controls if collision will be
             * enabled (true) or disabled (false).
             * @param start The first index of the tile to be set for collision.
             * @param stop The last index of the tile to be set for collision.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The Tilemap Layer to act upon.
             * @param updateLayer If true, updates the current tiles on the layer. Set to false if no tiles have been placed for significant performance boost. Default true.
             */
            function SetCollisionBetween(start: number, stop: number, collides: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData, updateLayer?: boolean): void;

            /**
             * Sets collision on all tiles in the given layer, except for tiles that have an index specified in
             * the given array. The `collides` parameter controls if collision will be enabled (true) or
             * disabled (false). Tile indexes not currently in the layer are not affected.
             * @param indexes An array of the tile indexes to not be counted for collision.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The Tilemap Layer to act upon.
             */
            function SetCollisionByExclusion(indexes: number[], collides: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Sets collision on the tiles within a layer by checking tile properties. If a tile has a property
             * that matches the given properties object, its collision flag will be set. The `collides`
             * parameter controls if collision will be enabled (true) or disabled (false). Passing in
             * `{ collides: true }` would update the collision flag on any tiles with a "collides" property that
             * has a value of true. Any tile that doesn't have "collides" set to true will be ignored. You can
             * also use an array of values, e.g. `{ types: ["stone", "lava", "sand" ] }`. If a tile has a
             * "types" property that matches any of those values, its collision flag will be updated.
             * @param properties An object with tile properties and corresponding values that should be checked.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The Tilemap Layer to act upon.
             */
            function SetCollisionByProperty(properties: object, collides: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Sets collision on the tiles within a layer by checking each tile's collision group data
             * (typically defined in Tiled within the tileset collision editor). If any objects are found within
             * a tile's collision group, the tile's colliding information will be set. The `collides` parameter
             * controls if collision will be enabled (true) or disabled (false).
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The Tilemap Layer to act upon.
             */
            function SetCollisionFromCollisionGroup(collides: boolean, recalculateFaces: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Internally used method to keep track of the tile indexes that collide within a layer. This
             * updates LayerData.collideIndexes to either contain or not contain the given `tileIndex`.
             * @param tileIndex The tile index to set the collision boolean for.
             * @param collides Should the tile index collide or not?
             * @param layer The Tilemap Layer to act upon.
             */
            function SetLayerCollisionIndex(tileIndex: number, collides: boolean, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Internally used method to set the colliding state of a tile. This does not recalculate
             * interesting faces.
             * @param tile The Tile to set the collision on.
             * @param collides Should the tile index collide or not? Default true.
             */
            function SetTileCollision(tile: Phaser.Tilemaps.Tile, collides?: boolean): void;

            /**
             * Sets a global collision callback for the given tile index within the layer. This will affect all
             * tiles on this layer that have the same index. If a callback is already set for the tile index it
             * will be replaced. Set the callback to null to remove it. If you want to set a callback for a tile
             * at a specific location on the map then see setTileLocationCallback.
             * @param indexes Either a single tile index, or an array of tile indexes to have a collision callback set for.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context under which the callback is called.
             * @param layer The Tilemap Layer to act upon.
             */
            function SetTileIndexCallback(indexes: number | any[], callback: Function, callbackContext: object, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Sets a collision callback for the given rectangular area (in tile coordinates) within the layer.
             * If a callback is already set for the tile index it will be replaced. Set the callback to null to
             * remove it.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context under which the callback is called.
             * @param layer The Tilemap Layer to act upon.
             */
            function SetTileLocationCallback(tileX: number, tileY: number, width: number, height: number, callback: Function, callbackContext: object, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Shuffles the tiles in a rectangular region (specified in tile coordinates) within the given
             * layer. It will only randomize the tiles in that area, so if they're all the same nothing will
             * appear to have changed! This method only modifies tile indexes and does not change collision
             * information.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The Tilemap Layer to act upon.
             */
            function Shuffle(tileX: number, tileY: number, width: number, height: number, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Returns the bounds in the given layer that are within the camera's viewport.
             * This is used internally by the cull tiles function.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             */
            function StaggeredCullBounds(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera): object;

            /**
             * Returns the tiles in the given layer that are within the cameras viewport. This is used internally.
             * @param layer The Tilemap Layer to act upon.
             * @param camera The Camera to run the cull check against.
             * @param outputArray An optional array to store the Tile objects within.
             * @param renderOrder The rendering order constant. Default 0.
             */
            function StaggeredCullTiles(layer: Phaser.Tilemaps.LayerData, camera: Phaser.Cameras.Scene2D.Camera, outputArray?: any[], renderOrder?: number): Phaser.Tilemaps.Tile[];

            /**
             * Converts from staggered tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function StaggeredTileToWorldXY(tileX: number, tileY: number, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from staggered tile Y coordinates (tile units) to world Y coordinates (pixels), factoring in the
             * layers position, scale and scroll.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function StaggeredTileToWorldY(tileY: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): number;

            /**
             * Converts from world XY coordinates (pixels) to staggered tile XY coordinates (tile units), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function StaggeredWorldToTileXY(worldX: number, worldY: number, snapToFloor: boolean, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from world Y coordinates (pixels) to staggered tile Y coordinates (tile units), factoring in the
             * layers position, scale and scroll.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function StaggeredWorldToTileY(worldY: number, snapToFloor: boolean, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): number;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `indexA` and swaps then with `indexB`. This only modifies the index and does not change collision
             * information.
             * @param tileA First tile index.
             * @param tileB Second tile index.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The Tilemap Layer to act upon.
             */
            function SwapByIndex(tileA: number, tileB: number, tileX: number, tileY: number, width: number, height: number, layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Converts from tile X coordinates (tile units) to world X coordinates (pixels), factoring in the
             * layer's position, scale and scroll.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function TileToWorldX(tileX: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): number;

            /**
             * Converts from tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function TileToWorldXY(tileX: number, tileY: number, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from tile Y coordinates (tile units) to world Y coordinates (pixels), factoring in the
             * layer's position, scale and scroll.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function TileToWorldY(tileY: number, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): number;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. New indexes are drawn from the given
             * weightedIndexes array. An example weighted array:
             * 
             * [
             *  { index: 6, weight: 4 },    // Probability of index 6 is 4 / 8
             *  { index: 7, weight: 2 },    // Probability of index 7 would be 2 / 8
             *  { index: 8, weight: 1.5 },  // Probability of index 8 would be 1.5 / 8
             *  { index: 26, weight: 0.5 }  // Probability of index 27 would be 0.5 / 8
             * ]
             * 
             * The probability of any index being choose is (the index's weight) / (sum of all weights). This
             * method only modifies tile indexes and does not change collision information.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param weightedIndexes An array of objects to randomly draw from during
             * randomization. They should be in the form: { index: 0, weight: 4 } or
             * { index: [0, 1], weight: 4 } if you wish to draw from multiple tile indexes.
             * @param layer The Tilemap Layer to act upon.
             */
            function WeightedRandomize(tileX: number, tileY: number, width: number, height: number, weightedIndexes: object[], layer: Phaser.Tilemaps.LayerData): void;

            /**
             * Converts from world X coordinates (pixels) to tile X coordinates (tile units), factoring in the
             * layer's position, scale and scroll.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function WorldToTileX(worldX: number, snapToFloor: boolean, camera: Phaser.Cameras.Scene2D.Camera | undefined, layer: Phaser.Tilemaps.LayerData): number;

            /**
             * Converts from world XY coordinates (pixels) to tile XY coordinates (tile units), factoring in the
             * layer's position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function WorldToTileXY(worldX: number, worldY: number, snapToFloor: boolean, point: Phaser.Math.Vector2, camera: Phaser.Cameras.Scene2D.Camera, layer: Phaser.Tilemaps.LayerData): Phaser.Math.Vector2;

            /**
             * Converts from world Y coordinates (pixels) to tile Y coordinates (tile units), factoring in the
             * layer's position, scale and scroll.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The Tilemap Layer to act upon.
             */
            function WorldToTileY(worldY: number, snapToFloor: boolean, camera: Phaser.Cameras.Scene2D.Camera | undefined, layer: Phaser.Tilemaps.LayerData): number;

        }

        /**
         * Phaser Tilemap constants for orientation.
         */
        enum Orientation {
            /**
             * Orthogonal Tilemap orientation constant.
             */
            ORTHOGONAL,
            /**
             * Isometric Tilemap orientation constant.
             */
            ISOMETRIC,
            /**
             * Staggered Tilemap orientation constant.
             */
            STAGGERED,
            /**
             * Hexagonal Tilemap orientation constant.
             */
            HEXAGONAL,
        }

        /**
         * Phaser Tilemap constants for orientation.
         * 
         * To find out what each mode does please see [Phaser.Tilemaps.Orientation]{@link Phaser.Tilemaps.Orientation}.
         */
        type OrientationType = Phaser.Tilemaps.Orientation;

        namespace Formats {
            /**
             * CSV Map Type
             */
            var CSV: number;

            /**
             * Tiled JSON Map Type
             */
            var TILED_JSON: number;

            /**
             * 2D Array Map Type
             */
            var ARRAY_2D: number;

            /**
             * Weltmeister (Impact.js) Map Type
             */
            var WELTMEISTER: number;

        }

        /**
         * An Image Collection is a special Tile Set containing multiple images, with no slicing into each image.
         * 
         * Image Collections are normally created automatically when Tiled data is loaded.
         */
        class ImageCollection {
            /**
             * 
             * @param name The name of the image collection in the map data.
             * @param firstgid The first image index this image collection contains.
             * @param width Width of widest image (in pixels). Default 32.
             * @param height Height of tallest image (in pixels). Default 32.
             * @param margin The margin around all images in the collection (in pixels). Default 0.
             * @param spacing The spacing between each image in the collection (in pixels). Default 0.
             * @param properties Custom Image Collection properties. Default {}.
             */
            constructor(name: string, firstgid: number, width?: number, height?: number, margin?: number, spacing?: number, properties?: object);

            /**
             * The name of the Image Collection.
             */
            name: string;

            /**
             * The Tiled firstgid value.
             * This is the starting index of the first image index this Image Collection contains.
             */
            firstgid: number;

            /**
             * The width of the widest image (in pixels).
             */
            readonly imageWidth: number;

            /**
             * The height of the tallest image (in pixels).
             */
            readonly imageHeight: number;

            /**
             * The margin around the images in the collection (in pixels).
             * Use `setSpacing` to change.
             */
            readonly imageMarge: number;

            /**
             * The spacing between each image in the collection (in pixels).
             * Use `setSpacing` to change.
             */
            readonly imageSpacing: number;

            /**
             * Image Collection-specific properties that are typically defined in the Tiled editor.
             */
            properties: object;

            /**
             * The cached images that are a part of this collection.
             */
            readonly images: any[];

            /**
             * The total number of images in the image collection.
             */
            readonly total: number;

            /**
             * Returns true if and only if this image collection contains the given image index.
             * @param imageIndex The image index to search for.
             */
            containsImageIndex(imageIndex: number): boolean;

            /**
             * Add an image to this Image Collection.
             * @param gid The gid of the image in the Image Collection.
             * @param image The the key of the image in the Image Collection and in the cache.
             */
            addImage(gid: number, image: string): Phaser.Tilemaps.ImageCollection;

        }

        /**
         * A class for representing data about about a layer in a map. Maps are parsed from CSV, Tiled,
         * etc. into this format. Tilemap and TilemapLayer objects have a reference
         * to this data and use it to look up and perform operations on tiles.
         */
        class LayerData {
            /**
             * 
             * @param config The Layer Data configuration object.
             */
            constructor(config?: Phaser.Types.Tilemaps.LayerDataConfig);

            /**
             * The name of the layer, if specified in Tiled.
             */
            name: string;

            /**
             * The id of the layer, as specified in the map data.
             * 
             * Note: This is not the index of the layer in the map data, but its actual ID in Tiled.
             */
            id: number;

            /**
             * The x offset of where to draw from the top left.
             */
            x: number;

            /**
             * The y offset of where to draw from the top left.
             */
            y: number;

            /**
             * The width of the layer in tiles.
             */
            width: number;

            /**
             * The height of the layer in tiles.
             */
            height: number;

            /**
             * The pixel width of the tiles.
             */
            tileWidth: number;

            /**
             * The pixel height of the tiles.
             */
            tileHeight: number;

            /**
             * The base tile width.
             */
            baseTileWidth: number;

            /**
             * The base tile height.
             */
            baseTileHeight: number;

            /**
             * The layers orientation, necessary to be able to determine a tiles pixelX and pixelY as well as the layers width and height.
             */
            orientation: Phaser.Tilemaps.OrientationType;

            /**
             * The width in pixels of the entire layer.
             */
            widthInPixels: number;

            /**
             * The height in pixels of the entire layer.
             */
            heightInPixels: number;

            /**
             * The alpha value of the layer.
             */
            alpha: number;

            /**
             * Is the layer visible or not?
             */
            visible: boolean;

            /**
             * Layer specific properties (can be specified in Tiled)
             */
            properties: object[];

            /**
             * Tile ID index map.
             */
            indexes: any[];

            /**
             * Tile Collision ID index map.
             */
            collideIndexes: any[];

            /**
             * An array of callbacks.
             */
            callbacks: any[];

            /**
             * An array of physics bodies.
             */
            bodies: any[];

            /**
             * An array of the tile data indexes.
             */
            data: Phaser.Tilemaps.Tile[][];

            /**
             * A reference to the Tilemap layer that owns this data.
             */
            tilemapLayer: Phaser.Tilemaps.TilemapLayer;

            /**
             * The length of the horizontal sides of the hexagon.
             * Only used for hexagonal orientation Tilemaps.
             */
            hexSideLength: number;

            /**
             * The Stagger Axis as defined in Tiled.
             * 
             * Only used for hexagonal orientation Tilemaps.
             */
            staggerAxis: string;

            /**
             * The Stagger Index as defined in Tiled.
             * 
             * Either 'odd' or 'even'.
             * 
             * Only used for hexagonal orientation Tilemaps.
             */
            staggerIndex: string;

        }

        /**
         * A class for representing data about a map. Maps are parsed from CSV, Tiled, etc. into this
         * format. A Tilemap object get a copy of this data and then unpacks the needed properties into
         * itself.
         */
        class MapData {
            /**
             * 
             * @param config The Map configuration object.
             */
            constructor(config?: Phaser.Types.Tilemaps.MapDataConfig);

            /**
             * The key in the Phaser cache that corresponds to the loaded tilemap data.
             */
            name: string;

            /**
             * The width of the entire tilemap.
             */
            width: number;

            /**
             * The height of the entire tilemap.
             */
            height: number;

            /**
             * If the map is infinite or not.
             */
            infinite: boolean;

            /**
             * The width of the tiles.
             */
            tileWidth: number;

            /**
             * The height of the tiles.
             */
            tileHeight: number;

            /**
             * The width in pixels of the entire tilemap.
             */
            widthInPixels: number;

            /**
             * The height in pixels of the entire tilemap.
             */
            heightInPixels: number;

            /**
             * The format of the map data.
             */
            format: number;

            /**
             * The orientation of the map data (i.e. orthogonal, isometric, hexagonal), default 'orthogonal'.
             */
            orientation: Phaser.Tilemaps.OrientationType;

            /**
             * Determines the draw order of tilemap. Default is right-down
             * 
             * 0, or 'right-down'
             * 1, or 'left-down'
             * 2, or 'right-up'
             * 3, or 'left-up'
             */
            renderOrder: string;

            /**
             * The version of the map data (as specified in Tiled).
             */
            version: string;

            /**
             * Map specific properties (can be specified in Tiled)
             */
            properties: object;

            /**
             * An array with all the layers configured to the MapData.
             */
            layers: Phaser.Tilemaps.LayerData[] | Phaser.Tilemaps.ObjectLayer;

            /**
             * An array of Tiled Image Layers.
             */
            images: any[];

            /**
             * An object of Tiled Object Layers.
             */
            objects: Phaser.Types.Tilemaps.ObjectLayerConfig[];

            /**
             * An object of collision data. Must be created as physics object or will return undefined.
             */
            collision: object;

            /**
             * An array of Tilesets.
             */
            tilesets: Phaser.Tilemaps.Tileset[];

            /**
             * The collection of images the map uses(specified in Tiled)
             */
            imageCollections: any[];

            /**
             * An array of tile instances.
             */
            tiles: any[];

            /**
             * The length of the horizontal sides of the hexagon.
             * 
             * Only used for hexagonal orientation Tilemaps.
             */
            hexSideLength: number;

            /**
             * The Stagger Axis as defined in Tiled.
             * 
             * Only used for hexagonal orientation Tilemaps.
             */
            staggerAxis: string;

            /**
             * The Stagger Index as defined in Tiled.
             * 
             * Either 'odd' or 'even'.
             * 
             * Only used for hexagonal orientation Tilemaps.
             */
            staggerIndex: string;

        }

        /**
         * A class for representing a Tiled object layer in a map. This mirrors the structure of a Tiled
         * object layer, except:
         *  - "x" & "y" properties are ignored since these cannot be changed in Tiled.
         *  - "offsetx" & "offsety" are applied to the individual object coordinates directly, so they
         *    are ignored as well.
         *  - "draworder" is ignored.
         */
        class ObjectLayer {
            /**
             * 
             * @param config The data for the layer from the Tiled JSON object.
             */
            constructor(config?: Phaser.Types.Tilemaps.ObjectLayerConfig);

            /**
             * The name of the Object Layer.
             */
            name: string;

            /**
             * The id of the object layer, as specified in the map data.
             */
            id: number;

            /**
             * The opacity of the layer, between 0 and 1.
             */
            opacity: number;

            /**
             * The custom properties defined on the Object Layer, keyed by their name.
             */
            properties: object;

            /**
             * The type of each custom property defined on the Object Layer, keyed by its name.
             */
            propertyTypes: object;

            /**
             * The type of the layer, which should be `objectgroup`.
             */
            type: string;

            /**
             * Whether the layer is shown (`true`) or hidden (`false`).
             */
            visible: boolean;

            /**
             * An array of all objects on this Object Layer.
             * 
             * Each Tiled object corresponds to a JavaScript object in this array. It has an `id` (unique),
             * `name` (as assigned in Tiled), `type` (as assigned in Tiled), `rotation` (in clockwise degrees),
             * `properties` (if any), `visible` state (`true` if visible, `false` otherwise),
             * `x` and `y` coordinates (in pixels, relative to the tilemap), and a `width` and `height` (in pixels).
             * 
             * An object tile has a `gid` property (GID of the represented tile), a `flippedHorizontal` property,
             * a `flippedVertical` property, and `flippedAntiDiagonal` property.
             * The {@link http://docs.mapeditor.org/en/latest/reference/tmx-map-format/|Tiled documentation} contains
             * information on flipping and rotation.
             * 
             * Polylines have a `polyline` property, which is an array of objects corresponding to points,
             * where each point has an `x` property and a `y` property. Polygons have an identically structured
             * array in their `polygon` property. Text objects have a `text` property with the text's properties.
             * 
             * Rectangles and ellipses have a `rectangle` or `ellipse` property set to `true`.
             */
            objects: Phaser.Types.Tilemaps.TiledObject[];

        }

        /**
         * The ObjectHelper helps tie objects with `gids` into the tileset
         * that sits behind them.
         */
        class ObjectHelper {
            /**
             * 
             * @param tilesets The backing tileset data.
             */
            constructor(tilesets: Phaser.Tilemaps.Tileset[]);

            /**
             * The Tile GIDs array.
             */
            gids: any[];

            /**
             * Enabled if the object helper reaches in to tilesets for data.
             * Disabled if it only uses data directly on a gid object.
             */
            enabled: boolean;

            /**
             * Gets the Tiled `type` field value from the object or the `gid` behind it.
             * @param obj The Tiled object to investigate.
             */
            getTypeIncludingTile(obj: Phaser.Types.Tilemaps.TiledObject): string | null;

            /**
             * Sets the sprite texture data as specified (usually in a config) or, failing that,
             * as specified in the `gid` of the object being loaded (if any).
             * 
             * This fallback will only work if the tileset was loaded as a spritesheet matching
             * the geometry of sprites fed into tiled, so that, for example: "tile id #`3`"" within
             * the tileset is the same as texture frame `3` from the image of the tileset.
             * @param sprite The Game Object to modify.
             * @param key The texture key to set (or else the `obj.gid`'s tile is used if available).
             * @param frame The frames key to set (or else the `obj.gid`'s tile is used if available).
             * @param obj The Tiled object for fallback.
             */
            setTextureAndFrame(sprite: Phaser.GameObjects.GameObject, key?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame, obj?: Phaser.Types.Tilemaps.TiledObject): void;

            /**
             * Sets the `sprite.data` field from the tiled properties on the object and its tile (if any).
             */
            setPropertiesFromTiledObject(sprite: Phaser.GameObjects.GameObject, obj: Phaser.Types.Tilemaps.TiledObject): void;

        }

        namespace Parsers {
            /**
             * Get the Tilemap orientation from the given string.
             * @param orientation The orientation type as a string.
             */
            function FromOrientationString(orientation?: string): Phaser.Tilemaps.OrientationType;

            namespace Impact {
                /**
                 * Parses all tilemap layers in an Impact JSON object into new LayerData objects.
                 * @param json The Impact JSON object.
                 * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
                 * data are handled (see {@link Phaser.Tilemaps.Parsers.Tiled.ParseJSONTiled}).
                 */
                function ParseTileLayers(json: object, insertNull: boolean): Phaser.Tilemaps.LayerData[];

                /**
                 * Tilesets and Image Collections
                 * @param json The Impact JSON data.
                 */
                function ParseTilesets(json: object): any[];

                /**
                 * Parses a Weltmeister JSON object into a new MapData object.
                 * @param name The name of the tilemap, used to set the name on the MapData.
                 * @param json The Weltmeister JSON object.
                 * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
                 * data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
                 * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
                 * the tile data doesn't need to change then setting this value to `true` will help with memory
                 * consumption. However if your map is small or you need to update the tiles dynamically, then leave
                 * the default value set.
                 */
                function ParseWeltmeister(name: string, json: object, insertNull: boolean): Phaser.Tilemaps.MapData | null;

            }

            /**
             * Parses raw data of a given Tilemap format into a new MapData object. If no recognized data format
             * is found, returns `null`. When loading from CSV or a 2D array, you should specify the tileWidth &
             * tileHeight. When parsing from a map from Tiled, the tileWidth & tileHeight will be pulled from
             * the map data.
             * @param name The name of the tilemap, used to set the name on the MapData.
             * @param mapFormat See ../Formats.js.
             * @param data 2D array, CSV string or Tiled JSON object.
             * @param tileWidth The width of a tile in pixels. Required for 2D array and CSV, but
             * ignored for Tiled JSON.
             * @param tileHeight The height of a tile in pixels. Required for 2D array and CSV, but
             * ignored for Tiled JSON.
             * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
             * data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
             * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
             * the tile data doesn't need to change then setting this value to `true` will help with memory
             * consumption. However if your map is small or you need to update the tiles dynamically, then leave
             * the default value set.
             */
            function Parse(name: string, mapFormat: number, data: number[][] | string | object, tileWidth: number, tileHeight: number, insertNull: boolean): Phaser.Tilemaps.MapData;

            /**
             * Parses a 2D array of tile indexes into a new MapData object with a single layer.
             * @param name The name of the tilemap, used to set the name on the MapData.
             * @param data 2D array, CSV string or Tiled JSON object.
             * @param tileWidth The width of a tile in pixels.
             * @param tileHeight The height of a tile in pixels.
             * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
             * data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
             * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
             * the tile data doesn't need to change then setting this value to `true` will help with memory
             * consumption. However if your map is small or you need to update the tiles dynamically, then leave
             * the default value set.
             */
            function Parse2DArray(name: string, data: number[][], tileWidth: number, tileHeight: number, insertNull: boolean): Phaser.Tilemaps.MapData;

            /**
             * Parses a CSV string of tile indexes into a new MapData object with a single layer.
             * @param name The name of the tilemap, used to set the name on the MapData.
             * @param data CSV string of tile indexes.
             * @param tileWidth The width of a tile in pixels.
             * @param tileHeight The height of a tile in pixels.
             * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
             * data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
             * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
             * the tile data doesn't need to change then setting this value to `true` will help with memory
             * consumption. However if your map is small or you need to update the tiles dynamically, then leave
             * the default value set.
             */
            function ParseCSV(name: string, data: string, tileWidth: number, tileHeight: number, insertNull: boolean): Phaser.Tilemaps.MapData;

            namespace Tiled {
                /**
                 * Copy properties from tileset to tiles.
                 * @param mapData The Map Data object.
                 */
                function AssignTileProperties(mapData: Phaser.Tilemaps.MapData): void;

                /**
                 * Decode base-64 encoded data, for example as exported by Tiled.
                 * @param data Base-64 encoded data to decode.
                 */
                function Base64Decode(data: object): any[];

                /**
                 * Master list of tiles -> x, y, index in tileset.
                 * @param mapData The Map Data object.
                 */
                function BuildTilesetIndex(mapData: Phaser.Tilemaps.MapData | Phaser.Tilemaps.Tilemap): any[];

                /**
                 * Parse a Tiled group layer and create a state object for inheriting.
                 * @param json The Tiled JSON object.
                 * @param group The current group layer from the Tiled JSON file.
                 * @param parentState The state of the parent group (if any).
                 */
                function CreateGroupLayer(json: object, group?: object, parentState?: object): object;

                /**
                 * See Tiled documentation on tile flipping:
                 * http://docs.mapeditor.org/en/latest/reference/tmx-map-format/
                 * @param gid A Tiled GID.
                 */
                function ParseGID(gid: number): Phaser.Types.Tilemaps.GIDData;

                /**
                 * Parses a Tiled JSON object into an array of objects with details about the image layers.
                 * @param json The Tiled JSON object.
                 */
                function ParseImageLayers(json: object): any[];

                /**
                 * Parses a Tiled JSON object into a new MapData object.
                 * @param name The name of the tilemap, used to set the name on the MapData.
                 * @param source The original Tiled JSON object. This is deep copied by this function.
                 * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
                 * data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
                 * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
                 * the tile data doesn't need to change then setting this value to `true` will help with memory
                 * consumption. However if your map is small or you need to update the tiles dynamically, then leave
                 * the default value set.
                 */
                function ParseJSONTiled(name: string, source: object, insertNull: boolean): Phaser.Tilemaps.MapData | null;

                /**
                 * Convert a Tiled object to an internal parsed object normalising and copying properties over, while applying optional x and y offsets. The parsed object will always have the properties `id`, `name`, `type`, `rotation`, `properties`, `visible`, `x`, `y`, `width` and `height`. Other properties will be added according to the object type (such as text, polyline, gid etc.)
                 * @param tiledObject Tiled object to convert to an internal parsed object normalising and copying properties over.
                 * @param offsetX Optional additional offset to apply to the object's x property. Defaults to 0. Default 0.
                 * @param offsetY Optional additional offset to apply to the object's y property. Defaults to 0. Default 0.
                 */
                function ParseObject(tiledObject: object, offsetX?: number, offsetY?: number): object;

                /**
                 * Parses a Tiled JSON object into an array of ObjectLayer objects.
                 * @param json The Tiled JSON object.
                 */
                function ParseObjectLayers(json: object): any[];

                /**
                 * Parses all tilemap layers in a Tiled JSON object into new LayerData objects.
                 * @param json The Tiled JSON object.
                 * @param insertNull Controls how empty tiles, tiles with an index of -1, in the map
                 * data are handled (see {@link Phaser.Tilemaps.Parsers.Tiled.ParseJSONTiled}).
                 */
                function ParseTileLayers(json: object, insertNull: boolean): Phaser.Tilemaps.LayerData[];

                /**
                 * Tilesets and Image Collections.
                 * @param json The Tiled JSON data.
                 */
                function ParseTilesets(json: object): object;

                /**
                 * Parses out the Wangset information from Tiled 1.1.5+ map data, if present.
                 * 
                 * Since a given tile can be in more than one wangset, the resulting properties
                 * are nested. `tile.data.wangid[someWangsetName]` will return the array-based wang id in
                 * this implementation.
                 * 
                 * Note that we're not guaranteed that there will be any 'normal' tiles if the only
                 * thing in the tilset are wangtile definitions, so this has to be parsed separately.
                 * 
                 * See https://doc.mapeditor.org/en/latest/manual/using-wang-tiles/ for more information.
                 * @param wangsets The array of wangset objects (parsed from JSON)
                 * @param datas The field into which to put wangset data from Tiled.
                 */
                function ParseWangsets(wangsets: object[], datas: object): object;

            }

        }

        /**
         * Create a Tilemap from the given key or data. If neither is given, make a blank Tilemap. When
         * loading from CSV or a 2D array, you should specify the tileWidth & tileHeight. When parsing from
         * a map from Tiled, the tileWidth, tileHeight, width & height will be pulled from the map data. For
         * an empty map, you should specify tileWidth, tileHeight, width & height.
         * @param scene The Scene to which this Tilemap belongs.
         * @param key The key in the Phaser cache that corresponds to the loaded tilemap data.
         * @param tileWidth The width of a tile in pixels. Default 32.
         * @param tileHeight The height of a tile in pixels. Default 32.
         * @param width The width of the map in tiles. Default 10.
         * @param height The height of the map in tiles. Default 10.
         * @param data Instead of loading from the cache, you can also load directly from
         * a 2D array of tile indexes.
         * @param insertNull Controls how empty tiles, tiles with an index of -1, in the
         * map data are handled. If `true`, empty locations will get a value of `null`. If `false`, empty
         * location will get a Tile object with an index of -1. If you've a large sparsely populated map and
         * the tile data doesn't need to change then setting this value to `true` will help with memory
         * consumption. However if your map is small or you need to update the tiles dynamically, then leave
         * the default value set. Default false.
         */
        function ParseToTilemap(scene: Phaser.Scene, key?: string, tileWidth?: number, tileHeight?: number, width?: number, height?: number, data?: number[][], insertNull?: boolean): Phaser.Tilemaps.Tilemap;

        /**
         * A Tile is a representation of a single tile within the Tilemap. This is a lightweight data
         * representation, so its position information is stored without factoring in scroll, layer
         * scale or layer position.
         */
        class Tile implements Phaser.GameObjects.Components.AlphaSingle, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.Visible {
            /**
             * 
             * @param layer The LayerData object in the Tilemap that this tile belongs to.
             * @param index The unique index of this tile within the map.
             * @param x The x coordinate of this tile in tile coordinates.
             * @param y The y coordinate of this tile in tile coordinates.
             * @param width Width of the tile in pixels.
             * @param height Height of the tile in pixels.
             * @param baseWidth The base width a tile in the map (in pixels). Tiled maps support
             * multiple tileset sizes within one map, but they are still placed at intervals of the base
             * tile width.
             * @param baseHeight The base height of the tile in pixels (in pixels). Tiled maps
             * support multiple tileset sizes within one map, but they are still placed at intervals of the
             * base tile height.
             */
            constructor(layer: Phaser.Tilemaps.LayerData, index: number, x: number, y: number, width: number, height: number, baseWidth: number, baseHeight: number);

            /**
             * The LayerData in the Tilemap data that this tile belongs to.
             */
            layer: Phaser.Tilemaps.LayerData;

            /**
             * The index of this tile within the map data corresponding to the tileset, or -1 if this
             * represents a blank tile.
             */
            index: number;

            /**
             * The x map coordinate of this tile in tile units.
             */
            x: number;

            /**
             * The y map coordinate of this tile in tile units.
             */
            y: number;

            /**
             * The width of the tile in pixels.
             */
            width: number;

            /**
             * The height of the tile in pixels.
             */
            height: number;

            /**
             * The right of the tile in pixels.
             * 
             * Set in the `updatePixelXY` method.
             */
            right: number;

            /**
             * The bottom of the tile in pixels.
             * 
             * Set in the `updatePixelXY` method.
             */
            bottom: number;

            /**
             * The maps base width of a tile in pixels. Tiled maps support multiple tileset sizes
             * within one map, but they are still placed at intervals of the base tile size.
             */
            baseWidth: number;

            /**
             * The maps base height of a tile in pixels. Tiled maps support multiple tileset sizes
             * within one map, but they are still placed at intervals of the base tile size.
             */
            baseHeight: number;

            /**
             * The x coordinate of the top left of this tile in pixels. This is relative to the top left
             * of the layer this tile is being rendered within. This property does NOT factor in camera
             * scroll, layer scale or layer position.
             */
            pixelX: number;

            /**
             * The y coordinate of the top left of this tile in pixels. This is relative to the top left
             * of the layer this tile is being rendered within. This property does NOT factor in camera
             * scroll, layer scale or layer position.
             */
            pixelY: number;

            /**
             * Tile specific properties. These usually come from Tiled.
             */
            properties: any;

            /**
             * The rotation angle of this tile.
             */
            rotation: number;

            /**
             * Whether the tile should collide with any object on the left side.
             * 
             * This property is used by Arcade Physics only, however, you can also use it
             * in your own checks.
             */
            collideLeft: boolean;

            /**
             * Whether the tile should collide with any object on the right side.
             * 
             * This property is used by Arcade Physics only, however, you can also use it
             * in your own checks.
             */
            collideRight: boolean;

            /**
             * Whether the tile should collide with any object on the top side.
             * 
             * This property is used by Arcade Physics only, however, you can also use it
             * in your own checks.
             */
            collideUp: boolean;

            /**
             * Whether the tile should collide with any object on the bottom side.
             * 
             * This property is used by Arcade Physics only, however, you can also use it
             * in your own checks.
             */
            collideDown: boolean;

            /**
             * Whether the tiles left edge is interesting for collisions.
             */
            faceLeft: boolean;

            /**
             * Whether the tiles right edge is interesting for collisions.
             */
            faceRight: boolean;

            /**
             * Whether the tiles top edge is interesting for collisions.
             */
            faceTop: boolean;

            /**
             * Whether the tiles bottom edge is interesting for collisions.
             */
            faceBottom: boolean;

            /**
             * Tile collision callback.
             */
            collisionCallback: Function;

            /**
             * The context in which the collision callback will be called.
             */
            collisionCallbackContext: object;

            /**
             * The tint to apply to this tile. Note: tint is currently a single color value instead of
             * the 4 corner tint component on other GameObjects.
             */
            tint: number;

            /**
             * The tint fill mode.
             * 
             * `false` = An additive tint (the default), where vertices colors are blended with the texture.
             * `true` = A fill tint, where the vertices colors replace the texture, but respects texture alpha.
             */
            tintFill: boolean;

            /**
             * An empty object where physics-engine specific information (e.g. bodies) may be stored.
             */
            physics: object;

            /**
             * Check if the given x and y world coordinates are within this Tile. This does not factor in
             * camera scroll, layer scale or layer position.
             * @param x The x coordinate to test.
             * @param y The y coordinate to test.
             */
            containsPoint(x: number, y: number): boolean;

            /**
             * Copies the tile data and properties from the given Tile to this Tile. This copies everything
             * except for position and interesting face calculations.
             * @param tile The tile to copy from.
             */
            copy(tile: Phaser.Tilemaps.Tile): this;

            /**
             * The collision group for this Tile, defined within the Tileset. This returns a reference to
             * the collision group stored within the Tileset, so any modification of the returned object
             * will impact all tiles that have the same index as this tile.
             */
            getCollisionGroup(): object | null;

            /**
             * The tile data for this Tile, defined within the Tileset. This typically contains Tiled
             * collision data, tile animations and terrain information. This returns a reference to the tile
             * data stored within the Tileset, so any modification of the returned object will impact all
             * tiles that have the same index as this tile.
             */
            getTileData(): object | null;

            /**
             * Gets the world X position of the left side of the tile, factoring in the layers position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getLeft(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Gets the world X position of the right side of the tile, factoring in the layer's position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getRight(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Gets the world Y position of the top side of the tile, factoring in the layer's position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getTop(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Gets the world Y position of the bottom side of the tile, factoring in the layer's position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getBottom(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Gets the world rectangle bounding box for the tile, factoring in the layers position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             * @param output Optional Rectangle object to store the results in.
             */
            getBounds(camera?: Phaser.Cameras.Scene2D.Camera, output?: Phaser.Geom.Rectangle): Phaser.Geom.Rectangle | object;

            /**
             * Gets the world X position of the center of the tile, factoring in the layer's position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getCenterX(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Gets the world Y position of the center of the tile, factoring in the layer's position,
             * scale and scroll.
             * @param camera The Camera to use to perform the check.
             */
            getCenterY(camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Check for intersection with this tile. This does not factor in camera scroll, layer scale or
             * layer position.
             * @param x The x axis in pixels.
             * @param y The y axis in pixels.
             * @param right The right point.
             * @param bottom The bottom point.
             */
            intersects(x: number, y: number, right: number, bottom: number): boolean;

            /**
             * Checks if the tile is interesting.
             * @param collides If true, will consider the tile interesting if it collides on any side.
             * @param faces If true, will consider the tile interesting if it has an interesting face.
             */
            isInteresting(collides: boolean, faces: boolean): boolean;

            /**
             * Reset collision status flags.
             * @param recalculateFaces Whether or not to recalculate interesting faces for this tile and its neighbors. Default true.
             */
            resetCollision(recalculateFaces?: boolean): this;

            /**
             * Reset faces.
             */
            resetFaces(): this;

            /**
             * Sets the collision flags for each side of this tile and updates the interesting faces list.
             * @param left Indicating collide with any object on the left.
             * @param right Indicating collide with any object on the right.
             * @param up Indicating collide with any object on the top.
             * @param down Indicating collide with any object on the bottom.
             * @param recalculateFaces Whether or not to recalculate interesting faces for this tile and its neighbors. Default true.
             */
            setCollision(left: boolean, right?: boolean, up?: boolean, down?: boolean, recalculateFaces?: boolean): this;

            /**
             * Set a callback to be called when this tile is hit by an object. The callback must true for
             * collision processing to take place.
             * @param callback Callback function.
             * @param context Callback will be called within this context.
             */
            setCollisionCallback(callback: Function, context: object): this;

            /**
             * Sets the size of the tile and updates its pixelX and pixelY.
             * @param tileWidth The width of the tile in pixels.
             * @param tileHeight The height of the tile in pixels.
             * @param baseWidth The base width a tile in the map (in pixels).
             * @param baseHeight The base height of the tile in pixels (in pixels).
             */
            setSize(tileWidth: number, tileHeight: number, baseWidth: number, baseHeight: number): this;

            /**
             * Used internally. Updates the tiles world XY position based on the current tile size.
             */
            updatePixelXY(): this;

            /**
             * Clean up memory.
             */
            destroy(): void;

            /**
             * True if this tile can collide on any of its faces or has a collision callback set.
             */
            readonly canCollide: boolean;

            /**
             * True if this tile can collide on any of its faces.
             */
            readonly collides: boolean;

            /**
             * True if this tile has any interesting faces.
             */
            readonly hasInterestingFace: boolean;

            /**
             * The tileset that contains this Tile. This is null if accessed from a LayerData instance
             * before the tile is placed in a TilemapLayer, or if the tile has an index that doesn't correspond
             * to any of the maps tilesets.
             */
            readonly tileset: Phaser.Tilemaps.Tileset | null;

            /**
             * The tilemap layer that contains this Tile. This will only return null if accessed from a
             * LayerData instance before the tile is placed within a TilemapLayer.
             */
            readonly tilemapLayer: Phaser.Tilemaps.TilemapLayer | null;

            /**
             * The tilemap that contains this Tile. This will only return null if accessed from a LayerData
             * instance before the tile is placed within a TilemapLayer.
             */
            readonly tilemap: Phaser.Tilemaps.Tilemap | null;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * @param value The alpha value applied across the whole Game Object. Default 1.
             */
            setAlpha(value?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

        }

        /**
         * A Tilemap is a container for Tilemap data. This isn't a display object, rather, it holds data
         * about the map and allows you to add tilesets and tilemap layers to it. A map can have one or
         * more tilemap layers, which are the display objects that actually render the tiles.
         * 
         * The Tilemap data can be parsed from a Tiled JSON file, a CSV file or a 2D array. Tiled is a free
         * software package specifically for creating tile maps, and is available from:
         * http://www.mapeditor.org
         * 
         * As of Phaser 3.50.0 the Tilemap API now supports the following types of map:
         * 
         * 1) Orthogonal
         * 2) Isometric
         * 3) Hexagonal
         * 4) Staggered
         * 
         * Prior to this release, only orthogonal maps were supported.
         * 
         * Another large change in 3.50 was the consolidation of Tilemap Layers. Previously, you created
         * either a Static or Dynamic Tilemap Layer. However, as of 3.50 the features of both have been
         * merged and the API simplified, so now there is just the single `TilemapLayer` class.
         * 
         * A Tilemap has handy methods for getting and manipulating the tiles within a layer, allowing
         * you to build or modify the tilemap data at runtime.
         * 
         * Note that all Tilemaps use a base tile size to calculate dimensions from, but that a
         * TilemapLayer may have its own unique tile size that overrides this.
         * 
         * As of Phaser 3.21.0, if your tilemap includes layer groups (a feature of Tiled 1.2.0+) these
         * will be traversed and the following properties will impact children:
         * 
         * - Opacity (blended with parent) and visibility (parent overrides child)
         * - Vertical and horizontal offset
         * 
         * The grouping hierarchy is not preserved and all layers will be flattened into a single array.
         * 
         * Group layers are parsed during Tilemap construction but are discarded after parsing so dynamic
         * layers will NOT continue to be affected by a parent.
         * 
         * To avoid duplicate layer names, a layer that is a child of a group layer will have its parent
         * group name prepended with a '/'.  For example, consider a group called 'ParentGroup' with a
         * child called 'Layer 1'. In the Tilemap object, 'Layer 1' will have the name
         * 'ParentGroup/Layer 1'.
         * 
         * The Phaser Tiled Parser does **not** support the 'Collection of Images' feature for a Tileset.
         * You must ensure all of your tiles are contained in a single tileset image file (per layer)
         * and have this 'embedded' in the exported Tiled JSON map data.
         */
        class Tilemap {
            /**
             * 
             * @param scene The Scene to which this Tilemap belongs.
             * @param mapData A MapData instance containing Tilemap data.
             */
            constructor(scene: Phaser.Scene, mapData: Phaser.Tilemaps.MapData);

            scene: Phaser.Scene;

            /**
             * The base width of a tile in pixels. Note that individual layers may have a different tile
             * width.
             */
            tileWidth: number;

            /**
             * The base height of a tile in pixels. Note that individual layers may have a different
             * tile height.
             */
            tileHeight: number;

            /**
             * The width of the map (in tiles).
             */
            width: number;

            /**
             * The height of the map (in tiles).
             */
            height: number;

            /**
             * The orientation of the map data (as specified in Tiled), usually 'orthogonal'.
             */
            orientation: string;

            /**
             * The render (draw) order of the map data (as specified in Tiled), usually 'right-down'.
             * 
             * The draw orders are:
             * 
             * right-down
             * left-down
             * right-up
             * left-up
             * 
             * This can be changed via the `setRenderOrder` method.
             */
            renderOrder: string;

            /**
             * The format of the map data.
             */
            format: number;

            /**
             * The version of the map data (as specified in Tiled, usually 1).
             */
            version: number;

            /**
             * Map specific properties as specified in Tiled.
             */
            properties: object;

            /**
             * The width of the map in pixels based on width * tileWidth.
             */
            widthInPixels: number;

            /**
             * The height of the map in pixels based on height * tileHeight.
             */
            heightInPixels: number;

            /**
             * A collection of Images, as parsed from Tiled map data.
             */
            imageCollections: Phaser.Tilemaps.ImageCollection[];

            /**
             * An array of Tiled Image Layers.
             */
            images: any[];

            /**
             * An array of Tilemap layer data.
             */
            layers: Phaser.Tilemaps.LayerData[];

            /**
             * Master list of tiles -> x, y, index in tileset.
             */
            tiles: any[];

            /**
             * An array of Tilesets used in the map.
             */
            tilesets: Phaser.Tilemaps.Tileset[];

            /**
             * An array of ObjectLayer instances parsed from Tiled object layers.
             */
            objects: Phaser.Tilemaps.ObjectLayer[];

            /**
             * The index of the currently selected LayerData object.
             */
            currentLayerIndex: number;

            /**
             * The length of the horizontal sides of the hexagon.
             * Only used for hexagonal orientation Tilemaps.
             */
            hexSideLength: number;

            /**
             * Sets the rendering (draw) order of the tiles in this map.
             * 
             * The default is 'right-down', meaning it will order the tiles starting from the top-left,
             * drawing to the right and then moving down to the next row.
             * 
             * The draw orders are:
             * 
             * 0 = right-down
             * 1 = left-down
             * 2 = right-up
             * 3 = left-up
             * 
             * Setting the render order does not change the tiles or how they are stored in the layer,
             * it purely impacts the order in which they are rendered.
             * 
             * You can provide either an integer (0 to 3), or the string version of the order.
             * 
             * Calling this method _after_ creating Tilemap Layers will **not** automatically
             * update them to use the new render order. If you call this method after creating layers, use their
             * own `setRenderOrder` methods to change them as needed.
             * @param renderOrder The render (draw) order value. Either an integer between 0 and 3, or a string: 'right-down', 'left-down', 'right-up' or 'left-up'.
             */
            setRenderOrder(renderOrder: number | string): this;

            /**
             * Adds an image to the map to be used as a tileset. A single map may use multiple tilesets.
             * Note that the tileset name can be found in the JSON file exported from Tiled, or in the Tiled
             * editor.
             * @param tilesetName The name of the tileset as specified in the map data.
             * @param key The key of the Phaser.Cache image used for this tileset. If
             * `undefined` or `null` it will look for an image with a key matching the tilesetName parameter.
             * @param tileWidth The width of the tile (in pixels) in the Tileset Image. If not
             * given it will default to the map's tileWidth value, or the tileWidth specified in the Tiled
             * JSON file.
             * @param tileHeight The height of the tiles (in pixels) in the Tileset Image. If
             * not given it will default to the map's tileHeight value, or the tileHeight specified in the
             * Tiled JSON file.
             * @param tileMargin The margin around the tiles in the sheet (in pixels). If not
             * specified, it will default to 0 or the value specified in the Tiled JSON file.
             * @param tileSpacing The spacing between each the tile in the sheet (in pixels).
             * If not specified, it will default to 0 or the value specified in the Tiled JSON file.
             * @param gid If adding multiple tilesets to a blank map, specify the starting
             * GID this set will use here. Default 0.
             * @param tileOffset Tile texture drawing offset.
             * If not specified, it will default to {0, 0} Default {x: 0, y: 0}.
             */
            addTilesetImage(tilesetName: string, key?: string, tileWidth?: number, tileHeight?: number, tileMargin?: number, tileSpacing?: number, gid?: number, tileOffset?: object): Phaser.Tilemaps.Tileset | null;

            /**
             * Copies the tiles in the source rectangular area to a new destination (all specified in tile
             * coordinates) within the layer. This copies all tile properties & recalculates collision
             * information in the destination region.
             * 
             * If no layer specified, the map's current layer is used. This cannot be applied to StaticTilemapLayers.
             * @param srcTileX The x coordinate of the area to copy from, in tiles, not pixels.
             * @param srcTileY The y coordinate of the area to copy from, in tiles, not pixels.
             * @param width The width of the area to copy, in tiles, not pixels.
             * @param height The height of the area to copy, in tiles, not pixels.
             * @param destTileX The x coordinate of the area to copy to, in tiles, not pixels.
             * @param destTileY The y coordinate of the area to copy to, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            copy(srcTileX: number, srcTileY: number, width: number, height: number, destTileX: number, destTileY: number, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Creates a new and empty Tilemap Layer. The currently selected layer in the map is set to this new layer.
             * 
             * Prior to v3.50.0 this method was called `createBlankDynamicLayer`.
             * @param name The name of this layer. Must be unique within the map.
             * @param tileset The tileset, or an array of tilesets, used to render this layer. Can be a string or a Tileset object.
             * @param x The world x position where the top left of this layer will be placed. Default 0.
             * @param y The world y position where the top left of this layer will be placed. Default 0.
             * @param width The width of the layer in tiles. If not specified, it will default to the map's width.
             * @param height The height of the layer in tiles. If not specified, it will default to the map's height.
             * @param tileWidth The width of the tiles the layer uses for calculations. If not specified, it will default to the map's tileWidth.
             * @param tileHeight The height of the tiles the layer uses for calculations. If not specified, it will default to the map's tileHeight.
             */
            createBlankLayer(name: string, tileset: string | string[] | Phaser.Tilemaps.Tileset | Phaser.Tilemaps.Tileset[], x?: number, y?: number, width?: number, height?: number, tileWidth?: number, tileHeight?: number): Phaser.Tilemaps.TilemapLayer | null;

            /**
             * Creates a new Tilemap Layer that renders the LayerData associated with the given
             * `layerID`. The currently selected layer in the map is set to this new layer.
             * 
             * The `layerID` is important. If you've created your map in Tiled then you can get this by
             * looking in Tiled and looking at the layer name. Or you can open the JSON file it exports and
             * look at the layers[].name value. Either way it must match.
             * 
             * Prior to v3.50.0 this method was called `createDynamicLayer`.
             * @param layerID The layer array index value, or if a string is given, the layer name from Tiled.
             * @param tileset The tileset, or an array of tilesets, used to render this layer. Can be a string or a Tileset object.
             * @param x The x position to place the layer in the world. If not specified, it will default to the layer offset from Tiled or 0. Default 0.
             * @param y The y position to place the layer in the world. If not specified, it will default to the layer offset from Tiled or 0. Default 0.
             */
            createLayer(layerID: number | string, tileset: string | string[] | Phaser.Tilemaps.Tileset | Phaser.Tilemaps.Tileset[], x?: number, y?: number): Phaser.Tilemaps.TilemapLayer | null;

            /**
             * This method will iterate through all of the objects defined in a Tiled Object Layer and then
             * convert the matching results into Phaser Game Objects (by default, Sprites)
             * 
             * Objects are matched on one of 4 criteria: The Object ID, the Object GID, the Object Name, or the Object Type.
             * 
             * Within Tiled, Object IDs are unique per Object. Object GIDs, however, are shared by all objects
             * using the same image. Finally, Object Names and Types are strings and the same name can be used on multiple
             * Objects in Tiled, they do not have to be unique; Names are specific to Objects while Types can be inherited
             * from Object GIDs using the same image.
             * 
             * You set the configuration parameter accordingly, based on which type of criteria you wish
             * to match against. For example, to convert all items on an Object Layer with a `gid` of 26:
             * 
             * ```javascript
             * createFromObjects(layerName, {
             *   gid: 26
             * });
             * ```
             * 
             * Or, to convert objects with the name 'bonus':
             * 
             * ```javascript
             * createFromObjects(layerName, {
             *   name: 'bonus'
             * });
             * ```
             * 
             * Or, to convert an object with a specific id:
             * 
             * ```javascript
             * createFromObjects(layerName, {
             *   id: 9
             * });
             * ```
             * 
             * You should only specify either `id`, `gid`, `name`, `type`, or none of them. Do not add more than
             * one criteria to your config. If you do not specify any criteria, then _all_ objects in the
             * Object Layer will be converted.
             * 
             * By default this method will convert Objects into {@link Phaser.GameObjects.Sprite} instances, but you can override
             * this by providing your own class type:
             * 
             * ```javascript
             * createFromObjects(layerName, {
             *   gid: 26,
             *   classType: Coin
             * });
             * ```
             * 
             * This will convert all Objects with a gid of 26 into your custom `Coin` class. You can pass
             * any class type here, but it _must_ extend {@link Phaser.GameObjects.GameObject} as its base class.
             * Your class will always be passed 1 parameter: `scene`, which is a reference to either the Scene
             * specified in the config object or, if not given, the Scene to which this Tilemap belongs. The
             * class must have {@link Phaser.GameObjects.Components.Transform#setPosition setPosition} and
             * {@link Phaser.GameObjects.Components.Texture#setTexture setTexture} methods.
             * 
             * This method will set the following Tiled Object properties on the new Game Object:
             * 
             * - `flippedHorizontal` as `flipX`
             * - `flippedVertical` as `flipY`
             * - `height` as `displayHeight`
             * - `name`
             * - `rotation`
             * - `visible`
             * - `width` as `displayWidth`
             * - `x`, adjusted for origin
             * - `y`, adjusted for origin
             * 
             * Additionally, this method will set Tiled Object custom properties
             * 
             * - on the Game Object, if it has the same property name and a value that isn't `undefined`; or
             * - on the Game Object's {@link Phaser.GameObjects.GameObject#data data store} otherwise.
             * 
             * For example, a Tiled Object with custom properties `{ alpha: 0.5, gold: 1 }` will be created as a Game
             * Object with an `alpha` value of 0.5 and a `data.values.gold` value of 1.
             * 
             * When `useTileset` is `true` (the default), Tile Objects will inherit the texture and any tile properties
             * from the tileset, and the local tile ID will be used as the texture frame. For the frame selection to work
             * you need to load the tileset texture as a spritesheet so its frame names match the local tile IDs.
             * 
             * For instance, a tileset tile
             * 
             * ```
             * { id: 3, type: 'treadmill', speed: 4 }
             * ```
             * 
             * with gid 19 and an object
             * 
             * ```
             * { id: 7, gid: 19, speed: 5, rotation: 90 }
             * ```
             * 
             * will be interpreted as
             * 
             * ```
             * { id: 7, gid: 19, speed: 5, rotation: 90, type: 'treadmill', texture: '[the tileset texture]', frame: 3 }
             * ```
             * 
             * You can suppress this behavior by setting the boolean `ignoreTileset` for each `config` that should ignore
             * object gid tilesets.
             * 
             * You can set a `container` property in the config. If given, the new Game Object will be added to
             * the Container or Layer instance instead of the Scene.
             * 
             * You can set named texture-`key` and texture-`frame` properties, which will be set on the new Game Object.
             * 
             * Finally, you can provide an array of config objects, to convert multiple types of object in
             * a single call:
             * 
             * ```javascript
             * createFromObjects(layerName, [
             *   {
             *     gid: 26,
             *     classType: Coin
             *   },
             *   {
             *     id: 9,
             *     classType: BossMonster
             *   },
             *   {
             *     name: 'lava',
             *     classType: LavaTile
             *   },
             *   {
             *     type: 'endzone',
             *     classType: Phaser.GameObjects.Zone
             *   }
             * ]);
             * ```
             * 
             * The signature of this method changed significantly in v3.60.0. Prior to this, it did not take config objects.
             * @param objectLayerName The name of the Tiled object layer to create the Game Objects from.
             * @param config A CreateFromObjects configuration object, or an array of them.
             * @param useTileset True if objects that set gids should also search the underlying tile for properties and data. Default true.
             */
            createFromObjects(objectLayerName: string, config: Phaser.Types.Tilemaps.CreateFromObjectLayerConfig | Phaser.Types.Tilemaps.CreateFromObjectLayerConfig[], useTileset?: boolean): Phaser.GameObjects.GameObject[];

            /**
             * Creates a Sprite for every object matching the given tile indexes in the layer. You can
             * optionally specify if each tile will be replaced with a new tile after the Sprite has been
             * created. This is useful if you want to lay down special tiles in a level that are converted to
             * Sprites, but want to replace the tile itself with a floor tile or similar once converted.
             * @param indexes The tile index, or array of indexes, to create Sprites from.
             * @param replacements The tile index, or array of indexes, to change a converted
             * tile to. Set to `null` to leave the tiles unchanged. If an array is given, it is assumed to be a
             * one-to-one mapping with the indexes array.
             * @param spriteConfig The config object to pass into the Sprite creator (i.e. scene.make.sprite).
             * @param scene The Scene to create the Sprites within.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            createFromTiles(indexes: number | any[], replacements: number | any[] | undefined, spriteConfig: Phaser.Types.GameObjects.Sprite.SpriteConfig, scene?: Phaser.Scene, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.GameObjects.Sprite[] | null;

            /**
             * Sets the tiles in the given rectangular area (in tile coordinates) of the layer with the
             * specified index. Tiles will be set to collide if the given index is a colliding index.
             * Collision information in the region will be recalculated.
             * 
             * If no layer specified, the map's current layer is used.
             * This cannot be applied to StaticTilemapLayers.
             * @param index The tile index to fill the area with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            fill(index: number, tileX?: number, tileY?: number, width?: number, height?: number, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * For each object in the given object layer, run the given filter callback function. Any
             * objects that pass the filter test (i.e. where the callback returns true) will be returned in a
             * new array. Similar to Array.prototype.Filter in vanilla JS.
             * @param objectLayer The name of an object layer (from Tiled) or an ObjectLayer instance.
             * @param callback The callback. Each object in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             */
            filterObjects(objectLayer: Phaser.Tilemaps.ObjectLayer | string, callback: TilemapFilterCallback, context?: object): Phaser.Types.Tilemaps.TiledObject[] | null;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * filter callback function. Any tiles that pass the filter test (i.e. where the callback returns
             * true) will returned as a new array. Similar to Array.prototype.Filter in vanilla JS.
             * If no layer specified, the map's current layer is used.
             * @param callback The callback. Each tile in the given area will be passed to this
             * callback as the first and only parameter. The callback should return true for tiles that pass the
             * filter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            filterTiles(callback: Function, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile[] | null;

            /**
             * Searches the entire map layer for the first tile matching the given index, then returns that Tile
             * object. If no match is found, it returns null. The search starts from the top-left tile and
             * continues horizontally until it hits the end of the row, then it drops down to the next column.
             * If the reverse boolean is true, it scans starting from the bottom-right corner traveling up to
             * the top-left.
             * If no layer specified, the map's current layer is used.
             * @param index The tile index value to search for.
             * @param skip The number of times to skip a matching tile before returning. Default 0.
             * @param reverse If true it will scan the layer in reverse, starting at the bottom-right. Otherwise it scans from the top-left. Default false.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            findByIndex(index: number, skip?: number, reverse?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Find the first object in the given object layer that satisfies the provided testing function.
             * I.e. finds the first object for which `callback` returns true. Similar to
             * Array.prototype.find in vanilla JS.
             * @param objectLayer The name of an object layer (from Tiled) or an ObjectLayer instance.
             * @param callback The callback. Each object in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             */
            findObject(objectLayer: Phaser.Tilemaps.ObjectLayer | string, callback: TilemapFindCallback, context?: object): Phaser.Types.Tilemaps.TiledObject | null;

            /**
             * Find the first tile in the given rectangular area (in tile coordinates) of the layer that
             * satisfies the provided testing function. I.e. finds the first tile for which `callback` returns
             * true. Similar to Array.prototype.find in vanilla JS.
             * If no layer specified, the maps current layer is used.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tile layer to run the search on. If not provided will use the current layer.
             */
            findTile(callback: FindTileCallback, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * callback. Similar to Array.prototype.forEach in vanilla JS.
             * 
             * If no layer specified, the map's current layer is used.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The Tile layer to run the search on. If not provided will use the current layer.
             */
            forEachTile(callback: EachTileCallback, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Gets the image layer index based on its name.
             * @param name The name of the image to get.
             */
            getImageIndex(name: string): number;

            /**
             * Return a list of all valid imagelayer names loaded in this Tilemap.
             */
            getImageLayerNames(): string[];

            /**
             * Internally used. Returns the index of the object in one of the Tilemaps arrays whose name
             * property matches the given `name`.
             * @param location The Tilemap array to search.
             * @param name The name of the array element to get.
             */
            getIndex(location: any[], name: string): number;

            /**
             * Gets the LayerData from `this.layers` that is associated with the given `layer`, or null if the layer is invalid.
             * @param layer The name of the layer from Tiled, the index of the layer in the map or Tilemap Layer. If not given will default to the maps current layer index.
             */
            getLayer(layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.LayerData | null;

            /**
             * Gets the ObjectLayer from `this.objects` that has the given `name`, or null if no ObjectLayer is found with that name.
             * @param name The name of the object layer from Tiled.
             */
            getObjectLayer(name?: string): Phaser.Tilemaps.ObjectLayer | null;

            /**
             * Return a list of all valid objectgroup names loaded in this Tilemap.
             */
            getObjectLayerNames(): string[];

            /**
             * Gets the LayerData index of the given `layer` within this.layers, or null if an invalid
             * `layer` is given.
             * @param layer The name of the layer from Tiled, the index of the layer in the map or a Tilemap Layer. If not given will default to the map's current layer index.
             */
            getLayerIndex(layer?: string | number | Phaser.Tilemaps.TilemapLayer): number;

            /**
             * Gets the index of the LayerData within this.layers that has the given `name`, or null if an
             * invalid `name` is given.
             * @param name The name of the layer to get.
             */
            getLayerIndexByName(name: string): number;

            /**
             * Gets a tile at the given tile coordinates from the given layer.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX X position to get the tile from (given in tile units, not pixels).
             * @param tileY Y position to get the tile from (given in tile units, not pixels).
             * @param nonNull If true getTile won't return null for empty tiles, but a Tile object with an index of -1.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTileAt(tileX: number, tileY: number, nonNull?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Gets a tile at the given world coordinates from the given layer.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param worldX X position to get the tile from (given in pixels)
             * @param worldY Y position to get the tile from (given in pixels)
             * @param nonNull If true, function won't return null for empty tiles, but a Tile object with an index of -1.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTileAtWorldXY(worldX: number, worldY: number, nonNull?: boolean, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Return a list of all valid tilelayer names loaded in this Tilemap.
             */
            getTileLayerNames(): string[];

            /**
             * Gets the tiles in the given rectangular area (in tile coordinates) of the layer.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTilesWithin(tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile[] | null;

            /**
             * Gets the tiles that overlap with the given shape in the given layer. The shape must be a Circle,
             * Line, Rectangle or Triangle. The shape should be in world coordinates.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param shape A shape in world (pixel) coordinates
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when factoring in which tiles to return.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTilesWithinShape(shape: Phaser.Geom.Circle | Phaser.Geom.Line | Phaser.Geom.Rectangle | Phaser.Geom.Triangle, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile[] | null;

            /**
             * Gets the tiles in the given rectangular area (in world coordinates) of the layer.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param worldX The world x coordinate for the top-left of the area.
             * @param worldY The world y coordinate for the top-left of the area.
             * @param width The width of the area.
             * @param height The height of the area.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when factoring in which tiles to return.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTilesWithinWorldXY(worldX: number, worldY: number, width: number, height: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile[] | null;

            /**
             * Gets the Tileset that has the given `name`, or null if an invalid `name` is given.
             * @param name The name of the Tileset to get.
             */
            getTileset(name: string): Phaser.Tilemaps.Tileset | null;

            /**
             * Gets the index of the Tileset within this.tilesets that has the given `name`, or null if an
             * invalid `name` is given.
             * @param name The name of the Tileset to get.
             */
            getTilesetIndex(name: string): number;

            /**
             * Checks if there is a tile at the given location (in tile coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            hasTileAt(tileX: number, tileY: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): boolean | null;

            /**
             * Checks if there is a tile at the given location (in world coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param camera The Camera to use when factoring in which tiles to return.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            hasTileAtWorldXY(worldX: number, worldY: number, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): boolean | null;

            /**
             * The LayerData object that is currently selected in the map. You can set this property using
             * any type supported by setLayer.
             */
            layer: Phaser.Tilemaps.LayerData;

            /**
             * Puts a tile at the given tile coordinates in the specified layer. You can pass in either an index
             * or a Tile object. If you pass in a Tile, all attributes will be copied over to the specified
             * location. If you pass in an index, only the index at the specified location will be changed.
             * Collision information will be recalculated at the specified location.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tile The index of this tile to set or a Tile object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            putTileAt(tile: number | Phaser.Tilemaps.Tile, tileX: number, tileY: number, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Puts a tile at the given world coordinates (pixels) in the specified layer. You can pass in either
             * an index or a Tile object. If you pass in a Tile, all attributes will be copied over to the
             * specified location. If you pass in an index, only the index at the specified location will be
             * changed. Collision information will be recalculated at the specified location.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tile The index of this tile to set or a Tile object.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            putTileAtWorldXY(tile: number | Phaser.Tilemaps.Tile, worldX: number, worldY: number, recalculateFaces?: boolean, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Puts an array of tiles or a 2D array of tiles at the given tile coordinates in the specified
             * layer. The array can be composed of either tile indexes or Tile objects. If you pass in a Tile,
             * all attributes will be copied over to the specified location. If you pass in an index, only the
             * index at the specified location will be changed. Collision information will be recalculated
             * within the region tiles were changed.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tile A row (array) or grid (2D array) of Tiles or tile indexes to place.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            putTilesAt(tile: number[] | number[][] | Phaser.Tilemaps.Tile[] | Phaser.Tilemaps.Tile[][], tileX: number, tileY: number, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. If an array of indexes is passed in, then
             * those will be used for randomly assigning new tile indexes. If an array is not provided, the
             * indexes found within the region (excluding -1) will be used for randomly assigning new tile
             * indexes. This method only modifies tile indexes and does not change collision information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param indexes An array of indexes to randomly draw from during randomization.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            randomize(tileX?: number, tileY?: number, width?: number, height?: number, indexes?: number[], layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Calculates interesting faces at the given tile coordinates of the specified layer. Interesting
             * faces are used internally for optimizing collisions against tiles. This method is mostly used
             * internally to optimize recalculating faces when only one tile has been changed.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            calculateFacesAt(tileX: number, tileY: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Calculates interesting faces within the rectangular area specified (in tile coordinates) of the
             * layer. Interesting faces are used internally for optimizing collisions against tiles. This method
             * is mostly used internally.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            calculateFacesWithin(tileX?: number, tileY?: number, width?: number, height?: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Removes the given TilemapLayer from this Tilemap without destroying it.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param layer The tile layer to be removed.
             */
            removeLayer(layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Destroys the given TilemapLayer and removes it from this Tilemap.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param layer The tile layer to be destroyed.
             */
            destroyLayer(layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Removes all Tilemap Layers from this Tilemap and calls `destroy` on each of them.
             */
            removeAllLayers(): this;

            /**
             * Removes the given Tile, or an array of Tiles, from the layer to which they belong,
             * and optionally recalculates the collision information.
             * @param tiles The Tile to remove, or an array of Tiles.
             * @param replaceIndex After removing the Tile, insert a brand new Tile into its location with the given index. Leave as -1 to just remove the tile. Default -1.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            removeTile(tiles: Phaser.Tilemaps.Tile | Phaser.Tilemaps.Tile[], replaceIndex?: number, recalculateFaces?: boolean): Phaser.Tilemaps.Tile[];

            /**
             * Removes the tile at the given tile coordinates in the specified layer and updates the layers collision information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param replaceWithNull If `true` (the default), this will replace the tile at the specified location with null instead of a Tile with an index of -1.
             * @param recalculateFaces If `true` (the default), the faces data will be recalculated.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            removeTileAt(tileX: number, tileY: number, replaceWithNull?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Removes the tile at the given world coordinates in the specified layer and updates the layers collision information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param replaceWithNull If `true` (the default), this will replace the tile at the specified location with null instead of a Tile with an index of -1.
             * @param recalculateFaces If `true` (the default), the faces data will be recalculated.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            removeTileAtWorldXY(worldX: number, worldY: number, replaceWithNull?: boolean, recalculateFaces?: boolean, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tile | null;

            /**
             * Draws a debug representation of the layer to the given Graphics object. This is helpful when you want to
             * get a quick idea of which of your tiles are colliding and which have interesting faces. The tiles
             * are drawn starting at (0, 0) in the Graphics, allowing you to place the debug representation
             * wherever you want on the screen.
             * 
             * If no layer is specified, the maps current layer is used.
             * 
             * **Note:** This method currently only works with orthogonal tilemap layers.
             * @param graphics The target Graphics object to draw upon.
             * @param styleConfig An object specifying the colors to use for the debug drawing.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            renderDebug(graphics: Phaser.GameObjects.Graphics, styleConfig?: Phaser.Types.Tilemaps.StyleConfig, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Draws a debug representation of all layers within this Tilemap to the given Graphics object.
             * 
             * This is helpful when you want to get a quick idea of which of your tiles are colliding and which
             * have interesting faces. The tiles are drawn starting at (0, 0) in the Graphics, allowing you to
             * place the debug representation wherever you want on the screen.
             * @param graphics The target Graphics object to draw upon.
             * @param styleConfig An object specifying the colors to use for the debug drawing.
             */
            renderDebugFull(graphics: Phaser.GameObjects.Graphics, styleConfig?: Phaser.Types.Tilemaps.StyleConfig): this;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `findIndex` and updates their index to match `newIndex`. This only modifies the index and does
             * not change collision information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param findIndex The index of the tile to search for.
             * @param newIndex The index of the tile to replace it with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            replaceByIndex(findIndex: number, newIndex: number, tileX?: number, tileY?: number, width?: number, height?: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets collision on the given tile or tiles within a layer by index. You can pass in either a
             * single numeric index or an array of indexes: [2, 3, 15, 20]. The `collides` parameter controls if
             * collision will be enabled (true) or disabled (false).
             * 
             * If no layer is specified, the maps current layer is used.
             * @param indexes Either a single tile index, or an array of tile indexes.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The tile layer to use. If not given the current layer is used.
             * @param updateLayer If true, updates the current tiles on the layer. Set to false if no tiles have been placed for significant performance boost. Default true.
             */
            setCollision(indexes: number | any[], collides?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer, updateLayer?: boolean): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets collision on a range of tiles in a layer whose index is between the specified `start` and
             * `stop` (inclusive). Calling this with a start value of 10 and a stop value of 14 would set
             * collision for tiles 10, 11, 12, 13 and 14. The `collides` parameter controls if collision will be
             * enabled (true) or disabled (false).
             * 
             * If no layer is specified, the maps current layer is used.
             * @param start The first index of the tile to be set for collision.
             * @param stop The last index of the tile to be set for collision.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setCollisionBetween(start: number, stop: number, collides?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets collision on the tiles within a layer by checking tile properties. If a tile has a property
             * that matches the given properties object, its collision flag will be set. The `collides`
             * parameter controls if collision will be enabled (true) or disabled (false). Passing in
             * `{ collides: true }` would update the collision flag on any tiles with a "collides" property that
             * has a value of true. Any tile that doesn't have "collides" set to true will be ignored. You can
             * also use an array of values, e.g. `{ types: ["stone", "lava", "sand" ] }`. If a tile has a
             * "types" property that matches any of those values, its collision flag will be updated.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param properties An object with tile properties and corresponding values that should be checked.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setCollisionByProperty(properties: object, collides?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets collision on all tiles in the given layer, except for tiles that have an index specified in
             * the given array. The `collides` parameter controls if collision will be enabled (true) or
             * disabled (false). Tile indexes not currently in the layer are not affected.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param indexes An array of the tile indexes to not be counted for collision.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setCollisionByExclusion(indexes: number[], collides?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets collision on the tiles within a layer by checking each tiles collision group data
             * (typically defined in Tiled within the tileset collision editor). If any objects are found within
             * a tiles collision group, the tiles colliding information will be set. The `collides` parameter
             * controls if collision will be enabled (true) or disabled (false).
             * 
             * If no layer is specified, the maps current layer is used.
             * @param collides If true it will enable collision. If false it will clear collision.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setCollisionFromCollisionGroup(collides?: boolean, recalculateFaces?: boolean, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets a global collision callback for the given tile index within the layer. This will affect all
             * tiles on this layer that have the same index. If a callback is already set for the tile index it
             * will be replaced. Set the callback to null to remove it. If you want to set a callback for a tile
             * at a specific location on the map then see `setTileLocationCallback`.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param indexes Either a single tile index, or an array of tile indexes to have a collision callback set for. All values should be integers.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context under which the callback is called.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setTileIndexCallback(indexes: number | number[], callback: Function, callbackContext: object, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets a collision callback for the given rectangular area (in tile coordinates) within the layer.
             * If a callback is already set for the tile index it will be replaced. Set the callback to null to
             * remove it.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context under which the callback is called.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            setTileLocationCallback(tileX: number, tileY: number, width: number, height: number, callback: Function, callbackContext?: object, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Sets the current layer to the LayerData associated with `layer`.
             * @param layer The name of the layer from Tiled, the index of the layer in the map or a TilemapLayer. If not given will default to the maps current layer index.
             */
            setLayer(layer?: string | number | Phaser.Tilemaps.TilemapLayer): this;

            /**
             * Sets the base tile size for the map. Note: this does not necessarily match the tileWidth and
             * tileHeight for all layers. This also updates the base size on all tiles across all layers.
             * @param tileWidth The width of the tiles the map uses for calculations.
             * @param tileHeight The height of the tiles the map uses for calculations.
             */
            setBaseTileSize(tileWidth: number, tileHeight: number): this;

            /**
             * Sets the tile size for a specific `layer`. Note: this does not necessarily match the maps
             * tileWidth and tileHeight for all layers. This will set the tile size for the layer and any
             * tiles the layer has.
             * @param tileWidth The width of the tiles (in pixels) in the layer.
             * @param tileHeight The height of the tiles (in pixels) in the layer.
             * @param layer The name of the layer from Tiled, the index of the layer in the map or a TilemapLayer. If not given will default to the maps current layer index.
             */
            setLayerTileSize(tileWidth: number, tileHeight: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): this;

            /**
             * Shuffles the tiles in a rectangular region (specified in tile coordinates) within the given
             * layer. It will only randomize the tiles in that area, so if they're all the same nothing will
             * appear to have changed! This method only modifies tile indexes and does not change collision
             * information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            shuffle(tileX?: number, tileY?: number, width?: number, height?: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `indexA` and swaps then with `indexB`. This only modifies the index and does not change collision
             * information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileA First tile index.
             * @param tileB Second tile index.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            swapByIndex(tileA: number, tileB: number, tileX?: number, tileY?: number, width?: number, height?: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Converts from tile X coordinates (tile units) to world X coordinates (pixels), factoring in the
             * layers position, scale and scroll.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            tileToWorldX(tileX: number, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): number | null;

            /**
             * Converts from tile Y coordinates (tile units) to world Y coordinates (pixels), factoring in the
             * layers position, scale and scroll.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            tileToWorldY(tileY: number, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): number | null;

            /**
             * Converts from tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layers position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param vec2 A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            tileToWorldXY(tileX: number, tileY: number, vec2?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Math.Vector2 | null;

            /**
             * Returns an array of Vector2s where each entry corresponds to the corner of the requested tile.
             * 
             * The `tileX` and `tileY` parameters are in tile coordinates, not world coordinates.
             * 
             * The corner coordinates are in world space, having factored in TilemapLayer scale, position
             * and the camera, if given.
             * 
             * The size of the array will vary based on the orientation of the map. For example an
             * orthographic map will return an array of 4 vectors, where-as a hexagonal map will,
             * of course, return an array of 6 corner vectors.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            getTileCorners(tileX: number, tileY: number, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Math.Vector2[] | null;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. New indexes are drawn from the given
             * weightedIndexes array. An example weighted array:
             * 
             * [
             *  { index: 6, weight: 4 },    // Probability of index 6 is 4 / 8
             *  { index: 7, weight: 2 },    // Probability of index 7 would be 2 / 8
             *  { index: 8, weight: 1.5 },  // Probability of index 8 would be 1.5 / 8
             *  { index: 26, weight: 0.5 }  // Probability of index 27 would be 0.5 / 8
             * ]
             * 
             * The probability of any index being picked is (the indexs weight) / (sum of all weights). This
             * method only modifies tile indexes and does not change collision information.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param weightedIndexes An array of objects to randomly draw from during randomization. They should be in the form: { index: 0, weight: 4 } or { index: [0, 1], weight: 4 } if you wish to draw from multiple tile indexes.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            weightedRandomize(weightedIndexes: object[], tileX?: number, tileY?: number, width?: number, height?: number, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Tilemaps.Tilemap | null;

            /**
             * Converts from world X coordinates (pixels) to tile X coordinates (tile units), factoring in the
             * layers position, scale and scroll.
             * 
             * If no layer is specified, the maps current layer is used.
             * 
             * You cannot call this method for Isometric or Hexagonal tilemaps as they require
             * both `worldX` and `worldY` values to determine the correct tile, instead you
             * should use the `worldToTileXY` method.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            worldToTileX(worldX: number, snapToFloor?: boolean, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): number | null;

            /**
             * Converts from world Y coordinates (pixels) to tile Y coordinates (tile units), factoring in the
             * layers position, scale and scroll.
             * 
             * If no layer is specified, the maps current layer is used.
             * 
             * You cannot call this method for Isometric or Hexagonal tilemaps as they require
             * both `worldX` and `worldY` values to determine the correct tile, instead you
             * should use the `worldToTileXY` method.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            worldToTileY(worldY: number, snapToFloor?: boolean, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): number | null;

            /**
             * Converts from world XY coordinates (pixels) to tile XY coordinates (tile units), factoring in the
             * layers position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * 
             * If no layer is specified, the maps current layer is used.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param vec2 A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             * @param layer The tile layer to use. If not given the current layer is used.
             */
            worldToTileXY(worldX: number, worldY: number, snapToFloor?: boolean, vec2?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera, layer?: string | number | Phaser.Tilemaps.TilemapLayer): Phaser.Math.Vector2 | null;

            /**
             * Removes all layer data from this Tilemap and nulls the scene reference. This will destroy any
             * TilemapLayers that have been created.
             */
            destroy(): void;

        }

        /**
         * A Tilemap Layer is a Game Object that renders LayerData from a Tilemap when used in combination
         * with one, or more, Tilesets.
         */
        class TilemapLayer extends Phaser.GameObjects.GameObject implements Phaser.GameObjects.Components.Alpha, Phaser.GameObjects.Components.BlendMode, Phaser.GameObjects.Components.ComputedSize, Phaser.GameObjects.Components.Depth, Phaser.GameObjects.Components.Flip, Phaser.GameObjects.Components.GetBounds, Phaser.GameObjects.Components.Mask, Phaser.GameObjects.Components.Origin, Phaser.GameObjects.Components.Pipeline, Phaser.GameObjects.Components.PostPipeline, Phaser.GameObjects.Components.ScrollFactor, Phaser.GameObjects.Components.Transform, Phaser.GameObjects.Components.Visible, Phaser.Physics.Arcade.Components.Collision {
            /**
             * 
             * @param scene The Scene to which this Game Object belongs.
             * @param tilemap The Tilemap this layer is a part of.
             * @param layerIndex The index of the LayerData associated with this layer.
             * @param tileset The tileset, or an array of tilesets, used to render this layer. Can be a string or a Tileset object.
             * @param x The world x position where the top left of this layer will be placed. Default 0.
             * @param y The world y position where the top left of this layer will be placed. Default 0.
             */
            constructor(scene: Phaser.Scene, tilemap: Phaser.Tilemaps.Tilemap, layerIndex: number, tileset: string | string[] | Phaser.Tilemaps.Tileset | Phaser.Tilemaps.Tileset[], x?: number, y?: number);

            /**
             * Used internally by physics system to perform fast type checks.
             */
            readonly isTilemap: boolean;

            /**
             * The Tilemap that this layer is a part of.
             */
            tilemap: Phaser.Tilemaps.Tilemap;

            /**
             * The index of the LayerData associated with this layer.
             */
            layerIndex: number;

            /**
             * The LayerData associated with this layer. LayerData can only be associated with one
             * tilemap layer.
             */
            layer: Phaser.Tilemaps.LayerData;

            /**
             * An array of `Tileset` objects associated with this layer.
             */
            tileset: Phaser.Tilemaps.Tileset[];

            /**
             * The total number of tiles drawn by the renderer in the last frame.
             */
            readonly tilesDrawn: number;

            /**
             * The total number of tiles in this layer. Updated every frame.
             */
            readonly tilesTotal: number;

            /**
             * Used internally during rendering. This holds the tiles that are visible within the Camera.
             */
            culledTiles: Phaser.Tilemaps.Tile[];

            /**
             * You can control if the camera should cull tiles on this layer before rendering them or not.
             * 
             * By default the camera will try to cull the tiles in this layer, to avoid over-drawing to the renderer.
             * 
             * However, there are some instances when you may wish to disable this, and toggling this flag allows
             * you to do so. Also see `setSkipCull` for a chainable method that does the same thing.
             */
            skipCull: boolean;

            /**
             * The amount of extra tiles to add into the cull rectangle when calculating its horizontal size.
             * 
             * See the method `setCullPadding` for more details.
             */
            cullPaddingX: number;

            /**
             * The amount of extra tiles to add into the cull rectangle when calculating its vertical size.
             * 
             * See the method `setCullPadding` for more details.
             */
            cullPaddingY: number;

            /**
             * The callback that is invoked when the tiles are culled.
             * 
             * It will call a different function based on the map orientation:
             * 
             * Orthogonal (the default) is `TilemapComponents.CullTiles`
             * Isometric is `TilemapComponents.IsometricCullTiles`
             * Hexagonal is `TilemapComponents.HexagonalCullTiles`
             * Staggered is `TilemapComponents.StaggeredCullTiles`
             * 
             * However, you can override this to call any function you like.
             * 
             * It will be sent 4 arguments:
             * 
             * 1. The Phaser.Tilemaps.LayerData object for this Layer
             * 2. The Camera that is culling the layer. You can check its `dirty` property to see if it has changed since the last cull.
             * 3. A reference to the `culledTiles` array, which should be used to store the tiles you want rendered.
             * 4. The Render Order constant.
             * 
             * See the `TilemapComponents.CullTiles` source code for details on implementing your own culling system.
             */
            cullCallback: Function;

            /**
             * An array holding the mapping between the tile indexes and the tileset they belong to.
             */
            gidMap: Phaser.Tilemaps.Tileset[];

            /**
             * The Tilemap Layer Collision Category.
             * 
             * This is exclusively used by the Arcade Physics system.
             * 
             * This can be set to any valid collision bitfield value.
             * 
             * See the `setCollisionCategory` method for more details.
             */
            collisionCategory: number;

            /**
             * The Tilemap Layer Collision Mask.
             * 
             * This is exclusively used by the Arcade Physics system.
             * 
             * See the `setCollidesWith` method for more details.
             */
            collisionMask: number;

            /**
             * The horizontal origin of this Tilemap Layer.
             */
            readonly originX: number;

            /**
             * The vertical origin of this Tilemap Layer.
             */
            readonly originY: number;

            /**
             * The horizontal display origin of this Tilemap Layer.
             */
            readonly displayOriginX: number;

            /**
             * The vertical display origin of this Tilemap Layer.
             */
            readonly displayOriginY: number;

            /**
             * Sets the rendering (draw) order of the tiles in this layer.
             * 
             * The default is 'right-down', meaning it will order the tiles starting from the top-left,
             * drawing to the right and then moving down to the next row.
             * 
             * The draw orders are:
             * 
             * 0 = right-down
             * 1 = left-down
             * 2 = right-up
             * 3 = left-up
             * 
             * Setting the render order does not change the tiles or how they are stored in the layer,
             * it purely impacts the order in which they are rendered.
             * 
             * You can provide either an integer (0 to 3), or the string version of the order.
             * @param renderOrder The render (draw) order value. Either an integer between 0 and 3, or a string: 'right-down', 'left-down', 'right-up' or 'left-up'.
             */
            setRenderOrder(renderOrder: number | string): this;

            /**
             * Calculates interesting faces at the given tile coordinates of the specified layer. Interesting
             * faces are used internally for optimizing collisions against tiles. This method is mostly used
             * internally to optimize recalculating faces when only one tile has been changed.
             * @param tileX The x coordinate.
             * @param tileY The y coordinate.
             */
            calculateFacesAt(tileX: number, tileY: number): this;

            /**
             * Calculates interesting faces within the rectangular area specified (in tile coordinates) of the
             * layer. Interesting faces are used internally for optimizing collisions against tiles. This method
             * is mostly used internally.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             */
            calculateFacesWithin(tileX?: number, tileY?: number, width?: number, height?: number): this;

            /**
             * Creates a Sprite for every object matching the given tile indexes in the layer. You can
             * optionally specify if each tile will be replaced with a new tile after the Sprite has been
             * created. This is useful if you want to lay down special tiles in a level that are converted to
             * Sprites, but want to replace the tile itself with a floor tile or similar once converted.
             * @param indexes The tile index, or array of indexes, to create Sprites from.
             * @param replacements The tile index, or array of indexes, to change a converted
             * tile to. Set to `null` to leave the tiles unchanged. If an array is given, it is assumed to be a
             * one-to-one mapping with the indexes array.
             * @param spriteConfig The config object to pass into the Sprite creator (i.e.
             * scene.make.sprite).
             * @param scene The Scene to create the Sprites within.
             * @param camera The Camera to use when determining the world XY
             */
            createFromTiles(indexes: number | any[], replacements: number | any[] | undefined, spriteConfig?: Phaser.Types.GameObjects.Sprite.SpriteConfig, scene?: Phaser.Scene, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.GameObjects.Sprite[];

            /**
             * Returns the tiles in the given layer that are within the cameras viewport.
             * This is used internally during rendering.
             * @param camera The Camera to run the cull check against.
             */
            cull(camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile[];

            /**
             * Copies the tiles in the source rectangular area to a new destination (all specified in tile
             * coordinates) within the layer. This copies all tile properties & recalculates collision
             * information in the destination region.
             * @param srcTileX The x coordinate of the area to copy from, in tiles, not pixels.
             * @param srcTileY The y coordinate of the area to copy from, in tiles, not pixels.
             * @param width The width of the area to copy, in tiles, not pixels.
             * @param height The height of the area to copy, in tiles, not pixels.
             * @param destTileX The x coordinate of the area to copy to, in tiles, not pixels.
             * @param destTileY The y coordinate of the area to copy to, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            copy(srcTileX: number, srcTileY: number, width: number, height: number, destTileX: number, destTileY: number, recalculateFaces?: boolean): this;

            /**
             * Sets the tiles in the given rectangular area (in tile coordinates) of the layer with the
             * specified index. Tiles will be set to collide if the given index is a colliding index.
             * Collision information in the region will be recalculated.
             * @param index The tile index to fill the area with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            fill(index: number, tileX?: number, tileY?: number, width?: number, height?: number, recalculateFaces?: boolean): this;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * filter callback function. Any tiles that pass the filter test (i.e. where the callback returns
             * true) will returned as a new array. Similar to Array.prototype.Filter in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this
             * callback as the first and only parameter. The callback should return true for tiles that pass the
             * filter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to filter.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            filterTiles(callback: Function, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): Phaser.Tilemaps.Tile[];

            /**
             * Searches the entire map layer for the first tile matching the given index, then returns that Tile
             * object. If no match is found, it returns null. The search starts from the top-left tile and
             * continues horizontally until it hits the end of the row, then it drops down to the next column.
             * If the reverse boolean is true, it scans starting from the bottom-right corner traveling up to
             * the top-left.
             * @param index The tile index value to search for.
             * @param skip The number of times to skip a matching tile before returning. Default 0.
             * @param reverse If true it will scan the layer in reverse, starting at the bottom-right. Otherwise it scans from the top-left. Default false.
             */
            findByIndex(index: number, skip?: number, reverse?: boolean): Phaser.Tilemaps.Tile;

            /**
             * Find the first tile in the given rectangular area (in tile coordinates) of the layer that
             * satisfies the provided testing function. I.e. finds the first tile for which `callback` returns
             * true. Similar to Array.prototype.find in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            findTile(callback: FindTileCallback, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): Phaser.Tilemaps.Tile | null;

            /**
             * For each tile in the given rectangular area (in tile coordinates) of the layer, run the given
             * callback. Similar to Array.prototype.forEach in vanilla JS.
             * @param callback The callback. Each tile in the given area will be passed to this callback as the first and only parameter.
             * @param context The context, or scope, under which the callback should be run.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            forEachTile(callback: EachTileCallback, context?: object, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): this;

            /**
             * Sets an additive tint on each Tile within the given area.
             * 
             * The tint works by taking the pixel color values from the tileset texture, and then
             * multiplying it by the color value of the tint.
             * 
             * If no area values are given then all tiles will be tinted to the given color.
             * 
             * To remove a tint call this method with either no parameters, or by passing white `0xffffff` as the tint color.
             * 
             * If a tile already has a tint set then calling this method will override that.
             * @param tint The tint color being applied to each tile within the region. Given as a hex value, i.e. `0xff0000` for red. Set to white (`0xffffff`) to reset the tint. Default 0xffffff.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            setTint(tint?: number, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): this;

            /**
             * Sets a fill-based tint on each Tile within the given area.
             * 
             * Unlike an additive tint, a fill-tint literally replaces the pixel colors from the texture
             * with those in the tint.
             * 
             * If no area values are given then all tiles will be tinted to the given color.
             * 
             * To remove a tint call this method with either no parameters, or by passing white `0xffffff` as the tint color.
             * 
             * If a tile already has a tint set then calling this method will override that.
             * @param tint The tint color being applied to each tile within the region. Given as a hex value, i.e. `0xff0000` for red. Set to white (`0xffffff`) to reset the tint. Default 0xffffff.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area to search.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            setTintFill(tint?: number, tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): this;

            /**
             * Gets a tile at the given tile coordinates from the given layer.
             * @param tileX X position to get the tile from (given in tile units, not pixels).
             * @param tileY Y position to get the tile from (given in tile units, not pixels).
             * @param nonNull If true getTile won't return null for empty tiles, but a Tile object with an index of -1. Default false.
             */
            getTileAt(tileX: number, tileY: number, nonNull?: boolean): Phaser.Tilemaps.Tile;

            /**
             * Gets a tile at the given world coordinates from the given layer.
             * @param worldX X position to get the tile from (given in pixels)
             * @param worldY Y position to get the tile from (given in pixels)
             * @param nonNull If true, function won't return null for empty tiles, but a Tile object with an index of -1. Default false.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            getTileAtWorldXY(worldX: number, worldY: number, nonNull?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile;

            /**
             * Gets a tile at the given world coordinates from the given isometric layer.
             * @param worldX X position to get the tile from (given in pixels)
             * @param worldY Y position to get the tile from (given in pixels)
             * @param originTop Which is the active face of the isometric tile? The top (default, true), or the base? (false) Default true.
             * @param nonNull If true, function won't return null for empty tiles, but a Tile object with an index of -1. Default false.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            getIsoTileAtWorldXY(worldX: number, worldY: number, originTop?: boolean, nonNull?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile;

            /**
             * Gets the tiles in the given rectangular area (in tile coordinates) of the layer.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             */
            getTilesWithin(tileX?: number, tileY?: number, width?: number, height?: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions): Phaser.Tilemaps.Tile[];

            /**
             * Gets the tiles that overlap with the given shape in the given layer. The shape must be a Circle,
             * Line, Rectangle or Triangle. The shape should be in world coordinates.
             * @param shape A shape in world (pixel) coordinates
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when factoring in which tiles to return.
             */
            getTilesWithinShape(shape: Phaser.Geom.Circle | Phaser.Geom.Line | Phaser.Geom.Rectangle | Phaser.Geom.Triangle, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile[];

            /**
             * Gets the tiles in the given rectangular area (in world coordinates) of the layer.
             * @param worldX The world x coordinate for the top-left of the area.
             * @param worldY The world y coordinate for the top-left of the area.
             * @param width The width of the area.
             * @param height The height of the area.
             * @param filteringOptions Optional filters to apply when getting the tiles.
             * @param camera The Camera to use when factoring in which tiles to return.
             */
            getTilesWithinWorldXY(worldX: number, worldY: number, width: number, height: number, filteringOptions?: Phaser.Types.Tilemaps.FilteringOptions, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile[];

            /**
             * Checks if there is a tile at the given location (in tile coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             */
            hasTileAt(tileX: number, tileY: number): boolean;

            /**
             * Checks if there is a tile at the given location (in world coordinates) in the given layer. Returns
             * false if there is no tile or if the tile at that location has an index of -1.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param camera The Camera to use when factoring in which tiles to return.
             */
            hasTileAtWorldXY(worldX: number, worldY: number, camera?: Phaser.Cameras.Scene2D.Camera): boolean;

            /**
             * Puts a tile at the given tile coordinates in the specified layer. You can pass in either an index
             * or a Tile object. If you pass in a Tile, all attributes will be copied over to the specified
             * location. If you pass in an index, only the index at the specified location will be changed.
             * Collision information will be recalculated at the specified location.
             * @param tile The index of this tile to set or a Tile object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            putTileAt(tile: number | Phaser.Tilemaps.Tile, tileX: number, tileY: number, recalculateFaces?: boolean): Phaser.Tilemaps.Tile;

            /**
             * Puts a tile at the given world coordinates (pixels) in the specified layer. You can pass in either
             * an index or a Tile object. If you pass in a Tile, all attributes will be copied over to the
             * specified location. If you pass in an index, only the index at the specified location will be
             * changed. Collision information will be recalculated at the specified location.
             * @param tile The index of this tile to set or a Tile object.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            putTileAtWorldXY(tile: number | Phaser.Tilemaps.Tile, worldX: number, worldY: number, recalculateFaces?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile;

            /**
             * Puts an array of tiles or a 2D array of tiles at the given tile coordinates in the specified
             * layer. The array can be composed of either tile indexes or Tile objects. If you pass in a Tile,
             * all attributes will be copied over to the specified location. If you pass in an index, only the
             * index at the specified location will be changed. Collision information will be recalculated
             * within the region tiles were changed.
             * @param tile A row (array) or grid (2D array) of Tiles or tile indexes to place.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            putTilesAt(tile: number[] | number[][] | Phaser.Tilemaps.Tile[] | Phaser.Tilemaps.Tile[][], tileX: number, tileY: number, recalculateFaces?: boolean): this;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. If an array of indexes is passed in, then
             * those will be used for randomly assigning new tile indexes. If an array is not provided, the
             * indexes found within the region (excluding -1) will be used for randomly assigning new tile
             * indexes. This method only modifies tile indexes and does not change collision information.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param indexes An array of indexes to randomly draw from during randomization.
             */
            randomize(tileX?: number, tileY?: number, width?: number, height?: number, indexes?: number[]): this;

            /**
             * Removes the tile at the given tile coordinates in the specified layer and updates the layers
             * collision information.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param replaceWithNull If true, this will replace the tile at the specified location with null instead of a Tile with an index of -1. Default true.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             */
            removeTileAt(tileX: number, tileY: number, replaceWithNull?: boolean, recalculateFaces?: boolean): Phaser.Tilemaps.Tile;

            /**
             * Removes the tile at the given world coordinates in the specified layer and updates the layers
             * collision information.
             * @param worldX The x coordinate, in pixels.
             * @param worldY The y coordinate, in pixels.
             * @param replaceWithNull If true, this will replace the tile at the specified location with null instead of a Tile with an index of -1. Default true.
             * @param recalculateFaces `true` if the faces data should be recalculated. Default true.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            removeTileAtWorldXY(worldX: number, worldY: number, replaceWithNull?: boolean, recalculateFaces?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Tilemaps.Tile;

            /**
             * Draws a debug representation of the layer to the given Graphics. This is helpful when you want to
             * get a quick idea of which of your tiles are colliding and which have interesting faces. The tiles
             * are drawn starting at (0, 0) in the Graphics, allowing you to place the debug representation
             * wherever you want on the screen.
             * @param graphics The target Graphics object to draw upon.
             * @param styleConfig An object specifying the colors to use for the debug drawing.
             */
            renderDebug(graphics: Phaser.GameObjects.Graphics, styleConfig?: Phaser.Types.Tilemaps.StyleConfig): this;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `findIndex` and updates their index to match `newIndex`. This only modifies the index and does
             * not change collision information.
             * @param findIndex The index of the tile to search for.
             * @param newIndex The index of the tile to replace it with.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             */
            replaceByIndex(findIndex: number, newIndex: number, tileX?: number, tileY?: number, width?: number, height?: number): this;

            /**
             * You can control if the Cameras should cull tiles before rendering them or not.
             * 
             * By default the camera will try to cull the tiles in this layer, to avoid over-drawing to the renderer.
             * 
             * However, there are some instances when you may wish to disable this.
             * @param value Set to `true` to stop culling tiles. Set to `false` to enable culling again. Default true.
             */
            setSkipCull(value?: boolean): this;

            /**
             * When a Camera culls the tiles in this layer it does so using its view into the world, building up a
             * rectangle inside which the tiles must exist or they will be culled. Sometimes you may need to expand the size
             * of this 'cull rectangle', especially if you plan on rotating the Camera viewing the layer. Do so
             * by providing the padding values. The values given are in tiles, not pixels. So if the tile width was 32px
             * and you set `paddingX` to be 4, it would add 32px x 4 to the cull rectangle (adjusted for scale)
             * @param paddingX The amount of extra horizontal tiles to add to the cull check padding. Default 1.
             * @param paddingY The amount of extra vertical tiles to add to the cull check padding. Default 1.
             */
            setCullPadding(paddingX?: number, paddingY?: number): this;

            /**
             * Sets collision on the given tile or tiles within a layer by index. You can pass in either a
             * single numeric index or an array of indexes: [2, 3, 15, 20]. The `collides` parameter controls if
             * collision will be enabled (true) or disabled (false).
             * @param indexes Either a single tile index, or an array of tile indexes.
             * @param collides If true it will enable collision. If false it will clear collision. Default true.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update. Default true.
             * @param updateLayer If true, updates the current tiles on the layer. Set to false if no tiles have been placed for significant performance boost. Default true.
             */
            setCollision(indexes: number | any[], collides?: boolean, recalculateFaces?: boolean, updateLayer?: boolean): this;

            /**
             * Sets collision on a range of tiles in a layer whose index is between the specified `start` and
             * `stop` (inclusive). Calling this with a start value of 10 and a stop value of 14 would set
             * collision for tiles 10, 11, 12, 13 and 14. The `collides` parameter controls if collision will be
             * enabled (true) or disabled (false).
             * @param start The first index of the tile to be set for collision.
             * @param stop The last index of the tile to be set for collision.
             * @param collides If true it will enable collision. If false it will clear collision. Default true.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update. Default true.
             */
            setCollisionBetween(start: number, stop: number, collides?: boolean, recalculateFaces?: boolean): this;

            /**
             * Sets collision on the tiles within a layer by checking tile properties. If a tile has a property
             * that matches the given properties object, its collision flag will be set. The `collides`
             * parameter controls if collision will be enabled (true) or disabled (false). Passing in
             * `{ collides: true }` would update the collision flag on any tiles with a "collides" property that
             * has a value of true. Any tile that doesn't have "collides" set to true will be ignored. You can
             * also use an array of values, e.g. `{ types: ["stone", "lava", "sand" ] }`. If a tile has a
             * "types" property that matches any of those values, its collision flag will be updated.
             * @param properties An object with tile properties and corresponding values that should be checked.
             * @param collides If true it will enable collision. If false it will clear collision. Default true.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update. Default true.
             */
            setCollisionByProperty(properties: object, collides?: boolean, recalculateFaces?: boolean): this;

            /**
             * Sets collision on all tiles in the given layer, except for tiles that have an index specified in
             * the given array. The `collides` parameter controls if collision will be enabled (true) or
             * disabled (false). Tile indexes not currently in the layer are not affected.
             * @param indexes An array of the tile indexes to not be counted for collision.
             * @param collides If true it will enable collision. If false it will clear collision. Default true.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update. Default true.
             */
            setCollisionByExclusion(indexes: number[], collides?: boolean, recalculateFaces?: boolean): this;

            /**
             * Sets collision on the tiles within a layer by checking each tiles collision group data
             * (typically defined in Tiled within the tileset collision editor). If any objects are found within
             * a tiles collision group, the tile's colliding information will be set. The `collides` parameter
             * controls if collision will be enabled (true) or disabled (false).
             * @param collides If true it will enable collision. If false it will clear collision. Default true.
             * @param recalculateFaces Whether or not to recalculate the tile faces after the update. Default true.
             */
            setCollisionFromCollisionGroup(collides?: boolean, recalculateFaces?: boolean): this;

            /**
             * Sets a global collision callback for the given tile index within the layer. This will affect all
             * tiles on this layer that have the same index. If a callback is already set for the tile index it
             * will be replaced. Set the callback to null to remove it. If you want to set a callback for a tile
             * at a specific location on the map then see setTileLocationCallback.
             * @param indexes Either a single tile index, or an array of tile indexes to have a collision callback set for.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context under which the callback is called.
             */
            setTileIndexCallback(indexes: number | number[], callback: Function, callbackContext: object): this;

            /**
             * Sets a collision callback for the given rectangular area (in tile coordinates) within the layer.
             * If a callback is already set for the tile index it will be replaced. Set the callback to null to
             * remove it.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             * @param callback The callback that will be invoked when the tile is collided with.
             * @param callbackContext The context, or scope, under which the callback is invoked.
             */
            setTileLocationCallback(tileX?: number, tileY?: number, width?: number, height?: number, callback?: Function, callbackContext?: object): this;

            /**
             * Shuffles the tiles in a rectangular region (specified in tile coordinates) within the given
             * layer. It will only randomize the tiles in that area, so if they're all the same nothing will
             * appear to have changed! This method only modifies tile indexes and does not change collision
             * information.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             */
            shuffle(tileX?: number, tileY?: number, width?: number, height?: number): this;

            /**
             * Scans the given rectangular area (given in tile coordinates) for tiles with an index matching
             * `indexA` and swaps then with `indexB`. This only modifies the index and does not change collision
             * information.
             * @param tileA First tile index.
             * @param tileB Second tile index.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             */
            swapByIndex(tileA: number, tileB: number, tileX?: number, tileY?: number, width?: number, height?: number): this;

            /**
             * Converts from tile X coordinates (tile units) to world X coordinates (pixels), factoring in the
             * layers position, scale and scroll.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            tileToWorldX(tileX: number, camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Converts from tile Y coordinates (tile units) to world Y coordinates (pixels), factoring in the
             * layers position, scale and scroll.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            tileToWorldY(tileY: number, camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Converts from tile XY coordinates (tile units) to world XY coordinates (pixels), factoring in the
             * layers position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            tileToWorldXY(tileX: number, tileY: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Returns an array of Vector2s where each entry corresponds to the corner of the requested tile.
             * 
             * The `tileX` and `tileY` parameters are in tile coordinates, not world coordinates.
             * 
             * The corner coordinates are in world space, having factored in TilemapLayer scale, position
             * and the camera, if given.
             * 
             * The size of the array will vary based on the orientation of the map. For example an
             * orthographic map will return an array of 4 vectors, where-as a hexagonal map will,
             * of course, return an array of 6 corner vectors.
             * @param tileX The x coordinate, in tiles, not pixels.
             * @param tileY The y coordinate, in tiles, not pixels.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            getTileCorners(tileX: number, tileY: number, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2[] | null;

            /**
             * Randomizes the indexes of a rectangular region of tiles (in tile coordinates) within the
             * specified layer. Each tile will receive a new index. New indexes are drawn from the given
             * weightedIndexes array. An example weighted array:
             * 
             * [
             *  { index: 6, weight: 4 },    // Probability of index 6 is 4 / 8
             *  { index: 7, weight: 2 },    // Probability of index 7 would be 2 / 8
             *  { index: 8, weight: 1.5 },  // Probability of index 8 would be 1.5 / 8
             *  { index: 26, weight: 0.5 }  // Probability of index 27 would be 0.5 / 8
             * ]
             * 
             * The probability of any index being choose is (the index's weight) / (sum of all weights). This
             * method only modifies tile indexes and does not change collision information.
             * @param weightedIndexes An array of objects to randomly draw from during randomization. They should be in the form: { index: 0, weight: 4 } or { index: [0, 1], weight: 4 } if you wish to draw from multiple tile indexes.
             * @param tileX The left most tile index (in tile coordinates) to use as the origin of the area.
             * @param tileY The top most tile index (in tile coordinates) to use as the origin of the area.
             * @param width How many tiles wide from the `tileX` index the area will be.
             * @param height How many tiles tall from the `tileY` index the area will be.
             */
            weightedRandomize(weightedIndexes: object[], tileX?: number, tileY?: number, width?: number, height?: number): this;

            /**
             * Converts from world X coordinates (pixels) to tile X coordinates (tile units), factoring in the
             * layers position, scale and scroll.
             * 
             * You cannot call this method for Isometric or Hexagonal tilemaps as they require
             * both `worldX` and `worldY` values to determine the correct tile, instead you
             * should use the `worldToTileXY` method.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            worldToTileX(worldX: number, snapToFloor?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Converts from world Y coordinates (pixels) to tile Y coordinates (tile units), factoring in the
             * layers position, scale and scroll.
             * 
             * You cannot call this method for Isometric or Hexagonal tilemaps as they require
             * both `worldX` and `worldY` values to determine the correct tile, instead you
             * should use the `worldToTileXY` method.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            worldToTileY(worldY: number, snapToFloor?: boolean, camera?: Phaser.Cameras.Scene2D.Camera): number;

            /**
             * Converts from world XY coordinates (pixels) to tile XY coordinates (tile units), factoring in the
             * layers position, scale and scroll. This will return a new Vector2 object or update the given
             * `point` object.
             * @param worldX The x coordinate to be converted, in pixels, not tiles.
             * @param worldY The y coordinate to be converted, in pixels, not tiles.
             * @param snapToFloor Whether or not to round the tile coordinate down to the nearest integer.
             * @param point A Vector2 to store the coordinates in. If not given a new Vector2 is created.
             * @param camera The Camera to use when calculating the tile index from the world values.
             */
            worldToTileXY(worldX: number, worldY: number, snapToFloor?: boolean, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Destroys this TilemapLayer and removes its link to the associated LayerData.
             * @param removeFromTilemap Remove this layer from the parent Tilemap? Default true.
             */
            destroy(removeFromTilemap?: boolean): void;

            /**
             * Clears all alpha values associated with this Game Object.
             * 
             * Immediately sets the alpha levels back to 1 (fully opaque).
             */
            clearAlpha(): this;

            /**
             * Set the Alpha level of this Game Object. The alpha controls the opacity of the Game Object as it renders.
             * Alpha values are provided as a float between 0, fully transparent, and 1, fully opaque.
             * 
             * If your game is running under WebGL you can optionally specify four different alpha values, each of which
             * correspond to the four corners of the Game Object. Under Canvas only the `topLeft` value given is used.
             * @param topLeft The alpha value used for the top-left of the Game Object. If this is the only value given it's applied across the whole Game Object. Default 1.
             * @param topRight The alpha value used for the top-right of the Game Object. WebGL only.
             * @param bottomLeft The alpha value used for the bottom-left of the Game Object. WebGL only.
             * @param bottomRight The alpha value used for the bottom-right of the Game Object. WebGL only.
             */
            setAlpha(topLeft?: number, topRight?: number, bottomLeft?: number, bottomRight?: number): this;

            /**
             * The alpha value of the Game Object.
             * 
             * This is a global value, impacting the entire Game Object, not just a region of it.
             */
            alpha: number;

            /**
             * The alpha value starting from the top-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopLeft: number;

            /**
             * The alpha value starting from the top-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaTopRight: number;

            /**
             * The alpha value starting from the bottom-left of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomLeft: number;

            /**
             * The alpha value starting from the bottom-right of the Game Object.
             * This value is interpolated from the corner to the center of the Game Object.
             */
            alphaBottomRight: number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency of which blend modes
             * are used.
             */
            blendMode: Phaser.BlendModes | string | number;

            /**
             * Sets the Blend Mode being used by this Game Object.
             * 
             * This can be a const, such as `Phaser.BlendModes.SCREEN`, or an integer, such as 4 (for Overlay)
             * 
             * Under WebGL only the following Blend Modes are available:
             * 
             * * NORMAL
             * * ADD
             * * MULTIPLY
             * * SCREEN
             * * ERASE (only works when rendering to a framebuffer, like a Render Texture)
             * 
             * Canvas has more available depending on browser support.
             * 
             * You can also create your own custom Blend Modes in WebGL.
             * 
             * Blend modes have different effects under Canvas and WebGL, and from browser to browser, depending
             * on support. Blend Modes also cause a WebGL batch flush should it encounter a new blend mode. For these
             * reasons try to be careful about the construction of your Scene and the frequency in which blend modes
             * are used.
             * @param value The BlendMode value. Either a string, a CONST or a number.
             */
            setBlendMode(value: string | Phaser.BlendModes | number): this;

            /**
             * The native (un-scaled) width of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayWidth` property.
             */
            width: number;

            /**
             * The native (un-scaled) height of this Game Object.
             * 
             * Changing this value will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or use
             * the `displayHeight` property.
             */
            height: number;

            /**
             * The displayed width of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayWidth: number;

            /**
             * The displayed height of this Game Object.
             * 
             * This value takes into account the scale factor.
             * 
             * Setting this value will adjust the Game Object's scale property.
             */
            displayHeight: number;

            /**
             * Sets the internal size of this Game Object, as used for frame or physics body creation.
             * 
             * This will not change the size that the Game Object is rendered in-game.
             * For that you need to either set the scale of the Game Object (`setScale`) or call the
             * `setDisplaySize` method, which is the same thing as changing the scale but allows you
             * to do so by giving pixel values.
             * 
             * If you have enabled this Game Object for input, changing the size will _not_ change the
             * size of the hit area. To do this you should adjust the `input.hitArea` object directly.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setSize(width: number, height: number): this;

            /**
             * Sets the display size of this Game Object.
             * 
             * Calling this will adjust the scale.
             * @param width The width of this Game Object.
             * @param height The height of this Game Object.
             */
            setDisplaySize(width: number, height: number): this;

            /**
             * The depth of this Game Object within the Scene. Ensure this value is only ever set to a number data-type.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             */
            depth: number;

            /**
             * The depth of this Game Object within the Scene.
             * 
             * The depth is also known as the 'z-index' in some environments, and allows you to change the rendering order
             * of Game Objects, without actually moving their position in the display list.
             * 
             * The default depth is zero. A Game Object with a higher depth
             * value will always render in front of one with a lower value.
             * 
             * Setting the depth will queue a depth sort event within the Scene.
             * @param value The depth of this Game Object. Ensure this value is only ever a number data-type.
             */
            setDepth(value: number): this;

            /**
             * The horizontally flipped state of the Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipX: boolean;

            /**
             * The vertically flipped state of the Game Object.
             * 
             * A Game Object that is flipped vertically will render inversed on the vertical axis (i.e. upside down)
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            flipY: boolean;

            /**
             * Toggles the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             */
            toggleFlipX(): this;

            /**
             * Toggles the vertical flipped state of this Game Object.
             */
            toggleFlipY(): this;

            /**
             * Sets the horizontal flipped state of this Game Object.
             * 
             * A Game Object that is flipped horizontally will render inversed on the horizontal axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipX(value: boolean): this;

            /**
             * Sets the vertical flipped state of this Game Object.
             * @param value The flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlipY(value: boolean): this;

            /**
             * Sets the horizontal and vertical flipped state of this Game Object.
             * 
             * A Game Object that is flipped will render inversed on the flipped axis.
             * Flipping always takes place from the middle of the texture and does not impact the scale value.
             * If this Game Object has a physics body, it will not change the body. This is a rendering toggle only.
             * @param x The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             * @param y The horizontal flipped state. `false` for no flip, or `true` to be flipped.
             */
            setFlip(x: boolean, y: boolean): this;

            /**
             * Resets the horizontal and vertical flipped state of this Game Object back to their default un-flipped state.
             */
            resetFlip(): this;

            /**
             * Gets the center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the top-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getTopRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the left-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getLeftCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the right-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getRightCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-left corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomLeft<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-center coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomCenter<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bottom-right corner coordinate of this Game Object, regardless of origin.
             * 
             * The returned point is calculated in local space and does not factor in any parent Containers,
             * unless the `includeParent` argument is set to `true`.
             * @param output An object to store the values in. If not provided a new Vector2 will be created.
             * @param includeParent If this Game Object has a parent Container, include it (and all other ancestors) in the resulting vector? Default false.
             */
            getBottomRight<O extends Phaser.Types.Math.Vector2Like>(output?: O, includeParent?: boolean): O;

            /**
             * Gets the bounds of this Game Object, regardless of origin.
             * 
             * The values are stored and returned in a Rectangle, or Rectangle-like, object.
             * @param output An object to store the values in. If not provided a new Rectangle will be created.
             */
            getBounds<O extends Phaser.Geom.Rectangle>(output?: O): O;

            /**
             * The Mask this Game Object is using during render.
             */
            mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the mask that this Game Object will use to render with.
             * 
             * The mask must have been previously created and can be either a GeometryMask or a BitmapMask.
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * If a mask is already set on this Game Object it will be immediately replaced.
             * 
             * Masks are positioned in global space and are not relative to the Game Object to which they
             * are applied. The reason for this is that multiple Game Objects can all share the same mask.
             * 
             * Masks have no impact on physics or input detection. They are purely a rendering component
             * that allows you to limit what is visible during the render pass.
             * @param mask The mask this Game Object will use when rendering.
             */
            setMask(mask: Phaser.Display.Masks.BitmapMask | Phaser.Display.Masks.GeometryMask): this;

            /**
             * Clears the mask that this Game Object was using.
             * @param destroyMask Destroy the mask before clearing it? Default false.
             */
            clearMask(destroyMask?: boolean): this;

            /**
             * Creates and returns a Bitmap Mask. This mask can be used by any Game Object,
             * including this one, or a Dynamic Texture.
             * 
             * Note: Bitmap Masks only work on WebGL. Geometry Masks work on both WebGL and Canvas.
             * 
             * To create the mask you need to pass in a reference to a renderable Game Object.
             * A renderable Game Object is one that uses a texture to render with, such as an
             * Image, Sprite, Render Texture or BitmapText.
             * 
             * If you do not provide a renderable object, and this Game Object has a texture,
             * it will use itself as the object. This means you can call this method to create
             * a Bitmap Mask from any renderable texture-based Game Object.
             * @param maskObject The Game Object or Dynamic Texture that will be used as the mask. If `null` it will generate an Image Game Object using the rest of the arguments.
             * @param x If creating a Game Object, the horizontal position in the world.
             * @param y If creating a Game Object, the vertical position in the world.
             * @param texture If creating a Game Object, the key, or instance of the Texture it will use to render with, as stored in the Texture Manager.
             * @param frame If creating a Game Object, an optional frame from the Texture this Game Object is rendering with.
             */
            createBitmapMask<G extends Phaser.GameObjects.GameObject, T extends Phaser.Textures.DynamicTexture>(maskObject?: Phaser.GameObjects.GameObject | Phaser.Textures.DynamicTexture, x?: number, y?: number, texture?: string | Phaser.Textures.Texture, frame?: string | number | Phaser.Textures.Frame): Phaser.Display.Masks.BitmapMask;

            /**
             * Creates and returns a Geometry Mask. This mask can be used by any Game Object,
             * including this one.
             * 
             * To create the mask you need to pass in a reference to a Graphics Game Object.
             * 
             * If you do not provide a graphics object, and this Game Object is an instance
             * of a Graphics object, then it will use itself to create the mask.
             * 
             * This means you can call this method to create a Geometry Mask from any Graphics Game Object.
             * @param graphics A Graphics Game Object, or any kind of Shape Game Object. The geometry within it will be used as the mask.
             */
            createGeometryMask<G extends Phaser.GameObjects.Graphics, S extends Phaser.GameObjects.Shape>(graphics?: Phaser.GameObjects.Graphics | Phaser.GameObjects.Shape): Phaser.Display.Masks.GeometryMask;

            /**
             * Sets the origin of this Game Object.
             * 
             * The values are given in the range 0 to 1.
             * @param x The horizontal origin value. Default 0.5.
             * @param y The vertical origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setOrigin(x?: number, y?: number): this;

            /**
             * Sets the origin of this Game Object based on the Pivot values in its Frame.
             */
            setOriginFromFrame(): this;

            /**
             * Sets the display origin of this Game Object.
             * The difference between this and setting the origin is that you can use pixel values for setting the display origin.
             * @param x The horizontal display origin value. Default 0.
             * @param y The vertical display origin value. If not defined it will be set to the value of `x`. Default x.
             */
            setDisplayOrigin(x?: number, y?: number): this;

            /**
             * Updates the Display Origin cached values internally stored on this Game Object.
             * You don't usually call this directly, but it is exposed for edge-cases where you may.
             */
            updateDisplayOrigin(): this;

            /**
             * The initial WebGL pipeline of this Game Object.
             * 
             * If you call `resetPipeline` on this Game Object, the pipeline is reset to this default.
             */
            defaultPipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * The current WebGL pipeline of this Game Object.
             */
            pipeline: Phaser.Renderer.WebGL.WebGLPipeline;

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            pipelineData: object;

            /**
             * Sets the initial WebGL Pipeline of this Game Object.
             * 
             * This should only be called during the instantiation of the Game Object. After that, use `setPipeline`.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             */
            initPipeline(pipeline?: string | Phaser.Renderer.WebGL.WebGLPipeline): boolean;

            /**
             * Sets the main WebGL Pipeline of this Game Object.
             * 
             * Also sets the `pipelineData` property, if the parameter is given.
             * @param pipeline Either the string-based name of the pipeline, or a pipeline instance to set.
             * @param pipelineData Optional pipeline data object that is set in to the `pipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `pipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPipeline(pipeline: string | Phaser.Renderer.WebGL.WebGLPipeline, pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `pipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPipelineData(key: string, value?: any): this;

            /**
             * Resets the WebGL Pipeline of this Game Object back to the default it was created with.
             * @param resetData Reset the `pipelineData` object to being an empty object? Default false.
             */
            resetPipeline(resetData?: boolean): boolean;

            /**
             * Gets the name of the WebGL Pipeline this Game Object is currently using.
             */
            getPipelineName(): string;

            /**
             * Does this Game Object have any Post Pipelines set?
             */
            hasPostPipeline: boolean;

            /**
             * The WebGL Post FX Pipelines this Game Object uses for post-render effects.
             * 
             * The pipelines are processed in the order in which they appear in this array.
             * 
             * If you modify this array directly, be sure to set the
             * `hasPostPipeline` property accordingly.
             */
            postPipelines: Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * An object to store pipeline specific data in, to be read by the pipelines this Game Object uses.
             */
            postPipelineData: object;

            /**
             * The Pre FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.preFX.addBloom();
             * ```
             * 
             * Only the following Game Objects support Pre FX:
             * 
             * * Image
             * * Sprite
             * * TileSprite
             * * Text
             * * RenderTexture
             * * Video
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             */
            preFX: Phaser.GameObjects.Components.FX | null;

            /**
             * The Post FX component of this Game Object.
             * 
             * This component allows you to apply a variety of built-in effects to this Game Object, such
             * as glow, blur, bloom, displacements, vignettes and more. You access them via this property,
             * for example:
             * 
             * ```js
             * const player = this.add.sprite();
             * player.postFX.addBloom();
             * ```
             * 
             * All FX are WebGL only and do not have Canvas counterparts.
             * 
             * Please see the FX Class for more details and available methods.
             * 
             * This property is always `null` until the `initPostPipeline` method is called.
             */
            postFX: Phaser.GameObjects.Components.FX;

            /**
             * This should only be called during the instantiation of the Game Object.
             * 
             * It is called by default by all core Game Objects and doesn't need
             * calling again.
             * 
             * After that, use `setPostPipeline`.
             * @param preFX Does this Game Object support Pre FX? Default false.
             */
            initPostPipeline(preFX?: boolean): void;

            /**
             * Sets one, or more, Post Pipelines on this Game Object.
             * 
             * Post Pipelines are invoked after this Game Object has rendered to its target and
             * are commonly used for post-fx.
             * 
             * The post pipelines are appended to the `postPipelines` array belonging to this
             * Game Object. When the renderer processes this Game Object, it iterates through the post
             * pipelines in the order in which they appear in the array. If you are stacking together
             * multiple effects, be aware that the order is important.
             * 
             * If you call this method multiple times, the new pipelines will be appended to any existing
             * post pipelines already set. Use the `resetPostPipeline` method to clear them first, if required.
             * 
             * You can optionally also set the `postPipelineData` property, if the parameter is given.
             * @param pipelines Either the string-based name of the pipeline, or a pipeline instance, or class, or an array of them.
             * @param pipelineData Optional pipeline data object that is set in to the `postPipelineData` property of this Game Object.
             * @param copyData Should the pipeline data object be _deep copied_ into the `postPipelineData` property of this Game Object? If `false` it will be set by reference instead. Default true.
             */
            setPostPipeline(pipelines: string | string[] | Function | Function[] | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[], pipelineData?: object, copyData?: boolean): this;

            /**
             * Adds an entry to the `postPipelineData` object belonging to this Game Object.
             * 
             * If the 'key' already exists, its value is updated. If it doesn't exist, it is created.
             * 
             * If `value` is undefined, and `key` exists, `key` is removed from the data object.
             * @param key The key of the pipeline data to set, update, or delete.
             * @param value The value to be set with the key. If `undefined` then `key` will be deleted from the object.
             */
            setPostPipelineData(key: string, value?: any): this;

            /**
             * Gets a Post Pipeline instance from this Game Object, based on the given name, and returns it.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            getPostPipeline(pipeline: string | Function | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): Phaser.Renderer.WebGL.Pipelines.PostFXPipeline | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline[];

            /**
             * Resets the WebGL Post Pipelines of this Game Object. It does this by calling
             * the `destroy` method on each post pipeline and then clearing the local array.
             * @param resetData Reset the `postPipelineData` object to being an empty object? Default false.
             */
            resetPostPipeline(resetData?: boolean): void;

            /**
             * Removes a type of Post Pipeline instances from this Game Object, based on the given name, and destroys them.
             * 
             * If you wish to remove all Post Pipelines use the `resetPostPipeline` method instead.
             * @param pipeline The string-based name of the pipeline, or a pipeline class.
             */
            removePostPipeline(pipeline: string | Phaser.Renderer.WebGL.Pipelines.PostFXPipeline): this;

            /**
             * Removes all Pre and Post FX Controllers from this Game Object.
             * 
             * If you wish to remove a single controller, use the `preFX.remove(fx)` or `postFX.remove(fx)` methods instead.
             * 
             * If you wish to clear a single controller, use the `preFX.clear()` or `postFX.clear()` methods instead.
             */
            clearFX(): this;

            /**
             * The horizontal scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorX: number;

            /**
             * The vertical scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             */
            scrollFactorY: number;

            /**
             * Sets the scroll factor of this Game Object.
             * 
             * The scroll factor controls the influence of the movement of a Camera upon this Game Object.
             * 
             * When a camera scrolls it will change the location at which this Game Object is rendered on-screen.
             * It does not change the Game Objects actual position values.
             * 
             * A value of 1 means it will move exactly in sync with a camera.
             * A value of 0 means it will not move at all, even if the camera moves.
             * Other values control the degree to which the camera movement is mapped to this Game Object.
             * 
             * Please be aware that scroll factor values other than 1 are not taken in to consideration when
             * calculating physics collisions. Bodies always collide based on their world position, but changing
             * the scroll factor is a visual adjustment to where the textures are rendered, which can offset
             * them from physics bodies if not accounted for in your code.
             * @param x The horizontal scroll factor of this Game Object.
             * @param y The vertical scroll factor of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScrollFactor(x: number, y?: number): this;

            /**
             * A property indicating that a Game Object has this component.
             */
            readonly hasTransformComponent: boolean;

            /**
             * The x position of this Game Object.
             */
            x: number;

            /**
             * The y position of this Game Object.
             */
            y: number;

            /**
             * The z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#depth} instead.
             */
            z: number;

            /**
             * The w position of this Game Object.
             */
            w: number;

            /**
             * This is a special setter that allows you to set both the horizontal and vertical scale of this Game Object
             * to the same value, at the same time. When reading this value the result returned is `(scaleX + scaleY) / 2`.
             * 
             * Use of this property implies you wish the horizontal and vertical scales to be equal to each other. If this
             * isn't the case, use the `scaleX` or `scaleY` properties instead.
             */
            scale: number;

            /**
             * The horizontal scale of this Game Object.
             */
            scaleX: number;

            /**
             * The vertical scale of this Game Object.
             */
            scaleY: number;

            /**
             * The angle of this Game Object as expressed in degrees.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, 90 is down, 180/-180 is left
             * and -90 is up.
             * 
             * If you prefer to work in radians, see the `rotation` property instead.
             */
            angle: number;

            /**
             * The angle of this Game Object in radians.
             * 
             * Phaser uses a right-hand clockwise rotation system, where 0 is right, PI/2 is down, +-PI is left
             * and -PI/2 is up.
             * 
             * If you prefer to work in degrees, see the `angle` property instead.
             */
            rotation: number;

            /**
             * Sets the position of this Game Object.
             * @param x The x position of this Game Object. Default 0.
             * @param y The y position of this Game Object. If not set it will use the `x` value. Default x.
             * @param z The z position of this Game Object. Default 0.
             * @param w The w position of this Game Object. Default 0.
             */
            setPosition(x?: number, y?: number, z?: number, w?: number): this;

            /**
             * Copies an object's coordinates to this Game Object's position.
             * @param source An object with numeric 'x', 'y', 'z', or 'w' properties. Undefined values are not copied.
             */
            copyPosition(source: Phaser.Types.Math.Vector2Like | Phaser.Types.Math.Vector3Like | Phaser.Types.Math.Vector4Like): this;

            /**
             * Sets the position of this Game Object to be a random position within the confines of
             * the given area.
             * 
             * If no area is specified a random position between 0 x 0 and the game width x height is used instead.
             * 
             * The position does not factor in the size of this Game Object, meaning that only the origin is
             * guaranteed to be within the area.
             * @param x The x position of the top-left of the random area. Default 0.
             * @param y The y position of the top-left of the random area. Default 0.
             * @param width The width of the random area.
             * @param height The height of the random area.
             */
            setRandomPosition(x?: number, y?: number, width?: number, height?: number): this;

            /**
             * Sets the rotation of this Game Object.
             * @param radians The rotation of this Game Object, in radians. Default 0.
             */
            setRotation(radians?: number): this;

            /**
             * Sets the angle of this Game Object.
             * @param degrees The rotation of this Game Object, in degrees. Default 0.
             */
            setAngle(degrees?: number): this;

            /**
             * Sets the scale of this Game Object.
             * @param x The horizontal scale of this Game Object. Default 1.
             * @param y The vertical scale of this Game Object. If not set it will use the `x` value. Default x.
             */
            setScale(x?: number, y?: number): this;

            /**
             * Sets the x position of this Game Object.
             * @param value The x position of this Game Object. Default 0.
             */
            setX(value?: number): this;

            /**
             * Sets the y position of this Game Object.
             * @param value The y position of this Game Object. Default 0.
             */
            setY(value?: number): this;

            /**
             * Sets the z position of this Game Object.
             * 
             * Note: The z position does not control the rendering order of 2D Game Objects. Use
             * {@link Phaser.GameObjects.Components.Depth#setDepth} instead.
             * @param value The z position of this Game Object. Default 0.
             */
            setZ(value?: number): this;

            /**
             * Sets the w position of this Game Object.
             * @param value The w position of this Game Object. Default 0.
             */
            setW(value?: number): this;

            /**
             * Gets the local transform matrix for this Game Object.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             */
            getLocalTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Gets the world transform matrix for this Game Object, factoring in any parent Containers.
             * @param tempMatrix The matrix to populate with the values from this Game Object.
             * @param parentMatrix A temporary matrix to hold parent values during the calculations.
             */
            getWorldTransformMatrix(tempMatrix?: Phaser.GameObjects.Components.TransformMatrix, parentMatrix?: Phaser.GameObjects.Components.TransformMatrix): Phaser.GameObjects.Components.TransformMatrix;

            /**
             * Takes the given `x` and `y` coordinates and converts them into local space for this
             * Game Object, taking into account parent and local transforms, and the Display Origin.
             * 
             * The returned Vector2 contains the translated point in its properties.
             * 
             * A Camera needs to be provided in order to handle modified scroll factors. If no
             * camera is specified, it will use the `main` camera from the Scene to which this
             * Game Object belongs.
             * @param x The x position to translate.
             * @param y The y position to translate.
             * @param point A Vector2, or point-like object, to store the results in.
             * @param camera The Camera which is being tested against. If not given will use the Scene default camera.
             */
            getLocalPoint(x: number, y: number, point?: Phaser.Math.Vector2, camera?: Phaser.Cameras.Scene2D.Camera): Phaser.Math.Vector2;

            /**
             * Gets the sum total rotation of all of this Game Objects parent Containers.
             * 
             * The returned value is in radians and will be zero if this Game Object has no parent container.
             */
            getParentRotation(): number;

            /**
             * The visible state of the Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             */
            visible: boolean;

            /**
             * Sets the visibility of this Game Object.
             * 
             * An invisible Game Object will skip rendering, but will still process update logic.
             * @param value The visible state of the Game Object.
             */
            setVisible(value: boolean): this;

            /**
             * Sets the Collision Category that this Arcade Physics Body
             * will use in order to determine what it can collide with.
             * 
             * It can only have one single category assigned to it.
             * 
             * If you wish to reset the collision category and mask, call
             * the `resetCollisionCategory` method.
             * @param category The collision category.
             */
            setCollisionCategory(category: number): this;

            /**
             * Checks to see if the given Collision Category will collide with
             * this Arcade Physics object or not.
             * @param category Collision category value to test.
             */
            willCollideWith(category: number): boolean;

            /**
             * Adds the given Collision Category to the list of those that this
             * Arcade Physics Body will collide with.
             * @param category The collision category to add.
             */
            addCollidesWith(category: number): this;

            /**
             * Removes the given Collision Category from the list of those that this
             * Arcade Physics Body will collide with.
             * @param category The collision category to add.
             */
            removeCollidesWith(category: number): this;

            /**
             * Sets all of the Collision Categories that this Arcade Physics Body
             * will collide with. You can either pass a single category value, or
             * an array of them.
             * 
             * Calling this method will reset all of the collision categories,
             * so only those passed to this method are enabled.
             * 
             * If you wish to add a new category to the existing mask, call
             * the `addCollisionCategory` method.
             * 
             * If you wish to reset the collision category and mask, call
             * the `resetCollisionCategory` method.
             * @param categories The collision category to collide with, or an array of them.
             */
            setCollidesWith(categories: number | number[]): this;

            /**
             * Resets the Collision Category and Mask back to the defaults,
             * which is to collide with everything.
             */
            resetCollisionCategory(): this;

        }

        /**
         * A Tileset is a combination of a single image containing the tiles and a container for data about
         * each tile.
         */
        class Tileset {
            /**
             * 
             * @param name The name of the tileset in the map data.
             * @param firstgid The first tile index this tileset contains.
             * @param tileWidth Width of each tile (in pixels). Default 32.
             * @param tileHeight Height of each tile (in pixels). Default 32.
             * @param tileMargin The margin around all tiles in the sheet (in pixels). Default 0.
             * @param tileSpacing The spacing between each tile in the sheet (in pixels). Default 0.
             * @param tileProperties Custom properties defined per tile in the Tileset.
             * These typically are custom properties created in Tiled when editing a tileset. Default {}.
             * @param tileData Data stored per tile. These typically are created in Tiled when editing a tileset, e.g. from Tiled's tile collision editor or terrain editor. Default {}.
             * @param tileOffset Tile texture drawing offset. Default {x: 0, y: 0}.
             */
            constructor(name: string, firstgid: number, tileWidth?: number, tileHeight?: number, tileMargin?: number, tileSpacing?: number, tileProperties?: object, tileData?: object, tileOffset?: object);

            /**
             * The name of the Tileset.
             */
            name: string;

            /**
             * The starting index of the first tile index this Tileset contains.
             */
            firstgid: number;

            /**
             * The width of each tile (in pixels). Use setTileSize to change.
             */
            readonly tileWidth: number;

            /**
             * The height of each tile (in pixels). Use setTileSize to change.
             */
            readonly tileHeight: number;

            /**
             * The margin around the tiles in the sheet (in pixels). Use `setSpacing` to change.
             */
            readonly tileMargin: number;

            /**
             * The spacing between each the tile in the sheet (in pixels). Use `setSpacing` to change.
             */
            readonly tileSpacing: number;

            /**
             * Tileset-specific properties per tile that are typically defined in the Tiled editor in the
             * Tileset editor.
             */
            tileProperties: object;

            /**
             * Tileset-specific data per tile that are typically defined in the Tiled editor, e.g. within
             * the Tileset collision editor. This is where collision objects and terrain are stored.
             */
            tileData: object;

            /**
             * Controls the drawing offset from the tile origin.
             * Defaults to 0x0, no offset.
             */
            tileOffset: Phaser.Math.Vector2;

            /**
             * The cached image that contains the individual tiles. Use setImage to set.
             */
            readonly image: Phaser.Textures.Texture | null;

            /**
             * The gl texture used by the WebGL renderer.
             */
            readonly glTexture: WebGLTexture | null;

            /**
             * The number of tile rows in the the tileset.
             */
            readonly rows: number;

            /**
             * The number of tile columns in the tileset.
             */
            readonly columns: number;

            /**
             * The total number of tiles in the tileset.
             */
            readonly total: number;

            /**
             * The look-up table to specific tile image texture coordinates (UV in pixels). Each element
             * contains the coordinates for a tile in an object of the form {x, y}.
             */
            readonly texCoordinates: object[];

            /**
             * Get a tiles properties that are stored in the Tileset. Returns null if tile index is not
             * contained in this Tileset. This is typically defined in Tiled under the Tileset editor.
             * @param tileIndex The unique id of the tile across all tilesets in the map.
             */
            getTileProperties(tileIndex: number): object | undefined | null;

            /**
             * Get a tile's data that is stored in the Tileset. Returns null if tile index is not contained
             * in this Tileset. This is typically defined in Tiled and will contain both Tileset collision
             * info and terrain mapping.
             * @param tileIndex The unique id of the tile across all tilesets in the map.
             */
            getTileData(tileIndex: number): object | undefined;

            /**
             * Get a tile's collision group that is stored in the Tileset. Returns null if tile index is not
             * contained in this Tileset. This is typically defined within Tiled's tileset collision editor.
             * @param tileIndex The unique id of the tile across all tilesets in the map.
             */
            getTileCollisionGroup(tileIndex: number): object | null;

            /**
             * Returns true if and only if this Tileset contains the given tile index.
             * @param tileIndex The unique id of the tile across all tilesets in the map.
             */
            containsTileIndex(tileIndex: number): boolean;

            /**
             * Returns the texture coordinates (UV in pixels) in the Tileset image for the given tile index.
             * Returns null if tile index is not contained in this Tileset.
             * @param tileIndex The unique id of the tile across all tilesets in the map.
             */
            getTileTextureCoordinates(tileIndex: number): object | null;

            /**
             * Sets the image associated with this Tileset and updates the tile data (rows, columns, etc.).
             * @param texture The image that contains the tiles.
             */
            setImage(texture: Phaser.Textures.Texture): Phaser.Tilemaps.Tileset;

            /**
             * Sets the tile width & height and updates the tile data (rows, columns, etc.).
             * @param tileWidth The width of a tile in pixels.
             * @param tileHeight The height of a tile in pixels.
             */
            setTileSize(tileWidth?: number, tileHeight?: number): Phaser.Tilemaps.Tileset;

            /**
             * Sets the tile margin & spacing and updates the tile data (rows, columns, etc.).
             * @param margin The margin around the tiles in the sheet (in pixels).
             * @param spacing The spacing between the tiles in the sheet (in pixels).
             */
            setSpacing(margin?: number, spacing?: number): Phaser.Tilemaps.Tileset;

            /**
             * Updates tile texture coordinates and tileset data.
             * @param imageWidth The (expected) width of the image to slice.
             * @param imageHeight The (expected) height of the image to slice.
             */
            updateTileData(imageWidth: number, imageHeight: number): Phaser.Tilemaps.Tileset;

        }

        /**
         * Orthogonal Tilemap orientation constant.
         */
        const ORTHOGONAL: number;

        /**
         * Isometric Tilemap orientation constant.
         */
        const ISOMETRIC: number;

        /**
         * Staggered Tilemap orientation constant.
         */
        const STAGGERED: number;

        /**
         * Hexagonal Tilemap orientation constant.
         */
        const HEXAGONAL: number;

    }

    namespace Time {
        /**
         * The Clock is a Scene plugin which creates and updates Timer Events for its Scene.
         */
        class Clock {
            /**
             * 
             * @param scene The Scene which owns this Clock.
             */
            constructor(scene: Phaser.Scene);

            /**
             * The Scene which owns this Clock.
             */
            scene: Phaser.Scene;

            /**
             * The Scene Systems object of the Scene which owns this Clock.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The current time of the Clock, in milliseconds.
             * 
             * If accessed externally, this is equivalent to the `time` parameter normally passed to a Scene's `update` method.
             */
            now: number;

            /**
             * The time the Clock (and Scene) started, in milliseconds.
             * 
             * This can be compared to the `time` parameter passed to a Scene's `update` method.
             */
            startTime: number;

            /**
             * The scale of the Clock's time delta.
             * 
             * The time delta is the time elapsed between two consecutive frames and influences the speed of time for this Clock and anything which uses it, such as its Timer Events. Values higher than 1 increase the speed of time, while values smaller than 1 decrease it. A value of 0 freezes time and is effectively equivalent to pausing the Clock.
             */
            timeScale: number;

            /**
             * Whether the Clock is paused (`true`) or active (`false`).
             * 
             * When paused, the Clock will not update any of its Timer Events, thus freezing time.
             */
            paused: boolean;

            /**
             * Creates a Timer Event and adds it to this Clock at the start of the next frame.
             * 
             * You can pass in either a `TimerEventConfig` object, from with a new `TimerEvent` will
             * be created, or you can pass in a `TimerEvent` instance.
             * 
             * If passing an instance please make sure that this instance hasn't been used before.
             * If it has ever entered a 'completed' state then it will no longer be suitable to
             * run again.
             * 
             * Also, if the `TimerEvent` instance is being used by _another_ Clock (in another Scene)
             * it will still be updated by that Clock as well, so be careful when using this feature.
             * @param config The configuration for the Timer Event, or an existing Timer Event object.
             */
            addEvent(config: Phaser.Time.TimerEvent | Phaser.Types.Time.TimerEventConfig): Phaser.Time.TimerEvent;

            /**
             * Creates a Timer Event and adds it to the Clock at the start of the frame.
             * 
             * This is a shortcut for {@link #addEvent} which can be shorter and is compatible with the syntax of the GreenSock Animation Platform (GSAP).
             * @param delay The delay of the function call, in milliseconds.
             * @param callback The function to call after the delay expires.
             * @param args The arguments to call the function with.
             * @param callbackScope The scope (`this` object) to call the function with.
             */
            delayedCall(delay: number, callback: Function, args?: any[], callbackScope?: any): Phaser.Time.TimerEvent;

            /**
             * Clears and recreates the array of pending Timer Events.
             */
            clearPendingEvents(): this;

            /**
             * Removes the given Timer Event, or an array of Timer Events, from this Clock.
             * 
             * The events are removed from all internal lists (active, pending and removal),
             * freeing the event up to be re-used.
             * @param events The Timer Event, or an array of Timer Events, to remove from this Clock.
             */
            removeEvent(events: Phaser.Time.TimerEvent | Phaser.Time.TimerEvent[]): this;

            /**
             * Schedules all active Timer Events for removal at the start of the frame.
             */
            removeAllEvents(): this;

            /**
             * Updates the arrays of active and pending Timer Events. Called at the start of the frame.
             * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            preUpdate(time: number, delta: number): void;

            /**
             * Updates the Clock's internal time and all of its Timer Events.
             * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            update(time: number, delta: number): void;

        }

        namespace Events {
            /**
             * The Timeline Complete Event.
             * 
             * This event is dispatched by timeline when all timeline events complete.
             * 
             * Listen to it from a Timeline instance using `Timeline.on('complete', listener)`, i.e.:
             * 
             * ```javascript
             * const timeline = this.add.timeline();
             * timeline.on('complete', listener);
             * timeline.play();
             * ```
             */
            const COMPLETE: string;

        }

        /**
         * A Timeline is a way to schedule events to happen at specific times in the future.
         * 
         * You can think of it as an event sequencer for your game, allowing you to schedule the
         * running of callbacks, events and other actions at specific times in the future.
         * 
         * A Timeline is a Scene level system, meaning you can have as many Timelines as you like, each
         * belonging to a different Scene. You can also have multiple Timelines running at the same time.
         * 
         * If the Scene is paused, the Timeline will also pause. If the Scene is destroyed, the Timeline
         * will be automatically destroyed. However, you can control the Timeline directly, pausing,
         * resuming and stopping it at any time.
         * 
         * Create an instance of a Timeline via the Game Object Factory:
         * 
         * ```js
         * const timeline = this.add.timeline();
         * ```
         * 
         * The Timeline always starts paused. You must call `play` on it to start it running.
         * 
         * You can also pass in a configuration object on creation, or an array of them:
         * 
         * ```js
         * const timeline = this.add.timeline({
         *     at: 1000,
         *     run: () => {
         *         this.add.sprite(400, 300, 'logo');
         *     }
         * });
         * 
         * timeline.play();
         * ```
         * 
         * In this example we sequence a few different events:
         * 
         * ```js
         * const timeline = this.add.timeline([
         *     {
         *         at: 1000,
         *         run: () => { this.logo = this.add.sprite(400, 300, 'logo'); },
         *         sound: 'TitleMusic'
         *     },
         *     {
         *         at: 2500,
         *         tween: {
         *             targets: this.logo,
         *             y: 600,
         *             yoyo: true
         *         },
         *         sound: 'Explode'
         *     },
         *     {
         *         at: 8000,
         *         event: 'HURRY_PLAYER',
         *         target: this.background,
         *         set: {
         *             tint: 0xff0000
         *         }
         *     }
         * ]);
         * 
         * timeline.play();
         * ```
         * 
         * There are lots of options available to you via the configuration object. See the
         * {@link Phaser.Types.Time.TimelineEventConfig} typedef for more details.
         */
        class Timeline {
            /**
             * 
             * @param scene The Scene which owns this Timeline.
             * @param config The configuration object for this Timeline Event, or an array of them.
             */
            constructor(scene: Phaser.Scene, config: Phaser.Types.Time.TimelineEventConfig | Phaser.Types.Time.TimelineEventConfig[]);

            /**
             * The Scene to which this Timeline belongs.
             */
            scene: Phaser.Scene;

            /**
             * A reference to the Scene Systems.
             */
            systems: Phaser.Scenes.Systems;

            /**
             * The elapsed time counter.
             * 
             * Treat this as read-only.
             */
            elapsed: number;

            /**
             * Whether the Timeline is running (`true`) or active (`false`).
             * 
             * When paused, the Timeline will not run any of its actions.
             * 
             * By default a Timeline is always paused and should be started by
             * calling the `Timeline.play` method.
             * 
             * You can use the `Timeline.pause` and `Timeline.resume` methods to control
             * this value in a chainable way.
             */
            paused: boolean;

            /**
             * Whether the Timeline is complete (`true`) or not (`false`).
             * 
             * A Timeline is considered complete when all of its events have been run.
             * 
             * If you wish to restart a Timeline after it has completed, you can do so
             * by calling the `Timeline.restart` method.
             * 
             * You can also use the `Timeline.stop` method to stop a running Timeline,
             * at any point, without resetting it.
             */
            complete: boolean;

            /**
             * The total number of events that have been run.
             * 
             * This value is reset to zero if the Timeline is restarted.
             * 
             * Treat this as read-only.
             */
            totalComplete: number;

            /**
             * An array of all the Timeline Events.
             */
            events: Phaser.Types.Time.TimelineEvent[];

            /**
             * Updates the elapsed time counter, if this Timeline is not paused.
             * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            preUpdate(time: number, delta: number): void;

            /**
             * Called automatically by the Scene update step.
             * 
             * Iterates through all of the Timeline Events and checks to see if they should be run.
             * 
             * If they should be run, then the `TimelineEvent.action` callback is invoked.
             * 
             * If the `TimelineEvent.once` property is `true` then the event is removed from the Timeline.
             * 
             * If the `TimelineEvent.event` property is set then the Timeline emits that event.
             * 
             * If the `TimelineEvent.run` property is set then the Timeline invokes that method.
             * 
             * If the `TimelineEvent.target` property is set then the Timeline invokes the `run` method on that target.
             * @param time The current time. Either a High Resolution Timer value if it comes from Request Animation Frame, or Date.now if using SetTimeout.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            update(time: number, delta: number): void;

            /**
             * Starts this Timeline running.
             * 
             * If the Timeline is already running and the `fromStart` parameter is `true`,
             * then calling this method will reset the Timeline events as incomplete.
             * 
             * If you wish to resume a paused Timeline, then use the `Timeline.resume` method instead.
             * @param fromStart Reset this Timeline back to the start before playing. Default true.
             */
            play(fromStart?: boolean): this;

            /**
             * Pauses this Timeline.
             * 
             * To resume it again, call the `Timeline.resume` method or set the `Timeline.paused` property to `false`.
             * 
             * If the Timeline is paused while processing the current game step, then it
             * will carry on with all events that are due to run during that step and pause
             * from the next game step.
             * 
             * Note that if any Tweens have been started prior to calling this method, they will **not** be paused as well.
             */
            pause(): this;

            /**
             * Resumes this Timeline from a paused state.
             * 
             * The Timeline will carry on from where it left off.
             * 
             * If you need to reset the Timeline to the start, then call the `Timeline.reset` method.
             */
            resume(): this;

            /**
             * Stops this Timeline.
             * 
             * This will set the `paused` and `complete` properties to `true`.
             * 
             * If you wish to reset the Timeline to the start, then call the `Timeline.reset` method.
             */
            stop(): this;

            /**
             * Resets this Timeline back to the start.
             * 
             * This will set the elapsed time to zero and set all events to be incomplete.
             * 
             * If the Timeline had any events that were set to `once` that have already
             * been removed, they will **not** be present again after calling this method.
             * 
             * If the Timeline isn't currently running (i.e. it's paused or complete) then
             * calling this method resets those states, the same as calling `Timeline.play(true)`.
             */
            reset(): this;

            /**
             * Adds one or more events to this Timeline.
             * 
             * You can pass in a single configuration object, or an array of them:
             * 
             * ```js
             * const timeline = this.add.timeline({
             *     at: 1000,
             *     run: () => {
             *         this.add.sprite(400, 300, 'logo');
             *     }
             * });
             * ```
             * @param config The configuration object for this Timeline Event, or an array of them.
             */
            add(config: Phaser.Types.Time.TimelineEventConfig | Phaser.Types.Time.TimelineEventConfig[]): this;

            /**
             * Removes all events from this Timeline, resets the elapsed time to zero
             * and pauses the Timeline.
             */
            clear(): this;

            /**
             * Returns `true` if this Timeline is currently playing.
             * 
             * A Timeline is playing if it is not paused or not complete.
             */
            isPlaying(): boolean;

            /**
             * Returns a number between 0 and 1 representing the progress of this Timeline.
             * 
             * A value of 0 means the Timeline has just started, 0.5 means it's half way through,
             * and 1 means it's complete.
             * 
             * If the Timeline has no events, or all events have been removed, this will return 1.
             * 
             * If the Timeline is paused, this will return the progress value at the time it was paused.
             * 
             * Note that the value returned is based on the number of events that have been completed,
             * not the 'duration' of the events (as this is unknown to the Timeline).
             */
            getProgress(): number;

            /**
             * Destroys this Timeline.
             * 
             * This will remove all events from the Timeline and stop it from processing.
             * 
             * This method is called automatically when the Scene shuts down, but you may
             * also call it directly should you need to destroy the Timeline earlier.
             */
            destroy(): void;

        }

        /**
         * A Timer Event represents a delayed function call. It's managed by a Scene's {@link Clock} and will call its function after a set amount of time has passed. The Timer Event can optionally repeat - i.e. call its function multiple times before finishing, or loop indefinitely.
         * 
         * Because it's managed by a Clock, a Timer Event is based on game time, will be affected by its Clock's time scale, and will pause if its Clock pauses.
         */
        class TimerEvent {
            /**
             * 
             * @param config The configuration for the Timer Event, including its delay and callback.
             */
            constructor(config: Phaser.Types.Time.TimerEventConfig);

            /**
             * The delay in ms at which this TimerEvent fires.
             */
            readonly delay: number;

            /**
             * The total number of times this TimerEvent will repeat before finishing.
             */
            readonly repeat: number;

            /**
             * If repeating this contains the current repeat count.
             */
            repeatCount: number;

            /**
             * True if this TimerEvent loops, otherwise false.
             */
            readonly loop: boolean;

            /**
             * The callback that will be called when the TimerEvent occurs.
             */
            callback: Function;

            /**
             * The scope in which the callback will be called.
             */
            callbackScope: object;

            /**
             * Additional arguments to be passed to the callback.
             */
            args: any[];

            /**
             * Scale the time causing this TimerEvent to update.
             */
            timeScale: number;

            /**
             * Start this many MS into the elapsed (useful if you want a long duration with repeat, but for the first loop to fire quickly)
             */
            startAt: number;

            /**
             * The time in milliseconds which has elapsed since the Timer Event's creation.
             * 
             * This value is local for the Timer Event and is relative to its Clock. As such, it's influenced by the Clock's time scale and paused state, the Timer Event's initial {@link #startAt} property, and the Timer Event's {@link #timeScale} and {@link #paused} state.
             */
            elapsed: number;

            /**
             * Whether or not this timer is paused.
             */
            paused: boolean;

            /**
             * Whether the Timer Event's function has been called.
             * 
             * When the Timer Event fires, this property will be set to `true` before the callback function is invoked and will be reset immediately afterward if the Timer Event should repeat. The value of this property does not directly influence whether the Timer Event will be removed from its Clock, but can prevent it from firing.
             */
            hasDispatched: boolean;

            /**
             * Completely reinitializes the Timer Event, regardless of its current state, according to a configuration object.
             * @param config The new state for the Timer Event.
             */
            reset(config: Phaser.Types.Time.TimerEventConfig): Phaser.Time.TimerEvent;

            /**
             * Gets the progress of the current iteration, not factoring in repeats.
             */
            getProgress(): number;

            /**
             * Gets the progress of the timer overall, factoring in repeats.
             */
            getOverallProgress(): number;

            /**
             * Returns the number of times this Timer Event will repeat before finishing.
             * 
             * This should not be confused with the number of times the Timer Event will fire before finishing. A return value of 0 doesn't indicate that the Timer Event has finished running - it indicates that it will not repeat after the next time it fires.
             */
            getRepeatCount(): number;

            /**
             * Returns the local elapsed time for the current iteration of the Timer Event.
             */
            getElapsed(): number;

            /**
             * Returns the local elapsed time for the current iteration of the Timer Event in seconds.
             */
            getElapsedSeconds(): number;

            /**
             * Returns the time interval until the next iteration of the Timer Event.
             */
            getRemaining(): number;

            /**
             * Returns the time interval until the next iteration of the Timer Event in seconds.
             */
            getRemainingSeconds(): number;

            /**
             * Returns the time interval until the last iteration of the Timer Event.
             */
            getOverallRemaining(): number;

            /**
             * Returns the time interval until the last iteration of the Timer Event in seconds.
             */
            getOverallRemainingSeconds(): number;

            /**
             * Forces the Timer Event to immediately expire, thus scheduling its removal in the next frame.
             * @param dispatchCallback If `true`, the function of the Timer Event will be called before its removal. Default false.
             */
            remove(dispatchCallback?: boolean): void;

            /**
             * Destroys all object references in the Timer Event, i.e. its callback, scope, and arguments.
             * 
             * Normally, this method is only called by the Clock when it shuts down. As such, it doesn't stop the Timer Event. If called manually, the Timer Event will still be updated by the Clock, but it won't do anything when it fires.
             */
            destroy(): void;

        }

    }

    namespace Tweens {
        namespace Builders {
            /**
             * Retrieves the value of the given key from an object.
             * @param source The object to retrieve the value from.
             * @param key The key to look for in the `source` object.
             * @param defaultValue The default value to return if the `key` doesn't exist or if no `source` object is provided.
             */
            function GetBoolean(source: object, key: string, defaultValue: boolean): boolean;

            /**
             * This internal function is used to return the correct ease function for a Tween.
             * 
             * It can take a variety of input, including an EaseMap based string, or a custom function.
             * @param ease The ease to find. This can be either a string from the EaseMap, or a custom function.
             * @param easeParams An optional array of ease parameters to go with the ease.
             */
            function GetEaseFunction(ease: string | Function, easeParams?: number[]): Function;

            /**
             * This internal function is used to return the correct interpolation function for a Tween.
             * 
             * It can take a variety of input, including a string, or a custom function.
             * @param interpolation The interpolation function to find. This can be either a string, or a custom function, or null.
             */
            function GetInterpolationFunction(interpolation: string | Function | null): Function | null;

            /**
             * Internal function used by the Tween Builder to create a function that will return
             * the given value from the source.
             * @param source The source object to get the value from.
             * @param key The property to get from the source.
             * @param defaultValue A default value to return should the source not have the property set.
             */
            function GetNewValue(source: any, key: string, defaultValue: any): Function;

            /**
             * Internal function used by the Tween Builder to return an array of properties
             * that the Tween will be operating on. It takes a tween configuration object
             * and then checks that none of the `props` entries start with an underscore, or that
             * none of the direct properties are on the Reserved list.
             * @param config The configuration object of the Tween to get the properties from.
             */
            function GetProps(config: Phaser.Types.Tweens.TweenBuilderConfig): string[];

            /**
             * Extracts an array of targets from a Tween configuration object.
             * 
             * The targets will be looked for in a `targets` property. If it's a function, its return value will be used as the result.
             * @param config The configuration object to use.
             */
            function GetTargets(config: object): any[];

            /**
             * Returns `getActive`, `getStart` and `getEnd` functions for a TweenData based on a target property and end value.
             * 
             * `getActive` if not null, is invoked _immediately_ as soon as the TweenData is running, and is set on the target property.
             * `getEnd` is invoked once any start delays have expired and returns what the value should tween to.
             * `getStart` is invoked when the tween reaches the end and needs to either repeat or yoyo, it returns the value to go back to.
             * 
             * If the end value is a number, it will be treated as an absolute value and the property will be tweened to it.
             * A string can be provided to specify a relative end value which consists of an operation
             * (`+=` to add to the current value, `-=` to subtract from the current value, `*=` to multiply the current
             * value, or `/=` to divide the current value) followed by its operand.
             * 
             * A function can be provided to allow greater control over the end value; it will receive the target
             * object being tweened, the name of the property being tweened, and the current value of the property
             * as its arguments and must return a value.
             * 
             * If both the starting and the ending values need to be controlled, an object with `getStart` and `getEnd`
             * callbacks, which will receive the same arguments, can be provided instead. If an object with a `value`
             * property is provided, the property will be used as the effective value under the same rules described here.
             * @param key The name of the property to modify.
             * @param propertyValue The ending value of the property, as described above.
             */
            function GetValueOp(key: string, propertyValue: any): Function;

            /**
             * Creates a new Number Tween.
             * @param parent The owner of the new Tween.
             * @param config Configuration for the new Tween.
             * @param defaults Tween configuration defaults.
             */
            function NumberTweenBuilder(parent: Phaser.Tweens.TweenManager, config: Phaser.Types.Tweens.NumberTweenBuilderConfig, defaults: Phaser.Types.Tweens.TweenConfigDefaults): Phaser.Tweens.Tween;

            /**
             * Creates a Stagger function to be used by a Tween property.
             * 
             * The stagger function will allow you to stagger changes to the value of the property across all targets of the tween.
             * 
             * This is only worth using if the tween has multiple targets.
             * 
             * The following will stagger the delay by 100ms across all targets of the tween, causing them to scale down to 0.2
             * over the duration specified:
             * 
             * ```javascript
             * this.tweens.add({
             *     targets: [ ... ],
             *     scale: 0.2,
             *     ease: 'linear',
             *     duration: 1000,
             *     delay: this.tweens.stagger(100)
             * });
             * ```
             * 
             * The following will stagger the delay by 500ms across all targets of the tween using a 10 x 6 grid, staggering
             * from the center out, using a cubic ease.
             * 
             * ```javascript
             * this.tweens.add({
             *     targets: [ ... ],
             *     scale: 0.2,
             *     ease: 'linear',
             *     duration: 1000,
             *     delay: this.tweens.stagger(500, { grid: [ 10, 6 ], from: 'center', ease: 'cubic.out' })
             * });
             * ```
             * @param value The amount to stagger by, or an array containing two elements representing the min and max values to stagger between.
             * @param config A Stagger Configuration object.
             */
            function StaggerBuilder(value: number | number[], config?: Phaser.Types.Tweens.StaggerConfig): Function;

            /**
             * Creates a new Tween.
             * @param parent The owner of the new Tween.
             * @param config Configuration for the new Tween.
             * @param defaults Tween configuration defaults.
             */
            function TweenBuilder(parent: Phaser.Tweens.TweenManager, config: Phaser.Types.Tweens.TweenBuilderConfig | object, defaults: Phaser.Types.Tweens.TweenConfigDefaults): Phaser.Tweens.Tween;

            /**
             * Creates a new Tween Chain instance.
             * @param parent The owner of the new Tween.
             * @param config Configuration for the new Tween.
             */
            function TweenChainBuilder(parent: Phaser.Tweens.TweenManager, config: Phaser.Types.Tweens.TweenChainBuilderConfig | object): Phaser.Tweens.TweenChain;

        }

        namespace Events {
            /**
             * The Tween Active Event.
             * 
             * This event is dispatched by a Tween when it becomes active within the Tween Manager.
             * 
             * An 'active' Tween is one that is now progressing, although it may not yet be updating
             * any target properties, due to settings such as `delay`. If you need an event for when
             * the Tween starts actually updating its first property, see `TWEEN_START`.
             * 
             * Listen to it from a Tween instance using `Tween.on('active', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.create({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000
             * });
             * tween.on('active', listener);
             * this.tweens.existing(tween);
             * ```
             * 
             * Note that this event is usually dispatched already by the time you call `this.tweens.add()`, and is
             * meant for use with `tweens.create()` and/or `tweens.existing()`.
             */
            const TWEEN_ACTIVE: string;

            /**
             * The Tween Complete Event.
             * 
             * This event is dispatched by a Tween when it completes playback entirely, factoring in repeats and loops.
             * 
             * If the Tween has been set to loop or repeat infinitely, this event will not be dispatched
             * unless the `Tween.stop` method is called.
             * 
             * If a Tween has a `completeDelay` set, this event will fire after that delay expires.
             * 
             * Listen to it from a Tween instance using `Tween.on('complete', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000
             * });
             * tween.on('complete', listener);
             * ```
             */
            const TWEEN_COMPLETE: string;

            /**
             * The Tween Loop Event.
             * 
             * This event is dispatched by a Tween when it loops.
             * 
             * This event will only be dispatched if the Tween has a loop count set.
             * 
             * If a Tween has a `loopDelay` set, this event will fire after that delay expires.
             * 
             * The difference between `loop` and `repeat` is that `repeat` is a property setting,
             * where-as `loop` applies to the entire Tween.
             * 
             * Listen to it from a Tween instance using `Tween.on('loop', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000,
             *     loop: 6
             * });
             * tween.on('loop', listener);
             * ```
             */
            const TWEEN_LOOP: string;

            /**
             * The Tween Pause Event.
             * 
             * This event is dispatched by a Tween when it is paused.
             * 
             * Listen to it from a Tween instance using `Tween.on('pause', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     ease: 'Power1',
             *     duration: 3000,
             *     x: 600
             * });
             * tween.on('pause', listener);
             * // At some point later ...
             * tween.pause();
             * ```
             */
            const TWEEN_PAUSE: string;

            /**
             * The Tween Repeat Event.
             * 
             * This event is dispatched by a Tween when one of the properties it is tweening repeats.
             * 
             * This event will only be dispatched if the Tween has a property with a repeat count set.
             * 
             * If a Tween has a `repeatDelay` set, this event will fire after that delay expires.
             * 
             * The difference between `loop` and `repeat` is that `repeat` is a property setting,
             * where-as `loop` applies to the entire Tween.
             * 
             * Listen to it from a Tween instance using `Tween.on('repeat', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000,
             *     repeat: 4
             * });
             * tween.on('repeat', listener);
             * ```
             */
            const TWEEN_REPEAT: string;

            /**
             * The Tween Resume Event.
             * 
             * This event is dispatched by a Tween when it is resumed from a paused state.
             * 
             * Listen to it from a Tween instance using `Tween.on('resume', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     ease: 'Power1',
             *     duration: 3000,
             *     x: 600
             * });
             * tween.on('resume', listener);
             * // At some point later ...
             * tween.resume();
             * ```
             */
            const TWEEN_RESUME: string;

            /**
             * The Tween Start Event.
             * 
             * This event is dispatched by a Tween when it starts tweening its first property.
             * 
             * A Tween will only emit this event once, as it can only start once.
             * 
             * If a Tween has a `delay` set, this event will fire after that delay expires.
             * 
             * Listen to it from a Tween instance using `Tween.on('start', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000
             * });
             * tween.on('start', listener);
             * ```
             */
            const TWEEN_START: string;

            /**
             * The Tween Stop Event.
             * 
             * This event is dispatched by a Tween when it is stopped.
             * 
             * Listen to it from a Tween instance using `Tween.on('stop', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000
             * });
             * tween.on('stop', listener);
             * ```
             */
            const TWEEN_STOP: string;

            /**
             * The Tween Update Event.
             * 
             * This event is dispatched by a Tween every time it updates _any_ of the properties it is tweening.
             * 
             * A Tween that is changing 3 properties of a target will emit this event 3 times per change, once per property.
             * 
             * **Note:** This is a very high frequency event and may be dispatched multiple times, every single frame.
             * 
             * Listen to it from a Tween instance using `Tween.on('update', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000,
             * });
             * tween.on('update', listener);
             * ```
             */
            const TWEEN_UPDATE: string;

            /**
             * The Tween Yoyo Event.
             * 
             * This event is dispatched by a Tween whenever a property it is tweening yoyos.
             * 
             * This event will only be dispatched if the Tween has a property with `yoyo` set.
             * 
             * If the Tween has a `hold` value, this event is dispatched when the hold expires.
             * 
             * This event is dispatched for every property, and for every target, that yoyos.
             * For example, if a Tween was updating 2 properties and had 10 targets, this event
             * would be dispatched 20 times (twice per target). So be careful how you use it!
             * 
             * Listen to it from a Tween instance using `Tween.on('yoyo', listener)`, i.e.:
             * 
             * ```javascript
             * var tween = this.tweens.add({
             *     targets: image,
             *     x: 500,
             *     ease: 'Power1',
             *     duration: 3000,
             *     yoyo: true
             * });
             * tween.on('yoyo', listener);
             * ```
             */
            const TWEEN_YOYO: string;

        }

        /**
         * As the name implies, this is the base Tween class that both the Tween and TweenChain
         * inherit from. It contains shared properties and methods common to both types of Tween.
         * 
         * Typically you would never instantiate this class directly, although you could certainly
         * use it to create your own variation of Tweens from.
         */
        class BaseTween extends Phaser.Events.EventEmitter {
            /**
             * 
             * @param parent A reference to the Tween Manager, or Tween Chain, that owns this Tween.
             */
            constructor(parent: Phaser.Tweens.TweenManager | Phaser.Tweens.TweenChain);

            /**
             * A reference to the Tween Manager, or Tween Chain, that owns this Tween.
             */
            parent: Phaser.Tweens.TweenManager | Phaser.Tweens.TweenChain;

            /**
             * The main data array. For a Tween, this contains all of the `TweenData` objects, each
             * containing a unique property and target that is being tweened.
             * 
             * For a TweenChain, this contains an array of `Tween` instances, which are being played
             * through in sequence.
             */
            data: Phaser.Tweens.TweenData[] | Phaser.Tweens.Tween[];

            /**
             * The cached size of the data array.
             */
            totalData: number;

            /**
             * The time in milliseconds before the 'onStart' event fires.
             * 
             * For a Tween, this is the shortest `delay` value across all of the TweenDatas it owns.
             * For a TweenChain, it is whatever delay value was given in the configuration.
             */
            startDelay: number;

            /**
             * Has this Tween started playback yet?
             * 
             * This boolean is toggled when the Tween leaves the 'start delayed' state and begins running.
             */
            readonly hasStarted: boolean;

            /**
             * Scales the time applied to this Tween. A value of 1 runs in real-time. A value of 0.5 runs 50% slower, and so on.
             * 
             * The value isn't used when calculating total duration of the tween, it's a run-time delta adjustment only.
             * 
             * This value is multiplied by the `TweenManager.timeScale`.
             */
            timeScale: number;

            /**
             * The number of times this Tween will loop.
             * 
             * Can be -1 for an infinite loop, zero for none, or a positive integer.
             * 
             * Typically this is set in the configuration object, but can also be set directly
             * as long as this Tween is paused and hasn't started playback.
             * 
             * When enabled it will play through ALL Tweens again.
             * 
             * Use TweenData.repeat to loop a single element.
             */
            loop: number;

            /**
             * The time in milliseconds before the Tween loops.
             * 
             * Only used if `loop` is > 0.
             */
            loopDelay: number;

            /**
             * Internal counter recording how many loops are left to run.
             */
            loopCounter: number;

            /**
             * The time in milliseconds before the 'onComplete' event fires.
             * 
             * This never fires if `loop = -1` as it never completes because it has been
             * set to loop forever.
             */
            completeDelay: number;

            /**
             * An internal countdown timer (used by loopDelay and completeDelay)
             */
            countdown: number;

            /**
             * The current state of the Tween.
             */
            state: Phaser.Tweens.StateType;

            /**
             * Is the Tween currently paused?
             * 
             * A paused Tween needs to be started with the `play` method, or resumed with the `resume` method.
             * 
             * This property can be toggled at runtime if required.
             */
            paused: boolean;

            /**
             * An object containing the different Tween callback functions.
             * 
             * You can either set these in the Tween config, or by calling the `Tween.setCallback` method.
             * 
             * The types available are:
             * 
             * `onActive` - When the Tween is first created it moves to an 'active' state when added to the Tween Manager. 'Active' does not mean 'playing'.
             * `onStart` - When the Tween starts playing after a delayed or paused state. This will happen at the same time as `onActive` if the tween has no delay and isn't paused.
             * `onLoop` - When a Tween loops, if it has been set to do so. This happens _after_ the `loopDelay` expires, if set.
             * `onComplete` - When the Tween finishes playback fully. Never invoked if the Tween is set to repeat infinitely.
             * `onStop` - Invoked only if the `Tween.stop` method is called.
             * `onPause` - Invoked only if the `Tween.pause` method is called. Not invoked if the Tween Manager is paused.
             * `onResume` - Invoked only if the `Tween.resume` method is called. Not invoked if the Tween Manager is resumed.
             * 
             * The following types are also available and are invoked on a `TweenData` level - that is per-object, per-property, being tweened.
             * 
             * `onYoyo` - When a TweenData starts a yoyo. This happens _after_ the `hold` delay expires, if set.
             * `onRepeat` - When a TweenData repeats playback. This happens _after_ the `repeatDelay` expires, if set.
             * `onUpdate` - When a TweenData updates a property on a source target during playback.
             */
            callbacks: Phaser.Types.Tweens.TweenCallbacks;

            /**
             * The scope (or context) in which all of the callbacks are invoked.
             * 
             * This defaults to be this Tween, but you can override this property
             * to set it to whatever object you require.
             */
            callbackScope: any;

            /**
             * Will this Tween persist after playback? A Tween that persists will _not_ be destroyed by the
             * Tween Manager, or when calling `Tween.stop`, and can be re-played as required. You can either
             * set this property when creating the tween in the tween config, or set it _prior_ to playback.
             * 
             * However, it's up to you to ensure you destroy persistent tweens when you are finished with them,
             * or they will retain references you may no longer require and waste memory.
             * 
             * By default, `Tweens` are set to _not_ persist, so they are automatically cleaned-up by
             * the Tween Manager. But `TweenChains` _do_ persist by default, unless overridden in their
             * config. This is because the type of situations you use a chain for is far more likely to
             * need to be replayed again in the future, rather than disposed of.
             */
            persist: boolean;

            /**
             * Sets the value of the time scale applied to this Tween. A value of 1 runs in real-time.
             * A value of 0.5 runs 50% slower, and so on.
             * 
             * The value isn't used when calculating total duration of the tween, it's a run-time delta adjustment only.
             * 
             * This value is multiplied by the `TweenManager.timeScale`.
             * @param value The time scale value to set.
             */
            setTimeScale(value: number): this;

            /**
             * Gets the value of the time scale applied to this Tween. A value of 1 runs in real-time.
             * A value of 0.5 runs 50% slower, and so on.
             */
            getTimeScale(): number;

            /**
             * Checks if this Tween is currently playing.
             * 
             * If this Tween is paused, or not active, this method will return false.
             */
            isPlaying(): boolean;

            /**
             * Checks if the Tween is currently paused.
             * 
             * This is the same as inspecting the `BaseTween.paused` property directly.
             */
            isPaused(): boolean;

            /**
             * Pauses the Tween immediately. Use `resume` to continue playback.
             * 
             * You can also toggle the `Tween.paused` boolean property, but doing so will not trigger the PAUSE event.
             */
            pause(): this;

            /**
             * Resumes the playback of a previously paused Tween.
             * 
             * You can also toggle the `Tween.paused` boolean property, but doing so will not trigger the RESUME event.
             */
            resume(): this;

            /**
             * Internal method that makes this Tween active within the TweenManager
             * and emits the onActive event and callback.
             */
            makeActive(): void;

            /**
             * Internal method that handles this tween completing and emitting the onComplete event
             * and callback.
             */
            onCompleteHandler(): void;

            /**
             * Flags the Tween as being complete, whatever stage of progress it is at.
             * 
             * If an `onComplete` callback has been defined it will automatically invoke it, unless a `delay`
             * argument is provided, in which case the Tween will delay for that period of time before calling the callback.
             * 
             * If you don't need a delay or don't have an `onComplete` callback then call `Tween.stop` instead.
             * @param delay The time to wait before invoking the complete callback. If zero it will fire immediately. Default 0.
             */
            complete(delay?: number): this;

            /**
             * Flags the Tween as being complete only once the current loop has finished.
             * 
             * This is a useful way to stop an infinitely looping tween once a complete cycle is over,
             * rather than abruptly.
             * 
             * If you don't have a loop then call `Tween.stop` instead.
             * @param loops The number of loops that should finish before this tween completes. Zero means complete just the current loop. Default 0.
             */
            completeAfterLoop(loops?: number): this;

            /**
             * Immediately removes this Tween from the TweenManager and all of its internal arrays,
             * no matter what stage it is at. Then sets the tween state to `REMOVED`.
             * 
             * You should dispose of your reference to this tween after calling this method, to
             * free it from memory. If you no longer require it, call `Tween.destroy()` on it.
             */
            remove(): this;

            /**
             * Stops the Tween immediately, whatever stage of progress it is at.
             * 
             * If not a part of a Tween Chain it is also flagged for removal by the Tween Manager.
             * 
             * If an `onStop` callback has been defined it will automatically invoke it.
             * 
             * The Tween will be removed during the next game frame, but should be considered 'destroyed' from this point on.
             * 
             * Typically, you cannot play a Tween that has been stopped. If you just wish to pause the tween, not destroy it,
             * then call the `pause` method instead and use `resume` to continue playback. If you wish to restart the Tween,
             * use the `restart` or `seek` methods.
             */
            stop(): this;

            /**
             * Internal method that handles the processing of the loop delay countdown timer and
             * the dispatch of related events. Called automatically by `Tween.update`.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            updateLoopCountdown(delta: number): void;

            /**
             * Internal method that handles the processing of the start delay countdown timer and
             * the dispatch of related events. Called automatically by `Tween.update`.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            updateStartCountdown(delta: number): void;

            /**
             * Internal method that handles the processing of the complete delay countdown timer and
             * the dispatch of related events. Called automatically by `Tween.update`.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            updateCompleteDelay(delta: number): void;

            /**
             * Sets an event based callback to be invoked during playback.
             * 
             * Calling this method will replace a previously set callback for the given type, if any exists.
             * 
             * The types available are:
             * 
             * `onActive` - When the Tween is first created it moves to an 'active' state when added to the Tween Manager. 'Active' does not mean 'playing'.
             * `onStart` - When the Tween starts playing after a delayed or paused state. This will happen at the same time as `onActive` if the tween has no delay and isn't paused.
             * `onLoop` - When a Tween loops, if it has been set to do so. This happens _after_ the `loopDelay` expires, if set.
             * `onComplete` - When the Tween finishes playback fully. Never invoked if the Tween is set to repeat infinitely.
             * `onStop` - Invoked only if the `Tween.stop` method is called.
             * `onPause` - Invoked only if the `Tween.pause` method is called. Not invoked if the Tween Manager is paused.
             * `onResume` - Invoked only if the `Tween.resume` method is called. Not invoked if the Tween Manager is resumed.
             * 
             * The following types are also available and are invoked on a `TweenData` level - that is per-object, per-property, being tweened.
             * 
             * `onYoyo` - When a TweenData starts a yoyo. This happens _after_ the `hold` delay expires, if set.
             * `onRepeat` - When a TweenData repeats playback. This happens _after_ the `repeatDelay` expires, if set.
             * `onUpdate` - When a TweenData updates a property on a source target during playback.
             * @param type The type of callback to set. One of: `onActive`, `onComplete`, `onLoop`, `onPause`, `onRepeat`, `onResume`, `onStart`, `onStop`, `onUpdate` or `onYoyo`.
             * @param callback Your callback that will be invoked.
             * @param params The parameters to pass to the callback. Pass an empty array if you don't want to define any, but do wish to set the scope.
             */
            setCallback(type: Phaser.Types.Tweens.TweenCallbackTypes, callback: Function, params?: any[]): this;

            /**
             * Sets this Tween state to PENDING.
             */
            setPendingState(): void;

            /**
             * Sets this Tween state to ACTIVE.
             */
            setActiveState(): void;

            /**
             * Sets this Tween state to LOOP_DELAY.
             */
            setLoopDelayState(): void;

            /**
             * Sets this Tween state to COMPLETE_DELAY.
             */
            setCompleteDelayState(): void;

            /**
             * Sets this Tween state to START_DELAY.
             */
            setStartDelayState(): void;

            /**
             * Sets this Tween state to PENDING_REMOVE.
             */
            setPendingRemoveState(): void;

            /**
             * Sets this Tween state to REMOVED.
             */
            setRemovedState(): void;

            /**
             * Sets this Tween state to FINISHED.
             */
            setFinishedState(): void;

            /**
             * Sets this Tween state to DESTROYED.
             */
            setDestroyedState(): void;

            /**
             * Returns `true` if this Tween has a _current_ state of PENDING, otherwise `false`.
             */
            isPending(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of ACTIVE, otherwise `false`.
             */
            isActive(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of LOOP_DELAY, otherwise `false`.
             */
            isLoopDelayed(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of COMPLETE_DELAY, otherwise `false`.
             */
            isCompleteDelayed(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of START_DELAY, otherwise `false`.
             */
            isStartDelayed(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of PENDING_REMOVE, otherwise `false`.
             */
            isPendingRemove(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of REMOVED, otherwise `false`.
             */
            isRemoved(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of FINISHED, otherwise `false`.
             */
            isFinished(): boolean;

            /**
             * Returns `true` if this Tween has a _current_ state of DESTROYED, otherwise `false`.
             */
            isDestroyed(): boolean;

            /**
             * Handles the destroy process of this Tween, clearing out the
             * Tween Data and resetting the targets. A Tween that has been
             * destroyed cannot ever be played or used again.
             */
            destroy(): void;

        }

        /**
         * BaseTweenData is the class that the TweenData and TweenFrameData classes
         * extend from. You should not typically instantiate this class directly, but instead
         * use it to form your own tween data classes from, should you require it.
         * 
         * Prior to Phaser 3.60 the TweenData was just an object, but was refactored to a class,
         * to make it responsible for its own state and updating.
         */
        class BaseTweenData {
            /**
             * 
             * @param tween The tween this TweenData instance belongs to.
             * @param targetIndex The target index within the Tween targets array.
             * @param key The property of the target to tween.
             * @param getEnd What the property will be at the END of the Tween.
             * @param getStart What the property will be at the START of the Tween.
             * @param getActive If not null, is invoked _immediately_ as soon as the TweenData is running, and is set on the target property.
             * @param ease The ease function this tween uses.
             * @param delay Function that returns the time in milliseconds before tween will start.
             * @param duration The duration of the tween in milliseconds.
             * @param yoyo Determines whether the tween should return back to its start value after hold has expired.
             * @param hold Function that returns the time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
             * @param repeat Function that returns the number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
             * @param repeatDelay Function that returns the time in milliseconds before the repeat will start.
             * @param flipX Should toggleFlipX be called when yoyo or repeat happens?
             * @param flipY Should toggleFlipY be called when yoyo or repeat happens?
             * @param interpolation The interpolation function to be used for arrays of data. Defaults to 'null'.
             * @param interpolationData The array of interpolation data to be set. Defaults to 'null'.
             */
            constructor(tween: Phaser.Tweens.Tween, targetIndex: number, key: string, getEnd: Phaser.Types.Tweens.GetEndCallback, getStart: Phaser.Types.Tweens.GetStartCallback, getActive: Phaser.Types.Tweens.GetActiveCallback | undefined, ease: Function, delay: Function, duration: number, yoyo: boolean, hold: number, repeat: number, repeatDelay: number, flipX: boolean, flipY: boolean, interpolation: Function | undefined, interpolationData: number[] | undefined);

            /**
             * A reference to the Tween that this TweenData instance belongs to.
             */
            tween: Phaser.Tweens.Tween;

            /**
             * The index of the target within the Tween `targets` array.
             */
            targetIndex: number;

            /**
             * The duration of the tween in milliseconds, excluding any time required
             * for yoyo or repeats.
             */
            duration: number;

            /**
             * The total calculated duration, in milliseconds, of this TweenData.
             * Factoring in the duration, repeats, delays and yoyos.
             */
            totalDuration: number;

            /**
             * The time, in milliseconds, before this tween will start playing.
             * 
             * This value is generated by the `getDelay` function.
             */
            delay: number;

            /**
             * This function returns the value to be used for `TweenData.delay`.
             */
            getDelay: Function;

            /**
             * Will the Tween ease back to its starting values, after reaching the end
             * and any `hold` value that may be set?
             */
            yoyo: boolean;

            /**
             * The time, in milliseconds, before this tween will start a yoyo to repeat.
             */
            hold: number;

            /**
             * The number of times this tween will repeat.
             * 
             * The tween will always run once regardless of this value,
             * so a repeat value of '1' will play the tween twice: I.e. the original
             * play-through and then it repeats that once (1).
             * 
             * If this value is set to -1 this tween will repeat forever.
             */
            repeat: number;

            /**
             * The time, in milliseconds, before the repeat will start.
             */
            repeatDelay: number;

            /**
             * How many repeats are left to run?
             */
            repeatCounter: number;

            /**
             * If `true` this Tween will call `toggleFlipX` on the Tween target
             * whenever it yoyo's or repeats. It will only be called if the target
             * has a function matching this name, like most Phaser GameObjects do.
             */
            flipX: boolean;

            /**
             * If `true` this Tween will call `toggleFlipY` on the Tween target
             * whenever it yoyo's or repeats. It will only be called if the target
             * has a function matching this name, like most Phaser GameObjects do.
             */
            flipY: boolean;

            /**
             * A value between 0 and 1 holding the progress of this TweenData.
             */
            progress: number;

            /**
             * The amount of time, in milliseconds, that has elapsed since this
             * TweenData was made active.
             */
            elapsed: number;

            /**
             * The state of this TweenData.
             */
            state: Phaser.Tweens.StateType;

            /**
             * Is this Tween Data currently waiting for a countdown to elapse, or not?
             */
            isCountdown: boolean;

            /**
             * Returns a reference to the target object belonging to this TweenData.
             */
            getTarget(): object;

            /**
             * Sets this TweenData's target object property to be the given value.
             * @param value The value to set on the target. If not given, sets it to the last `current` value.
             */
            setTargetValue(value?: number): void;

            /**
             * Sets this TweenData state to CREATED.
             */
            setCreatedState(): void;

            /**
             * Sets this TweenData state to DELAY.
             */
            setDelayState(): void;

            /**
             * Sets this TweenData state to PENDING_RENDER.
             */
            setPendingRenderState(): void;

            /**
             * Sets this TweenData state to PLAYING_FORWARD.
             */
            setPlayingForwardState(): void;

            /**
             * Sets this TweenData state to PLAYING_BACKWARD.
             */
            setPlayingBackwardState(): void;

            /**
             * Sets this TweenData state to HOLD_DELAY.
             */
            setHoldState(): void;

            /**
             * Sets this TweenData state to REPEAT_DELAY.
             */
            setRepeatState(): void;

            /**
             * Sets this TweenData state to COMPLETE.
             */
            setCompleteState(): void;

            /**
             * Returns `true` if this TweenData has a _current_ state of CREATED, otherwise `false`.
             */
            isCreated(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of DELAY, otherwise `false`.
             */
            isDelayed(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of PENDING_RENDER, otherwise `false`.
             */
            isPendingRender(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of PLAYING_FORWARD, otherwise `false`.
             */
            isPlayingForward(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of PLAYING_BACKWARD, otherwise `false`.
             */
            isPlayingBackward(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of HOLD_DELAY, otherwise `false`.
             */
            isHolding(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of REPEAT_DELAY, otherwise `false`.
             */
            isRepeating(): boolean;

            /**
             * Returns `true` if this TweenData has a _current_ state of COMPLETE, otherwise `false`.
             */
            isComplete(): boolean;

            /**
             * Internal method used as part of the playback process that checks if this
             * TweenData should yoyo, repeat, or has completed.
             * @param diff Any extra time that needs to be accounted for in the elapsed and progress values.
             */
            setStateFromEnd(diff: number): void;

            /**
             * Internal method used as part of the playback process that checks if this
             * TweenData should repeat or has completed.
             * @param diff Any extra time that needs to be accounted for in the elapsed and progress values.
             */
            setStateFromStart(diff: number): void;

            /**
             * Internal method that resets this Tween Data entirely, including the progress and elapsed values.
             * 
             * Called automatically by the parent Tween. Should not be called directly.
             */
            reset(): void;

            /**
             * Internal method that handles repeating or yoyo'ing this TweenData.
             * 
             * Called automatically by `setStateFromStart` and `setStateFromEnd`.
             * @param diff Any extra time that needs to be accounted for in the elapsed and progress values.
             * @param setStart Set the TweenData start values?
             * @param isYoyo Is this call a Yoyo check?
             */
            onRepeat(diff: number, setStart: boolean, isYoyo: boolean): void;

            /**
             * Immediately destroys this TweenData, nulling of all its references.
             */
            destroy(): void;

        }

        /**
         * Phaser Tween States.
         */
        enum States {
            /**
             * TweenData state.
             */
            CREATED,
            /**
             * TweenData state.
             */
            DELAY,
            /**
             * TweenData state.
             */
            PENDING_RENDER,
            /**
             * TweenData state.
             */
            PLAYING_FORWARD,
            /**
             * TweenData state.
             */
            PLAYING_BACKWARD,
            /**
             * TweenData state.
             */
            HOLD_DELAY,
            /**
             * TweenData state.
             */
            REPEAT_DELAY,
            /**
             * TweenData state.
             */
            COMPLETE,
            /**
             * Tween state. The Tween has been created but has not yet been added to the Tween Manager.
             */
            PENDING,
            /**
             * Tween state. The Tween is active within the Tween Manager. This means it is either playing,
             * or was playing and is currently paused, but in both cases it's still being processed by
             * the Tween Manager, so is considered 'active'.
             */
            ACTIVE,
            /**
             * Tween state. The Tween is waiting for a loop countdown to elapse.
             */
            LOOP_DELAY,
            /**
             * Tween state. The Tween is waiting for a complete delay to elapse.
             */
            COMPLETE_DELAY,
            /**
             * Tween state. The Tween is waiting for a starting delay to elapse.
             */
            START_DELAY,
            /**
             * Tween state. The Tween has finished playback and is waiting to be removed from the Tween Manager.
             */
            PENDING_REMOVE,
            /**
             * Tween state. The Tween has been removed from the Tween Manager.
             */
            REMOVED,
            /**
             * Tween state. The Tween has finished playback but was flagged as 'persistent' during creation,
             * so will not be automatically removed by the Tween Manager.
             */
            FINISHED,
            /**
             * Tween state. The Tween has been destroyed and can no longer be played by a Tween Manager.
             */
            DESTROYED,
            /**
             * A large integer value used for 'infinite' style countdowns.
             * 
             * Similar use-case to Number.MAX_SAFE_INTEGER but we cannot use that because it's not
             * supported on IE.
             */
            MAX,
        }

        /**
         * Phaser Tween state constants.
         */
        type StateType = Phaser.Tweens.States;

        /**
         * A Tween is able to manipulate the properties of one or more objects to any given value, based
         * on a duration and type of ease. They are rarely instantiated directly and instead should be
         * created via the TweenManager.
         * 
         * Please note that a Tween will not manipulate any property that begins with an underscore.
         */
        class Tween extends Phaser.Tweens.BaseTween {
            /**
             * 
             * @param parent A reference to the Tween Manager that owns this Tween.
             * @param targets An array of targets to be tweened.
             */
            constructor(parent: Phaser.Tweens.TweenManager, targets: object[]);

            /**
             * An array of references to the target/s this Tween is operating on.
             * 
             * This array should not be manipulated outside of this Tween.
             */
            targets: object[];

            /**
             * Cached target total.
             * 
             * Used internally and should be treated as read-only.
             * 
             * This is not necessarily the same as the data total.
             */
            totalTargets: number;

            /**
             * Is this Tween currently seeking?
             * 
             * This boolean is toggled in the `Tween.seek` method.
             * 
             * When a tween is seeking, by default it will not dispatch any events or callbacks.
             */
            readonly isSeeking: boolean;

            /**
             * Does this Tween loop or repeat infinitely?
             */
            readonly isInfinite: boolean;

            /**
             * Elapsed time in milliseconds of this run through of the Tween.
             */
            elapsed: number;

            /**
             * Total elapsed time in milliseconds of the entire Tween, including looping.
             */
            totalElapsed: number;

            /**
             * Time in milliseconds for the whole Tween to play through once, excluding loop amounts and loop delays.
             * 
             * This value is set in the `Tween.initTweenData` method and is zero before that point.
             */
            duration: number;

            /**
             * Value between 0 and 1. The amount of progress through the Tween, excluding loops.
             */
            progress: number;

            /**
             * Time in milliseconds it takes for the Tween to complete a full playthrough (including looping)
             * 
             * For an infinite Tween, this value is a very large integer.
             */
            totalDuration: number;

            /**
             * The amount of progress that has been made through the entire Tween, including looping.
             * 
             * A value between 0 and 1.
             */
            totalProgress: number;

            /**
             * Adds a new TweenData to this Tween. Typically, this method is called
             * automatically by the TweenBuilder, however you can also invoke it
             * yourself.
             * @param targetIndex The target index within the Tween targets array.
             * @param key The property of the target to tween.
             * @param getEnd What the property will be at the END of the Tween.
             * @param getStart What the property will be at the START of the Tween.
             * @param getActive If not null, is invoked _immediately_ as soon as the TweenData is running, and is set on the target property.
             * @param ease The ease function this tween uses.
             * @param delay Function that returns the time in milliseconds before tween will start.
             * @param duration The duration of the tween in milliseconds.
             * @param yoyo Determines whether the tween should return back to its start value after hold has expired.
             * @param hold Function that returns the time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
             * @param repeat Function that returns the number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
             * @param repeatDelay Function that returns the time in milliseconds before the repeat will start.
             * @param flipX Should toggleFlipX be called when yoyo or repeat happens?
             * @param flipY Should toggleFlipY be called when yoyo or repeat happens?
             * @param interpolation The interpolation function to be used for arrays of data. Defaults to 'null'.
             * @param interpolationData The array of interpolation data to be set. Defaults to 'null'.
             */
            add(targetIndex: number, key: string, getEnd: Phaser.Types.Tweens.GetEndCallback, getStart: Phaser.Types.Tweens.GetStartCallback, getActive: Phaser.Types.Tweens.GetActiveCallback | undefined, ease: Function, delay: Function, duration: number, yoyo: boolean, hold: number, repeat: number, repeatDelay: number, flipX: boolean, flipY: boolean, interpolation: Function | undefined, interpolationData: number[] | undefined): Phaser.Tweens.TweenData;

            /**
             * Adds a new TweenFrameData to this Tween. Typically, this method is called
             * automatically by the TweenBuilder, however you can also invoke it
             * yourself.
             * @param targetIndex The target index within the Tween targets array.
             * @param texture The texture to set on the target at the end of the tween.
             * @param frame The texture frame to set on the target at the end of the tween.
             * @param delay Function that returns the time in milliseconds before tween will start.
             * @param duration The duration of the tween in milliseconds.
             * @param hold Function that returns the time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
             * @param repeat Function that returns the number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
             * @param repeatDelay Function that returns the time in milliseconds before the repeat will start.
             * @param flipX Should toggleFlipX be called when yoyo or repeat happens?
             * @param flipY Should toggleFlipY be called when yoyo or repeat happens?
             */
            addFrame(targetIndex: number, texture: string, frame: string | number, delay: Function, duration: number, hold: number, repeat: number, repeatDelay: number, flipX: boolean, flipY: boolean): Phaser.Tweens.TweenFrameData;

            /**
             * Returns the current value of the specified Tween Data.
             * 
             * If this Tween has been destroyed, it will return `null`.
             * @param index The Tween Data to return the value from. Default 0.
             */
            getValue(index?: number): number;

            /**
             * See if this Tween is currently acting upon the given target.
             * @param target The target to check against this Tween.
             */
            hasTarget(target: object): boolean;

            /**
             * Updates the 'end' value of the given property across all matching targets, as long
             * as this Tween is currently playing (either forwards or backwards).
             * 
             * Calling this does not adjust the duration of the Tween, or the current progress.
             * 
             * You can optionally tell it to set the 'start' value to be the current value.
             * 
             * If this Tween is in any other state other than playing then calling this method has no effect.
             * 
             * Additionally, if the Tween repeats, is reset, or is seeked, it will revert to the original
             * starting and ending values.
             * @param key The property to set the new value for. You cannot update the 'texture' property via this method.
             * @param value The new value of the property.
             * @param startToCurrent Should this change set the start value to be the current value? Default false.
             */
            updateTo(key: string, value: number, startToCurrent?: boolean): this;

            /**
             * Restarts the Tween from the beginning.
             * 
             * If the Tween has already finished and been destroyed, restarting it will throw an error.
             * 
             * If you wish to restart the Tween from a specific point, use the `Tween.seek` method instead.
             */
            restart(): this;

            /**
             * Internal method that advances to the next state of the Tween during playback.
             */
            nextState(): boolean;

            /**
             * Internal method that handles this tween completing and starting
             * the next tween in the chain, if any.
             */
            onCompleteHandler(): void;

            /**
             * Starts a Tween playing.
             * 
             * You only need to call this method if you have configured the tween to be paused on creation.
             * 
             * If the Tween is already playing, calling this method again will have no effect. If you wish to
             * restart the Tween, use `Tween.restart` instead.
             * 
             * Calling this method after the Tween has completed will start the Tween playing again from the beginning.
             * This is the same as calling `Tween.seek(0)` and then `Tween.play()`.
             */
            play(): this;

            /**
             * Seeks to a specific point in the Tween.
             * 
             * The given amount is a value in milliseconds that represents how far into the Tween
             * you wish to seek, based on the start of the Tween.
             * 
             * Note that the seek amount takes the entire duration of the Tween into account, including delays, loops and repeats.
             * For example, a Tween that lasts for 2 seconds, but that loops 3 times, would have a total duration of 6 seconds,
             * so seeking to 3000 ms would seek to the Tweens half-way point based on its _entire_ duration.
             * 
             * Prior to Phaser 3.60 this value was given as a number between 0 and 1 and didn't
             * work for Tweens had an infinite repeat. This new method works for all Tweens.
             * 
             * Seeking works by resetting the Tween to its initial values and then iterating through the Tween at `delta`
             * jumps per step. The longer the Tween, the longer this can take. If you need more precision you can
             * reduce the delta value. If you need a faster seek, you can increase it. When the Tween is
             * reset it will refresh the starting and ending values. If these are coming from a dynamic function,
             * or a random array, it will be called for each seek.
             * 
             * While seeking the Tween will _not_ emit any of its events or callbacks unless
             * the 3rd parameter is set to `true`.
             * 
             * If this Tween is paused, seeking will not change this fact. It will advance the Tween
             * to the desired point and then pause it again.
             * @param amount The number of milliseconds to seek into the Tween from the beginning. Default 0.
             * @param delta The size of each step when seeking through the Tween. A higher value completes faster but at the cost of less precision. Default 16.6.
             * @param emit While seeking, should the Tween emit any of its events or callbacks? The default is 'false', i.e. to seek silently. Default false.
             */
            seek(amount?: number, delta?: number, emit?: boolean): this;

            /**
             * Initialises all of the Tween Data and Tween values.
             * 
             * This is called automatically and should not typically be invoked directly.
             * @param isSeeking Is the Tween Data being reset as part of a seek? Default false.
             */
            initTweenData(isSeeking?: boolean): void;

            /**
             * Resets this Tween ready for another play-through.
             * 
             * This is called automatically from the Tween Manager, or from the parent TweenChain,
             * and should not typically be invoked directly.
             * 
             * If you wish to restart this Tween, use the `Tween.restart` or `Tween.seek` methods instead.
             * @param skipInit Skip resetting the TweenData and Active State? Default false.
             */
            reset(skipInit?: boolean): this;

            /**
             * Internal method that advances the Tween based on the time values.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            update(delta: number): boolean;

            /**
             * Moves this Tween forward by the given amount of milliseconds.
             * 
             * It will only advance through the current loop of the Tween. For example, if the
             * Tween is set to repeat or yoyo, it can only fast forward through a single
             * section of the sequence. Use `Tween.seek` for more complex playhead control.
             * 
             * If the Tween is paused or has already finished, calling this will have no effect.
             * @param ms The number of milliseconds to advance this Tween by.
             */
            forward(ms: number): this;

            /**
             * Moves this Tween backward by the given amount of milliseconds.
             * 
             * It will only rewind through the current loop of the Tween. For example, if the
             * Tween is set to repeat or yoyo, it can only fast forward through a single
             * section of the sequence. Use `Tween.seek` for more complex playhead control.
             * 
             * If the Tween is paused or has already finished, calling this will have no effect.
             * @param ms The number of milliseconds to rewind this Tween by.
             */
            rewind(ms: number): this;

            /**
             * Internal method that will emit a Tween based Event and invoke the given callback.
             * @param event The Event to be dispatched.
             * @param callback The name of the callback to be invoked. Can be `null` or `undefined` to skip invocation.
             */
            dispatchEvent(event: Phaser.Types.Tweens.Event, callback?: Phaser.Types.Tweens.TweenCallbackTypes): void;

            /**
             * Handles the destroy process of this Tween, clearing out the
             * Tween Data and resetting the targets. A Tween that has been
             * destroyed cannot ever be played or used again.
             */
            destroy(): void;

        }

        /**
         * A TweenChain is a special type of Tween that allows you to create a sequence of Tweens, chained to one-another,
         * and add them to the Tween Manager.
         * 
         * The tweens are played in order, from start to finish. You can optionally set the chain
         * to repeat as many times as you like. Once the chain has finished playing, or repeating if set,
         * all tweens in the chain will be destroyed automatically. To override this, set the 'persist'
         * argument to 'true'.
         * 
         * Playback will start immediately unless the _first_ Tween has been configured to be paused.
         * 
         * Please note that Tweens will not manipulate any target property that begins with an underscore.
         */
        class TweenChain extends Phaser.Tweens.BaseTween {
            /**
             * 
             * @param parent A reference to the Tween Manager, or TweenChain, that owns this TweenChain.
             */
            constructor(parent: Phaser.Tweens.TweenManager | Phaser.Tweens.TweenChain);

            /**
             * A reference to the Tween that this TweenChain is currently playing.
             */
            currentTween: Phaser.Tweens.Tween;

            /**
             * A reference to the data array index of the currently playing tween.
             */
            currentIndex: number;

            /**
             * Prepares this TweenChain for playback.
             * 
             * Called automatically by the TweenManager. Should not be called directly.
             */
            init(): this;

            /**
             * Create a sequence of Tweens, chained to one-another, and add them to this Tween Manager.
             * 
             * The tweens are played in order, from start to finish. You can optionally set the chain
             * to repeat as many times as you like. Once the chain has finished playing, or repeating if set,
             * all tweens in the chain will be destroyed automatically. To override this, set the 'persist'
             * argument to 'true'.
             * 
             * Playback will start immediately unless the _first_ Tween has been configured to be paused.
             * 
             * Please note that Tweens will not manipulate any target property that begins with an underscore.
             * @param tweens An array of Tween configuration objects for the Tweens in this chain.
             */
            add(tweens: Phaser.Types.Tweens.TweenBuilderConfig[] | object[]): this;

            /**
             * See if any of the tweens in this Tween Chain is currently acting upon the given target.
             * @param target The target to check against this TweenChain.
             */
            hasTarget(target: object): boolean;

            /**
             * Restarts the TweenChain from the beginning.
             * 
             * If this TweenChain was configured to have a loop, or start delay, those
             * are reset to their initial values as well. It will also dispatch the
             * `onActive` callback and event again.
             */
            restart(): this;

            /**
             * Resets the given Tween.
             * 
             * It will seek to position 0 and playback will start on the next frame.
             * @param tween The Tween to be reset.
             */
            reset(tween: Phaser.Tweens.Tween): this;

            /**
             * Internal method that advances to the next state of the TweenChain playback.
             */
            nextState(): boolean;

            /**
             * Starts this TweenChain playing.
             * 
             * You only need to call this method if you have configured this TweenChain to be paused on creation.
             * 
             * If the TweenChain is already playing, calling this method again will have no effect. If you wish to
             * restart the chain, use `TweenChain.restart` instead.
             * 
             * Calling this method after the TweenChain has completed will start the chain playing again from the beginning.
             */
            play(): this;

            /**
             * Internal method that resets all of the Tweens and the current index pointer.
             */
            resetTweens(): void;

            /**
             * Internal method that advances the TweenChain based on the time values.
             * @param delta The delta time in ms since the last frame. This is a smoothed and capped value based on the FPS rate.
             */
            update(delta: number): boolean;

            /**
             * Immediately advances to the next Tween in the chain.
             * 
             * This is typically called internally, but can be used if you need to
             * advance playback for some reason.
             */
            nextTween(): boolean;

            /**
             * Sets the current active Tween to the given index, based on its
             * entry in the TweenChain data array.
             * @param index The index of the Tween to be made current.
             */
            setCurrentTween(index: number): void;

            /**
             * Internal method that will emit a TweenChain based Event and invoke the given callback.
             * @param event The Event to be dispatched.
             * @param callback The name of the callback to be invoked. Can be `null` or `undefined` to skip invocation.
             */
            dispatchEvent(event: Phaser.Types.Tweens.Event, callback?: Phaser.Types.Tweens.TweenCallbackTypes): void;

            /**
             * Immediately destroys this TweenChain, nulling of all its references.
             */
            destroy(): void;

        }

        /**
         * The TweenData is a class that contains a single target and property that is being tweened.
         * 
         * Tweens create TweenData instances when they are created, with one TweenData instance per
         * target, per property. A Tween can own multiple TweenData instances, but a TweenData only
         * ever belongs to a single Tween.
         * 
         * You should not typically create these yourself, but rather use the TweenBuilder,
         * or the `Tween.add` method.
         * 
         * Prior to Phaser 3.60 the TweenData was just an object, but was refactored to a class,
         * to make it responsible for its own state and updating.
         */
        class TweenData extends Phaser.Tweens.BaseTweenData {
            /**
             * 
             * @param tween The tween this TweenData instance belongs to.
             * @param targetIndex The target index within the Tween targets array.
             * @param key The property of the target to tween.
             * @param getEnd What the property will be at the END of the Tween.
             * @param getStart What the property will be at the START of the Tween.
             * @param getActive If not null, is invoked _immediately_ as soon as the TweenData is running, and is set on the target property.
             * @param ease The ease function this tween uses.
             * @param delay Function that returns the time in milliseconds before tween will start.
             * @param duration The duration of the tween in milliseconds.
             * @param yoyo Determines whether the tween should return back to its start value after hold has expired.
             * @param hold Function that returns the time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
             * @param repeat Function that returns the number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
             * @param repeatDelay Function that returns the time in milliseconds before the repeat will start.
             * @param flipX Should toggleFlipX be called when yoyo or repeat happens?
             * @param flipY Should toggleFlipY be called when yoyo or repeat happens?
             * @param interpolation The interpolation function to be used for arrays of data. Defaults to 'null'.
             * @param interpolationData The array of interpolation data to be set. Defaults to 'null'.
             */
            constructor(tween: Phaser.Tweens.Tween, targetIndex: number, key: string, getEnd: Phaser.Types.Tweens.GetEndCallback, getStart: Phaser.Types.Tweens.GetStartCallback, getActive: Phaser.Types.Tweens.GetActiveCallback | undefined, ease: Function, delay: Function, duration: number, yoyo: boolean, hold: number, repeat: number, repeatDelay: number, flipX: boolean, flipY: boolean, interpolation: Function | undefined, interpolationData: number[] | undefined);

            /**
             * The property of the target to be tweened.
             */
            readonly key: string;

            /**
             * A function that returns what to set the target property to,
             * the moment the TweenData is invoked.
             * 
             * This is called when this TweenData is inititalised or reset.
             */
            getActiveValue: Phaser.Types.Tweens.GetActiveCallback | null;

            /**
             * A function that returns what to set the target property to
             * at the end of the tween.
             * 
             * This is called when the tween starts playing, after any initial
             * start delay, or if the tween is reset, or is set to repeat.
             */
            getEndValue: Phaser.Types.Tweens.GetEndCallback;

            /**
             * A function that returns what to set the target property to
             * at the start of the tween.
             * 
             * This is called when the tween starts playing, after any initial
             * start delay, or if the tween is reset, or is set to repeat.
             */
            getStartValue: Phaser.Types.Tweens.GetStartCallback;

            /**
             * The ease function this Tween uses to calculate the target value.
             */
            ease: Function;

            /**
             * The targets starting value, as returned by `getStartValue`.
             */
            start: number;

            /**
             * The target value from the previous step.
             */
            previous: number;

            /**
             * The targets current value, as recorded in the most recent step.
             */
            current: number;

            /**
             * The targets ending value, as returned by `getEndValue`.
             */
            end: number;

            /**
             * The interpolation function to be used for arrays of data.
             */
            interpolation: Function | null;

            /**
             * The array of data to interpolate, if interpolation is being used.
             */
            interpolationData: number[] | null;

            /**
             * Internal method that resets this Tween Data entirely, including the progress and elapsed values.
             * 
             * Called automatically by the parent Tween. Should not be called directly.
             * @param isSeeking Is the Tween Data being reset as part of a Tween seek? Default false.
             */
            reset(isSeeking?: boolean): void;

            /**
             * Internal method that advances this TweenData based on the delta value given.
             * @param delta The elapsed delta time in ms.
             */
            update(delta: number): boolean;

            /**
             * Internal method that will emit a TweenData based Event on the
             * parent Tween and also invoke the given callback, if provided.
             * @param event The Event to be dispatched.
             * @param callback The name of the callback to be invoked. Can be `null` or `undefined` to skip invocation.
             */
            dispatchEvent(event: Phaser.Types.Tweens.Event, callback?: Phaser.Types.Tweens.TweenCallbackTypes): void;

            /**
             * Immediately destroys this TweenData, nulling of all its references.
             */
            destroy(): void;

        }

        /**
         * The TweenFrameData is a class that contains a single target that will change the texture frame
         * at the conclusion of the Tween.
         * 
         * TweenFrameData instances are typically created by the TweenBuilder automatically, when it
         * detects the prescence of a 'texture' property as the key being tweened.
         * 
         * A Tween can own multiple TweenFrameData instances, but a TweenFrameData only
         * ever belongs to a single Tween.
         * 
         * You should not typically create these yourself, but rather use the TweenBuilder,
         * or the `Tween.addFrame` method.
         */
        class TweenFrameData extends Phaser.Tweens.BaseTweenData {
            /**
             * 
             * @param tween The tween this TweenData instance belongs to.
             * @param targetIndex The target index within the Tween targets array.
             * @param texture The texture key to set at the end of this tween.
             * @param frame The texture frame to set at the end of this tween.
             * @param delay Function that returns the time in milliseconds before tween will start.
             * @param duration The duration of the tween in milliseconds.
             * @param hold Function that returns the time in milliseconds the tween will pause before repeating or returning to its starting value if yoyo is set to true.
             * @param repeat Function that returns the number of times to repeat the tween. The tween will always run once regardless, so a repeat value of '1' will play the tween twice.
             * @param repeatDelay Function that returns the time in milliseconds before the repeat will start.
             * @param flipX Should toggleFlipX be called when yoyo or repeat happens?
             * @param flipY Should toggleFlipY be called when yoyo or repeat happens?
             */
            constructor(tween: Phaser.Tweens.Tween, targetIndex: number, texture: string, frame: string | number, delay: Function, duration: number, hold: number, repeat: number, repeatDelay: number, flipX: boolean, flipY: boolean);

            /**
             * The property of the target to be tweened.
             * 
             * Always 'texture' for a TweenFrameData object.
             */
            readonly key: string;

            /**
             * The texture to be set at the start of the tween.
             */
            startTexture: string;

            /**
             * The texture to be set at the end of the tween.
             */
            endTexture: string;

            /**
             * The frame to be set at the start of the tween.
             */
            startFrame: string | number;

            /**
             * The frame to be set at the end of the tween.
             */
            endFrame: string | number;

            /**
             * Will the Tween ease back to its starting values, after reaching the end
             * and any `hold` value that may be set?
             */
            yoyo: boolean;

            /**
             * Internal method that resets this Tween Data entirely, including the progress and elapsed values.
             * 
             * Called automatically by the parent Tween. Should not be called directly.
             * @param isSeeking Is the Tween Data being reset as part of a Tween seek? Default false.
             */
            reset(isSeeking?: boolean): void;

            /**
             * Internal method that advances this TweenData based on the delta value given.
             * @param delta The elapsed delta time in ms.
             */
            update(delta: number): boolean;

            /**
             * Internal method that will emit a TweenData based Event on the
             * parent Tween and also invoke the given callback, if provided.
             * @param event The Event to be dispatched.
             * @param callback The name of the callback to be invoked. Can be `null` or `undefined` to skip invocation.
             */
            dispatchEvent(event: Phaser.Types.Tweens.Event, callback?: Phaser.Types.Tweens.TweenCallbackTypes): void;

            /**
             * Immediately destroys this TweenData, nulling of all its references.
             */
            destroy(): void;

        }

        /**
         * The Tween Manager is a default Scene Plugin which controls and updates Tweens.
         * 
         * A tween is a way to alter one or more properties of a target object over a defined period of time.
         * 
         * Tweens are created by calling the `add` method and passing in the configuration object.
         * 
         * ```js
         * const logo = this.add.image(100, 100, 'logo');
         * 
         * this.tweens.add({
         *   targets: logo,
         *   x: 600,
         *   ease: 'Power1',
         *   duration: 2000
         * });
         * ```
         * 
         * See the `TweenBuilderConfig` for all of the options you have available.
         * 
         * Playback will start immediately unless the tween has been configured to be paused.
         * 
         * Please note that a Tween will not manipulate any target property that begins with an underscore.
         * 
         * Tweens are designed to be 'fire-and-forget'. They automatically destroy themselves once playback
         * is complete, to free-up memory and resources. If you wish to keep a tween after playback, i.e. to
         * play it again at a later time, then you should set the `persist` property to `true` in the config.
         * However, doing so means it's entirely up to _you_ to destroy the tween when you're finished with it,
         * otherwise it will linger in memory forever.
         * 
         * If you wish to chain Tweens together for sequential playback, see the `TweenManager.chain` method.
         */
        class TweenManager {
            /**
             * 
             * @param scene The Scene which owns this Tween Manager.
             */
            constructor(scene: Phaser.Scene);

            /**
             * The Scene which owns this Tween Manager.
             */
            scene: Phaser.Scene;

            /**
             * The Scene Systems Event Emitter.
             */
            events: Phaser.Events.EventEmitter;

            /**
             * The time scale of the Tween Manager.
             * 
             * This value scales the time delta between two frames, thus influencing the speed of time for all Tweens owned by this Tween Manager.
             */
            timeScale: number;

            /**
             * This toggles the updating state of this Tween Manager.
             * 
             * Setting `paused` to `true` (or calling the `pauseAll` method) will
             * stop this Tween Manager from updating any of its tweens, including
             * newly created ones. Set back to `false` to resume playback.
             */
            paused: boolean;

            /**
             * Is this Tween Manager currently processing the tweens as part of
             * its 'update' loop? This is set to 'true' at the start of 'update'
             * and reset to 'false' at the end of the function. Allows you to trap
             * Tween Manager status during tween callbacks.
             */
            processing: boolean;

            /**
             * An array of Tweens which are actively being processed by the Tween Manager.
             */
            tweens: Phaser.Tweens.Tween[];

            /**
             * The time the Tween Manager was updated.
             */
            time: number;

            /**
             * The time the Tween Manager was started.
             */
            startTime: number;

            /**
             * The time the Tween Manager should next update.
             */
            nextTime: number;

            /**
             * The time the Tween Manager previously updated.
             */
            prevTime: number;

            /**
             * The maximum amount of time, in milliseconds, the browser can
             * lag for, before lag smoothing is applied.
             * 
             * See the `TweenManager.setLagSmooth` method for further details.
             */
            maxLag: number;

            /**
             * The amount of time, in milliseconds, that is used to set the
             * delta when lag smoothing is applied.
             * 
             * See the `TweenManager.setLagSmooth` method for further details.
             */
            lagSkip: number;

            /**
             * An internal value that holds the fps rate.
             */
            gap: number;

            /**
             * Create a Tween and return it, but does not add it to this Tween Manager.
             * 
             * Please note that a Tween will not manipulate any target property that begins with an underscore.
             * 
             * In order to play this tween, you'll need to add it to a Tween Manager via
             * the `TweenManager.existing` method.
             * 
             * You can optionally pass an **array** of Tween Configuration objects to this method and it will create
             * one Tween per entry in the array. If an array is given, an array of tweens is returned.
             * @param config A Tween Configuration object. Or an array of Tween Configuration objects.
             */
            create(config: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenBuilderConfig[] | object | object[]): Phaser.Tweens.Tween | Phaser.Tweens.Tween[];

            /**
             * Create a Tween and add it to this Tween Manager by passing a Tween Configuration object.
             * 
             * Example, run from within a Scene:
             * 
             * ```js
             * const logo = this.add.image(100, 100, 'logo');
             * 
             * this.tweens.add({
             *   targets: logo,
             *   x: 600,
             *   ease: 'Power1',
             *   duration: 2000
             * });
             * ```
             * 
             * See the `TweenBuilderConfig` for all of the options you have available.
             * 
             * Playback will start immediately unless the tween has been configured to be paused.
             * 
             * Please note that a Tween will not manipulate any target property that begins with an underscore.
             * 
             * Tweens are designed to be 'fire-and-forget'. They automatically destroy themselves once playback
             * is complete, to free-up memory and resources. If you wish to keep a tween after playback, i.e. to
             * play it again at a later time, then you should set the `persist` property to `true` in the config.
             * However, doing so means it's entirely up to _you_ to destroy the tween when you're finished with it,
             * otherwise it will linger in memory forever.
             * 
             * If you wish to chain Tweens together for sequential playback, see the `TweenManager.chain` method.
             * @param config A Tween Configuration object, or a Tween or TweenChain instance.
             */
            add(config: Phaser.Types.Tweens.TweenBuilderConfig | Phaser.Types.Tweens.TweenChainBuilderConfig | Phaser.Tweens.Tween | Phaser.Tweens.TweenChain): Phaser.Tweens.Tween;

            /**
             * Create multiple Tweens and add them all to this Tween Manager, by passing an array of Tween Configuration objects.
             * 
             * See the `TweenBuilderConfig` for all of the options you have available.
             * 
             * Playback will start immediately unless the tweens have been configured to be paused.
             * 
             * Please note that a Tween will not manipulate any target property that begins with an underscore.
             * 
             * Tweens are designed to be 'fire-and-forget'. They automatically destroy themselves once playback
             * is complete, to free-up memory and resources. If you wish to keep a tween after playback, i.e. to
             * play it again at a later time, then you should set the `persist` property to `true` in the config.
             * However, doing so means it's entirely up to _you_ to destroy the tween when you're finished with it,
             * otherwise it will linger in memory forever.
             * 
             * If you wish to chain Tweens together for sequential playback, see the `TweenManager.chain` method.
             * @param configs An array of Tween Configuration objects.
             */
            addMultiple(configs: Phaser.Types.Tweens.TweenBuilderConfig[] | object[]): Phaser.Tweens.Tween[];

            /**
             * Create a sequence of Tweens, chained to one-another, and add them to this Tween Manager.
             * 
             * The tweens are played in order, from start to finish. You can optionally set the chain
             * to repeat as many times as you like. Once the chain has finished playing, or repeating if set,
             * all tweens in the chain will be destroyed automatically. To override this, set the `persist`
             * argument to 'true'.
             * 
             * Playback will start immediately unless the _first_ Tween has been configured to be paused.
             * 
             * Please note that Tweens will not manipulate any target property that begins with an underscore.
             * @param tweens A Tween Chain configuration object.
             */
            chain(tweens: Phaser.Types.Tweens.TweenChainBuilderConfig | object): Phaser.Tweens.TweenChain;

            /**
             * Returns an array containing this Tween and all Tweens chained to it,
             * in the order in which they will be played.
             * 
             * If there are no chained Tweens an empty array is returned.
             * @param tween The Tween to return the chain from.
             */
            getChainedTweens(tween: Phaser.Tweens.Tween): Phaser.Tweens.Tween[];

            /**
             * Check to see if the given Tween instance exists within this Tween Manager.
             * 
             * Will return `true` as long as the Tween is being processed by this Tween Manager.
             * 
             * Will return `false` if not present, or has a state of `REMOVED` or `DESTROYED`.
             * @param tween The Tween instance to check.
             */
            has(tween: Phaser.Tweens.Tween): boolean;

            /**
             * Add an existing Tween to this Tween Manager.
             * 
             * Playback will start immediately unless the tween has been configured to be paused.
             * @param tween The Tween to add.
             */
            existing(tween: Phaser.Tweens.Tween): this;

            /**
             * Create a Number Tween and add it to the active Tween list.
             * 
             * A Number Tween is a special kind of tween that doesn't have a target. Instead,
             * it allows you to tween between 2 numeric values. The default values are
             * `0` and `1`, but you can change them via the `from` and `to` properties.
             * 
             * You can get the current tweened value via the `Tween.getValue()` method.
             * 
             * Playback will start immediately unless the tween has been configured to be paused.
             * 
             * Please note that a Tween will not manipulate any target property that begins with an underscore.
             * @param config The configuration object for the Number Tween.
             */
            addCounter(config: Phaser.Types.Tweens.NumberTweenBuilderConfig): Phaser.Tweens.Tween;

            /**
             * Creates a Stagger function to be used by a Tween property.
             * 
             * The stagger function will allow you to stagger changes to the value of the property across all targets of the tween.
             * 
             * This is only worth using if the tween has multiple targets.
             * 
             * The following will stagger the delay by 100ms across all targets of the tween, causing them to scale down to 0.2
             * over the duration specified:
             * 
             * ```javascript
             * this.tweens.add({
             *     targets: [ ... ],
             *     scale: 0.2,
             *     ease: 'linear',
             *     duration: 1000,
             *     delay: this.tweens.stagger(100)
             * });
             * ```
             * 
             * The following will stagger the delay by 500ms across all targets of the tween using a 10 x 6 grid, staggering
             * from the center out, using a cubic ease.
             * 
             * ```javascript
             * this.tweens.add({
             *     targets: [ ... ],
             *     scale: 0.2,
             *     ease: 'linear',
             *     duration: 1000,
             *     delay: this.tweens.stagger(500, { grid: [ 10, 6 ], from: 'center', ease: 'cubic.out' })
             * });
             * ```
             * @param value The amount to stagger by, or an array containing two elements representing the min and max values to stagger between.
             * @param config The configuration object for the Stagger function.
             */
            stagger(value: number | number[], config: Phaser.Types.Tweens.StaggerConfig): Function;

            /**
             * Set the limits that are used when a browser encounters lag, or delays that cause the elapsed
             * time between two frames to exceed the expected amount. If this occurs, the Tween Manager will
             * act as if the 'skip' amount of times has passed, in order to maintain strict tween sequencing.
             * 
             * This is enabled by default with the values 500ms for the lag limit and 33ms for the skip.
             * 
             * You should not set these to low values, as it won't give time for the browser to ever
             * catch-up with itself and reclaim sync.
             * 
             * Call this method with no arguments to disable smoothing.
             * 
             * Call it with the arguments `500` and `33` to reset to the defaults.
             * @param limit If the browser exceeds this amount, in milliseconds, it will act as if the 'skip' amount has elapsed instead. Default 0.
             * @param skip The amount, in milliseconds, to use as the step delta should the browser lag beyond the 'limit'. Default 0.
             */
            setLagSmooth(limit?: number, skip?: number): this;

            /**
             * Limits the Tween system to run at a particular frame rate.
             * 
             * You should not set this _above_ the frequency of the browser,
             * but instead can use it to throttle the frame rate lower, should
             * you need to in certain situations.
             * @param fps The frame rate to tick at. Default 240.
             */
            setFps(fps?: number): this;

            /**
             * Internal method that calculates the delta value, along with the other timing values,
             * and returns the new delta.
             * 
             * You should not typically call this method directly.
             * @param tick Is this a manual tick, or an automated tick? Default false.
             */
            getDelta(tick?: boolean): number;

            /**
             * Manually advance the Tween system by one step.
             * 
             * This will update all Tweens even if the Tween Manager is currently
             * paused.
             */
            tick(): this;

            /**
             * Internal update handler.
             * 
             * Calls `TweenManager.step` as long as the Tween Manager has not
             * been paused.
             */
            update(): void;

            /**
             * Updates all Tweens belonging to this Tween Manager.
             * 
             * Called automatically by `update` and `tick`.
             * @param tick Is this a manual tick, or an automated tick? Default false.
             */
            step(tick?: boolean): void;

            /**
             * Removes the given Tween from this Tween Manager, even if it hasn't started
             * playback yet. If this method is called while the Tween Manager is processing
             * an update loop, then the tween will be flagged for removal at the start of
             * the next frame. Otherwise, it is removed immediately.
             * 
             * The removed tween is _not_ destroyed. It is just removed from this Tween Manager.
             * @param tween The Tween to be removed.
             */
            remove(tween: Phaser.Tweens.Tween): this;

            /**
             * Resets the given Tween.
             * 
             * If the Tween does not belong to this Tween Manager, it will first be added.
             * 
             * Then it will seek to position 0 and playback will start on the next frame.
             * @param tween The Tween to be reset.
             */
            reset(tween: Phaser.Tweens.Tween): this;

            /**
             * Checks if a Tween is active and adds it to the Tween Manager at the start of the frame if it isn't.
             * @param tween The Tween to check.
             */
            makeActive(tween: Phaser.Tweens.Tween): this;

            /**
             * Passes all Tweens to the given callback.
             * @param callback The function to call.
             * @param scope The scope (`this` object) to call the function with.
             * @param args The arguments to pass into the function. Its first argument will always be the Tween currently being iterated.
             */
            each(callback: Function, scope?: object, ...args: any[]): this;

            /**
             * Returns an array containing references to all Tweens in this Tween Manager.
             * 
             * It is safe to mutate the returned array. However, acting upon any of the Tweens
             * within it, will adjust those stored in this Tween Manager, as they are passed
             * by reference and not cloned.
             * 
             * If you wish to get tweens for a specific target, see `getTweensOf`.
             */
            getTweens(): Phaser.Tweens.Tween[];

            /**
             * Returns an array of all Tweens in the Tween Manager which affect the given target, or array of targets.
             * 
             * It's possible for this method to return tweens that are about to be removed from
             * the Tween Manager. You should check the state of the returned tween before acting
             * upon it.
             * @param target The target to look for. Provide an array to look for multiple targets.
             */
            getTweensOf(target: object | object[]): Phaser.Tweens.Tween[];

            /**
             * Returns the scale of the time delta for all Tweens owned by this Tween Manager.
             */
            getGlobalTimeScale(): number;

            /**
             * Sets a new scale of the time delta for this Tween Manager.
             * 
             * The time delta is the time elapsed between two consecutive frames and influences the speed of time for this Tween Manager and all Tweens it owns. Values higher than 1 increase the speed of time, while values smaller than 1 decrease it. A value of 0 freezes time and is effectively equivalent to pausing all Tweens.
             * @param value The new scale of the time delta, where 1 is the normal speed.
             */
            setGlobalTimeScale(value: number): this;

            /**
             * Checks if the given object is being affected by a _playing_ Tween.
             * 
             * If the Tween is paused, this method will return false.
             * @param target The object to check if a tween is active for it, or not.
             */
            isTweening(target: object): boolean;

            /**
             * Destroys all Tweens in this Tween Manager.
             * 
             * The tweens will erase all references to any targets they hold
             * and be stopped immediately.
             * 
             * If this method is called while the Tween Manager is running its
             * update process, then the tweens will be removed at the start of
             * the next frame. Outside of this, they are removed immediately.
             */
            killAll(): this;

            /**
             * Stops all Tweens which affect the given target or array of targets.
             * 
             * The tweens will erase all references to any targets they hold
             * and be stopped immediately.
             * 
             * If this method is called while the Tween Manager is running its
             * update process, then the tweens will be removed at the start of
             * the next frame. Outside of this, they are removed immediately.
             * @param target The target to kill the tweens of. Provide an array to use multiple targets.
             */
            killTweensOf(target: object | any[]): this;

            /**
             * Pauses this Tween Manager. No Tweens will update while paused.
             * 
             * This includes tweens created after this method was called.
             * 
             * See `TweenManager#resumeAll` to resume the playback.
             * 
             * As of Phaser 3.60 you can also toggle the boolean property `TweenManager.paused`.
             */
            pauseAll(): this;

            /**
             * Resumes playback of this Tween Manager.
             * 
             * All active Tweens will continue updating.
             * 
             * See `TweenManager#pauseAll` to pause the playback.
             * 
             * As of Phaser 3.60 you can also toggle the boolean property `TweenManager.paused`.
             */
            resumeAll(): this;

            /**
             * The Scene that owns this plugin is shutting down.
             * 
             * We need to kill and reset all internal properties as well as stop listening to Scene events.
             */
            shutdown(): void;

            /**
             * The Scene that owns this plugin is being destroyed.
             * We need to shutdown and then kill off all external references.
             */
            destroy(): void;

        }

    }

    namespace Utils {
        namespace Array {
            /**
             * Adds the given item, or array of items, to the array.
             * 
             * Each item must be unique within the array.
             * 
             * The array is modified in-place and returned.
             * 
             * You can optionally specify a limit to the maximum size of the array. If the quantity of items being
             * added will take the array length over this limit, it will stop adding once the limit is reached.
             * 
             * You can optionally specify a callback to be invoked for each item successfully added to the array.
             * @param array The array to be added to.
             * @param item The item, or array of items, to add to the array. Each item must be unique within the array.
             * @param limit Optional limit which caps the size of the array.
             * @param callback A callback to be invoked for each item successfully added to the array.
             * @param context The context in which the callback is invoked.
             */
            function Add(array: any[], item: any | any[], limit?: number, callback?: Function, context?: object): any[];

            /**
             * Adds the given item, or array of items, to the array starting at the index specified.
             * 
             * Each item must be unique within the array.
             * 
             * Existing elements in the array are shifted up.
             * 
             * The array is modified in-place and returned.
             * 
             * You can optionally specify a limit to the maximum size of the array. If the quantity of items being
             * added will take the array length over this limit, it will stop adding once the limit is reached.
             * 
             * You can optionally specify a callback to be invoked for each item successfully added to the array.
             * @param array The array to be added to.
             * @param item The item, or array of items, to add to the array.
             * @param index The index in the array where the item will be inserted. Default 0.
             * @param limit Optional limit which caps the size of the array.
             * @param callback A callback to be invoked for each item successfully added to the array.
             * @param context The context in which the callback is invoked.
             */
            function AddAt(array: any[], item: any | any[], index?: number, limit?: number, callback?: Function, context?: object): any[];

            /**
             * Moves the given element to the top of the array.
             * The array is modified in-place.
             * @param array The array.
             * @param item The element to move.
             */
            function BringToTop(array: any[], item: any): any;

            /**
             * Returns the total number of elements in the array which have a property matching the given value.
             * @param array The array to search.
             * @param property The property to test on each array element.
             * @param value The value to test the property against. Must pass a strict (`===`) comparison check.
             * @param startIndex An optional start index to search from.
             * @param endIndex An optional end index to search to.
             */
            function CountAllMatching(array: any[], property: string, value: any, startIndex?: number, endIndex?: number): number;

            /**
             * Passes each element in the array to the given callback.
             * @param array The array to search.
             * @param callback A callback to be invoked for each item in the array.
             * @param context The context in which the callback is invoked.
             * @param args Additional arguments that will be passed to the callback, after the current array item.
             */
            function Each(array: any[], callback: Function, context: object, ...args: any[]): any[];

            /**
             * Passes each element in the array, between the start and end indexes, to the given callback.
             * @param array The array to search.
             * @param callback A callback to be invoked for each item in the array.
             * @param context The context in which the callback is invoked.
             * @param startIndex The start index to search from.
             * @param endIndex The end index to search to.
             * @param args Additional arguments that will be passed to the callback, after the child.
             */
            function EachInRange(array: any[], callback: Function, context: object, startIndex: number, endIndex: number, ...args: any[]): any[];

            /**
             * Searches a pre-sorted array for the closet value to the given number.
             * 
             * If the `key` argument is given it will assume the array contains objects that all have the required `key` property name,
             * and will check for the closest value of those to the given number.
             * @param value The value to search for in the array.
             * @param array The array to search, which must be sorted.
             * @param key An optional property key. If specified the array elements property will be checked against value.
             */
            function FindClosestInSorted(value: number, array: any[], key?: string): number | any;

            /**
             * Takes an array and flattens it, returning a shallow-copy flattened array.
             * @param array The array to flatten.
             * @param output An array to hold the results in.
             */
            function Flatten(array: any[], output?: any[]): any[];

            /**
             * Returns all elements in the array.
             * 
             * You can optionally specify a matching criteria using the `property` and `value` arguments.
             * 
             * For example: `getAll('visible', true)` would return only elements that have their visible property set.
             * 
             * Optionally you can specify a start and end index. For example if the array had 100 elements,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would return matches from only
             * the first 50 elements.
             * @param array The array to search.
             * @param property The property to test on each array element.
             * @param value The value to test the property against. Must pass a strict (`===`) comparison check.
             * @param startIndex An optional start index to search from.
             * @param endIndex An optional end index to search to.
             */
            function GetAll(array: any[], property?: string, value?: any, startIndex?: number, endIndex?: number): any[];

            /**
             * Returns the first element in the array.
             * 
             * You can optionally specify a matching criteria using the `property` and `value` arguments.
             * 
             * For example: `getAll('visible', true)` would return the first element that had its `visible` property set.
             * 
             * Optionally you can specify a start and end index. For example if the array had 100 elements,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would search only the first 50 elements.
             * @param array The array to search.
             * @param property The property to test on each array element.
             * @param value The value to test the property against. Must pass a strict (`===`) comparison check.
             * @param startIndex An optional start index to search from. Default 0.
             * @param endIndex An optional end index to search up to (but not included) Default array.length.
             */
            function GetFirst(array: any[], property?: string, value?: any, startIndex?: number, endIndex?: number): object;

            /**
             * Returns a Random element from the array.
             * @param array The array to select the random entry from.
             * @param startIndex An optional start index. Default 0.
             * @param length An optional length, the total number of elements (from the startIndex) to choose from. Default array.length.
             */
            function GetRandom<T>(array: T[], startIndex?: number, length?: number): T;

            namespace Matrix {
                /**
                 * Checks if an array can be used as a matrix.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array to check.
                 */
                function CheckMatrix<T>(matrix?: T[][]): boolean;

                /**
                 * Generates a string (which you can pass to console.log) from the given Array Matrix.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix A 2-dimensional array.
                 */
                function MatrixToString<T>(matrix?: T[][]): string;

                /**
                 * Reverses the columns in the given Array Matrix.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array matrix to reverse the columns for.
                 */
                function ReverseColumns<T>(matrix?: T[][]): T[][];

                /**
                 * Reverses the rows in the given Array Matrix.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array matrix to reverse the rows for.
                 */
                function ReverseRows<T>(matrix?: T[][]): T[][];

                /**
                 * Rotates the array matrix 180 degrees.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array to rotate.
                 */
                function Rotate180<T>(matrix?: T[][]): T[][];

                /**
                 * Rotates the array matrix to the left (or 90 degrees)
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array to rotate.
                 * @param amount The number of times to rotate the matrix. Default 1.
                 */
                function RotateLeft<T>(matrix?: T[][], amount?: number): T[][];

                /**
                 * Rotates the array matrix based on the given rotation value.
                 * 
                 * The value can be given in degrees: 90, -90, 270, -270 or 180,
                 * or a string command: `rotateLeft`, `rotateRight` or `rotate180`.
                 * 
                 * Based on the routine from {@link http://jsfiddle.net/MrPolywhirl/NH42z/}.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array to rotate.
                 * @param direction The amount to rotate the matrix by. Default 90.
                 */
                function RotateMatrix<T>(matrix?: T[][], direction?: number | string): T[][];

                /**
                 * Rotates the array matrix to the left (or -90 degrees)
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array to rotate.
                 * @param amount The number of times to rotate the matrix. Default 1.
                 */
                function RotateRight<T>(matrix?: T[][], amount?: number): T[][];

                /**
                 * Translates the given Array Matrix by shifting each column and row the
                 * amount specified.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param matrix The array matrix to translate.
                 * @param x The amount to horizontally translate the matrix by. Default 0.
                 * @param y The amount to vertically translate the matrix by. Default 0.
                 */
                function Translate<T>(matrix?: T[][], x?: number, y?: number): T[][];

                /**
                 * Transposes the elements of the given matrix (array of arrays).
                 * 
                 * The transpose of a matrix is a new matrix whose rows are the columns of the original.
                 * 
                 * A matrix is a two-dimensional array (array of arrays), where all sub-arrays (rows)
                 * have the same length. There must be at least two rows. This is an example matrix:
                 * 
                 * ```
                 * [
                 *    [ 1, 1, 1, 1, 1, 1 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 2, 0, 1, 2, 0, 4 ],
                 *    [ 2, 0, 3, 4, 0, 4 ],
                 *    [ 2, 0, 0, 0, 0, 4 ],
                 *    [ 3, 3, 3, 3, 3, 3 ]
                 * ]
                 * ```
                 * @param array The array matrix to transpose.
                 */
                function TransposeMatrix<T>(array?: T[][]): T[][];

            }

            /**
             * Moves the given array element above another one in the array.
             * The array is modified in-place.
             * @param array The input array.
             * @param item1 The element to move above base element.
             * @param item2 The base element.
             */
            function MoveAbove(array: any[], item1: any, item2: any): any[];

            /**
             * Moves the given array element below another one in the array.
             * The array is modified in-place.
             * @param array The input array.
             * @param item1 The element to move below base element.
             * @param item2 The base element.
             */
            function MoveBelow(array: any[], item1: any, item2: any): any[];

            /**
             * Moves the given array element down one place in the array.
             * The array is modified in-place.
             * @param array The input array.
             * @param item The element to move down the array.
             */
            function MoveDown(array: any[], item: any): any[];

            /**
             * Moves an element in an array to a new position within the same array.
             * The array is modified in-place.
             * @param array The array.
             * @param item The element to move.
             * @param index The new index that the element will be moved to.
             */
            function MoveTo(array: any[], item: any, index: number): any;

            /**
             * Moves the given array element up one place in the array.
             * The array is modified in-place.
             * @param array The input array.
             * @param item The element to move up the array.
             */
            function MoveUp(array: any[], item: any): any[];

            /**
             * Create an array representing the range of numbers (usually integers), between, and inclusive of,
             * the given `start` and `end` arguments. For example:
             * 
             * `var array = Phaser.Utils.Array.NumberArray(2, 4); // array = [2, 3, 4]`
             * `var array = Phaser.Utils.Array.NumberArray(0, 9); // array = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]`
             * `var array = Phaser.Utils.Array.NumberArray(8, 2); // array = [8, 7, 6, 5, 4, 3, 2]`
             * 
             * This is equivalent to `Phaser.Utils.Array.NumberArrayStep(start, end, 1)`.
             * 
             * You can optionally provide a prefix and / or suffix string. If given the array will contain
             * strings, not integers. For example:
             * 
             * `var array = Phaser.Utils.Array.NumberArray(1, 4, 'Level '); // array = ["Level 1", "Level 2", "Level 3", "Level 4"]`
             * `var array = Phaser.Utils.Array.NumberArray(5, 7, 'HD-', '.png'); // array = ["HD-5.png", "HD-6.png", "HD-7.png"]`
             * @param start The minimum value the array starts with.
             * @param end The maximum value the array contains.
             * @param prefix Optional prefix to place before the number. If provided the array will contain strings, not integers.
             * @param suffix Optional suffix to place after the number. If provided the array will contain strings, not integers.
             */
            function NumberArray(start: number, end: number, prefix?: string, suffix?: string): number[] | string[];

            /**
             * Create an array of numbers (positive and/or negative) progressing from `start`
             * up to but not including `end` by advancing by `step`.
             * 
             * If `start` is less than `end` a zero-length range is created unless a negative `step` is specified.
             * 
             * Certain values for `start` and `end` (eg. NaN/undefined/null) are currently coerced to 0;
             * for forward compatibility make sure to pass in actual numbers.
             * @param start The start of the range. Default 0.
             * @param end The end of the range. Default null.
             * @param step The value to increment or decrement by. Default 1.
             */
            function NumberArrayStep(start?: number, end?: number, step?: number): number[];

            /**
             * A [Floyd-Rivest](https://en.wikipedia.org/wiki/Floyd%E2%80%93Rivest_algorithm) quick selection algorithm.
             * 
             * Rearranges the array items so that all items in the [left, k] range are smaller than all items in [k, right];
             * The k-th element will have the (k - left + 1)th smallest value in [left, right].
             * 
             * The array is modified in-place.
             * 
             * Based on code by [Vladimir Agafonkin](https://www.npmjs.com/~mourner)
             * @param arr The array to sort.
             * @param k The k-th element index.
             * @param left The index of the left part of the range. Default 0.
             * @param right The index of the right part of the range.
             * @param compare An optional comparison function. Is passed two elements and should return 0, 1 or -1.
             */
            function QuickSelect(arr: any[], k: number, left?: number, right?: number, compare?: Function): void;

            /**
             * Creates an array populated with a range of values, based on the given arguments and configuration object.
             * 
             * Range ([a,b,c], [1,2,3]) =
             * a1, a2, a3, b1, b2, b3, c1, c2, c3
             * 
             * Range ([a,b], [1,2,3], qty = 3) =
             * a1, a1, a1, a2, a2, a2, a3, a3, a3, b1, b1, b1, b2, b2, b2, b3, b3, b3
             * 
             * Range ([a,b,c], [1,2,3], repeat x1) =
             * a1, a2, a3, b1, b2, b3, c1, c2, c3, a1, a2, a3, b1, b2, b3, c1, c2, c3
             * 
             * Range ([a,b], [1,2], repeat -1 = endless, max = 14) =
             * Maybe if max is set then repeat goes to -1 automatically?
             * a1, a2, b1, b2, a1, a2, b1, b2, a1, a2, b1, b2, a1, a2 (capped at 14 elements)
             * 
             * Range ([a], [1,2,3,4,5], random = true) =
             * a4, a1, a5, a2, a3
             * 
             * Range ([a, b], [1,2,3], random = true) =
             * b3, a2, a1, b1, a3, b2
             * 
             * Range ([a, b, c], [1,2,3], randomB = true) =
             * a3, a1, a2, b2, b3, b1, c1, c3, c2
             * 
             * Range ([a], [1,2,3,4,5], yoyo = true) =
             * a1, a2, a3, a4, a5, a5, a4, a3, a2, a1
             * 
             * Range ([a, b], [1,2,3], yoyo = true) =
             * a1, a2, a3, b1, b2, b3, b3, b2, b1, a3, a2, a1
             * @param a The first array of range elements.
             * @param b The second array of range elements.
             * @param options A range configuration object. Can contain: repeat, random, randomB, yoyo, max, qty.
             */
            function Range(a: any[], b: any[], options?: object): any[];

            /**
             * Removes the given item, or array of items, from the array.
             * 
             * The array is modified in-place.
             * 
             * You can optionally specify a callback to be invoked for each item successfully removed from the array.
             * @param array The array to be modified.
             * @param item The item, or array of items, to be removed from the array.
             * @param callback A callback to be invoked for each item successfully removed from the array.
             * @param context The context in which the callback is invoked.
             */
            function Remove(array: any[], item: any | any[], callback?: Function, context?: object): any | any[];

            /**
             * Removes the item from the given position in the array.
             * 
             * The array is modified in-place.
             * 
             * You can optionally specify a callback to be invoked for the item if it is successfully removed from the array.
             * @param array The array to be modified.
             * @param index The array index to remove the item from. The index must be in bounds or it will throw an error.
             * @param callback A callback to be invoked for the item removed from the array.
             * @param context The context in which the callback is invoked.
             */
            function RemoveAt(array: any[], index: number, callback?: Function, context?: object): any;

            /**
             * Removes the item within the given range in the array.
             * 
             * The array is modified in-place.
             * 
             * You can optionally specify a callback to be invoked for the item/s successfully removed from the array.
             * @param array The array to be modified.
             * @param startIndex The start index to remove from.
             * @param endIndex The end index to remove to.
             * @param callback A callback to be invoked for the item removed from the array.
             * @param context The context in which the callback is invoked.
             */
            function RemoveBetween(array: any[], startIndex: number, endIndex: number, callback?: Function, context?: object): any[];

            /**
             * Removes a random object from the given array and returns it.
             * Will return null if there are no array items that fall within the specified range or if there is no item for the randomly chosen index.
             * @param array The array to removed a random element from.
             * @param start The array index to start the search from. Default 0.
             * @param length Optional restriction on the number of elements to randomly select from. Default array.length.
             */
            function RemoveRandomElement(array: any[], start?: number, length?: number): object;

            /**
             * Replaces an element of the array with the new element.
             * The new element cannot already be a member of the array.
             * The array is modified in-place.
             * @param array The array to search within.
             * @param oldChild The element in the array that will be replaced.
             * @param newChild The element to be inserted into the array at the position of `oldChild`.
             */
            function Replace(array: any[], oldChild: any, newChild: any): boolean;

            /**
             * Moves the element at the start of the array to the end, shifting all items in the process.
             * The "rotation" happens to the left.
             * @param array The array to shift to the left. This array is modified in place.
             * @param total The number of times to shift the array. Default 1.
             */
            function RotateLeft(array: any[], total?: number): any;

            /**
             * Moves the element at the end of the array to the start, shifting all items in the process.
             * The "rotation" happens to the right.
             * @param array The array to shift to the right. This array is modified in place.
             * @param total The number of times to shift the array. Default 1.
             */
            function RotateRight(array: any[], total?: number): any;

            /**
             * Tests if the start and end indexes are a safe range for the given array.
             * @param array The array to check.
             * @param startIndex The start index.
             * @param endIndex The end index.
             * @param throwError Throw an error if the range is out of bounds. Default true.
             */
            function SafeRange(array: any[], startIndex: number, endIndex: number, throwError?: boolean): boolean;

            /**
             * Moves the given element to the bottom of the array.
             * The array is modified in-place.
             * @param array The array.
             * @param item The element to move.
             */
            function SendToBack(array: any[], item: any): any;

            /**
             * Scans the array for elements with the given property. If found, the property is set to the `value`.
             * 
             * For example: `SetAll('visible', true)` would set all elements that have a `visible` property to `false`.
             * 
             * Optionally you can specify a start and end index. For example if the array had 100 elements,
             * and you set `startIndex` to 0 and `endIndex` to 50, it would update only the first 50 elements.
             * @param array The array to search.
             * @param property The property to test for on each array element.
             * @param value The value to set the property to.
             * @param startIndex An optional start index to search from.
             * @param endIndex An optional end index to search to.
             */
            function SetAll(array: any[], property: string, value: any, startIndex?: number, endIndex?: number): any[];

            /**
             * Shuffles the contents of the given array using the Fisher-Yates implementation.
             * 
             * The original array is modified directly and returned.
             * @param array The array to shuffle. This array is modified in place.
             */
            function Shuffle<T>(array: T[]): T[];

            /**
             * Takes the given array and runs a numeric sort on it, ignoring any non-digits that
             * may be in the entries.
             * 
             * You should only run this on arrays containing strings.
             * @param array The input array of strings.
             */
            function SortByDigits(array: string[]): string[];

            /**
             * Removes a single item from an array and returns it without creating gc, like the native splice does.
             * Based on code by Mike Reinstein.
             * @param array The array to splice from.
             * @param index The index of the item which should be spliced.
             */
            function SpliceOne(array: any[], index: number): any;

            /**
             * An in-place stable array sort, because `Array#sort()` is not guaranteed stable.
             * 
             * This is an implementation of merge sort, without recursion.
             * 
             * Function based on the Two-Screen/stable sort 0.1.8 from https://github.com/Two-Screen/stable
             * @param array The input array to be sorted.
             * @param compare The comparison function.
             */
            function StableSort(array: any[], compare?: Function): any[];

            /**
             * Swaps the position of two elements in the given array.
             * The elements must exist in the same array.
             * The array is modified in-place.
             * @param array The input array.
             * @param item1 The first element to swap.
             * @param item2 The second element to swap.
             */
            function Swap(array: any[], item1: any, item2: any): any[];

        }

        namespace Base64 {
            /**
             * Converts an ArrayBuffer into a base64 string.
             * 
             * The resulting string can optionally be a data uri if the `mediaType` argument is provided.
             * 
             * See https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs for more details.
             * @param arrayBuffer The Array Buffer to encode.
             * @param mediaType An optional media type, i.e. `audio/ogg` or `image/jpeg`. If included the resulting string will be a data URI.
             */
            function ArrayBufferToBase64(arrayBuffer: ArrayBuffer, mediaType?: string): string;

            /**
             * Converts a base64 string, either with or without a data uri, into an Array Buffer.
             * @param base64 The base64 string to be decoded. Can optionally contain a data URI header, which will be stripped out prior to decoding.
             */
            function Base64ToArrayBuffer(base64: string): ArrayBuffer;

        }

        /**
         * A NOOP (No Operation) callback function.
         * 
         * Used internally by Phaser when it's more expensive to determine if a callback exists
         * than it is to just invoke an empty function.
         */
        function NOOP(): void;

        /**
         * A NULL OP callback function.
         * 
         * This function always returns `null`.
         * 
         * Used internally by Phaser when it's more expensive to determine if a callback exists
         * than it is to just invoke an empty function.
         */
        function NULL(): void;

        namespace Objects {
            /**
             * Shallow Object Clone. Will not clone nested objects.
             * @param obj The object to clone.
             */
            function Clone(obj: object): object;

            /**
             * Deep Copy the given object or array.
             * @param obj The object to deep copy.
             */
            function DeepCopy(obj: object): object;

            /**
             * This is a slightly modified version of http://api.jquery.com/jQuery.extend/
             * @param args The objects that will be mixed.
             */
            function Extend(...args: any[]): object;

            /**
             * Retrieves a value from an object. Allows for more advanced selection options, including:
             * 
             * Allowed types:
             * 
             * Explicit:
             * {
             *     x: 4
             * }
             * 
             * From function
             * {
             *     x: function ()
             * }
             * 
             * Randomly pick one element from the array
             * {
             *     x: [a, b, c, d, e, f]
             * }
             * 
             * Random integer between min and max:
             * {
             *     x: { randInt: [min, max] }
             * }
             * 
             * Random float between min and max:
             * {
             *     x: { randFloat: [min, max] }
             * }
             * @param source The object to retrieve the value from.
             * @param key The name of the property to retrieve from the object. If a property is nested, the names of its preceding properties should be separated by a dot (`.`) - `banner.hideBanner` would return the value of the `hideBanner` property from the object stored in the `banner` property of the `source` object.
             * @param defaultValue The value to return if the `key` isn't found in the `source` object.
             */
            function GetAdvancedValue(source: object, key: string, defaultValue: any): any;

            /**
             * Finds the key within the top level of the {@link source} object, or returns {@link defaultValue}
             * @param source The object to search
             * @param key The key for the property on source. Must exist at the top level of the source object (no periods)
             * @param defaultValue The default value to use if the key does not exist.
             */
            function GetFastValue(source: object, key: string, defaultValue?: any): any;

            /**
             * Retrieves and clamps a numerical value from an object.
             * @param source The object to retrieve the value from.
             * @param key The name of the property to retrieve from the object. If a property is nested, the names of its preceding properties should be separated by a dot (`.`).
             * @param min The minimum value which can be returned.
             * @param max The maximum value which can be returned.
             * @param defaultValue The value to return if the property doesn't exist. It's also constrained to the given bounds.
             */
            function GetMinMaxValue(source: object, key: string, min: number, max: number, defaultValue: number): number;

            /**
             * Retrieves a value from an object, or an alternative object, falling to a back-up default value if not found.
             * 
             * The key is a string, which can be split based on the use of the period character.
             * 
             * For example:
             * 
             * ```javascript
             * const source = {
             *   lives: 3,
             *   render: {
             *     screen: {
             *       width: 1024
             *     }
             *   }
             * }
             * 
             * const lives = GetValue(source, 'lives', 1);
             * const width = GetValue(source, 'render.screen.width', 800);
             * const height = GetValue(source, 'render.screen.height', 600);
             * ```
             * 
             * In the code above, `lives` will be 3 because it's defined at the top level of `source`.
             * The `width` value will be 1024 because it can be found inside the `render.screen` object.
             * The `height` value will be 600, the default value, because it is missing from the `render.screen` object.
             * @param source The primary object to try to retrieve the value from. If not found in here, `altSource` is checked.
             * @param key The name of the property to retrieve from the object. If a property is nested, the names of its preceding properties should be separated by a dot (`.`) - `banner.hideBanner` would return the value of the `hideBanner` property from the object stored in the `banner` property of the `source` object.
             * @param defaultValue The value to return if the `key` isn't found in the `source` object.
             * @param altSource An alternative object to retrieve the value from. If the property exists in `source` then `altSource` will not be used.
             */
            function GetValue(source: object, key: string, defaultValue: any, altSource?: object): any;

            /**
             * Verifies that an object contains all requested keys
             * @param source an object on which to check for key existence
             * @param keys an array of keys to ensure the source object contains
             */
            function HasAll(source: object, keys: string[]): boolean;

            /**
             * Verifies that an object contains at least one of the requested keys
             * @param source an object on which to check for key existence
             * @param keys an array of keys to search the object for
             */
            function HasAny(source: object, keys: string[]): boolean;

            /**
             * Determine whether the source object has a property with the specified key.
             * @param source The source object to be checked.
             * @param key The property to check for within the object
             */
            function HasValue(source: object, key: string): boolean;

            /**
             * This is a slightly modified version of jQuery.isPlainObject.
             * A plain object is an object whose internal class property is [object Object].
             * @param obj The object to inspect.
             */
            function IsPlainObject(obj: object): boolean;

            /**
             * Creates a new Object using all values from obj1 and obj2.
             * If a value exists in both obj1 and obj2, the value in obj1 is used.
             * 
             * This is only a shallow copy. Deeply nested objects are not cloned, so be sure to only use this
             * function on shallow objects.
             * @param obj1 The first object.
             * @param obj2 The second object.
             */
            function Merge(obj1: object, obj2: object): object;

            /**
             * Creates a new Object using all values from obj1.
             * 
             * Then scans obj2. If a property is found in obj2 that *also* exists in obj1, the value from obj2 is used, otherwise the property is skipped.
             * @param obj1 The first object to merge.
             * @param obj2 The second object to merge. Keys from this object which also exist in `obj1` will be copied to `obj1`.
             */
            function MergeRight(obj1: object, obj2: object): object;

            /**
             * Returns a new object that only contains the `keys` that were found on the object provided.
             * If no `keys` are found, an empty object is returned.
             * @param object The object to pick the provided keys from.
             * @param keys An array of properties to retrieve from the provided object.
             */
            function Pick(object: object, keys: any[]): object;

            /**
             * Sets a value in an object, allowing for dot notation to control the depth of the property.
             * 
             * For example:
             * 
             * ```javascript
             * var data = {
             *   world: {
             *     position: {
             *       x: 200,
             *       y: 100
             *     }
             *   }
             * };
             * 
             * SetValue(data, 'world.position.y', 300);
             * 
             * console.log(data.world.position.y); // 300
             * ```
             * @param source The object to set the value in.
             * @param key The name of the property in the object. If a property is nested, the names of its preceding properties should be separated by a dot (`.`)
             * @param value The value to set into the property, if found in the source object.
             */
            function SetValue(source: object, key: string, value: any): boolean;

        }

        namespace String {
            /**
             * Takes a string and replaces instances of markers with values in the given array.
             * The markers take the form of `%1`, `%2`, etc. I.e.:
             * 
             * `Format("The %1 is worth %2 gold", [ 'Sword', 500 ])`
             * @param string The string containing the replacement markers.
             * @param values An array containing values that will replace the markers. If no value exists an empty string is inserted instead.
             */
            function Format(string: string, values: any[]): string;

            /**
             * Takes the given string and pads it out, to the length required, using the character
             * specified. For example if you need a string to be 6 characters long, you can call:
             * 
             * `pad('bob', 6, '-', 2)`
             * 
             * This would return: `bob---` as it has padded it out to 6 characters, using the `-` on the right.
             * 
             * You can also use it to pad numbers (they are always returned as strings):
             * 
             * `pad(512, 6, '0', 1)`
             * 
             * Would return: `000512` with the string padded to the left.
             * 
             * If you don't specify a direction it'll pad to both sides:
             * 
             * `pad('c64', 7, '*')`
             * 
             * Would return: `**c64**`
             * @param str The target string. `toString()` will be called on the string, which means you can also pass in common data types like numbers.
             * @param len The number of characters to be added. Default 0.
             * @param pad The string to pad it out with (defaults to a space). Default " ".
             * @param dir The direction dir = 1 (left), 2 (right), 3 (both). Default 3.
             */
            function Pad(str: string | number | object, len?: number, pad?: string, dir?: number): string;

            /**
             * Takes a string and removes the character at the given index.
             * @param string The string to be worked on.
             * @param index The index of the character to be removed.
             */
            function RemoveAt(string: string, index: number): string;

            /**
             * Takes the given string and reverses it, returning the reversed string.
             * For example if given the string `Atari 520ST` it would return `TS025 iratA`.
             * @param string The string to be reversed.
             */
            function Reverse(string: string): string;

            /**
             * Capitalizes the first letter of a string if there is one.
             * @param str The string to capitalize.
             */
            function UppercaseFirst(str: string): string;

            /**
             * Creates and returns an RFC4122 version 4 compliant UUID.
             * 
             * The string is in the form: `xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx` where each `x` is replaced with a random
             * hexadecimal digit from 0 to f, and `y` is replaced with a random hexadecimal digit from 8 to b.
             */
            function UUID(): string;

        }

    }

    /**
     * The Facebook Instant Games Plugin for Phaser 3 provides a seamless bridge between Phaser
     * and the Facebook Instant Games API version 6.2.
     * 
     * You can access this plugin via the `facebook` property in a Scene, i.e:
     * 
     * ```javascript
     * this.facebook.getPlatform();
     * ```
     * 
     * If this is unavailable please check to make sure you're using a build of Phaser that has
     * this plugin within it. You can quickly check this by looking at the dev tools console
     * header - the Phaser version number will have `-FB` after it if this plugin is loaded.
     * 
     * If you are building your own version of Phaser then use this Webpack DefinePlugin flag:
     * 
     * `"typeof PLUGIN_FBINSTANT": JSON.stringify(true)`
     * 
     * You will find that every Instant Games API method has a mapping in this plugin.
     * For a full list please consult either the plugin documentation, or the 6.2 SDK documentation
     * at https://developers.facebook.com/docs/games/instant-games/sdk/fbinstant6.2
     * 
     * Internally this plugin uses its own Data Manager to handle seamless user data updates and provides
     * handy functions for advertisement displaying, opening share dialogs, logging, leaderboards, purchase API requests,
     * loader integration and more.
     * 
     * To get started with Facebook Instant Games you will need to register on Facebook and create a new Instant
     * Game app that has its own unique app ID. Facebook have also provided a dashboard interface for setting up
     * various features for your game, including leaderboards, ad requests and the payments API. There are lots
     * of guides on the Facebook Developers portal to assist with setting these
     * various systems up: https://developers.facebook.com/docs/games/instant-games/guides
     * 
     * For more details follow the Quick Start guide here: https://developers.facebook.com/docs/games/instant-games
     */
    class FacebookInstantGamesPlugin extends Phaser.Events.EventEmitter {
        /**
         * 
         * @param game A reference to the Phaser.Game instance.
         */
        constructor(game: Phaser.Game);

        /**
         * A reference to the Phaser.Game instance.
         */
        readonly game: Phaser.Game;

        /**
         * A Data Manager instance.
         * It allows you to store, query and retrieve any key/value data you may need to store.
         * It's also used internally by the plugin to store FBIG API data.
         */
        data: Phaser.Data.DataManager;

        /**
         * Has the Facebook Instant Games API loaded yet?
         * This is set automatically during the boot process.
         */
        hasLoaded: boolean;

        /**
         * Is the Data Manager currently locked?
         */
        dataLocked: boolean;

        /**
         * A list of the Facebook Instant Games APIs that are available,
         * based on the given platform, context and user privacy settings.
         * This value is populated automatically during boot.
         */
        supportedAPIs: string[];

        /**
         * Holds the entry point that the game was launched from.
         * This value is populated automatically during boot.
         */
        entryPoint: string;

        /**
         * An object that contains any data associated with the entry point that the game was launched from.
         * The contents of the object are developer-defined, and can occur from entry points on different platforms.
         * This will return null for older mobile clients, as well as when there is no data associated with the particular entry point.
         * This value is populated automatically during boot.
         */
        entryPointData: any;

        /**
         * A unique identifier for the current game context. This represents a specific context
         * that the game is being played in (for example, a particular messenger conversation or facebook post).
         * The identifier will be null if game is being played in a solo context.
         * This value is populated automatically during boot.
         */
        contextID: string;

        /**
         * The current context in which your game is running. This can be either `null` or
         * one of:
         * 
         * `POST` - The game is running inside of a Facebook post.
         * `THREAD` - The game is running inside a Facebook Messenger thread.
         * `GROUP` - The game is running inside a Facebook Group.
         * `SOLO` - This is the default context, the player is the only participant.
         * 
         * This value is populated automatically during boot.
         */
        contextType: string | null;

        /**
         * The current locale.
         * See https://origincache.facebook.com/developers/resources/?id=FacebookLocales.xml for a complete list of supported locale values.
         * Use this to determine what languages the current game should be localized with.
         * This value is populated automatically during boot.
         */
        locale: string | null;

        /**
         * The platform on which the game is currently running, i.e. `IOS`.
         * This value is populated automatically during boot.
         */
        platform: string | null;

        /**
         * The string representation of the Facebook Instant Games SDK version being used.
         * This value is populated automatically during boot.
         */
        version: string | null;

        /**
         * Holds the id of the player. This is a string based ID, the same as `FBInstant.player.getID()`.
         * This value is populated automatically during boot if the API is supported.
         */
        playerID: string | null;

        /**
         * The player's localized display name.
         * This value is populated automatically during boot if the API is supported.
         */
        playerName: string | null;

        /**
         * A url to the player's public profile photo. The photo will always be a square, and with dimensions
         * of at least 200x200. When rendering it in the game, the exact dimensions should never be assumed to be constant.
         * It's recommended to always scale the image to a desired size before rendering.
         * This value is populated automatically during boot if the API is supported.
         */
        playerPhotoURL: string | null;

        /**
         * Whether a player can subscribe to the game bot or not.
         */
        playerCanSubscribeBot: boolean;

        /**
         * Does the current platform and context allow for use of the payments API?
         * Currently this is only available on Facebook.com and Android 6+.
         */
        paymentsReady: boolean;

        /**
         * The set of products that are registered to the game.
         */
        catalog: Product[];

        /**
         * Contains all of the player's unconsumed purchases.
         * The game must fetch the current player's purchases as soon as the client indicates that it is ready to perform payments-related operations,
         * i.e. at game start. The game can then process and consume any purchases that are waiting to be consumed.
         */
        purchases: Purchase[];

        /**
         * Contains all of the leaderboard data, as populated by the `getLeaderboard()` method.
         */
        leaderboards: Phaser.FacebookInstantGamesLeaderboard[];

        /**
         * Contains AdInstance objects, as created by the `preloadAds()` method.
         */
        ads: AdInstance[];

        /**
         * Call this method from your `Scene.preload` in order to sync the load progress
         * of the Phaser Loader with the Facebook Instant Games loader display, i.e.:
         * 
         * ```javascript
         * this.facebook.showLoadProgress(this);
         * this.facebook.once('startgame', this.startGame, this);
         * ```
         * @param scene The Scene for which you want to show loader progress for.
         */
        showLoadProgress(scene: Phaser.Scene): this;

        /**
         * This method is called automatically when the game has finished loading,
         * if you used the `showLoadProgress` method. If your game doesn't need to
         * load any assets, or you're managing the load yourself, then call this
         * method directly to start the API running.
         * 
         * When the API has finished starting this plugin will emit a `startgame` event
         * which you should listen for.
         */
        gameStarted(): void;

        /**
         * Checks to see if a given Facebook Instant Games API is available or not.
         * @param api The API to check for, i.e. `player.getID`.
         */
        checkAPI(api: string): boolean;

        /**
         * Returns the unique identifier for the current game context. This represents a specific context
         * that the game is being played in (for example, a particular messenger conversation or facebook post).
         * The identifier will be null if game is being played in a solo context.
         * 
         * It is only populated if `contextGetID` is in the list of supported APIs.
         */
        getID(): string;

        /**
         * Returns the current context in which your game is running. This can be either `null` or one of:
         * 
         * `POST` - The game is running inside of a Facebook post.
         * `THREAD` - The game is running inside a Facebook Messenger thread.
         * `GROUP` - The game is running inside a Facebook Group.
         * `SOLO` - This is the default context, the player is the only participant.
         * 
         * It is only populated if `contextGetType` is in the list of supported APIs.
         */
        getType(): string | null;

        /**
         * Returns the current locale.
         * See https://origincache.facebook.com/developers/resources/?id=FacebookLocales.xml for a complete list of supported locale values.
         * Use this to determine what languages the current game should be localized with.
         * It is only populated if `getLocale` is in the list of supported APIs.
         */
        getLocale(): string | null;

        /**
         * Returns the platform on which the game is currently running, i.e. `IOS`.
         * It is only populated if `getPlatform` is in the list of supported APIs.
         */
        getPlatform(): string | null;

        /**
         * Returns the string representation of the Facebook Instant Games SDK version being used.
         * It is only populated if `getSDKVersion` is in the list of supported APIs.
         */
        getSDKVersion(): string | null;

        /**
         * Returns the id of the player. This is a string based ID, the same as `FBInstant.player.getID()`.
         * It is only populated if `playerGetID` is in the list of supported APIs.
         */
        getPlayerID(): string | null;

        /**
         * Returns the player's localized display name.
         * It is only populated if `playerGetName` is in the list of supported APIs.
         */
        getPlayerName(): string | null;

        /**
         * Returns the url to the player's public profile photo. The photo will always be a square, and with dimensions
         * of at least 200x200. When rendering it in the game, the exact dimensions should never be assumed to be constant.
         * It's recommended to always scale the image to a desired size before rendering.
         * It is only populated if `playerGetPhoto` is in the list of supported APIs.
         */
        getPlayerPhotoURL(): string | null;

        /**
         * Load the player's photo and store it in the Texture Manager, ready for use in-game.
         * 
         * This method works by using a Scene Loader instance and then asking the Loader to
         * retrieve the image.
         * 
         * When complete the plugin will emit a `photocomplete` event, along with the key of the photo.
         * 
         * ```javascript
         * this.facebook.loadPlayerPhoto(this, 'player').once('photocomplete', function (key) {
         *   this.add.image(x, y, 'player');
         * }, this);
         * ```
         * @param scene The Scene that will be responsible for loading this photo.
         * @param key The key to use when storing the photo in the Texture Manager.
         */
        loadPlayerPhoto(scene: Phaser.Scene, key: string): this;

        /**
         * Checks if the current player can subscribe to the game bot.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they can subscribe, the `playerCanSubscribeBot` property is set to `true`
         * and this plugin will emit the `cansubscribebot` event.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `cansubscribebotfail` event instead.
         */
        canSubscribeBot(): this;

        /**
         * Subscribes the current player to the game bot.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `subscribebot` event.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `subscribebotfail` event instead.
         */
        subscribeBot(): this;

        /**
         * Gets the associated data from the player based on the given key, or array of keys.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes the data is set into this plugins Data Manager and the
         * `getdata` event will be emitted.
         * @param keys The key/s of the data to retrieve.
         */
        getData(keys: string | string[]): this;

        /**
         * Set data to be saved to the designated cloud storage of the current player. The game can store up to 1MB of data for each unique player.
         * 
         * The data save is requested in an async call, so the result isn't available immediately.
         * 
         * Data managed via this plugins Data Manager instance is automatically synced with Facebook. However, you can call this
         * method directly if you need to replace the data object directly.
         * 
         * When the APIs `setDataAsync` call resolves it will emit the `savedata` event from this plugin. If the call fails for some
         * reason it will emit `savedatafail` instead.
         * 
         * The call resolving does not necessarily mean that the input has already been persisted. Rather, it means that the data was valid and
         * has been scheduled to be saved. It also guarantees that all values that were set are now available in `getData`.
         * @param data An object containing a set of key-value pairs that should be persisted to cloud storage.
         * The object must contain only serializable values - any non-serializable values will cause the entire modification to be rejected.
         */
        saveData(data: object): this;

        /**
         * Immediately flushes any changes to the player data to the designated cloud storage.
         * This function is expensive, and should primarily be used for critical changes where persistence needs to be immediate
         * and known by the game. Non-critical changes should rely on the platform to persist them in the background.
         * NOTE: Calls to player.setDataAsync will be rejected while this function's result is pending.
         * 
         * Data managed via this plugins Data Manager instance is automatically synced with Facebook. However, you can call this
         * method directly if you need to flush the data directly.
         * 
         * When the APIs `flushDataAsync` call resolves it will emit the `flushdata` event from this plugin. If the call fails for some
         * reason it will emit `flushdatafail` instead.
         */
        flushData(): this;

        /**
         * Retrieve stats from the designated cloud storage of the current player.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes the `getstats` event will be emitted along with the data object returned.
         * 
         * If the call fails, i.e. it's not in the list of supported APIs, or the request was rejected,
         * it will emit a `getstatsfail` event instead.
         * @param keys An optional array of unique keys to retrieve stats for. If the function is called without it, it will fetch all stats.
         */
        getStats(keys?: string[]): this;

        /**
         * Save the stats of the current player to the designated cloud storage.
         * 
         * Stats in the Facebook Instant Games API are purely numerical values paired with a string-based key. Only numbers can be saved as stats,
         * all other data types will be ignored.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes the `savestats` event will be emitted along with the data object returned.
         * 
         * If the call fails, i.e. it's not in the list of supported APIs, or the request was rejected,
         * it will emit a `savestatsfail` event instead.
         * @param data An object containing a set of key-value pairs that should be persisted to cloud storage as stats. Note that only numerical values are stored.
         */
        saveStats(data: object): this;

        /**
         * Increment the stats of the current player and save them to the designated cloud storage.
         * 
         * Stats in the Facebook Instant Games API are purely numerical values paired with a string-based key. Only numbers can be saved as stats,
         * all other data types will be ignored.
         * 
         * The data object provided for this call should contain offsets for how much to modify the stats by:
         * 
         * ```javascript
         * this.facebook.incStats({
         *     level: 1,
         *     zombiesSlain: 17,
         *     rank: -1
         * });
         * ```
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes the `incstats` event will be emitted along with the data object returned.
         * 
         * If the call fails, i.e. it's not in the list of supported APIs, or the request was rejected,
         * it will emit a `incstatsfail` event instead.
         * @param data An object containing a set of key-value pairs indicating how much to increment each stat in cloud storage. Note that only numerical values are processed.
         */
        incStats(data: object): this;

        /**
         * Sets the data associated with the individual gameplay session for the current context.
         * 
         * This function should be called whenever the game would like to update the current session data.
         * 
         * This session data may be used to populate a variety of payloads, such as game play webhooks.
         * @param data An arbitrary data object, which must be less than or equal to 1000 characters when stringified.
         */
        saveSession(data: object): this;

        /**
         * This invokes a dialog to let the user share specified content, either as a message in Messenger or as a post on the user's timeline.
         * 
         * A blob of data can be attached to the share which every game session launched from the share will be able to access via the `this.entryPointData` property.
         * 
         * This data must be less than or equal to 1000 characters when stringified.
         * 
         * When this method is called you should consider your game paused. Listen out for the `resume` event from this plugin to know when the dialog has been closed.
         * 
         * The user may choose to cancel the share action and close the dialog. The resulting `resume` event will be dispatched regardless if the user actually shared the content or not.
         * @param text A text message to be shared.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param sessionData A blob of data to attach to the share.
         */
        openShare(text: string, key: string, frame?: string, sessionData?: object): this;

        /**
         * This invokes a dialog to let the user invite a friend to play this game, either as a message in Messenger or as a post on the user's timeline.
         * 
         * A blob of data can be attached to the share which every game session launched from the share will be able to access via the `this.entryPointData` property.
         * 
         * This data must be less than or equal to 1000 characters when stringified.
         * 
         * When this method is called you should consider your game paused. Listen out for the `resume` event from this plugin to know when the dialog has been closed.
         * 
         * The user may choose to cancel the share action and close the dialog. The resulting `resume` event will be dispatched regardless if the user actually shared the content or not.
         * @param text A text message to be shared.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param sessionData A blob of data to attach to the share.
         */
        openInvite(text: string, key: string, frame?: string, sessionData?: object): this;

        /**
         * This invokes a dialog to let the user share specified content, either as a message in Messenger or as a post on the user's timeline.
         * 
         * A blob of data can be attached to the share which every game session launched from the share will be able to access via the `this.entryPointData` property.
         * 
         * This data must be less than or equal to 1000 characters when stringified.
         * 
         * When this method is called you should consider your game paused. Listen out for the `resume` event from this plugin to know when the dialog has been closed.
         * 
         * The user may choose to cancel the share action and close the dialog. The resulting `resume` event will be dispatched regardless if the user actually shared the content or not.
         * @param text A text message to be shared.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param sessionData A blob of data to attach to the share.
         */
        openRequest(text: string, key: string, frame?: string, sessionData?: object): this;

        /**
         * This invokes a dialog to let the user share specified content, either as a message in Messenger or as a post on the user's timeline.
         * 
         * A blob of data can be attached to the share which every game session launched from the share will be able to access via the `this.entryPointData` property.
         * 
         * This data must be less than or equal to 1000 characters when stringified.
         * 
         * When this method is called you should consider your game paused. Listen out for the `resume` event from this plugin to know when the dialog has been closed.
         * 
         * The user may choose to cancel the share action and close the dialog. The resulting `resume` event will be dispatched regardless if the user actually shared the content or not.
         * @param text A text message to be shared.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param sessionData A blob of data to attach to the share.
         */
        openChallenge(text: string, key: string, frame?: string, sessionData?: object): this;

        /**
         * This function determines whether the number of participants in the current game context is between a given minimum and maximum, inclusive.
         * If one of the bounds is null only the other bound will be checked against.
         * It will always return the original result for the first call made in a context in a given game play session.
         * Subsequent calls, regardless of arguments, will return the answer to the original query until a context change occurs and the query result is reset.
         * @param min The minimum bound of the context size query.
         * @param max The maximum bound of the context size query.
         */
        isSizeBetween(min?: integer, max?: integer): object;

        /**
         * Request a switch into a specific context. If the player does not have permission to enter that context,
         * or if the player does not provide permission for the game to enter that context, this will emit a `switchfail` event.
         * 
         * Otherwise, the plugin will emit the `switch` event when the game has switched into the specified context.
         * @param contextID The ID of the desired context.
         */
        switchContext(contextID: string): this;

        /**
         * Opens a context selection dialog for the player. If the player selects an available context,
         * the client will attempt to switch into that context, and emit the `choose` event if successful.
         * Otherwise, if the player exits the menu or the client fails to switch into the new context, the `choosefail` event will be emitted.
         * @param options An object specifying conditions on the contexts that should be offered.
         */
        chooseContext(options?: ChooseContextConfig): this;

        /**
         * Attempts to create or switch into a context between a specified player and the current player.
         * This plugin will emit the `create` event once the context switch is completed.
         * If the API call fails, such as if the player listed is not a Connected Player of the current player or if the
         * player does not provide permission to enter the new context, then the plugin will emit a 'createfail' event.
         * @param playerID ID of the player.
         */
        createContext(playerID: string): this;

        /**
         * Fetches an array of ConnectedPlayer objects containing information about active players
         * (people who played the game in the last 90 days) that are connected to the current player.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `players` event along
         * with the player data.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `playersfail` event instead.
         */
        getPlayers(): this;

        /**
         * Fetches the game's product catalog.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `getcatalog` event along
         * with the catalog data.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `getcatalogfail` event instead.
         */
        getCatalog(): this;

        /**
         * Fetches a single Product from the game's product catalog.
         * 
         * The product catalog must have been populated using `getCatalog` prior to calling this method.
         * 
         * Use this to look-up product details based on a purchase list.
         * @param productID The Product ID of the item to get from the catalog.
         */
        getProduct(productID: string): Product | null;

        /**
         * Begins the purchase flow for a specific product.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `purchase` event along
         * with the purchase data.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `purchasefail` event instead.
         * @param productID The identifier of the product to purchase.
         * @param developerPayload An optional developer-specified payload, to be included in the returned purchase's signed request.
         */
        purchase(productID: string, developerPayload?: string): this;

        /**
         * Fetches all of the player's unconsumed purchases. The game must fetch the current player's purchases
         * as soon as the client indicates that it is ready to perform payments-related operations,
         * i.e. at game start. The game can then process and consume any purchases that are waiting to be consumed.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `getpurchases` event along
         * with the purchase data.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `getpurchasesfail` event instead.
         */
        getPurchases(): this;

        /**
         * Consumes a specific purchase belonging to the current player. Before provisioning a product's effects to the player,
         * the game should request the consumption of the purchased product. Once the purchase is successfully consumed,
         * the game should immediately provide the player with the effects of their purchase.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If they are successfully subscribed this plugin will emit the `consumepurchase` event along
         * with the purchase data.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `consumepurchasefail` event instead.
         * @param purchaseToken The purchase token of the purchase that should be consumed.
         */
        consumePurchase(purchaseToken: string): this;

        /**
         * Informs Facebook of a custom update that occurred in the game.
         * This will temporarily yield control to Facebook and Facebook will decide what to do based on what the update is.
         * Once Facebook returns control to the game the plugin will emit an `update` or `updatefail` event.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * The `text` parameter is an update payload with the following structure:
         * 
         * ```
         * text: {
         *     default: 'X just invaded Y\'s village!',
         *     localizations: {
         *         ar_AR: 'X \u0641\u0642\u0637 \u063A\u0632\u062A ' +
         *         '\u0642\u0631\u064A\u0629 Y!',
         *         en_US: 'X just invaded Y\'s village!',
         *         es_LA: '\u00A1X acaba de invadir el pueblo de Y!',
         *     }
         * }
         * ```
         * @param cta The call to action text.
         * @param text The text object.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param template The update template key.
         * @param updateData The update data object payload.
         */
        update(cta: string, text: object, key: string, frame: string | integer | undefined, template: string, updateData: object): this;

        /**
         * Informs Facebook of a leaderboard update that occurred in the game.
         * This will temporarily yield control to Facebook and Facebook will decide what to do based on what the update is.
         * Once Facebook returns control to the game the plugin will emit an `update` or `updatefail` event.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * The `text` parameter is an update payload with the following structure:
         * 
         * ```
         * text: {
         *     default: 'X just invaded Y\'s village!',
         *     localizations: {
         *         ar_AR: 'X \u0641\u0642\u0637 \u063A\u0632\u062A ' +
         *         '\u0642\u0631\u064A\u0629 Y!',
         *         en_US: 'X just invaded Y\'s village!',
         *         es_LA: '\u00A1X acaba de invadir el pueblo de Y!',
         *     }
         * }
         * ```
         * @param cta The call to action text.
         * @param text The text object.
         * @param key The key of the texture to use as the share image.
         * @param frame The frame of the texture to use as the share image. Set to `null` if you don't require a frame, but do need to set session data.
         * @param template The update template key.
         * @param updateData The update data object payload.
         */
        updateLeaderboard(cta: string, text: object, key: string, frame: string | integer | undefined, template: string, updateData: object): this;

        /**
         * Request that the client switch to a different Instant Game.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If the game switches successfully this plugin will emit the `switchgame` event and the client will load the new game.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `switchgamefail` event instead.
         * @param appID The Application ID of the Instant Game to switch to. The application must be an Instant Game, and must belong to the same business as the current game.
         * @param data An optional data payload. This will be set as the entrypoint data for the game being switched to. Must be less than or equal to 1000 characters when stringified.
         */
        switchGame(appID: string, data?: object): this;

        /**
         * Prompts the user to create a shortcut to the game if they are eligible to.
         * Can only be called once per session.
         * 
         * It makes an async call to the API, so the result isn't available immediately.
         * 
         * If the user choose to create a shortcut this plugin will emit the `shortcutcreated` event.
         * 
         * If they cannot, i.e. it's not in the list of supported APIs, or the request
         * was rejected, it will emit a `shortcutcreatedfail` event instead.
         */
        createShortcut(): this;

        /**
         * Quits the game.
         */
        quit(): void;

        /**
         * Log an app event with FB Analytics.
         * 
         * See https://developers.facebook.com/docs/javascript/reference/v2.8#app_events for more details about FB Analytics.
         * @param name Name of the event. Must be 2 to 40 characters, and can only contain '_', '-', ' ', and alphanumeric characters.
         * @param value An optional numeric value that FB Analytics can calculate a sum with.
         * @param params An optional object that can contain up to 25 key-value pairs to be logged with the event. Keys must be 2 to 40 characters, and can only contain '_', '-', ' ', and alphanumeric characters. Values must be less than 100 characters in length.
         */
        log(name: string, value?: number, params?: object): this;

        /**
         * Attempt to create an instance of an interstitial ad.
         * 
         * If the instance is created successfully then the ad is preloaded ready for display in-game via the method `showAd()`.
         * 
         * If the ad loads it will emit the `adloaded` event, passing the AdInstance as the only parameter.
         * 
         * If the ad cannot be displayed because there was no inventory to fill it, it will emit the `adsnofill` event.
         * @param placementID The ad placement ID, or an array of IDs, as created in your Audience Network settings within Facebook.
         */
        preloadAds(placementID: string | string[]): this;

        /**
         * Attempt to create an instance of an rewarded video ad.
         * 
         * If the instance is created successfully then the ad is preloaded ready for display in-game via the method `showVideo()`.
         * 
         * If the ad loads it will emit the `adloaded` event, passing the AdInstance as the only parameter.
         * 
         * If the ad cannot be displayed because there was no inventory to fill it, it will emit the `adsnofill` event.
         * @param placementID The ad placement ID, or an array of IDs, as created in your Audience Network settings within Facebook.
         */
        preloadVideoAds(placementID: string | string[]): this;

        /**
         * Displays a previously loaded interstitial ad.
         * 
         * If the ad is successfully displayed this plugin will emit the `adfinished` event, with the AdInstance object as its parameter.
         * 
         * If the ad cannot be displayed, it will emit the `adsnotloaded` event.
         * @param placementID The ad placement ID to display.
         */
        showAd(placementID: string): this;

        /**
         * Displays a previously loaded interstitial video ad.
         * 
         * If the ad is successfully displayed this plugin will emit the `adfinished` event, with the AdInstance object as its parameter.
         * 
         * If the ad cannot be displayed, it will emit the `adsnotloaded` event.
         * @param placementID The ad placement ID to display.
         */
        showVideo(placementID: string): this;

        /**
         * Attempts to match the current player with other users looking for people to play with.
         * If successful, a new Messenger group thread will be created containing the matched players and the player will
         * be context switched to that thread. This plugin will also dispatch the `matchplayer` event, containing the new context ID and Type.
         * 
         * The default minimum and maximum number of players in one matched thread are 2 and 20 respectively,
         * depending on how many players are trying to get matched around the same time.
         * 
         * The values can be changed in `fbapp-config.json`. See the Bundle Config documentation for documentation about `fbapp-config.json`.
         * @param matchTag Optional extra information about the player used to group them with similar players. Players will only be grouped with other players with exactly the same tag. The tag must only include letters, numbers, and underscores and be 100 characters or less in length.
         * @param switchImmediately Optional extra parameter that specifies whether the player should be immediately switched to the new context when a match is found. By default this will be false which will mean the player needs explicitly press play after being matched to switch to the new context. Default false.
         */
        matchPlayer(matchTag?: string, switchImmediately?: boolean): this;

        /**
         * Fetch a specific leaderboard belonging to this Instant Game.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes the `getleaderboard` event will be emitted along with a Leaderboard object instance.
         * @param name The name of the leaderboard. Each leaderboard for an Instant Game must have its own distinct name.
         */
        getLeaderboard(name: string): this;

        /**
         * Quits the Facebook API and then destroys this plugin.
         */
        destroy(): void;

    }

    /**
     * This class represents one single Leaderboard that belongs to a Facebook Instant Game.
     * 
     * You do not need to instantiate this class directly, it will be created when you use the
     * `getLeaderboard()` method of the main plugin.
     */
    class FacebookInstantGamesLeaderboard extends Phaser.Events.EventEmitter {
        /**
         * 
         * @param plugin A reference to the Facebook Instant Games Plugin.
         * @param data An Instant Game leaderboard instance.
         */
        constructor(plugin: Phaser.FacebookInstantGamesPlugin, data: any);

        /**
         * A reference to the Facebook Instant Games Plugin.
         */
        plugin: Phaser.FacebookInstantGamesPlugin;

        /**
         * An Instant Game leaderboard instance.
         */
        ref: any;

        /**
         * The name of the leaderboard.
         */
        name: string;

        /**
         * The ID of the context that the leaderboard is associated with, or null if the leaderboard is not tied to a particular context.
         */
        contextID: string;

        /**
         * The total number of player entries in the leaderboard.
         * This value defaults to zero. Populate it via the `getEntryCount()` method.
         */
        entryCount: integer;

        /**
         * The players score object.
         * This value defaults to `null`. Populate it via the `getPlayerScore()` method.
         */
        playerScore: LeaderboardScore;

        /**
         * The scores in the Leaderboard from the currently requested range.
         * This value defaults to an empty array. Populate it via the `getScores()` method.
         * The contents of this array are reset each time `getScores()` is called.
         */
        scores: LeaderboardScore[];

        /**
         * Fetches the total number of player entries in the leaderboard.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes this Leaderboard will emit the `getentrycount` event along with the count and name of the Leaderboard.
         */
        getEntryCount(): this;

        /**
         * Updates the player's score. If the player has an existing score, the old score will only be replaced if the new score is better than it.
         * NOTE: If the leaderboard is associated with a specific context, the game must be in that context to set a score for the player.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes this Leaderboard will emit the `setscore` event along with the LeaderboardScore object and the name of the Leaderboard.
         * 
         * If the save fails the event will send `null` as the score value.
         * @param score The new score for the player. Must be a 64-bit integer number.
         * @param data Metadata to associate with the stored score. Must be less than 2KB in size. If an object is given it will be passed to `JSON.stringify`.
         */
        setScore(score: integer, data?: string | any): this;

        /**
         * Gets the players leaderboard entry and stores it in the `playerScore` property.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes this Leaderboard will emit the `getplayerscore` event along with the score and the name of the Leaderboard.
         * 
         * If the player has not yet saved a score, the event will send `null` as the score value, and `playerScore` will be set to `null` as well.
         */
        getPlayerScore(): this;

        /**
         * Retrieves a set of leaderboard entries, ordered by score ranking in the leaderboard.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes this Leaderboard will emit the `getscores` event along with an array of LeaderboardScore entries and the name of the Leaderboard.
         * @param count The number of entries to attempt to fetch from the leaderboard. Currently, up to a maximum of 100 entries may be fetched per query. Default 10.
         * @param offset The offset from the top of the leaderboard that entries will be fetched from. Default 0.
         */
        getScores(count?: integer, offset?: integer): this;

        /**
         * Retrieves a set of leaderboard entries, based on the current player's connected players (including the current player), ordered by local rank within the set of connected players.
         * 
         * The data is requested in an async call, so the result isn't available immediately.
         * 
         * When the call completes this Leaderboard will emit the `getconnectedscores` event along with an array of LeaderboardScore entries and the name of the Leaderboard.
         */
        getConnectedScores(): this;

    }

}

declare type WebGLContextCallback = (renderer: Phaser.Renderer.WebGL.WebGLRenderer)=>void;

declare type EachListCallback<I> = (item: I, ...args: any[])=>void;

declare type EachMapCallback<E> = (key: string, entry: E)=>boolean | null;

declare type EachSetCallback<E> = (entry: E, index: number)=>boolean | null;

declare type EachTextureCallback = (texture: Phaser.Textures.Texture, ...args: any[])=>void;

declare type FindTileCallback = (value: Phaser.Tilemaps.Tile, index: number, array: Phaser.Tilemaps.Tile[])=>boolean;

declare type EachTileCallback = (value: Phaser.Tilemaps.Tile, index: number, array: Phaser.Tilemaps.Tile[])=>void;

/**
 * A predicate, to test each element of the array.
 */
declare type TilemapFilterCallback = (value: Phaser.GameObjects.GameObject, index: number, array: Phaser.GameObjects.GameObject[])=>boolean;

declare type TilemapFindCallback = (value: Phaser.GameObjects.GameObject, index: number, array: Phaser.GameObjects.GameObject[])=>boolean;

/**
 * Phaser.Class
 */
declare class Class {
    /**
     * 
     * @param definition a dictionary of functions for the class
     */
    constructor(definition: Object);

}

declare type AdInstance = {
    /**
     * Represents an instance of an ad.
     */
    instance: any;
    /**
     * The Audience Network placement ID of this ad instance.
     */
    placementID: string;
    /**
     * Has this ad already been shown in-game?
     */
    shown: boolean;
    /**
     * Is this a video ad?
     */
    video: boolean;
};

/**
 * A filter that may be applied to a Context Choose operation.
 * 
 * 'NEW_CONTEXT_ONLY' - Prefer to only surface contexts the game has not been played in before.
 * 'INCLUDE_EXISTING_CHALLENGES' - Include the "Existing Challenges" section, which surfaces actively played-in contexts that the player is a part of.
 * 'NEW_PLAYERS_ONLY' - In sections containing individuals, prefer people who have not played the game.
 */
declare type ContextFilter = string;

/**
 * A configuration object that may be applied to a Context Choose operation.
 */
declare type ChooseContextConfig = {
    /**
     * The set of filters to apply to the context suggestions: 'NEW_CONTEXT_ONLY', 'INCLUDE_EXISTING_CHALLENGES' or 'NEW_PLAYERS_ONLY'.
     */
    filters?: ContextFilter[];
    /**
     * The maximum number of participants that a suggested context should ideally have.
     */
    maxSize?: number;
    /**
     * The minimum number of participants that a suggested context should ideally have.
     */
    minSize?: number;
};

declare type LeaderboardScore = {
    /**
     * An integer score value.
     */
    score: integer;
    /**
     * The score value, formatted with the score format associated with the leaderboard.
     */
    scoreFormatted: string;
    /**
     * The Unix timestamp of when the leaderboard entry was last updated.
     */
    timestamp: integer;
    /**
     * The entry's leaderboard ranking.
     */
    rank: integer;
    /**
     * The developer-specified payload associated with the score, or null if one was not set.
     */
    data: string;
    /**
     * The player's localized display name.
     */
    playerName: string;
    /**
     * A url to the player's public profile photo.
     */
    playerPhotoURL: string;
    /**
     * The game's unique identifier for the player.
     */
    playerID: string;
};

declare type Product = {
    /**
     * The title of the product.
     */
    title?: string;
    /**
     * The product's game-specified identifier.
     */
    productID?: string;
    /**
     * The product description.
     */
    description?: string;
    /**
     * A link to the product's associated image.
     */
    imageURI?: string;
    /**
     * The price of the product.
     */
    price?: string;
    /**
     * The currency code for the product.
     */
    priceCurrencyCode?: string;
};

declare type Purchase = {
    /**
     * A developer-specified string, provided during the purchase of the product.
     */
    developerPayload?: string;
    /**
     * The identifier for the purchase transaction.
     */
    paymentID?: string;
    /**
     * The product's game-specified identifier.
     */
    productID?: string;
    /**
     * Unix timestamp of when the purchase occurred.
     */
    purchaseTime?: string;
    /**
     * A token representing the purchase that may be used to consume the purchase.
     */
    purchaseToken?: string;
    /**
     * Server-signed encoding of the purchase request.
     */
    signedRequest?: string;
};

declare type integer = number;

declare module 'phaser' {
    export = Phaser;

}

